// Copyright (C) 2003-2005 Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// First added:  2003
// Last changed: 2005

#include <dolfin.h>

using namespace dolfin;

class TestProblem3 : public ODE
{
public:
  
  TestProblem3() : ODE(2, 1.0), A(2,2)
  {
    dolfin_info("A non-normal test problem, critically damped oscillation");
    dolfin_info("with eigenvalues l1 = l2 = 100.");

    // The matrix A
    A(0,0) = 0.0;    
    A(0,1) = -1.0;
    A(1,0) = 1e4;
    A(1,1) = 200;

    // Compute sparsity
    sparse();
  }

  real u0(unsigned int i)
  {
    return 1.0;
  }

  real f(const real u[], real t, unsigned int i)
  {
    return -A.mult(u, i);
  }

private:
  
  Matrix A;

};
