#ifndef __DOLFIN_MESH_H
#define __DOLFIN_MESH_H

// DOLFIN grid classes

#include <dolfin/Mesh.h>
#include <dolfin/MeshData.h>
#include <dolfin/MeshInit.h>
#include <dolfin/MeshHierarchy.h>
#include <dolfin/MeshRefinement.h>
#include <dolfin/TriMeshRefinement.h>
#include <dolfin/TetMeshRefinement.h>

#include <dolfin/CellRefData.h>
#include <dolfin/EdgeRefData.h>

#include <dolfin/Point.h>
#include <dolfin/Vertex.h> 
#include <dolfin/Cell.h>
#include <dolfin/Edge.h>  
#include <dolfin/Face.h>  

#include <dolfin/GenericCell.h>
#include <dolfin/Triangle.h>
#include <dolfin/Tetrahedron.h>

#include <dolfin/MeshIterator.h>
#include <dolfin/VertexIterator.h>
#include <dolfin/CellIterator.h>
#include <dolfin/EdgeIterator.h>
#include <dolfin/FaceIterator.h>

#include <dolfin/Boundary.h>
#include <dolfin/BoundaryData.h>
#include <dolfin/BoundaryInit.h>

#include <dolfin/UnitCube.h>
#include <dolfin/UnitSquare.h>

#endif
