// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.3.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __ELASTICITY_H
#define __ELASTICITY_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Elasticity {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 12;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.vertexID(0);
      dofs[5] = offset + cell.vertexID(1);
      dofs[6] = offset + cell.vertexID(2);
      dofs[7] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[8] = offset + cell.vertexID(0);
      dofs[9] = offset + cell.vertexID(1);
      dofs[10] = offset + cell.vertexID(2);
      dofs[11] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices();
      values[2] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 12;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.vertexID(0);
      dofs[5] = offset + cell.vertexID(1);
      dofs[6] = offset + cell.vertexID(2);
      dofs[7] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[8] = offset + cell.vertexID(0);
      dofs[9] = offset + cell.vertexID(1);
      dofs[10] = offset + cell.vertexID(2);
      dofs[11] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices();
      values[2] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm(const real& c0, const real& c1) : dolfin::BilinearForm(0), c0(c0), c1(c1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_0_0 = map.det*c1*map.g00*map.g00 + map.det*c1*map.g00*map.g00 + map.det*c1*map.g00*map.g00 + map.det*c1*map.g00*map.g00 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g02*map.g02 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g02*map.g02;
    const real G0_0_1 = map.det*c1*map.g00*map.g10 + map.det*c1*map.g00*map.g10 + map.det*c1*map.g00*map.g10 + map.det*c1*map.g00*map.g10 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g02*map.g12 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g02*map.g12;
    const real G0_0_2 = map.det*c1*map.g00*map.g20 + map.det*c1*map.g00*map.g20 + map.det*c1*map.g00*map.g20 + map.det*c1*map.g00*map.g20 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g02*map.g22 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g02*map.g22;
    const real G0_1_0 = map.det*c1*map.g10*map.g00 + map.det*c1*map.g10*map.g00 + map.det*c1*map.g10*map.g00 + map.det*c1*map.g10*map.g00 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g12*map.g02 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g12*map.g02;
    const real G0_1_1 = map.det*c1*map.g10*map.g10 + map.det*c1*map.g10*map.g10 + map.det*c1*map.g10*map.g10 + map.det*c1*map.g10*map.g10 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g12*map.g12 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g12*map.g12;
    const real G0_1_2 = map.det*c1*map.g10*map.g20 + map.det*c1*map.g10*map.g20 + map.det*c1*map.g10*map.g20 + map.det*c1*map.g10*map.g20 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g12*map.g22 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g12*map.g22;
    const real G0_2_0 = map.det*c1*map.g20*map.g00 + map.det*c1*map.g20*map.g00 + map.det*c1*map.g20*map.g00 + map.det*c1*map.g20*map.g00 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g22*map.g02 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g22*map.g02;
    const real G0_2_1 = map.det*c1*map.g20*map.g10 + map.det*c1*map.g20*map.g10 + map.det*c1*map.g20*map.g10 + map.det*c1*map.g20*map.g10 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g22*map.g12 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g22*map.g12;
    const real G0_2_2 = map.det*c1*map.g20*map.g20 + map.det*c1*map.g20*map.g20 + map.det*c1*map.g20*map.g20 + map.det*c1*map.g20*map.g20 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g22*map.g22 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g22*map.g22;
    const real G1_0_0 = map.det*c0*map.g00*map.g00 + map.det*c0*map.g00*map.g00 + map.det*c0*map.g00*map.g00 + map.det*c0*map.g00*map.g00;
    const real G1_0_1 = map.det*c0*map.g00*map.g10 + map.det*c0*map.g00*map.g10 + map.det*c0*map.g00*map.g10 + map.det*c0*map.g00*map.g10;
    const real G1_0_2 = map.det*c0*map.g00*map.g20 + map.det*c0*map.g00*map.g20 + map.det*c0*map.g00*map.g20 + map.det*c0*map.g00*map.g20;
    const real G1_1_0 = map.det*c0*map.g10*map.g00 + map.det*c0*map.g10*map.g00 + map.det*c0*map.g10*map.g00 + map.det*c0*map.g10*map.g00;
    const real G1_1_1 = map.det*c0*map.g10*map.g10 + map.det*c0*map.g10*map.g10 + map.det*c0*map.g10*map.g10 + map.det*c0*map.g10*map.g10;
    const real G1_1_2 = map.det*c0*map.g10*map.g20 + map.det*c0*map.g10*map.g20 + map.det*c0*map.g10*map.g20 + map.det*c0*map.g10*map.g20;
    const real G1_2_0 = map.det*c0*map.g20*map.g00 + map.det*c0*map.g20*map.g00 + map.det*c0*map.g20*map.g00 + map.det*c0*map.g20*map.g00;
    const real G1_2_1 = map.det*c0*map.g20*map.g10 + map.det*c0*map.g20*map.g10 + map.det*c0*map.g20*map.g10 + map.det*c0*map.g20*map.g10;
    const real G1_2_2 = map.det*c0*map.g20*map.g20 + map.det*c0*map.g20*map.g20 + map.det*c0*map.g20*map.g20 + map.det*c0*map.g20*map.g20;
    const real G2_0_0 = map.det*c0*map.g01*map.g00 + map.det*c0*map.g01*map.g00 + map.det*c0*map.g01*map.g00 + map.det*c0*map.g01*map.g00;
    const real G2_0_1 = map.det*c0*map.g01*map.g10 + map.det*c0*map.g01*map.g10 + map.det*c0*map.g01*map.g10 + map.det*c0*map.g01*map.g10;
    const real G2_0_2 = map.det*c0*map.g01*map.g20 + map.det*c0*map.g01*map.g20 + map.det*c0*map.g01*map.g20 + map.det*c0*map.g01*map.g20;
    const real G2_1_0 = map.det*c0*map.g11*map.g00 + map.det*c0*map.g11*map.g00 + map.det*c0*map.g11*map.g00 + map.det*c0*map.g11*map.g00;
    const real G2_1_1 = map.det*c0*map.g11*map.g10 + map.det*c0*map.g11*map.g10 + map.det*c0*map.g11*map.g10 + map.det*c0*map.g11*map.g10;
    const real G2_1_2 = map.det*c0*map.g11*map.g20 + map.det*c0*map.g11*map.g20 + map.det*c0*map.g11*map.g20 + map.det*c0*map.g11*map.g20;
    const real G2_2_0 = map.det*c0*map.g21*map.g00 + map.det*c0*map.g21*map.g00 + map.det*c0*map.g21*map.g00 + map.det*c0*map.g21*map.g00;
    const real G2_2_1 = map.det*c0*map.g21*map.g10 + map.det*c0*map.g21*map.g10 + map.det*c0*map.g21*map.g10 + map.det*c0*map.g21*map.g10;
    const real G2_2_2 = map.det*c0*map.g21*map.g20 + map.det*c0*map.g21*map.g20 + map.det*c0*map.g21*map.g20 + map.det*c0*map.g21*map.g20;
    const real G3_0_0 = map.det*c0*map.g02*map.g00 + map.det*c0*map.g02*map.g00 + map.det*c0*map.g02*map.g00 + map.det*c0*map.g02*map.g00;
    const real G3_0_1 = map.det*c0*map.g02*map.g10 + map.det*c0*map.g02*map.g10 + map.det*c0*map.g02*map.g10 + map.det*c0*map.g02*map.g10;
    const real G3_0_2 = map.det*c0*map.g02*map.g20 + map.det*c0*map.g02*map.g20 + map.det*c0*map.g02*map.g20 + map.det*c0*map.g02*map.g20;
    const real G3_1_0 = map.det*c0*map.g12*map.g00 + map.det*c0*map.g12*map.g00 + map.det*c0*map.g12*map.g00 + map.det*c0*map.g12*map.g00;
    const real G3_1_1 = map.det*c0*map.g12*map.g10 + map.det*c0*map.g12*map.g10 + map.det*c0*map.g12*map.g10 + map.det*c0*map.g12*map.g10;
    const real G3_1_2 = map.det*c0*map.g12*map.g20 + map.det*c0*map.g12*map.g20 + map.det*c0*map.g12*map.g20 + map.det*c0*map.g12*map.g20;
    const real G3_2_0 = map.det*c0*map.g22*map.g00 + map.det*c0*map.g22*map.g00 + map.det*c0*map.g22*map.g00 + map.det*c0*map.g22*map.g00;
    const real G3_2_1 = map.det*c0*map.g22*map.g10 + map.det*c0*map.g22*map.g10 + map.det*c0*map.g22*map.g10 + map.det*c0*map.g22*map.g10;
    const real G3_2_2 = map.det*c0*map.g22*map.g20 + map.det*c0*map.g22*map.g20 + map.det*c0*map.g22*map.g20 + map.det*c0*map.g22*map.g20;
    const real G4_0_0 = map.det*c1*map.g01*map.g00 + map.det*c1*map.g01*map.g00;
    const real G4_0_1 = map.det*c1*map.g01*map.g10 + map.det*c1*map.g01*map.g10;
    const real G4_0_2 = map.det*c1*map.g01*map.g20 + map.det*c1*map.g01*map.g20;
    const real G4_1_0 = map.det*c1*map.g11*map.g00 + map.det*c1*map.g11*map.g00;
    const real G4_1_1 = map.det*c1*map.g11*map.g10 + map.det*c1*map.g11*map.g10;
    const real G4_1_2 = map.det*c1*map.g11*map.g20 + map.det*c1*map.g11*map.g20;
    const real G4_2_0 = map.det*c1*map.g21*map.g00 + map.det*c1*map.g21*map.g00;
    const real G4_2_1 = map.det*c1*map.g21*map.g10 + map.det*c1*map.g21*map.g10;
    const real G4_2_2 = map.det*c1*map.g21*map.g20 + map.det*c1*map.g21*map.g20;
    const real G5_0_0 = map.det*c1*map.g00*map.g01 + map.det*c1*map.g00*map.g01;
    const real G5_0_1 = map.det*c1*map.g00*map.g11 + map.det*c1*map.g00*map.g11;
    const real G5_0_2 = map.det*c1*map.g00*map.g21 + map.det*c1*map.g00*map.g21;
    const real G5_1_0 = map.det*c1*map.g10*map.g01 + map.det*c1*map.g10*map.g01;
    const real G5_1_1 = map.det*c1*map.g10*map.g11 + map.det*c1*map.g10*map.g11;
    const real G5_1_2 = map.det*c1*map.g10*map.g21 + map.det*c1*map.g10*map.g21;
    const real G5_2_0 = map.det*c1*map.g20*map.g01 + map.det*c1*map.g20*map.g01;
    const real G5_2_1 = map.det*c1*map.g20*map.g11 + map.det*c1*map.g20*map.g11;
    const real G5_2_2 = map.det*c1*map.g20*map.g21 + map.det*c1*map.g20*map.g21;
    const real G6_0_0 = map.det*c1*map.g00*map.g00 + map.det*c1*map.g00*map.g00 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g02*map.g02 + map.det*c1*map.g02*map.g02;
    const real G6_0_1 = map.det*c1*map.g00*map.g10 + map.det*c1*map.g00*map.g10 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g02*map.g12 + map.det*c1*map.g02*map.g12;
    const real G6_0_2 = map.det*c1*map.g00*map.g20 + map.det*c1*map.g00*map.g20 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g02*map.g22 + map.det*c1*map.g02*map.g22;
    const real G6_1_0 = map.det*c1*map.g10*map.g00 + map.det*c1*map.g10*map.g00 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g12*map.g02 + map.det*c1*map.g12*map.g02;
    const real G6_1_1 = map.det*c1*map.g10*map.g10 + map.det*c1*map.g10*map.g10 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g12*map.g12 + map.det*c1*map.g12*map.g12;
    const real G6_1_2 = map.det*c1*map.g10*map.g20 + map.det*c1*map.g10*map.g20 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g12*map.g22 + map.det*c1*map.g12*map.g22;
    const real G6_2_0 = map.det*c1*map.g20*map.g00 + map.det*c1*map.g20*map.g00 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g22*map.g02 + map.det*c1*map.g22*map.g02;
    const real G6_2_1 = map.det*c1*map.g20*map.g10 + map.det*c1*map.g20*map.g10 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g22*map.g12 + map.det*c1*map.g22*map.g12;
    const real G6_2_2 = map.det*c1*map.g20*map.g20 + map.det*c1*map.g20*map.g20 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g22*map.g22 + map.det*c1*map.g22*map.g22;
    const real G13_0_0 = map.det*c1*map.g02*map.g00 + map.det*c1*map.g02*map.g00;
    const real G13_0_1 = map.det*c1*map.g02*map.g10 + map.det*c1*map.g02*map.g10;
    const real G13_0_2 = map.det*c1*map.g02*map.g20 + map.det*c1*map.g02*map.g20;
    const real G13_1_0 = map.det*c1*map.g12*map.g00 + map.det*c1*map.g12*map.g00;
    const real G13_1_1 = map.det*c1*map.g12*map.g10 + map.det*c1*map.g12*map.g10;
    const real G13_1_2 = map.det*c1*map.g12*map.g20 + map.det*c1*map.g12*map.g20;
    const real G13_2_0 = map.det*c1*map.g22*map.g00 + map.det*c1*map.g22*map.g00;
    const real G13_2_1 = map.det*c1*map.g22*map.g10 + map.det*c1*map.g22*map.g10;
    const real G13_2_2 = map.det*c1*map.g22*map.g20 + map.det*c1*map.g22*map.g20;
    const real G14_0_0 = map.det*c1*map.g00*map.g02 + map.det*c1*map.g00*map.g02;
    const real G14_0_1 = map.det*c1*map.g00*map.g12 + map.det*c1*map.g00*map.g12;
    const real G14_0_2 = map.det*c1*map.g00*map.g22 + map.det*c1*map.g00*map.g22;
    const real G14_1_0 = map.det*c1*map.g10*map.g02 + map.det*c1*map.g10*map.g02;
    const real G14_1_1 = map.det*c1*map.g10*map.g12 + map.det*c1*map.g10*map.g12;
    const real G14_1_2 = map.det*c1*map.g10*map.g22 + map.det*c1*map.g10*map.g22;
    const real G14_2_0 = map.det*c1*map.g20*map.g02 + map.det*c1*map.g20*map.g02;
    const real G14_2_1 = map.det*c1*map.g20*map.g12 + map.det*c1*map.g20*map.g12;
    const real G14_2_2 = map.det*c1*map.g20*map.g22 + map.det*c1*map.g20*map.g22;
    const real G15_0_0 = map.det*c1*map.g00*map.g00 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g00*map.g00 + map.det*c1*map.g01*map.g01 + map.det*c1*map.g02*map.g02 + map.det*c1*map.g02*map.g02 + map.det*c1*map.g02*map.g02 + map.det*c1*map.g02*map.g02;
    const real G15_0_1 = map.det*c1*map.g00*map.g10 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g00*map.g10 + map.det*c1*map.g01*map.g11 + map.det*c1*map.g02*map.g12 + map.det*c1*map.g02*map.g12 + map.det*c1*map.g02*map.g12 + map.det*c1*map.g02*map.g12;
    const real G15_0_2 = map.det*c1*map.g00*map.g20 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g00*map.g20 + map.det*c1*map.g01*map.g21 + map.det*c1*map.g02*map.g22 + map.det*c1*map.g02*map.g22 + map.det*c1*map.g02*map.g22 + map.det*c1*map.g02*map.g22;
    const real G15_1_0 = map.det*c1*map.g10*map.g00 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g10*map.g00 + map.det*c1*map.g11*map.g01 + map.det*c1*map.g12*map.g02 + map.det*c1*map.g12*map.g02 + map.det*c1*map.g12*map.g02 + map.det*c1*map.g12*map.g02;
    const real G15_1_1 = map.det*c1*map.g10*map.g10 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g10*map.g10 + map.det*c1*map.g11*map.g11 + map.det*c1*map.g12*map.g12 + map.det*c1*map.g12*map.g12 + map.det*c1*map.g12*map.g12 + map.det*c1*map.g12*map.g12;
    const real G15_1_2 = map.det*c1*map.g10*map.g20 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g10*map.g20 + map.det*c1*map.g11*map.g21 + map.det*c1*map.g12*map.g22 + map.det*c1*map.g12*map.g22 + map.det*c1*map.g12*map.g22 + map.det*c1*map.g12*map.g22;
    const real G15_2_0 = map.det*c1*map.g20*map.g00 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g20*map.g00 + map.det*c1*map.g21*map.g01 + map.det*c1*map.g22*map.g02 + map.det*c1*map.g22*map.g02 + map.det*c1*map.g22*map.g02 + map.det*c1*map.g22*map.g02;
    const real G15_2_1 = map.det*c1*map.g20*map.g10 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g20*map.g10 + map.det*c1*map.g21*map.g11 + map.det*c1*map.g22*map.g12 + map.det*c1*map.g22*map.g12 + map.det*c1*map.g22*map.g12 + map.det*c1*map.g22*map.g12;
    const real G15_2_2 = map.det*c1*map.g20*map.g20 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g20*map.g20 + map.det*c1*map.g21*map.g21 + map.det*c1*map.g22*map.g22 + map.det*c1*map.g22*map.g22 + map.det*c1*map.g22*map.g22 + map.det*c1*map.g22*map.g22;
    const real G19_0_0 = map.det*c0*map.g00*map.g01 + map.det*c0*map.g00*map.g01 + map.det*c0*map.g00*map.g01 + map.det*c0*map.g00*map.g01;
    const real G19_0_1 = map.det*c0*map.g00*map.g11 + map.det*c0*map.g00*map.g11 + map.det*c0*map.g00*map.g11 + map.det*c0*map.g00*map.g11;
    const real G19_0_2 = map.det*c0*map.g00*map.g21 + map.det*c0*map.g00*map.g21 + map.det*c0*map.g00*map.g21 + map.det*c0*map.g00*map.g21;
    const real G19_1_0 = map.det*c0*map.g10*map.g01 + map.det*c0*map.g10*map.g01 + map.det*c0*map.g10*map.g01 + map.det*c0*map.g10*map.g01;
    const real G19_1_1 = map.det*c0*map.g10*map.g11 + map.det*c0*map.g10*map.g11 + map.det*c0*map.g10*map.g11 + map.det*c0*map.g10*map.g11;
    const real G19_1_2 = map.det*c0*map.g10*map.g21 + map.det*c0*map.g10*map.g21 + map.det*c0*map.g10*map.g21 + map.det*c0*map.g10*map.g21;
    const real G19_2_0 = map.det*c0*map.g20*map.g01 + map.det*c0*map.g20*map.g01 + map.det*c0*map.g20*map.g01 + map.det*c0*map.g20*map.g01;
    const real G19_2_1 = map.det*c0*map.g20*map.g11 + map.det*c0*map.g20*map.g11 + map.det*c0*map.g20*map.g11 + map.det*c0*map.g20*map.g11;
    const real G19_2_2 = map.det*c0*map.g20*map.g21 + map.det*c0*map.g20*map.g21 + map.det*c0*map.g20*map.g21 + map.det*c0*map.g20*map.g21;
    const real G20_0_0 = map.det*c0*map.g01*map.g01 + map.det*c0*map.g01*map.g01 + map.det*c0*map.g01*map.g01 + map.det*c0*map.g01*map.g01;
    const real G20_0_1 = map.det*c0*map.g01*map.g11 + map.det*c0*map.g01*map.g11 + map.det*c0*map.g01*map.g11 + map.det*c0*map.g01*map.g11;
    const real G20_0_2 = map.det*c0*map.g01*map.g21 + map.det*c0*map.g01*map.g21 + map.det*c0*map.g01*map.g21 + map.det*c0*map.g01*map.g21;
    const real G20_1_0 = map.det*c0*map.g11*map.g01 + map.det*c0*map.g11*map.g01 + map.det*c0*map.g11*map.g01 + map.det*c0*map.g11*map.g01;
    const real G20_1_1 = map.det*c0*map.g11*map.g11 + map.det*c0*map.g11*map.g11 + map.det*c0*map.g11*map.g11 + map.det*c0*map.g11*map.g11;
    const real G20_1_2 = map.det*c0*map.g11*map.g21 + map.det*c0*map.g11*map.g21 + map.det*c0*map.g11*map.g21 + map.det*c0*map.g11*map.g21;
    const real G20_2_0 = map.det*c0*map.g21*map.g01 + map.det*c0*map.g21*map.g01 + map.det*c0*map.g21*map.g01 + map.det*c0*map.g21*map.g01;
    const real G20_2_1 = map.det*c0*map.g21*map.g11 + map.det*c0*map.g21*map.g11 + map.det*c0*map.g21*map.g11 + map.det*c0*map.g21*map.g11;
    const real G20_2_2 = map.det*c0*map.g21*map.g21 + map.det*c0*map.g21*map.g21 + map.det*c0*map.g21*map.g21 + map.det*c0*map.g21*map.g21;
    const real G21_0_0 = map.det*c0*map.g02*map.g01 + map.det*c0*map.g02*map.g01 + map.det*c0*map.g02*map.g01 + map.det*c0*map.g02*map.g01;
    const real G21_0_1 = map.det*c0*map.g02*map.g11 + map.det*c0*map.g02*map.g11 + map.det*c0*map.g02*map.g11 + map.det*c0*map.g02*map.g11;
    const real G21_0_2 = map.det*c0*map.g02*map.g21 + map.det*c0*map.g02*map.g21 + map.det*c0*map.g02*map.g21 + map.det*c0*map.g02*map.g21;
    const real G21_1_0 = map.det*c0*map.g12*map.g01 + map.det*c0*map.g12*map.g01 + map.det*c0*map.g12*map.g01 + map.det*c0*map.g12*map.g01;
    const real G21_1_1 = map.det*c0*map.g12*map.g11 + map.det*c0*map.g12*map.g11 + map.det*c0*map.g12*map.g11 + map.det*c0*map.g12*map.g11;
    const real G21_1_2 = map.det*c0*map.g12*map.g21 + map.det*c0*map.g12*map.g21 + map.det*c0*map.g12*map.g21 + map.det*c0*map.g12*map.g21;
    const real G21_2_0 = map.det*c0*map.g22*map.g01 + map.det*c0*map.g22*map.g01 + map.det*c0*map.g22*map.g01 + map.det*c0*map.g22*map.g01;
    const real G21_2_1 = map.det*c0*map.g22*map.g11 + map.det*c0*map.g22*map.g11 + map.det*c0*map.g22*map.g11 + map.det*c0*map.g22*map.g11;
    const real G21_2_2 = map.det*c0*map.g22*map.g21 + map.det*c0*map.g22*map.g21 + map.det*c0*map.g22*map.g21 + map.det*c0*map.g22*map.g21;
    const real G22_0_0 = map.det*c1*map.g02*map.g01 + map.det*c1*map.g02*map.g01;
    const real G22_0_1 = map.det*c1*map.g02*map.g11 + map.det*c1*map.g02*map.g11;
    const real G22_0_2 = map.det*c1*map.g02*map.g21 + map.det*c1*map.g02*map.g21;
    const real G22_1_0 = map.det*c1*map.g12*map.g01 + map.det*c1*map.g12*map.g01;
    const real G22_1_1 = map.det*c1*map.g12*map.g11 + map.det*c1*map.g12*map.g11;
    const real G22_1_2 = map.det*c1*map.g12*map.g21 + map.det*c1*map.g12*map.g21;
    const real G22_2_0 = map.det*c1*map.g22*map.g01 + map.det*c1*map.g22*map.g01;
    const real G22_2_1 = map.det*c1*map.g22*map.g11 + map.det*c1*map.g22*map.g11;
    const real G22_2_2 = map.det*c1*map.g22*map.g21 + map.det*c1*map.g22*map.g21;
    const real G23_0_0 = map.det*c1*map.g01*map.g02 + map.det*c1*map.g01*map.g02;
    const real G23_0_1 = map.det*c1*map.g01*map.g12 + map.det*c1*map.g01*map.g12;
    const real G23_0_2 = map.det*c1*map.g01*map.g22 + map.det*c1*map.g01*map.g22;
    const real G23_1_0 = map.det*c1*map.g11*map.g02 + map.det*c1*map.g11*map.g02;
    const real G23_1_1 = map.det*c1*map.g11*map.g12 + map.det*c1*map.g11*map.g12;
    const real G23_1_2 = map.det*c1*map.g11*map.g22 + map.det*c1*map.g11*map.g22;
    const real G23_2_0 = map.det*c1*map.g21*map.g02 + map.det*c1*map.g21*map.g02;
    const real G23_2_1 = map.det*c1*map.g21*map.g12 + map.det*c1*map.g21*map.g12;
    const real G23_2_2 = map.det*c1*map.g21*map.g22 + map.det*c1*map.g21*map.g22;
    const real G24_0_0 = map.det*c0*map.g00*map.g02 + map.det*c0*map.g00*map.g02 + map.det*c0*map.g00*map.g02 + map.det*c0*map.g00*map.g02;
    const real G24_0_1 = map.det*c0*map.g00*map.g12 + map.det*c0*map.g00*map.g12 + map.det*c0*map.g00*map.g12 + map.det*c0*map.g00*map.g12;
    const real G24_0_2 = map.det*c0*map.g00*map.g22 + map.det*c0*map.g00*map.g22 + map.det*c0*map.g00*map.g22 + map.det*c0*map.g00*map.g22;
    const real G24_1_0 = map.det*c0*map.g10*map.g02 + map.det*c0*map.g10*map.g02 + map.det*c0*map.g10*map.g02 + map.det*c0*map.g10*map.g02;
    const real G24_1_1 = map.det*c0*map.g10*map.g12 + map.det*c0*map.g10*map.g12 + map.det*c0*map.g10*map.g12 + map.det*c0*map.g10*map.g12;
    const real G24_1_2 = map.det*c0*map.g10*map.g22 + map.det*c0*map.g10*map.g22 + map.det*c0*map.g10*map.g22 + map.det*c0*map.g10*map.g22;
    const real G24_2_0 = map.det*c0*map.g20*map.g02 + map.det*c0*map.g20*map.g02 + map.det*c0*map.g20*map.g02 + map.det*c0*map.g20*map.g02;
    const real G24_2_1 = map.det*c0*map.g20*map.g12 + map.det*c0*map.g20*map.g12 + map.det*c0*map.g20*map.g12 + map.det*c0*map.g20*map.g12;
    const real G24_2_2 = map.det*c0*map.g20*map.g22 + map.det*c0*map.g20*map.g22 + map.det*c0*map.g20*map.g22 + map.det*c0*map.g20*map.g22;
    const real G25_0_0 = map.det*c0*map.g01*map.g02 + map.det*c0*map.g01*map.g02 + map.det*c0*map.g01*map.g02 + map.det*c0*map.g01*map.g02;
    const real G25_0_1 = map.det*c0*map.g01*map.g12 + map.det*c0*map.g01*map.g12 + map.det*c0*map.g01*map.g12 + map.det*c0*map.g01*map.g12;
    const real G25_0_2 = map.det*c0*map.g01*map.g22 + map.det*c0*map.g01*map.g22 + map.det*c0*map.g01*map.g22 + map.det*c0*map.g01*map.g22;
    const real G25_1_0 = map.det*c0*map.g11*map.g02 + map.det*c0*map.g11*map.g02 + map.det*c0*map.g11*map.g02 + map.det*c0*map.g11*map.g02;
    const real G25_1_1 = map.det*c0*map.g11*map.g12 + map.det*c0*map.g11*map.g12 + map.det*c0*map.g11*map.g12 + map.det*c0*map.g11*map.g12;
    const real G25_1_2 = map.det*c0*map.g11*map.g22 + map.det*c0*map.g11*map.g22 + map.det*c0*map.g11*map.g22 + map.det*c0*map.g11*map.g22;
    const real G25_2_0 = map.det*c0*map.g21*map.g02 + map.det*c0*map.g21*map.g02 + map.det*c0*map.g21*map.g02 + map.det*c0*map.g21*map.g02;
    const real G25_2_1 = map.det*c0*map.g21*map.g12 + map.det*c0*map.g21*map.g12 + map.det*c0*map.g21*map.g12 + map.det*c0*map.g21*map.g12;
    const real G25_2_2 = map.det*c0*map.g21*map.g22 + map.det*c0*map.g21*map.g22 + map.det*c0*map.g21*map.g22 + map.det*c0*map.g21*map.g22;
    const real G26_0_0 = map.det*c0*map.g02*map.g02 + map.det*c0*map.g02*map.g02 + map.det*c0*map.g02*map.g02 + map.det*c0*map.g02*map.g02;
    const real G26_0_1 = map.det*c0*map.g02*map.g12 + map.det*c0*map.g02*map.g12 + map.det*c0*map.g02*map.g12 + map.det*c0*map.g02*map.g12;
    const real G26_0_2 = map.det*c0*map.g02*map.g22 + map.det*c0*map.g02*map.g22 + map.det*c0*map.g02*map.g22 + map.det*c0*map.g02*map.g22;
    const real G26_1_0 = map.det*c0*map.g12*map.g02 + map.det*c0*map.g12*map.g02 + map.det*c0*map.g12*map.g02 + map.det*c0*map.g12*map.g02;
    const real G26_1_1 = map.det*c0*map.g12*map.g12 + map.det*c0*map.g12*map.g12 + map.det*c0*map.g12*map.g12 + map.det*c0*map.g12*map.g12;
    const real G26_1_2 = map.det*c0*map.g12*map.g22 + map.det*c0*map.g12*map.g22 + map.det*c0*map.g12*map.g22 + map.det*c0*map.g12*map.g22;
    const real G26_2_0 = map.det*c0*map.g22*map.g02 + map.det*c0*map.g22*map.g02 + map.det*c0*map.g22*map.g02 + map.det*c0*map.g22*map.g02;
    const real G26_2_1 = map.det*c0*map.g22*map.g12 + map.det*c0*map.g22*map.g12 + map.det*c0*map.g22*map.g12 + map.det*c0*map.g22*map.g12;
    const real G26_2_2 = map.det*c0*map.g22*map.g22 + map.det*c0*map.g22*map.g22 + map.det*c0*map.g22*map.g22 + map.det*c0*map.g22*map.g22;

    // Compute element tensor
    block[0] = 8.333333333333320e-02*G0_0_0 + 8.333333333333322e-02*G0_0_1 + 8.333333333333320e-02*G0_0_2 + 8.333333333333322e-02*G0_1_0 + 8.333333333333323e-02*G0_1_1 + 8.333333333333322e-02*G0_1_2 + 8.333333333333320e-02*G0_2_0 + 8.333333333333322e-02*G0_2_1 + 8.333333333333320e-02*G0_2_2 + 4.166666666666660e-02*G1_0_0 + 4.166666666666661e-02*G1_0_1 + 4.166666666666660e-02*G1_0_2 + 4.166666666666661e-02*G1_1_0 + 4.166666666666662e-02*G1_1_1 + 4.166666666666661e-02*G1_1_2 + 4.166666666666660e-02*G1_2_0 + 4.166666666666661e-02*G1_2_1 + 4.166666666666660e-02*G1_2_2;
    block[1] = -8.333333333333320e-02*G0_0_0 - 8.333333333333322e-02*G0_0_1 - 8.333333333333320e-02*G0_0_2 - 4.166666666666660e-02*G1_0_0 - 4.166666666666661e-02*G1_0_1 - 4.166666666666660e-02*G1_0_2;
    block[2] = -8.333333333333322e-02*G0_1_0 - 8.333333333333323e-02*G0_1_1 - 8.333333333333322e-02*G0_1_2 - 4.166666666666661e-02*G1_1_0 - 4.166666666666662e-02*G1_1_1 - 4.166666666666661e-02*G1_1_2;
    block[3] = -8.333333333333322e-02*G0_2_0 - 8.333333333333323e-02*G0_2_1 - 8.333333333333322e-02*G0_2_2 - 4.166666666666661e-02*G1_2_0 - 4.166666666666662e-02*G1_2_1 - 4.166666666666661e-02*G1_2_2;
    block[4] = 4.166666666666660e-02*G2_0_0 + 4.166666666666661e-02*G2_0_1 + 4.166666666666660e-02*G2_0_2 + 4.166666666666661e-02*G2_1_0 + 4.166666666666662e-02*G2_1_1 + 4.166666666666661e-02*G2_1_2 + 4.166666666666661e-02*G2_2_0 + 4.166666666666662e-02*G2_2_1 + 4.166666666666661e-02*G2_2_2 + 8.333333333333320e-02*G5_0_0 + 8.333333333333322e-02*G5_0_1 + 8.333333333333320e-02*G5_0_2 + 8.333333333333322e-02*G5_1_0 + 8.333333333333323e-02*G5_1_1 + 8.333333333333322e-02*G5_1_2 + 8.333333333333322e-02*G5_2_0 + 8.333333333333323e-02*G5_2_1 + 8.333333333333322e-02*G5_2_2;
    block[5] = -4.166666666666660e-02*G2_0_0 - 4.166666666666661e-02*G2_0_1 - 4.166666666666660e-02*G2_0_2 - 8.333333333333320e-02*G5_0_0 - 8.333333333333322e-02*G5_0_1 - 8.333333333333320e-02*G5_0_2;
    block[6] = -4.166666666666661e-02*G2_1_0 - 4.166666666666662e-02*G2_1_1 - 4.166666666666661e-02*G2_1_2 - 8.333333333333322e-02*G5_1_0 - 8.333333333333323e-02*G5_1_1 - 8.333333333333322e-02*G5_1_2;
    block[7] = -4.166666666666661e-02*G2_2_0 - 4.166666666666662e-02*G2_2_1 - 4.166666666666661e-02*G2_2_2 - 8.333333333333322e-02*G5_2_0 - 8.333333333333323e-02*G5_2_1 - 8.333333333333322e-02*G5_2_2;
    block[8] = 4.166666666666660e-02*G3_0_0 + 4.166666666666661e-02*G3_0_1 + 4.166666666666660e-02*G3_0_2 + 4.166666666666661e-02*G3_1_0 + 4.166666666666662e-02*G3_1_1 + 4.166666666666661e-02*G3_1_2 + 4.166666666666661e-02*G3_2_0 + 4.166666666666662e-02*G3_2_1 + 4.166666666666661e-02*G3_2_2 + 8.333333333333320e-02*G14_0_0 + 8.333333333333322e-02*G14_0_1 + 8.333333333333320e-02*G14_0_2 + 8.333333333333322e-02*G14_1_0 + 8.333333333333323e-02*G14_1_1 + 8.333333333333322e-02*G14_1_2 + 8.333333333333322e-02*G14_2_0 + 8.333333333333323e-02*G14_2_1 + 8.333333333333322e-02*G14_2_2;
    block[9] = -4.166666666666660e-02*G3_0_0 - 4.166666666666661e-02*G3_0_1 - 4.166666666666660e-02*G3_0_2 - 8.333333333333320e-02*G14_0_0 - 8.333333333333322e-02*G14_0_1 - 8.333333333333320e-02*G14_0_2;
    block[10] = -4.166666666666661e-02*G3_1_0 - 4.166666666666662e-02*G3_1_1 - 4.166666666666661e-02*G3_1_2 - 8.333333333333322e-02*G14_1_0 - 8.333333333333323e-02*G14_1_1 - 8.333333333333322e-02*G14_1_2;
    block[11] = -4.166666666666661e-02*G3_2_0 - 4.166666666666662e-02*G3_2_1 - 4.166666666666661e-02*G3_2_2 - 8.333333333333322e-02*G14_2_0 - 8.333333333333323e-02*G14_2_1 - 8.333333333333322e-02*G14_2_2;
    block[12] = -8.333333333333320e-02*G0_0_0 - 8.333333333333322e-02*G0_1_0 - 8.333333333333320e-02*G0_2_0 - 4.166666666666660e-02*G1_0_0 - 4.166666666666661e-02*G1_1_0 - 4.166666666666660e-02*G1_2_0;
    block[13] = 8.333333333333320e-02*G0_0_0 + 4.166666666666660e-02*G1_0_0;
    block[14] = 8.333333333333322e-02*G0_1_0 + 4.166666666666661e-02*G1_1_0;
    block[15] = 8.333333333333322e-02*G0_2_0 + 4.166666666666661e-02*G1_2_0;
    block[16] = -4.166666666666660e-02*G2_0_0 - 4.166666666666661e-02*G2_1_0 - 4.166666666666661e-02*G2_2_0 - 8.333333333333320e-02*G5_0_0 - 8.333333333333322e-02*G5_1_0 - 8.333333333333322e-02*G5_2_0;
    block[17] = 4.166666666666660e-02*G2_0_0 + 8.333333333333320e-02*G5_0_0;
    block[18] = 4.166666666666661e-02*G2_1_0 + 8.333333333333322e-02*G5_1_0;
    block[19] = 4.166666666666661e-02*G2_2_0 + 8.333333333333322e-02*G5_2_0;
    block[20] = -4.166666666666660e-02*G3_0_0 - 4.166666666666661e-02*G3_1_0 - 4.166666666666661e-02*G3_2_0 - 8.333333333333320e-02*G14_0_0 - 8.333333333333322e-02*G14_1_0 - 8.333333333333322e-02*G14_2_0;
    block[21] = 4.166666666666660e-02*G3_0_0 + 8.333333333333320e-02*G14_0_0;
    block[22] = 4.166666666666661e-02*G3_1_0 + 8.333333333333322e-02*G14_1_0;
    block[23] = 4.166666666666661e-02*G3_2_0 + 8.333333333333322e-02*G14_2_0;
    block[24] = -8.333333333333322e-02*G0_0_1 - 8.333333333333323e-02*G0_1_1 - 8.333333333333322e-02*G0_2_1 - 4.166666666666661e-02*G1_0_1 - 4.166666666666662e-02*G1_1_1 - 4.166666666666661e-02*G1_2_1;
    block[25] = 8.333333333333322e-02*G0_0_1 + 4.166666666666661e-02*G1_0_1;
    block[26] = 8.333333333333323e-02*G0_1_1 + 4.166666666666662e-02*G1_1_1;
    block[27] = 8.333333333333323e-02*G0_2_1 + 4.166666666666662e-02*G1_2_1;
    block[28] = -4.166666666666661e-02*G2_0_1 - 4.166666666666662e-02*G2_1_1 - 4.166666666666662e-02*G2_2_1 - 8.333333333333322e-02*G5_0_1 - 8.333333333333323e-02*G5_1_1 - 8.333333333333323e-02*G5_2_1;
    block[29] = 4.166666666666661e-02*G2_0_1 + 8.333333333333322e-02*G5_0_1;
    block[30] = 4.166666666666662e-02*G2_1_1 + 8.333333333333323e-02*G5_1_1;
    block[31] = 4.166666666666662e-02*G2_2_1 + 8.333333333333323e-02*G5_2_1;
    block[32] = -4.166666666666661e-02*G3_0_1 - 4.166666666666662e-02*G3_1_1 - 4.166666666666662e-02*G3_2_1 - 8.333333333333322e-02*G14_0_1 - 8.333333333333323e-02*G14_1_1 - 8.333333333333323e-02*G14_2_1;
    block[33] = 4.166666666666661e-02*G3_0_1 + 8.333333333333322e-02*G14_0_1;
    block[34] = 4.166666666666662e-02*G3_1_1 + 8.333333333333323e-02*G14_1_1;
    block[35] = 4.166666666666662e-02*G3_2_1 + 8.333333333333323e-02*G14_2_1;
    block[36] = -8.333333333333322e-02*G0_0_2 - 8.333333333333323e-02*G0_1_2 - 8.333333333333322e-02*G0_2_2 - 4.166666666666661e-02*G1_0_2 - 4.166666666666662e-02*G1_1_2 - 4.166666666666661e-02*G1_2_2;
    block[37] = 8.333333333333322e-02*G0_0_2 + 4.166666666666661e-02*G1_0_2;
    block[38] = 8.333333333333323e-02*G0_1_2 + 4.166666666666662e-02*G1_1_2;
    block[39] = 8.333333333333323e-02*G0_2_2 + 4.166666666666662e-02*G1_2_2;
    block[40] = -4.166666666666661e-02*G2_0_2 - 4.166666666666662e-02*G2_1_2 - 4.166666666666662e-02*G2_2_2 - 8.333333333333322e-02*G5_0_2 - 8.333333333333323e-02*G5_1_2 - 8.333333333333323e-02*G5_2_2;
    block[41] = 4.166666666666661e-02*G2_0_2 + 8.333333333333322e-02*G5_0_2;
    block[42] = 4.166666666666662e-02*G2_1_2 + 8.333333333333323e-02*G5_1_2;
    block[43] = 4.166666666666662e-02*G2_2_2 + 8.333333333333323e-02*G5_2_2;
    block[44] = -4.166666666666661e-02*G3_0_2 - 4.166666666666662e-02*G3_1_2 - 4.166666666666662e-02*G3_2_2 - 8.333333333333322e-02*G14_0_2 - 8.333333333333323e-02*G14_1_2 - 8.333333333333323e-02*G14_2_2;
    block[45] = 4.166666666666661e-02*G3_0_2 + 8.333333333333322e-02*G14_0_2;
    block[46] = 4.166666666666662e-02*G3_1_2 + 8.333333333333323e-02*G14_1_2;
    block[47] = 4.166666666666662e-02*G3_2_2 + 8.333333333333323e-02*G14_2_2;
    block[48] = 8.333333333333320e-02*G4_0_0 + 8.333333333333322e-02*G4_0_1 + 8.333333333333322e-02*G4_0_2 + 8.333333333333322e-02*G4_1_0 + 8.333333333333323e-02*G4_1_1 + 8.333333333333323e-02*G4_1_2 + 8.333333333333320e-02*G4_2_0 + 8.333333333333322e-02*G4_2_1 + 8.333333333333322e-02*G4_2_2 + 4.166666666666660e-02*G19_0_0 + 4.166666666666661e-02*G19_0_1 + 4.166666666666661e-02*G19_0_2 + 4.166666666666661e-02*G19_1_0 + 4.166666666666662e-02*G19_1_1 + 4.166666666666662e-02*G19_1_2 + 4.166666666666660e-02*G19_2_0 + 4.166666666666661e-02*G19_2_1 + 4.166666666666661e-02*G19_2_2;
    block[49] = -8.333333333333320e-02*G4_0_0 - 8.333333333333322e-02*G4_0_1 - 8.333333333333322e-02*G4_0_2 - 4.166666666666660e-02*G19_0_0 - 4.166666666666661e-02*G19_0_1 - 4.166666666666661e-02*G19_0_2;
    block[50] = -8.333333333333322e-02*G4_1_0 - 8.333333333333323e-02*G4_1_1 - 8.333333333333323e-02*G4_1_2 - 4.166666666666661e-02*G19_1_0 - 4.166666666666662e-02*G19_1_1 - 4.166666666666662e-02*G19_1_2;
    block[51] = -8.333333333333322e-02*G4_2_0 - 8.333333333333323e-02*G4_2_1 - 8.333333333333323e-02*G4_2_2 - 4.166666666666661e-02*G19_2_0 - 4.166666666666662e-02*G19_2_1 - 4.166666666666662e-02*G19_2_2;
    block[52] = 8.333333333333320e-02*G6_0_0 + 8.333333333333322e-02*G6_0_1 + 8.333333333333322e-02*G6_0_2 + 8.333333333333322e-02*G6_1_0 + 8.333333333333323e-02*G6_1_1 + 8.333333333333323e-02*G6_1_2 + 8.333333333333322e-02*G6_2_0 + 8.333333333333323e-02*G6_2_1 + 8.333333333333323e-02*G6_2_2 + 4.166666666666660e-02*G20_0_0 + 4.166666666666661e-02*G20_0_1 + 4.166666666666661e-02*G20_0_2 + 4.166666666666661e-02*G20_1_0 + 4.166666666666662e-02*G20_1_1 + 4.166666666666662e-02*G20_1_2 + 4.166666666666661e-02*G20_2_0 + 4.166666666666662e-02*G20_2_1 + 4.166666666666662e-02*G20_2_2;
    block[53] = -8.333333333333320e-02*G6_0_0 - 8.333333333333322e-02*G6_0_1 - 8.333333333333322e-02*G6_0_2 - 4.166666666666660e-02*G20_0_0 - 4.166666666666661e-02*G20_0_1 - 4.166666666666661e-02*G20_0_2;
    block[54] = -8.333333333333322e-02*G6_1_0 - 8.333333333333323e-02*G6_1_1 - 8.333333333333323e-02*G6_1_2 - 4.166666666666661e-02*G20_1_0 - 4.166666666666662e-02*G20_1_1 - 4.166666666666662e-02*G20_1_2;
    block[55] = -8.333333333333322e-02*G6_2_0 - 8.333333333333323e-02*G6_2_1 - 8.333333333333323e-02*G6_2_2 - 4.166666666666661e-02*G20_2_0 - 4.166666666666662e-02*G20_2_1 - 4.166666666666662e-02*G20_2_2;
    block[56] = 4.166666666666660e-02*G21_0_0 + 4.166666666666661e-02*G21_0_1 + 4.166666666666661e-02*G21_0_2 + 4.166666666666661e-02*G21_1_0 + 4.166666666666662e-02*G21_1_1 + 4.166666666666662e-02*G21_1_2 + 4.166666666666661e-02*G21_2_0 + 4.166666666666662e-02*G21_2_1 + 4.166666666666662e-02*G21_2_2 + 8.333333333333320e-02*G23_0_0 + 8.333333333333322e-02*G23_0_1 + 8.333333333333322e-02*G23_0_2 + 8.333333333333322e-02*G23_1_0 + 8.333333333333323e-02*G23_1_1 + 8.333333333333323e-02*G23_1_2 + 8.333333333333322e-02*G23_2_0 + 8.333333333333323e-02*G23_2_1 + 8.333333333333323e-02*G23_2_2;
    block[57] = -4.166666666666660e-02*G21_0_0 - 4.166666666666661e-02*G21_0_1 - 4.166666666666661e-02*G21_0_2 - 8.333333333333320e-02*G23_0_0 - 8.333333333333322e-02*G23_0_1 - 8.333333333333322e-02*G23_0_2;
    block[58] = -4.166666666666661e-02*G21_1_0 - 4.166666666666662e-02*G21_1_1 - 4.166666666666662e-02*G21_1_2 - 8.333333333333322e-02*G23_1_0 - 8.333333333333323e-02*G23_1_1 - 8.333333333333323e-02*G23_1_2;
    block[59] = -4.166666666666661e-02*G21_2_0 - 4.166666666666662e-02*G21_2_1 - 4.166666666666662e-02*G21_2_2 - 8.333333333333322e-02*G23_2_0 - 8.333333333333323e-02*G23_2_1 - 8.333333333333323e-02*G23_2_2;
    block[60] = -8.333333333333320e-02*G4_0_0 - 8.333333333333322e-02*G4_1_0 - 8.333333333333320e-02*G4_2_0 - 4.166666666666660e-02*G19_0_0 - 4.166666666666661e-02*G19_1_0 - 4.166666666666660e-02*G19_2_0;
    block[61] = 8.333333333333320e-02*G4_0_0 + 4.166666666666660e-02*G19_0_0;
    block[62] = 8.333333333333322e-02*G4_1_0 + 4.166666666666661e-02*G19_1_0;
    block[63] = 8.333333333333322e-02*G4_2_0 + 4.166666666666661e-02*G19_2_0;
    block[64] = -8.333333333333320e-02*G6_0_0 - 8.333333333333322e-02*G6_1_0 - 8.333333333333322e-02*G6_2_0 - 4.166666666666660e-02*G20_0_0 - 4.166666666666661e-02*G20_1_0 - 4.166666666666661e-02*G20_2_0;
    block[65] = 8.333333333333320e-02*G6_0_0 + 4.166666666666660e-02*G20_0_0;
    block[66] = 8.333333333333322e-02*G6_1_0 + 4.166666666666661e-02*G20_1_0;
    block[67] = 8.333333333333322e-02*G6_2_0 + 4.166666666666661e-02*G20_2_0;
    block[68] = -4.166666666666660e-02*G21_0_0 - 4.166666666666661e-02*G21_1_0 - 4.166666666666661e-02*G21_2_0 - 8.333333333333320e-02*G23_0_0 - 8.333333333333322e-02*G23_1_0 - 8.333333333333322e-02*G23_2_0;
    block[69] = 4.166666666666660e-02*G21_0_0 + 8.333333333333320e-02*G23_0_0;
    block[70] = 4.166666666666661e-02*G21_1_0 + 8.333333333333322e-02*G23_1_0;
    block[71] = 4.166666666666661e-02*G21_2_0 + 8.333333333333322e-02*G23_2_0;
    block[72] = -8.333333333333322e-02*G4_0_1 - 8.333333333333323e-02*G4_1_1 - 8.333333333333322e-02*G4_2_1 - 4.166666666666661e-02*G19_0_1 - 4.166666666666662e-02*G19_1_1 - 4.166666666666661e-02*G19_2_1;
    block[73] = 8.333333333333322e-02*G4_0_1 + 4.166666666666661e-02*G19_0_1;
    block[74] = 8.333333333333323e-02*G4_1_1 + 4.166666666666662e-02*G19_1_1;
    block[75] = 8.333333333333323e-02*G4_2_1 + 4.166666666666662e-02*G19_2_1;
    block[76] = -8.333333333333322e-02*G6_0_1 - 8.333333333333323e-02*G6_1_1 - 8.333333333333323e-02*G6_2_1 - 4.166666666666661e-02*G20_0_1 - 4.166666666666662e-02*G20_1_1 - 4.166666666666662e-02*G20_2_1;
    block[77] = 8.333333333333322e-02*G6_0_1 + 4.166666666666661e-02*G20_0_1;
    block[78] = 8.333333333333323e-02*G6_1_1 + 4.166666666666662e-02*G20_1_1;
    block[79] = 8.333333333333323e-02*G6_2_1 + 4.166666666666662e-02*G20_2_1;
    block[80] = -4.166666666666661e-02*G21_0_1 - 4.166666666666662e-02*G21_1_1 - 4.166666666666662e-02*G21_2_1 - 8.333333333333322e-02*G23_0_1 - 8.333333333333323e-02*G23_1_1 - 8.333333333333323e-02*G23_2_1;
    block[81] = 4.166666666666661e-02*G21_0_1 + 8.333333333333322e-02*G23_0_1;
    block[82] = 4.166666666666662e-02*G21_1_1 + 8.333333333333323e-02*G23_1_1;
    block[83] = 4.166666666666662e-02*G21_2_1 + 8.333333333333323e-02*G23_2_1;
    block[84] = -8.333333333333322e-02*G4_0_2 - 8.333333333333323e-02*G4_1_2 - 8.333333333333322e-02*G4_2_2 - 4.166666666666661e-02*G19_0_2 - 4.166666666666662e-02*G19_1_2 - 4.166666666666661e-02*G19_2_2;
    block[85] = 8.333333333333322e-02*G4_0_2 + 4.166666666666661e-02*G19_0_2;
    block[86] = 8.333333333333323e-02*G4_1_2 + 4.166666666666662e-02*G19_1_2;
    block[87] = 8.333333333333323e-02*G4_2_2 + 4.166666666666662e-02*G19_2_2;
    block[88] = -8.333333333333322e-02*G6_0_2 - 8.333333333333323e-02*G6_1_2 - 8.333333333333323e-02*G6_2_2 - 4.166666666666661e-02*G20_0_2 - 4.166666666666662e-02*G20_1_2 - 4.166666666666662e-02*G20_2_2;
    block[89] = 8.333333333333322e-02*G6_0_2 + 4.166666666666661e-02*G20_0_2;
    block[90] = 8.333333333333323e-02*G6_1_2 + 4.166666666666662e-02*G20_1_2;
    block[91] = 8.333333333333323e-02*G6_2_2 + 4.166666666666662e-02*G20_2_2;
    block[92] = -4.166666666666661e-02*G21_0_2 - 4.166666666666662e-02*G21_1_2 - 4.166666666666662e-02*G21_2_2 - 8.333333333333322e-02*G23_0_2 - 8.333333333333323e-02*G23_1_2 - 8.333333333333323e-02*G23_2_2;
    block[93] = 4.166666666666661e-02*G21_0_2 + 8.333333333333322e-02*G23_0_2;
    block[94] = 4.166666666666662e-02*G21_1_2 + 8.333333333333323e-02*G23_1_2;
    block[95] = 4.166666666666662e-02*G21_2_2 + 8.333333333333323e-02*G23_2_2;
    block[96] = 8.333333333333320e-02*G13_0_0 + 8.333333333333322e-02*G13_0_1 + 8.333333333333322e-02*G13_0_2 + 8.333333333333322e-02*G13_1_0 + 8.333333333333323e-02*G13_1_1 + 8.333333333333323e-02*G13_1_2 + 8.333333333333320e-02*G13_2_0 + 8.333333333333322e-02*G13_2_1 + 8.333333333333322e-02*G13_2_2 + 4.166666666666660e-02*G24_0_0 + 4.166666666666661e-02*G24_0_1 + 4.166666666666661e-02*G24_0_2 + 4.166666666666661e-02*G24_1_0 + 4.166666666666662e-02*G24_1_1 + 4.166666666666662e-02*G24_1_2 + 4.166666666666660e-02*G24_2_0 + 4.166666666666661e-02*G24_2_1 + 4.166666666666661e-02*G24_2_2;
    block[97] = -8.333333333333320e-02*G13_0_0 - 8.333333333333322e-02*G13_0_1 - 8.333333333333322e-02*G13_0_2 - 4.166666666666660e-02*G24_0_0 - 4.166666666666661e-02*G24_0_1 - 4.166666666666661e-02*G24_0_2;
    block[98] = -8.333333333333322e-02*G13_1_0 - 8.333333333333323e-02*G13_1_1 - 8.333333333333323e-02*G13_1_2 - 4.166666666666661e-02*G24_1_0 - 4.166666666666662e-02*G24_1_1 - 4.166666666666662e-02*G24_1_2;
    block[99] = -8.333333333333322e-02*G13_2_0 - 8.333333333333323e-02*G13_2_1 - 8.333333333333323e-02*G13_2_2 - 4.166666666666661e-02*G24_2_0 - 4.166666666666662e-02*G24_2_1 - 4.166666666666662e-02*G24_2_2;
    block[100] = 8.333333333333320e-02*G22_0_0 + 8.333333333333322e-02*G22_0_1 + 8.333333333333322e-02*G22_0_2 + 8.333333333333322e-02*G22_1_0 + 8.333333333333323e-02*G22_1_1 + 8.333333333333323e-02*G22_1_2 + 8.333333333333322e-02*G22_2_0 + 8.333333333333323e-02*G22_2_1 + 8.333333333333323e-02*G22_2_2 + 4.166666666666660e-02*G25_0_0 + 4.166666666666661e-02*G25_0_1 + 4.166666666666661e-02*G25_0_2 + 4.166666666666661e-02*G25_1_0 + 4.166666666666662e-02*G25_1_1 + 4.166666666666662e-02*G25_1_2 + 4.166666666666661e-02*G25_2_0 + 4.166666666666662e-02*G25_2_1 + 4.166666666666662e-02*G25_2_2;
    block[101] = -8.333333333333320e-02*G22_0_0 - 8.333333333333322e-02*G22_0_1 - 8.333333333333322e-02*G22_0_2 - 4.166666666666660e-02*G25_0_0 - 4.166666666666661e-02*G25_0_1 - 4.166666666666661e-02*G25_0_2;
    block[102] = -8.333333333333322e-02*G22_1_0 - 8.333333333333323e-02*G22_1_1 - 8.333333333333323e-02*G22_1_2 - 4.166666666666661e-02*G25_1_0 - 4.166666666666662e-02*G25_1_1 - 4.166666666666662e-02*G25_1_2;
    block[103] = -8.333333333333322e-02*G22_2_0 - 8.333333333333323e-02*G22_2_1 - 8.333333333333323e-02*G22_2_2 - 4.166666666666661e-02*G25_2_0 - 4.166666666666662e-02*G25_2_1 - 4.166666666666662e-02*G25_2_2;
    block[104] = 8.333333333333320e-02*G15_0_0 + 8.333333333333322e-02*G15_0_1 + 8.333333333333322e-02*G15_0_2 + 8.333333333333322e-02*G15_1_0 + 8.333333333333323e-02*G15_1_1 + 8.333333333333323e-02*G15_1_2 + 8.333333333333322e-02*G15_2_0 + 8.333333333333323e-02*G15_2_1 + 8.333333333333323e-02*G15_2_2 + 4.166666666666660e-02*G26_0_0 + 4.166666666666661e-02*G26_0_1 + 4.166666666666661e-02*G26_0_2 + 4.166666666666661e-02*G26_1_0 + 4.166666666666662e-02*G26_1_1 + 4.166666666666662e-02*G26_1_2 + 4.166666666666661e-02*G26_2_0 + 4.166666666666662e-02*G26_2_1 + 4.166666666666662e-02*G26_2_2;
    block[105] = -8.333333333333320e-02*G15_0_0 - 8.333333333333322e-02*G15_0_1 - 8.333333333333322e-02*G15_0_2 - 4.166666666666660e-02*G26_0_0 - 4.166666666666661e-02*G26_0_1 - 4.166666666666661e-02*G26_0_2;
    block[106] = -8.333333333333322e-02*G15_1_0 - 8.333333333333323e-02*G15_1_1 - 8.333333333333323e-02*G15_1_2 - 4.166666666666661e-02*G26_1_0 - 4.166666666666662e-02*G26_1_1 - 4.166666666666662e-02*G26_1_2;
    block[107] = -8.333333333333322e-02*G15_2_0 - 8.333333333333323e-02*G15_2_1 - 8.333333333333323e-02*G15_2_2 - 4.166666666666661e-02*G26_2_0 - 4.166666666666662e-02*G26_2_1 - 4.166666666666662e-02*G26_2_2;
    block[108] = -8.333333333333320e-02*G13_0_0 - 8.333333333333322e-02*G13_1_0 - 8.333333333333320e-02*G13_2_0 - 4.166666666666660e-02*G24_0_0 - 4.166666666666661e-02*G24_1_0 - 4.166666666666660e-02*G24_2_0;
    block[109] = 8.333333333333320e-02*G13_0_0 + 4.166666666666660e-02*G24_0_0;
    block[110] = 8.333333333333322e-02*G13_1_0 + 4.166666666666661e-02*G24_1_0;
    block[111] = 8.333333333333322e-02*G13_2_0 + 4.166666666666661e-02*G24_2_0;
    block[112] = -8.333333333333320e-02*G22_0_0 - 8.333333333333322e-02*G22_1_0 - 8.333333333333322e-02*G22_2_0 - 4.166666666666660e-02*G25_0_0 - 4.166666666666661e-02*G25_1_0 - 4.166666666666661e-02*G25_2_0;
    block[113] = 8.333333333333320e-02*G22_0_0 + 4.166666666666660e-02*G25_0_0;
    block[114] = 8.333333333333322e-02*G22_1_0 + 4.166666666666661e-02*G25_1_0;
    block[115] = 8.333333333333322e-02*G22_2_0 + 4.166666666666661e-02*G25_2_0;
    block[116] = -8.333333333333320e-02*G15_0_0 - 8.333333333333322e-02*G15_1_0 - 8.333333333333322e-02*G15_2_0 - 4.166666666666660e-02*G26_0_0 - 4.166666666666661e-02*G26_1_0 - 4.166666666666661e-02*G26_2_0;
    block[117] = 8.333333333333320e-02*G15_0_0 + 4.166666666666660e-02*G26_0_0;
    block[118] = 8.333333333333322e-02*G15_1_0 + 4.166666666666661e-02*G26_1_0;
    block[119] = 8.333333333333322e-02*G15_2_0 + 4.166666666666661e-02*G26_2_0;
    block[120] = -8.333333333333322e-02*G13_0_1 - 8.333333333333323e-02*G13_1_1 - 8.333333333333322e-02*G13_2_1 - 4.166666666666661e-02*G24_0_1 - 4.166666666666662e-02*G24_1_1 - 4.166666666666661e-02*G24_2_1;
    block[121] = 8.333333333333322e-02*G13_0_1 + 4.166666666666661e-02*G24_0_1;
    block[122] = 8.333333333333323e-02*G13_1_1 + 4.166666666666662e-02*G24_1_1;
    block[123] = 8.333333333333323e-02*G13_2_1 + 4.166666666666662e-02*G24_2_1;
    block[124] = -8.333333333333322e-02*G22_0_1 - 8.333333333333323e-02*G22_1_1 - 8.333333333333323e-02*G22_2_1 - 4.166666666666661e-02*G25_0_1 - 4.166666666666662e-02*G25_1_1 - 4.166666666666662e-02*G25_2_1;
    block[125] = 8.333333333333322e-02*G22_0_1 + 4.166666666666661e-02*G25_0_1;
    block[126] = 8.333333333333323e-02*G22_1_1 + 4.166666666666662e-02*G25_1_1;
    block[127] = 8.333333333333323e-02*G22_2_1 + 4.166666666666662e-02*G25_2_1;
    block[128] = -8.333333333333322e-02*G15_0_1 - 8.333333333333323e-02*G15_1_1 - 8.333333333333323e-02*G15_2_1 - 4.166666666666661e-02*G26_0_1 - 4.166666666666662e-02*G26_1_1 - 4.166666666666662e-02*G26_2_1;
    block[129] = 8.333333333333322e-02*G15_0_1 + 4.166666666666661e-02*G26_0_1;
    block[130] = 8.333333333333323e-02*G15_1_1 + 4.166666666666662e-02*G26_1_1;
    block[131] = 8.333333333333323e-02*G15_2_1 + 4.166666666666662e-02*G26_2_1;
    block[132] = -8.333333333333322e-02*G13_0_2 - 8.333333333333323e-02*G13_1_2 - 8.333333333333322e-02*G13_2_2 - 4.166666666666661e-02*G24_0_2 - 4.166666666666662e-02*G24_1_2 - 4.166666666666661e-02*G24_2_2;
    block[133] = 8.333333333333322e-02*G13_0_2 + 4.166666666666661e-02*G24_0_2;
    block[134] = 8.333333333333323e-02*G13_1_2 + 4.166666666666662e-02*G24_1_2;
    block[135] = 8.333333333333323e-02*G13_2_2 + 4.166666666666662e-02*G24_2_2;
    block[136] = -8.333333333333322e-02*G22_0_2 - 8.333333333333323e-02*G22_1_2 - 8.333333333333323e-02*G22_2_2 - 4.166666666666661e-02*G25_0_2 - 4.166666666666662e-02*G25_1_2 - 4.166666666666662e-02*G25_2_2;
    block[137] = 8.333333333333322e-02*G22_0_2 + 4.166666666666661e-02*G25_0_2;
    block[138] = 8.333333333333323e-02*G22_1_2 + 4.166666666666662e-02*G25_1_2;
    block[139] = 8.333333333333323e-02*G22_2_2 + 4.166666666666662e-02*G25_2_2;
    block[140] = -8.333333333333322e-02*G15_0_2 - 8.333333333333323e-02*G15_1_2 - 8.333333333333323e-02*G15_2_2 - 4.166666666666661e-02*G26_0_2 - 4.166666666666662e-02*G26_1_2 - 4.166666666666662e-02*G26_2_2;
    block[141] = 8.333333333333322e-02*G15_0_2 + 4.166666666666661e-02*G26_0_2;
    block[142] = 8.333333333333323e-02*G15_1_2 + 4.166666666666662e-02*G26_1_2;
    block[143] = 8.333333333333323e-02*G15_2_2 + 4.166666666666662e-02*G26_2_2;
  }

private:

  const real& c0;  const real& c1;

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 12;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.vertexID(0);
      dofs[5] = offset + cell.vertexID(1);
      dofs[6] = offset + cell.vertexID(2);
      dofs[7] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[8] = offset + cell.vertexID(0);
      dofs[9] = offset + cell.vertexID(1);
      dofs[10] = offset + cell.vertexID(2);
      dofs[11] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices();
      values[2] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 12;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.vertexID(0);
      dofs[5] = offset + cell.vertexID(1);
      dofs[6] = offset + cell.vertexID(2);
      dofs[7] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[8] = offset + cell.vertexID(0);
      dofs[9] = offset + cell.vertexID(1);
      dofs[10] = offset + cell.vertexID(2);
      dofs[11] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices();
      values[2] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];
    const real c0_4 = c[0][4];
    const real c0_5 = c[0][5];
    const real c0_6 = c[0][6];
    const real c0_7 = c[0][7];
    const real c0_8 = c[0][8];
    const real c0_9 = c[0][9];
    const real c0_10 = c[0][10];
    const real c0_11 = c[0][11];

    // Compute geometry tensors
    const real G0_0 = map.det*c0_0;
    const real G0_1 = map.det*c0_1;
    const real G0_2 = map.det*c0_2;
    const real G0_3 = map.det*c0_3;
    const real G0_4 = map.det*c0_4;
    const real G0_5 = map.det*c0_5;
    const real G0_6 = map.det*c0_6;
    const real G0_7 = map.det*c0_7;
    const real G0_8 = map.det*c0_8;
    const real G0_9 = map.det*c0_9;
    const real G0_10 = map.det*c0_10;
    const real G0_11 = map.det*c0_11;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_0 + 8.333333333333309e-03*G0_1 + 8.333333333333309e-03*G0_2 + 8.333333333333311e-03*G0_3;
    block[1] = 8.333333333333307e-03*G0_0 + 1.666666666666661e-02*G0_1 + 8.333333333333309e-03*G0_2 + 8.333333333333309e-03*G0_3;
    block[2] = 8.333333333333309e-03*G0_0 + 8.333333333333309e-03*G0_1 + 1.666666666666662e-02*G0_2 + 8.333333333333311e-03*G0_3;
    block[3] = 8.333333333333311e-03*G0_0 + 8.333333333333307e-03*G0_1 + 8.333333333333311e-03*G0_2 + 1.666666666666662e-02*G0_3;
    block[4] = 1.666666666666662e-02*G0_4 + 8.333333333333307e-03*G0_5 + 8.333333333333309e-03*G0_6 + 8.333333333333309e-03*G0_7;
    block[5] = 8.333333333333307e-03*G0_4 + 1.666666666666662e-02*G0_5 + 8.333333333333312e-03*G0_6 + 8.333333333333311e-03*G0_7;
    block[6] = 8.333333333333311e-03*G0_4 + 8.333333333333312e-03*G0_5 + 1.666666666666662e-02*G0_6 + 8.333333333333314e-03*G0_7;
    block[7] = 8.333333333333309e-03*G0_4 + 8.333333333333311e-03*G0_5 + 8.333333333333314e-03*G0_6 + 1.666666666666662e-02*G0_7;
    block[8] = 1.666666666666662e-02*G0_8 + 8.333333333333309e-03*G0_9 + 8.333333333333307e-03*G0_10 + 8.333333333333309e-03*G0_11;
    block[9] = 8.333333333333309e-03*G0_8 + 1.666666666666662e-02*G0_9 + 8.333333333333311e-03*G0_10 + 8.333333333333312e-03*G0_11;
    block[10] = 8.333333333333307e-03*G0_8 + 8.333333333333311e-03*G0_9 + 1.666666666666662e-02*G0_10 + 8.333333333333311e-03*G0_11;
    block[11] = 8.333333333333309e-03*G0_8 + 8.333333333333311e-03*G0_9 + 8.333333333333311e-03*G0_10 + 1.666666666666662e-02*G0_11;
  }

};

} }

#endif
