// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.3.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __POISSON3D_4_H
#define __POISSON3D_4_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Poisson3D_4 {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 35;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering_0[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 35;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering_0[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_0_0 = map.det*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    const real G0_0_1 = map.det*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    const real G0_0_2 = map.det*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    const real G0_1_0 = map.det*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    const real G0_1_1 = map.det*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    const real G0_1_2 = map.det*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    const real G0_2_0 = map.det*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    const real G0_2_1 = map.det*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    const real G0_2_2 = map.det*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);

    // Compute element tensor
    block[0] = 3.791887125220452e-02*G0_0_0 + 3.791887125220451e-02*G0_0_1 + 3.791887125220452e-02*G0_0_2 + 3.791887125220451e-02*G0_1_0 + 3.791887125220451e-02*G0_1_1 + 3.791887125220451e-02*G0_1_2 + 3.791887125220452e-02*G0_2_0 + 3.791887125220451e-02*G0_2_1 + 3.791887125220452e-02*G0_2_2;
    block[1] = 5.114638447971763e-03*G0_0_0 + 5.114638447971767e-03*G0_1_0 + 5.114638447971762e-03*G0_2_0;
    block[2] = 5.114638447971750e-03*G0_0_1 + 5.114638447971749e-03*G0_1_1 + 5.114638447971752e-03*G0_2_1;
    block[3] = 5.114638447971775e-03*G0_0_2 + 5.114638447971780e-03*G0_1_2 + 5.114638447971788e-03*G0_2_2;
    block[4] = 7.760141093474357e-03*G0_0_0 + 7.760141093474410e-03*G0_0_1 + 7.760141093474360e-03*G0_1_0 + 7.760141093474419e-03*G0_1_1 + 7.760141093474339e-03*G0_2_0 + 7.760141093474394e-03*G0_2_1;
    block[5] = 5.114638447971805e-03*G0_0_0 + 5.114638447971737e-03*G0_0_1 + 5.114638447971828e-03*G0_1_0 + 5.114638447971755e-03*G0_1_1 + 5.114638447971807e-03*G0_2_0 + 5.114638447971747e-03*G0_2_1;
    block[6] = 7.760141093474393e-03*G0_0_0 + 7.760141093474451e-03*G0_0_1 + 7.760141093474398e-03*G0_1_0 + 7.760141093474459e-03*G0_1_1 + 7.760141093474383e-03*G0_2_0 + 7.760141093474438e-03*G0_2_1;
    block[7] = -7.760141093474373e-03*G0_0_0 - 2.539682539682529e-02*G0_0_1 - 7.760141093474377e-03*G0_0_2 - 7.760141093474378e-03*G0_1_0 - 2.539682539682529e-02*G0_1_1 - 7.760141093474382e-03*G0_1_2 - 7.760141093474366e-03*G0_2_0 - 2.539682539682530e-02*G0_2_1 - 7.760141093474370e-03*G0_2_2;
    block[8] = 2.028218694885356e-02*G0_0_0 + 5.291005291005275e-02*G0_0_1 + 2.028218694885356e-02*G0_0_2 + 2.028218694885359e-02*G0_1_0 + 5.291005291005275e-02*G0_1_1 + 2.028218694885358e-02*G0_1_2 + 2.028218694885359e-02*G0_2_0 + 5.291005291005278e-02*G0_2_1 + 2.028218694885359e-02*G0_2_2;
    block[9] = -2.469135802469133e-02*G0_0_0 - 7.054673721340371e-02*G0_0_1 - 2.469135802469134e-02*G0_0_2 - 2.469135802469135e-02*G0_1_0 - 7.054673721340371e-02*G0_1_1 - 2.469135802469136e-02*G0_1_2 - 2.469135802469134e-02*G0_2_0 - 7.054673721340374e-02*G0_2_1 - 2.469135802469135e-02*G0_2_2;
    block[10] = -7.054673721340371e-02*G0_0_0 - 2.469135802469130e-02*G0_0_1 - 2.469135802469131e-02*G0_0_2 - 7.054673721340370e-02*G0_1_0 - 2.469135802469133e-02*G0_1_1 - 2.469135802469133e-02*G0_1_2 - 7.054673721340371e-02*G0_2_0 - 2.469135802469130e-02*G0_2_1 - 2.469135802469132e-02*G0_2_2;
    block[11] = 5.291005291005282e-02*G0_0_0 + 2.028218694885357e-02*G0_0_1 + 2.028218694885358e-02*G0_0_2 + 5.291005291005282e-02*G0_1_0 + 2.028218694885359e-02*G0_1_1 + 2.028218694885359e-02*G0_1_2 + 5.291005291005282e-02*G0_2_0 + 2.028218694885356e-02*G0_2_1 + 2.028218694885357e-02*G0_2_2;
    block[12] = -2.539682539682536e-02*G0_0_0 - 7.760141093474384e-03*G0_0_1 - 7.760141093474387e-03*G0_0_2 - 2.539682539682536e-02*G0_1_0 - 7.760141093474390e-03*G0_1_1 - 7.760141093474392e-03*G0_1_2 - 2.539682539682536e-02*G0_2_0 - 7.760141093474364e-03*G0_2_1 - 7.760141093474367e-03*G0_2_2;
    block[13] = -2.469135802469135e-02*G0_0_0 - 2.469135802469137e-02*G0_0_1 - 7.054673721340378e-02*G0_0_2 - 2.469135802469138e-02*G0_1_0 - 2.469135802469141e-02*G0_1_1 - 7.054673721340378e-02*G0_1_2 - 2.469135802469136e-02*G0_2_0 - 2.469135802469138e-02*G0_2_1 - 7.054673721340378e-02*G0_2_2;
    block[14] = 2.028218694885357e-02*G0_0_0 + 2.028218694885358e-02*G0_0_1 + 5.291005291005281e-02*G0_0_2 + 2.028218694885359e-02*G0_1_0 + 2.028218694885359e-02*G0_1_1 + 5.291005291005282e-02*G0_1_2 + 2.028218694885360e-02*G0_2_0 + 2.028218694885360e-02*G0_2_1 + 5.291005291005282e-02*G0_2_2;
    block[15] = -7.760141093474393e-03*G0_0_0 - 7.760141093474391e-03*G0_0_1 - 2.539682539682535e-02*G0_0_2 - 7.760141093474413e-03*G0_1_0 - 7.760141093474415e-03*G0_1_1 - 2.539682539682535e-02*G0_1_2 - 7.760141093474405e-03*G0_2_0 - 7.760141093474405e-03*G0_2_1 - 2.539682539682536e-02*G0_2_2;
    block[16] = 7.760141093474382e-03*G0_0_0 + 7.760141093474382e-03*G0_0_2 + 7.760141093474390e-03*G0_1_0 + 7.760141093474390e-03*G0_1_2 + 7.760141093474371e-03*G0_2_0 + 7.760141093474363e-03*G0_2_2;
    block[17] = 5.114638447971768e-03*G0_0_0 + 5.114638447971761e-03*G0_0_2 + 5.114638447971744e-03*G0_1_0 + 5.114638447971746e-03*G0_1_2 + 5.114638447971761e-03*G0_2_0 + 5.114638447971775e-03*G0_2_2;
    block[18] = 7.760141093474385e-03*G0_0_0 + 7.760141093474385e-03*G0_0_2 + 7.760141093474406e-03*G0_1_0 + 7.760141093474397e-03*G0_1_2 + 7.760141093474397e-03*G0_2_0 + 7.760141093474373e-03*G0_2_2;
    block[19] = 7.760141093474410e-03*G0_0_1 + 7.760141093474385e-03*G0_0_2 + 7.760141093474424e-03*G0_1_1 + 7.760141093474390e-03*G0_1_2 + 7.760141093474410e-03*G0_2_1 + 7.760141093474375e-03*G0_2_2;
    block[20] = 5.114638447971821e-03*G0_0_1 + 5.114638447971821e-03*G0_0_2 + 5.114638447971813e-03*G0_1_1 + 5.114638447971821e-03*G0_1_2 + 5.114638447971828e-03*G0_2_1 + 5.114638447971846e-03*G0_2_2;
    block[21] = 7.760141093474374e-03*G0_0_1 + 7.760141093474387e-03*G0_0_2 + 7.760141093474397e-03*G0_1_1 + 7.760141093474403e-03*G0_1_2 + 7.760141093474389e-03*G0_2_1 + 7.760141093474377e-03*G0_2_2;
    block[22] = 1.834215167548479e-02*G0_0_0 + 1.834215167548480e-02*G0_0_1 + 1.834215167548483e-02*G0_0_2 + 1.834215167548481e-02*G0_1_0 + 1.834215167548481e-02*G0_1_1 + 1.834215167548486e-02*G0_1_2 + 1.834215167548480e-02*G0_2_0 + 1.834215167548480e-02*G0_2_1 + 1.834215167548481e-02*G0_2_2;
    block[23] = 1.834215167548496e-02*G0_0_0 + 1.834215167548492e-02*G0_0_1 + 1.834215167548492e-02*G0_0_2 + 1.834215167548498e-02*G0_1_0 + 1.834215167548492e-02*G0_1_1 + 1.834215167548491e-02*G0_1_2 + 1.834215167548500e-02*G0_2_0 + 1.834215167548493e-02*G0_2_1 + 1.834215167548496e-02*G0_2_2;
    block[24] = 1.834215167548504e-02*G0_0_0 + 1.834215167548499e-02*G0_0_1 + 1.834215167548501e-02*G0_0_2 + 1.834215167548505e-02*G0_1_0 + 1.834215167548501e-02*G0_1_1 + 1.834215167548504e-02*G0_1_2 + 1.834215167548503e-02*G0_2_0 + 1.834215167548499e-02*G0_2_1 + 1.834215167548498e-02*G0_2_2;
    block[25] = -1.834215167548504e-02*G0_0_0 - 2.539682539682538e-02*G0_0_1 - 2.539682539682539e-02*G0_0_2 - 1.834215167548505e-02*G0_1_0 - 2.539682539682542e-02*G0_1_1 - 2.539682539682542e-02*G0_1_2 - 1.834215167548503e-02*G0_2_0 - 2.539682539682539e-02*G0_2_1 - 2.539682539682544e-02*G0_2_2;
    block[26] = -1.834215167548495e-02*G0_0_0 - 2.539682539682540e-02*G0_0_1 - 2.539682539682536e-02*G0_0_2 - 1.834215167548497e-02*G0_1_0 - 2.539682539682540e-02*G0_1_1 - 2.539682539682539e-02*G0_1_2 - 1.834215167548498e-02*G0_2_0 - 2.539682539682542e-02*G0_2_1 - 2.539682539682536e-02*G0_2_2;
    block[27] = 4.938271604938264e-02*G0_0_0 + 4.232804232804230e-02*G0_0_1 + 4.232804232804228e-02*G0_0_2 + 4.938271604938266e-02*G0_1_0 + 4.232804232804237e-02*G0_1_1 + 4.232804232804232e-02*G0_1_2 + 4.938271604938266e-02*G0_2_0 + 4.232804232804233e-02*G0_2_1 + 4.232804232804231e-02*G0_2_2;
    block[28] = -2.539682539682533e-02*G0_0_0 - 1.834215167548488e-02*G0_0_1 - 2.539682539682537e-02*G0_0_2 - 2.539682539682532e-02*G0_1_0 - 1.834215167548489e-02*G0_1_1 - 2.539682539682538e-02*G0_1_2 - 2.539682539682535e-02*G0_2_0 - 1.834215167548490e-02*G0_2_1 - 2.539682539682536e-02*G0_2_2;
    block[29] = -2.539682539682536e-02*G0_0_0 - 1.834215167548486e-02*G0_0_1 - 2.539682539682534e-02*G0_0_2 - 2.539682539682537e-02*G0_1_0 - 1.834215167548486e-02*G0_1_1 - 2.539682539682533e-02*G0_1_2 - 2.539682539682532e-02*G0_2_0 - 1.834215167548485e-02*G0_2_1 - 2.539682539682534e-02*G0_2_2;
    block[30] = 4.232804232804233e-02*G0_0_0 + 4.938271604938267e-02*G0_0_1 + 4.232804232804233e-02*G0_0_2 + 4.232804232804234e-02*G0_1_0 + 4.938271604938267e-02*G0_1_1 + 4.232804232804234e-02*G0_1_2 + 4.232804232804229e-02*G0_2_0 + 4.938271604938264e-02*G0_2_1 + 4.232804232804233e-02*G0_2_2;
    block[31] = 4.232804232804228e-02*G0_0_0 + 4.232804232804228e-02*G0_0_1 + 4.938271604938265e-02*G0_0_2 + 4.232804232804228e-02*G0_1_0 + 4.232804232804233e-02*G0_1_1 + 4.938271604938266e-02*G0_1_2 + 4.232804232804228e-02*G0_2_0 + 4.232804232804232e-02*G0_2_1 + 4.938271604938264e-02*G0_2_2;
    block[32] = -2.539682539682529e-02*G0_0_0 - 2.539682539682533e-02*G0_0_1 - 1.834215167548485e-02*G0_0_2 - 2.539682539682529e-02*G0_1_0 - 2.539682539682536e-02*G0_1_1 - 1.834215167548488e-02*G0_1_2 - 2.539682539682527e-02*G0_2_0 - 2.539682539682533e-02*G0_2_1 - 1.834215167548484e-02*G0_2_2;
    block[33] = -2.539682539682538e-02*G0_0_0 - 2.539682539682536e-02*G0_0_1 - 1.834215167548501e-02*G0_0_2 - 2.539682539682543e-02*G0_1_0 - 2.539682539682538e-02*G0_1_1 - 1.834215167548504e-02*G0_1_2 - 2.539682539682541e-02*G0_2_0 - 2.539682539682537e-02*G0_2_1 - 1.834215167548498e-02*G0_2_2;
    block[34] = -6.772486772486744e-02*G0_0_0 - 6.772486772486762e-02*G0_0_1 - 6.772486772486754e-02*G0_0_2 - 6.772486772486749e-02*G0_1_0 - 6.772486772486763e-02*G0_1_1 - 6.772486772486754e-02*G0_1_2 - 6.772486772486747e-02*G0_2_0 - 6.772486772486759e-02*G0_2_1 - 6.772486772486758e-02*G0_2_2;
    block[35] = 5.114638447971763e-03*G0_0_0 + 5.114638447971766e-03*G0_0_1 + 5.114638447971763e-03*G0_0_2;
    block[36] = 3.791887125220453e-02*G0_0_0;
    block[37] = -5.114638447971765e-03*G0_0_1;
    block[38] = -5.114638447971776e-03*G0_0_2;
    block[39] = -2.469135802469135e-02*G0_0_0 + 4.585537918871242e-02*G0_0_1;
    block[40] = 2.028218694885359e-02*G0_0_0 - 3.262786596119924e-02*G0_0_1;
    block[41] = -7.760141093474394e-03*G0_0_0 + 1.763668430335094e-02*G0_0_1;
    block[42] = 7.760141093474375e-03*G0_0_0 + 7.760141093474389e-03*G0_0_2;
    block[43] = 5.114638447971801e-03*G0_0_0 + 5.114638447971801e-03*G0_0_2;
    block[44] = 7.760141093474391e-03*G0_0_0 + 7.760141093474375e-03*G0_0_2;
    block[45] = -2.539682539682536e-02*G0_0_0 - 1.763668430335097e-02*G0_0_1 - 1.763668430335097e-02*G0_0_2;
    block[46] = 5.291005291005281e-02*G0_0_0 + 3.262786596119926e-02*G0_0_1 + 3.262786596119927e-02*G0_0_2;
    block[47] = -7.054673721340378e-02*G0_0_0 - 4.585537918871243e-02*G0_0_1 - 4.585537918871243e-02*G0_0_2;
    block[48] = 7.760141093474391e-03*G0_0_0 + 7.760141093474387e-03*G0_0_1;
    block[49] = 5.114638447971780e-03*G0_0_0 + 5.114638447971781e-03*G0_0_1;
    block[50] = 7.760141093474438e-03*G0_0_0 + 7.760141093474423e-03*G0_0_1;
    block[51] = -2.469135802469137e-02*G0_0_0 + 4.585537918871241e-02*G0_0_2;
    block[52] = 2.028218694885364e-02*G0_0_0 - 3.262786596119922e-02*G0_0_2;
    block[53] = -7.760141093474426e-03*G0_0_0 + 1.763668430335093e-02*G0_0_2;
    block[54] = -7.760141093474410e-03*G0_0_1 - 7.760141093474378e-03*G0_0_2;
    block[55] = -5.114638447971804e-03*G0_0_1 - 5.114638447971822e-03*G0_0_2;
    block[56] = -7.760141093474429e-03*G0_0_1 - 7.760141093474424e-03*G0_0_2;
    block[57] = 4.938271604938267e-02*G0_0_0 + 7.054673721340310e-03*G0_0_1 + 7.054673721340290e-03*G0_0_2;
    block[58] = -1.834215167548501e-02*G0_0_0 + 7.054673721340441e-03*G0_0_1 + 7.054673721340447e-03*G0_0_2;
    block[59] = -1.834215167548498e-02*G0_0_0 + 7.054673721340430e-03*G0_0_1 + 7.054673721340389e-03*G0_0_2;
    block[60] = 1.834215167548500e-02*G0_0_0;
    block[61] = 1.834215167548501e-02*G0_0_0;
    block[62] = 1.834215167548489e-02*G0_0_0;
    block[63] = -2.539682539682543e-02*G0_0_0 - 7.054673721340431e-03*G0_0_1;
    block[64] = 4.232804232804235e-02*G0_0_0 - 7.054673721340379e-03*G0_0_1;
    block[65] = -2.539682539682531e-02*G0_0_0 - 7.054673721340362e-03*G0_0_1;
    block[66] = -2.539682539682533e-02*G0_0_0 - 7.054673721340369e-03*G0_0_2;
    block[67] = 4.232804232804228e-02*G0_0_0 - 7.054673721340323e-03*G0_0_2;
    block[68] = -2.539682539682539e-02*G0_0_0 - 7.054673721340381e-03*G0_0_2;
    block[69] = -6.772486772486759e-02*G0_0_0;
    block[70] = 5.114638447971750e-03*G0_1_0 + 5.114638447971749e-03*G0_1_1 + 5.114638447971750e-03*G0_1_2;
    block[71] = -5.114638447971765e-03*G0_1_0;
    block[72] = 3.791887125220451e-02*G0_1_1;
    block[73] = -5.114638447971800e-03*G0_1_2;
    block[74] = 1.763668430335083e-02*G0_1_0 - 7.760141093474458e-03*G0_1_1;
    block[75] = -3.262786596119914e-02*G0_1_0 + 2.028218694885360e-02*G0_1_1;
    block[76] = 4.585537918871242e-02*G0_1_0 - 2.469135802469132e-02*G0_1_1;
    block[77] = -4.585537918871240e-02*G0_1_0 - 7.054673721340370e-02*G0_1_1 - 4.585537918871242e-02*G0_1_2;
    block[78] = 3.262786596119917e-02*G0_1_0 + 5.291005291005276e-02*G0_1_1 + 3.262786596119917e-02*G0_1_2;
    block[79] = -1.763668430335086e-02*G0_1_0 - 2.539682539682529e-02*G0_1_1 - 1.763668430335087e-02*G0_1_2;
    block[80] = 7.760141093474478e-03*G0_1_1 + 7.760141093474466e-03*G0_1_2;
    block[81] = 5.114638447971786e-03*G0_1_1 + 5.114638447971777e-03*G0_1_2;
    block[82] = 7.760141093474487e-03*G0_1_1 + 7.760141093474478e-03*G0_1_2;
    block[83] = 7.760141093474446e-03*G0_1_0 + 7.760141093474444e-03*G0_1_1;
    block[84] = 5.114638447971760e-03*G0_1_0 + 5.114638447971764e-03*G0_1_1;
    block[85] = 7.760141093474457e-03*G0_1_0 + 7.760141093474462e-03*G0_1_1;
    block[86] = -7.760141093474489e-03*G0_1_0 - 7.760141093474462e-03*G0_1_2;
    block[87] = -5.114638447971729e-03*G0_1_0 - 5.114638447971751e-03*G0_1_2;
    block[88] = -7.760141093474466e-03*G0_1_0 - 7.760141093474438e-03*G0_1_2;
    block[89] = -2.469135802469135e-02*G0_1_1 + 4.585537918871241e-02*G0_1_2;
    block[90] = 2.028218694885358e-02*G0_1_1 - 3.262786596119928e-02*G0_1_2;
    block[91] = -7.760141093474467e-03*G0_1_1 + 1.763668430335089e-02*G0_1_2;
    block[92] = 7.054673721340454e-03*G0_1_0 - 1.834215167548506e-02*G0_1_1 + 7.054673721340298e-03*G0_1_2;
    block[93] = 7.054673721340302e-03*G0_1_0 - 1.834215167548501e-02*G0_1_1 + 7.054673721340363e-03*G0_1_2;
    block[94] = 7.054673721340356e-03*G0_1_0 + 4.938271604938276e-02*G0_1_1 + 7.054673721340479e-03*G0_1_2;
    block[95] = -7.054673721340361e-03*G0_1_0 + 4.232804232804235e-02*G0_1_1;
    block[96] = -7.054673721340297e-03*G0_1_0 - 2.539682539682531e-02*G0_1_1;
    block[97] = -7.054673721340369e-03*G0_1_0 - 2.539682539682544e-02*G0_1_1;
    block[98] = 1.834215167548502e-02*G0_1_1;
    block[99] = 1.834215167548504e-02*G0_1_1;
    block[100] = 1.834215167548502e-02*G0_1_1;
    block[101] = -2.539682539682546e-02*G0_1_1 - 7.054673721340377e-03*G0_1_2;
    block[102] = -2.539682539682542e-02*G0_1_1 - 7.054673721340295e-03*G0_1_2;
    block[103] = 4.232804232804237e-02*G0_1_1 - 7.054673721340454e-03*G0_1_2;
    block[104] = -6.772486772486777e-02*G0_1_1;
    block[105] = 5.114638447971775e-03*G0_2_0 + 5.114638447971778e-03*G0_2_1 + 5.114638447971787e-03*G0_2_2;
    block[106] = -5.114638447971775e-03*G0_2_0;
    block[107] = -5.114638447971801e-03*G0_2_1;
    block[108] = 3.791887125220460e-02*G0_2_2;
    block[109] = -7.760141093474415e-03*G0_2_0 - 7.760141093474413e-03*G0_2_1;
    block[110] = -5.114638447971736e-03*G0_2_0 - 5.114638447971740e-03*G0_2_1;
    block[111] = -7.760141093474501e-03*G0_2_0 - 7.760141093474467e-03*G0_2_1;
    block[112] = 7.760141093474497e-03*G0_2_0 + 7.760141093474495e-03*G0_2_2;
    block[113] = 5.114638447971764e-03*G0_2_0 + 5.114638447971762e-03*G0_2_2;
    block[114] = 7.760141093474391e-03*G0_2_0 + 7.760141093474391e-03*G0_2_2;
    block[115] = 7.760141093474398e-03*G0_2_1 + 7.760141093474403e-03*G0_2_2;
    block[116] = 5.114638447971767e-03*G0_2_1 + 5.114638447971778e-03*G0_2_2;
    block[117] = 7.760141093474412e-03*G0_2_1 + 7.760141093474413e-03*G0_2_2;
    block[118] = -1.763668430335098e-02*G0_2_0 - 1.763668430335099e-02*G0_2_1 - 2.539682539682539e-02*G0_2_2;
    block[119] = 3.262786596119930e-02*G0_2_0 + 3.262786596119930e-02*G0_2_1 + 5.291005291005287e-02*G0_2_2;
    block[120] = -4.585537918871251e-02*G0_2_0 - 4.585537918871250e-02*G0_2_1 - 7.054673721340386e-02*G0_2_2;
    block[121] = 1.763668430335093e-02*G0_2_0 - 7.760141093474423e-03*G0_2_2;
    block[122] = -3.262786596119926e-02*G0_2_0 + 2.028218694885359e-02*G0_2_2;
    block[123] = 4.585537918871250e-02*G0_2_0 - 2.469135802469131e-02*G0_2_2;
    block[124] = 1.763668430335097e-02*G0_2_1 - 7.760141093474509e-03*G0_2_2;
    block[125] = -3.262786596119926e-02*G0_2_1 + 2.028218694885372e-02*G0_2_2;
    block[126] = 4.585537918871251e-02*G0_2_1 - 2.469135802469134e-02*G0_2_2;
    block[127] = 7.054673721340353e-03*G0_2_0 + 7.054673721340333e-03*G0_2_1 - 1.834215167548495e-02*G0_2_2;
    block[128] = 7.054673721340418e-03*G0_2_0 + 7.054673721340401e-03*G0_2_1 + 4.938271604938266e-02*G0_2_2;
    block[129] = 7.054673721340395e-03*G0_2_0 + 7.054673721340400e-03*G0_2_1 - 1.834215167548504e-02*G0_2_2;
    block[130] = -7.054673721340401e-03*G0_2_0 - 2.539682539682545e-02*G0_2_2;
    block[131] = -7.054673721340415e-03*G0_2_0 + 4.232804232804224e-02*G0_2_2;
    block[132] = -7.054673721340334e-03*G0_2_0 - 2.539682539682526e-02*G0_2_2;
    block[133] = -7.054673721340419e-03*G0_2_1 + 4.232804232804217e-02*G0_2_2;
    block[134] = -7.054673721340316e-03*G0_2_1 - 2.539682539682530e-02*G0_2_2;
    block[135] = -7.054673721340353e-03*G0_2_1 - 2.539682539682529e-02*G0_2_2;
    block[136] = 1.834215167548496e-02*G0_2_2;
    block[137] = 1.834215167548494e-02*G0_2_2;
    block[138] = 1.834215167548501e-02*G0_2_2;
    block[139] = -6.772486772486765e-02*G0_2_2;
    block[140] = 7.760141093474355e-03*G0_0_0 + 7.760141093474357e-03*G0_0_1 + 7.760141093474339e-03*G0_0_2 + 7.760141093474410e-03*G0_1_0 + 7.760141093474419e-03*G0_1_1 + 7.760141093474394e-03*G0_1_2;
    block[141] = -2.469135802469135e-02*G0_0_0 + 4.585537918871242e-02*G0_1_0;
    block[142] = 1.763668430335083e-02*G0_0_1 - 7.760141093474458e-03*G0_1_1;
    block[143] = -7.760141093474416e-03*G0_0_2 - 7.760141093474413e-03*G0_1_2;
    block[144] = 2.031746031746025e-01*G0_0_0 + 7.901234567901207e-02*G0_0_1 + 7.901234567901207e-02*G0_1_0 + 1.580246913580244e-01*G0_1_1;
    block[145] = -1.185185185185181e-01*G0_0_0 + 4.232804232804206e-02*G0_0_1 - 3.104056437389752e-02*G0_1_0 - 9.029982363315694e-02*G0_1_1;
    block[146] = 4.514991181657822e-02*G0_0_0 - 3.386243386243368e-02*G0_0_1 + 1.128747795414458e-02*G0_1_0 + 4.514991181657856e-02*G0_1_1;
    block[147] = -4.514991181657810e-02*G0_0_0 - 1.128747795414443e-02*G0_0_1 - 4.514991181657813e-02*G0_0_2 - 1.128747795414453e-02*G0_1_0 - 1.128747795414456e-02*G0_1_2;
    block[148] = -1.693121693121700e-02*G0_0_0 - 2.821869488536311e-03*G0_0_1 - 1.693121693121697e-02*G0_0_2 - 2.821869488536137e-03*G0_1_0 - 2.821869488536116e-03*G0_1_2;
    block[149] = -2.257495590828918e-02*G0_0_0 - 1.128747795414449e-02*G0_0_1 - 2.257495590828920e-02*G0_0_2 - 1.128747795414467e-02*G0_1_0 - 1.128747795414470e-02*G0_1_2;
    block[150] = -2.257495590828900e-02*G0_0_0 - 3.386243386243372e-02*G0_0_1 - 3.386243386243376e-02*G0_0_2 - 3.386243386243377e-02*G0_1_0 - 4.514991181657845e-02*G0_1_1 - 4.514991181657850e-02*G0_1_2;
    block[151] = 1.693121693121672e-02*G0_0_0 + 5.925925925925902e-02*G0_0_1 + 5.925925925925903e-02*G0_0_2 + 5.925925925925914e-02*G0_1_0 + 9.029982363315678e-02*G0_1_1 + 9.029982363315681e-02*G0_1_2;
    block[152] = 2.257495590828925e-02*G0_0_0 - 7.901234567901211e-02*G0_0_1 - 7.901234567901208e-02*G0_0_2 - 7.901234567901222e-02*G0_1_0 - 1.580246913580245e-01*G0_1_1 - 1.580246913580244e-01*G0_1_2;
    block[153] = -1.128747795414464e-02*G0_0_0 - 1.128747795414467e-02*G0_0_1 - 1.128747795414464e-02*G0_1_0 - 1.128747795414466e-02*G0_1_1;
    block[154] = -2.821869488535993e-03*G0_0_0 - 2.821869488535996e-03*G0_0_1 - 2.821869488536043e-03*G0_1_0 - 2.821869488536049e-03*G0_1_1;
    block[155] = -1.128747795414464e-02*G0_0_0 - 1.128747795414462e-02*G0_0_1 - 1.128747795414464e-02*G0_1_0 - 1.128747795414465e-02*G0_1_1;
    block[156] = 1.015873015873014e-01*G0_0_0 + 7.901234567901205e-02*G0_0_2 + 7.901234567901214e-02*G0_1_0 + 1.580246913580243e-01*G0_1_2;
    block[157] = -4.232804232804219e-02*G0_0_0 - 5.925925925925905e-02*G0_0_2 - 3.104056437389761e-02*G0_1_0 - 9.029982363315679e-02*G0_1_2;
    block[158] = 1.128747795414462e-02*G0_0_0 + 3.386243386243379e-02*G0_0_2 + 1.128747795414465e-02*G0_1_0 + 4.514991181657842e-02*G0_1_2;
    block[159] = 3.386243386243383e-02*G0_0_1 + 4.514991181657820e-02*G0_0_2 + 1.128747795414467e-02*G0_1_1 + 1.128747795414460e-02*G0_1_2;
    block[160] = 1.410934744268074e-02*G0_0_1 + 1.693121693121704e-02*G0_0_2 + 2.821869488536083e-03*G0_1_1 + 2.821869488536163e-03*G0_1_2;
    block[161] = 1.128747795414463e-02*G0_0_1 + 2.257495590828919e-02*G0_0_2 + 1.128747795414466e-02*G0_1_1 + 1.128747795414464e-02*G0_1_2;
    block[162] = -6.772486772486777e-02*G0_0_0 + 1.015873015873010e-01*G0_0_1 + 2.031746031746023e-01*G0_0_2 + 1.128747795414452e-02*G0_1_0 + 1.128747795414457e-01*G0_1_1 + 1.128747795414457e-01*G0_1_2;
    block[163] = 2.257495590828924e-02*G0_0_0 - 3.386243386243373e-02*G0_0_1 - 6.772486772486766e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 - 2.257495590828914e-02*G0_1_1 - 2.257495590828925e-02*G0_1_2;
    block[164] = 6.772486772486770e-02*G0_0_0 - 3.386243386243388e-02*G0_0_1 - 6.772486772486754e-02*G0_0_2 + 1.128747795414476e-02*G0_1_0 - 2.257495590828910e-02*G0_1_1 - 2.257495590828904e-02*G0_1_2;
    block[165] = -6.772486772486772e-02*G0_0_0 - 1.128747795414451e-02*G0_0_1 - 1.128747795414480e-02*G0_1_0;
    block[166] = -2.257495590828923e-02*G0_0_0 - 1.128747795414477e-02*G0_0_1 - 1.128747795414461e-02*G0_1_0;
    block[167] = -2.257495590828913e-02*G0_0_0 - 1.128747795414472e-02*G0_0_1 - 1.128747795414461e-02*G0_1_0;
    block[168] = 4.514991181657817e-02*G0_0_0 + 3.386243386243372e-02*G0_0_1 + 3.386243386243368e-02*G0_1_0 + 2.257495590828916e-02*G0_1_1;
    block[169] = -1.354497354497353e-01*G0_0_0 - 1.015873015873013e-01*G0_0_1 - 1.015873015873015e-01*G0_1_0 - 1.128747795414461e-01*G0_1_1;
    block[170] = 4.514991181657846e-02*G0_0_0 + 3.386243386243400e-02*G0_0_1 + 3.386243386243389e-02*G0_1_0 + 2.257495590828943e-02*G0_1_1;
    block[171] = 9.029982363315670e-02*G0_0_0 + 3.386243386243370e-02*G0_0_1 + 6.772486772486752e-02*G0_0_2 + 3.386243386243384e-02*G0_1_0 + 2.257495590828925e-02*G0_1_2;
    block[172] = -2.708994708994700e-01*G0_0_0 - 1.015873015873011e-01*G0_0_1 - 2.031746031746024e-01*G0_0_2 - 1.015873015873012e-01*G0_1_0 - 1.128747795414459e-01*G0_1_2;
    block[173] = 1.354497354497350e-01*G0_0_0 + 3.386243386243382e-02*G0_0_1 + 6.772486772486758e-02*G0_0_2 + 3.386243386243366e-02*G0_1_0 + 2.257495590828911e-02*G0_1_2;
    block[174] = 9.029982363315693e-02*G0_0_0;
    block[175] = 5.114638447971804e-03*G0_0_0 + 5.114638447971827e-03*G0_0_1 + 5.114638447971806e-03*G0_0_2 + 5.114638447971736e-03*G0_1_0 + 5.114638447971749e-03*G0_1_1 + 5.114638447971744e-03*G0_1_2;
    block[176] = 2.028218694885359e-02*G0_0_0 - 3.262786596119924e-02*G0_1_0;
    block[177] = -3.262786596119914e-02*G0_0_1 + 2.028218694885360e-02*G0_1_1;
    block[178] = -5.114638447971737e-03*G0_0_2 - 5.114638447971736e-03*G0_1_2;
    block[179] = -1.185185185185181e-01*G0_0_0 - 3.104056437389752e-02*G0_0_1 + 4.232804232804206e-02*G0_1_0 - 9.029982363315694e-02*G0_1_1;
    block[180] = 2.497354497354491e-01*G0_0_0 + 8.253968253968252e-02*G0_0_1 + 8.253968253968252e-02*G0_1_0 + 2.497354497354494e-01*G0_1_1;
    block[181] = -9.029982363315668e-02*G0_0_0 + 4.232804232804212e-02*G0_0_1 - 3.104056437389782e-02*G0_1_0 - 1.185185185185186e-01*G0_1_1;
    block[182] = 9.029982363315667e-02*G0_0_0 + 3.104056437389750e-02*G0_0_1 + 9.029982363315672e-02*G0_0_2 + 3.104056437389786e-02*G0_1_0 - 1.128747795414466e-02*G0_1_1 + 3.104056437389788e-02*G0_1_2;
    block[183] = 2.116402116402119e-02*G0_0_0 + 1.058201058201076e-02*G0_0_1 + 2.116402116402117e-02*G0_0_2 + 1.058201058201054e-02*G0_1_0 - 2.821869488536034e-03*G0_1_1 + 1.058201058201052e-02*G0_1_2;
    block[184] = -1.693121693121696e-02*G0_0_0 - 1.410934744268089e-02*G0_0_1 - 1.693121693121690e-02*G0_0_2 - 1.410934744268065e-02*G0_1_0 - 1.128747795414459e-02*G0_1_1 - 1.410934744268060e-02*G0_1_2;
    block[185] = -1.128747795414468e-02*G0_0_0 - 1.410934744268077e-02*G0_0_1 - 1.410934744268069e-02*G0_0_2 - 1.410934744268060e-02*G0_1_0 - 1.693121693121672e-02*G0_1_1 - 1.693121693121664e-02*G0_1_2;
    block[186] = -2.821869488536127e-03*G0_0_0 + 1.058201058201059e-02*G0_0_1 + 1.058201058201055e-02*G0_0_2 + 1.058201058201038e-02*G0_1_0 + 2.116402116402104e-02*G0_1_1 + 2.116402116402098e-02*G0_1_2;
    block[187] = -1.128747795414457e-02*G0_0_0 + 3.104056437389758e-02*G0_0_1 + 3.104056437389758e-02*G0_0_2 + 3.104056437389774e-02*G0_1_0 + 9.029982363315704e-02*G0_1_1 + 9.029982363315703e-02*G0_1_2;
    block[188] = -2.821869488536172e-03*G0_0_0 - 2.821869488536181e-03*G0_0_1 - 2.821869488536115e-03*G0_1_0 - 2.821869488536143e-03*G0_1_1;
    block[189] = -9.171075837742479e-03*G0_0_0 - 9.171075837742489e-03*G0_0_1 - 9.171075837742499e-03*G0_1_0 - 9.171075837742508e-03*G0_1_1;
    block[190] = -2.821869488536158e-03*G0_0_0 - 2.821869488536208e-03*G0_0_1 - 2.821869488536086e-03*G0_1_0 - 2.821869488536117e-03*G0_1_1;
    block[191] = -4.232804232804212e-02*G0_0_0 - 3.104056437389760e-02*G0_0_2 - 5.925925925925925e-02*G0_1_0 - 9.029982363315700e-02*G0_1_2;
    block[192] = -1.340388007054683e-02*G0_0_0 - 1.058201058201060e-02*G0_0_2 - 1.058201058201055e-02*G0_1_0 - 2.116402116402098e-02*G0_1_2;
    block[193] = 2.821869488536190e-03*G0_0_0 + 1.410934744268074e-02*G0_0_2 + 2.821869488536092e-03*G0_1_0 + 1.693121693121679e-02*G0_1_2;
    block[194] = -5.925925925925919e-02*G0_0_1 - 9.029982363315665e-02*G0_0_2 - 4.232804232804240e-02*G0_1_1 - 3.104056437389782e-02*G0_1_2;
    block[195] = -1.058201058201049e-02*G0_0_1 - 2.116402116402118e-02*G0_0_2 - 1.340388007054662e-02*G0_1_1 - 1.058201058201048e-02*G0_1_2;
    block[196] = 2.821869488536170e-03*G0_0_1 + 1.693121693121697e-02*G0_0_2 + 2.821869488536069e-03*G0_1_1 + 1.410934744268067e-02*G0_1_2;
    block[197] = 1.185185185185184e-01*G0_0_0 - 4.232804232804206e-02*G0_0_1 + 5.079365079365106e-02*G0_0_2 + 9.312169312169305e-02*G0_1_0 - 8.465608465608457e-02*G0_1_1 + 1.862433862433859e-01*G0_1_2;
    block[198] = -1.693121693121682e-02*G0_0_0 - 1.975308641975315e-02*G0_0_1 - 8.465608465608442e-02*G0_0_2 - 1.975308641975302e-02*G0_1_0 - 1.693121693121697e-02*G0_1_1 - 8.465608465608432e-02*G0_1_2;
    block[199] = -8.465608465608464e-02*G0_0_0 + 9.312169312169299e-02*G0_0_1 + 1.862433862433857e-01*G0_0_2 - 4.232804232804255e-02*G0_1_0 + 1.185185185185183e-01*G0_1_1 + 5.079365079365054e-02*G0_1_2;
    block[200] = 8.465608465608465e-02*G0_0_0 + 4.232804232804230e-02*G0_0_1 + 4.232804232804255e-02*G0_1_0 + 2.257495590828937e-02*G0_1_1;
    block[201] = 1.693121693121681e-02*G0_0_0 + 1.975308641975303e-02*G0_0_1 + 1.975308641975303e-02*G0_1_0 + 2.257495590828917e-02*G0_1_1;
    block[202] = 1.693121693121685e-02*G0_0_0 + 1.975308641975312e-02*G0_0_1 + 1.975308641975309e-02*G0_1_0 + 2.257495590828928e-02*G0_1_1;
    block[203] = 2.257495590828935e-02*G0_0_0 + 1.975308641975315e-02*G0_0_1 + 1.975308641975308e-02*G0_1_0 + 1.693121693121694e-02*G0_1_1;
    block[204] = 2.257495590828915e-02*G0_0_0 + 4.232804232804213e-02*G0_0_1 + 4.232804232804236e-02*G0_1_0 + 8.465608465608476e-02*G0_1_1;
    block[205] = 2.257495590828915e-02*G0_0_0 + 1.975308641975301e-02*G0_0_1 + 1.975308641975301e-02*G0_1_0 + 1.693121693121688e-02*G0_1_1;
    block[206] = 6.772486772486762e-02*G0_0_0 + 6.490299823633149e-02*G0_0_1 + 8.465608465608450e-02*G0_0_2 + 6.490299823633124e-02*G0_1_0 + 6.772486772486733e-02*G0_1_1 + 8.465608465608436e-02*G0_1_2;
    block[207] = 6.772486772486730e-02*G0_0_0 - 9.312169312169312e-02*G0_0_1 - 5.079365079365102e-02*G0_0_2 - 9.312169312169263e-02*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 1.862433862433859e-01*G0_1_2;
    block[208] = -2.708994708994703e-01*G0_0_0 - 9.312169312169277e-02*G0_0_1 - 1.862433862433859e-01*G0_0_2 - 9.312169312169306e-02*G0_1_0 + 6.772486772486802e-02*G0_1_1 - 5.079365079365074e-02*G0_1_2;
    block[209] = -1.354497354497352e-01*G0_0_0 - 1.128747795414461e-01*G0_0_1 - 1.128747795414461e-01*G0_1_0 - 1.354497354497355e-01*G0_1_1;
    block[210] = 7.760141093474391e-03*G0_0_0 + 7.760141093474398e-03*G0_0_1 + 7.760141093474384e-03*G0_0_2 + 7.760141093474448e-03*G0_1_0 + 7.760141093474459e-03*G0_1_1 + 7.760141093474436e-03*G0_1_2;
    block[211] = -7.760141093474394e-03*G0_0_0 + 1.763668430335094e-02*G0_1_0;
    block[212] = 4.585537918871242e-02*G0_0_1 - 2.469135802469132e-02*G0_1_1;
    block[213] = -7.760141093474501e-03*G0_0_2 - 7.760141093474467e-03*G0_1_2;
    block[214] = 4.514991181657822e-02*G0_0_0 + 1.128747795414458e-02*G0_0_1 - 3.386243386243369e-02*G0_1_0 + 4.514991181657856e-02*G0_1_1;
    block[215] = -9.029982363315667e-02*G0_0_0 - 3.104056437389782e-02*G0_0_1 + 4.232804232804213e-02*G0_1_0 - 1.185185185185186e-01*G0_1_1;
    block[216] = 1.580246913580246e-01*G0_0_0 + 7.901234567901244e-02*G0_0_1 + 7.901234567901244e-02*G0_1_0 + 2.031746031746031e-01*G0_1_1;
    block[217] = -1.580246913580245e-01*G0_0_0 - 7.901234567901222e-02*G0_0_1 - 1.580246913580245e-01*G0_0_2 - 7.901234567901247e-02*G0_1_0 + 2.257495590828915e-02*G0_1_1 - 7.901234567901247e-02*G0_1_2;
    block[218] = 9.029982363315697e-02*G0_0_0 + 5.925925925925916e-02*G0_0_1 + 9.029982363315701e-02*G0_0_2 + 5.925925925925939e-02*G0_1_0 + 1.693121693121694e-02*G0_1_1 + 5.925925925925941e-02*G0_1_2;
    block[219] = -4.514991181657847e-02*G0_0_0 - 3.386243386243380e-02*G0_0_1 - 4.514991181657854e-02*G0_0_2 - 3.386243386243393e-02*G0_1_0 - 2.257495590828930e-02*G0_1_1 - 3.386243386243398e-02*G0_1_2;
    block[220] = -1.128747795414463e-02*G0_0_1 - 1.128747795414469e-02*G0_0_2 - 1.128747795414468e-02*G0_1_0 - 2.257495590828930e-02*G0_1_1 - 2.257495590828936e-02*G0_1_2;
    block[221] = -2.821869488536154e-03*G0_0_1 - 2.821869488536127e-03*G0_0_2 - 2.821869488536082e-03*G0_1_0 - 1.693121693121695e-02*G0_1_1 - 1.693121693121689e-02*G0_1_2;
    block[222] = -1.128747795414457e-02*G0_0_1 - 1.128747795414457e-02*G0_0_2 - 1.128747795414467e-02*G0_1_0 - 4.514991181657858e-02*G0_1_1 - 4.514991181657857e-02*G0_1_2;
    block[223] = -1.128747795414462e-02*G0_0_0 - 1.128747795414459e-02*G0_0_1 - 1.128747795414463e-02*G0_1_0 - 1.128747795414459e-02*G0_1_1;
    block[224] = -2.821869488536196e-03*G0_0_0 - 2.821869488536228e-03*G0_0_1 - 2.821869488536183e-03*G0_1_0 - 2.821869488536214e-03*G0_1_1;
    block[225] = -1.128747795414465e-02*G0_0_0 - 1.128747795414460e-02*G0_0_1 - 1.128747795414477e-02*G0_1_0 - 1.128747795414473e-02*G0_1_1;
    block[226] = 1.128747795414453e-02*G0_0_0 + 1.128747795414461e-02*G0_0_2 + 3.386243386243395e-02*G0_1_0 + 4.514991181657858e-02*G0_1_2;
    block[227] = 2.821869488536250e-03*G0_0_0 + 2.821869488536142e-03*G0_0_2 + 1.410934744268071e-02*G0_1_0 + 1.693121693121677e-02*G0_1_2;
    block[228] = 1.128747795414459e-02*G0_0_0 + 1.128747795414468e-02*G0_0_2 + 1.128747795414473e-02*G0_1_0 + 2.257495590828939e-02*G0_1_2;
    block[229] = 7.901234567901230e-02*G0_0_1 + 1.580246913580245e-01*G0_0_2 + 1.015873015873016e-01*G0_1_1 + 7.901234567901246e-02*G0_1_2;
    block[230] = -3.104056437389778e-02*G0_0_1 - 9.029982363315699e-02*G0_0_2 - 4.232804232804237e-02*G0_1_1 - 5.925925925925933e-02*G0_1_2;
    block[231] = 1.128747795414459e-02*G0_0_1 + 4.514991181657837e-02*G0_0_2 + 1.128747795414474e-02*G0_1_1 + 3.386243386243391e-02*G0_1_2;
    block[232] = -2.257495590828918e-02*G0_0_0 + 1.128747795414444e-02*G0_0_1 - 2.257495590828949e-02*G0_0_2 - 3.386243386243400e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 6.772486772486763e-02*G0_1_2;
    block[233] = -2.257495590828922e-02*G0_0_0 + 1.128747795414478e-02*G0_0_1 - 2.257495590828919e-02*G0_0_2 - 3.386243386243364e-02*G0_1_0 + 2.257495590828944e-02*G0_1_1 - 6.772486772486766e-02*G0_1_2;
    block[234] = 1.128747795414461e-01*G0_0_0 + 1.128747795414460e-02*G0_0_1 + 1.128747795414463e-01*G0_0_2 + 1.015873015873016e-01*G0_1_0 - 6.772486772486788e-02*G0_1_1 + 2.031746031746029e-01*G0_1_2;
    block[235] = -1.128747795414461e-01*G0_0_0 - 1.015873015873017e-01*G0_0_1 - 1.015873015873016e-01*G0_1_0 - 1.354497354497356e-01*G0_1_1;
    block[236] = 2.257495590828926e-02*G0_0_0 + 3.386243386243398e-02*G0_0_1 + 3.386243386243366e-02*G0_1_0 + 4.514991181657858e-02*G0_1_1;
    block[237] = 2.257495590828946e-02*G0_0_0 + 3.386243386243389e-02*G0_0_1 + 3.386243386243400e-02*G0_1_0 + 4.514991181657847e-02*G0_1_1;
    block[238] = -1.128747795414480e-02*G0_0_1 - 1.128747795414455e-02*G0_1_0 - 2.257495590828949e-02*G0_1_1;
    block[239] = -1.128747795414461e-02*G0_0_1 - 1.128747795414465e-02*G0_1_0 - 6.772486772486785e-02*G0_1_1;
    block[240] = -1.128747795414446e-02*G0_0_1 - 1.128747795414466e-02*G0_1_0 - 2.257495590828914e-02*G0_1_1;
    block[241] = 3.386243386243398e-02*G0_0_1 + 2.257495590828942e-02*G0_0_2 + 3.386243386243395e-02*G0_1_0 + 9.029982363315717e-02*G0_1_1 + 6.772486772486784e-02*G0_1_2;
    block[242] = 3.386243386243389e-02*G0_0_1 + 2.257495590828936e-02*G0_0_2 + 3.386243386243371e-02*G0_1_0 + 1.354497354497355e-01*G0_1_1 + 6.772486772486754e-02*G0_1_2;
    block[243] = -1.015873015873018e-01*G0_0_1 - 1.128747795414460e-01*G0_0_2 - 1.015873015873015e-01*G0_1_0 - 2.708994708994710e-01*G0_1_1 - 2.031746031746027e-01*G0_1_2;
    block[244] = 9.029982363315736e-02*G0_1_1;
    block[245] = -7.760141093474373e-03*G0_0_0 - 7.760141093474378e-03*G0_0_1 - 7.760141093474366e-03*G0_0_2 - 2.539682539682529e-02*G0_1_0 - 2.539682539682529e-02*G0_1_1 - 2.539682539682530e-02*G0_1_2 - 7.760141093474378e-03*G0_2_0 - 7.760141093474382e-03*G0_2_1 - 7.760141093474370e-03*G0_2_2;
    block[246] = 7.760141093474375e-03*G0_0_0 + 7.760141093474389e-03*G0_2_0;
    block[247] = -4.585537918871241e-02*G0_0_1 - 7.054673721340370e-02*G0_1_1 - 4.585537918871242e-02*G0_2_1;
    block[248] = 7.760141093474497e-03*G0_0_2 + 7.760141093474496e-03*G0_2_2;
    block[249] = -4.514991181657810e-02*G0_0_0 - 1.128747795414453e-02*G0_0_1 - 1.128747795414443e-02*G0_1_0 - 4.514991181657813e-02*G0_2_0 - 1.128747795414456e-02*G0_2_1;
    block[250] = 9.029982363315668e-02*G0_0_0 + 3.104056437389786e-02*G0_0_1 + 3.104056437389749e-02*G0_1_0 - 1.128747795414466e-02*G0_1_1 + 9.029982363315672e-02*G0_2_0 + 3.104056437389789e-02*G0_2_1;
    block[251] = -1.580246913580245e-01*G0_0_0 - 7.901234567901247e-02*G0_0_1 - 7.901234567901222e-02*G0_1_0 + 2.257495590828916e-02*G0_1_1 - 1.580246913580245e-01*G0_2_0 - 7.901234567901248e-02*G0_2_1;
    block[252] = 1.580246913580245e-01*G0_0_0 + 7.901234567901216e-02*G0_0_1 + 1.580246913580245e-01*G0_0_2 + 7.901234567901215e-02*G0_1_0 + 2.031746031746026e-01*G0_1_1 + 7.901234567901218e-02*G0_1_2 + 1.580246913580245e-01*G0_2_0 + 7.901234567901218e-02*G0_2_1 + 1.580246913580245e-01*G0_2_2;
    block[253] = -9.029982363315693e-02*G0_0_0 - 5.925925925925903e-02*G0_0_1 - 9.029982363315696e-02*G0_0_2 - 1.326278659611989e-01*G0_1_0 - 2.201058201058194e-01*G0_1_1 - 1.326278659611989e-01*G0_1_2 - 9.029982363315694e-02*G0_2_0 - 5.925925925925907e-02*G0_2_1 - 9.029982363315700e-02*G0_2_2;
    block[254] = 4.514991181657828e-02*G0_0_0 + 3.386243386243368e-02*G0_0_1 + 4.514991181657834e-02*G0_0_2 + 7.901234567901205e-02*G0_1_0 + 1.128747795414459e-01*G0_1_1 + 7.901234567901204e-02*G0_1_2 + 4.514991181657838e-02*G0_2_0 + 3.386243386243373e-02*G0_2_1 + 4.514991181657843e-02*G0_2_2;
    block[255] = 1.128747795414449e-02*G0_0_1 + 1.128747795414456e-02*G0_0_2 + 1.128747795414450e-02*G0_1_0 - 2.257495590828934e-02*G0_1_1 - 2.257495590828933e-02*G0_1_2 + 1.128747795414455e-02*G0_2_1 + 1.128747795414461e-02*G0_2_2;
    block[256] = 2.821869488536275e-03*G0_0_1 + 2.821869488536246e-03*G0_0_2 + 2.821869488536230e-03*G0_1_0 - 1.128747795414461e-02*G0_1_1 - 1.128747795414459e-02*G0_1_2 + 2.821869488536250e-03*G0_2_1 + 2.821869488536220e-03*G0_2_2;
    block[257] = 1.128747795414451e-02*G0_0_1 + 1.128747795414452e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 + 1.128747795414454e-02*G0_2_1 + 1.128747795414455e-02*G0_2_2;
    block[258] = 1.128747795414451e-02*G0_0_0 + 1.128747795414448e-02*G0_0_1 - 2.257495590828926e-02*G0_1_0 - 2.257495590828924e-02*G0_1_1 + 1.128747795414457e-02*G0_1_2 + 1.128747795414458e-02*G0_2_0 + 1.128747795414454e-02*G0_2_1;
    block[259] = 2.821869488536204e-03*G0_0_0 + 2.821869488536233e-03*G0_0_1 - 1.128747795414452e-02*G0_1_0 - 1.128747795414453e-02*G0_1_1 + 2.821869488536150e-03*G0_1_2 + 2.821869488536191e-03*G0_2_0 + 2.821869488536222e-03*G0_2_1;
    block[260] = 1.128747795414464e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 + 1.128747795414460e-02*G0_1_2 + 1.128747795414464e-02*G0_2_0 + 1.128747795414460e-02*G0_2_1;
    block[261] = -1.128747795414446e-02*G0_0_0 - 1.128747795414456e-02*G0_0_2 - 1.128747795414451e-02*G0_2_0 - 1.128747795414459e-02*G0_2_2;
    block[262] = -2.821869488536249e-03*G0_0_0 - 2.821869488536134e-03*G0_0_2 - 2.821869488536224e-03*G0_2_0 - 2.821869488536119e-03*G0_2_2;
    block[263] = -1.128747795414459e-02*G0_0_0 - 1.128747795414467e-02*G0_0_2 - 1.128747795414458e-02*G0_2_0 - 1.128747795414466e-02*G0_2_2;
    block[264] = -7.901234567901233e-02*G0_0_1 - 1.580246913580245e-01*G0_0_2 + 2.257495590828915e-02*G0_1_1 - 7.901234567901216e-02*G0_1_2 - 7.901234567901234e-02*G0_2_1 - 1.580246913580245e-01*G0_2_2;
    block[265] = 3.104056437389774e-02*G0_0_1 + 9.029982363315693e-02*G0_0_2 - 1.128747795414453e-02*G0_1_1 + 3.104056437389768e-02*G0_1_2 + 3.104056437389771e-02*G0_2_1 + 9.029982363315688e-02*G0_2_2;
    block[266] = -1.128747795414458e-02*G0_0_1 - 4.514991181657835e-02*G0_0_2 - 1.128747795414448e-02*G0_1_2 - 1.128747795414458e-02*G0_2_1 - 4.514991181657835e-02*G0_2_2;
    block[267] = 2.257495590828920e-02*G0_0_0 - 1.128747795414435e-02*G0_0_1 + 2.257495590828962e-02*G0_0_2 - 1.128747795414470e-02*G0_1_0 - 1.128747795414449e-02*G0_1_2 + 2.257495590828929e-02*G0_2_0 - 1.128747795414434e-02*G0_2_1 + 2.257495590828964e-02*G0_2_2;
    block[268] = 2.257495590828917e-02*G0_0_0 - 1.128747795414480e-02*G0_0_1 + 2.257495590828915e-02*G0_0_2 - 1.128747795414436e-02*G0_1_0 - 1.128747795414449e-02*G0_1_2 + 2.257495590828913e-02*G0_2_0 - 1.128747795414477e-02*G0_2_1 + 2.257495590828911e-02*G0_2_2;
    block[269] = -1.128747795414462e-01*G0_0_0 - 1.128747795414467e-02*G0_0_1 - 1.128747795414463e-01*G0_0_2 - 1.128747795414473e-02*G0_1_0 - 4.514991181657865e-02*G0_1_1 - 1.128747795414492e-02*G0_1_2 - 1.128747795414463e-01*G0_2_0 - 1.128747795414466e-02*G0_2_1 - 1.128747795414462e-01*G0_2_2;
    block[270] = 1.128747795414462e-01*G0_0_0 + 1.015873015873018e-01*G0_0_1 + 1.128747795414474e-02*G0_1_0 - 6.772486772486758e-02*G0_1_1 + 1.015873015873013e-01*G0_1_2 + 1.128747795414463e-01*G0_2_0 + 1.015873015873018e-01*G0_2_1;
    block[271] = -2.257495590828922e-02*G0_0_0 - 3.386243386243395e-02*G0_0_1 + 1.128747795414434e-02*G0_1_0 + 2.257495590828903e-02*G0_1_1 - 3.386243386243396e-02*G0_1_2 - 2.257495590828917e-02*G0_2_0 - 3.386243386243391e-02*G0_2_1;
    block[272] = -2.257495590828960e-02*G0_0_0 - 3.386243386243382e-02*G0_0_1 + 1.128747795414458e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 3.386243386243364e-02*G0_1_2 - 2.257495590828954e-02*G0_2_0 - 3.386243386243389e-02*G0_2_1;
    block[273] = 1.128747795414483e-02*G0_0_1 + 1.128747795414458e-02*G0_1_0 + 1.128747795414444e-02*G0_1_2 + 1.128747795414480e-02*G0_2_1;
    block[274] = 1.128747795414451e-02*G0_0_1 + 1.128747795414448e-02*G0_1_0 + 1.128747795414464e-02*G0_1_2 + 1.128747795414451e-02*G0_2_1;
    block[275] = 1.128747795414450e-02*G0_0_1 + 1.128747795414463e-02*G0_1_0 - 4.514991181657840e-02*G0_1_1 + 1.128747795414482e-02*G0_1_2 + 1.128747795414454e-02*G0_2_1;
    block[276] = -3.386243386243381e-02*G0_0_1 - 2.257495590828933e-02*G0_0_2 - 3.386243386243361e-02*G0_1_0 + 6.772486772486783e-02*G0_1_1 + 1.128747795414456e-02*G0_1_2 - 3.386243386243391e-02*G0_2_1 - 2.257495590828933e-02*G0_2_2;
    block[277] = -3.386243386243405e-02*G0_0_1 - 2.257495590828950e-02*G0_0_2 - 3.386243386243406e-02*G0_1_0 + 2.257495590828932e-02*G0_1_1 + 1.128747795414447e-02*G0_1_2 - 3.386243386243406e-02*G0_2_1 - 2.257495590828951e-02*G0_2_2;
    block[278] = 1.015873015873017e-01*G0_0_1 + 1.128747795414461e-01*G0_0_2 + 1.015873015873015e-01*G0_1_0 - 6.772486772486769e-02*G0_1_1 + 1.128747795414490e-02*G0_1_2 + 1.015873015873018e-01*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[279] = 9.029982363315707e-02*G0_1_1;
    block[280] = 2.028218694885356e-02*G0_0_0 + 2.028218694885359e-02*G0_0_1 + 2.028218694885358e-02*G0_0_2 + 5.291005291005275e-02*G0_1_0 + 5.291005291005275e-02*G0_1_1 + 5.291005291005278e-02*G0_1_2 + 2.028218694885356e-02*G0_2_0 + 2.028218694885359e-02*G0_2_1 + 2.028218694885359e-02*G0_2_2;
    block[281] = 5.114638447971801e-03*G0_0_0 + 5.114638447971801e-03*G0_2_0;
    block[282] = 3.262786596119917e-02*G0_0_1 + 5.291005291005276e-02*G0_1_1 + 3.262786596119917e-02*G0_2_1;
    block[283] = 5.114638447971765e-03*G0_0_2 + 5.114638447971762e-03*G0_2_2;
    block[284] = -1.693121693121700e-02*G0_0_0 - 2.821869488536139e-03*G0_0_1 - 2.821869488536302e-03*G0_1_0 - 1.693121693121697e-02*G0_2_0 - 2.821869488536116e-03*G0_2_1;
    block[285] = 2.116402116402119e-02*G0_0_0 + 1.058201058201054e-02*G0_0_1 + 1.058201058201076e-02*G0_1_0 - 2.821869488536035e-03*G0_1_1 + 2.116402116402117e-02*G0_2_0 + 1.058201058201052e-02*G0_2_1;
    block[286] = 9.029982363315696e-02*G0_0_0 + 5.925925925925939e-02*G0_0_1 + 5.925925925925915e-02*G0_1_0 + 1.693121693121696e-02*G0_1_1 + 9.029982363315700e-02*G0_2_0 + 5.925925925925941e-02*G0_2_1;
    block[287] = -9.029982363315692e-02*G0_0_0 - 1.326278659611989e-01*G0_0_1 - 9.029982363315694e-02*G0_0_2 - 5.925925925925901e-02*G0_1_0 - 2.201058201058194e-01*G0_1_1 - 5.925925925925907e-02*G0_1_2 - 9.029982363315696e-02*G0_2_0 - 1.326278659611989e-01*G0_2_1 - 9.029982363315700e-02*G0_2_2;
    block[288] = 2.497354497354495e-01*G0_0_0 + 1.671957671957667e-01*G0_0_1 + 2.497354497354495e-01*G0_0_2 + 1.671957671957667e-01*G0_1_0 + 3.343915343915336e-01*G0_1_1 + 1.671957671957667e-01*G0_1_2 + 2.497354497354495e-01*G0_2_0 + 1.671957671957667e-01*G0_2_1 + 2.497354497354495e-01*G0_2_2;
    block[289] = -1.185185185185183e-01*G0_0_0 - 8.747795414462055e-02*G0_0_1 - 1.185185185185183e-01*G0_0_2 - 1.608465608465604e-01*G0_1_0 - 2.201058201058196e-01*G0_1_1 - 1.608465608465604e-01*G0_1_2 - 1.185185185185183e-01*G0_2_0 - 8.747795414462056e-02*G0_2_1 - 1.185185185185184e-01*G0_2_2;
    block[290] = -1.128747795414451e-02*G0_0_0 - 4.232804232804229e-02*G0_0_1 - 4.232804232804233e-02*G0_0_2 - 4.232804232804221e-02*G0_1_0 + 1.693121693121706e-02*G0_1_1 + 1.693121693121704e-02*G0_1_2 - 1.128747795414450e-02*G0_2_0 - 4.232804232804235e-02*G0_2_1 - 4.232804232804237e-02*G0_2_2;
    block[291] = -2.821869488536202e-03*G0_0_0 - 1.340388007054682e-02*G0_0_1 - 1.340388007054679e-02*G0_0_2 - 1.340388007054669e-02*G0_1_0 - 2.821869488536050e-03*G0_1_1 - 2.821869488536071e-03*G0_1_2 - 2.821869488536214e-03*G0_2_0 - 1.340388007054680e-02*G0_2_1 - 1.340388007054678e-02*G0_2_2;
    block[292] = -1.128747795414466e-02*G0_0_0 + 2.821869488536188e-03*G0_0_1 + 2.821869488536184e-03*G0_0_2 + 2.821869488536091e-03*G0_1_0 - 1.128747795414465e-02*G0_2_0 + 2.821869488536168e-03*G0_2_1 + 2.821869488536163e-03*G0_2_2;
    block[293] = -4.232804232804233e-02*G0_0_0 - 4.232804232804229e-02*G0_0_1 - 1.128747795414459e-02*G0_0_2 + 1.693121693121702e-02*G0_1_0 + 1.693121693121701e-02*G0_1_1 - 4.232804232804219e-02*G0_1_2 - 4.232804232804237e-02*G0_2_0 - 4.232804232804230e-02*G0_2_1 - 1.128747795414457e-02*G0_2_2;
    block[294] = -1.340388007054675e-02*G0_0_0 - 1.340388007054680e-02*G0_0_1 - 2.821869488536211e-03*G0_0_2 - 2.821869488536286e-03*G0_1_0 - 2.821869488536282e-03*G0_1_1 - 1.340388007054678e-02*G0_1_2 - 1.340388007054674e-02*G0_2_0 - 1.340388007054679e-02*G0_2_1 - 2.821869488536217e-03*G0_2_2;
    block[295] = 2.821869488536118e-03*G0_0_0 + 2.821869488536111e-03*G0_0_1 - 1.128747795414465e-02*G0_0_2 + 2.821869488536098e-03*G0_1_2 + 2.821869488536111e-03*G0_2_0 + 2.821869488536104e-03*G0_2_1 - 1.128747795414465e-02*G0_2_2;
    block[296] = -2.821869488536194e-03*G0_0_0 - 2.821869488536140e-03*G0_0_2 - 2.821869488536178e-03*G0_2_0 - 2.821869488536120e-03*G0_2_2;
    block[297] = -9.171075837742470e-03*G0_0_0 - 9.171075837742531e-03*G0_0_2 - 9.171075837742466e-03*G0_2_0 - 9.171075837742538e-03*G0_2_2;
    block[298] = -2.821869488536164e-03*G0_0_0 - 2.821869488536119e-03*G0_0_2 - 2.821869488536158e-03*G0_2_0 - 2.821869488536112e-03*G0_2_2;
    block[299] = 5.925925925925939e-02*G0_0_1 + 9.029982363315693e-02*G0_0_2 + 1.693121693121699e-02*G0_1_1 + 5.925925925925905e-02*G0_1_2 + 5.925925925925941e-02*G0_2_1 + 9.029982363315697e-02*G0_2_2;
    block[300] = 1.058201058201049e-02*G0_0_1 + 2.116402116402119e-02*G0_0_2 - 2.821869488536284e-03*G0_1_1 + 1.058201058201057e-02*G0_1_2 + 1.058201058201049e-02*G0_2_1 + 2.116402116402118e-02*G0_2_2;
    block[301] = -2.821869488536182e-03*G0_0_1 - 1.693121693121702e-02*G0_0_2 - 2.821869488536317e-03*G0_1_2 - 2.821869488536178e-03*G0_2_1 - 1.693121693121700e-02*G0_2_2;
    block[302] = 1.693121693121699e-02*G0_0_0 - 2.821869488536238e-03*G0_0_1 + 1.693121693121688e-02*G0_0_2 - 2.821869488536185e-03*G0_1_0 - 2.821869488536256e-03*G0_1_2 + 1.693121693121697e-02*G0_2_0 - 2.821869488536230e-03*G0_2_1 + 1.693121693121688e-02*G0_2_2;
    block[303] = 1.693121693121675e-02*G0_0_0 - 2.821869488536193e-03*G0_0_1 + 1.693121693121685e-02*G0_0_2 - 2.821869488536496e-03*G0_1_0 - 2.821869488536400e-03*G0_1_2 + 1.693121693121676e-02*G0_2_0 - 2.821869488536183e-03*G0_2_1 + 1.693121693121686e-02*G0_2_2;
    block[304] = 8.465608465608492e-02*G0_0_0 + 4.232804232804247e-02*G0_0_1 + 8.465608465608485e-02*G0_0_2 + 4.232804232804242e-02*G0_1_0 + 2.257495590828938e-02*G0_1_1 + 4.232804232804260e-02*G0_1_2 + 8.465608465608496e-02*G0_2_0 + 4.232804232804247e-02*G0_2_1 + 8.465608465608486e-02*G0_2_2;
    block[305] = -8.465608465608489e-02*G0_0_0 - 1.777777777777781e-01*G0_0_1 - 2.708994708994706e-01*G0_0_2 - 4.232804232804243e-02*G0_1_0 - 1.693121693121690e-02*G0_1_1 - 1.777777777777773e-01*G0_1_2 - 8.465608465608493e-02*G0_2_0 - 1.777777777777781e-01*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[306] = -1.693121693121670e-02*G0_0_0 + 2.821869488536296e-03*G0_0_1 + 6.772486772486762e-02*G0_0_2 + 2.821869488536523e-03*G0_1_0 + 5.643738977072590e-03*G0_1_1 + 2.821869488536411e-03*G0_1_2 - 1.693121693121672e-02*G0_2_0 + 2.821869488536291e-03*G0_2_1 + 6.772486772486760e-02*G0_2_2;
    block[307] = 1.185185185185188e-01*G0_0_0 + 1.608465608465609e-01*G0_0_1 + 6.772486772486773e-02*G0_0_2 + 2.539682539682527e-02*G0_1_0 - 1.693121693121709e-02*G0_1_1 + 1.608465608465602e-01*G0_1_2 + 1.185185185185188e-01*G0_2_0 + 1.608465608465610e-01*G0_2_1 + 6.772486772486777e-02*G0_2_2;
    block[308] = 2.257495590828923e-02*G0_0_0 + 2.821869488536198e-03*G0_0_1 + 2.257495590828924e-02*G0_0_2 + 2.821869488536240e-03*G0_1_0 + 2.821869488536324e-03*G0_1_2 + 2.257495590828922e-02*G0_2_0 + 2.821869488536189e-03*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[309] = 2.257495590828929e-02*G0_0_0 + 2.821869488536065e-03*G0_0_1 + 2.257495590828924e-02*G0_0_2 + 2.821869488536202e-03*G0_1_0 + 2.821869488536028e-03*G0_1_2 + 2.257495590828925e-02*G0_2_0 + 2.821869488536061e-03*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[310] = 2.257495590828925e-02*G0_0_0 - 1.975308641975287e-02*G0_0_1 + 2.257495590828930e-02*G0_0_2 - 1.975308641975309e-02*G0_1_0 + 2.257495590828928e-02*G0_1_1 - 1.975308641975326e-02*G0_1_2 + 2.257495590828931e-02*G0_2_0 - 1.975308641975288e-02*G0_2_1 + 2.257495590828934e-02*G0_2_2;
    block[311] = 6.772486772486737e-02*G0_0_0 + 1.608465608465609e-01*G0_0_1 + 1.185185185185186e-01*G0_0_2 + 1.608465608465604e-01*G0_1_0 - 1.693121693121718e-02*G0_1_1 + 2.539682539682543e-02*G0_1_2 + 6.772486772486745e-02*G0_2_0 + 1.608465608465610e-01*G0_2_1 + 1.185185185185186e-01*G0_2_2;
    block[312] = 6.772486772486794e-02*G0_0_0 + 2.821869488536183e-03*G0_0_1 - 1.693121693121698e-02*G0_0_2 + 2.821869488536357e-03*G0_1_0 + 5.643738977072071e-03*G0_1_1 + 2.821869488536299e-03*G0_1_2 + 6.772486772486787e-02*G0_2_0 + 2.821869488536181e-03*G0_2_1 - 1.693121693121698e-02*G0_2_2;
    block[313] = -2.708994708994709e-01*G0_0_0 - 1.777777777777779e-01*G0_0_1 - 8.465608465608476e-02*G0_0_2 - 1.777777777777775e-01*G0_1_0 - 1.693121693121678e-02*G0_1_1 - 4.232804232804261e-02*G0_1_2 - 2.708994708994709e-01*G0_2_0 - 1.777777777777780e-01*G0_2_1 - 8.465608465608478e-02*G0_2_2;
    block[314] = -1.354497354497358e-01*G0_0_0 - 2.257495590828936e-02*G0_0_1 - 1.354497354497353e-01*G0_0_2 - 2.257495590828906e-02*G0_1_0 - 4.514991181657865e-02*G0_1_1 - 2.257495590828895e-02*G0_1_2 - 1.354497354497358e-01*G0_2_0 - 2.257495590828935e-02*G0_2_1 - 1.354497354497354e-01*G0_2_2;
    block[315] = -2.469135802469132e-02*G0_0_0 - 2.469135802469135e-02*G0_0_1 - 2.469135802469134e-02*G0_0_2 - 7.054673721340371e-02*G0_1_0 - 7.054673721340370e-02*G0_1_1 - 7.054673721340374e-02*G0_1_2 - 2.469135802469133e-02*G0_2_0 - 2.469135802469136e-02*G0_2_1 - 2.469135802469135e-02*G0_2_2;
    block[316] = 7.760141093474389e-03*G0_0_0 + 7.760141093474373e-03*G0_2_0;
    block[317] = -1.763668430335086e-02*G0_0_1 - 2.539682539682529e-02*G0_1_1 - 1.763668430335087e-02*G0_2_1;
    block[318] = 7.760141093474390e-03*G0_0_2 + 7.760141093474391e-03*G0_2_2;
    block[319] = -2.257495590828918e-02*G0_0_0 - 1.128747795414467e-02*G0_0_1 - 1.128747795414450e-02*G0_1_0 - 2.257495590828920e-02*G0_2_0 - 1.128747795414470e-02*G0_2_1;
    block[320] = -1.693121693121695e-02*G0_0_0 - 1.410934744268064e-02*G0_0_1 - 1.410934744268089e-02*G0_1_0 - 1.128747795414459e-02*G0_1_1 - 1.693121693121690e-02*G0_2_0 - 1.410934744268060e-02*G0_2_1;
    block[321] = -4.514991181657847e-02*G0_0_0 - 3.386243386243394e-02*G0_0_1 - 3.386243386243380e-02*G0_1_0 - 2.257495590828930e-02*G0_1_1 - 4.514991181657854e-02*G0_2_0 - 3.386243386243399e-02*G0_2_1;
    block[322] = 4.514991181657828e-02*G0_0_0 + 7.901234567901205e-02*G0_0_1 + 4.514991181657838e-02*G0_0_2 + 3.386243386243368e-02*G0_1_0 + 1.128747795414459e-01*G0_1_1 + 3.386243386243373e-02*G0_1_2 + 4.514991181657834e-02*G0_2_0 + 7.901234567901205e-02*G0_2_1 + 4.514991181657843e-02*G0_2_2;
    block[323] = -1.185185185185183e-01*G0_0_0 - 1.608465608465604e-01*G0_0_1 - 1.185185185185183e-01*G0_0_2 - 8.747795414462056e-02*G0_1_0 - 2.201058201058196e-01*G0_1_1 - 8.747795414462056e-02*G0_1_2 - 1.185185185185183e-01*G0_2_0 - 1.608465608465604e-01*G0_2_1 - 1.185185185185184e-01*G0_2_2;
    block[324] = 2.031746031746028e-01*G0_0_0 + 1.241622574955906e-01*G0_0_1 + 2.031746031746028e-01*G0_0_2 + 1.241622574955906e-01*G0_1_0 + 2.031746031746027e-01*G0_1_1 + 1.241622574955906e-01*G0_1_2 + 2.031746031746028e-01*G0_2_0 + 1.241622574955906e-01*G0_2_1 + 2.031746031746028e-01*G0_2_2;
    block[325] = 2.257495590828912e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.015873015873014e-01*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 2.257495590828915e-02*G0_1_1 + 2.257495590828919e-02*G0_1_2 + 2.257495590828915e-02*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 1.015873015873014e-01*G0_2_2;
    block[326] = 1.693121693121694e-02*G0_0_0 - 4.232804232804229e-02*G0_0_1 - 4.232804232804229e-02*G0_0_2 - 4.232804232804230e-02*G0_1_0 - 1.128747795414469e-02*G0_1_1 - 1.128747795414467e-02*G0_1_2 + 1.693121693121691e-02*G0_2_0 - 4.232804232804224e-02*G0_2_1 - 4.232804232804224e-02*G0_2_2;
    block[327] = -2.257495590828916e-02*G0_0_0 + 1.128747795414468e-02*G0_0_1 + 1.128747795414466e-02*G0_0_2 + 1.128747795414469e-02*G0_1_0 - 2.257495590828915e-02*G0_2_0 + 1.128747795414472e-02*G0_2_1 + 1.128747795414469e-02*G0_2_2;
    block[328] = 1.015873015873014e-01*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 2.257495590828923e-02*G0_0_2 + 2.257495590828920e-02*G0_1_0 + 2.257495590828923e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[329] = -4.232804232804213e-02*G0_0_0 - 4.232804232804210e-02*G0_0_1 + 1.693121693121701e-02*G0_0_2 - 1.128747795414455e-02*G0_1_0 - 1.128747795414455e-02*G0_1_1 - 4.232804232804218e-02*G0_1_2 - 4.232804232804216e-02*G0_2_0 - 4.232804232804213e-02*G0_2_1 + 1.693121693121698e-02*G0_2_2;
    block[330] = 1.128747795414462e-02*G0_0_0 + 1.128747795414463e-02*G0_0_1 - 2.257495590828916e-02*G0_0_2 + 1.128747795414464e-02*G0_1_2 + 1.128747795414462e-02*G0_2_0 + 1.128747795414463e-02*G0_2_1 - 2.257495590828911e-02*G0_2_2;
    block[331] = -1.128747795414467e-02*G0_0_0 - 1.128747795414469e-02*G0_0_2 - 1.128747795414465e-02*G0_2_0 - 1.128747795414472e-02*G0_2_2;
    block[332] = -2.821869488536050e-03*G0_0_0 - 2.821869488536146e-03*G0_0_2 - 2.821869488536063e-03*G0_2_0 - 2.821869488536097e-03*G0_2_2;
    block[333] = -1.128747795414458e-02*G0_0_0 - 1.128747795414456e-02*G0_0_2 - 1.128747795414458e-02*G0_2_0 - 1.128747795414459e-02*G0_2_2;
    block[334] = -3.386243386243392e-02*G0_0_1 - 4.514991181657842e-02*G0_0_2 - 2.257495590828923e-02*G0_1_1 - 3.386243386243373e-02*G0_1_2 - 3.386243386243396e-02*G0_2_1 - 4.514991181657848e-02*G0_2_2;
    block[335] = -1.410934744268075e-02*G0_0_1 - 1.693121693121702e-02*G0_0_2 - 1.128747795414460e-02*G0_1_1 - 1.410934744268082e-02*G0_1_2 - 1.410934744268077e-02*G0_2_1 - 1.693121693121702e-02*G0_2_2;
    block[336] = -1.128747795414456e-02*G0_0_1 - 2.257495590828910e-02*G0_0_2 - 1.128747795414451e-02*G0_1_2 - 1.128747795414456e-02*G0_2_1 - 2.257495590828909e-02*G0_2_2;
    block[337] = -2.257495590828915e-02*G0_0_0 - 1.128747795414454e-02*G0_0_1 - 2.257495590828911e-02*G0_0_2 - 1.128747795414437e-02*G0_1_0 - 1.128747795414446e-02*G0_1_2 - 2.257495590828915e-02*G0_2_0 - 1.128747795414455e-02*G0_2_1 - 2.257495590828913e-02*G0_2_2;
    block[338] = -2.257495590828920e-02*G0_0_0 - 1.128747795414451e-02*G0_0_1 - 2.257495590828930e-02*G0_0_2 - 1.128747795414447e-02*G0_1_0 - 1.128747795414439e-02*G0_1_2 - 2.257495590828919e-02*G0_2_0 - 1.128747795414451e-02*G0_2_1 - 2.257495590828930e-02*G0_2_2;
    block[339] = -6.772486772486785e-02*G0_0_0 - 5.643738977072320e-02*G0_0_1 - 6.772486772486766e-02*G0_0_2 - 5.643738977072316e-02*G0_1_0 - 4.514991181657851e-02*G0_1_1 - 5.643738977072322e-02*G0_1_2 - 6.772486772486794e-02*G0_2_0 - 5.643738977072321e-02*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[340] = 6.772486772486787e-02*G0_0_0 + 1.015873015873017e-01*G0_0_1 + 1.354497354497354e-01*G0_0_2 + 5.643738977072317e-02*G0_1_0 + 6.772486772486763e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 6.772486772486795e-02*G0_2_0 + 1.015873015873018e-01*G0_2_1 + 1.354497354497355e-01*G0_2_2;
    block[341] = 2.257495590828917e-02*G0_0_0 + 5.643738977072289e-02*G0_0_1 + 9.029982363315671e-02*G0_0_2 + 1.128747795414444e-02*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 5.643738977072290e-02*G0_1_2 + 2.257495590828917e-02*G0_2_0 + 5.643738977072296e-02*G0_2_1 + 9.029982363315671e-02*G0_2_2;
    block[342] = -6.772486772486781e-02*G0_0_0 - 1.693121693121691e-01*G0_0_1 - 2.708994708994704e-01*G0_0_2 - 7.901234567901215e-02*G0_1_0 - 6.772486772486762e-02*G0_1_1 - 1.693121693121690e-01*G0_1_2 - 6.772486772486788e-02*G0_2_0 - 1.693121693121692e-01*G0_2_1 - 2.708994708994704e-01*G0_2_2;
    block[343] = 4.514991181657816e-02*G0_0_0 + 1.128747795414448e-02*G0_0_1 + 4.514991181657820e-02*G0_0_2 + 1.128747795414450e-02*G0_1_0 + 1.128747795414455e-02*G0_1_2 + 4.514991181657822e-02*G0_2_0 + 1.128747795414447e-02*G0_2_1 + 4.514991181657824e-02*G0_2_2;
    block[344] = 4.514991181657859e-02*G0_0_0 + 1.128747795414467e-02*G0_0_1 + 4.514991181657851e-02*G0_0_2 + 1.128747795414461e-02*G0_1_0 + 1.128747795414464e-02*G0_1_2 + 4.514991181657850e-02*G0_2_0 + 1.128747795414469e-02*G0_2_1 + 4.514991181657842e-02*G0_2_2;
    block[345] = -1.354497354497353e-01*G0_0_0 - 3.386243386243402e-02*G0_0_1 - 1.354497354497351e-01*G0_0_2 - 3.386243386243385e-02*G0_1_0 - 4.514991181657847e-02*G0_1_1 - 3.386243386243382e-02*G0_1_2 - 1.354497354497353e-01*G0_2_0 - 3.386243386243398e-02*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[346] = -2.708994708994704e-01*G0_0_0 - 1.693121693121691e-01*G0_0_1 - 6.772486772486785e-02*G0_0_2 - 1.693121693121690e-01*G0_1_0 - 6.772486772486758e-02*G0_1_1 - 7.901234567901229e-02*G0_1_2 - 2.708994708994703e-01*G0_2_0 - 1.693121693121692e-01*G0_2_1 - 6.772486772486785e-02*G0_2_2;
    block[347] = 9.029982363315668e-02*G0_0_0 + 5.643738977072293e-02*G0_0_1 + 2.257495590828919e-02*G0_0_2 + 5.643738977072286e-02*G0_1_0 + 2.257495590828930e-02*G0_1_1 + 1.128747795414445e-02*G0_1_2 + 9.029982363315660e-02*G0_2_0 + 5.643738977072284e-02*G0_2_1 + 2.257495590828921e-02*G0_2_2;
    block[348] = 1.354497354497353e-01*G0_0_0 + 1.015873015873016e-01*G0_0_1 + 6.772486772486769e-02*G0_0_2 + 1.015873015873016e-01*G0_1_0 + 6.772486772486759e-02*G0_1_1 + 5.643738977072322e-02*G0_1_2 + 1.354497354497353e-01*G0_2_0 + 1.015873015873017e-01*G0_2_1 + 6.772486772486772e-02*G0_2_2;
    block[349] = 9.029982363315697e-02*G0_0_0 + 9.029982363315697e-02*G0_0_1 + 9.029982363315706e-02*G0_0_2 + 9.029982363315656e-02*G0_1_0 + 9.029982363315692e-02*G0_1_1 + 9.029982363315663e-02*G0_1_2 + 9.029982363315707e-02*G0_2_0 + 9.029982363315694e-02*G0_2_1 + 9.029982363315704e-02*G0_2_2;
    block[350] = -7.054673721340371e-02*G0_0_0 - 7.054673721340370e-02*G0_0_1 - 7.054673721340371e-02*G0_0_2 - 2.469135802469130e-02*G0_1_0 - 2.469135802469133e-02*G0_1_1 - 2.469135802469130e-02*G0_1_2 - 2.469135802469131e-02*G0_2_0 - 2.469135802469134e-02*G0_2_1 - 2.469135802469132e-02*G0_2_2;
    block[351] = -2.539682539682536e-02*G0_0_0 - 1.763668430335097e-02*G0_1_0 - 1.763668430335097e-02*G0_2_0;
    block[352] = 7.760141093474475e-03*G0_1_1 + 7.760141093474469e-03*G0_2_1;
    block[353] = 7.760141093474400e-03*G0_1_2 + 7.760141093474405e-03*G0_2_2;
    block[354] = -2.257495590828900e-02*G0_0_0 - 3.386243386243377e-02*G0_0_1 - 3.386243386243372e-02*G0_1_0 - 4.514991181657845e-02*G0_1_1 - 3.386243386243376e-02*G0_2_0 - 4.514991181657849e-02*G0_2_1;
    block[355] = -1.128747795414467e-02*G0_0_0 - 1.410934744268059e-02*G0_0_1 - 1.410934744268076e-02*G0_1_0 - 1.693121693121673e-02*G0_1_1 - 1.410934744268069e-02*G0_2_0 - 1.693121693121665e-02*G0_2_1;
    block[356] = -1.128747795414468e-02*G0_0_1 - 1.128747795414463e-02*G0_1_0 - 2.257495590828930e-02*G0_1_1 - 1.128747795414469e-02*G0_2_0 - 2.257495590828936e-02*G0_2_1;
    block[357] = 1.128747795414450e-02*G0_0_1 + 1.128747795414449e-02*G0_1_0 - 2.257495590828933e-02*G0_1_1 + 1.128747795414454e-02*G0_1_2 + 1.128747795414456e-02*G0_2_0 - 2.257495590828931e-02*G0_2_1 + 1.128747795414461e-02*G0_2_2;
    block[358] = -1.128747795414451e-02*G0_0_0 - 4.232804232804220e-02*G0_0_1 - 1.128747795414451e-02*G0_0_2 - 4.232804232804229e-02*G0_1_0 + 1.693121693121706e-02*G0_1_1 - 4.232804232804235e-02*G0_1_2 - 4.232804232804233e-02*G0_2_0 + 1.693121693121704e-02*G0_2_1 - 4.232804232804237e-02*G0_2_2;
    block[359] = 2.257495590828912e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 2.257495590828914e-02*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 2.257495590828915e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 2.257495590828919e-02*G0_2_1 + 1.015873015873014e-01*G0_2_2;
    block[360] = 2.031746031746028e-01*G0_0_0 + 1.241622574955904e-01*G0_0_1 + 1.241622574955904e-01*G0_0_2 + 1.241622574955904e-01*G0_1_0 + 2.031746031746028e-01*G0_1_1 + 2.031746031746027e-01*G0_1_2 + 1.241622574955905e-01*G0_2_0 + 2.031746031746027e-01*G0_2_1 + 2.031746031746027e-01*G0_2_2;
    block[361] = -2.201058201058196e-01*G0_0_0 - 8.747795414462058e-02*G0_0_1 - 8.747795414462058e-02*G0_0_2 - 1.608465608465604e-01*G0_1_0 - 1.185185185185183e-01*G0_1_1 - 1.185185185185183e-01*G0_1_2 - 1.608465608465604e-01*G0_2_0 - 1.185185185185182e-01*G0_2_1 - 1.185185185185182e-01*G0_2_2;
    block[362] = 1.128747795414460e-01*G0_0_0 + 3.386243386243373e-02*G0_0_1 + 3.386243386243374e-02*G0_0_2 + 7.901234567901218e-02*G0_1_0 + 4.514991181657849e-02*G0_1_1 + 4.514991181657848e-02*G0_1_2 + 7.901234567901218e-02*G0_2_0 + 4.514991181657853e-02*G0_2_1 + 4.514991181657852e-02*G0_2_2;
    block[363] = 2.257495590828910e-02*G0_0_0 + 2.257495590828914e-02*G0_0_1 + 1.015873015873014e-01*G0_0_2 + 1.015873015873015e-01*G0_1_0 + 1.015873015873014e-01*G0_1_1 + 2.257495590828925e-02*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 2.257495590828927e-02*G0_2_2;
    block[364] = -1.128747795414453e-02*G0_0_0 - 1.128747795414453e-02*G0_0_1 - 4.232804232804225e-02*G0_0_2 - 4.232804232804219e-02*G0_1_0 - 4.232804232804217e-02*G0_1_1 + 1.693121693121695e-02*G0_1_2 - 4.232804232804219e-02*G0_2_0 - 4.232804232804217e-02*G0_2_1 + 1.693121693121697e-02*G0_2_2;
    block[365] = 1.128747795414457e-02*G0_0_2 + 1.128747795414459e-02*G0_1_0 + 1.128747795414462e-02*G0_1_1 - 2.257495590828919e-02*G0_1_2 + 1.128747795414461e-02*G0_2_0 + 1.128747795414463e-02*G0_2_1 - 2.257495590828919e-02*G0_2_2;
    block[366] = -2.257495590828910e-02*G0_0_0 - 3.386243386243371e-02*G0_0_2 - 3.386243386243380e-02*G0_1_0 - 4.514991181657846e-02*G0_1_2 - 3.386243386243382e-02*G0_2_0 - 4.514991181657850e-02*G0_2_2;
    block[367] = -1.128747795414455e-02*G0_0_0 - 1.410934744268066e-02*G0_0_2 - 1.410934744268067e-02*G0_1_0 - 1.693121693121678e-02*G0_1_2 - 1.410934744268066e-02*G0_2_0 - 1.693121693121674e-02*G0_2_2;
    block[368] = -1.128747795414455e-02*G0_0_2 - 1.128747795414460e-02*G0_1_0 - 2.257495590828920e-02*G0_1_2 - 1.128747795414461e-02*G0_2_0 - 2.257495590828923e-02*G0_2_2;
    block[369] = -1.128747795414467e-02*G0_1_1 - 1.128747795414463e-02*G0_1_2 - 1.128747795414472e-02*G0_2_1 - 1.128747795414469e-02*G0_2_2;
    block[370] = -2.821869488536176e-03*G0_1_1 - 2.821869488536246e-03*G0_1_2 - 2.821869488536192e-03*G0_2_1 - 2.821869488536235e-03*G0_2_2;
    block[371] = -1.128747795414458e-02*G0_1_1 - 1.128747795414456e-02*G0_1_2 - 1.128747795414459e-02*G0_2_1 - 1.128747795414459e-02*G0_2_2;
    block[372] = -4.514991181657804e-02*G0_0_0 - 5.643738977072252e-02*G0_0_1 - 5.643738977072258e-02*G0_0_2 - 5.643738977072289e-02*G0_1_0 - 6.772486772486731e-02*G0_1_1 - 6.772486772486737e-02*G0_1_2 - 5.643738977072280e-02*G0_2_0 - 6.772486772486729e-02*G0_2_1 - 6.772486772486730e-02*G0_2_2;
    block[373] = -1.128747795414449e-02*G0_0_1 - 1.128747795414445e-02*G0_0_2 - 1.128747795414467e-02*G0_1_0 - 2.257495590828920e-02*G0_1_1 - 2.257495590828933e-02*G0_1_2 - 1.128747795414471e-02*G0_2_0 - 2.257495590828922e-02*G0_2_1 - 2.257495590828934e-02*G0_2_2;
    block[374] = -1.128747795414457e-02*G0_0_1 - 1.128747795414461e-02*G0_0_2 - 1.128747795414474e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 2.257495590828914e-02*G0_1_2 - 1.128747795414481e-02*G0_2_0 - 2.257495590828932e-02*G0_2_1 - 2.257495590828915e-02*G0_2_2;
    block[375] = 1.128747795414452e-02*G0_0_1 + 1.128747795414458e-02*G0_0_2 + 1.128747795414476e-02*G0_1_0 + 4.514991181657872e-02*G0_1_1 + 4.514991181657865e-02*G0_1_2 + 1.128747795414484e-02*G0_2_0 + 4.514991181657877e-02*G0_2_1 + 4.514991181657867e-02*G0_2_2;
    block[376] = 1.128747795414457e-02*G0_0_1 + 1.128747795414454e-02*G0_0_2 + 1.128747795414467e-02*G0_1_0 + 4.514991181657840e-02*G0_1_1 + 4.514991181657838e-02*G0_1_2 + 1.128747795414471e-02*G0_2_0 + 4.514991181657841e-02*G0_2_1 + 4.514991181657840e-02*G0_2_2;
    block[377] = -4.514991181657825e-02*G0_0_0 - 3.386243386243364e-02*G0_0_1 - 3.386243386243365e-02*G0_0_2 - 3.386243386243402e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 1.354497354497352e-01*G0_1_2 - 3.386243386243403e-02*G0_2_0 - 1.354497354497354e-01*G0_2_1 - 1.354497354497352e-01*G0_2_2;
    block[378] = 2.257495590828907e-02*G0_0_0 + 1.128747795414443e-02*G0_0_1 + 5.643738977072297e-02*G0_0_2 + 5.643738977072281e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1 + 9.029982363315664e-02*G0_1_2 + 5.643738977072280e-02*G0_2_0 + 2.257495590828914e-02*G0_2_1 + 9.029982363315664e-02*G0_2_2;
    block[379] = 6.772486772486751e-02*G0_0_0 + 5.643738977072264e-02*G0_0_1 + 1.015873015873013e-01*G0_0_2 + 1.015873015873015e-01*G0_1_0 + 6.772486772486752e-02*G0_1_1 + 1.354497354497352e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 6.772486772486748e-02*G0_2_1 + 1.354497354497351e-01*G0_2_2;
    block[380] = -6.772486772486749e-02*G0_0_0 - 7.901234567901212e-02*G0_0_1 - 1.693121693121688e-01*G0_0_2 - 1.693121693121691e-01*G0_1_0 - 6.772486772486773e-02*G0_1_1 - 2.708994708994704e-01*G0_1_2 - 1.693121693121691e-01*G0_2_0 - 6.772486772486763e-02*G0_2_1 - 2.708994708994703e-01*G0_2_2;
    block[381] = -6.772486772486742e-02*G0_0_0 - 1.693121693121689e-01*G0_0_1 - 7.901234567901211e-02*G0_0_2 - 1.693121693121690e-01*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 6.772486772486780e-02*G0_1_2 - 1.693121693121689e-01*G0_2_0 - 2.708994708994706e-01*G0_2_1 - 6.772486772486778e-02*G0_2_2;
    block[382] = 6.772486772486735e-02*G0_0_0 + 1.015873015873012e-01*G0_0_1 + 5.643738977072261e-02*G0_0_2 + 1.015873015873013e-01*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 6.772486772486748e-02*G0_1_2 + 1.015873015873013e-01*G0_2_0 + 1.354497354497349e-01*G0_2_1 + 6.772486772486741e-02*G0_2_2;
    block[383] = 2.257495590828920e-02*G0_0_0 + 5.643738977072298e-02*G0_0_1 + 1.128747795414460e-02*G0_0_2 + 5.643738977072314e-02*G0_1_0 + 9.029982363315703e-02*G0_1_1 + 2.257495590828915e-02*G0_1_2 + 5.643738977072310e-02*G0_2_0 + 9.029982363315710e-02*G0_2_1 + 2.257495590828916e-02*G0_2_2;
    block[384] = 9.029982363315629e-02*G0_0_0 + 9.029982363315658e-02*G0_0_1 + 9.029982363315649e-02*G0_0_2 + 9.029982363315692e-02*G0_1_0 + 9.029982363315679e-02*G0_1_1 + 9.029982363315699e-02*G0_1_2 + 9.029982363315683e-02*G0_2_0 + 9.029982363315672e-02*G0_2_1 + 9.029982363315697e-02*G0_2_2;
    block[385] = 5.291005291005282e-02*G0_0_0 + 5.291005291005281e-02*G0_0_1 + 5.291005291005282e-02*G0_0_2 + 2.028218694885357e-02*G0_1_0 + 2.028218694885359e-02*G0_1_1 + 2.028218694885356e-02*G0_1_2 + 2.028218694885358e-02*G0_2_0 + 2.028218694885359e-02*G0_2_1 + 2.028218694885356e-02*G0_2_2;
    block[386] = 5.291005291005281e-02*G0_0_0 + 3.262786596119926e-02*G0_1_0 + 3.262786596119927e-02*G0_2_0;
    block[387] = 5.114638447971784e-03*G0_1_1 + 5.114638447971777e-03*G0_2_1;
    block[388] = 5.114638447971770e-03*G0_1_2 + 5.114638447971778e-03*G0_2_2;
    block[389] = 1.693121693121673e-02*G0_0_0 + 5.925925925925914e-02*G0_0_1 + 5.925925925925902e-02*G0_1_0 + 9.029982363315679e-02*G0_1_1 + 5.925925925925903e-02*G0_2_0 + 9.029982363315682e-02*G0_2_1;
    block[390] = -2.821869488536131e-03*G0_0_0 + 1.058201058201038e-02*G0_0_1 + 1.058201058201059e-02*G0_1_0 + 2.116402116402105e-02*G0_1_1 + 1.058201058201055e-02*G0_2_0 + 2.116402116402101e-02*G0_2_1;
    block[391] = -2.821869488536074e-03*G0_0_1 - 2.821869488536154e-03*G0_1_0 - 1.693121693121695e-02*G0_1_1 - 2.821869488536127e-03*G0_2_0 - 1.693121693121690e-02*G0_2_1;
    block[392] = 2.821869488536233e-03*G0_0_1 + 2.821869488536274e-03*G0_1_0 - 1.128747795414461e-02*G0_1_1 + 2.821869488536249e-03*G0_1_2 + 2.821869488536247e-03*G0_2_0 - 1.128747795414460e-02*G0_2_1 + 2.821869488536221e-03*G0_2_2;
    block[393] = -2.821869488536202e-03*G0_0_0 - 1.340388007054669e-02*G0_0_1 - 2.821869488536212e-03*G0_0_2 - 1.340388007054682e-02*G0_1_0 - 2.821869488536052e-03*G0_1_1 - 1.340388007054680e-02*G0_1_2 - 1.340388007054680e-02*G0_2_0 - 2.821869488536073e-03*G0_2_1 - 1.340388007054678e-02*G0_2_2;
    block[394] = 1.693121693121694e-02*G0_0_0 - 4.232804232804232e-02*G0_0_1 + 1.693121693121691e-02*G0_0_2 - 4.232804232804230e-02*G0_1_0 - 1.128747795414469e-02*G0_1_1 - 4.232804232804224e-02*G0_1_2 - 4.232804232804230e-02*G0_2_0 - 1.128747795414467e-02*G0_2_1 - 4.232804232804224e-02*G0_2_2;
    block[395] = -2.201058201058196e-01*G0_0_0 - 1.608465608465604e-01*G0_0_1 - 1.608465608465604e-01*G0_0_2 - 8.747795414462058e-02*G0_1_0 - 1.185185185185183e-01*G0_1_1 - 1.185185185185182e-01*G0_1_2 - 8.747795414462058e-02*G0_2_0 - 1.185185185185183e-01*G0_2_1 - 1.185185185185182e-01*G0_2_2;
    block[396] = 3.343915343915335e-01*G0_0_0 + 1.671957671957669e-01*G0_0_1 + 1.671957671957669e-01*G0_0_2 + 1.671957671957668e-01*G0_1_0 + 2.497354497354494e-01*G0_1_1 + 2.497354497354494e-01*G0_1_2 + 1.671957671957669e-01*G0_2_0 + 2.497354497354494e-01*G0_2_1 + 2.497354497354495e-01*G0_2_2;
    block[397] = -2.201058201058196e-01*G0_0_0 - 5.925925925925912e-02*G0_0_1 - 5.925925925925914e-02*G0_0_2 - 1.326278659611991e-01*G0_1_0 - 9.029982363315688e-02*G0_1_1 - 9.029982363315686e-02*G0_1_2 - 1.326278659611991e-01*G0_2_0 - 9.029982363315689e-02*G0_2_1 - 9.029982363315688e-02*G0_2_2;
    block[398] = 1.693121693121698e-02*G0_0_0 + 1.693121693121696e-02*G0_0_1 - 4.232804232804229e-02*G0_0_2 - 4.232804232804225e-02*G0_1_0 - 4.232804232804230e-02*G0_1_1 - 1.128747795414464e-02*G0_1_2 - 4.232804232804226e-02*G0_2_0 - 4.232804232804230e-02*G0_2_1 - 1.128747795414465e-02*G0_2_2;
    block[399] = -2.821869488536260e-03*G0_0_0 - 2.821869488536246e-03*G0_0_1 - 1.340388007054671e-02*G0_0_2 - 1.340388007054677e-02*G0_1_0 - 1.340388007054676e-02*G0_1_1 - 2.821869488536185e-03*G0_1_2 - 1.340388007054677e-02*G0_2_0 - 1.340388007054677e-02*G0_2_1 - 2.821869488536165e-03*G0_2_2;
    block[400] = 2.821869488536189e-03*G0_0_2 + 2.821869488536195e-03*G0_1_0 + 2.821869488536181e-03*G0_1_1 - 1.128747795414454e-02*G0_1_2 + 2.821869488536181e-03*G0_2_0 + 2.821869488536165e-03*G0_2_1 - 1.128747795414456e-02*G0_2_2;
    block[401] = 1.693121693121685e-02*G0_0_0 + 5.925925925925911e-02*G0_0_2 + 5.925925925925908e-02*G0_1_0 + 9.029982363315681e-02*G0_1_2 + 5.925925925925908e-02*G0_2_0 + 9.029982363315683e-02*G0_2_2;
    block[402] = -2.821869488536200e-03*G0_0_0 + 1.058201058201051e-02*G0_0_2 + 1.058201058201065e-02*G0_1_0 + 2.116402116402115e-02*G0_1_2 + 1.058201058201064e-02*G0_2_0 + 2.116402116402114e-02*G0_2_2;
    block[403] = -2.821869488536223e-03*G0_0_2 - 2.821869488536185e-03*G0_1_0 - 1.693121693121694e-02*G0_1_2 - 2.821869488536173e-03*G0_2_0 - 1.693121693121693e-02*G0_2_2;
    block[404] = -2.821869488536223e-03*G0_1_1 - 2.821869488536171e-03*G0_1_2 - 2.821869488536180e-03*G0_2_1 - 2.821869488536144e-03*G0_2_2;
    block[405] = -9.171075837742492e-03*G0_1_1 - 9.171075837742588e-03*G0_1_2 - 9.171075837742498e-03*G0_2_1 - 9.171075837742584e-03*G0_2_2;
    block[406] = -2.821869488536174e-03*G0_1_1 - 2.821869488536122e-03*G0_1_2 - 2.821869488536161e-03*G0_2_1 - 2.821869488536121e-03*G0_2_2;
    block[407] = 2.257495590828884e-02*G0_0_0 + 4.232804232804185e-02*G0_0_1 + 4.232804232804178e-02*G0_0_2 + 4.232804232804222e-02*G0_1_0 + 8.465608465608442e-02*G0_1_1 + 8.465608465608421e-02*G0_1_2 + 4.232804232804215e-02*G0_2_0 + 8.465608465608437e-02*G0_2_1 + 8.465608465608417e-02*G0_2_2;
    block[408] = -2.821869488536230e-03*G0_0_1 - 2.821869488536257e-03*G0_0_2 - 2.821869488536160e-03*G0_1_0 + 1.693121693121699e-02*G0_1_1 + 1.693121693121699e-02*G0_1_2 - 2.821869488536129e-03*G0_2_0 + 1.693121693121702e-02*G0_2_1 + 1.693121693121700e-02*G0_2_2;
    block[409] = -2.821869488536228e-03*G0_0_1 - 2.821869488536170e-03*G0_0_2 - 2.821869488536354e-03*G0_1_0 + 1.693121693121684e-02*G0_1_1 + 1.693121693121682e-02*G0_1_2 - 2.821869488536309e-03*G0_2_0 + 1.693121693121680e-02*G0_2_1 + 1.693121693121682e-02*G0_2_2;
    block[410] = 2.821869488536148e-03*G0_0_1 + 2.821869488536179e-03*G0_0_2 + 2.821869488536300e-03*G0_1_0 + 2.257495590828936e-02*G0_1_1 + 2.257495590828935e-02*G0_1_2 + 2.821869488536253e-03*G0_2_0 + 2.257495590828930e-02*G0_2_1 + 2.257495590828932e-02*G0_2_2;
    block[411] = 2.821869488536281e-03*G0_0_1 + 2.821869488536236e-03*G0_0_2 + 2.821869488536157e-03*G0_1_0 + 2.257495590828926e-02*G0_1_1 + 2.257495590828924e-02*G0_1_2 + 2.821869488536126e-03*G0_2_0 + 2.257495590828928e-02*G0_2_1 + 2.257495590828927e-02*G0_2_2;
    block[412] = 2.257495590828908e-02*G0_0_0 - 1.975308641975311e-02*G0_0_1 - 1.975308641975312e-02*G0_0_2 - 1.975308641975326e-02*G0_1_0 + 2.257495590828909e-02*G0_1_1 + 2.257495590828907e-02*G0_1_2 - 1.975308641975324e-02*G0_2_0 + 2.257495590828913e-02*G0_2_1 + 2.257495590828902e-02*G0_2_2;
    block[413] = 5.643738977072465e-03*G0_0_0 + 2.821869488536261e-03*G0_0_1 + 2.821869488536225e-03*G0_0_2 + 2.821869488536158e-03*G0_1_0 - 1.693121693121693e-02*G0_1_1 + 6.772486772486766e-02*G0_1_2 + 2.821869488536176e-03*G0_2_0 - 1.693121693121694e-02*G0_2_1 + 6.772486772486769e-02*G0_2_2;
    block[414] = -1.693121693121688e-02*G0_0_0 - 4.232804232804195e-02*G0_0_1 - 1.777777777777774e-01*G0_0_2 - 1.777777777777775e-01*G0_1_0 - 8.465608465608457e-02*G0_1_1 - 2.708994708994705e-01*G0_1_2 - 1.777777777777775e-01*G0_2_0 - 8.465608465608454e-02*G0_2_1 - 2.708994708994705e-01*G0_2_2;
    block[415] = -1.693121693121695e-02*G0_0_0 + 2.539682539682524e-02*G0_0_1 + 1.608465608465604e-01*G0_0_2 + 1.608465608465607e-01*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 6.772486772486756e-02*G0_1_2 + 1.608465608465607e-01*G0_2_0 + 1.185185185185183e-01*G0_2_1 + 6.772486772486754e-02*G0_2_2;
    block[416] = -1.693121693121697e-02*G0_0_0 + 1.608465608465604e-01*G0_0_1 + 2.539682539682528e-02*G0_0_2 + 1.608465608465607e-01*G0_1_0 + 6.772486772486740e-02*G0_1_1 + 1.185185185185182e-01*G0_1_2 + 1.608465608465607e-01*G0_2_0 + 6.772486772486744e-02*G0_2_1 + 1.185185185185182e-01*G0_2_2;
    block[417] = -1.693121693121677e-02*G0_0_0 - 1.777777777777772e-01*G0_0_1 - 4.232804232804180e-02*G0_0_2 - 1.777777777777774e-01*G0_1_0 - 2.708994708994703e-01*G0_1_1 - 8.465608465608426e-02*G0_1_2 - 1.777777777777773e-01*G0_2_0 - 2.708994708994703e-01*G0_2_1 - 8.465608465608421e-02*G0_2_2;
    block[418] = 5.643738977072345e-03*G0_0_0 + 2.821869488536163e-03*G0_0_1 + 2.821869488536178e-03*G0_0_2 + 2.821869488536209e-03*G0_1_0 + 6.772486772486785e-02*G0_1_1 - 1.693121693121693e-02*G0_1_2 + 2.821869488536220e-03*G0_2_0 + 6.772486772486778e-02*G0_2_1 - 1.693121693121693e-02*G0_2_2;
    block[419] = -4.514991181657795e-02*G0_0_0 - 2.257495590828897e-02*G0_0_1 - 2.257495590828891e-02*G0_0_2 - 2.257495590828892e-02*G0_1_0 - 1.354497354497351e-01*G0_1_1 - 1.354497354497350e-01*G0_1_2 - 2.257495590828886e-02*G0_2_0 - 1.354497354497350e-01*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[420] = -2.539682539682536e-02*G0_0_0 - 2.539682539682536e-02*G0_0_1 - 2.539682539682536e-02*G0_0_2 - 7.760141093474382e-03*G0_1_0 - 7.760141093474390e-03*G0_1_1 - 7.760141093474364e-03*G0_1_2 - 7.760141093474385e-03*G0_2_0 - 7.760141093474392e-03*G0_2_1 - 7.760141093474367e-03*G0_2_2;
    block[421] = -7.054673721340378e-02*G0_0_0 - 4.585537918871243e-02*G0_1_0 - 4.585537918871243e-02*G0_2_0;
    block[422] = 7.760141093474485e-03*G0_1_1 + 7.760141093474478e-03*G0_2_1;
    block[423] = 7.760141093474414e-03*G0_1_2 + 7.760141093474416e-03*G0_2_2;
    block[424] = 2.257495590828924e-02*G0_0_0 - 7.901234567901222e-02*G0_0_1 - 7.901234567901211e-02*G0_1_0 - 1.580246913580245e-01*G0_1_1 - 7.901234567901208e-02*G0_2_0 - 1.580246913580244e-01*G0_2_1;
    block[425] = -1.128747795414457e-02*G0_0_0 + 3.104056437389772e-02*G0_0_1 + 3.104056437389758e-02*G0_1_0 + 9.029982363315704e-02*G0_1_1 + 3.104056437389758e-02*G0_2_0 + 9.029982363315703e-02*G0_2_1;
    block[426] = -1.128747795414466e-02*G0_0_1 - 1.128747795414457e-02*G0_1_0 - 4.514991181657858e-02*G0_1_1 - 1.128747795414457e-02*G0_2_0 - 4.514991181657858e-02*G0_2_1;
    block[427] = 1.128747795414461e-02*G0_0_1 + 1.128747795414451e-02*G0_1_0 + 1.128747795414454e-02*G0_1_2 + 1.128747795414452e-02*G0_2_0 + 1.128747795414455e-02*G0_2_2;
    block[428] = -1.128747795414465e-02*G0_0_0 + 2.821869488536083e-03*G0_0_1 - 1.128747795414465e-02*G0_0_2 + 2.821869488536187e-03*G0_1_0 + 2.821869488536168e-03*G0_1_2 + 2.821869488536185e-03*G0_2_0 + 2.821869488536163e-03*G0_2_2;
    block[429] = -2.257495590828916e-02*G0_0_0 + 1.128747795414469e-02*G0_0_1 - 2.257495590828915e-02*G0_0_2 + 1.128747795414468e-02*G0_1_0 + 1.128747795414472e-02*G0_1_2 + 1.128747795414466e-02*G0_2_0 + 1.128747795414469e-02*G0_2_2;
    block[430] = 1.128747795414460e-01*G0_0_0 + 7.901234567901218e-02*G0_0_1 + 7.901234567901216e-02*G0_0_2 + 3.386243386243373e-02*G0_1_0 + 4.514991181657849e-02*G0_1_1 + 4.514991181657853e-02*G0_1_2 + 3.386243386243374e-02*G0_2_0 + 4.514991181657847e-02*G0_2_1 + 4.514991181657851e-02*G0_2_2;
    block[431] = -2.201058201058196e-01*G0_0_0 - 1.326278659611991e-01*G0_0_1 - 1.326278659611991e-01*G0_0_2 - 5.925925925925912e-02*G0_1_0 - 9.029982363315686e-02*G0_1_1 - 9.029982363315690e-02*G0_1_2 - 5.925925925925914e-02*G0_2_0 - 9.029982363315685e-02*G0_2_1 - 9.029982363315689e-02*G0_2_2;
    block[432] = 2.031746031746028e-01*G0_0_0 + 7.901234567901222e-02*G0_0_1 + 7.901234567901223e-02*G0_0_2 + 7.901234567901222e-02*G0_1_0 + 1.580246913580245e-01*G0_1_1 + 1.580246913580245e-01*G0_1_2 + 7.901234567901223e-02*G0_2_0 + 1.580246913580245e-01*G0_2_1 + 1.580246913580245e-01*G0_2_2;
    block[433] = -2.257495590828920e-02*G0_0_0 - 2.257495590828919e-02*G0_0_1 + 1.128747795414464e-02*G0_0_2 + 1.128747795414469e-02*G0_1_0 + 1.128747795414471e-02*G0_1_1 + 1.128747795414467e-02*G0_2_0 + 1.128747795414468e-02*G0_2_1;
    block[434] = -1.128747795414455e-02*G0_0_0 - 1.128747795414456e-02*G0_0_1 + 2.821869488536148e-03*G0_0_2 + 2.821869488536047e-03*G0_1_0 + 2.821869488536051e-03*G0_1_1 + 2.821869488536043e-03*G0_2_0 + 2.821869488536048e-03*G0_2_1;
    block[435] = 1.128747795414458e-02*G0_0_2 + 1.128747795414463e-02*G0_1_0 + 1.128747795414464e-02*G0_1_1 + 1.128747795414464e-02*G0_2_0 + 1.128747795414464e-02*G0_2_1;
    block[436] = 2.257495590828923e-02*G0_0_0 - 7.901234567901221e-02*G0_0_2 - 7.901234567901222e-02*G0_1_0 - 1.580246913580244e-01*G0_1_2 - 7.901234567901221e-02*G0_2_0 - 1.580246913580244e-01*G0_2_2;
    block[437] = -1.128747795414463e-02*G0_0_0 + 3.104056437389764e-02*G0_0_2 + 3.104056437389758e-02*G0_1_0 + 9.029982363315678e-02*G0_1_2 + 3.104056437389758e-02*G0_2_0 + 9.029982363315679e-02*G0_2_2;
    block[438] = -1.128747795414454e-02*G0_0_2 - 1.128747795414464e-02*G0_1_0 - 4.514991181657841e-02*G0_1_2 - 1.128747795414464e-02*G0_2_0 - 4.514991181657842e-02*G0_2_2;
    block[439] = -1.128747795414470e-02*G0_1_1 - 1.128747795414458e-02*G0_1_2 - 1.128747795414469e-02*G0_2_1 - 1.128747795414459e-02*G0_2_2;
    block[440] = -2.821869488536074e-03*G0_1_1 - 2.821869488536185e-03*G0_1_2 - 2.821869488536083e-03*G0_2_1 - 2.821869488536176e-03*G0_2_2;
    block[441] = -1.128747795414465e-02*G0_1_1 - 1.128747795414461e-02*G0_1_2 - 1.128747795414465e-02*G0_2_1 - 1.128747795414463e-02*G0_2_2;
    block[442] = -4.514991181657835e-02*G0_0_0 - 1.128747795414450e-02*G0_0_1 - 1.128747795414441e-02*G0_0_2 - 1.128747795414447e-02*G0_1_0 - 1.128747795414458e-01*G0_1_1 - 1.128747795414457e-01*G0_1_2 - 1.128747795414447e-02*G0_2_0 - 1.128747795414458e-01*G0_2_1 - 1.128747795414457e-01*G0_2_2;
    block[443] = -1.128747795414462e-02*G0_0_1 - 1.128747795414466e-02*G0_0_2 - 1.128747795414457e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1 + 2.257495590828924e-02*G0_1_2 - 1.128747795414459e-02*G0_2_0 + 2.257495590828913e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[444] = -1.128747795414465e-02*G0_0_1 - 1.128747795414464e-02*G0_0_2 - 1.128747795414476e-02*G0_1_0 + 2.257495590828920e-02*G0_1_1 + 2.257495590828913e-02*G0_1_2 - 1.128747795414476e-02*G0_2_0 + 2.257495590828919e-02*G0_2_1 + 2.257495590828912e-02*G0_2_2;
    block[445] = 1.128747795414468e-02*G0_0_1 + 1.128747795414463e-02*G0_0_2 + 1.128747795414479e-02*G0_1_0 + 1.128747795414480e-02*G0_2_0;
    block[446] = 1.128747795414452e-02*G0_0_1 + 1.128747795414455e-02*G0_0_2 + 1.128747795414457e-02*G0_1_0 + 1.128747795414460e-02*G0_2_0;
    block[447] = -4.514991181657837e-02*G0_0_0 + 1.128747795414457e-02*G0_0_1 + 1.128747795414463e-02*G0_0_2 + 1.128747795414464e-02*G0_1_0 + 1.128747795414464e-02*G0_2_0;
    block[448] = 2.257495590828918e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 - 3.386243386243389e-02*G0_0_2 - 3.386243386243364e-02*G0_1_0 - 2.257495590828915e-02*G0_1_1 - 3.386243386243364e-02*G0_2_0 - 2.257495590828914e-02*G0_2_1;
    block[449] = -6.772486772486766e-02*G0_0_0 + 1.128747795414462e-02*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 1.015873015873016e-01*G0_1_0 + 1.128747795414462e-01*G0_1_1 + 1.015873015873015e-01*G0_2_0 + 1.128747795414462e-01*G0_2_1;
    block[450] = 6.772486772486763e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 - 3.386243386243382e-02*G0_0_2 - 3.386243386243400e-02*G0_1_0 - 2.257495590828946e-02*G0_1_1 - 3.386243386243395e-02*G0_2_0 - 2.257495590828946e-02*G0_2_1;
    block[451] = 6.772486772486760e-02*G0_0_0 - 3.386243386243382e-02*G0_0_1 + 1.128747795414463e-02*G0_0_2 - 3.386243386243392e-02*G0_1_0 - 2.257495590828927e-02*G0_1_2 - 3.386243386243386e-02*G0_2_0 - 2.257495590828924e-02*G0_2_2;
    block[452] = -6.772486772486765e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.128747795414444e-02*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 1.128747795414459e-01*G0_1_2 + 1.015873015873013e-01*G0_2_0 + 1.128747795414458e-01*G0_2_2;
    block[453] = 2.257495590828920e-02*G0_0_0 - 3.386243386243378e-02*G0_0_1 + 1.128747795414464e-02*G0_0_2 - 3.386243386243375e-02*G0_1_0 - 2.257495590828919e-02*G0_1_2 - 3.386243386243375e-02*G0_2_0 - 2.257495590828919e-02*G0_2_2;
    block[454] = 9.029982363315671e-02*G0_0_0;
    block[455] = -2.469135802469135e-02*G0_0_0 - 2.469135802469138e-02*G0_0_1 - 2.469135802469136e-02*G0_0_2 - 2.469135802469137e-02*G0_1_0 - 2.469135802469141e-02*G0_1_1 - 2.469135802469138e-02*G0_1_2 - 7.054673721340378e-02*G0_2_0 - 7.054673721340377e-02*G0_2_1 - 7.054673721340378e-02*G0_2_2;
    block[456] = 7.760141093474395e-03*G0_0_0 + 7.760141093474389e-03*G0_1_0;
    block[457] = 7.760141093474443e-03*G0_0_1 + 7.760141093474444e-03*G0_1_1;
    block[458] = -1.763668430335098e-02*G0_0_2 - 1.763668430335099e-02*G0_1_2 - 2.539682539682539e-02*G0_2_2;
    block[459] = -1.128747795414464e-02*G0_0_0 - 1.128747795414464e-02*G0_0_1 - 1.128747795414467e-02*G0_1_0 - 1.128747795414466e-02*G0_1_1;
    block[460] = -2.821869488536173e-03*G0_0_0 - 2.821869488536117e-03*G0_0_1 - 2.821869488536182e-03*G0_1_0 - 2.821869488536145e-03*G0_1_1;
    block[461] = -1.128747795414462e-02*G0_0_0 - 1.128747795414463e-02*G0_0_1 - 1.128747795414459e-02*G0_1_0 - 1.128747795414459e-02*G0_1_1;
    block[462] = 1.128747795414451e-02*G0_0_0 - 2.257495590828927e-02*G0_0_1 + 1.128747795414457e-02*G0_0_2 + 1.128747795414448e-02*G0_1_0 - 2.257495590828924e-02*G0_1_1 + 1.128747795414454e-02*G0_1_2 + 1.128747795414457e-02*G0_2_1;
    block[463] = -4.232804232804233e-02*G0_0_0 + 1.693121693121702e-02*G0_0_1 - 4.232804232804237e-02*G0_0_2 - 4.232804232804228e-02*G0_1_0 + 1.693121693121701e-02*G0_1_1 - 4.232804232804230e-02*G0_1_2 - 1.128747795414459e-02*G0_2_0 - 4.232804232804218e-02*G0_2_1 - 1.128747795414457e-02*G0_2_2;
    block[464] = 1.015873015873014e-01*G0_0_0 + 2.257495590828920e-02*G0_0_1 + 1.015873015873014e-01*G0_0_2 + 1.015873015873014e-01*G0_1_0 + 2.257495590828922e-02*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 2.257495590828923e-02*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[465] = 2.257495590828910e-02*G0_0_0 + 1.015873015873015e-01*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 2.257495590828914e-02*G0_1_0 + 1.015873015873014e-01*G0_1_1 + 1.015873015873014e-01*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 2.257495590828925e-02*G0_2_1 + 2.257495590828926e-02*G0_2_2;
    block[466] = 1.693121693121699e-02*G0_0_0 - 4.232804232804225e-02*G0_0_1 - 4.232804232804226e-02*G0_0_2 + 1.693121693121696e-02*G0_1_0 - 4.232804232804230e-02*G0_1_1 - 4.232804232804230e-02*G0_1_2 - 4.232804232804229e-02*G0_2_0 - 1.128747795414464e-02*G0_2_1 - 1.128747795414465e-02*G0_2_2;
    block[467] = -2.257495590828922e-02*G0_0_0 + 1.128747795414469e-02*G0_0_1 + 1.128747795414466e-02*G0_0_2 - 2.257495590828919e-02*G0_1_0 + 1.128747795414471e-02*G0_1_1 + 1.128747795414468e-02*G0_1_2 + 1.128747795414464e-02*G0_2_0;
    block[468] = 2.031746031746030e-01*G0_0_0 + 2.031746031746030e-01*G0_0_1 + 1.241622574955907e-01*G0_0_2 + 2.031746031746029e-01*G0_1_0 + 2.031746031746028e-01*G0_1_1 + 1.241622574955907e-01*G0_1_2 + 1.241622574955907e-01*G0_2_0 + 1.241622574955907e-01*G0_2_1 + 2.031746031746029e-01*G0_2_2;
    block[469] = -1.185185185185183e-01*G0_0_0 - 1.185185185185182e-01*G0_0_1 - 1.608465608465606e-01*G0_0_2 - 1.185185185185183e-01*G0_1_0 - 1.185185185185182e-01*G0_1_1 - 1.608465608465606e-01*G0_1_2 - 8.747795414462067e-02*G0_2_0 - 8.747795414462066e-02*G0_2_1 - 2.201058201058197e-01*G0_2_2;
    block[470] = 4.514991181657840e-02*G0_0_0 + 4.514991181657842e-02*G0_0_1 + 7.901234567901227e-02*G0_0_2 + 4.514991181657839e-02*G0_1_0 + 4.514991181657842e-02*G0_1_1 + 7.901234567901232e-02*G0_1_2 + 3.386243386243378e-02*G0_2_0 + 3.386243386243380e-02*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[471] = -2.257495590828922e-02*G0_0_0 - 1.128747795414466e-02*G0_0_2 - 2.257495590828925e-02*G0_1_0 - 1.128747795414468e-02*G0_1_2 - 1.128747795414460e-02*G0_2_0;
    block[472] = -1.693121693121682e-02*G0_0_0 - 1.410934744268070e-02*G0_0_2 - 1.693121693121682e-02*G0_1_0 - 1.410934744268070e-02*G0_1_2 - 1.410934744268068e-02*G0_2_0 - 1.128747795414451e-02*G0_2_2;
    block[473] = -4.514991181657837e-02*G0_0_0 - 3.386243386243377e-02*G0_0_2 - 4.514991181657837e-02*G0_1_0 - 3.386243386243378e-02*G0_1_2 - 3.386243386243378e-02*G0_2_0 - 2.257495590828919e-02*G0_2_2;
    block[474] = -2.257495590828923e-02*G0_0_1 - 1.128747795414460e-02*G0_0_2 - 2.257495590828921e-02*G0_1_1 - 1.128747795414457e-02*G0_1_2 - 1.128747795414460e-02*G0_2_1;
    block[475] = -1.693121693121699e-02*G0_0_1 - 1.410934744268088e-02*G0_0_2 - 1.693121693121699e-02*G0_1_1 - 1.410934744268088e-02*G0_1_2 - 1.410934744268087e-02*G0_2_1 - 1.128747795414472e-02*G0_2_2;
    block[476] = -4.514991181657835e-02*G0_0_1 - 3.386243386243377e-02*G0_0_2 - 4.514991181657835e-02*G0_1_1 - 3.386243386243377e-02*G0_1_2 - 3.386243386243377e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[477] = -2.257495590828909e-02*G0_0_0 - 2.257495590828903e-02*G0_0_1 - 1.128747795414455e-02*G0_0_2 - 2.257495590828913e-02*G0_1_0 - 2.257495590828908e-02*G0_1_1 - 1.128747795414463e-02*G0_1_2 - 1.128747795414418e-02*G0_2_0 - 1.128747795414433e-02*G0_2_1;
    block[478] = -6.772486772486766e-02*G0_0_0 - 6.772486772486752e-02*G0_0_1 - 5.643738977072309e-02*G0_0_2 - 6.772486772486767e-02*G0_1_0 - 6.772486772486755e-02*G0_1_1 - 5.643738977072309e-02*G0_1_2 - 5.643738977072303e-02*G0_2_0 - 5.643738977072286e-02*G0_2_1 - 4.514991181657827e-02*G0_2_2;
    block[479] = -2.257495590828937e-02*G0_0_0 - 2.257495590828940e-02*G0_0_1 - 1.128747795414456e-02*G0_0_2 - 2.257495590828934e-02*G0_1_0 - 2.257495590828940e-02*G0_1_1 - 1.128747795414454e-02*G0_1_2 - 1.128747795414473e-02*G0_2_0 - 1.128747795414459e-02*G0_2_1;
    block[480] = 2.257495590828938e-02*G0_0_0 + 9.029982363315707e-02*G0_0_1 + 5.643738977072326e-02*G0_0_2 + 2.257495590828935e-02*G0_1_0 + 9.029982363315699e-02*G0_1_1 + 5.643738977072323e-02*G0_1_2 + 1.128747795414473e-02*G0_2_0 + 5.643738977072302e-02*G0_2_1 + 2.257495590828930e-02*G0_2_2;
    block[481] = 6.772486772486770e-02*G0_0_0 + 1.354497354497353e-01*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 6.772486772486772e-02*G0_1_0 + 1.354497354497353e-01*G0_1_1 + 1.015873015873015e-01*G0_1_2 + 5.643738977072306e-02*G0_2_0 + 1.015873015873016e-01*G0_2_1 + 6.772486772486763e-02*G0_2_2;
    block[482] = -6.772486772486785e-02*G0_0_0 - 2.708994708994707e-01*G0_0_1 - 1.693121693121692e-01*G0_0_2 - 6.772486772486791e-02*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 1.693121693121691e-01*G0_1_2 - 7.901234567901216e-02*G0_2_0 - 1.693121693121691e-01*G0_2_1 - 6.772486772486767e-02*G0_2_2;
    block[483] = 1.354497354497351e-01*G0_0_0 + 6.772486772486745e-02*G0_0_1 + 1.015873015873013e-01*G0_0_2 + 1.354497354497350e-01*G0_1_0 + 6.772486772486745e-02*G0_1_1 + 1.015873015873013e-01*G0_1_2 + 1.015873015873013e-01*G0_2_0 + 5.643738977072281e-02*G0_2_1 + 6.772486772486773e-02*G0_2_2;
    block[484] = 9.029982363315696e-02*G0_0_0 + 2.257495590828920e-02*G0_0_1 + 5.643738977072298e-02*G0_0_2 + 9.029982363315699e-02*G0_1_0 + 2.257495590828927e-02*G0_1_1 + 5.643738977072303e-02*G0_1_2 + 5.643738977072305e-02*G0_2_0 + 1.128747795414442e-02*G0_2_1 + 2.257495590828909e-02*G0_2_2;
    block[485] = -2.708994708994706e-01*G0_0_0 - 6.772486772486781e-02*G0_0_1 - 1.693121693121692e-01*G0_0_2 - 2.708994708994706e-01*G0_1_0 - 6.772486772486791e-02*G0_1_1 - 1.693121693121691e-01*G0_1_2 - 1.693121693121692e-01*G0_2_0 - 7.901234567901227e-02*G0_2_1 - 6.772486772486777e-02*G0_2_2;
    block[486] = -1.354497354497353e-01*G0_0_0 - 1.354497354497354e-01*G0_0_1 - 3.386243386243404e-02*G0_0_2 - 1.354497354497352e-01*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 3.386243386243409e-02*G0_1_2 - 3.386243386243380e-02*G0_2_0 - 3.386243386243387e-02*G0_2_1 - 4.514991181657838e-02*G0_2_2;
    block[487] = 4.514991181657840e-02*G0_0_0 + 4.514991181657839e-02*G0_0_1 + 1.128747795414465e-02*G0_0_2 + 4.514991181657845e-02*G0_1_0 + 4.514991181657846e-02*G0_1_1 + 1.128747795414473e-02*G0_1_2 + 1.128747795414460e-02*G0_2_0 + 1.128747795414459e-02*G0_2_1;
    block[488] = 4.514991181657853e-02*G0_0_0 + 4.514991181657860e-02*G0_0_1 + 1.128747795414459e-02*G0_0_2 + 4.514991181657850e-02*G0_1_0 + 4.514991181657850e-02*G0_1_1 + 1.128747795414456e-02*G0_1_2 + 1.128747795414455e-02*G0_2_0 + 1.128747795414458e-02*G0_2_1;
    block[489] = 9.029982363315700e-02*G0_0_0 + 9.029982363315699e-02*G0_0_1 + 9.029982363315701e-02*G0_0_2 + 9.029982363315708e-02*G0_1_0 + 9.029982363315708e-02*G0_1_1 + 9.029982363315707e-02*G0_1_2 + 9.029982363315638e-02*G0_2_0 + 9.029982363315674e-02*G0_2_1 + 9.029982363315661e-02*G0_2_2;
    block[490] = 2.028218694885358e-02*G0_0_0 + 2.028218694885359e-02*G0_0_1 + 2.028218694885360e-02*G0_0_2 + 2.028218694885358e-02*G0_1_0 + 2.028218694885359e-02*G0_1_1 + 2.028218694885360e-02*G0_1_2 + 5.291005291005281e-02*G0_2_0 + 5.291005291005282e-02*G0_2_1 + 5.291005291005281e-02*G0_2_2;
    block[491] = 5.114638447971776e-03*G0_0_0 + 5.114638447971778e-03*G0_1_0;
    block[492] = 5.114638447971762e-03*G0_0_1 + 5.114638447971765e-03*G0_1_1;
    block[493] = 3.262786596119930e-02*G0_0_2 + 3.262786596119930e-02*G0_1_2 + 5.291005291005287e-02*G0_2_2;
    block[494] = -2.821869488535993e-03*G0_0_0 - 2.821869488536045e-03*G0_0_1 - 2.821869488535998e-03*G0_1_0 - 2.821869488536049e-03*G0_1_1;
    block[495] = -9.171075837742477e-03*G0_0_0 - 9.171075837742498e-03*G0_0_1 - 9.171075837742487e-03*G0_1_0 - 9.171075837742508e-03*G0_1_1;
    block[496] = -2.821869488536197e-03*G0_0_0 - 2.821869488536184e-03*G0_0_1 - 2.821869488536227e-03*G0_1_0 - 2.821869488536215e-03*G0_1_1;
    block[497] = 2.821869488536204e-03*G0_0_0 - 1.128747795414452e-02*G0_0_1 + 2.821869488536193e-03*G0_0_2 + 2.821869488536233e-03*G0_1_0 - 1.128747795414453e-02*G0_1_1 + 2.821869488536223e-03*G0_1_2 + 2.821869488536148e-03*G0_2_1;
    block[498] = -1.340388007054675e-02*G0_0_0 - 2.821869488536285e-03*G0_0_1 - 1.340388007054674e-02*G0_0_2 - 1.340388007054680e-02*G0_1_0 - 2.821869488536283e-03*G0_1_1 - 1.340388007054679e-02*G0_1_2 - 2.821869488536210e-03*G0_2_0 - 1.340388007054677e-02*G0_2_1 - 2.821869488536218e-03*G0_2_2;
    block[499] = -4.232804232804212e-02*G0_0_0 - 1.128747795414455e-02*G0_0_1 - 4.232804232804216e-02*G0_0_2 - 4.232804232804210e-02*G0_1_0 - 1.128747795414455e-02*G0_1_1 - 4.232804232804213e-02*G0_1_2 + 1.693121693121703e-02*G0_2_0 - 4.232804232804219e-02*G0_2_1 + 1.693121693121698e-02*G0_2_2;
    block[500] = -1.128747795414453e-02*G0_0_0 - 4.232804232804219e-02*G0_0_1 - 4.232804232804219e-02*G0_0_2 - 1.128747795414454e-02*G0_1_0 - 4.232804232804217e-02*G0_1_1 - 4.232804232804217e-02*G0_1_2 - 4.232804232804223e-02*G0_2_0 + 1.693121693121696e-02*G0_2_1 + 1.693121693121696e-02*G0_2_2;
    block[501] = -2.821869488536256e-03*G0_0_0 - 1.340388007054676e-02*G0_0_1 - 1.340388007054677e-02*G0_0_2 - 2.821869488536246e-03*G0_1_0 - 1.340388007054676e-02*G0_1_1 - 1.340388007054677e-02*G0_1_2 - 1.340388007054671e-02*G0_2_0 - 2.821869488536185e-03*G0_2_1 - 2.821869488536165e-03*G0_2_2;
    block[502] = -1.128747795414455e-02*G0_0_0 + 2.821869488536047e-03*G0_0_1 + 2.821869488536044e-03*G0_0_2 - 1.128747795414456e-02*G0_1_0 + 2.821869488536052e-03*G0_1_1 + 2.821869488536048e-03*G0_1_2 + 2.821869488536153e-03*G0_2_0;
    block[503] = -1.185185185185183e-01*G0_0_0 - 1.185185185185183e-01*G0_0_1 - 8.747795414462066e-02*G0_0_2 - 1.185185185185182e-01*G0_1_0 - 1.185185185185182e-01*G0_1_1 - 8.747795414462067e-02*G0_1_2 - 1.608465608465605e-01*G0_2_0 - 1.608465608465606e-01*G0_2_1 - 2.201058201058197e-01*G0_2_2;
    block[504] = 2.497354497354492e-01*G0_0_0 + 2.497354497354493e-01*G0_0_1 + 1.671957671957669e-01*G0_0_2 + 2.497354497354493e-01*G0_1_0 + 2.497354497354493e-01*G0_1_1 + 1.671957671957668e-01*G0_1_2 + 1.671957671957668e-01*G0_2_0 + 1.671957671957668e-01*G0_2_1 + 3.343915343915339e-01*G0_2_2;
    block[505] = -9.029982363315679e-02*G0_0_0 - 9.029982363315678e-02*G0_0_1 - 1.326278659611992e-01*G0_0_2 - 9.029982363315676e-02*G0_1_0 - 9.029982363315674e-02*G0_1_1 - 1.326278659611992e-01*G0_1_2 - 5.925925925925903e-02*G0_2_0 - 5.925925925925907e-02*G0_2_1 - 2.201058201058199e-01*G0_2_2;
    block[506] = -1.693121693121679e-02*G0_0_0 - 2.821869488536085e-03*G0_0_2 - 1.693121693121679e-02*G0_1_0 - 2.821869488536088e-03*G0_1_2 - 2.821869488536184e-03*G0_2_0;
    block[507] = 2.116402116402091e-02*G0_0_0 + 1.058201058201048e-02*G0_0_2 + 2.116402116402093e-02*G0_1_0 + 1.058201058201052e-02*G0_1_2 + 1.058201058201046e-02*G0_2_0 - 2.821869488536194e-03*G0_2_2;
    block[508] = 9.029982363315682e-02*G0_0_0 + 5.925925925925908e-02*G0_0_2 + 9.029982363315679e-02*G0_1_0 + 5.925925925925905e-02*G0_1_2 + 5.925925925925905e-02*G0_2_0 + 1.693121693121678e-02*G0_2_2;
    block[509] = -1.693121693121694e-02*G0_0_1 - 2.821869488536192e-03*G0_0_2 - 1.693121693121699e-02*G0_1_1 - 2.821869488536220e-03*G0_1_2 - 2.821869488536263e-03*G0_2_1;
    block[510] = 2.116402116402122e-02*G0_0_1 + 1.058201058201067e-02*G0_0_2 + 2.116402116402125e-02*G0_1_1 + 1.058201058201068e-02*G0_1_2 + 1.058201058201070e-02*G0_2_1 - 2.821869488535994e-03*G0_2_2;
    block[511] = 9.029982363315676e-02*G0_0_1 + 5.925925925925914e-02*G0_0_2 + 9.029982363315674e-02*G0_1_1 + 5.925925925925914e-02*G0_1_2 + 5.925925925925905e-02*G0_2_1 + 1.693121693121680e-02*G0_2_2;
    block[512] = 1.693121693121675e-02*G0_0_0 + 1.693121693121680e-02*G0_0_1 - 2.821869488536054e-03*G0_0_2 + 1.693121693121677e-02*G0_1_0 + 1.693121693121687e-02*G0_1_1 - 2.821869488536047e-03*G0_1_2 - 2.821869488536487e-03*G0_2_0 - 2.821869488536369e-03*G0_2_1;
    block[513] = 8.465608465608464e-02*G0_0_0 + 8.465608465608429e-02*G0_0_1 + 4.232804232804230e-02*G0_0_2 + 8.465608465608464e-02*G0_1_0 + 8.465608465608428e-02*G0_1_1 + 4.232804232804231e-02*G0_1_2 + 4.232804232804219e-02*G0_2_0 + 4.232804232804190e-02*G0_2_1 + 2.257495590828898e-02*G0_2_2;
    block[514] = 1.693121693121705e-02*G0_0_0 + 1.693121693121717e-02*G0_0_1 - 2.821869488536226e-03*G0_0_2 + 1.693121693121698e-02*G0_1_0 + 1.693121693121715e-02*G0_1_1 - 2.821869488536286e-03*G0_1_2 - 2.821869488536123e-03*G0_2_0 - 2.821869488536112e-03*G0_2_1;
    block[515] = -1.693121693121702e-02*G0_0_0 + 6.772486772486769e-02*G0_0_1 + 2.821869488536057e-03*G0_0_2 - 1.693121693121697e-02*G0_1_0 + 6.772486772486777e-02*G0_1_1 + 2.821869488536097e-03*G0_1_2 + 2.821869488536136e-03*G0_2_0 + 2.821869488536373e-03*G0_2_1 + 5.643738977072251e-03*G0_2_2;
    block[516] = -8.465608465608465e-02*G0_0_0 - 2.708994708994705e-01*G0_0_1 - 1.777777777777775e-01*G0_0_2 - 8.465608465608465e-02*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 1.777777777777775e-01*G0_1_2 - 4.232804232804221e-02*G0_2_0 - 1.777777777777776e-01*G0_2_1 - 1.693121693121681e-02*G0_2_2;
    block[517] = 1.185185185185183e-01*G0_0_0 + 6.772486772486742e-02*G0_0_1 + 1.608465608465604e-01*G0_0_2 + 1.185185185185183e-01*G0_1_0 + 6.772486772486735e-02*G0_1_1 + 1.608465608465604e-01*G0_1_2 + 2.539682539682518e-02*G0_2_0 + 1.608465608465604e-01*G0_2_1 - 1.693121693121709e-02*G0_2_2;
    block[518] = -2.708994708994701e-01*G0_0_0 - 8.465608465608422e-02*G0_0_1 - 1.777777777777773e-01*G0_0_2 - 2.708994708994703e-01*G0_1_0 - 8.465608465608421e-02*G0_1_1 - 1.777777777777773e-01*G0_1_2 - 1.777777777777773e-01*G0_2_0 - 4.232804232804188e-02*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[519] = 6.772486772486749e-02*G0_0_0 - 1.693121693121690e-02*G0_0_1 + 2.821869488536335e-03*G0_0_2 + 6.772486772486748e-02*G0_1_0 - 1.693121693121698e-02*G0_1_1 + 2.821869488536282e-03*G0_1_2 + 2.821869488536186e-03*G0_2_0 + 2.821869488536303e-03*G0_2_1 + 5.643738977072495e-03*G0_2_2;
    block[520] = 6.772486772486752e-02*G0_0_0 + 1.185185185185184e-01*G0_0_1 + 1.608465608465604e-01*G0_0_2 + 6.772486772486751e-02*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 1.608465608465605e-01*G0_1_2 + 1.608465608465604e-01*G0_2_0 + 2.539682539682531e-02*G0_2_1 - 1.693121693121694e-02*G0_2_2;
    block[521] = 2.257495590828909e-02*G0_0_0 + 2.257495590828914e-02*G0_0_1 - 1.975308641975294e-02*G0_0_2 + 2.257495590828908e-02*G0_1_0 + 2.257495590828908e-02*G0_1_1 - 1.975308641975296e-02*G0_1_2 - 1.975308641975321e-02*G0_2_0 - 1.975308641975315e-02*G0_2_1 + 2.257495590828910e-02*G0_2_2;
    block[522] = 2.257495590828907e-02*G0_0_0 + 2.257495590828922e-02*G0_0_1 + 2.821869488535991e-03*G0_0_2 + 2.257495590828908e-02*G0_1_0 + 2.257495590828923e-02*G0_1_1 + 2.821869488535983e-03*G0_1_2 + 2.821869488536182e-03*G0_2_0 + 2.821869488536118e-03*G0_2_1;
    block[523] = 2.257495590828925e-02*G0_0_0 + 2.257495590828925e-02*G0_0_1 + 2.821869488536204e-03*G0_0_2 + 2.257495590828930e-02*G0_1_0 + 2.257495590828932e-02*G0_1_1 + 2.821869488536266e-03*G0_1_2 + 2.821869488536209e-03*G0_2_0 + 2.821869488536337e-03*G0_2_1;
    block[524] = -1.354497354497352e-01*G0_0_0 - 1.354497354497355e-01*G0_0_1 - 2.257495590828933e-02*G0_0_2 - 1.354497354497352e-01*G0_1_0 - 1.354497354497355e-01*G0_1_1 - 2.257495590828934e-02*G0_1_2 - 2.257495590828876e-02*G0_2_0 - 2.257495590828911e-02*G0_2_1 - 4.514991181657806e-02*G0_2_2;
    block[525] = -7.760141093474393e-03*G0_0_0 - 7.760141093474412e-03*G0_0_1 - 7.760141093474405e-03*G0_0_2 - 7.760141093474391e-03*G0_1_0 - 7.760141093474415e-03*G0_1_1 - 7.760141093474405e-03*G0_1_2 - 2.539682539682534e-02*G0_2_0 - 2.539682539682536e-02*G0_2_1 - 2.539682539682537e-02*G0_2_2;
    block[526] = 7.760141093474440e-03*G0_0_0 + 7.760141093474423e-03*G0_1_0;
    block[527] = 7.760141093474459e-03*G0_0_1 + 7.760141093474462e-03*G0_1_1;
    block[528] = -4.585537918871250e-02*G0_0_2 - 4.585537918871250e-02*G0_1_2 - 7.054673721340386e-02*G0_2_2;
    block[529] = -1.128747795414464e-02*G0_0_0 - 1.128747795414464e-02*G0_0_1 - 1.128747795414462e-02*G0_1_0 - 1.128747795414465e-02*G0_1_1;
    block[530] = -2.821869488536158e-03*G0_0_0 - 2.821869488536087e-03*G0_0_1 - 2.821869488536207e-03*G0_1_0 - 2.821869488536118e-03*G0_1_1;
    block[531] = -1.128747795414465e-02*G0_0_0 - 1.128747795414477e-02*G0_0_1 - 1.128747795414460e-02*G0_1_0 - 1.128747795414473e-02*G0_1_1;
    block[532] = 1.128747795414464e-02*G0_0_0 + 1.128747795414464e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 + 1.128747795414460e-02*G0_1_2 + 1.128747795414461e-02*G0_2_1;
    block[533] = 2.821869488536118e-03*G0_0_0 + 2.821869488536111e-03*G0_0_2 + 2.821869488536110e-03*G0_1_0 + 2.821869488536103e-03*G0_1_2 - 1.128747795414465e-02*G0_2_0 + 2.821869488536100e-03*G0_2_1 - 1.128747795414465e-02*G0_2_2;
    block[534] = 1.128747795414463e-02*G0_0_0 + 1.128747795414463e-02*G0_0_2 + 1.128747795414463e-02*G0_1_0 + 1.128747795414463e-02*G0_1_2 - 2.257495590828916e-02*G0_2_0 + 1.128747795414464e-02*G0_2_1 - 2.257495590828911e-02*G0_2_2;
    block[535] = 1.128747795414459e-02*G0_0_1 + 1.128747795414461e-02*G0_0_2 + 1.128747795414462e-02*G0_1_1 + 1.128747795414463e-02*G0_1_2 + 1.128747795414457e-02*G0_2_0 - 2.257495590828918e-02*G0_2_1 - 2.257495590828919e-02*G0_2_2;
    block[536] = 2.821869488536194e-03*G0_0_1 + 2.821869488536179e-03*G0_0_2 + 2.821869488536181e-03*G0_1_1 + 2.821869488536166e-03*G0_1_2 + 2.821869488536189e-03*G0_2_0 - 1.128747795414454e-02*G0_2_1 - 1.128747795414456e-02*G0_2_2;
    block[537] = 1.128747795414463e-02*G0_0_1 + 1.128747795414463e-02*G0_0_2 + 1.128747795414464e-02*G0_1_1 + 1.128747795414464e-02*G0_1_2 + 1.128747795414457e-02*G0_2_0;
    block[538] = 4.514991181657839e-02*G0_0_0 + 4.514991181657840e-02*G0_0_1 + 3.386243386243378e-02*G0_0_2 + 4.514991181657842e-02*G0_1_0 + 4.514991181657842e-02*G0_1_1 + 3.386243386243380e-02*G0_1_2 + 7.901234567901227e-02*G0_2_0 + 7.901234567901233e-02*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[539] = -9.029982363315679e-02*G0_0_0 - 9.029982363315676e-02*G0_0_1 - 5.925925925925904e-02*G0_0_2 - 9.029982363315676e-02*G0_1_0 - 9.029982363315674e-02*G0_1_1 - 5.925925925925907e-02*G0_1_2 - 1.326278659611992e-01*G0_2_0 - 1.326278659611992e-01*G0_2_1 - 2.201058201058199e-01*G0_2_2;
    block[540] = 1.580246913580247e-01*G0_0_0 + 1.580246913580246e-01*G0_0_1 + 7.901234567901219e-02*G0_0_2 + 1.580246913580246e-01*G0_1_0 + 1.580246913580245e-01*G0_1_1 + 7.901234567901219e-02*G0_1_2 + 7.901234567901219e-02*G0_2_0 + 7.901234567901221e-02*G0_2_1 + 2.031746031746028e-01*G0_2_2;
    block[541] = -4.514991181657841e-02*G0_0_0 - 1.128747795414457e-02*G0_0_2 - 4.514991181657839e-02*G0_1_0 - 1.128747795414458e-02*G0_1_2 - 1.128747795414456e-02*G0_2_0;
    block[542] = 9.029982363315688e-02*G0_0_0 + 3.104056437389771e-02*G0_0_2 + 9.029982363315686e-02*G0_1_0 + 3.104056437389769e-02*G0_1_2 + 3.104056437389770e-02*G0_2_0 - 1.128747795414467e-02*G0_2_2;
    block[543] = -1.580246913580246e-01*G0_0_0 - 7.901234567901237e-02*G0_0_2 - 1.580246913580245e-01*G0_1_0 - 7.901234567901232e-02*G0_1_2 - 7.901234567901221e-02*G0_2_0 + 2.257495590828931e-02*G0_2_2;
    block[544] = -4.514991181657869e-02*G0_0_1 - 1.128747795414466e-02*G0_0_2 - 4.514991181657858e-02*G0_1_1 - 1.128747795414461e-02*G0_1_2 - 1.128747795414462e-02*G0_2_1;
    block[545] = 9.029982363315700e-02*G0_0_1 + 3.104056437389758e-02*G0_0_2 + 9.029982363315697e-02*G0_1_1 + 3.104056437389763e-02*G0_1_2 + 3.104056437389759e-02*G0_2_1 - 1.128747795414486e-02*G0_2_2;
    block[546] = -1.580246913580246e-01*G0_0_1 - 7.901234567901233e-02*G0_0_2 - 1.580246913580245e-01*G0_1_1 - 7.901234567901232e-02*G0_1_2 - 7.901234567901219e-02*G0_2_1 + 2.257495590828928e-02*G0_2_2;
    block[547] = 2.257495590828948e-02*G0_0_0 + 2.257495590828949e-02*G0_0_1 - 1.128747795414445e-02*G0_0_2 + 2.257495590828935e-02*G0_1_0 + 2.257495590828942e-02*G0_1_1 - 1.128747795414453e-02*G0_1_2 - 1.128747795414448e-02*G0_2_0 - 1.128747795414447e-02*G0_2_1;
    block[548] = -1.128747795414463e-01*G0_0_0 - 1.128747795414463e-01*G0_0_1 - 1.128747795414457e-02*G0_0_2 - 1.128747795414462e-01*G0_1_0 - 1.128747795414462e-01*G0_1_1 - 1.128747795414456e-02*G0_1_2 - 1.128747795414464e-02*G0_2_0 - 1.128747795414443e-02*G0_2_1 - 4.514991181657838e-02*G0_2_2;
    block[549] = 2.257495590828889e-02*G0_0_0 + 2.257495590828918e-02*G0_0_1 - 1.128747795414474e-02*G0_0_2 + 2.257495590828909e-02*G0_1_0 + 2.257495590828922e-02*G0_1_1 - 1.128747795414465e-02*G0_1_2 - 1.128747795414478e-02*G0_2_0 - 1.128747795414480e-02*G0_2_1;
    block[550] = -2.257495590828888e-02*G0_0_0 - 3.386243386243364e-02*G0_0_2 - 2.257495590828907e-02*G0_1_0 - 3.386243386243368e-02*G0_1_2 + 1.128747795414478e-02*G0_2_0 - 3.386243386243382e-02*G0_2_1 + 2.257495590828944e-02*G0_2_2;
    block[551] = 1.128747795414463e-01*G0_0_0 + 1.015873015873016e-01*G0_0_2 + 1.128747795414462e-01*G0_1_0 + 1.015873015873016e-01*G0_1_2 + 1.128747795414463e-02*G0_2_0 + 1.015873015873016e-01*G0_2_1 - 6.772486772486758e-02*G0_2_2;
    block[552] = -2.257495590828944e-02*G0_0_0 - 3.386243386243385e-02*G0_0_2 - 2.257495590828946e-02*G0_1_0 - 3.386243386243387e-02*G0_1_2 + 1.128747795414455e-02*G0_2_0 - 3.386243386243389e-02*G0_2_1 + 6.772486772486747e-02*G0_2_2;
    block[553] = 1.128747795414463e-01*G0_0_1 + 1.015873015873017e-01*G0_0_2 + 1.128747795414462e-01*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 1.128747795414446e-02*G0_2_1 - 6.772486772486748e-02*G0_2_2;
    block[554] = -2.257495590828940e-02*G0_0_1 - 3.386243386243395e-02*G0_0_2 - 2.257495590828933e-02*G0_1_1 - 3.386243386243393e-02*G0_1_2 - 3.386243386243390e-02*G0_2_0 + 1.128747795414451e-02*G0_2_1 + 2.257495590828907e-02*G0_2_2;
    block[555] = -2.257495590828940e-02*G0_0_1 - 3.386243386243391e-02*G0_0_2 - 2.257495590828937e-02*G0_1_1 - 3.386243386243391e-02*G0_1_2 - 3.386243386243378e-02*G0_2_0 + 1.128747795414458e-02*G0_2_1 + 6.772486772486745e-02*G0_2_2;
    block[556] = 1.128747795414450e-02*G0_0_2 + 1.128747795414448e-02*G0_1_2 + 1.128747795414459e-02*G0_2_0 + 1.128747795414459e-02*G0_2_1 - 4.514991181657833e-02*G0_2_2;
    block[557] = 1.128747795414455e-02*G0_0_2 + 1.128747795414464e-02*G0_1_2 + 1.128747795414449e-02*G0_2_0 + 1.128747795414463e-02*G0_2_1;
    block[558] = 1.128747795414474e-02*G0_0_2 + 1.128747795414464e-02*G0_1_2 + 1.128747795414472e-02*G0_2_0 + 1.128747795414452e-02*G0_2_1;
    block[559] = 9.029982363315672e-02*G0_2_2;
    block[560] = 7.760141093474378e-03*G0_0_0 + 7.760141093474390e-03*G0_0_1 + 7.760141093474372e-03*G0_0_2 + 7.760141093474381e-03*G0_2_0 + 7.760141093474390e-03*G0_2_1 + 7.760141093474363e-03*G0_2_2;
    block[561] = -2.469135802469137e-02*G0_0_0 + 4.585537918871241e-02*G0_2_0;
    block[562] = -7.760141093474489e-03*G0_0_1 - 7.760141093474464e-03*G0_2_1;
    block[563] = 1.763668430335092e-02*G0_0_2 - 7.760141093474423e-03*G0_2_2;
    block[564] = 1.015873015873014e-01*G0_0_0 + 7.901234567901214e-02*G0_0_1 + 7.901234567901205e-02*G0_2_0 + 1.580246913580244e-01*G0_2_1;
    block[565] = -4.232804232804212e-02*G0_0_0 - 5.925925925925925e-02*G0_0_1 - 3.104056437389760e-02*G0_2_0 - 9.029982363315699e-02*G0_2_1;
    block[566] = 1.128747795414454e-02*G0_0_0 + 3.386243386243395e-02*G0_0_1 + 1.128747795414461e-02*G0_2_0 + 4.514991181657858e-02*G0_2_1;
    block[567] = -1.128747795414446e-02*G0_0_0 - 1.128747795414451e-02*G0_0_2 - 1.128747795414456e-02*G0_2_0 - 1.128747795414459e-02*G0_2_2;
    block[568] = -2.821869488536194e-03*G0_0_0 - 2.821869488536177e-03*G0_0_2 - 2.821869488536139e-03*G0_2_0 - 2.821869488536120e-03*G0_2_2;
    block[569] = -1.128747795414467e-02*G0_0_0 - 1.128747795414465e-02*G0_0_2 - 1.128747795414469e-02*G0_2_0 - 1.128747795414472e-02*G0_2_2;
    block[570] = -2.257495590828909e-02*G0_0_0 - 3.386243386243380e-02*G0_0_1 - 3.386243386243382e-02*G0_0_2 - 3.386243386243371e-02*G0_2_0 - 4.514991181657846e-02*G0_2_1 - 4.514991181657850e-02*G0_2_2;
    block[571] = 1.693121693121685e-02*G0_0_0 + 5.925925925925907e-02*G0_0_1 + 5.925925925925908e-02*G0_0_2 + 5.925925925925911e-02*G0_2_0 + 9.029982363315679e-02*G0_2_1 + 9.029982363315685e-02*G0_2_2;
    block[572] = 2.257495590828923e-02*G0_0_0 - 7.901234567901222e-02*G0_0_1 - 7.901234567901221e-02*G0_0_2 - 7.901234567901221e-02*G0_2_0 - 1.580246913580244e-01*G0_2_1 - 1.580246913580244e-01*G0_2_2;
    block[573] = -2.257495590828924e-02*G0_0_0 - 2.257495590828925e-02*G0_0_1 - 1.128747795414460e-02*G0_0_2 - 1.128747795414466e-02*G0_2_0 - 1.128747795414468e-02*G0_2_1;
    block[574] = -1.693121693121680e-02*G0_0_0 - 1.693121693121678e-02*G0_0_1 - 2.821869488536183e-03*G0_0_2 - 2.821869488536085e-03*G0_2_0 - 2.821869488536088e-03*G0_2_1;
    block[575] = -4.514991181657841e-02*G0_0_0 - 4.514991181657839e-02*G0_0_1 - 1.128747795414457e-02*G0_0_2 - 1.128747795414457e-02*G0_2_0 - 1.128747795414458e-02*G0_2_1;
    block[576] = 2.031746031746027e-01*G0_0_0 + 7.901234567901215e-02*G0_0_2 + 7.901234567901215e-02*G0_2_0 + 1.580246913580243e-01*G0_2_2;
    block[577] = -1.185185185185183e-01*G0_0_0 + 4.232804232804218e-02*G0_0_2 - 3.104056437389755e-02*G0_2_0 - 9.029982363315670e-02*G0_2_2;
    block[578] = 4.514991181657842e-02*G0_0_0 - 3.386243386243372e-02*G0_0_2 + 1.128747795414458e-02*G0_2_0 + 4.514991181657833e-02*G0_2_2;
    block[579] = 2.257495590828928e-02*G0_0_1 + 1.128747795414454e-02*G0_0_2 + 1.128747795414471e-02*G0_2_1 + 1.128747795414463e-02*G0_2_2;
    block[580] = 1.693121693121693e-02*G0_0_1 + 1.410934744268085e-02*G0_0_2 + 2.821869488536126e-03*G0_2_1 + 2.821869488536180e-03*G0_2_2;
    block[581] = 4.514991181657842e-02*G0_0_1 + 3.386243386243389e-02*G0_0_2 + 1.128747795414459e-02*G0_2_1 + 1.128747795414461e-02*G0_2_2;
    block[582] = -6.772486772486785e-02*G0_0_0 + 2.031746031746024e-01*G0_0_1 + 1.015873015873012e-01*G0_0_2 + 1.128747795414446e-02*G0_2_0 + 1.128747795414457e-01*G0_2_1 + 1.128747795414456e-01*G0_2_2;
    block[583] = 6.772486772486760e-02*G0_0_0 - 6.772486772486760e-02*G0_0_1 - 3.386243386243407e-02*G0_0_2 + 1.128747795414458e-02*G0_2_0 - 2.257495590828915e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[584] = 2.257495590828937e-02*G0_0_0 - 6.772486772486769e-02*G0_0_1 - 3.386243386243367e-02*G0_0_2 + 1.128747795414483e-02*G0_2_0 - 2.257495590828915e-02*G0_2_1 - 2.257495590828906e-02*G0_2_2;
    block[585] = -2.257495590828945e-02*G0_0_0 - 1.128747795414474e-02*G0_0_2 - 1.128747795414487e-02*G0_2_0;
    block[586] = -6.772486772486763e-02*G0_0_0 - 1.128747795414474e-02*G0_0_2 - 1.128747795414458e-02*G0_2_0;
    block[587] = -2.257495590828898e-02*G0_0_0 - 1.128747795414452e-02*G0_0_2 - 1.128747795414460e-02*G0_2_0;
    block[588] = 1.354497354497351e-01*G0_0_0 + 6.772486772486762e-02*G0_0_1 + 3.386243386243357e-02*G0_0_2 + 3.386243386243365e-02*G0_2_0 + 2.257495590828916e-02*G0_2_1;
    block[589] = -2.708994708994703e-01*G0_0_0 - 2.031746031746026e-01*G0_0_1 - 1.015873015873013e-01*G0_0_2 - 1.015873015873015e-01*G0_2_0 - 1.128747795414461e-01*G0_2_1;
    block[590] = 9.029982363315679e-02*G0_0_0 + 6.772486772486770e-02*G0_0_1 + 3.386243386243398e-02*G0_0_2 + 3.386243386243393e-02*G0_2_0 + 2.257495590828941e-02*G0_2_1;
    block[591] = 4.514991181657842e-02*G0_0_0 + 3.386243386243384e-02*G0_0_2 + 3.386243386243386e-02*G0_2_0 + 2.257495590828926e-02*G0_2_2;
    block[592] = -1.354497354497350e-01*G0_0_0 - 1.015873015873012e-01*G0_0_2 - 1.015873015873012e-01*G0_2_0 - 1.128747795414457e-01*G0_2_2;
    block[593] = 4.514991181657834e-02*G0_0_0 + 3.386243386243372e-02*G0_0_2 + 3.386243386243373e-02*G0_2_0 + 2.257495590828914e-02*G0_2_2;
    block[594] = 9.029982363315683e-02*G0_0_0;
    block[595] = 5.114638447971767e-03*G0_0_0 + 5.114638447971744e-03*G0_0_1 + 5.114638447971761e-03*G0_0_2 + 5.114638447971761e-03*G0_2_0 + 5.114638447971748e-03*G0_2_1 + 5.114638447971776e-03*G0_2_2;
    block[596] = 2.028218694885365e-02*G0_0_0 - 3.262786596119922e-02*G0_2_0;
    block[597] = -5.114638447971729e-03*G0_0_1 - 5.114638447971749e-03*G0_2_1;
    block[598] = -3.262786596119926e-02*G0_0_2 + 2.028218694885359e-02*G0_2_2;
    block[599] = -4.232804232804219e-02*G0_0_0 - 3.104056437389762e-02*G0_0_1 - 5.925925925925905e-02*G0_2_0 - 9.029982363315681e-02*G0_2_1;
    block[600] = -1.340388007054683e-02*G0_0_0 - 1.058201058201055e-02*G0_0_1 - 1.058201058201060e-02*G0_2_0 - 2.116402116402098e-02*G0_2_1;
    block[601] = 2.821869488536251e-03*G0_0_0 + 1.410934744268071e-02*G0_0_1 + 2.821869488536143e-03*G0_2_0 + 1.693121693121677e-02*G0_2_1;
    block[602] = -2.821869488536248e-03*G0_0_0 - 2.821869488536225e-03*G0_0_2 - 2.821869488536135e-03*G0_2_0 - 2.821869488536119e-03*G0_2_2;
    block[603] = -9.171075837742470e-03*G0_0_0 - 9.171075837742466e-03*G0_0_2 - 9.171075837742531e-03*G0_2_0 - 9.171075837742536e-03*G0_2_2;
    block[604] = -2.821869488536050e-03*G0_0_0 - 2.821869488536063e-03*G0_0_2 - 2.821869488536146e-03*G0_2_0 - 2.821869488536096e-03*G0_2_2;
    block[605] = -1.128747795414455e-02*G0_0_0 - 1.410934744268068e-02*G0_0_1 - 1.410934744268066e-02*G0_0_2 - 1.410934744268065e-02*G0_2_0 - 1.693121693121678e-02*G0_2_1 - 1.693121693121673e-02*G0_2_2;
    block[606] = -2.821869488536200e-03*G0_0_0 + 1.058201058201064e-02*G0_0_1 + 1.058201058201064e-02*G0_0_2 + 1.058201058201051e-02*G0_2_0 + 2.116402116402116e-02*G0_2_1 + 2.116402116402114e-02*G0_2_2;
    block[607] = -1.128747795414463e-02*G0_0_0 + 3.104056437389758e-02*G0_0_1 + 3.104056437389758e-02*G0_0_2 + 3.104056437389765e-02*G0_2_0 + 9.029982363315679e-02*G0_2_1 + 9.029982363315681e-02*G0_2_2;
    block[608] = -1.693121693121682e-02*G0_0_0 - 1.693121693121682e-02*G0_0_1 - 1.410934744268068e-02*G0_0_2 - 1.410934744268069e-02*G0_2_0 - 1.410934744268070e-02*G0_2_1 - 1.128747795414451e-02*G0_2_2;
    block[609] = 2.116402116402091e-02*G0_0_0 + 2.116402116402093e-02*G0_0_1 + 1.058201058201047e-02*G0_0_2 + 1.058201058201048e-02*G0_2_0 + 1.058201058201053e-02*G0_2_1 - 2.821869488536193e-03*G0_2_2;
    block[610] = 9.029982363315688e-02*G0_0_0 + 9.029982363315688e-02*G0_0_1 + 3.104056437389771e-02*G0_0_2 + 3.104056437389770e-02*G0_2_0 + 3.104056437389769e-02*G0_2_1 - 1.128747795414467e-02*G0_2_2;
    block[611] = -1.185185185185183e-01*G0_0_0 - 3.104056437389754e-02*G0_0_2 + 4.232804232804218e-02*G0_2_0 - 9.029982363315670e-02*G0_2_2;
    block[612] = 2.497354497354492e-01*G0_0_0 + 8.253968253968233e-02*G0_0_2 + 8.253968253968234e-02*G0_2_0 + 2.497354497354492e-01*G0_2_2;
    block[613] = -9.029982363315683e-02*G0_0_0 + 4.232804232804224e-02*G0_0_2 - 3.104056437389765e-02*G0_2_0 - 1.185185185185183e-01*G0_2_2;
    block[614] = 1.693121693121684e-02*G0_0_1 + 2.821869488536248e-03*G0_0_2 + 1.410934744268064e-02*G0_2_1 + 2.821869488536122e-03*G0_2_2;
    block[615] = -2.116402116402109e-02*G0_0_1 - 1.058201058201070e-02*G0_0_2 - 1.058201058201046e-02*G0_2_1 - 1.340388007054674e-02*G0_2_2;
    block[616] = -9.029982363315681e-02*G0_0_1 - 5.925925925925915e-02*G0_0_2 - 3.104056437389763e-02*G0_2_1 - 4.232804232804223e-02*G0_2_2;
    block[617] = 1.185185185185186e-01*G0_0_0 + 5.079365079365096e-02*G0_0_1 - 4.232804232804213e-02*G0_0_2 + 9.312169312169308e-02*G0_2_0 + 1.862433862433860e-01*G0_2_1 - 8.465608465608425e-02*G0_2_2;
    block[618] = -8.465608465608429e-02*G0_0_0 + 1.862433862433862e-01*G0_0_1 + 9.312169312169342e-02*G0_0_2 - 4.232804232804205e-02*G0_2_0 + 5.079365079365088e-02*G0_2_1 + 1.185185185185185e-01*G0_2_2;
    block[619] = -1.693121693121697e-02*G0_0_0 - 8.465608465608446e-02*G0_0_1 - 1.975308641975309e-02*G0_0_2 - 1.975308641975322e-02*G0_2_0 - 8.465608465608453e-02*G0_2_1 - 1.693121693121699e-02*G0_2_2;
    block[620] = 1.693121693121701e-02*G0_0_0 + 1.975308641975314e-02*G0_0_2 + 1.975308641975322e-02*G0_2_0 + 2.257495590828925e-02*G0_2_2;
    block[621] = 8.465608465608435e-02*G0_0_0 + 4.232804232804241e-02*G0_0_2 + 4.232804232804205e-02*G0_2_0 + 2.257495590828917e-02*G0_2_2;
    block[622] = 1.693121693121669e-02*G0_0_0 + 1.975308641975282e-02*G0_0_2 + 1.975308641975302e-02*G0_2_0 + 2.257495590828927e-02*G0_2_2;
    block[623] = -2.708994708994702e-01*G0_0_0 - 1.862433862433861e-01*G0_0_1 - 9.312169312169256e-02*G0_0_2 - 9.312169312169286e-02*G0_2_0 - 5.079365079365081e-02*G0_2_1 + 6.772486772486788e-02*G0_2_2;
    block[624] = 6.772486772486773e-02*G0_0_0 - 5.079365079365085e-02*G0_0_1 - 9.312169312169299e-02*G0_0_2 - 9.312169312169259e-02*G0_2_0 - 1.862433862433858e-01*G0_2_1 - 2.708994708994703e-01*G0_2_2;
    block[625] = 6.772486772486740e-02*G0_0_0 + 8.465608465608430e-02*G0_0_1 + 6.490299823633100e-02*G0_0_2 + 6.490299823633112e-02*G0_2_0 + 8.465608465608415e-02*G0_2_1 + 6.772486772486708e-02*G0_2_2;
    block[626] = 2.257495590828913e-02*G0_0_0 + 1.975308641975315e-02*G0_0_2 + 1.975308641975311e-02*G0_2_0 + 1.693121693121689e-02*G0_2_2;
    block[627] = 2.257495590828908e-02*G0_0_0 + 4.232804232804215e-02*G0_0_2 + 4.232804232804210e-02*G0_2_0 + 8.465608465608435e-02*G0_2_2;
    block[628] = 2.257495590828927e-02*G0_0_0 + 1.975308641975307e-02*G0_0_2 + 1.975308641975313e-02*G0_2_0 + 1.693121693121697e-02*G0_2_2;
    block[629] = -1.354497354497353e-01*G0_0_0 - 1.128747795414465e-01*G0_0_2 - 1.128747795414462e-01*G0_2_0 - 1.354497354497356e-01*G0_2_2;
    block[630] = 7.760141093474385e-03*G0_0_0 + 7.760141093474406e-03*G0_0_1 + 7.760141093474397e-03*G0_0_2 + 7.760141093474385e-03*G0_2_0 + 7.760141093474397e-03*G0_2_1 + 7.760141093474375e-03*G0_2_2;
    block[631] = -7.760141093474426e-03*G0_0_0 + 1.763668430335093e-02*G0_2_0;
    block[632] = -7.760141093474466e-03*G0_0_1 - 7.760141093474442e-03*G0_2_1;
    block[633] = 4.585537918871250e-02*G0_0_2 - 2.469135802469131e-02*G0_2_2;
    block[634] = 1.128747795414462e-02*G0_0_0 + 1.128747795414465e-02*G0_0_1 + 3.386243386243380e-02*G0_2_0 + 4.514991181657842e-02*G0_2_1;
    block[635] = 2.821869488536189e-03*G0_0_0 + 2.821869488536092e-03*G0_0_1 + 1.410934744268074e-02*G0_2_0 + 1.693121693121678e-02*G0_2_1;
    block[636] = 1.128747795414459e-02*G0_0_0 + 1.128747795414473e-02*G0_0_1 + 1.128747795414468e-02*G0_2_0 + 2.257495590828939e-02*G0_2_1;
    block[637] = -1.128747795414459e-02*G0_0_0 - 1.128747795414458e-02*G0_0_2 - 1.128747795414467e-02*G0_2_0 - 1.128747795414466e-02*G0_2_2;
    block[638] = -2.821869488536164e-03*G0_0_0 - 2.821869488536156e-03*G0_0_2 - 2.821869488536120e-03*G0_2_0 - 2.821869488536112e-03*G0_2_2;
    block[639] = -1.128747795414458e-02*G0_0_0 - 1.128747795414458e-02*G0_0_2 - 1.128747795414456e-02*G0_2_0 - 1.128747795414459e-02*G0_2_2;
    block[640] = -1.128747795414460e-02*G0_0_1 - 1.128747795414461e-02*G0_0_2 - 1.128747795414455e-02*G0_2_0 - 2.257495590828920e-02*G0_2_1 - 2.257495590828923e-02*G0_2_2;
    block[641] = -2.821869488536184e-03*G0_0_1 - 2.821869488536171e-03*G0_0_2 - 2.821869488536219e-03*G0_2_0 - 1.693121693121693e-02*G0_2_1 - 1.693121693121691e-02*G0_2_2;
    block[642] = -1.128747795414464e-02*G0_0_1 - 1.128747795414464e-02*G0_0_2 - 1.128747795414454e-02*G0_2_0 - 4.514991181657841e-02*G0_2_1 - 4.514991181657843e-02*G0_2_2;
    block[643] = -4.514991181657837e-02*G0_0_0 - 4.514991181657837e-02*G0_0_1 - 3.386243386243378e-02*G0_0_2 - 3.386243386243377e-02*G0_2_0 - 3.386243386243378e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[644] = 9.029982363315682e-02*G0_0_0 + 9.029982363315679e-02*G0_0_1 + 5.925925925925905e-02*G0_0_2 + 5.925925925925907e-02*G0_2_0 + 5.925925925925905e-02*G0_2_1 + 1.693121693121678e-02*G0_2_2;
    block[645] = -1.580246913580246e-01*G0_0_0 - 1.580246913580245e-01*G0_0_1 - 7.901234567901221e-02*G0_0_2 - 7.901234567901237e-02*G0_2_0 - 7.901234567901230e-02*G0_2_1 + 2.257495590828931e-02*G0_2_2;
    block[646] = 4.514991181657842e-02*G0_0_0 + 1.128747795414458e-02*G0_0_2 - 3.386243386243372e-02*G0_2_0 + 4.514991181657834e-02*G0_2_2;
    block[647] = -9.029982363315683e-02*G0_0_0 - 3.104056437389765e-02*G0_0_2 + 4.232804232804224e-02*G0_2_0 - 1.185185185185183e-01*G0_2_2;
    block[648] = 1.580246913580245e-01*G0_0_0 + 7.901234567901233e-02*G0_0_2 + 7.901234567901232e-02*G0_2_0 + 2.031746031746030e-01*G0_2_2;
    block[649] = 4.514991181657858e-02*G0_0_1 + 1.128747795414459e-02*G0_0_2 + 3.386243386243400e-02*G0_2_1 + 1.128747795414472e-02*G0_2_2;
    block[650] = -9.029982363315700e-02*G0_0_1 - 3.104056437389766e-02*G0_0_2 - 5.925925925925938e-02*G0_2_1 - 4.232804232804244e-02*G0_2_2;
    block[651] = 1.580246913580245e-01*G0_0_1 + 7.901234567901232e-02*G0_0_2 + 7.901234567901234e-02*G0_2_1 + 1.015873015873016e-01*G0_2_2;
    block[652] = -2.257495590828937e-02*G0_0_0 - 2.257495590828937e-02*G0_0_1 + 1.128747795414452e-02*G0_0_2 - 3.386243386243396e-02*G0_2_0 - 6.772486772486770e-02*G0_2_1 + 6.772486772486740e-02*G0_2_2;
    block[653] = 1.128747795414461e-01*G0_0_0 + 1.128747795414463e-01*G0_0_1 + 1.128747795414451e-02*G0_0_2 + 1.015873015873015e-01*G0_2_0 + 2.031746031746030e-01*G0_2_1 - 6.772486772486765e-02*G0_2_2;
    block[654] = -2.257495590828916e-02*G0_0_0 - 2.257495590828934e-02*G0_0_1 + 1.128747795414458e-02*G0_0_2 - 3.386243386243375e-02*G0_2_0 - 6.772486772486776e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[655] = 2.257495590828915e-02*G0_0_0 + 3.386243386243377e-02*G0_0_2 + 3.386243386243374e-02*G0_2_0 + 4.514991181657842e-02*G0_2_2;
    block[656] = -1.128747795414462e-01*G0_0_0 - 1.015873015873016e-01*G0_0_2 - 1.015873015873015e-01*G0_2_0 - 1.354497354497353e-01*G0_2_2;
    block[657] = 2.257495590828940e-02*G0_0_0 + 3.386243386243382e-02*G0_0_2 + 3.386243386243387e-02*G0_2_0 + 4.514991181657825e-02*G0_2_2;
    block[658] = -1.128747795414463e-01*G0_0_1 - 1.015873015873017e-01*G0_0_2 - 1.015873015873013e-01*G0_2_0 - 2.031746031746031e-01*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[659] = 2.257495590828927e-02*G0_0_1 + 3.386243386243389e-02*G0_0_2 + 3.386243386243360e-02*G0_2_0 + 6.772486772486756e-02*G0_2_1 + 1.354497354497352e-01*G0_2_2;
    block[660] = 2.257495590828941e-02*G0_0_1 + 3.386243386243391e-02*G0_0_2 + 3.386243386243384e-02*G0_2_0 + 6.772486772486784e-02*G0_2_1 + 9.029982363315690e-02*G0_2_2;
    block[661] = -1.128747795414453e-02*G0_0_2 - 1.128747795414464e-02*G0_2_0 - 2.257495590828905e-02*G0_2_2;
    block[662] = -1.128747795414463e-02*G0_0_2 - 1.128747795414461e-02*G0_2_0 - 6.772486772486754e-02*G0_2_2;
    block[663] = -1.128747795414458e-02*G0_0_2 - 1.128747795414461e-02*G0_2_0 - 2.257495590828920e-02*G0_2_2;
    block[664] = 9.029982363315683e-02*G0_2_2;
    block[665] = 7.760141093474410e-03*G0_1_0 + 7.760141093474426e-03*G0_1_1 + 7.760141093474410e-03*G0_1_2 + 7.760141093474385e-03*G0_2_0 + 7.760141093474390e-03*G0_2_1 + 7.760141093474377e-03*G0_2_2;
    block[666] = -7.760141093474410e-03*G0_1_0 - 7.760141093474378e-03*G0_2_0;
    block[667] = -2.469135802469135e-02*G0_1_1 + 4.585537918871241e-02*G0_2_1;
    block[668] = 1.763668430335097e-02*G0_1_2 - 7.760141093474509e-03*G0_2_2;
    block[669] = 3.386243386243383e-02*G0_1_0 + 1.128747795414467e-02*G0_1_1 + 4.514991181657820e-02*G0_2_0 + 1.128747795414460e-02*G0_2_1;
    block[670] = -5.925925925925919e-02*G0_1_0 - 4.232804232804240e-02*G0_1_1 - 9.029982363315667e-02*G0_2_0 - 3.104056437389782e-02*G0_2_1;
    block[671] = 7.901234567901230e-02*G0_1_0 + 1.015873015873016e-01*G0_1_1 + 1.580246913580245e-01*G0_2_0 + 7.901234567901246e-02*G0_2_1;
    block[672] = -7.901234567901233e-02*G0_1_0 + 2.257495590828915e-02*G0_1_1 - 7.901234567901234e-02*G0_1_2 - 1.580246913580245e-01*G0_2_0 - 7.901234567901216e-02*G0_2_1 - 1.580246913580245e-01*G0_2_2;
    block[673] = 5.925925925925939e-02*G0_1_0 + 1.693121693121697e-02*G0_1_1 + 5.925925925925941e-02*G0_1_2 + 9.029982363315693e-02*G0_2_0 + 5.925925925925905e-02*G0_2_1 + 9.029982363315697e-02*G0_2_2;
    block[674] = -3.386243386243391e-02*G0_1_0 - 2.257495590828923e-02*G0_1_1 - 3.386243386243396e-02*G0_1_2 - 4.514991181657841e-02*G0_2_0 - 3.386243386243373e-02*G0_2_1 - 4.514991181657848e-02*G0_2_2;
    block[675] = -1.128747795414467e-02*G0_1_1 - 1.128747795414472e-02*G0_1_2 - 1.128747795414463e-02*G0_2_1 - 1.128747795414469e-02*G0_2_2;
    block[676] = -2.821869488536224e-03*G0_1_1 - 2.821869488536180e-03*G0_1_2 - 2.821869488536171e-03*G0_2_1 - 2.821869488536143e-03*G0_2_2;
    block[677] = -1.128747795414470e-02*G0_1_1 - 1.128747795414469e-02*G0_1_2 - 1.128747795414458e-02*G0_2_1 - 1.128747795414459e-02*G0_2_2;
    block[678] = -2.257495590828923e-02*G0_1_0 - 2.257495590828922e-02*G0_1_1 - 1.128747795414459e-02*G0_1_2 - 1.128747795414460e-02*G0_2_0 - 1.128747795414457e-02*G0_2_1;
    block[679] = -1.693121693121693e-02*G0_1_0 - 1.693121693121699e-02*G0_1_1 - 2.821869488536259e-03*G0_1_2 - 2.821869488536192e-03*G0_2_0 - 2.821869488536220e-03*G0_2_1;
    block[680] = -4.514991181657869e-02*G0_1_0 - 4.514991181657858e-02*G0_1_1 - 1.128747795414463e-02*G0_1_2 - 1.128747795414466e-02*G0_2_0 - 1.128747795414461e-02*G0_2_1;
    block[681] = 2.257495590828928e-02*G0_1_0 + 1.128747795414471e-02*G0_1_2 + 1.128747795414454e-02*G0_2_0 + 1.128747795414463e-02*G0_2_2;
    block[682] = 1.693121693121685e-02*G0_1_0 + 1.410934744268064e-02*G0_1_2 + 2.821869488536247e-03*G0_2_0 + 2.821869488536123e-03*G0_2_2;
    block[683] = 4.514991181657858e-02*G0_1_0 + 3.386243386243399e-02*G0_1_2 + 1.128747795414459e-02*G0_2_0 + 1.128747795414471e-02*G0_2_2;
    block[684] = 2.031746031746031e-01*G0_1_1 + 7.901234567901232e-02*G0_1_2 + 7.901234567901232e-02*G0_2_1 + 1.580246913580245e-01*G0_2_2;
    block[685] = -1.185185185185185e-01*G0_1_1 + 4.232804232804234e-02*G0_1_2 - 3.104056437389773e-02*G0_2_1 - 9.029982363315693e-02*G0_2_2;
    block[686] = 4.514991181657858e-02*G0_1_1 - 3.386243386243380e-02*G0_1_2 + 1.128747795414460e-02*G0_2_1 + 4.514991181657839e-02*G0_2_2;
    block[687] = -6.772486772486783e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1 - 3.386243386243394e-02*G0_1_2 - 2.257495590828915e-02*G0_2_0 + 1.128747795414446e-02*G0_2_1 - 2.257495590828948e-02*G0_2_2;
    block[688] = -6.772486772486745e-02*G0_1_0 + 6.772486772486787e-02*G0_1_1 - 3.386243386243379e-02*G0_1_2 - 2.257495590828910e-02*G0_2_0 + 1.128747795414484e-02*G0_2_1 - 2.257495590828912e-02*G0_2_2;
    block[689] = 2.031746031746032e-01*G0_1_0 - 6.772486772486772e-02*G0_1_1 + 1.015873015873015e-01*G0_1_2 + 1.128747795414461e-01*G0_2_0 + 1.128747795414465e-02*G0_2_1 + 1.128747795414463e-01*G0_2_2;
    block[690] = -2.031746031746032e-01*G0_1_0 - 2.708994708994709e-01*G0_1_1 - 1.015873015873018e-01*G0_1_2 - 1.128747795414461e-01*G0_2_0 - 1.015873015873017e-01*G0_2_1;
    block[691] = 6.772486772486754e-02*G0_1_0 + 1.354497354497354e-01*G0_1_1 + 3.386243386243383e-02*G0_1_2 + 2.257495590828915e-02*G0_2_0 + 3.386243386243393e-02*G0_2_1;
    block[692] = 6.772486772486780e-02*G0_1_0 + 9.029982363315699e-02*G0_1_1 + 3.386243386243395e-02*G0_1_2 + 2.257495590828953e-02*G0_2_0 + 3.386243386243389e-02*G0_2_1;
    block[693] = -6.772486772486798e-02*G0_1_1 - 1.128747795414481e-02*G0_1_2 - 1.128747795414487e-02*G0_2_1;
    block[694] = -2.257495590828918e-02*G0_1_1 - 1.128747795414451e-02*G0_1_2 - 1.128747795414463e-02*G0_2_1;
    block[695] = -2.257495590828919e-02*G0_1_1 - 1.128747795414448e-02*G0_1_2 - 1.128747795414445e-02*G0_2_1;
    block[696] = 4.514991181657863e-02*G0_1_1 + 3.386243386243382e-02*G0_1_2 + 3.386243386243398e-02*G0_2_1 + 2.257495590828943e-02*G0_2_2;
    block[697] = 4.514991181657862e-02*G0_1_1 + 3.386243386243383e-02*G0_1_2 + 3.386243386243393e-02*G0_2_1 + 2.257495590828933e-02*G0_2_2;
    block[698] = -1.354497354497356e-01*G0_1_1 - 1.015873015873014e-01*G0_1_2 - 1.015873015873018e-01*G0_2_1 - 1.128747795414460e-01*G0_2_2;
    block[699] = 9.029982363315718e-02*G0_1_1;
    block[700] = 5.114638447971821e-03*G0_1_0 + 5.114638447971814e-03*G0_1_1 + 5.114638447971828e-03*G0_1_2 + 5.114638447971821e-03*G0_2_0 + 5.114638447971823e-03*G0_2_1 + 5.114638447971846e-03*G0_2_2;
    block[701] = -5.114638447971806e-03*G0_1_0 - 5.114638447971821e-03*G0_2_0;
    block[702] = 2.028218694885358e-02*G0_1_1 - 3.262786596119929e-02*G0_2_1;
    block[703] = -3.262786596119926e-02*G0_1_2 + 2.028218694885373e-02*G0_2_2;
    block[704] = 1.410934744268074e-02*G0_1_0 + 2.821869488536082e-03*G0_1_1 + 1.693121693121704e-02*G0_2_0 + 2.821869488536164e-03*G0_2_1;
    block[705] = -1.058201058201049e-02*G0_1_0 - 1.340388007054662e-02*G0_1_1 - 2.116402116402118e-02*G0_2_0 - 1.058201058201048e-02*G0_2_1;
    block[706] = -3.104056437389778e-02*G0_1_0 - 4.232804232804237e-02*G0_1_1 - 9.029982363315699e-02*G0_2_0 - 5.925925925925933e-02*G0_2_1;
    block[707] = 3.104056437389774e-02*G0_1_0 - 1.128747795414453e-02*G0_1_1 + 3.104056437389770e-02*G0_1_2 + 9.029982363315693e-02*G0_2_0 + 3.104056437389769e-02*G0_2_1 + 9.029982363315688e-02*G0_2_2;
    block[708] = 1.058201058201049e-02*G0_1_0 - 2.821869488536282e-03*G0_1_1 + 1.058201058201049e-02*G0_1_2 + 2.116402116402119e-02*G0_2_0 + 1.058201058201058e-02*G0_2_1 + 2.116402116402118e-02*G0_2_2;
    block[709] = -1.410934744268075e-02*G0_1_0 - 1.128747795414460e-02*G0_1_1 - 1.410934744268077e-02*G0_1_2 - 1.693121693121702e-02*G0_2_0 - 1.410934744268083e-02*G0_2_1 - 1.693121693121703e-02*G0_2_2;
    block[710] = -2.821869488536177e-03*G0_1_1 - 2.821869488536194e-03*G0_1_2 - 2.821869488536247e-03*G0_2_1 - 2.821869488536235e-03*G0_2_2;
    block[711] = -9.171075837742492e-03*G0_1_1 - 9.171075837742498e-03*G0_1_2 - 9.171075837742588e-03*G0_2_1 - 9.171075837742586e-03*G0_2_2;
    block[712] = -2.821869488536073e-03*G0_1_1 - 2.821869488536083e-03*G0_1_2 - 2.821869488536185e-03*G0_2_1 - 2.821869488536177e-03*G0_2_2;
    block[713] = -1.693121693121698e-02*G0_1_0 - 1.693121693121699e-02*G0_1_1 - 1.410934744268087e-02*G0_1_2 - 1.410934744268088e-02*G0_2_0 - 1.410934744268088e-02*G0_2_1 - 1.128747795414472e-02*G0_2_2;
    block[714] = 2.116402116402121e-02*G0_1_0 + 2.116402116402126e-02*G0_1_1 + 1.058201058201069e-02*G0_1_2 + 1.058201058201068e-02*G0_2_0 + 1.058201058201068e-02*G0_2_1 - 2.821869488535996e-03*G0_2_2;
    block[715] = 9.029982363315700e-02*G0_1_0 + 9.029982363315697e-02*G0_1_1 + 3.104056437389760e-02*G0_1_2 + 3.104056437389758e-02*G0_2_0 + 3.104056437389763e-02*G0_2_1 - 1.128747795414485e-02*G0_2_2;
    block[716] = 1.693121693121693e-02*G0_1_0 + 2.821869488536126e-03*G0_1_2 + 1.410934744268085e-02*G0_2_0 + 2.821869488536179e-03*G0_2_2;
    block[717] = -2.116402116402108e-02*G0_1_0 - 1.058201058201046e-02*G0_1_2 - 1.058201058201070e-02*G0_2_0 - 1.340388007054674e-02*G0_2_2;
    block[718] = -9.029982363315700e-02*G0_1_0 - 5.925925925925938e-02*G0_1_2 - 3.104056437389766e-02*G0_2_0 - 4.232804232804243e-02*G0_2_2;
    block[719] = -1.185185185185185e-01*G0_1_1 - 3.104056437389773e-02*G0_1_2 + 4.232804232804233e-02*G0_2_1 - 9.029982363315697e-02*G0_2_2;
    block[720] = 2.497354497354497e-01*G0_1_1 + 8.253968253968250e-02*G0_1_2 + 8.253968253968250e-02*G0_2_1 + 2.497354497354499e-01*G0_2_2;
    block[721] = -9.029982363315707e-02*G0_1_1 + 4.232804232804215e-02*G0_1_2 - 3.104056437389768e-02*G0_2_1 - 1.185185185185185e-01*G0_2_2;
    block[722] = -8.465608465608430e-02*G0_1_0 - 1.693121693121668e-02*G0_1_1 - 1.975308641975292e-02*G0_1_2 - 8.465608465608464e-02*G0_2_0 - 1.975308641975294e-02*G0_2_1 - 1.693121693121671e-02*G0_2_2;
    block[723] = 1.862433862433858e-01*G0_1_0 - 8.465608465608489e-02*G0_1_1 + 9.312169312169297e-02*G0_1_2 + 5.079365079365056e-02*G0_2_0 - 4.232804232804269e-02*G0_2_1 + 1.185185185185183e-01*G0_2_2;
    block[724] = 5.079365079365079e-02*G0_1_0 + 1.185185185185186e-01*G0_1_1 - 4.232804232804221e-02*G0_1_2 + 1.862433862433863e-01*G0_2_0 + 9.312169312169324e-02*G0_2_1 - 8.465608465608455e-02*G0_2_2;
    block[725] = -5.079365079365077e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 9.312169312169295e-02*G0_1_2 - 1.862433862433863e-01*G0_2_0 - 9.312169312169315e-02*G0_2_1 - 2.708994708994708e-01*G0_2_2;
    block[726] = -1.862433862433857e-01*G0_1_0 - 2.708994708994709e-01*G0_1_1 - 9.312169312169302e-02*G0_1_2 - 5.079365079365044e-02*G0_2_0 - 9.312169312169322e-02*G0_2_1 + 6.772486772486773e-02*G0_2_2;
    block[727] = 8.465608465608472e-02*G0_1_0 + 6.772486772486778e-02*G0_1_1 + 6.490299823633164e-02*G0_1_2 + 8.465608465608457e-02*G0_2_0 + 6.490299823633171e-02*G0_2_1 + 6.772486772486785e-02*G0_2_2;
    block[728] = 8.465608465608504e-02*G0_1_1 + 4.232804232804246e-02*G0_1_2 + 4.232804232804271e-02*G0_2_1 + 2.257495590828925e-02*G0_2_2;
    block[729] = 1.693121693121661e-02*G0_1_1 + 1.975308641975287e-02*G0_1_2 + 1.975308641975296e-02*G0_2_1 + 2.257495590828936e-02*G0_2_2;
    block[730] = 1.693121693121705e-02*G0_1_1 + 1.975308641975323e-02*G0_1_2 + 1.975308641975301e-02*G0_2_1 + 2.257495590828945e-02*G0_2_2;
    block[731] = 2.257495590828930e-02*G0_1_1 + 1.975308641975321e-02*G0_1_2 + 1.975308641975320e-02*G0_2_1 + 1.693121693121683e-02*G0_2_2;
    block[732] = 2.257495590828910e-02*G0_1_1 + 1.975308641975295e-02*G0_1_2 + 1.975308641975310e-02*G0_2_1 + 1.693121693121678e-02*G0_2_2;
    block[733] = 2.257495590828924e-02*G0_1_1 + 4.232804232804217e-02*G0_1_2 + 4.232804232804230e-02*G0_2_1 + 8.465608465608442e-02*G0_2_2;
    block[734] = -1.354497354497356e-01*G0_1_1 - 1.128747795414462e-01*G0_1_2 - 1.128747795414462e-01*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[735] = 7.760141093474374e-03*G0_1_0 + 7.760141093474398e-03*G0_1_1 + 7.760141093474390e-03*G0_1_2 + 7.760141093474386e-03*G0_2_0 + 7.760141093474403e-03*G0_2_1 + 7.760141093474377e-03*G0_2_2;
    block[736] = -7.760141093474429e-03*G0_1_0 - 7.760141093474424e-03*G0_2_0;
    block[737] = -7.760141093474469e-03*G0_1_1 + 1.763668430335089e-02*G0_2_1;
    block[738] = 4.585537918871251e-02*G0_1_2 - 2.469135802469135e-02*G0_2_2;
    block[739] = 1.128747795414463e-02*G0_1_0 + 1.128747795414466e-02*G0_1_1 + 2.257495590828918e-02*G0_2_0 + 1.128747795414464e-02*G0_2_1;
    block[740] = 2.821869488536169e-03*G0_1_0 + 2.821869488536070e-03*G0_1_1 + 1.693121693121697e-02*G0_2_0 + 1.410934744268067e-02*G0_2_1;
    block[741] = 1.128747795414459e-02*G0_1_0 + 1.128747795414474e-02*G0_1_1 + 4.514991181657837e-02*G0_2_0 + 3.386243386243391e-02*G0_2_1;
    block[742] = -1.128747795414458e-02*G0_1_0 - 1.128747795414458e-02*G0_1_2 - 4.514991181657835e-02*G0_2_0 - 1.128747795414448e-02*G0_2_1 - 4.514991181657835e-02*G0_2_2;
    block[743] = -2.821869488536183e-03*G0_1_0 - 2.821869488536178e-03*G0_1_2 - 1.693121693121702e-02*G0_2_0 - 2.821869488536329e-03*G0_2_1 - 1.693121693121700e-02*G0_2_2;
    block[744] = -1.128747795414456e-02*G0_1_0 - 1.128747795414456e-02*G0_1_2 - 2.257495590828910e-02*G0_2_0 - 1.128747795414451e-02*G0_2_1 - 2.257495590828909e-02*G0_2_2;
    block[745] = -1.128747795414458e-02*G0_1_1 - 1.128747795414460e-02*G0_1_2 - 1.128747795414456e-02*G0_2_1 - 1.128747795414458e-02*G0_2_2;
    block[746] = -2.821869488536174e-03*G0_1_1 - 2.821869488536161e-03*G0_1_2 - 2.821869488536124e-03*G0_2_1 - 2.821869488536122e-03*G0_2_2;
    block[747] = -1.128747795414464e-02*G0_1_1 - 1.128747795414465e-02*G0_1_2 - 1.128747795414461e-02*G0_2_1 - 1.128747795414463e-02*G0_2_2;
    block[748] = -4.514991181657835e-02*G0_1_0 - 4.514991181657835e-02*G0_1_1 - 3.386243386243377e-02*G0_1_2 - 3.386243386243377e-02*G0_2_0 - 3.386243386243377e-02*G0_2_1 - 2.257495590828918e-02*G0_2_2;
    block[749] = 9.029982363315678e-02*G0_1_0 + 9.029982363315674e-02*G0_1_1 + 5.925925925925905e-02*G0_1_2 + 5.925925925925914e-02*G0_2_0 + 5.925925925925914e-02*G0_2_1 + 1.693121693121680e-02*G0_2_2;
    block[750] = -1.580246913580246e-01*G0_1_0 - 1.580246913580245e-01*G0_1_1 - 7.901234567901219e-02*G0_1_2 - 7.901234567901233e-02*G0_2_0 - 7.901234567901234e-02*G0_2_1 + 2.257495590828929e-02*G0_2_2;
    block[751] = 4.514991181657841e-02*G0_1_0 + 1.128747795414459e-02*G0_1_2 + 3.386243386243390e-02*G0_2_0 + 1.128747795414461e-02*G0_2_2;
    block[752] = -9.029982363315681e-02*G0_1_0 - 3.104056437389763e-02*G0_1_2 - 5.925925925925915e-02*G0_2_0 - 4.232804232804223e-02*G0_2_2;
    block[753] = 1.580246913580245e-01*G0_1_0 + 7.901234567901234e-02*G0_1_2 + 7.901234567901232e-02*G0_2_0 + 1.015873015873016e-01*G0_2_2;
    block[754] = 4.514991181657858e-02*G0_1_1 + 1.128747795414460e-02*G0_1_2 - 3.386243386243380e-02*G0_2_1 + 4.514991181657839e-02*G0_2_2;
    block[755] = -9.029982363315707e-02*G0_1_1 - 3.104056437389768e-02*G0_1_2 + 4.232804232804215e-02*G0_2_1 - 1.185185185185185e-01*G0_2_2;
    block[756] = 1.580246913580245e-01*G0_1_1 + 7.901234567901232e-02*G0_1_2 + 7.901234567901230e-02*G0_2_1 + 2.031746031746030e-01*G0_2_2;
    block[757] = -2.257495590828941e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 + 1.128747795414450e-02*G0_1_2 - 6.772486772486769e-02*G0_2_0 - 3.386243386243383e-02*G0_2_1 + 2.257495590828910e-02*G0_2_2;
    block[758] = 1.128747795414461e-01*G0_1_0 + 1.128747795414463e-01*G0_1_1 + 1.128747795414449e-02*G0_1_2 + 2.031746031746030e-01*G0_2_0 + 1.015873015873017e-01*G0_2_1 - 6.772486772486763e-02*G0_2_2;
    block[759] = -2.257495590828920e-02*G0_1_0 - 2.257495590828944e-02*G0_1_1 + 1.128747795414454e-02*G0_1_2 - 6.772486772486787e-02*G0_2_0 - 3.386243386243411e-02*G0_2_1 + 6.772486772486749e-02*G0_2_2;
    block[760] = 2.257495590828919e-02*G0_1_0 + 3.386243386243381e-02*G0_1_2 + 6.772486772486784e-02*G0_2_0 + 3.386243386243382e-02*G0_2_1 + 1.354497354497354e-01*G0_2_2;
    block[761] = -1.128747795414462e-01*G0_1_0 - 1.015873015873015e-01*G0_1_2 - 2.031746031746032e-01*G0_2_0 - 1.015873015873013e-01*G0_2_1 - 2.708994708994708e-01*G0_2_2;
    block[762] = 2.257495590828928e-02*G0_1_0 + 3.386243386243373e-02*G0_1_2 + 6.772486772486781e-02*G0_2_0 + 3.386243386243366e-02*G0_2_1 + 9.029982363315675e-02*G0_2_2;
    block[763] = -1.128747795414463e-01*G0_1_1 - 1.015873015873017e-01*G0_1_2 - 1.015873015873017e-01*G0_2_1 - 1.354497354497354e-01*G0_2_2;
    block[764] = 2.257495590828927e-02*G0_1_1 + 3.386243386243386e-02*G0_1_2 + 3.386243386243371e-02*G0_2_1 + 4.514991181657827e-02*G0_2_2;
    block[765] = 2.257495590828936e-02*G0_1_1 + 3.386243386243386e-02*G0_1_2 + 3.386243386243409e-02*G0_2_1 + 4.514991181657844e-02*G0_2_2;
    block[766] = -1.128747795414457e-02*G0_1_2 - 1.128747795414462e-02*G0_2_1 - 2.257495590828904e-02*G0_2_2;
    block[767] = -1.128747795414460e-02*G0_1_2 - 1.128747795414462e-02*G0_2_1 - 2.257495590828920e-02*G0_2_2;
    block[768] = -1.128747795414454e-02*G0_1_2 - 1.128747795414465e-02*G0_2_1 - 6.772486772486742e-02*G0_2_2;
    block[769] = 9.029982363315672e-02*G0_2_2;
    block[770] = 1.834215167548478e-02*G0_0_0 + 1.834215167548481e-02*G0_0_1 + 1.834215167548480e-02*G0_0_2 + 1.834215167548480e-02*G0_1_0 + 1.834215167548481e-02*G0_1_1 + 1.834215167548480e-02*G0_1_2 + 1.834215167548482e-02*G0_2_0 + 1.834215167548486e-02*G0_2_1 + 1.834215167548481e-02*G0_2_2;
    block[771] = 4.938271604938267e-02*G0_0_0 + 7.054673721340312e-03*G0_1_0 + 7.054673721340289e-03*G0_2_0;
    block[772] = 7.054673721340454e-03*G0_0_1 - 1.834215167548506e-02*G0_1_1 + 7.054673721340298e-03*G0_2_1;
    block[773] = 7.054673721340351e-03*G0_0_2 + 7.054673721340332e-03*G0_1_2 - 1.834215167548494e-02*G0_2_2;
    block[774] = -6.772486772486780e-02*G0_0_0 + 1.128747795414452e-02*G0_0_1 + 1.015873015873010e-01*G0_1_0 + 1.128747795414458e-01*G0_1_1 + 2.031746031746023e-01*G0_2_0 + 1.128747795414457e-01*G0_2_1;
    block[775] = 1.185185185185184e-01*G0_0_0 + 9.312169312169305e-02*G0_0_1 - 4.232804232804206e-02*G0_1_0 - 8.465608465608455e-02*G0_1_1 + 5.079365079365106e-02*G0_2_0 + 1.862433862433859e-01*G0_2_1;
    block[776] = -2.257495590828917e-02*G0_0_0 - 3.386243386243400e-02*G0_0_1 + 1.128747795414445e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 2.257495590828949e-02*G0_2_0 - 6.772486772486763e-02*G0_2_1;
    block[777] = 2.257495590828920e-02*G0_0_0 - 1.128747795414470e-02*G0_0_1 + 2.257495590828929e-02*G0_0_2 - 1.128747795414435e-02*G0_1_0 - 1.128747795414434e-02*G0_1_2 + 2.257495590828963e-02*G0_2_0 - 1.128747795414448e-02*G0_2_1 + 2.257495590828964e-02*G0_2_2;
    block[778] = 1.693121693121699e-02*G0_0_0 - 2.821869488536185e-03*G0_0_1 + 1.693121693121697e-02*G0_0_2 - 2.821869488536239e-03*G0_1_0 - 2.821869488536233e-03*G0_1_2 + 1.693121693121688e-02*G0_2_0 - 2.821869488536259e-03*G0_2_1 + 1.693121693121688e-02*G0_2_2;
    block[779] = -2.257495590828917e-02*G0_0_0 - 1.128747795414438e-02*G0_0_1 - 2.257495590828916e-02*G0_0_2 - 1.128747795414454e-02*G0_1_0 - 1.128747795414455e-02*G0_1_2 - 2.257495590828910e-02*G0_2_0 - 1.128747795414446e-02*G0_2_1 - 2.257495590828913e-02*G0_2_2;
    block[780] = -4.514991181657802e-02*G0_0_0 - 5.643738977072289e-02*G0_0_1 - 5.643738977072280e-02*G0_0_2 - 5.643738977072251e-02*G0_1_0 - 6.772486772486730e-02*G0_1_1 - 6.772486772486730e-02*G0_1_2 - 5.643738977072258e-02*G0_2_0 - 6.772486772486734e-02*G0_2_1 - 6.772486772486730e-02*G0_2_2;
    block[781] = 2.257495590828884e-02*G0_0_0 + 4.232804232804221e-02*G0_0_1 + 4.232804232804215e-02*G0_0_2 + 4.232804232804185e-02*G0_1_0 + 8.465608465608442e-02*G0_1_1 + 8.465608465608439e-02*G0_1_2 + 4.232804232804179e-02*G0_2_0 + 8.465608465608421e-02*G0_2_1 + 8.465608465608415e-02*G0_2_2;
    block[782] = -4.514991181657835e-02*G0_0_0 - 1.128747795414447e-02*G0_0_1 - 1.128747795414447e-02*G0_0_2 - 1.128747795414450e-02*G0_1_0 - 1.128747795414458e-01*G0_1_1 - 1.128747795414458e-01*G0_1_2 - 1.128747795414441e-02*G0_2_0 - 1.128747795414457e-01*G0_2_1 - 1.128747795414457e-01*G0_2_2;
    block[783] = -2.257495590828910e-02*G0_0_0 - 2.257495590828914e-02*G0_0_1 - 1.128747795414417e-02*G0_0_2 - 2.257495590828903e-02*G0_1_0 - 2.257495590828908e-02*G0_1_1 - 1.128747795414434e-02*G0_1_2 - 1.128747795414455e-02*G0_2_0 - 1.128747795414463e-02*G0_2_1;
    block[784] = 1.693121693121674e-02*G0_0_0 + 1.693121693121677e-02*G0_0_1 - 2.821869488536488e-03*G0_0_2 + 1.693121693121680e-02*G0_1_0 + 1.693121693121686e-02*G0_1_1 - 2.821869488536374e-03*G0_1_2 - 2.821869488536053e-03*G0_2_0 - 2.821869488536044e-03*G0_2_1;
    block[785] = 2.257495590828948e-02*G0_0_0 + 2.257495590828935e-02*G0_0_1 - 1.128747795414448e-02*G0_0_2 + 2.257495590828949e-02*G0_1_0 + 2.257495590828941e-02*G0_1_1 - 1.128747795414447e-02*G0_1_2 - 1.128747795414444e-02*G0_2_0 - 1.128747795414453e-02*G0_2_1;
    block[786] = -6.772486772486788e-02*G0_0_0 + 1.128747795414446e-02*G0_0_2 + 2.031746031746024e-01*G0_1_0 + 1.128747795414457e-01*G0_1_2 + 1.015873015873012e-01*G0_2_0 + 1.128747795414456e-01*G0_2_2;
    block[787] = 1.185185185185185e-01*G0_0_0 + 9.312169312169311e-02*G0_0_2 + 5.079365079365097e-02*G0_1_0 + 1.862433862433860e-01*G0_1_2 - 4.232804232804214e-02*G0_2_0 - 8.465608465608422e-02*G0_2_2;
    block[788] = -2.257495590828937e-02*G0_0_0 - 3.386243386243395e-02*G0_0_2 - 2.257495590828936e-02*G0_1_0 - 6.772486772486770e-02*G0_1_2 + 1.128747795414452e-02*G0_2_0 + 6.772486772486740e-02*G0_2_2;
    block[789] = -6.772486772486781e-02*G0_0_1 - 2.257495590828915e-02*G0_0_2 + 2.257495590828913e-02*G0_1_1 + 1.128747795414446e-02*G0_1_2 - 3.386243386243394e-02*G0_2_1 - 2.257495590828947e-02*G0_2_2;
    block[790] = -8.465608465608430e-02*G0_0_1 - 8.465608465608465e-02*G0_0_2 - 1.693121693121668e-02*G0_1_1 - 1.975308641975294e-02*G0_1_2 - 1.975308641975292e-02*G0_2_1 - 1.693121693121671e-02*G0_2_2;
    block[791] = -2.257495590828941e-02*G0_0_1 - 6.772486772486770e-02*G0_0_2 - 2.257495590828936e-02*G0_1_1 - 3.386243386243383e-02*G0_1_2 + 1.128747795414450e-02*G0_2_1 + 2.257495590828909e-02*G0_2_2;
    block[792] = 6.320987654320984e-01*G0_0_0 + 2.708994708994703e-01*G0_0_1 + 2.708994708994704e-01*G0_0_2 + 2.708994708994703e-01*G0_1_0 + 5.417989417989402e-01*G0_1_1 + 2.708994708994698e-01*G0_1_2 + 2.708994708994704e-01*G0_2_0 + 2.708994708994698e-01*G0_2_1 + 5.417989417989401e-01*G0_2_2;
    block[793] = -1.354497354497348e-01*G0_0_0 + 6.772486772486803e-02*G0_0_1 + 2.257495590828931e-01*G0_0_2 - 6.772486772486729e-02*G0_1_0 + 6.772486772486805e-02*G0_1_2 - 4.514991181657831e-02*G0_2_0 - 6.772486772486759e-02*G0_2_1 - 1.354497354497349e-01*G0_2_2;
    block[794] = -1.354497354497353e-01*G0_0_0 + 2.257495590828928e-01*G0_0_1 + 6.772486772486762e-02*G0_0_2 - 4.514991181657836e-02*G0_1_0 - 1.354497354497352e-01*G0_1_1 - 6.772486772486756e-02*G0_1_2 - 6.772486772486772e-02*G0_2_0 + 6.772486772486780e-02*G0_2_1;
    block[795] = 1.354497354497353e-01*G0_0_0 + 4.514991181657873e-02*G0_0_1 + 6.772486772486752e-02*G0_0_2 + 4.514991181657829e-02*G0_1_0 + 2.257495590828900e-02*G0_1_2 + 6.772486772486769e-02*G0_2_0 + 2.257495590828947e-02*G0_2_1;
    block[796] = 1.354497354497349e-01*G0_0_0 + 6.772486772486762e-02*G0_0_1 + 4.514991181657869e-02*G0_0_2 + 6.772486772486730e-02*G0_1_0 + 2.257495590828928e-02*G0_1_2 + 4.514991181657831e-02*G0_2_0 + 2.257495590828903e-02*G0_2_1;
    block[797] = 9.029982363315642e-02*G0_0_0 + 4.514991181657815e-02*G0_0_1 + 4.514991181657801e-02*G0_0_2 + 4.514991181657833e-02*G0_1_0 + 2.257495590828894e-02*G0_1_2 + 4.514991181657831e-02*G0_2_0 + 2.257495590828896e-02*G0_2_1;
    block[798] = -1.354497354497352e-01*G0_0_0 - 6.772486772486791e-02*G0_0_1 + 4.514991181657891e-02*G0_0_2 - 6.772486772486778e-02*G0_1_0 + 6.772486772486797e-02*G0_1_2 + 4.514991181657822e-02*G0_2_0 + 6.772486772486755e-02*G0_2_1;
    block[799] = 4.514991181657902e-02*G0_0_0 - 2.708994708994705e-01*G0_0_1 - 1.354497354497353e-01*G0_0_2 - 2.708994708994698e-01*G0_1_0 - 5.417989417989405e-01*G0_1_1 - 2.708994708994704e-01*G0_1_2 - 1.354497354497350e-01*G0_2_0 - 2.708994708994703e-01*G0_2_1;
    block[800] = 4.514991181657804e-02*G0_0_0 + 9.029982363315656e-02*G0_0_1 + 4.514991181657785e-02*G0_0_2 + 9.029982363315633e-02*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 6.772486772486709e-02*G0_1_2 + 4.514991181657825e-02*G0_2_0 + 6.772486772486772e-02*G0_2_1;
    block[801] = 4.514991181657815e-02*G0_0_0 + 4.514991181657826e-02*G0_0_1 + 9.029982363315674e-02*G0_0_2 + 4.514991181657825e-02*G0_1_0 + 6.772486772486767e-02*G0_1_2 + 9.029982363315636e-02*G0_2_0 + 6.772486772486733e-02*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[802] = 4.514991181657867e-02*G0_0_0 - 1.354497354497353e-01*G0_0_1 - 2.708994708994705e-01*G0_0_2 - 1.354497354497348e-01*G0_1_0 - 2.708994708994700e-01*G0_1_2 - 2.708994708994696e-01*G0_2_0 - 2.708994708994703e-01*G0_2_1 - 5.417989417989404e-01*G0_2_2;
    block[803] = -1.354497354497354e-01*G0_0_0 + 4.514991181657874e-02*G0_0_1 - 6.772486772486770e-02*G0_0_2 + 4.514991181657830e-02*G0_1_0 + 6.772486772486763e-02*G0_1_2 - 6.772486772486797e-02*G0_2_0 + 6.772486772486791e-02*G0_2_1;
    block[804] = -7.223985890652547e-01*G0_0_0 - 3.160493827160492e-01*G0_0_1 - 3.160493827160495e-01*G0_0_2 - 3.160493827160487e-01*G0_1_0 - 1.354497354497353e-01*G0_1_2 - 3.160493827160488e-01*G0_2_0 - 1.354497354497351e-01*G0_2_1;
    block[805] = 1.834215167548496e-02*G0_0_0 + 1.834215167548498e-02*G0_0_1 + 1.834215167548499e-02*G0_0_2 + 1.834215167548492e-02*G0_1_0 + 1.834215167548492e-02*G0_1_1 + 1.834215167548493e-02*G0_1_2 + 1.834215167548492e-02*G0_2_0 + 1.834215167548491e-02*G0_2_1 + 1.834215167548496e-02*G0_2_2;
    block[806] = -1.834215167548500e-02*G0_0_0 + 7.054673721340440e-03*G0_1_0 + 7.054673721340448e-03*G0_2_0;
    block[807] = 7.054673721340302e-03*G0_0_1 - 1.834215167548500e-02*G0_1_1 + 7.054673721340367e-03*G0_2_1;
    block[808] = 7.054673721340420e-03*G0_0_2 + 7.054673721340401e-03*G0_1_2 + 4.938271604938266e-02*G0_2_2;
    block[809] = 2.257495590828924e-02*G0_0_0 + 1.128747795414460e-02*G0_0_1 - 3.386243386243373e-02*G0_1_0 - 2.257495590828914e-02*G0_1_1 - 6.772486772486767e-02*G0_2_0 - 2.257495590828925e-02*G0_2_1;
    block[810] = -1.693121693121682e-02*G0_0_0 - 1.975308641975303e-02*G0_0_1 - 1.975308641975315e-02*G0_1_0 - 1.693121693121697e-02*G0_1_1 - 8.465608465608440e-02*G0_2_0 - 8.465608465608436e-02*G0_2_1;
    block[811] = -2.257495590828922e-02*G0_0_0 - 3.386243386243364e-02*G0_0_1 + 1.128747795414478e-02*G0_1_0 + 2.257495590828944e-02*G0_1_1 - 2.257495590828920e-02*G0_2_0 - 6.772486772486765e-02*G0_2_1;
    block[812] = 2.257495590828917e-02*G0_0_0 - 1.128747795414435e-02*G0_0_1 + 2.257495590828913e-02*G0_0_2 - 1.128747795414480e-02*G0_1_0 - 1.128747795414477e-02*G0_1_2 + 2.257495590828914e-02*G0_2_0 - 1.128747795414448e-02*G0_2_1 + 2.257495590828911e-02*G0_2_2;
    block[813] = 1.693121693121674e-02*G0_0_0 - 2.821869488536493e-03*G0_0_1 + 1.693121693121676e-02*G0_0_2 - 2.821869488536195e-03*G0_1_0 - 2.821869488536183e-03*G0_1_2 + 1.693121693121686e-02*G0_2_0 - 2.821869488536400e-03*G0_2_1 + 1.693121693121686e-02*G0_2_2;
    block[814] = -2.257495590828919e-02*G0_0_0 - 1.128747795414447e-02*G0_0_1 - 2.257495590828920e-02*G0_0_2 - 1.128747795414451e-02*G0_1_0 - 1.128747795414451e-02*G0_1_2 - 2.257495590828930e-02*G0_2_0 - 1.128747795414440e-02*G0_2_1 - 2.257495590828930e-02*G0_2_2;
    block[815] = -1.128747795414467e-02*G0_0_1 - 1.128747795414471e-02*G0_0_2 - 1.128747795414449e-02*G0_1_0 - 2.257495590828920e-02*G0_1_1 - 2.257495590828922e-02*G0_1_2 - 1.128747795414445e-02*G0_2_0 - 2.257495590828933e-02*G0_2_1 - 2.257495590828933e-02*G0_2_2;
    block[816] = -2.821869488536159e-03*G0_0_1 - 2.821869488536129e-03*G0_0_2 - 2.821869488536232e-03*G0_1_0 + 1.693121693121699e-02*G0_1_1 + 1.693121693121702e-02*G0_1_2 - 2.821869488536256e-03*G0_2_0 + 1.693121693121699e-02*G0_2_1 + 1.693121693121700e-02*G0_2_2;
    block[817] = -1.128747795414457e-02*G0_0_1 - 1.128747795414459e-02*G0_0_2 - 1.128747795414462e-02*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 2.257495590828913e-02*G0_1_2 - 1.128747795414465e-02*G0_2_0 + 2.257495590828924e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[818] = -6.772486772486766e-02*G0_0_0 - 6.772486772486769e-02*G0_0_1 - 5.643738977072302e-02*G0_0_2 - 6.772486772486752e-02*G0_1_0 - 6.772486772486755e-02*G0_1_1 - 5.643738977072286e-02*G0_1_2 - 5.643738977072309e-02*G0_2_0 - 5.643738977072309e-02*G0_2_1 - 4.514991181657826e-02*G0_2_2;
    block[819] = 8.465608465608464e-02*G0_0_0 + 8.465608465608467e-02*G0_0_1 + 4.232804232804218e-02*G0_0_2 + 8.465608465608429e-02*G0_1_0 + 8.465608465608428e-02*G0_1_1 + 4.232804232804189e-02*G0_1_2 + 4.232804232804229e-02*G0_2_0 + 4.232804232804231e-02*G0_2_1 + 2.257495590828898e-02*G0_2_2;
    block[820] = -1.128747795414463e-01*G0_0_0 - 1.128747795414462e-01*G0_0_1 - 1.128747795414463e-02*G0_0_2 - 1.128747795414463e-01*G0_1_0 - 1.128747795414462e-01*G0_1_1 - 1.128747795414443e-02*G0_1_2 - 1.128747795414457e-02*G0_2_0 - 1.128747795414456e-02*G0_2_1 - 4.514991181657839e-02*G0_2_2;
    block[821] = 6.772486772486760e-02*G0_0_0 + 1.128747795414458e-02*G0_0_2 - 6.772486772486760e-02*G0_1_0 - 2.257495590828915e-02*G0_1_2 - 3.386243386243407e-02*G0_2_0 - 2.257495590828918e-02*G0_2_2;
    block[822] = -8.465608465608429e-02*G0_0_0 - 4.232804232804205e-02*G0_0_2 + 1.862433862433861e-01*G0_1_0 + 5.079365079365088e-02*G0_1_2 + 9.312169312169342e-02*G0_2_0 + 1.185185185185185e-01*G0_2_2;
    block[823] = 1.128747795414461e-01*G0_0_0 + 1.015873015873015e-01*G0_0_2 + 1.128747795414463e-01*G0_1_0 + 2.031746031746030e-01*G0_1_2 + 1.128747795414451e-02*G0_2_0 - 6.772486772486765e-02*G0_2_2;
    block[824] = -6.772486772486745e-02*G0_0_1 - 2.257495590828910e-02*G0_0_2 + 6.772486772486788e-02*G0_1_1 + 1.128747795414485e-02*G0_1_2 - 3.386243386243379e-02*G0_2_1 - 2.257495590828911e-02*G0_2_2;
    block[825] = 1.862433862433857e-01*G0_0_1 + 5.079365079365056e-02*G0_0_2 - 8.465608465608487e-02*G0_1_1 - 4.232804232804269e-02*G0_1_2 + 9.312169312169297e-02*G0_2_1 + 1.185185185185183e-01*G0_2_2;
    block[826] = 1.128747795414461e-01*G0_0_1 + 2.031746031746031e-01*G0_0_2 + 1.128747795414463e-01*G0_1_1 + 1.015873015873017e-01*G0_1_2 + 1.128747795414449e-02*G0_2_1 - 6.772486772486762e-02*G0_2_2;
    block[827] = -1.354497354497348e-01*G0_0_0 - 6.772486772486729e-02*G0_0_1 - 4.514991181657831e-02*G0_0_2 + 6.772486772486803e-02*G0_1_0 - 6.772486772486759e-02*G0_1_2 + 2.257495590828932e-01*G0_2_0 + 6.772486772486803e-02*G0_2_1 - 1.354497354497349e-01*G0_2_2;
    block[828] = 5.417989417989409e-01*G0_0_0 + 2.708994708994709e-01*G0_0_1 + 2.708994708994706e-01*G0_0_2 + 2.708994708994709e-01*G0_1_0 + 5.417989417989418e-01*G0_1_1 + 2.708994708994713e-01*G0_1_2 + 2.708994708994706e-01*G0_2_0 + 2.708994708994712e-01*G0_2_1 + 6.320987654320984e-01*G0_2_2;
    block[829] = 6.772486772486756e-02*G0_0_1 - 6.772486772486740e-02*G0_0_2 - 6.772486772486777e-02*G0_1_0 - 1.354497354497355e-01*G0_1_1 - 4.514991181657840e-02*G0_1_2 + 6.772486772486778e-02*G0_2_0 + 2.257495590828928e-01*G0_2_1 - 1.354497354497349e-01*G0_2_2;
    block[830] = 6.772486772486741e-02*G0_0_1 - 6.772486772486733e-02*G0_0_2 + 6.772486772486776e-02*G0_1_0 + 4.514991181657872e-02*G0_1_2 - 6.772486772486773e-02*G0_2_0 + 4.514991181657827e-02*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[831] = -5.417989417989409e-01*G0_0_0 - 2.708994708994705e-01*G0_0_1 - 2.708994708994708e-01*G0_0_2 - 2.708994708994709e-01*G0_1_0 - 1.354497354497355e-01*G0_1_2 - 2.708994708994705e-01*G0_2_0 - 1.354497354497353e-01*G0_2_1 + 4.514991181657838e-02*G0_2_2;
    block[832] = 1.354497354497357e-01*G0_0_0 + 6.772486772486767e-02*G0_0_1 + 9.029982363315707e-02*G0_0_2 + 6.772486772486777e-02*G0_1_0 + 4.514991181657829e-02*G0_1_2 + 9.029982363315706e-02*G0_2_0 + 4.514991181657855e-02*G0_2_1 + 4.514991181657869e-02*G0_2_2;
    block[833] = -2.708994708994707e-01*G0_0_1 - 1.354497354497355e-01*G0_0_2 - 2.708994708994705e-01*G0_1_0 - 5.417989417989418e-01*G0_1_1 - 2.708994708994706e-01*G0_1_2 - 1.354497354497357e-01*G0_2_0 - 2.708994708994709e-01*G0_2_1 + 4.514991181657856e-02*G0_2_2;
    block[834] = 6.772486772486710e-02*G0_0_1 + 4.514991181657813e-02*G0_0_2 + 6.772486772486766e-02*G0_1_0 - 6.772486772486791e-02*G0_1_2 + 4.514991181657890e-02*G0_2_0 - 6.772486772486812e-02*G0_2_1 - 1.354497354497356e-01*G0_2_2;
    block[835] = 6.772486772486812e-02*G0_0_1 + 4.514991181657881e-02*G0_0_2 + 6.772486772486738e-02*G0_1_0 + 1.354497354497354e-01*G0_1_1 + 9.029982363315665e-02*G0_1_2 + 4.514991181657840e-02*G0_2_0 + 9.029982363315696e-02*G0_2_1 + 4.514991181657850e-02*G0_2_2;
    block[836] = 2.257495590828937e-02*G0_0_1 + 4.514991181657869e-02*G0_0_2 + 2.257495590828923e-02*G0_1_0 + 4.514991181657870e-02*G0_1_2 + 4.514991181657848e-02*G0_2_0 + 4.514991181657857e-02*G0_2_1 + 9.029982363315704e-02*G0_2_2;
    block[837] = 2.257495590828909e-02*G0_0_1 + 4.514991181657815e-02*G0_0_2 + 2.257495590828901e-02*G0_1_0 + 6.772486772486742e-02*G0_1_2 + 4.514991181657842e-02*G0_2_0 + 6.772486772486740e-02*G0_2_1 + 1.354497354497348e-01*G0_2_2;
    block[838] = 2.257495590828903e-02*G0_0_1 + 6.772486772486735e-02*G0_0_2 + 2.257495590828935e-02*G0_1_0 + 4.514991181657836e-02*G0_1_2 + 6.772486772486755e-02*G0_2_0 + 4.514991181657837e-02*G0_2_1 + 1.354497354497348e-01*G0_2_2;
    block[839] = -1.354497354497356e-01*G0_0_1 - 3.160493827160493e-01*G0_0_2 - 1.354497354497359e-01*G0_1_0 - 3.160493827160499e-01*G0_1_2 - 3.160493827160503e-01*G0_2_0 - 3.160493827160497e-01*G0_2_1 - 7.223985890652558e-01*G0_2_2;
    block[840] = 1.834215167548504e-02*G0_0_0 + 1.834215167548505e-02*G0_0_1 + 1.834215167548503e-02*G0_0_2 + 1.834215167548499e-02*G0_1_0 + 1.834215167548501e-02*G0_1_1 + 1.834215167548500e-02*G0_1_2 + 1.834215167548501e-02*G0_2_0 + 1.834215167548504e-02*G0_2_1 + 1.834215167548498e-02*G0_2_2;
    block[841] = -1.834215167548498e-02*G0_0_0 + 7.054673721340432e-03*G0_1_0 + 7.054673721340389e-03*G0_2_0;
    block[842] = 7.054673721340357e-03*G0_0_1 + 4.938271604938275e-02*G0_1_1 + 7.054673721340475e-03*G0_2_1;
    block[843] = 7.054673721340397e-03*G0_0_2 + 7.054673721340403e-03*G0_1_2 - 1.834215167548504e-02*G0_2_2;
    block[844] = 6.772486772486770e-02*G0_0_0 + 1.128747795414476e-02*G0_0_1 - 3.386243386243389e-02*G0_1_0 - 2.257495590828910e-02*G0_1_1 - 6.772486772486754e-02*G0_2_0 - 2.257495590828905e-02*G0_2_1;
    block[845] = -8.465608465608461e-02*G0_0_0 - 4.232804232804254e-02*G0_0_1 + 9.312169312169301e-02*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 1.862433862433857e-01*G0_2_0 + 5.079365079365054e-02*G0_2_1;
    block[846] = 1.128747795414461e-01*G0_0_0 + 1.015873015873016e-01*G0_0_1 + 1.128747795414460e-02*G0_1_0 - 6.772486772486788e-02*G0_1_1 + 1.128747795414462e-01*G0_2_0 + 2.031746031746029e-01*G0_2_1;
    block[847] = -1.128747795414462e-01*G0_0_0 - 1.128747795414473e-02*G0_0_1 - 1.128747795414463e-01*G0_0_2 - 1.128747795414467e-02*G0_1_0 - 4.514991181657865e-02*G0_1_1 - 1.128747795414466e-02*G0_1_2 - 1.128747795414463e-01*G0_2_0 - 1.128747795414492e-02*G0_2_1 - 1.128747795414462e-01*G0_2_2;
    block[848] = 8.465608465608492e-02*G0_0_0 + 4.232804232804242e-02*G0_0_1 + 8.465608465608494e-02*G0_0_2 + 4.232804232804249e-02*G0_1_0 + 2.257495590828938e-02*G0_1_1 + 4.232804232804247e-02*G0_1_2 + 8.465608465608482e-02*G0_2_0 + 4.232804232804260e-02*G0_2_1 + 8.465608465608486e-02*G0_2_2;
    block[849] = -6.772486772486784e-02*G0_0_0 - 5.643738977072316e-02*G0_0_1 - 6.772486772486792e-02*G0_0_2 - 5.643738977072321e-02*G0_1_0 - 4.514991181657850e-02*G0_1_1 - 5.643738977072320e-02*G0_1_2 - 6.772486772486766e-02*G0_2_0 - 5.643738977072322e-02*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[850] = -1.128747795414474e-02*G0_0_1 - 1.128747795414481e-02*G0_0_2 - 1.128747795414457e-02*G0_1_0 - 2.257495590828936e-02*G0_1_1 - 2.257495590828934e-02*G0_1_2 - 1.128747795414461e-02*G0_2_0 - 2.257495590828914e-02*G0_2_1 - 2.257495590828915e-02*G0_2_2;
    block[851] = -2.821869488536355e-03*G0_0_1 - 2.821869488536310e-03*G0_0_2 - 2.821869488536228e-03*G0_1_0 + 1.693121693121683e-02*G0_1_1 + 1.693121693121680e-02*G0_1_2 - 2.821869488536170e-03*G0_2_0 + 1.693121693121683e-02*G0_2_1 + 1.693121693121682e-02*G0_2_2;
    block[852] = -1.128747795414476e-02*G0_0_1 - 1.128747795414476e-02*G0_0_2 - 1.128747795414465e-02*G0_1_0 + 2.257495590828920e-02*G0_1_1 + 2.257495590828919e-02*G0_1_2 - 1.128747795414464e-02*G0_2_0 + 2.257495590828913e-02*G0_2_1 + 2.257495590828912e-02*G0_2_2;
    block[853] = -2.257495590828937e-02*G0_0_0 - 2.257495590828934e-02*G0_0_1 - 1.128747795414473e-02*G0_0_2 - 2.257495590828941e-02*G0_1_0 - 2.257495590828939e-02*G0_1_1 - 1.128747795414460e-02*G0_1_2 - 1.128747795414456e-02*G0_2_0 - 1.128747795414453e-02*G0_2_1;
    block[854] = 1.693121693121705e-02*G0_0_0 + 1.693121693121698e-02*G0_0_1 - 2.821869488536124e-03*G0_0_2 + 1.693121693121717e-02*G0_1_0 + 1.693121693121715e-02*G0_1_1 - 2.821869488536113e-03*G0_1_2 - 2.821869488536225e-03*G0_2_0 - 2.821869488536288e-03*G0_2_1;
    block[855] = 2.257495590828889e-02*G0_0_0 + 2.257495590828908e-02*G0_0_1 - 1.128747795414478e-02*G0_0_2 + 2.257495590828918e-02*G0_1_0 + 2.257495590828921e-02*G0_1_1 - 1.128747795414480e-02*G0_1_2 - 1.128747795414474e-02*G0_2_0 - 1.128747795414465e-02*G0_2_1;
    block[856] = 2.257495590828936e-02*G0_0_0 + 1.128747795414483e-02*G0_0_2 - 6.772486772486770e-02*G0_1_0 - 2.257495590828915e-02*G0_1_2 - 3.386243386243366e-02*G0_2_0 - 2.257495590828906e-02*G0_2_2;
    block[857] = -1.693121693121697e-02*G0_0_0 - 1.975308641975322e-02*G0_0_2 - 8.465608465608444e-02*G0_1_0 - 8.465608465608453e-02*G0_1_2 - 1.975308641975309e-02*G0_2_0 - 1.693121693121699e-02*G0_2_2;
    block[858] = -2.257495590828916e-02*G0_0_0 - 3.386243386243376e-02*G0_0_2 - 2.257495590828934e-02*G0_1_0 - 6.772486772486776e-02*G0_1_2 + 1.128747795414458e-02*G0_2_0 + 2.257495590828924e-02*G0_2_2;
    block[859] = 2.031746031746032e-01*G0_0_1 + 1.128747795414461e-01*G0_0_2 - 6.772486772486774e-02*G0_1_1 + 1.128747795414465e-02*G0_1_2 + 1.015873015873015e-01*G0_2_1 + 1.128747795414463e-01*G0_2_2;
    block[860] = 5.079365079365079e-02*G0_0_1 + 1.862433862433863e-01*G0_0_2 + 1.185185185185186e-01*G0_1_1 + 9.312169312169324e-02*G0_1_2 - 4.232804232804220e-02*G0_2_1 - 8.465608465608458e-02*G0_2_2;
    block[861] = -2.257495590828920e-02*G0_0_1 - 6.772486772486787e-02*G0_0_2 - 2.257495590828944e-02*G0_1_1 - 3.386243386243413e-02*G0_1_2 + 1.128747795414454e-02*G0_2_1 + 6.772486772486751e-02*G0_2_2;
    block[862] = -1.354497354497353e-01*G0_0_0 - 4.514991181657836e-02*G0_0_1 - 6.772486772486773e-02*G0_0_2 + 2.257495590828928e-01*G0_1_0 - 1.354497354497352e-01*G0_1_1 + 6.772486772486780e-02*G0_1_2 + 6.772486772486760e-02*G0_2_0 - 6.772486772486755e-02*G0_2_1;
    block[863] = -6.772486772486777e-02*G0_0_1 + 6.772486772486778e-02*G0_0_2 + 6.772486772486754e-02*G0_1_0 - 1.354497354497355e-01*G0_1_1 + 2.257495590828928e-01*G0_1_2 - 6.772486772486740e-02*G0_2_0 - 4.514991181657839e-02*G0_2_1 - 1.354497354497349e-01*G0_2_2;
    block[864] = 5.417989417989417e-01*G0_0_0 + 2.708994708994709e-01*G0_0_1 + 2.708994708994706e-01*G0_0_2 + 2.708994708994709e-01*G0_1_0 + 6.320987654320986e-01*G0_1_1 + 2.708994708994706e-01*G0_1_2 + 2.708994708994706e-01*G0_2_0 + 2.708994708994706e-01*G0_2_1 + 5.417989417989409e-01*G0_2_2;
    block[865] = -5.417989417989416e-01*G0_0_0 - 2.708994708994710e-01*G0_0_1 - 2.708994708994713e-01*G0_0_2 - 2.708994708994708e-01*G0_1_0 + 4.514991181657863e-02*G0_1_1 - 1.354497354497356e-01*G0_1_2 - 2.708994708994706e-01*G0_2_0 - 1.354497354497354e-01*G0_2_1;
    block[866] = -6.772486772486774e-02*G0_0_1 + 6.772486772486780e-02*G0_0_2 - 6.772486772486733e-02*G0_1_0 - 1.354497354497355e-01*G0_1_1 + 4.514991181657869e-02*G0_1_2 + 6.772486772486755e-02*G0_2_0 + 4.514991181657859e-02*G0_2_1;
    block[867] = 1.354497354497356e-01*G0_0_0 + 9.029982363315717e-02*G0_0_1 + 6.772486772486805e-02*G0_0_2 + 9.029982363315689e-02*G0_1_0 + 4.514991181657853e-02*G0_1_1 + 4.514991181657866e-02*G0_1_2 + 6.772486772486774e-02*G0_2_0 + 4.514991181657838e-02*G0_2_1;
    block[868] = 6.772486772486773e-02*G0_0_1 + 2.257495590828906e-02*G0_0_2 + 6.772486772486740e-02*G0_1_0 + 1.354497354497356e-01*G0_1_1 + 4.514991181657839e-02*G0_1_2 + 2.257495590828934e-02*G0_2_0 + 4.514991181657833e-02*G0_2_1;
    block[869] = 4.514991181657815e-02*G0_0_1 + 2.257495590828936e-02*G0_0_2 + 4.514991181657860e-02*G0_1_0 + 1.354497354497351e-01*G0_1_1 + 6.772486772486762e-02*G0_1_2 + 2.257495590828919e-02*G0_2_0 + 6.772486772486738e-02*G0_2_1;
    block[870] = 4.514991181657844e-02*G0_0_1 + 2.257495590828954e-02*G0_0_2 + 4.514991181657865e-02*G0_1_0 + 9.029982363315697e-02*G0_1_1 + 4.514991181657880e-02*G0_1_2 + 2.257495590828905e-02*G0_2_0 + 4.514991181657844e-02*G0_2_1;
    block[871] = 4.514991181657876e-02*G0_0_1 + 6.772486772486755e-02*G0_0_2 + 4.514991181657831e-02*G0_1_0 + 4.514991181657858e-02*G0_1_1 + 9.029982363315668e-02*G0_1_2 + 6.772486772486751e-02*G0_2_0 + 9.029982363315688e-02*G0_2_1 + 1.354497354497353e-01*G0_2_2;
    block[872] = 4.514991181657883e-02*G0_0_1 + 6.772486772486763e-02*G0_0_2 + 4.514991181657875e-02*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 6.772486772486785e-02*G0_1_2 + 6.772486772486776e-02*G0_2_0 - 6.772486772486748e-02*G0_2_1;
    block[873] = -1.354497354497355e-01*G0_0_1 - 2.708994708994705e-01*G0_0_2 - 1.354497354497354e-01*G0_1_0 + 4.514991181657890e-02*G0_1_1 - 2.708994708994706e-01*G0_1_2 - 2.708994708994706e-01*G0_2_0 - 2.708994708994706e-01*G0_2_1 - 5.417989417989409e-01*G0_2_2;
    block[874] = -3.160493827160489e-01*G0_0_1 - 1.354497354497352e-01*G0_0_2 - 3.160493827160497e-01*G0_1_0 - 7.223985890652561e-01*G0_1_1 - 3.160493827160493e-01*G0_1_2 - 1.354497354497354e-01*G0_2_0 - 3.160493827160488e-01*G0_2_1;
    block[875] = -1.834215167548504e-02*G0_0_0 - 1.834215167548505e-02*G0_0_1 - 1.834215167548504e-02*G0_0_2 - 2.539682539682538e-02*G0_1_0 - 2.539682539682542e-02*G0_1_1 - 2.539682539682539e-02*G0_1_2 - 2.539682539682539e-02*G0_2_0 - 2.539682539682542e-02*G0_2_1 - 2.539682539682545e-02*G0_2_2;
    block[876] = 1.834215167548500e-02*G0_0_0;
    block[877] = -7.054673721340359e-03*G0_0_1 + 4.232804232804235e-02*G0_1_1;
    block[878] = -7.054673721340400e-03*G0_0_2 - 2.539682539682546e-02*G0_2_2;
    block[879] = -6.772486772486770e-02*G0_0_0 - 1.128747795414480e-02*G0_0_1 - 1.128747795414452e-02*G0_1_0;
    block[880] = 8.465608465608464e-02*G0_0_0 + 4.232804232804255e-02*G0_0_1 + 4.232804232804230e-02*G0_1_0 + 2.257495590828937e-02*G0_1_1;
    block[881] = -1.128747795414461e-01*G0_0_0 - 1.015873015873016e-01*G0_0_1 - 1.015873015873017e-01*G0_1_0 - 1.354497354497356e-01*G0_1_1;
    block[882] = 1.128747795414462e-01*G0_0_0 + 1.128747795414474e-02*G0_0_1 + 1.128747795414463e-01*G0_0_2 + 1.015873015873018e-01*G0_1_0 - 6.772486772486755e-02*G0_1_1 + 1.015873015873018e-01*G0_1_2 + 1.015873015873013e-01*G0_2_1;
    block[883] = -8.465608465608490e-02*G0_0_0 - 4.232804232804243e-02*G0_0_1 - 8.465608465608493e-02*G0_0_2 - 1.777777777777781e-01*G0_1_0 - 1.693121693121693e-02*G0_1_1 - 1.777777777777781e-01*G0_1_2 - 2.708994708994706e-01*G0_2_0 - 1.777777777777773e-01*G0_2_1 - 2.708994708994706e-01*G0_2_2;
    block[884] = 6.772486772486787e-02*G0_0_0 + 5.643738977072317e-02*G0_0_1 + 6.772486772486794e-02*G0_0_2 + 1.015873015873017e-01*G0_1_0 + 6.772486772486763e-02*G0_1_1 + 1.015873015873018e-01*G0_1_2 + 1.354497354497354e-01*G0_2_0 + 1.015873015873014e-01*G0_2_1 + 1.354497354497355e-01*G0_2_2;
    block[885] = 1.128747795414476e-02*G0_0_1 + 1.128747795414484e-02*G0_0_2 + 1.128747795414452e-02*G0_1_0 + 4.514991181657872e-02*G0_1_1 + 4.514991181657878e-02*G0_1_2 + 1.128747795414458e-02*G0_2_0 + 4.514991181657865e-02*G0_2_1 + 4.514991181657866e-02*G0_2_2;
    block[886] = 2.821869488536300e-03*G0_0_1 + 2.821869488536253e-03*G0_0_2 + 2.821869488536155e-03*G0_1_0 + 2.257495590828936e-02*G0_1_1 + 2.257495590828930e-02*G0_1_2 + 2.821869488536182e-03*G0_2_0 + 2.257495590828935e-02*G0_2_1 + 2.257495590828932e-02*G0_2_2;
    block[887] = 1.128747795414479e-02*G0_0_1 + 1.128747795414480e-02*G0_0_2 + 1.128747795414470e-02*G0_1_0 + 1.128747795414463e-02*G0_2_0;
    block[888] = 2.257495590828939e-02*G0_0_0 + 2.257495590828935e-02*G0_0_1 + 1.128747795414474e-02*G0_0_2 + 9.029982363315707e-02*G0_1_0 + 9.029982363315699e-02*G0_1_1 + 5.643738977072303e-02*G0_1_2 + 5.643738977072325e-02*G0_2_0 + 5.643738977072323e-02*G0_2_1 + 2.257495590828930e-02*G0_2_2;
    block[889] = -1.693121693121702e-02*G0_0_0 - 1.693121693121697e-02*G0_0_1 + 2.821869488536130e-03*G0_0_2 + 6.772486772486767e-02*G0_1_0 + 6.772486772486777e-02*G0_1_1 + 2.821869488536363e-03*G0_1_2 + 2.821869488536059e-03*G0_2_0 + 2.821869488536097e-03*G0_2_1 + 5.643738977072251e-03*G0_2_2;
    block[890] = -2.257495590828888e-02*G0_0_0 - 2.257495590828907e-02*G0_0_1 + 1.128747795414478e-02*G0_0_2 - 3.386243386243381e-02*G0_1_2 - 3.386243386243365e-02*G0_2_0 - 3.386243386243368e-02*G0_2_1 + 2.257495590828944e-02*G0_2_2;
    block[891] = -2.257495590828944e-02*G0_0_0 - 1.128747795414487e-02*G0_0_2 - 1.128747795414474e-02*G0_2_0;
    block[892] = 1.693121693121701e-02*G0_0_0 + 1.975308641975322e-02*G0_0_2 + 1.975308641975314e-02*G0_2_0 + 2.257495590828925e-02*G0_2_2;
    block[893] = 2.257495590828915e-02*G0_0_0 + 3.386243386243375e-02*G0_0_2 + 3.386243386243377e-02*G0_2_0 + 4.514991181657842e-02*G0_2_2;
    block[894] = -2.031746031746032e-01*G0_0_1 - 1.128747795414461e-01*G0_0_2 - 2.708994708994709e-01*G0_1_1 - 1.015873015873017e-01*G0_1_2 - 1.015873015873018e-01*G0_2_1;
    block[895] = -5.079365079365079e-02*G0_0_1 - 1.862433862433863e-01*G0_0_2 + 6.772486772486766e-02*G0_1_1 - 9.312169312169315e-02*G0_1_2 - 9.312169312169295e-02*G0_2_1 - 2.708994708994708e-01*G0_2_2;
    block[896] = 2.257495590828919e-02*G0_0_1 + 6.772486772486785e-02*G0_0_2 + 3.386243386243382e-02*G0_1_2 + 3.386243386243381e-02*G0_2_1 + 1.354497354497355e-01*G0_2_2;
    block[897] = 1.354497354497353e-01*G0_0_0 + 4.514991181657829e-02*G0_0_1 + 6.772486772486769e-02*G0_0_2 + 4.514991181657874e-02*G0_1_0 + 2.257495590828948e-02*G0_1_2 + 6.772486772486754e-02*G0_2_0 + 2.257495590828901e-02*G0_2_1;
    block[898] = 6.772486772486776e-02*G0_0_1 - 6.772486772486772e-02*G0_0_2 + 6.772486772486740e-02*G0_1_0 + 4.514991181657829e-02*G0_1_2 - 6.772486772486731e-02*G0_2_0 + 4.514991181657872e-02*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[899] = -5.417989417989416e-01*G0_0_0 - 2.708994708994708e-01*G0_0_1 - 2.708994708994706e-01*G0_0_2 - 2.708994708994710e-01*G0_1_0 + 4.514991181657863e-02*G0_1_1 - 1.354497354497354e-01*G0_1_2 - 2.708994708994713e-01*G0_2_0 - 1.354497354497356e-01*G0_2_1;
    block[900] = 5.417989417989416e-01*G0_0_0 + 2.708994708994710e-01*G0_0_1 + 2.708994708994713e-01*G0_0_2 + 2.708994708994710e-01*G0_1_0 + 6.320987654320991e-01*G0_1_1 + 2.708994708994713e-01*G0_1_2 + 2.708994708994713e-01*G0_2_0 + 2.708994708994713e-01*G0_2_1 + 5.417989417989413e-01*G0_2_2;
    block[901] = 6.772486772486767e-02*G0_0_1 - 6.772486772486787e-02*G0_0_2 - 6.772486772486752e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 + 9.029982363315699e-02*G0_1_2 + 6.772486772486717e-02*G0_2_0 + 9.029982363315685e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[902] = -1.354497354497355e-01*G0_0_0 - 9.029982363315711e-02*G0_0_1 - 6.772486772486801e-02*G0_0_2 - 3.611992945326281e-01*G0_1_0 - 4.514991181657851e-01*G0_1_1 - 2.257495590828926e-01*G0_1_2 - 2.031746031746035e-01*G0_2_0 - 2.257495590828927e-01*G0_2_1 - 1.354497354497357e-01*G0_2_2;
    block[903] = -6.772486772486776e-02*G0_0_1 - 2.257495590828903e-02*G0_0_2 - 6.772486772486766e-02*G0_1_0 - 4.514991181657829e-02*G0_1_2 - 2.257495590828918e-02*G0_2_0 - 4.514991181657877e-02*G0_2_1 - 4.514991181657835e-02*G0_2_2;
    block[904] = -4.514991181657810e-02*G0_0_1 - 2.257495590828930e-02*G0_0_2 - 4.514991181657848e-02*G0_1_0 - 2.257495590828916e-02*G0_1_2 - 2.257495590828913e-02*G0_2_0 - 2.257495590828886e-02*G0_2_1 - 4.514991181657853e-02*G0_2_2;
    block[905] = -4.514991181657851e-02*G0_0_1 - 2.257495590828960e-02*G0_0_2 - 4.514991181657858e-02*G0_1_0 + 4.514991181657829e-02*G0_1_1 - 2.257495590828949e-02*G0_2_0 - 4.514991181657887e-02*G0_2_2;
    block[906] = -4.514991181657876e-02*G0_0_1 - 6.772486772486760e-02*G0_0_2 - 4.514991181657836e-02*G0_1_0 - 2.257495590828929e-01*G0_1_1 - 1.805996472663140e-01*G0_1_2 - 6.772486772486747e-02*G0_2_0 - 1.805996472663143e-01*G0_2_1 - 1.354497354497354e-01*G0_2_2;
    block[907] = -4.514991181657877e-02*G0_0_1 - 6.772486772486756e-02*G0_0_2 - 4.514991181657883e-02*G0_1_0 - 4.514991181657869e-02*G0_1_1 - 2.257495590828928e-02*G0_1_2 - 6.772486772486781e-02*G0_2_0 - 2.257495590828928e-02*G0_2_1;
    block[908] = 1.354497354497355e-01*G0_0_1 + 2.708994708994704e-01*G0_0_2 + 1.354497354497358e-01*G0_1_0 + 3.160493827160498e-01*G0_1_1 + 1.354497354497352e-01*G0_1_2 + 2.708994708994707e-01*G0_2_0 + 1.354497354497357e-01*G0_2_1;
    block[909] = 3.160493827160489e-01*G0_0_1 + 1.354497354497351e-01*G0_0_2 + 3.160493827160493e-01*G0_1_0 - 9.029982363315731e-02*G0_1_1 + 1.354497354497355e-01*G0_1_2 + 1.354497354497359e-01*G0_2_0 + 1.354497354497355e-01*G0_2_1 + 2.708994708994703e-01*G0_2_2;
    block[910] = -1.834215167548495e-02*G0_0_0 - 1.834215167548497e-02*G0_0_1 - 1.834215167548498e-02*G0_0_2 - 2.539682539682540e-02*G0_1_0 - 2.539682539682540e-02*G0_1_1 - 2.539682539682542e-02*G0_1_2 - 2.539682539682536e-02*G0_2_0 - 2.539682539682538e-02*G0_2_1 - 2.539682539682536e-02*G0_2_2;
    block[911] = 1.834215167548500e-02*G0_0_0;
    block[912] = -7.054673721340297e-03*G0_0_1 - 2.539682539682531e-02*G0_1_1;
    block[913] = -7.054673721340415e-03*G0_0_2 + 4.232804232804225e-02*G0_2_2;
    block[914] = -2.257495590828923e-02*G0_0_0 - 1.128747795414460e-02*G0_0_1 - 1.128747795414476e-02*G0_1_0;
    block[915] = 1.693121693121680e-02*G0_0_0 + 1.975308641975303e-02*G0_0_1 + 1.975308641975303e-02*G0_1_0 + 2.257495590828917e-02*G0_1_1;
    block[916] = 2.257495590828926e-02*G0_0_0 + 3.386243386243367e-02*G0_0_1 + 3.386243386243398e-02*G0_1_0 + 4.514991181657858e-02*G0_1_1;
    block[917] = -2.257495590828921e-02*G0_0_0 + 1.128747795414434e-02*G0_0_1 - 2.257495590828917e-02*G0_0_2 - 3.386243386243395e-02*G0_1_0 + 2.257495590828902e-02*G0_1_1 - 3.386243386243391e-02*G0_1_2 - 3.386243386243396e-02*G0_2_1;
    block[918] = -1.693121693121670e-02*G0_0_0 + 2.821869488536522e-03*G0_0_1 - 1.693121693121672e-02*G0_0_2 + 2.821869488536298e-03*G0_1_0 + 5.643738977072588e-03*G0_1_1 + 2.821869488536291e-03*G0_1_2 + 6.772486772486762e-02*G0_2_0 + 2.821869488536415e-03*G0_2_1 + 6.772486772486762e-02*G0_2_2;
    block[919] = 2.257495590828918e-02*G0_0_0 + 1.128747795414444e-02*G0_0_1 + 2.257495590828917e-02*G0_0_2 + 5.643738977072289e-02*G0_1_0 + 2.257495590828914e-02*G0_1_1 + 5.643738977072296e-02*G0_1_2 + 9.029982363315671e-02*G0_2_0 + 5.643738977072289e-02*G0_2_1 + 9.029982363315671e-02*G0_2_2;
    block[920] = 1.128747795414467e-02*G0_0_1 + 1.128747795414471e-02*G0_0_2 + 1.128747795414457e-02*G0_1_0 + 4.514991181657840e-02*G0_1_1 + 4.514991181657840e-02*G0_1_2 + 1.128747795414454e-02*G0_2_0 + 4.514991181657838e-02*G0_2_1 + 4.514991181657840e-02*G0_2_2;
    block[921] = 2.821869488536157e-03*G0_0_1 + 2.821869488536126e-03*G0_0_2 + 2.821869488536282e-03*G0_1_0 + 2.257495590828927e-02*G0_1_1 + 2.257495590828928e-02*G0_1_2 + 2.821869488536234e-03*G0_2_0 + 2.257495590828925e-02*G0_2_1 + 2.257495590828927e-02*G0_2_2;
    block[922] = 1.128747795414458e-02*G0_0_1 + 1.128747795414460e-02*G0_0_2 + 1.128747795414452e-02*G0_1_0 + 1.128747795414454e-02*G0_2_0;
    block[923] = 6.772486772486770e-02*G0_0_0 + 6.772486772486772e-02*G0_0_1 + 5.643738977072306e-02*G0_0_2 + 1.354497354497353e-01*G0_1_0 + 1.354497354497353e-01*G0_1_1 + 1.015873015873016e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0 + 1.015873015873015e-01*G0_2_1 + 6.772486772486765e-02*G0_2_2;
    block[924] = -8.465608465608465e-02*G0_0_0 - 8.465608465608467e-02*G0_0_1 - 4.232804232804221e-02*G0_0_2 - 2.708994708994705e-01*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 1.777777777777777e-01*G0_1_2 - 1.777777777777775e-01*G0_2_0 - 1.777777777777775e-01*G0_2_1 - 1.693121693121681e-02*G0_2_2;
    block[925] = 1.128747795414463e-01*G0_0_0 + 1.128747795414462e-01*G0_0_1 + 1.128747795414463e-02*G0_0_2 + 1.015873015873016e-01*G0_1_2 + 1.015873015873016e-01*G0_2_0 + 1.015873015873016e-01*G0_2_1 - 6.772486772486758e-02*G0_2_2;
    block[926] = -6.772486772486763e-02*G0_0_0 - 1.128747795414458e-02*G0_0_2 - 1.128747795414474e-02*G0_2_0;
    block[927] = 8.465608465608435e-02*G0_0_0 + 4.232804232804205e-02*G0_0_2 + 4.232804232804240e-02*G0_2_0 + 2.257495590828917e-02*G0_2_2;
    block[928] = -1.128747795414462e-01*G0_0_0 - 1.015873015873015e-01*G0_0_2 - 1.015873015873016e-01*G0_2_0 - 1.354497354497353e-01*G0_2_2;
    block[929] = 6.772486772486754e-02*G0_0_1 + 2.257495590828915e-02*G0_0_2 + 1.354497354497354e-01*G0_1_1 + 3.386243386243393e-02*G0_1_2 + 3.386243386243383e-02*G0_2_1;
    block[930] = -1.862433862433857e-01*G0_0_1 - 5.079365079365043e-02*G0_0_2 - 2.708994708994709e-01*G0_1_1 - 9.312169312169322e-02*G0_1_2 - 9.312169312169301e-02*G0_2_1 + 6.772486772486773e-02*G0_2_2;
    block[931] = -1.128747795414462e-01*G0_0_1 - 2.031746031746032e-01*G0_0_2 - 1.015873015873013e-01*G0_1_2 - 1.015873015873015e-01*G0_2_1 - 2.708994708994708e-01*G0_2_2;
    block[932] = 1.354497354497349e-01*G0_0_0 + 6.772486772486729e-02*G0_0_1 + 4.514991181657832e-02*G0_0_2 + 6.772486772486762e-02*G0_1_0 + 2.257495590828904e-02*G0_1_2 + 4.514991181657871e-02*G0_2_0 + 2.257495590828928e-02*G0_2_1;
    block[933] = -5.417989417989409e-01*G0_0_0 - 2.708994708994710e-01*G0_0_1 - 2.708994708994705e-01*G0_0_2 - 2.708994708994704e-01*G0_1_0 - 1.354497354497353e-01*G0_1_2 - 2.708994708994708e-01*G0_2_0 - 1.354497354497355e-01*G0_2_1 + 4.514991181657838e-02*G0_2_2;
    block[934] = -6.772486772486734e-02*G0_0_1 + 6.772486772486755e-02*G0_0_2 - 6.772486772486774e-02*G0_1_0 - 1.354497354497355e-01*G0_1_1 + 4.514991181657859e-02*G0_1_2 + 6.772486772486781e-02*G0_2_0 + 4.514991181657869e-02*G0_2_1;
    block[935] = -6.772486772486751e-02*G0_0_1 + 6.772486772486717e-02*G0_0_2 + 6.772486772486770e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 + 9.029982363315685e-02*G0_1_2 - 6.772486772486788e-02*G0_2_0 + 9.029982363315701e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[936] = 5.417989417989409e-01*G0_0_0 + 2.708994708994704e-01*G0_0_1 + 2.708994708994709e-01*G0_0_2 + 2.708994708994704e-01*G0_1_0 + 5.417989417989415e-01*G0_1_1 + 2.708994708994705e-01*G0_1_2 + 2.708994708994709e-01*G0_2_0 + 2.708994708994705e-01*G0_2_1 + 6.320987654320980e-01*G0_2_2;
    block[937] = -1.354497354497356e-01*G0_0_0 - 6.772486772486767e-02*G0_0_1 - 9.029982363315703e-02*G0_0_2 - 2.031746031746029e-01*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 2.257495590828922e-01*G0_1_2 - 3.611992945326276e-01*G0_2_0 - 2.257495590828922e-01*G0_2_1 - 4.514991181657843e-01*G0_2_2;
    block[938] = 2.708994708994708e-01*G0_0_1 + 1.354497354497355e-01*G0_0_2 + 2.708994708994706e-01*G0_1_0 + 1.354497354497350e-01*G0_1_2 + 1.354497354497350e-01*G0_2_0 + 1.354497354497353e-01*G0_2_1 + 3.160493827160489e-01*G0_2_2;
    block[939] = -6.772486772486713e-02*G0_0_1 - 4.514991181657815e-02*G0_0_2 - 6.772486772486742e-02*G0_1_0 - 2.257495590828916e-02*G0_1_2 - 4.514991181657825e-02*G0_2_0 - 2.257495590828917e-02*G0_2_1 - 4.514991181657832e-02*G0_2_2;
    block[940] = -6.772486772486806e-02*G0_0_1 - 4.514991181657880e-02*G0_0_2 - 6.772486772486784e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 1.805996472663137e-01*G0_1_2 - 4.514991181657854e-02*G0_2_0 - 1.805996472663138e-01*G0_2_1 - 2.257495590828921e-01*G0_2_2;
    block[941] = -2.257495590828936e-02*G0_0_1 - 4.514991181657865e-02*G0_0_2 - 2.257495590828915e-02*G0_1_0 - 4.514991181657844e-02*G0_1_1 - 4.514991181657835e-02*G0_2_0 + 4.514991181657808e-02*G0_2_2;
    block[942] = -2.257495590828909e-02*G0_0_1 - 4.514991181657815e-02*G0_0_2 - 2.257495590828901e-02*G0_1_0 - 4.514991181657839e-02*G0_1_1 - 2.257495590828901e-02*G0_1_2 - 4.514991181657829e-02*G0_2_0 - 2.257495590828919e-02*G0_2_1;
    block[943] = -2.257495590828908e-02*G0_0_1 - 6.772486772486751e-02*G0_0_2 - 2.257495590828936e-02*G0_1_0 - 4.514991181657855e-02*G0_1_1 - 4.514991181657853e-02*G0_1_2 - 6.772486772486765e-02*G0_2_0 - 4.514991181657821e-02*G0_2_1;
    block[944] = 1.354497354497353e-01*G0_0_1 + 3.160493827160491e-01*G0_0_2 + 1.354497354497355e-01*G0_1_0 + 2.708994708994708e-01*G0_1_1 + 1.354497354497355e-01*G0_1_2 + 3.160493827160490e-01*G0_2_0 + 1.354497354497351e-01*G0_2_1 - 9.029982363315651e-02*G0_2_2;
    block[945] = 4.938271604938264e-02*G0_0_0 + 4.938271604938266e-02*G0_0_1 + 4.938271604938265e-02*G0_0_2 + 4.232804232804230e-02*G0_1_0 + 4.232804232804237e-02*G0_1_1 + 4.232804232804233e-02*G0_1_2 + 4.232804232804228e-02*G0_2_0 + 4.232804232804232e-02*G0_2_1 + 4.232804232804231e-02*G0_2_2;
    block[946] = 1.834215167548488e-02*G0_0_0;
    block[947] = -7.054673721340369e-03*G0_0_1 - 2.539682539682543e-02*G0_1_1;
    block[948] = -7.054673721340337e-03*G0_0_2 - 2.539682539682526e-02*G0_2_2;
    block[949] = -2.257495590828913e-02*G0_0_0 - 1.128747795414461e-02*G0_0_1 - 1.128747795414472e-02*G0_1_0;
    block[950] = 1.693121693121685e-02*G0_0_0 + 1.975308641975309e-02*G0_0_1 + 1.975308641975312e-02*G0_1_0 + 2.257495590828928e-02*G0_1_1;
    block[951] = 2.257495590828946e-02*G0_0_0 + 3.386243386243400e-02*G0_0_1 + 3.386243386243389e-02*G0_1_0 + 4.514991181657847e-02*G0_1_1;
    block[952] = -2.257495590828959e-02*G0_0_0 + 1.128747795414457e-02*G0_0_1 - 2.257495590828954e-02*G0_0_2 - 3.386243386243382e-02*G0_1_0 + 6.772486772486765e-02*G0_1_1 - 3.386243386243389e-02*G0_1_2 - 3.386243386243363e-02*G0_2_1;
    block[953] = 1.185185185185188e-01*G0_0_0 + 2.539682539682525e-02*G0_0_1 + 1.185185185185188e-01*G0_0_2 + 1.608465608465610e-01*G0_1_0 - 1.693121693121709e-02*G0_1_1 + 1.608465608465610e-01*G0_1_2 + 6.772486772486774e-02*G0_2_0 + 1.608465608465603e-01*G0_2_1 + 6.772486772486776e-02*G0_2_2;
    block[954] = -6.772486772486780e-02*G0_0_0 - 7.901234567901216e-02*G0_0_1 - 6.772486772486788e-02*G0_0_2 - 1.693121693121691e-01*G0_1_0 - 6.772486772486762e-02*G0_1_1 - 1.693121693121692e-01*G0_1_2 - 2.708994708994705e-01*G0_2_0 - 1.693121693121690e-01*G0_2_1 - 2.708994708994704e-01*G0_2_2;
    block[955] = -4.514991181657825e-02*G0_0_0 - 3.386243386243403e-02*G0_0_1 - 3.386243386243402e-02*G0_0_2 - 3.386243386243365e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 1.354497354497354e-01*G0_1_2 - 3.386243386243366e-02*G0_2_0 - 1.354497354497352e-01*G0_2_1 - 1.354497354497352e-01*G0_2_2;
    block[956] = 2.257495590828908e-02*G0_0_0 - 1.975308641975324e-02*G0_0_1 - 1.975308641975324e-02*G0_0_2 - 1.975308641975311e-02*G0_1_0 + 2.257495590828910e-02*G0_1_1 + 2.257495590828913e-02*G0_1_2 - 1.975308641975313e-02*G0_2_0 + 2.257495590828908e-02*G0_2_1 + 2.257495590828902e-02*G0_2_2;
    block[957] = -4.514991181657837e-02*G0_0_0 + 1.128747795414464e-02*G0_0_1 + 1.128747795414463e-02*G0_0_2 + 1.128747795414457e-02*G0_1_0 + 1.128747795414463e-02*G0_2_0;
    block[958] = -6.772486772486783e-02*G0_0_0 - 6.772486772486790e-02*G0_0_1 - 7.901234567901216e-02*G0_0_2 - 2.708994708994707e-01*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 1.693121693121691e-01*G0_1_2 - 1.693121693121692e-01*G0_2_0 - 1.693121693121691e-01*G0_2_1 - 6.772486772486769e-02*G0_2_2;
    block[959] = 1.185185185185183e-01*G0_0_0 + 1.185185185185183e-01*G0_0_1 + 2.539682539682519e-02*G0_0_2 + 6.772486772486744e-02*G0_1_0 + 6.772486772486734e-02*G0_1_1 + 1.608465608465604e-01*G0_1_2 + 1.608465608465604e-01*G0_2_0 + 1.608465608465604e-01*G0_2_1 - 1.693121693121708e-02*G0_2_2;
    block[960] = -2.257495590828944e-02*G0_0_0 - 2.257495590828946e-02*G0_0_1 + 1.128747795414453e-02*G0_0_2 - 3.386243386243389e-02*G0_1_2 - 3.386243386243384e-02*G0_2_0 - 3.386243386243387e-02*G0_2_1 + 6.772486772486747e-02*G0_2_2;
    block[961] = -2.257495590828898e-02*G0_0_0 - 1.128747795414459e-02*G0_0_2 - 1.128747795414451e-02*G0_2_0;
    block[962] = 1.693121693121668e-02*G0_0_0 + 1.975308641975302e-02*G0_0_2 + 1.975308641975282e-02*G0_2_0 + 2.257495590828927e-02*G0_2_2;
    block[963] = 2.257495590828939e-02*G0_0_0 + 3.386243386243387e-02*G0_0_2 + 3.386243386243381e-02*G0_2_0 + 4.514991181657825e-02*G0_2_2;
    block[964] = 6.772486772486781e-02*G0_0_1 + 2.257495590828953e-02*G0_0_2 + 9.029982363315699e-02*G0_1_1 + 3.386243386243389e-02*G0_1_2 + 3.386243386243395e-02*G0_2_1;
    block[965] = 8.465608465608472e-02*G0_0_1 + 8.465608465608457e-02*G0_0_2 + 6.772486772486777e-02*G0_1_1 + 6.490299823633168e-02*G0_1_2 + 6.490299823633165e-02*G0_2_1 + 6.772486772486784e-02*G0_2_2;
    block[966] = 2.257495590828929e-02*G0_0_1 + 6.772486772486781e-02*G0_0_2 + 3.386243386243367e-02*G0_1_2 + 3.386243386243373e-02*G0_2_1 + 9.029982363315674e-02*G0_2_2;
    block[967] = 9.029982363315642e-02*G0_0_0 + 4.514991181657833e-02*G0_0_1 + 4.514991181657831e-02*G0_0_2 + 4.514991181657815e-02*G0_1_0 + 2.257495590828897e-02*G0_1_2 + 4.514991181657801e-02*G0_2_0 + 2.257495590828895e-02*G0_2_1;
    block[968] = 1.354497354497357e-01*G0_0_0 + 6.772486772486777e-02*G0_0_1 + 9.029982363315701e-02*G0_0_2 + 6.772486772486767e-02*G0_1_0 + 4.514991181657856e-02*G0_1_2 + 9.029982363315706e-02*G0_2_0 + 4.514991181657828e-02*G0_2_1 + 4.514991181657870e-02*G0_2_2;
    block[969] = 1.354497354497356e-01*G0_0_0 + 9.029982363315689e-02*G0_0_1 + 6.772486772486776e-02*G0_0_2 + 9.029982363315719e-02*G0_1_0 + 4.514991181657851e-02*G0_1_1 + 4.514991181657838e-02*G0_1_2 + 6.772486772486805e-02*G0_2_0 + 4.514991181657865e-02*G0_2_1;
    block[970] = -1.354497354497355e-01*G0_0_0 - 3.611992945326281e-01*G0_0_1 - 2.031746031746035e-01*G0_0_2 - 9.029982363315710e-02*G0_1_0 - 4.514991181657851e-01*G0_1_1 - 2.257495590828927e-01*G0_1_2 - 6.772486772486802e-02*G0_2_0 - 2.257495590828926e-01*G0_2_1 - 1.354497354497357e-01*G0_2_2;
    block[971] = -1.354497354497356e-01*G0_0_0 - 2.031746031746029e-01*G0_0_1 - 3.611992945326275e-01*G0_0_2 - 6.772486772486766e-02*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 2.257495590828922e-01*G0_1_2 - 9.029982363315704e-02*G0_2_0 - 2.257495590828922e-01*G0_2_1 - 4.514991181657843e-01*G0_2_2;
    block[972] = 6.320987654320985e-01*G0_0_0 + 3.611992945326281e-01*G0_0_1 + 3.611992945326276e-01*G0_0_2 + 3.611992945326281e-01*G0_1_0 + 6.320987654320988e-01*G0_1_1 + 3.611992945326277e-01*G0_1_2 + 3.611992945326277e-01*G0_2_0 + 3.611992945326276e-01*G0_2_1 + 6.320987654320975e-01*G0_2_2;
    block[973] = -1.354497354497350e-01*G0_0_0 - 6.772486772486752e-02*G0_0_1 - 1.805996472663135e-01*G0_0_2 - 6.772486772486731e-02*G0_1_0 - 4.514991181657806e-02*G0_1_2 - 1.805996472663133e-01*G0_2_0 - 4.514991181657811e-02*G0_2_1 - 2.257495590828916e-01*G0_2_2;
    block[974] = 4.514991181657836e-02*G0_0_0 - 4.514991181657859e-02*G0_0_1 - 4.514991181657832e-02*G0_1_0 - 2.257495590828931e-02*G0_1_2 - 2.257495590828908e-02*G0_2_1 - 4.514991181657842e-02*G0_2_2;
    block[975] = 4.514991181657848e-02*G0_0_0 + 3.160493827160488e-01*G0_0_1 + 1.805996472663139e-01*G0_0_2 + 3.160493827160490e-01*G0_1_0 + 4.514991181657866e-02*G0_1_1 + 1.805996472663138e-01*G0_1_2 + 1.805996472663138e-01*G0_2_0 + 1.805996472663137e-01*G0_2_1 + 3.160493827160488e-01*G0_2_2;
    block[976] = 4.514991181657826e-02*G0_0_0 + 1.805996472663144e-01*G0_0_1 + 3.160493827160492e-01*G0_0_2 + 1.805996472663136e-01*G0_1_0 + 3.160493827160494e-01*G0_1_1 + 1.805996472663141e-01*G0_1_2 + 3.160493827160487e-01*G0_2_0 + 1.805996472663138e-01*G0_2_1 + 4.514991181657870e-02*G0_2_2;
    block[977] = 4.514991181657862e-02*G0_0_0 - 4.514991181657851e-02*G0_0_2 - 4.514991181657841e-02*G0_1_1 - 2.257495590828916e-02*G0_1_2 - 4.514991181657815e-02*G0_2_0 - 2.257495590828898e-02*G0_2_1;
    block[978] = -1.354497354497356e-01*G0_0_0 - 1.805996472663144e-01*G0_0_1 - 6.772486772486770e-02*G0_0_2 - 1.805996472663141e-01*G0_1_0 - 2.257495590828926e-01*G0_1_1 - 4.514991181657838e-02*G0_1_2 - 6.772486772486773e-02*G0_2_0 - 4.514991181657874e-02*G0_2_1;
    block[979] = -7.223985890652549e-01*G0_0_0 - 4.063492063492055e-01*G0_0_1 - 4.063492063492060e-01*G0_0_2 - 4.063492063492062e-01*G0_1_0 - 9.029982363315665e-02*G0_1_1 - 2.257495590828925e-01*G0_1_2 - 4.063492063492057e-01*G0_2_0 - 2.257495590828920e-01*G0_2_1 - 9.029982363315726e-02*G0_2_2;
    block[980] = -2.539682539682533e-02*G0_0_0 - 2.539682539682532e-02*G0_0_1 - 2.539682539682534e-02*G0_0_2 - 1.834215167548488e-02*G0_1_0 - 1.834215167548489e-02*G0_1_1 - 1.834215167548490e-02*G0_1_2 - 2.539682539682538e-02*G0_2_0 - 2.539682539682538e-02*G0_2_1 - 2.539682539682537e-02*G0_2_2;
    block[981] = -2.539682539682542e-02*G0_0_0 - 7.054673721340433e-03*G0_1_0;
    block[982] = 1.834215167548503e-02*G0_1_1;
    block[983] = -7.054673721340420e-03*G0_1_2 + 4.232804232804217e-02*G0_2_2;
    block[984] = 4.514991181657817e-02*G0_0_0 + 3.386243386243366e-02*G0_0_1 + 3.386243386243373e-02*G0_1_0 + 2.257495590828916e-02*G0_1_1;
    block[985] = 2.257495590828935e-02*G0_0_0 + 1.975308641975308e-02*G0_0_1 + 1.975308641975315e-02*G0_1_0 + 1.693121693121695e-02*G0_1_1;
    block[986] = -1.128747795414455e-02*G0_0_1 - 1.128747795414481e-02*G0_1_0 - 2.257495590828951e-02*G0_1_1;
    block[987] = 1.128747795414458e-02*G0_0_1 + 1.128747795414483e-02*G0_1_0 + 1.128747795414480e-02*G0_1_2 + 1.128747795414443e-02*G0_2_1;
    block[988] = 2.257495590828923e-02*G0_0_0 + 2.821869488536240e-03*G0_0_1 + 2.257495590828922e-02*G0_0_2 + 2.821869488536199e-03*G0_1_0 + 2.821869488536188e-03*G0_1_2 + 2.257495590828924e-02*G0_2_0 + 2.821869488536324e-03*G0_2_1 + 2.257495590828923e-02*G0_2_2;
    block[989] = 4.514991181657816e-02*G0_0_0 + 1.128747795414451e-02*G0_0_1 + 4.514991181657823e-02*G0_0_2 + 1.128747795414448e-02*G0_1_0 + 1.128747795414447e-02*G0_1_2 + 4.514991181657820e-02*G0_2_0 + 1.128747795414455e-02*G0_2_1 + 4.514991181657825e-02*G0_2_2;
    block[990] = 2.257495590828906e-02*G0_0_0 + 5.643738977072281e-02*G0_0_1 + 5.643738977072280e-02*G0_0_2 + 1.128747795414443e-02*G0_1_0 + 2.257495590828913e-02*G0_1_1 + 2.257495590828914e-02*G0_1_2 + 5.643738977072298e-02*G0_2_0 + 9.029982363315665e-02*G0_2_1 + 9.029982363315667e-02*G0_2_2;
    block[991] = 5.643738977072470e-03*G0_0_0 + 2.821869488536158e-03*G0_0_1 + 2.821869488536177e-03*G0_0_2 + 2.821869488536267e-03*G0_1_0 - 1.693121693121693e-02*G0_1_1 - 1.693121693121694e-02*G0_1_2 + 2.821869488536228e-03*G0_2_0 + 6.772486772486765e-02*G0_2_1 + 6.772486772486767e-02*G0_2_2;
    block[992] = 2.257495590828918e-02*G0_0_0 - 3.386243386243364e-02*G0_0_1 - 3.386243386243363e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 - 2.257495590828915e-02*G0_1_1 - 2.257495590828914e-02*G0_1_2 - 3.386243386243389e-02*G0_2_0;
    block[993] = 1.354497354497350e-01*G0_0_0 + 1.354497354497350e-01*G0_0_1 + 1.015873015873013e-01*G0_0_2 + 6.772486772486745e-02*G0_1_0 + 6.772486772486747e-02*G0_1_1 + 5.643738977072280e-02*G0_1_2 + 1.015873015873014e-01*G0_2_0 + 1.015873015873013e-01*G0_2_1 + 6.772486772486772e-02*G0_2_2;
    block[994] = -2.708994708994701e-01*G0_0_0 - 2.708994708994702e-01*G0_0_1 - 1.777777777777772e-01*G0_0_2 - 8.465608465608421e-02*G0_1_0 - 8.465608465608421e-02*G0_1_1 - 4.232804232804189e-02*G0_1_2 - 1.777777777777773e-01*G0_2_0 - 1.777777777777773e-01*G0_2_1 - 1.693121693121687e-02*G0_2_2;
    block[995] = 1.015873015873014e-01*G0_0_2 + 1.128747795414463e-01*G0_1_0 + 1.128747795414462e-01*G0_1_1 + 1.128747795414446e-02*G0_1_2 + 1.015873015873017e-01*G0_2_0 + 1.015873015873016e-01*G0_2_1 - 6.772486772486748e-02*G0_2_2;
    block[996] = 1.354497354497351e-01*G0_0_0 + 3.386243386243365e-02*G0_0_2 + 6.772486772486762e-02*G0_1_0 + 2.257495590828916e-02*G0_1_2 + 3.386243386243358e-02*G0_2_0;
    block[997] = -2.708994708994702e-01*G0_0_0 - 9.312169312169286e-02*G0_0_2 - 1.862433862433861e-01*G0_1_0 - 5.079365079365082e-02*G0_1_2 - 9.312169312169256e-02*G0_2_0 + 6.772486772486787e-02*G0_2_2;
    block[998] = -1.015873015873013e-01*G0_0_2 - 1.128747795414463e-01*G0_1_0 - 2.031746031746031e-01*G0_1_2 - 1.015873015873017e-01*G0_2_0 - 2.708994708994707e-01*G0_2_2;
    block[999] = -6.772486772486798e-02*G0_1_1 - 1.128747795414487e-02*G0_1_2 - 1.128747795414481e-02*G0_2_1;
    block[1000] = 8.465608465608501e-02*G0_1_1 + 4.232804232804272e-02*G0_1_2 + 4.232804232804247e-02*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[1001] = -1.128747795414463e-01*G0_1_1 - 1.015873015873017e-01*G0_1_2 - 1.015873015873017e-01*G0_2_1 - 1.354497354497354e-01*G0_2_2;
    block[1002] = -1.354497354497352e-01*G0_0_0 - 6.772486772486778e-02*G0_0_1 + 4.514991181657822e-02*G0_0_2 - 6.772486772486791e-02*G0_1_0 + 6.772486772486755e-02*G0_1_2 + 4.514991181657891e-02*G0_2_0 + 6.772486772486797e-02*G0_2_1;
    block[1003] = -2.708994708994705e-01*G0_0_1 - 1.354497354497357e-01*G0_0_2 - 2.708994708994708e-01*G0_1_0 - 5.417989417989418e-01*G0_1_1 - 2.708994708994709e-01*G0_1_2 - 1.354497354497355e-01*G0_2_0 - 2.708994708994706e-01*G0_2_1 + 4.514991181657856e-02*G0_2_2;
    block[1004] = 6.772486772486740e-02*G0_0_1 + 2.257495590828934e-02*G0_0_2 + 6.772486772486773e-02*G0_1_0 + 1.354497354497356e-01*G0_1_1 + 4.514991181657833e-02*G0_1_2 + 2.257495590828906e-02*G0_2_0 + 4.514991181657840e-02*G0_2_1;
    block[1005] = -6.772486772486765e-02*G0_0_1 - 2.257495590828918e-02*G0_0_2 - 6.772486772486777e-02*G0_1_0 - 4.514991181657877e-02*G0_1_2 - 2.257495590828903e-02*G0_2_0 - 4.514991181657829e-02*G0_2_1 - 4.514991181657835e-02*G0_2_2;
    block[1006] = 2.708994708994706e-01*G0_0_1 + 1.354497354497350e-01*G0_0_2 + 2.708994708994708e-01*G0_1_0 + 1.354497354497354e-01*G0_1_2 + 1.354497354497355e-01*G0_2_0 + 1.354497354497350e-01*G0_2_1 + 3.160493827160489e-01*G0_2_2;
    block[1007] = -1.354497354497350e-01*G0_0_0 - 6.772486772486731e-02*G0_0_1 - 1.805996472663133e-01*G0_0_2 - 6.772486772486752e-02*G0_1_0 - 4.514991181657812e-02*G0_1_2 - 1.805996472663135e-01*G0_2_0 - 4.514991181657806e-02*G0_2_1 - 2.257495590828916e-01*G0_2_2;
    block[1008] = 5.417989417989404e-01*G0_0_0 + 2.708994708994703e-01*G0_0_1 + 2.708994708994699e-01*G0_0_2 + 2.708994708994703e-01*G0_1_0 + 5.417989417989417e-01*G0_1_1 + 2.708994708994705e-01*G0_1_2 + 2.708994708994699e-01*G0_2_0 + 2.708994708994704e-01*G0_2_1 + 6.320987654320976e-01*G0_2_2;
    block[1009] = -1.354497354497353e-01*G0_0_0 + 6.772486772486778e-02*G0_0_1 + 9.029982363315672e-02*G0_0_2 - 6.772486772486784e-02*G0_1_0 + 6.772486772486778e-02*G0_1_2 + 9.029982363315713e-02*G0_2_0 - 6.772486772486774e-02*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[1010] = -1.354497354497348e-01*G0_0_0 - 2.031746031746026e-01*G0_0_1 - 2.257495590828913e-01*G0_0_2 - 6.772486772486719e-02*G0_1_0 - 1.354497354497351e-01*G0_1_1 - 9.029982363315639e-02*G0_1_2 - 2.257495590828919e-01*G0_2_0 - 3.611992945326273e-01*G0_2_1 - 4.514991181657837e-01*G0_2_2;
    block[1011] = -4.514991181657817e-02*G0_0_0 - 2.257495590828901e-02*G0_0_1 - 2.257495590828910e-02*G0_1_0 - 4.514991181657849e-02*G0_1_2 - 4.514991181657836e-02*G0_2_1 + 4.514991181657816e-02*G0_2_2;
    block[1012] = -4.514991181657819e-02*G0_0_0 - 2.257495590828929e-02*G0_0_1 - 4.514991181657817e-02*G0_0_2 - 2.257495590828908e-02*G0_1_0 - 6.772486772486742e-02*G0_1_2 - 4.514991181657815e-02*G0_2_0 - 6.772486772486766e-02*G0_2_1;
    block[1013] = -4.514991181657852e-02*G0_0_0 - 2.257495590828922e-02*G0_0_1 - 2.257495590828930e-02*G0_0_2 - 2.257495590828936e-02*G0_1_0 - 4.514991181657829e-02*G0_1_2 - 2.257495590828935e-02*G0_2_0 - 4.514991181657831e-02*G0_2_1;
    block[1014] = 2.708994708994704e-01*G0_0_0 + 1.354497354497352e-01*G0_0_1 + 1.354497354497358e-01*G0_0_2 + 1.354497354497356e-01*G0_1_0 + 3.160493827160494e-01*G0_1_2 + 1.354497354497348e-01*G0_2_0 + 3.160493827160487e-01*G0_2_1 - 9.029982363315667e-02*G0_2_2;
    block[1015] = -2.539682539682536e-02*G0_0_0 - 2.539682539682536e-02*G0_0_1 - 2.539682539682532e-02*G0_0_2 - 1.834215167548486e-02*G0_1_0 - 1.834215167548486e-02*G0_1_1 - 1.834215167548485e-02*G0_1_2 - 2.539682539682533e-02*G0_2_0 - 2.539682539682533e-02*G0_2_1 - 2.539682539682534e-02*G0_2_2;
    block[1016] = 4.232804232804235e-02*G0_0_0 - 7.054673721340379e-03*G0_1_0;
    block[1017] = 1.834215167548504e-02*G0_1_1;
    block[1018] = -7.054673721340316e-03*G0_1_2 - 2.539682539682530e-02*G0_2_2;
    block[1019] = -1.354497354497353e-01*G0_0_0 - 1.015873015873015e-01*G0_0_1 - 1.015873015873013e-01*G0_1_0 - 1.128747795414461e-01*G0_1_1;
    block[1020] = 2.257495590828915e-02*G0_0_0 + 4.232804232804233e-02*G0_0_1 + 4.232804232804213e-02*G0_1_0 + 8.465608465608472e-02*G0_1_1;
    block[1021] = -1.128747795414465e-02*G0_0_1 - 1.128747795414461e-02*G0_1_0 - 6.772486772486787e-02*G0_1_1;
    block[1022] = 1.128747795414448e-02*G0_0_1 + 1.128747795414451e-02*G0_1_0 + 1.128747795414451e-02*G0_1_2 + 1.128747795414464e-02*G0_2_1;
    block[1023] = 2.257495590828928e-02*G0_0_0 + 2.821869488536213e-03*G0_0_1 + 2.257495590828925e-02*G0_0_2 + 2.821869488536064e-03*G0_1_0 + 2.821869488536060e-03*G0_1_2 + 2.257495590828924e-02*G0_2_0 + 2.821869488536031e-03*G0_2_1 + 2.257495590828924e-02*G0_2_2;
    block[1024] = 4.514991181657860e-02*G0_0_0 + 1.128747795414461e-02*G0_0_1 + 4.514991181657850e-02*G0_0_2 + 1.128747795414467e-02*G0_1_0 + 1.128747795414469e-02*G0_1_2 + 4.514991181657851e-02*G0_2_0 + 1.128747795414464e-02*G0_2_1 + 4.514991181657843e-02*G0_2_2;
    block[1025] = 6.772486772486751e-02*G0_0_0 + 1.015873015873015e-01*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 5.643738977072263e-02*G0_1_0 + 6.772486772486754e-02*G0_1_1 + 6.772486772486749e-02*G0_1_2 + 1.015873015873013e-01*G0_2_0 + 1.354497354497352e-01*G0_2_1 + 1.354497354497351e-01*G0_2_2;
    block[1026] = -1.693121693121688e-02*G0_0_0 - 1.777777777777775e-01*G0_0_1 - 1.777777777777775e-01*G0_0_2 - 4.232804232804196e-02*G0_1_0 - 8.465608465608457e-02*G0_1_1 - 8.465608465608454e-02*G0_1_2 - 1.777777777777774e-01*G0_2_0 - 2.708994708994705e-01*G0_2_1 - 2.708994708994705e-01*G0_2_2;
    block[1027] = -6.772486772486766e-02*G0_0_0 + 1.015873015873016e-01*G0_0_1 + 1.015873015873015e-01*G0_0_2 + 1.128747795414461e-02*G0_1_0 + 1.128747795414462e-01*G0_1_1 + 1.128747795414462e-01*G0_1_2 + 1.015873015873015e-01*G0_2_0;
    block[1028] = 9.029982363315696e-02*G0_0_0 + 9.029982363315699e-02*G0_0_1 + 5.643738977072305e-02*G0_0_2 + 2.257495590828921e-02*G0_1_0 + 2.257495590828926e-02*G0_1_1 + 1.128747795414441e-02*G0_1_2 + 5.643738977072299e-02*G0_2_0 + 5.643738977072303e-02*G0_2_1 + 2.257495590828909e-02*G0_2_2;
    block[1029] = 6.772486772486749e-02*G0_0_0 + 6.772486772486748e-02*G0_0_1 + 2.821869488536193e-03*G0_0_2 - 1.693121693121691e-02*G0_1_0 - 1.693121693121698e-02*G0_1_1 + 2.821869488536297e-03*G0_1_2 + 2.821869488536335e-03*G0_2_0 + 2.821869488536283e-03*G0_2_1 + 5.643738977072492e-03*G0_2_2;
    block[1030] = -3.386243386243391e-02*G0_0_2 - 2.257495590828940e-02*G0_1_0 - 2.257495590828933e-02*G0_1_1 + 1.128747795414451e-02*G0_1_2 - 3.386243386243395e-02*G0_2_0 - 3.386243386243393e-02*G0_2_1 + 2.257495590828907e-02*G0_2_2;
    block[1031] = -2.708994708994704e-01*G0_0_0 - 1.015873015873015e-01*G0_0_2 - 2.031746031746027e-01*G0_1_0 - 1.128747795414461e-01*G0_1_2 - 1.015873015873013e-01*G0_2_0;
    block[1032] = 6.772486772486773e-02*G0_0_0 - 9.312169312169261e-02*G0_0_2 - 5.079365079365085e-02*G0_1_0 - 1.862433862433858e-01*G0_1_2 - 9.312169312169299e-02*G0_2_0 - 2.708994708994703e-01*G0_2_2;
    block[1033] = 3.386243386243361e-02*G0_0_2 + 2.257495590828927e-02*G0_1_0 + 6.772486772486756e-02*G0_1_2 + 3.386243386243389e-02*G0_2_0 + 1.354497354497352e-01*G0_2_2;
    block[1034] = -2.257495590828918e-02*G0_1_1 - 1.128747795414463e-02*G0_1_2 - 1.128747795414451e-02*G0_2_1;
    block[1035] = 1.693121693121661e-02*G0_1_1 + 1.975308641975296e-02*G0_1_2 + 1.975308641975287e-02*G0_2_1 + 2.257495590828936e-02*G0_2_2;
    block[1036] = 2.257495590828927e-02*G0_1_1 + 3.386243386243371e-02*G0_1_2 + 3.386243386243386e-02*G0_2_1 + 4.514991181657827e-02*G0_2_2;
    block[1037] = 4.514991181657902e-02*G0_0_0 - 2.708994708994698e-01*G0_0_1 - 1.354497354497350e-01*G0_0_2 - 2.708994708994705e-01*G0_1_0 - 5.417989417989405e-01*G0_1_1 - 2.708994708994702e-01*G0_1_2 - 1.354497354497353e-01*G0_2_0 - 2.708994708994704e-01*G0_2_1;
    block[1038] = 6.772486772486763e-02*G0_0_1 + 4.514991181657889e-02*G0_0_2 + 6.772486772486713e-02*G0_1_0 - 6.772486772486813e-02*G0_1_2 + 4.514991181657813e-02*G0_2_0 - 6.772486772486791e-02*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[1039] = 4.514991181657860e-02*G0_0_1 + 2.257495590828919e-02*G0_0_2 + 4.514991181657815e-02*G0_1_0 + 1.354497354497351e-01*G0_1_1 + 6.772486772486740e-02*G0_1_2 + 2.257495590828936e-02*G0_2_0 + 6.772486772486762e-02*G0_2_1;
    block[1040] = -4.514991181657848e-02*G0_0_1 - 2.257495590828912e-02*G0_0_2 - 4.514991181657810e-02*G0_1_0 - 2.257495590828886e-02*G0_1_2 - 2.257495590828930e-02*G0_2_0 - 2.257495590828916e-02*G0_2_1 - 4.514991181657853e-02*G0_2_2;
    block[1041] = -6.772486772486742e-02*G0_0_1 - 4.514991181657824e-02*G0_0_2 - 6.772486772486713e-02*G0_1_0 - 2.257495590828917e-02*G0_1_2 - 4.514991181657815e-02*G0_2_0 - 2.257495590828916e-02*G0_2_1 - 4.514991181657833e-02*G0_2_2;
    block[1042] = 4.514991181657836e-02*G0_0_0 - 4.514991181657835e-02*G0_0_1 - 4.514991181657859e-02*G0_1_0 - 2.257495590828908e-02*G0_1_2 - 2.257495590828931e-02*G0_2_1 - 4.514991181657842e-02*G0_2_2;
    block[1043] = -1.354497354497353e-01*G0_0_0 - 6.772486772486784e-02*G0_0_1 + 9.029982363315715e-02*G0_0_2 + 6.772486772486780e-02*G0_1_0 - 6.772486772486776e-02*G0_1_2 + 9.029982363315672e-02*G0_2_0 + 6.772486772486778e-02*G0_2_1 - 1.354497354497355e-01*G0_2_2;
    block[1044] = 6.320987654320976e-01*G0_0_0 + 2.708994708994702e-01*G0_0_1 + 2.708994708994703e-01*G0_0_2 + 2.708994708994703e-01*G0_1_0 + 5.417989417989409e-01*G0_1_1 + 2.708994708994704e-01*G0_1_2 + 2.708994708994703e-01*G0_2_0 + 2.708994708994704e-01*G0_2_1 + 5.417989417989409e-01*G0_2_2;
    block[1045] = -4.514991181657844e-01*G0_0_0 - 3.611992945326274e-01*G0_0_1 - 2.257495590828923e-01*G0_0_2 - 9.029982363315664e-02*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 6.772486772486737e-02*G0_1_2 - 2.257495590828918e-01*G0_2_0 - 2.031746031746025e-01*G0_2_1 - 1.354497354497348e-01*G0_2_2;
    block[1046] = -2.257495590828923e-01*G0_0_0 - 4.514991181657849e-02*G0_0_1 - 1.805996472663136e-01*G0_0_2 - 4.514991181657842e-02*G0_1_0 - 6.772486772486797e-02*G0_1_2 - 1.805996472663138e-01*G0_2_0 - 6.772486772486740e-02*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[1047] = 3.160493827160489e-01*G0_0_0 + 1.354497354497350e-01*G0_0_1 + 1.354497354497350e-01*G0_0_2 + 1.354497354497351e-01*G0_1_0 + 2.708994708994704e-01*G0_1_2 + 1.354497354497352e-01*G0_2_0 + 2.708994708994704e-01*G0_2_1;
    block[1048] = -4.514991181657844e-02*G0_0_0 - 4.514991181657833e-02*G0_0_1 - 2.257495590828916e-02*G0_0_2 - 4.514991181657820e-02*G0_1_0 - 6.772486772486748e-02*G0_1_2 - 2.257495590828929e-02*G0_2_0 - 6.772486772486765e-02*G0_2_1;
    block[1049] = -9.029982363315744e-02*G0_0_0 + 3.160493827160486e-01*G0_0_1 + 1.354497354497345e-01*G0_0_2 + 3.160493827160492e-01*G0_1_0 + 1.354497354497357e-01*G0_1_2 + 1.354497354497353e-01*G0_2_0 + 1.354497354497349e-01*G0_2_1 + 2.708994708994707e-01*G0_2_2;
    block[1050] = 4.232804232804233e-02*G0_0_0 + 4.232804232804235e-02*G0_0_1 + 4.232804232804229e-02*G0_0_2 + 4.938271604938268e-02*G0_1_0 + 4.938271604938267e-02*G0_1_1 + 4.938271604938265e-02*G0_1_2 + 4.232804232804233e-02*G0_2_0 + 4.232804232804234e-02*G0_2_1 + 4.232804232804234e-02*G0_2_2;
    block[1051] = -2.539682539682531e-02*G0_0_0 - 7.054673721340363e-03*G0_1_0;
    block[1052] = 1.834215167548501e-02*G0_1_1;
    block[1053] = -7.054673721340353e-03*G0_1_2 - 2.539682539682529e-02*G0_2_2;
    block[1054] = 4.514991181657847e-02*G0_0_0 + 3.386243386243389e-02*G0_0_1 + 3.386243386243400e-02*G0_1_0 + 2.257495590828943e-02*G0_1_1;
    block[1055] = 2.257495590828916e-02*G0_0_0 + 1.975308641975303e-02*G0_0_1 + 1.975308641975301e-02*G0_1_0 + 1.693121693121688e-02*G0_1_1;
    block[1056] = -1.128747795414466e-02*G0_0_1 - 1.128747795414446e-02*G0_1_0 - 2.257495590828913e-02*G0_1_1;
    block[1057] = 1.128747795414464e-02*G0_0_1 + 1.128747795414450e-02*G0_1_0 - 4.514991181657840e-02*G0_1_1 + 1.128747795414455e-02*G0_1_2 + 1.128747795414481e-02*G0_2_1;
    block[1058] = 2.257495590828925e-02*G0_0_0 - 1.975308641975308e-02*G0_0_1 + 2.257495590828931e-02*G0_0_2 - 1.975308641975287e-02*G0_1_0 + 2.257495590828928e-02*G0_1_1 - 1.975308641975288e-02*G0_1_2 + 2.257495590828931e-02*G0_2_0 - 1.975308641975325e-02*G0_2_1 + 2.257495590828934e-02*G0_2_2;
    block[1059] = -1.354497354497353e-01*G0_0_0 - 3.386243386243384e-02*G0_0_1 - 1.354497354497353e-01*G0_0_2 - 3.386243386243401e-02*G0_1_0 - 4.514991181657848e-02*G0_1_1 - 3.386243386243398e-02*G0_1_2 - 1.354497354497351e-01*G0_2_0 - 3.386243386243382e-02*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[1060] = -6.772486772486752e-02*G0_0_0 - 1.693121693121691e-01*G0_0_1 - 1.693121693121691e-01*G0_0_2 - 7.901234567901212e-02*G0_1_0 - 6.772486772486772e-02*G0_1_1 - 6.772486772486762e-02*G0_1_2 - 1.693121693121688e-01*G0_2_0 - 2.708994708994704e-01*G0_2_1 - 2.708994708994703e-01*G0_2_2;
    block[1061] = -1.693121693121695e-02*G0_0_0 + 1.608465608465607e-01*G0_0_1 + 1.608465608465607e-01*G0_0_2 + 2.539682539682524e-02*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 1.185185185185183e-01*G0_1_2 + 1.608465608465604e-01*G0_2_0 + 6.772486772486756e-02*G0_2_1 + 6.772486772486754e-02*G0_2_2;
    block[1062] = 6.772486772486763e-02*G0_0_0 - 3.386243386243400e-02*G0_0_1 - 3.386243386243395e-02*G0_0_2 + 1.128747795414460e-02*G0_1_0 - 2.257495590828947e-02*G0_1_1 - 2.257495590828946e-02*G0_1_2 - 3.386243386243382e-02*G0_2_0;
    block[1063] = -2.708994708994706e-01*G0_0_0 - 2.708994708994706e-01*G0_0_1 - 1.693121693121691e-01*G0_0_2 - 6.772486772486784e-02*G0_1_0 - 6.772486772486791e-02*G0_1_1 - 7.901234567901227e-02*G0_1_2 - 1.693121693121692e-01*G0_2_0 - 1.693121693121691e-01*G0_2_1 - 6.772486772486777e-02*G0_2_2;
    block[1064] = 6.772486772486752e-02*G0_0_0 + 6.772486772486751e-02*G0_0_1 + 1.608465608465605e-01*G0_0_2 + 1.185185185185184e-01*G0_1_0 + 1.185185185185184e-01*G0_1_1 + 2.539682539682532e-02*G0_1_2 + 1.608465608465604e-01*G0_2_0 + 1.608465608465605e-01*G0_2_1 - 1.693121693121693e-02*G0_2_2;
    block[1065] = -3.386243386243377e-02*G0_0_2 - 2.257495590828940e-02*G0_1_0 - 2.257495590828937e-02*G0_1_1 + 1.128747795414457e-02*G0_1_2 - 3.386243386243391e-02*G0_2_0 - 3.386243386243391e-02*G0_2_1 + 6.772486772486745e-02*G0_2_2;
    block[1066] = 9.029982363315678e-02*G0_0_0 + 3.386243386243392e-02*G0_0_2 + 6.772486772486772e-02*G0_1_0 + 2.257495590828941e-02*G0_1_2 + 3.386243386243398e-02*G0_2_0;
    block[1067] = 6.772486772486740e-02*G0_0_0 + 6.490299823633114e-02*G0_0_2 + 8.465608465608430e-02*G0_1_0 + 8.465608465608415e-02*G0_1_2 + 6.490299823633101e-02*G0_2_0 + 6.772486772486708e-02*G0_2_2;
    block[1068] = 3.386243386243384e-02*G0_0_2 + 2.257495590828941e-02*G0_1_0 + 6.772486772486784e-02*G0_1_2 + 3.386243386243391e-02*G0_2_0 + 9.029982363315692e-02*G0_2_2;
    block[1069] = -2.257495590828917e-02*G0_1_1 - 1.128747795414445e-02*G0_1_2 - 1.128747795414448e-02*G0_2_1;
    block[1070] = 1.693121693121705e-02*G0_1_1 + 1.975308641975301e-02*G0_1_2 + 1.975308641975323e-02*G0_2_1 + 2.257495590828945e-02*G0_2_2;
    block[1071] = 2.257495590828936e-02*G0_1_1 + 3.386243386243409e-02*G0_1_2 + 3.386243386243386e-02*G0_2_1 + 4.514991181657845e-02*G0_2_2;
    block[1072] = 4.514991181657804e-02*G0_0_0 + 9.029982363315631e-02*G0_0_1 + 4.514991181657824e-02*G0_0_2 + 9.029982363315658e-02*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 6.772486772486772e-02*G0_1_2 + 4.514991181657786e-02*G0_2_0 + 6.772486772486709e-02*G0_2_1;
    block[1073] = 6.772486772486738e-02*G0_0_1 + 4.514991181657840e-02*G0_0_2 + 6.772486772486812e-02*G0_1_0 + 1.354497354497355e-01*G0_1_1 + 9.029982363315696e-02*G0_1_2 + 4.514991181657881e-02*G0_2_0 + 9.029982363315667e-02*G0_2_1 + 4.514991181657849e-02*G0_2_2;
    block[1074] = 4.514991181657865e-02*G0_0_1 + 2.257495590828906e-02*G0_0_2 + 4.514991181657844e-02*G0_1_0 + 9.029982363315694e-02*G0_1_1 + 4.514991181657844e-02*G0_1_2 + 2.257495590828954e-02*G0_2_0 + 4.514991181657879e-02*G0_2_1;
    block[1075] = -4.514991181657857e-02*G0_0_1 - 2.257495590828948e-02*G0_0_2 - 4.514991181657853e-02*G0_1_0 + 4.514991181657829e-02*G0_1_1 - 2.257495590828959e-02*G0_2_0 - 4.514991181657887e-02*G0_2_2;
    block[1076] = -6.772486772486785e-02*G0_0_1 - 4.514991181657856e-02*G0_0_2 - 6.772486772486806e-02*G0_1_0 - 1.354497354497354e-01*G0_1_1 - 1.805996472663138e-01*G0_1_2 - 4.514991181657880e-02*G0_2_0 - 1.805996472663137e-01*G0_2_1 - 2.257495590828921e-01*G0_2_2;
    block[1077] = 4.514991181657848e-02*G0_0_0 + 3.160493827160490e-01*G0_0_1 + 1.805996472663138e-01*G0_0_2 + 3.160493827160489e-01*G0_1_0 + 4.514991181657864e-02*G0_1_1 + 1.805996472663137e-01*G0_1_2 + 1.805996472663139e-01*G0_2_0 + 1.805996472663138e-01*G0_2_1 + 3.160493827160488e-01*G0_2_2;
    block[1078] = -1.354497354497348e-01*G0_0_0 - 6.772486772486719e-02*G0_0_1 - 2.257495590828919e-01*G0_0_2 - 2.031746031746026e-01*G0_1_0 - 1.354497354497351e-01*G0_1_1 - 3.611992945326273e-01*G0_1_2 - 2.257495590828914e-01*G0_2_0 - 9.029982363315640e-02*G0_2_1 - 4.514991181657837e-01*G0_2_2;
    block[1079] = -4.514991181657843e-01*G0_0_0 - 9.029982363315661e-02*G0_0_1 - 2.257495590828918e-01*G0_0_2 - 3.611992945326274e-01*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 2.031746031746025e-01*G0_1_2 - 2.257495590828923e-01*G0_2_0 - 6.772486772486737e-02*G0_2_1 - 1.354497354497348e-01*G0_2_2;
    block[1080] = 6.320987654320981e-01*G0_0_0 + 3.611992945326273e-01*G0_0_1 + 3.611992945326274e-01*G0_0_2 + 3.611992945326273e-01*G0_1_0 + 6.320987654320978e-01*G0_1_1 + 3.611992945326273e-01*G0_1_2 + 3.611992945326274e-01*G0_2_0 + 3.611992945326273e-01*G0_2_1 + 6.320987654320976e-01*G0_2_2;
    block[1081] = 3.160493827160489e-01*G0_0_0 + 1.805996472663138e-01*G0_0_1 + 1.805996472663138e-01*G0_0_2 + 1.805996472663138e-01*G0_1_0 + 4.514991181657856e-02*G0_1_1 + 3.160493827160489e-01*G0_1_2 + 1.805996472663136e-01*G0_2_0 + 3.160493827160490e-01*G0_2_1 + 4.514991181657888e-02*G0_2_2;
    block[1082] = -2.257495590828921e-01*G0_0_0 - 1.805996472663136e-01*G0_0_1 - 4.514991181657834e-02*G0_0_2 - 1.805996472663138e-01*G0_1_0 - 1.354497354497352e-01*G0_1_1 - 6.772486772486781e-02*G0_1_2 - 4.514991181657858e-02*G0_2_0 - 6.772486772486727e-02*G0_2_1;
    block[1083] = -4.514991181657849e-02*G0_0_0 - 2.257495590828918e-02*G0_0_2 + 4.514991181657829e-02*G0_1_1 - 4.514991181657855e-02*G0_1_2 - 2.257495590828925e-02*G0_2_0 - 4.514991181657876e-02*G0_2_1;
    block[1084] = -9.029982363315658e-02*G0_0_0 - 4.063492063492057e-01*G0_0_1 - 2.257495590828920e-01*G0_0_2 - 4.063492063492057e-01*G0_1_0 - 7.223985890652546e-01*G0_1_1 - 4.063492063492058e-01*G0_1_2 - 2.257495590828919e-01*G0_2_0 - 4.063492063492058e-01*G0_2_1 - 9.029982363315744e-02*G0_2_2;
    block[1085] = 4.232804232804228e-02*G0_0_0 + 4.232804232804228e-02*G0_0_1 + 4.232804232804228e-02*G0_0_2 + 4.232804232804228e-02*G0_1_0 + 4.232804232804233e-02*G0_1_1 + 4.232804232804233e-02*G0_1_2 + 4.938271604938265e-02*G0_2_0 + 4.938271604938266e-02*G0_2_1 + 4.938271604938264e-02*G0_2_2;
    block[1086] = -2.539682539682533e-02*G0_0_0 - 7.054673721340369e-03*G0_2_0;
    block[1087] = -2.539682539682546e-02*G0_1_1 - 7.054673721340375e-03*G0_2_1;
    block[1088] = 1.834215167548496e-02*G0_2_2;
    block[1089] = 9.029982363315671e-02*G0_0_0 + 3.386243386243384e-02*G0_0_1 + 3.386243386243370e-02*G0_1_0 + 6.772486772486752e-02*G0_2_0 + 2.257495590828925e-02*G0_2_1;
    block[1090] = 6.772486772486762e-02*G0_0_0 + 6.490299823633124e-02*G0_0_1 + 6.490299823633149e-02*G0_1_0 + 6.772486772486733e-02*G0_1_1 + 8.465608465608447e-02*G0_2_0 + 8.465608465608436e-02*G0_2_1;
    block[1091] = 3.386243386243397e-02*G0_0_1 + 3.386243386243398e-02*G0_1_0 + 9.029982363315717e-02*G0_1_1 + 2.257495590828942e-02*G0_2_0 + 6.772486772486784e-02*G0_2_1;
    block[1092] = -3.386243386243361e-02*G0_0_1 - 3.386243386243381e-02*G0_1_0 + 6.772486772486780e-02*G0_1_1 - 3.386243386243391e-02*G0_1_2 - 2.257495590828933e-02*G0_2_0 + 1.128747795414456e-02*G0_2_1 - 2.257495590828933e-02*G0_2_2;
    block[1093] = 6.772486772486737e-02*G0_0_0 + 1.608465608465604e-01*G0_0_1 + 6.772486772486745e-02*G0_0_2 + 1.608465608465609e-01*G0_1_0 - 1.693121693121716e-02*G0_1_1 + 1.608465608465610e-01*G0_1_2 + 1.185185185185186e-01*G0_2_0 + 2.539682539682542e-02*G0_2_1 + 1.185185185185186e-01*G0_2_2;
    block[1094] = -2.708994708994704e-01*G0_0_0 - 1.693121693121690e-01*G0_0_1 - 2.708994708994703e-01*G0_0_2 - 1.693121693121691e-01*G0_1_0 - 6.772486772486759e-02*G0_1_1 - 1.693121693121692e-01*G0_1_2 - 6.772486772486785e-02*G0_2_0 - 7.901234567901229e-02*G0_2_1 - 6.772486772486785e-02*G0_2_2;
    block[1095] = -6.772486772486744e-02*G0_0_0 - 1.693121693121690e-01*G0_0_1 - 1.693121693121690e-01*G0_0_2 - 1.693121693121688e-01*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 2.708994708994706e-01*G0_1_2 - 7.901234567901209e-02*G0_2_0 - 6.772486772486780e-02*G0_2_1 - 6.772486772486778e-02*G0_2_2;
    block[1096] = -1.693121693121696e-02*G0_0_0 + 1.608465608465606e-01*G0_0_1 + 1.608465608465607e-01*G0_0_2 + 1.608465608465604e-01*G0_1_0 + 6.772486772486741e-02*G0_1_1 + 6.772486772486744e-02*G0_1_2 + 2.539682539682528e-02*G0_2_0 + 1.185185185185182e-01*G0_2_1 + 1.185185185185182e-01*G0_2_2;
    block[1097] = 6.772486772486760e-02*G0_0_0 - 3.386243386243393e-02*G0_0_1 - 3.386243386243386e-02*G0_0_2 - 3.386243386243384e-02*G0_1_0 + 1.128747795414465e-02*G0_2_0 - 2.257495590828927e-02*G0_2_1 - 2.257495590828924e-02*G0_2_2;
    block[1098] = -1.354497354497353e-01*G0_0_0 - 1.354497354497352e-01*G0_0_1 - 3.386243386243380e-02*G0_0_2 - 1.354497354497354e-01*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 3.386243386243388e-02*G0_1_2 - 3.386243386243404e-02*G0_2_0 - 3.386243386243410e-02*G0_2_1 - 4.514991181657838e-02*G0_2_2;
    block[1099] = 2.257495590828909e-02*G0_0_0 + 2.257495590828908e-02*G0_0_1 - 1.975308641975322e-02*G0_0_2 + 2.257495590828913e-02*G0_1_0 + 2.257495590828908e-02*G0_1_1 - 1.975308641975314e-02*G0_1_2 - 1.975308641975294e-02*G0_2_0 - 1.975308641975296e-02*G0_2_1 + 2.257495590828911e-02*G0_2_2;
    block[1100] = 1.128747795414459e-02*G0_0_2 + 1.128747795414458e-02*G0_1_2 + 1.128747795414449e-02*G0_2_0 + 1.128747795414448e-02*G0_2_1 - 4.514991181657833e-02*G0_2_2;
    block[1101] = 4.514991181657842e-02*G0_0_0 + 3.386243386243386e-02*G0_0_2 + 3.386243386243383e-02*G0_2_0 + 2.257495590828926e-02*G0_2_2;
    block[1102] = 2.257495590828914e-02*G0_0_0 + 1.975308641975311e-02*G0_0_2 + 1.975308641975314e-02*G0_2_0 + 1.693121693121689e-02*G0_2_2;
    block[1103] = -1.128747795414464e-02*G0_0_2 - 1.128747795414453e-02*G0_2_0 - 2.257495590828905e-02*G0_2_2;
    block[1104] = 4.514991181657863e-02*G0_1_1 + 3.386243386243399e-02*G0_1_2 + 3.386243386243383e-02*G0_2_1 + 2.257495590828943e-02*G0_2_2;
    block[1105] = 2.257495590828930e-02*G0_1_1 + 1.975308641975320e-02*G0_1_2 + 1.975308641975321e-02*G0_2_1 + 1.693121693121683e-02*G0_2_2;
    block[1106] = -1.128747795414462e-02*G0_1_2 - 1.128747795414458e-02*G0_2_1 - 2.257495590828905e-02*G0_2_2;
    block[1107] = 4.514991181657815e-02*G0_0_0 + 4.514991181657824e-02*G0_0_1 + 9.029982363315639e-02*G0_0_2 + 4.514991181657824e-02*G0_1_0 + 6.772486772486733e-02*G0_1_2 + 9.029982363315671e-02*G0_2_0 + 6.772486772486766e-02*G0_2_1 + 1.354497354497350e-01*G0_2_2;
    block[1108] = 2.257495590828923e-02*G0_0_1 + 4.514991181657849e-02*G0_0_2 + 2.257495590828937e-02*G0_1_0 + 4.514991181657855e-02*G0_1_2 + 4.514991181657869e-02*G0_2_0 + 4.514991181657870e-02*G0_2_1 + 9.029982363315703e-02*G0_2_2;
    block[1109] = 4.514991181657833e-02*G0_0_1 + 6.772486772486752e-02*G0_0_2 + 4.514991181657875e-02*G0_1_0 + 4.514991181657860e-02*G0_1_1 + 9.029982363315689e-02*G0_1_2 + 6.772486772486755e-02*G0_2_0 + 9.029982363315668e-02*G0_2_1 + 1.354497354497353e-01*G0_2_2;
    block[1110] = -4.514991181657838e-02*G0_0_1 - 6.772486772486747e-02*G0_0_2 - 4.514991181657876e-02*G0_1_0 - 2.257495590828930e-01*G0_1_1 - 1.805996472663143e-01*G0_1_2 - 6.772486772486762e-02*G0_2_0 - 1.805996472663140e-01*G0_2_1 - 1.354497354497354e-01*G0_2_2;
    block[1111] = -2.257495590828915e-02*G0_0_1 - 4.514991181657838e-02*G0_0_2 - 2.257495590828936e-02*G0_1_0 - 4.514991181657844e-02*G0_1_1 - 4.514991181657865e-02*G0_2_0 + 4.514991181657810e-02*G0_2_2;
    block[1112] = 4.514991181657824e-02*G0_0_0 + 1.805996472663136e-01*G0_0_1 + 3.160493827160487e-01*G0_0_2 + 1.805996472663144e-01*G0_1_0 + 3.160493827160494e-01*G0_1_1 + 1.805996472663138e-01*G0_1_2 + 3.160493827160492e-01*G0_2_0 + 1.805996472663141e-01*G0_2_1 + 4.514991181657869e-02*G0_2_2;
    block[1113] = -4.514991181657817e-02*G0_0_0 - 2.257495590828909e-02*G0_0_1 - 2.257495590828901e-02*G0_1_0 - 4.514991181657835e-02*G0_1_2 - 4.514991181657849e-02*G0_2_1 + 4.514991181657814e-02*G0_2_2;
    block[1114] = -2.257495590828923e-01*G0_0_0 - 4.514991181657843e-02*G0_0_1 - 1.805996472663138e-01*G0_0_2 - 4.514991181657848e-02*G0_1_0 - 6.772486772486740e-02*G0_1_2 - 1.805996472663136e-01*G0_2_0 - 6.772486772486795e-02*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[1115] = 3.160493827160489e-01*G0_0_0 + 1.805996472663138e-01*G0_0_1 + 1.805996472663136e-01*G0_0_2 + 1.805996472663138e-01*G0_1_0 + 4.514991181657860e-02*G0_1_1 + 3.160493827160490e-01*G0_1_2 + 1.805996472663138e-01*G0_2_0 + 3.160493827160489e-01*G0_2_1 + 4.514991181657890e-02*G0_2_2;
    block[1116] = 6.320987654320978e-01*G0_0_0 + 3.611992945326272e-01*G0_0_1 + 3.611992945326273e-01*G0_0_2 + 3.611992945326272e-01*G0_1_0 + 6.320987654320984e-01*G0_1_1 + 3.611992945326277e-01*G0_1_2 + 3.611992945326273e-01*G0_2_0 + 3.611992945326277e-01*G0_2_1 + 6.320987654320978e-01*G0_2_2;
    block[1117] = -4.514991181657839e-01*G0_0_0 - 2.257495590828918e-01*G0_0_1 - 9.029982363315650e-02*G0_0_2 - 2.257495590828917e-01*G0_1_0 - 1.354497354497348e-01*G0_1_1 - 6.772486772486758e-02*G0_1_2 - 3.611992945326269e-01*G0_2_0 - 2.031746031746025e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1118] = -1.354497354497352e-01*G0_0_0 - 2.257495590828920e-01*G0_0_1 - 6.772486772486770e-02*G0_0_2 - 2.257495590828925e-01*G0_1_0 - 4.514991181657848e-01*G0_1_1 - 9.029982363315686e-02*G0_1_2 - 2.031746031746031e-01*G0_2_0 - 3.611992945326277e-01*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1119] = -9.029982363315625e-02*G0_0_0 - 2.257495590828919e-01*G0_0_1 - 4.063492063492055e-01*G0_0_2 - 2.257495590828926e-01*G0_1_0 - 9.029982363315671e-02*G0_1_1 - 4.063492063492062e-01*G0_1_2 - 4.063492063492059e-01*G0_2_0 - 4.063492063492054e-01*G0_2_1 - 7.223985890652546e-01*G0_2_2;
    block[1120] = -2.539682539682529e-02*G0_0_0 - 2.539682539682529e-02*G0_0_1 - 2.539682539682527e-02*G0_0_2 - 2.539682539682533e-02*G0_1_0 - 2.539682539682537e-02*G0_1_1 - 2.539682539682533e-02*G0_1_2 - 1.834215167548485e-02*G0_2_0 - 1.834215167548488e-02*G0_2_1 - 1.834215167548484e-02*G0_2_2;
    block[1121] = 4.232804232804228e-02*G0_0_0 - 7.054673721340323e-03*G0_2_0;
    block[1122] = -2.539682539682541e-02*G0_1_1 - 7.054673721340298e-03*G0_2_1;
    block[1123] = 1.834215167548494e-02*G0_2_2;
    block[1124] = -2.708994708994700e-01*G0_0_0 - 1.015873015873012e-01*G0_0_1 - 1.015873015873012e-01*G0_1_0 - 2.031746031746024e-01*G0_2_0 - 1.128747795414459e-01*G0_2_1;
    block[1125] = 6.772486772486734e-02*G0_0_0 - 9.312169312169266e-02*G0_0_1 - 9.312169312169311e-02*G0_1_0 - 2.708994708994706e-01*G0_1_1 - 5.079365079365101e-02*G0_2_0 - 1.862433862433859e-01*G0_2_1;
    block[1126] = 3.386243386243371e-02*G0_0_1 + 3.386243386243389e-02*G0_1_0 + 1.354497354497355e-01*G0_1_1 + 2.257495590828935e-02*G0_2_0 + 6.772486772486751e-02*G0_2_1;
    block[1127] = -3.386243386243407e-02*G0_0_1 - 3.386243386243405e-02*G0_1_0 + 2.257495590828932e-02*G0_1_1 - 3.386243386243406e-02*G0_1_2 - 2.257495590828949e-02*G0_2_0 + 1.128747795414446e-02*G0_2_1 - 2.257495590828951e-02*G0_2_2;
    block[1128] = 6.772486772486791e-02*G0_0_0 + 2.821869488536353e-03*G0_0_1 + 6.772486772486787e-02*G0_0_2 + 2.821869488536185e-03*G0_1_0 + 5.643738977072075e-03*G0_1_1 + 2.821869488536182e-03*G0_1_2 - 1.693121693121698e-02*G0_2_0 + 2.821869488536298e-03*G0_2_1 - 1.693121693121698e-02*G0_2_2;
    block[1129] = 9.029982363315670e-02*G0_0_0 + 5.643738977072286e-02*G0_0_1 + 9.029982363315661e-02*G0_0_2 + 5.643738977072293e-02*G0_1_0 + 2.257495590828930e-02*G0_1_1 + 5.643738977072284e-02*G0_1_2 + 2.257495590828919e-02*G0_2_0 + 1.128747795414446e-02*G0_2_1 + 2.257495590828920e-02*G0_2_2;
    block[1130] = 6.772486772486735e-02*G0_0_0 + 1.015873015873013e-01*G0_0_1 + 1.015873015873013e-01*G0_0_2 + 1.015873015873012e-01*G0_1_0 + 1.354497354497350e-01*G0_1_1 + 1.354497354497349e-01*G0_1_2 + 5.643738977072262e-02*G0_2_0 + 6.772486772486748e-02*G0_2_1 + 6.772486772486741e-02*G0_2_2;
    block[1131] = -1.693121693121678e-02*G0_0_0 - 1.777777777777774e-01*G0_0_1 - 1.777777777777774e-01*G0_0_2 - 1.777777777777772e-01*G0_1_0 - 2.708994708994703e-01*G0_1_1 - 2.708994708994703e-01*G0_1_2 - 4.232804232804180e-02*G0_2_0 - 8.465608465608425e-02*G0_2_1 - 8.465608465608421e-02*G0_2_2;
    block[1132] = -6.772486772486765e-02*G0_0_0 + 1.015873015873014e-01*G0_0_1 + 1.015873015873013e-01*G0_0_2 + 1.015873015873013e-01*G0_1_0 + 1.128747795414444e-02*G0_2_0 + 1.128747795414459e-01*G0_2_1 + 1.128747795414458e-01*G0_2_2;
    block[1133] = 4.514991181657840e-02*G0_0_0 + 4.514991181657844e-02*G0_0_1 + 1.128747795414460e-02*G0_0_2 + 4.514991181657839e-02*G0_1_0 + 4.514991181657844e-02*G0_1_1 + 1.128747795414459e-02*G0_1_2 + 1.128747795414465e-02*G0_2_0 + 1.128747795414473e-02*G0_2_1;
    block[1134] = 2.257495590828907e-02*G0_0_0 + 2.257495590828908e-02*G0_0_1 + 2.821869488536186e-03*G0_0_2 + 2.257495590828922e-02*G0_1_0 + 2.257495590828923e-02*G0_1_1 + 2.821869488536118e-03*G0_1_2 + 2.821869488535991e-03*G0_2_0 + 2.821869488535983e-03*G0_2_1;
    block[1135] = 1.128747795414448e-02*G0_0_2 + 1.128747795414463e-02*G0_1_2 + 1.128747795414455e-02*G0_2_0 + 1.128747795414464e-02*G0_2_1;
    block[1136] = -1.354497354497350e-01*G0_0_0 - 1.015873015873012e-01*G0_0_2 - 1.015873015873012e-01*G0_2_0 - 1.128747795414457e-01*G0_2_2;
    block[1137] = 2.257495590828908e-02*G0_0_0 + 4.232804232804210e-02*G0_0_2 + 4.232804232804215e-02*G0_2_0 + 8.465608465608433e-02*G0_2_2;
    block[1138] = -1.128747795414460e-02*G0_0_2 - 1.128747795414463e-02*G0_2_0 - 6.772486772486752e-02*G0_2_2;
    block[1139] = 4.514991181657861e-02*G0_1_1 + 3.386243386243393e-02*G0_1_2 + 3.386243386243383e-02*G0_2_1 + 2.257495590828933e-02*G0_2_2;
    block[1140] = 2.257495590828910e-02*G0_1_1 + 1.975308641975310e-02*G0_1_2 + 1.975308641975296e-02*G0_2_1 + 1.693121693121678e-02*G0_2_2;
    block[1141] = -1.128747795414462e-02*G0_1_2 - 1.128747795414460e-02*G0_2_1 - 2.257495590828920e-02*G0_2_2;
    block[1142] = 4.514991181657869e-02*G0_0_0 - 1.354497354497348e-01*G0_0_1 - 2.708994708994696e-01*G0_0_2 - 1.354497354497353e-01*G0_1_0 - 2.708994708994703e-01*G0_1_2 - 2.708994708994705e-01*G0_2_0 - 2.708994708994700e-01*G0_2_1 - 5.417989417989404e-01*G0_2_2;
    block[1143] = 2.257495590828900e-02*G0_0_1 + 4.514991181657842e-02*G0_0_2 + 2.257495590828909e-02*G0_1_0 + 6.772486772486740e-02*G0_1_2 + 4.514991181657815e-02*G0_2_0 + 6.772486772486742e-02*G0_2_1 + 1.354497354497348e-01*G0_2_2;
    block[1144] = 4.514991181657874e-02*G0_0_1 + 6.772486772486774e-02*G0_0_2 + 4.514991181657885e-02*G0_1_0 - 1.354497354497353e-01*G0_1_1 - 6.772486772486747e-02*G0_1_2 + 6.772486772486762e-02*G0_2_0 - 6.772486772486787e-02*G0_2_1;
    block[1145] = -4.514991181657885e-02*G0_0_1 - 6.772486772486781e-02*G0_0_2 - 4.514991181657877e-02*G0_1_0 - 4.514991181657869e-02*G0_1_1 - 2.257495590828928e-02*G0_1_2 - 6.772486772486756e-02*G0_2_0 - 2.257495590828928e-02*G0_2_1;
    block[1146] = -2.257495590828901e-02*G0_0_1 - 4.514991181657829e-02*G0_0_2 - 2.257495590828909e-02*G0_1_0 - 4.514991181657838e-02*G0_1_1 - 2.257495590828918e-02*G0_1_2 - 4.514991181657815e-02*G0_2_0 - 2.257495590828901e-02*G0_2_1;
    block[1147] = 4.514991181657855e-02*G0_0_0 - 4.514991181657817e-02*G0_0_2 - 4.514991181657841e-02*G0_1_1 - 2.257495590828898e-02*G0_1_2 - 4.514991181657851e-02*G0_2_0 - 2.257495590828915e-02*G0_2_1;
    block[1148] = -4.514991181657820e-02*G0_0_0 - 2.257495590828908e-02*G0_0_1 - 4.514991181657815e-02*G0_0_2 - 2.257495590828929e-02*G0_1_0 - 6.772486772486766e-02*G0_1_2 - 4.514991181657817e-02*G0_2_0 - 6.772486772486742e-02*G0_2_1;
    block[1149] = 3.160493827160489e-01*G0_0_0 + 1.354497354497351e-01*G0_0_1 + 1.354497354497352e-01*G0_0_2 + 1.354497354497350e-01*G0_1_0 + 2.708994708994704e-01*G0_1_2 + 1.354497354497350e-01*G0_2_0 + 2.708994708994704e-01*G0_2_1;
    block[1150] = -2.257495590828921e-01*G0_0_0 - 1.805996472663138e-01*G0_0_1 - 4.514991181657858e-02*G0_0_2 - 1.805996472663136e-01*G0_1_0 - 1.354497354497352e-01*G0_1_1 - 6.772486772486727e-02*G0_1_2 - 4.514991181657835e-02*G0_2_0 - 6.772486772486781e-02*G0_2_1;
    block[1151] = -4.514991181657839e-01*G0_0_0 - 2.257495590828917e-01*G0_0_1 - 3.611992945326269e-01*G0_0_2 - 2.257495590828918e-01*G0_1_0 - 1.354497354497348e-01*G0_1_1 - 2.031746031746025e-01*G0_1_2 - 9.029982363315650e-02*G0_2_0 - 6.772486772486758e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1152] = 6.320987654320971e-01*G0_0_0 + 2.708994708994700e-01*G0_0_1 + 2.708994708994699e-01*G0_0_2 + 2.708994708994700e-01*G0_1_0 + 5.417989417989409e-01*G0_1_1 + 2.708994708994703e-01*G0_1_2 + 2.708994708994698e-01*G0_2_0 + 2.708994708994703e-01*G0_2_1 + 5.417989417989405e-01*G0_2_2;
    block[1153] = -1.354497354497352e-01*G0_0_0 + 9.029982363315658e-02*G0_0_1 - 6.772486772486763e-02*G0_0_2 + 9.029982363315693e-02*G0_1_0 - 1.354497354497358e-01*G0_1_1 + 6.772486772486778e-02*G0_1_2 + 6.772486772486801e-02*G0_2_0 - 6.772486772486762e-02*G0_2_1;
    block[1154] = -9.029982363315742e-02*G0_0_0 + 1.354497354497348e-01*G0_0_1 + 3.160493827160482e-01*G0_0_2 + 1.354497354497351e-01*G0_1_0 + 2.708994708994706e-01*G0_1_1 + 1.354497354497349e-01*G0_1_2 + 3.160493827160490e-01*G0_2_0 + 1.354497354497353e-01*G0_2_1;
    block[1155] = -2.539682539682538e-02*G0_0_0 - 2.539682539682543e-02*G0_0_1 - 2.539682539682541e-02*G0_0_2 - 2.539682539682536e-02*G0_1_0 - 2.539682539682538e-02*G0_1_1 - 2.539682539682537e-02*G0_1_2 - 1.834215167548501e-02*G0_2_0 - 1.834215167548504e-02*G0_2_1 - 1.834215167548498e-02*G0_2_2;
    block[1156] = -2.539682539682539e-02*G0_0_0 - 7.054673721340380e-03*G0_2_0;
    block[1157] = 4.232804232804237e-02*G0_1_1 - 7.054673721340455e-03*G0_2_1;
    block[1158] = 1.834215167548501e-02*G0_2_2;
    block[1159] = 1.354497354497350e-01*G0_0_0 + 3.386243386243366e-02*G0_0_1 + 3.386243386243382e-02*G0_1_0 + 6.772486772486758e-02*G0_2_0 + 2.257495590828911e-02*G0_2_1;
    block[1160] = -2.708994708994703e-01*G0_0_0 - 9.312169312169308e-02*G0_0_1 - 9.312169312169277e-02*G0_1_0 + 6.772486772486803e-02*G0_1_1 - 1.862433862433859e-01*G0_2_0 - 5.079365079365074e-02*G0_2_1;
    block[1161] = -1.015873015873015e-01*G0_0_1 - 1.015873015873018e-01*G0_1_0 - 2.708994708994710e-01*G0_1_1 - 1.128747795414460e-01*G0_2_0 - 2.031746031746026e-01*G0_2_1;
    block[1162] = 1.015873015873015e-01*G0_0_1 + 1.015873015873017e-01*G0_1_0 - 6.772486772486769e-02*G0_1_1 + 1.015873015873018e-01*G0_1_2 + 1.128747795414461e-01*G0_2_0 + 1.128747795414490e-02*G0_2_1 + 1.128747795414460e-01*G0_2_2;
    block[1163] = -2.708994708994709e-01*G0_0_0 - 1.777777777777775e-01*G0_0_1 - 2.708994708994709e-01*G0_0_2 - 1.777777777777779e-01*G0_1_0 - 1.693121693121677e-02*G0_1_1 - 1.777777777777780e-01*G0_1_2 - 8.465608465608476e-02*G0_2_0 - 4.232804232804261e-02*G0_2_1 - 8.465608465608478e-02*G0_2_2;
    block[1164] = 1.354497354497353e-01*G0_0_0 + 1.015873015873015e-01*G0_0_1 + 1.354497354497354e-01*G0_0_2 + 1.015873015873016e-01*G0_1_0 + 6.772486772486759e-02*G0_1_1 + 1.015873015873017e-01*G0_1_2 + 6.772486772486769e-02*G0_2_0 + 5.643738977072321e-02*G0_2_1 + 6.772486772486770e-02*G0_2_2;
    block[1165] = 2.257495590828920e-02*G0_0_0 + 5.643738977072314e-02*G0_0_1 + 5.643738977072310e-02*G0_0_2 + 5.643738977072298e-02*G0_1_0 + 9.029982363315704e-02*G0_1_1 + 9.029982363315710e-02*G0_1_2 + 1.128747795414460e-02*G0_2_0 + 2.257495590828915e-02*G0_2_1 + 2.257495590828916e-02*G0_2_2;
    block[1166] = 5.643738977072347e-03*G0_0_0 + 2.821869488536208e-03*G0_0_1 + 2.821869488536221e-03*G0_0_2 + 2.821869488536170e-03*G0_1_0 + 6.772486772486781e-02*G0_1_1 + 6.772486772486778e-02*G0_1_2 + 2.821869488536173e-03*G0_2_0 - 1.693121693121693e-02*G0_2_1 - 1.693121693121693e-02*G0_2_2;
    block[1167] = 2.257495590828921e-02*G0_0_0 - 3.386243386243375e-02*G0_0_1 - 3.386243386243375e-02*G0_0_2 - 3.386243386243378e-02*G0_1_0 + 1.128747795414464e-02*G0_2_0 - 2.257495590828920e-02*G0_2_1 - 2.257495590828919e-02*G0_2_2;
    block[1168] = 4.514991181657853e-02*G0_0_0 + 4.514991181657850e-02*G0_0_1 + 1.128747795414455e-02*G0_0_2 + 4.514991181657861e-02*G0_1_0 + 4.514991181657850e-02*G0_1_1 + 1.128747795414457e-02*G0_1_2 + 1.128747795414459e-02*G0_2_0 + 1.128747795414456e-02*G0_2_1;
    block[1169] = 2.257495590828925e-02*G0_0_0 + 2.257495590828930e-02*G0_0_1 + 2.821869488536211e-03*G0_0_2 + 2.257495590828925e-02*G0_1_0 + 2.257495590828932e-02*G0_1_1 + 2.821869488536331e-03*G0_1_2 + 2.821869488536204e-03*G0_2_0 + 2.821869488536266e-03*G0_2_1;
    block[1170] = 1.128747795414473e-02*G0_0_2 + 1.128747795414453e-02*G0_1_2 + 1.128747795414474e-02*G0_2_0 + 1.128747795414464e-02*G0_2_1;
    block[1171] = 4.514991181657834e-02*G0_0_0 + 3.386243386243373e-02*G0_0_2 + 3.386243386243372e-02*G0_2_0 + 2.257495590828914e-02*G0_2_2;
    block[1172] = 2.257495590828927e-02*G0_0_0 + 1.975308641975313e-02*G0_0_2 + 1.975308641975307e-02*G0_2_0 + 1.693121693121697e-02*G0_2_2;
    block[1173] = -1.128747795414461e-02*G0_0_2 - 1.128747795414458e-02*G0_2_0 - 2.257495590828920e-02*G0_2_2;
    block[1174] = -1.354497354497356e-01*G0_1_1 - 1.015873015873017e-01*G0_1_2 - 1.015873015873014e-01*G0_2_1 - 1.128747795414460e-01*G0_2_2;
    block[1175] = 2.257495590828925e-02*G0_1_1 + 4.232804232804230e-02*G0_1_2 + 4.232804232804217e-02*G0_2_1 + 8.465608465608440e-02*G0_2_2;
    block[1176] = -1.128747795414464e-02*G0_1_2 - 1.128747795414453e-02*G0_2_1 - 6.772486772486741e-02*G0_2_2;
    block[1177] = -1.354497354497354e-01*G0_0_0 + 4.514991181657829e-02*G0_0_1 - 6.772486772486798e-02*G0_0_2 + 4.514991181657874e-02*G0_1_0 + 6.772486772486788e-02*G0_1_2 - 6.772486772486769e-02*G0_2_0 + 6.772486772486763e-02*G0_2_1;
    block[1178] = 2.257495590828935e-02*G0_0_1 + 6.772486772486756e-02*G0_0_2 + 2.257495590828903e-02*G0_1_0 + 4.514991181657840e-02*G0_1_2 + 6.772486772486734e-02*G0_2_0 + 4.514991181657835e-02*G0_2_1 + 1.354497354497348e-01*G0_2_2;
    block[1179] = -1.354497354497354e-01*G0_0_1 - 2.708994708994705e-01*G0_0_2 - 1.354497354497355e-01*G0_1_0 + 4.514991181657892e-02*G0_1_1 - 2.708994708994706e-01*G0_1_2 - 2.708994708994705e-01*G0_2_0 - 2.708994708994706e-01*G0_2_1 - 5.417989417989408e-01*G0_2_2;
    block[1180] = 1.354497354497358e-01*G0_0_1 + 2.708994708994707e-01*G0_0_2 + 1.354497354497355e-01*G0_1_0 + 3.160493827160499e-01*G0_1_1 + 1.354497354497357e-01*G0_1_2 + 2.708994708994704e-01*G0_2_0 + 1.354497354497352e-01*G0_2_1;
    block[1181] = -2.257495590828936e-02*G0_0_1 - 6.772486772486765e-02*G0_0_2 - 2.257495590828908e-02*G0_1_0 - 4.514991181657855e-02*G0_1_1 - 4.514991181657822e-02*G0_1_2 - 6.772486772486751e-02*G0_2_0 - 4.514991181657853e-02*G0_2_1;
    block[1182] = -1.354497354497356e-01*G0_0_0 - 1.805996472663141e-01*G0_0_1 - 6.772486772486773e-02*G0_0_2 - 1.805996472663144e-01*G0_1_0 - 2.257495590828926e-01*G0_1_1 - 4.514991181657873e-02*G0_1_2 - 6.772486772486770e-02*G0_2_0 - 4.514991181657838e-02*G0_2_1;
    block[1183] = -4.514991181657853e-02*G0_0_0 - 2.257495590828936e-02*G0_0_1 - 2.257495590828934e-02*G0_0_2 - 2.257495590828921e-02*G0_1_0 - 4.514991181657831e-02*G0_1_2 - 2.257495590828930e-02*G0_2_0 - 4.514991181657830e-02*G0_2_1;
    block[1184] = -4.514991181657844e-02*G0_0_0 - 4.514991181657819e-02*G0_0_1 - 2.257495590828930e-02*G0_0_2 - 4.514991181657834e-02*G0_1_0 - 6.772486772486765e-02*G0_1_2 - 2.257495590828916e-02*G0_2_0 - 6.772486772486747e-02*G0_2_1;
    block[1185] = -4.514991181657849e-02*G0_0_0 - 2.257495590828924e-02*G0_0_2 + 4.514991181657829e-02*G0_1_1 - 4.514991181657874e-02*G0_1_2 - 2.257495590828917e-02*G0_2_0 - 4.514991181657856e-02*G0_2_1;
    block[1186] = -1.354497354497352e-01*G0_0_0 - 2.257495590828925e-01*G0_0_1 - 2.031746031746031e-01*G0_0_2 - 2.257495590828920e-01*G0_1_0 - 4.514991181657848e-01*G0_1_1 - 3.611992945326277e-01*G0_1_2 - 6.772486772486770e-02*G0_2_0 - 9.029982363315686e-02*G0_2_1 - 1.354497354497353e-01*G0_2_2;
    block[1187] = -1.354497354497352e-01*G0_0_0 + 9.029982363315694e-02*G0_0_1 + 6.772486772486801e-02*G0_0_2 + 9.029982363315658e-02*G0_1_0 - 1.354497354497358e-01*G0_1_1 - 6.772486772486762e-02*G0_1_2 - 6.772486772486765e-02*G0_2_0 + 6.772486772486778e-02*G0_2_1;
    block[1188] = 5.417989417989413e-01*G0_0_0 + 2.708994708994706e-01*G0_0_1 + 2.708994708994706e-01*G0_0_2 + 2.708994708994707e-01*G0_1_0 + 6.320987654320989e-01*G0_1_1 + 2.708994708994703e-01*G0_1_2 + 2.708994708994706e-01*G0_2_0 + 2.708994708994703e-01*G0_2_1 + 5.417989417989405e-01*G0_2_2;
    block[1189] = 2.708994708994709e-01*G0_0_0 + 1.354497354497354e-01*G0_0_1 + 1.354497354497354e-01*G0_0_2 + 1.354497354497357e-01*G0_1_0 - 9.029982363315769e-02*G0_1_1 + 3.160493827160492e-01*G0_1_2 + 1.354497354497355e-01*G0_2_0 + 3.160493827160490e-01*G0_2_1;
    block[1190] = -6.772486772486744e-02*G0_0_0 - 6.772486772486749e-02*G0_0_1 - 6.772486772486747e-02*G0_0_2 - 6.772486772486762e-02*G0_1_0 - 6.772486772486765e-02*G0_1_1 - 6.772486772486760e-02*G0_1_2 - 6.772486772486754e-02*G0_2_0 - 6.772486772486754e-02*G0_2_1 - 6.772486772486758e-02*G0_2_2;
    block[1191] = -6.772486772486755e-02*G0_0_0;
    block[1192] = -6.772486772486777e-02*G0_1_1;
    block[1193] = -6.772486772486765e-02*G0_2_2;
    block[1194] = 9.029982363315693e-02*G0_0_0;
    block[1195] = -1.354497354497352e-01*G0_0_0 - 1.128747795414461e-01*G0_0_1 - 1.128747795414461e-01*G0_1_0 - 1.354497354497355e-01*G0_1_1;
    block[1196] = 9.029982363315733e-02*G0_1_1;
    block[1197] = 9.029982363315707e-02*G0_1_1;
    block[1198] = -1.354497354497358e-01*G0_0_0 - 2.257495590828909e-02*G0_0_1 - 1.354497354497358e-01*G0_0_2 - 2.257495590828936e-02*G0_1_0 - 4.514991181657865e-02*G0_1_1 - 2.257495590828936e-02*G0_1_2 - 1.354497354497353e-01*G0_2_0 - 2.257495590828893e-02*G0_2_1 - 1.354497354497354e-01*G0_2_2;
    block[1199] = 9.029982363315697e-02*G0_0_0 + 9.029982363315656e-02*G0_0_1 + 9.029982363315704e-02*G0_0_2 + 9.029982363315699e-02*G0_1_0 + 9.029982363315692e-02*G0_1_1 + 9.029982363315694e-02*G0_1_2 + 9.029982363315706e-02*G0_2_0 + 9.029982363315663e-02*G0_2_1 + 9.029982363315704e-02*G0_2_2;
    block[1200] = 9.029982363315631e-02*G0_0_0 + 9.029982363315692e-02*G0_0_1 + 9.029982363315683e-02*G0_0_2 + 9.029982363315660e-02*G0_1_0 + 9.029982363315678e-02*G0_1_1 + 9.029982363315672e-02*G0_1_2 + 9.029982363315649e-02*G0_2_0 + 9.029982363315699e-02*G0_2_1 + 9.029982363315699e-02*G0_2_2;
    block[1201] = -4.514991181657795e-02*G0_0_0 - 2.257495590828893e-02*G0_0_1 - 2.257495590828889e-02*G0_0_2 - 2.257495590828897e-02*G0_1_0 - 1.354497354497351e-01*G0_1_1 - 1.354497354497350e-01*G0_1_2 - 2.257495590828892e-02*G0_2_0 - 1.354497354497350e-01*G0_2_1 - 1.354497354497350e-01*G0_2_2;
    block[1202] = 9.029982363315672e-02*G0_0_0;
    block[1203] = 9.029982363315701e-02*G0_0_0 + 9.029982363315708e-02*G0_0_1 + 9.029982363315639e-02*G0_0_2 + 9.029982363315699e-02*G0_1_0 + 9.029982363315708e-02*G0_1_1 + 9.029982363315675e-02*G0_1_2 + 9.029982363315703e-02*G0_2_0 + 9.029982363315707e-02*G0_2_1 + 9.029982363315661e-02*G0_2_2;
    block[1204] = -1.354497354497352e-01*G0_0_0 - 1.354497354497352e-01*G0_0_1 - 2.257495590828876e-02*G0_0_2 - 1.354497354497354e-01*G0_1_0 - 1.354497354497355e-01*G0_1_1 - 2.257495590828910e-02*G0_1_2 - 2.257495590828933e-02*G0_2_0 - 2.257495590828935e-02*G0_2_1 - 4.514991181657808e-02*G0_2_2;
    block[1205] = 9.029982363315671e-02*G0_2_2;
    block[1206] = 9.029982363315683e-02*G0_0_0;
    block[1207] = -1.354497354497353e-01*G0_0_0 - 1.128747795414462e-01*G0_0_2 - 1.128747795414465e-01*G0_2_0 - 1.354497354497356e-01*G0_2_2;
    block[1208] = 9.029982363315683e-02*G0_2_2;
    block[1209] = 9.029982363315717e-02*G0_1_1;
    block[1210] = -1.354497354497356e-01*G0_1_1 - 1.128747795414462e-01*G0_1_2 - 1.128747795414462e-01*G0_2_1 - 1.354497354497351e-01*G0_2_2;
    block[1211] = 9.029982363315670e-02*G0_2_2;
    block[1212] = -7.223985890652547e-01*G0_0_0 - 3.160493827160487e-01*G0_0_1 - 3.160493827160488e-01*G0_0_2 - 3.160493827160492e-01*G0_1_0 - 1.354497354497351e-01*G0_1_2 - 3.160493827160495e-01*G0_2_0 - 1.354497354497353e-01*G0_2_1;
    block[1213] = -1.354497354497359e-01*G0_0_1 - 3.160493827160503e-01*G0_0_2 - 1.354497354497356e-01*G0_1_0 - 3.160493827160498e-01*G0_1_2 - 3.160493827160493e-01*G0_2_0 - 3.160493827160498e-01*G0_2_1 - 7.223985890652558e-01*G0_2_2;
    block[1214] = -3.160493827160497e-01*G0_0_1 - 1.354497354497354e-01*G0_0_2 - 3.160493827160489e-01*G0_1_0 - 7.223985890652561e-01*G0_1_1 - 3.160493827160488e-01*G0_1_2 - 1.354497354497352e-01*G0_2_0 - 3.160493827160493e-01*G0_2_1;
    block[1215] = 3.160493827160493e-01*G0_0_1 + 1.354497354497359e-01*G0_0_2 + 3.160493827160489e-01*G0_1_0 - 9.029982363315729e-02*G0_1_1 + 1.354497354497355e-01*G0_1_2 + 1.354497354497352e-01*G0_2_0 + 1.354497354497355e-01*G0_2_1 + 2.708994708994703e-01*G0_2_2;
    block[1216] = 1.354497354497355e-01*G0_0_1 + 3.160493827160489e-01*G0_0_2 + 1.354497354497353e-01*G0_1_0 + 2.708994708994709e-01*G0_1_1 + 1.354497354497351e-01*G0_1_2 + 3.160493827160492e-01*G0_2_0 + 1.354497354497355e-01*G0_2_1 - 9.029982363315651e-02*G0_2_2;
    block[1217] = -7.223985890652549e-01*G0_0_0 - 4.063492063492062e-01*G0_0_1 - 4.063492063492057e-01*G0_0_2 - 4.063492063492055e-01*G0_1_0 - 9.029982363315665e-02*G0_1_1 - 2.257495590828920e-01*G0_1_2 - 4.063492063492060e-01*G0_2_0 - 2.257495590828925e-01*G0_2_1 - 9.029982363315725e-02*G0_2_2;
    block[1218] = 2.708994708994704e-01*G0_0_0 + 1.354497354497356e-01*G0_0_1 + 1.354497354497348e-01*G0_0_2 + 1.354497354497352e-01*G0_1_0 + 3.160493827160487e-01*G0_1_2 + 1.354497354497358e-01*G0_2_0 + 3.160493827160494e-01*G0_2_1 - 9.029982363315668e-02*G0_2_2;
    block[1219] = -9.029982363315739e-02*G0_0_0 + 3.160493827160492e-01*G0_0_1 + 1.354497354497353e-01*G0_0_2 + 3.160493827160485e-01*G0_1_0 + 1.354497354497349e-01*G0_1_2 + 1.354497354497345e-01*G0_2_0 + 1.354497354497357e-01*G0_2_1 + 2.708994708994707e-01*G0_2_2;
    block[1220] = -9.029982363315657e-02*G0_0_0 - 4.063492063492057e-01*G0_0_1 - 2.257495590828919e-01*G0_0_2 - 4.063492063492057e-01*G0_1_0 - 7.223985890652546e-01*G0_1_1 - 4.063492063492058e-01*G0_1_2 - 2.257495590828920e-01*G0_2_0 - 4.063492063492058e-01*G0_2_1 - 9.029982363315739e-02*G0_2_2;
    block[1221] = -9.029982363315625e-02*G0_0_0 - 2.257495590828926e-01*G0_0_1 - 4.063492063492059e-01*G0_0_2 - 2.257495590828919e-01*G0_1_0 - 9.029982363315671e-02*G0_1_1 - 4.063492063492054e-01*G0_1_2 - 4.063492063492055e-01*G0_2_0 - 4.063492063492062e-01*G0_2_1 - 7.223985890652547e-01*G0_2_2;
    block[1222] = -9.029982363315747e-02*G0_0_0 + 1.354497354497351e-01*G0_0_1 + 3.160493827160490e-01*G0_0_2 + 1.354497354497348e-01*G0_1_0 + 2.708994708994706e-01*G0_1_1 + 1.354497354497353e-01*G0_1_2 + 3.160493827160482e-01*G0_2_0 + 1.354497354497349e-01*G0_2_1;
    block[1223] = 2.708994708994709e-01*G0_0_0 + 1.354497354497356e-01*G0_0_1 + 1.354497354497354e-01*G0_0_2 + 1.354497354497354e-01*G0_1_0 - 9.029982363315767e-02*G0_1_1 + 3.160493827160490e-01*G0_1_2 + 1.354497354497354e-01*G0_2_0 + 3.160493827160492e-01*G0_2_1;
    block[1224] = 1.444797178130510e+00*G0_0_0 + 7.223985890652549e-01*G0_0_1 + 7.223985890652558e-01*G0_0_2 + 7.223985890652549e-01*G0_1_0 + 1.444797178130510e+00*G0_1_1 + 7.223985890652551e-01*G0_1_2 + 7.223985890652558e-01*G0_2_0 + 7.223985890652551e-01*G0_2_1 + 1.444797178130510e+00*G0_2_2;
  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 35;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering_0[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 35;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][3] = {{0, 1, 2}, {2, 1, 0}};
      static unsigned int face_reordering_0[6][3] = {{0, 1, 2}, {0, 2, 1}, {2, 0, 1}, {1, 0, 2}, {1, 2, 0}, {2, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 3*cell.edgeID(0) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(1);
      dofs[7] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[8] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[9] = offset + 3*cell.edgeID(1) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(2);
      dofs[10] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[11] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[12] = offset + 3*cell.edgeID(2) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(3);
      dofs[13] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[14] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[15] = offset + 3*cell.edgeID(3) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(4);
      dofs[16] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 3*cell.edgeID(4) + edge_reordering_0[alignment][2];
      alignment = cell.edgeAlignment(5);
      dofs[19] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[20] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[21] = offset + 3*cell.edgeID(5) + edge_reordering_0[alignment][2];
      alignment = cell.faceAlignment(0);
      offset = offset + 3*mesh.noEdges();
      dofs[22] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[23] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[24] = offset + 3*cell.faceID(0) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(1);
      dofs[25] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[26] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[27] = offset + 3*cell.faceID(1) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(2);
      dofs[28] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[29] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[30] = offset + 3*cell.faceID(2) + face_reordering_0[alignment][2];
      alignment = cell.faceAlignment(3);
      dofs[31] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[32] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[33] = offset + 3*cell.faceID(3) + face_reordering_0[alignment][2];
      offset = offset + 3*mesh.noFaces();
      dofs[34] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(7.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[5] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(2.500000000000000e-01, 7.500000000000000e-01, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 7.500000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 2.500000000000000e-01, 0.000000000000000e+00);
      points[10] = map(2.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(7.500000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.500000000000000e-01);
      points[14] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[15] = map(0.000000000000000e+00, 0.000000000000000e+00, 7.500000000000000e-01);
      points[16] = map(7.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[17] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(2.500000000000000e-01, 0.000000000000000e+00, 7.500000000000000e-01);
      points[19] = map(0.000000000000000e+00, 7.500000000000000e-01, 2.500000000000000e-01);
      points[20] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[21] = map(0.000000000000000e+00, 2.500000000000000e-01, 7.500000000000000e-01);
      points[22] = map(5.000000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[23] = map(2.500000000000000e-01, 2.500000000000000e-01, 5.000000000000000e-01);
      points[24] = map(2.500000000000000e-01, 5.000000000000000e-01, 2.500000000000000e-01);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 2.500000000000000e-01);
      points[26] = map(0.000000000000000e+00, 2.500000000000000e-01, 5.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.500000000000000e-01, 2.500000000000000e-01);
      points[28] = map(2.500000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(5.000000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[30] = map(2.500000000000000e-01, 0.000000000000000e+00, 2.500000000000000e-01);
      points[31] = map(2.500000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[32] = map(5.000000000000000e-01, 2.500000000000000e-01, 0.000000000000000e+00);
      points[33] = map(2.500000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[34] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];
    const real c0_4 = c[0][4];
    const real c0_5 = c[0][5];
    const real c0_6 = c[0][6];
    const real c0_7 = c[0][7];
    const real c0_8 = c[0][8];
    const real c0_9 = c[0][9];
    const real c0_10 = c[0][10];
    const real c0_11 = c[0][11];
    const real c0_12 = c[0][12];
    const real c0_13 = c[0][13];
    const real c0_14 = c[0][14];
    const real c0_15 = c[0][15];
    const real c0_16 = c[0][16];
    const real c0_17 = c[0][17];
    const real c0_18 = c[0][18];
    const real c0_19 = c[0][19];
    const real c0_20 = c[0][20];
    const real c0_21 = c[0][21];
    const real c0_22 = c[0][22];
    const real c0_23 = c[0][23];
    const real c0_24 = c[0][24];
    const real c0_25 = c[0][25];
    const real c0_26 = c[0][26];
    const real c0_27 = c[0][27];
    const real c0_28 = c[0][28];
    const real c0_29 = c[0][29];
    const real c0_30 = c[0][30];
    const real c0_31 = c[0][31];
    const real c0_32 = c[0][32];
    const real c0_33 = c[0][33];
    const real c0_34 = c[0][34];

    // Compute geometry tensors
    const real G0_0 = map.det*c0_0;
    const real G0_1 = map.det*c0_1;
    const real G0_2 = map.det*c0_2;
    const real G0_3 = map.det*c0_3;
    const real G0_4 = map.det*c0_4;
    const real G0_5 = map.det*c0_5;
    const real G0_6 = map.det*c0_6;
    const real G0_7 = map.det*c0_7;
    const real G0_8 = map.det*c0_8;
    const real G0_9 = map.det*c0_9;
    const real G0_10 = map.det*c0_10;
    const real G0_11 = map.det*c0_11;
    const real G0_12 = map.det*c0_12;
    const real G0_13 = map.det*c0_13;
    const real G0_14 = map.det*c0_14;
    const real G0_15 = map.det*c0_15;
    const real G0_16 = map.det*c0_16;
    const real G0_17 = map.det*c0_17;
    const real G0_18 = map.det*c0_18;
    const real G0_19 = map.det*c0_19;
    const real G0_20 = map.det*c0_20;
    const real G0_21 = map.det*c0_21;
    const real G0_22 = map.det*c0_22;
    const real G0_23 = map.det*c0_23;
    const real G0_24 = map.det*c0_24;
    const real G0_25 = map.det*c0_25;
    const real G0_26 = map.det*c0_26;
    const real G0_27 = map.det*c0_27;
    const real G0_28 = map.det*c0_28;
    const real G0_29 = map.det*c0_29;
    const real G0_30 = map.det*c0_30;
    const real G0_31 = map.det*c0_31;
    const real G0_32 = map.det*c0_32;
    const real G0_33 = map.det*c0_33;
    const real G0_34 = map.det*c0_34;

    // Compute element tensor
    block[0] = 2.004168670835322e-04*G0_0 + 1.630057185612728e-05*G0_1 + 1.630057185612725e-05*G0_2 + 1.630057185612739e-05*G0_3 - 1.218534551867875e-04*G0_4 + 8.390786168563884e-05*G0_5 - 1.218534551867873e-04*G0_6 - 6.840895729784516e-05*G0_7 + 1.122334455667780e-04*G0_8 - 1.496445940890377e-04*G0_9 - 1.496445940890376e-04*G0_10 + 1.122334455667780e-04*G0_11 - 6.840895729784547e-05*G0_12 - 1.496445940890383e-04*G0_13 + 1.122334455667788e-04*G0_14 - 6.840895729784588e-05*G0_15 - 1.218534551867876e-04*G0_16 + 8.390786168563893e-05*G0_17 - 1.218534551867878e-04*G0_18 - 1.218534551867875e-04*G0_19 + 8.390786168563885e-05*G0_20 - 1.218534551867876e-04*G0_21 - 2.159157714713257e-04*G0_22 - 2.159157714713260e-04*G0_23 - 2.159157714713258e-04*G0_24 - 1.859868526535184e-04*G0_25 - 1.859868526535181e-04*G0_26 + 2.886002886002872e-04*G0_27 - 1.859868526535178e-04*G0_28 - 1.859868526535186e-04*G0_29 + 2.886002886002876e-04*G0_30 + 2.886002886002879e-04*G0_31 - 1.859868526535181e-04*G0_32 - 1.859868526535180e-04*G0_33 - 5.387205387205348e-04*G0_34;
    block[1] = 1.630057185612728e-05*G0_0 + 2.004168670835317e-04*G0_1 + 1.630057185612735e-05*G0_2 + 1.630057185612741e-05*G0_3 - 1.496445940890380e-04*G0_4 + 1.122334455667784e-04*G0_5 - 6.840895729784566e-05*G0_6 - 1.218534551867873e-04*G0_7 + 8.390786168563878e-05*G0_8 - 1.218534551867874e-04*G0_9 - 6.840895729784565e-05*G0_10 + 1.122334455667779e-04*G0_11 - 1.496445940890376e-04*G0_12 - 1.218534551867877e-04*G0_13 + 8.390786168563895e-05*G0_14 - 1.218534551867878e-04*G0_15 - 1.496445940890387e-04*G0_16 + 1.122334455667794e-04*G0_17 - 6.840895729784635e-05*G0_18 - 1.218534551867877e-04*G0_19 + 8.390786168563908e-05*G0_20 - 1.218534551867877e-04*G0_21 + 2.886002886002866e-04*G0_22 - 1.859868526535185e-04*G0_23 - 1.859868526535181e-04*G0_24 - 2.159157714713252e-04*G0_25 - 2.159157714713266e-04*G0_26 - 2.159157714713254e-04*G0_27 - 1.859868526535186e-04*G0_28 + 2.886002886002868e-04*G0_29 - 1.859868526535176e-04*G0_30 - 1.859868526535169e-04*G0_31 + 2.886002886002866e-04*G0_32 - 1.859868526535181e-04*G0_33 - 5.387205387205351e-04*G0_34;
    block[2] = 1.630057185612724e-05*G0_0 + 1.630057185612735e-05*G0_1 + 2.004168670835320e-04*G0_2 + 1.630057185612732e-05*G0_3 - 6.840895729784530e-05*G0_4 + 1.122334455667777e-04*G0_5 - 1.496445940890372e-04*G0_6 - 1.496445940890370e-04*G0_7 + 1.122334455667777e-04*G0_8 - 6.840895729784531e-05*G0_9 - 1.218534551867873e-04*G0_10 + 8.390786168563873e-05*G0_11 - 1.218534551867873e-04*G0_12 - 1.218534551867874e-04*G0_13 + 8.390786168563872e-05*G0_14 - 1.218534551867874e-04*G0_15 - 1.218534551867875e-04*G0_16 + 8.390786168563870e-05*G0_17 - 1.218534551867876e-04*G0_18 - 1.496445940890380e-04*G0_19 + 1.122334455667787e-04*G0_20 - 6.840895729784604e-05*G0_21 - 1.859868526535178e-04*G0_22 - 1.859868526535180e-04*G0_23 + 2.886002886002865e-04*G0_24 + 2.886002886002864e-04*G0_25 - 1.859868526535179e-04*G0_26 - 1.859868526535183e-04*G0_27 - 2.159157714713260e-04*G0_28 - 2.159157714713250e-04*G0_29 - 2.159157714713249e-04*G0_30 - 1.859868526535175e-04*G0_31 - 1.859868526535175e-04*G0_32 + 2.886002886002863e-04*G0_33 - 5.387205387205351e-04*G0_34;
    block[3] = 1.630057185612739e-05*G0_0 + 1.630057185612740e-05*G0_1 + 1.630057185612732e-05*G0_2 + 2.004168670835326e-04*G0_3 - 1.218534551867876e-04*G0_4 + 8.390786168563930e-05*G0_5 - 1.218534551867876e-04*G0_6 - 1.218534551867875e-04*G0_7 + 8.390786168563896e-05*G0_8 - 1.218534551867876e-04*G0_9 - 1.218534551867875e-04*G0_10 + 8.390786168563877e-05*G0_11 - 1.218534551867875e-04*G0_12 - 6.840895729784580e-05*G0_13 + 1.122334455667781e-04*G0_14 - 1.496445940890377e-04*G0_15 - 6.840895729784587e-05*G0_16 + 1.122334455667781e-04*G0_17 - 1.496445940890376e-04*G0_18 - 6.840895729784638e-05*G0_19 + 1.122334455667786e-04*G0_20 - 1.496445940890378e-04*G0_21 - 1.859868526535175e-04*G0_22 + 2.886002886002862e-04*G0_23 - 1.859868526535185e-04*G0_24 - 1.859868526535189e-04*G0_25 + 2.886002886002864e-04*G0_26 - 1.859868526535175e-04*G0_27 + 2.886002886002861e-04*G0_28 - 1.859868526535183e-04*G0_29 - 1.859868526535175e-04*G0_30 - 2.159157714713245e-04*G0_31 - 2.159157714713251e-04*G0_32 - 2.159157714713257e-04*G0_33 - 5.387205387205361e-04*G0_34;
    block[4] = -1.218534551867875e-04*G0_0 - 1.496445940890380e-04*G0_1 - 6.840895729784530e-05*G0_2 - 1.218534551867876e-04*G0_3 + 1.710223932446139e-03*G0_4 - 1.257014590347911e-03*G0_5 + 6.840895729784542e-04*G0_6 + 3.591470258136882e-04*G0_7 - 1.539201539201524e-04*G0_8 + 2.736358291913819e-04*G0_9 + 3.591470258136886e-04*G0_10 - 6.541606541606470e-04*G0_11 + 8.551119662230690e-04*G0_12 + 1.368179145956913e-04*G0_13 - 9.833787611565335e-05*G0_14 + 1.368179145956916e-04*G0_15 + 8.551119662230684e-04*G0_16 - 6.541606541606473e-04*G0_17 + 3.591470258136887e-04*G0_18 + 3.591470258136891e-04*G0_19 - 1.539201539201528e-04*G0_20 + 2.736358291913825e-04*G0_21 + 1.026134359467643e-04*G0_22 - 3.420447864892171e-05*G0_23 + 5.130671797338442e-04*G0_24 + 9.748276414943018e-04*G0_25 + 8.551119662230793e-05*G0_26 + 8.551119662230600e-05*G0_27 - 1.710223932446111e-05*G0_28 + 5.130671797338300e-05*G0_29 - 1.710223932446158e-05*G0_30 - 3.420447864892522e-05*G0_31 + 1.026134359467679e-04*G0_32 + 5.130671797338427e-04*G0_33 + 1.094543316765530e-03*G0_34;
    block[5] = 8.390786168563884e-05*G0_0 + 1.122334455667784e-04*G0_1 + 1.122334455667777e-04*G0_2 + 8.390786168563930e-05*G0_3 - 1.257014590347911e-03*G0_4 + 2.385762385762360e-03*G0_5 - 1.257014590347910e-03*G0_6 - 6.541606541606473e-04*G0_7 + 2.565335898669206e-04*G0_8 - 1.539201539201526e-04*G0_9 - 1.539201539201525e-04*G0_10 + 2.565335898669203e-04*G0_11 - 6.541606541606473e-04*G0_12 - 9.833787611565332e-05*G0_13 + 1.924001924001926e-05*G0_14 - 9.833787611565353e-05*G0_15 - 6.541606541606474e-04*G0_16 + 2.565335898669204e-04*G0_17 - 1.539201539201528e-04*G0_18 - 6.541606541606479e-04*G0_19 + 2.565335898669213e-04*G0_20 - 1.539201539201530e-04*G0_21 - 7.696007696007733e-05*G0_22 - 1.795735129068430e-04*G0_23 - 7.696007696007977e-05*G0_24 - 1.013307679974340e-03*G0_25 + 2.693602693602673e-04*G0_26 + 2.693602693602681e-04*G0_27 + 2.693602693602671e-04*G0_28 - 1.013307679974337e-03*G0_29 + 2.693602693602680e-04*G0_30 - 1.795735129068428e-04*G0_31 - 7.696007696007576e-05*G0_32 - 7.696007696007764e-05*G0_33 - 1.026134359467686e-03*G0_34;
    block[6] = -1.218534551867873e-04*G0_0 - 6.840895729784568e-05*G0_1 - 1.496445940890372e-04*G0_2 - 1.218534551867876e-04*G0_3 + 6.840895729784542e-04*G0_4 - 1.257014590347910e-03*G0_5 + 1.710223932446136e-03*G0_6 + 8.551119662230683e-04*G0_7 - 6.541606541606470e-04*G0_8 + 3.591470258136879e-04*G0_9 + 2.736358291913815e-04*G0_10 - 1.539201539201522e-04*G0_11 + 3.591470258136884e-04*G0_12 + 1.368179145956911e-04*G0_13 - 9.833787611565327e-05*G0_14 + 1.368179145956913e-04*G0_15 + 3.591470258136887e-04*G0_16 - 1.539201539201527e-04*G0_17 + 2.736358291913823e-04*G0_18 + 8.551119662230683e-04*G0_19 - 6.541606541606474e-04*G0_20 + 3.591470258136884e-04*G0_21 + 5.130671797338425e-04*G0_22 - 3.420447864892167e-05*G0_23 + 1.026134359467640e-04*G0_24 + 5.130671797338262e-05*G0_25 - 1.710223932446050e-05*G0_26 - 1.710223932446116e-05*G0_27 + 8.551119662230770e-05*G0_28 + 9.748276414943000e-04*G0_29 + 8.551119662230674e-05*G0_30 - 3.420447864892455e-05*G0_31 + 5.130671797338423e-04*G0_32 + 1.026134359467673e-04*G0_33 + 1.094543316765530e-03*G0_34;
    block[7] = -6.840895729784513e-05*G0_0 - 1.218534551867873e-04*G0_1 - 1.496445940890370e-04*G0_2 - 1.218534551867875e-04*G0_3 + 3.591470258136882e-04*G0_4 - 6.541606541606473e-04*G0_5 + 8.551119662230684e-04*G0_6 + 1.710223932446136e-03*G0_7 - 1.257014590347910e-03*G0_8 + 6.840895729784537e-04*G0_9 + 3.591470258136875e-04*G0_10 - 1.539201539201518e-04*G0_11 + 2.736358291913815e-04*G0_12 + 3.591470258136882e-04*G0_13 - 1.539201539201518e-04*G0_14 + 2.736358291913816e-04*G0_15 + 1.368179145956910e-04*G0_16 - 9.833787611565332e-05*G0_17 + 1.368179145956910e-04*G0_18 + 8.551119662230691e-04*G0_19 - 6.541606541606473e-04*G0_20 + 3.591470258136884e-04*G0_21 - 1.710223932446251e-05*G0_22 - 1.710223932446125e-05*G0_23 + 5.130671797338249e-05*G0_24 + 1.026134359467658e-04*G0_25 - 3.420447864892210e-05*G0_26 + 5.130671797338417e-04*G0_27 + 8.551119662230772e-05*G0_28 + 8.551119662230619e-05*G0_29 + 9.748276414942990e-04*G0_30 + 5.130671797338393e-04*G0_31 - 3.420447864892478e-05*G0_32 + 1.026134359467680e-04*G0_33 + 1.094543316765525e-03*G0_34;
    block[8] = 1.122334455667780e-04*G0_0 + 8.390786168563878e-05*G0_1 + 1.122334455667777e-04*G0_2 + 8.390786168563893e-05*G0_3 - 1.539201539201524e-04*G0_4 + 2.565335898669205e-04*G0_5 - 6.541606541606470e-04*G0_6 - 1.257014590347910e-03*G0_7 + 2.385762385762361e-03*G0_8 - 1.257014590347910e-03*G0_9 - 6.541606541606471e-04*G0_10 + 2.565335898669208e-04*G0_11 - 1.539201539201525e-04*G0_12 - 6.541606541606479e-04*G0_13 + 2.565335898669206e-04*G0_14 - 1.539201539201522e-04*G0_15 - 9.833787611565323e-05*G0_16 + 1.924001924001944e-05*G0_17 - 9.833787611565321e-05*G0_18 - 6.541606541606481e-04*G0_19 + 2.565335898669204e-04*G0_20 - 1.539201539201522e-04*G0_21 + 2.693602693602681e-04*G0_22 + 2.693602693602668e-04*G0_23 - 1.013307679974340e-03*G0_24 - 7.696007696007745e-05*G0_25 - 1.795735129068441e-04*G0_26 - 7.696007696007757e-05*G0_27 + 2.693602693602667e-04*G0_28 + 2.693602693602678e-04*G0_29 - 1.013307679974337e-03*G0_30 - 7.696007696007535e-05*G0_31 - 1.795735129068434e-04*G0_32 - 7.696007696007736e-05*G0_33 - 1.026134359467685e-03*G0_34;
    block[9] = -1.496445940890377e-04*G0_0 - 1.218534551867874e-04*G0_1 - 6.840895729784534e-05*G0_2 - 1.218534551867876e-04*G0_3 + 2.736358291913820e-04*G0_4 - 1.539201539201526e-04*G0_5 + 3.591470258136879e-04*G0_6 + 6.840895729784537e-04*G0_7 - 1.257014590347910e-03*G0_8 + 1.710223932446141e-03*G0_9 + 8.551119662230694e-04*G0_10 - 6.541606541606476e-04*G0_11 + 3.591470258136889e-04*G0_12 + 8.551119662230695e-04*G0_13 - 6.541606541606477e-04*G0_14 + 3.591470258136885e-04*G0_15 + 1.368179145956913e-04*G0_16 - 9.833787611565358e-05*G0_17 + 1.368179145956916e-04*G0_18 + 3.591470258136892e-04*G0_19 - 1.539201539201524e-04*G0_20 + 2.736358291913822e-04*G0_21 + 8.551119662230667e-05*G0_22 + 8.551119662230840e-05*G0_23 + 9.748276414943014e-04*G0_24 + 5.130671797338438e-04*G0_25 - 3.420447864892123e-05*G0_26 + 1.026134359467653e-04*G0_27 - 1.710223932446097e-05*G0_28 - 1.710223932446034e-05*G0_29 + 5.130671797338145e-05*G0_30 + 1.026134359467650e-04*G0_31 - 3.420447864892268e-05*G0_32 + 5.130671797338429e-04*G0_33 + 1.094543316765531e-03*G0_34;
    block[10] = -1.496445940890376e-04*G0_0 - 6.840895729784565e-05*G0_1 - 1.218534551867873e-04*G0_2 - 1.218534551867875e-04*G0_3 + 3.591470258136887e-04*G0_4 - 1.539201539201525e-04*G0_5 + 2.736358291913815e-04*G0_6 + 3.591470258136875e-04*G0_7 - 6.541606541606471e-04*G0_8 + 8.551119662230696e-04*G0_9 + 1.710223932446139e-03*G0_10 - 1.257014590347912e-03*G0_11 + 6.840895729784546e-04*G0_12 + 8.551119662230697e-04*G0_13 - 6.541606541606470e-04*G0_14 + 3.591470258136885e-04*G0_15 + 3.591470258136891e-04*G0_16 - 1.539201539201523e-04*G0_17 + 2.736358291913823e-04*G0_18 + 1.368179145956914e-04*G0_19 - 9.833787611565359e-05*G0_20 + 1.368179145956914e-04*G0_21 + 9.748276414943007e-04*G0_22 + 8.551119662230859e-05*G0_23 + 8.551119662230729e-05*G0_24 - 1.710223932446090e-05*G0_25 - 1.710223932446062e-05*G0_26 + 5.130671797338238e-05*G0_27 - 3.420447864892118e-05*G0_28 + 5.130671797338433e-04*G0_29 + 1.026134359467641e-04*G0_30 + 1.026134359467655e-04*G0_31 + 5.130671797338426e-04*G0_32 - 3.420447864892224e-05*G0_33 + 1.094543316765532e-03*G0_34;
    block[11] = 1.122334455667780e-04*G0_0 + 1.122334455667779e-04*G0_1 + 8.390786168563874e-05*G0_2 + 8.390786168563877e-05*G0_3 - 6.541606541606470e-04*G0_4 + 2.565335898669203e-04*G0_5 - 1.539201539201522e-04*G0_6 - 1.539201539201518e-04*G0_7 + 2.565335898669207e-04*G0_8 - 6.541606541606476e-04*G0_9 - 1.257014590347912e-03*G0_10 + 2.385762385762362e-03*G0_11 - 1.257014590347911e-03*G0_12 - 6.541606541606481e-04*G0_13 + 2.565335898669205e-04*G0_14 - 1.539201539201523e-04*G0_15 - 6.541606541606474e-04*G0_16 + 2.565335898669199e-04*G0_17 - 1.539201539201525e-04*G0_18 - 9.833787611565317e-05*G0_19 + 1.924001924001941e-05*G0_20 - 9.833787611565301e-05*G0_21 - 1.013307679974339e-03*G0_22 + 2.693602693602669e-04*G0_23 + 2.693602693602679e-04*G0_24 + 2.693602693602678e-04*G0_25 + 2.693602693602672e-04*G0_26 - 1.013307679974338e-03*G0_27 - 1.795735129068437e-04*G0_28 - 7.696007696007804e-05*G0_29 - 7.696007696007714e-05*G0_30 - 7.696007696007486e-05*G0_31 - 7.696007696007677e-05*G0_32 - 1.795735129068435e-04*G0_33 - 1.026134359467685e-03*G0_34;
    block[12] = -6.840895729784546e-05*G0_0 - 1.496445940890376e-04*G0_1 - 1.218534551867873e-04*G0_2 - 1.218534551867875e-04*G0_3 + 8.551119662230690e-04*G0_4 - 6.541606541606473e-04*G0_5 + 3.591470258136884e-04*G0_6 + 2.736358291913815e-04*G0_7 - 1.539201539201525e-04*G0_8 + 3.591470258136889e-04*G0_9 + 6.840895729784545e-04*G0_10 - 1.257014590347911e-03*G0_11 + 1.710223932446138e-03*G0_12 + 3.591470258136892e-04*G0_13 - 1.539201539201527e-04*G0_14 + 2.736358291913823e-04*G0_15 + 8.551119662230693e-04*G0_16 - 6.541606541606473e-04*G0_17 + 3.591470258136891e-04*G0_18 + 1.368179145956914e-04*G0_19 - 9.833787611565365e-05*G0_20 + 1.368179145956915e-04*G0_21 + 5.130671797338260e-05*G0_22 - 1.710223932446079e-05*G0_23 - 1.710223932446066e-05*G0_24 + 8.551119662230726e-05*G0_25 + 8.551119662230789e-05*G0_26 + 9.748276414943004e-04*G0_27 - 3.420447864892153e-05*G0_28 + 1.026134359467663e-04*G0_29 + 5.130671797338428e-04*G0_30 + 5.130671797338405e-04*G0_31 + 1.026134359467675e-04*G0_32 - 3.420447864892230e-05*G0_33 + 1.094543316765531e-03*G0_34;
    block[13] = -1.496445940890383e-04*G0_0 - 1.218534551867877e-04*G0_1 - 1.218534551867874e-04*G0_2 - 6.840895729784582e-05*G0_3 + 1.368179145956914e-04*G0_4 - 9.833787611565331e-05*G0_5 + 1.368179145956911e-04*G0_6 + 3.591470258136882e-04*G0_7 - 6.541606541606478e-04*G0_8 + 8.551119662230695e-04*G0_9 + 8.551119662230698e-04*G0_10 - 6.541606541606481e-04*G0_11 + 3.591470258136892e-04*G0_12 + 1.710223932446142e-03*G0_13 - 1.257014590347915e-03*G0_14 + 6.840895729784570e-04*G0_15 + 2.736358291913830e-04*G0_16 - 1.539201539201537e-04*G0_17 + 3.591470258136908e-04*G0_18 + 2.736358291913836e-04*G0_19 - 1.539201539201537e-04*G0_20 + 3.591470258136907e-04*G0_21 + 8.551119662230679e-05*G0_22 + 9.748276414943028e-04*G0_23 + 8.551119662230759e-05*G0_24 - 3.420447864892151e-05*G0_25 + 5.130671797338440e-04*G0_26 + 1.026134359467667e-04*G0_27 + 5.130671797338434e-04*G0_28 - 3.420447864892213e-05*G0_29 + 1.026134359467655e-04*G0_30 + 5.130671797338072e-05*G0_31 - 1.710223932446088e-05*G0_32 - 1.710223932446044e-05*G0_33 + 1.094543316765534e-03*G0_34;
    block[14] = 1.122334455667788e-04*G0_0 + 8.390786168563895e-05*G0_1 + 8.390786168563874e-05*G0_2 + 1.122334455667781e-04*G0_3 - 9.833787611565335e-05*G0_4 + 1.924001924001925e-05*G0_5 - 9.833787611565326e-05*G0_6 - 1.539201539201518e-04*G0_7 + 2.565335898669207e-04*G0_8 - 6.541606541606477e-04*G0_9 - 6.541606541606470e-04*G0_10 + 2.565335898669205e-04*G0_11 - 1.539201539201526e-04*G0_12 - 1.257014590347915e-03*G0_13 + 2.385762385762368e-03*G0_14 - 1.257014590347915e-03*G0_15 - 1.539201539201536e-04*G0_16 + 2.565335898669224e-04*G0_17 - 6.541606541606511e-04*G0_18 - 1.539201539201539e-04*G0_19 + 2.565335898669231e-04*G0_20 - 6.541606541606510e-04*G0_21 + 2.693602693602680e-04*G0_22 - 1.013307679974341e-03*G0_23 + 2.693602693602677e-04*G0_24 - 1.795735129068452e-04*G0_25 - 7.696007696007692e-05*G0_26 - 7.696007696007652e-05*G0_27 - 7.696007696007759e-05*G0_28 - 1.795735129068447e-04*G0_29 - 7.696007696007531e-05*G0_30 - 1.013307679974336e-03*G0_31 + 2.693602693602670e-04*G0_32 + 2.693602693602660e-04*G0_33 - 1.026134359467686e-03*G0_34;
    block[15] = -6.840895729784588e-05*G0_0 - 1.218534551867878e-04*G0_1 - 1.218534551867875e-04*G0_2 - 1.496445940890377e-04*G0_3 + 1.368179145956916e-04*G0_4 - 9.833787611565351e-05*G0_5 + 1.368179145956913e-04*G0_6 + 2.736358291913816e-04*G0_7 - 1.539201539201522e-04*G0_8 + 3.591470258136885e-04*G0_9 + 3.591470258136885e-04*G0_10 - 1.539201539201522e-04*G0_11 + 2.736358291913823e-04*G0_12 + 6.840895729784570e-04*G0_13 - 1.257014590347915e-03*G0_14 + 1.710223932446144e-03*G0_15 + 3.591470258136907e-04*G0_16 - 6.541606541606515e-04*G0_17 + 8.551119662230727e-04*G0_18 + 3.591470258136911e-04*G0_19 - 6.541606541606516e-04*G0_20 + 8.551119662230730e-04*G0_21 - 1.710223932446190e-05*G0_22 + 5.130671797338373e-05*G0_23 - 1.710223932446149e-05*G0_24 - 3.420447864892155e-05*G0_25 + 1.026134359467691e-04*G0_26 + 5.130671797338407e-04*G0_27 + 1.026134359467684e-04*G0_28 - 3.420447864892249e-05*G0_29 + 5.130671797338407e-04*G0_30 + 9.748276414942965e-04*G0_31 + 8.551119662230698e-05*G0_32 + 8.551119662230790e-05*G0_33 + 1.094543316765529e-03*G0_34;
    block[16] = -1.218534551867876e-04*G0_0 - 1.496445940890386e-04*G0_1 - 1.218534551867875e-04*G0_2 - 6.840895729784587e-05*G0_3 + 8.551119662230684e-04*G0_4 - 6.541606541606474e-04*G0_5 + 3.591470258136887e-04*G0_6 + 1.368179145956910e-04*G0_7 - 9.833787611565323e-05*G0_8 + 1.368179145956913e-04*G0_9 + 3.591470258136891e-04*G0_10 - 6.541606541606474e-04*G0_11 + 8.551119662230693e-04*G0_12 + 2.736358291913830e-04*G0_13 - 1.539201539201535e-04*G0_14 + 3.591470258136907e-04*G0_15 + 1.710223932446140e-03*G0_16 - 1.257014590347913e-03*G0_17 + 6.840895729784572e-04*G0_18 + 2.736358291913831e-04*G0_19 - 1.539201539201542e-04*G0_20 + 3.591470258136911e-04*G0_21 + 1.026134359467657e-04*G0_22 + 5.130671797338433e-04*G0_23 - 3.420447864892205e-05*G0_24 + 8.551119662230663e-05*G0_25 + 9.748276414943035e-04*G0_26 + 8.551119662230735e-05*G0_27 + 5.130671797338440e-04*G0_28 + 1.026134359467673e-04*G0_29 - 3.420447864892305e-05*G0_30 - 1.710223932446258e-05*G0_31 + 5.130671797338355e-05*G0_32 - 1.710223932446122e-05*G0_33 + 1.094543316765533e-03*G0_34;
    block[17] = 8.390786168563893e-05*G0_0 + 1.122334455667793e-04*G0_1 + 8.390786168563869e-05*G0_2 + 1.122334455667781e-04*G0_3 - 6.541606541606473e-04*G0_4 + 2.565335898669204e-04*G0_5 - 1.539201539201527e-04*G0_6 - 9.833787611565334e-05*G0_7 + 1.924001924001944e-05*G0_8 - 9.833787611565358e-05*G0_9 - 1.539201539201524e-04*G0_10 + 2.565335898669199e-04*G0_11 - 6.541606541606473e-04*G0_12 - 1.539201539201537e-04*G0_13 + 2.565335898669225e-04*G0_14 - 6.541606541606515e-04*G0_15 - 1.257014590347913e-03*G0_16 + 2.385762385762368e-03*G0_17 - 1.257014590347916e-03*G0_18 - 1.539201539201543e-04*G0_19 + 2.565335898669233e-04*G0_20 - 6.541606541606517e-04*G0_21 - 7.696007696007364e-05*G0_22 - 7.696007696007743e-05*G0_23 - 1.795735129068459e-04*G0_24 + 2.693602693602670e-04*G0_25 - 1.013307679974341e-03*G0_26 + 2.693602693602676e-04*G0_27 - 7.696007696007748e-05*G0_28 - 7.696007696007542e-05*G0_29 - 1.795735129068452e-04*G0_30 + 2.693602693602676e-04*G0_31 - 1.013307679974337e-03*G0_32 + 2.693602693602661e-04*G0_33 - 1.026134359467687e-03*G0_34;
    block[18] = -1.218534551867878e-04*G0_0 - 6.840895729784637e-05*G0_1 - 1.218534551867876e-04*G0_2 - 1.496445940890376e-04*G0_3 + 3.591470258136887e-04*G0_4 - 1.539201539201528e-04*G0_5 + 2.736358291913823e-04*G0_6 + 1.368179145956910e-04*G0_7 - 9.833787611565321e-05*G0_8 + 1.368179145956916e-04*G0_9 + 2.736358291913823e-04*G0_10 - 1.539201539201524e-04*G0_11 + 3.591470258136891e-04*G0_12 + 3.591470258136908e-04*G0_13 - 6.541606541606510e-04*G0_14 + 8.551119662230726e-04*G0_15 + 6.840895729784570e-04*G0_16 - 1.257014590347916e-03*G0_17 + 1.710223932446143e-03*G0_18 + 3.591470258136908e-04*G0_19 - 6.541606541606515e-04*G0_20 + 8.551119662230729e-04*G0_21 + 5.130671797338408e-04*G0_22 + 1.026134359467689e-04*G0_23 - 3.420447864892276e-05*G0_24 - 1.710223932446104e-05*G0_25 + 5.130671797338475e-05*G0_26 - 1.710223932446070e-05*G0_27 + 1.026134359467690e-04*G0_28 + 5.130671797338427e-04*G0_29 - 3.420447864892312e-05*G0_30 + 8.551119662230596e-05*G0_31 + 9.748276414942987e-04*G0_32 + 8.551119662230754e-05*G0_33 + 1.094543316765532e-03*G0_34;
    block[19] = -1.218534551867875e-04*G0_0 - 1.218534551867877e-04*G0_1 - 1.496445940890380e-04*G0_2 - 6.840895729784639e-05*G0_3 + 3.591470258136891e-04*G0_4 - 6.541606541606479e-04*G0_5 + 8.551119662230683e-04*G0_6 + 8.551119662230691e-04*G0_7 - 6.541606541606479e-04*G0_8 + 3.591470258136892e-04*G0_9 + 1.368179145956914e-04*G0_10 - 9.833787611565317e-05*G0_11 + 1.368179145956914e-04*G0_12 + 2.736358291913836e-04*G0_13 - 1.539201539201539e-04*G0_14 + 3.591470258136911e-04*G0_15 + 2.736358291913831e-04*G0_16 - 1.539201539201543e-04*G0_17 + 3.591470258136908e-04*G0_18 + 1.710223932446141e-03*G0_19 - 1.257014590347916e-03*G0_20 + 6.840895729784574e-04*G0_21 - 3.420447864892312e-05*G0_22 + 5.130671797338428e-04*G0_23 + 1.026134359467672e-04*G0_24 + 1.026134359467673e-04*G0_25 + 5.130671797338433e-04*G0_26 - 3.420447864892182e-05*G0_27 + 9.748276414943018e-04*G0_28 + 8.551119662230687e-05*G0_29 + 8.551119662230702e-05*G0_30 - 1.710223932446242e-05*G0_31 - 1.710223932446192e-05*G0_32 + 5.130671797338384e-05*G0_33 + 1.094543316765532e-03*G0_34;
    block[20] = 8.390786168563887e-05*G0_0 + 8.390786168563904e-05*G0_1 + 1.122334455667787e-04*G0_2 + 1.122334455667786e-04*G0_3 - 1.539201539201528e-04*G0_4 + 2.565335898669213e-04*G0_5 - 6.541606541606474e-04*G0_6 - 6.541606541606474e-04*G0_7 + 2.565335898669205e-04*G0_8 - 1.539201539201525e-04*G0_9 - 9.833787611565358e-05*G0_10 + 1.924001924001941e-05*G0_11 - 9.833787611565365e-05*G0_12 - 1.539201539201537e-04*G0_13 + 2.565335898669231e-04*G0_14 - 6.541606541606516e-04*G0_15 - 1.539201539201542e-04*G0_16 + 2.565335898669233e-04*G0_17 - 6.541606541606515e-04*G0_18 - 1.257014590347916e-03*G0_19 + 2.385762385762370e-03*G0_20 - 1.257014590347915e-03*G0_21 - 1.795735129068453e-04*G0_22 - 7.696007696007786e-05*G0_23 - 7.696007696007471e-05*G0_24 - 7.696007696007485e-05*G0_25 - 7.696007696007729e-05*G0_26 - 1.795735129068462e-04*G0_27 - 1.013307679974340e-03*G0_28 + 2.693602693602663e-04*G0_29 + 2.693602693602672e-04*G0_30 + 2.693602693602676e-04*G0_31 + 2.693602693602667e-04*G0_32 - 1.013307679974337e-03*G0_33 - 1.026134359467689e-03*G0_34;
    block[21] = -1.218534551867876e-04*G0_0 - 1.218534551867878e-04*G0_1 - 6.840895729784604e-05*G0_2 - 1.496445940890378e-04*G0_3 + 2.736358291913825e-04*G0_4 - 1.539201539201530e-04*G0_5 + 3.591470258136884e-04*G0_6 + 3.591470258136884e-04*G0_7 - 1.539201539201522e-04*G0_8 + 2.736358291913822e-04*G0_9 + 1.368179145956914e-04*G0_10 - 9.833787611565301e-05*G0_11 + 1.368179145956915e-04*G0_12 + 3.591470258136907e-04*G0_13 - 6.541606541606510e-04*G0_14 + 8.551119662230730e-04*G0_15 + 3.591470258136911e-04*G0_16 - 6.541606541606517e-04*G0_17 + 8.551119662230729e-04*G0_18 + 6.840895729784574e-04*G0_19 - 1.257014590347915e-03*G0_20 + 1.710223932446144e-03*G0_21 - 3.420447864892341e-05*G0_22 + 1.026134359467694e-04*G0_23 + 5.130671797338400e-04*G0_24 + 5.130671797338412e-04*G0_25 + 1.026134359467700e-04*G0_26 - 3.420447864892274e-05*G0_27 + 5.130671797338424e-05*G0_28 - 1.710223932446089e-05*G0_29 - 1.710223932446147e-05*G0_30 + 8.551119662230596e-05*G0_31 + 8.551119662230711e-05*G0_32 + 9.748276414942985e-04*G0_33 + 1.094543316765530e-03*G0_34;
    block[22] = -2.159157714713257e-04*G0_0 + 2.886002886002867e-04*G0_1 - 1.859868526535178e-04*G0_2 - 1.859868526535175e-04*G0_3 + 1.026134359467643e-04*G0_4 - 7.696007696007730e-05*G0_5 + 5.130671797338426e-04*G0_6 - 1.710223932446254e-05*G0_7 + 2.693602693602681e-04*G0_8 + 8.551119662230667e-05*G0_9 + 9.748276414943007e-04*G0_10 - 1.013307679974339e-03*G0_11 + 5.130671797338259e-05*G0_12 + 8.551119662230682e-05*G0_13 + 2.693602693602680e-04*G0_14 - 1.710223932446193e-05*G0_15 + 1.026134359467654e-04*G0_16 - 7.696007696007362e-05*G0_17 + 5.130671797338408e-04*G0_18 - 3.420447864892319e-05*G0_19 - 1.795735129068453e-04*G0_20 - 3.420447864892340e-05*G0_21 + 7.798621131954401e-03*G0_22 - 2.052268718935368e-03*G0_23 - 2.052268718935372e-03*G0_24 - 1.436588103254759e-03*G0_25 - 1.436588103254760e-03*G0_26 - 2.052268718935380e-04*G0_27 - 1.026134359467685e-03*G0_28 + 3.899310565977210e-03*G0_29 - 1.436588103254762e-03*G0_30 - 1.436588103254762e-03*G0_31 + 3.899310565977200e-03*G0_32 - 1.026134359467687e-03*G0_33 + 1.641814975148300e-03*G0_34;
    block[23] = -2.159157714713261e-04*G0_0 - 1.859868526535185e-04*G0_1 - 1.859868526535180e-04*G0_2 + 2.886002886002862e-04*G0_3 - 3.420447864892172e-05*G0_4 - 1.795735129068430e-04*G0_5 - 3.420447864892175e-05*G0_6 - 1.710223932446123e-05*G0_7 + 2.693602693602668e-04*G0_8 + 8.551119662230835e-05*G0_9 + 8.551119662230861e-05*G0_10 + 2.693602693602668e-04*G0_11 - 1.710223932446082e-05*G0_12 + 9.748276414943028e-04*G0_13 - 1.013307679974341e-03*G0_14 + 5.130671797338372e-05*G0_15 + 5.130671797338433e-04*G0_16 - 7.696007696007717e-05*G0_17 + 1.026134359467690e-04*G0_18 + 5.130671797338427e-04*G0_19 - 7.696007696007797e-05*G0_20 + 1.026134359467693e-04*G0_21 - 2.052268718935368e-03*G0_22 + 7.798621131954411e-03*G0_23 - 2.052268718935372e-03*G0_24 - 1.026134359467688e-03*G0_25 + 3.899310565977212e-03*G0_26 - 1.436588103254760e-03*G0_27 + 3.899310565977206e-03*G0_28 - 1.026134359467687e-03*G0_29 - 1.436588103254763e-03*G0_30 - 2.052268718935401e-04*G0_31 - 1.436588103254758e-03*G0_32 - 1.436588103254758e-03*G0_33 + 1.641814975148302e-03*G0_34;
    block[24] = -2.159157714713258e-04*G0_0 - 1.859868526535181e-04*G0_1 + 2.886002886002865e-04*G0_2 - 1.859868526535185e-04*G0_3 + 5.130671797338442e-04*G0_4 - 7.696007696007958e-05*G0_5 + 1.026134359467641e-04*G0_6 + 5.130671797338245e-05*G0_7 - 1.013307679974340e-03*G0_8 + 9.748276414943015e-04*G0_9 + 8.551119662230728e-05*G0_10 + 2.693602693602679e-04*G0_11 - 1.710223932446066e-05*G0_12 + 8.551119662230759e-05*G0_13 + 2.693602693602676e-04*G0_14 - 1.710223932446150e-05*G0_15 - 3.420447864892200e-05*G0_16 - 1.795735129068459e-04*G0_17 - 3.420447864892274e-05*G0_18 + 1.026134359467671e-04*G0_19 - 7.696007696007466e-05*G0_20 + 5.130671797338400e-04*G0_21 - 2.052268718935372e-03*G0_22 - 2.052268718935372e-03*G0_23 + 7.798621131954406e-03*G0_24 + 3.899310565977210e-03*G0_25 - 1.026134359467686e-03*G0_26 - 1.436588103254761e-03*G0_27 - 1.436588103254763e-03*G0_28 - 1.436588103254759e-03*G0_29 - 2.052268718935353e-04*G0_30 - 1.436588103254760e-03*G0_31 - 1.026134359467685e-03*G0_32 + 3.899310565977202e-03*G0_33 + 1.641814975148294e-03*G0_34;
    block[25] = -1.859868526535184e-04*G0_0 - 2.159157714713252e-04*G0_1 + 2.886002886002864e-04*G0_2 - 1.859868526535189e-04*G0_3 + 9.748276414943018e-04*G0_4 - 1.013307679974340e-03*G0_5 + 5.130671797338260e-05*G0_6 + 1.026134359467657e-04*G0_7 - 7.696007696007744e-05*G0_8 + 5.130671797338439e-04*G0_9 - 1.710223932446087e-05*G0_10 + 2.693602693602679e-04*G0_11 + 8.551119662230726e-05*G0_12 - 3.420447864892152e-05*G0_13 - 1.795735129068452e-04*G0_14 - 3.420447864892154e-05*G0_15 + 8.551119662230671e-05*G0_16 + 2.693602693602670e-04*G0_17 - 1.710223932446104e-05*G0_18 + 1.026134359467673e-04*G0_19 - 7.696007696007484e-05*G0_20 + 5.130671797338413e-04*G0_21 - 1.436588103254759e-03*G0_22 - 1.026134359467688e-03*G0_23 + 3.899310565977210e-03*G0_24 + 7.798621131954416e-03*G0_25 - 2.052268718935372e-03*G0_26 - 2.052268718935373e-03*G0_27 - 1.436588103254764e-03*G0_28 - 2.052268718935354e-04*G0_29 - 1.436588103254759e-03*G0_30 - 1.026134359467687e-03*G0_31 - 1.436588103254757e-03*G0_32 + 3.899310565977204e-03*G0_33 + 1.641814975148296e-03*G0_34;
    block[26] = -1.859868526535181e-04*G0_0 - 2.159157714713266e-04*G0_1 - 1.859868526535179e-04*G0_2 + 2.886002886002864e-04*G0_3 + 8.551119662230796e-05*G0_4 + 2.693602693602673e-04*G0_5 - 1.710223932446048e-05*G0_6 - 3.420447864892206e-05*G0_7 - 1.795735129068441e-04*G0_8 - 3.420447864892127e-05*G0_9 - 1.710223932446056e-05*G0_10 + 2.693602693602672e-04*G0_11 + 8.551119662230789e-05*G0_12 + 5.130671797338440e-04*G0_13 - 7.696007696007682e-05*G0_14 + 1.026134359467691e-04*G0_15 + 9.748276414943033e-04*G0_16 - 1.013307679974341e-03*G0_17 + 5.130671797338479e-05*G0_18 + 5.130671797338433e-04*G0_19 - 7.696007696007736e-05*G0_20 + 1.026134359467699e-04*G0_21 - 1.436588103254760e-03*G0_22 + 3.899310565977211e-03*G0_23 - 1.026134359467686e-03*G0_24 - 2.052268718935372e-03*G0_25 + 7.798621131954414e-03*G0_26 - 2.052268718935370e-03*G0_27 + 3.899310565977208e-03*G0_28 - 1.436588103254761e-03*G0_29 - 1.026134359467687e-03*G0_30 - 1.436588103254760e-03*G0_31 - 2.052268718935386e-04*G0_32 - 1.436588103254758e-03*G0_33 + 1.641814975148302e-03*G0_34;
    block[27] = 2.886002886002872e-04*G0_0 - 2.159157714713253e-04*G0_1 - 1.859868526535183e-04*G0_2 - 1.859868526535174e-04*G0_3 + 8.551119662230600e-05*G0_4 + 2.693602693602681e-04*G0_5 - 1.710223932446112e-05*G0_6 + 5.130671797338417e-04*G0_7 - 7.696007696007757e-05*G0_8 + 1.026134359467653e-04*G0_9 + 5.130671797338261e-05*G0_10 - 1.013307679974338e-03*G0_11 + 9.748276414943007e-04*G0_12 + 1.026134359467670e-04*G0_13 - 7.696007696007638e-05*G0_14 + 5.130671797338407e-04*G0_15 + 8.551119662230735e-05*G0_16 + 2.693602693602676e-04*G0_17 - 1.710223932446070e-05*G0_18 - 3.420447864892175e-05*G0_19 - 1.795735129068463e-04*G0_20 - 3.420447864892268e-05*G0_21 - 2.052268718935380e-04*G0_22 - 1.436588103254760e-03*G0_23 - 1.436588103254761e-03*G0_24 - 2.052268718935373e-03*G0_25 - 2.052268718935371e-03*G0_26 + 7.798621131954416e-03*G0_27 - 1.026134359467684e-03*G0_28 - 1.436588103254761e-03*G0_29 + 3.899310565977207e-03*G0_30 + 3.899310565977198e-03*G0_31 - 1.436588103254758e-03*G0_32 - 1.026134359467686e-03*G0_33 + 1.641814975148299e-03*G0_34;
    block[28] = -1.859868526535178e-04*G0_0 - 1.859868526535186e-04*G0_1 - 2.159157714713260e-04*G0_2 + 2.886002886002861e-04*G0_3 - 1.710223932446109e-05*G0_4 + 2.693602693602670e-04*G0_5 + 8.551119662230767e-05*G0_6 + 8.551119662230770e-05*G0_7 + 2.693602693602667e-04*G0_8 - 1.710223932446093e-05*G0_9 - 3.420447864892121e-05*G0_10 - 1.795735129068436e-04*G0_11 - 3.420447864892153e-05*G0_12 + 5.130671797338434e-04*G0_13 - 7.696007696007748e-05*G0_14 + 1.026134359467685e-04*G0_15 + 5.130671797338441e-04*G0_16 - 7.696007696007748e-05*G0_17 + 1.026134359467691e-04*G0_18 + 9.748276414943018e-04*G0_19 - 1.013307679974340e-03*G0_20 + 5.130671797338425e-05*G0_21 - 1.026134359467685e-03*G0_22 + 3.899310565977206e-03*G0_23 - 1.436588103254763e-03*G0_24 - 1.436588103254764e-03*G0_25 + 3.899310565977208e-03*G0_26 - 1.026134359467684e-03*G0_27 + 7.798621131954406e-03*G0_28 - 2.052268718935371e-03*G0_29 - 2.052268718935368e-03*G0_30 - 1.436588103254758e-03*G0_31 - 1.436588103254757e-03*G0_32 - 2.052268718935408e-04*G0_33 + 1.641814975148300e-03*G0_34;
    block[29] = -1.859868526535187e-04*G0_0 + 2.886002886002868e-04*G0_1 - 2.159157714713251e-04*G0_2 - 1.859868526535183e-04*G0_3 + 5.130671797338300e-05*G0_4 - 1.013307679974337e-03*G0_5 + 9.748276414943002e-04*G0_6 + 8.551119662230619e-05*G0_7 + 2.693602693602677e-04*G0_8 - 1.710223932446029e-05*G0_9 + 5.130671797338433e-04*G0_10 - 7.696007696007804e-05*G0_11 + 1.026134359467665e-04*G0_12 - 3.420447864892202e-05*G0_13 - 1.795735129068447e-04*G0_14 - 3.420447864892238e-05*G0_15 + 1.026134359467674e-04*G0_16 - 7.696007696007542e-05*G0_17 + 5.130671797338427e-04*G0_18 + 8.551119662230688e-05*G0_19 + 2.693602693602663e-04*G0_20 - 1.710223932446092e-05*G0_21 + 3.899310565977210e-03*G0_22 - 1.026134359467686e-03*G0_23 - 1.436588103254759e-03*G0_24 - 2.052268718935357e-04*G0_25 - 1.436588103254761e-03*G0_26 - 1.436588103254761e-03*G0_27 - 2.052268718935371e-03*G0_28 + 7.798621131954410e-03*G0_29 - 2.052268718935373e-03*G0_30 - 1.026134359467688e-03*G0_31 + 3.899310565977202e-03*G0_32 - 1.436588103254758e-03*G0_33 + 1.641814975148301e-03*G0_34;
    block[30] = 2.886002886002877e-04*G0_0 - 1.859868526535175e-04*G0_1 - 2.159157714713249e-04*G0_2 - 1.859868526535175e-04*G0_3 - 1.710223932446158e-05*G0_4 + 2.693602693602680e-04*G0_5 + 8.551119662230674e-05*G0_6 + 9.748276414942990e-04*G0_7 - 1.013307679974337e-03*G0_8 + 5.130671797338145e-05*G0_9 + 1.026134359467639e-04*G0_10 - 7.696007696007714e-05*G0_11 + 5.130671797338430e-04*G0_12 + 1.026134359467655e-04*G0_13 - 7.696007696007515e-05*G0_14 + 5.130671797338407e-04*G0_15 - 3.420447864892305e-05*G0_16 - 1.795735129068452e-04*G0_17 - 3.420447864892316e-05*G0_18 + 8.551119662230707e-05*G0_19 + 2.693602693602672e-04*G0_20 - 1.710223932446145e-05*G0_21 - 1.436588103254762e-03*G0_22 - 1.436588103254763e-03*G0_23 - 2.052268718935353e-04*G0_24 - 1.436588103254758e-03*G0_25 - 1.026134359467687e-03*G0_26 + 3.899310565977207e-03*G0_27 - 2.052268718935369e-03*G0_28 - 2.052268718935373e-03*G0_29 + 7.798621131954406e-03*G0_30 + 3.899310565977198e-03*G0_31 - 1.026134359467685e-03*G0_32 - 1.436588103254757e-03*G0_33 + 1.641814975148293e-03*G0_34;
    block[31] = 2.886002886002879e-04*G0_0 - 1.859868526535170e-04*G0_1 - 1.859868526535175e-04*G0_2 - 2.159157714713244e-04*G0_3 - 3.420447864892525e-05*G0_4 - 1.795735129068428e-04*G0_5 - 3.420447864892442e-05*G0_6 + 5.130671797338393e-04*G0_7 - 7.696007696007546e-05*G0_8 + 1.026134359467650e-04*G0_9 + 1.026134359467655e-04*G0_10 - 7.696007696007508e-05*G0_11 + 5.130671797338405e-04*G0_12 + 5.130671797338072e-05*G0_13 - 1.013307679974336e-03*G0_14 + 9.748276414942965e-04*G0_15 - 1.710223932446256e-05*G0_16 + 2.693602693602676e-04*G0_17 + 8.551119662230596e-05*G0_18 - 1.710223932446242e-05*G0_19 + 2.693602693602675e-04*G0_20 + 8.551119662230596e-05*G0_21 - 1.436588103254762e-03*G0_22 - 2.052268718935399e-04*G0_23 - 1.436588103254760e-03*G0_24 - 1.026134359467687e-03*G0_25 - 1.436588103254760e-03*G0_26 + 3.899310565977198e-03*G0_27 - 1.436588103254758e-03*G0_28 - 1.026134359467688e-03*G0_29 + 3.899310565977198e-03*G0_30 + 7.798621131954397e-03*G0_31 - 2.052268718935369e-03*G0_32 - 2.052268718935368e-03*G0_33 + 1.641814975148281e-03*G0_34;
    block[32] = -1.859868526535181e-04*G0_0 + 2.886002886002866e-04*G0_1 - 1.859868526535175e-04*G0_2 - 2.159157714713251e-04*G0_3 + 1.026134359467679e-04*G0_4 - 7.696007696007579e-05*G0_5 + 5.130671797338423e-04*G0_6 - 3.420447864892480e-05*G0_7 - 1.795735129068433e-04*G0_8 - 3.420447864892259e-05*G0_9 + 5.130671797338426e-04*G0_10 - 7.696007696007657e-05*G0_11 + 1.026134359467676e-04*G0_12 - 1.710223932446086e-05*G0_13 + 2.693602693602670e-04*G0_14 + 8.551119662230691e-05*G0_15 + 5.130671797338346e-05*G0_16 - 1.013307679974337e-03*G0_17 + 9.748276414942987e-04*G0_18 - 1.710223932446192e-05*G0_19 + 2.693602693602668e-04*G0_20 + 8.551119662230711e-05*G0_21 + 3.899310565977200e-03*G0_22 - 1.436588103254757e-03*G0_23 - 1.026134359467685e-03*G0_24 - 1.436588103254757e-03*G0_25 - 2.052268718935386e-04*G0_26 - 1.436588103254758e-03*G0_27 - 1.436588103254757e-03*G0_28 + 3.899310565977202e-03*G0_29 - 1.026134359467685e-03*G0_30 - 2.052268718935369e-03*G0_31 + 7.798621131954399e-03*G0_32 - 2.052268718935370e-03*G0_33 + 1.641814975148294e-03*G0_34;
    block[33] = -1.859868526535179e-04*G0_0 - 1.859868526535181e-04*G0_1 + 2.886002886002863e-04*G0_2 - 2.159157714713257e-04*G0_3 + 5.130671797338427e-04*G0_4 - 7.696007696007753e-05*G0_5 + 1.026134359467673e-04*G0_6 + 1.026134359467679e-04*G0_7 - 7.696007696007714e-05*G0_8 + 5.130671797338429e-04*G0_9 - 3.420447864892232e-05*G0_10 - 1.795735129068436e-04*G0_11 - 3.420447864892230e-05*G0_12 - 1.710223932446043e-05*G0_13 + 2.693602693602660e-04*G0_14 + 8.551119662230793e-05*G0_15 - 1.710223932446122e-05*G0_16 + 2.693602693602661e-04*G0_17 + 8.551119662230751e-05*G0_18 + 5.130671797338386e-05*G0_19 - 1.013307679974337e-03*G0_20 + 9.748276414942983e-04*G0_21 - 1.026134359467687e-03*G0_22 - 1.436588103254758e-03*G0_23 + 3.899310565977202e-03*G0_24 + 3.899310565977203e-03*G0_25 - 1.436588103254758e-03*G0_26 - 1.026134359467686e-03*G0_27 - 2.052268718935408e-04*G0_28 - 1.436588103254758e-03*G0_29 - 1.436588103254757e-03*G0_30 - 2.052268718935368e-03*G0_31 - 2.052268718935371e-03*G0_32 + 7.798621131954399e-03*G0_33 + 1.641814975148288e-03*G0_34;
    block[34] = -5.387205387205348e-04*G0_0 - 5.387205387205350e-04*G0_1 - 5.387205387205353e-04*G0_2 - 5.387205387205361e-04*G0_3 + 1.094543316765530e-03*G0_4 - 1.026134359467686e-03*G0_5 + 1.094543316765530e-03*G0_6 + 1.094543316765525e-03*G0_7 - 1.026134359467685e-03*G0_8 + 1.094543316765530e-03*G0_9 + 1.094543316765532e-03*G0_10 - 1.026134359467685e-03*G0_11 + 1.094543316765532e-03*G0_12 + 1.094543316765534e-03*G0_13 - 1.026134359467686e-03*G0_14 + 1.094543316765529e-03*G0_15 + 1.094543316765533e-03*G0_16 - 1.026134359467687e-03*G0_17 + 1.094543316765532e-03*G0_18 + 1.094543316765532e-03*G0_19 - 1.026134359467689e-03*G0_20 + 1.094543316765530e-03*G0_21 + 1.641814975148300e-03*G0_22 + 1.641814975148302e-03*G0_23 + 1.641814975148294e-03*G0_24 + 1.641814975148296e-03*G0_25 + 1.641814975148301e-03*G0_26 + 1.641814975148299e-03*G0_27 + 1.641814975148300e-03*G0_28 + 1.641814975148301e-03*G0_29 + 1.641814975148293e-03*G0_30 + 1.641814975148281e-03*G0_31 + 1.641814975148294e-03*G0_32 + 1.641814975148288e-03*G0_33 + 2.626903960237277e-02*G0_34;
  }

};

} }

#endif
