// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.3.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __POISSON3D_5_H
#define __POISSON3D_5_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Poisson3D_5 {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 56;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      static unsigned int face_reordering_0[6][6] = {{0, 1, 2, 3, 4, 5}, {0, 3, 5, 1, 4, 2}, {5, 3, 0, 4, 1, 2}, {2, 1, 0, 4, 3, 5}, {2, 4, 5, 1, 3, 0}, {5, 4, 2, 3, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][2];
      dofs[7] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][2];
      dofs[11] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][2];
      dofs[15] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(3);
      dofs[16] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][2];
      dofs[19] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(4);
      dofs[20] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[21] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[22] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][2];
      dofs[23] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(5);
      dofs[24] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[25] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[26] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][2];
      dofs[27] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][3];
      alignment = cell.faceAlignment(0);
      offset = offset + 4*mesh.noEdges();
      dofs[28] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[29] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[30] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][2];
      dofs[31] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][3];
      dofs[32] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][4];
      dofs[33] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(1);
      dofs[34] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[35] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[36] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][2];
      dofs[37] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][3];
      dofs[38] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][4];
      dofs[39] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(2);
      dofs[40] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[41] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[42] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][2];
      dofs[43] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][3];
      dofs[44] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][4];
      dofs[45] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(3);
      dofs[46] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[47] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[48] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][2];
      dofs[49] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][3];
      dofs[50] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][4];
      dofs[51] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][5];
      offset = offset + 6*mesh.noFaces();
      dofs[52] = offset + 4*cell.id() + 0;
      dofs[53] = offset + 4*cell.id() + 1;
      dofs[54] = offset + 4*cell.id() + 2;
      dofs[55] = offset + 4*cell.id() + 3;
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(8.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(6.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(4.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[7] = map(2.000000000000000e-01, 8.000000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 8.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 6.000000000000000e-01, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 4.000000000000000e-01, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(2.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(4.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[14] = map(6.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[15] = map(8.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[16] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.000000000000000e-01);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 4.000000000000000e-01);
      points[18] = map(0.000000000000000e+00, 0.000000000000000e+00, 6.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 0.000000000000000e+00, 8.000000000000000e-01);
      points[20] = map(8.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[21] = map(6.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[22] = map(4.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[23] = map(2.000000000000000e-01, 0.000000000000000e+00, 8.000000000000000e-01);
      points[24] = map(0.000000000000000e+00, 8.000000000000000e-01, 2.000000000000000e-01);
      points[25] = map(0.000000000000000e+00, 6.000000000000000e-01, 4.000000000000000e-01);
      points[26] = map(0.000000000000000e+00, 4.000000000000000e-01, 6.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.000000000000000e-01, 8.000000000000000e-01);
      points[28] = map(6.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[29] = map(4.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      points[30] = map(2.000000000000000e-01, 2.000000000000000e-01, 6.000000000000000e-01);
      points[31] = map(4.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[32] = map(2.000000000000000e-01, 4.000000000000000e-01, 4.000000000000000e-01);
      points[33] = map(2.000000000000000e-01, 6.000000000000000e-01, 2.000000000000000e-01);
      points[34] = map(0.000000000000000e+00, 6.000000000000000e-01, 2.000000000000000e-01);
      points[35] = map(0.000000000000000e+00, 4.000000000000000e-01, 4.000000000000000e-01);
      points[36] = map(0.000000000000000e+00, 2.000000000000000e-01, 6.000000000000000e-01);
      points[37] = map(0.000000000000000e+00, 4.000000000000000e-01, 2.000000000000000e-01);
      points[38] = map(0.000000000000000e+00, 2.000000000000000e-01, 4.000000000000000e-01);
      points[39] = map(0.000000000000000e+00, 2.000000000000000e-01, 2.000000000000000e-01);
      points[40] = map(2.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[41] = map(4.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[42] = map(6.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[43] = map(2.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[44] = map(4.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[45] = map(2.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[46] = map(2.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[47] = map(4.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[48] = map(6.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[49] = map(2.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[50] = map(4.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[51] = map(2.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[52] = map(2.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[53] = map(4.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[54] = map(2.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[55] = map(2.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
      components[35] = 0;
      components[36] = 0;
      components[37] = 0;
      components[38] = 0;
      components[39] = 0;
      components[40] = 0;
      components[41] = 0;
      components[42] = 0;
      components[43] = 0;
      components[44] = 0;
      components[45] = 0;
      components[46] = 0;
      components[47] = 0;
      components[48] = 0;
      components[49] = 0;
      components[50] = 0;
      components[51] = 0;
      components[52] = 0;
      components[53] = 0;
      components[54] = 0;
      components[55] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 56;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      static unsigned int face_reordering_0[6][6] = {{0, 1, 2, 3, 4, 5}, {0, 3, 5, 1, 4, 2}, {5, 3, 0, 4, 1, 2}, {2, 1, 0, 4, 3, 5}, {2, 4, 5, 1, 3, 0}, {5, 4, 2, 3, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][2];
      dofs[7] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][2];
      dofs[11] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][2];
      dofs[15] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(3);
      dofs[16] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][2];
      dofs[19] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(4);
      dofs[20] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[21] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[22] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][2];
      dofs[23] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(5);
      dofs[24] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[25] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[26] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][2];
      dofs[27] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][3];
      alignment = cell.faceAlignment(0);
      offset = offset + 4*mesh.noEdges();
      dofs[28] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[29] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[30] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][2];
      dofs[31] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][3];
      dofs[32] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][4];
      dofs[33] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(1);
      dofs[34] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[35] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[36] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][2];
      dofs[37] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][3];
      dofs[38] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][4];
      dofs[39] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(2);
      dofs[40] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[41] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[42] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][2];
      dofs[43] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][3];
      dofs[44] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][4];
      dofs[45] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(3);
      dofs[46] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[47] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[48] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][2];
      dofs[49] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][3];
      dofs[50] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][4];
      dofs[51] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][5];
      offset = offset + 6*mesh.noFaces();
      dofs[52] = offset + 4*cell.id() + 0;
      dofs[53] = offset + 4*cell.id() + 1;
      dofs[54] = offset + 4*cell.id() + 2;
      dofs[55] = offset + 4*cell.id() + 3;
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(8.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(6.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(4.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[7] = map(2.000000000000000e-01, 8.000000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 8.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 6.000000000000000e-01, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 4.000000000000000e-01, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(2.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(4.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[14] = map(6.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[15] = map(8.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[16] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.000000000000000e-01);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 4.000000000000000e-01);
      points[18] = map(0.000000000000000e+00, 0.000000000000000e+00, 6.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 0.000000000000000e+00, 8.000000000000000e-01);
      points[20] = map(8.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[21] = map(6.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[22] = map(4.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[23] = map(2.000000000000000e-01, 0.000000000000000e+00, 8.000000000000000e-01);
      points[24] = map(0.000000000000000e+00, 8.000000000000000e-01, 2.000000000000000e-01);
      points[25] = map(0.000000000000000e+00, 6.000000000000000e-01, 4.000000000000000e-01);
      points[26] = map(0.000000000000000e+00, 4.000000000000000e-01, 6.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.000000000000000e-01, 8.000000000000000e-01);
      points[28] = map(6.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[29] = map(4.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      points[30] = map(2.000000000000000e-01, 2.000000000000000e-01, 6.000000000000000e-01);
      points[31] = map(4.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[32] = map(2.000000000000000e-01, 4.000000000000000e-01, 4.000000000000000e-01);
      points[33] = map(2.000000000000000e-01, 6.000000000000000e-01, 2.000000000000000e-01);
      points[34] = map(0.000000000000000e+00, 6.000000000000000e-01, 2.000000000000000e-01);
      points[35] = map(0.000000000000000e+00, 4.000000000000000e-01, 4.000000000000000e-01);
      points[36] = map(0.000000000000000e+00, 2.000000000000000e-01, 6.000000000000000e-01);
      points[37] = map(0.000000000000000e+00, 4.000000000000000e-01, 2.000000000000000e-01);
      points[38] = map(0.000000000000000e+00, 2.000000000000000e-01, 4.000000000000000e-01);
      points[39] = map(0.000000000000000e+00, 2.000000000000000e-01, 2.000000000000000e-01);
      points[40] = map(2.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[41] = map(4.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[42] = map(6.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[43] = map(2.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[44] = map(4.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[45] = map(2.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[46] = map(2.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[47] = map(4.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[48] = map(6.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[49] = map(2.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[50] = map(4.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[51] = map(2.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[52] = map(2.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[53] = map(4.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[54] = map(2.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[55] = map(2.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
      components[35] = 0;
      components[36] = 0;
      components[37] = 0;
      components[38] = 0;
      components[39] = 0;
      components[40] = 0;
      components[41] = 0;
      components[42] = 0;
      components[43] = 0;
      components[44] = 0;
      components[45] = 0;
      components[46] = 0;
      components[47] = 0;
      components[48] = 0;
      components[49] = 0;
      components[50] = 0;
      components[51] = 0;
      components[52] = 0;
      components[53] = 0;
      components[54] = 0;
      components[55] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_0_0 = map.det*(map.g00*map.g00 + map.g01*map.g01 + map.g02*map.g02);
    const real G0_0_1 = map.det*(map.g00*map.g10 + map.g01*map.g11 + map.g02*map.g12);
    const real G0_0_2 = map.det*(map.g00*map.g20 + map.g01*map.g21 + map.g02*map.g22);
    const real G0_1_0 = map.det*(map.g10*map.g00 + map.g11*map.g01 + map.g12*map.g02);
    const real G0_1_1 = map.det*(map.g10*map.g10 + map.g11*map.g11 + map.g12*map.g12);
    const real G0_1_2 = map.det*(map.g10*map.g20 + map.g11*map.g21 + map.g12*map.g22);
    const real G0_2_0 = map.det*(map.g20*map.g00 + map.g21*map.g01 + map.g22*map.g02);
    const real G0_2_1 = map.det*(map.g20*map.g10 + map.g21*map.g11 + map.g22*map.g12);
    const real G0_2_2 = map.det*(map.g20*map.g20 + map.g21*map.g21 + map.g22*map.g22);

    // Compute element tensor
    block[0] = 2.626525673400649e-02*G0_0_0 + 2.626525673400648e-02*G0_0_1 + 2.626525673400647e-02*G0_0_2 + 2.626525673400648e-02*G0_1_0 + 2.626525673400646e-02*G0_1_1 + 2.626525673400645e-02*G0_1_2 + 2.626525673400647e-02*G0_2_0 + 2.626525673400645e-02*G0_2_1 + 2.626525673400645e-02*G0_2_2;
    block[1] = -2.778905122655079e-03*G0_0_0 - 2.778905122655084e-03*G0_1_0 - 2.778905122655092e-03*G0_2_0;
    block[2] = -2.778905122655082e-03*G0_0_1 - 2.778905122655084e-03*G0_1_1 - 2.778905122655086e-03*G0_2_1;
    block[3] = -2.778905122655095e-03*G0_0_2 - 2.778905122655098e-03*G0_1_2 - 2.778905122655096e-03*G0_2_2;
    block[4] = -4.800349309897909e-03*G0_0_0 - 4.800349309897891e-03*G0_0_1 - 4.800349309897903e-03*G0_1_0 - 4.800349309897903e-03*G0_1_1 - 4.800349309897916e-03*G0_2_0 - 4.800349309897939e-03*G0_2_1;
    block[5] = -3.365072266981929e-03*G0_0_0 - 3.365072266981939e-03*G0_0_1 - 3.365072266981925e-03*G0_1_0 - 3.365072266981912e-03*G0_1_1 - 3.365072266981919e-03*G0_2_0 - 3.365072266981888e-03*G0_2_1;
    block[6] = -3.365072266981967e-03*G0_0_0 - 3.365072266981981e-03*G0_0_1 - 3.365072266981981e-03*G0_1_0 - 3.365072266982020e-03*G0_1_1 - 3.365072266981955e-03*G0_2_0 - 3.365072266981999e-03*G0_2_1;
    block[7] = -4.800349309897817e-03*G0_0_0 - 4.800349309897812e-03*G0_0_1 - 4.800349309897838e-03*G0_1_0 - 4.800349309897815e-03*G0_1_1 - 4.800349309897829e-03*G0_2_0 - 4.800349309897806e-03*G0_2_1;
    block[8] = 4.800349309897816e-03*G0_0_0 + 1.533136841296545e-02*G0_0_1 + 4.800349309897816e-03*G0_0_2 + 4.800349309897835e-03*G0_1_0 + 1.533136841296543e-02*G0_1_1 + 4.800349309897837e-03*G0_1_2 + 4.800349309897829e-03*G0_2_0 + 1.533136841296544e-02*G0_2_1 + 4.800349309897829e-03*G0_2_2;
    block[9] = -1.555448875327324e-02*G0_0_0 - 3.881772002431679e-02*G0_0_1 - 1.555448875327325e-02*G0_0_2 - 1.555448875327328e-02*G0_1_0 - 3.881772002431676e-02*G0_1_1 - 1.555448875327328e-02*G0_1_2 - 1.555448875327326e-02*G0_2_0 - 3.881772002431677e-02*G0_2_1 - 1.555448875327326e-02*G0_2_2;
    block[10] = 2.146913496739853e-02*G0_0_0 + 5.512768642108861e-02*G0_0_1 + 2.146913496739854e-02*G0_0_2 + 2.146913496739855e-02*G0_1_0 + 5.512768642108857e-02*G0_1_1 + 2.146913496739856e-02*G0_1_2 + 2.146913496739853e-02*G0_2_0 + 5.512768642108858e-02*G0_2_1 + 2.146913496739855e-02*G0_2_2;
    block[11] = -1.787050398161485e-02*G0_0_0 - 5.512768642108868e-02*G0_0_1 - 1.787050398161486e-02*G0_0_2 - 1.787050398161485e-02*G0_1_0 - 5.512768642108861e-02*G0_1_1 - 1.787050398161484e-02*G0_1_2 - 1.787050398161489e-02*G0_2_0 - 5.512768642108862e-02*G0_2_1 - 1.787050398161489e-02*G0_2_2;
    block[12] = -5.512768642108867e-02*G0_0_0 - 1.787050398161484e-02*G0_0_1 - 1.787050398161484e-02*G0_0_2 - 5.512768642108867e-02*G0_1_0 - 1.787050398161486e-02*G0_1_1 - 1.787050398161485e-02*G0_1_2 - 5.512768642108865e-02*G0_2_0 - 1.787050398161491e-02*G0_2_1 - 1.787050398161490e-02*G0_2_2;
    block[13] = 5.512768642108867e-02*G0_0_0 + 2.146913496739864e-02*G0_0_1 + 2.146913496739864e-02*G0_0_2 + 5.512768642108865e-02*G0_1_0 + 2.146913496739864e-02*G0_1_1 + 2.146913496739865e-02*G0_1_2 + 5.512768642108867e-02*G0_2_0 + 2.146913496739867e-02*G0_2_1 + 2.146913496739868e-02*G0_2_2;
    block[14] = -3.881772002431682e-02*G0_0_0 - 1.555448875327332e-02*G0_0_1 - 1.555448875327333e-02*G0_0_2 - 3.881772002431681e-02*G0_1_0 - 1.555448875327333e-02*G0_1_1 - 1.555448875327333e-02*G0_1_2 - 3.881772002431683e-02*G0_2_0 - 1.555448875327336e-02*G0_2_1 - 1.555448875327337e-02*G0_2_2;
    block[15] = 1.533136841296545e-02*G0_0_0 + 4.800349309897897e-03*G0_0_1 + 4.800349309897900e-03*G0_0_2 + 1.533136841296545e-02*G0_1_0 + 4.800349309897908e-03*G0_1_1 + 4.800349309897913e-03*G0_1_2 + 1.533136841296546e-02*G0_2_0 + 4.800349309897943e-03*G0_2_1 + 4.800349309897947e-03*G0_2_2;
    block[16] = -1.787050398161491e-02*G0_0_0 - 1.787050398161490e-02*G0_0_1 - 5.512768642108868e-02*G0_0_2 - 1.787050398161492e-02*G0_1_0 - 1.787050398161491e-02*G0_1_1 - 5.512768642108866e-02*G0_1_2 - 1.787050398161494e-02*G0_2_0 - 1.787050398161494e-02*G0_2_1 - 5.512768642108865e-02*G0_2_2;
    block[17] = 2.146913496739859e-02*G0_0_0 + 2.146913496739857e-02*G0_0_1 + 5.512768642108876e-02*G0_0_2 + 2.146913496739856e-02*G0_1_0 + 2.146913496739854e-02*G0_1_1 + 5.512768642108872e-02*G0_1_2 + 2.146913496739863e-02*G0_2_0 + 2.146913496739861e-02*G0_2_1 + 5.512768642108869e-02*G0_2_2;
    block[18] = -1.555448875327325e-02*G0_0_0 - 1.555448875327324e-02*G0_0_1 - 3.881772002431688e-02*G0_0_2 - 1.555448875327325e-02*G0_1_0 - 1.555448875327324e-02*G0_1_1 - 3.881772002431687e-02*G0_1_2 - 1.555448875327331e-02*G0_2_0 - 1.555448875327330e-02*G0_2_1 - 3.881772002431683e-02*G0_2_2;
    block[19] = 4.800349309897839e-03*G0_0_0 + 4.800349309897839e-03*G0_0_1 + 1.533136841296549e-02*G0_0_2 + 4.800349309897837e-03*G0_1_0 + 4.800349309897837e-03*G0_1_1 + 1.533136841296549e-02*G0_1_2 + 4.800349309897874e-03*G0_2_0 + 4.800349309897876e-03*G0_2_1 + 1.533136841296548e-02*G0_2_2;
    block[20] = -4.800349309897934e-03*G0_0_0 - 4.800349309897881e-03*G0_0_2 - 4.800349309897937e-03*G0_1_0 - 4.800349309897892e-03*G0_1_2 - 4.800349309897956e-03*G0_2_0 - 4.800349309897927e-03*G0_2_2;
    block[21] = -3.365072266981908e-03*G0_0_0 - 3.365072266981977e-03*G0_0_2 - 3.365072266981937e-03*G0_1_0 - 3.365072266981987e-03*G0_1_2 - 3.365072266981917e-03*G0_2_0 - 3.365072266981952e-03*G0_2_2;
    block[22] = -3.365072266982042e-03*G0_0_0 - 3.365072266981985e-03*G0_0_2 - 3.365072266982030e-03*G0_1_0 - 3.365072266981991e-03*G0_1_2 - 3.365072266982022e-03*G0_2_0 - 3.365072266981990e-03*G0_2_2;
    block[23] = -4.800349309897852e-03*G0_0_0 - 4.800349309897872e-03*G0_0_2 - 4.800349309897849e-03*G0_1_0 - 4.800349309897863e-03*G0_1_2 - 4.800349309897889e-03*G0_2_0 - 4.800349309897901e-03*G0_2_2;
    block[24] = -4.800349309897835e-03*G0_0_1 - 4.800349309897816e-03*G0_0_2 - 4.800349309897845e-03*G0_1_1 - 4.800349309897836e-03*G0_1_2 - 4.800349309897835e-03*G0_2_1 - 4.800349309897829e-03*G0_2_2;
    block[25] = -3.365072266982004e-03*G0_0_1 - 3.365072266982004e-03*G0_0_2 - 3.365072266981984e-03*G0_1_1 - 3.365072266981981e-03*G0_1_2 - 3.365072266982008e-03*G0_2_1 - 3.365072266982002e-03*G0_2_2;
    block[26] = -3.365072266981906e-03*G0_0_1 - 3.365072266981935e-03*G0_0_2 - 3.365072266981922e-03*G0_1_1 - 3.365072266981947e-03*G0_1_2 - 3.365072266981891e-03*G0_2_1 - 3.365072266981918e-03*G0_2_2;
    block[27] = -4.800349309897845e-03*G0_0_1 - 4.800349309897829e-03*G0_0_2 - 4.800349309897844e-03*G0_1_1 - 4.800349309897827e-03*G0_1_2 - 4.800349309897883e-03*G0_2_1 - 4.800349309897868e-03*G0_2_2;
    block[28] = -1.374212528726399e-02*G0_0_0 - 1.374212528726410e-02*G0_0_1 - 1.374212528726407e-02*G0_0_2 - 1.374212528726402e-02*G0_1_0 - 1.374212528726413e-02*G0_1_1 - 1.374212528726407e-02*G0_1_2 - 1.374212528726400e-02*G0_2_0 - 1.374212528726414e-02*G0_2_1 - 1.374212528726409e-02*G0_2_2;
    block[29] = -9.464999699374650e-03*G0_0_0 - 9.464999699374631e-03*G0_0_1 - 9.464999699374577e-03*G0_0_2 - 9.464999699374642e-03*G0_1_0 - 9.464999699374676e-03*G0_1_1 - 9.464999699374610e-03*G0_1_2 - 9.464999699374652e-03*G0_2_0 - 9.464999699374631e-03*G0_2_1 - 9.464999699374626e-03*G0_2_2;
    block[30] = -1.374212528726396e-02*G0_0_0 - 1.374212528726408e-02*G0_0_1 - 1.374212528726404e-02*G0_0_2 - 1.374212528726397e-02*G0_1_0 - 1.374212528726406e-02*G0_1_1 - 1.374212528726404e-02*G0_1_2 - 1.374212528726400e-02*G0_2_0 - 1.374212528726410e-02*G0_2_1 - 1.374212528726401e-02*G0_2_2;
    block[31] = -9.464999699374518e-03*G0_0_0 - 9.464999699374459e-03*G0_0_1 - 9.464999699374539e-03*G0_0_2 - 9.464999699374541e-03*G0_1_0 - 9.464999699374432e-03*G0_1_1 - 9.464999699374548e-03*G0_1_2 - 9.464999699374530e-03*G0_2_0 - 9.464999699374463e-03*G0_2_1 - 9.464999699374503e-03*G0_2_2;
    block[32] = -9.464999699374598e-03*G0_0_0 - 9.464999699374520e-03*G0_0_1 - 9.464999699374595e-03*G0_0_2 - 9.464999699374581e-03*G0_1_0 - 9.464999699374506e-03*G0_1_1 - 9.464999699374579e-03*G0_1_2 - 9.464999699374584e-03*G0_2_0 - 9.464999699374522e-03*G0_2_1 - 9.464999699374638e-03*G0_2_2;
    block[33] = -1.374212528726395e-02*G0_0_0 - 1.374212528726402e-02*G0_0_1 - 1.374212528726390e-02*G0_0_2 - 1.374212528726396e-02*G0_1_0 - 1.374212528726407e-02*G0_1_1 - 1.374212528726395e-02*G0_1_2 - 1.374212528726396e-02*G0_2_0 - 1.374212528726404e-02*G0_2_1 - 1.374212528726391e-02*G0_2_2;
    block[34] = 1.374212528726397e-02*G0_0_0 + 1.891956102025531e-02*G0_0_1 + 1.891956102025525e-02*G0_0_2 + 1.374212528726399e-02*G0_1_0 + 1.891956102025534e-02*G0_1_1 + 1.891956102025526e-02*G0_1_2 + 1.374212528726400e-02*G0_2_0 + 1.891956102025530e-02*G0_2_1 + 1.891956102025526e-02*G0_2_2;
    block[35] = 9.464999699374593e-03*G0_0_0 + 1.174317580567568e-02*G0_0_1 + 1.174317580567574e-02*G0_0_2 + 9.464999699374579e-03*G0_1_0 + 1.174317580567565e-02*G0_1_1 + 1.174317580567572e-02*G0_1_2 + 9.464999699374581e-03*G0_2_0 + 1.174317580567566e-02*G0_2_1 + 1.174317580567571e-02*G0_2_2;
    block[36] = 1.374212528726395e-02*G0_0_0 + 1.891956102025517e-02*G0_0_1 + 1.891956102025513e-02*G0_0_2 + 1.374212528726397e-02*G0_1_0 + 1.891956102025519e-02*G0_1_1 + 1.891956102025512e-02*G0_1_2 + 1.374212528726399e-02*G0_2_0 + 1.891956102025522e-02*G0_2_1 + 1.891956102025522e-02*G0_2_2;
    block[37] = -3.457190957190927e-02*G0_0_0 - 2.984723850609245e-02*G0_0_1 - 2.984723850609236e-02*G0_0_2 - 3.457190957190926e-02*G0_1_0 - 2.984723850609250e-02*G0_1_1 - 2.984723850609236e-02*G0_1_2 - 3.457190957190925e-02*G0_2_0 - 2.984723850609244e-02*G0_2_1 - 2.984723850609236e-02*G0_2_2;
    block[38] = -3.457190957190911e-02*G0_0_0 - 2.984723850609225e-02*G0_0_1 - 2.984723850609226e-02*G0_0_2 - 3.457190957190912e-02*G0_1_0 - 2.984723850609220e-02*G0_1_1 - 2.984723850609221e-02*G0_1_2 - 3.457190957190914e-02*G0_2_0 - 2.984723850609225e-02*G0_2_1 - 2.984723850609232e-02*G0_2_2;
    block[39] = 4.799305472048473e-02*G0_0_0 + 3.359853077734992e-02*G0_0_1 + 3.359853077734983e-02*G0_0_2 + 4.799305472048474e-02*G0_1_0 + 3.359853077734997e-02*G0_1_1 + 3.359853077734978e-02*G0_1_2 + 4.799305472048471e-02*G0_2_0 + 3.359853077734994e-02*G0_2_1 + 3.359853077734988e-02*G0_2_2;
    block[40] = 1.891956102025532e-02*G0_0_0 + 1.374212528726407e-02*G0_0_1 + 1.891956102025524e-02*G0_0_2 + 1.891956102025531e-02*G0_1_0 + 1.374212528726406e-02*G0_1_1 + 1.891956102025523e-02*G0_1_2 + 1.891956102025537e-02*G0_2_0 + 1.374212528726411e-02*G0_2_1 + 1.891956102025532e-02*G0_2_2;
    block[41] = 1.174317580567566e-02*G0_0_0 + 9.464999699374603e-03*G0_0_1 + 1.174317580567575e-02*G0_0_2 + 1.174317580567568e-02*G0_1_0 + 9.464999699374645e-03*G0_1_1 + 1.174317580567574e-02*G0_1_2 + 1.174317580567563e-02*G0_2_0 + 9.464999699374600e-03*G0_2_1 + 1.174317580567572e-02*G0_2_2;
    block[42] = 1.891956102025538e-02*G0_0_0 + 1.374212528726415e-02*G0_0_1 + 1.891956102025525e-02*G0_0_2 + 1.891956102025538e-02*G0_1_0 + 1.374212528726418e-02*G0_1_1 + 1.891956102025527e-02*G0_1_2 + 1.891956102025542e-02*G0_2_0 + 1.374212528726419e-02*G0_2_1 + 1.891956102025527e-02*G0_2_2;
    block[43] = -2.984723850609238e-02*G0_0_0 - 3.457190957190923e-02*G0_0_1 - 2.984723850609236e-02*G0_0_2 - 2.984723850609233e-02*G0_1_0 - 3.457190957190925e-02*G0_1_1 - 2.984723850609235e-02*G0_1_2 - 2.984723850609239e-02*G0_2_0 - 3.457190957190926e-02*G0_2_1 - 2.984723850609247e-02*G0_2_2;
    block[44] = -2.984723850609249e-02*G0_0_0 - 3.457190957190923e-02*G0_0_1 - 2.984723850609234e-02*G0_0_2 - 2.984723850609251e-02*G0_1_0 - 3.457190957190924e-02*G0_1_1 - 2.984723850609232e-02*G0_1_2 - 2.984723850609253e-02*G0_2_0 - 3.457190957190924e-02*G0_2_1 - 2.984723850609234e-02*G0_2_2;
    block[45] = 3.359853077735001e-02*G0_0_0 + 4.799305472048486e-02*G0_0_1 + 3.359853077734978e-02*G0_0_2 + 3.359853077735002e-02*G0_1_0 + 4.799305472048485e-02*G0_1_1 + 3.359853077734978e-02*G0_1_2 + 3.359853077735004e-02*G0_2_0 + 4.799305472048487e-02*G0_2_1 + 3.359853077734989e-02*G0_2_2;
    block[46] = 3.359853077734984e-02*G0_0_0 + 3.359853077734973e-02*G0_0_1 + 4.799305472048476e-02*G0_0_2 + 3.359853077734982e-02*G0_1_0 + 3.359853077734978e-02*G0_1_1 + 4.799305472048480e-02*G0_1_2 + 3.359853077734987e-02*G0_2_0 + 3.359853077734979e-02*G0_2_1 + 4.799305472048473e-02*G0_2_2;
    block[47] = -2.984723850609239e-02*G0_0_0 - 2.984723850609237e-02*G0_0_1 - 3.457190957190924e-02*G0_0_2 - 2.984723850609239e-02*G0_1_0 - 2.984723850609238e-02*G0_1_1 - 3.457190957190927e-02*G0_1_2 - 2.984723850609240e-02*G0_2_0 - 2.984723850609237e-02*G0_2_1 - 3.457190957190925e-02*G0_2_2;
    block[48] = 1.891956102025533e-02*G0_0_0 + 1.891956102025527e-02*G0_0_1 + 1.374212528726413e-02*G0_0_2 + 1.891956102025532e-02*G0_1_0 + 1.891956102025524e-02*G0_1_1 + 1.374212528726413e-02*G0_1_2 + 1.891956102025535e-02*G0_2_0 + 1.891956102025525e-02*G0_2_1 + 1.374212528726415e-02*G0_2_2;
    block[49] = -2.984723850609227e-02*G0_0_0 - 2.984723850609224e-02*G0_0_1 - 3.457190957190917e-02*G0_0_2 - 2.984723850609229e-02*G0_1_0 - 2.984723850609231e-02*G0_1_1 - 3.457190957190921e-02*G0_1_2 - 2.984723850609227e-02*G0_2_0 - 2.984723850609227e-02*G0_2_1 - 3.457190957190918e-02*G0_2_2;
    block[50] = 1.174317580567563e-02*G0_0_0 + 1.174317580567568e-02*G0_0_1 + 9.464999699374513e-03*G0_0_2 + 1.174317580567563e-02*G0_1_0 + 1.174317580567572e-02*G0_1_1 + 9.464999699374524e-03*G0_1_2 + 1.174317580567562e-02*G0_2_0 + 1.174317580567567e-02*G0_2_1 + 9.464999699374475e-03*G0_2_2;
    block[51] = 1.891956102025521e-02*G0_0_0 + 1.891956102025516e-02*G0_0_1 + 1.374212528726394e-02*G0_0_2 + 1.891956102025525e-02*G0_1_0 + 1.891956102025520e-02*G0_1_1 + 1.374212528726400e-02*G0_1_2 + 1.891956102025521e-02*G0_2_0 + 1.891956102025518e-02*G0_2_1 + 1.374212528726395e-02*G0_2_2;
    block[52] = -7.828783870450447e-02*G0_0_0 - 7.828783870450465e-02*G0_0_1 - 7.828783870450459e-02*G0_0_2 - 7.828783870450451e-02*G0_1_0 - 7.828783870450465e-02*G0_1_1 - 7.828783870450468e-02*G0_1_2 - 7.828783870450445e-02*G0_2_0 - 7.828783870450466e-02*G0_2_1 - 7.828783870450456e-02*G0_2_2;
    block[53] = 4.403690927128375e-02*G0_0_0 + 4.403690927128365e-02*G0_0_1 + 4.403690927128373e-02*G0_0_2 + 4.403690927128380e-02*G0_1_0 + 4.403690927128363e-02*G0_1_1 + 4.403690927128377e-02*G0_1_2 + 4.403690927128376e-02*G0_2_0 + 4.403690927128367e-02*G0_2_1 + 4.403690927128377e-02*G0_2_2;
    block[54] = 4.403690927128372e-02*G0_0_0 + 4.403690927128385e-02*G0_0_1 + 4.403690927128370e-02*G0_0_2 + 4.403690927128374e-02*G0_1_0 + 4.403690927128390e-02*G0_1_1 + 4.403690927128372e-02*G0_1_2 + 4.403690927128373e-02*G0_2_0 + 4.403690927128386e-02*G0_2_1 + 4.403690927128374e-02*G0_2_2;
    block[55] = 4.403690927128370e-02*G0_0_0 + 4.403690927128368e-02*G0_0_1 + 4.403690927128389e-02*G0_0_2 + 4.403690927128371e-02*G0_1_0 + 4.403690927128368e-02*G0_1_1 + 4.403690927128392e-02*G0_1_2 + 4.403690927128374e-02*G0_2_0 + 4.403690927128371e-02*G0_2_1 + 4.403690927128384e-02*G0_2_2;
    block[56] = -2.778905122655079e-03*G0_0_0 - 2.778905122655083e-03*G0_0_1 - 2.778905122655092e-03*G0_0_2;
    block[57] = 2.626525673400645e-02*G0_0_0;
    block[58] = 2.778905122655093e-03*G0_0_1;
    block[59] = 2.778905122655113e-03*G0_0_2;
    block[60] = -1.787050398161497e-02*G0_0_0 + 3.725718243947366e-02*G0_0_1;
    block[61] = 2.146913496739869e-02*G0_0_0 - 3.365855145368994e-02*G0_0_1;
    block[62] = -1.555448875327333e-02*G0_0_0 + 2.326323127104351e-02*G0_0_1;
    block[63] = 4.800349309897857e-03*G0_0_0 - 1.053101910306762e-02*G0_0_1;
    block[64] = -4.800349309897851e-03*G0_0_0 - 4.800349309897849e-03*G0_0_2;
    block[65] = -3.365072266981974e-03*G0_0_0 - 3.365072266982005e-03*G0_0_2;
    block[66] = -3.365072266981947e-03*G0_0_0 - 3.365072266981939e-03*G0_0_2;
    block[67] = -4.800349309897908e-03*G0_0_0 - 4.800349309897912e-03*G0_0_2;
    block[68] = 1.533136841296541e-02*G0_0_0 + 1.053101910306754e-02*G0_0_1 + 1.053101910306754e-02*G0_0_2;
    block[69] = -3.881772002431678e-02*G0_0_0 - 2.326323127104346e-02*G0_0_1 - 2.326323127104345e-02*G0_0_2;
    block[70] = 5.512768642108853e-02*G0_0_0 + 3.365855145368990e-02*G0_0_1 + 3.365855145368989e-02*G0_0_2;
    block[71] = -5.512768642108859e-02*G0_0_0 - 3.725718243947366e-02*G0_0_1 - 3.725718243947367e-02*G0_0_2;
    block[72] = -4.800349309897920e-03*G0_0_0 - 4.800349309897922e-03*G0_0_1;
    block[73] = -3.365072266981938e-03*G0_0_0 - 3.365072266981923e-03*G0_0_1;
    block[74] = -3.365072266981985e-03*G0_0_0 - 3.365072266981991e-03*G0_0_1;
    block[75] = -4.800349309897874e-03*G0_0_0 - 4.800349309897879e-03*G0_0_1;
    block[76] = -1.787050398161502e-02*G0_0_0 + 3.725718243947363e-02*G0_0_2;
    block[77] = 2.146913496739874e-02*G0_0_0 - 3.365855145368996e-02*G0_0_2;
    block[78] = -1.555448875327339e-02*G0_0_0 + 2.326323127104350e-02*G0_0_2;
    block[79] = 4.800349309897884e-03*G0_0_0 - 1.053101910306762e-02*G0_0_2;
    block[80] = 4.800349309897874e-03*G0_0_1 + 4.800349309897844e-03*G0_0_2;
    block[81] = 3.365072266981972e-03*G0_0_1 + 3.365072266981992e-03*G0_0_2;
    block[82] = 3.365072266981977e-03*G0_0_1 + 3.365072266981972e-03*G0_0_2;
    block[83] = 4.800349309897877e-03*G0_0_1 + 4.800349309897857e-03*G0_0_2;
    block[84] = 4.799305472048487e-02*G0_0_0 + 1.439452394313478e-02*G0_0_1 + 1.439452394313484e-02*G0_0_2;
    block[85] = -3.457190957190934e-02*G0_0_0 - 4.724671065816841e-03*G0_0_1 - 4.724671065816877e-03*G0_0_2;
    block[86] = 1.374212528726409e-02*G0_0_0 - 5.177435732991272e-03*G0_0_1 - 5.177435732991223e-03*G0_0_2;
    block[87] = -3.457190957190929e-02*G0_0_0 - 4.724671065816807e-03*G0_0_1 - 4.724671065816794e-03*G0_0_2;
    block[88] = 9.464999699374673e-03*G0_0_0 - 2.278176106301061e-03*G0_0_1 - 2.278176106301073e-03*G0_0_2;
    block[89] = 1.374212528726405e-02*G0_0_0 - 5.177435732991243e-03*G0_0_1 - 5.177435732991279e-03*G0_0_2;
    block[90] = -1.374212528726406e-02*G0_0_0;
    block[91] = -9.464999699374673e-03*G0_0_0;
    block[92] = -1.374212528726411e-02*G0_0_0;
    block[93] = -9.464999699374662e-03*G0_0_0;
    block[94] = -9.464999699374680e-03*G0_0_0;
    block[95] = -1.374212528726390e-02*G0_0_0;
    block[96] = 1.891956102025535e-02*G0_0_0 + 5.177435732991269e-03*G0_0_1;
    block[97] = -2.984723850609246e-02*G0_0_0 + 4.724671065816859e-03*G0_0_1;
    block[98] = 3.359853077735001e-02*G0_0_0 - 1.439452394313490e-02*G0_0_1;
    block[99] = 1.174317580567569e-02*G0_0_0 + 2.278176106301050e-03*G0_0_1;
    block[100] = -2.984723850609246e-02*G0_0_0 + 4.724671065816948e-03*G0_0_1;
    block[101] = 1.891956102025535e-02*G0_0_0 + 5.177435732991256e-03*G0_0_1;
    block[102] = 1.891956102025540e-02*G0_0_0 + 5.177435732991254e-03*G0_0_2;
    block[103] = -2.984723850609246e-02*G0_0_0 + 4.724671065816995e-03*G0_0_2;
    block[104] = 3.359853077734996e-02*G0_0_0 - 1.439452394313497e-02*G0_0_2;
    block[105] = 1.174317580567564e-02*G0_0_0 + 2.278176106301039e-03*G0_0_2;
    block[106] = -2.984723850609240e-02*G0_0_0 + 4.724671065816768e-03*G0_0_2;
    block[107] = 1.891956102025533e-02*G0_0_0 + 5.177435732991288e-03*G0_0_2;
    block[108] = 4.403690927128379e-02*G0_0_0;
    block[109] = -7.828783870450481e-02*G0_0_0;
    block[110] = 4.403690927128399e-02*G0_0_0;
    block[111] = 4.403690927128399e-02*G0_0_0;
    block[112] = -2.778905122655082e-03*G0_1_0 - 2.778905122655084e-03*G0_1_1 - 2.778905122655086e-03*G0_1_2;
    block[113] = 2.778905122655093e-03*G0_1_0;
    block[114] = 2.626525673400649e-02*G0_1_1;
    block[115] = 2.778905122655099e-03*G0_1_2;
    block[116] = -1.053101910306757e-02*G0_1_0 + 4.800349309897873e-03*G0_1_1;
    block[117] = 2.326323127104350e-02*G0_1_0 - 1.555448875327330e-02*G0_1_1;
    block[118] = -3.365855145368996e-02*G0_1_0 + 2.146913496739864e-02*G0_1_1;
    block[119] = 3.725718243947375e-02*G0_1_0 - 1.787050398161490e-02*G0_1_1;
    block[120] = -3.725718243947374e-02*G0_1_0 - 5.512768642108869e-02*G0_1_1 - 3.725718243947374e-02*G0_1_2;
    block[121] = 3.365855145369005e-02*G0_1_0 + 5.512768642108868e-02*G0_1_1 + 3.365855145369006e-02*G0_1_2;
    block[122] = -2.326323127104359e-02*G0_1_0 - 3.881772002431689e-02*G0_1_1 - 2.326323127104361e-02*G0_1_2;
    block[123] = 1.053101910306767e-02*G0_1_0 + 1.533136841296547e-02*G0_1_1 + 1.053101910306768e-02*G0_1_2;
    block[124] = -4.800349309897782e-03*G0_1_1 - 4.800349309897777e-03*G0_1_2;
    block[125] = -3.365072266981977e-03*G0_1_1 - 3.365072266981965e-03*G0_1_2;
    block[126] = -3.365072266981853e-03*G0_1_1 - 3.365072266981858e-03*G0_1_2;
    block[127] = -4.800349309897882e-03*G0_1_1 - 4.800349309897877e-03*G0_1_2;
    block[128] = -4.800349309897814e-03*G0_1_0 - 4.800349309897810e-03*G0_1_1;
    block[129] = -3.365072266982027e-03*G0_1_0 - 3.365072266982029e-03*G0_1_1;
    block[130] = -3.365072266981862e-03*G0_1_0 - 3.365072266981860e-03*G0_1_1;
    block[131] = -4.800349309897887e-03*G0_1_0 - 4.800349309897887e-03*G0_1_1;
    block[132] = 4.800349309897889e-03*G0_1_0 + 4.800349309897887e-03*G0_1_2;
    block[133] = 3.365072266981963e-03*G0_1_0 + 3.365072266982007e-03*G0_1_2;
    block[134] = 3.365072266981969e-03*G0_1_0 + 3.365072266981913e-03*G0_1_2;
    block[135] = 4.800349309897891e-03*G0_1_0 + 4.800349309897921e-03*G0_1_2;
    block[136] = -1.787050398161498e-02*G0_1_1 + 3.725718243947373e-02*G0_1_2;
    block[137] = 2.146913496739871e-02*G0_1_1 - 3.365855145369002e-02*G0_1_2;
    block[138] = -1.555448875327328e-02*G0_1_1 + 2.326323127104366e-02*G0_1_2;
    block[139] = 4.800349309897888e-03*G0_1_1 - 1.053101910306764e-02*G0_1_2;
    block[140] = -5.177435732991203e-03*G0_1_0 + 1.374212528726406e-02*G0_1_1 - 5.177435732991239e-03*G0_1_2;
    block[141] = -2.278176106301118e-03*G0_1_0 + 9.464999699374674e-03*G0_1_1 - 2.278176106301094e-03*G0_1_2;
    block[142] = -5.177435732991190e-03*G0_1_0 + 1.374212528726405e-02*G0_1_1 - 5.177435732991186e-03*G0_1_2;
    block[143] = -4.724671065816876e-03*G0_1_0 - 3.457190957190926e-02*G0_1_1 - 4.724671065816761e-03*G0_1_2;
    block[144] = -4.724671065816696e-03*G0_1_0 - 3.457190957190930e-02*G0_1_1 - 4.724671065816877e-03*G0_1_2;
    block[145] = 1.439452394313483e-02*G0_1_0 + 4.799305472048485e-02*G0_1_1 + 1.439452394313485e-02*G0_1_2;
    block[146] = -1.439452394313485e-02*G0_1_0 + 3.359853077734994e-02*G0_1_1;
    block[147] = 4.724671065816709e-03*G0_1_0 - 2.984723850609250e-02*G0_1_1;
    block[148] = 5.177435732991197e-03*G0_1_0 + 1.891956102025515e-02*G0_1_1;
    block[149] = 4.724671065816880e-03*G0_1_0 - 2.984723850609238e-02*G0_1_1;
    block[150] = 2.278176106301184e-03*G0_1_0 + 1.174317580567582e-02*G0_1_1;
    block[151] = 5.177435732991295e-03*G0_1_0 + 1.891956102025522e-02*G0_1_1;
    block[152] = -1.374212528726406e-02*G0_1_1;
    block[153] = -9.464999699374678e-03*G0_1_1;
    block[154] = -1.374212528726410e-02*G0_1_1;
    block[155] = -9.464999699374626e-03*G0_1_1;
    block[156] = -9.464999699374619e-03*G0_1_1;
    block[157] = -1.374212528726398e-02*G0_1_1;
    block[158] = 1.891956102025523e-02*G0_1_1 + 5.177435732991351e-03*G0_1_2;
    block[159] = 1.174317580567568e-02*G0_1_1 + 2.278176106301150e-03*G0_1_2;
    block[160] = 1.891956102025518e-02*G0_1_1 + 5.177435732991227e-03*G0_1_2;
    block[161] = -2.984723850609240e-02*G0_1_1 + 4.724671065816778e-03*G0_1_2;
    block[162] = -2.984723850609242e-02*G0_1_1 + 4.724671065816797e-03*G0_1_2;
    block[163] = 3.359853077734997e-02*G0_1_1 - 1.439452394313489e-02*G0_1_2;
    block[164] = 4.403690927128374e-02*G0_1_1;
    block[165] = 4.403690927128393e-02*G0_1_1;
    block[166] = -7.828783870450452e-02*G0_1_1;
    block[167] = 4.403690927128386e-02*G0_1_1;
    block[168] = -2.778905122655096e-03*G0_2_0 - 2.778905122655097e-03*G0_2_1 - 2.778905122655096e-03*G0_2_2;
    block[169] = 2.778905122655113e-03*G0_2_0;
    block[170] = 2.778905122655100e-03*G0_2_1;
    block[171] = 2.626525673400660e-02*G0_2_2;
    block[172] = 4.800349309897909e-03*G0_2_0 + 4.800349309897909e-03*G0_2_1;
    block[173] = 3.365072266981976e-03*G0_2_0 + 3.365072266981984e-03*G0_2_1;
    block[174] = 3.365072266982001e-03*G0_2_0 + 3.365072266981989e-03*G0_2_1;
    block[175] = 4.800349309897907e-03*G0_2_0 + 4.800349309897905e-03*G0_2_1;
    block[176] = -4.800349309897908e-03*G0_2_0 - 4.800349309897905e-03*G0_2_2;
    block[177] = -3.365072266981962e-03*G0_2_0 - 3.365072266981962e-03*G0_2_2;
    block[178] = -3.365072266982020e-03*G0_2_0 - 3.365072266982010e-03*G0_2_2;
    block[179] = -4.800349309897893e-03*G0_2_0 - 4.800349309897902e-03*G0_2_2;
    block[180] = -4.800349309897879e-03*G0_2_1 - 4.800349309897894e-03*G0_2_2;
    block[181] = -3.365072266981977e-03*G0_2_1 - 3.365072266981966e-03*G0_2_2;
    block[182] = -3.365072266981976e-03*G0_2_1 - 3.365072266981976e-03*G0_2_2;
    block[183] = -4.800349309897899e-03*G0_2_1 - 4.800349309897903e-03*G0_2_2;
    block[184] = 1.053101910306762e-02*G0_2_0 + 1.053101910306762e-02*G0_2_1 + 1.533136841296554e-02*G0_2_2;
    block[185] = -2.326323127104358e-02*G0_2_0 - 2.326323127104360e-02*G0_2_1 - 3.881772002431707e-02*G0_2_2;
    block[186] = 3.365855145369009e-02*G0_2_0 + 3.365855145369009e-02*G0_2_1 + 5.512768642108896e-02*G0_2_2;
    block[187] = -3.725718243947381e-02*G0_2_0 - 3.725718243947381e-02*G0_2_1 - 5.512768642108890e-02*G0_2_2;
    block[188] = -1.053101910306762e-02*G0_2_0 + 4.800349309897920e-03*G0_2_2;
    block[189] = 2.326323127104360e-02*G0_2_0 - 1.555448875327341e-02*G0_2_2;
    block[190] = -3.365855145369011e-02*G0_2_0 + 2.146913496739877e-02*G0_2_2;
    block[191] = 3.725718243947379e-02*G0_2_0 - 1.787050398161506e-02*G0_2_2;
    block[192] = -1.053101910306761e-02*G0_2_1 + 4.800349309897930e-03*G0_2_2;
    block[193] = 2.326323127104355e-02*G0_2_1 - 1.555448875327351e-02*G0_2_2;
    block[194] = -3.365855145369003e-02*G0_2_1 + 2.146913496739887e-02*G0_2_2;
    block[195] = 3.725718243947379e-02*G0_2_1 - 1.787050398161506e-02*G0_2_2;
    block[196] = -5.177435732991147e-03*G0_2_0 - 5.177435732991151e-03*G0_2_1 + 1.374212528726419e-02*G0_2_2;
    block[197] = -4.724671065816950e-03*G0_2_0 - 4.724671065816902e-03*G0_2_1 - 3.457190957190934e-02*G0_2_2;
    block[198] = 1.439452394313499e-02*G0_2_0 + 1.439452394313489e-02*G0_2_1 + 4.799305472048494e-02*G0_2_2;
    block[199] = -2.278176106301052e-03*G0_2_0 - 2.278176106301055e-03*G0_2_1 + 9.464999699374688e-03*G0_2_2;
    block[200] = -4.724671065816813e-03*G0_2_0 - 4.724671065816774e-03*G0_2_1 - 3.457190957190936e-02*G0_2_2;
    block[201] = -5.177435732991313e-03*G0_2_0 - 5.177435732991289e-03*G0_2_1 + 1.374212528726412e-02*G0_2_2;
    block[202] = 5.177435732991315e-03*G0_2_0 + 1.891956102025541e-02*G0_2_2;
    block[203] = 4.724671065816811e-03*G0_2_0 - 2.984723850609256e-02*G0_2_2;
    block[204] = -1.439452394313500e-02*G0_2_0 + 3.359853077735014e-02*G0_2_2;
    block[205] = 2.278176106301091e-03*G0_2_0 + 1.174317580567578e-02*G0_2_2;
    block[206] = 4.724671065816846e-03*G0_2_0 - 2.984723850609260e-02*G0_2_2;
    block[207] = 5.177435732991322e-03*G0_2_0 + 1.891956102025542e-02*G0_2_2;
    block[208] = -1.439452394313488e-02*G0_2_1 + 3.359853077735003e-02*G0_2_2;
    block[209] = 4.724671065816892e-03*G0_2_1 - 2.984723850609248e-02*G0_2_2;
    block[210] = 5.177435732991130e-03*G0_2_1 + 1.891956102025534e-02*G0_2_2;
    block[211] = 4.724671065816817e-03*G0_2_1 - 2.984723850609258e-02*G0_2_2;
    block[212] = 2.278176106301154e-03*G0_2_1 + 1.174317580567573e-02*G0_2_2;
    block[213] = 5.177435732991362e-03*G0_2_1 + 1.891956102025542e-02*G0_2_2;
    block[214] = -1.374212528726408e-02*G0_2_2;
    block[215] = -9.464999699374640e-03*G0_2_2;
    block[216] = -1.374212528726419e-02*G0_2_2;
    block[217] = -9.464999699374706e-03*G0_2_2;
    block[218] = -9.464999699374704e-03*G0_2_2;
    block[219] = -1.374212528726414e-02*G0_2_2;
    block[220] = 4.403690927128397e-02*G0_2_2;
    block[221] = 4.403690927128399e-02*G0_2_2;
    block[222] = 4.403690927128411e-02*G0_2_2;
    block[223] = -7.828783870450486e-02*G0_2_2;
    block[224] = -4.800349309897908e-03*G0_0_0 - 4.800349309897904e-03*G0_0_1 - 4.800349309897915e-03*G0_0_2 - 4.800349309897891e-03*G0_1_0 - 4.800349309897902e-03*G0_1_1 - 4.800349309897939e-03*G0_1_2;
    block[225] = -1.787050398161497e-02*G0_0_0 + 3.725718243947367e-02*G0_1_0;
    block[226] = -1.053101910306757e-02*G0_0_1 + 4.800349309897873e-03*G0_1_1;
    block[227] = 4.800349309897908e-03*G0_0_2 + 4.800349309897908e-03*G0_1_2;
    block[228] = 1.790964790096713e-01*G0_0_0 + 6.991103996312238e-02*G0_0_1 + 6.991103996312238e-02*G0_1_0 + 1.398220799262448e-01*G0_1_1;
    block[229] = -1.470637050064117e-01*G0_0_0 + 2.638300164341826e-02*G0_0_1 - 3.872638421249491e-02*G0_1_0 - 1.086374241756173e-01*G0_1_1;
    block[230] = 1.007173044933449e-01*G0_0_0 - 2.463457324568436e-02*G0_0_1 + 1.897827689928361e-02*G0_1_0 + 7.889456945446424e-02*G0_1_1;
    block[231] = -3.283522434998078e-02*G0_0_0 + 2.091590090722037e-02*G0_0_1 - 5.375764924375950e-03*G0_1_0 - 3.283522434998079e-02*G0_1_1;
    block[232] = 3.283522434998074e-02*G0_0_0 + 5.375764924375847e-03*G0_0_1 + 3.283522434998074e-02*G0_0_2 + 5.375764924375942e-03*G0_1_0 + 5.375764924375924e-03*G0_1_2;
    block[233] = 1.116906498850957e-02*G0_0_0 + 2.289919282106909e-03*G0_0_1 + 1.116906498850950e-02*G0_0_2 + 2.289919282106862e-03*G0_1_0 + 2.289919282106778e-03*G0_1_2;
    block[234] = 1.397437920875404e-02*G0_0_0 + 2.289919282106672e-03*G0_0_1 + 1.397437920875408e-02*G0_0_2 + 2.289919282106743e-03*G0_1_0 + 2.289919282106759e-03*G0_1_2;
    block[235] = 1.075152984875202e-02*G0_0_0 + 5.375764924376020e-03*G0_0_1 + 1.075152984875196e-02*G0_0_2 + 5.375764924376036e-03*G0_1_0 + 5.375764924375970e-03*G0_1_2;
    block[236] = 2.208369450122904e-02*G0_0_0 + 2.745945942560494e-02*G0_0_1 + 2.745945942560495e-02*G0_0_2 + 2.745945942560494e-02*G0_1_0 + 3.283522434998090e-02*G0_1_1 + 3.283522434998094e-02*G0_1_2;
    block[237] = -3.154347501135667e-02*G0_0_0 - 5.991629255518076e-02*G0_0_1 - 5.991629255518076e-02*G0_0_2 - 5.991629255518074e-02*G0_1_0 - 7.889456945446431e-02*G0_1_1 - 7.889456945446431e-02*G0_1_2;
    block[238] = 1.249343425992723e-02*G0_0_0 + 6.991103996312259e-02*G0_0_1 + 6.991103996312252e-02*G0_0_2 + 6.991103996312248e-02*G0_1_0 + 1.086374241756173e-01*G0_1_1 + 1.086374241756172e-01*G0_1_2;
    block[239] = 1.963719954171328e-02*G0_0_0 - 6.991103996312242e-02*G0_0_1 - 6.991103996312233e-02*G0_0_2 - 6.991103996312249e-02*G0_1_0 - 1.398220799262449e-01*G0_1_1 - 1.398220799262448e-01*G0_1_2;
    block[240] = 5.375764924375932e-03*G0_0_0 + 5.375764924375899e-03*G0_0_1 + 5.375764924375943e-03*G0_1_0 + 5.375764924375913e-03*G0_1_1;
    block[241] = 2.289919282106599e-03*G0_0_0 + 2.289919282106625e-03*G0_0_1 + 2.289919282106564e-03*G0_1_0 + 2.289919282106586e-03*G0_1_1;
    block[242] = 2.289919282106846e-03*G0_0_0 + 2.289919282106857e-03*G0_0_1 + 2.289919282106830e-03*G0_1_0 + 2.289919282106834e-03*G0_1_1;
    block[243] = 5.375764924375791e-03*G0_0_0 + 5.375764924375821e-03*G0_0_1 + 5.375764924375866e-03*G0_1_0 + 5.375764924375885e-03*G0_1_1;
    block[244] = 8.954823950483559e-02*G0_0_0 + 6.991103996312230e-02*G0_0_2 + 6.991103996312227e-02*G0_1_0 + 1.398220799262447e-01*G0_1_2;
    block[245] = -5.741760570319510e-02*G0_0_0 - 6.991103996312240e-02*G0_0_2 - 3.872638421249458e-02*G0_1_0 - 1.086374241756172e-01*G0_1_2;
    block[246] = 2.837281754382387e-02*G0_0_0 + 5.991629255518057e-02*G0_0_2 + 1.897827689928337e-02*G0_1_0 + 7.889456945446414e-02*G0_1_2;
    block[247] = -5.375764924375781e-03*G0_0_0 - 2.745945942560486e-02*G0_0_2 - 5.375764924375841e-03*G0_1_0 - 3.283522434998085e-02*G0_1_2;
    block[248] = -2.745945942560473e-02*G0_0_1 - 3.283522434998069e-02*G0_0_2 - 5.375764924375847e-03*G0_1_1 - 5.375764924375910e-03*G0_1_2;
    block[249] = -8.879145706402738e-03*G0_0_1 - 1.116906498850944e-02*G0_0_2 - 2.289919282106838e-03*G0_1_1 - 2.289919282106737e-03*G0_1_2;
    block[250] = -1.168445992664726e-02*G0_0_1 - 1.397437920875408e-02*G0_0_2 - 2.289919282106668e-03*G0_1_1 - 2.289919282106727e-03*G0_1_2;
    block[251] = -5.375764924375793e-03*G0_0_1 - 1.075152984875183e-02*G0_0_2 - 5.375764924375856e-03*G0_1_1 - 5.375764924375933e-03*G0_1_2;
    block[252] = -6.445698720004234e-02*G0_0_0 + 9.629404160654015e-02*G0_0_1 + 1.925880832130807e-01*G0_0_2 + 2.844458139596996e-02*G0_1_0 + 1.247386230025100e-01*G0_1_1 + 1.247386230025099e-01*G0_1_2;
    block[253] = 4.397166940569677e-02*G0_0_0 - 4.227543290043238e-02*G0_0_1 - 8.455086580086493e-02*G0_0_2 - 6.850185886645547e-04*G0_1_0 - 4.296045148909679e-02*G0_1_1 - 4.296045148909680e-02*G0_1_2;
    block[254] = -1.878908128908080e-02*G0_0_0 + 2.126819618139026e-02*G0_0_1 + 4.253639236278099e-02*G0_0_2 - 9.394540644540303e-03*G0_1_0 + 1.187365553684970e-02*G0_1_1 + 1.187365553685001e-02*G0_1_2;
    block[255] = 1.273155976932006e-01*G0_0_0 - 7.045905483405425e-03*G0_0_1 - 4.932133838383794e-02*G0_0_2 - 6.850185886644570e-04*G0_1_0 - 4.296045148909680e-02*G0_1_1 - 4.296045148909686e-02*G0_1_2;
    block[256] = -2.926007971580859e-02*G0_0_0 + 8.448562593528289e-03*G0_0_1 + 1.428753056357240e-02*G0_0_2 - 3.294613212147738e-03*G0_1_0 + 2.544354757896797e-03*G0_1_1 + 2.544354757896623e-03*G0_1_2;
    block[257] = -6.413078787210634e-02*G0_0_0 + 2.648738542835736e-02*G0_0_1 + 4.775558160974783e-02*G0_0_2 - 9.394540644540431e-03*G0_1_0 + 1.187365553684978e-02*G0_1_1 + 1.187365553684980e-02*G0_1_2;
    block[258] = 6.413078787210633e-02*G0_0_0 + 9.394540644540289e-03*G0_0_1 + 9.394540644540417e-03*G0_1_0;
    block[259] = 2.926007971580858e-02*G0_0_0 + 3.294613212147956e-03*G0_0_1 + 3.294613212147710e-03*G0_1_0;
    block[260] = 1.878908128908083e-02*G0_0_0 + 9.394540644540430e-03*G0_0_1 + 9.394540644540329e-03*G0_1_0;
    block[261] = 2.926007971580906e-02*G0_0_0 + 3.294613212147774e-03*G0_0_1 + 3.294613212148276e-03*G0_1_0;
    block[262] = 6.589226424296014e-03*G0_0_0 + 3.294613212148090e-03*G0_0_1 + 3.294613212148094e-03*G0_1_0;
    block[263] = 1.878908128908095e-02*G0_0_0 + 9.394540644540881e-03*G0_0_1 + 9.394540644540639e-03*G0_1_0;
    block[264] = -3.066273682593073e-02*G0_0_0 - 2.126819618139027e-02*G0_0_1 - 2.126819618139021e-02*G0_1_0 - 1.187365553684969e-02*G0_1_1;
    block[265] = 6.426126760328056e-02*G0_0_0 + 4.227543290043249e-02*G0_0_1 + 4.227543290043201e-02*G0_1_0 + 4.296045148909691e-02*G0_1_1;
    block[266] = -1.285225352065617e-01*G0_0_0 - 9.629404160654045e-02*G0_0_1 - 9.629404160654047e-02*G0_1_0 - 1.247386230025105e-01*G0_1_1;
    block[267] = -9.133581182192025e-03*G0_0_0 - 5.838967970044303e-03*G0_0_1 - 5.838967970043961e-03*G0_1_0 - 2.544354757896255e-03*G0_1_1;
    block[268] = 6.426126760328121e-02*G0_0_0 + 4.227543290043295e-02*G0_0_1 + 4.227543290043281e-02*G0_1_0 + 4.296045148909754e-02*G0_1_1;
    block[269] = -3.066273682593109e-02*G0_0_0 - 2.126819618139096e-02*G0_0_1 - 2.126819618139055e-02*G0_1_0 - 1.187365553685053e-02*G0_1_1;
    block[270] = -6.132547365186217e-02*G0_0_0 - 2.126819618139048e-02*G0_0_1 - 4.253639236278113e-02*G0_0_2 - 2.126819618139056e-02*G0_1_0 - 1.187365553685017e-02*G0_1_2;
    block[271] = 1.285225352065624e-01*G0_0_0 + 4.227543290043281e-02*G0_0_1 + 8.455086580086557e-02*G0_0_2 + 4.227543290043275e-02*G0_1_0 + 4.296045148909752e-02*G0_1_2;
    block[272] = -2.570450704131236e-01*G0_0_0 - 9.629404160654083e-02*G0_0_1 - 1.925880832130812e-01*G0_0_2 - 9.629404160654054e-02*G0_1_0 - 1.247386230025106e-01*G0_1_2;
    block[273] = -4.354761027938064e-02*G0_0_0 - 5.838967970044103e-03*G0_0_1 - 1.428753056357169e-02*G0_0_2 - 5.838967970044274e-03*G0_1_0 - 2.544354757896116e-03*G0_1_2;
    block[274] = 1.766369360770384e-01*G0_0_0 + 4.227543290043265e-02*G0_0_1 + 4.932133838383804e-02*G0_0_2 + 4.227543290043243e-02*G0_1_0 + 4.296045148909684e-02*G0_1_2;
    block[275] = -1.118863694818545e-01*G0_0_0 - 2.126819618139079e-02*G0_0_1 - 4.775558160974790e-02*G0_0_2 - 2.126819618139047e-02*G0_1_0 - 1.187365553684979e-02*G0_1_2;
    block[276] = -5.056089582999240e-02*G0_0_0 - 2.609594623482564e-03*G0_0_1 - 2.609594623483391e-03*G0_1_0;
    block[277] = 9.622880174095397e-02*G0_0_0 - 3.522952741702697e-02*G0_0_1 - 3.522952741702713e-02*G0_1_0;
    block[278] = -1.565756774090099e-01*G0_0_0 - 2.609594623484203e-03*G0_0_1 - 2.609594623483836e-03*G0_1_0;
    block[279] = -5.056089582999273e-02*G0_0_0 - 2.609594623483960e-03*G0_0_1 - 2.609594623483540e-03*G0_1_0;
    block[280] = -3.365072266981931e-03*G0_0_0 - 3.365072266981925e-03*G0_0_1 - 3.365072266981918e-03*G0_0_2 - 3.365072266981939e-03*G0_1_0 - 3.365072266981912e-03*G0_1_1 - 3.365072266981887e-03*G0_1_2;
    block[281] = 2.146913496739870e-02*G0_0_0 - 3.365855145368994e-02*G0_1_0;
    block[282] = 2.326323127104350e-02*G0_0_1 - 1.555448875327330e-02*G0_1_1;
    block[283] = 3.365072266981976e-03*G0_0_2 + 3.365072266981984e-03*G0_1_2;
    block[284] = -1.470637050064117e-01*G0_0_0 - 3.872638421249490e-02*G0_0_1 + 2.638300164341825e-02*G0_1_0 - 1.086374241756173e-01*G0_1_1;
    block[285] = 3.042265412057047e-01*G0_0_0 + 7.813126302709567e-02*G0_0_1 + 7.813126302709564e-02*G0_1_0 + 2.810011490567019e-01*G0_1_1;
    block[286] = -2.041877313144652e-01*G0_0_0 + 1.530527246673054e-02*G0_0_1 - 3.649518080941667e-02*G0_1_0 - 2.041877313144654e-01*G0_1_1;
    block[287] = 7.889456945446438e-02*G0_0_0 - 2.463457324568423e-02*G0_0_1 + 1.897827689928372e-02*G0_1_0 + 1.007173044933451e-01*G0_1_1;
    block[288] = -7.889456945446430e-02*G0_0_0 - 1.897827689928369e-02*G0_0_1 - 7.889456945446428e-02*G0_0_2 - 1.897827689928369e-02*G0_1_0 + 9.394540644540412e-03*G0_1_1 - 1.897827689928371e-02*G0_1_2;
    block[289] = -5.232237220084614e-03*G0_0_0 + 5.480148709315723e-04*G0_0_1 - 5.232237220084482e-03*G0_0_2 + 5.480148709315240e-04*G0_1_0 + 6.523986558712707e-05*G0_1_1 + 5.480148709316292e-04*G0_1_2;
    block[290] = -2.630471380471345e-02*G0_0_0 - 1.315235690235673e-02*G0_0_1 - 2.630471380471358e-02*G0_0_2 - 1.315235690235679e-02*G0_1_0 + 6.523986558717429e-05*G0_1_1 - 1.315235690235683e-02*G0_1_2;
    block[291] = 1.397437920875397e-02*G0_0_0 + 1.168445992664723e-02*G0_0_1 + 1.397437920875404e-02*G0_0_2 + 1.168445992664723e-02*G0_1_0 + 9.394540644540497e-03*G0_1_1 + 1.168445992664725e-02*G0_1_2;
    block[292] = 6.589226424295741e-03*G0_0_0 + 8.879145706402575e-03*G0_0_1 + 8.879145706402551e-03*G0_0_2 + 8.879145706402554e-03*G0_1_0 + 1.116906498850930e-02*G0_1_1 + 1.116906498850924e-02*G0_1_2;
    block[293] = -6.263027096360365e-03*G0_0_0 - 5.780252091015882e-03*G0_0_1 - 5.780252091015826e-03*G0_0_2 - 5.780252091015996e-03*G0_1_0 - 5.232237220084449e-03*G0_1_1 - 5.232237220084384e-03*G0_1_2;
    block[294] = 2.609594623484389e-04*G0_0_0 - 4.801654107209576e-03*G0_0_1 - 4.801654107209593e-03*G0_0_2 - 4.801654107209462e-03*G0_1_0 - 9.603308214419045e-03*G0_1_1 - 9.603308214419022e-03*G0_1_2;
    block[295] = -1.869122149070051e-02*G0_0_0 + 3.872638421249488e-02*G0_0_1 + 3.872638421249484e-02*G0_0_2 + 3.872638421249480e-02*G0_1_0 + 1.086374241756172e-01*G0_1_1 + 1.086374241756172e-01*G0_1_2;
    block[296] = 2.289919282106938e-03*G0_0_0 + 2.289919282106919e-03*G0_0_1 + 2.289919282106878e-03*G0_1_0 + 2.289919282106827e-03*G0_1_1;
    block[297] = 1.787572317086243e-03*G0_0_0 + 1.787572317086211e-03*G0_0_1 + 1.787572317086319e-03*G0_1_0 + 1.787572317086307e-03*G0_1_1;
    block[298] = 1.787572317086234e-03*G0_0_0 + 1.787572317086253e-03*G0_0_1 + 1.787572317086214e-03*G0_1_0 + 1.787572317086236e-03*G0_1_1;
    block[299] = 2.289919282106799e-03*G0_0_0 + 2.289919282106771e-03*G0_0_1 + 2.289919282106764e-03*G0_1_0 + 2.289919282106746e-03*G0_1_1;
    block[300] = -5.741760570319542e-02*G0_0_0 - 3.872638421249481e-02*G0_0_2 - 6.991103996312245e-02*G0_1_0 - 1.086374241756171e-01*G0_1_2;
    block[301] = 5.062613569557912e-03*G0_0_0 + 4.801654107209468e-03*G0_0_2 + 4.801654107209377e-03*G0_1_0 + 9.603308214418639e-03*G0_1_2;
    block[302] = -4.827750053443594e-04*G0_0_0 + 5.780252091016173e-03*G0_0_2 - 5.480148709313530e-04*G0_1_0 + 5.232237220084991e-03*G0_1_2;
    block[303] = -2.289919282106782e-03*G0_0_0 - 8.879145706402636e-03*G0_0_2 - 2.289919282106754e-03*G0_1_0 - 1.116906498850950e-02*G0_1_2;
    block[304] = 5.991629255518053e-02*G0_0_1 + 7.889456945446423e-02*G0_0_2 + 2.837281754382399e-02*G0_1_1 + 1.897827689928362e-02*G0_1_2;
    block[305] = 5.780252091016120e-03*G0_0_1 + 5.232237220084509e-03*G0_0_2 - 4.827750053443331e-04*G0_1_1 - 5.480148709315711e-04*G0_1_2;
    block[306] = 1.315235690235677e-02*G0_0_1 + 2.630471380471354e-02*G0_0_2 + 1.321759676794373e-02*G0_1_1 + 1.315235690235664e-02*G0_1_2;
    block[307] = -2.289919282106777e-03*G0_0_1 - 1.397437920875411e-02*G0_0_2 - 2.289919282106754e-03*G0_1_1 - 1.168445992664731e-02*G0_1_2;
    block[308] = 1.323064474106128e-01*G0_0_0 - 6.236931150125530e-02*G0_0_1 + 1.096029741863108e-02*G0_0_2 + 7.332960891988581e-02*G0_1_0 - 1.247386230025104e-01*G0_1_1 + 1.466592178397728e-01*G0_1_2;
    block[309] = -4.364547007776150e-02*G0_0_0 - 6.491366625915262e-03*G0_0_1 - 8.083219346240139e-02*G0_0_2 - 3.389211017249180e-02*G0_1_0 - 3.522952741702943e-03*G0_1_1 - 1.082329370089784e-01*G0_1_2;
    block[310] = 1.487468935385585e-02*G0_0_0 + 1.239557446154780e-03*G0_0_1 + 4.031823693281997e-02*G0_0_2 + 1.493992921944284e-02*G0_1_0 + 1.174317580567772e-03*G0_1_1 + 5.401860870610831e-02*G0_1_2;
    block[311] = -1.669488160373563e-01*G0_0_0 + 8.386584721220051e-02*G0_0_1 + 1.677316944244009e-01*G0_0_2 - 6.165167297979822e-03*G0_1_0 + 1.824106641814956e-01*G0_1_1 + 7.770067991422071e-02*G0_1_2;
    block[312] = 1.898480088584234e-02*G0_0_0 - 1.888694108746215e-02*G0_0_1 - 3.777388217492373e-02*G0_0_2 + 9.492400442920938e-03*G0_1_0 - 1.559232787531427e-02*G0_1_1 - 9.394540644540678e-03*G0_1_2;
    block[313] = 1.270872581636453e-01*G0_0_0 - 4.638554443241926e-02*G0_0_1 - 8.233271037090439e-02*G0_0_2 + 3.777388217492330e-02*G0_1_0 - 5.101757488910216e-02*G0_1_1 + 1.826716236438234e-03*G0_1_2;
    block[314] = -1.270872581636454e-01*G0_0_0 - 3.777388217492302e-02*G0_0_1 - 3.777388217492334e-02*G0_1_0 - 1.500516908502975e-02*G0_1_1;
    block[315] = -1.898480088584235e-02*G0_0_0 - 9.492400442921409e-03*G0_0_1 - 9.492400442920912e-03*G0_1_0 - 6.523986558708888e-04*G0_1_1;
    block[316] = -1.487468935385584e-02*G0_0_0 - 1.493992921944308e-02*G0_0_1 - 1.493992921944287e-02*G0_1_0 - 1.500516908503006e-02*G0_1_1;
    block[317] = -1.898480088584303e-02*G0_0_0 - 9.492400442921250e-03*G0_0_1 - 9.492400442922010e-03*G0_1_0 - 6.523986558708067e-04*G0_1_1;
    block[318] = 4.501550725509282e-03*G0_0_0 + 1.924576034819181e-03*G0_0_1 + 1.924576034819204e-03*G0_1_0 - 6.523986558709093e-04*G0_1_1;
    block[319] = -1.487468935385577e-02*G0_0_0 - 1.493992921944331e-02*G0_0_1 - 1.493992921944314e-02*G0_1_0 - 1.500516908503045e-02*G0_1_1;
    block[320] = -1.304797311741887e-03*G0_0_0 - 1.239557446154843e-03*G0_0_1 - 1.239557446154895e-03*G0_1_0 - 1.174317580567883e-03*G0_1_1;
    block[321] = 8.807381854256708e-03*G0_0_0 + 6.491366625915237e-03*G0_0_1 + 6.491366625915416e-03*G0_1_0 + 3.522952741702909e-03*G0_1_1;
    block[322] = 4.762510187857377e-02*G0_0_0 + 6.236931150125544e-02*G0_0_1 + 6.236931150125542e-02*G0_1_0 + 1.247386230025108e-01*G0_1_1;
    block[323] = -1.565756774090090e-02*G0_0_0 - 1.308059305021053e-02*G0_0_1 - 1.308059305021114e-02*G0_1_0 - 1.050361835952079e-02*G0_1_1;
    block[324] = 8.807381854256521e-03*G0_0_0 + 6.491366625914820e-03*G0_0_1 + 6.491366625914692e-03*G0_1_0 + 3.522952741702053e-03*G0_1_1;
    block[325] = -1.304797311741758e-03*G0_0_0 - 1.239557446154158e-03*G0_0_1 - 1.239557446154522e-03*G0_1_0 - 1.174317580566897e-03*G0_1_1;
    block[326] = -2.544354757896355e-02*G0_0_0 - 3.907867948666510e-02*G0_0_1 - 4.031823693281942e-02*G0_0_2 - 3.907867948666495e-02*G0_1_0 - 5.284429112554057e-02*G0_1_1 - 5.401860870610786e-02*G0_1_2;
    block[327] = 3.718672338463890e-02*G0_0_0 + 7.434082683648549e-02*G0_0_1 + 8.083219346240032e-02*G0_0_2 + 7.434082683648544e-02*G0_1_0 + 1.047099842672748e-01*G0_1_1 + 1.082329370089772e-01*G0_1_2;
    block[328] = 1.213461499919823e-01*G0_0_0 - 7.332960891988607e-02*G0_0_1 - 1.096029741863067e-02*G0_0_2 - 7.332960891988605e-02*G0_1_0 - 2.713978408422829e-01*G0_1_1 - 1.466592178397723e-01*G0_1_2;
    block[329] = 5.675868306076557e-02*G0_0_0 + 1.888694108746127e-02*G0_0_1 + 3.777388217492280e-02*G0_0_2 + 1.888694108746174e-02*G0_1_0 - 6.197787230773567e-03*G0_1_1 + 9.394540644540159e-03*G0_1_2;
    block[330] = -3.346805104617568e-01*G0_0_0 - 8.386584721220029e-02*G0_0_1 - 1.677316944244011e-01*G0_0_2 - 8.386584721220050e-02*G0_1_0 + 1.047099842672752e-01*G0_1_1 - 7.770067991422058e-02*G0_1_2;
    block[331] = 2.094199685345498e-01*G0_0_0 + 3.594716593848558e-02*G0_0_1 + 8.233271037090439e-02*G0_0_2 + 3.594716593848514e-02*G0_1_0 - 5.284429112554030e-02*G0_1_1 - 1.826716236438381e-03*G0_1_2;
    block[332] = 3.914391935225253e-02*G0_0_0 + 3.196753413767211e-02*G0_0_1 + 3.196753413767333e-02*G0_1_0 + 2.609594623483427e-02*G0_1_1;
    block[333] = -1.565756774090097e-01*G0_0_0 - 9.035721383811586e-02*G0_0_1 - 9.035721383811596e-02*G0_1_0 - 1.859336169231985e-01*G0_1_1;
    block[334] = 1.859336169231995e-01*G0_0_0 + 1.565756774090172e-02*G0_0_1 + 1.565756774090185e-02*G0_1_0 + 2.609594623483533e-02*G0_1_1;
    block[335] = 3.914391935225219e-02*G0_0_0 + 3.196753413767274e-02*G0_0_1 + 3.196753413767267e-02*G0_1_0 + 2.609594623483516e-02*G0_1_1;
    block[336] = -3.365072266981969e-03*G0_0_0 - 3.365072266981980e-03*G0_0_1 - 3.365072266981954e-03*G0_0_2 - 3.365072266981981e-03*G0_1_0 - 3.365072266982017e-03*G0_1_1 - 3.365072266981998e-03*G0_1_2;
    block[337] = -1.555448875327333e-02*G0_0_0 + 2.326323127104351e-02*G0_1_0;
    block[338] = -3.365855145368996e-02*G0_0_1 + 2.146913496739864e-02*G0_1_1;
    block[339] = 3.365072266982003e-03*G0_0_2 + 3.365072266981988e-03*G0_1_2;
    block[340] = 1.007173044933449e-01*G0_0_0 + 1.897827689928361e-02*G0_0_1 - 2.463457324568436e-02*G0_1_0 + 7.889456945446424e-02*G0_1_1;
    block[341] = -2.041877313144652e-01*G0_0_0 - 3.649518080941667e-02*G0_0_1 + 1.530527246673054e-02*G0_1_0 - 2.041877313144654e-01*G0_1_1;
    block[342] = 2.810011490567019e-01*G0_0_0 + 7.813126302709575e-02*G0_0_1 + 7.813126302709575e-02*G0_1_0 + 3.042265412057050e-01*G0_1_1;
    block[343] = -1.086374241756174e-01*G0_0_0 + 2.638300164341811e-02*G0_0_1 - 3.872638421249492e-02*G0_1_0 - 1.470637050064117e-01*G0_1_1;
    block[344] = 1.086374241756174e-01*G0_0_0 + 3.872638421249499e-02*G0_0_1 + 1.086374241756174e-01*G0_0_2 + 3.872638421249493e-02*G0_1_0 - 1.869122149070034e-02*G0_1_1 + 3.872638421249494e-02*G0_1_2;
    block[345] = -9.603308214419208e-03*G0_0_0 - 4.801654107209739e-03*G0_0_1 - 9.603308214419348e-03*G0_0_2 - 4.801654107209520e-03*G0_1_0 + 2.609594623482553e-04*G0_1_1 - 4.801654107209632e-03*G0_1_2;
    block[346] = -5.232237220084212e-03*G0_0_0 - 5.780252091015725e-03*G0_0_1 - 5.232237220084118e-03*G0_0_2 - 5.780252091015879e-03*G0_1_0 - 6.263027096360281e-03*G0_1_1 - 5.780252091015868e-03*G0_1_2;
    block[347] = 1.116906498850919e-02*G0_0_0 + 8.879145706402485e-03*G0_0_1 + 1.116906498850912e-02*G0_0_2 + 8.879145706402507e-03*G0_1_0 + 6.589226424295762e-03*G0_1_1 + 8.879145706402502e-03*G0_1_2;
    block[348] = 9.394540644540527e-03*G0_0_0 + 1.168445992664714e-02*G0_0_1 + 1.168445992664713e-02*G0_0_2 + 1.168445992664730e-02*G0_1_0 + 1.397437920875402e-02*G0_1_1 + 1.397437920875407e-02*G0_1_2;
    block[349] = 6.523986558717866e-05*G0_0_0 - 1.315235690235673e-02*G0_0_1 - 1.315235690235680e-02*G0_0_2 - 1.315235690235677e-02*G0_1_0 - 2.630471380471341e-02*G0_1_1 - 2.630471380471349e-02*G0_1_2;
    block[350] = 6.523986558703936e-05*G0_0_0 + 5.480148709314869e-04*G0_0_1 + 5.480148709314820e-04*G0_0_2 + 5.480148709315757e-04*G0_1_0 - 5.232237220084368e-03*G0_1_1 - 5.232237220084392e-03*G0_1_2;
    block[351] = 9.394540644540497e-03*G0_0_0 - 1.897827689928366e-02*G0_0_1 - 1.897827689928360e-02*G0_0_2 - 1.897827689928372e-02*G0_1_0 - 7.889456945446434e-02*G0_1_1 - 7.889456945446424e-02*G0_1_2;
    block[352] = 2.289919282106545e-03*G0_0_0 + 2.289919282106539e-03*G0_0_1 + 2.289919282106622e-03*G0_1_0 + 2.289919282106660e-03*G0_1_1;
    block[353] = 1.787572317086139e-03*G0_0_0 + 1.787572317086157e-03*G0_0_1 + 1.787572317086041e-03*G0_1_0 + 1.787572317086049e-03*G0_1_1;
    block[354] = 1.787572317086272e-03*G0_0_0 + 1.787572317086257e-03*G0_0_1 + 1.787572317086353e-03*G0_1_0 + 1.787572317086339e-03*G0_1_1;
    block[355] = 2.289919282106657e-03*G0_0_0 + 2.289919282106668e-03*G0_0_1 + 2.289919282106663e-03*G0_1_0 + 2.289919282106678e-03*G0_1_1;
    block[356] = 2.837281754382418e-02*G0_0_0 + 1.897827689928358e-02*G0_0_2 + 5.991629255518068e-02*G0_1_0 + 7.889456945446417e-02*G0_1_2;
    block[357] = -4.827750053442868e-04*G0_0_0 - 5.480148709313673e-04*G0_0_2 + 5.780252091016408e-03*G0_1_0 + 5.232237220085024e-03*G0_1_2;
    block[358] = 1.321759676794374e-02*G0_0_0 + 1.315235690235662e-02*G0_0_2 + 1.315235690235639e-02*G0_1_0 + 2.630471380471300e-02*G0_1_2;
    block[359] = -2.289919282106648e-03*G0_0_0 - 1.168445992664727e-02*G0_0_2 - 2.289919282106657e-03*G0_1_0 - 1.397437920875394e-02*G0_1_2;
    block[360] = -6.991103996312240e-02*G0_0_1 - 1.086374241756173e-01*G0_0_2 - 5.741760570319513e-02*G0_1_1 - 3.872638421249486e-02*G0_1_2;
    block[361] = 4.801654107209543e-03*G0_0_1 + 9.603308214419036e-03*G0_0_2 + 5.062613569557812e-03*G0_1_1 + 4.801654107209580e-03*G0_1_2;
    block[362] = -5.480148709315309e-04*G0_0_1 + 5.232237220084525e-03*G0_0_2 - 4.827750053441309e-04*G0_1_1 + 5.780252091016238e-03*G0_1_2;
    block[363] = -2.289919282106672e-03*G0_0_1 - 1.116906498850933e-02*G0_0_2 - 2.289919282106676e-03*G0_1_1 - 8.879145706402551e-03*G0_1_2;
    block[364] = -5.101757488910194e-02*G0_0_0 + 3.777388217492367e-02*G0_0_1 + 1.826716236438202e-03*G0_0_2 - 4.638554443241862e-02*G0_1_0 + 1.270872581636459e-01*G0_1_1 - 8.233271037090459e-02*G0_1_2;
    block[365] = -1.559232787531392e-02*G0_0_0 + 9.492400442921243e-03*G0_0_1 - 9.394540644540386e-03*G0_0_2 - 1.888694108746206e-02*G0_1_0 + 1.898480088584265e-02*G0_1_1 - 3.777388217492309e-02*G0_1_2;
    block[366] = 1.174317580567627e-03*G0_0_0 + 1.493992921944285e-02*G0_0_1 + 5.401860870610829e-02*G0_0_2 + 1.239557446155052e-03*G0_1_0 + 1.487468935385558e-02*G0_1_1 + 4.031823693282014e-02*G0_1_2;
    block[367] = 1.824106641814955e-01*G0_0_0 - 6.165167297980225e-03*G0_0_1 + 7.770067991422067e-02*G0_0_2 + 8.386584721220015e-02*G0_1_0 - 1.669488160373567e-01*G0_1_1 + 1.677316944244008e-01*G0_1_2;
    block[368] = -3.522952741702519e-03*G0_0_0 - 3.389211017249150e-02*G0_0_1 - 1.082329370089776e-01*G0_0_2 - 6.491366625914680e-03*G0_1_0 - 4.364547007776084e-02*G0_1_1 - 8.083219346240103e-02*G0_1_2;
    block[369] = -1.247386230025103e-01*G0_0_0 + 7.332960891988641e-02*G0_0_1 + 1.466592178397725e-01*G0_0_2 - 6.236931150125510e-02*G0_1_0 + 1.323064474106131e-01*G0_1_1 + 1.096029741863107e-02*G0_1_2;
    block[370] = 1.247386230025104e-01*G0_0_0 + 6.236931150125521e-02*G0_0_1 + 6.236931150125512e-02*G0_1_0 + 4.762510187857325e-02*G0_1_1;
    block[371] = 3.522952741702501e-03*G0_0_0 + 6.491366625915459e-03*G0_0_1 + 6.491366625914666e-03*G0_1_0 + 8.807381854256937e-03*G0_1_1;
    block[372] = -1.174317580567689e-03*G0_0_0 - 1.239557446154702e-03*G0_0_1 - 1.239557446155079e-03*G0_1_0 - 1.304797311742119e-03*G0_1_1;
    block[373] = 3.522952741703140e-03*G0_0_0 + 6.491366625914850e-03*G0_0_1 + 6.491366625916095e-03*G0_1_0 + 8.807381854256752e-03*G0_1_1;
    block[374] = -1.050361835952131e-02*G0_0_0 - 1.308059305021119e-02*G0_0_1 - 1.308059305021103e-02*G0_1_0 - 1.565756774090093e-02*G0_1_1;
    block[375] = -1.174317580567693e-03*G0_0_0 - 1.239557446154093e-03*G0_0_1 - 1.239557446154781e-03*G0_1_0 - 1.304797311741387e-03*G0_1_1;
    block[376] = -1.500516908503004e-02*G0_0_0 - 1.493992921944286e-02*G0_0_1 - 1.493992921944277e-02*G0_1_0 - 1.487468935385549e-02*G0_1_1;
    block[377] = -6.523986558708592e-04*G0_0_0 - 9.492400442921219e-03*G0_0_1 - 9.492400442921383e-03*G0_1_0 - 1.898480088584261e-02*G0_1_1;
    block[378] = -1.500516908502996e-02*G0_0_0 - 3.777388217492369e-02*G0_0_1 - 3.777388217492342e-02*G0_1_0 - 1.270872581636461e-01*G0_1_1;
    block[379] = -6.523986558709241e-04*G0_0_0 + 1.924576034818811e-03*G0_0_1 + 1.924576034819008e-03*G0_1_0 + 4.501550725508709e-03*G0_1_1;
    block[380] = -6.523986558708864e-04*G0_0_0 - 9.492400442921172e-03*G0_0_1 - 9.492400442920998e-03*G0_1_0 - 1.898480088584206e-02*G0_1_1;
    block[381] = -1.500516908502996e-02*G0_0_0 - 1.493992921944352e-02*G0_0_1 - 1.493992921944291e-02*G0_1_0 - 1.487468935385651e-02*G0_1_1;
    block[382] = -5.284429112554050e-02*G0_0_0 - 3.907867948666482e-02*G0_0_1 - 5.401860870610820e-02*G0_0_2 - 3.907867948666499e-02*G0_1_0 - 2.544354757896378e-02*G0_1_1 - 4.031823693281993e-02*G0_1_2;
    block[383] = -6.197787230773360e-03*G0_0_0 + 1.888694108746175e-02*G0_0_1 + 9.394540644540742e-03*G0_0_2 + 1.888694108746150e-02*G0_1_0 + 5.675868306076557e-02*G0_1_1 + 3.777388217492370e-02*G0_1_2;
    block[384] = -5.284429112554022e-02*G0_0_0 + 3.594716593848520e-02*G0_0_1 - 1.826716236438412e-03*G0_0_2 + 3.594716593848533e-02*G0_1_0 + 2.094199685345500e-01*G0_1_1 + 8.233271037090439e-02*G0_1_2;
    block[385] = 1.047099842672750e-01*G0_0_0 + 7.434082683648574e-02*G0_0_1 + 1.082329370089782e-01*G0_0_2 + 7.434082683648574e-02*G0_1_0 + 3.718672338463980e-02*G0_1_1 + 8.083219346240147e-02*G0_1_2;
    block[386] = 1.047099842672746e-01*G0_0_0 - 8.386584721220060e-02*G0_0_1 - 7.770067991422062e-02*G0_0_2 - 8.386584721220051e-02*G0_1_0 - 3.346805104617571e-01*G0_1_1 - 1.677316944244009e-01*G0_1_2;
    block[387] = -2.713978408422825e-01*G0_0_0 - 7.332960891988634e-02*G0_0_1 - 1.466592178397724e-01*G0_0_2 - 7.332960891988620e-02*G0_1_0 + 1.213461499919817e-01*G0_1_1 - 1.096029741863095e-02*G0_1_2;
    block[388] = 2.609594623483513e-02*G0_0_0 + 3.196753413767407e-02*G0_0_1 + 3.196753413767281e-02*G0_1_0 + 3.914391935225367e-02*G0_1_1;
    block[389] = 2.609594623483469e-02*G0_0_0 + 1.565756774090162e-02*G0_0_1 + 1.565756774090065e-02*G0_1_0 + 1.859336169231993e-01*G0_1_1;
    block[390] = -1.859336169231990e-01*G0_0_0 - 9.035721383811719e-02*G0_0_1 - 9.035721383811642e-02*G0_1_0 - 1.565756774090105e-01*G0_1_1;
    block[391] = 2.609594623483538e-02*G0_0_0 + 3.196753413767266e-02*G0_0_1 + 3.196753413767312e-02*G0_1_0 + 3.914391935225194e-02*G0_1_1;
    block[392] = -4.800349309897817e-03*G0_0_0 - 4.800349309897839e-03*G0_0_1 - 4.800349309897829e-03*G0_0_2 - 4.800349309897814e-03*G0_1_0 - 4.800349309897816e-03*G0_1_1 - 4.800349309897807e-03*G0_1_2;
    block[393] = 4.800349309897857e-03*G0_0_0 - 1.053101910306762e-02*G0_1_0;
    block[394] = 3.725718243947376e-02*G0_0_1 - 1.787050398161490e-02*G0_1_1;
    block[395] = 4.800349309897906e-03*G0_0_2 + 4.800349309897905e-03*G0_1_2;
    block[396] = -3.283522434998078e-02*G0_0_0 - 5.375764924375950e-03*G0_0_1 + 2.091590090722037e-02*G0_1_0 - 3.283522434998079e-02*G0_1_1;
    block[397] = 7.889456945446438e-02*G0_0_0 + 1.897827689928372e-02*G0_0_1 - 2.463457324568423e-02*G0_1_0 + 1.007173044933451e-01*G0_1_1;
    block[398] = -1.086374241756175e-01*G0_0_0 - 3.872638421249492e-02*G0_0_1 + 2.638300164341810e-02*G0_1_0 - 1.470637050064117e-01*G0_1_1;
    block[399] = 1.398220799262452e-01*G0_0_0 + 6.991103996312248e-02*G0_0_1 + 6.991103996312248e-02*G0_1_0 + 1.790964790096714e-01*G0_1_1;
    block[400] = -1.398220799262452e-01*G0_0_0 - 6.991103996312281e-02*G0_0_1 - 1.398220799262452e-01*G0_0_2 - 6.991103996312249e-02*G0_1_0 + 1.963719954171302e-02*G0_1_1 - 6.991103996312248e-02*G0_1_2;
    block[401] = 1.086374241756176e-01*G0_0_0 + 6.991103996312274e-02*G0_0_1 + 1.086374241756177e-01*G0_0_2 + 6.991103996312242e-02*G0_1_0 + 1.249343425992735e-02*G0_1_1 + 6.991103996312246e-02*G0_1_2;
    block[402] = -7.889456945446455e-02*G0_0_0 - 5.991629255518084e-02*G0_0_1 - 7.889456945446464e-02*G0_0_2 - 5.991629255518056e-02*G0_1_0 - 3.154347501135655e-02*G0_1_1 - 5.991629255518056e-02*G0_1_2;
    block[403] = 3.283522434998099e-02*G0_0_0 + 2.745945942560490e-02*G0_0_1 + 3.283522434998103e-02*G0_0_2 + 2.745945942560482e-02*G0_1_0 + 2.208369450122889e-02*G0_1_1 + 2.745945942560481e-02*G0_1_2;
    block[404] = 5.375764924376244e-03*G0_0_1 + 5.375764924376211e-03*G0_0_2 + 5.375764924375921e-03*G0_1_0 + 1.075152984875197e-02*G0_1_1 + 1.075152984875190e-02*G0_1_2;
    block[405] = 2.289919282106628e-03*G0_0_1 + 2.289919282106664e-03*G0_0_2 + 2.289919282106698e-03*G0_1_0 + 1.397437920875388e-02*G0_1_1 + 1.397437920875391e-02*G0_1_2;
    block[406] = 2.289919282106989e-03*G0_0_1 + 2.289919282107002e-03*G0_0_2 + 2.289919282106885e-03*G0_1_0 + 1.116906498850938e-02*G0_1_1 + 1.116906498850942e-02*G0_1_2;
    block[407] = 5.375764924376048e-03*G0_0_1 + 5.375764924375991e-03*G0_0_2 + 5.375764924375998e-03*G0_1_0 + 3.283522434998092e-02*G0_1_1 + 3.283522434998083e-02*G0_1_2;
    block[408] = 5.375764924376159e-03*G0_0_0 + 5.375764924376215e-03*G0_0_1 + 5.375764924375969e-03*G0_1_0 + 5.375764924376000e-03*G0_1_1;
    block[409] = 2.289919282106738e-03*G0_0_0 + 2.289919282106662e-03*G0_0_1 + 2.289919282106910e-03*G0_1_0 + 2.289919282106851e-03*G0_1_1;
    block[410] = 2.289919282106823e-03*G0_0_0 + 2.289919282106845e-03*G0_0_1 + 2.289919282106587e-03*G0_1_0 + 2.289919282106599e-03*G0_1_1;
    block[411] = 5.375764924375991e-03*G0_0_0 + 5.375764924375997e-03*G0_0_1 + 5.375764924376076e-03*G0_1_0 + 5.375764924376076e-03*G0_1_1;
    block[412] = -5.375764924375941e-03*G0_0_0 - 5.375764924375959e-03*G0_0_2 - 2.745945942560485e-02*G0_1_0 - 3.283522434998080e-02*G0_1_2;
    block[413] = -2.289919282106815e-03*G0_0_0 - 2.289919282106618e-03*G0_0_2 - 8.879145706402771e-03*G0_1_0 - 1.116906498850945e-02*G0_1_2;
    block[414] = -2.289919282106650e-03*G0_0_0 - 2.289919282106768e-03*G0_0_2 - 1.168445992664707e-02*G0_1_0 - 1.397437920875382e-02*G0_1_2;
    block[415] = -5.375764924375994e-03*G0_0_0 - 5.375764924375952e-03*G0_0_2 - 5.375764924376071e-03*G0_1_0 - 1.075152984875209e-02*G0_1_2;
    block[416] = 6.991103996312233e-02*G0_0_1 + 1.398220799262452e-01*G0_0_2 + 8.954823950483548e-02*G0_1_1 + 6.991103996312240e-02*G0_1_2;
    block[417] = -3.872638421249473e-02*G0_0_1 - 1.086374241756175e-01*G0_0_2 - 5.741760570319524e-02*G0_1_1 - 6.991103996312266e-02*G0_1_2;
    block[418] = 1.897827689928366e-02*G0_0_1 + 7.889456945446464e-02*G0_0_2 + 2.837281754382403e-02*G0_1_1 + 5.991629255518081e-02*G0_1_2;
    block[419] = -5.375764924375985e-03*G0_0_1 - 3.283522434998112e-02*G0_0_2 - 5.375764924376061e-03*G0_1_1 - 2.745945942560518e-02*G0_1_2;
    block[420] = 1.187365553684992e-02*G0_0_0 - 9.394540644540579e-03*G0_0_1 + 1.187365553685002e-02*G0_0_2 + 2.648738542835739e-02*G0_1_0 - 6.413078787210656e-02*G0_1_1 + 4.775558160974813e-02*G0_1_2;
    block[421] = 2.544354757896427e-03*G0_0_0 - 3.294613212147779e-03*G0_0_1 + 2.544354757896196e-03*G0_0_2 + 8.448562593527957e-03*G0_1_0 - 2.926007971580861e-02*G0_1_1 + 1.428753056357189e-02*G0_1_2;
    block[422] = 1.187365553684981e-02*G0_0_0 - 9.394540644540501e-03*G0_0_1 + 1.187365553685005e-02*G0_0_2 + 2.126819618139003e-02*G0_1_0 - 1.878908128908111e-02*G0_1_1 + 4.253639236278079e-02*G0_1_2;
    block[423] = -4.296045148909666e-02*G0_0_0 - 6.850185886640501e-04*G0_0_1 - 4.296045148909652e-02*G0_0_2 - 7.045905483405045e-03*G0_1_0 + 1.273155976932011e-01*G0_1_1 - 4.932133838383762e-02*G0_1_2;
    block[424] = -4.296045148909678e-02*G0_0_0 - 6.850185886646700e-04*G0_0_1 - 4.296045148909704e-02*G0_0_2 - 4.227543290043267e-02*G0_1_0 + 4.397166940569644e-02*G0_1_1 - 8.455086580086514e-02*G0_1_2;
    block[425] = 1.247386230025101e-01*G0_0_0 + 2.844458139596963e-02*G0_0_1 + 1.247386230025101e-01*G0_0_2 + 9.629404160653994e-02*G0_1_0 - 6.445698720004259e-02*G0_1_1 + 1.925880832130807e-01*G0_1_2;
    block[426] = -1.247386230025102e-01*G0_0_0 - 9.629404160654044e-02*G0_0_1 - 9.629404160654004e-02*G0_1_0 - 1.285225352065611e-01*G0_1_1;
    block[427] = 4.296045148909679e-02*G0_0_0 + 4.227543290043232e-02*G0_0_1 + 4.227543290043267e-02*G0_1_0 + 6.426126760328081e-02*G0_1_1;
    block[428] = -1.187365553684976e-02*G0_0_0 - 2.126819618139052e-02*G0_0_1 - 2.126819618138999e-02*G0_1_0 - 3.066273682593068e-02*G0_1_1;
    block[429] = 4.296045148909632e-02*G0_0_0 + 4.227543290043252e-02*G0_0_1 + 4.227543290043159e-02*G0_1_0 + 6.426126760328037e-02*G0_1_1;
    block[430] = -2.544354757896320e-03*G0_0_0 - 5.838967970044170e-03*G0_0_1 - 5.838967970044561e-03*G0_1_0 - 9.133581182192336e-03*G0_1_1;
    block[431] = -1.187365553684940e-02*G0_0_0 - 2.126819618139072e-02*G0_0_1 - 2.126819618138974e-02*G0_1_0 - 3.066273682593079e-02*G0_1_1;
    block[432] = 9.394540644540483e-03*G0_0_1 + 9.394540644540492e-03*G0_1_0 + 1.878908128908105e-02*G0_1_1;
    block[433] = 3.294613212147850e-03*G0_0_1 + 3.294613212147543e-03*G0_1_0 + 2.926007971580866e-02*G0_1_1;
    block[434] = 9.394540644540457e-03*G0_0_1 + 9.394540644540457e-03*G0_1_0 + 6.413078787210655e-02*G0_1_1;
    block[435] = 3.294613212148299e-03*G0_0_1 + 3.294613212148256e-03*G0_1_0 + 6.589226424296245e-03*G0_1_1;
    block[436] = 3.294613212148090e-03*G0_0_1 + 3.294613212147833e-03*G0_1_0 + 2.926007971580865e-02*G0_1_1;
    block[437] = 9.394540644540997e-03*G0_0_1 + 9.394540644540579e-03*G0_1_0 + 1.878908128908150e-02*G0_1_1;
    block[438] = -2.126819618139057e-02*G0_0_1 - 1.187365553684940e-02*G0_0_2 - 2.126819618139012e-02*G0_1_0 - 6.132547365186160e-02*G0_1_1 - 4.253639236278027e-02*G0_1_2;
    block[439] = -5.838967970044272e-03*G0_0_1 - 2.544354757896486e-03*G0_0_2 - 5.838967970044557e-03*G0_1_0 - 4.354761027938057e-02*G0_1_1 - 1.428753056357241e-02*G0_1_2;
    block[440] = -2.126819618139085e-02*G0_0_1 - 1.187365553685005e-02*G0_0_2 - 2.126819618139053e-02*G0_1_0 - 1.118863694818546e-01*G0_1_1 - 4.775558160974815e-02*G0_1_2;
    block[441] = 4.227543290043210e-02*G0_0_1 + 4.296045148909618e-02*G0_0_2 + 4.227543290043204e-02*G0_1_0 + 1.285225352065609e-01*G0_1_1 + 8.455086580086421e-02*G0_1_2;
    block[442] = 4.227543290043256e-02*G0_0_1 + 4.296045148909667e-02*G0_0_2 + 4.227543290043285e-02*G0_1_0 + 1.766369360770386e-01*G0_1_1 + 4.932133838383778e-02*G0_1_2;
    block[443] = -9.629404160654007e-02*G0_0_1 - 1.247386230025102e-01*G0_0_2 - 9.629404160654055e-02*G0_1_0 - 2.570450704131226e-01*G0_1_1 - 1.925880832130808e-01*G0_1_2;
    block[444] = -2.609594623484587e-03*G0_0_1 - 2.609594623484046e-03*G0_1_0 - 5.056089582999348e-02*G0_1_1;
    block[445] = -2.609594623484040e-03*G0_0_1 - 2.609594623483667e-03*G0_1_0 - 1.565756774090098e-01*G0_1_1;
    block[446] = -3.522952741702595e-02*G0_0_1 - 3.522952741702644e-02*G0_1_0 + 9.622880174095456e-02*G0_1_1;
    block[447] = -2.609594623483696e-03*G0_0_1 - 2.609594623483313e-03*G0_1_0 - 5.056089582999258e-02*G0_1_1;
    block[448] = 4.800349309897816e-03*G0_0_0 + 4.800349309897836e-03*G0_0_1 + 4.800349309897828e-03*G0_0_2 + 1.533136841296544e-02*G0_1_0 + 1.533136841296543e-02*G0_1_1 + 1.533136841296544e-02*G0_1_2 + 4.800349309897816e-03*G0_2_0 + 4.800349309897836e-03*G0_2_1 + 4.800349309897828e-03*G0_2_2;
    block[449] = -4.800349309897850e-03*G0_0_0 - 4.800349309897848e-03*G0_2_0;
    block[450] = -3.725718243947375e-02*G0_0_1 - 5.512768642108868e-02*G0_1_1 - 3.725718243947374e-02*G0_2_1;
    block[451] = -4.800349309897906e-03*G0_0_2 - 4.800349309897904e-03*G0_2_2;
    block[452] = 3.283522434998074e-02*G0_0_0 + 5.375764924375942e-03*G0_0_1 + 5.375764924375844e-03*G0_1_0 + 3.283522434998074e-02*G0_2_0 + 5.375764924375924e-03*G0_2_1;
    block[453] = -7.889456945446430e-02*G0_0_0 - 1.897827689928369e-02*G0_0_1 - 1.897827689928369e-02*G0_1_0 + 9.394540644540410e-03*G0_1_1 - 7.889456945446428e-02*G0_2_0 - 1.897827689928371e-02*G0_2_1;
    block[454] = 1.086374241756174e-01*G0_0_0 + 3.872638421249493e-02*G0_0_1 + 3.872638421249500e-02*G0_1_0 - 1.869122149070034e-02*G0_1_1 + 1.086374241756174e-01*G0_2_0 + 3.872638421249494e-02*G0_2_1;
    block[455] = -1.398220799262452e-01*G0_0_0 - 6.991103996312249e-02*G0_0_1 - 6.991103996312280e-02*G0_1_0 + 1.963719954171302e-02*G0_1_1 - 1.398220799262452e-01*G0_2_0 - 6.991103996312246e-02*G0_2_1;
    block[456] = 1.398220799262452e-01*G0_0_0 + 6.991103996312280e-02*G0_0_1 + 1.398220799262451e-01*G0_0_2 + 6.991103996312280e-02*G0_1_0 + 1.790964790096718e-01*G0_1_1 + 6.991103996312278e-02*G0_1_2 + 1.398220799262451e-01*G0_2_0 + 6.991103996312280e-02*G0_2_1 + 1.398220799262451e-01*G0_2_2;
    block[457] = -1.086374241756176e-01*G0_0_0 - 6.991103996312274e-02*G0_0_1 - 1.086374241756177e-01*G0_0_2 - 1.350204258190359e-01*G0_1_0 - 2.433577466129525e-01*G0_1_1 - 1.350204258190359e-01*G0_1_2 - 1.086374241756177e-01*G0_2_0 - 6.991103996312277e-02*G0_2_1 - 1.086374241756177e-01*G0_2_2;
    block[458] = 7.889456945446453e-02*G0_0_0 + 5.991629255518085e-02*G0_0_1 + 7.889456945446463e-02*G0_0_2 + 1.035291427001490e-01*G0_1_0 + 1.852681702942102e-01*G0_1_1 + 1.035291427001490e-01*G0_1_2 + 7.889456945446463e-02*G0_2_0 + 5.991629255518086e-02*G0_2_1 + 7.889456945446471e-02*G0_2_2;
    block[459] = -3.283522434998100e-02*G0_0_0 - 2.745945942560490e-02*G0_0_1 - 3.283522434998103e-02*G0_0_2 - 5.375112525720135e-02*G0_1_0 - 8.121058468280599e-02*G0_1_1 - 5.375112525720138e-02*G0_1_2 - 3.283522434998101e-02*G0_2_0 - 2.745945942560490e-02*G0_2_1 - 3.283522434998105e-02*G0_2_2;
    block[460] = -5.375764924376231e-03*G0_0_1 - 5.375764924376195e-03*G0_0_2 - 5.375764924375998e-03*G0_1_0 + 2.208369450122872e-02*G0_1_1 + 2.208369450122872e-02*G0_1_2 - 5.375764924376246e-03*G0_2_1 - 5.375764924376207e-03*G0_2_2;
    block[461] = -2.289919282106640e-03*G0_0_1 - 2.289919282106675e-03*G0_0_2 - 2.289919282106579e-03*G0_1_0 + 6.589226424295894e-03*G0_1_1 + 6.589226424295856e-03*G0_1_2 - 2.289919282106621e-03*G0_2_1 - 2.289919282106655e-03*G0_2_2;
    block[462] = -2.289919282106981e-03*G0_0_1 - 2.289919282106995e-03*G0_0_2 - 2.289919282106992e-03*G0_1_0 + 9.394540644540201e-03*G0_1_1 + 9.394540644540216e-03*G0_1_2 - 2.289919282107020e-03*G0_2_1 - 2.289919282107031e-03*G0_2_2;
    block[463] = -5.375764924376041e-03*G0_0_1 - 5.375764924375985e-03*G0_0_2 - 5.375764924375891e-03*G0_1_0 - 5.375764924376023e-03*G0_2_1 - 5.375764924375965e-03*G0_2_2;
    block[464] = -5.375764924376139e-03*G0_0_0 - 5.375764924376194e-03*G0_0_1 + 2.208369450122879e-02*G0_1_0 + 2.208369450122883e-02*G0_1_1 - 5.375764924375896e-03*G0_1_2 - 5.375764924376168e-03*G0_2_0 - 5.375764924376223e-03*G0_2_1;
    block[465] = -2.289919282106746e-03*G0_0_0 - 2.289919282106671e-03*G0_0_1 + 6.589226424296022e-03*G0_1_0 + 6.589226424296011e-03*G0_1_1 - 2.289919282106810e-03*G0_1_2 - 2.289919282106770e-03*G0_2_0 - 2.289919282106695e-03*G0_2_1;
    block[466] = -2.289919282106805e-03*G0_0_0 - 2.289919282106822e-03*G0_0_1 + 9.394540644540230e-03*G0_1_0 + 9.394540644540234e-03*G0_1_1 - 2.289919282106743e-03*G0_1_2 - 2.289919282106793e-03*G0_2_0 - 2.289919282106811e-03*G0_2_1;
    block[467] = -5.375764924375991e-03*G0_0_0 - 5.375764924375996e-03*G0_0_1 - 5.375764924376015e-03*G0_1_2 - 5.375764924376003e-03*G0_2_0 - 5.375764924376006e-03*G0_2_1;
    block[468] = 5.375764924375953e-03*G0_0_0 + 5.375764924375955e-03*G0_0_2 + 5.375764924375913e-03*G0_2_0 + 5.375764924375936e-03*G0_2_2;
    block[469] = 2.289919282106795e-03*G0_0_0 + 2.289919282106622e-03*G0_0_2 + 2.289919282106829e-03*G0_2_0 + 2.289919282106636e-03*G0_2_2;
    block[470] = 2.289919282106670e-03*G0_0_0 + 2.289919282106781e-03*G0_0_2 + 2.289919282106623e-03*G0_2_0 + 2.289919282106740e-03*G0_2_2;
    block[471] = 5.375764924375995e-03*G0_0_0 + 5.375764924375957e-03*G0_0_2 + 5.375764924376004e-03*G0_2_0 + 5.375764924375965e-03*G0_2_2;
    block[472] = -6.991103996312230e-02*G0_0_1 - 1.398220799262451e-01*G0_0_2 + 1.963719954171307e-02*G0_1_1 - 6.991103996312278e-02*G0_1_2 - 6.991103996312230e-02*G0_2_1 - 1.398220799262451e-01*G0_2_2;
    block[473] = 3.872638421249473e-02*G0_0_1 + 1.086374241756175e-01*G0_0_2 - 1.869122149070043e-02*G0_1_1 + 3.872638421249495e-02*G0_1_2 + 3.872638421249467e-02*G0_2_1 + 1.086374241756174e-01*G0_2_2;
    block[474] = -1.897827689928366e-02*G0_0_1 - 7.889456945446464e-02*G0_0_2 + 9.394540644540355e-03*G0_1_1 - 1.897827689928389e-02*G0_1_2 - 1.897827689928364e-02*G0_2_1 - 7.889456945446459e-02*G0_2_2;
    block[475] = 5.375764924375985e-03*G0_0_1 + 3.283522434998112e-02*G0_0_2 + 5.375764924375964e-03*G0_1_2 + 5.375764924375996e-03*G0_2_1 + 3.283522434998110e-02*G0_2_2;
    block[476] = -1.187365553684989e-02*G0_0_0 + 9.394540644540577e-03*G0_0_1 - 1.187365553685000e-02*G0_0_2 + 9.394540644540452e-03*G0_1_0 + 9.394540644540327e-03*G0_1_2 - 1.187365553684991e-02*G0_2_0 + 9.394540644540553e-03*G0_2_1 - 1.187365553685006e-02*G0_2_2;
    block[477] = -2.544354757896321e-03*G0_0_0 + 3.294613212147828e-03*G0_0_1 - 2.544354757896163e-03*G0_0_2 + 3.294613212148048e-03*G0_1_0 + 3.294613212148094e-03*G0_1_2 - 2.544354757896370e-03*G0_2_0 + 3.294613212147789e-03*G0_2_1 - 2.544354757896126e-03*G0_2_2;
    block[478] = -1.187365553684981e-02*G0_0_0 + 9.394540644540520e-03*G0_0_1 - 1.187365553685000e-02*G0_0_2 + 9.394540644540272e-03*G0_1_0 + 9.394540644540351e-03*G0_1_2 - 1.187365553684977e-02*G0_2_0 + 9.394540644540483e-03*G0_2_1 - 1.187365553685003e-02*G0_2_2;
    block[479] = 4.296045148909659e-02*G0_0_0 + 6.850185886640750e-04*G0_0_1 + 4.296045148909653e-02*G0_0_2 + 6.850185886644988e-04*G0_1_0 + 2.267085329151262e-02*G0_1_1 + 6.850185886642233e-04*G0_1_2 + 4.296045148909668e-02*G0_2_0 + 6.850185886641148e-04*G0_2_1 + 4.296045148909655e-02*G0_2_2;
    block[480] = 4.296045148909678e-02*G0_0_0 + 6.850185886647041e-04*G0_0_1 + 4.296045148909705e-02*G0_0_2 + 6.850185886641489e-04*G0_1_0 + 2.267085329151269e-02*G0_1_1 + 6.850185886643816e-04*G0_1_2 + 4.296045148909673e-02*G0_2_0 + 6.850185886647385e-04*G0_2_1 + 4.296045148909700e-02*G0_2_2;
    block[481] = -1.247386230025101e-01*G0_0_0 - 2.844458139596967e-02*G0_0_1 - 1.247386230025101e-01*G0_0_2 - 2.844458139597016e-02*G0_1_0 - 6.067307499599099e-02*G0_1_1 - 2.844458139597000e-02*G0_1_2 - 1.247386230025101e-01*G0_2_0 - 2.844458139596970e-02*G0_2_1 - 1.247386230025101e-01*G0_2_2;
    block[482] = 1.247386230025102e-01*G0_0_0 + 9.629404160654050e-02*G0_0_1 + 2.844458139597023e-02*G0_1_0 - 6.445698720004180e-02*G0_1_1 + 9.629404160654111e-02*G0_1_2 + 1.247386230025102e-01*G0_2_0 + 9.629404160654050e-02*G0_2_1;
    block[483] = -4.296045148909679e-02*G0_0_0 - 4.227543290043236e-02*G0_0_1 - 6.850185886641791e-04*G0_1_0 + 4.397166940569679e-02*G0_1_1 - 4.227543290043231e-02*G0_1_2 - 4.296045148909675e-02*G0_2_0 - 4.227543290043227e-02*G0_2_1;
    block[484] = 1.187365553684976e-02*G0_0_0 + 2.126819618139052e-02*G0_0_1 - 9.394540644540287e-03*G0_1_0 - 1.878908128908055e-02*G0_1_1 + 2.126819618139064e-02*G0_1_2 + 1.187365553684973e-02*G0_2_0 + 2.126819618139048e-02*G0_2_1;
    block[485] = -4.296045148909644e-02*G0_0_0 - 4.227543290043260e-02*G0_0_1 - 3.591454600569168e-02*G0_1_0 + 9.208607027617334e-02*G0_1_1 - 4.227543290043304e-02*G0_1_2 - 4.296045148909646e-02*G0_2_0 - 4.227543290043267e-02*G0_2_1;
    block[486] = 2.544354757896407e-03*G0_0_0 + 5.838967970044209e-03*G0_0_1 - 5.904207835631720e-03*G0_1_0 - 3.186967433929246e-02*G0_1_1 + 5.838967970044232e-03*G0_1_2 + 2.544354757896354e-03*G0_2_0 + 5.838967970044209e-03*G0_2_1;
    block[487] = 1.187365553684942e-02*G0_0_0 + 2.126819618139071e-02*G0_0_1 - 1.461372989150762e-02*G0_1_0 - 6.934997711907336e-02*G0_1_1 + 2.126819618139067e-02*G0_1_2 + 1.187365553684940e-02*G0_2_0 + 2.126819618139076e-02*G0_2_1;
    block[488] = -9.394540644540504e-03*G0_0_1 - 9.394540644540240e-03*G0_1_0 - 9.394540644540142e-03*G0_1_2 - 9.394540644540469e-03*G0_2_1;
    block[489] = -3.294613212147900e-03*G0_0_1 - 3.294613212148293e-03*G0_1_0 - 3.294613212148331e-03*G0_1_2 - 3.294613212147860e-03*G0_2_1;
    block[490] = -9.394540644540461e-03*G0_0_1 - 9.394540644540308e-03*G0_1_0 - 9.394540644540393e-03*G0_1_2 - 9.394540644540428e-03*G0_2_1;
    block[491] = -3.294613212148248e-03*G0_0_1 - 3.294613212147816e-03*G0_1_0 + 2.267085329151283e-02*G0_1_1 - 3.294613212148294e-03*G0_1_2 - 3.294613212148261e-03*G0_2_1;
    block[492] = -3.294613212148063e-03*G0_0_1 - 3.294613212147885e-03*G0_1_0 + 2.267085329151285e-02*G0_1_1 - 3.294613212147477e-03*G0_1_2 - 3.294613212148070e-03*G0_2_1;
    block[493] = -9.394540644541005e-03*G0_0_1 - 9.394540644540548e-03*G0_1_0 + 4.534170658302528e-02*G0_1_1 - 9.394540644540209e-03*G0_1_2 - 9.394540644541031e-03*G0_2_1;
    block[494] = 2.126819618139056e-02*G0_0_1 + 1.187365553684939e-02*G0_0_2 + 2.126819618139040e-02*G0_1_0 - 6.934997711907330e-02*G0_1_1 - 1.461372989150780e-02*G0_1_2 + 2.126819618139063e-02*G0_2_1 + 1.187365553684946e-02*G0_2_2;
    block[495] = 5.838967970044309e-03*G0_0_1 + 2.544354757896544e-03*G0_0_2 + 5.838967970044275e-03*G0_1_0 - 3.186967433929210e-02*G0_1_1 - 5.904207835631661e-03*G0_1_2 + 5.838967970044321e-03*G0_2_1 + 2.544354757896538e-03*G0_2_2;
    block[496] = 2.126819618139081e-02*G0_0_1 + 1.187365553685003e-02*G0_0_2 + 2.126819618139088e-02*G0_1_0 - 1.878908128908064e-02*G0_1_1 - 9.394540644540261e-03*G0_1_2 + 2.126819618139087e-02*G0_2_1 + 1.187365553685009e-02*G0_2_2;
    block[497] = -4.227543290043213e-02*G0_0_1 - 4.296045148909621e-02*G0_0_2 - 4.227543290043254e-02*G0_1_0 + 9.208607027617348e-02*G0_1_1 - 3.591454600569142e-02*G0_1_2 - 4.227543290043222e-02*G0_2_1 - 4.296045148909619e-02*G0_2_2;
    block[498] = -4.227543290043259e-02*G0_0_1 - 4.296045148909670e-02*G0_0_2 - 4.227543290043286e-02*G0_1_0 + 4.397166940569655e-02*G0_1_1 - 6.850185886643732e-04*G0_1_2 - 4.227543290043263e-02*G0_2_1 - 4.296045148909668e-02*G0_2_2;
    block[499] = 9.629404160654007e-02*G0_0_1 + 1.247386230025102e-01*G0_0_2 + 9.629404160654105e-02*G0_1_0 - 6.445698720004196e-02*G0_1_1 + 2.844458139597012e-02*G0_1_2 + 9.629404160654012e-02*G0_2_1 + 1.247386230025102e-01*G0_2_2;
    block[500] = 2.609594623484570e-03*G0_0_1 + 2.609594623483984e-03*G0_1_0 - 1.513564881620419e-01*G0_1_1 + 2.609594623483909e-03*G0_1_2 + 2.609594623484651e-03*G0_2_1;
    block[501] = 2.609594623483990e-03*G0_0_1 + 2.609594623483231e-03*G0_1_0 - 4.534170658302551e-02*G0_1_1 + 2.609594623483560e-03*G0_1_2 + 2.609594623483958e-03*G0_2_1;
    block[502] = 3.522952741702601e-02*G0_0_1 + 3.522952741702705e-02*G0_1_0 + 1.666878565750074e-01*G0_1_1 + 3.522952741702683e-02*G0_1_2 + 3.522952741702598e-02*G0_2_1;
    block[503] = 2.609594623483623e-03*G0_0_1 + 2.609594623483676e-03*G0_1_0 - 4.534170658302550e-02*G0_1_1 + 2.609594623483521e-03*G0_1_2 + 2.609594623483598e-03*G0_2_1;
    block[504] = -1.555448875327324e-02*G0_0_0 - 1.555448875327328e-02*G0_0_1 - 1.555448875327326e-02*G0_0_2 - 3.881772002431679e-02*G0_1_0 - 3.881772002431676e-02*G0_1_1 - 3.881772002431677e-02*G0_1_2 - 1.555448875327325e-02*G0_2_0 - 1.555448875327328e-02*G0_2_1 - 1.555448875327326e-02*G0_2_2;
    block[505] = -3.365072266981974e-03*G0_0_0 - 3.365072266982005e-03*G0_2_0;
    block[506] = 3.365855145369005e-02*G0_0_1 + 5.512768642108869e-02*G0_1_1 + 3.365855145369006e-02*G0_2_1;
    block[507] = -3.365072266981961e-03*G0_0_2 - 3.365072266981962e-03*G0_2_2;
    block[508] = 1.116906498850957e-02*G0_0_0 + 2.289919282106863e-03*G0_0_1 + 2.289919282106909e-03*G0_1_0 + 1.116906498850951e-02*G0_2_0 + 2.289919282106778e-03*G0_2_1;
    block[509] = -5.232237220084616e-03*G0_0_0 + 5.480148709315269e-04*G0_0_1 + 5.480148709315741e-04*G0_1_0 + 6.523986558712664e-05*G0_1_1 - 5.232237220084483e-03*G0_2_0 + 5.480148709316294e-04*G0_2_1;
    block[510] = -9.603308214419204e-03*G0_0_0 - 4.801654107209520e-03*G0_0_1 - 4.801654107209743e-03*G0_1_0 + 2.609594623482483e-04*G0_1_1 - 9.603308214419331e-03*G0_2_0 - 4.801654107209632e-03*G0_2_1;
    block[511] = 1.086374241756176e-01*G0_0_0 + 6.991103996312241e-02*G0_0_1 + 6.991103996312274e-02*G0_1_0 + 1.249343425992735e-02*G0_1_1 + 1.086374241756177e-01*G0_2_0 + 6.991103996312245e-02*G0_2_1;
    block[512] = -1.086374241756176e-01*G0_0_0 - 1.350204258190359e-01*G0_0_1 - 1.086374241756176e-01*G0_0_2 - 6.991103996312276e-02*G0_1_0 - 2.433577466129525e-01*G0_1_1 - 6.991103996312278e-02*G0_1_2 - 1.086374241756177e-01*G0_2_0 - 1.350204258190359e-01*G0_2_1 - 1.086374241756177e-01*G0_2_2;
    block[513] = 2.810011490567021e-01*G0_0_0 + 2.028698860296066e-01*G0_0_1 + 2.810011490567023e-01*G0_0_2 + 2.028698860296066e-01*G0_1_0 + 4.289651642082155e-01*G0_1_1 + 2.028698860296067e-01*G0_1_2 + 2.810011490567023e-01*G0_2_0 + 2.028698860296067e-01*G0_2_1 + 2.810011490567024e-01*G0_2_2;
    block[514] = -2.041877313144654e-01*G0_0_0 - 1.676925505050487e-01*G0_0_1 - 2.041877313144655e-01*G0_0_2 - 2.194930037811964e-01*G0_1_0 - 3.871855542862447e-01*G0_1_1 - 2.194930037811965e-01*G0_1_2 - 2.041877313144655e-01*G0_2_0 - 1.676925505050488e-01*G0_2_1 - 2.041877313144657e-01*G0_2_2;
    block[515] = 1.007173044933450e-01*G0_0_0 + 8.173902759406133e-02*G0_0_1 + 1.007173044933450e-01*G0_0_2 + 1.253518777390295e-01*G0_1_0 + 1.852681702942099e-01*G0_1_1 + 1.253518777390294e-01*G0_1_2 + 1.007173044933451e-01*G0_2_0 + 8.173902759406136e-02*G0_2_1 + 1.007173044933451e-01*G0_2_2;
    block[516] = 9.394540644540482e-03*G0_0_0 + 2.837281754382434e-02*G0_0_1 + 2.837281754382432e-02*G0_0_2 + 2.837281754382420e-02*G0_1_0 - 3.154347501135633e-02*G0_1_1 - 3.154347501135633e-02*G0_1_2 + 9.394540644540469e-03*G0_2_0 + 2.837281754382432e-02*G0_2_1 + 2.837281754382430e-02*G0_2_2;
    block[517] = 6.523986558683481e-05*G0_0_0 - 4.827750053445867e-04*G0_0_1 - 4.827750053445688e-04*G0_0_2 - 4.827750053446507e-04*G0_1_0 - 6.263027096360540e-03*G0_1_1 - 6.263027096360498e-03*G0_1_2 + 6.523986558688929e-05*G0_2_0 - 4.827750053445398e-04*G0_2_1 - 4.827750053445221e-04*G0_2_2;
    block[518] = 6.523986558751321e-05*G0_0_0 + 1.321759676794404e-02*G0_0_1 + 1.321759676794407e-02*G0_0_2 + 1.321759676794415e-02*G0_1_0 + 6.523986558749708e-05*G0_1_1 + 6.523986558746672e-05*G0_1_2 + 6.523986558743759e-05*G0_2_0 + 1.321759676794400e-02*G0_2_1 + 1.321759676794404e-02*G0_2_2;
    block[519] = 9.394540644540468e-03*G0_0_0 - 2.289919282106732e-03*G0_0_1 - 2.289919282106755e-03*G0_0_2 - 2.289919282106892e-03*G0_1_0 + 9.394540644540537e-03*G0_2_0 - 2.289919282106652e-03*G0_2_1 - 2.289919282106673e-03*G0_2_2;
    block[520] = 2.837281754382430e-02*G0_0_0 + 2.837281754382434e-02*G0_0_1 + 9.394540644540548e-03*G0_0_2 - 3.154347501135630e-02*G0_1_0 - 3.154347501135635e-02*G0_1_1 + 2.837281754382414e-02*G0_1_2 + 2.837281754382431e-02*G0_2_0 + 2.837281754382435e-02*G0_2_1 + 9.394540644540563e-03*G0_2_2;
    block[521] = -4.827750053445285e-04*G0_0_0 - 4.827750053445613e-04*G0_0_1 + 6.523986558701697e-05*G0_0_2 - 6.263027096360723e-03*G0_1_0 - 6.263027096360677e-03*G0_1_1 - 4.827750053445486e-04*G0_1_2 - 4.827750053444798e-04*G0_2_0 - 4.827750053445117e-04*G0_2_1 + 6.523986558699096e-05*G0_2_2;
    block[522] = 1.321759676794397e-02*G0_0_0 + 1.321759676794397e-02*G0_0_1 + 6.523986558714637e-05*G0_0_2 + 6.523986558755075e-05*G0_1_0 + 6.523986558753884e-05*G0_1_1 + 1.321759676794399e-02*G0_1_2 + 1.321759676794397e-02*G0_2_0 + 1.321759676794397e-02*G0_2_1 + 6.523986558718831e-05*G0_2_2;
    block[523] = -2.289919282106804e-03*G0_0_0 - 2.289919282106807e-03*G0_0_1 + 9.394540644540535e-03*G0_0_2 - 2.289919282106828e-03*G0_1_2 - 2.289919282106795e-03*G0_2_0 - 2.289919282106795e-03*G0_2_1 + 9.394540644540518e-03*G0_2_2;
    block[524] = 2.289919282106792e-03*G0_0_0 + 2.289919282106825e-03*G0_0_2 + 2.289919282106758e-03*G0_2_0 + 2.289919282106740e-03*G0_2_2;
    block[525] = 1.787572317086225e-03*G0_0_0 + 1.787572317086238e-03*G0_0_2 + 1.787572317086194e-03*G0_2_0 + 1.787572317086256e-03*G0_2_2;
    block[526] = 1.787572317086215e-03*G0_0_0 + 1.787572317086206e-03*G0_0_2 + 1.787572317086225e-03*G0_2_0 + 1.787572317086175e-03*G0_2_2;
    block[527] = 2.289919282106801e-03*G0_0_0 + 2.289919282106795e-03*G0_0_2 + 2.289919282106790e-03*G0_2_0 + 2.289919282106802e-03*G0_2_2;
    block[528] = 6.991103996312251e-02*G0_0_1 + 1.086374241756175e-01*G0_0_2 + 1.249343425992737e-02*G0_1_1 + 6.991103996312273e-02*G0_1_2 + 6.991103996312255e-02*G0_2_1 + 1.086374241756175e-01*G0_2_2;
    block[529] = -4.801654107209456e-03*G0_0_1 - 9.603308214418968e-03*G0_0_2 + 2.609594623482745e-04*G0_1_1 - 4.801654107209566e-03*G0_1_2 - 4.801654107209415e-03*G0_2_1 - 9.603308214418916e-03*G0_2_2;
    block[530] = 5.480148709315866e-04*G0_0_1 - 5.232237220084469e-03*G0_0_2 + 6.523986558724102e-05*G0_1_1 + 5.480148709316611e-04*G0_1_2 + 5.480148709315871e-04*G0_2_1 - 5.232237220084507e-03*G0_2_2;
    block[531] = 2.289919282106804e-03*G0_0_1 + 1.116906498850944e-02*G0_0_2 + 2.289919282106853e-03*G0_1_2 + 2.289919282106795e-03*G0_2_1 + 1.116906498850941e-02*G0_2_2;
    block[532] = -1.174317580567435e-03*G0_0_0 + 6.523986558720843e-05*G0_0_1 - 1.174317580567442e-03*G0_0_2 + 6.523986558728109e-05*G0_1_0 + 6.523986558740662e-05*G0_1_2 - 1.174317580567490e-03*G0_2_0 + 6.523986558703997e-05*G0_2_1 - 1.174317580567531e-03*G0_2_2;
    block[533] = -1.050361835952133e-02*G0_0_0 + 2.576974690689921e-03*G0_0_1 - 1.050361835952138e-02*G0_0_2 + 2.576974690689699e-03*G0_1_0 + 2.576974690689829e-03*G0_1_2 - 1.050361835952127e-02*G0_2_0 + 2.576974690689941e-03*G0_2_1 - 1.050361835952137e-02*G0_2_2;
    block[534] = -1.174317580567357e-03*G0_0_0 + 6.523986558726414e-05*G0_0_1 - 1.174317580567442e-03*G0_0_2 + 6.523986558743519e-05*G0_1_0 + 6.523986558713600e-05*G0_1_2 - 1.174317580567396e-03*G0_2_0 + 6.523986558724372e-05*G0_2_1 - 1.174317580567450e-03*G0_2_2;
    block[535] = 3.522952741702808e-03*G0_0_0 - 2.968413884212434e-03*G0_0_1 + 3.522952741703036e-03*G0_0_2 - 2.968413884212625e-03*G0_1_0 - 6.523986558707380e-04*G0_1_1 - 2.968413884212294e-03*G0_1_2 + 3.522952741702665e-03*G0_2_0 - 2.968413884212360e-03*G0_2_1 + 3.522952741703050e-03*G0_2_2;
    block[536] = 3.522952741702881e-03*G0_0_0 - 2.968413884212612e-03*G0_0_1 + 3.522952741702944e-03*G0_0_2 - 2.968413884212317e-03*G0_1_0 - 6.523986558708152e-04*G0_1_1 - 2.968413884212382e-03*G0_1_2 + 3.522952741702990e-03*G0_2_0 - 2.968413884212550e-03*G0_2_1 + 3.522952741703044e-03*G0_2_2;
    block[537] = 1.247386230025105e-01*G0_0_0 + 6.236931150125530e-02*G0_0_1 + 1.247386230025102e-01*G0_0_2 + 6.236931150125540e-02*G0_1_0 + 4.762510187857340e-02*G0_1_1 + 6.236931150125502e-02*G0_1_2 + 1.247386230025106e-01*G0_2_0 + 6.236931150125521e-02*G0_2_1 + 1.247386230025101e-01*G0_2_2;
    block[538] = -1.247386230025107e-01*G0_0_0 - 1.980682319223968e-01*G0_0_1 - 2.713978408422831e-01*G0_0_2 - 6.236931150125549e-02*G0_1_0 - 3.392473010529002e-03*G0_1_1 - 1.980682319223971e-01*G0_1_2 - 1.247386230025107e-01*G0_2_0 - 1.980682319223969e-01*G0_2_1 - 2.713978408422834e-01*G0_2_2;
    block[539] = -3.522952741702918e-03*G0_0_0 + 3.036915743078915e-02*G0_0_1 + 1.047099842672752e-01*G0_0_2 + 2.968413884212321e-03*G0_1_0 - 6.784946021056930e-03*G0_1_1 + 3.036915743078886e-02*G0_1_2 - 3.522952741703004e-03*G0_2_0 + 3.036915743078906e-02*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[540] = 1.174317580567387e-03*G0_0_0 - 1.376561163887557e-02*G0_0_1 - 5.284429112554070e-02*G0_0_2 - 6.523986558739977e-05*G0_1_0 - 1.304797311748511e-04*G0_1_1 - 1.376561163887559e-02*G0_1_2 + 1.174317580567423e-03*G0_2_0 - 1.376561163887557e-02*G0_2_1 - 5.284429112554073e-02*G0_2_2;
    block[541] = 1.824106641814954e-01*G0_0_0 + 1.885758314794757e-01*G0_0_1 + 1.047099842672751e-01*G0_0_2 + 9.854481696929535e-02*G0_1_0 - 6.223883177008094e-02*G0_1_1 + 1.885758314794760e-01*G0_1_2 + 1.824106641814955e-01*G0_2_0 + 1.885758314794758e-01*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[542] = -1.559232787531395e-02*G0_0_0 - 2.508472831823510e-02*G0_0_1 - 6.197787230773567e-03*G0_0_2 + 3.294613212148270e-03*G0_1_0 + 1.278701365506943e-02*G0_1_1 - 2.508472831823502e-02*G0_1_2 - 1.559232787531382e-02*G0_2_0 - 2.508472831823509e-02*G0_2_1 - 6.197787230773705e-03*G0_2_2;
    block[543] = -5.101757488910177e-02*G0_0_0 - 8.879145706402583e-02*G0_0_1 - 5.284429112554039e-02*G0_0_2 - 4.632030456682959e-03*G0_1_0 + 8.468134553203874e-02*G0_1_1 - 8.879145706402580e-02*G0_1_2 - 5.101757488910171e-02*G0_2_0 - 8.879145706402586e-02*G0_2_1 - 5.284429112554029e-02*G0_2_2;
    block[544] = -1.500516908503020e-02*G0_0_0 - 6.523986558720851e-05*G0_0_1 - 1.500516908503024e-02*G0_0_2 - 6.523986558752129e-05*G0_1_0 - 6.523986558764850e-05*G0_1_2 - 1.500516908503021e-02*G0_2_0 - 6.523986558718876e-05*G0_2_1 - 1.500516908503019e-02*G0_2_2;
    block[545] = -6.523986558709253e-04*G0_0_0 - 2.576974690689876e-03*G0_0_1 - 6.523986558707858e-04*G0_0_2 - 2.576974690689667e-03*G0_1_0 - 2.576974690689553e-03*G0_1_2 - 6.523986558708462e-04*G0_2_0 - 2.576974690689896e-03*G0_2_1 - 6.523986558707670e-04*G0_2_2;
    block[546] = -1.500516908503016e-02*G0_0_0 - 6.523986558727660e-05*G0_0_1 - 1.500516908503033e-02*G0_0_2 - 6.523986558738207e-05*G0_1_0 - 6.523986558722936e-05*G0_1_2 - 1.500516908503019e-02*G0_2_0 - 6.523986558711226e-05*G0_2_1 - 1.500516908503032e-02*G0_2_2;
    block[547] = -6.523986558707750e-04*G0_0_0 + 8.840001787050362e-03*G0_0_1 - 6.523986558708625e-04*G0_0_2 + 8.840001787050423e-03*G0_1_0 - 6.523986558706914e-04*G0_1_1 + 8.840001787050827e-03*G0_1_2 - 6.523986558708691e-04*G0_2_0 + 8.840001787050399e-03*G0_2_1 - 6.523986558709458e-04*G0_2_2;
    block[548] = -6.523986558710657e-04*G0_0_0 + 8.840001787050389e-03*G0_0_1 - 6.523986558708908e-04*G0_0_2 + 8.840001787050340e-03*G0_1_0 - 6.523986558708899e-04*G0_1_1 + 8.840001787049903e-03*G0_1_2 - 6.523986558710132e-04*G0_2_0 + 8.840001787050305e-03*G0_2_1 - 6.523986558709252e-04*G0_2_2;
    block[549] = -1.500516908502986e-02*G0_0_0 + 2.276871308989382e-02*G0_0_1 - 1.500516908503012e-02*G0_0_2 + 2.276871308989326e-02*G0_1_0 - 6.654466289882860e-02*G0_1_1 + 2.276871308989304e-02*G0_1_2 - 1.500516908502989e-02*G0_2_0 + 2.276871308989389e-02*G0_2_1 - 1.500516908503006e-02*G0_2_2;
    block[550] = -5.284429112553979e-02*G0_0_0 - 8.879145706402550e-02*G0_0_1 - 5.101757488910157e-02*G0_0_2 - 8.879145706402536e-02*G0_1_0 + 8.468134553203918e-02*G0_1_1 - 4.632030456682606e-03*G0_1_2 - 5.284429112553986e-02*G0_2_0 - 8.879145706402558e-02*G0_2_1 - 5.101757488910164e-02*G0_2_2;
    block[551] = -6.197787230773842e-03*G0_0_0 - 2.508472831823489e-02*G0_0_1 - 1.559232787531397e-02*G0_0_2 - 2.508472831823514e-02*G0_1_0 + 1.278701365506912e-02*G0_1_1 + 3.294613212148195e-03*G0_1_2 - 6.197787230773755e-03*G0_2_0 - 2.508472831823493e-02*G0_2_1 - 1.559232787531405e-02*G0_2_2;
    block[552] = -5.284429112554103e-02*G0_0_0 - 1.376561163887581e-02*G0_0_1 + 1.174317580567131e-03*G0_0_2 - 1.376561163887589e-02*G0_1_0 - 1.304797311746130e-04*G0_1_1 - 6.523986558756181e-05*G0_1_2 - 5.284429112554100e-02*G0_2_0 - 1.376561163887587e-02*G0_2_1 + 1.174317580567219e-03*G0_2_2;
    block[553] = 1.047099842672742e-01*G0_0_0 + 1.885758314794750e-01*G0_0_1 + 1.824106641814951e-01*G0_0_2 + 1.885758314794754e-01*G0_1_0 - 6.223883177008129e-02*G0_1_1 + 9.854481696929487e-02*G0_1_2 + 1.047099842672743e-01*G0_2_0 + 1.885758314794752e-01*G0_2_1 + 1.824106641814951e-01*G0_2_2;
    block[554] = 1.047099842672760e-01*G0_0_0 + 3.036915743078919e-02*G0_0_1 - 3.522952741702713e-03*G0_0_2 + 3.036915743078950e-02*G0_1_0 - 6.784946021056849e-03*G0_1_1 + 2.968413884212559e-03*G0_1_2 + 1.047099842672759e-01*G0_2_0 + 3.036915743078929e-02*G0_2_1 - 3.522952741702710e-03*G0_2_2;
    block[555] = -2.713978408422831e-01*G0_0_0 - 1.980682319223961e-01*G0_0_1 - 1.247386230025104e-01*G0_0_2 - 1.980682319223969e-01*G0_1_0 - 3.392473010528427e-03*G0_1_1 - 6.236931150125521e-02*G0_1_2 - 2.713978408422831e-01*G0_2_0 - 1.980682319223962e-01*G0_2_1 - 1.247386230025102e-01*G0_2_2;
    block[556] = 2.609594623483392e-02*G0_0_0 + 1.043837849393264e-02*G0_0_1 + 2.609594623483416e-02*G0_0_2 + 1.043837849393334e-02*G0_1_0 + 1.807144276762311e-01*G0_1_1 + 1.043837849393343e-02*G0_1_2 + 2.609594623483366e-02*G0_2_0 + 1.043837849393253e-02*G0_2_1 + 2.609594623483434e-02*G0_2_2;
    block[557] = 2.609594623483524e-02*G0_0_0 - 5.871587902838027e-03*G0_0_1 + 2.609594623483548e-02*G0_0_2 - 5.871587902837757e-03*G0_1_0 + 1.304797311741658e-03*G0_1_1 - 5.871587902837927e-03*G0_1_2 + 2.609594623483547e-02*G0_2_0 - 5.871587902838028e-03*G0_2_1 + 2.609594623483554e-02*G0_2_2;
    block[558] = -1.859336169231981e-01*G0_0_0 - 9.557640308508161e-02*G0_0_1 - 1.859336169231979e-01*G0_0_2 - 9.557640308508256e-02*G0_1_0 - 1.617948666559757e-01*G0_1_1 - 9.557640308508221e-02*G0_1_2 - 1.859336169231980e-01*G0_2_0 - 9.557640308508150e-02*G0_2_1 - 1.859336169231980e-01*G0_2_2;
    block[559] = 2.609594623483539e-02*G0_0_0 - 5.871587902837753e-03*G0_0_1 + 2.609594623483502e-02*G0_0_2 - 5.871587902837926e-03*G0_1_0 + 1.304797311741543e-03*G0_1_1 - 5.871587902837942e-03*G0_1_2 + 2.609594623483519e-02*G0_2_0 - 5.871587902837857e-03*G0_2_1 + 2.609594623483494e-02*G0_2_2;
    block[560] = 2.146913496739853e-02*G0_0_0 + 2.146913496739855e-02*G0_0_1 + 2.146913496739853e-02*G0_0_2 + 5.512768642108861e-02*G0_1_0 + 5.512768642108856e-02*G0_1_1 + 5.512768642108858e-02*G0_1_2 + 2.146913496739854e-02*G0_2_0 + 2.146913496739856e-02*G0_2_1 + 2.146913496739855e-02*G0_2_2;
    block[561] = -3.365072266981945e-03*G0_0_0 - 3.365072266981937e-03*G0_2_0;
    block[562] = -2.326323127104360e-02*G0_0_1 - 3.881772002431689e-02*G0_1_1 - 2.326323127104361e-02*G0_2_1;
    block[563] = -3.365072266982019e-03*G0_0_2 - 3.365072266982009e-03*G0_2_2;
    block[564] = 1.397437920875404e-02*G0_0_0 + 2.289919282106743e-03*G0_0_1 + 2.289919282106671e-03*G0_1_0 + 1.397437920875408e-02*G0_2_0 + 2.289919282106759e-03*G0_2_1;
    block[565] = -2.630471380471346e-02*G0_0_0 - 1.315235690235679e-02*G0_0_1 - 1.315235690235673e-02*G0_1_0 + 6.523986558717342e-05*G0_1_1 - 2.630471380471358e-02*G0_2_0 - 1.315235690235682e-02*G0_2_1;
    block[566] = -5.232237220084212e-03*G0_0_0 - 5.780252091015878e-03*G0_0_1 - 5.780252091015722e-03*G0_1_0 - 6.263027096360277e-03*G0_1_1 - 5.232237220084118e-03*G0_2_0 - 5.780252091015868e-03*G0_2_1;
    block[567] = -7.889456945446456e-02*G0_0_0 - 5.991629255518056e-02*G0_0_1 - 5.991629255518083e-02*G0_1_0 - 3.154347501135655e-02*G0_1_1 - 7.889456945446466e-02*G0_2_0 - 5.991629255518058e-02*G0_2_1;
    block[568] = 7.889456945446453e-02*G0_0_0 + 1.035291427001490e-01*G0_0_1 + 7.889456945446462e-02*G0_0_2 + 5.991629255518085e-02*G0_1_0 + 1.852681702942102e-01*G0_1_1 + 5.991629255518086e-02*G0_1_2 + 7.889456945446463e-02*G0_2_0 + 1.035291427001490e-01*G0_2_1 + 7.889456945446471e-02*G0_2_2;
    block[569] = -2.041877313144654e-01*G0_0_0 - 2.194930037811964e-01*G0_0_1 - 2.041877313144655e-01*G0_0_2 - 1.676925505050487e-01*G0_1_0 - 3.871855542862447e-01*G0_1_1 - 1.676925505050488e-01*G0_1_2 - 2.041877313144655e-01*G0_2_0 - 2.194930037811965e-01*G0_2_1 - 2.041877313144656e-01*G0_2_2;
    block[570] = 3.042265412057049e-01*G0_0_0 + 2.260952781786091e-01*G0_0_1 + 3.042265412057051e-01*G0_0_2 + 2.260952781786091e-01*G0_1_0 + 4.289651642082155e-01*G0_1_1 + 2.260952781786091e-01*G0_1_2 + 3.042265412057051e-01*G0_2_0 + 2.260952781786091e-01*G0_2_1 + 3.042265412057050e-01*G0_2_2;
    block[571] = -1.470637050064116e-01*G0_0_0 - 1.083373207939166e-01*G0_0_1 - 1.470637050064116e-01*G0_0_2 - 1.734467066498299e-01*G0_1_0 - 2.433577466129524e-01*G0_1_1 - 1.734467066498299e-01*G0_1_2 - 1.470637050064115e-01*G0_2_0 - 1.083373207939167e-01*G0_2_1 - 1.470637050064115e-01*G0_2_2;
    block[572] = -1.869122149070028e-02*G0_0_0 - 5.741760570319534e-02*G0_0_1 - 5.741760570319535e-02*G0_0_2 - 5.741760570319534e-02*G0_1_0 + 1.249343425992715e-02*G0_1_1 + 1.249343425992714e-02*G0_1_2 - 1.869122149070031e-02*G0_2_0 - 5.741760570319532e-02*G0_2_1 - 5.741760570319533e-02*G0_2_2;
    block[573] = 2.609594623484372e-04*G0_0_0 + 5.062613569558064e-03*G0_0_1 + 5.062613569558035e-03*G0_0_2 + 5.062613569558051e-03*G0_1_0 + 2.609594623484954e-04*G0_1_1 + 2.609594623484515e-04*G0_1_2 + 2.609594623484577e-04*G0_2_0 + 5.062613569558040e-03*G0_2_1 + 5.062613569558012e-03*G0_2_2;
    block[574] = -6.263027096360712e-03*G0_0_0 - 4.827750053445347e-04*G0_0_1 - 4.827750053445414e-04*G0_0_2 - 4.827750053445587e-04*G0_1_0 + 6.523986558683859e-05*G0_1_1 + 6.523986558686781e-05*G0_1_2 - 6.263027096360737e-03*G0_2_0 - 4.827750053445445e-04*G0_2_1 - 4.827750053445497e-04*G0_2_2;
    block[575] = 6.589226424295948e-03*G0_0_0 - 2.289919282106874e-03*G0_0_1 - 2.289919282106798e-03*G0_0_2 - 2.289919282106741e-03*G0_1_0 + 6.589226424295944e-03*G0_2_0 - 2.289919282106891e-03*G0_2_1 - 2.289919282106817e-03*G0_2_2;
    block[576] = -5.741760570319549e-02*G0_0_0 - 5.741760570319553e-02*G0_0_1 - 1.869122149070056e-02*G0_0_2 + 1.249343425992696e-02*G0_1_0 + 1.249343425992702e-02*G0_1_1 - 5.741760570319543e-02*G0_1_2 - 5.741760570319547e-02*G0_2_0 - 5.741760570319551e-02*G0_2_1 - 1.869122149070057e-02*G0_2_2;
    block[577] = 5.062613569557959e-03*G0_0_0 + 5.062613569558047e-03*G0_0_1 + 2.609594623486837e-04*G0_0_2 + 2.609594623485405e-04*G0_1_0 + 2.609594623485027e-04*G0_1_1 + 5.062613569558094e-03*G0_1_2 + 5.062613569557915e-03*G0_2_0 + 5.062613569558005e-03*G0_2_1 + 2.609594623486886e-04*G0_2_2;
    block[578] = -4.827750053444710e-04*G0_0_0 - 4.827750053445024e-04*G0_0_1 - 6.263027096360721e-03*G0_0_2 + 6.523986558687913e-05*G0_1_0 + 6.523986558689122e-05*G0_1_1 - 4.827750053445023e-04*G0_1_2 - 4.827750053444606e-04*G0_2_0 - 4.827750053444928e-04*G0_2_1 - 6.263027096360745e-03*G0_2_2;
    block[579] = -2.289919282106689e-03*G0_0_0 - 2.289919282106685e-03*G0_0_1 + 6.589226424296088e-03*G0_0_2 - 2.289919282106700e-03*G0_1_2 - 2.289919282106762e-03*G0_2_0 - 2.289919282106757e-03*G0_2_1 + 6.589226424296084e-03*G0_2_2;
    block[580] = 2.289919282106829e-03*G0_0_0 + 2.289919282106753e-03*G0_0_2 + 2.289919282106820e-03*G0_2_0 + 2.289919282106770e-03*G0_2_2;
    block[581] = 1.787572317086165e-03*G0_0_0 + 1.787572317086181e-03*G0_0_2 + 1.787572317086249e-03*G0_2_0 + 1.787572317086216e-03*G0_2_2;
    block[582] = 1.787572317086270e-03*G0_0_0 + 1.787572317086214e-03*G0_0_2 + 1.787572317086194e-03*G0_2_0 + 1.787572317086194e-03*G0_2_2;
    block[583] = 2.289919282106675e-03*G0_0_0 + 2.289919282106775e-03*G0_0_2 + 2.289919282106746e-03*G0_2_0 + 2.289919282106809e-03*G0_2_2;
    block[584] = -5.991629255518061e-02*G0_0_1 - 7.889456945446444e-02*G0_0_2 - 3.154347501135658e-02*G0_1_1 - 5.991629255518083e-02*G0_1_2 - 5.991629255518065e-02*G0_2_1 - 7.889456945446453e-02*G0_2_2;
    block[585] = -5.780252091016172e-03*G0_0_1 - 5.232237220084558e-03*G0_0_2 - 6.263027096360503e-03*G0_1_1 - 5.780252091016039e-03*G0_1_2 - 5.780252091016103e-03*G0_2_1 - 5.232237220084457e-03*G0_2_2;
    block[586] = -1.315235690235659e-02*G0_0_1 - 2.630471380471343e-02*G0_0_2 + 6.523986558718419e-05*G0_1_1 - 1.315235690235678e-02*G0_1_2 - 1.315235690235668e-02*G0_2_1 - 2.630471380471354e-02*G0_2_2;
    block[587] = 2.289919282106689e-03*G0_0_1 + 1.397437920875413e-02*G0_0_2 + 2.289919282106697e-03*G0_1_2 + 2.289919282106759e-03*G0_2_1 + 1.397437920875420e-02*G0_2_2;
    block[588] = -1.487468935385585e-02*G0_0_0 + 6.523986558718312e-05*G0_0_1 - 1.487468935385578e-02*G0_0_2 + 6.523986558690287e-05*G0_1_0 + 6.523986558696115e-05*G0_1_2 - 1.487468935385578e-02*G0_2_0 + 6.523986558729912e-05*G0_2_1 - 1.487468935385573e-02*G0_2_2;
    block[589] = 4.501550725509346e-03*G0_0_0 + 2.576974690690052e-03*G0_0_1 + 4.501550725509266e-03*G0_0_2 + 2.576974690690144e-03*G0_1_0 + 2.576974690689770e-03*G0_1_2 + 4.501550725509263e-03*G0_2_0 + 2.576974690690039e-03*G0_2_1 + 4.501550725509261e-03*G0_2_2;
    block[590] = -1.487468935385566e-02*G0_0_0 + 6.523986558717541e-05*G0_0_1 - 1.487468935385558e-02*G0_0_2 + 6.523986558696462e-05*G0_1_0 + 6.523986558730447e-05*G0_1_2 - 1.487468935385563e-02*G0_2_0 + 6.523986558721843e-05*G0_2_1 - 1.487468935385563e-02*G0_2_2;
    block[591] = -1.898480088584237e-02*G0_0_0 - 9.492400442921135e-03*G0_0_1 - 1.898480088584244e-02*G0_0_2 - 9.492400442920884e-03*G0_1_0 - 6.523986558707561e-04*G0_1_1 - 9.492400442921059e-03*G0_1_2 - 1.898480088584241e-02*G0_2_0 - 9.492400442921274e-03*G0_2_1 - 1.898480088584258e-02*G0_2_2;
    block[592] = -1.898480088584233e-02*G0_0_0 - 9.492400442920729e-03*G0_0_1 - 1.898480088584251e-02*G0_0_2 - 9.492400442921226e-03*G0_1_0 - 6.523986558706475e-04*G0_1_1 - 9.492400442921222e-03*G0_1_2 - 1.898480088584237e-02*G0_2_0 - 9.492400442920825e-03*G0_2_1 - 1.898480088584248e-02*G0_2_2;
    block[593] = -1.270872581636456e-01*G0_0_0 - 8.931337598872226e-02*G0_0_1 - 1.270872581636451e-01*G0_0_2 - 8.931337598872210e-02*G0_1_0 - 6.654466289882852e-02*G0_1_1 - 8.931337598872165e-02*G0_1_2 - 1.270872581636455e-01*G0_2_0 - 8.931337598872213e-02*G0_2_1 - 1.270872581636450e-01*G0_2_2;
    block[594] = 1.270872581636456e-01*G0_0_0 + 1.734728025960645e-01*G0_0_1 + 2.094199685345499e-01*G0_0_2 + 8.931337598872216e-02*G0_1_0 + 8.468134553203928e-02*G0_1_1 + 1.734728025960648e-01*G0_1_2 + 1.270872581636456e-01*G0_2_0 + 1.734728025960646e-01*G0_2_1 + 2.094199685345498e-01*G0_2_2;
    block[595] = 1.898480088584232e-02*G0_0_0 + 3.787174197330418e-02*G0_0_1 + 5.675868306076586e-02*G0_0_2 + 9.492400442921226e-03*G0_1_0 + 1.278701365506911e-02*G0_1_1 + 3.787174197330439e-02*G0_1_2 + 1.898480088584235e-02*G0_2_0 + 3.787174197330417e-02*G0_2_1 + 5.675868306076596e-02*G0_2_2;
    block[596] = 1.487468935385567e-02*G0_0_0 + 1.363513190770114e-02*G0_0_1 - 2.544354757896435e-02*G0_0_2 - 6.523986558699129e-05*G0_1_0 - 1.304797311740127e-04*G0_1_1 + 1.363513190770119e-02*G0_1_2 + 1.487468935385563e-02*G0_2_0 + 1.363513190770121e-02*G0_2_1 - 2.544354757896439e-02*G0_2_2;
    block[597] = -1.669488160373556e-01*G0_0_0 - 2.508146632495564e-01*G0_0_1 - 3.346805104617574e-01*G0_0_2 - 1.607836487393763e-01*G0_1_0 - 6.223883177008115e-02*G0_1_1 - 2.508146632495569e-01*G0_1_2 - 1.669488160373557e-01*G0_2_0 - 2.508146632495564e-01*G0_2_1 - 3.346805104617576e-01*G0_2_2;
    block[598] = -4.364547007776117e-02*G0_0_0 - 3.715410345184609e-02*G0_0_1 + 3.718672338464037e-02*G0_0_2 - 9.753359905269680e-03*G0_1_0 - 6.784946021057170e-03*G0_1_1 - 3.715410345184611e-02*G0_1_2 - 4.364547007776126e-02*G0_2_0 - 3.715410345184609e-02*G0_2_1 + 3.718672338464041e-02*G0_2_2;
    block[599] = 1.323064474106120e-01*G0_0_0 + 1.946757589118680e-01*G0_0_1 + 1.213461499919815e-01*G0_0_2 + 5.897683849072641e-02*G0_1_0 - 3.392473010528332e-03*G0_1_1 + 1.946757589118682e-01*G0_1_2 + 1.323064474106120e-01*G0_2_0 + 1.946757589118681e-01*G0_2_1 + 1.213461499919814e-01*G0_2_2;
    block[600] = -1.304797311741739e-03*G0_0_0 - 6.523986558719280e-05*G0_0_1 - 1.304797311741830e-03*G0_0_2 - 6.523986558690206e-05*G0_1_0 - 6.523986558671343e-05*G0_1_2 - 1.304797311741674e-03*G0_2_0 - 6.523986558723404e-05*G0_2_1 - 1.304797311741848e-03*G0_2_2;
    block[601] = -1.565756774090083e-02*G0_0_0 - 2.576974690690102e-03*G0_0_1 - 1.565756774090107e-02*G0_0_2 - 2.576974690689778e-03*G0_1_0 - 2.576974690690113e-03*G0_1_2 - 1.565756774090090e-02*G0_2_0 - 2.576974690690088e-03*G0_2_1 - 1.565756774090106e-02*G0_2_2;
    block[602] = -1.304797311741859e-03*G0_0_0 - 6.523986558710915e-05*G0_0_1 - 1.304797311741542e-03*G0_0_2 - 6.523986558686926e-05*G0_1_0 - 6.523986558685927e-05*G0_1_2 - 1.304797311741832e-03*G0_2_0 - 6.523986558722274e-05*G0_2_1 - 1.304797311741573e-03*G0_2_2;
    block[603] = 8.807381854256708e-03*G0_0_0 + 2.316015228341518e-03*G0_0_1 + 8.807381854257158e-03*G0_0_2 + 2.316015228341351e-03*G0_1_0 - 6.523986558711731e-04*G0_1_1 + 2.316015228341327e-03*G0_1_2 + 8.807381854256740e-03*G0_2_0 + 2.316015228341450e-03*G0_2_1 + 8.807381854257163e-03*G0_2_2;
    block[604] = 8.807381854257093e-03*G0_0_0 + 2.316015228341694e-03*G0_0_1 + 8.807381854256710e-03*G0_0_2 + 2.316015228341447e-03*G0_1_0 - 6.523986558709032e-04*G0_1_1 + 2.316015228341734e-03*G0_1_2 + 8.807381854257069e-03*G0_2_0 + 2.316015228341661e-03*G0_2_1 + 8.807381854256734e-03*G0_2_2;
    block[605] = 4.762510187857349e-02*G0_0_0 - 1.474420962268240e-02*G0_0_1 + 4.762510187857340e-02*G0_0_2 - 1.474420962268141e-02*G0_1_0 + 4.762510187857341e-02*G0_1_1 - 1.474420962268168e-02*G0_1_2 + 4.762510187857344e-02*G0_2_0 - 1.474420962268237e-02*G0_2_1 + 4.762510187857331e-02*G0_2_2;
    block[606] = 1.213461499919810e-01*G0_0_0 + 1.946757589118675e-01*G0_0_1 + 1.323064474106116e-01*G0_0_2 + 1.946757589118679e-01*G0_1_0 - 3.392473010528964e-03*G0_1_1 + 5.897683849072607e-02*G0_1_2 + 1.213461499919809e-01*G0_2_0 + 1.946757589118675e-01*G0_2_1 + 1.323064474106118e-01*G0_2_2;
    block[607] = 3.718672338464082e-02*G0_0_0 - 3.715410345184620e-02*G0_0_1 - 4.364547007776095e-02*G0_0_2 - 3.715410345184606e-02*G0_1_0 - 6.784946021056950e-03*G0_1_1 - 9.753359905269402e-03*G0_1_2 + 3.718672338464076e-02*G0_2_0 - 3.715410345184617e-02*G0_2_1 - 4.364547007776101e-02*G0_2_2;
    block[608] = -2.544354757896414e-02*G0_0_0 + 1.363513190770160e-02*G0_0_1 + 1.487468935385609e-02*G0_0_2 + 1.363513190770154e-02*G0_1_0 - 1.304797311739718e-04*G0_1_1 - 6.523986558677350e-05*G0_1_2 - 2.544354757896413e-02*G0_2_0 + 1.363513190770164e-02*G0_2_1 + 1.487468935385605e-02*G0_2_2;
    block[609] = -3.346805104617568e-01*G0_0_0 - 2.508146632495555e-01*G0_0_1 - 1.669488160373551e-01*G0_0_2 - 2.508146632495561e-01*G0_1_0 - 6.223883177008046e-02*G0_1_1 - 1.607836487393757e-01*G0_1_2 - 3.346805104617568e-01*G0_2_0 - 2.508146632495556e-01*G0_2_1 - 1.669488160373551e-01*G0_2_2;
    block[610] = 5.675868306076518e-02*G0_0_0 + 3.787174197330387e-02*G0_0_1 + 1.898480088584209e-02*G0_0_2 + 3.787174197330355e-02*G0_1_0 + 1.278701365506873e-02*G0_1_1 + 9.492400442920813e-03*G0_1_2 + 5.675868306076524e-02*G0_2_0 + 3.787174197330386e-02*G0_2_1 + 1.898480088584223e-02*G0_2_2;
    block[611] = 2.094199685345497e-01*G0_0_0 + 1.734728025960637e-01*G0_0_1 + 1.270872581636452e-01*G0_0_2 + 1.734728025960646e-01*G0_1_0 + 8.468134553203868e-02*G0_1_1 + 8.931337598872190e-02*G0_1_2 + 2.094199685345497e-01*G0_2_0 + 1.734728025960638e-01*G0_2_1 + 1.270872581636452e-01*G0_2_2;
    block[612] = -1.565756774090085e-01*G0_0_0 - 6.621846357089251e-02*G0_0_1 - 1.565756774090086e-01*G0_0_2 - 6.621846357089280e-02*G0_1_0 - 1.617948666559757e-01*G0_1_1 - 6.621846357089303e-02*G0_1_2 - 1.565756774090085e-01*G0_2_0 - 6.621846357089257e-02*G0_2_1 - 1.565756774090088e-01*G0_2_2;
    block[613] = 3.914391935225247e-02*G0_0_0 + 7.176385214579476e-03*G0_0_1 + 3.914391935225162e-02*G0_0_2 + 7.176385214579546e-03*G0_1_0 + 1.304797311741577e-03*G0_1_1 + 7.176385214579482e-03*G0_1_2 + 3.914391935225241e-02*G0_2_0 + 7.176385214579642e-03*G0_2_1 + 3.914391935225166e-02*G0_2_2;
    block[614] = 1.859336169231977e-01*G0_0_0 + 1.702760491822971e-01*G0_0_1 + 1.859336169231976e-01*G0_0_2 + 1.702760491822970e-01*G0_1_0 + 1.807144276762308e-01*G0_1_1 + 1.702760491822966e-01*G0_1_2 + 1.859336169231979e-01*G0_2_0 + 1.702760491822971e-01*G0_2_1 + 1.859336169231976e-01*G0_2_2;
    block[615] = 3.914391935225167e-02*G0_0_0 + 7.176385214579166e-03*G0_0_1 + 3.914391935225238e-02*G0_0_2 + 7.176385214579461e-03*G0_1_0 + 1.304797311741755e-03*G0_1_1 + 7.176385214579807e-03*G0_1_2 + 3.914391935225184e-02*G0_2_0 + 7.176385214579328e-03*G0_2_1 + 3.914391935225252e-02*G0_2_2;
    block[616] = -1.787050398161485e-02*G0_0_0 - 1.787050398161485e-02*G0_0_1 - 1.787050398161489e-02*G0_0_2 - 5.512768642108867e-02*G0_1_0 - 5.512768642108860e-02*G0_1_1 - 5.512768642108862e-02*G0_1_2 - 1.787050398161486e-02*G0_2_0 - 1.787050398161484e-02*G0_2_1 - 1.787050398161489e-02*G0_2_2;
    block[617] = -4.800349309897907e-03*G0_0_0 - 4.800349309897911e-03*G0_2_0;
    block[618] = 1.053101910306767e-02*G0_0_1 + 1.533136841296547e-02*G0_1_1 + 1.053101910306768e-02*G0_2_1;
    block[619] = -4.800349309897894e-03*G0_0_2 - 4.800349309897902e-03*G0_2_2;
    block[620] = 1.075152984875202e-02*G0_0_0 + 5.375764924376036e-03*G0_0_1 + 5.375764924376018e-03*G0_1_0 + 1.075152984875196e-02*G0_2_0 + 5.375764924375970e-03*G0_2_1;
    block[621] = 1.397437920875397e-02*G0_0_0 + 1.168445992664723e-02*G0_0_1 + 1.168445992664723e-02*G0_1_0 + 9.394540644540494e-03*G0_1_1 + 1.397437920875405e-02*G0_2_0 + 1.168445992664725e-02*G0_2_1;
    block[622] = 1.116906498850919e-02*G0_0_0 + 8.879145706402507e-03*G0_0_1 + 8.879145706402485e-03*G0_1_0 + 6.589226424295760e-03*G0_1_1 + 1.116906498850911e-02*G0_2_0 + 8.879145706402506e-03*G0_2_1;
    block[623] = 3.283522434998099e-02*G0_0_0 + 2.745945942560481e-02*G0_0_1 + 2.745945942560490e-02*G0_1_0 + 2.208369450122889e-02*G0_1_1 + 3.283522434998103e-02*G0_2_0 + 2.745945942560481e-02*G0_2_1;
    block[624] = -3.283522434998100e-02*G0_0_0 - 5.375112525720135e-02*G0_0_1 - 3.283522434998101e-02*G0_0_2 - 2.745945942560490e-02*G0_1_0 - 8.121058468280602e-02*G0_1_1 - 2.745945942560490e-02*G0_1_2 - 3.283522434998103e-02*G0_2_0 - 5.375112525720138e-02*G0_2_1 - 3.283522434998105e-02*G0_2_2;
    block[625] = 1.007173044933450e-01*G0_0_0 + 1.253518777390295e-01*G0_0_1 + 1.007173044933451e-01*G0_0_2 + 8.173902759406133e-02*G0_1_0 + 1.852681702942099e-01*G0_1_1 + 8.173902759406136e-02*G0_1_2 + 1.007173044933450e-01*G0_2_0 + 1.253518777390294e-01*G0_2_1 + 1.007173044933451e-01*G0_2_2;
    block[626] = -1.470637050064116e-01*G0_0_0 - 1.734467066498300e-01*G0_0_1 - 1.470637050064116e-01*G0_0_2 - 1.083373207939166e-01*G0_1_0 - 2.433577466129524e-01*G0_1_1 - 1.083373207939166e-01*G0_1_2 - 1.470637050064116e-01*G0_2_0 - 1.734467066498299e-01*G0_2_1 - 1.470637050064115e-01*G0_2_2;
    block[627] = 1.790964790096718e-01*G0_0_0 + 1.091854390465491e-01*G0_0_1 + 1.790964790096717e-01*G0_0_2 + 1.091854390465491e-01*G0_1_0 + 1.790964790096715e-01*G0_1_1 + 1.091854390465490e-01*G0_1_2 + 1.790964790096717e-01*G0_2_0 + 1.091854390465491e-01*G0_2_1 + 1.790964790096715e-01*G0_2_2;
    block[628] = 1.963719954171308e-02*G0_0_0 + 8.954823950483580e-02*G0_0_1 + 8.954823950483581e-02*G0_0_2 + 8.954823950483577e-02*G0_1_0 + 1.963719954171314e-02*G0_1_1 + 1.963719954171313e-02*G0_1_2 + 1.963719954171308e-02*G0_2_0 + 8.954823950483579e-02*G0_2_1 + 8.954823950483579e-02*G0_2_2;
    block[629] = 1.249343425992730e-02*G0_0_0 - 5.741760570319547e-02*G0_0_1 - 5.741760570319542e-02*G0_0_2 - 5.741760570319540e-02*G0_1_0 - 1.869122149070052e-02*G0_1_1 - 1.869122149070051e-02*G0_1_2 + 1.249343425992730e-02*G0_2_0 - 5.741760570319539e-02*G0_2_1 - 5.741760570319535e-02*G0_2_2;
    block[630] = -3.154347501135665e-02*G0_0_0 + 2.837281754382429e-02*G0_0_1 + 2.837281754382424e-02*G0_0_2 + 2.837281754382421e-02*G0_1_0 + 9.394540644540645e-03*G0_1_1 + 9.394540644540641e-03*G0_1_2 - 3.154347501135665e-02*G0_2_0 + 2.837281754382422e-02*G0_2_1 + 2.837281754382417e-02*G0_2_2;
    block[631] = 2.208369450122908e-02*G0_0_0 - 5.375764924375951e-03*G0_0_1 - 5.375764924375943e-03*G0_0_2 - 5.375764924375904e-03*G0_1_0 + 2.208369450122909e-02*G0_2_0 - 5.375764924375884e-03*G0_2_1 - 5.375764924375876e-03*G0_2_2;
    block[632] = 8.954823950483591e-02*G0_0_0 + 8.954823950483597e-02*G0_0_1 + 1.963719954171331e-02*G0_0_2 + 1.963719954171340e-02*G0_1_0 + 1.963719954171335e-02*G0_1_1 + 8.954823950483594e-02*G0_1_2 + 8.954823950483588e-02*G0_2_0 + 8.954823950483591e-02*G0_2_1 + 1.963719954171330e-02*G0_2_2;
    block[633] = -5.741760570319551e-02*G0_0_0 - 5.741760570319552e-02*G0_0_1 + 1.249343425992715e-02*G0_0_2 - 1.869122149070056e-02*G0_1_0 - 1.869122149070052e-02*G0_1_1 - 5.741760570319560e-02*G0_1_2 - 5.741760570319548e-02*G0_2_0 - 5.741760570319547e-02*G0_2_1 + 1.249343425992716e-02*G0_2_2;
    block[634] = 2.837281754382422e-02*G0_0_0 + 2.837281754382424e-02*G0_0_1 - 3.154347501135683e-02*G0_0_2 + 9.394540644540610e-03*G0_1_0 + 9.394540644540598e-03*G0_1_1 + 2.837281754382425e-02*G0_1_2 + 2.837281754382419e-02*G0_2_0 + 2.837281754382421e-02*G0_2_1 - 3.154347501135684e-02*G0_2_2;
    block[635] = -5.375764924376120e-03*G0_0_0 - 5.375764924376122e-03*G0_0_1 + 2.208369450122909e-02*G0_0_2 - 5.375764924376029e-03*G0_1_2 - 5.375764924376089e-03*G0_2_0 - 5.375764924376092e-03*G0_2_1 + 2.208369450122910e-02*G0_2_2;
    block[636] = 5.375764924375949e-03*G0_0_0 + 5.375764924376051e-03*G0_0_2 + 5.375764924375921e-03*G0_2_0 + 5.375764924375982e-03*G0_2_2;
    block[637] = 2.289919282106883e-03*G0_0_0 + 2.289919282106732e-03*G0_0_2 + 2.289919282106881e-03*G0_2_0 + 2.289919282106782e-03*G0_2_2;
    block[638] = 2.289919282106606e-03*G0_0_0 + 2.289919282106697e-03*G0_0_2 + 2.289919282106579e-03*G0_2_0 + 2.289919282106626e-03*G0_2_2;
    block[639] = 5.375764924376148e-03*G0_0_0 + 5.375764924376107e-03*G0_0_2 + 5.375764924376119e-03*G0_2_0 + 5.375764924376115e-03*G0_2_2;
    block[640] = 2.745945942560475e-02*G0_0_1 + 3.283522434998094e-02*G0_0_2 + 2.208369450122891e-02*G0_1_1 + 2.745945942560489e-02*G0_1_2 + 2.745945942560477e-02*G0_2_1 + 3.283522434998097e-02*G0_2_2;
    block[641] = 8.879145706402906e-03*G0_0_1 + 1.116906498850940e-02*G0_0_2 + 6.589226424295975e-03*G0_1_1 + 8.879145706402719e-03*G0_1_2 + 8.879145706402849e-03*G0_2_1 + 1.116906498850934e-02*G0_2_2;
    block[642] = 1.168445992664708e-02*G0_0_1 + 1.397437920875403e-02*G0_0_2 + 9.394540644540412e-03*G0_1_1 + 1.168445992664724e-02*G0_1_2 + 1.168445992664714e-02*G0_2_1 + 1.397437920875408e-02*G0_2_2;
    block[643] = 5.375764924376122e-03*G0_0_1 + 1.075152984875211e-02*G0_0_2 + 5.375764924376073e-03*G0_1_2 + 5.375764924376095e-03*G0_2_1 + 1.075152984875209e-02*G0_2_2;
    block[644] = 1.878908128908099e-02*G0_0_0 + 9.394540644540464e-03*G0_0_1 + 1.878908128908090e-02*G0_0_2 + 9.394540644540619e-03*G0_1_0 + 9.394540644540546e-03*G0_1_2 + 1.878908128908095e-02*G0_2_0 + 9.394540644540390e-03*G0_2_1 + 1.878908128908080e-02*G0_2_2;
    block[645] = 6.589226424295624e-03*G0_0_0 + 3.294613212147842e-03*G0_0_1 + 6.589226424295764e-03*G0_0_2 + 3.294613212147794e-03*G0_1_0 + 3.294613212148060e-03*G0_1_2 + 6.589226424295645e-03*G0_2_0 + 3.294613212147848e-03*G0_2_1 + 6.589226424295834e-03*G0_2_2;
    block[646] = 1.878908128908105e-02*G0_0_0 + 9.394540644540603e-03*G0_0_1 + 1.878908128908075e-02*G0_0_2 + 9.394540644540665e-03*G0_1_0 + 9.394540644540440e-03*G0_1_2 + 1.878908128908107e-02*G0_2_0 + 9.394540644540521e-03*G0_2_1 + 1.878908128908071e-02*G0_2_2;
    block[647] = 2.926007971580835e-02*G0_0_0 + 2.596546650366043e-02*G0_0_1 + 2.926007971580832e-02*G0_0_2 + 2.596546650366044e-02*G0_1_0 + 2.267085329151254e-02*G0_1_1 + 2.596546650366049e-02*G0_1_2 + 2.926007971580839e-02*G0_2_0 + 2.596546650366049e-02*G0_2_1 + 2.926007971580839e-02*G0_2_2;
    block[648] = 2.926007971580865e-02*G0_0_0 + 2.596546650366045e-02*G0_0_1 + 2.926007971580874e-02*G0_0_2 + 2.596546650366068e-02*G0_1_0 + 2.267085329151256e-02*G0_1_1 + 2.596546650366071e-02*G0_1_2 + 2.926007971580865e-02*G0_2_0 + 2.596546650366053e-02*G0_2_1 + 2.926007971580874e-02*G0_2_2;
    block[649] = 6.413078787210649e-02*G0_0_0 + 5.473624722756603e-02*G0_0_1 + 6.413078787210620e-02*G0_0_2 + 5.473624722756593e-02*G0_1_0 + 4.534170658302542e-02*G0_1_1 + 5.473624722756564e-02*G0_1_2 + 6.413078787210648e-02*G0_2_0 + 5.473624722756599e-02*G0_2_1 + 6.413078787210616e-02*G0_2_2;
    block[650] = -6.413078787210659e-02*G0_0_0 - 9.061817330046365e-02*G0_0_1 - 1.118863694818544e-01*G0_0_2 - 5.473624722756600e-02*G0_1_0 - 6.934997711907372e-02*G0_1_1 - 9.061817330046408e-02*G0_1_2 - 6.413078787210658e-02*G0_2_0 - 9.061817330046364e-02*G0_2_1 - 1.118863694818543e-01*G0_2_2;
    block[651] = -2.926007971580864e-02*G0_0_0 - 3.770864230933672e-02*G0_0_1 - 4.354761027938056e-02*G0_0_2 - 2.596546650366070e-02*G0_1_0 - 3.186967433929217e-02*G0_1_1 - 3.770864230933652e-02*G0_1_2 - 2.926007971580862e-02*G0_2_0 - 3.770864230933672e-02*G0_2_1 - 4.354761027938062e-02*G0_2_2;
    block[652] = -1.878908128908108e-02*G0_0_0 - 4.005727747047139e-02*G0_0_1 - 6.132547365186236e-02*G0_0_2 - 9.394540644540662e-03*G0_1_0 - 1.878908128908107e-02*G0_1_1 - 4.005727747047153e-02*G0_1_2 - 1.878908128908109e-02*G0_2_0 - 4.005727747047142e-02*G0_2_1 - 6.132547365186237e-02*G0_2_2;
    block[653] = 1.273155976932002e-01*G0_0_0 + 1.343615031766057e-01*G0_0_1 + 1.766369360770383e-01*G0_0_2 + 1.280006162818650e-01*G0_1_0 + 9.208607027617370e-02*G0_1_1 + 1.343615031766060e-01*G0_1_2 + 1.273155976932002e-01*G0_2_0 + 1.343615031766057e-01*G0_2_1 + 1.766369360770382e-01*G0_2_2;
    block[654] = 4.397166940569690e-02*G0_0_0 + 8.624710230612938e-02*G0_0_1 + 1.285225352065622e-01*G0_0_2 + 4.465668799436120e-02*G0_1_0 + 4.397166940569673e-02*G0_1_1 + 8.624710230612927e-02*G0_1_2 + 4.397166940569698e-02*G0_2_0 + 8.624710230612936e-02*G0_2_1 + 1.285225352065622e-01*G0_2_2;
    block[655] = -6.445698720004184e-02*G0_0_0 - 1.607510288065828e-01*G0_0_1 - 2.570450704131236e-01*G0_0_2 - 9.290156859601194e-02*G0_1_0 - 6.445698720004232e-02*G0_1_1 - 1.607510288065829e-01*G0_1_2 - 6.445698720004192e-02*G0_2_0 - 1.607510288065827e-01*G0_2_1 - 2.570450704131236e-01*G0_2_2;
    block[656] = -3.066273682593085e-02*G0_0_0 - 9.394540644540561e-03*G0_0_1 - 3.066273682593132e-02*G0_0_2 - 9.394540644540606e-03*G0_1_0 - 9.394540644540712e-03*G0_1_2 - 3.066273682593082e-02*G0_2_0 - 9.394540644540482e-03*G0_2_1 - 3.066273682593132e-02*G0_2_2;
    block[657] = -9.133581182192334e-03*G0_0_0 - 3.294613212147748e-03*G0_0_1 - 9.133581182191926e-03*G0_0_2 - 3.294613212148045e-03*G0_1_0 - 3.294613212147837e-03*G0_1_2 - 9.133581182192305e-03*G0_2_0 - 3.294613212147755e-03*G0_2_1 - 9.133581182191841e-03*G0_2_2;
    block[658] = -3.066273682593112e-02*G0_0_0 - 9.394540644540619e-03*G0_0_1 - 3.066273682593122e-02*G0_0_2 - 9.394540644540728e-03*G0_1_0 - 9.394540644540757e-03*G0_1_2 - 3.066273682593105e-02*G0_2_0 - 9.394540644540546e-03*G0_2_1 - 3.066273682593120e-02*G0_2_2;
    block[659] = 6.426126760328109e-02*G0_0_0 + 2.198583470284852e-02*G0_0_1 + 6.426126760328127e-02*G0_0_2 + 2.198583470284850e-02*G0_1_0 + 2.267085329151297e-02*G0_1_1 + 2.198583470284846e-02*G0_1_2 + 6.426126760328099e-02*G0_2_0 + 2.198583470284851e-02*G0_2_1 + 6.426126760328128e-02*G0_2_2;
    block[660] = 6.426126760328120e-02*G0_0_0 + 2.198583470284820e-02*G0_0_1 + 6.426126760328094e-02*G0_0_2 + 2.198583470284859e-02*G0_1_0 + 2.267085329151282e-02*G0_1_1 + 2.198583470284830e-02*G0_1_2 + 6.426126760328110e-02*G0_2_0 + 2.198583470284812e-02*G0_2_1 + 6.426126760328085e-02*G0_2_2;
    block[661] = -1.285225352065621e-01*G0_0_0 - 3.222849360002104e-02*G0_0_1 - 1.285225352065621e-01*G0_0_2 - 3.222849360002134e-02*G0_1_0 - 6.067307499599102e-02*G0_1_1 - 3.222849360002095e-02*G0_1_2 - 1.285225352065620e-01*G0_2_0 - 3.222849360002104e-02*G0_2_1 - 1.285225352065620e-01*G0_2_2;
    block[662] = -2.570450704131233e-01*G0_0_0 - 1.607510288065824e-01*G0_0_1 - 6.445698720004149e-02*G0_0_2 - 1.607510288065828e-01*G0_1_0 - 6.445698720004168e-02*G0_1_1 - 9.290156859601172e-02*G0_1_2 - 2.570450704131231e-01*G0_2_0 - 1.607510288065823e-01*G0_2_1 - 6.445698720004153e-02*G0_2_2;
    block[663] = 1.285225352065618e-01*G0_0_0 + 8.624710230612929e-02*G0_0_1 + 4.397166940569638e-02*G0_0_2 + 8.624710230612932e-02*G0_1_0 + 4.397166940569660e-02*G0_1_1 + 4.465668799436102e-02*G0_1_2 + 1.285225352065618e-01*G0_2_0 + 8.624710230612928e-02*G0_2_1 + 4.397166940569639e-02*G0_2_2;
    block[664] = -6.132547365186224e-02*G0_0_0 - 4.005727747047170e-02*G0_0_1 - 1.878908128908124e-02*G0_0_2 - 4.005727747047173e-02*G0_1_0 - 1.878908128908118e-02*G0_1_1 - 9.394540644540672e-03*G0_1_2 - 6.132547365186213e-02*G0_2_0 - 4.005727747047166e-02*G0_2_1 - 1.878908128908113e-02*G0_2_2;
    block[665] = 1.766369360770380e-01*G0_0_0 + 1.343615031766053e-01*G0_0_1 + 1.273155976932000e-01*G0_0_2 + 1.343615031766055e-01*G0_1_0 + 9.208607027617308e-02*G0_1_1 + 1.280006162818646e-01*G0_1_2 + 1.766369360770380e-01*G0_2_0 + 1.343615031766053e-01*G0_2_1 + 1.273155976931999e-01*G0_2_2;
    block[666] = -4.354761027938010e-02*G0_0_0 - 3.770864230933606e-02*G0_0_1 - 2.926007971580811e-02*G0_0_2 - 3.770864230933595e-02*G0_1_0 - 3.186967433929185e-02*G0_1_1 - 2.596546650366036e-02*G0_1_2 - 4.354761027938016e-02*G0_2_0 - 3.770864230933613e-02*G0_2_1 - 2.926007971580816e-02*G0_2_2;
    block[667] = -1.118863694818543e-01*G0_0_0 - 9.061817330046351e-02*G0_0_1 - 6.413078787210637e-02*G0_0_2 - 9.061817330046384e-02*G0_1_0 - 6.934997711907329e-02*G0_1_1 - 5.473624722756582e-02*G0_1_2 - 1.118863694818543e-01*G0_2_0 - 9.061817330046348e-02*G0_2_1 - 6.413078787210633e-02*G0_2_2;
    block[668] = 9.622880174095279e-02*G0_0_0 + 1.314583291579801e-01*G0_0_1 + 9.622880174095293e-02*G0_0_2 + 1.314583291579803e-01*G0_1_0 + 1.666878565750075e-01*G0_1_1 + 1.314583291579805e-01*G0_1_2 + 9.622880174095283e-02*G0_2_0 + 1.314583291579802e-01*G0_2_1 + 9.622880174095298e-02*G0_2_2;
    block[669] = -5.056089582999203e-02*G0_0_0 - 4.795130120650853e-02*G0_0_1 - 5.056089582999188e-02*G0_0_2 - 4.795130120650897e-02*G0_1_0 - 4.534170658302524e-02*G0_1_1 - 4.795130120650893e-02*G0_1_2 - 5.056089582999197e-02*G0_2_0 - 4.795130120650852e-02*G0_2_1 - 5.056089582999194e-02*G0_2_2;
    block[670] = -1.565756774090084e-01*G0_0_0 - 1.539660827855251e-01*G0_0_1 - 1.565756774090086e-01*G0_0_2 - 1.539660827855253e-01*G0_1_0 - 1.513564881620419e-01*G0_1_1 - 1.539660827855250e-01*G0_1_2 - 1.565756774090085e-01*G0_2_0 - 1.539660827855251e-01*G0_2_1 - 1.565756774090086e-01*G0_2_2;
    block[671] = -5.056089582999239e-02*G0_0_0 - 4.795130120650894e-02*G0_0_1 - 5.056089582999217e-02*G0_0_2 - 4.795130120650889e-02*G0_1_0 - 4.534170658302543e-02*G0_1_1 - 4.795130120650932e-02*G0_1_2 - 5.056089582999251e-02*G0_2_0 - 4.795130120650901e-02*G0_2_1 - 5.056089582999213e-02*G0_2_2;
    block[672] = -5.512768642108867e-02*G0_0_0 - 5.512768642108867e-02*G0_0_1 - 5.512768642108865e-02*G0_0_2 - 1.787050398161484e-02*G0_1_0 - 1.787050398161486e-02*G0_1_1 - 1.787050398161491e-02*G0_1_2 - 1.787050398161484e-02*G0_2_0 - 1.787050398161485e-02*G0_2_1 - 1.787050398161490e-02*G0_2_2;
    block[673] = 1.533136841296541e-02*G0_0_0 + 1.053101910306754e-02*G0_1_0 + 1.053101910306754e-02*G0_2_0;
    block[674] = -4.800349309897781e-03*G0_1_1 - 4.800349309897778e-03*G0_2_1;
    block[675] = -4.800349309897879e-03*G0_1_2 - 4.800349309897894e-03*G0_2_2;
    block[676] = 2.208369450122905e-02*G0_0_0 + 2.745945942560494e-02*G0_0_1 + 2.745945942560494e-02*G0_1_0 + 3.283522434998090e-02*G0_1_1 + 2.745945942560495e-02*G0_2_0 + 3.283522434998094e-02*G0_2_1;
    block[677] = 6.589226424295734e-03*G0_0_0 + 8.879145706402554e-03*G0_0_1 + 8.879145706402575e-03*G0_1_0 + 1.116906498850930e-02*G0_1_1 + 8.879145706402549e-03*G0_2_0 + 1.116906498850924e-02*G0_2_1;
    block[678] = 9.394540644540527e-03*G0_0_0 + 1.168445992664730e-02*G0_0_1 + 1.168445992664714e-02*G0_1_0 + 1.397437920875403e-02*G0_1_1 + 1.168445992664714e-02*G0_2_0 + 1.397437920875407e-02*G0_2_1;
    block[679] = 5.375764924375922e-03*G0_0_1 + 5.375764924376245e-03*G0_1_0 + 1.075152984875197e-02*G0_1_1 + 5.375764924376211e-03*G0_2_0 + 1.075152984875191e-02*G0_2_1;
    block[680] = -5.375764924375999e-03*G0_0_1 - 5.375764924376231e-03*G0_1_0 + 2.208369450122871e-02*G0_1_1 - 5.375764924376245e-03*G0_1_2 - 5.375764924376196e-03*G0_2_0 + 2.208369450122872e-02*G0_2_1 - 5.375764924376208e-03*G0_2_2;
    block[681] = 9.394540644540483e-03*G0_0_0 + 2.837281754382420e-02*G0_0_1 + 9.394540644540469e-03*G0_0_2 + 2.837281754382434e-02*G0_1_0 - 3.154347501135633e-02*G0_1_1 + 2.837281754382432e-02*G0_1_2 + 2.837281754382432e-02*G0_2_0 - 3.154347501135633e-02*G0_2_1 + 2.837281754382430e-02*G0_2_2;
    block[682] = -1.869122149070028e-02*G0_0_0 - 5.741760570319534e-02*G0_0_1 - 1.869122149070031e-02*G0_0_2 - 5.741760570319535e-02*G0_1_0 + 1.249343425992714e-02*G0_1_1 - 5.741760570319532e-02*G0_1_2 - 5.741760570319535e-02*G0_2_0 + 1.249343425992714e-02*G0_2_1 - 5.741760570319533e-02*G0_2_2;
    block[683] = 1.963719954171308e-02*G0_0_0 + 8.954823950483576e-02*G0_0_1 + 1.963719954171308e-02*G0_0_2 + 8.954823950483580e-02*G0_1_0 + 1.963719954171314e-02*G0_1_1 + 8.954823950483579e-02*G0_1_2 + 8.954823950483581e-02*G0_2_0 + 1.963719954171313e-02*G0_2_1 + 8.954823950483577e-02*G0_2_2;
    block[684] = 1.790964790096716e-01*G0_0_0 + 1.091854390465489e-01*G0_0_1 + 1.091854390465488e-01*G0_0_2 + 1.091854390465489e-01*G0_1_0 + 1.790964790096715e-01*G0_1_1 + 1.790964790096715e-01*G0_1_2 + 1.091854390465489e-01*G0_2_0 + 1.790964790096715e-01*G0_2_1 + 1.790964790096715e-01*G0_2_2;
    block[685] = -2.433577466129525e-01*G0_0_0 - 1.083373207939168e-01*G0_0_1 - 1.083373207939168e-01*G0_0_2 - 1.734467066498297e-01*G0_1_0 - 1.470637050064117e-01*G0_1_1 - 1.470637050064117e-01*G0_1_2 - 1.734467066498297e-01*G0_2_0 - 1.470637050064117e-01*G0_2_1 - 1.470637050064117e-01*G0_2_2;
    block[686] = 1.852681702942099e-01*G0_0_0 + 8.173902759406139e-02*G0_0_1 + 8.173902759406138e-02*G0_0_2 + 1.253518777390290e-01*G0_1_0 + 1.007173044933451e-01*G0_1_1 + 1.007173044933451e-01*G0_1_2 + 1.253518777390291e-01*G0_2_0 + 1.007173044933451e-01*G0_2_1 + 1.007173044933451e-01*G0_2_2;
    block[687] = -8.121058468280595e-02*G0_0_0 - 2.745945942560496e-02*G0_0_1 - 2.745945942560499e-02*G0_0_2 - 5.375112525720092e-02*G0_1_0 - 3.283522434998085e-02*G0_1_1 - 3.283522434998087e-02*G0_1_2 - 5.375112525720095e-02*G0_2_0 - 3.283522434998089e-02*G0_2_1 - 3.283522434998091e-02*G0_2_2;
    block[688] = 1.963719954171322e-02*G0_0_0 + 1.963719954171322e-02*G0_0_1 + 8.954823950483592e-02*G0_0_2 + 8.954823950483584e-02*G0_1_0 + 8.954823950483583e-02*G0_1_1 + 1.963719954171318e-02*G0_1_2 + 8.954823950483584e-02*G0_2_0 + 8.954823950483583e-02*G0_2_1 + 1.963719954171319e-02*G0_2_2;
    block[689] = -1.869122149070042e-02*G0_0_0 - 1.869122149070038e-02*G0_0_1 - 5.741760570319564e-02*G0_0_2 - 5.741760570319540e-02*G0_1_0 - 5.741760570319535e-02*G0_1_1 + 1.249343425992730e-02*G0_1_2 - 5.741760570319539e-02*G0_2_0 - 5.741760570319536e-02*G0_2_1 + 1.249343425992731e-02*G0_2_2;
    block[690] = 9.394540644540631e-03*G0_0_0 + 9.394540644540615e-03*G0_0_1 + 2.837281754382426e-02*G0_0_2 + 2.837281754382427e-02*G0_1_0 + 2.837281754382427e-02*G0_1_1 - 3.154347501135688e-02*G0_1_2 + 2.837281754382426e-02*G0_2_0 + 2.837281754382425e-02*G0_2_1 - 3.154347501135690e-02*G0_2_2;
    block[691] = -5.375764924376071e-03*G0_0_2 - 5.375764924376096e-03*G0_1_0 - 5.375764924376093e-03*G0_1_1 + 2.208369450122903e-02*G0_1_2 - 5.375764924376059e-03*G0_2_0 - 5.375764924376057e-03*G0_2_1 + 2.208369450122907e-02*G0_2_2;
    block[692] = 2.208369450122908e-02*G0_0_0 + 2.745945942560489e-02*G0_0_2 + 2.745945942560495e-02*G0_1_0 + 3.283522434998085e-02*G0_1_2 + 2.745945942560498e-02*G0_2_0 + 3.283522434998088e-02*G0_2_2;
    block[693] = 6.589226424295752e-03*G0_0_0 + 8.879145706402636e-03*G0_0_2 + 8.879145706402596e-03*G0_1_0 + 1.116906498850931e-02*G0_1_2 + 8.879145706402554e-03*G0_2_0 + 1.116906498850928e-02*G0_2_2;
    block[694] = 9.394540644540619e-03*G0_0_0 + 1.168445992664731e-02*G0_0_2 + 1.168445992664720e-02*G0_1_0 + 1.397437920875404e-02*G0_1_2 + 1.168445992664722e-02*G0_2_0 + 1.397437920875405e-02*G0_2_2;
    block[695] = 5.375764924376111e-03*G0_0_2 + 5.375764924376161e-03*G0_1_0 + 1.075152984875210e-02*G0_1_2 + 5.375764924376126e-03*G0_2_0 + 1.075152984875209e-02*G0_2_2;
    block[696] = 5.375764924375917e-03*G0_1_1 + 5.375764924376171e-03*G0_1_2 + 5.375764924375883e-03*G0_2_1 + 5.375764924376138e-03*G0_2_2;
    block[697] = 2.289919282106858e-03*G0_1_1 + 2.289919282106566e-03*G0_1_2 + 2.289919282106886e-03*G0_2_1 + 2.289919282106603e-03*G0_2_2;
    block[698] = 2.289919282106602e-03*G0_1_1 + 2.289919282106822e-03*G0_1_2 + 2.289919282106597e-03*G0_2_1 + 2.289919282106793e-03*G0_2_2;
    block[699] = 5.375764924376103e-03*G0_1_1 + 5.375764924376053e-03*G0_1_2 + 5.375764924376072e-03*G0_2_1 + 5.375764924376049e-03*G0_2_2;
    block[700] = 4.534170658302528e-02*G0_0_0 + 5.473624722756606e-02*G0_0_1 + 5.473624722756605e-02*G0_0_2 + 5.473624722756577e-02*G0_1_0 + 6.413078787210637e-02*G0_1_1 + 6.413078787210630e-02*G0_1_2 + 5.473624722756574e-02*G0_2_0 + 6.413078787210637e-02*G0_2_1 + 6.413078787210631e-02*G0_2_2;
    block[701] = 2.267085329151297e-02*G0_0_0 + 2.596546650366074e-02*G0_0_1 + 2.596546650366063e-02*G0_0_2 + 2.596546650366087e-02*G0_1_0 + 2.926007971580858e-02*G0_1_1 + 2.926007971580854e-02*G0_1_2 + 2.596546650366086e-02*G0_2_0 + 2.926007971580857e-02*G0_2_1 + 2.926007971580853e-02*G0_2_2;
    block[702] = 9.394540644540806e-03*G0_0_1 + 9.394540644540711e-03*G0_0_2 + 9.394540644540572e-03*G0_1_0 + 1.878908128908123e-02*G0_1_1 + 1.878908128908108e-02*G0_1_2 + 9.394540644540485e-03*G0_2_0 + 1.878908128908116e-02*G0_2_1 + 1.878908128908098e-02*G0_2_2;
    block[703] = 2.267085329151260e-02*G0_0_0 + 2.596546650366031e-02*G0_0_1 + 2.596546650366042e-02*G0_0_2 + 2.596546650366057e-02*G0_1_0 + 2.926007971580831e-02*G0_1_1 + 2.926007971580835e-02*G0_1_2 + 2.596546650366056e-02*G0_2_0 + 2.926007971580824e-02*G0_2_1 + 2.926007971580831e-02*G0_2_2;
    block[704] = 3.294613212147825e-03*G0_0_1 + 3.294613212147859e-03*G0_0_2 + 3.294613212147779e-03*G0_1_0 + 6.589226424295785e-03*G0_1_1 + 6.589226424295754e-03*G0_1_2 + 3.294613212147848e-03*G0_2_0 + 6.589226424295803e-03*G0_2_1 + 6.589226424295862e-03*G0_2_2;
    block[705] = 9.394540644540556e-03*G0_0_1 + 9.394540644540431e-03*G0_0_2 + 9.394540644540584e-03*G0_1_0 + 1.878908128908110e-02*G0_1_1 + 1.878908128908113e-02*G0_1_2 + 9.394540644540541e-03*G0_2_0 + 1.878908128908112e-02*G0_2_1 + 1.878908128908105e-02*G0_2_2;
    block[706] = -9.394540644540626e-03*G0_0_1 - 9.394540644540497e-03*G0_0_2 - 9.394540644540643e-03*G0_1_0 - 3.066273682593081e-02*G0_1_1 - 3.066273682593079e-02*G0_1_2 - 9.394540644540598e-03*G0_2_0 - 3.066273682593074e-02*G0_2_1 - 3.066273682593080e-02*G0_2_2;
    block[707] = -3.294613212147709e-03*G0_0_1 - 3.294613212147885e-03*G0_0_2 - 3.294613212147764e-03*G0_1_0 - 9.133581182192135e-03*G0_1_1 - 9.133581182191963e-03*G0_1_2 - 3.294613212147830e-03*G0_2_0 - 9.133581182192192e-03*G0_2_1 - 9.133581182191958e-03*G0_2_2;
    block[708] = -9.394540644540553e-03*G0_0_1 - 9.394540644540502e-03*G0_0_2 - 9.394540644540605e-03*G0_1_0 - 3.066273682593091e-02*G0_1_1 - 3.066273682593136e-02*G0_1_2 - 9.394540644540516e-03*G0_2_0 - 3.066273682593088e-02*G0_2_1 - 3.066273682593136e-02*G0_2_2;
    block[709] = 2.267085329151274e-02*G0_0_0 + 2.198583470284839e-02*G0_0_1 + 2.198583470284823e-02*G0_0_2 + 2.198583470284802e-02*G0_1_0 + 6.426126760328058e-02*G0_1_1 + 6.426126760328056e-02*G0_1_2 + 2.198583470284798e-02*G0_2_0 + 6.426126760328062e-02*G0_2_1 + 6.426126760328058e-02*G0_2_2;
    block[710] = 2.267085329151270e-02*G0_0_0 + 2.198583470284802e-02*G0_0_1 + 2.198583470284826e-02*G0_0_2 + 2.198583470284845e-02*G0_1_0 + 6.426126760328060e-02*G0_1_1 + 6.426126760328117e-02*G0_1_2 + 2.198583470284846e-02*G0_2_0 + 6.426126760328060e-02*G0_2_1 + 6.426126760328120e-02*G0_2_2;
    block[711] = -6.067307499599085e-02*G0_0_0 - 3.222849360002097e-02*G0_0_1 - 3.222849360002089e-02*G0_0_2 - 3.222849360002089e-02*G0_1_0 - 1.285225352065615e-01*G0_1_1 - 1.285225352065618e-01*G0_1_2 - 3.222849360002089e-02*G0_2_0 - 1.285225352065615e-01*G0_2_1 - 1.285225352065618e-01*G0_2_2;
    block[712] = -1.878908128908136e-02*G0_0_0 - 9.394540644540861e-03*G0_0_1 - 4.005727747047163e-02*G0_0_2 - 4.005727747047155e-02*G0_1_0 - 1.878908128908122e-02*G0_1_1 - 6.132547365186225e-02*G0_1_2 - 4.005727747047155e-02*G0_2_0 - 1.878908128908115e-02*G0_2_1 - 6.132547365186223e-02*G0_2_2;
    block[713] = -3.186967433929184e-02*G0_0_0 - 2.596546650366069e-02*G0_0_1 - 3.770864230933643e-02*G0_0_2 - 3.770864230933622e-02*G0_1_0 - 2.926007971580847e-02*G0_1_1 - 4.354761027938047e-02*G0_1_2 - 3.770864230933620e-02*G0_2_0 - 2.926007971580846e-02*G0_2_1 - 4.354761027938046e-02*G0_2_2;
    block[714] = -6.934997711907390e-02*G0_0_0 - 5.473624722756624e-02*G0_0_1 - 9.061817330046390e-02*G0_0_2 - 9.061817330046427e-02*G0_1_0 - 6.413078787210659e-02*G0_1_1 - 1.118863694818545e-01*G0_1_2 - 9.061817330046432e-02*G0_2_0 - 6.413078787210662e-02*G0_2_1 - 1.118863694818545e-01*G0_2_2;
    block[715] = 4.397166940569663e-02*G0_0_0 + 4.465668799436129e-02*G0_0_1 + 8.624710230612945e-02*G0_0_2 + 8.624710230612917e-02*G0_1_0 + 4.397166940569691e-02*G0_1_1 + 1.285225352065622e-01*G0_1_2 + 8.624710230612920e-02*G0_2_0 + 4.397166940569689e-02*G0_2_1 + 1.285225352065622e-01*G0_2_2;
    block[716] = 9.208607027617376e-02*G0_0_0 + 1.280006162818650e-01*G0_0_1 + 1.343615031766058e-01*G0_0_2 + 1.343615031766063e-01*G0_1_0 + 1.273155976932005e-01*G0_1_1 + 1.766369360770386e-01*G0_1_2 + 1.343615031766064e-01*G0_2_0 + 1.273155976932005e-01*G0_2_1 + 1.766369360770385e-01*G0_2_2;
    block[717] = -6.445698720004228e-02*G0_0_0 - 9.290156859601223e-02*G0_0_1 - 1.607510288065825e-01*G0_0_2 - 1.607510288065830e-01*G0_1_0 - 6.445698720004227e-02*G0_1_1 - 2.570450704131235e-01*G0_1_2 - 1.607510288065830e-01*G0_2_0 - 6.445698720004227e-02*G0_2_1 - 2.570450704131235e-01*G0_2_2;
    block[718] = -6.445698720004191e-02*G0_0_0 - 1.607510288065823e-01*G0_0_1 - 9.290156859601201e-02*G0_0_2 - 1.607510288065826e-01*G0_1_0 - 2.570450704131231e-01*G0_1_1 - 6.445698720004185e-02*G0_1_2 - 1.607510288065826e-01*G0_2_0 - 2.570450704131232e-01*G0_2_1 - 6.445698720004187e-02*G0_2_2;
    block[719] = 9.208607027617349e-02*G0_0_0 + 1.343615031766060e-01*G0_0_1 + 1.280006162818651e-01*G0_0_2 + 1.343615031766059e-01*G0_1_0 + 1.766369360770385e-01*G0_1_1 + 1.273155976932004e-01*G0_1_2 + 1.343615031766059e-01*G0_2_0 + 1.766369360770385e-01*G0_2_1 + 1.273155976932004e-01*G0_2_2;
    block[720] = -6.934997711907373e-02*G0_0_0 - 9.061817330046400e-02*G0_0_1 - 5.473624722756627e-02*G0_0_2 - 9.061817330046415e-02*G0_1_0 - 1.118863694818546e-01*G0_1_1 - 6.413078787210674e-02*G0_1_2 - 9.061817330046414e-02*G0_2_0 - 1.118863694818545e-01*G0_2_1 - 6.413078787210674e-02*G0_2_2;
    block[721] = 4.397166940569648e-02*G0_0_0 + 8.624710230612892e-02*G0_0_1 + 4.465668799436105e-02*G0_0_2 + 8.624710230612903e-02*G0_1_0 + 1.285225352065613e-01*G0_1_1 + 4.397166940569650e-02*G0_1_2 + 8.624710230612904e-02*G0_2_0 + 1.285225352065614e-01*G0_2_1 + 4.397166940569647e-02*G0_2_2;
    block[722] = -3.186967433929189e-02*G0_0_0 - 3.770864230933634e-02*G0_0_1 - 2.596546650366038e-02*G0_0_2 - 3.770864230933607e-02*G0_1_0 - 4.354761027938045e-02*G0_1_1 - 2.926007971580820e-02*G0_1_2 - 3.770864230933607e-02*G0_2_0 - 4.354761027938050e-02*G0_2_1 - 2.926007971580816e-02*G0_2_2;
    block[723] = -1.878908128908098e-02*G0_0_0 - 4.005727747047135e-02*G0_0_1 - 9.394540644540468e-03*G0_0_2 - 4.005727747047151e-02*G0_1_0 - 6.132547365186182e-02*G0_1_1 - 1.878908128908116e-02*G0_1_2 - 4.005727747047149e-02*G0_2_0 - 6.132547365186176e-02*G0_2_1 - 1.878908128908108e-02*G0_2_2;
    block[724] = 1.666878565750073e-01*G0_0_0 + 1.314583291579807e-01*G0_0_1 + 1.314583291579804e-01*G0_0_2 + 1.314583291579801e-01*G0_1_0 + 9.622880174095319e-02*G0_1_1 + 9.622880174095301e-02*G0_1_2 + 1.314583291579800e-01*G0_2_0 + 9.622880174095325e-02*G0_2_1 + 9.622880174095295e-02*G0_2_2;
    block[725] = -1.513564881620417e-01*G0_0_0 - 1.539660827855251e-01*G0_0_1 - 1.539660827855254e-01*G0_0_2 - 1.539660827855250e-01*G0_1_0 - 1.565756774090086e-01*G0_1_1 - 1.565756774090086e-01*G0_1_2 - 1.539660827855249e-01*G0_2_0 - 1.565756774090085e-01*G0_2_1 - 1.565756774090085e-01*G0_2_2;
    block[726] = -4.534170658302530e-02*G0_0_0 - 4.795130120650910e-02*G0_0_1 - 4.795130120650883e-02*G0_0_2 - 4.795130120650857e-02*G0_1_0 - 5.056089582999222e-02*G0_1_1 - 5.056089582999231e-02*G0_1_2 - 4.795130120650852e-02*G0_2_0 - 5.056089582999222e-02*G0_2_1 - 5.056089582999240e-02*G0_2_2;
    block[727] = -4.534170658302560e-02*G0_0_0 - 4.795130120650892e-02*G0_0_1 - 4.795130120650927e-02*G0_0_2 - 4.795130120650921e-02*G0_1_0 - 5.056089582999256e-02*G0_1_1 - 5.056089582999224e-02*G0_1_2 - 4.795130120650920e-02*G0_2_0 - 5.056089582999255e-02*G0_2_1 - 5.056089582999213e-02*G0_2_2;
    block[728] = 5.512768642108867e-02*G0_0_0 + 5.512768642108865e-02*G0_0_1 + 5.512768642108867e-02*G0_0_2 + 2.146913496739864e-02*G0_1_0 + 2.146913496739864e-02*G0_1_1 + 2.146913496739867e-02*G0_1_2 + 2.146913496739865e-02*G0_2_0 + 2.146913496739865e-02*G0_2_1 + 2.146913496739868e-02*G0_2_2;
    block[729] = -3.881772002431678e-02*G0_0_0 - 2.326323127104346e-02*G0_1_0 - 2.326323127104345e-02*G0_2_0;
    block[730] = -3.365072266981978e-03*G0_1_1 - 3.365072266981965e-03*G0_2_1;
    block[731] = -3.365072266981978e-03*G0_1_2 - 3.365072266981967e-03*G0_2_2;
    block[732] = -3.154347501135667e-02*G0_0_0 - 5.991629255518074e-02*G0_0_1 - 5.991629255518076e-02*G0_1_0 - 7.889456945446431e-02*G0_1_1 - 5.991629255518076e-02*G0_2_0 - 7.889456945446431e-02*G0_2_1;
    block[733] = -6.263027096360362e-03*G0_0_0 - 5.780252091015998e-03*G0_0_1 - 5.780252091015881e-03*G0_1_0 - 5.232237220084450e-03*G0_1_1 - 5.780252091015823e-03*G0_2_0 - 5.232237220084385e-03*G0_2_1;
    block[734] = 6.523986558717866e-05*G0_0_0 - 1.315235690235677e-02*G0_0_1 - 1.315235690235673e-02*G0_1_0 - 2.630471380471341e-02*G0_1_1 - 1.315235690235680e-02*G0_2_0 - 2.630471380471349e-02*G0_2_1;
    block[735] = 2.289919282106706e-03*G0_0_1 + 2.289919282106628e-03*G0_1_0 + 1.397437920875389e-02*G0_1_1 + 2.289919282106663e-03*G0_2_0 + 1.397437920875391e-02*G0_2_1;
    block[736] = -2.289919282106580e-03*G0_0_1 - 2.289919282106640e-03*G0_1_0 + 6.589226424295894e-03*G0_1_1 - 2.289919282106621e-03*G0_1_2 - 2.289919282106676e-03*G0_2_0 + 6.589226424295858e-03*G0_2_1 - 2.289919282106655e-03*G0_2_2;
    block[737] = 6.523986558683313e-05*G0_0_0 - 4.827750053446550e-04*G0_0_1 + 6.523986558688935e-05*G0_0_2 - 4.827750053445865e-04*G0_1_0 - 6.263027096360544e-03*G0_1_1 - 4.827750053445398e-04*G0_1_2 - 4.827750053445688e-04*G0_2_0 - 6.263027096360502e-03*G0_2_1 - 4.827750053445220e-04*G0_2_2;
    block[738] = 2.609594623484399e-04*G0_0_0 + 5.062613569558047e-03*G0_0_1 + 2.609594623484488e-04*G0_0_2 + 5.062613569558065e-03*G0_1_0 + 2.609594623484930e-04*G0_1_1 + 5.062613569558043e-03*G0_1_2 + 5.062613569558037e-03*G0_2_0 + 2.609594623484528e-04*G0_2_1 + 5.062613569558013e-03*G0_2_2;
    block[739] = 1.249343425992730e-02*G0_0_0 - 5.741760570319539e-02*G0_0_1 + 1.249343425992730e-02*G0_0_2 - 5.741760570319547e-02*G0_1_0 - 1.869122149070052e-02*G0_1_1 - 5.741760570319539e-02*G0_1_2 - 5.741760570319542e-02*G0_2_0 - 1.869122149070051e-02*G0_2_1 - 5.741760570319535e-02*G0_2_2;
    block[740] = -2.433577466129525e-01*G0_0_0 - 1.734467066498297e-01*G0_0_1 - 1.734467066498297e-01*G0_0_2 - 1.083373207939168e-01*G0_1_0 - 1.470637050064117e-01*G0_1_1 - 1.470637050064117e-01*G0_1_2 - 1.083373207939168e-01*G0_2_0 - 1.470637050064117e-01*G0_2_1 - 1.470637050064117e-01*G0_2_2;
    block[741] = 4.289651642082154e-01*G0_0_0 + 2.260952781786089e-01*G0_0_1 + 2.260952781786089e-01*G0_0_2 + 2.260952781786089e-01*G0_1_0 + 3.042265412057046e-01*G0_1_1 + 3.042265412057045e-01*G0_1_2 + 2.260952781786089e-01*G0_2_0 + 3.042265412057045e-01*G0_2_1 + 3.042265412057045e-01*G0_2_2;
    block[742] = -3.871855542862447e-01*G0_0_0 - 1.676925505050486e-01*G0_0_1 - 1.676925505050486e-01*G0_0_2 - 2.194930037811959e-01*G0_1_0 - 2.041877313144654e-01*G0_1_1 - 2.041877313144653e-01*G0_1_2 - 2.194930037811958e-01*G0_2_0 - 2.041877313144653e-01*G0_2_1 - 2.041877313144652e-01*G0_2_2;
    block[743] = 1.852681702942098e-01*G0_0_0 + 5.991629255518079e-02*G0_0_1 + 5.991629255518081e-02*G0_0_2 + 1.035291427001484e-01*G0_1_0 + 7.889456945446441e-02*G0_1_1 + 7.889456945446434e-02*G0_1_2 + 1.035291427001484e-01*G0_2_0 + 7.889456945446439e-02*G0_2_1 + 7.889456945446433e-02*G0_2_2;
    block[744] = 1.249343425992729e-02*G0_0_0 + 1.249343425992731e-02*G0_0_1 - 5.741760570319538e-02*G0_0_2 - 5.741760570319549e-02*G0_1_0 - 5.741760570319548e-02*G0_1_1 - 1.869122149070049e-02*G0_1_2 - 5.741760570319545e-02*G0_2_0 - 5.741760570319541e-02*G0_2_1 - 1.869122149070050e-02*G0_2_2;
    block[745] = 2.609594623482672e-04*G0_0_0 + 2.609594623482150e-04*G0_0_1 + 5.062613569558020e-03*G0_0_2 + 5.062613569557988e-03*G0_1_0 + 5.062613569558008e-03*G0_1_1 + 2.609594623484282e-04*G0_1_2 + 5.062613569557953e-03*G0_2_0 + 5.062613569557976e-03*G0_2_1 + 2.609594623484349e-04*G0_2_2;
    block[746] = 6.523986558692388e-05*G0_0_0 + 6.523986558694900e-05*G0_0_1 - 4.827750053445552e-04*G0_0_2 - 4.827750053445080e-04*G0_1_0 - 4.827750053445272e-04*G0_1_1 - 6.263027096360455e-03*G0_1_2 - 4.827750053444644e-04*G0_2_0 - 4.827750053444829e-04*G0_2_1 - 6.263027096360445e-03*G0_2_2;
    block[747] = -2.289919282106618e-03*G0_0_2 - 2.289919282106674e-03*G0_1_0 - 2.289919282106681e-03*G0_1_1 + 6.589226424295900e-03*G0_1_2 - 2.289919282106739e-03*G0_2_0 - 2.289919282106745e-03*G0_2_1 + 6.589226424295877e-03*G0_2_2;
    block[748] = -3.154347501135672e-02*G0_0_0 - 5.991629255518065e-02*G0_0_2 - 5.991629255518081e-02*G0_1_0 - 7.889456945446428e-02*G0_1_2 - 5.991629255518082e-02*G0_2_0 - 7.889456945446427e-02*G0_2_2;
    block[749] = -6.263027096360290e-03*G0_0_0 - 5.780252091016011e-03*G0_0_2 - 5.780252091016117e-03*G0_1_0 - 5.232237220084665e-03*G0_1_2 - 5.780252091016115e-03*G0_2_0 - 5.232237220084676e-03*G0_2_2;
    block[750] = 6.523986558709713e-05*G0_0_0 - 1.315235690235674e-02*G0_0_2 - 1.315235690235657e-02*G0_1_0 - 2.630471380471328e-02*G0_1_2 - 1.315235690235662e-02*G0_2_0 - 2.630471380471331e-02*G0_2_2;
    block[751] = 2.289919282106671e-03*G0_0_2 + 2.289919282106580e-03*G0_1_0 + 1.397437920875391e-02*G0_1_2 + 2.289919282106644e-03*G0_2_0 + 1.397437920875395e-02*G0_2_2;
    block[752] = 2.289919282106632e-03*G0_1_1 + 2.289919282106612e-03*G0_1_2 + 2.289919282106633e-03*G0_2_1 + 2.289919282106648e-03*G0_2_2;
    block[753] = 1.787572317086212e-03*G0_1_1 + 1.787572317086222e-03*G0_1_2 + 1.787572317086241e-03*G0_2_1 + 1.787572317086205e-03*G0_2_2;
    block[754] = 1.787572317086206e-03*G0_1_1 + 1.787572317086197e-03*G0_1_2 + 1.787572317086147e-03*G0_2_1 + 1.787572317086175e-03*G0_2_2;
    block[755] = 2.289919282106636e-03*G0_1_1 + 2.289919282106701e-03*G0_1_2 + 2.289919282106700e-03*G0_2_1 + 2.289919282106732e-03*G0_2_2;
    block[756] = -6.654466289882854e-02*G0_0_0 - 8.931337598872217e-02*G0_0_1 - 8.931337598872224e-02*G0_0_2 - 8.931337598872208e-02*G0_1_0 - 1.270872581636456e-01*G0_1_1 - 1.270872581636454e-01*G0_1_2 - 8.931337598872204e-02*G0_2_0 - 1.270872581636456e-01*G0_2_1 - 1.270872581636453e-01*G0_2_2;
    block[757] = -6.523986558710406e-04*G0_0_0 - 9.492400442921170e-03*G0_0_1 - 9.492400442921047e-03*G0_0_2 - 9.492400442921120e-03*G0_1_0 - 1.898480088584247e-02*G0_1_1 - 1.898480088584229e-02*G0_1_2 - 9.492400442921113e-03*G0_2_0 - 1.898480088584253e-02*G0_2_1 - 1.898480088584228e-02*G0_2_2;
    block[758] = 6.523986558693378e-05*G0_0_1 + 6.523986558690068e-05*G0_0_2 + 6.523986558701750e-05*G0_1_0 - 1.487468935385578e-02*G0_1_1 - 1.487468935385588e-02*G0_1_2 + 6.523986558705072e-05*G0_2_0 - 1.487468935385573e-02*G0_2_1 - 1.487468935385589e-02*G0_2_2;
    block[759] = -6.523986558708283e-04*G0_0_0 - 9.492400442920846e-03*G0_0_1 - 9.492400442921005e-03*G0_0_2 - 9.492400442920993e-03*G0_1_0 - 1.898480088584199e-02*G0_1_1 - 1.898480088584214e-02*G0_1_2 - 9.492400442921016e-03*G0_2_0 - 1.898480088584188e-02*G0_2_1 - 1.898480088584217e-02*G0_2_2;
    block[760] = 2.576974690689885e-03*G0_0_1 + 2.576974690689978e-03*G0_0_2 + 2.576974690689970e-03*G0_1_0 + 4.501550725509000e-03*G0_1_1 + 4.501550725508941e-03*G0_1_2 + 2.576974690689926e-03*G0_2_0 + 4.501550725509004e-03*G0_2_1 + 4.501550725508970e-03*G0_2_2;
    block[761] = 6.523986558701536e-05*G0_0_1 + 6.523986558694884e-05*G0_0_2 + 6.523986558689740e-05*G0_1_0 - 1.487468935385599e-02*G0_1_1 - 1.487468935385593e-02*G0_1_2 + 6.523986558692248e-05*G0_2_0 - 1.487468935385604e-02*G0_2_1 - 1.487468935385596e-02*G0_2_2;
    block[762] = -6.523986558682446e-05*G0_0_1 - 6.523986558700994e-05*G0_0_2 - 6.523986558684100e-05*G0_1_0 - 1.304797311741545e-03*G0_1_1 - 1.304797311741609e-03*G0_1_2 - 6.523986558686567e-05*G0_2_0 - 1.304797311741527e-03*G0_2_1 - 1.304797311741616e-03*G0_2_2;
    block[763] = -2.576974690690351e-03*G0_0_1 - 2.576974690690109e-03*G0_0_2 - 2.576974690689962e-03*G0_1_0 - 1.565756774090101e-02*G0_1_1 - 1.565756774090101e-02*G0_1_2 - 2.576974690689919e-03*G0_2_0 - 1.565756774090100e-02*G0_2_1 - 1.565756774090097e-02*G0_2_2;
    block[764] = -6.523986558693011e-05*G0_0_1 - 6.523986558704993e-05*G0_0_2 - 6.523986558698303e-05*G0_1_0 - 1.304797311741615e-03*G0_1_1 - 1.304797311741691e-03*G0_1_2 - 6.523986558701668e-05*G0_2_0 - 1.304797311741599e-03*G0_2_1 - 1.304797311741744e-03*G0_2_2;
    block[765] = -6.523986558708575e-04*G0_0_0 + 2.316015228341495e-03*G0_0_1 + 2.316015228341693e-03*G0_0_2 + 2.316015228341602e-03*G0_1_0 + 8.807381854256710e-03*G0_1_1 + 8.807381854256656e-03*G0_1_2 + 2.316015228341576e-03*G0_2_0 + 8.807381854256668e-03*G0_2_1 + 8.807381854256655e-03*G0_2_2;
    block[766] = -6.523986558707924e-04*G0_0_0 + 2.316015228342074e-03*G0_0_1 + 2.316015228341758e-03*G0_0_2 + 2.316015228341563e-03*G0_1_0 + 8.807381854256825e-03*G0_1_1 + 8.807381854256856e-03*G0_1_2 + 2.316015228341557e-03*G0_2_0 + 8.807381854256821e-03*G0_2_1 + 8.807381854256885e-03*G0_2_2;
    block[767] = 4.762510187857342e-02*G0_0_0 - 1.474420962268182e-02*G0_0_1 - 1.474420962268194e-02*G0_0_2 - 1.474420962268168e-02*G0_1_0 + 4.762510187857370e-02*G0_1_1 + 4.762510187857374e-02*G0_1_2 - 1.474420962268164e-02*G0_2_0 + 4.762510187857369e-02*G0_2_1 + 4.762510187857366e-02*G0_2_2;
    block[768] = -1.304797311739148e-04*G0_0_0 - 6.523986558686022e-05*G0_0_1 + 1.363513190770126e-02*G0_0_2 + 1.363513190770127e-02*G0_1_0 + 1.487468935385588e-02*G0_1_1 - 2.544354757896386e-02*G0_1_2 + 1.363513190770127e-02*G0_2_0 + 1.487468935385583e-02*G0_2_1 - 2.544354757896388e-02*G0_2_2;
    block[769] = 1.278701365506870e-02*G0_0_0 + 9.492400442921108e-03*G0_0_1 + 3.787174197330416e-02*G0_0_2 + 3.787174197330401e-02*G0_1_0 + 1.898480088584228e-02*G0_1_1 + 5.675868306076565e-02*G0_1_2 + 3.787174197330407e-02*G0_2_0 + 1.898480088584235e-02*G0_2_1 + 5.675868306076568e-02*G0_2_2;
    block[770] = 8.468134553203938e-02*G0_0_0 + 8.931337598872247e-02*G0_0_1 + 1.734728025960646e-01*G0_0_2 + 1.734728025960652e-01*G0_1_0 + 1.270872581636459e-01*G0_1_1 + 2.094199685345501e-01*G0_1_2 + 1.734728025960652e-01*G0_2_0 + 1.270872581636459e-01*G0_2_1 + 2.094199685345500e-01*G0_2_2;
    block[771] = -6.784946021056773e-03*G0_0_0 - 9.753359905269612e-03*G0_0_1 - 3.715410345184609e-02*G0_0_2 - 3.715410345184620e-02*G0_1_0 - 4.364547007776132e-02*G0_1_1 + 3.718672338463969e-02*G0_1_2 - 3.715410345184623e-02*G0_2_0 - 4.364547007776132e-02*G0_2_1 + 3.718672338463971e-02*G0_2_2;
    block[772] = -6.223883177008119e-02*G0_0_0 - 1.607836487393765e-01*G0_0_1 - 2.508146632495565e-01*G0_0_2 - 2.508146632495571e-01*G0_1_0 - 1.669488160373562e-01*G0_1_1 - 3.346805104617576e-01*G0_1_2 - 2.508146632495570e-01*G0_2_0 - 1.669488160373562e-01*G0_2_1 - 3.346805104617574e-01*G0_2_2;
    block[773] = -3.392473010528656e-03*G0_0_0 + 5.897683849072675e-02*G0_0_1 + 1.946757589118678e-01*G0_0_2 + 1.946757589118684e-01*G0_1_0 + 1.323064474106129e-01*G0_1_1 + 1.213461499919822e-01*G0_1_2 + 1.946757589118684e-01*G0_2_0 + 1.323064474106129e-01*G0_2_1 + 1.213461499919821e-01*G0_2_2;
    block[774] = -3.392473010528993e-03*G0_0_0 + 1.946757589118678e-01*G0_0_1 + 5.897683849072684e-02*G0_0_2 + 1.946757589118683e-01*G0_1_0 + 1.213461499919821e-01*G0_1_1 + 1.323064474106128e-01*G0_1_2 + 1.946757589118683e-01*G0_2_0 + 1.213461499919821e-01*G0_2_1 + 1.323064474106128e-01*G0_2_2;
    block[775] = -6.223883177008097e-02*G0_0_0 - 2.508146632495566e-01*G0_0_1 - 1.607836487393768e-01*G0_0_2 - 2.508146632495570e-01*G0_1_0 - 3.346805104617573e-01*G0_1_1 - 1.669488160373563e-01*G0_1_2 - 2.508146632495569e-01*G0_2_0 - 3.346805104617572e-01*G0_2_1 - 1.669488160373563e-01*G0_2_2;
    block[776] = 8.468134553203924e-02*G0_0_0 + 1.734728025960647e-01*G0_0_1 + 8.931337598872262e-02*G0_0_2 + 1.734728025960650e-01*G0_1_0 + 2.094199685345499e-01*G0_1_1 + 1.270872581636458e-01*G0_1_2 + 1.734728025960650e-01*G0_2_0 + 2.094199685345497e-01*G0_2_1 + 1.270872581636458e-01*G0_2_2;
    block[777] = -6.784946021056984e-03*G0_0_0 - 3.715410345184600e-02*G0_0_1 - 9.753359905269645e-03*G0_0_2 - 3.715410345184625e-02*G0_1_0 + 3.718672338463966e-02*G0_1_1 - 4.364547007776132e-02*G0_1_2 - 3.715410345184621e-02*G0_2_0 + 3.718672338463959e-02*G0_2_1 - 4.364547007776132e-02*G0_2_2;
    block[778] = 1.278701365506892e-02*G0_0_0 + 3.787174197330421e-02*G0_0_1 + 9.492400442920943e-03*G0_0_2 + 3.787174197330386e-02*G0_1_0 + 5.675868306076555e-02*G0_1_1 + 1.898480088584203e-02*G0_1_2 + 3.787174197330381e-02*G0_2_0 + 5.675868306076559e-02*G0_2_1 + 1.898480088584205e-02*G0_2_2;
    block[779] = -1.304797311740461e-04*G0_0_0 + 1.363513190770125e-02*G0_0_1 - 6.523986558692492e-05*G0_0_2 + 1.363513190770139e-02*G0_1_0 - 2.544354757896372e-02*G0_1_1 + 1.487468935385602e-02*G0_1_2 + 1.363513190770144e-02*G0_2_0 - 2.544354757896372e-02*G0_2_1 + 1.487468935385605e-02*G0_2_2;
    block[780] = -1.617948666559759e-01*G0_0_0 - 6.621846357089335e-02*G0_0_1 - 6.621846357089332e-02*G0_0_2 - 6.621846357089321e-02*G0_1_0 - 1.565756774090092e-01*G0_1_1 - 1.565756774090091e-01*G0_1_2 - 6.621846357089314e-02*G0_2_0 - 1.565756774090091e-01*G0_2_1 - 1.565756774090091e-01*G0_2_2;
    block[781] = 1.807144276762310e-01*G0_0_0 + 1.702760491822970e-01*G0_0_1 + 1.702760491822973e-01*G0_0_2 + 1.702760491822970e-01*G0_1_0 + 1.859336169231977e-01*G0_1_1 + 1.859336169231982e-01*G0_1_2 + 1.702760491822969e-01*G0_2_0 + 1.859336169231976e-01*G0_2_1 + 1.859336169231980e-01*G0_2_2;
    block[782] = 1.304797311741660e-03*G0_0_0 + 7.176385214579717e-03*G0_0_1 + 7.176385214579639e-03*G0_0_2 + 7.176385214579394e-03*G0_1_0 + 3.914391935225253e-02*G0_1_1 + 3.914391935225238e-02*G0_1_2 + 7.176385214579448e-03*G0_2_0 + 3.914391935225252e-02*G0_2_1 + 3.914391935225236e-02*G0_2_2;
    block[783] = 1.304797311741769e-03*G0_0_0 + 7.176385214579484e-03*G0_0_1 + 7.176385214579694e-03*G0_0_2 + 7.176385214579408e-03*G0_1_0 + 3.914391935225208e-02*G0_1_1 + 3.914391935225199e-02*G0_1_2 + 7.176385214579412e-03*G0_2_0 + 3.914391935225214e-02*G0_2_1 + 3.914391935225197e-02*G0_2_2;
    block[784] = -3.881772002431683e-02*G0_0_0 - 3.881772002431681e-02*G0_0_1 - 3.881772002431683e-02*G0_0_2 - 1.555448875327332e-02*G0_1_0 - 1.555448875327332e-02*G0_1_1 - 1.555448875327336e-02*G0_1_2 - 1.555448875327332e-02*G0_2_0 - 1.555448875327333e-02*G0_2_1 - 1.555448875327337e-02*G0_2_2;
    block[785] = 5.512768642108853e-02*G0_0_0 + 3.365855145368990e-02*G0_1_0 + 3.365855145368989e-02*G0_2_0;
    block[786] = -3.365072266981852e-03*G0_1_1 - 3.365072266981857e-03*G0_2_1;
    block[787] = -3.365072266981976e-03*G0_1_2 - 3.365072266981975e-03*G0_2_2;
    block[788] = 1.249343425992723e-02*G0_0_0 + 6.991103996312248e-02*G0_0_1 + 6.991103996312259e-02*G0_1_0 + 1.086374241756173e-01*G0_1_1 + 6.991103996312249e-02*G0_2_0 + 1.086374241756172e-01*G0_2_1;
    block[789] = 2.609594623484337e-04*G0_0_0 - 4.801654107209449e-03*G0_0_1 - 4.801654107209577e-03*G0_1_0 - 9.603308214419010e-03*G0_1_1 - 4.801654107209599e-03*G0_2_0 - 9.603308214419026e-03*G0_2_1;
    block[790] = 6.523986558704155e-05*G0_0_0 + 5.480148709315861e-04*G0_0_1 + 5.480148709314844e-04*G0_1_0 - 5.232237220084372e-03*G0_1_1 + 5.480148709314807e-04*G0_2_0 - 5.232237220084397e-03*G0_2_1;
    block[791] = 2.289919282106878e-03*G0_0_1 + 2.289919282106989e-03*G0_1_0 + 1.116906498850938e-02*G0_1_1 + 2.289919282107002e-03*G0_2_0 + 1.116906498850942e-02*G0_2_1;
    block[792] = -2.289919282107003e-03*G0_0_1 - 2.289919282106981e-03*G0_1_0 + 9.394540644540201e-03*G0_1_1 - 2.289919282107020e-03*G0_1_2 - 2.289919282106994e-03*G0_2_0 + 9.394540644540213e-03*G0_2_1 - 2.289919282107032e-03*G0_2_2;
    block[793] = 6.523986558751397e-05*G0_0_0 + 1.321759676794415e-02*G0_0_1 + 6.523986558743856e-05*G0_0_2 + 1.321759676794404e-02*G0_1_0 + 6.523986558750055e-05*G0_1_1 + 1.321759676794400e-02*G0_1_2 + 1.321759676794407e-02*G0_2_0 + 6.523986558746754e-05*G0_2_1 + 1.321759676794404e-02*G0_2_2;
    block[794] = -6.263027096360721e-03*G0_0_0 - 4.827750053445689e-04*G0_0_1 - 6.263027096360734e-03*G0_0_2 - 4.827750053445347e-04*G0_1_0 + 6.523986558683865e-05*G0_1_1 - 4.827750053445437e-04*G0_1_2 - 4.827750053445420e-04*G0_2_0 + 6.523986558686856e-05*G0_2_1 - 4.827750053445506e-04*G0_2_2;
    block[795] = -3.154347501135664e-02*G0_0_0 + 2.837281754382422e-02*G0_0_1 - 3.154347501135665e-02*G0_0_2 + 2.837281754382429e-02*G0_1_0 + 9.394540644540645e-03*G0_1_1 + 2.837281754382422e-02*G0_1_2 + 2.837281754382424e-02*G0_2_0 + 9.394540644540641e-03*G0_2_1 + 2.837281754382417e-02*G0_2_2;
    block[796] = 1.852681702942099e-01*G0_0_0 + 1.253518777390291e-01*G0_0_1 + 1.253518777390291e-01*G0_0_2 + 8.173902759406138e-02*G0_1_0 + 1.007173044933451e-01*G0_1_1 + 1.007173044933451e-01*G0_1_2 + 8.173902759406138e-02*G0_2_0 + 1.007173044933451e-01*G0_2_1 + 1.007173044933451e-01*G0_2_2;
    block[797] = -3.871855542862447e-01*G0_0_0 - 2.194930037811959e-01*G0_0_1 - 2.194930037811959e-01*G0_0_2 - 1.676925505050486e-01*G0_1_0 - 2.041877313144654e-01*G0_1_1 - 2.041877313144653e-01*G0_1_2 - 1.676925505050486e-01*G0_2_0 - 2.041877313144653e-01*G0_2_1 - 2.041877313144652e-01*G0_2_2;
    block[798] = 4.289651642082152e-01*G0_0_0 + 2.028698860296060e-01*G0_0_1 + 2.028698860296060e-01*G0_0_2 + 2.028698860296060e-01*G0_1_0 + 2.810011490567019e-01*G0_1_1 + 2.810011490567018e-01*G0_1_2 + 2.028698860296060e-01*G0_2_0 + 2.810011490567018e-01*G0_2_1 + 2.810011490567018e-01*G0_2_2;
    block[799] = -2.433577466129523e-01*G0_0_0 - 6.991103996312251e-02*G0_0_1 - 6.991103996312253e-02*G0_0_2 - 1.350204258190353e-01*G0_1_0 - 1.086374241756173e-01*G0_1_1 - 1.086374241756173e-01*G0_1_2 - 1.350204258190353e-01*G0_2_0 - 1.086374241756172e-01*G0_2_1 - 1.086374241756172e-01*G0_2_2;
    block[800] = -3.154347501135671e-02*G0_0_0 - 3.154347501135675e-02*G0_0_1 + 2.837281754382411e-02*G0_0_2 + 2.837281754382426e-02*G0_1_0 + 2.837281754382421e-02*G0_1_1 + 9.394540644540574e-03*G0_1_2 + 2.837281754382422e-02*G0_2_0 + 2.837281754382417e-02*G0_2_1 + 9.394540644540586e-03*G0_2_2;
    block[801] = -6.263027096360317e-03*G0_0_0 - 6.263027096360242e-03*G0_0_1 - 4.827750053444634e-04*G0_0_2 - 4.827750053443289e-04*G0_1_0 - 4.827750053443145e-04*G0_1_1 + 6.523986558707042e-05*G0_1_2 - 4.827750053443036e-04*G0_2_0 - 4.827750053442872e-04*G0_2_1 + 6.523986558705698e-05*G0_2_2;
    block[802] = 6.523986558719020e-05*G0_0_0 + 6.523986558715027e-05*G0_0_1 + 1.321759676794404e-02*G0_0_2 + 1.321759676794378e-02*G0_1_0 + 1.321759676794377e-02*G0_1_1 + 6.523986558703070e-05*G0_1_2 + 1.321759676794375e-02*G0_2_0 + 1.321759676794374e-02*G0_2_1 + 6.523986558703593e-05*G0_2_2;
    block[803] = -2.289919282106877e-03*G0_0_2 - 2.289919282106762e-03*G0_1_0 - 2.289919282106756e-03*G0_1_1 + 9.394540644540633e-03*G0_1_2 - 2.289919282106791e-03*G0_2_0 - 2.289919282106785e-03*G0_2_1 + 9.394540644540622e-03*G0_2_2;
    block[804] = 1.249343425992730e-02*G0_0_0 + 6.991103996312240e-02*G0_0_2 + 6.991103996312260e-02*G0_1_0 + 1.086374241756172e-01*G0_1_2 + 6.991103996312251e-02*G0_2_0 + 1.086374241756171e-01*G0_2_2;
    block[805] = 2.609594623481759e-04*G0_0_0 - 4.801654107209474e-03*G0_0_2 - 4.801654107209452e-03*G0_1_0 - 9.603308214418828e-03*G0_1_2 - 4.801654107209386e-03*G0_2_0 - 9.603308214418708e-03*G0_2_2;
    block[806] = 6.523986558718915e-05*G0_0_0 + 5.480148709314933e-04*G0_0_2 + 5.480148709314528e-04*G0_1_0 - 5.232237220084740e-03*G0_1_2 + 5.480148709313801e-04*G0_2_0 - 5.232237220084848e-03*G0_2_2;
    block[807] = 2.289919282106755e-03*G0_0_2 + 2.289919282106830e-03*G0_1_0 + 1.116906498850954e-02*G0_1_2 + 2.289919282106862e-03*G0_2_0 + 1.116906498850959e-02*G0_2_2;
    block[808] = 2.289919282106669e-03*G0_1_1 + 2.289919282106956e-03*G0_1_2 + 2.289919282106671e-03*G0_2_1 + 2.289919282106968e-03*G0_2_2;
    block[809] = 1.787572317086225e-03*G0_1_1 + 1.787572317085929e-03*G0_1_2 + 1.787572317086238e-03*G0_2_1 + 1.787572317085921e-03*G0_2_2;
    block[810] = 1.787572317086201e-03*G0_1_1 + 1.787572317086385e-03*G0_1_2 + 1.787572317086172e-03*G0_2_1 + 1.787572317086376e-03*G0_2_2;
    block[811] = 2.289919282106789e-03*G0_1_1 + 2.289919282106768e-03*G0_1_2 + 2.289919282106820e-03*G0_2_1 + 2.289919282106784e-03*G0_2_2;
    block[812] = 4.762510187857360e-02*G0_0_0 + 6.236931150125542e-02*G0_0_1 + 6.236931150125547e-02*G0_0_2 + 6.236931150125510e-02*G0_1_0 + 1.247386230025106e-01*G0_1_1 + 1.247386230025104e-01*G0_1_2 + 6.236931150125500e-02*G0_2_0 + 1.247386230025104e-01*G0_2_1 + 1.247386230025102e-01*G0_2_2;
    block[813] = -6.523986558708794e-04*G0_0_0 - 2.968413884212570e-03*G0_0_1 - 2.968413884212674e-03*G0_0_2 - 2.968413884212816e-03*G0_1_0 + 3.522952741702655e-03*G0_1_1 + 3.522952741702459e-03*G0_1_2 - 2.968413884212838e-03*G0_2_0 + 3.522952741702670e-03*G0_2_1 + 3.522952741702531e-03*G0_2_2;
    block[814] = 6.523986558709560e-05*G0_0_1 + 6.523986558721692e-05*G0_0_2 + 6.523986558720001e-05*G0_1_0 - 1.174317580567552e-03*G0_1_1 - 1.174317580567674e-03*G0_1_2 + 6.523986558722585e-05*G0_2_0 - 1.174317580567573e-03*G0_2_1 - 1.174317580567718e-03*G0_2_2;
    block[815] = -6.523986558707944e-04*G0_0_0 - 2.968413884212646e-03*G0_0_1 - 2.968413884212417e-03*G0_0_2 - 2.968413884212522e-03*G0_1_0 + 3.522952741702117e-03*G0_1_1 + 3.522952741702561e-03*G0_1_2 - 2.968413884212443e-03*G0_2_0 + 3.522952741702137e-03*G0_2_1 + 3.522952741702591e-03*G0_2_2;
    block[816] = 2.576974690689968e-03*G0_0_1 + 2.576974690689869e-03*G0_0_2 + 2.576974690689917e-03*G0_1_0 - 1.050361835952123e-02*G0_1_1 - 1.050361835952117e-02*G0_1_2 + 2.576974690689888e-03*G0_2_0 - 1.050361835952123e-02*G0_2_1 - 1.050361835952116e-02*G0_2_2;
    block[817] = 6.523986558732377e-05*G0_0_1 + 6.523986558742913e-05*G0_0_2 + 6.523986558708408e-05*G0_1_0 - 1.174317580567272e-03*G0_1_1 - 1.174317580567405e-03*G0_1_2 + 6.523986558708933e-05*G0_2_0 - 1.174317580567253e-03*G0_2_1 - 1.174317580567400e-03*G0_2_2;
    block[818] = -6.523986558737526e-05*G0_0_1 - 6.523986558725694e-05*G0_0_2 - 6.523986558712296e-05*G0_1_0 - 1.500516908502984e-02*G0_1_1 - 1.500516908502987e-02*G0_1_2 - 6.523986558712875e-05*G0_2_0 - 1.500516908502987e-02*G0_2_1 - 1.500516908502990e-02*G0_2_2;
    block[819] = -2.576974690689605e-03*G0_0_1 - 2.576974690689769e-03*G0_0_2 - 2.576974690689960e-03*G0_1_0 - 6.523986558709414e-04*G0_1_1 - 6.523986558708616e-04*G0_1_2 - 2.576974690689932e-03*G0_2_0 - 6.523986558709543e-04*G0_2_1 - 6.523986558708532e-04*G0_2_2;
    block[820] = -6.523986558726837e-05*G0_0_1 - 6.523986558700022e-05*G0_0_2 - 6.523986558718750e-05*G0_1_0 - 1.500516908502999e-02*G0_1_1 - 1.500516908503018e-02*G0_1_2 - 6.523986558721400e-05*G0_2_0 - 1.500516908502993e-02*G0_2_1 - 1.500516908503016e-02*G0_2_2;
    block[821] = -6.523986558709477e-04*G0_0_0 + 8.840001787050546e-03*G0_0_1 + 8.840001787050361e-03*G0_0_2 + 8.840001787049998e-03*G0_1_0 - 6.523986558711624e-04*G0_1_1 - 6.523986558710225e-04*G0_1_2 + 8.840001787050035e-03*G0_2_0 - 6.523986558710823e-04*G0_2_1 - 6.523986558710194e-04*G0_2_2;
    block[822] = -6.523986558709732e-04*G0_0_0 + 8.840001787049972e-03*G0_0_1 + 8.840001787050061e-03*G0_0_2 + 8.840001787050546e-03*G0_1_0 - 6.523986558710444e-04*G0_1_1 - 6.523986558708051e-04*G0_1_2 + 8.840001787050550e-03*G0_2_0 - 6.523986558710702e-04*G0_2_1 - 6.523986558708551e-04*G0_2_2;
    block[823] = -6.654466289882889e-02*G0_0_0 + 2.276871308989332e-02*G0_0_1 + 2.276871308989370e-02*G0_0_2 + 2.276871308989356e-02*G0_1_0 - 1.500516908502999e-02*G0_1_1 - 1.500516908503005e-02*G0_1_2 + 2.276871308989353e-02*G0_2_0 - 1.500516908503000e-02*G0_2_1 - 1.500516908502998e-02*G0_2_2;
    block[824] = -1.304797311744075e-04*G0_0_0 - 6.523986558712468e-05*G0_0_1 - 1.376561163887528e-02*G0_0_2 - 1.376561163887536e-02*G0_1_0 + 1.174317580567478e-03*G0_1_1 - 5.284429112554089e-02*G0_1_2 - 1.376561163887527e-02*G0_2_0 + 1.174317580567496e-03*G0_2_1 - 5.284429112554091e-02*G0_2_2;
    block[825] = -6.784946021056809e-03*G0_0_0 + 2.968413884212583e-03*G0_0_1 + 3.036915743078908e-02*G0_0_2 + 3.036915743078876e-02*G0_1_0 - 3.522952741702581e-03*G0_1_1 + 1.047099842672751e-01*G0_1_2 + 3.036915743078869e-02*G0_2_0 - 3.522952741702590e-03*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[826] = -3.392473010528565e-03*G0_0_0 - 6.236931150125569e-02*G0_0_1 - 1.980682319223965e-01*G0_0_2 - 1.980682319223969e-01*G0_1_0 - 1.247386230025110e-01*G0_1_1 - 2.713978408422830e-01*G0_1_2 - 1.980682319223968e-01*G0_2_0 - 1.247386230025109e-01*G0_2_1 - 2.713978408422830e-01*G0_2_2;
    block[827] = 1.278701365506889e-02*G0_0_0 + 3.294613212147972e-03*G0_0_1 - 2.508472831823538e-02*G0_0_2 - 2.508472831823480e-02*G0_1_0 - 1.559232787531336e-02*G0_1_1 - 6.197787230773031e-03*G0_1_2 - 2.508472831823482e-02*G0_2_0 - 1.559232787531335e-02*G0_2_1 - 6.197787230773077e-03*G0_2_2;
    block[828] = -6.223883177008160e-02*G0_0_0 + 9.854481696929535e-02*G0_0_1 + 1.885758314794753e-01*G0_0_2 + 1.885758314794763e-01*G0_1_0 + 1.824106641814959e-01*G0_1_1 + 1.047099842672752e-01*G0_1_2 + 1.885758314794762e-01*G0_2_0 + 1.824106641814959e-01*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[829] = 8.468134553203947e-02*G0_0_0 - 4.632030456682953e-03*G0_0_1 - 8.879145706402509e-02*G0_0_2 - 8.879145706402619e-02*G0_1_0 - 5.101757488910264e-02*G0_1_1 - 5.284429112554073e-02*G0_1_2 - 8.879145706402611e-02*G0_2_0 - 5.101757488910258e-02*G0_2_1 - 5.284429112554069e-02*G0_2_2;
    block[830] = 8.468134553203957e-02*G0_0_0 - 8.879145706402562e-02*G0_0_1 - 4.632030456683364e-03*G0_0_2 - 8.879145706402611e-02*G0_1_0 - 5.284429112554091e-02*G0_1_1 - 5.101757488910261e-02*G0_1_2 - 8.879145706402600e-02*G0_2_0 - 5.284429112554095e-02*G0_2_1 - 5.101757488910263e-02*G0_2_2;
    block[831] = -6.223883177008152e-02*G0_0_0 + 1.885758314794759e-01*G0_0_1 + 9.854481696929569e-02*G0_0_2 + 1.885758314794763e-01*G0_1_0 + 1.047099842672757e-01*G0_1_1 + 1.824106641814962e-01*G0_1_2 + 1.885758314794762e-01*G0_2_0 + 1.047099842672756e-01*G0_2_1 + 1.824106641814962e-01*G0_2_2;
    block[832] = -3.392473010528506e-03*G0_0_0 - 1.980682319223967e-01*G0_0_1 - 6.236931150125580e-02*G0_0_2 - 1.980682319223970e-01*G0_1_0 - 2.713978408422830e-01*G0_1_1 - 1.247386230025110e-01*G0_1_2 - 1.980682319223970e-01*G0_2_0 - 2.713978408422829e-01*G0_2_1 - 1.247386230025108e-01*G0_2_2;
    block[833] = 1.278701365506922e-02*G0_0_0 - 2.508472831823488e-02*G0_0_1 + 3.294613212148118e-03*G0_0_2 - 2.508472831823499e-02*G0_1_0 - 6.197787230773241e-03*G0_1_1 - 1.559232787531385e-02*G0_1_2 - 2.508472831823505e-02*G0_2_0 - 6.197787230773140e-03*G0_2_1 - 1.559232787531387e-02*G0_2_2;
    block[834] = -6.784946021057059e-03*G0_0_0 + 3.036915743078879e-02*G0_0_1 + 2.968413884212443e-03*G0_0_2 + 3.036915743078924e-02*G0_1_0 + 1.047099842672748e-01*G0_1_1 - 3.522952741702598e-03*G0_1_2 + 3.036915743078932e-02*G0_2_0 + 1.047099842672748e-01*G0_2_1 - 3.522952741702630e-03*G0_2_2;
    block[835] = -1.304797311744720e-04*G0_0_0 - 1.376561163887553e-02*G0_0_1 - 6.523986558745691e-05*G0_0_2 - 1.376561163887556e-02*G0_1_0 - 5.284429112554055e-02*G0_1_1 + 1.174317580567394e-03*G0_1_2 - 1.376561163887560e-02*G0_2_0 - 5.284429112554061e-02*G0_2_1 + 1.174317580567385e-03*G0_2_2;
    block[836] = 1.807144276762315e-01*G0_0_0 + 1.043837849393356e-02*G0_0_1 + 1.043837849393395e-02*G0_0_2 + 1.043837849393352e-02*G0_1_0 + 2.609594623483498e-02*G0_1_1 + 2.609594623483540e-02*G0_1_2 + 1.043837849393356e-02*G0_2_0 + 2.609594623483492e-02*G0_2_1 + 2.609594623483550e-02*G0_2_2;
    block[837] = -1.617948666559764e-01*G0_0_0 - 9.557640308508233e-02*G0_0_1 - 9.557640308508254e-02*G0_0_2 - 9.557640308508210e-02*G0_1_0 - 1.859336169231977e-01*G0_1_1 - 1.859336169231978e-01*G0_1_2 - 9.557640308508199e-02*G0_2_0 - 1.859336169231977e-01*G0_2_1 - 1.859336169231978e-01*G0_2_2;
    block[838] = 1.304797311741776e-03*G0_0_0 - 5.871587902838107e-03*G0_0_1 - 5.871587902837930e-03*G0_0_2 - 5.871587902837440e-03*G0_1_0 + 2.609594623483483e-02*G0_1_1 + 2.609594623483508e-02*G0_1_2 - 5.871587902837541e-03*G0_2_0 + 2.609594623483483e-02*G0_2_1 + 2.609594623483509e-02*G0_2_2;
    block[839] = 1.304797311741859e-03*G0_0_0 - 5.871587902837746e-03*G0_0_1 - 5.871587902837923e-03*G0_0_2 - 5.871587902837663e-03*G0_1_0 + 2.609594623483480e-02*G0_1_1 + 2.609594623483480e-02*G0_1_2 - 5.871587902837647e-03*G0_2_0 + 2.609594623483480e-02*G0_2_1 + 2.609594623483476e-02*G0_2_2;
    block[840] = 1.533136841296546e-02*G0_0_0 + 1.533136841296545e-02*G0_0_1 + 1.533136841296546e-02*G0_0_2 + 4.800349309897897e-03*G0_1_0 + 4.800349309897908e-03*G0_1_1 + 4.800349309897943e-03*G0_1_2 + 4.800349309897900e-03*G0_2_0 + 4.800349309897912e-03*G0_2_1 + 4.800349309897946e-03*G0_2_2;
    block[841] = -5.512768642108859e-02*G0_0_0 - 3.725718243947367e-02*G0_1_0 - 3.725718243947367e-02*G0_2_0;
    block[842] = -4.800349309897881e-03*G0_1_1 - 4.800349309897877e-03*G0_2_1;
    block[843] = -4.800349309897900e-03*G0_1_2 - 4.800349309897903e-03*G0_2_2;
    block[844] = 1.963719954171329e-02*G0_0_0 - 6.991103996312248e-02*G0_0_1 - 6.991103996312242e-02*G0_1_0 - 1.398220799262449e-01*G0_1_1 - 6.991103996312234e-02*G0_2_0 - 1.398220799262448e-01*G0_2_1;
    block[845] = -1.869122149070051e-02*G0_0_0 + 3.872638421249478e-02*G0_0_1 + 3.872638421249489e-02*G0_1_0 + 1.086374241756172e-01*G0_1_1 + 3.872638421249484e-02*G0_2_0 + 1.086374241756172e-01*G0_2_1;
    block[846] = 9.394540644540497e-03*G0_0_0 - 1.897827689928371e-02*G0_0_1 - 1.897827689928366e-02*G0_1_0 - 7.889456945446434e-02*G0_1_1 - 1.897827689928360e-02*G0_2_0 - 7.889456945446424e-02*G0_2_1;
    block[847] = 5.375764924376000e-03*G0_0_1 + 5.375764924376048e-03*G0_1_0 + 3.283522434998092e-02*G0_1_1 + 5.375764924375992e-03*G0_2_0 + 3.283522434998083e-02*G0_2_1;
    block[848] = -5.375764924375887e-03*G0_0_1 - 5.375764924376041e-03*G0_1_0 - 5.375764924376023e-03*G0_1_2 - 5.375764924375985e-03*G0_2_0 - 5.375764924375965e-03*G0_2_2;
    block[849] = 9.394540644540468e-03*G0_0_0 - 2.289919282106891e-03*G0_0_1 + 9.394540644540537e-03*G0_0_2 - 2.289919282106732e-03*G0_1_0 - 2.289919282106652e-03*G0_1_2 - 2.289919282106756e-03*G0_2_0 - 2.289919282106672e-03*G0_2_2;
    block[850] = 6.589226424295948e-03*G0_0_0 - 2.289919282106739e-03*G0_0_1 + 6.589226424295947e-03*G0_0_2 - 2.289919282106874e-03*G0_1_0 - 2.289919282106891e-03*G0_1_2 - 2.289919282106798e-03*G0_2_0 - 2.289919282106816e-03*G0_2_2;
    block[851] = 2.208369450122908e-02*G0_0_0 - 5.375764924375907e-03*G0_0_1 + 2.208369450122909e-02*G0_0_2 - 5.375764924375951e-03*G0_1_0 - 5.375764924375883e-03*G0_1_2 - 5.375764924375941e-03*G0_2_0 - 5.375764924375876e-03*G0_2_2;
    block[852] = -8.121058468280595e-02*G0_0_0 - 5.375112525720092e-02*G0_0_1 - 5.375112525720093e-02*G0_0_2 - 2.745945942560496e-02*G0_1_0 - 3.283522434998085e-02*G0_1_1 - 3.283522434998089e-02*G0_1_2 - 2.745945942560498e-02*G0_2_0 - 3.283522434998087e-02*G0_2_1 - 3.283522434998091e-02*G0_2_2;
    block[853] = 1.852681702942099e-01*G0_0_0 + 1.035291427001484e-01*G0_0_1 + 1.035291427001484e-01*G0_0_2 + 5.991629255518079e-02*G0_1_0 + 7.889456945446441e-02*G0_1_1 + 7.889456945446441e-02*G0_1_2 + 5.991629255518081e-02*G0_2_0 + 7.889456945446434e-02*G0_2_1 + 7.889456945446434e-02*G0_2_2;
    block[854] = -2.433577466129523e-01*G0_0_0 - 1.350204258190353e-01*G0_0_1 - 1.350204258190353e-01*G0_0_2 - 6.991103996312251e-02*G0_1_0 - 1.086374241756173e-01*G0_1_1 - 1.086374241756172e-01*G0_1_2 - 6.991103996312252e-02*G0_2_0 - 1.086374241756173e-01*G0_2_1 - 1.086374241756172e-01*G0_2_2;
    block[855] = 1.790964790096715e-01*G0_0_0 + 6.991103996312249e-02*G0_0_1 + 6.991103996312251e-02*G0_0_2 + 6.991103996312249e-02*G0_1_0 + 1.398220799262450e-01*G0_1_1 + 1.398220799262449e-01*G0_1_2 + 6.991103996312251e-02*G0_2_0 + 1.398220799262449e-01*G0_2_1 + 1.398220799262448e-01*G0_2_2;
    block[856] = 2.208369450122909e-02*G0_0_0 + 2.208369450122908e-02*G0_0_1 - 5.375764924375888e-03*G0_0_2 - 5.375764924375861e-03*G0_1_0 - 5.375764924375831e-03*G0_1_1 - 5.375764924375865e-03*G0_2_0 - 5.375764924375835e-03*G0_2_1;
    block[857] = 6.589226424295764e-03*G0_0_0 + 6.589226424295695e-03*G0_0_1 - 2.289919282106752e-03*G0_0_2 - 2.289919282106630e-03*G0_1_0 - 2.289919282106652e-03*G0_1_1 - 2.289919282106657e-03*G0_2_0 - 2.289919282106678e-03*G0_2_1;
    block[858] = 9.394540644540580e-03*G0_0_0 + 9.394540644540622e-03*G0_0_1 - 2.289919282106872e-03*G0_0_2 - 2.289919282106776e-03*G0_1_0 - 2.289919282106780e-03*G0_1_1 - 2.289919282106739e-03*G0_2_0 - 2.289919282106741e-03*G0_2_1;
    block[859] = -5.375764924375903e-03*G0_0_2 - 5.375764924375940e-03*G0_1_0 - 5.375764924375960e-03*G0_1_1 - 5.375764924375922e-03*G0_2_0 - 5.375764924375941e-03*G0_2_1;
    block[860] = 1.963719954171330e-02*G0_0_0 - 6.991103996312242e-02*G0_0_2 - 6.991103996312234e-02*G0_1_0 - 1.398220799262448e-01*G0_1_2 - 6.991103996312226e-02*G0_2_0 - 1.398220799262447e-01*G0_2_2;
    block[861] = -1.869122149070045e-02*G0_0_0 + 3.872638421249480e-02*G0_0_2 + 3.872638421249467e-02*G0_1_0 + 1.086374241756172e-01*G0_1_2 + 3.872638421249459e-02*G0_2_0 + 1.086374241756171e-01*G0_2_2;
    block[862] = 9.394540644540495e-03*G0_0_0 - 1.897827689928357e-02*G0_0_2 - 1.897827689928354e-02*G0_1_0 - 7.889456945446430e-02*G0_1_2 - 1.897827689928341e-02*G0_2_0 - 7.889456945446416e-02*G0_2_2;
    block[863] = 5.375764924375980e-03*G0_0_2 + 5.375764924375915e-03*G0_1_0 + 3.283522434998089e-02*G0_1_2 + 5.375764924375899e-03*G0_2_0 + 3.283522434998087e-02*G0_2_2;
    block[864] = 5.375764924375962e-03*G0_1_1 + 5.375764924376009e-03*G0_1_2 + 5.375764924375899e-03*G0_2_1 + 5.375764924375953e-03*G0_2_2;
    block[865] = 2.289919282106787e-03*G0_1_1 + 2.289919282106698e-03*G0_1_2 + 2.289919282106828e-03*G0_2_1 + 2.289919282106736e-03*G0_2_2;
    block[866] = 2.289919282106685e-03*G0_1_1 + 2.289919282106765e-03*G0_1_2 + 2.289919282106655e-03*G0_2_1 + 2.289919282106720e-03*G0_2_2;
    block[867] = 5.375764924375931e-03*G0_1_1 + 5.375764924375977e-03*G0_1_2 + 5.375764924375914e-03*G0_2_1 + 5.375764924375983e-03*G0_2_2;
    block[868] = -6.067307499599124e-02*G0_0_0 - 2.844458139597001e-02*G0_0_1 - 2.844458139597009e-02*G0_0_2 - 2.844458139597005e-02*G0_1_0 - 1.247386230025101e-01*G0_1_1 - 1.247386230025101e-01*G0_1_2 - 2.844458139597004e-02*G0_2_0 - 1.247386230025100e-01*G0_2_1 - 1.247386230025100e-01*G0_2_2;
    block[869] = 2.267085329151293e-02*G0_0_0 + 6.850185886644359e-04*G0_0_1 + 6.850185886645219e-04*G0_0_2 + 6.850185886644838e-04*G0_1_0 + 4.296045148909664e-02*G0_1_1 + 4.296045148909688e-02*G0_1_2 + 6.850185886645664e-04*G0_2_0 + 4.296045148909670e-02*G0_2_1 + 4.296045148909679e-02*G0_2_2;
    block[870] = 9.394540644540587e-03*G0_0_1 + 9.394540644540528e-03*G0_0_2 + 9.394540644540412e-03*G0_1_0 - 1.187365553684978e-02*G0_1_1 - 1.187365553685007e-02*G0_1_2 + 9.394540644540369e-03*G0_2_0 - 1.187365553684966e-02*G0_2_1 - 1.187365553685000e-02*G0_2_2;
    block[871] = 2.267085329151276e-02*G0_0_0 + 6.850185886644716e-04*G0_0_1 + 6.850185886643034e-04*G0_0_2 + 6.850185886644794e-04*G0_1_0 + 4.296045148909685e-02*G0_1_1 + 4.296045148909678e-02*G0_1_2 + 6.850185886644447e-04*G0_2_0 + 4.296045148909678e-02*G0_2_1 + 4.296045148909675e-02*G0_2_2;
    block[872] = 3.294613212147965e-03*G0_0_1 + 3.294613212147993e-03*G0_0_2 + 3.294613212147735e-03*G0_1_0 - 2.544354757896611e-03*G0_1_1 - 2.544354757896558e-03*G0_1_2 + 3.294613212147757e-03*G0_2_0 - 2.544354757896676e-03*G0_2_1 - 2.544354757896561e-03*G0_2_2;
    block[873] = 9.394540644540417e-03*G0_0_1 + 9.394540644540463e-03*G0_0_2 + 9.394540644540554e-03*G0_1_0 - 1.187365553684984e-02*G0_1_1 - 1.187365553684969e-02*G0_1_2 + 9.394540644540489e-03*G0_2_0 - 1.187365553684981e-02*G0_2_1 - 1.187365553684974e-02*G0_2_2;
    block[874] = -9.394540644540639e-03*G0_0_1 - 9.394540644540584e-03*G0_0_2 - 9.394540644540546e-03*G0_1_0 - 9.394540644540471e-03*G0_2_0;
    block[875] = -3.294613212148040e-03*G0_0_1 - 3.294613212147950e-03*G0_0_2 - 3.294613212147707e-03*G0_1_0 - 3.294613212147729e-03*G0_2_0;
    block[876] = -9.394540644540587e-03*G0_0_1 - 9.394540644540815e-03*G0_0_2 - 9.394540644540436e-03*G0_1_0 - 9.394540644540390e-03*G0_2_0;
    block[877] = 2.267085329151302e-02*G0_0_0 - 3.294613212147822e-03*G0_0_1 - 3.294613212147897e-03*G0_0_2 - 3.294613212148059e-03*G0_1_0 - 3.294613212148132e-03*G0_2_0;
    block[878] = 2.267085329151294e-02*G0_0_0 - 3.294613212147648e-03*G0_0_1 - 3.294613212147598e-03*G0_0_2 - 3.294613212148055e-03*G0_1_0 - 3.294613212148056e-03*G0_2_0;
    block[879] = 4.534170658302542e-02*G0_0_0 - 9.394540644540610e-03*G0_0_1 - 9.394540644540789e-03*G0_0_2 - 9.394540644540718e-03*G0_1_0 - 9.394540644540672e-03*G0_2_0;
    block[880] = -1.878908128908107e-02*G0_0_0 - 9.394540644540570e-03*G0_0_1 + 2.126819618139028e-02*G0_0_2 + 2.126819618139032e-02*G0_1_0 + 1.187365553684978e-02*G0_1_1 + 2.126819618139017e-02*G0_2_0 + 1.187365553684966e-02*G0_2_1;
    block[881] = 4.397166940569681e-02*G0_0_0 - 6.850185886644513e-04*G0_0_1 - 4.227543290043254e-02*G0_0_2 - 4.227543290043204e-02*G0_1_0 - 4.296045148909677e-02*G0_1_1 - 4.227543290043199e-02*G0_2_0 - 4.296045148909682e-02*G0_2_1;
    block[882] = -6.445698720004243e-02*G0_0_0 + 2.844458139597025e-02*G0_0_1 + 9.629404160654054e-02*G0_0_2 + 9.629404160654056e-02*G0_1_0 + 1.247386230025107e-01*G0_1_1 + 9.629404160654047e-02*G0_2_0 + 1.247386230025105e-01*G0_2_1;
    block[883] = -3.186967433929206e-02*G0_0_0 - 5.904207835631442e-03*G0_0_1 + 5.838967970044608e-03*G0_0_2 + 5.838967970043969e-03*G0_1_0 + 2.544354757896223e-03*G0_1_1 + 5.838967970044021e-03*G0_2_0 + 2.544354757896291e-03*G0_2_1;
    block[884] = 9.208607027617390e-02*G0_0_0 - 3.591454600569162e-02*G0_0_1 - 4.227543290043239e-02*G0_0_2 - 4.227543290043288e-02*G0_1_0 - 4.296045148909764e-02*G0_1_1 - 4.227543290043283e-02*G0_2_0 - 4.296045148909764e-02*G0_2_1;
    block[885] = -6.934997711907388e-02*G0_0_0 - 1.461372989150764e-02*G0_0_1 + 2.126819618139005e-02*G0_0_2 + 2.126819618139053e-02*G0_1_0 + 1.187365553685063e-02*G0_1_1 + 2.126819618139051e-02*G0_2_0 + 1.187365553685055e-02*G0_2_1;
    block[886] = -6.934997711907394e-02*G0_0_0 + 2.126819618139037e-02*G0_0_1 - 1.461372989150741e-02*G0_0_2 + 2.126819618139054e-02*G0_1_0 + 1.187365553685020e-02*G0_1_2 + 2.126819618139049e-02*G0_2_0 + 1.187365553685021e-02*G0_2_2;
    block[887] = 9.208607027617383e-02*G0_0_0 - 4.227543290043280e-02*G0_0_1 - 3.591454600569187e-02*G0_0_2 - 4.227543290043281e-02*G0_1_0 - 4.296045148909762e-02*G0_1_2 - 4.227543290043274e-02*G0_2_0 - 4.296045148909765e-02*G0_2_2;
    block[888] = -6.445698720004227e-02*G0_0_0 + 9.629404160654062e-02*G0_0_1 + 2.844458139597034e-02*G0_0_2 + 9.629404160654063e-02*G0_1_0 + 1.247386230025107e-01*G0_1_2 + 9.629404160654055e-02*G0_2_0 + 1.247386230025106e-01*G0_2_2;
    block[889] = -3.186967433929222e-02*G0_0_0 + 5.838967970044377e-03*G0_0_1 - 5.904207835631426e-03*G0_0_2 + 5.838967970044347e-03*G0_1_0 + 2.544354757896238e-03*G0_1_2 + 5.838967970044284e-03*G0_2_0 + 2.544354757896230e-03*G0_2_2;
    block[890] = 4.397166940569690e-02*G0_0_0 - 4.227543290043217e-02*G0_0_1 - 6.850185886642602e-04*G0_0_2 - 4.227543290043236e-02*G0_1_0 - 4.296045148909675e-02*G0_1_2 - 4.227543290043233e-02*G0_2_0 - 4.296045148909673e-02*G0_2_2;
    block[891] = -1.878908128908100e-02*G0_0_0 + 2.126819618139028e-02*G0_0_1 - 9.394540644540483e-03*G0_0_2 + 2.126819618139039e-02*G0_1_0 + 1.187365553684968e-02*G0_1_2 + 2.126819618139036e-02*G0_2_0 + 1.187365553684973e-02*G0_2_2;
    block[892] = -1.513564881620423e-01*G0_0_0 + 2.609594623483681e-03*G0_0_1 + 2.609594623483394e-03*G0_0_2 + 2.609594623483453e-03*G0_1_0 + 2.609594623483348e-03*G0_2_0;
    block[893] = 1.666878565750081e-01*G0_0_0 + 3.522952741702674e-02*G0_0_1 + 3.522952741702700e-02*G0_0_2 + 3.522952741702724e-02*G0_1_0 + 3.522952741702728e-02*G0_2_0;
    block[894] = -4.534170658302580e-02*G0_0_0 + 2.609594623483718e-03*G0_0_1 + 2.609594623483376e-03*G0_0_2 + 2.609594623483603e-03*G0_1_0 + 2.609594623483699e-03*G0_2_0;
    block[895] = -4.534170658302587e-02*G0_0_0 + 2.609594623483386e-03*G0_0_1 + 2.609594623483620e-03*G0_0_2 + 2.609594623483560e-03*G0_1_0 + 2.609594623483483e-03*G0_2_0;
    block[896] = -1.787050398161491e-02*G0_0_0 - 1.787050398161492e-02*G0_0_1 - 1.787050398161494e-02*G0_0_2 - 1.787050398161490e-02*G0_1_0 - 1.787050398161491e-02*G0_1_1 - 1.787050398161494e-02*G0_1_2 - 5.512768642108869e-02*G0_2_0 - 5.512768642108866e-02*G0_2_1 - 5.512768642108865e-02*G0_2_2;
    block[897] = -4.800349309897920e-03*G0_0_0 - 4.800349309897921e-03*G0_1_0;
    block[898] = -4.800349309897814e-03*G0_0_1 - 4.800349309897812e-03*G0_1_1;
    block[899] = 1.053101910306762e-02*G0_0_2 + 1.053101910306762e-02*G0_1_2 + 1.533136841296554e-02*G0_2_2;
    block[900] = 5.375764924375931e-03*G0_0_0 + 5.375764924375944e-03*G0_0_1 + 5.375764924375899e-03*G0_1_0 + 5.375764924375912e-03*G0_1_1;
    block[901] = 2.289919282106938e-03*G0_0_0 + 2.289919282106877e-03*G0_0_1 + 2.289919282106919e-03*G0_1_0 + 2.289919282106828e-03*G0_1_1;
    block[902] = 2.289919282106544e-03*G0_0_0 + 2.289919282106623e-03*G0_0_1 + 2.289919282106540e-03*G0_1_0 + 2.289919282106660e-03*G0_1_1;
    block[903] = 5.375764924376159e-03*G0_0_0 + 5.375764924375965e-03*G0_0_1 + 5.375764924376215e-03*G0_1_0 + 5.375764924375998e-03*G0_1_1;
    block[904] = -5.375764924376139e-03*G0_0_0 + 2.208369450122879e-02*G0_0_1 - 5.375764924376168e-03*G0_0_2 - 5.375764924376194e-03*G0_1_0 + 2.208369450122883e-02*G0_1_1 - 5.375764924376221e-03*G0_1_2 - 5.375764924375896e-03*G0_2_1;
    block[905] = 2.837281754382430e-02*G0_0_0 - 3.154347501135630e-02*G0_0_1 + 2.837281754382431e-02*G0_0_2 + 2.837281754382434e-02*G0_1_0 - 3.154347501135635e-02*G0_1_1 + 2.837281754382435e-02*G0_1_2 + 9.394540644540546e-03*G0_2_0 + 2.837281754382414e-02*G0_2_1 + 9.394540644540565e-03*G0_2_2;
    block[906] = -5.741760570319548e-02*G0_0_0 + 1.249343425992696e-02*G0_0_1 - 5.741760570319547e-02*G0_0_2 - 5.741760570319551e-02*G0_1_0 + 1.249343425992703e-02*G0_1_1 - 5.741760570319551e-02*G0_1_2 - 1.869122149070056e-02*G0_2_0 - 5.741760570319542e-02*G0_2_1 - 1.869122149070057e-02*G0_2_2;
    block[907] = 8.954823950483591e-02*G0_0_0 + 1.963719954171340e-02*G0_0_1 + 8.954823950483587e-02*G0_0_2 + 8.954823950483597e-02*G0_1_0 + 1.963719954171335e-02*G0_1_1 + 8.954823950483591e-02*G0_1_2 + 1.963719954171331e-02*G0_2_0 + 8.954823950483594e-02*G0_2_1 + 1.963719954171330e-02*G0_2_2;
    block[908] = 1.963719954171323e-02*G0_0_0 + 8.954823950483584e-02*G0_0_1 + 8.954823950483583e-02*G0_0_2 + 1.963719954171323e-02*G0_1_0 + 8.954823950483581e-02*G0_1_1 + 8.954823950483583e-02*G0_1_2 + 8.954823950483592e-02*G0_2_0 + 1.963719954171317e-02*G0_2_1 + 1.963719954171319e-02*G0_2_2;
    block[909] = 1.249343425992730e-02*G0_0_0 - 5.741760570319549e-02*G0_0_1 - 5.741760570319544e-02*G0_0_2 + 1.249343425992730e-02*G0_1_0 - 5.741760570319548e-02*G0_1_1 - 5.741760570319541e-02*G0_1_2 - 5.741760570319538e-02*G0_2_0 - 1.869122149070049e-02*G0_2_1 - 1.869122149070050e-02*G0_2_2;
    block[910] = -3.154347501135671e-02*G0_0_0 + 2.837281754382426e-02*G0_0_1 + 2.837281754382421e-02*G0_0_2 - 3.154347501135674e-02*G0_1_0 + 2.837281754382420e-02*G0_1_1 + 2.837281754382416e-02*G0_1_2 + 2.837281754382410e-02*G0_2_0 + 9.394540644540574e-03*G0_2_1 + 9.394540644540586e-03*G0_2_2;
    block[911] = 2.208369450122909e-02*G0_0_0 - 5.375764924375861e-03*G0_0_1 - 5.375764924375865e-03*G0_0_2 + 2.208369450122908e-02*G0_1_0 - 5.375764924375829e-03*G0_1_1 - 5.375764924375835e-03*G0_1_2 - 5.375764924375889e-03*G0_2_0;
    block[912] = 1.790964790096718e-01*G0_0_0 + 1.790964790096718e-01*G0_0_1 + 1.091854390465494e-01*G0_0_2 + 1.790964790096718e-01*G0_1_0 + 1.790964790096718e-01*G0_1_1 + 1.091854390465493e-01*G0_1_2 + 1.091854390465494e-01*G0_2_0 + 1.091854390465493e-01*G0_2_1 + 1.790964790096720e-01*G0_2_2;
    block[913] = -1.470637050064119e-01*G0_0_0 - 1.470637050064119e-01*G0_0_1 - 1.734467066498303e-01*G0_0_2 - 1.470637050064119e-01*G0_1_0 - 1.470637050064119e-01*G0_1_1 - 1.734467066498303e-01*G0_1_2 - 1.083373207939171e-01*G0_2_0 - 1.083373207939171e-01*G0_2_1 - 2.433577466129530e-01*G0_2_2;
    block[914] = 1.007173044933451e-01*G0_0_0 + 1.007173044933451e-01*G0_0_1 + 1.253518777390296e-01*G0_0_2 + 1.007173044933450e-01*G0_1_0 + 1.007173044933450e-01*G0_1_1 + 1.253518777390295e-01*G0_1_2 + 8.173902759406157e-02*G0_2_0 + 8.173902759406153e-02*G0_2_1 + 1.852681702942105e-01*G0_2_2;
    block[915] = -3.283522434998101e-02*G0_0_0 - 3.283522434998101e-02*G0_0_1 - 5.375112525720119e-02*G0_0_2 - 3.283522434998099e-02*G0_1_0 - 3.283522434998100e-02*G0_1_1 - 5.375112525720117e-02*G0_1_2 - 2.745945942560508e-02*G0_2_0 - 2.745945942560508e-02*G0_2_1 - 8.121058468280629e-02*G0_2_2;
    block[916] = 1.075152984875192e-02*G0_0_0 + 5.375764924375934e-03*G0_0_2 + 1.075152984875191e-02*G0_1_0 + 5.375764924375906e-03*G0_1_2 + 5.375764924376073e-03*G0_2_0;
    block[917] = 1.397437920875403e-02*G0_0_0 + 1.168445992664724e-02*G0_0_2 + 1.397437920875410e-02*G0_1_0 + 1.168445992664732e-02*G0_1_2 + 1.168445992664727e-02*G0_2_0 + 9.394540644540620e-03*G0_2_2;
    block[918] = 1.116906498850931e-02*G0_0_0 + 8.879145706402563e-03*G0_0_2 + 1.116906498850923e-02*G0_1_0 + 8.879145706402497e-03*G0_1_2 + 8.879145706402617e-03*G0_2_0 + 6.589226424295740e-03*G0_2_2;
    block[919] = 3.283522434998104e-02*G0_0_0 + 2.745945942560505e-02*G0_0_2 + 3.283522434998103e-02*G0_1_0 + 2.745945942560503e-02*G0_1_2 + 2.745945942560509e-02*G0_2_0 + 2.208369450122911e-02*G0_2_2;
    block[920] = 1.075152984875193e-02*G0_0_1 + 5.375764924376128e-03*G0_0_2 + 1.075152984875196e-02*G0_1_1 + 5.375764924376182e-03*G0_1_2 + 5.375764924376011e-03*G0_2_1;
    block[921] = 1.397437920875440e-02*G0_0_1 + 1.168445992664733e-02*G0_0_2 + 1.397437920875431e-02*G0_1_1 + 1.168445992664721e-02*G0_1_2 + 1.168445992664750e-02*G0_2_1 + 9.394540644540697e-03*G0_2_2;
    block[922] = 1.116906498850916e-02*G0_0_1 + 8.879145706402622e-03*G0_0_2 + 1.116906498850922e-02*G0_1_1 + 8.879145706402690e-03*G0_1_2 + 8.879145706402448e-03*G0_2_1 + 6.589226424295758e-03*G0_2_2;
    block[923] = 3.283522434998100e-02*G0_0_1 + 2.745945942560498e-02*G0_0_2 + 3.283522434998098e-02*G0_1_1 + 2.745945942560496e-02*G0_1_2 + 2.745945942560507e-02*G0_2_1 + 2.208369450122903e-02*G0_2_2;
    block[924] = 1.878908128908101e-02*G0_0_0 + 1.878908128908086e-02*G0_0_1 + 9.394540644540379e-03*G0_0_2 + 1.878908128908103e-02*G0_1_0 + 1.878908128908090e-02*G0_1_1 + 9.394540644540293e-03*G0_1_2 + 9.394540644540624e-03*G0_2_0 + 9.394540644540691e-03*G0_2_1;
    block[925] = 2.926007971580840e-02*G0_0_0 + 2.926007971580839e-02*G0_0_1 + 2.596546650366048e-02*G0_0_2 + 2.926007971580842e-02*G0_1_0 + 2.926007971580845e-02*G0_1_1 + 2.596546650366067e-02*G0_1_2 + 2.596546650366056e-02*G0_2_0 + 2.596546650366059e-02*G0_2_1 + 2.267085329151285e-02*G0_2_2;
    block[926] = 6.413078787210660e-02*G0_0_0 + 6.413078787210681e-02*G0_0_1 + 5.473624722756589e-02*G0_0_2 + 6.413078787210663e-02*G0_1_0 + 6.413078787210671e-02*G0_1_1 + 5.473624722756586e-02*G0_1_2 + 5.473624722756622e-02*G0_2_0 + 5.473624722756638e-02*G0_2_1 + 4.534170658302549e-02*G0_2_2;
    block[927] = 6.589226424295386e-03*G0_0_0 + 6.589226424295621e-03*G0_0_1 + 3.294613212147730e-03*G0_0_2 + 6.589226424295494e-03*G0_1_0 + 6.589226424295640e-03*G0_1_1 + 3.294613212147733e-03*G0_1_2 + 3.294613212147599e-03*G0_2_0 + 3.294613212147705e-03*G0_2_1;
    block[928] = 2.926007971580864e-02*G0_0_0 + 2.926007971580834e-02*G0_0_1 + 2.596546650366074e-02*G0_0_2 + 2.926007971580854e-02*G0_1_0 + 2.926007971580840e-02*G0_1_1 + 2.596546650366067e-02*G0_1_2 + 2.596546650366062e-02*G0_2_0 + 2.596546650366042e-02*G0_2_1 + 2.267085329151278e-02*G0_2_2;
    block[929] = 1.878908128908129e-02*G0_0_0 + 1.878908128908112e-02*G0_0_1 + 9.394540644540442e-03*G0_0_2 + 1.878908128908125e-02*G0_1_0 + 1.878908128908109e-02*G0_1_1 + 9.394540644540509e-03*G0_1_2 + 9.394540644540650e-03*G0_2_0 + 9.394540644540617e-03*G0_2_1;
    block[930] = -1.878908128908135e-02*G0_0_0 - 6.132547365186183e-02*G0_0_1 - 4.005727747047157e-02*G0_0_2 - 1.878908128908132e-02*G0_1_0 - 6.132547365186191e-02*G0_1_1 - 4.005727747047148e-02*G0_1_2 - 9.394540644540711e-03*G0_2_0 - 4.005727747047181e-02*G0_2_1 - 1.878908128908128e-02*G0_2_2;
    block[931] = -2.926007971580862e-02*G0_0_0 - 4.354761027938101e-02*G0_0_1 - 3.770864230933620e-02*G0_0_2 - 2.926007971580851e-02*G0_1_0 - 4.354761027938094e-02*G0_1_1 - 3.770864230933627e-02*G0_1_2 - 2.596546650366061e-02*G0_2_0 - 3.770864230933648e-02*G0_2_1 - 3.186967433929216e-02*G0_2_2;
    block[932] = -6.413078787210662e-02*G0_0_0 - 1.118863694818542e-01*G0_0_1 - 9.061817330046422e-02*G0_0_2 - 6.413078787210665e-02*G0_1_0 - 1.118863694818543e-01*G0_1_1 - 9.061817330046419e-02*G0_1_2 - 5.473624722756621e-02*G0_2_0 - 9.061817330046404e-02*G0_2_1 - 6.934997711907355e-02*G0_2_2;
    block[933] = 4.397166940569651e-02*G0_0_0 + 1.285225352065617e-01*G0_0_1 + 8.624710230612928e-02*G0_0_2 + 4.397166940569653e-02*G0_1_0 + 1.285225352065618e-01*G0_1_1 + 8.624710230612934e-02*G0_1_2 + 4.465668799436131e-02*G0_2_0 + 8.624710230612974e-02*G0_2_1 + 4.397166940569705e-02*G0_2_2;
    block[934] = 1.273155976932005e-01*G0_0_0 + 1.766369360770385e-01*G0_0_1 + 1.343615031766059e-01*G0_0_2 + 1.273155976932006e-01*G0_1_0 + 1.766369360770384e-01*G0_1_1 + 1.343615031766060e-01*G0_1_2 + 1.280006162818650e-01*G0_2_0 + 1.343615031766060e-01*G0_2_1 + 9.208607027617319e-02*G0_2_2;
    block[935] = -6.445698720004192e-02*G0_0_0 - 2.570450704131237e-01*G0_0_1 - 1.607510288065828e-01*G0_0_2 - 6.445698720004193e-02*G0_1_0 - 2.570450704131236e-01*G0_1_1 - 1.607510288065828e-01*G0_1_2 - 9.290156859601204e-02*G0_2_0 - 1.607510288065833e-01*G0_2_1 - 6.445698720004213e-02*G0_2_2;
    block[936] = -1.118863694818544e-01*G0_0_0 - 6.413078787210665e-02*G0_0_1 - 9.061817330046416e-02*G0_0_2 - 1.118863694818542e-01*G0_1_0 - 6.413078787210655e-02*G0_1_1 - 9.061817330046407e-02*G0_1_2 - 9.061817330046415e-02*G0_2_0 - 5.473624722756628e-02*G0_2_1 - 6.934997711907367e-02*G0_2_2;
    block[937] = -4.354761027938052e-02*G0_0_0 - 2.926007971580831e-02*G0_0_1 - 3.770864230933607e-02*G0_0_2 - 4.354761027938060e-02*G0_1_0 - 2.926007971580838e-02*G0_1_1 - 3.770864230933605e-02*G0_1_2 - 3.770864230933613e-02*G0_2_0 - 2.596546650366055e-02*G0_2_1 - 3.186967433929192e-02*G0_2_2;
    block[938] = -6.132547365186217e-02*G0_0_0 - 1.878908128908096e-02*G0_0_1 - 4.005727747047173e-02*G0_0_2 - 6.132547365186215e-02*G0_1_0 - 1.878908128908100e-02*G0_1_1 - 4.005727747047177e-02*G0_1_2 - 4.005727747047180e-02*G0_2_0 - 9.394540644540757e-03*G0_2_1 - 1.878908128908117e-02*G0_2_2;
    block[939] = 1.766369360770386e-01*G0_0_0 + 1.273155976932005e-01*G0_0_1 + 1.343615031766061e-01*G0_0_2 + 1.766369360770385e-01*G0_1_0 + 1.273155976932005e-01*G0_1_1 + 1.343615031766059e-01*G0_1_2 + 1.343615031766060e-01*G0_2_0 + 1.280006162818649e-01*G0_2_1 + 9.208607027617341e-02*G0_2_2;
    block[940] = 1.285225352065623e-01*G0_0_0 + 4.397166940569654e-02*G0_0_1 + 8.624710230612932e-02*G0_0_2 + 1.285225352065621e-01*G0_1_0 + 4.397166940569656e-02*G0_1_1 + 8.624710230612936e-02*G0_1_2 + 8.624710230612959e-02*G0_2_0 + 4.465668799436102e-02*G0_2_1 + 4.397166940569661e-02*G0_2_2;
    block[941] = -2.570450704131240e-01*G0_0_0 - 6.445698720004203e-02*G0_0_1 - 1.607510288065827e-01*G0_0_2 - 2.570450704131239e-01*G0_1_0 - 6.445698720004189e-02*G0_1_1 - 1.607510288065827e-01*G0_1_2 - 1.607510288065833e-01*G0_2_0 - 9.290156859601197e-02*G0_2_1 - 6.445698720004189e-02*G0_2_2;
    block[942] = -1.285225352065619e-01*G0_0_0 - 1.285225352065616e-01*G0_0_1 - 3.222849360002102e-02*G0_0_2 - 1.285225352065619e-01*G0_1_0 - 1.285225352065617e-01*G0_1_1 - 3.222849360002102e-02*G0_1_2 - 3.222849360002117e-02*G0_2_0 - 3.222849360002100e-02*G0_2_1 - 6.067307499599109e-02*G0_2_2;
    block[943] = 6.426126760328114e-02*G0_0_0 + 6.426126760328109e-02*G0_0_1 + 2.198583470284815e-02*G0_0_2 + 6.426126760328106e-02*G0_1_0 + 6.426126760328106e-02*G0_1_1 + 2.198583470284816e-02*G0_1_2 + 2.198583470284847e-02*G0_2_0 + 2.198583470284842e-02*G0_2_1 + 2.267085329151277e-02*G0_2_2;
    block[944] = -3.066273682593114e-02*G0_0_0 - 3.066273682593126e-02*G0_0_1 - 9.394540644540645e-03*G0_0_2 - 3.066273682593108e-02*G0_1_0 - 3.066273682593118e-02*G0_1_1 - 9.394540644540561e-03*G0_1_2 - 9.394540644540620e-03*G0_2_0 - 9.394540644540580e-03*G0_2_1;
    block[945] = 6.426126760328087e-02*G0_0_0 + 6.426126760328067e-02*G0_0_1 + 2.198583470284811e-02*G0_0_2 + 6.426126760328091e-02*G0_1_0 + 6.426126760328080e-02*G0_1_1 + 2.198583470284807e-02*G0_1_2 + 2.198583470284848e-02*G0_2_0 + 2.198583470284839e-02*G0_2_1 + 2.267085329151271e-02*G0_2_2;
    block[946] = -9.133581182192154e-03*G0_0_0 - 9.133581182191985e-03*G0_0_1 - 3.294613212147626e-03*G0_0_2 - 9.133581182192119e-03*G0_1_0 - 9.133581182192031e-03*G0_1_1 - 3.294613212147629e-03*G0_1_2 - 3.294613212147951e-03*G0_2_0 - 3.294613212147916e-03*G0_2_1;
    block[947] = -3.066273682593086e-02*G0_0_0 - 3.066273682593087e-02*G0_0_1 - 9.394540644540489e-03*G0_0_2 - 3.066273682593089e-02*G0_1_0 - 3.066273682593093e-02*G0_1_1 - 9.394540644540560e-03*G0_1_2 - 9.394540644540495e-03*G0_2_0 - 9.394540644540513e-03*G0_2_1;
    block[948] = 9.622880174095279e-02*G0_0_0 + 9.622880174095298e-02*G0_0_1 + 1.314583291579803e-01*G0_0_2 + 9.622880174095287e-02*G0_1_0 + 9.622880174095279e-02*G0_1_1 + 1.314583291579803e-01*G0_1_2 + 1.314583291579802e-01*G0_2_0 + 1.314583291579804e-01*G0_2_1 + 1.666878565750077e-01*G0_2_2;
    block[949] = -5.056089582999195e-02*G0_0_0 - 5.056089582999212e-02*G0_0_1 - 4.795130120650837e-02*G0_0_2 - 5.056089582999202e-02*G0_1_0 - 5.056089582999219e-02*G0_1_1 - 4.795130120650857e-02*G0_1_2 - 4.795130120650880e-02*G0_2_0 - 4.795130120650867e-02*G0_2_1 - 4.534170658302551e-02*G0_2_2;
    block[950] = -5.056089582999181e-02*G0_0_0 - 5.056089582999218e-02*G0_0_1 - 4.795130120650885e-02*G0_0_2 - 5.056089582999194e-02*G0_1_0 - 5.056089582999211e-02*G0_1_1 - 4.795130120650874e-02*G0_1_2 - 4.795130120650880e-02*G0_2_0 - 4.795130120650910e-02*G0_2_1 - 4.534170658302537e-02*G0_2_2;
    block[951] = -1.565756774090089e-01*G0_0_0 - 1.565756774090088e-01*G0_0_1 - 1.539660827855251e-01*G0_0_2 - 1.565756774090090e-01*G0_1_0 - 1.565756774090088e-01*G0_1_1 - 1.539660827855252e-01*G0_1_2 - 1.539660827855255e-01*G0_2_0 - 1.539660827855253e-01*G0_2_1 - 1.513564881620421e-01*G0_2_2;
    block[952] = 2.146913496739859e-02*G0_0_0 + 2.146913496739856e-02*G0_0_1 + 2.146913496739862e-02*G0_0_2 + 2.146913496739857e-02*G0_1_0 + 2.146913496739854e-02*G0_1_1 + 2.146913496739861e-02*G0_1_2 + 5.512768642108875e-02*G0_2_0 + 5.512768642108873e-02*G0_2_1 + 5.512768642108869e-02*G0_2_2;
    block[953] = -3.365072266981939e-03*G0_0_0 - 3.365072266981926e-03*G0_1_0;
    block[954] = -3.365072266982029e-03*G0_0_1 - 3.365072266982030e-03*G0_1_1;
    block[955] = -2.326323127104358e-02*G0_0_2 - 2.326323127104360e-02*G0_1_2 - 3.881772002431707e-02*G0_2_2;
    block[956] = 2.289919282106599e-03*G0_0_0 + 2.289919282106564e-03*G0_0_1 + 2.289919282106625e-03*G0_1_0 + 2.289919282106585e-03*G0_1_1;
    block[957] = 1.787572317086242e-03*G0_0_0 + 1.787572317086318e-03*G0_0_1 + 1.787572317086211e-03*G0_1_0 + 1.787572317086307e-03*G0_1_1;
    block[958] = 1.787572317086139e-03*G0_0_0 + 1.787572317086041e-03*G0_0_1 + 1.787572317086156e-03*G0_1_0 + 1.787572317086050e-03*G0_1_1;
    block[959] = 2.289919282106737e-03*G0_0_0 + 2.289919282106910e-03*G0_0_1 + 2.289919282106663e-03*G0_1_0 + 2.289919282106851e-03*G0_1_1;
    block[960] = -2.289919282106745e-03*G0_0_0 + 6.589226424296018e-03*G0_0_1 - 2.289919282106771e-03*G0_0_2 - 2.289919282106671e-03*G0_1_0 + 6.589226424296014e-03*G0_1_1 - 2.289919282106695e-03*G0_1_2 - 2.289919282106812e-03*G0_2_1;
    block[961] = -4.827750053445290e-04*G0_0_0 - 6.263027096360723e-03*G0_0_1 - 4.827750053444808e-04*G0_0_2 - 4.827750053445609e-04*G0_1_0 - 6.263027096360676e-03*G0_1_1 - 4.827750053445115e-04*G0_1_2 + 6.523986558701410e-05*G0_2_0 - 4.827750053445382e-04*G0_2_1 + 6.523986558699009e-05*G0_2_2;
    block[962] = 5.062613569557959e-03*G0_0_0 + 2.609594623485368e-04*G0_0_1 + 5.062613569557915e-03*G0_0_2 + 5.062613569558047e-03*G0_1_0 + 2.609594623484988e-04*G0_1_1 + 5.062613569558002e-03*G0_1_2 + 2.609594623486844e-04*G0_2_0 + 5.062613569558086e-03*G0_2_1 + 2.609594623486892e-04*G0_2_2;
    block[963] = -5.741760570319551e-02*G0_0_0 - 1.869122149070055e-02*G0_0_1 - 5.741760570319547e-02*G0_0_2 - 5.741760570319552e-02*G0_1_0 - 1.869122149070052e-02*G0_1_1 - 5.741760570319547e-02*G0_1_2 + 1.249343425992714e-02*G0_2_0 - 5.741760570319562e-02*G0_2_1 + 1.249343425992716e-02*G0_2_2;
    block[964] = -1.869122149070042e-02*G0_0_0 - 5.741760570319540e-02*G0_0_1 - 5.741760570319539e-02*G0_0_2 - 1.869122149070039e-02*G0_1_0 - 5.741760570319535e-02*G0_1_1 - 5.741760570319536e-02*G0_1_2 - 5.741760570319565e-02*G0_2_0 + 1.249343425992730e-02*G0_2_1 + 1.249343425992731e-02*G0_2_2;
    block[965] = 2.609594623482694e-04*G0_0_0 + 5.062613569557988e-03*G0_0_1 + 5.062613569557953e-03*G0_0_2 + 2.609594623482138e-04*G0_1_0 + 5.062613569558008e-03*G0_1_1 + 5.062613569557976e-03*G0_1_2 + 5.062613569558009e-03*G0_2_0 + 2.609594623484360e-04*G0_2_1 + 2.609594623484379e-04*G0_2_2;
    block[966] = -6.263027096360318e-03*G0_0_0 - 4.827750053443293e-04*G0_0_1 - 4.827750053443023e-04*G0_0_2 - 6.263027096360243e-03*G0_1_0 - 4.827750053443137e-04*G0_1_1 - 4.827750053442874e-04*G0_1_2 - 4.827750053444658e-04*G0_2_0 + 6.523986558706901e-05*G0_2_1 + 6.523986558705600e-05*G0_2_2;
    block[967] = 6.589226424295767e-03*G0_0_0 - 2.289919282106630e-03*G0_0_1 - 2.289919282106657e-03*G0_0_2 + 6.589226424295697e-03*G0_1_0 - 2.289919282106651e-03*G0_1_1 - 2.289919282106679e-03*G0_1_2 - 2.289919282106751e-03*G0_2_0;
    block[968] = -1.470637050064119e-01*G0_0_0 - 1.470637050064119e-01*G0_0_1 - 1.083373207939171e-01*G0_0_2 - 1.470637050064119e-01*G0_1_0 - 1.470637050064118e-01*G0_1_1 - 1.083373207939171e-01*G0_1_2 - 1.734467066498303e-01*G0_2_0 - 1.734467066498303e-01*G0_2_1 - 2.433577466129529e-01*G0_2_2;
    block[969] = 3.042265412057055e-01*G0_0_0 + 3.042265412057053e-01*G0_0_1 + 2.260952781786098e-01*G0_0_2 + 3.042265412057053e-01*G0_1_0 + 3.042265412057050e-01*G0_1_1 + 2.260952781786097e-01*G0_1_2 + 2.260952781786098e-01*G0_2_0 + 2.260952781786097e-01*G0_2_1 + 4.289651642082170e-01*G0_2_2;
    block[970] = -2.041877313144658e-01*G0_0_0 - 2.041877313144657e-01*G0_0_1 - 2.194930037811965e-01*G0_0_2 - 2.041877313144657e-01*G0_1_0 - 2.041877313144656e-01*G0_1_1 - 2.194930037811965e-01*G0_1_2 - 1.676925505050491e-01*G0_2_0 - 1.676925505050490e-01*G0_2_1 - 3.871855542862464e-01*G0_2_2;
    block[971] = 7.889456945446467e-02*G0_0_0 + 7.889456945446469e-02*G0_0_1 + 1.035291427001487e-01*G0_0_2 + 7.889456945446460e-02*G0_1_0 + 7.889456945446459e-02*G0_1_1 + 1.035291427001487e-01*G0_1_2 + 5.991629255518111e-02*G0_2_0 + 5.991629255518111e-02*G0_2_1 + 1.852681702942108e-01*G0_2_2;
    block[972] = 1.397437920875388e-02*G0_0_0 + 2.289919282106498e-03*G0_0_2 + 1.397437920875389e-02*G0_1_0 + 2.289919282106519e-03*G0_1_2 + 2.289919282106695e-03*G0_2_0;
    block[973] = -2.630471380471323e-02*G0_0_0 - 1.315235690235637e-02*G0_0_2 - 2.630471380471324e-02*G0_1_0 - 1.315235690235638e-02*G0_1_2 - 1.315235690235675e-02*G0_2_0 + 6.523986558711043e-05*G0_2_2;
    block[974] = -5.232237220084587e-03*G0_0_0 - 5.780252091016211e-03*G0_0_2 - 5.232237220084522e-03*G0_1_0 - 5.780252091016174e-03*G0_1_2 - 5.780252091015846e-03*G0_2_0 - 6.263027096360267e-03*G0_2_2;
    block[975] = -7.889456945446469e-02*G0_0_0 - 5.991629255518094e-02*G0_0_2 - 7.889456945446460e-02*G0_1_0 - 5.991629255518084e-02*G0_1_2 - 5.991629255518112e-02*G0_2_0 - 3.154347501135677e-02*G0_2_2;
    block[976] = 1.397437920875429e-02*G0_0_1 + 2.289919282106721e-03*G0_0_2 + 1.397437920875423e-02*G0_1_1 + 2.289919282106646e-03*G0_1_2 + 2.289919282106675e-03*G0_2_1;
    block[977] = -2.630471380471396e-02*G0_0_1 - 1.315235690235673e-02*G0_0_2 - 2.630471380471387e-02*G0_1_1 - 1.315235690235659e-02*G0_1_2 - 1.315235690235706e-02*G0_2_1 + 6.523986558682299e-05*G0_2_2;
    block[978] = -5.232237220084060e-03*G0_0_1 - 5.780252091015938e-03*G0_0_2 - 5.232237220084150e-03*G0_1_1 - 5.780252091016068e-03*G0_1_2 - 5.780252091015700e-03*G0_2_1 - 6.263027096360203e-03*G0_2_2;
    block[979] = -7.889456945446463e-02*G0_0_1 - 5.991629255518098e-02*G0_0_2 - 7.889456945446457e-02*G0_1_1 - 5.991629255518089e-02*G0_1_2 - 5.991629255518107e-02*G0_2_1 - 3.154347501135671e-02*G0_2_2;
    block[980] = -1.487468935385575e-02*G0_0_0 - 1.487468935385596e-02*G0_0_1 + 6.523986558700395e-05*G0_0_2 - 1.487468935385578e-02*G0_1_0 - 1.487468935385592e-02*G0_1_1 + 6.523986558703689e-05*G0_1_2 + 6.523986558689516e-05*G0_2_0 + 6.523986558686869e-05*G0_2_1;
    block[981] = -1.898480088584266e-02*G0_0_0 - 1.898480088584205e-02*G0_0_1 - 9.492400442921350e-03*G0_0_2 - 1.898480088584264e-02*G0_1_0 - 1.898480088584206e-02*G0_1_1 - 9.492400442921446e-03*G0_1_2 - 9.492400442921010e-03*G0_2_0 - 9.492400442920853e-03*G0_2_1 - 6.523986558711835e-04*G0_2_2;
    block[982] = -1.270872581636458e-01*G0_0_0 - 1.270872581636462e-01*G0_0_1 - 8.931337598872188e-02*G0_0_2 - 1.270872581636458e-01*G0_1_0 - 1.270872581636460e-01*G0_1_1 - 8.931337598872185e-02*G0_1_2 - 8.931337598872255e-02*G0_2_0 - 8.931337598872267e-02*G0_2_1 - 6.654466289882861e-02*G0_2_2;
    block[983] = 4.501550725509024e-03*G0_0_0 + 4.501550725509046e-03*G0_0_1 + 2.576974690690100e-03*G0_0_2 + 4.501550725508985e-03*G0_1_0 + 4.501550725508976e-03*G0_1_1 + 2.576974690690088e-03*G0_1_2 + 2.576974690690200e-03*G0_2_0 + 2.576974690689955e-03*G0_2_1;
    block[984] = -1.898480088584234e-02*G0_0_0 - 1.898480088584231e-02*G0_0_1 - 9.492400442921453e-03*G0_0_2 - 1.898480088584233e-02*G0_1_0 - 1.898480088584237e-02*G0_1_1 - 9.492400442921382e-03*G0_1_2 - 9.492400442921066e-03*G0_2_0 - 9.492400442920984e-03*G0_2_1 - 6.523986558711565e-04*G0_2_2;
    block[985] = -1.487468935385584e-02*G0_0_0 - 1.487468935385593e-02*G0_0_1 + 6.523986558713325e-05*G0_0_2 - 1.487468935385581e-02*G0_1_0 - 1.487468935385588e-02*G0_1_1 + 6.523986558703445e-05*G0_1_2 + 6.523986558678373e-05*G0_2_0 + 6.523986558697773e-05*G0_2_1;
    block[986] = 1.487468935385588e-02*G0_0_0 - 2.544354757896445e-02*G0_0_1 + 1.363513190770126e-02*G0_0_2 + 1.487468935385586e-02*G0_1_0 - 2.544354757896439e-02*G0_1_1 + 1.363513190770116e-02*G0_1_2 - 6.523986558675663e-05*G0_2_0 + 1.363513190770158e-02*G0_2_1 - 1.304797311737674e-04*G0_2_2;
    block[987] = 1.898480088584232e-02*G0_0_0 + 5.675868306076610e-02*G0_0_1 + 3.787174197330357e-02*G0_0_2 + 1.898480088584231e-02*G0_1_0 + 5.675868306076608e-02*G0_1_1 + 3.787174197330365e-02*G0_1_2 + 9.492400442921045e-03*G0_2_0 + 3.787174197330433e-02*G0_2_1 + 1.278701365506906e-02*G0_2_2;
    block[988] = 1.270872581636457e-01*G0_0_0 + 2.094199685345497e-01*G0_0_1 + 1.734728025960655e-01*G0_0_2 + 1.270872581636457e-01*G0_1_0 + 2.094199685345495e-01*G0_1_1 + 1.734728025960653e-01*G0_1_2 + 8.931337598872248e-02*G0_2_0 + 1.734728025960648e-01*G0_2_1 + 8.468134553203879e-02*G0_2_2;
    block[989] = -4.364547007776119e-02*G0_0_0 + 3.718672338464010e-02*G0_0_1 - 3.715410345184588e-02*G0_0_2 - 4.364547007776112e-02*G0_1_0 + 3.718672338463998e-02*G0_1_1 - 3.715410345184596e-02*G0_1_2 - 9.753359905269786e-03*G0_2_0 - 3.715410345184662e-02*G0_2_1 - 6.784946021057664e-03*G0_2_2;
    block[990] = -1.669488160373559e-01*G0_0_0 - 3.346805104617575e-01*G0_0_1 - 2.508146632495571e-01*G0_0_2 - 1.669488160373560e-01*G0_1_0 - 3.346805104617573e-01*G0_1_1 - 2.508146632495569e-01*G0_1_2 - 1.607836487393763e-01*G0_2_0 - 2.508146632495568e-01*G0_2_1 - 6.223883177008018e-02*G0_2_2;
    block[991] = 1.323064474106129e-01*G0_0_0 + 1.213461499919820e-01*G0_0_1 + 1.946757589118685e-01*G0_0_2 + 1.323064474106128e-01*G0_1_0 + 1.213461499919821e-01*G0_1_1 + 1.946757589118682e-01*G0_1_2 + 5.897683849072659e-02*G0_2_0 + 1.946757589118688e-01*G0_2_1 - 3.392473010528973e-03*G0_2_2;
    block[992] = 2.094199685345501e-01*G0_0_0 + 1.270872581636459e-01*G0_0_1 + 1.734728025960652e-01*G0_0_2 + 2.094199685345499e-01*G0_1_0 + 1.270872581636457e-01*G0_1_1 + 1.734728025960649e-01*G0_1_2 + 1.734728025960648e-01*G0_2_0 + 8.931337598872241e-02*G0_2_1 + 8.468134553203888e-02*G0_2_2;
    block[993] = 5.675868306076542e-02*G0_0_0 + 1.898480088584201e-02*G0_0_1 + 3.787174197330379e-02*G0_0_2 + 5.675868306076535e-02*G0_1_0 + 1.898480088584202e-02*G0_1_1 + 3.787174197330372e-02*G0_1_2 + 3.787174197330381e-02*G0_2_0 + 9.492400442920877e-03*G0_2_1 + 1.278701365506877e-02*G0_2_2;
    block[994] = -2.544354757896401e-02*G0_0_0 + 1.487468935385611e-02*G0_0_1 + 1.363513190770108e-02*G0_0_2 - 2.544354757896392e-02*G0_1_0 + 1.487468935385608e-02*G0_1_1 + 1.363513190770107e-02*G0_1_2 + 1.363513190770137e-02*G0_2_0 - 6.523986558682230e-05*G0_2_1 - 1.304797311741354e-04*G0_2_2;
    block[995] = -3.346805104617577e-01*G0_0_0 - 1.669488160373559e-01*G0_0_1 - 2.508146632495570e-01*G0_0_2 - 3.346805104617573e-01*G0_1_0 - 1.669488160373558e-01*G0_1_1 - 2.508146632495568e-01*G0_1_2 - 2.508146632495569e-01*G0_2_0 - 1.607836487393760e-01*G0_2_1 - 6.223883177008028e-02*G0_2_2;
    block[996] = 3.718672338463994e-02*G0_0_0 - 4.364547007776101e-02*G0_0_1 - 3.715410345184597e-02*G0_0_2 + 3.718672338463981e-02*G0_1_0 - 4.364547007776091e-02*G0_1_1 - 3.715410345184596e-02*G0_1_2 - 3.715410345184621e-02*G0_2_0 - 9.753359905269272e-03*G0_2_1 - 6.784946021056944e-03*G0_2_2;
    block[997] = 1.213461499919822e-01*G0_0_0 + 1.323064474106129e-01*G0_0_1 + 1.946757589118682e-01*G0_0_2 + 1.213461499919822e-01*G0_1_0 + 1.323064474106126e-01*G0_1_1 + 1.946757589118680e-01*G0_1_2 + 1.946757589118687e-01*G0_2_0 + 5.897683849072631e-02*G0_2_1 - 3.392473010529196e-03*G0_2_2;
    block[998] = 4.762510187857372e-02*G0_0_0 + 4.762510187857355e-02*G0_0_1 - 1.474420962268168e-02*G0_0_2 + 4.762510187857371e-02*G0_1_0 + 4.762510187857363e-02*G0_1_1 - 1.474420962268160e-02*G0_1_2 - 1.474420962268165e-02*G0_2_0 - 1.474420962268173e-02*G0_2_1 + 4.762510187857388e-02*G0_2_2;
    block[999] = 8.807381854256767e-03*G0_0_0 + 8.807381854256599e-03*G0_0_1 + 2.316015228341855e-03*G0_0_2 + 8.807381854256727e-03*G0_1_0 + 8.807381854256516e-03*G0_1_1 + 2.316015228341861e-03*G0_1_2 + 2.316015228341568e-03*G0_2_0 + 2.316015228341492e-03*G0_2_1 - 6.523986558707795e-04*G0_2_2;
    block[1000] = -1.304797311741574e-03*G0_0_0 - 1.304797311741944e-03*G0_0_1 - 6.523986558679368e-05*G0_0_2 - 1.304797311741590e-03*G0_1_0 - 1.304797311741947e-03*G0_1_1 - 6.523986558682828e-05*G0_1_2 - 6.523986558709098e-05*G0_2_0 - 6.523986558717328e-05*G0_2_1;
    block[1001] = 8.807381854256790e-03*G0_0_0 + 8.807381854256823e-03*G0_0_1 + 2.316015228341507e-03*G0_0_2 + 8.807381854256674e-03*G0_1_0 + 8.807381854256741e-03*G0_1_1 + 2.316015228341513e-03*G0_1_2 + 2.316015228341212e-03*G0_2_0 + 2.316015228341415e-03*G0_2_1 - 6.523986558707965e-04*G0_2_2;
    block[1002] = -1.565756774090102e-02*G0_0_0 - 1.565756774090074e-02*G0_0_1 - 2.576974690690140e-03*G0_0_2 - 1.565756774090096e-02*G0_1_0 - 1.565756774090070e-02*G0_1_1 - 2.576974690690128e-03*G0_1_2 - 2.576974690689893e-03*G0_2_0 - 2.576974690689930e-03*G0_2_1;
    block[1003] = -1.304797311741644e-03*G0_0_0 - 1.304797311741760e-03*G0_0_1 - 6.523986558703514e-05*G0_0_2 - 1.304797311741629e-03*G0_1_0 - 1.304797311741709e-03*G0_1_1 - 6.523986558693808e-05*G0_1_2 - 6.523986558704533e-05*G0_2_0 - 6.523986558700930e-05*G0_2_1;
    block[1004] = -1.565756774090086e-01*G0_0_0 - 1.565756774090085e-01*G0_0_1 - 6.621846357089249e-02*G0_0_2 - 1.565756774090084e-01*G0_1_0 - 1.565756774090083e-01*G0_1_1 - 6.621846357089264e-02*G0_1_2 - 6.621846357089282e-02*G0_2_0 - 6.621846357089296e-02*G0_2_1 - 1.617948666559767e-01*G0_2_2;
    block[1005] = 3.914391935225154e-02*G0_0_0 + 3.914391935225195e-02*G0_0_1 + 7.176385214579191e-03*G0_0_2 + 3.914391935225150e-02*G0_1_0 + 3.914391935225192e-02*G0_1_1 + 7.176385214579285e-03*G0_1_2 + 7.176385214579321e-03*G0_2_0 + 7.176385214579321e-03*G0_2_1 + 1.304797311741919e-03*G0_2_2;
    block[1006] = 3.914391935225207e-02*G0_0_0 + 3.914391935225150e-02*G0_0_1 + 7.176385214579807e-03*G0_0_2 + 3.914391935225203e-02*G0_1_0 + 3.914391935225151e-02*G0_1_1 + 7.176385214579727e-03*G0_1_2 + 7.176385214579509e-03*G0_2_0 + 7.176385214579617e-03*G0_2_1 + 1.304797311741838e-03*G0_2_2;
    block[1007] = 1.859336169231986e-01*G0_0_0 + 1.859336169231982e-01*G0_0_1 + 1.702760491822962e-01*G0_0_2 + 1.859336169231987e-01*G0_1_0 + 1.859336169231982e-01*G0_1_1 + 1.702760491822962e-01*G0_1_2 + 1.702760491822974e-01*G0_2_0 + 1.702760491822969e-01*G0_2_1 + 1.807144276762313e-01*G0_2_2;
    block[1008] = -1.555448875327325e-02*G0_0_0 - 1.555448875327326e-02*G0_0_1 - 1.555448875327331e-02*G0_0_2 - 1.555448875327324e-02*G0_1_0 - 1.555448875327324e-02*G0_1_1 - 1.555448875327330e-02*G0_1_2 - 3.881772002431688e-02*G0_2_0 - 3.881772002431687e-02*G0_2_1 - 3.881772002431684e-02*G0_2_2;
    block[1009] = -3.365072266981985e-03*G0_0_0 - 3.365072266981991e-03*G0_1_0;
    block[1010] = -3.365072266981863e-03*G0_0_1 - 3.365072266981860e-03*G0_1_1;
    block[1011] = 3.365855145369009e-02*G0_0_2 + 3.365855145369009e-02*G0_1_2 + 5.512768642108896e-02*G0_2_2;
    block[1012] = 2.289919282106847e-03*G0_0_0 + 2.289919282106831e-03*G0_0_1 + 2.289919282106858e-03*G0_1_0 + 2.289919282106833e-03*G0_1_1;
    block[1013] = 1.787572317086234e-03*G0_0_0 + 1.787572317086215e-03*G0_0_1 + 1.787572317086253e-03*G0_1_0 + 1.787572317086236e-03*G0_1_1;
    block[1014] = 1.787572317086273e-03*G0_0_0 + 1.787572317086353e-03*G0_0_1 + 1.787572317086257e-03*G0_1_0 + 1.787572317086339e-03*G0_1_1;
    block[1015] = 2.289919282106823e-03*G0_0_0 + 2.289919282106586e-03*G0_0_1 + 2.289919282106846e-03*G0_1_0 + 2.289919282106598e-03*G0_1_1;
    block[1016] = -2.289919282106805e-03*G0_0_0 + 9.394540644540230e-03*G0_0_1 - 2.289919282106793e-03*G0_0_2 - 2.289919282106822e-03*G0_1_0 + 9.394540644540235e-03*G0_1_1 - 2.289919282106811e-03*G0_1_2 - 2.289919282106740e-03*G0_2_1;
    block[1017] = 1.321759676794397e-02*G0_0_0 + 6.523986558754899e-05*G0_0_1 + 1.321759676794397e-02*G0_0_2 + 1.321759676794397e-02*G0_1_0 + 6.523986558753798e-05*G0_1_1 + 1.321759676794397e-02*G0_1_2 + 6.523986558714661e-05*G0_2_0 + 1.321759676794399e-02*G0_2_1 + 6.523986558718830e-05*G0_2_2;
    block[1018] = -4.827750053444703e-04*G0_0_0 + 6.523986558688197e-05*G0_0_1 - 4.827750053444613e-04*G0_0_2 - 4.827750053445029e-04*G0_1_0 + 6.523986558689132e-05*G0_1_1 - 4.827750053444943e-04*G0_1_2 - 6.263027096360721e-03*G0_2_0 - 4.827750053445053e-04*G0_2_1 - 6.263027096360744e-03*G0_2_2;
    block[1019] = 2.837281754382422e-02*G0_0_0 + 9.394540644540610e-03*G0_0_1 + 2.837281754382419e-02*G0_0_2 + 2.837281754382423e-02*G0_1_0 + 9.394540644540600e-03*G0_1_1 + 2.837281754382421e-02*G0_1_2 - 3.154347501135683e-02*G0_2_0 + 2.837281754382425e-02*G0_2_1 - 3.154347501135684e-02*G0_2_2;
    block[1020] = 9.394540644540631e-03*G0_0_0 + 2.837281754382427e-02*G0_0_1 + 2.837281754382426e-02*G0_0_2 + 9.394540644540615e-03*G0_1_0 + 2.837281754382428e-02*G0_1_1 + 2.837281754382426e-02*G0_1_2 + 2.837281754382425e-02*G0_2_0 - 3.154347501135690e-02*G0_2_1 - 3.154347501135691e-02*G0_2_2;
    block[1021] = 6.523986558692515e-05*G0_0_0 - 4.827750053445086e-04*G0_0_1 - 4.827750053444637e-04*G0_0_2 + 6.523986558695338e-05*G0_1_0 - 4.827750053445266e-04*G0_1_1 - 4.827750053444820e-04*G0_1_2 - 4.827750053445502e-04*G0_2_0 - 6.263027096360454e-03*G0_2_1 - 6.263027096360446e-03*G0_2_2;
    block[1022] = 6.523986558719139e-05*G0_0_0 + 1.321759676794378e-02*G0_0_1 + 1.321759676794375e-02*G0_0_2 + 6.523986558715035e-05*G0_1_0 + 1.321759676794377e-02*G0_1_1 + 1.321759676794374e-02*G0_1_2 + 1.321759676794404e-02*G0_2_0 + 6.523986558702879e-05*G0_2_1 + 6.523986558703677e-05*G0_2_2;
    block[1023] = 9.394540644540577e-03*G0_0_0 - 2.289919282106775e-03*G0_0_1 - 2.289919282106738e-03*G0_0_2 + 9.394540644540622e-03*G0_1_0 - 2.289919282106781e-03*G0_1_1 - 2.289919282106740e-03*G0_1_2 - 2.289919282106876e-03*G0_2_0;
    block[1024] = 1.007173044933451e-01*G0_0_0 + 1.007173044933451e-01*G0_0_1 + 8.173902759406157e-02*G0_0_2 + 1.007173044933451e-01*G0_1_0 + 1.007173044933450e-01*G0_1_1 + 8.173902759406153e-02*G0_1_2 + 1.253518777390296e-01*G0_2_0 + 1.253518777390295e-01*G0_2_1 + 1.852681702942105e-01*G0_2_2;
    block[1025] = -2.041877313144658e-01*G0_0_0 - 2.041877313144657e-01*G0_0_1 - 1.676925505050491e-01*G0_0_2 - 2.041877313144657e-01*G0_1_0 - 2.041877313144656e-01*G0_1_1 - 1.676925505050490e-01*G0_1_2 - 2.194930037811965e-01*G0_2_0 - 2.194930037811965e-01*G0_2_1 - 3.871855542862464e-01*G0_2_2;
    block[1026] = 2.810011490567022e-01*G0_0_0 + 2.810011490567021e-01*G0_0_1 + 2.028698860296065e-01*G0_0_2 + 2.810011490567021e-01*G0_1_0 + 2.810011490567020e-01*G0_1_1 + 2.028698860296064e-01*G0_1_2 + 2.028698860296065e-01*G0_2_0 + 2.028698860296064e-01*G0_2_1 + 4.289651642082169e-01*G0_2_2;
    block[1027] = -1.086374241756178e-01*G0_0_0 - 1.086374241756178e-01*G0_0_1 - 1.350204258190358e-01*G0_0_2 - 1.086374241756177e-01*G0_1_0 - 1.086374241756177e-01*G0_1_1 - 1.350204258190358e-01*G0_1_2 - 6.991103996312278e-02*G0_2_0 - 6.991103996312278e-02*G0_2_1 - 2.433577466129533e-01*G0_2_2;
    block[1028] = 1.116906498850948e-02*G0_0_0 + 2.289919282106916e-03*G0_0_2 + 1.116906498850948e-02*G0_1_0 + 2.289919282106919e-03*G0_1_2 + 2.289919282106853e-03*G0_2_0;
    block[1029] = -5.232237220084555e-03*G0_0_0 + 5.480148709313762e-04*G0_0_2 - 5.232237220084606e-03*G0_1_0 + 5.480148709313454e-04*G0_1_2 + 5.480148709314177e-04*G0_2_0 + 6.523986558688636e-05*G0_2_2;
    block[1030] = -9.603308214419157e-03*G0_0_0 - 4.801654107209528e-03*G0_0_2 - 9.603308214419145e-03*G0_1_0 - 4.801654107209467e-03*G0_1_2 - 4.801654107209744e-03*G0_2_0 + 2.609594623483907e-04*G0_2_2;
    block[1031] = 1.086374241756178e-01*G0_0_0 + 6.991103996312273e-02*G0_0_2 + 1.086374241756177e-01*G0_1_0 + 6.991103996312266e-02*G0_1_2 + 6.991103996312278e-02*G0_2_0 + 1.249343425992703e-02*G0_2_2;
    block[1032] = 1.116906498850904e-02*G0_0_1 + 2.289919282106867e-03*G0_0_2 + 1.116906498850906e-02*G0_1_1 + 2.289919282106888e-03*G0_1_2 + 2.289919282106867e-03*G0_2_1;
    block[1033] = -5.232237220084060e-03*G0_0_1 + 5.480148709311841e-04*G0_0_2 - 5.232237220084069e-03*G0_1_1 + 5.480148709311749e-04*G0_1_2 + 5.480148709316059e-04*G0_2_1 + 6.523986558719359e-05*G0_2_2;
    block[1034] = -9.603308214419379e-03*G0_0_1 - 4.801654107209247e-03*G0_0_2 - 9.603308214419343e-03*G0_1_1 - 4.801654107209205e-03*G0_1_2 - 4.801654107209721e-03*G0_2_1 + 2.609594623482421e-04*G0_2_2;
    block[1035] = 1.086374241756178e-01*G0_0_1 + 6.991103996312269e-02*G0_0_2 + 1.086374241756177e-01*G0_1_1 + 6.991103996312265e-02*G0_1_2 + 6.991103996312276e-02*G0_2_1 + 1.249343425992706e-02*G0_2_2;
    block[1036] = -1.174317580567338e-03*G0_0_0 - 1.174317580567206e-03*G0_0_1 + 6.523986558722675e-05*G0_0_2 - 1.174317580567338e-03*G0_1_0 - 1.174317580567226e-03*G0_1_1 + 6.523986558725609e-05*G0_1_2 + 6.523986558732385e-05*G0_2_0 + 6.523986558740547e-05*G0_2_1;
    block[1037] = 3.522952741702241e-03*G0_0_0 + 3.522952741702097e-03*G0_0_1 - 2.968413884212520e-03*G0_0_2 + 3.522952741702279e-03*G0_1_0 + 3.522952741702158e-03*G0_1_1 - 2.968413884212521e-03*G0_1_2 - 2.968413884212735e-03*G0_2_0 - 2.968413884212912e-03*G0_2_1 - 6.523986558706823e-04*G0_2_2;
    block[1038] = 1.247386230025110e-01*G0_0_0 + 1.247386230025111e-01*G0_0_1 + 6.236931150125477e-02*G0_0_2 + 1.247386230025109e-01*G0_1_0 + 1.247386230025110e-01*G0_1_1 + 6.236931150125474e-02*G0_1_2 + 6.236931150125540e-02*G0_2_0 + 6.236931150125542e-02*G0_2_1 + 4.762510187857327e-02*G0_2_2;
    block[1039] = -1.050361835952121e-02*G0_0_0 - 1.050361835952133e-02*G0_0_1 + 2.576974690689909e-03*G0_0_2 - 1.050361835952123e-02*G0_1_0 - 1.050361835952133e-02*G0_1_1 + 2.576974690689892e-03*G0_1_2 + 2.576974690689899e-03*G0_2_0 + 2.576974690689982e-03*G0_2_1;
    block[1040] = 3.522952741702968e-03*G0_0_0 + 3.522952741702726e-03*G0_0_1 - 2.968413884212184e-03*G0_0_2 + 3.522952741703010e-03*G0_1_0 + 3.522952741702740e-03*G0_1_1 - 2.968413884212185e-03*G0_1_2 - 2.968413884212673e-03*G0_2_0 - 2.968413884212642e-03*G0_2_1 - 6.523986558706618e-04*G0_2_2;
    block[1041] = -1.174317580567964e-03*G0_0_0 - 1.174317580567620e-03*G0_0_1 + 6.523986558685110e-05*G0_0_2 - 1.174317580567941e-03*G0_1_0 - 1.174317580567590e-03*G0_1_1 + 6.523986558688441e-05*G0_1_2 + 6.523986558729152e-05*G0_2_0 + 6.523986558717327e-05*G0_2_1;
    block[1042] = 1.174317580567962e-03*G0_0_0 - 5.284429112554002e-02*G0_0_1 - 1.376561163887527e-02*G0_0_2 + 1.174317580567924e-03*G0_1_0 - 5.284429112554006e-02*G0_1_1 - 1.376561163887525e-02*G0_1_2 - 6.523986558728446e-05*G0_2_0 - 1.376561163887560e-02*G0_2_1 - 1.304797311744579e-04*G0_2_2;
    block[1043] = -3.522952741702996e-03*G0_0_0 + 1.047099842672750e-01*G0_0_1 + 3.036915743078959e-02*G0_0_2 - 3.522952741703037e-03*G0_1_0 + 1.047099842672750e-01*G0_1_1 + 3.036915743078951e-02*G0_1_2 + 2.968413884212674e-03*G0_2_0 + 3.036915743078917e-02*G0_2_1 - 6.784946021056970e-03*G0_2_2;
    block[1044] = -1.247386230025108e-01*G0_0_0 - 2.713978408422828e-01*G0_0_1 - 1.980682319223973e-01*G0_0_2 - 1.247386230025107e-01*G0_1_0 - 2.713978408422828e-01*G0_1_1 - 1.980682319223972e-01*G0_1_2 - 6.236931150125534e-02*G0_2_0 - 1.980682319223966e-01*G0_2_1 - 3.392473010527869e-03*G0_2_2;
    block[1045] = -1.559232787531447e-02*G0_0_0 - 6.197787230773997e-03*G0_0_1 - 2.508472831823549e-02*G0_0_2 - 1.559232787531445e-02*G0_1_0 - 6.197787230773969e-03*G0_1_1 - 2.508472831823542e-02*G0_1_2 + 3.294613212147909e-03*G0_2_0 - 2.508472831823496e-02*G0_2_1 + 1.278701365506953e-02*G0_2_2;
    block[1046] = 1.824106641814960e-01*G0_0_0 + 1.047099842672746e-01*G0_0_1 + 1.885758314794758e-01*G0_0_2 + 1.824106641814960e-01*G0_1_0 + 1.047099842672745e-01*G0_1_1 + 1.885758314794758e-01*G0_1_2 + 9.854481696929489e-02*G0_2_0 + 1.885758314794755e-01*G0_2_1 - 6.223883177008267e-02*G0_2_2;
    block[1047] = -5.101757488910196e-02*G0_0_0 - 5.284429112554018e-02*G0_0_1 - 8.879145706402564e-02*G0_0_2 - 5.101757488910189e-02*G0_1_0 - 5.284429112554023e-02*G0_1_1 - 8.879145706402561e-02*G0_1_2 - 4.632030456682681e-03*G0_2_0 - 8.879145706402587e-02*G0_2_1 + 8.468134553204017e-02*G0_2_2;
    block[1048] = -2.713978408422829e-01*G0_0_0 - 1.247386230025107e-01*G0_0_1 - 1.980682319223974e-01*G0_0_2 - 2.713978408422830e-01*G0_1_0 - 1.247386230025106e-01*G0_1_1 - 1.980682319223973e-01*G0_1_2 - 1.980682319223965e-01*G0_2_0 - 6.236931150125517e-02*G0_2_1 - 3.392473010527844e-03*G0_2_2;
    block[1049] = 1.047099842672751e-01*G0_0_0 - 3.522952741702135e-03*G0_0_1 + 3.036915743078958e-02*G0_0_2 + 1.047099842672752e-01*G0_1_0 - 3.522952741702193e-03*G0_1_1 + 3.036915743078951e-02*G0_1_2 + 3.036915743078945e-02*G0_2_0 + 2.968413884212861e-03*G0_2_1 - 6.784946021056852e-03*G0_2_2;
    block[1050] = -5.284429112554079e-02*G0_0_0 + 1.174317580567110e-03*G0_0_1 - 1.376561163887561e-02*G0_0_2 - 5.284429112554083e-02*G0_1_0 + 1.174317580567135e-03*G0_1_1 - 1.376561163887556e-02*G0_1_2 - 1.376561163887534e-02*G0_2_0 - 6.523986558744310e-05*G0_2_1 - 1.304797311739905e-04*G0_2_2;
    block[1051] = 1.047099842672750e-01*G0_0_0 + 1.824106641814961e-01*G0_0_1 + 1.885758314794763e-01*G0_0_2 + 1.047099842672749e-01*G0_1_0 + 1.824106641814961e-01*G0_1_1 + 1.885758314794762e-01*G0_1_2 + 1.885758314794754e-01*G0_2_0 + 9.854481696929458e-02*G0_2_1 - 6.223883177008274e-02*G0_2_2;
    block[1052] = -6.197787230773381e-03*G0_0_0 - 1.559232787531380e-02*G0_0_1 - 2.508472831823503e-02*G0_0_2 - 6.197787230773310e-03*G0_1_0 - 1.559232787531384e-02*G0_1_1 - 2.508472831823502e-02*G0_1_2 - 2.508472831823550e-02*G0_2_0 + 3.294613212147537e-03*G0_2_1 + 1.278701365506895e-02*G0_2_2;
    block[1053] = -5.284429112554041e-02*G0_0_0 - 5.101757488910213e-02*G0_0_1 - 8.879145706402586e-02*G0_0_2 - 5.284429112554047e-02*G0_1_0 - 5.101757488910209e-02*G0_1_1 - 8.879145706402583e-02*G0_1_2 - 8.879145706402554e-02*G0_2_0 - 4.632030456682276e-03*G0_2_1 + 8.468134553204024e-02*G0_2_2;
    block[1054] = -1.500516908502991e-02*G0_0_0 - 1.500516908503001e-02*G0_0_1 + 2.276871308989343e-02*G0_0_2 - 1.500516908502994e-02*G0_1_0 - 1.500516908503004e-02*G0_1_1 + 2.276871308989341e-02*G0_1_2 + 2.276871308989376e-02*G0_2_0 + 2.276871308989364e-02*G0_2_1 - 6.654466289882907e-02*G0_2_2;
    block[1055] = -6.523986558710368e-04*G0_0_0 - 6.523986558705375e-04*G0_0_1 + 8.840001787050369e-03*G0_0_2 - 6.523986558710066e-04*G0_1_0 - 6.523986558704982e-04*G0_1_1 + 8.840001787050356e-03*G0_1_2 + 8.840001787049950e-03*G0_2_0 + 8.840001787050352e-03*G0_2_1 - 6.523986558711112e-04*G0_2_2;
    block[1056] = -1.500516908503010e-02*G0_0_0 - 1.500516908502999e-02*G0_0_1 - 6.523986558750177e-05*G0_0_2 - 1.500516908503012e-02*G0_1_0 - 1.500516908503000e-02*G0_1_1 - 6.523986558753485e-05*G0_1_2 - 6.523986558691336e-05*G0_2_0 - 6.523986558680174e-05*G0_2_1;
    block[1057] = -6.523986558708858e-04*G0_0_0 - 6.523986558710689e-04*G0_0_1 + 8.840001787050161e-03*G0_0_2 - 6.523986558708538e-04*G0_1_0 - 6.523986558710620e-04*G0_1_1 + 8.840001787050160e-03*G0_1_2 + 8.840001787050692e-03*G0_2_0 + 8.840001787050408e-03*G0_2_1 - 6.523986558710772e-04*G0_2_2;
    block[1058] = -6.523986558708576e-04*G0_0_0 - 6.523986558711655e-04*G0_0_1 - 2.576974690689892e-03*G0_0_2 - 6.523986558708749e-04*G0_1_0 - 6.523986558711672e-04*G0_1_1 - 2.576974690689874e-03*G0_1_2 - 2.576974690689918e-03*G0_2_0 - 2.576974690690032e-03*G0_2_1;
    block[1059] = -1.500516908503026e-02*G0_0_0 - 1.500516908502992e-02*G0_0_1 - 6.523986558702558e-05*G0_0_2 - 1.500516908503024e-02*G0_1_0 - 1.500516908502992e-02*G0_1_1 - 6.523986558705802e-05*G0_1_2 - 6.523986558722156e-05*G0_2_0 - 6.523986558711506e-05*G0_2_1;
    block[1060] = 2.609594623483440e-02*G0_0_0 + 2.609594623483412e-02*G0_0_1 + 1.043837849393365e-02*G0_0_2 + 2.609594623483431e-02*G0_1_0 + 2.609594623483411e-02*G0_1_1 + 1.043837849393370e-02*G0_1_2 + 1.043837849393302e-02*G0_2_0 + 1.043837849393287e-02*G0_2_1 + 1.807144276762319e-01*G0_2_2;
    block[1061] = 2.609594623483493e-02*G0_0_0 + 2.609594623483500e-02*G0_0_1 - 5.871587902837502e-03*G0_0_2 + 2.609594623483499e-02*G0_1_0 + 2.609594623483504e-02*G0_1_1 - 5.871587902837485e-03*G0_1_2 - 5.871587902837620e-03*G0_2_0 - 5.871587902837519e-03*G0_2_1 + 1.304797311741816e-03*G0_2_2;
    block[1062] = 2.609594623483581e-02*G0_0_0 + 2.609594623483589e-02*G0_0_1 - 5.871587902837688e-03*G0_0_2 + 2.609594623483581e-02*G0_1_0 + 2.609594623483583e-02*G0_1_1 - 5.871587902837683e-03*G0_1_2 - 5.871587902837756e-03*G0_2_0 - 5.871587902837692e-03*G0_2_1 + 1.304797311741834e-03*G0_2_2;
    block[1063] = -1.859336169231983e-01*G0_0_0 - 1.859336169231990e-01*G0_0_1 - 9.557640308508199e-02*G0_0_2 - 1.859336169231983e-01*G0_1_0 - 1.859336169231989e-01*G0_1_1 - 9.557640308508202e-02*G0_1_2 - 9.557640308508214e-02*G0_2_0 - 9.557640308508195e-02*G0_2_1 - 1.617948666559758e-01*G0_2_2;
    block[1064] = 4.800349309897840e-03*G0_0_0 + 4.800349309897837e-03*G0_0_1 + 4.800349309897875e-03*G0_0_2 + 4.800349309897839e-03*G0_1_0 + 4.800349309897837e-03*G0_1_1 + 4.800349309897876e-03*G0_1_2 + 1.533136841296549e-02*G0_2_0 + 1.533136841296549e-02*G0_2_1 + 1.533136841296548e-02*G0_2_2;
    block[1065] = -4.800349309897874e-03*G0_0_0 - 4.800349309897879e-03*G0_1_0;
    block[1066] = -4.800349309897887e-03*G0_0_1 - 4.800349309897887e-03*G0_1_1;
    block[1067] = -3.725718243947380e-02*G0_0_2 - 3.725718243947380e-02*G0_1_2 - 5.512768642108890e-02*G0_2_2;
    block[1068] = 5.375764924375791e-03*G0_0_0 + 5.375764924375866e-03*G0_0_1 + 5.375764924375821e-03*G0_1_0 + 5.375764924375886e-03*G0_1_1;
    block[1069] = 2.289919282106798e-03*G0_0_0 + 2.289919282106765e-03*G0_0_1 + 2.289919282106771e-03*G0_1_0 + 2.289919282106746e-03*G0_1_1;
    block[1070] = 2.289919282106657e-03*G0_0_0 + 2.289919282106662e-03*G0_0_1 + 2.289919282106668e-03*G0_1_0 + 2.289919282106678e-03*G0_1_1;
    block[1071] = 5.375764924375991e-03*G0_0_0 + 5.375764924376076e-03*G0_0_1 + 5.375764924375996e-03*G0_1_0 + 5.375764924376076e-03*G0_1_1;
    block[1072] = -5.375764924375991e-03*G0_0_0 - 5.375764924376002e-03*G0_0_2 - 5.375764924375996e-03*G0_1_0 - 5.375764924376006e-03*G0_1_2 - 5.375764924376016e-03*G0_2_1;
    block[1073] = -2.289919282106804e-03*G0_0_0 - 2.289919282106793e-03*G0_0_2 - 2.289919282106807e-03*G0_1_0 - 2.289919282106795e-03*G0_1_2 + 9.394540644540534e-03*G0_2_0 - 2.289919282106828e-03*G0_2_1 + 9.394540644540511e-03*G0_2_2;
    block[1074] = -2.289919282106689e-03*G0_0_0 - 2.289919282106762e-03*G0_0_2 - 2.289919282106685e-03*G0_1_0 - 2.289919282106756e-03*G0_1_2 + 6.589226424296084e-03*G0_2_0 - 2.289919282106697e-03*G0_2_1 + 6.589226424296087e-03*G0_2_2;
    block[1075] = -5.375764924376121e-03*G0_0_0 - 5.375764924376090e-03*G0_0_2 - 5.375764924376120e-03*G0_1_0 - 5.375764924376092e-03*G0_1_2 + 2.208369450122910e-02*G0_2_0 - 5.375764924376032e-03*G0_2_1 + 2.208369450122909e-02*G0_2_2;
    block[1076] = -5.375764924376096e-03*G0_0_1 - 5.375764924376060e-03*G0_0_2 - 5.375764924376095e-03*G0_1_1 - 5.375764924376056e-03*G0_1_2 - 5.375764924376075e-03*G0_2_0 + 2.208369450122904e-02*G0_2_1 + 2.208369450122906e-02*G0_2_2;
    block[1077] = -2.289919282106675e-03*G0_0_1 - 2.289919282106739e-03*G0_0_2 - 2.289919282106681e-03*G0_1_1 - 2.289919282106745e-03*G0_1_2 - 2.289919282106622e-03*G0_2_0 + 6.589226424295896e-03*G0_2_1 + 6.589226424295877e-03*G0_2_2;
    block[1078] = -2.289919282106762e-03*G0_0_1 - 2.289919282106791e-03*G0_0_2 - 2.289919282106756e-03*G0_1_1 - 2.289919282106786e-03*G0_1_2 - 2.289919282106877e-03*G0_2_0 + 9.394540644540629e-03*G0_2_1 + 9.394540644540620e-03*G0_2_2;
    block[1079] = -5.375764924375940e-03*G0_0_1 - 5.375764924375922e-03*G0_0_2 - 5.375764924375960e-03*G0_1_1 - 5.375764924375943e-03*G0_1_2 - 5.375764924375906e-03*G0_2_0;
    block[1080] = -3.283522434998101e-02*G0_0_0 - 3.283522434998098e-02*G0_0_1 - 2.745945942560508e-02*G0_0_2 - 3.283522434998101e-02*G0_1_0 - 3.283522434998100e-02*G0_1_1 - 2.745945942560508e-02*G0_1_2 - 5.375112525720119e-02*G0_2_0 - 5.375112525720119e-02*G0_2_1 - 8.121058468280630e-02*G0_2_2;
    block[1081] = 7.889456945446467e-02*G0_0_0 + 7.889456945446460e-02*G0_0_1 + 5.991629255518111e-02*G0_0_2 + 7.889456945446469e-02*G0_1_0 + 7.889456945446459e-02*G0_1_1 + 5.991629255518111e-02*G0_1_2 + 1.035291427001487e-01*G0_2_0 + 1.035291427001487e-01*G0_2_1 + 1.852681702942108e-01*G0_2_2;
    block[1082] = -1.086374241756178e-01*G0_0_0 - 1.086374241756177e-01*G0_0_1 - 6.991103996312278e-02*G0_0_2 - 1.086374241756178e-01*G0_1_0 - 1.086374241756177e-01*G0_1_1 - 6.991103996312280e-02*G0_1_2 - 1.350204258190358e-01*G0_2_0 - 1.350204258190358e-01*G0_2_1 - 2.433577466129533e-01*G0_2_2;
    block[1083] = 1.398220799262456e-01*G0_0_0 + 1.398220799262456e-01*G0_0_1 + 6.991103996312259e-02*G0_0_2 + 1.398220799262456e-01*G0_1_0 + 1.398220799262457e-01*G0_1_1 + 6.991103996312260e-02*G0_1_2 + 6.991103996312259e-02*G0_2_0 + 6.991103996312260e-02*G0_2_1 + 1.790964790096723e-01*G0_2_2;
    block[1084] = 3.283522434998090e-02*G0_0_0 + 5.375764924375806e-03*G0_0_2 + 3.283522434998096e-02*G0_1_0 + 5.375764924375828e-03*G0_1_2 + 5.375764924375900e-03*G0_2_0;
    block[1085] = -7.889456945446463e-02*G0_0_0 - 1.897827689928351e-02*G0_0_2 - 7.889456945446467e-02*G0_1_0 - 1.897827689928352e-02*G0_1_2 - 1.897827689928359e-02*G0_2_0 + 9.394540644540804e-03*G0_2_2;
    block[1086] = 1.086374241756178e-01*G0_0_0 + 3.872638421249495e-02*G0_0_2 + 1.086374241756179e-01*G0_1_0 + 3.872638421249494e-02*G0_1_2 + 3.872638421249498e-02*G0_2_0 - 1.869122149070077e-02*G0_2_2;
    block[1087] = -1.398220799262456e-01*G0_0_0 - 6.991103996312291e-02*G0_0_2 - 1.398220799262457e-01*G0_1_0 - 6.991103996312290e-02*G0_1_2 - 6.991103996312260e-02*G0_2_0 + 1.963719954171359e-02*G0_2_2;
    block[1088] = 3.283522434998110e-02*G0_0_1 + 5.375764924375903e-03*G0_0_2 + 3.283522434998112e-02*G0_1_1 + 5.375764924375906e-03*G0_1_2 + 5.375764924375912e-03*G0_2_1;
    block[1089] = -7.889456945446481e-02*G0_0_1 - 1.897827689928341e-02*G0_0_2 - 7.889456945446488e-02*G0_1_1 - 1.897827689928343e-02*G0_1_2 - 1.897827689928361e-02*G0_2_1 + 9.394540644540702e-03*G0_2_2;
    block[1090] = 1.086374241756178e-01*G0_0_1 + 3.872638421249466e-02*G0_0_2 + 1.086374241756179e-01*G0_1_1 + 3.872638421249466e-02*G0_1_2 + 3.872638421249491e-02*G0_2_1 - 1.869122149070068e-02*G0_2_2;
    block[1091] = -1.398220799262456e-01*G0_0_1 - 6.991103996312287e-02*G0_0_2 - 1.398220799262457e-01*G0_1_1 - 6.991103996312288e-02*G0_1_2 - 6.991103996312258e-02*G0_2_1 + 1.963719954171354e-02*G0_2_2;
    block[1092] = -1.187365553685008e-02*G0_0_0 - 1.187365553685043e-02*G0_0_1 + 9.394540644540291e-03*G0_0_2 - 1.187365553685014e-02*G0_1_0 - 1.187365553685039e-02*G0_1_1 + 9.394540644540315e-03*G0_1_2 + 9.394540644540364e-03*G0_2_0 + 9.394540644540261e-03*G0_2_1;
    block[1093] = 4.296045148909736e-02*G0_0_0 + 4.296045148909747e-02*G0_0_1 + 6.850185886641701e-04*G0_0_2 + 4.296045148909739e-02*G0_1_0 + 4.296045148909746e-02*G0_1_1 + 6.850185886641403e-04*G0_1_2 + 6.850185886645925e-04*G0_2_0 + 6.850185886646022e-04*G0_2_1 + 2.267085329151287e-02*G0_2_2;
    block[1094] = -1.247386230025112e-01*G0_0_0 - 1.247386230025111e-01*G0_0_1 - 2.844458139596939e-02*G0_0_2 - 1.247386230025112e-01*G0_1_0 - 1.247386230025111e-01*G0_1_1 - 2.844458139596936e-02*G0_1_2 - 2.844458139596994e-02*G0_2_0 - 2.844458139596990e-02*G0_2_1 - 6.067307499599105e-02*G0_2_2;
    block[1095] = -2.544354757896430e-03*G0_0_0 - 2.544354757896319e-03*G0_0_1 + 3.294613212147929e-03*G0_0_2 - 2.544354757896395e-03*G0_1_0 - 2.544354757896344e-03*G0_1_1 + 3.294613212147915e-03*G0_1_2 + 3.294613212147831e-03*G0_2_0 + 3.294613212147907e-03*G0_2_1;
    block[1096] = 4.296045148909668e-02*G0_0_0 + 4.296045148909666e-02*G0_0_1 + 6.850185886639937e-04*G0_0_2 + 4.296045148909667e-02*G0_1_0 + 4.296045148909672e-02*G0_1_1 + 6.850185886639921e-04*G0_1_2 + 6.850185886644415e-04*G0_2_0 + 6.850185886644074e-04*G0_2_1 + 2.267085329151283e-02*G0_2_2;
    block[1097] = -1.187365553684975e-02*G0_0_0 - 1.187365553684986e-02*G0_0_1 + 9.394540644540626e-03*G0_0_2 - 1.187365553684976e-02*G0_1_0 - 1.187365553684986e-02*G0_1_1 + 9.394540644540645e-03*G0_1_2 + 9.394540644540572e-03*G0_2_0 + 9.394540644540506e-03*G0_2_1;
    block[1098] = 1.187365553684972e-02*G0_0_0 + 2.126819618139048e-02*G0_0_2 + 1.187365553684974e-02*G0_1_0 + 2.126819618139050e-02*G0_1_2 - 9.394540644540572e-03*G0_2_0 + 2.126819618139053e-02*G0_2_1 - 1.878908128908111e-02*G0_2_2;
    block[1099] = -4.296045148909670e-02*G0_0_0 - 4.227543290043274e-02*G0_0_2 - 4.296045148909668e-02*G0_1_0 - 4.227543290043276e-02*G0_1_2 - 6.850185886644248e-04*G0_2_0 - 4.227543290043264e-02*G0_2_1 + 4.397166940569695e-02*G0_2_2;
    block[1100] = 1.247386230025112e-01*G0_0_0 + 9.629404160654147e-02*G0_0_2 + 1.247386230025112e-01*G0_1_0 + 9.629404160654152e-02*G0_1_2 + 2.844458139596994e-02*G0_2_0 + 9.629404160654072e-02*G0_2_1 - 6.445698720004293e-02*G0_2_2;
    block[1101] = 2.544354757896285e-03*G0_0_0 + 5.838967970044360e-03*G0_0_2 + 2.544354757896267e-03*G0_1_0 + 5.838967970044345e-03*G0_1_2 - 5.904207835631401e-03*G0_2_0 + 5.838967970044207e-03*G0_2_1 - 3.186967433929242e-02*G0_2_2;
    block[1102] = -4.296045148909691e-02*G0_0_0 - 4.227543290043307e-02*G0_0_2 - 4.296045148909694e-02*G0_1_0 - 4.227543290043309e-02*G0_1_2 - 3.591454600569132e-02*G0_2_0 - 4.227543290043241e-02*G0_2_1 + 9.208607027617444e-02*G0_2_2;
    block[1103] = 1.187365553684983e-02*G0_0_0 + 2.126819618139074e-02*G0_0_2 + 1.187365553684984e-02*G0_1_0 + 2.126819618139075e-02*G0_1_2 - 1.461372989150778e-02*G0_2_0 + 2.126819618139054e-02*G0_2_1 - 6.934997711907423e-02*G0_2_2;
    block[1104] = 1.247386230025110e-01*G0_0_1 + 9.629404160654165e-02*G0_0_2 + 1.247386230025110e-01*G0_1_1 + 9.629404160654165e-02*G0_1_2 + 9.629404160654065e-02*G0_2_0 + 2.844458139596979e-02*G0_2_1 - 6.445698720004260e-02*G0_2_2;
    block[1105] = -4.296045148909733e-02*G0_0_1 - 4.227543290043306e-02*G0_0_2 - 4.296045148909731e-02*G0_1_1 - 4.227543290043308e-02*G0_1_2 - 4.227543290043268e-02*G0_2_0 - 6.850185886645675e-04*G0_2_1 + 4.397166940569693e-02*G0_2_2;
    block[1106] = 1.187365553685040e-02*G0_0_1 + 2.126819618139059e-02*G0_0_2 + 1.187365553685037e-02*G0_1_1 + 2.126819618139059e-02*G0_1_2 + 2.126819618139045e-02*G0_2_0 - 9.394540644540240e-03*G0_2_1 - 1.878908128908134e-02*G0_2_2;
    block[1107] = -4.296045148909686e-02*G0_0_1 - 4.227543290043326e-02*G0_0_2 - 4.296045148909684e-02*G0_1_1 - 4.227543290043324e-02*G0_1_2 - 4.227543290043243e-02*G0_2_0 - 3.591454600569124e-02*G0_2_1 + 9.208607027617441e-02*G0_2_2;
    block[1108] = 2.544354757896353e-03*G0_0_1 + 5.838967970044553e-03*G0_0_2 + 2.544354757896372e-03*G0_1_1 + 5.838967970044568e-03*G0_1_2 + 5.838967970044551e-03*G0_2_0 - 5.904207835631315e-03*G0_2_1 - 3.186967433929214e-02*G0_2_2;
    block[1109] = 1.187365553684972e-02*G0_0_1 + 2.126819618139070e-02*G0_0_2 + 1.187365553684971e-02*G0_1_1 + 2.126819618139069e-02*G0_1_2 + 2.126819618139032e-02*G0_2_0 - 1.461372989150801e-02*G0_2_1 - 6.934997711907433e-02*G0_2_2;
    block[1110] = -9.394540644540761e-03*G0_0_2 - 9.394540644540768e-03*G0_1_2 - 9.394540644540718e-03*G0_2_0 - 9.394540644540534e-03*G0_2_1 + 4.534170658302580e-02*G0_2_2;
    block[1111] = -3.294613212147897e-03*G0_0_2 - 3.294613212147905e-03*G0_1_2 - 3.294613212147620e-03*G0_2_0 - 3.294613212147884e-03*G0_2_1 + 2.267085329151294e-02*G0_2_2;
    block[1112] = -9.394540644540206e-03*G0_0_2 - 9.394540644540232e-03*G0_1_2 - 9.394540644540681e-03*G0_2_0 - 9.394540644540783e-03*G0_2_1;
    block[1113] = -3.294613212147928e-03*G0_0_2 - 3.294613212147933e-03*G0_1_2 - 3.294613212148200e-03*G0_2_0 - 3.294613212148067e-03*G0_2_1 + 2.267085329151295e-02*G0_2_2;
    block[1114] = -3.294613212147885e-03*G0_0_2 - 3.294613212147873e-03*G0_1_2 - 3.294613212147884e-03*G0_2_0 - 3.294613212147789e-03*G0_2_1;
    block[1115] = -9.394540644540509e-03*G0_0_2 - 9.394540644540532e-03*G0_1_2 - 9.394540644540404e-03*G0_2_0 - 9.394540644540482e-03*G0_2_1;
    block[1116] = 2.609594623484604e-03*G0_0_2 + 2.609594623484589e-03*G0_1_2 + 2.609594623483830e-03*G0_2_0 + 2.609594623484077e-03*G0_2_1 - 1.513564881620426e-01*G0_2_2;
    block[1117] = 2.609594623483559e-03*G0_0_2 + 2.609594623483589e-03*G0_1_2 + 2.609594623483548e-03*G0_2_0 + 2.609594623483422e-03*G0_2_1 - 4.534170658302585e-02*G0_2_2;
    block[1118] = 2.609594623483599e-03*G0_0_2 + 2.609594623483615e-03*G0_1_2 + 2.609594623483545e-03*G0_2_0 + 2.609594623483365e-03*G0_2_1 - 4.534170658302588e-02*G0_2_2;
    block[1119] = 3.522952741702579e-02*G0_0_2 + 3.522952741702578e-02*G0_1_2 + 3.522952741702673e-02*G0_2_0 + 3.522952741702681e-02*G0_2_1 + 1.666878565750080e-01*G0_2_2;
    block[1120] = -4.800349309897936e-03*G0_0_0 - 4.800349309897937e-03*G0_0_1 - 4.800349309897956e-03*G0_0_2 - 4.800349309897881e-03*G0_2_0 - 4.800349309897892e-03*G0_2_1 - 4.800349309897927e-03*G0_2_2;
    block[1121] = -1.787050398161502e-02*G0_0_0 + 3.725718243947363e-02*G0_2_0;
    block[1122] = 4.800349309897889e-03*G0_0_1 + 4.800349309897886e-03*G0_2_1;
    block[1123] = -1.053101910306763e-02*G0_0_2 + 4.800349309897920e-03*G0_2_2;
    block[1124] = 8.954823950483559e-02*G0_0_0 + 6.991103996312228e-02*G0_0_1 + 6.991103996312230e-02*G0_2_0 + 1.398220799262447e-01*G0_2_1;
    block[1125] = -5.741760570319542e-02*G0_0_0 - 6.991103996312248e-02*G0_0_1 - 3.872638421249481e-02*G0_2_0 - 1.086374241756171e-01*G0_2_1;
    block[1126] = 2.837281754382418e-02*G0_0_0 + 5.991629255518068e-02*G0_0_1 + 1.897827689928358e-02*G0_2_0 + 7.889456945446416e-02*G0_2_1;
    block[1127] = -5.375764924375941e-03*G0_0_0 - 2.745945942560485e-02*G0_0_1 - 5.375764924375960e-03*G0_2_0 - 3.283522434998080e-02*G0_2_1;
    block[1128] = 5.375764924375953e-03*G0_0_0 + 5.375764924375913e-03*G0_0_2 + 5.375764924375955e-03*G0_2_0 + 5.375764924375936e-03*G0_2_2;
    block[1129] = 2.289919282106792e-03*G0_0_0 + 2.289919282106758e-03*G0_0_2 + 2.289919282106826e-03*G0_2_0 + 2.289919282106741e-03*G0_2_2;
    block[1130] = 2.289919282106830e-03*G0_0_0 + 2.289919282106821e-03*G0_0_2 + 2.289919282106752e-03*G0_2_0 + 2.289919282106771e-03*G0_2_2;
    block[1131] = 5.375764924375950e-03*G0_0_0 + 5.375764924375923e-03*G0_0_2 + 5.375764924376051e-03*G0_2_0 + 5.375764924375982e-03*G0_2_2;
    block[1132] = 2.208369450122908e-02*G0_0_0 + 2.745945942560495e-02*G0_0_1 + 2.745945942560498e-02*G0_0_2 + 2.745945942560488e-02*G0_2_0 + 3.283522434998085e-02*G0_2_1 + 3.283522434998088e-02*G0_2_2;
    block[1133] = -3.154347501135672e-02*G0_0_0 - 5.991629255518082e-02*G0_0_1 - 5.991629255518083e-02*G0_0_2 - 5.991629255518065e-02*G0_2_0 - 7.889456945446428e-02*G0_2_1 - 7.889456945446428e-02*G0_2_2;
    block[1134] = 1.249343425992729e-02*G0_0_0 + 6.991103996312260e-02*G0_0_1 + 6.991103996312253e-02*G0_0_2 + 6.991103996312240e-02*G0_2_0 + 1.086374241756172e-01*G0_2_1 + 1.086374241756171e-01*G0_2_2;
    block[1135] = 1.963719954171330e-02*G0_0_0 - 6.991103996312234e-02*G0_0_1 - 6.991103996312226e-02*G0_0_2 - 6.991103996312241e-02*G0_2_0 - 1.398220799262448e-01*G0_2_1 - 1.398220799262447e-01*G0_2_2;
    block[1136] = 1.075152984875192e-02*G0_0_0 + 1.075152984875191e-02*G0_0_1 + 5.375764924376072e-03*G0_0_2 + 5.375764924375934e-03*G0_2_0 + 5.375764924375908e-03*G0_2_1;
    block[1137] = 1.397437920875388e-02*G0_0_0 + 1.397437920875388e-02*G0_0_1 + 2.289919282106695e-03*G0_0_2 + 2.289919282106498e-03*G0_2_0 + 2.289919282106518e-03*G0_2_1;
    block[1138] = 1.116906498850948e-02*G0_0_0 + 1.116906498850948e-02*G0_0_1 + 2.289919282106854e-03*G0_0_2 + 2.289919282106916e-03*G0_2_0 + 2.289919282106919e-03*G0_2_1;
    block[1139] = 3.283522434998089e-02*G0_0_0 + 3.283522434998096e-02*G0_0_1 + 5.375764924375899e-03*G0_0_2 + 5.375764924375807e-03*G0_2_0 + 5.375764924375828e-03*G0_2_1;
    block[1140] = 1.790964790096715e-01*G0_0_0 + 6.991103996312217e-02*G0_0_2 + 6.991103996312217e-02*G0_2_0 + 1.398220799262446e-01*G0_2_2;
    block[1141] = -1.470637050064117e-01*G0_0_0 + 2.638300164341855e-02*G0_0_2 - 3.872638421249451e-02*G0_2_0 - 1.086374241756170e-01*G0_2_2;
    block[1142] = 1.007173044933452e-01*G0_0_0 - 2.463457324568448e-02*G0_0_2 + 1.897827689928334e-02*G0_2_0 + 7.889456945446408e-02*G0_2_2;
    block[1143] = -3.283522434998089e-02*G0_0_0 + 2.091590090722035e-02*G0_0_2 - 5.375764924375780e-03*G0_2_0 - 3.283522434998079e-02*G0_2_2;
    block[1144] = -1.075152984875188e-02*G0_0_1 - 5.375764924375907e-03*G0_0_2 - 5.375764924375887e-03*G0_2_1 - 5.375764924375919e-03*G0_2_2;
    block[1145] = -1.397437920875412e-02*G0_0_1 - 1.168445992664728e-02*G0_0_2 - 2.289919282106766e-03*G0_2_1 - 2.289919282106691e-03*G0_2_2;
    block[1146] = -1.116906498850932e-02*G0_0_1 - 8.879145706402622e-03*G0_0_2 - 2.289919282106687e-03*G0_2_1 - 2.289919282106740e-03*G0_2_2;
    block[1147] = -3.283522434998090e-02*G0_0_1 - 2.745945942560495e-02*G0_0_2 - 5.375764924375796e-03*G0_2_1 - 5.375764924375886e-03*G0_2_2;
    block[1148] = -6.445698720004235e-02*G0_0_0 + 1.925880832130808e-01*G0_0_1 + 9.629404160653988e-02*G0_0_2 + 2.844458139597003e-02*G0_2_0 + 1.247386230025099e-01*G0_2_1 + 1.247386230025099e-01*G0_2_2;
    block[1149] = 1.273155976932007e-01*G0_0_0 - 4.932133838383759e-02*G0_0_1 - 7.045905483405219e-03*G0_0_2 - 6.850185886646627e-04*G0_2_0 - 4.296045148909670e-02*G0_2_1 - 4.296045148909683e-02*G0_2_2;
    block[1150] = -6.413078787210663e-02*G0_0_0 + 4.775558160974774e-02*G0_0_1 + 2.648738542835753e-02*G0_0_2 - 9.394540644540220e-03*G0_2_0 + 1.187365553684977e-02*G0_2_1 + 1.187365553685002e-02*G0_2_2;
    block[1151] = 4.397166940569660e-02*G0_0_0 - 8.455086580086518e-02*G0_0_1 - 4.227543290043254e-02*G0_0_2 - 6.850185886645216e-04*G0_2_0 - 4.296045148909682e-02*G0_2_1 - 4.296045148909680e-02*G0_2_2;
    block[1152] = -2.926007971580862e-02*G0_0_0 + 1.428753056357217e-02*G0_0_1 + 8.448562593527794e-03*G0_0_2 - 3.294613212147710e-03*G0_2_0 + 2.544354757896658e-03*G0_2_1 + 2.544354757896610e-03*G0_2_2;
    block[1153] = -1.878908128908090e-02*G0_0_0 + 4.253639236278092e-02*G0_0_1 + 2.126819618139045e-02*G0_0_2 - 9.394540644540372e-03*G0_2_0 + 1.187365553684991e-02*G0_2_1 + 1.187365553684979e-02*G0_2_2;
    block[1154] = 1.878908128908089e-02*G0_0_0 + 9.394540644540471e-03*G0_0_2 + 9.394540644540358e-03*G0_2_0;
    block[1155] = 2.926007971580856e-02*G0_0_0 + 3.294613212147737e-03*G0_0_2 + 3.294613212147680e-03*G0_2_0;
    block[1156] = 6.413078787210678e-02*G0_0_0 + 9.394540644540572e-03*G0_0_2 + 9.394540644540244e-03*G0_2_0;
    block[1157] = 6.589226424296184e-03*G0_0_0 + 3.294613212147943e-03*G0_0_2 + 3.294613212148190e-03*G0_2_0;
    block[1158] = 2.926007971580891e-02*G0_0_0 + 3.294613212147992e-03*G0_0_2 + 3.294613212148151e-03*G0_2_0;
    block[1159] = 1.878908128908093e-02*G0_0_0 + 9.394540644540532e-03*G0_0_2 + 9.394540644540631e-03*G0_2_0;
    block[1160] = -1.118863694818545e-01*G0_0_0 - 4.775558160974775e-02*G0_0_1 - 2.126819618139047e-02*G0_0_2 - 2.126819618139026e-02*G0_2_0 - 1.187365553684978e-02*G0_2_1;
    block[1161] = 1.766369360770383e-01*G0_0_0 + 4.932133838383770e-02*G0_0_1 + 4.227543290043246e-02*G0_0_2 + 4.227543290043199e-02*G0_2_0 + 4.296045148909684e-02*G0_2_1;
    block[1162] = -2.570450704131235e-01*G0_0_0 - 1.925880832130812e-01*G0_0_1 - 9.629404160654111e-02*G0_0_2 - 9.629404160654037e-02*G0_2_0 - 1.247386230025105e-01*G0_2_1;
    block[1163] = -4.354761027938038e-02*G0_0_0 - 1.428753056357179e-02*G0_0_1 - 5.838967970044115e-03*G0_0_2 - 5.838967970043949e-03*G0_2_0 - 2.544354757896218e-03*G0_2_1;
    block[1164] = 1.285225352065622e-01*G0_0_0 + 8.455086580086539e-02*G0_0_1 + 4.227543290043305e-02*G0_0_2 + 4.227543290043277e-02*G0_2_0 + 4.296045148909748e-02*G0_2_1;
    block[1165] = -6.132547365186217e-02*G0_0_0 - 4.253639236278164e-02*G0_0_1 - 2.126819618139077e-02*G0_0_2 - 2.126819618139051e-02*G0_2_0 - 1.187365553685056e-02*G0_2_1;
    block[1166] = -3.066273682593115e-02*G0_0_0 - 2.126819618139082e-02*G0_0_2 - 2.126819618139057e-02*G0_2_0 - 1.187365553685014e-02*G0_2_2;
    block[1167] = 6.426126760328126e-02*G0_0_0 + 4.227543290043283e-02*G0_0_2 + 4.227543290043274e-02*G0_2_0 + 4.296045148909753e-02*G0_2_2;
    block[1168] = -1.285225352065616e-01*G0_0_0 - 9.629404160654025e-02*G0_0_2 - 9.629404160654048e-02*G0_2_0 - 1.247386230025106e-01*G0_2_2;
    block[1169] = -9.133581182192164e-03*G0_0_0 - 5.838967970043993e-03*G0_0_2 - 5.838967970044271e-03*G0_2_0 - 2.544354757896166e-03*G0_2_2;
    block[1170] = 6.426126760328081e-02*G0_0_0 + 4.227543290043259e-02*G0_0_2 + 4.227543290043235e-02*G0_2_0 + 4.296045148909677e-02*G0_2_2;
    block[1171] = -3.066273682593099e-02*G0_0_0 - 2.126819618139042e-02*G0_0_2 - 2.126819618139041e-02*G0_2_0 - 1.187365553684978e-02*G0_2_2;
    block[1172] = -5.056089582999240e-02*G0_0_0 - 2.609594623482569e-03*G0_0_2 - 2.609594623483424e-03*G0_2_0;
    block[1173] = 9.622880174095380e-02*G0_0_0 - 3.522952741702712e-02*G0_0_2 - 3.522952741702716e-02*G0_2_0;
    block[1174] = -5.056089582999275e-02*G0_0_0 - 2.609594623483797e-03*G0_0_2 - 2.609594623483690e-03*G0_2_0;
    block[1175] = -1.565756774090097e-01*G0_0_0 - 2.609594623484183e-03*G0_0_2 - 2.609594623483483e-03*G0_2_0;
    block[1176] = -3.365072266981910e-03*G0_0_0 - 3.365072266981936e-03*G0_0_1 - 3.365072266981916e-03*G0_0_2 - 3.365072266981977e-03*G0_2_0 - 3.365072266981987e-03*G0_2_1 - 3.365072266981952e-03*G0_2_2;
    block[1177] = 2.146913496739873e-02*G0_0_0 - 3.365855145368996e-02*G0_2_0;
    block[1178] = 3.365072266981961e-03*G0_0_1 + 3.365072266982007e-03*G0_2_1;
    block[1179] = 2.326323127104360e-02*G0_0_2 - 1.555448875327341e-02*G0_2_2;
    block[1180] = -5.741760570319510e-02*G0_0_0 - 3.872638421249458e-02*G0_0_1 - 6.991103996312240e-02*G0_2_0 - 1.086374241756172e-01*G0_2_1;
    block[1181] = 5.062613569557914e-03*G0_0_0 + 4.801654107209376e-03*G0_0_1 + 4.801654107209464e-03*G0_2_0 + 9.603308214418632e-03*G0_2_1;
    block[1182] = -4.827750053442861e-04*G0_0_0 + 5.780252091016409e-03*G0_0_1 - 5.480148709313640e-04*G0_2_0 + 5.232237220085023e-03*G0_2_1;
    block[1183] = -2.289919282106815e-03*G0_0_0 - 8.879145706402768e-03*G0_0_1 - 2.289919282106618e-03*G0_2_0 - 1.116906498850945e-02*G0_2_1;
    block[1184] = 2.289919282106795e-03*G0_0_0 + 2.289919282106828e-03*G0_0_2 + 2.289919282106622e-03*G0_2_0 + 2.289919282106636e-03*G0_2_2;
    block[1185] = 1.787572317086225e-03*G0_0_0 + 1.787572317086194e-03*G0_0_2 + 1.787572317086239e-03*G0_2_0 + 1.787572317086256e-03*G0_2_2;
    block[1186] = 1.787572317086164e-03*G0_0_0 + 1.787572317086247e-03*G0_0_2 + 1.787572317086181e-03*G0_2_0 + 1.787572317086216e-03*G0_2_2;
    block[1187] = 2.289919282106883e-03*G0_0_0 + 2.289919282106880e-03*G0_0_2 + 2.289919282106731e-03*G0_2_0 + 2.289919282106782e-03*G0_2_2;
    block[1188] = 6.589226424295754e-03*G0_0_0 + 8.879145706402596e-03*G0_0_1 + 8.879145706402554e-03*G0_0_2 + 8.879145706402639e-03*G0_2_0 + 1.116906498850932e-02*G0_2_1 + 1.116906498850928e-02*G0_2_2;
    block[1189] = -6.263027096360289e-03*G0_0_0 - 5.780252091016118e-03*G0_0_1 - 5.780252091016114e-03*G0_0_2 - 5.780252091016010e-03*G0_2_0 - 5.232237220084665e-03*G0_2_1 - 5.232237220084659e-03*G0_2_2;
    block[1190] = 2.609594623481758e-04*G0_0_0 - 4.801654107209453e-03*G0_0_1 - 4.801654107209388e-03*G0_0_2 - 4.801654107209467e-03*G0_2_0 - 9.603308214418823e-03*G0_2_1 - 9.603308214418713e-03*G0_2_2;
    block[1191] = -1.869122149070045e-02*G0_0_0 + 3.872638421249467e-02*G0_0_1 + 3.872638421249459e-02*G0_0_2 + 3.872638421249480e-02*G0_2_0 + 1.086374241756172e-01*G0_2_1 + 1.086374241756171e-01*G0_2_2;
    block[1192] = 1.397437920875403e-02*G0_0_0 + 1.397437920875410e-02*G0_0_1 + 1.168445992664727e-02*G0_0_2 + 1.168445992664724e-02*G0_2_0 + 1.168445992664732e-02*G0_2_1 + 9.394540644540620e-03*G0_2_2;
    block[1193] = -2.630471380471323e-02*G0_0_0 - 2.630471380471324e-02*G0_0_1 - 1.315235690235675e-02*G0_0_2 - 1.315235690235636e-02*G0_2_0 - 1.315235690235638e-02*G0_2_1 + 6.523986558710983e-05*G0_2_2;
    block[1194] = -5.232237220084555e-03*G0_0_0 - 5.232237220084598e-03*G0_0_1 + 5.480148709314177e-04*G0_0_2 + 5.480148709313817e-04*G0_2_0 + 5.480148709313455e-04*G0_2_1 + 6.523986558688600e-05*G0_2_2;
    block[1195] = -7.889456945446463e-02*G0_0_0 - 7.889456945446467e-02*G0_0_1 - 1.897827689928359e-02*G0_0_2 - 1.897827689928351e-02*G0_2_0 - 1.897827689928352e-02*G0_2_1 + 9.394540644540804e-03*G0_2_2;
    block[1196] = -1.470637050064117e-01*G0_0_0 - 3.872638421249451e-02*G0_0_2 + 2.638300164341855e-02*G0_2_0 - 1.086374241756170e-01*G0_2_2;
    block[1197] = 3.042265412057053e-01*G0_0_0 + 7.813126302709535e-02*G0_0_2 + 7.813126302709535e-02*G0_2_0 + 2.810011490567018e-01*G0_2_2;
    block[1198] = -2.041877313144658e-01*G0_0_0 + 1.530527246673101e-02*G0_0_2 - 3.649518080941633e-02*G0_2_0 - 2.041877313144653e-01*G0_2_2;
    block[1199] = 7.889456945446471e-02*G0_0_0 - 2.463457324568420e-02*G0_0_2 + 1.897827689928358e-02*G0_2_0 + 1.007173044933452e-01*G0_2_2;
    block[1200] = -1.397437920875417e-02*G0_0_1 - 2.289919282106802e-03*G0_0_2 - 1.168445992664736e-02*G0_2_1 - 2.289919282106641e-03*G0_2_2;
    block[1201] = 2.630471380471380e-02*G0_0_1 + 1.315235690235671e-02*G0_0_2 + 1.315235690235679e-02*G0_2_1 + 1.321759676794356e-02*G0_2_2;
    block[1202] = 5.232237220084176e-03*G0_0_1 + 5.780252091016073e-03*G0_0_2 - 5.480148709316947e-04*G0_2_1 - 4.827750053442144e-04*G0_2_2;
    block[1203] = 7.889456945446469e-02*G0_0_1 + 5.991629255518091e-02*G0_0_2 + 1.897827689928355e-02*G0_2_1 + 2.837281754382412e-02*G0_2_2;
    block[1204] = 1.323064474106129e-01*G0_0_0 + 1.096029741863159e-02*G0_0_1 - 6.236931150125468e-02*G0_0_2 + 7.332960891988585e-02*G0_2_0 + 1.466592178397730e-01*G0_2_1 - 1.247386230025103e-01*G0_2_2;
    block[1205] = -1.669488160373561e-01*G0_0_0 + 1.677316944244012e-01*G0_0_1 + 8.386584721220060e-02*G0_0_2 - 6.165167297979417e-03*G0_2_0 + 7.770067991422099e-02*G0_2_1 + 1.824106641814961e-01*G0_2_2;
    block[1206] = 1.270872581636459e-01*G0_0_0 - 8.233271037090387e-02*G0_0_1 - 4.638554443241915e-02*G0_0_2 + 3.777388217492322e-02*G0_2_0 + 1.826716236438606e-03*G0_2_1 - 5.101757488910248e-02*G0_2_2;
    block[1207] = -4.364547007776139e-02*G0_0_0 - 8.083219346240160e-02*G0_0_1 - 6.491366625915142e-03*G0_0_2 - 3.389211017249195e-02*G0_2_0 - 1.082329370089784e-01*G0_2_1 - 3.522952741702959e-03*G0_2_2;
    block[1208] = 1.898480088584247e-02*G0_0_0 - 3.777388217492369e-02*G0_0_1 - 1.888694108746185e-02*G0_0_2 + 9.492400442920899e-03*G0_2_0 - 9.394540644541068e-03*G0_2_1 - 1.559232787531451e-02*G0_2_2;
    block[1209] = 1.487468935385578e-02*G0_0_0 + 4.031823693282019e-02*G0_0_1 + 1.239557446154845e-03*G0_0_2 + 1.493992921944289e-02*G0_2_0 + 5.401860870610844e-02*G0_2_1 + 1.174317580568127e-03*G0_2_2;
    block[1210] = -1.487468935385578e-02*G0_0_0 - 1.493992921944305e-02*G0_0_2 - 1.493992921944291e-02*G0_2_0 - 1.500516908502982e-02*G0_2_2;
    block[1211] = -1.898480088584240e-02*G0_0_0 - 9.492400442920964e-03*G0_0_2 - 9.492400442920915e-03*G0_2_0 - 6.523986558708624e-04*G0_2_2;
    block[1212] = -1.270872581636460e-01*G0_0_0 - 3.777388217492373e-02*G0_0_2 - 3.777388217492324e-02*G0_2_0 - 1.500516908503032e-02*G0_2_2;
    block[1213] = 4.501550725509171e-03*G0_0_0 + 1.924576034818996e-03*G0_0_2 + 1.924576034819215e-03*G0_2_0 - 6.523986558709767e-04*G0_2_2;
    block[1214] = -1.898480088584312e-02*G0_0_0 - 9.492400442921189e-03*G0_0_2 - 9.492400442921774e-03*G0_2_0 - 6.523986558708178e-04*G0_2_2;
    block[1215] = -1.487468935385563e-02*G0_0_0 - 1.493992921944312e-02*G0_0_2 - 1.493992921944304e-02*G0_2_0 - 1.500516908503007e-02*G0_2_2;
    block[1216] = 2.094199685345501e-01*G0_0_0 + 8.233271037090378e-02*G0_0_1 + 3.594716593848482e-02*G0_0_2 + 3.594716593848485e-02*G0_2_0 - 1.826716236438618e-03*G0_2_1 - 5.284429112554113e-02*G0_2_2;
    block[1217] = -3.346805104617571e-01*G0_0_0 - 1.677316944244013e-01*G0_0_1 - 8.386584721220033e-02*G0_0_2 - 8.386584721219999e-02*G0_2_0 - 7.770067991422110e-02*G0_2_1 + 1.047099842672756e-01*G0_2_2;
    block[1218] = 1.213461499919818e-01*G0_0_0 - 1.096029741863126e-02*G0_0_1 - 7.332960891988591e-02*G0_0_2 - 7.332960891988644e-02*G0_2_0 - 1.466592178397726e-01*G0_2_1 - 2.713978408422827e-01*G0_2_2;
    block[1219] = 5.675868306076525e-02*G0_0_0 + 3.777388217492283e-02*G0_0_1 + 1.888694108746192e-02*G0_0_2 + 1.888694108746113e-02*G0_2_0 + 9.394540644540246e-03*G0_2_1 - 6.197787230772854e-03*G0_2_2;
    block[1220] = 3.718672338463982e-02*G0_0_0 + 8.083219346240042e-02*G0_0_1 + 7.434082683648524e-02*G0_0_2 + 7.434082683648595e-02*G0_2_0 + 1.082329370089766e-01*G0_2_1 + 1.047099842672740e-01*G0_2_2;
    block[1221] = -2.544354757896406e-02*G0_0_0 - 4.031823693281941e-02*G0_0_1 - 3.907867948666502e-02*G0_0_2 - 3.907867948666533e-02*G0_2_0 - 5.401860870610779e-02*G0_2_1 - 5.284429112554035e-02*G0_2_2;
    block[1222] = -1.304797311741897e-03*G0_0_0 - 1.239557446154411e-03*G0_0_2 - 1.239557446154714e-03*G0_2_0 - 1.174317580567519e-03*G0_2_2;
    block[1223] = 8.807381854256858e-03*G0_0_0 + 6.491366625914696e-03*G0_0_2 + 6.491366625915223e-03*G0_2_0 + 3.522952741701913e-03*G0_2_2;
    block[1224] = 4.762510187857322e-02*G0_0_0 + 6.236931150125480e-02*G0_0_2 + 6.236931150125513e-02*G0_2_0 + 1.247386230025107e-01*G0_2_2;
    block[1225] = -1.565756774090081e-02*G0_0_0 - 1.308059305021069e-02*G0_0_2 - 1.308059305021083e-02*G0_2_0 - 1.050361835952068e-02*G0_2_2;
    block[1226] = 8.807381854256757e-03*G0_0_0 + 6.491366625915162e-03*G0_0_2 + 6.491366625915197e-03*G0_2_0 + 3.522952741703023e-03*G0_2_2;
    block[1227] = -1.304797311741925e-03*G0_0_0 - 1.239557446154844e-03*G0_0_2 - 1.239557446154865e-03*G0_2_0 - 1.174317580568090e-03*G0_2_2;
    block[1228] = 3.914391935225098e-02*G0_0_0 + 3.196753413767076e-02*G0_0_2 + 3.196753413767176e-02*G0_2_0 + 2.609594623483342e-02*G0_2_2;
    block[1229] = -1.565756774090082e-01*G0_0_0 - 9.035721383811549e-02*G0_0_2 - 9.035721383811464e-02*G0_2_0 - 1.859336169231985e-01*G0_2_2;
    block[1230] = 3.914391935225209e-02*G0_0_0 + 3.196753413767258e-02*G0_0_2 + 3.196753413767275e-02*G0_2_0 + 2.609594623483505e-02*G0_2_2;
    block[1231] = 1.859336169231995e-01*G0_0_0 + 1.565756774090278e-02*G0_0_2 + 1.565756774090123e-02*G0_2_0 + 2.609594623483667e-02*G0_2_2;
    block[1232] = -3.365072266982042e-03*G0_0_0 - 3.365072266982030e-03*G0_0_1 - 3.365072266982022e-03*G0_0_2 - 3.365072266981986e-03*G0_2_0 - 3.365072266981990e-03*G0_2_1 - 3.365072266981991e-03*G0_2_2;
    block[1233] = -1.555448875327339e-02*G0_0_0 + 2.326323127104350e-02*G0_2_0;
    block[1234] = 3.365072266981969e-03*G0_0_1 + 3.365072266981913e-03*G0_2_1;
    block[1235] = -3.365855145369011e-02*G0_0_2 + 2.146913496739877e-02*G0_2_2;
    block[1236] = 2.837281754382387e-02*G0_0_0 + 1.897827689928337e-02*G0_0_1 + 5.991629255518057e-02*G0_2_0 + 7.889456945446414e-02*G0_2_1;
    block[1237] = -4.827750053443594e-04*G0_0_0 - 5.480148709313512e-04*G0_0_1 + 5.780252091016177e-03*G0_2_0 + 5.232237220084993e-03*G0_2_1;
    block[1238] = 1.321759676794373e-02*G0_0_0 + 1.315235690235639e-02*G0_0_1 + 1.315235690235662e-02*G0_2_0 + 2.630471380471301e-02*G0_2_1;
    block[1239] = -2.289919282106650e-03*G0_0_0 - 1.168445992664707e-02*G0_0_1 - 2.289919282106767e-03*G0_2_0 - 1.397437920875382e-02*G0_2_1;
    block[1240] = 2.289919282106670e-03*G0_0_0 + 2.289919282106624e-03*G0_0_2 + 2.289919282106781e-03*G0_2_0 + 2.289919282106740e-03*G0_2_2;
    block[1241] = 1.787572317086215e-03*G0_0_0 + 1.787572317086225e-03*G0_0_2 + 1.787572317086206e-03*G0_2_0 + 1.787572317086175e-03*G0_2_2;
    block[1242] = 1.787572317086270e-03*G0_0_0 + 1.787572317086193e-03*G0_0_2 + 1.787572317086216e-03*G0_2_0 + 1.787572317086193e-03*G0_2_2;
    block[1243] = 2.289919282106606e-03*G0_0_0 + 2.289919282106579e-03*G0_0_2 + 2.289919282106697e-03*G0_2_0 + 2.289919282106625e-03*G0_2_2;
    block[1244] = 9.394540644540619e-03*G0_0_0 + 1.168445992664720e-02*G0_0_1 + 1.168445992664722e-02*G0_0_2 + 1.168445992664730e-02*G0_2_0 + 1.397437920875404e-02*G0_2_1 + 1.397437920875406e-02*G0_2_2;
    block[1245] = 6.523986558709711e-05*G0_0_0 - 1.315235690235657e-02*G0_0_1 - 1.315235690235662e-02*G0_0_2 - 1.315235690235672e-02*G0_2_0 - 2.630471380471328e-02*G0_2_1 - 2.630471380471331e-02*G0_2_2;
    block[1246] = 6.523986558718943e-05*G0_0_0 + 5.480148709314538e-04*G0_0_1 + 5.480148709313811e-04*G0_0_2 + 5.480148709314796e-04*G0_2_0 - 5.232237220084734e-03*G0_2_1 - 5.232237220084863e-03*G0_2_2;
    block[1247] = 9.394540644540499e-03*G0_0_0 - 1.897827689928354e-02*G0_0_1 - 1.897827689928341e-02*G0_0_2 - 1.897827689928357e-02*G0_2_0 - 7.889456945446430e-02*G0_2_1 - 7.889456945446417e-02*G0_2_2;
    block[1248] = 1.116906498850931e-02*G0_0_0 + 1.116906498850923e-02*G0_0_1 + 8.879145706402618e-03*G0_0_2 + 8.879145706402563e-03*G0_2_0 + 8.879145706402497e-03*G0_2_1 + 6.589226424295740e-03*G0_2_2;
    block[1249] = -5.232237220084580e-03*G0_0_0 - 5.232237220084529e-03*G0_0_1 - 5.780252091015846e-03*G0_0_2 - 5.780252091016212e-03*G0_2_0 - 5.780252091016171e-03*G0_2_1 - 6.263027096360262e-03*G0_2_2;
    block[1250] = -9.603308214419171e-03*G0_0_0 - 9.603308214419138e-03*G0_0_1 - 4.801654107209742e-03*G0_0_2 - 4.801654107209526e-03*G0_2_0 - 4.801654107209467e-03*G0_2_1 + 2.609594623483976e-04*G0_2_2;
    block[1251] = 1.086374241756178e-01*G0_0_0 + 1.086374241756179e-01*G0_0_1 + 3.872638421249498e-02*G0_0_2 + 3.872638421249495e-02*G0_2_0 + 3.872638421249494e-02*G0_2_1 - 1.869122149070077e-02*G0_2_2;
    block[1252] = 1.007173044933452e-01*G0_0_0 + 1.897827689928334e-02*G0_0_2 - 2.463457324568448e-02*G0_2_0 + 7.889456945446408e-02*G0_2_2;
    block[1253] = -2.041877313144658e-01*G0_0_0 - 3.649518080941634e-02*G0_0_2 + 1.530527246673100e-02*G0_2_0 - 2.041877313144653e-01*G0_2_2;
    block[1254] = 2.810011490567027e-01*G0_0_0 + 7.813126302709554e-02*G0_0_2 + 7.813126302709554e-02*G0_2_0 + 3.042265412057052e-01*G0_2_2;
    block[1255] = -1.086374241756179e-01*G0_0_0 + 2.638300164341806e-02*G0_0_2 - 3.872638421249497e-02*G0_2_0 - 1.470637050064123e-01*G0_2_2;
    block[1256] = -1.116906498850916e-02*G0_0_1 - 2.289919282106696e-03*G0_0_2 - 8.879145706402322e-03*G0_2_1 - 2.289919282106769e-03*G0_2_2;
    block[1257] = 5.232237220084202e-03*G0_0_1 - 5.480148709314000e-04*G0_0_2 + 5.780252091015801e-03*G0_2_1 - 4.827750053441658e-04*G0_2_2;
    block[1258] = 9.603308214419447e-03*G0_0_1 + 4.801654107209469e-03*G0_0_2 + 4.801654107209911e-03*G0_2_1 + 5.062613569557835e-03*G0_2_2;
    block[1259] = -1.086374241756179e-01*G0_0_1 - 6.991103996312285e-02*G0_0_2 - 3.872638421249502e-02*G0_2_1 - 5.741760570319557e-02*G0_2_2;
    block[1260] = -5.101757488910223e-02*G0_0_0 + 1.826716236437786e-03*G0_0_1 + 3.777388217492300e-02*G0_0_2 - 4.638554443241884e-02*G0_2_0 - 8.233271037090473e-02*G0_2_1 + 1.270872581636456e-01*G0_2_2;
    block[1261] = 1.824106641814963e-01*G0_0_0 + 7.770067991422126e-02*G0_0_1 - 6.165167297979810e-03*G0_0_2 + 8.386584721220079e-02*G0_2_0 + 1.677316944244018e-01*G0_2_1 - 1.669488160373567e-01*G0_2_2;
    block[1262] = -1.247386230025110e-01*G0_0_0 + 1.466592178397720e-01*G0_0_1 + 7.332960891988662e-02*G0_0_2 - 6.236931150125519e-02*G0_2_0 + 1.096029741863043e-02*G0_2_1 + 1.323064474106139e-01*G0_2_2;
    block[1263] = -1.559232787531435e-02*G0_0_0 - 9.394540644540586e-03*G0_0_1 + 9.492400442920950e-03*G0_0_2 - 1.888694108746219e-02*G0_2_0 - 3.777388217492351e-02*G0_2_1 + 1.898480088584243e-02*G0_2_2;
    block[1264] = -3.522952741702862e-03*G0_0_0 - 1.082329370089779e-01*G0_0_1 - 3.389211017249217e-02*G0_0_2 - 6.491366625914960e-03*G0_2_0 - 8.083219346240074e-02*G0_2_1 - 4.364547007776120e-02*G0_2_2;
    block[1265] = 1.174317580567987e-03*G0_0_0 + 5.401860870610829e-02*G0_0_1 + 1.493992921944316e-02*G0_0_2 + 1.239557446155202e-03*G0_2_0 + 4.031823693282006e-02*G0_2_1 + 1.487468935385590e-02*G0_2_2;
    block[1266] = -1.174317580567991e-03*G0_0_0 - 1.239557446154627e-03*G0_0_2 - 1.239557446155219e-03*G0_2_0 - 1.304797311741997e-03*G0_2_2;
    block[1267] = 3.522952741702807e-03*G0_0_0 + 6.491366625914899e-03*G0_0_2 + 6.491366625914990e-03*G0_2_0 + 8.807381854256722e-03*G0_2_2;
    block[1268] = 1.247386230025112e-01*G0_0_0 + 6.236931150125586e-02*G0_0_2 + 6.236931150125519e-02*G0_2_0 + 4.762510187857416e-02*G0_2_2;
    block[1269] = -1.050361835952097e-02*G0_0_0 - 1.308059305021102e-02*G0_0_2 - 1.308059305021092e-02*G0_2_0 - 1.565756774090096e-02*G0_2_2;
    block[1270] = 3.522952741703063e-03*G0_0_0 + 6.491366625914931e-03*G0_0_2 + 6.491366625915517e-03*G0_2_0 + 8.807381854256611e-03*G0_2_2;
    block[1271] = -1.174317580568047e-03*G0_0_0 - 1.239557446154418e-03*G0_0_2 - 1.239557446155057e-03*G0_2_0 - 1.304797311741656e-03*G0_2_2;
    block[1272] = -2.713978408422832e-01*G0_0_0 - 1.466592178397719e-01*G0_0_1 - 7.332960891988557e-02*G0_0_2 - 7.332960891988599e-02*G0_2_0 - 1.096029741863046e-02*G0_2_1 + 1.213461499919831e-01*G0_2_2;
    block[1273] = 1.047099842672747e-01*G0_0_0 - 7.770067991422111e-02*G0_0_1 - 8.386584721220090e-02*G0_0_2 - 8.386584721220103e-02*G0_2_0 - 1.677316944244015e-01*G0_2_1 - 3.346805104617584e-01*G0_2_2;
    block[1274] = -5.284429112554033e-02*G0_0_0 - 1.826716236437858e-03*G0_0_1 + 3.594716593848497e-02*G0_0_2 + 3.594716593848540e-02*G0_2_0 + 8.233271037090456e-02*G0_2_1 + 2.094199685345501e-01*G0_2_2;
    block[1275] = 1.047099842672754e-01*G0_0_0 + 1.082329370089780e-01*G0_0_1 + 7.434082683648557e-02*G0_0_2 + 7.434082683648623e-02*G0_2_0 + 8.083219346240099e-02*G0_2_1 + 3.718672338463912e-02*G0_2_2;
    block[1276] = -6.197787230773355e-03*G0_0_0 + 9.394540644540633e-03*G0_0_1 + 1.888694108746209e-02*G0_0_2 + 1.888694108746176e-02*G0_2_0 + 3.777388217492410e-02*G0_2_1 + 5.675868306076669e-02*G0_2_2;
    block[1277] = -5.284429112554074e-02*G0_0_0 - 5.401860870610886e-02*G0_0_1 - 3.907867948666531e-02*G0_0_2 - 3.907867948666519e-02*G0_2_0 - 4.031823693282054e-02*G0_2_1 - 2.544354757896427e-02*G0_2_2;
    block[1278] = -1.500516908503002e-02*G0_0_0 - 1.493992921944338e-02*G0_0_2 - 1.493992921944292e-02*G0_2_0 - 1.487468935385624e-02*G0_2_2;
    block[1279] = -6.523986558708484e-04*G0_0_0 - 9.492400442921047e-03*G0_0_2 - 9.492400442921285e-03*G0_2_0 - 1.898480088584203e-02*G0_2_2;
    block[1280] = -1.500516908502957e-02*G0_0_0 - 3.777388217492298e-02*G0_0_2 - 3.777388217492304e-02*G0_2_0 - 1.270872581636459e-01*G0_2_2;
    block[1281] = -6.523986558709296e-04*G0_0_0 + 1.924576034819173e-03*G0_0_2 + 1.924576034818979e-03*G0_2_0 + 4.501550725509050e-03*G0_2_2;
    block[1282] = -6.523986558710051e-04*G0_0_0 - 9.492400442920934e-03*G0_0_2 - 9.492400442921394e-03*G0_2_0 - 1.898480088584244e-02*G0_2_2;
    block[1283] = -1.500516908502995e-02*G0_0_0 - 1.493992921944309e-02*G0_0_2 - 1.493992921944283e-02*G0_2_0 - 1.487468935385587e-02*G0_2_2;
    block[1284] = 2.609594623483615e-02*G0_0_0 + 3.196753413767441e-02*G0_0_2 + 3.196753413767382e-02*G0_2_0 + 3.914391935225373e-02*G0_2_2;
    block[1285] = 2.609594623483403e-02*G0_0_0 + 1.565756774090086e-02*G0_0_2 + 1.565756774090008e-02*G0_2_0 + 1.859336169231989e-01*G0_2_2;
    block[1286] = 2.609594623483547e-02*G0_0_0 + 3.196753413767287e-02*G0_0_2 + 3.196753413767315e-02*G0_2_0 + 3.914391935225214e-02*G0_2_2;
    block[1287] = -1.859336169231994e-01*G0_0_0 - 9.035721383811735e-02*G0_0_2 - 9.035721383811632e-02*G0_2_0 - 1.565756774090112e-01*G0_2_2;
    block[1288] = -4.800349309897852e-03*G0_0_0 - 4.800349309897849e-03*G0_0_1 - 4.800349309897889e-03*G0_0_2 - 4.800349309897872e-03*G0_2_0 - 4.800349309897863e-03*G0_2_1 - 4.800349309897902e-03*G0_2_2;
    block[1289] = 4.800349309897884e-03*G0_0_0 - 1.053101910306762e-02*G0_2_0;
    block[1290] = 4.800349309897891e-03*G0_0_1 + 4.800349309897921e-03*G0_2_1;
    block[1291] = 3.725718243947379e-02*G0_0_2 - 1.787050398161506e-02*G0_2_2;
    block[1292] = -5.375764924375780e-03*G0_0_0 - 5.375764924375841e-03*G0_0_1 - 2.745945942560486e-02*G0_2_0 - 3.283522434998085e-02*G0_2_1;
    block[1293] = -2.289919282106782e-03*G0_0_0 - 2.289919282106754e-03*G0_0_1 - 8.879145706402636e-03*G0_2_0 - 1.116906498850950e-02*G0_2_1;
    block[1294] = -2.289919282106648e-03*G0_0_0 - 2.289919282106657e-03*G0_0_1 - 1.168445992664727e-02*G0_2_0 - 1.397437920875395e-02*G0_2_1;
    block[1295] = -5.375764924375994e-03*G0_0_0 - 5.375764924376070e-03*G0_0_1 - 5.375764924375952e-03*G0_2_0 - 1.075152984875209e-02*G0_2_1;
    block[1296] = 5.375764924375995e-03*G0_0_0 + 5.375764924376004e-03*G0_0_2 + 5.375764924375958e-03*G0_2_0 + 5.375764924375964e-03*G0_2_2;
    block[1297] = 2.289919282106800e-03*G0_0_0 + 2.289919282106790e-03*G0_0_2 + 2.289919282106794e-03*G0_2_0 + 2.289919282106803e-03*G0_2_2;
    block[1298] = 2.289919282106675e-03*G0_0_0 + 2.289919282106747e-03*G0_0_2 + 2.289919282106774e-03*G0_2_0 + 2.289919282106808e-03*G0_2_2;
    block[1299] = 5.375764924376147e-03*G0_0_0 + 5.375764924376119e-03*G0_0_2 + 5.375764924376109e-03*G0_2_0 + 5.375764924376115e-03*G0_2_2;
    block[1300] = 5.375764924376161e-03*G0_0_1 + 5.375764924376126e-03*G0_0_2 + 5.375764924376111e-03*G0_2_0 + 1.075152984875211e-02*G0_2_1 + 1.075152984875209e-02*G0_2_2;
    block[1301] = 2.289919282106579e-03*G0_0_1 + 2.289919282106643e-03*G0_0_2 + 2.289919282106677e-03*G0_2_0 + 1.397437920875392e-02*G0_2_1 + 1.397437920875395e-02*G0_2_2;
    block[1302] = 2.289919282106830e-03*G0_0_1 + 2.289919282106862e-03*G0_0_2 + 2.289919282106751e-03*G0_2_0 + 1.116906498850953e-02*G0_2_1 + 1.116906498850960e-02*G0_2_2;
    block[1303] = 5.375764924375915e-03*G0_0_1 + 5.375764924375899e-03*G0_0_2 + 5.375764924375980e-03*G0_2_0 + 3.283522434998089e-02*G0_2_1 + 3.283522434998087e-02*G0_2_2;
    block[1304] = 3.283522434998104e-02*G0_0_0 + 3.283522434998103e-02*G0_0_1 + 2.745945942560509e-02*G0_0_2 + 2.745945942560505e-02*G0_2_0 + 2.745945942560503e-02*G0_2_1 + 2.208369450122912e-02*G0_2_2;
    block[1305] = -7.889456945446469e-02*G0_0_0 - 7.889456945446460e-02*G0_0_1 - 5.991629255518112e-02*G0_0_2 - 5.991629255518094e-02*G0_2_0 - 5.991629255518084e-02*G0_2_1 - 3.154347501135678e-02*G0_2_2;
    block[1306] = 1.086374241756178e-01*G0_0_0 + 1.086374241756177e-01*G0_0_1 + 6.991103996312278e-02*G0_0_2 + 6.991103996312273e-02*G0_2_0 + 6.991103996312266e-02*G0_2_1 + 1.249343425992703e-02*G0_2_2;
    block[1307] = -1.398220799262456e-01*G0_0_0 - 1.398220799262457e-01*G0_0_1 - 6.991103996312260e-02*G0_0_2 - 6.991103996312291e-02*G0_2_0 - 6.991103996312290e-02*G0_2_1 + 1.963719954171360e-02*G0_2_2;
    block[1308] = -3.283522434998089e-02*G0_0_0 - 5.375764924375780e-03*G0_0_2 + 2.091590090722034e-02*G0_2_0 - 3.283522434998079e-02*G0_2_2;
    block[1309] = 7.889456945446471e-02*G0_0_0 + 1.897827689928358e-02*G0_0_2 - 2.463457324568420e-02*G0_2_0 + 1.007173044933452e-01*G0_2_2;
    block[1310] = -1.086374241756179e-01*G0_0_0 - 3.872638421249497e-02*G0_0_2 + 2.638300164341806e-02*G0_2_0 - 1.470637050064123e-01*G0_2_2;
    block[1311] = 1.398220799262457e-01*G0_0_0 + 6.991103996312291e-02*G0_0_2 + 6.991103996312291e-02*G0_2_0 + 1.790964790096723e-01*G0_2_2;
    block[1312] = -3.283522434998111e-02*G0_0_1 - 5.375764924375905e-03*G0_0_2 - 2.745945942560519e-02*G0_2_1 - 5.375764924375910e-03*G0_2_2;
    block[1313] = 7.889456945446484e-02*G0_0_1 + 1.897827689928343e-02*G0_0_2 + 5.991629255518122e-02*G0_2_1 + 2.837281754382405e-02*G0_2_2;
    block[1314] = -1.086374241756178e-01*G0_0_1 - 3.872638421249466e-02*G0_0_2 - 6.991103996312298e-02*G0_2_1 - 5.741760570319535e-02*G0_2_2;
    block[1315] = 1.398220799262457e-01*G0_0_1 + 6.991103996312290e-02*G0_0_2 + 6.991103996312291e-02*G0_2_1 + 8.954823950483626e-02*G0_2_2;
    block[1316] = 1.187365553685033e-02*G0_0_0 + 1.187365553685061e-02*G0_0_1 - 9.394540644540162e-03*G0_0_2 + 2.648738542835770e-02*G0_2_0 + 4.775558160974844e-02*G0_2_1 - 6.413078787210662e-02*G0_2_2;
    block[1317] = -4.296045148909739e-02*G0_0_0 - 4.296045148909738e-02*G0_0_1 - 6.850185886640111e-04*G0_0_2 - 7.045905483405813e-03*G0_2_0 - 4.932133838383845e-02*G0_2_1 + 1.273155976932014e-01*G0_2_2;
    block[1318] = 1.247386230025112e-01*G0_0_0 + 1.247386230025111e-01*G0_0_1 + 2.844458139596931e-02*G0_0_2 + 9.629404160654095e-02*G0_2_0 + 1.925880832130819e-01*G0_2_1 - 6.445698720004317e-02*G0_2_2;
    block[1319] = 2.544354757896457e-03*G0_0_0 + 2.544354757896429e-03*G0_0_1 - 3.294613212147892e-03*G0_0_2 + 8.448562593527737e-03*G0_2_0 + 1.428753056357206e-02*G0_2_1 - 2.926007971580879e-02*G0_2_2;
    block[1320] = -4.296045148909671e-02*G0_0_0 - 4.296045148909670e-02*G0_0_1 - 6.850185886639887e-04*G0_0_2 - 4.227543290043251e-02*G0_2_0 - 8.455086580086515e-02*G0_2_1 + 4.397166940569698e-02*G0_2_2;
    block[1321] = 1.187365553684977e-02*G0_0_0 + 1.187365553684988e-02*G0_0_1 - 9.394540644540608e-03*G0_0_2 + 2.126819618139028e-02*G0_2_0 + 4.253639236278085e-02*G0_2_1 - 1.878908128908119e-02*G0_2_2;
    block[1322] = -1.187365553684974e-02*G0_0_0 - 2.126819618139050e-02*G0_0_2 - 2.126819618139026e-02*G0_2_0 - 3.066273682593097e-02*G0_2_2;
    block[1323] = 4.296045148909674e-02*G0_0_0 + 4.227543290043277e-02*G0_0_2 + 4.227543290043251e-02*G0_2_0 + 6.426126760328116e-02*G0_2_2;
    block[1324] = -1.247386230025112e-01*G0_0_0 - 9.629404160654148e-02*G0_0_2 - 9.629404160654088e-02*G0_2_0 - 1.285225352065629e-01*G0_2_2;
    block[1325] = -2.544354757896301e-03*G0_0_0 - 5.838967970044357e-03*G0_0_2 - 5.838967970044230e-03*G0_2_0 - 9.133581182192351e-03*G0_2_2;
    block[1326] = 4.296045148909688e-02*G0_0_0 + 4.227543290043305e-02*G0_0_2 + 4.227543290043244e-02*G0_2_0 + 6.426126760328157e-02*G0_2_2;
    block[1327] = -1.187365553684985e-02*G0_0_0 - 2.126819618139076e-02*G0_0_2 - 2.126819618139047e-02*G0_2_0 - 3.066273682593136e-02*G0_2_2;
    block[1328] = -1.247386230025110e-01*G0_0_1 - 9.629404160654162e-02*G0_0_2 - 9.629404160654072e-02*G0_2_0 - 1.925880832130817e-01*G0_2_1 - 2.570450704131250e-01*G0_2_2;
    block[1329] = 4.296045148909725e-02*G0_0_1 + 4.227543290043305e-02*G0_0_2 + 4.227543290043270e-02*G0_2_0 + 4.932133838383827e-02*G0_2_1 + 1.766369360770396e-01*G0_2_2;
    block[1330] = -1.187365553685058e-02*G0_0_1 - 2.126819618139072e-02*G0_0_2 - 2.126819618139077e-02*G0_2_0 - 4.775558160974833e-02*G0_2_1 - 1.118863694818550e-01*G0_2_2;
    block[1331] = 4.296045148909688e-02*G0_0_1 + 4.227543290043324e-02*G0_0_2 + 4.227543290043240e-02*G0_2_0 + 8.455086580086521e-02*G0_2_1 + 1.285225352065629e-01*G0_2_2;
    block[1332] = -2.544354757896167e-03*G0_0_1 - 5.838967970044417e-03*G0_0_2 - 5.838967970043946e-03*G0_2_0 - 1.428753056357219e-02*G0_2_1 - 4.354761027938113e-02*G0_2_2;
    block[1333] = -1.187365553684981e-02*G0_0_1 - 2.126819618139077e-02*G0_0_2 - 2.126819618139073e-02*G0_2_0 - 4.253639236278092e-02*G0_2_1 - 6.132547365186234e-02*G0_2_2;
    block[1334] = 9.394540644540674e-03*G0_0_2 + 9.394540644540473e-03*G0_2_0 + 1.878908128908129e-02*G0_2_2;
    block[1335] = 3.294613212148026e-03*G0_0_2 + 3.294613212148108e-03*G0_2_0 + 2.926007971580867e-02*G0_2_2;
    block[1336] = 9.394540644540081e-03*G0_0_2 + 9.394540644540197e-03*G0_2_0 + 6.413078787210663e-02*G0_2_2;
    block[1337] = 3.294613212147945e-03*G0_0_2 + 3.294613212147888e-03*G0_2_0 + 6.589226424295985e-03*G0_2_2;
    block[1338] = 3.294613212147849e-03*G0_0_2 + 3.294613212147984e-03*G0_2_0 + 2.926007971580875e-02*G0_2_2;
    block[1339] = 9.394540644540495e-03*G0_0_2 + 9.394540644540473e-03*G0_2_0 + 1.878908128908111e-02*G0_2_2;
    block[1340] = -2.609594623484477e-03*G0_0_2 - 2.609594623483891e-03*G0_2_0 - 5.056089582999368e-02*G0_2_2;
    block[1341] = -2.609594623483839e-03*G0_0_2 - 2.609594623483307e-03*G0_2_0 - 1.565756774090100e-01*G0_2_2;
    block[1342] = -2.609594623483617e-03*G0_0_2 - 2.609594623483486e-03*G0_2_0 - 5.056089582999276e-02*G0_2_2;
    block[1343] = -3.522952741702575e-02*G0_0_2 - 3.522952741702673e-02*G0_2_0 + 9.622880174095530e-02*G0_2_2;
    block[1344] = -4.800349309897835e-03*G0_1_0 - 4.800349309897845e-03*G0_1_1 - 4.800349309897835e-03*G0_1_2 - 4.800349309897816e-03*G0_2_0 - 4.800349309897836e-03*G0_2_1 - 4.800349309897829e-03*G0_2_2;
    block[1345] = 4.800349309897874e-03*G0_1_0 + 4.800349309897844e-03*G0_2_0;
    block[1346] = -1.787050398161498e-02*G0_1_1 + 3.725718243947373e-02*G0_2_1;
    block[1347] = -1.053101910306761e-02*G0_1_2 + 4.800349309897930e-03*G0_2_2;
    block[1348] = -2.745945942560474e-02*G0_1_0 - 5.375764924375846e-03*G0_1_1 - 3.283522434998069e-02*G0_2_0 - 5.375764924375910e-03*G0_2_1;
    block[1349] = 5.991629255518053e-02*G0_1_0 + 2.837281754382399e-02*G0_1_1 + 7.889456945446423e-02*G0_2_0 + 1.897827689928362e-02*G0_2_1;
    block[1350] = -6.991103996312241e-02*G0_1_0 - 5.741760570319514e-02*G0_1_1 - 1.086374241756173e-01*G0_2_0 - 3.872638421249486e-02*G0_2_1;
    block[1351] = 6.991103996312233e-02*G0_1_0 + 8.954823950483548e-02*G0_1_1 + 1.398220799262452e-01*G0_2_0 + 6.991103996312240e-02*G0_2_1;
    block[1352] = -6.991103996312230e-02*G0_1_0 + 1.963719954171307e-02*G0_1_1 - 6.991103996312230e-02*G0_1_2 - 1.398220799262451e-01*G0_2_0 - 6.991103996312278e-02*G0_2_1 - 1.398220799262451e-01*G0_2_2;
    block[1353] = 6.991103996312251e-02*G0_1_0 + 1.249343425992737e-02*G0_1_1 + 6.991103996312255e-02*G0_1_2 + 1.086374241756175e-01*G0_2_0 + 6.991103996312273e-02*G0_2_1 + 1.086374241756175e-01*G0_2_2;
    block[1354] = -5.991629255518061e-02*G0_1_0 - 3.154347501135658e-02*G0_1_1 - 5.991629255518066e-02*G0_1_2 - 7.889456945446444e-02*G0_2_0 - 5.991629255518081e-02*G0_2_1 - 7.889456945446455e-02*G0_2_2;
    block[1355] = 2.745945942560475e-02*G0_1_0 + 2.208369450122890e-02*G0_1_1 + 2.745945942560477e-02*G0_1_2 + 3.283522434998094e-02*G0_2_0 + 2.745945942560489e-02*G0_2_1 + 3.283522434998097e-02*G0_2_2;
    block[1356] = 5.375764924375919e-03*G0_1_1 + 5.375764924375883e-03*G0_1_2 + 5.375764924376171e-03*G0_2_1 + 5.375764924376138e-03*G0_2_2;
    block[1357] = 2.289919282106633e-03*G0_1_1 + 2.289919282106633e-03*G0_1_2 + 2.289919282106612e-03*G0_2_1 + 2.289919282106648e-03*G0_2_2;
    block[1358] = 2.289919282106669e-03*G0_1_1 + 2.289919282106673e-03*G0_1_2 + 2.289919282106956e-03*G0_2_1 + 2.289919282106968e-03*G0_2_2;
    block[1359] = 5.375764924375962e-03*G0_1_1 + 5.375764924375898e-03*G0_1_2 + 5.375764924376009e-03*G0_2_1 + 5.375764924375953e-03*G0_2_2;
    block[1360] = 1.075152984875193e-02*G0_1_0 + 1.075152984875196e-02*G0_1_1 + 5.375764924376010e-03*G0_1_2 + 5.375764924376128e-03*G0_2_0 + 5.375764924376182e-03*G0_2_1;
    block[1361] = 1.397437920875429e-02*G0_1_0 + 1.397437920875423e-02*G0_1_1 + 2.289919282106674e-03*G0_1_2 + 2.289919282106720e-03*G0_2_0 + 2.289919282106646e-03*G0_2_1;
    block[1362] = 1.116906498850904e-02*G0_1_0 + 1.116906498850906e-02*G0_1_1 + 2.289919282106867e-03*G0_1_2 + 2.289919282106867e-03*G0_2_0 + 2.289919282106889e-03*G0_2_1;
    block[1363] = 3.283522434998110e-02*G0_1_0 + 3.283522434998112e-02*G0_1_1 + 5.375764924375913e-03*G0_1_2 + 5.375764924375903e-03*G0_2_0 + 5.375764924375906e-03*G0_2_1;
    block[1364] = -1.075152984875188e-02*G0_1_0 - 5.375764924375887e-03*G0_1_2 - 5.375764924375908e-03*G0_2_0 - 5.375764924375919e-03*G0_2_2;
    block[1365] = -1.397437920875417e-02*G0_1_0 - 1.168445992664736e-02*G0_1_2 - 2.289919282106802e-03*G0_2_0 - 2.289919282106641e-03*G0_2_2;
    block[1366] = -1.116906498850916e-02*G0_1_0 - 8.879145706402322e-03*G0_1_2 - 2.289919282106697e-03*G0_2_0 - 2.289919282106769e-03*G0_2_2;
    block[1367] = -3.283522434998111e-02*G0_1_0 - 2.745945942560519e-02*G0_1_2 - 5.375764924375905e-03*G0_2_0 - 5.375764924375910e-03*G0_2_2;
    block[1368] = 1.790964790096713e-01*G0_1_1 + 6.991103996312223e-02*G0_1_2 + 6.991103996312222e-02*G0_2_1 + 1.398220799262450e-01*G0_2_2;
    block[1369] = -1.470637050064119e-01*G0_1_1 + 2.638300164341837e-02*G0_1_2 - 3.872638421249470e-02*G0_2_1 - 1.086374241756175e-01*G0_2_2;
    block[1370] = 1.007173044933451e-01*G0_1_1 - 2.463457324568460e-02*G0_1_2 + 1.897827689928354e-02*G0_2_1 + 7.889456945446455e-02*G0_2_2;
    block[1371] = -3.283522434998108e-02*G0_1_1 + 2.091590090722009e-02*G0_1_2 - 5.375764924375893e-03*G0_2_1 - 3.283522434998105e-02*G0_2_2;
    block[1372] = 4.253639236278055e-02*G0_1_0 - 1.878908128908112e-02*G0_1_1 + 2.126819618139051e-02*G0_1_2 + 1.187365553684983e-02*G0_2_0 - 9.394540644540534e-03*G0_2_1 + 1.187365553684999e-02*G0_2_2;
    block[1373] = 1.428753056357223e-02*G0_1_0 - 2.926007971580855e-02*G0_1_1 + 8.448562593527451e-03*G0_1_2 + 2.544354757896454e-03*G0_2_0 - 3.294613212147823e-03*G0_2_1 + 2.544354757896231e-03*G0_2_2;
    block[1374] = 4.775558160974749e-02*G0_1_0 - 6.413078787210671e-02*G0_1_1 + 2.648738542835742e-02*G0_1_2 + 1.187365553684983e-02*G0_2_0 - 9.394540644540398e-03*G0_2_1 + 1.187365553685000e-02*G0_2_2;
    block[1375] = -8.455086580086452e-02*G0_1_0 + 4.397166940569693e-02*G0_1_1 - 4.227543290043229e-02*G0_1_2 - 4.296045148909654e-02*G0_2_0 - 6.850185886640981e-04*G0_2_1 - 4.296045148909659e-02*G0_2_2;
    block[1376] = -4.932133838383838e-02*G0_1_0 + 1.273155976932002e-01*G0_1_1 - 7.045905483405553e-03*G0_1_2 - 4.296045148909689e-02*G0_2_0 - 6.850185886647539e-04*G0_2_1 - 4.296045148909706e-02*G0_2_2;
    block[1377] = 1.925880832130806e-01*G0_1_0 - 6.445698720004248e-02*G0_1_1 + 9.629404160654004e-02*G0_1_2 + 1.247386230025100e-01*G0_2_0 + 2.844458139596965e-02*G0_2_1 + 1.247386230025101e-01*G0_2_2;
    block[1378] = -1.925880832130808e-01*G0_1_0 - 2.570450704131232e-01*G0_1_1 - 9.629404160654070e-02*G0_1_2 - 1.247386230025100e-01*G0_2_0 - 9.629404160654033e-02*G0_2_1;
    block[1379] = 4.932133838383838e-02*G0_1_0 + 1.766369360770386e-01*G0_1_1 + 4.227543290043298e-02*G0_1_2 + 4.296045148909691e-02*G0_2_0 + 4.227543290043236e-02*G0_2_1;
    block[1380] = -4.775558160974742e-02*G0_1_0 - 1.118863694818541e-01*G0_1_1 - 2.126819618138997e-02*G0_1_2 - 1.187365553684978e-02*G0_2_0 - 2.126819618139044e-02*G0_2_1;
    block[1381] = 8.455086580086432e-02*G0_1_0 + 1.285225352065615e-01*G0_1_1 + 4.227543290043237e-02*G0_1_2 + 4.296045148909629e-02*G0_2_0 + 4.227543290043244e-02*G0_2_1;
    block[1382] = -1.428753056357248e-02*G0_1_0 - 4.354761027938097e-02*G0_1_1 - 5.838967970045102e-03*G0_1_2 - 2.544354757896353e-03*G0_2_0 - 5.838967970044233e-03*G0_2_1;
    block[1383] = -4.253639236278015e-02*G0_1_0 - 6.132547365186182e-02*G0_1_1 - 2.126819618138990e-02*G0_1_2 - 1.187365553684934e-02*G0_2_0 - 2.126819618139060e-02*G0_2_1;
    block[1384] = 6.413078787210676e-02*G0_1_1 + 9.394540644541170e-03*G0_1_2 + 9.394540644540386e-03*G0_2_1;
    block[1385] = 2.926007971580864e-02*G0_1_1 + 3.294613212147266e-03*G0_1_2 + 3.294613212147895e-03*G0_2_1;
    block[1386] = 1.878908128908108e-02*G0_1_1 + 9.394540644540790e-03*G0_1_2 + 9.394540644540416e-03*G0_2_1;
    block[1387] = 2.926007971580886e-02*G0_1_1 + 3.294613212147166e-03*G0_1_2 + 3.294613212148322e-03*G0_2_1;
    block[1388] = 6.589226424295892e-03*G0_1_1 + 3.294613212148318e-03*G0_1_2 + 3.294613212148013e-03*G0_2_1;
    block[1389] = 1.878908128908149e-02*G0_1_1 + 9.394540644540974e-03*G0_1_2 + 9.394540644540948e-03*G0_2_1;
    block[1390] = -3.066273682593070e-02*G0_1_1 - 2.126819618139011e-02*G0_1_2 - 2.126819618139042e-02*G0_2_1 - 1.187365553684937e-02*G0_2_2;
    block[1391] = -9.133581182192074e-03*G0_1_1 - 5.838967970044691e-03*G0_1_2 - 5.838967970044262e-03*G0_2_1 - 2.544354757896584e-03*G0_2_2;
    block[1392] = -3.066273682593084e-02*G0_1_1 - 2.126819618139054e-02*G0_1_2 - 2.126819618139072e-02*G0_2_1 - 1.187365553685002e-02*G0_2_2;
    block[1393] = 6.426126760328028e-02*G0_1_1 + 4.227543290043191e-02*G0_1_2 + 4.227543290043197e-02*G0_2_1 + 4.296045148909616e-02*G0_2_2;
    block[1394] = 6.426126760328070e-02*G0_1_1 + 4.227543290043238e-02*G0_1_2 + 4.227543290043249e-02*G0_2_1 + 4.296045148909674e-02*G0_2_2;
    block[1395] = -1.285225352065609e-01*G0_1_1 - 9.629404160654007e-02*G0_1_2 - 9.629404160653998e-02*G0_2_1 - 1.247386230025102e-01*G0_2_2;
    block[1396] = -5.056089582999341e-02*G0_1_1 - 2.609594623483202e-03*G0_1_2 - 2.609594623484575e-03*G0_2_1;
    block[1397] = -5.056089582999285e-02*G0_1_1 - 2.609594623482874e-03*G0_1_2 - 2.609594623483914e-03*G0_2_1;
    block[1398] = 9.622880174095427e-02*G0_1_1 - 3.522952741702645e-02*G0_1_2 - 3.522952741702594e-02*G0_2_1;
    block[1399] = -1.565756774090089e-01*G0_1_1 - 2.609594623484000e-03*G0_1_2 - 2.609594623483637e-03*G0_2_1;
    block[1400] = -3.365072266982004e-03*G0_1_0 - 3.365072266981983e-03*G0_1_1 - 3.365072266982007e-03*G0_1_2 - 3.365072266982004e-03*G0_2_0 - 3.365072266981981e-03*G0_2_1 - 3.365072266982001e-03*G0_2_2;
    block[1401] = 3.365072266981973e-03*G0_1_0 + 3.365072266981994e-03*G0_2_0;
    block[1402] = 2.146913496739871e-02*G0_1_1 - 3.365855145369002e-02*G0_2_1;
    block[1403] = 2.326323127104355e-02*G0_1_2 - 1.555448875327351e-02*G0_2_2;
    block[1404] = -8.879145706402740e-03*G0_1_0 - 2.289919282106838e-03*G0_1_1 - 1.116906498850944e-02*G0_2_0 - 2.289919282106737e-03*G0_2_1;
    block[1405] = 5.780252091016123e-03*G0_1_0 - 4.827750053443324e-04*G0_1_1 + 5.232237220084515e-03*G0_2_0 - 5.480148709315719e-04*G0_2_1;
    block[1406] = 4.801654107209543e-03*G0_1_0 + 5.062613569557810e-03*G0_1_1 + 9.603308214419045e-03*G0_2_0 + 4.801654107209577e-03*G0_2_1;
    block[1407] = -3.872638421249473e-02*G0_1_0 - 5.741760570319524e-02*G0_1_1 - 1.086374241756175e-01*G0_2_0 - 6.991103996312266e-02*G0_2_1;
    block[1408] = 3.872638421249473e-02*G0_1_0 - 1.869122149070043e-02*G0_1_1 + 3.872638421249466e-02*G0_1_2 + 1.086374241756175e-01*G0_2_0 + 3.872638421249495e-02*G0_2_1 + 1.086374241756174e-01*G0_2_2;
    block[1409] = -4.801654107209455e-03*G0_1_0 + 2.609594623482762e-04*G0_1_1 - 4.801654107209419e-03*G0_1_2 - 9.603308214418968e-03*G0_2_0 - 4.801654107209560e-03*G0_2_1 - 9.603308214418920e-03*G0_2_2;
    block[1410] = -5.780252091016174e-03*G0_1_0 - 6.263027096360506e-03*G0_1_1 - 5.780252091016103e-03*G0_1_2 - 5.232237220084567e-03*G0_2_0 - 5.780252091016035e-03*G0_2_1 - 5.232237220084448e-03*G0_2_2;
    block[1411] = 8.879145706402906e-03*G0_1_0 + 6.589226424295979e-03*G0_1_1 + 8.879145706402844e-03*G0_1_2 + 1.116906498850940e-02*G0_2_0 + 8.879145706402716e-03*G0_2_1 + 1.116906498850934e-02*G0_2_2;
    block[1412] = 2.289919282106859e-03*G0_1_1 + 2.289919282106886e-03*G0_1_2 + 2.289919282106566e-03*G0_2_1 + 2.289919282106603e-03*G0_2_2;
    block[1413] = 1.787572317086213e-03*G0_1_1 + 1.787572317086241e-03*G0_1_2 + 1.787572317086222e-03*G0_2_1 + 1.787572317086206e-03*G0_2_2;
    block[1414] = 1.787572317086225e-03*G0_1_1 + 1.787572317086238e-03*G0_1_2 + 1.787572317085929e-03*G0_2_1 + 1.787572317085921e-03*G0_2_2;
    block[1415] = 2.289919282106786e-03*G0_1_1 + 2.289919282106828e-03*G0_1_2 + 2.289919282106699e-03*G0_2_1 + 2.289919282106736e-03*G0_2_2;
    block[1416] = 1.397437920875440e-02*G0_1_0 + 1.397437920875431e-02*G0_1_1 + 1.168445992664750e-02*G0_1_2 + 1.168445992664733e-02*G0_2_0 + 1.168445992664721e-02*G0_2_1 + 9.394540644540697e-03*G0_2_2;
    block[1417] = -2.630471380471396e-02*G0_1_0 - 2.630471380471387e-02*G0_1_1 - 1.315235690235706e-02*G0_1_2 - 1.315235690235673e-02*G0_2_0 - 1.315235690235659e-02*G0_2_1 + 6.523986558682299e-05*G0_2_2;
    block[1418] = -5.232237220084057e-03*G0_1_0 - 5.232237220084081e-03*G0_1_1 + 5.480148709316094e-04*G0_1_2 + 5.480148709311925e-04*G0_2_0 + 5.480148709311783e-04*G0_2_1 + 6.523986558719543e-05*G0_2_2;
    block[1419] = -7.889456945446480e-02*G0_1_0 - 7.889456945446488e-02*G0_1_1 - 1.897827689928361e-02*G0_1_2 - 1.897827689928341e-02*G0_2_0 - 1.897827689928343e-02*G0_2_1 + 9.394540644540702e-03*G0_2_2;
    block[1420] = -1.397437920875412e-02*G0_1_0 - 2.289919282106766e-03*G0_1_2 - 1.168445992664727e-02*G0_2_0 - 2.289919282106691e-03*G0_2_2;
    block[1421] = 2.630471380471381e-02*G0_1_0 + 1.315235690235679e-02*G0_1_2 + 1.315235690235671e-02*G0_2_0 + 1.321759676794356e-02*G0_2_2;
    block[1422] = 5.232237220084208e-03*G0_1_0 + 5.780252091015799e-03*G0_1_2 - 5.480148709314023e-04*G0_2_0 - 4.827750053441651e-04*G0_2_2;
    block[1423] = 7.889456945446484e-02*G0_1_0 + 5.991629255518122e-02*G0_1_2 + 1.897827689928343e-02*G0_2_0 + 2.837281754382405e-02*G0_2_2;
    block[1424] = -1.470637050064119e-01*G0_1_1 - 3.872638421249470e-02*G0_1_2 + 2.638300164341837e-02*G0_2_1 - 1.086374241756175e-01*G0_2_2;
    block[1425] = 3.042265412057053e-01*G0_1_1 + 7.813126302709550e-02*G0_1_2 + 7.813126302709550e-02*G0_2_1 + 2.810011490567023e-01*G0_2_2;
    block[1426] = -2.041877313144657e-01*G0_1_1 + 1.530527246673103e-02*G0_1_2 - 3.649518080941652e-02*G0_2_1 - 2.041877313144660e-01*G0_2_2;
    block[1427] = 7.889456945446480e-02*G0_1_1 - 2.463457324568388e-02*G0_1_2 + 1.897827689928343e-02*G0_2_1 + 1.007173044933455e-01*G0_2_2;
    block[1428] = 4.031823693282035e-02*G0_1_0 + 1.487468935385621e-02*G0_1_1 + 1.239557446154626e-03*G0_1_2 + 5.401860870610804e-02*G0_2_0 + 1.493992921944308e-02*G0_2_1 + 1.174317580567519e-03*G0_2_2;
    block[1429] = -3.777388217492385e-02*G0_1_0 + 1.898480088584237e-02*G0_1_1 - 1.888694108746115e-02*G0_1_2 - 9.394540644540620e-03*G0_2_0 + 9.492400442921137e-03*G0_2_1 - 1.559232787531373e-02*G0_2_2;
    block[1430] = -8.233271037090366e-02*G0_1_0 + 1.270872581636462e-01*G0_1_1 - 4.638554443241950e-02*G0_1_2 + 1.826716236438322e-03*G0_2_0 + 3.777388217492339e-02*G0_2_1 - 5.101757488910274e-02*G0_2_2;
    block[1431] = -8.083219346240153e-02*G0_1_0 - 4.364547007776164e-02*G0_1_1 - 6.491366625915432e-03*G0_1_2 - 1.082329370089782e-01*G0_2_0 - 3.389211017249247e-02*G0_2_1 - 3.522952741703271e-03*G0_2_2;
    block[1432] = 1.677316944244018e-01*G0_1_0 - 1.669488160373561e-01*G0_1_1 + 8.386584721220085e-02*G0_1_2 + 7.770067991422065e-02*G0_2_0 - 6.165167297979862e-03*G0_2_1 + 1.824106641814962e-01*G0_2_2;
    block[1433] = 1.096029741863132e-02*G0_1_0 + 1.323064474106135e-01*G0_1_1 - 6.236931150125479e-02*G0_1_2 + 1.466592178397731e-01*G0_2_0 + 7.332960891988680e-02*G0_2_1 - 1.247386230025102e-01*G0_2_2;
    block[1434] = -1.096029741863139e-02*G0_1_0 + 1.213461499919820e-01*G0_1_1 - 7.332960891988616e-02*G0_1_2 - 1.466592178397731e-01*G0_2_0 - 7.332960891988630e-02*G0_2_1 - 2.713978408422835e-01*G0_2_2;
    block[1435] = -1.677316944244018e-01*G0_1_0 - 3.346805104617580e-01*G0_1_1 - 8.386584721220072e-02*G0_1_2 - 7.770067991422069e-02*G0_2_0 - 8.386584721220074e-02*G0_2_1 + 1.047099842672757e-01*G0_2_2;
    block[1436] = 8.233271037090364e-02*G0_1_0 + 2.094199685345497e-01*G0_1_1 + 3.594716593848399e-02*G0_1_2 - 1.826716236438262e-03*G0_2_0 + 3.594716593848534e-02*G0_2_1 - 5.284429112554127e-02*G0_2_2;
    block[1437] = 8.083219346240166e-02*G0_1_0 + 3.718672338464019e-02*G0_1_1 + 7.434082683648588e-02*G0_1_2 + 1.082329370089783e-01*G0_2_0 + 7.434082683648606e-02*G0_2_1 + 1.047099842672746e-01*G0_2_2;
    block[1438] = 3.777388217492419e-02*G0_1_0 + 5.675868306076634e-02*G0_1_1 + 1.888694108746318e-02*G0_1_2 + 9.394540644540574e-03*G0_2_0 + 1.888694108746184e-02*G0_2_1 - 6.197787230772655e-03*G0_2_2;
    block[1439] = -4.031823693282061e-02*G0_1_0 - 2.544354757896450e-02*G0_1_1 - 3.907867948666601e-02*G0_1_2 - 5.401860870610863e-02*G0_2_0 - 3.907867948666532e-02*G0_2_1 - 5.284429112554069e-02*G0_2_2;
    block[1440] = -1.270872581636462e-01*G0_1_1 - 3.777388217492451e-02*G0_1_2 - 3.777388217492339e-02*G0_2_1 - 1.500516908502968e-02*G0_2_2;
    block[1441] = -1.898480088584245e-02*G0_1_1 - 9.492400442920476e-03*G0_1_2 - 9.492400442921232e-03*G0_2_1 - 6.523986558710805e-04*G0_2_2;
    block[1442] = -1.487468935385612e-02*G0_1_1 - 1.493992921944329e-02*G0_1_2 - 1.493992921944290e-02*G0_2_1 - 1.500516908502968e-02*G0_2_2;
    block[1443] = -1.898480088584252e-02*G0_1_1 - 9.492400442920292e-03*G0_1_2 - 9.492400442921795e-03*G0_2_1 - 6.523986558712454e-04*G0_2_2;
    block[1444] = 4.501550725508788e-03*G0_1_1 + 1.924576034818661e-03*G0_1_2 + 1.924576034818715e-03*G0_2_1 - 6.523986558708964e-04*G0_2_2;
    block[1445] = -1.487468935385612e-02*G0_1_1 - 1.493992921944352e-02*G0_1_2 - 1.493992921944310e-02*G0_2_1 - 1.500516908502987e-02*G0_2_2;
    block[1446] = -1.304797311741903e-03*G0_1_1 - 1.239557446154756e-03*G0_1_2 - 1.239557446154598e-03*G0_2_1 - 1.174317580567935e-03*G0_2_2;
    block[1447] = -1.565756774090099e-02*G0_1_1 - 1.308059305021098e-02*G0_1_2 - 1.308059305021092e-02*G0_2_1 - 1.050361835952130e-02*G0_2_2;
    block[1448] = -1.304797311741828e-03*G0_1_1 - 1.239557446154642e-03*G0_1_2 - 1.239557446154311e-03*G0_2_1 - 1.174317580567539e-03*G0_2_2;
    block[1449] = 8.807381854257159e-03*G0_1_1 + 6.491366625915569e-03*G0_1_2 + 6.491366625915686e-03*G0_2_1 + 3.522952741703469e-03*G0_2_2;
    block[1450] = 8.807381854256854e-03*G0_1_1 + 6.491366625915417e-03*G0_1_2 + 6.491366625915169e-03*G0_2_1 + 3.522952741703202e-03*G0_2_2;
    block[1451] = 4.762510187857304e-02*G0_1_1 + 6.236931150125474e-02*G0_1_2 + 6.236931150125483e-02*G0_2_1 + 1.247386230025103e-01*G0_2_2;
    block[1452] = 3.914391935225237e-02*G0_1_1 + 3.196753413767200e-02*G0_1_2 + 3.196753413767308e-02*G0_2_1 + 2.609594623483467e-02*G0_2_2;
    block[1453] = 3.914391935225272e-02*G0_1_1 + 3.196753413767234e-02*G0_1_2 + 3.196753413767354e-02*G0_2_1 + 2.609594623483526e-02*G0_2_2;
    block[1454] = -1.565756774090095e-01*G0_1_1 - 9.035721383811617e-02*G0_1_2 - 9.035721383811665e-02*G0_2_1 - 1.859336169231998e-01*G0_2_2;
    block[1455] = 1.859336169231987e-01*G0_1_1 + 1.565756774090212e-02*G0_1_2 + 1.565756774090181e-02*G0_2_1 + 2.609594623483601e-02*G0_2_2;
    block[1456] = -3.365072266981906e-03*G0_1_0 - 3.365072266981922e-03*G0_1_1 - 3.365072266981892e-03*G0_1_2 - 3.365072266981935e-03*G0_2_0 - 3.365072266981946e-03*G0_2_1 - 3.365072266981917e-03*G0_2_2;
    block[1457] = 3.365072266981979e-03*G0_1_0 + 3.365072266981974e-03*G0_2_0;
    block[1458] = -1.555448875327328e-02*G0_1_1 + 2.326323127104366e-02*G0_2_1;
    block[1459] = -3.365855145369003e-02*G0_1_2 + 2.146913496739887e-02*G0_2_2;
    block[1460] = -1.168445992664726e-02*G0_1_0 - 2.289919282106667e-03*G0_1_1 - 1.397437920875409e-02*G0_2_0 - 2.289919282106727e-03*G0_2_1;
    block[1461] = 1.315235690235677e-02*G0_1_0 + 1.321759676794373e-02*G0_1_1 + 2.630471380471353e-02*G0_2_0 + 1.315235690235665e-02*G0_2_1;
    block[1462] = -5.480148709315275e-04*G0_1_0 - 4.827750053441293e-04*G0_1_1 + 5.232237220084535e-03*G0_2_0 + 5.780252091016238e-03*G0_2_1;
    block[1463] = 1.897827689928366e-02*G0_1_0 + 2.837281754382403e-02*G0_1_1 + 7.889456945446464e-02*G0_2_0 + 5.991629255518081e-02*G0_2_1;
    block[1464] = -1.897827689928366e-02*G0_1_0 + 9.394540644540351e-03*G0_1_1 - 1.897827689928364e-02*G0_1_2 - 7.889456945446464e-02*G0_2_0 - 1.897827689928389e-02*G0_2_1 - 7.889456945446459e-02*G0_2_2;
    block[1465] = 5.480148709315864e-04*G0_1_0 + 6.523986558724102e-05*G0_1_1 + 5.480148709315882e-04*G0_1_2 - 5.232237220084477e-03*G0_2_0 + 5.480148709316576e-04*G0_2_1 - 5.232237220084502e-03*G0_2_2;
    block[1466] = -1.315235690235660e-02*G0_1_0 + 6.523986558718246e-05*G0_1_1 - 1.315235690235668e-02*G0_1_2 - 2.630471380471343e-02*G0_2_0 - 1.315235690235679e-02*G0_2_1 - 2.630471380471353e-02*G0_2_2;
    block[1467] = 1.168445992664708e-02*G0_1_0 + 9.394540644540412e-03*G0_1_1 + 1.168445992664714e-02*G0_1_2 + 1.397437920875403e-02*G0_2_0 + 1.168445992664724e-02*G0_2_1 + 1.397437920875408e-02*G0_2_2;
    block[1468] = 2.289919282106601e-03*G0_1_1 + 2.289919282106596e-03*G0_1_2 + 2.289919282106821e-03*G0_2_1 + 2.289919282106792e-03*G0_2_2;
    block[1469] = 1.787572317086207e-03*G0_1_1 + 1.787572317086147e-03*G0_1_2 + 1.787572317086197e-03*G0_2_1 + 1.787572317086176e-03*G0_2_2;
    block[1470] = 1.787572317086200e-03*G0_1_1 + 1.787572317086172e-03*G0_1_2 + 1.787572317086386e-03*G0_2_1 + 1.787572317086377e-03*G0_2_2;
    block[1471] = 2.289919282106686e-03*G0_1_1 + 2.289919282106655e-03*G0_1_2 + 2.289919282106765e-03*G0_2_1 + 2.289919282106720e-03*G0_2_2;
    block[1472] = 1.116906498850916e-02*G0_1_0 + 1.116906498850921e-02*G0_1_1 + 8.879145706402447e-03*G0_1_2 + 8.879145706402622e-03*G0_2_0 + 8.879145706402690e-03*G0_2_1 + 6.589226424295757e-03*G0_2_2;
    block[1473] = -5.232237220084058e-03*G0_1_0 - 5.232237220084145e-03*G0_1_1 - 5.780252091015696e-03*G0_1_2 - 5.780252091015941e-03*G0_2_0 - 5.780252091016066e-03*G0_2_1 - 6.263027096360205e-03*G0_2_2;
    block[1474] = -9.603308214419383e-03*G0_1_0 - 9.603308214419346e-03*G0_1_1 - 4.801654107209726e-03*G0_1_2 - 4.801654107209249e-03*G0_2_0 - 4.801654107209204e-03*G0_2_1 + 2.609594623482405e-04*G0_2_2;
    block[1475] = 1.086374241756178e-01*G0_1_0 + 1.086374241756179e-01*G0_1_1 + 3.872638421249491e-02*G0_1_2 + 3.872638421249466e-02*G0_2_0 + 3.872638421249466e-02*G0_2_1 - 1.869122149070068e-02*G0_2_2;
    block[1476] = -1.116906498850931e-02*G0_1_0 - 2.289919282106687e-03*G0_1_2 - 8.879145706402622e-03*G0_2_0 - 2.289919282106740e-03*G0_2_2;
    block[1477] = 5.232237220084182e-03*G0_1_0 - 5.480148709316925e-04*G0_1_2 + 5.780252091016071e-03*G0_2_0 - 4.827750053442154e-04*G0_2_2;
    block[1478] = 9.603308214419444e-03*G0_1_0 + 4.801654107209907e-03*G0_1_2 + 4.801654107209469e-03*G0_2_0 + 5.062613569557835e-03*G0_2_2;
    block[1479] = -1.086374241756178e-01*G0_1_0 - 6.991103996312298e-02*G0_1_2 - 3.872638421249466e-02*G0_2_0 - 5.741760570319533e-02*G0_2_2;
    block[1480] = 1.007173044933451e-01*G0_1_1 + 1.897827689928354e-02*G0_1_2 - 2.463457324568461e-02*G0_2_1 + 7.889456945446455e-02*G0_2_2;
    block[1481] = -2.041877313144657e-01*G0_1_1 - 3.649518080941652e-02*G0_1_2 + 1.530527246673104e-02*G0_2_1 - 2.041877313144660e-01*G0_2_2;
    block[1482] = 2.810011490567023e-01*G0_1_1 + 7.813126302709551e-02*G0_1_2 + 7.813126302709550e-02*G0_2_1 + 3.042265412057059e-01*G0_2_2;
    block[1483] = -1.086374241756178e-01*G0_1_1 + 2.638300164341787e-02*G0_1_2 - 3.872638421249468e-02*G0_2_1 - 1.470637050064123e-01*G0_2_2;
    block[1484] = 5.401860870610754e-02*G0_1_0 + 1.174317580567089e-03*G0_1_1 + 1.493992921944291e-02*G0_1_2 + 4.031823693281997e-02*G0_2_0 + 1.239557446154629e-03*G0_2_1 + 1.487468935385591e-02*G0_2_2;
    block[1485] = -1.082329370089778e-01*G0_1_0 - 3.522952741702704e-03*G0_1_1 - 3.389211017249304e-02*G0_1_2 - 8.083219346240127e-02*G0_2_0 - 6.491366625915067e-03*G0_2_1 - 4.364547007776179e-02*G0_2_2;
    block[1486] = 1.466592178397719e-01*G0_1_0 - 1.247386230025109e-01*G0_1_1 + 7.332960891988685e-02*G0_1_2 + 1.096029741863082e-02*G0_2_0 - 6.236931150125515e-02*G0_2_1 + 1.323064474106136e-01*G0_2_2;
    block[1487] = -9.394540644540353e-03*G0_1_0 - 1.559232787531417e-02*G0_1_1 + 9.492400442921418e-03*G0_1_2 - 3.777388217492317e-02*G0_2_0 - 1.888694108746165e-02*G0_2_1 + 1.898480088584283e-02*G0_2_2;
    block[1488] = 7.770067991422062e-02*G0_1_0 + 1.824106641814954e-01*G0_1_1 - 6.165167297980306e-03*G0_1_2 + 1.677316944244014e-01*G0_2_0 + 8.386584721220011e-02*G0_2_1 - 1.669488160373571e-01*G0_2_2;
    block[1489] = 1.826716236437929e-03*G0_1_0 - 5.101757488910220e-02*G0_1_1 + 3.777388217492331e-02*G0_1_2 - 8.233271037090512e-02*G0_2_0 - 4.638554443241930e-02*G0_2_1 + 1.270872581636457e-01*G0_2_2;
    block[1490] = -1.826716236437943e-03*G0_1_0 - 5.284429112554012e-02*G0_1_1 + 3.594716593848529e-02*G0_1_2 + 8.233271037090506e-02*G0_2_0 + 3.594716593848567e-02*G0_2_1 + 2.094199685345507e-01*G0_2_2;
    block[1491] = -7.770067991422068e-02*G0_1_0 + 1.047099842672753e-01*G0_1_1 - 8.386584721220053e-02*G0_1_2 - 1.677316944244015e-01*G0_2_0 - 8.386584721220064e-02*G0_2_1 - 3.346805104617583e-01*G0_2_2;
    block[1492] = -1.466592178397719e-01*G0_1_0 - 2.713978408422830e-01*G0_1_1 - 7.332960891988539e-02*G0_1_2 - 1.096029741863089e-02*G0_2_0 - 7.332960891988635e-02*G0_2_1 + 1.213461499919827e-01*G0_2_2;
    block[1493] = 9.394540644539928e-03*G0_1_0 - 6.197787230773973e-03*G0_1_1 + 1.888694108746139e-02*G0_1_2 + 3.777388217492279e-02*G0_2_0 + 1.888694108746130e-02*G0_2_1 + 5.675868306076585e-02*G0_2_2;
    block[1494] = 1.082329370089774e-01*G0_1_0 + 1.047099842672747e-01*G0_1_1 + 7.434082683648494e-02*G0_1_2 + 8.083219346240138e-02*G0_2_0 + 7.434082683648581e-02*G0_2_1 + 3.718672338463941e-02*G0_2_2;
    block[1495] = -5.401860870610763e-02*G0_1_0 - 5.284429112554020e-02*G0_1_1 - 3.907867948666460e-02*G0_1_2 - 4.031823693281955e-02*G0_2_0 - 3.907867948666504e-02*G0_2_1 - 2.544354757896390e-02*G0_2_2;
    block[1496] = 1.247386230025109e-01*G0_1_1 + 6.236931150125637e-02*G0_1_2 + 6.236931150125516e-02*G0_2_1 + 4.762510187857333e-02*G0_2_2;
    block[1497] = 3.522952741702850e-03*G0_1_1 + 6.491366625914519e-03*G0_1_2 + 6.491366625915233e-03*G0_2_1 + 8.807381854256920e-03*G0_2_2;
    block[1498] = -1.174317580567134e-03*G0_1_1 - 1.239557446154257e-03*G0_1_2 - 1.239557446154765e-03*G0_2_1 - 1.304797311742006e-03*G0_2_2;
    block[1499] = 3.522952741702892e-03*G0_1_1 + 6.491366625914308e-03*G0_1_2 + 6.491366625915955e-03*G0_2_1 + 8.807381854257057e-03*G0_2_2;
    block[1500] = -1.050361835952131e-02*G0_1_1 - 1.308059305021081e-02*G0_1_2 - 1.308059305021110e-02*G0_2_1 - 1.565756774090102e-02*G0_2_2;
    block[1501] = -1.174317580567266e-03*G0_1_1 - 1.239557446154045e-03*G0_1_2 - 1.239557446154558e-03*G0_2_1 - 1.304797311741729e-03*G0_2_2;
    block[1502] = -1.500516908502999e-02*G0_1_1 - 1.493992921944291e-02*G0_1_2 - 1.493992921944299e-02*G0_2_1 - 1.487468935385561e-02*G0_2_2;
    block[1503] = -6.523986558708161e-04*G0_1_1 + 1.924576034818744e-03*G0_1_2 + 1.924576034818943e-03*G0_2_1 + 4.501550725508801e-03*G0_2_2;
    block[1504] = -1.500516908503006e-02*G0_1_1 - 1.493992921944293e-02*G0_1_2 - 1.493992921944316e-02*G0_2_1 - 1.487468935385589e-02*G0_2_2;
    block[1505] = -6.523986558711164e-04*G0_1_1 - 9.492400442921298e-03*G0_1_2 - 9.492400442921652e-03*G0_2_1 - 1.898480088584297e-02*G0_2_2;
    block[1506] = -6.523986558710374e-04*G0_1_1 - 9.492400442921309e-03*G0_1_2 - 9.492400442921291e-03*G0_2_1 - 1.898480088584272e-02*G0_2_2;
    block[1507] = -1.500516908502948e-02*G0_1_1 - 3.777388217492322e-02*G0_1_2 - 3.777388217492294e-02*G0_2_1 - 1.270872581636458e-01*G0_2_2;
    block[1508] = 2.609594623483512e-02*G0_1_1 + 3.196753413767338e-02*G0_1_2 + 3.196753413767273e-02*G0_2_1 + 3.914391935225280e-02*G0_2_2;
    block[1509] = 2.609594623483552e-02*G0_1_1 + 3.196753413767414e-02*G0_1_2 + 3.196753413767286e-02*G0_2_1 + 3.914391935225284e-02*G0_2_2;
    block[1510] = 2.609594623483421e-02*G0_1_1 + 1.565756774090123e-02*G0_1_2 + 1.565756774090107e-02*G0_2_1 + 1.859336169232000e-01*G0_2_2;
    block[1511] = -1.859336169231984e-01*G0_1_1 - 9.035721383811710e-02*G0_1_2 - 9.035721383811628e-02*G0_2_1 - 1.565756774090107e-01*G0_2_2;
    block[1512] = -4.800349309897844e-03*G0_1_0 - 4.800349309897844e-03*G0_1_1 - 4.800349309897883e-03*G0_1_2 - 4.800349309897829e-03*G0_2_0 - 4.800349309897828e-03*G0_2_1 - 4.800349309897868e-03*G0_2_2;
    block[1513] = 4.800349309897876e-03*G0_1_0 + 4.800349309897861e-03*G0_2_0;
    block[1514] = 4.800349309897888e-03*G0_1_1 - 1.053101910306764e-02*G0_2_1;
    block[1515] = 3.725718243947379e-02*G0_1_2 - 1.787050398161506e-02*G0_2_2;
    block[1516] = -5.375764924375793e-03*G0_1_0 - 5.375764924375855e-03*G0_1_1 - 1.075152984875183e-02*G0_2_0 - 5.375764924375933e-03*G0_2_1;
    block[1517] = -2.289919282106777e-03*G0_1_0 - 2.289919282106755e-03*G0_1_1 - 1.397437920875411e-02*G0_2_0 - 1.168445992664731e-02*G0_2_1;
    block[1518] = -2.289919282106672e-03*G0_1_0 - 2.289919282106675e-03*G0_1_1 - 1.116906498850933e-02*G0_2_0 - 8.879145706402551e-03*G0_2_1;
    block[1519] = -5.375764924375985e-03*G0_1_0 - 5.375764924376061e-03*G0_1_1 - 3.283522434998112e-02*G0_2_0 - 2.745945942560518e-02*G0_2_1;
    block[1520] = 5.375764924375985e-03*G0_1_0 + 5.375764924375996e-03*G0_1_2 + 3.283522434998112e-02*G0_2_0 + 5.375764924375965e-03*G0_2_1 + 3.283522434998111e-02*G0_2_2;
    block[1521] = 2.289919282106804e-03*G0_1_0 + 2.289919282106796e-03*G0_1_2 + 1.116906498850944e-02*G0_2_0 + 2.289919282106853e-03*G0_2_1 + 1.116906498850941e-02*G0_2_2;
    block[1522] = 2.289919282106688e-03*G0_1_0 + 2.289919282106759e-03*G0_1_2 + 1.397437920875413e-02*G0_2_0 + 2.289919282106695e-03*G0_2_1 + 1.397437920875420e-02*G0_2_2;
    block[1523] = 5.375764924376122e-03*G0_1_0 + 5.375764924376095e-03*G0_1_2 + 1.075152984875211e-02*G0_2_0 + 5.375764924376066e-03*G0_2_1 + 1.075152984875209e-02*G0_2_2;
    block[1524] = 5.375764924376103e-03*G0_1_1 + 5.375764924376072e-03*G0_1_2 + 5.375764924376052e-03*G0_2_1 + 5.375764924376049e-03*G0_2_2;
    block[1525] = 2.289919282106636e-03*G0_1_1 + 2.289919282106700e-03*G0_1_2 + 2.289919282106701e-03*G0_2_1 + 2.289919282106732e-03*G0_2_2;
    block[1526] = 2.289919282106789e-03*G0_1_1 + 2.289919282106820e-03*G0_1_2 + 2.289919282106767e-03*G0_2_1 + 2.289919282106783e-03*G0_2_2;
    block[1527] = 5.375764924375931e-03*G0_1_1 + 5.375764924375914e-03*G0_1_2 + 5.375764924375977e-03*G0_2_1 + 5.375764924375983e-03*G0_2_2;
    block[1528] = 3.283522434998100e-02*G0_1_0 + 3.283522434998098e-02*G0_1_1 + 2.745945942560507e-02*G0_1_2 + 2.745945942560498e-02*G0_2_0 + 2.745945942560496e-02*G0_2_1 + 2.208369450122903e-02*G0_2_2;
    block[1529] = -7.889456945446463e-02*G0_1_0 - 7.889456945446457e-02*G0_1_1 - 5.991629255518108e-02*G0_1_2 - 5.991629255518099e-02*G0_2_0 - 5.991629255518090e-02*G0_2_1 - 3.154347501135671e-02*G0_2_2;
    block[1530] = 1.086374241756178e-01*G0_1_0 + 1.086374241756177e-01*G0_1_1 + 6.991103996312276e-02*G0_1_2 + 6.991103996312269e-02*G0_2_0 + 6.991103996312265e-02*G0_2_1 + 1.249343425992707e-02*G0_2_2;
    block[1531] = -1.398220799262456e-01*G0_1_0 - 1.398220799262457e-01*G0_1_1 - 6.991103996312258e-02*G0_1_2 - 6.991103996312287e-02*G0_2_0 - 6.991103996312288e-02*G0_2_1 + 1.963719954171354e-02*G0_2_2;
    block[1532] = -3.283522434998090e-02*G0_1_0 - 5.375764924375798e-03*G0_1_2 - 2.745945942560495e-02*G0_2_0 - 5.375764924375886e-03*G0_2_2;
    block[1533] = 7.889456945446467e-02*G0_1_0 + 1.897827689928355e-02*G0_1_2 + 5.991629255518091e-02*G0_2_0 + 2.837281754382412e-02*G0_2_2;
    block[1534] = -1.086374241756179e-01*G0_1_0 - 3.872638421249500e-02*G0_1_2 - 6.991103996312285e-02*G0_2_0 - 5.741760570319558e-02*G0_2_2;
    block[1535] = 1.398220799262457e-01*G0_1_0 + 6.991103996312291e-02*G0_1_2 + 6.991103996312288e-02*G0_2_0 + 8.954823950483626e-02*G0_2_2;
    block[1536] = -3.283522434998108e-02*G0_1_1 - 5.375764924375893e-03*G0_1_2 + 2.091590090722009e-02*G0_2_1 - 3.283522434998105e-02*G0_2_2;
    block[1537] = 7.889456945446478e-02*G0_1_1 + 1.897827689928343e-02*G0_1_2 - 2.463457324568389e-02*G0_2_1 + 1.007173044933455e-01*G0_2_2;
    block[1538] = -1.086374241756178e-01*G0_1_1 - 3.872638421249468e-02*G0_1_2 + 2.638300164341787e-02*G0_2_1 - 1.470637050064123e-01*G0_2_2;
    block[1539] = 1.398220799262457e-01*G0_1_1 + 6.991103996312292e-02*G0_1_2 + 6.991103996312291e-02*G0_2_1 + 1.790964790096724e-01*G0_2_2;
    block[1540] = 1.187365553685021e-02*G0_1_0 + 1.187365553685052e-02*G0_1_1 - 9.394540644540228e-03*G0_1_2 + 4.253639236278075e-02*G0_2_0 + 2.126819618139070e-02*G0_2_1 - 1.878908128908113e-02*G0_2_2;
    block[1541] = -4.296045148909740e-02*G0_1_0 - 4.296045148909752e-02*G0_1_1 - 6.850185886640970e-04*G0_1_2 - 8.455086580086540e-02*G0_2_0 - 4.227543290043312e-02*G0_2_1 + 4.397166940569690e-02*G0_2_2;
    block[1542] = 1.247386230025112e-01*G0_1_0 + 1.247386230025112e-01*G0_1_1 + 2.844458139596938e-02*G0_1_2 + 1.925880832130820e-01*G0_2_0 + 9.629404160654118e-02*G0_2_1 - 6.445698720004289e-02*G0_2_2;
    block[1543] = 2.544354757896426e-03*G0_1_0 + 2.544354757896390e-03*G0_1_1 - 3.294613212147929e-03*G0_1_2 + 1.428753056357201e-02*G0_2_0 + 8.448562593527564e-03*G0_2_1 - 2.926007971580877e-02*G0_2_2;
    block[1544] = -4.296045148909672e-02*G0_1_0 - 4.296045148909663e-02*G0_1_1 - 6.850185886639741e-04*G0_1_2 - 4.932133838383781e-02*G0_2_0 - 7.045905483405214e-03*G0_2_1 + 1.273155976932015e-01*G0_2_2;
    block[1545] = 1.187365553684980e-02*G0_1_0 + 1.187365553684984e-02*G0_1_1 - 9.394540644540603e-03*G0_1_2 + 4.775558160974799e-02*G0_2_0 + 2.648738542835755e-02*G0_2_1 - 6.413078787210698e-02*G0_2_2;
    block[1546] = -1.187365553684978e-02*G0_1_0 - 2.126819618139051e-02*G0_1_2 - 4.775558160974797e-02*G0_2_0 - 2.126819618139044e-02*G0_2_1 - 1.118863694818551e-01*G0_2_2;
    block[1547] = 4.296045148909674e-02*G0_1_0 + 4.227543290043279e-02*G0_1_2 + 4.932133838383779e-02*G0_2_0 + 4.227543290043251e-02*G0_2_1 + 1.766369360770394e-01*G0_2_2;
    block[1548] = -1.247386230025112e-01*G0_1_0 - 9.629404160654152e-02*G0_1_2 - 1.925880832130820e-01*G0_2_0 - 9.629404160654055e-02*G0_2_1 - 2.570450704131249e-01*G0_2_2;
    block[1549] = -2.544354757896278e-03*G0_1_0 - 5.838967970044372e-03*G0_1_2 - 1.428753056357190e-02*G0_2_0 - 5.838967970044316e-03*G0_2_1 - 4.354761027938098e-02*G0_2_2;
    block[1550] = 4.296045148909689e-02*G0_1_0 + 4.227543290043307e-02*G0_1_2 + 8.455086580086490e-02*G0_2_0 + 4.227543290043227e-02*G0_2_1 + 1.285225352065625e-01*G0_2_2;
    block[1551] = -1.187365553684985e-02*G0_1_0 - 2.126819618139074e-02*G0_1_2 - 4.253639236278082e-02*G0_2_0 - 2.126819618139041e-02*G0_2_1 - 6.132547365186237e-02*G0_2_2;
    block[1552] = -1.247386230025110e-01*G0_1_1 - 9.629404160654170e-02*G0_1_2 - 9.629404160654106e-02*G0_2_1 - 1.285225352065626e-01*G0_2_2;
    block[1553] = 4.296045148909736e-02*G0_1_1 + 4.227543290043312e-02*G0_1_2 + 4.227543290043295e-02*G0_2_1 + 6.426126760328141e-02*G0_2_2;
    block[1554] = -1.187365553685049e-02*G0_1_1 - 2.126819618139065e-02*G0_1_2 - 2.126819618139063e-02*G0_2_1 - 3.066273682593113e-02*G0_2_2;
    block[1555] = 4.296045148909686e-02*G0_1_1 + 4.227543290043327e-02*G0_1_2 + 4.227543290043224e-02*G0_2_1 + 6.426126760328153e-02*G0_2_2;
    block[1556] = -2.544354757896306e-03*G0_1_1 - 5.838967970044521e-03*G0_1_2 - 5.838967970044324e-03*G0_2_1 - 9.133581182192416e-03*G0_2_2;
    block[1557] = -1.187365553684980e-02*G0_1_1 - 2.126819618139073e-02*G0_1_2 - 2.126819618139037e-02*G0_2_1 - 3.066273682593127e-02*G0_2_2;
    block[1558] = 9.394540644540709e-03*G0_1_2 + 9.394540644540688e-03*G0_2_1 + 1.878908128908136e-02*G0_2_2;
    block[1559] = 3.294613212147956e-03*G0_1_2 + 3.294613212148061e-03*G0_2_1 + 6.589226424295929e-03*G0_2_2;
    block[1560] = 9.394540644540143e-03*G0_1_2 + 9.394540644540574e-03*G0_2_1 + 1.878908128908102e-02*G0_2_2;
    block[1561] = 3.294613212147956e-03*G0_1_2 + 3.294613212147904e-03*G0_2_1 + 2.926007971580898e-02*G0_2_2;
    block[1562] = 3.294613212147886e-03*G0_1_2 + 3.294613212147767e-03*G0_2_1 + 2.926007971580875e-02*G0_2_2;
    block[1563] = 9.394540644540489e-03*G0_1_2 + 9.394540644540436e-03*G0_2_1 + 6.413078787210688e-02*G0_2_2;
    block[1564] = -2.609594623484559e-03*G0_1_2 - 2.609594623484083e-03*G0_2_1 - 5.056089582999398e-02*G0_2_2;
    block[1565] = -2.609594623483684e-03*G0_1_2 - 2.609594623483437e-03*G0_2_1 - 5.056089582999261e-02*G0_2_2;
    block[1566] = -2.609594623483647e-03*G0_1_2 - 2.609594623482972e-03*G0_2_1 - 1.565756774090103e-01*G0_2_2;
    block[1567] = -3.522952741702577e-02*G0_1_2 - 3.522952741702696e-02*G0_2_1 + 9.622880174095526e-02*G0_2_2;
    block[1568] = -1.374212528726399e-02*G0_0_0 - 1.374212528726402e-02*G0_0_1 - 1.374212528726401e-02*G0_0_2 - 1.374212528726410e-02*G0_1_0 - 1.374212528726413e-02*G0_1_1 - 1.374212528726414e-02*G0_1_2 - 1.374212528726407e-02*G0_2_0 - 1.374212528726407e-02*G0_2_1 - 1.374212528726409e-02*G0_2_2;
    block[1569] = 4.799305472048487e-02*G0_0_0 + 1.439452394313478e-02*G0_1_0 + 1.439452394313484e-02*G0_2_0;
    block[1570] = -5.177435732991202e-03*G0_0_1 + 1.374212528726406e-02*G0_1_1 - 5.177435732991239e-03*G0_2_1;
    block[1571] = -5.177435732991147e-03*G0_0_2 - 5.177435732991153e-03*G0_1_2 + 1.374212528726419e-02*G0_2_2;
    block[1572] = -6.445698720004234e-02*G0_0_0 + 2.844458139596997e-02*G0_0_1 + 9.629404160654015e-02*G0_1_0 + 1.247386230025100e-01*G0_1_1 + 1.925880832130807e-01*G0_2_0 + 1.247386230025099e-01*G0_2_1;
    block[1573] = 1.323064474106128e-01*G0_0_0 + 7.332960891988581e-02*G0_0_1 - 6.236931150125530e-02*G0_1_0 - 1.247386230025104e-01*G0_1_1 + 1.096029741863108e-02*G0_2_0 + 1.466592178397728e-01*G0_2_1;
    block[1574] = -5.101757488910194e-02*G0_0_0 - 4.638554443241862e-02*G0_0_1 + 3.777388217492367e-02*G0_1_0 + 1.270872581636460e-01*G0_1_1 + 1.826716236438201e-03*G0_2_0 - 8.233271037090457e-02*G0_2_1;
    block[1575] = 1.187365553684992e-02*G0_0_0 + 2.648738542835739e-02*G0_0_1 - 9.394540644540579e-03*G0_1_0 - 6.413078787210656e-02*G0_1_1 + 1.187365553685002e-02*G0_2_0 + 4.775558160974813e-02*G0_2_1;
    block[1576] = -1.187365553684989e-02*G0_0_0 + 9.394540644540454e-03*G0_0_1 - 1.187365553684992e-02*G0_0_2 + 9.394540644540577e-03*G0_1_0 + 9.394540644540553e-03*G0_1_2 - 1.187365553685000e-02*G0_2_0 + 9.394540644540327e-03*G0_2_1 - 1.187365553685006e-02*G0_2_2;
    block[1577] = -1.174317580567435e-03*G0_0_0 + 6.523986558727764e-05*G0_0_1 - 1.174317580567490e-03*G0_0_2 + 6.523986558720713e-05*G0_1_0 + 6.523986558704084e-05*G0_1_2 - 1.174317580567441e-03*G0_2_0 + 6.523986558740464e-05*G0_2_1 - 1.174317580567528e-03*G0_2_2;
    block[1578] = -1.487468935385585e-02*G0_0_0 + 6.523986558689940e-05*G0_0_1 - 1.487468935385578e-02*G0_0_2 + 6.523986558718318e-05*G0_1_0 + 6.523986558729836e-05*G0_1_2 - 1.487468935385578e-02*G0_2_0 + 6.523986558696245e-05*G0_2_1 - 1.487468935385573e-02*G0_2_2;
    block[1579] = 1.878908128908099e-02*G0_0_0 + 9.394540644540613e-03*G0_0_1 + 1.878908128908094e-02*G0_0_2 + 9.394540644540463e-03*G0_1_0 + 9.394540644540391e-03*G0_1_2 + 1.878908128908090e-02*G0_2_0 + 9.394540644540542e-03*G0_2_1 + 1.878908128908080e-02*G0_2_2;
    block[1580] = 4.534170658302528e-02*G0_0_0 + 5.473624722756579e-02*G0_0_1 + 5.473624722756574e-02*G0_0_2 + 5.473624722756606e-02*G0_1_0 + 6.413078787210638e-02*G0_1_1 + 6.413078787210638e-02*G0_1_2 + 5.473624722756605e-02*G0_2_0 + 6.413078787210631e-02*G0_2_1 + 6.413078787210631e-02*G0_2_2;
    block[1581] = -6.654466289882854e-02*G0_0_0 - 8.931337598872209e-02*G0_0_1 - 8.931337598872204e-02*G0_0_2 - 8.931337598872217e-02*G0_1_0 - 1.270872581636456e-01*G0_1_1 - 1.270872581636456e-01*G0_1_2 - 8.931337598872227e-02*G0_2_0 - 1.270872581636454e-01*G0_2_1 - 1.270872581636453e-01*G0_2_2;
    block[1582] = 4.762510187857361e-02*G0_0_0 + 6.236931150125510e-02*G0_0_1 + 6.236931150125501e-02*G0_0_2 + 6.236931150125543e-02*G0_1_0 + 1.247386230025106e-01*G0_1_1 + 1.247386230025104e-01*G0_1_2 + 6.236931150125547e-02*G0_2_0 + 1.247386230025104e-01*G0_2_1 + 1.247386230025102e-01*G0_2_2;
    block[1583] = -6.067307499599123e-02*G0_0_0 - 2.844458139597005e-02*G0_0_1 - 2.844458139597004e-02*G0_0_2 - 2.844458139597002e-02*G0_1_0 - 1.247386230025102e-01*G0_1_1 - 1.247386230025100e-01*G0_1_2 - 2.844458139597009e-02*G0_2_0 - 1.247386230025101e-01*G0_2_1 - 1.247386230025100e-01*G0_2_2;
    block[1584] = 1.878908128908101e-02*G0_0_0 + 1.878908128908102e-02*G0_0_1 + 9.394540644540620e-03*G0_0_2 + 1.878908128908087e-02*G0_1_0 + 1.878908128908090e-02*G0_1_1 + 9.394540644540695e-03*G0_1_2 + 9.394540644540379e-03*G0_2_0 + 9.394540644540293e-03*G0_2_1;
    block[1585] = -1.487468935385575e-02*G0_0_0 - 1.487468935385577e-02*G0_0_1 + 6.523986558689348e-05*G0_0_2 - 1.487468935385596e-02*G0_1_0 - 1.487468935385592e-02*G0_1_1 + 6.523986558687021e-05*G0_1_2 + 6.523986558700393e-05*G0_2_0 + 6.523986558703753e-05*G0_2_1;
    block[1586] = -1.174317580567338e-03*G0_0_0 - 1.174317580567339e-03*G0_0_1 + 6.523986558732244e-05*G0_0_2 - 1.174317580567208e-03*G0_1_0 - 1.174317580567233e-03*G0_1_1 + 6.523986558740628e-05*G0_1_2 + 6.523986558722588e-05*G0_2_0 + 6.523986558725610e-05*G0_2_1;
    block[1587] = -1.187365553685008e-02*G0_0_0 - 1.187365553685014e-02*G0_0_1 + 9.394540644540362e-03*G0_0_2 - 1.187365553685042e-02*G0_1_0 - 1.187365553685039e-02*G0_1_1 + 9.394540644540261e-03*G0_1_2 + 9.394540644540291e-03*G0_2_0 + 9.394540644540315e-03*G0_2_1;
    block[1588] = -6.445698720004235e-02*G0_0_0 + 2.844458139597003e-02*G0_0_2 + 1.925880832130808e-01*G0_1_0 + 1.247386230025099e-01*G0_1_2 + 9.629404160653988e-02*G0_2_0 + 1.247386230025099e-01*G0_2_2;
    block[1589] = 1.323064474106129e-01*G0_0_0 + 7.332960891988587e-02*G0_0_2 + 1.096029741863159e-02*G0_1_0 + 1.466592178397730e-01*G0_1_2 - 6.236931150125468e-02*G0_2_0 - 1.247386230025103e-01*G0_2_2;
    block[1590] = -5.101757488910223e-02*G0_0_0 - 4.638554443241884e-02*G0_0_2 + 1.826716236437783e-03*G0_1_0 - 8.233271037090473e-02*G0_1_2 + 3.777388217492299e-02*G0_2_0 + 1.270872581636456e-01*G0_2_2;
    block[1591] = 1.187365553685032e-02*G0_0_0 + 2.648738542835770e-02*G0_0_2 + 1.187365553685061e-02*G0_1_0 + 4.775558160974844e-02*G0_1_2 - 9.394540644540164e-03*G0_2_0 - 6.413078787210660e-02*G0_2_2;
    block[1592] = 4.253639236278057e-02*G0_0_1 + 1.187365553684983e-02*G0_0_2 - 1.878908128908112e-02*G0_1_1 - 9.394540644540534e-03*G0_1_2 + 2.126819618139051e-02*G0_2_1 + 1.187365553684999e-02*G0_2_2;
    block[1593] = 4.031823693282035e-02*G0_0_1 + 5.401860870610806e-02*G0_0_2 + 1.487468935385621e-02*G0_1_1 + 1.493992921944308e-02*G0_1_2 + 1.239557446154626e-03*G0_2_1 + 1.174317580567519e-03*G0_2_2;
    block[1594] = 5.401860870610753e-02*G0_0_1 + 4.031823693281997e-02*G0_0_2 + 1.174317580567089e-03*G0_1_1 + 1.239557446154631e-03*G0_1_2 + 1.493992921944291e-02*G0_2_1 + 1.487468935385590e-02*G0_2_2;
    block[1595] = 1.187365553685021e-02*G0_0_1 + 4.253639236278076e-02*G0_0_2 + 1.187365553685052e-02*G0_1_1 + 2.126819618139071e-02*G0_1_2 - 9.394540644540227e-03*G0_2_1 - 1.878908128908114e-02*G0_2_2;
    block[1596] = 6.471794666239046e-01*G0_0_0 + 2.713978408422824e-01*G0_0_1 + 2.713978408422824e-01*G0_0_2 + 2.713978408422824e-01*G0_1_0 + 5.427956816845647e-01*G0_1_1 + 2.713978408422813e-01*G0_1_2 + 2.713978408422824e-01*G0_2_0 + 2.713978408422813e-01*G0_2_1 + 5.427956816845645e-01*G0_2_2;
    block[1597] = -2.681358475629282e-01*G0_0_0 + 2.250775362754544e-02*G0_0_1 + 1.807144276762317e-01*G0_0_2 - 4.599410523889642e-02*G0_1_0 - 2.348635161135043e-02*G0_1_1 + 8.122363265592421e-02*G0_1_2 - 7.372104811340850e-02*G0_2_0 - 1.047099842672743e-01*G0_2_1 - 2.094199685345505e-01*G0_2_2;
    block[1598] = 1.056885822510811e-01*G0_0_0 + 6.523986558714122e-04*G0_0_1 - 7.437344676927936e-02*G0_0_2 + 5.284429112554115e-02*G0_1_0 + 5.349668978141186e-02*G0_1_1 + 6.523986558710436e-04*G0_1_2 + 3.001033817006050e-02*G0_2_0 + 5.284429112554054e-02*G0_2_1 + 1.056885822510821e-01*G0_2_2;
    block[1599] = -2.681358475629290e-01*G0_0_0 + 1.807144276762312e-01*G0_0_1 + 2.250775362754502e-02*G0_0_2 - 7.372104811340917e-02*G0_1_0 - 2.094199685345506e-01*G0_1_1 - 1.047099842672748e-01*G0_1_2 - 4.599410523889701e-02*G0_2_0 + 8.122363265592354e-02*G0_2_1 - 2.348635161135114e-02*G0_2_2;
    block[1600] = 1.135173661215313e-01*G0_0_0 - 8.513802459114982e-02*G0_0_1 - 8.513802459114986e-02*G0_0_2 + 1.272177378948187e-02*G0_1_0 - 1.370037177328881e-02*G0_1_1 - 1.989815900406215e-02*G0_1_2 + 1.272177378948188e-02*G0_2_0 - 1.989815900406152e-02*G0_2_1 - 1.370037177328867e-02*G0_2_2;
    block[1601] = 1.056885822510809e-01*G0_0_0 - 7.437344676927943e-02*G0_0_1 + 6.523986558710992e-04*G0_0_2 + 3.001033817006030e-02*G0_1_0 + 1.056885822510816e-01*G0_1_1 + 5.284429112554086e-02*G0_1_2 + 5.284429112554070e-02*G0_2_0 + 6.523986558705128e-04*G0_2_1 + 5.349668978141116e-02*G0_2_2;
    block[1602] = -1.056885822510811e-01*G0_0_0 - 3.001033817006022e-02*G0_0_1 - 5.284429112554041e-02*G0_0_2 - 3.001033817006038e-02*G0_1_0 - 1.500516908503028e-02*G0_1_2 - 5.284429112554079e-02*G0_2_0 - 1.500516908502998e-02*G0_2_1;
    block[1603] = -1.135173661215313e-01*G0_0_0 - 1.272177378948153e-02*G0_0_1 - 1.272177378948165e-02*G0_0_2 - 1.272177378948195e-02*G0_1_0 - 6.523986558708663e-04*G0_1_2 - 1.272177378948193e-02*G0_2_0 - 6.523986558707762e-04*G0_2_1;
    block[1604] = -1.056885822510811e-01*G0_0_0 - 5.284429112554029e-02*G0_0_1 - 3.001033817006011e-02*G0_0_2 - 5.284429112554114e-02*G0_1_0 - 1.500516908503022e-02*G0_1_2 - 3.001033817006047e-02*G0_2_0 - 1.500516908503020e-02*G0_2_1;
    block[1605] = -2.544354757896395e-02*G0_0_0 - 1.304797311741636e-03*G0_0_1 - 1.272177378948230e-02*G0_0_2 - 1.304797311740782e-03*G0_1_0 - 6.523986558709097e-04*G0_1_2 - 1.272177378948190e-02*G0_2_0 - 6.523986558714307e-04*G0_2_1;
    block[1606] = -2.544354757896458e-02*G0_0_0 - 1.272177378948277e-02*G0_0_1 - 1.304797311741861e-03*G0_0_2 - 1.272177378948238e-02*G0_1_0 - 6.523986558709939e-04*G0_1_2 - 1.304797311741528e-03*G0_2_0 - 6.523986558708655e-04*G0_2_1;
    block[1607] = -6.002067634011994e-02*G0_0_0 - 3.001033817005984e-02*G0_0_1 - 3.001033817005984e-02*G0_0_2 - 3.001033817006007e-02*G0_1_0 - 1.500516908502996e-02*G0_1_2 - 3.001033817006014e-02*G0_2_0 - 1.500516908502932e-02*G0_2_1;
    block[1608] = 5.219189246966929e-02*G0_0_0 - 6.523986558716955e-04*G0_0_1 - 3.783912204051102e-02*G0_0_2 - 6.523986558707677e-04*G0_1_0 - 5.349668978141194e-02*G0_1_1 - 5.284429112554112e-02*G0_1_2 - 3.783912204051031e-02*G0_2_0 - 5.284429112554068e-02*G0_2_1;
    block[1609] = -1.565756774090090e-01*G0_0_0 - 2.250775362754523e-02*G0_0_1 + 6.784946021057102e-02*G0_0_2 - 2.250775362754532e-02*G0_1_0 + 2.348635161135067e-02*G0_1_1 + 1.047099842672756e-01*G0_1_2 + 6.784946021057001e-02*G0_2_0 + 1.047099842672747e-01*G0_2_1;
    block[1610] = 5.219189246967075e-02*G0_0_0 - 2.713978408422824e-01*G0_0_1 - 1.356989204211408e-01*G0_0_2 - 2.713978408422821e-01*G0_1_0 - 5.427956816845653e-01*G0_1_1 - 2.713978408422834e-01*G0_1_2 - 1.356989204211404e-01*G0_2_0 - 2.713978408422818e-01*G0_2_1;
    block[1611] = 3.914391935225198e-02*G0_0_0 + 2.642214556277049e-02*G0_0_1 - 5.545388574902389e-03*G0_0_2 + 2.642214556276994e-02*G0_1_0 + 1.370037177328811e-02*G0_1_1 - 6.197787230773127e-03*G0_1_2 - 5.545388574902279e-03*G0_2_0 - 6.197787230772972e-03*G0_2_1;
    block[1612] = 3.914391935225121e-02*G0_0_0 + 1.356989204211398e-01*G0_0_1 + 6.784946021056983e-02*G0_0_2 + 1.356989204211413e-01*G0_1_0 + 2.094199685345494e-01*G0_1_1 + 1.047099842672748e-01*G0_1_2 + 6.784946021057030e-02*G0_2_0 + 1.047099842672750e-01*G0_2_1;
    block[1613] = -4.566790591096059e-02*G0_0_0 - 7.567824408102058e-02*G0_0_1 - 3.783912204050999e-02*G0_0_2 - 7.567824408102096e-02*G0_1_0 - 1.056885822510818e-01*G0_1_1 - 5.284429112554051e-02*G0_1_2 - 3.783912204051020e-02*G0_2_0 - 5.284429112554098e-02*G0_2_1;
    block[1614] = -4.566790591096041e-02*G0_0_0 - 3.783912204050988e-02*G0_0_1 - 7.567824408102060e-02*G0_0_2 - 3.783912204051046e-02*G0_1_0 - 5.284429112554080e-02*G0_1_2 - 7.567824408102068e-02*G0_2_0 - 5.284429112554011e-02*G0_2_1 - 1.056885822510813e-01*G0_2_2;
    block[1615] = 3.914391935225110e-02*G0_0_0 + 6.784946021057033e-02*G0_0_1 + 1.356989204211402e-01*G0_0_2 + 6.784946021057062e-02*G0_1_0 + 1.047099842672749e-01*G0_1_2 + 1.356989204211409e-01*G0_2_0 + 1.047099842672751e-01*G0_2_1 + 2.094199685345500e-01*G0_2_2;
    block[1616] = 5.219189246967048e-02*G0_0_0 - 1.356989204211409e-01*G0_0_1 - 2.713978408422824e-01*G0_0_2 - 1.356989204211407e-01*G0_1_0 - 2.713978408422820e-01*G0_1_2 - 2.713978408422817e-01*G0_2_0 - 2.713978408422831e-01*G0_2_1 - 5.427956816845652e-01*G0_2_2;
    block[1617] = 3.914391935225259e-02*G0_0_0 - 5.545388574902487e-03*G0_0_1 + 2.642214556277100e-02*G0_0_2 - 5.545388574902035e-03*G0_1_0 - 6.197787230772078e-03*G0_1_2 + 2.642214556277036e-02*G0_2_0 - 6.197787230773556e-03*G0_2_1 + 1.370037177328875e-02*G0_2_2;
    block[1618] = -1.565756774090094e-01*G0_0_0 + 6.784946021057062e-02*G0_0_1 - 2.250775362754483e-02*G0_0_2 + 6.784946021057014e-02*G0_1_0 + 1.047099842672750e-01*G0_1_2 - 2.250775362754554e-02*G0_2_0 + 1.047099842672754e-01*G0_2_1 + 2.348635161135139e-02*G0_2_2;
    block[1619] = 5.219189246966938e-02*G0_0_0 - 3.783912204051081e-02*G0_0_1 - 6.523986558711987e-04*G0_0_2 - 3.783912204051084e-02*G0_1_0 - 5.284429112554086e-02*G0_1_2 - 6.523986558707240e-04*G0_2_0 - 5.284429112554073e-02*G0_2_1 - 5.349668978141135e-02*G0_2_2;
    block[1620] = 1.957195967612609e-01*G0_0_0 + 7.502584542514942e-02*G0_0_1 + 7.502584542514891e-02*G0_0_2 + 7.502584542514934e-02*G0_1_0 + 2.609594623483419e-02*G0_1_2 + 7.502584542515099e-02*G0_2_0 + 2.609594623483583e-02*G0_2_1;
    block[1621] = -7.828783870450458e-01*G0_0_0 - 3.164133480973711e-01*G0_0_1 - 3.164133480973719e-01*G0_0_2 - 3.164133480973718e-01*G0_1_0 - 1.859336169231983e-01*G0_1_2 - 3.164133480973731e-01*G0_2_0 - 1.859336169231978e-01*G0_2_1;
    block[1622] = 2.935793951418930e-01*G0_0_0 + 7.502584542515034e-02*G0_0_1 + 5.871587902837852e-02*G0_0_2 + 7.502584542514990e-02*G0_1_0 + 2.609594623483414e-02*G0_1_2 + 5.871587902837887e-02*G0_2_0 + 2.609594623483396e-02*G0_2_1;
    block[1623] = 2.935793951418929e-01*G0_0_0 + 5.871587902837969e-02*G0_0_1 + 7.502584542515137e-02*G0_0_2 + 5.871587902837897e-02*G0_1_0 + 2.609594623483568e-02*G0_1_2 + 7.502584542515024e-02*G0_2_0 + 2.609594623483463e-02*G0_2_1;
    block[1624] = -9.464999699374650e-03*G0_0_0 - 9.464999699374642e-03*G0_0_1 - 9.464999699374650e-03*G0_0_2 - 9.464999699374631e-03*G0_1_0 - 9.464999699374676e-03*G0_1_1 - 9.464999699374631e-03*G0_1_2 - 9.464999699374579e-03*G0_2_0 - 9.464999699374610e-03*G0_2_1 - 9.464999699374629e-03*G0_2_2;
    block[1625] = -3.457190957190934e-02*G0_0_0 - 4.724671065816841e-03*G0_1_0 - 4.724671065816877e-03*G0_2_0;
    block[1626] = -2.278176106301120e-03*G0_0_1 + 9.464999699374674e-03*G0_1_1 - 2.278176106301095e-03*G0_2_1;
    block[1627] = -4.724671065816948e-03*G0_0_2 - 4.724671065816899e-03*G0_1_2 - 3.457190957190934e-02*G0_2_2;
    block[1628] = 4.397166940569678e-02*G0_0_0 - 6.850185886645547e-04*G0_0_1 - 4.227543290043238e-02*G0_1_0 - 4.296045148909679e-02*G0_1_1 - 8.455086580086493e-02*G0_2_0 - 4.296045148909679e-02*G0_2_1;
    block[1629] = -4.364547007776150e-02*G0_0_0 - 3.389211017249179e-02*G0_0_1 - 6.491366625915258e-03*G0_1_0 - 3.522952741702943e-03*G0_1_1 - 8.083219346240139e-02*G0_2_0 - 1.082329370089784e-01*G0_2_1;
    block[1630] = -1.559232787531392e-02*G0_0_0 - 1.888694108746206e-02*G0_0_1 + 9.492400442921243e-03*G0_1_0 + 1.898480088584265e-02*G0_1_1 - 9.394540644540390e-03*G0_2_0 - 3.777388217492309e-02*G0_2_1;
    block[1631] = 2.544354757896425e-03*G0_0_0 + 8.448562593527954e-03*G0_0_1 - 3.294613212147779e-03*G0_1_0 - 2.926007971580861e-02*G0_1_1 + 2.544354757896198e-03*G0_2_0 + 1.428753056357188e-02*G0_2_1;
    block[1632] = -2.544354757896321e-03*G0_0_0 + 3.294613212148047e-03*G0_0_1 - 2.544354757896370e-03*G0_0_2 + 3.294613212147828e-03*G0_1_0 + 3.294613212147789e-03*G0_1_2 - 2.544354757896166e-03*G0_2_0 + 3.294613212148094e-03*G0_2_1 - 2.544354757896127e-03*G0_2_2;
    block[1633] = -1.050361835952133e-02*G0_0_0 + 2.576974690689698e-03*G0_0_1 - 1.050361835952127e-02*G0_0_2 + 2.576974690689920e-03*G0_1_0 + 2.576974690689941e-03*G0_1_2 - 1.050361835952138e-02*G0_2_0 + 2.576974690689829e-03*G0_2_1 - 1.050361835952137e-02*G0_2_2;
    block[1634] = 4.501550725509351e-03*G0_0_0 + 2.576974690690148e-03*G0_0_1 + 4.501550725509265e-03*G0_0_2 + 2.576974690690053e-03*G0_1_0 + 2.576974690690038e-03*G0_1_2 + 4.501550725509265e-03*G0_2_0 + 2.576974690689768e-03*G0_2_1 + 4.501550725509264e-03*G0_2_2;
    block[1635] = 6.589226424295626e-03*G0_0_0 + 3.294613212147798e-03*G0_0_1 + 6.589226424295645e-03*G0_0_2 + 3.294613212147844e-03*G0_1_0 + 3.294613212147848e-03*G0_1_2 + 6.589226424295766e-03*G0_2_0 + 3.294613212148056e-03*G0_2_1 + 6.589226424295837e-03*G0_2_2;
    block[1636] = 2.267085329151297e-02*G0_0_0 + 2.596546650366087e-02*G0_0_1 + 2.596546650366086e-02*G0_0_2 + 2.596546650366074e-02*G0_1_0 + 2.926007971580858e-02*G0_1_1 + 2.926007971580857e-02*G0_1_2 + 2.596546650366064e-02*G0_2_0 + 2.926007971580855e-02*G0_2_1 + 2.926007971580853e-02*G0_2_2;
    block[1637] = -6.523986558710425e-04*G0_0_0 - 9.492400442921121e-03*G0_0_1 - 9.492400442921115e-03*G0_0_2 - 9.492400442921173e-03*G0_1_0 - 1.898480088584247e-02*G0_1_1 - 1.898480088584253e-02*G0_1_2 - 9.492400442921047e-03*G0_2_0 - 1.898480088584230e-02*G0_2_1 - 1.898480088584228e-02*G0_2_2;
    block[1638] = -6.523986558708820e-04*G0_0_0 - 2.968413884212816e-03*G0_0_1 - 2.968413884212841e-03*G0_0_2 - 2.968413884212570e-03*G0_1_0 + 3.522952741702648e-03*G0_1_1 + 3.522952741702671e-03*G0_1_2 - 2.968413884212682e-03*G0_2_0 + 3.522952741702469e-03*G0_2_1 + 3.522952741702533e-03*G0_2_2;
    block[1639] = 2.267085329151293e-02*G0_0_0 + 6.850185886644838e-04*G0_0_1 + 6.850185886645669e-04*G0_0_2 + 6.850185886644324e-04*G0_1_0 + 4.296045148909664e-02*G0_1_1 + 4.296045148909670e-02*G0_1_2 + 6.850185886645184e-04*G0_2_0 + 4.296045148909688e-02*G0_2_1 + 4.296045148909679e-02*G0_2_2;
    block[1640] = 2.926007971580840e-02*G0_0_0 + 2.926007971580843e-02*G0_0_1 + 2.596546650366056e-02*G0_0_2 + 2.926007971580839e-02*G0_1_0 + 2.926007971580846e-02*G0_1_1 + 2.596546650366060e-02*G0_1_2 + 2.596546650366049e-02*G0_2_0 + 2.596546650366066e-02*G0_2_1 + 2.267085329151285e-02*G0_2_2;
    block[1641] = -1.898480088584265e-02*G0_0_0 - 1.898480088584265e-02*G0_0_1 - 9.492400442921017e-03*G0_0_2 - 1.898480088584205e-02*G0_1_0 - 1.898480088584206e-02*G0_1_1 - 9.492400442920851e-03*G0_1_2 - 9.492400442921352e-03*G0_2_0 - 9.492400442921448e-03*G0_2_1 - 6.523986558711809e-04*G0_2_2;
    block[1642] = 3.522952741702241e-03*G0_0_0 + 3.522952741702267e-03*G0_0_1 - 2.968413884212735e-03*G0_0_2 + 3.522952741702090e-03*G0_1_0 + 3.522952741702150e-03*G0_1_1 - 2.968413884212915e-03*G0_1_2 - 2.968413884212519e-03*G0_2_0 - 2.968413884212521e-03*G0_2_1 - 6.523986558706824e-04*G0_2_2;
    block[1643] = 4.296045148909734e-02*G0_0_0 + 4.296045148909740e-02*G0_0_1 + 6.850185886645957e-04*G0_0_2 + 4.296045148909746e-02*G0_1_0 + 4.296045148909746e-02*G0_1_1 + 6.850185886646009e-04*G0_1_2 + 6.850185886641705e-04*G0_2_0 + 6.850185886641410e-04*G0_2_1 + 2.267085329151287e-02*G0_2_2;
    block[1644] = 1.273155976932007e-01*G0_0_0 - 6.850185886646610e-04*G0_0_2 - 4.932133838383759e-02*G0_1_0 - 4.296045148909671e-02*G0_1_2 - 7.045905483405215e-03*G0_2_0 - 4.296045148909683e-02*G0_2_2;
    block[1645] = -1.669488160373561e-01*G0_0_0 - 6.165167297979415e-03*G0_0_2 + 1.677316944244012e-01*G0_1_0 + 7.770067991422100e-02*G0_1_2 + 8.386584721220060e-02*G0_2_0 + 1.824106641814961e-01*G0_2_2;
    block[1646] = 1.824106641814963e-01*G0_0_0 + 8.386584721220082e-02*G0_0_2 + 7.770067991422126e-02*G0_1_0 + 1.677316944244018e-01*G0_1_2 - 6.165167297979808e-03*G0_2_0 - 1.669488160373568e-01*G0_2_2;
    block[1647] = -4.296045148909739e-02*G0_0_0 - 7.045905483405809e-03*G0_0_2 - 4.296045148909738e-02*G0_1_0 - 4.932133838383847e-02*G0_1_2 - 6.850185886640096e-04*G0_2_0 + 1.273155976932014e-01*G0_2_2;
    block[1648] = 1.428753056357222e-02*G0_0_1 + 2.544354757896453e-03*G0_0_2 - 2.926007971580856e-02*G0_1_1 - 3.294613212147822e-03*G0_1_2 + 8.448562593527449e-03*G0_2_1 + 2.544354757896231e-03*G0_2_2;
    block[1649] = -3.777388217492386e-02*G0_0_1 - 9.394540644540620e-03*G0_0_2 + 1.898480088584237e-02*G0_1_1 + 9.492400442921139e-03*G0_1_2 - 1.888694108746114e-02*G0_2_1 - 1.559232787531373e-02*G0_2_2;
    block[1650] = -1.082329370089778e-01*G0_0_1 - 8.083219346240125e-02*G0_0_2 - 3.522952741702702e-03*G0_1_1 - 6.491366625915067e-03*G0_1_2 - 3.389211017249304e-02*G0_2_1 - 4.364547007776179e-02*G0_2_2;
    block[1651] = -4.296045148909740e-02*G0_0_1 - 8.455086580086538e-02*G0_0_2 - 4.296045148909752e-02*G0_1_1 - 4.227543290043312e-02*G0_1_2 - 6.850185886640969e-04*G0_2_1 + 4.397166940569691e-02*G0_2_2;
    block[1652] = -2.681358475629282e-01*G0_0_0 - 4.599410523889642e-02*G0_0_1 - 7.372104811340850e-02*G0_0_2 + 2.250775362754545e-02*G0_1_0 - 2.348635161135043e-02*G0_1_1 - 1.047099842672743e-01*G0_1_2 + 1.807144276762317e-01*G0_2_0 + 8.122363265592421e-02*G0_2_1 - 2.094199685345504e-01*G0_2_2;
    block[1653] = 7.261197039842824e-01*G0_0_0 + 2.700930435305419e-01*G0_0_1 + 2.700930435305419e-01*G0_0_2 + 2.700930435305419e-01*G0_1_0 + 5.401860870610831e-01*G0_1_1 + 2.700930435305414e-01*G0_1_2 + 2.700930435305419e-01*G0_2_0 + 2.700930435305413e-01*G0_2_1 + 7.261197039842832e-01*G0_2_2;
    block[1654] = -2.094199685345512e-01*G0_0_0 + 8.122363265592251e-02*G0_0_1 + 1.807144276762313e-01*G0_0_2 - 1.047099842672762e-01*G0_1_0 - 2.348635161135223e-02*G0_1_1 + 2.250775362754516e-02*G0_1_2 - 7.372104811340972e-02*G0_2_0 - 4.599410523889656e-02*G0_2_1 - 2.681358475629305e-01*G0_2_2;
    block[1655] = 6.556606491502269e-02*G0_0_0 + 2.789004253848023e-02*G0_0_1 - 7.486274576118293e-02*G0_0_2 - 7.486274576118321e-02*G0_1_0 - 1.497254915223661e-01*G0_1_1 - 2.837934153038344e-02*G0_1_2 + 2.789004253848025e-02*G0_2_0 + 1.771262350689423e-01*G0_2_1 - 1.497254915223654e-01*G0_2_2;
    block[1656] = -1.497254915223656e-01*G0_0_0 + 1.771262350689423e-01*G0_0_1 + 2.789004253847981e-02*G0_0_2 - 2.837934153038297e-02*G0_1_0 - 1.497254915223657e-01*G0_1_1 - 7.486274576118315e-02*G0_1_2 - 7.486274576118324e-02*G0_2_0 + 2.789004253847905e-02*G0_2_1 + 6.556606491502259e-02*G0_2_2;
    block[1657] = -1.370037177328821e-02*G0_0_0 - 8.513802459114941e-02*G0_0_1 - 1.989815900406167e-02*G0_0_2 + 1.272177378948237e-02*G0_1_0 + 1.135173661215323e-01*G0_1_1 + 1.272177378948265e-02*G0_1_2 - 1.989815900406202e-02*G0_2_0 - 8.513802459114929e-02*G0_2_1 - 1.370037177328856e-02*G0_2_2;
    block[1658] = 1.370037177328814e-02*G0_0_0 - 1.272177378948198e-02*G0_0_1 + 1.989815900406176e-02*G0_0_2 - 1.272177378948245e-02*G0_1_0 - 1.206937513361107e-02*G0_1_2 + 1.989815900406188e-02*G0_2_0 - 1.206937513361144e-02*G0_2_1 + 2.609594623483490e-02*G0_2_2;
    block[1659] = 1.497254915223657e-01*G0_0_0 + 2.837934153038254e-02*G0_0_1 + 7.486274576118246e-02*G0_0_2 + 2.837934153038310e-02*G0_1_0 + 1.418967076519119e-02*G0_1_2 + 7.486274576118342e-02*G0_2_0 + 1.418967076519142e-02*G0_2_1 + 1.957195967612631e-02*G0_2_2;
    block[1660] = 2.094199685345513e-01*G0_0_0 + 1.047099842672753e-01*G0_0_1 + 7.372104811340903e-02*G0_0_2 + 1.047099842672762e-01*G0_1_0 + 3.686052405670504e-02*G0_1_2 + 7.372104811340970e-02*G0_2_0 + 3.686052405670542e-02*G0_2_1 - 2.283395295548092e-02*G0_2_2;
    block[1661] = -1.663616572470707e-02*G0_0_0 - 1.810406270041692e-02*G0_0_1 + 1.467896975709480e-03*G0_0_2 - 1.810406270041622e-02*G0_1_0 - 1.027527882996627e-02*G0_1_2 + 1.467896975710067e-03*G0_2_0 - 1.027527882996579e-02*G0_2_1 + 1.957195967612651e-02*G0_2_2;
    block[1662] = 5.675868306076558e-02*G0_0_0 + 2.837934153038395e-02*G0_0_1 + 2.837934153038293e-02*G0_0_2 + 2.837934153038213e-02*G0_1_0 + 1.418967076519114e-02*G0_1_2 + 2.837934153038187e-02*G0_2_0 + 1.418967076519139e-02*G0_2_1 - 4.892989919031445e-03*G0_2_2;
    block[1663] = -2.544354757896438e-02*G0_0_0 - 1.272177378948180e-02*G0_0_1 - 2.413875026722235e-02*G0_0_2 - 1.272177378948240e-02*G0_1_0 - 1.206937513361113e-02*G0_1_2 - 2.413875026722203e-02*G0_2_0 - 1.206937513361101e-02*G0_2_1 - 2.283395295548077e-02*G0_2_2;
    block[1664] = -1.859336169231983e-01*G0_0_0 - 8.122363265592264e-02*G0_0_1 + 9.133581182192950e-03*G0_0_2 - 8.122363265592340e-02*G0_1_0 + 2.348635161135208e-02*G0_1_1 + 4.599410523889744e-02*G0_1_2 + 9.133581182192159e-03*G0_2_0 + 4.599410523889626e-02*G0_2_1 - 8.807381854256879e-02*G0_2_2;
    block[1665] = 9.296680846159820e-02*G0_0_0 - 2.700930435305418e-01*G0_0_1 - 1.350465217652715e-01*G0_0_2 - 2.700930435305416e-01*G0_1_0 - 5.401860870610827e-01*G0_1_1 - 2.700930435305415e-01*G0_1_2 - 1.350465217652707e-01*G0_2_0 - 2.700930435305412e-01*G0_2_1 + 9.296680846160028e-02*G0_2_2;
    block[1666] = -8.807381854256745e-02*G0_0_0 + 4.599410523889631e-02*G0_0_1 + 9.133581182192299e-03*G0_0_2 + 4.599410523889651e-02*G0_1_0 + 2.348635161135084e-02*G0_1_1 - 8.122363265592350e-02*G0_1_2 + 9.133581182192430e-03*G0_2_0 - 8.122363265592404e-02*G0_2_1 - 1.859336169231985e-01*G0_2_2;
    block[1667] = 9.296680846160035e-02*G0_0_0 + 1.213461499919823e-01*G0_0_1 + 6.067307499599110e-02*G0_0_2 + 1.213461499919824e-01*G0_1_0 + 1.497254915223644e-01*G0_1_1 + 7.486274576118232e-02*G0_1_2 + 6.067307499599155e-02*G0_2_0 + 7.486274576118238e-02*G0_2_1 + 1.957195967612687e-02*G0_2_2;
    block[1668] = 1.957195967612629e-02*G0_0_0 + 7.486274576118346e-02*G0_0_1 + 6.067307499599199e-02*G0_0_2 + 7.486274576118269e-02*G0_1_0 + 1.497254915223648e-01*G0_1_1 + 1.213461499919823e-01*G0_1_2 + 6.067307499599067e-02*G0_2_0 + 1.213461499919815e-01*G0_2_1 + 9.296680846159854e-02*G0_2_2;
    block[1669] = -8.807381854256788e-02*G0_0_0 - 1.007955923320505e-01*G0_0_1 - 8.872621719843918e-02*G0_0_2 - 1.007955923320500e-01*G0_1_0 - 1.135173661215322e-01*G0_1_1 - 1.007955923320497e-01*G0_1_2 - 8.872621719843839e-02*G0_2_0 - 1.007955923320496e-01*G0_2_1 - 8.807381854256767e-02*G0_2_2;
    block[1670] = -2.283395295548055e-02*G0_0_0 - 1.206937513361126e-02*G0_0_1 - 2.413875026722235e-02*G0_0_2 - 1.206937513361141e-02*G0_1_0 - 1.272177378948232e-02*G0_1_2 - 2.413875026722221e-02*G0_2_0 - 1.272177378948158e-02*G0_2_1 - 2.544354757896336e-02*G0_2_2;
    block[1671] = -4.892989919031436e-03*G0_0_0 + 1.418967076519148e-02*G0_0_1 + 2.837934153038322e-02*G0_0_2 + 1.418967076519156e-02*G0_1_0 + 2.837934153038234e-02*G0_1_2 + 2.837934153038276e-02*G0_2_0 + 2.837934153038260e-02*G0_2_1 + 5.675868306076530e-02*G0_2_2;
    block[1672] = -2.283395295548045e-02*G0_0_0 + 3.686052405670459e-02*G0_0_1 + 7.372104811340843e-02*G0_0_2 + 3.686052405670436e-02*G0_1_0 + 1.047099842672745e-01*G0_1_2 + 7.372104811340856e-02*G0_2_0 + 1.047099842672759e-01*G0_2_1 + 2.094199685345503e-01*G0_2_2;
    block[1673] = 1.957195967612580e-02*G0_0_0 - 1.027527882996613e-02*G0_0_1 + 1.467896975709376e-03*G0_0_2 - 1.027527882996613e-02*G0_1_0 - 1.810406270041606e-02*G0_1_2 + 1.467896975709667e-03*G0_2_0 - 1.810406270041660e-02*G0_2_1 - 1.663616572470682e-02*G0_2_2;
    block[1674] = 1.957195967612634e-02*G0_0_0 + 1.418967076519182e-02*G0_0_1 + 7.486274576118281e-02*G0_0_2 + 1.418967076519133e-02*G0_1_0 + 2.837934153038342e-02*G0_1_2 + 7.486274576118253e-02*G0_2_0 + 2.837934153038263e-02*G0_2_1 + 1.497254915223654e-01*G0_2_2;
    block[1675] = 2.609594623483523e-02*G0_0_0 - 1.206937513361133e-02*G0_0_1 + 1.989815900406174e-02*G0_0_2 - 1.206937513361119e-02*G0_1_0 - 1.272177378948253e-02*G0_1_2 + 1.989815900406177e-02*G0_2_0 - 1.272177378948220e-02*G0_2_1 + 1.370037177328857e-02*G0_2_2;
    block[1676] = 1.467896975709470e-01*G0_0_0 + 9.296680846160008e-02*G0_0_1 + 1.418967076519152e-01*G0_0_2 + 9.296680846159931e-02*G0_1_0 + 9.296680846159910e-02*G0_1_2 + 1.418967076519130e-01*G0_2_0 + 9.296680846159781e-02*G0_2_1 + 1.467896975709436e-01*G0_2_2;
    block[1677] = 1.467896975709450e-01*G0_0_0 - 1.027527882996635e-01*G0_0_1 - 2.984723850609251e-01*G0_0_2 - 1.027527882996626e-01*G0_1_0 - 2.984723850609239e-01*G0_1_2 - 2.984723850609228e-01*G0_2_0 - 2.984723850609239e-01*G0_2_1 - 7.828783870450481e-01*G0_2_2;
    block[1678] = -4.892989919031544e-02*G0_0_0 + 9.296680846159965e-02*G0_0_1 - 2.935793951418899e-02*G0_0_2 + 9.296680846159955e-02*G0_1_0 + 9.296680846159916e-02*G0_1_2 - 2.935793951419024e-02*G0_2_0 + 9.296680846160084e-02*G0_2_1 - 4.892989919031570e-02*G0_2_2;
    block[1679] = -7.828783870450478e-01*G0_0_0 - 2.984723850609244e-01*G0_0_1 - 2.984723850609243e-01*G0_0_2 - 2.984723850609243e-01*G0_1_0 - 1.027527882996618e-01*G0_1_2 - 2.984723850609238e-01*G0_2_0 - 1.027527882996610e-01*G0_2_1 + 1.467896975709500e-01*G0_2_2;
    block[1680] = -1.374212528726396e-02*G0_0_0 - 1.374212528726398e-02*G0_0_1 - 1.374212528726400e-02*G0_0_2 - 1.374212528726408e-02*G0_1_0 - 1.374212528726406e-02*G0_1_1 - 1.374212528726411e-02*G0_1_2 - 1.374212528726404e-02*G0_2_0 - 1.374212528726403e-02*G0_2_1 - 1.374212528726401e-02*G0_2_2;
    block[1681] = 1.374212528726409e-02*G0_0_0 - 5.177435732991272e-03*G0_1_0 - 5.177435732991223e-03*G0_2_0;
    block[1682] = -5.177435732991189e-03*G0_0_1 + 1.374212528726405e-02*G0_1_1 - 5.177435732991186e-03*G0_2_1;
    block[1683] = 1.439452394313499e-02*G0_0_2 + 1.439452394313489e-02*G0_1_2 + 4.799305472048494e-02*G0_2_2;
    block[1684] = -1.878908128908080e-02*G0_0_0 - 9.394540644540303e-03*G0_0_1 + 2.126819618139025e-02*G0_1_0 + 1.187365553684970e-02*G0_1_1 + 4.253639236278100e-02*G0_2_0 + 1.187365553685001e-02*G0_2_1;
    block[1685] = 1.487468935385585e-02*G0_0_0 + 1.493992921944284e-02*G0_0_1 + 1.239557446154779e-03*G0_1_0 + 1.174317580567772e-03*G0_1_1 + 4.031823693281996e-02*G0_2_0 + 5.401860870610831e-02*G0_2_1;
    block[1686] = 1.174317580567627e-03*G0_0_0 + 1.239557446155053e-03*G0_0_1 + 1.493992921944286e-02*G0_1_0 + 1.487468935385558e-02*G0_1_1 + 5.401860870610831e-02*G0_2_0 + 4.031823693282014e-02*G0_2_1;
    block[1687] = 1.187365553684981e-02*G0_0_0 + 2.126819618139003e-02*G0_0_1 - 9.394540644540502e-03*G0_1_0 - 1.878908128908112e-02*G0_1_1 + 1.187365553685004e-02*G0_2_0 + 4.253639236278079e-02*G0_2_1;
    block[1688] = -1.187365553684980e-02*G0_0_0 + 9.394540644540270e-03*G0_0_1 - 1.187365553684977e-02*G0_0_2 + 9.394540644540520e-03*G0_1_0 + 9.394540644540482e-03*G0_1_2 - 1.187365553685000e-02*G0_2_0 + 9.394540644540355e-03*G0_2_1 - 1.187365553685003e-02*G0_2_2;
    block[1689] = -1.174317580567362e-03*G0_0_0 + 6.523986558743845e-05*G0_0_1 - 1.174317580567396e-03*G0_0_2 + 6.523986558726392e-05*G0_1_0 + 6.523986558724358e-05*G0_1_2 - 1.174317580567441e-03*G0_2_0 + 6.523986558713557e-05*G0_2_1 - 1.174317580567446e-03*G0_2_2;
    block[1690] = -1.487468935385566e-02*G0_0_0 + 6.523986558696722e-05*G0_0_1 - 1.487468935385563e-02*G0_0_2 + 6.523986558717541e-05*G0_1_0 + 6.523986558721854e-05*G0_1_2 - 1.487468935385558e-02*G0_2_0 + 6.523986558730491e-05*G0_2_1 - 1.487468935385564e-02*G0_2_2;
    block[1691] = 1.878908128908105e-02*G0_0_0 + 9.394540644540669e-03*G0_0_1 + 1.878908128908106e-02*G0_0_2 + 9.394540644540603e-03*G0_1_0 + 9.394540644540521e-03*G0_1_2 + 1.878908128908074e-02*G0_2_0 + 9.394540644540447e-03*G0_2_1 + 1.878908128908071e-02*G0_2_2;
    block[1692] = 9.394540644540574e-03*G0_0_1 + 9.394540644540487e-03*G0_0_2 + 9.394540644540806e-03*G0_1_0 + 1.878908128908123e-02*G0_1_1 + 1.878908128908116e-02*G0_1_2 + 9.394540644540712e-03*G0_2_0 + 1.878908128908107e-02*G0_2_1 + 1.878908128908097e-02*G0_2_2;
    block[1693] = 6.523986558701755e-05*G0_0_1 + 6.523986558705036e-05*G0_0_2 + 6.523986558693704e-05*G0_1_0 - 1.487468935385577e-02*G0_1_1 - 1.487468935385573e-02*G0_1_2 + 6.523986558690393e-05*G0_2_0 - 1.487468935385587e-02*G0_2_1 - 1.487468935385587e-02*G0_2_2;
    block[1694] = 6.523986558720023e-05*G0_0_1 + 6.523986558722542e-05*G0_0_2 + 6.523986558709549e-05*G0_1_0 - 1.174317580567553e-03*G0_1_1 - 1.174317580567574e-03*G0_1_2 + 6.523986558721393e-05*G0_2_0 - 1.174317580567674e-03*G0_2_1 - 1.174317580567718e-03*G0_2_2;
    block[1695] = 9.394540644540412e-03*G0_0_1 + 9.394540644540369e-03*G0_0_2 + 9.394540644540587e-03*G0_1_0 - 1.187365553684978e-02*G0_1_1 - 1.187365553684967e-02*G0_1_2 + 9.394540644540528e-03*G0_2_0 - 1.187365553685007e-02*G0_2_1 - 1.187365553685000e-02*G0_2_2;
    block[1696] = 6.413078787210660e-02*G0_0_0 + 6.413078787210663e-02*G0_0_1 + 5.473624722756622e-02*G0_0_2 + 6.413078787210681e-02*G0_1_0 + 6.413078787210671e-02*G0_1_1 + 5.473624722756640e-02*G0_1_2 + 5.473624722756589e-02*G0_2_0 + 5.473624722756584e-02*G0_2_1 + 4.534170658302549e-02*G0_2_2;
    block[1697] = -1.270872581636458e-01*G0_0_0 - 1.270872581636458e-01*G0_0_1 - 8.931337598872255e-02*G0_0_2 - 1.270872581636462e-01*G0_1_0 - 1.270872581636460e-01*G0_1_1 - 8.931337598872267e-02*G0_1_2 - 8.931337598872188e-02*G0_2_0 - 8.931337598872185e-02*G0_2_1 - 6.654466289882861e-02*G0_2_2;
    block[1698] = 1.247386230025110e-01*G0_0_0 + 1.247386230025109e-01*G0_0_1 + 6.236931150125540e-02*G0_0_2 + 1.247386230025111e-01*G0_1_0 + 1.247386230025110e-01*G0_1_1 + 6.236931150125542e-02*G0_1_2 + 6.236931150125477e-02*G0_2_0 + 6.236931150125474e-02*G0_2_1 + 4.762510187857328e-02*G0_2_2;
    block[1699] = -1.247386230025112e-01*G0_0_0 - 1.247386230025112e-01*G0_0_1 - 2.844458139596994e-02*G0_0_2 - 1.247386230025111e-01*G0_1_0 - 1.247386230025111e-01*G0_1_1 - 2.844458139596991e-02*G0_1_2 - 2.844458139596939e-02*G0_2_0 - 2.844458139596935e-02*G0_2_1 - 6.067307499599106e-02*G0_2_2;
    block[1700] = -6.413078787210663e-02*G0_0_0 - 9.394540644540220e-03*G0_0_2 + 4.775558160974774e-02*G0_1_0 + 1.187365553684977e-02*G0_1_2 + 2.648738542835753e-02*G0_2_0 + 1.187365553685002e-02*G0_2_2;
    block[1701] = 1.270872581636459e-01*G0_0_0 + 3.777388217492322e-02*G0_0_2 - 8.233271037090387e-02*G0_1_0 + 1.826716236438599e-03*G0_1_2 - 4.638554443241916e-02*G0_2_0 - 5.101757488910248e-02*G0_2_2;
    block[1702] = -1.247386230025110e-01*G0_0_0 - 6.236931150125519e-02*G0_0_2 + 1.466592178397720e-01*G0_1_0 + 1.096029741863044e-02*G0_1_2 + 7.332960891988662e-02*G0_2_0 + 1.323064474106139e-01*G0_2_2;
    block[1703] = 1.247386230025112e-01*G0_0_0 + 9.629404160654094e-02*G0_0_2 + 1.247386230025111e-01*G0_1_0 + 1.925880832130819e-01*G0_1_2 + 2.844458139596931e-02*G0_2_0 - 6.445698720004317e-02*G0_2_2;
    block[1704] = 4.775558160974749e-02*G0_0_1 + 1.187365553684983e-02*G0_0_2 - 6.413078787210671e-02*G0_1_1 - 9.394540644540400e-03*G0_1_2 + 2.648738542835743e-02*G0_2_1 + 1.187365553684999e-02*G0_2_2;
    block[1705] = -8.233271037090366e-02*G0_0_1 + 1.826716236438325e-03*G0_0_2 + 1.270872581636462e-01*G0_1_1 + 3.777388217492339e-02*G0_1_2 - 4.638554443241952e-02*G0_2_1 - 5.101757488910274e-02*G0_2_2;
    block[1706] = 1.466592178397719e-01*G0_0_1 + 1.096029741863082e-02*G0_0_2 - 1.247386230025108e-01*G0_1_1 - 6.236931150125515e-02*G0_1_2 + 7.332960891988685e-02*G0_2_1 + 1.323064474106136e-01*G0_2_2;
    block[1707] = 1.247386230025112e-01*G0_0_1 + 1.925880832130820e-01*G0_0_2 + 1.247386230025112e-01*G0_1_1 + 9.629404160654118e-02*G0_1_2 + 2.844458139596937e-02*G0_2_1 - 6.445698720004291e-02*G0_2_2;
    block[1708] = 1.056885822510810e-01*G0_0_0 + 5.284429112554115e-02*G0_0_1 + 3.001033817006050e-02*G0_0_2 + 6.523986558714081e-04*G0_1_0 + 5.349668978141186e-02*G0_1_1 + 5.284429112554054e-02*G0_1_2 - 7.437344676927934e-02*G0_2_0 + 6.523986558710470e-04*G0_2_1 + 1.056885822510821e-01*G0_2_2;
    block[1709] = -2.094199685345512e-01*G0_0_0 - 1.047099842672762e-01*G0_0_1 - 7.372104811340974e-02*G0_0_2 + 8.122363265592251e-02*G0_1_0 - 2.348635161135223e-02*G0_1_1 - 4.599410523889656e-02*G0_1_2 + 1.807144276762313e-01*G0_2_0 + 2.250775362754515e-02*G0_2_1 - 2.681358475629305e-01*G0_2_2;
    block[1710] = 5.427956816845667e-01*G0_0_0 + 2.713978408422837e-01*G0_0_1 + 2.713978408422827e-01*G0_0_2 + 2.713978408422836e-01*G0_1_0 + 5.427956816845659e-01*G0_1_1 + 2.713978408422822e-01*G0_1_2 + 2.713978408422827e-01*G0_2_0 + 2.713978408422822e-01*G0_2_1 + 6.471794666239068e-01*G0_2_2;
    block[1711] = -1.370037177328851e-02*G0_0_0 - 1.989815900406234e-02*G0_0_1 + 1.272177378948201e-02*G0_0_2 - 1.989815900406263e-02*G0_1_0 - 1.370037177328889e-02*G0_1_1 + 1.272177378948151e-02*G0_1_2 - 8.513802459114961e-02*G0_2_0 - 8.513802459114993e-02*G0_2_1 + 1.135173661215316e-01*G0_2_2;
    block[1712] = -2.348635161135118e-02*G0_0_0 + 8.122363265592361e-02*G0_0_1 - 4.599410523889627e-02*G0_0_2 - 1.047099842672746e-01*G0_1_0 - 2.094199685345497e-01*G0_1_1 - 7.372104811340813e-02*G0_1_2 + 2.250775362754539e-02*G0_2_0 + 1.807144276762319e-01*G0_2_1 - 2.681358475629294e-01*G0_2_2;
    block[1713] = 5.349668978141094e-02*G0_0_0 + 6.523986558707504e-04*G0_0_1 + 5.284429112554016e-02*G0_0_2 + 5.284429112554091e-02*G0_1_0 + 1.056885822510813e-01*G0_1_1 + 3.001033817005991e-02*G0_1_2 + 6.523986558704924e-04*G0_2_0 - 7.437344676927961e-02*G0_2_1 + 1.056885822510814e-01*G0_2_2;
    block[1714] = -5.349668978141087e-02*G0_0_0 - 5.284429112554034e-02*G0_0_1 - 6.523986558710512e-04*G0_0_2 - 5.284429112554083e-02*G0_1_0 - 3.783912204051094e-02*G0_1_2 - 6.523986558704576e-04*G0_2_0 - 3.783912204051021e-02*G0_2_1 + 5.219189246967023e-02*G0_2_2;
    block[1715] = 2.348635161135113e-02*G0_0_0 + 1.047099842672753e-01*G0_0_1 - 2.250775362754442e-02*G0_0_2 + 1.047099842672744e-01*G0_1_0 + 6.784946021057096e-02*G0_1_2 - 2.250775362754552e-02*G0_2_0 + 6.784946021057092e-02*G0_2_1 - 1.565756774090098e-01*G0_2_2;
    block[1716] = -5.427956816845667e-01*G0_0_0 - 2.713978408422829e-01*G0_0_1 - 2.713978408422838e-01*G0_0_2 - 2.713978408422834e-01*G0_1_0 - 1.356989204211423e-01*G0_1_2 - 2.713978408422826e-01*G0_2_0 - 1.356989204211417e-01*G0_2_1 + 5.219189246967121e-02*G0_2_2;
    block[1717] = 1.370037177328812e-02*G0_0_0 - 6.197787230773668e-03*G0_0_1 + 2.642214556276969e-02*G0_0_2 - 6.197787230772916e-03*G0_1_0 - 5.545388574902731e-03*G0_1_2 + 2.642214556276991e-02*G0_2_0 - 5.545388574902925e-03*G0_2_1 + 3.914391935225167e-02*G0_2_2;
    block[1718] = 2.094199685345496e-01*G0_0_0 + 1.047099842672742e-01*G0_0_1 + 1.356989204211415e-01*G0_0_2 + 1.047099842672751e-01*G0_1_0 + 6.784946021057130e-02*G0_1_2 + 1.356989204211410e-01*G0_2_0 + 6.784946021057037e-02*G0_2_1 + 3.914391935225128e-02*G0_2_2;
    block[1719] = -1.056885822510808e-01*G0_0_0 - 5.284429112554031e-02*G0_0_1 - 7.567824408102110e-02*G0_0_2 - 5.284429112554093e-02*G0_1_0 - 3.783912204051083e-02*G0_1_2 - 7.567824408102103e-02*G0_2_0 - 3.783912204051021e-02*G0_2_1 - 4.566790591096025e-02*G0_2_2;
    block[1720] = -2.713978408422834e-01*G0_0_1 - 1.356989204211423e-01*G0_0_2 - 2.713978408422829e-01*G0_1_0 - 5.427956816845657e-01*G0_1_1 - 2.713978408422841e-01*G0_1_2 - 1.356989204211412e-01*G0_2_0 - 2.713978408422821e-01*G0_2_1 + 5.219189246967115e-02*G0_2_2;
    block[1721] = 1.047099842672760e-01*G0_0_1 + 6.784946021057106e-02*G0_0_2 + 1.047099842672750e-01*G0_1_0 + 2.348635161135210e-02*G0_1_1 - 2.250775362754430e-02*G0_1_2 + 6.784946021057012e-02*G0_2_0 - 2.250775362754505e-02*G0_2_1 - 1.565756774090107e-01*G0_2_2;
    block[1722] = -5.284429112554111e-02*G0_0_1 - 3.783912204051067e-02*G0_0_2 - 5.284429112554087e-02*G0_1_0 - 5.349668978141186e-02*G0_1_1 - 6.523986558714887e-04*G0_1_2 - 3.783912204051063e-02*G0_2_0 - 6.523986558711318e-04*G0_2_1 + 5.219189246967012e-02*G0_2_2;
    block[1723] = 1.047099842672752e-01*G0_0_1 + 6.784946021057141e-02*G0_0_2 + 1.047099842672750e-01*G0_1_0 + 2.094199685345502e-01*G0_1_1 + 1.356989204211426e-01*G0_1_2 + 6.784946021057082e-02*G0_2_0 + 1.356989204211416e-01*G0_2_1 + 3.914391935225175e-02*G0_2_2;
    block[1724] = -6.197787230773379e-03*G0_0_1 - 5.545388574902677e-03*G0_0_2 - 6.197787230772819e-03*G0_1_0 + 1.370037177328856e-02*G0_1_1 + 2.642214556277026e-02*G0_1_2 - 5.545388574902168e-03*G0_2_0 + 2.642214556277057e-02*G0_2_1 + 3.914391935225297e-02*G0_2_2;
    block[1725] = -5.284429112554032e-02*G0_0_1 - 3.783912204051060e-02*G0_0_2 - 5.284429112554094e-02*G0_1_0 - 1.056885822510816e-01*G0_1_1 - 7.567824408102178e-02*G0_1_2 - 3.783912204051065e-02*G0_2_0 - 7.567824408102151e-02*G0_2_1 - 4.566790591096090e-02*G0_2_2;
    block[1726] = -1.500516908502966e-02*G0_0_1 - 3.001033817005953e-02*G0_0_2 - 1.500516908502984e-02*G0_1_0 - 3.001033817005986e-02*G0_1_2 - 3.001033817005982e-02*G0_2_0 - 3.001033817006016e-02*G0_2_1 - 6.002067634012046e-02*G0_2_2;
    block[1727] = -6.523986558709231e-04*G0_0_1 - 1.304797311742117e-03*G0_0_2 - 6.523986558709217e-04*G0_1_0 - 1.272177378948192e-02*G0_1_2 - 1.304797311742032e-03*G0_2_0 - 1.272177378948215e-02*G0_2_1 - 2.544354757896454e-02*G0_2_2;
    block[1728] = -1.500516908503011e-02*G0_0_1 - 3.001033817006058e-02*G0_0_2 - 1.500516908503004e-02*G0_1_0 - 5.284429112554059e-02*G0_1_2 - 3.001033817005989e-02*G0_2_0 - 5.284429112554070e-02*G0_2_1 - 1.056885822510820e-01*G0_2_2;
    block[1729] = -6.523986558711930e-04*G0_0_1 - 1.272177378948184e-02*G0_0_2 - 6.523986558711457e-04*G0_1_0 - 1.304797311741431e-03*G0_1_2 - 1.272177378948251e-02*G0_2_0 - 1.304797311741764e-03*G0_2_1 - 2.544354757896422e-02*G0_2_2;
    block[1730] = -6.523986558709901e-04*G0_0_1 - 1.272177378948197e-02*G0_0_2 - 6.523986558708212e-04*G0_1_0 - 1.272177378948156e-02*G0_1_2 - 1.272177378948186e-02*G0_2_0 - 1.272177378948168e-02*G0_2_1 - 1.135173661215316e-01*G0_2_2;
    block[1731] = -1.500516908502984e-02*G0_0_1 - 5.284429112554018e-02*G0_0_2 - 1.500516908503008e-02*G0_1_0 - 3.001033817005995e-02*G0_1_2 - 5.284429112554081e-02*G0_2_0 - 3.001033817005999e-02*G0_2_1 - 1.056885822510813e-01*G0_2_2;
    block[1732] = 2.609594623483421e-02*G0_0_1 + 7.502584542514906e-02*G0_0_2 + 2.609594623483546e-02*G0_1_0 + 7.502584542515012e-02*G0_1_2 + 7.502584542515145e-02*G0_2_0 + 7.502584542515171e-02*G0_2_1 + 1.957195967612634e-01*G0_2_2;
    block[1733] = 2.609594623483534e-02*G0_0_1 + 7.502584542515189e-02*G0_0_2 + 2.609594623483414e-02*G0_1_0 + 5.871587902837866e-02*G0_1_2 + 7.502584542514892e-02*G0_2_0 + 5.871587902837918e-02*G0_2_1 + 2.935793951418950e-01*G0_2_2;
    block[1734] = 2.609594623483558e-02*G0_0_1 + 5.871587902837827e-02*G0_0_2 + 2.609594623483562e-02*G0_1_0 + 7.502584542514995e-02*G0_1_2 + 5.871587902837981e-02*G0_2_0 + 7.502584542514952e-02*G0_2_1 + 2.935793951418935e-01*G0_2_2;
    block[1735] = -1.859336169231987e-01*G0_0_1 - 3.164133480973723e-01*G0_0_2 - 1.859336169231978e-01*G0_1_0 - 3.164133480973724e-01*G0_1_2 - 3.164133480973723e-01*G0_2_0 - 3.164133480973738e-01*G0_2_1 - 7.828783870450494e-01*G0_2_2;
    block[1736] = -9.464999699374520e-03*G0_0_0 - 9.464999699374541e-03*G0_0_1 - 9.464999699374534e-03*G0_0_2 - 9.464999699374459e-03*G0_1_0 - 9.464999699374428e-03*G0_1_1 - 9.464999699374463e-03*G0_1_2 - 9.464999699374537e-03*G0_2_0 - 9.464999699374548e-03*G0_2_1 - 9.464999699374499e-03*G0_2_2;
    block[1737] = -3.457190957190929e-02*G0_0_0 - 4.724671065816807e-03*G0_1_0 - 4.724671065816795e-03*G0_2_0;
    block[1738] = -4.724671065816876e-03*G0_0_1 - 3.457190957190925e-02*G0_1_1 - 4.724671065816763e-03*G0_2_1;
    block[1739] = -2.278176106301052e-03*G0_0_2 - 2.278176106301054e-03*G0_1_2 + 9.464999699374688e-03*G0_2_2;
    block[1740] = 1.273155976932005e-01*G0_0_0 - 6.850185886644575e-04*G0_0_1 - 7.045905483405425e-03*G0_1_0 - 4.296045148909680e-02*G0_1_1 - 4.932133838383793e-02*G0_2_0 - 4.296045148909686e-02*G0_2_1;
    block[1741] = -1.669488160373563e-01*G0_0_0 - 6.165167297979819e-03*G0_0_1 + 8.386584721220051e-02*G0_1_0 + 1.824106641814956e-01*G0_1_1 + 1.677316944244009e-01*G0_2_0 + 7.770067991422071e-02*G0_2_1;
    block[1742] = 1.824106641814955e-01*G0_0_0 + 8.386584721220015e-02*G0_0_1 - 6.165167297980225e-03*G0_1_0 - 1.669488160373567e-01*G0_1_1 + 7.770067991422067e-02*G0_2_0 + 1.677316944244008e-01*G0_2_1;
    block[1743] = -4.296045148909666e-02*G0_0_0 - 7.045905483405049e-03*G0_0_1 - 6.850185886640506e-04*G0_1_0 + 1.273155976932011e-01*G0_1_1 - 4.296045148909652e-02*G0_2_0 - 4.932133838383760e-02*G0_2_1;
    block[1744] = 4.296045148909660e-02*G0_0_0 + 6.850185886644990e-04*G0_0_1 + 4.296045148909669e-02*G0_0_2 + 6.850185886640742e-04*G0_1_0 + 2.267085329151261e-02*G0_1_1 + 6.850185886641150e-04*G0_1_2 + 4.296045148909653e-02*G0_2_0 + 6.850185886642298e-04*G0_2_1 + 4.296045148909655e-02*G0_2_2;
    block[1745] = 3.522952741702800e-03*G0_0_0 - 2.968413884212618e-03*G0_0_1 + 3.522952741702653e-03*G0_0_2 - 2.968413884212435e-03*G0_1_0 - 6.523986558707380e-04*G0_1_1 - 2.968413884212362e-03*G0_1_2 + 3.522952741703040e-03*G0_2_0 - 2.968413884212292e-03*G0_2_1 + 3.522952741703044e-03*G0_2_2;
    block[1746] = -1.898480088584236e-02*G0_0_0 - 9.492400442920884e-03*G0_0_1 - 1.898480088584240e-02*G0_0_2 - 9.492400442921137e-03*G0_1_0 - 6.523986558707518e-04*G0_1_1 - 9.492400442921271e-03*G0_1_2 - 1.898480088584246e-02*G0_2_0 - 9.492400442921057e-03*G0_2_1 - 1.898480088584258e-02*G0_2_2;
    block[1747] = 2.926007971580835e-02*G0_0_0 + 2.596546650366044e-02*G0_0_1 + 2.926007971580840e-02*G0_0_2 + 2.596546650366043e-02*G0_1_0 + 2.267085329151254e-02*G0_1_1 + 2.596546650366049e-02*G0_1_2 + 2.926007971580832e-02*G0_2_0 + 2.596546650366049e-02*G0_2_1 + 2.926007971580838e-02*G0_2_2;
    block[1748] = 2.267085329151260e-02*G0_0_0 + 2.596546650366057e-02*G0_0_1 + 2.596546650366056e-02*G0_0_2 + 2.596546650366031e-02*G0_1_0 + 2.926007971580831e-02*G0_1_1 + 2.926007971580825e-02*G0_1_2 + 2.596546650366043e-02*G0_2_0 + 2.926007971580835e-02*G0_2_1 + 2.926007971580830e-02*G0_2_2;
    block[1749] = -6.523986558708285e-04*G0_0_0 - 9.492400442920993e-03*G0_0_1 - 9.492400442921017e-03*G0_0_2 - 9.492400442920853e-03*G0_1_0 - 1.898480088584198e-02*G0_1_1 - 1.898480088584190e-02*G0_1_2 - 9.492400442921012e-03*G0_2_0 - 1.898480088584214e-02*G0_2_1 - 1.898480088584216e-02*G0_2_2;
    block[1750] = -6.523986558707946e-04*G0_0_0 - 2.968413884212526e-03*G0_0_1 - 2.968413884212441e-03*G0_0_2 - 2.968413884212643e-03*G0_1_0 + 3.522952741702120e-03*G0_1_1 + 3.522952741702140e-03*G0_1_2 - 2.968413884212409e-03*G0_2_0 + 3.522952741702555e-03*G0_2_1 + 3.522952741702593e-03*G0_2_2;
    block[1751] = 2.267085329151276e-02*G0_0_0 + 6.850185886644789e-04*G0_0_1 + 6.850185886644447e-04*G0_0_2 + 6.850185886644727e-04*G0_1_0 + 4.296045148909685e-02*G0_1_1 + 4.296045148909678e-02*G0_1_2 + 6.850185886643043e-04*G0_2_0 + 4.296045148909678e-02*G0_2_1 + 4.296045148909676e-02*G0_2_2;
    block[1752] = 6.589226424295386e-03*G0_0_0 + 6.589226424295494e-03*G0_0_1 + 3.294613212147600e-03*G0_0_2 + 6.589226424295618e-03*G0_1_0 + 6.589226424295637e-03*G0_1_1 + 3.294613212147701e-03*G0_1_2 + 3.294613212147730e-03*G0_2_0 + 3.294613212147732e-03*G0_2_1;
    block[1753] = 4.501550725509028e-03*G0_0_0 + 4.501550725508985e-03*G0_0_1 + 2.576974690690199e-03*G0_0_2 + 4.501550725509052e-03*G0_1_0 + 4.501550725508979e-03*G0_1_1 + 2.576974690689958e-03*G0_1_2 + 2.576974690690100e-03*G0_2_0 + 2.576974690690088e-03*G0_2_1;
    block[1754] = -1.050361835952121e-02*G0_0_0 - 1.050361835952123e-02*G0_0_1 + 2.576974690689899e-03*G0_0_2 - 1.050361835952133e-02*G0_1_0 - 1.050361835952133e-02*G0_1_1 + 2.576974690689981e-03*G0_1_2 + 2.576974690689909e-03*G0_2_0 + 2.576974690689893e-03*G0_2_1;
    block[1755] = -2.544354757896431e-03*G0_0_0 - 2.544354757896394e-03*G0_0_1 + 3.294613212147832e-03*G0_0_2 - 2.544354757896319e-03*G0_1_0 - 2.544354757896344e-03*G0_1_1 + 3.294613212147907e-03*G0_1_2 + 3.294613212147928e-03*G0_2_0 + 3.294613212147915e-03*G0_2_1;
    block[1756] = 4.397166940569660e-02*G0_0_0 - 6.850185886645216e-04*G0_0_2 - 8.455086580086517e-02*G0_1_0 - 4.296045148909682e-02*G0_1_2 - 4.227543290043254e-02*G0_2_0 - 4.296045148909681e-02*G0_2_2;
    block[1757] = -4.364547007776139e-02*G0_0_0 - 3.389211017249195e-02*G0_0_2 - 8.083219346240159e-02*G0_1_0 - 1.082329370089784e-01*G0_1_2 - 6.491366625915139e-03*G0_2_0 - 3.522952741702954e-03*G0_2_2;
    block[1758] = -1.559232787531436e-02*G0_0_0 - 1.888694108746219e-02*G0_0_2 - 9.394540644540589e-03*G0_1_0 - 3.777388217492352e-02*G0_1_2 + 9.492400442920946e-03*G0_2_0 + 1.898480088584244e-02*G0_2_2;
    block[1759] = 2.544354757896458e-03*G0_0_0 + 8.448562593527737e-03*G0_0_2 + 2.544354757896427e-03*G0_1_0 + 1.428753056357206e-02*G0_1_2 - 3.294613212147890e-03*G0_2_0 - 2.926007971580879e-02*G0_2_2;
    block[1760] = -8.455086580086452e-02*G0_0_1 - 4.296045148909654e-02*G0_0_2 + 4.397166940569693e-02*G0_1_1 - 6.850185886640984e-04*G0_1_2 - 4.227543290043228e-02*G0_2_1 - 4.296045148909659e-02*G0_2_2;
    block[1761] = -8.083219346240153e-02*G0_0_1 - 1.082329370089782e-01*G0_0_2 - 4.364547007776166e-02*G0_1_1 - 3.389211017249247e-02*G0_1_2 - 6.491366625915432e-03*G0_2_1 - 3.522952741703271e-03*G0_2_2;
    block[1762] = -9.394540644540351e-03*G0_0_1 - 3.777388217492319e-02*G0_0_2 - 1.559232787531417e-02*G0_1_1 - 1.888694108746165e-02*G0_1_2 + 9.492400442921418e-03*G0_2_1 + 1.898480088584283e-02*G0_2_2;
    block[1763] = 2.544354757896426e-03*G0_0_1 + 1.428753056357202e-02*G0_0_2 + 2.544354757896389e-03*G0_1_1 + 8.448562593527565e-03*G0_1_2 - 3.294613212147929e-03*G0_2_1 - 2.926007971580876e-02*G0_2_2;
    block[1764] = -2.681358475629290e-01*G0_0_0 - 7.372104811340917e-02*G0_0_1 - 4.599410523889701e-02*G0_0_2 + 1.807144276762312e-01*G0_1_0 - 2.094199685345506e-01*G0_1_1 + 8.122363265592353e-02*G0_1_2 + 2.250775362754502e-02*G0_2_0 - 1.047099842672748e-01*G0_2_1 - 2.348635161135115e-02*G0_2_2;
    block[1765] = 6.556606491502269e-02*G0_0_0 - 7.486274576118321e-02*G0_0_1 + 2.789004253848023e-02*G0_0_2 + 2.789004253848024e-02*G0_1_0 - 1.497254915223662e-01*G0_1_1 + 1.771262350689423e-01*G0_1_2 - 7.486274576118293e-02*G0_2_0 - 2.837934153038344e-02*G0_2_1 - 1.497254915223654e-01*G0_2_2;
    block[1766] = -1.370037177328851e-02*G0_0_0 - 1.989815900406263e-02*G0_0_1 - 8.513802459114961e-02*G0_0_2 - 1.989815900406234e-02*G0_1_0 - 1.370037177328889e-02*G0_1_1 - 8.513802459114994e-02*G0_1_2 + 1.272177378948201e-02*G0_2_0 + 1.272177378948150e-02*G0_2_1 + 1.135173661215316e-01*G0_2_2;
    block[1767] = 7.261197039842816e-01*G0_0_0 + 2.700930435305418e-01*G0_0_1 + 2.700930435305407e-01*G0_0_2 + 2.700930435305416e-01*G0_1_0 + 7.261197039842822e-01*G0_1_1 + 2.700930435305405e-01*G0_1_2 + 2.700930435305406e-01*G0_2_0 + 2.700930435305405e-01*G0_2_1 + 5.401860870610805e-01*G0_2_2;
    block[1768] = -1.497254915223648e-01*G0_0_0 + 2.789004253848132e-02*G0_0_1 + 1.771262350689429e-01*G0_0_2 - 7.486274576118311e-02*G0_1_0 + 6.556606491502354e-02*G0_1_1 + 2.789004253848016e-02*G0_1_2 - 2.837934153038265e-02*G0_2_0 - 7.486274576118193e-02*G0_2_1 - 1.497254915223649e-01*G0_2_2;
    block[1769] = -2.094199685345501e-01*G0_0_0 + 1.807144276762307e-01*G0_0_1 + 8.122363265592333e-02*G0_0_2 - 7.372104811340922e-02*G0_1_0 - 2.681358475629305e-01*G0_1_1 - 4.599410523889707e-02*G0_1_2 - 1.047099842672750e-01*G0_2_0 + 2.250775362754482e-02*G0_2_1 - 2.348635161135101e-02*G0_2_2;
    block[1770] = 2.094199685345501e-01*G0_0_0 + 7.372104811340795e-02*G0_0_1 + 1.047099842672753e-01*G0_0_2 + 7.372104811340913e-02*G0_1_0 - 2.283395295548083e-02*G0_1_1 + 3.686052405670497e-02*G0_1_2 + 1.047099842672750e-01*G0_2_0 + 3.686052405670386e-02*G0_2_1;
    block[1771] = 1.497254915223651e-01*G0_0_0 + 7.486274576118275e-02*G0_0_1 + 2.837934153038202e-02*G0_0_2 + 7.486274576118329e-02*G0_1_0 + 1.957195967612638e-02*G0_1_1 + 1.418967076519140e-02*G0_1_2 + 2.837934153038271e-02*G0_2_0 + 1.418967076519172e-02*G0_2_1;
    block[1772] = 1.370037177328834e-02*G0_0_0 + 1.989815900406145e-02*G0_0_1 - 1.272177378948157e-02*G0_0_2 + 1.989815900406220e-02*G0_1_0 + 2.609594623483521e-02*G0_1_1 - 1.206937513361083e-02*G0_1_2 - 1.272177378948213e-02*G0_2_0 - 1.206937513361142e-02*G0_2_1;
    block[1773] = 5.675868306076644e-02*G0_0_0 + 2.837934153038331e-02*G0_0_1 + 2.837934153038340e-02*G0_0_2 + 2.837934153038249e-02*G0_1_0 - 4.892989919031318e-03*G0_1_1 + 1.418967076519155e-02*G0_1_2 + 2.837934153038317e-02*G0_2_0 + 1.418967076519182e-02*G0_2_1;
    block[1774] = -1.663616572470735e-02*G0_0_0 + 1.467896975709817e-03*G0_0_1 - 1.810406270041685e-02*G0_0_2 + 1.467896975709207e-03*G0_1_0 + 1.957195967612656e-02*G0_1_1 - 1.027527882996621e-02*G0_1_2 - 1.810406270041671e-02*G0_2_0 - 1.027527882996627e-02*G0_2_1;
    block[1775] = -2.544354757896430e-02*G0_0_0 - 2.413875026722217e-02*G0_0_1 - 1.272177378948183e-02*G0_0_2 - 2.413875026722222e-02*G0_1_0 - 2.283395295548061e-02*G0_1_1 - 1.206937513361089e-02*G0_1_2 - 1.272177378948247e-02*G0_2_0 - 1.206937513361128e-02*G0_2_1;
    block[1776] = 2.609594623483541e-02*G0_0_0 + 1.989815900406251e-02*G0_0_1 - 1.206937513361093e-02*G0_0_2 + 1.989815900406177e-02*G0_1_0 + 1.370037177328848e-02*G0_1_1 - 1.272177378948201e-02*G0_1_2 - 1.206937513361097e-02*G0_2_0 - 1.272177378948162e-02*G0_2_1;
    block[1777] = 1.957195967612614e-02*G0_0_0 + 7.486274576118331e-02*G0_0_1 + 1.418967076519170e-02*G0_0_2 + 7.486274576118239e-02*G0_1_0 + 1.497254915223662e-01*G0_1_1 + 2.837934153038252e-02*G0_1_2 + 1.418967076519138e-02*G0_2_0 + 2.837934153038343e-02*G0_2_1;
    block[1778] = -2.283395295548052e-02*G0_0_0 + 7.372104811340904e-02*G0_0_1 + 3.686052405670448e-02*G0_0_2 + 7.372104811340925e-02*G0_1_0 + 2.094199685345507e-01*G0_1_1 + 1.047099842672763e-01*G0_1_2 + 3.686052405670459e-02*G0_2_0 + 1.047099842672751e-01*G0_2_1;
    block[1779] = 1.957195967612640e-02*G0_0_0 + 1.467896975709166e-03*G0_0_1 - 1.027527882996614e-02*G0_0_2 + 1.467896975710237e-03*G0_1_0 - 1.663616572470657e-02*G0_1_1 - 1.810406270041682e-02*G0_1_2 - 1.027527882996621e-02*G0_2_0 - 1.810406270041648e-02*G0_2_1;
    block[1780] = -4.892989919031560e-03*G0_0_0 + 2.837934153038324e-02*G0_0_1 + 1.418967076519159e-02*G0_0_2 + 2.837934153038188e-02*G0_1_0 + 5.675868306076536e-02*G0_1_1 + 2.837934153038288e-02*G0_1_2 + 1.418967076519102e-02*G0_2_0 + 2.837934153038232e-02*G0_2_1;
    block[1781] = -2.283395295548003e-02*G0_0_0 - 2.413875026722243e-02*G0_0_1 - 1.206937513361107e-02*G0_0_2 - 2.413875026722165e-02*G0_1_0 - 2.544354757896329e-02*G0_1_1 - 1.272177378948153e-02*G0_1_2 - 1.206937513361085e-02*G0_2_0 - 1.272177378948203e-02*G0_2_1;
    block[1782] = -8.807381854256720e-02*G0_0_0 - 8.872621719843850e-02*G0_0_1 - 1.007955923320496e-01*G0_0_2 - 8.872621719843772e-02*G0_1_0 - 8.807381854256727e-02*G0_1_1 - 1.007955923320489e-01*G0_1_2 - 1.007955923320489e-01*G0_2_0 - 1.007955923320493e-01*G0_2_1 - 1.135173661215313e-01*G0_2_2;
    block[1783] = 1.957195967612594e-02*G0_0_0 + 6.067307499599097e-02*G0_0_1 + 7.486274576118278e-02*G0_0_2 + 6.067307499598987e-02*G0_1_0 + 9.296680846159887e-02*G0_1_1 + 1.213461499919811e-01*G0_1_2 + 7.486274576118131e-02*G0_2_0 + 1.213461499919816e-01*G0_2_1 + 1.497254915223641e-01*G0_2_2;
    block[1784] = -8.807381854256777e-02*G0_0_0 + 9.133581182192287e-03*G0_0_1 + 4.599410523889690e-02*G0_0_2 + 9.133581182192686e-03*G0_1_0 - 1.859336169231978e-01*G0_1_1 - 8.122363265592335e-02*G0_1_2 + 4.599410523889700e-02*G0_2_0 - 8.122363265592328e-02*G0_2_1 + 2.348635161135158e-02*G0_2_2;
    block[1785] = 9.296680846159906e-02*G0_0_0 + 6.067307499599108e-02*G0_0_1 + 1.213461499919821e-01*G0_0_2 + 6.067307499599068e-02*G0_1_0 + 1.957195967612554e-02*G0_1_1 + 7.486274576118181e-02*G0_1_2 + 1.213461499919819e-01*G0_2_0 + 7.486274576118229e-02*G0_2_1 + 1.497254915223650e-01*G0_2_2;
    block[1786] = 9.296680846159980e-02*G0_0_0 - 1.350465217652700e-01*G0_0_1 - 2.700930435305407e-01*G0_0_2 - 1.350465217652699e-01*G0_1_0 + 9.296680846160003e-02*G0_1_1 - 2.700930435305406e-01*G0_1_2 - 2.700930435305403e-01*G0_2_0 - 2.700930435305402e-01*G0_2_1 - 5.401860870610806e-01*G0_2_2;
    block[1787] = -1.859336169231981e-01*G0_0_0 + 9.133581182191821e-03*G0_0_1 - 8.122363265592336e-02*G0_0_2 + 9.133581182192744e-03*G0_1_0 - 8.807381854256773e-02*G0_1_1 + 4.599410523889696e-02*G0_1_2 - 8.122363265592361e-02*G0_2_0 + 4.599410523889613e-02*G0_2_1 + 2.348635161135109e-02*G0_2_2;
    block[1788] = 1.467896975709460e-01*G0_0_0 + 1.418967076519151e-01*G0_0_1 + 9.296680846159909e-02*G0_0_2 + 1.418967076519145e-01*G0_1_0 + 1.467896975709449e-01*G0_1_1 + 9.296680846159867e-02*G0_1_2 + 9.296680846160003e-02*G0_2_0 + 9.296680846160020e-02*G0_2_1;
    block[1789] = 1.467896975709474e-01*G0_0_0 - 2.984723850609245e-01*G0_0_1 - 1.027527882996628e-01*G0_0_2 - 2.984723850609234e-01*G0_1_0 - 7.828783870450476e-01*G0_1_1 - 2.984723850609239e-01*G0_1_2 - 1.027527882996625e-01*G0_2_0 - 2.984723850609233e-01*G0_2_1;
    block[1790] = -7.828783870450484e-01*G0_0_0 - 2.984723850609238e-01*G0_0_1 - 2.984723850609250e-01*G0_0_2 - 2.984723850609243e-01*G0_1_0 + 1.467896975709484e-01*G0_1_1 - 1.027527882996622e-01*G0_1_2 - 2.984723850609242e-01*G0_2_0 - 1.027527882996627e-01*G0_2_1;
    block[1791] = -4.892989919031474e-02*G0_0_0 - 2.935793951419013e-02*G0_0_1 + 9.296680846160012e-02*G0_0_2 - 2.935793951418905e-02*G0_1_0 - 4.892989919031612e-02*G0_1_1 + 9.296680846160020e-02*G0_1_2 + 9.296680846159994e-02*G0_2_0 + 9.296680846159863e-02*G0_2_1;
    block[1792] = -9.464999699374596e-03*G0_0_0 - 9.464999699374581e-03*G0_0_1 - 9.464999699374584e-03*G0_0_2 - 9.464999699374518e-03*G0_1_0 - 9.464999699374504e-03*G0_1_1 - 9.464999699374522e-03*G0_1_2 - 9.464999699374595e-03*G0_2_0 - 9.464999699374579e-03*G0_2_1 - 9.464999699374640e-03*G0_2_2;
    block[1793] = 9.464999699374671e-03*G0_0_0 - 2.278176106301061e-03*G0_1_0 - 2.278176106301072e-03*G0_2_0;
    block[1794] = -4.724671065816697e-03*G0_0_1 - 3.457190957190930e-02*G0_1_1 - 4.724671065816878e-03*G0_2_1;
    block[1795] = -4.724671065816814e-03*G0_0_2 - 4.724671065816774e-03*G0_1_2 - 3.457190957190936e-02*G0_2_2;
    block[1796] = -2.926007971580859e-02*G0_0_0 - 3.294613212147739e-03*G0_0_1 + 8.448562593528290e-03*G0_1_0 + 2.544354757896797e-03*G0_1_1 + 1.428753056357239e-02*G0_2_0 + 2.544354757896621e-03*G0_2_1;
    block[1797] = 1.898480088584235e-02*G0_0_0 + 9.492400442920932e-03*G0_0_1 - 1.888694108746215e-02*G0_1_0 - 1.559232787531427e-02*G0_1_1 - 3.777388217492373e-02*G0_2_0 - 9.394540644540671e-03*G0_2_1;
    block[1798] = -3.522952741702523e-03*G0_0_0 - 6.491366625914684e-03*G0_0_1 - 3.389211017249151e-02*G0_1_0 - 4.364547007776082e-02*G0_1_1 - 1.082329370089776e-01*G0_2_0 - 8.083219346240102e-02*G0_2_1;
    block[1799] = -4.296045148909677e-02*G0_0_0 - 4.227543290043267e-02*G0_0_1 - 6.850185886646698e-04*G0_1_0 + 4.397166940569644e-02*G0_1_1 - 4.296045148909704e-02*G0_2_0 - 8.455086580086513e-02*G0_2_1;
    block[1800] = 4.296045148909678e-02*G0_0_0 + 6.850185886641550e-04*G0_0_1 + 4.296045148909673e-02*G0_0_2 + 6.850185886647049e-04*G0_1_0 + 2.267085329151269e-02*G0_1_1 + 6.850185886647393e-04*G0_1_2 + 4.296045148909704e-02*G0_2_0 + 6.850185886643881e-04*G0_2_1 + 4.296045148909700e-02*G0_2_2;
    block[1801] = 3.522952741702878e-03*G0_0_0 - 2.968413884212313e-03*G0_0_1 + 3.522952741702987e-03*G0_0_2 - 2.968413884212612e-03*G0_1_0 - 6.523986558708112e-04*G0_1_1 - 2.968413884212549e-03*G0_1_2 + 3.522952741702947e-03*G0_2_0 - 2.968413884212379e-03*G0_2_1 + 3.522952741703056e-03*G0_2_2;
    block[1802] = -1.898480088584233e-02*G0_0_0 - 9.492400442921226e-03*G0_0_1 - 1.898480088584236e-02*G0_0_2 - 9.492400442920729e-03*G0_1_0 - 6.523986558706425e-04*G0_1_1 - 9.492400442920825e-03*G0_1_2 - 1.898480088584251e-02*G0_2_0 - 9.492400442921219e-03*G0_2_1 - 1.898480088584247e-02*G0_2_2;
    block[1803] = 2.926007971580866e-02*G0_0_0 + 2.596546650366068e-02*G0_0_1 + 2.926007971580865e-02*G0_0_2 + 2.596546650366045e-02*G0_1_0 + 2.267085329151255e-02*G0_1_1 + 2.596546650366053e-02*G0_1_2 + 2.926007971580874e-02*G0_2_0 + 2.596546650366070e-02*G0_2_1 + 2.926007971580874e-02*G0_2_2;
    block[1804] = 3.294613212147778e-03*G0_0_1 + 3.294613212147848e-03*G0_0_2 + 3.294613212147829e-03*G0_1_0 + 6.589226424295784e-03*G0_1_1 + 6.589226424295799e-03*G0_1_2 + 3.294613212147861e-03*G0_2_0 + 6.589226424295751e-03*G0_2_1 + 6.589226424295862e-03*G0_2_2;
    block[1805] = 2.576974690689968e-03*G0_0_1 + 2.576974690689925e-03*G0_0_2 + 2.576974690689882e-03*G0_1_0 + 4.501550725509000e-03*G0_1_1 + 4.501550725508997e-03*G0_1_2 + 2.576974690689978e-03*G0_2_0 + 4.501550725508945e-03*G0_2_1 + 4.501550725508969e-03*G0_2_2;
    block[1806] = 2.576974690689917e-03*G0_0_1 + 2.576974690689888e-03*G0_0_2 + 2.576974690689966e-03*G0_1_0 - 1.050361835952123e-02*G0_1_1 - 1.050361835952123e-02*G0_1_2 + 2.576974690689867e-03*G0_2_0 - 1.050361835952117e-02*G0_2_1 - 1.050361835952116e-02*G0_2_2;
    block[1807] = 3.294613212147736e-03*G0_0_1 + 3.294613212147757e-03*G0_0_2 + 3.294613212147965e-03*G0_1_0 - 2.544354757896611e-03*G0_1_1 - 2.544354757896677e-03*G0_1_2 + 3.294613212147993e-03*G0_2_0 - 2.544354757896556e-03*G0_2_1 - 2.544354757896561e-03*G0_2_2;
    block[1808] = 2.926007971580863e-02*G0_0_0 + 2.926007971580854e-02*G0_0_1 + 2.596546650366062e-02*G0_0_2 + 2.926007971580835e-02*G0_1_0 + 2.926007971580839e-02*G0_1_1 + 2.596546650366042e-02*G0_1_2 + 2.596546650366074e-02*G0_2_0 + 2.596546650366067e-02*G0_2_1 + 2.267085329151278e-02*G0_2_2;
    block[1809] = -1.898480088584235e-02*G0_0_0 - 1.898480088584233e-02*G0_0_1 - 9.492400442921066e-03*G0_0_2 - 1.898480088584232e-02*G0_1_0 - 1.898480088584237e-02*G0_1_1 - 9.492400442920991e-03*G0_1_2 - 9.492400442921451e-03*G0_2_0 - 9.492400442921380e-03*G0_2_1 - 6.523986558711549e-04*G0_2_2;
    block[1810] = 3.522952741702965e-03*G0_0_0 + 3.522952741703011e-03*G0_0_1 - 2.968413884212673e-03*G0_0_2 + 3.522952741702722e-03*G0_1_0 + 3.522952741702742e-03*G0_1_1 - 2.968413884212635e-03*G0_1_2 - 2.968413884212184e-03*G0_2_0 - 2.968413884212189e-03*G0_2_1 - 6.523986558706614e-04*G0_2_2;
    block[1811] = 4.296045148909668e-02*G0_0_0 + 4.296045148909667e-02*G0_0_1 + 6.850185886644446e-04*G0_0_2 + 4.296045148909666e-02*G0_1_0 + 4.296045148909672e-02*G0_1_1 + 6.850185886644107e-04*G0_1_2 + 6.850185886639930e-04*G0_2_0 + 6.850185886639932e-04*G0_2_1 + 2.267085329151283e-02*G0_2_2;
    block[1812] = -2.926007971580862e-02*G0_0_0 - 3.294613212147710e-03*G0_0_2 + 1.428753056357216e-02*G0_1_0 + 2.544354757896657e-03*G0_1_2 + 8.448562593527794e-03*G0_2_0 + 2.544354757896610e-03*G0_2_2;
    block[1813] = 1.898480088584247e-02*G0_0_0 + 9.492400442920899e-03*G0_0_2 - 3.777388217492369e-02*G0_1_0 - 9.394540644541061e-03*G0_1_2 - 1.888694108746185e-02*G0_2_0 - 1.559232787531451e-02*G0_2_2;
    block[1814] = -3.522952741702863e-03*G0_0_0 - 6.491366625914962e-03*G0_0_2 - 1.082329370089779e-01*G0_1_0 - 8.083219346240074e-02*G0_1_2 - 3.389211017249217e-02*G0_2_0 - 4.364547007776120e-02*G0_2_2;
    block[1815] = -4.296045148909670e-02*G0_0_0 - 4.227543290043250e-02*G0_0_2 - 4.296045148909670e-02*G0_1_0 - 8.455086580086514e-02*G0_1_2 - 6.850185886639892e-04*G0_2_0 + 4.397166940569698e-02*G0_2_2;
    block[1816] = -4.932133838383839e-02*G0_0_1 - 4.296045148909689e-02*G0_0_2 + 1.273155976932002e-01*G0_1_1 - 6.850185886647530e-04*G0_1_2 - 7.045905483405550e-03*G0_2_1 - 4.296045148909706e-02*G0_2_2;
    block[1817] = 1.677316944244017e-01*G0_0_1 + 7.770067991422065e-02*G0_0_2 - 1.669488160373561e-01*G0_1_1 - 6.165167297979859e-03*G0_1_2 + 8.386584721220083e-02*G0_2_1 + 1.824106641814962e-01*G0_2_2;
    block[1818] = 7.770067991422062e-02*G0_0_1 + 1.677316944244014e-01*G0_0_2 + 1.824106641814954e-01*G0_1_1 + 8.386584721220013e-02*G0_1_2 - 6.165167297980303e-03*G0_2_1 - 1.669488160373571e-01*G0_2_2;
    block[1819] = -4.296045148909672e-02*G0_0_1 - 4.932133838383781e-02*G0_0_2 - 4.296045148909663e-02*G0_1_1 - 7.045905483405215e-03*G0_1_2 - 6.850185886639748e-04*G0_2_1 + 1.273155976932015e-01*G0_2_2;
    block[1820] = 1.135173661215313e-01*G0_0_0 + 1.272177378948187e-02*G0_0_1 + 1.272177378948188e-02*G0_0_2 - 8.513802459114982e-02*G0_1_0 - 1.370037177328881e-02*G0_1_1 - 1.989815900406152e-02*G0_1_2 - 8.513802459114986e-02*G0_2_0 - 1.989815900406215e-02*G0_2_1 - 1.370037177328867e-02*G0_2_2;
    block[1821] = -1.497254915223656e-01*G0_0_0 - 2.837934153038297e-02*G0_0_1 - 7.486274576118322e-02*G0_0_2 + 1.771262350689423e-01*G0_1_0 - 1.497254915223656e-01*G0_1_1 + 2.789004253847904e-02*G0_1_2 + 2.789004253847981e-02*G0_2_0 - 7.486274576118314e-02*G0_2_1 + 6.556606491502255e-02*G0_2_2;
    block[1822] = -2.348635161135117e-02*G0_0_0 - 1.047099842672746e-01*G0_0_1 + 2.250775362754538e-02*G0_0_2 + 8.122363265592361e-02*G0_1_0 - 2.094199685345497e-01*G0_1_1 + 1.807144276762319e-01*G0_1_2 - 4.599410523889627e-02*G0_2_0 - 7.372104811340814e-02*G0_2_1 - 2.681358475629295e-01*G0_2_2;
    block[1823] = -1.497254915223648e-01*G0_0_0 - 7.486274576118311e-02*G0_0_1 - 2.837934153038265e-02*G0_0_2 + 2.789004253848131e-02*G0_1_0 + 6.556606491502352e-02*G0_1_1 - 7.486274576118193e-02*G0_1_2 + 1.771262350689429e-01*G0_2_0 + 2.789004253848016e-02*G0_2_1 - 1.497254915223649e-01*G0_2_2;
    block[1824] = 5.401860870610822e-01*G0_0_0 + 2.700930435305404e-01*G0_0_1 + 2.700930435305409e-01*G0_0_2 + 2.700930435305405e-01*G0_1_0 + 7.261197039842814e-01*G0_1_1 + 2.700930435305413e-01*G0_1_2 + 2.700930435305409e-01*G0_2_0 + 2.700930435305413e-01*G0_2_1 + 7.261197039842823e-01*G0_2_2;
    block[1825] = -2.348635161135182e-02*G0_0_0 + 2.250775362754577e-02*G0_0_1 - 1.047099842672746e-01*G0_0_2 - 4.599410523889799e-02*G0_1_0 - 2.681358475629296e-01*G0_1_1 - 7.372104811340939e-02*G0_1_2 + 8.122363265592362e-02*G0_2_0 + 1.807144276762319e-01*G0_2_1 - 2.094199685345503e-01*G0_2_2;
    block[1826] = 2.348635161135165e-02*G0_0_0 + 4.599410523889745e-02*G0_0_1 - 8.122363265592326e-02*G0_0_2 + 4.599410523889788e-02*G0_1_0 - 8.807381854256677e-02*G0_1_1 + 9.133581182192600e-03*G0_1_2 - 8.122363265592379e-02*G0_2_0 + 9.133581182192563e-03*G0_2_1 - 1.859336169231992e-01*G0_2_2;
    block[1827] = -5.401860870610825e-01*G0_0_0 - 2.700930435305411e-01*G0_0_1 - 2.700930435305406e-01*G0_0_2 - 2.700930435305405e-01*G0_1_0 + 9.296680846160003e-02*G0_1_1 - 1.350465217652695e-01*G0_1_2 - 2.700930435305408e-01*G0_2_0 - 1.350465217652705e-01*G0_2_1 + 9.296680846160095e-02*G0_2_2;
    block[1828] = 2.348635161135105e-02*G0_0_0 - 8.122363265592367e-02*G0_0_1 + 4.599410523889582e-02*G0_0_2 - 8.122363265592369e-02*G0_1_0 - 1.859336169231985e-01*G0_1_1 + 9.133581182191947e-03*G0_1_2 + 4.599410523889617e-02*G0_2_0 + 9.133581182192374e-03*G0_2_1 - 8.807381854256954e-02*G0_2_2;
    block[1829] = 1.497254915223644e-01*G0_0_0 + 7.486274576118172e-02*G0_0_1 + 1.213461499919812e-01*G0_0_2 + 7.486274576118121e-02*G0_1_0 + 1.957195967612504e-02*G0_1_1 + 6.067307499599019e-02*G0_1_2 + 1.213461499919819e-01*G0_2_0 + 6.067307499599095e-02*G0_2_1 + 9.296680846159870e-02*G0_2_2;
    block[1830] = 1.497254915223656e-01*G0_0_0 + 1.213461499919819e-01*G0_0_1 + 7.486274576118315e-02*G0_0_2 + 1.213461499919818e-01*G0_1_0 + 9.296680846159884e-02*G0_1_1 + 6.067307499599077e-02*G0_1_2 + 7.486274576118297e-02*G0_2_0 + 6.067307499599112e-02*G0_2_1 + 1.957195967612719e-02*G0_2_2;
    block[1831] = -1.135173661215316e-01*G0_0_0 - 1.007955923320493e-01*G0_0_1 - 1.007955923320496e-01*G0_0_2 - 1.007955923320488e-01*G0_1_0 - 8.807381854256696e-02*G0_1_1 - 8.872621719843816e-02*G0_1_2 - 1.007955923320497e-01*G0_2_0 - 8.872621719843853e-02*G0_2_1 - 8.807381854256789e-02*G0_2_2;
    block[1832] = 1.047099842672746e-01*G0_0_1 + 3.686052405670399e-02*G0_0_2 + 1.047099842672752e-01*G0_1_0 + 2.094199685345500e-01*G0_1_1 + 7.372104811340870e-02*G0_1_2 + 3.686052405670428e-02*G0_2_0 + 7.372104811340817e-02*G0_2_1 - 2.283395295548101e-02*G0_2_2;
    block[1833] = 2.837934153038312e-02*G0_0_1 + 1.418967076519146e-02*G0_0_2 + 2.837934153038279e-02*G0_1_0 + 1.497254915223658e-01*G0_1_1 + 7.486274576118179e-02*G0_1_2 + 1.418967076519231e-02*G0_2_0 + 7.486274576118321e-02*G0_2_1 + 1.957195967612618e-02*G0_2_2;
    block[1834] = -1.272177378948183e-02*G0_0_1 - 1.206937513361089e-02*G0_0_2 - 1.272177378948207e-02*G0_1_0 + 1.370037177328856e-02*G0_1_1 + 1.989815900406238e-02*G0_1_2 - 1.206937513361138e-02*G0_2_0 + 1.989815900406211e-02*G0_2_1 + 2.609594623483543e-02*G0_2_2;
    block[1835] = 2.837934153038314e-02*G0_0_1 + 1.418967076519157e-02*G0_0_2 + 2.837934153038321e-02*G0_1_0 + 5.675868306076633e-02*G0_1_1 + 2.837934153038277e-02*G0_1_2 + 1.418967076519106e-02*G0_2_0 + 2.837934153038265e-02*G0_2_1 - 4.892989919031573e-03*G0_2_2;
    block[1836] = -1.810406270041732e-02*G0_0_1 - 1.027527882996648e-02*G0_0_2 - 1.810406270041698e-02*G0_1_0 - 1.663616572470697e-02*G0_1_1 + 1.467896975709773e-03*G0_1_2 - 1.027527882996619e-02*G0_2_0 + 1.467896975709404e-03*G0_2_1 + 1.957195967612618e-02*G0_2_2;
    block[1837] = -1.272177378948188e-02*G0_0_1 - 1.206937513361094e-02*G0_0_2 - 1.272177378948149e-02*G0_1_0 - 2.544354757896358e-02*G0_1_1 - 2.413875026722197e-02*G0_1_2 - 1.206937513361106e-02*G0_2_0 - 2.413875026722198e-02*G0_2_1 - 2.283395295548043e-02*G0_2_2;
    block[1838] = -1.206937513361119e-02*G0_0_1 - 1.272177378948216e-02*G0_0_2 - 1.206937513361099e-02*G0_1_0 - 2.283395295548037e-02*G0_1_1 - 2.413875026722191e-02*G0_1_2 - 1.272177378948224e-02*G0_2_0 - 2.413875026722236e-02*G0_2_1 - 2.544354757896425e-02*G0_2_2;
    block[1839] = -1.027527882996606e-02*G0_0_1 - 1.810406270041687e-02*G0_0_2 - 1.027527882996619e-02*G0_1_0 + 1.957195967612643e-02*G0_1_1 + 1.467896975709642e-03*G0_1_2 - 1.810406270041620e-02*G0_2_0 + 1.467896975709949e-03*G0_2_1 - 1.663616572470680e-02*G0_2_2;
    block[1840] = -1.206937513361096e-02*G0_0_1 - 1.272177378948200e-02*G0_0_2 - 1.206937513361158e-02*G0_1_0 + 2.609594623483526e-02*G0_1_1 + 1.989815900406133e-02*G0_1_2 - 1.272177378948268e-02*G0_2_0 + 1.989815900406181e-02*G0_2_1 + 1.370037177328840e-02*G0_2_2;
    block[1841] = 1.418967076519153e-02*G0_0_1 + 2.837934153038314e-02*G0_0_2 + 1.418967076519112e-02*G0_1_0 - 4.892989919032031e-03*G0_1_1 + 2.837934153038240e-02*G0_1_2 + 2.837934153038316e-02*G0_2_0 + 2.837934153038334e-02*G0_2_1 + 5.675868306076642e-02*G0_2_2;
    block[1842] = 1.418967076519096e-02*G0_0_1 + 2.837934153038284e-02*G0_0_2 + 1.418967076519177e-02*G0_1_0 + 1.957195967612569e-02*G0_1_1 + 7.486274576118206e-02*G0_1_2 + 2.837934153038307e-02*G0_2_0 + 7.486274576118213e-02*G0_2_1 + 1.497254915223651e-01*G0_2_2;
    block[1843] = 3.686052405670444e-02*G0_0_1 + 1.047099842672745e-01*G0_0_2 + 3.686052405670420e-02*G0_1_0 - 2.283395295547977e-02*G0_1_1 + 7.372104811340931e-02*G0_1_2 + 1.047099842672748e-01*G0_2_0 + 7.372104811340843e-02*G0_2_1 + 2.094199685345501e-01*G0_2_2;
    block[1844] = 9.296680846159885e-02*G0_0_1 + 9.296680846159878e-02*G0_0_2 + 9.296680846159834e-02*G0_1_0 + 1.467896975709446e-01*G0_1_1 + 1.418967076519136e-01*G0_1_2 + 9.296680846159835e-02*G0_2_0 + 1.418967076519130e-01*G0_2_1 + 1.467896975709447e-01*G0_2_2;
    block[1845] = 9.296680846160031e-02*G0_0_1 + 9.296680846160044e-02*G0_0_2 + 9.296680846160024e-02*G0_1_0 - 4.892989919031613e-02*G0_1_1 - 2.935793951418832e-02*G0_1_2 + 9.296680846160130e-02*G0_2_0 - 2.935793951418935e-02*G0_2_1 - 4.892989919031514e-02*G0_2_2;
    block[1846] = -1.027527882996629e-01*G0_0_1 - 2.984723850609242e-01*G0_0_2 - 1.027527882996625e-01*G0_1_0 + 1.467896975709478e-01*G0_1_1 - 2.984723850609239e-01*G0_1_2 - 2.984723850609248e-01*G0_2_0 - 2.984723850609233e-01*G0_2_1 - 7.828783870450482e-01*G0_2_2;
    block[1847] = -2.984723850609238e-01*G0_0_1 - 1.027527882996619e-01*G0_0_2 - 2.984723850609237e-01*G0_1_0 - 7.828783870450475e-01*G0_1_1 - 2.984723850609238e-01*G0_1_2 - 1.027527882996622e-01*G0_2_0 - 2.984723850609237e-01*G0_2_1 + 1.467896975709486e-01*G0_2_2;
    block[1848] = -1.374212528726394e-02*G0_0_0 - 1.374212528726396e-02*G0_0_1 - 1.374212528726396e-02*G0_0_2 - 1.374212528726401e-02*G0_1_0 - 1.374212528726407e-02*G0_1_1 - 1.374212528726404e-02*G0_1_2 - 1.374212528726390e-02*G0_2_0 - 1.374212528726395e-02*G0_2_1 - 1.374212528726391e-02*G0_2_2;
    block[1849] = 1.374212528726405e-02*G0_0_0 - 5.177435732991243e-03*G0_1_0 - 5.177435732991277e-03*G0_2_0;
    block[1850] = 1.439452394313483e-02*G0_0_1 + 4.799305472048486e-02*G0_1_1 + 1.439452394313485e-02*G0_2_1;
    block[1851] = -5.177435732991313e-03*G0_0_2 - 5.177435732991289e-03*G0_1_2 + 1.374212528726411e-02*G0_2_2;
    block[1852] = -6.413078787210634e-02*G0_0_0 - 9.394540644540431e-03*G0_0_1 + 2.648738542835735e-02*G0_1_0 + 1.187365553684978e-02*G0_1_1 + 4.775558160974782e-02*G0_2_0 + 1.187365553684980e-02*G0_2_1;
    block[1853] = 1.270872581636453e-01*G0_0_0 + 3.777388217492331e-02*G0_0_1 - 4.638554443241925e-02*G0_1_0 - 5.101757488910217e-02*G0_1_1 - 8.233271037090439e-02*G0_2_0 + 1.826716236438235e-03*G0_2_1;
    block[1854] = -1.247386230025103e-01*G0_0_0 - 6.236931150125508e-02*G0_0_1 + 7.332960891988641e-02*G0_1_0 + 1.323064474106131e-01*G0_1_1 + 1.466592178397724e-01*G0_2_0 + 1.096029741863107e-02*G0_2_1;
    block[1855] = 1.247386230025100e-01*G0_0_0 + 9.629404160653994e-02*G0_0_1 + 2.844458139596963e-02*G0_1_0 - 6.445698720004259e-02*G0_1_1 + 1.247386230025101e-01*G0_2_0 + 1.925880832130807e-01*G0_2_1;
    block[1856] = -1.247386230025101e-01*G0_0_0 - 2.844458139597016e-02*G0_0_1 - 1.247386230025101e-01*G0_0_2 - 2.844458139596967e-02*G0_1_0 - 6.067307499599101e-02*G0_1_1 - 2.844458139596970e-02*G0_1_2 - 1.247386230025101e-01*G0_2_0 - 2.844458139597000e-02*G0_2_1 - 1.247386230025101e-01*G0_2_2;
    block[1857] = 1.247386230025106e-01*G0_0_0 + 6.236931150125539e-02*G0_0_1 + 1.247386230025106e-01*G0_0_2 + 6.236931150125529e-02*G0_1_0 + 4.762510187857340e-02*G0_1_1 + 6.236931150125521e-02*G0_1_2 + 1.247386230025102e-01*G0_2_0 + 6.236931150125502e-02*G0_2_1 + 1.247386230025101e-01*G0_2_2;
    block[1858] = -1.270872581636456e-01*G0_0_0 - 8.931337598872210e-02*G0_0_1 - 1.270872581636455e-01*G0_0_2 - 8.931337598872226e-02*G0_1_0 - 6.654466289882852e-02*G0_1_1 - 8.931337598872213e-02*G0_1_2 - 1.270872581636451e-01*G0_2_0 - 8.931337598872165e-02*G0_2_1 - 1.270872581636450e-01*G0_2_2;
    block[1859] = 6.413078787210651e-02*G0_0_0 + 5.473624722756593e-02*G0_0_1 + 6.413078787210649e-02*G0_0_2 + 5.473624722756603e-02*G0_1_0 + 4.534170658302542e-02*G0_1_1 + 5.473624722756597e-02*G0_1_2 + 6.413078787210619e-02*G0_2_0 + 5.473624722756564e-02*G0_2_1 + 6.413078787210616e-02*G0_2_2;
    block[1860] = 9.394540644540584e-03*G0_0_1 + 9.394540644540541e-03*G0_0_2 + 9.394540644540558e-03*G0_1_0 + 1.878908128908111e-02*G0_1_1 + 1.878908128908112e-02*G0_1_2 + 9.394540644540433e-03*G0_2_0 + 1.878908128908113e-02*G0_2_1 + 1.878908128908105e-02*G0_2_2;
    block[1861] = 6.523986558689729e-05*G0_0_1 + 6.523986558692313e-05*G0_0_2 + 6.523986558702132e-05*G0_1_0 - 1.487468935385599e-02*G0_1_1 - 1.487468935385604e-02*G0_1_2 + 6.523986558694787e-05*G0_2_0 - 1.487468935385593e-02*G0_2_1 - 1.487468935385596e-02*G0_2_2;
    block[1862] = 6.523986558708240e-05*G0_0_1 + 6.523986558708803e-05*G0_0_2 + 6.523986558733091e-05*G0_1_0 - 1.174317580567267e-03*G0_1_1 - 1.174317580567254e-03*G0_1_2 + 6.523986558742582e-05*G0_2_0 - 1.174317580567402e-03*G0_2_1 - 1.174317580567403e-03*G0_2_2;
    block[1863] = 9.394540644540554e-03*G0_0_1 + 9.394540644540489e-03*G0_0_2 + 9.394540644540417e-03*G0_1_0 - 1.187365553684984e-02*G0_1_1 - 1.187365553684981e-02*G0_1_2 + 9.394540644540466e-03*G0_2_0 - 1.187365553684968e-02*G0_2_1 - 1.187365553684974e-02*G0_2_2;
    block[1864] = 1.878908128908129e-02*G0_0_0 + 1.878908128908126e-02*G0_0_1 + 9.394540644540646e-03*G0_0_2 + 1.878908128908112e-02*G0_1_0 + 1.878908128908109e-02*G0_1_1 + 9.394540644540613e-03*G0_1_2 + 9.394540644540442e-03*G0_2_0 + 9.394540644540508e-03*G0_2_1;
    block[1865] = -1.487468935385584e-02*G0_0_0 - 1.487468935385581e-02*G0_0_1 + 6.523986558678893e-05*G0_0_2 - 1.487468935385592e-02*G0_1_0 - 1.487468935385588e-02*G0_1_1 + 6.523986558697188e-05*G0_1_2 + 6.523986558713264e-05*G0_2_0 + 6.523986558703475e-05*G0_2_1;
    block[1866] = -1.174317580567965e-03*G0_0_0 - 1.174317580567941e-03*G0_0_1 + 6.523986558729177e-05*G0_0_2 - 1.174317580567619e-03*G0_1_0 - 1.174317580567591e-03*G0_1_1 + 6.523986558716979e-05*G0_1_2 + 6.523986558685208e-05*G0_2_0 + 6.523986558688428e-05*G0_2_1;
    block[1867] = -1.187365553684975e-02*G0_0_0 - 1.187365553684976e-02*G0_0_1 + 9.394540644540568e-03*G0_0_2 - 1.187365553684986e-02*G0_1_0 - 1.187365553684986e-02*G0_1_1 + 9.394540644540509e-03*G0_1_2 + 9.394540644540626e-03*G0_2_0 + 9.394540644540641e-03*G0_2_1;
    block[1868] = -1.878908128908090e-02*G0_0_0 - 9.394540644540372e-03*G0_0_2 + 4.253639236278092e-02*G0_1_0 + 1.187365553684991e-02*G0_1_2 + 2.126819618139045e-02*G0_2_0 + 1.187365553684979e-02*G0_2_2;
    block[1869] = 1.487468935385578e-02*G0_0_0 + 1.493992921944289e-02*G0_0_2 + 4.031823693282019e-02*G0_1_0 + 5.401860870610842e-02*G0_1_2 + 1.239557446154844e-03*G0_2_0 + 1.174317580568126e-03*G0_2_2;
    block[1870] = 1.174317580567987e-03*G0_0_0 + 1.239557446155201e-03*G0_0_2 + 5.401860870610829e-02*G0_1_0 + 4.031823693282006e-02*G0_1_2 + 1.493992921944316e-02*G0_2_0 + 1.487468935385590e-02*G0_2_2;
    block[1871] = 1.187365553684976e-02*G0_0_0 + 2.126819618139028e-02*G0_0_2 + 1.187365553684987e-02*G0_1_0 + 4.253639236278085e-02*G0_1_2 - 9.394540644540608e-03*G0_2_0 - 1.878908128908119e-02*G0_2_2;
    block[1872] = 1.925880832130806e-01*G0_0_1 + 1.247386230025100e-01*G0_0_2 - 6.445698720004249e-02*G0_1_1 + 2.844458139596965e-02*G0_1_2 + 9.629404160654004e-02*G0_2_1 + 1.247386230025101e-01*G0_2_2;
    block[1873] = 1.096029741863133e-02*G0_0_1 + 1.466592178397731e-01*G0_0_2 + 1.323064474106135e-01*G0_1_1 + 7.332960891988681e-02*G0_1_2 - 6.236931150125479e-02*G0_2_1 - 1.247386230025102e-01*G0_2_2;
    block[1874] = 1.826716236437929e-03*G0_0_1 - 8.233271037090512e-02*G0_0_2 - 5.101757488910220e-02*G0_1_1 - 4.638554443241930e-02*G0_1_2 + 3.777388217492331e-02*G0_2_1 + 1.270872581636457e-01*G0_2_2;
    block[1875] = 1.187365553684980e-02*G0_0_1 + 4.775558160974800e-02*G0_0_2 + 1.187365553684984e-02*G0_1_1 + 2.648738542835755e-02*G0_1_2 - 9.394540644540601e-03*G0_2_1 - 6.413078787210698e-02*G0_2_2;
    block[1876] = 1.056885822510809e-01*G0_0_0 + 3.001033817006030e-02*G0_0_1 + 5.284429112554070e-02*G0_0_2 - 7.437344676927943e-02*G0_1_0 + 1.056885822510816e-01*G0_1_1 + 6.523986558705128e-04*G0_1_2 + 6.523986558710956e-04*G0_2_0 + 5.284429112554086e-02*G0_2_1 + 5.349668978141116e-02*G0_2_2;
    block[1877] = -1.370037177328821e-02*G0_0_0 + 1.272177378948238e-02*G0_0_1 - 1.989815900406201e-02*G0_0_2 - 8.513802459114943e-02*G0_1_0 + 1.135173661215323e-01*G0_1_1 - 8.513802459114926e-02*G0_1_2 - 1.989815900406167e-02*G0_2_0 + 1.272177378948265e-02*G0_2_1 - 1.370037177328856e-02*G0_2_2;
    block[1878] = 5.349668978141092e-02*G0_0_0 + 5.284429112554091e-02*G0_0_1 + 6.523986558705017e-04*G0_0_2 + 6.523986558707517e-04*G0_1_0 + 1.056885822510813e-01*G0_1_1 - 7.437344676927961e-02*G0_1_2 + 5.284429112554015e-02*G0_2_0 + 3.001033817005991e-02*G0_2_1 + 1.056885822510814e-01*G0_2_2;
    block[1879] = -2.094199685345501e-01*G0_0_0 - 7.372104811340924e-02*G0_0_1 - 1.047099842672750e-01*G0_0_2 + 1.807144276762307e-01*G0_1_0 - 2.681358475629305e-01*G0_1_1 + 2.250775362754484e-02*G0_1_2 + 8.122363265592332e-02*G0_2_0 - 4.599410523889707e-02*G0_2_1 - 2.348635161135103e-02*G0_2_2;
    block[1880] = -2.348635161135182e-02*G0_0_0 - 4.599410523889799e-02*G0_0_1 + 8.122363265592361e-02*G0_0_2 + 2.250775362754577e-02*G0_1_0 - 2.681358475629296e-01*G0_1_1 + 1.807144276762318e-01*G0_1_2 - 1.047099842672746e-01*G0_2_0 - 7.372104811340939e-02*G0_2_1 - 2.094199685345503e-01*G0_2_2;
    block[1881] = 5.427956816845653e-01*G0_0_0 + 2.713978408422834e-01*G0_0_1 + 2.713978408422819e-01*G0_0_2 + 2.713978408422834e-01*G0_1_0 + 6.471794666239071e-01*G0_1_1 + 2.713978408422830e-01*G0_1_2 + 2.713978408422819e-01*G0_2_0 + 2.713978408422830e-01*G0_2_1 + 5.427956816845646e-01*G0_2_2;
    block[1882] = -5.427956816845656e-01*G0_0_0 - 2.713978408422816e-01*G0_0_1 - 2.713978408422834e-01*G0_0_2 - 2.713978408422836e-01*G0_1_0 + 5.219189246967055e-02*G0_1_1 - 1.356989204211420e-01*G0_1_2 - 2.713978408422820e-01*G0_2_0 - 1.356989204211402e-01*G0_2_1;
    block[1883] = 2.348635161135177e-02*G0_0_0 - 2.250775362754588e-02*G0_0_1 + 1.047099842672762e-01*G0_0_2 - 2.250775362754576e-02*G0_1_0 - 1.565756774090103e-01*G0_1_1 + 6.784946021057082e-02*G0_1_2 + 1.047099842672746e-01*G0_2_0 + 6.784946021057010e-02*G0_2_1;
    block[1884] = -5.349668978141069e-02*G0_0_0 - 6.523986558700085e-04*G0_0_1 - 5.284429112554064e-02*G0_0_2 - 6.523986558706925e-04*G0_1_0 + 5.219189246966992e-02*G0_1_1 - 3.783912204051071e-02*G0_1_2 - 5.284429112554005e-02*G0_2_0 - 3.783912204051016e-02*G0_2_1;
    block[1885] = 2.094199685345493e-01*G0_0_0 + 1.356989204211408e-01*G0_0_1 + 1.047099842672746e-01*G0_0_2 + 1.356989204211418e-01*G0_1_0 + 3.914391935225182e-02*G0_1_1 + 6.784946021057046e-02*G0_1_2 + 1.047099842672743e-01*G0_2_0 + 6.784946021056962e-02*G0_2_1;
    block[1886] = 1.370037177328804e-02*G0_0_0 + 2.642214556277052e-02*G0_0_1 - 6.197787230773662e-03*G0_0_2 + 2.642214556277063e-02*G0_1_0 + 3.914391935225268e-02*G0_1_1 - 5.545388574902297e-03*G0_1_2 - 6.197787230773720e-03*G0_2_0 - 5.545388574902260e-03*G0_2_1;
    block[1887] = -1.056885822510804e-01*G0_0_0 - 7.567824408102117e-02*G0_0_1 - 5.284429112554021e-02*G0_0_2 - 7.567824408102121e-02*G0_1_0 - 4.566790591096090e-02*G0_1_1 - 3.783912204051040e-02*G0_1_2 - 5.284429112553964e-02*G0_2_0 - 3.783912204050995e-02*G0_2_1;
    block[1888] = -5.284429112554104e-02*G0_0_1 - 1.500516908502961e-02*G0_0_2 - 5.284429112554076e-02*G0_1_0 - 1.056885822510813e-01*G0_1_1 - 3.001033817006000e-02*G0_1_2 - 1.500516908503004e-02*G0_2_0 - 3.001033817006001e-02*G0_2_1;
    block[1889] = -1.272177378948229e-02*G0_0_1 - 6.523986558713866e-04*G0_0_2 - 1.272177378948182e-02*G0_1_0 - 1.135173661215323e-01*G0_1_1 - 1.272177378948154e-02*G0_1_2 - 6.523986558717424e-04*G0_2_0 - 1.272177378948245e-02*G0_2_1;
    block[1890] = -3.001033817006038e-02*G0_0_1 - 1.500516908503004e-02*G0_0_2 - 3.001033817006019e-02*G0_1_0 - 1.056885822510816e-01*G0_1_1 - 5.284429112554130e-02*G0_1_2 - 1.500516908502996e-02*G0_2_0 - 5.284429112554115e-02*G0_2_1;
    block[1891] = -1.272177378948213e-02*G0_0_1 - 6.523986558714169e-04*G0_0_2 - 1.272177378948243e-02*G0_1_0 - 2.544354757896474e-02*G0_1_1 - 1.304797311741661e-03*G0_1_2 - 6.523986558702997e-04*G0_2_0 - 1.304797311741594e-03*G0_2_1;
    block[1892] = -1.304797311741998e-03*G0_0_1 - 6.523986558706946e-04*G0_0_2 - 1.304797311741487e-03*G0_1_0 - 2.544354757896441e-02*G0_1_1 - 1.272177378948228e-02*G0_1_2 - 6.523986558710300e-04*G0_2_0 - 1.272177378948181e-02*G0_2_1;
    block[1893] = -3.001033817005954e-02*G0_0_1 - 1.500516908502996e-02*G0_0_2 - 3.001033817006044e-02*G0_1_0 - 6.002067634012054e-02*G0_1_1 - 3.001033817006036e-02*G0_1_2 - 1.500516908502997e-02*G0_2_0 - 3.001033817005998e-02*G0_2_1;
    block[1894] = -3.783912204051019e-02*G0_0_1 - 5.284429112553988e-02*G0_0_2 - 3.783912204051039e-02*G0_1_0 - 4.566790591096088e-02*G0_1_1 - 7.567824408102110e-02*G0_1_2 - 5.284429112553970e-02*G0_2_0 - 7.567824408102047e-02*G0_2_1 - 1.056885822510801e-01*G0_2_2;
    block[1895] = -5.545388574902487e-03*G0_0_1 - 6.197787230774262e-03*G0_0_2 - 5.545388574902492e-03*G0_1_0 + 3.914391935225234e-02*G0_1_1 + 2.642214556277011e-02*G0_1_2 - 6.197787230774099e-03*G0_2_0 + 2.642214556277003e-02*G0_2_1 + 1.370037177328776e-02*G0_2_2;
    block[1896] = -3.783912204051053e-02*G0_0_1 - 5.284429112554075e-02*G0_0_2 - 3.783912204051051e-02*G0_1_0 + 5.219189246966949e-02*G0_1_1 - 6.523986558706981e-04*G0_1_2 - 5.284429112554023e-02*G0_2_0 - 6.523986558709955e-04*G0_2_1 - 5.349668978141141e-02*G0_2_2;
    block[1897] = 6.784946021057006e-02*G0_0_1 + 1.047099842672743e-01*G0_0_2 + 6.784946021057078e-02*G0_1_0 + 3.914391935225234e-02*G0_1_1 + 1.356989204211418e-01*G0_1_2 + 1.047099842672741e-01*G0_2_0 + 1.356989204211400e-01*G0_2_1 + 2.094199685345488e-01*G0_2_2;
    block[1898] = 6.784946021057073e-02*G0_0_1 + 1.047099842672751e-01*G0_0_2 + 6.784946021057094e-02*G0_1_0 - 1.565756774090094e-01*G0_1_1 - 2.250775362754457e-02*G0_1_2 + 1.047099842672757e-01*G0_2_0 - 2.250775362754497e-02*G0_2_1 + 2.348635161135139e-02*G0_2_2;
    block[1899] = -1.356989204211402e-01*G0_0_1 - 2.713978408422820e-01*G0_0_2 - 1.356989204211416e-01*G0_1_0 + 5.219189246967011e-02*G0_1_1 - 2.713978408422830e-01*G0_1_2 - 2.713978408422826e-01*G0_2_0 - 2.713978408422812e-01*G0_2_1 - 5.427956816845647e-01*G0_2_2;
    block[1900] = 7.502584542514897e-02*G0_0_1 + 2.609594623483452e-02*G0_0_2 + 7.502584542515005e-02*G0_1_0 + 1.957195967612627e-01*G0_1_1 + 7.502584542515037e-02*G0_1_2 + 2.609594623483415e-02*G0_2_0 + 7.502584542515017e-02*G0_2_1;
    block[1901] = 7.502584542515101e-02*G0_0_1 + 2.609594623483623e-02*G0_0_2 + 7.502584542515060e-02*G0_1_0 + 2.935793951418948e-01*G0_1_1 + 5.871587902837939e-02*G0_1_2 + 2.609594623483433e-02*G0_2_0 + 5.871587902837916e-02*G0_2_1;
    block[1902] = -3.164133480973725e-01*G0_0_1 - 1.859336169231978e-01*G0_0_2 - 3.164133480973725e-01*G0_1_0 - 7.828783870450486e-01*G0_1_1 - 3.164133480973734e-01*G0_1_2 - 1.859336169231975e-01*G0_2_0 - 3.164133480973732e-01*G0_2_1;
    block[1903] = 5.871587902838007e-02*G0_0_1 + 2.609594623483494e-02*G0_0_2 + 5.871587902837924e-02*G0_1_0 + 2.935793951418940e-01*G0_1_1 + 7.502584542515046e-02*G0_1_2 + 2.609594623483571e-02*G0_2_0 + 7.502584542515081e-02*G0_2_1;
    block[1904] = 1.374212528726397e-02*G0_0_0 + 1.374212528726399e-02*G0_0_1 + 1.374212528726400e-02*G0_0_2 + 1.891956102025530e-02*G0_1_0 + 1.891956102025534e-02*G0_1_1 + 1.891956102025530e-02*G0_1_2 + 1.891956102025525e-02*G0_2_0 + 1.891956102025526e-02*G0_2_1 + 1.891956102025526e-02*G0_2_2;
    block[1905] = -1.374212528726406e-02*G0_0_0;
    block[1906] = -1.439452394313485e-02*G0_0_1 + 3.359853077734994e-02*G0_1_1;
    block[1907] = 5.177435732991315e-03*G0_0_2 + 1.891956102025541e-02*G0_2_2;
    block[1908] = 6.413078787210634e-02*G0_0_0 + 9.394540644540417e-03*G0_0_1 + 9.394540644540289e-03*G0_1_0;
    block[1909] = -1.270872581636453e-01*G0_0_0 - 3.777388217492334e-02*G0_0_1 - 3.777388217492302e-02*G0_1_0 - 1.500516908502975e-02*G0_1_1;
    block[1910] = 1.247386230025104e-01*G0_0_0 + 6.236931150125512e-02*G0_0_1 + 6.236931150125521e-02*G0_1_0 + 4.762510187857324e-02*G0_1_1;
    block[1911] = -1.247386230025102e-01*G0_0_0 - 9.629404160654004e-02*G0_0_1 - 9.629404160654044e-02*G0_1_0 - 1.285225352065611e-01*G0_1_1;
    block[1912] = 1.247386230025102e-01*G0_0_0 + 2.844458139597022e-02*G0_0_1 + 1.247386230025102e-01*G0_0_2 + 9.629404160654050e-02*G0_1_0 - 6.445698720004180e-02*G0_1_1 + 9.629404160654050e-02*G0_1_2 + 9.629404160654111e-02*G0_2_1;
    block[1913] = -1.247386230025107e-01*G0_0_0 - 6.236931150125547e-02*G0_0_1 - 1.247386230025107e-01*G0_0_2 - 1.980682319223968e-01*G0_1_0 - 3.392473010528995e-03*G0_1_1 - 1.980682319223969e-01*G0_1_2 - 2.713978408422832e-01*G0_2_0 - 1.980682319223971e-01*G0_2_1 - 2.713978408422833e-01*G0_2_2;
    block[1914] = 1.270872581636456e-01*G0_0_0 + 8.931337598872216e-02*G0_0_1 + 1.270872581636455e-01*G0_0_2 + 1.734728025960645e-01*G0_1_0 + 8.468134553203928e-02*G0_1_1 + 1.734728025960646e-01*G0_1_2 + 2.094199685345499e-01*G0_2_0 + 1.734728025960648e-01*G0_2_1 + 2.094199685345498e-01*G0_2_2;
    block[1915] = -6.413078787210658e-02*G0_0_0 - 5.473624722756600e-02*G0_0_1 - 6.413078787210658e-02*G0_0_2 - 9.061817330046365e-02*G0_1_0 - 6.934997711907372e-02*G0_1_1 - 9.061817330046364e-02*G0_1_2 - 1.118863694818544e-01*G0_2_0 - 9.061817330046407e-02*G0_2_1 - 1.118863694818543e-01*G0_2_2;
    block[1916] = -9.394540644540639e-03*G0_0_1 - 9.394540644540600e-03*G0_0_2 - 9.394540644540627e-03*G0_1_0 - 3.066273682593081e-02*G0_1_1 - 3.066273682593074e-02*G0_1_2 - 9.394540644540497e-03*G0_2_0 - 3.066273682593079e-02*G0_2_1 - 3.066273682593080e-02*G0_2_2;
    block[1917] = -6.523986558684111e-05*G0_0_1 - 6.523986558686599e-05*G0_0_2 - 6.523986558682478e-05*G0_1_0 - 1.304797311741544e-03*G0_1_1 - 1.304797311741529e-03*G0_1_2 - 6.523986558701221e-05*G0_2_0 - 1.304797311741609e-03*G0_2_1 - 1.304797311741616e-03*G0_2_2;
    block[1918] = -6.523986558712378e-05*G0_0_1 - 6.523986558712875e-05*G0_0_2 - 6.523986558737444e-05*G0_1_0 - 1.500516908502984e-02*G0_1_1 - 1.500516908502987e-02*G0_1_2 - 6.523986558725694e-05*G0_2_0 - 1.500516908502987e-02*G0_2_1 - 1.500516908502990e-02*G0_2_2;
    block[1919] = -9.394540644540544e-03*G0_0_1 - 9.394540644540471e-03*G0_0_2 - 9.394540644540641e-03*G0_1_0 - 9.394540644540584e-03*G0_2_0;
    block[1920] = -1.878908128908135e-02*G0_0_0 - 1.878908128908132e-02*G0_0_1 - 9.394540644540707e-03*G0_0_2 - 6.132547365186184e-02*G0_1_0 - 6.132547365186192e-02*G0_1_1 - 4.005727747047182e-02*G0_1_2 - 4.005727747047157e-02*G0_2_0 - 4.005727747047148e-02*G0_2_1 - 1.878908128908128e-02*G0_2_2;
    block[1921] = 1.487468935385588e-02*G0_0_0 + 1.487468935385586e-02*G0_0_1 - 6.523986558675625e-05*G0_0_2 - 2.544354757896446e-02*G0_1_0 - 2.544354757896439e-02*G0_1_1 + 1.363513190770158e-02*G0_1_2 + 1.363513190770126e-02*G0_2_0 + 1.363513190770116e-02*G0_2_1 - 1.304797311737690e-04*G0_2_2;
    block[1922] = 1.174317580567959e-03*G0_0_0 + 1.174317580567924e-03*G0_0_1 - 6.523986558728303e-05*G0_0_2 - 5.284429112554003e-02*G0_1_0 - 5.284429112554006e-02*G0_1_1 - 1.376561163887560e-02*G0_1_2 - 1.376561163887527e-02*G0_2_0 - 1.376561163887525e-02*G0_2_1 - 1.304797311744580e-04*G0_2_2;
    block[1923] = 1.187365553684972e-02*G0_0_0 + 1.187365553684974e-02*G0_0_1 - 9.394540644540572e-03*G0_0_2 + 2.126819618139053e-02*G0_1_2 + 2.126819618139048e-02*G0_2_0 + 2.126819618139050e-02*G0_2_1 - 1.878908128908111e-02*G0_2_2;
    block[1924] = 1.878908128908089e-02*G0_0_0 + 9.394540644540358e-03*G0_0_2 + 9.394540644540473e-03*G0_2_0;
    block[1925] = -1.487468935385579e-02*G0_0_0 - 1.493992921944291e-02*G0_0_2 - 1.493992921944305e-02*G0_2_0 - 1.500516908502982e-02*G0_2_2;
    block[1926] = -1.174317580567989e-03*G0_0_0 - 1.239557446155217e-03*G0_0_2 - 1.239557446154626e-03*G0_2_0 - 1.304797311741998e-03*G0_2_2;
    block[1927] = -1.187365553684974e-02*G0_0_0 - 2.126819618139026e-02*G0_0_2 - 2.126819618139050e-02*G0_2_0 - 3.066273682593097e-02*G0_2_2;
    block[1928] = -1.925880832130808e-01*G0_0_1 - 1.247386230025100e-01*G0_0_2 - 2.570450704131232e-01*G0_1_1 - 9.629404160654033e-02*G0_1_2 - 9.629404160654068e-02*G0_2_1;
    block[1929] = -1.096029741863138e-02*G0_0_1 - 1.466592178397731e-01*G0_0_2 + 1.213461499919820e-01*G0_1_1 - 7.332960891988630e-02*G0_1_2 - 7.332960891988616e-02*G0_2_1 - 2.713978408422835e-01*G0_2_2;
    block[1930] = -1.826716236437943e-03*G0_0_1 + 8.233271037090507e-02*G0_0_2 - 5.284429112554011e-02*G0_1_1 + 3.594716593848567e-02*G0_1_2 + 3.594716593848529e-02*G0_2_1 + 2.094199685345507e-01*G0_2_2;
    block[1931] = -1.187365553684978e-02*G0_0_1 - 4.775558160974799e-02*G0_0_2 - 2.126819618139044e-02*G0_1_2 - 2.126819618139051e-02*G0_2_1 - 1.118863694818551e-01*G0_2_2;
    block[1932] = -1.056885822510811e-01*G0_0_0 - 3.001033817006038e-02*G0_0_1 - 5.284429112554079e-02*G0_0_2 - 3.001033817006022e-02*G0_1_0 - 1.500516908502998e-02*G0_1_2 - 5.284429112554041e-02*G0_2_0 - 1.500516908503028e-02*G0_2_1;
    block[1933] = 1.370037177328814e-02*G0_0_0 - 1.272177378948245e-02*G0_0_1 + 1.989815900406188e-02*G0_0_2 - 1.272177378948197e-02*G0_1_0 - 1.206937513361145e-02*G0_1_2 + 1.989815900406175e-02*G0_2_0 - 1.206937513361107e-02*G0_2_1 + 2.609594623483490e-02*G0_2_2;
    block[1934] = -5.349668978141087e-02*G0_0_0 - 5.284429112554083e-02*G0_0_1 - 6.523986558704467e-04*G0_0_2 - 5.284429112554034e-02*G0_1_0 - 3.783912204051021e-02*G0_1_2 - 6.523986558710517e-04*G0_2_0 - 3.783912204051093e-02*G0_2_1 + 5.219189246967022e-02*G0_2_2;
    block[1935] = 2.094199685345502e-01*G0_0_0 + 7.372104811340910e-02*G0_0_1 + 1.047099842672750e-01*G0_0_2 + 7.372104811340796e-02*G0_1_0 - 2.283395295548083e-02*G0_1_1 + 3.686052405670386e-02*G0_1_2 + 1.047099842672754e-01*G0_2_0 + 3.686052405670497e-02*G0_2_1;
    block[1936] = 2.348635161135166e-02*G0_0_0 + 4.599410523889788e-02*G0_0_1 - 8.122363265592379e-02*G0_0_2 + 4.599410523889745e-02*G0_1_0 - 8.807381854256675e-02*G0_1_1 + 9.133581182192549e-03*G0_1_2 - 8.122363265592326e-02*G0_2_0 + 9.133581182192596e-03*G0_2_1 - 1.859336169231992e-01*G0_2_2;
    block[1937] = -5.427956816845656e-01*G0_0_0 - 2.713978408422836e-01*G0_0_1 - 2.713978408422820e-01*G0_0_2 - 2.713978408422816e-01*G0_1_0 + 5.219189246967055e-02*G0_1_1 - 1.356989204211402e-01*G0_1_2 - 2.713978408422834e-01*G0_2_0 - 1.356989204211420e-01*G0_2_1;
    block[1938] = 5.427956816845657e-01*G0_0_0 + 2.713978408422817e-01*G0_0_1 + 2.713978408422836e-01*G0_0_2 + 2.713978408422817e-01*G0_1_0 + 6.471794666239050e-01*G0_1_1 + 2.713978408422829e-01*G0_1_2 + 2.713978408422836e-01*G0_2_0 + 2.713978408422829e-01*G0_2_1 + 5.427956816845664e-01*G0_2_2;
    block[1939] = -2.348635161135160e-02*G0_0_0 + 2.250775362754607e-02*G0_0_1 - 1.047099842672761e-01*G0_0_2 - 4.599410523889740e-02*G0_1_0 - 2.681358475629290e-01*G0_1_1 + 5.349668978141093e-02*G0_1_2 + 8.122363265592333e-02*G0_2_0 + 5.349668978141161e-02*G0_2_1 - 2.094199685345512e-01*G0_2_2;
    block[1940] = 5.349668978141065e-02*G0_0_0 + 6.523986558700289e-04*G0_0_1 + 5.284429112554073e-02*G0_0_2 + 5.284429112554030e-02*G0_1_0 + 1.056885822510802e-01*G0_1_1 - 2.218155429961043e-02*G0_1_2 + 6.523986558709747e-04*G0_2_0 - 2.218155429961002e-02*G0_2_1 + 1.056885822510822e-01*G0_2_2;
    block[1941] = -2.094199685345496e-01*G0_0_0 - 1.356989204211410e-01*G0_0_1 - 1.047099842672748e-01*G0_0_2 - 3.901343962107807e-01*G0_1_0 - 5.845491956603021e-01*G0_1_1 - 2.629166583159613e-01*G0_1_2 - 2.906436011904735e-01*G0_2_0 - 2.629166583159616e-01*G0_2_1 - 2.094199685345494e-01*G0_2_2;
    block[1942] = -1.370037177328829e-02*G0_0_0 - 2.642214556277071e-02*G0_0_1 + 6.197787230773505e-03*G0_0_2 + 7.143765281786160e-02*G0_1_0 + 1.722332451499113e-01*G0_1_1 + 6.197787230774579e-03*G0_1_2 + 6.197787230773329e-03*G0_2_0 + 6.197787230773424e-03*G0_2_1 + 1.239557446154631e-02*G0_2_2;
    block[1943] = 1.056885822510806e-01*G0_0_0 + 7.567824408102131e-02*G0_0_1 + 5.284429112554035e-02*G0_0_2 + 1.800620290203598e-01*G0_1_0 + 2.557402731013819e-01*G0_1_1 + 1.278701365506901e-01*G0_1_2 + 1.050361835952102e-01*G0_2_0 + 1.278701365506909e-01*G0_2_1 + 1.056885822510809e-01*G0_2_2;
    block[1944] = 5.284429112554096e-02*G0_0_1 + 1.500516908502964e-02*G0_0_2 + 5.284429112554003e-02*G0_1_0 + 3.783912204051009e-02*G0_1_2 + 1.500516908502993e-02*G0_2_0 + 3.783912204051086e-02*G0_2_1 + 3.001033817005994e-02*G0_2_2;
    block[1945] = 1.272177378948238e-02*G0_0_1 + 6.523986558714167e-04*G0_0_2 + 1.272177378948324e-02*G0_1_0 + 1.206937513361175e-02*G0_1_2 + 6.523986558705790e-04*G0_2_0 + 1.206937513361112e-02*G0_2_1 + 1.304797311741939e-03*G0_2_2;
    block[1946] = 3.001033817006048e-02*G0_0_1 + 1.500516908503010e-02*G0_0_2 + 3.001033817005999e-02*G0_1_0 + 1.500516908503034e-02*G0_1_2 + 1.500516908503001e-02*G0_2_0 + 1.500516908503019e-02*G0_2_1 + 3.001033817005993e-02*G0_2_2;
    block[1947] = 1.272177378948198e-02*G0_0_1 + 6.523986558713168e-04*G0_0_2 + 1.272177378948160e-02*G0_1_0 - 8.807381854256809e-02*G0_1_1 + 6.523986558718830e-04*G0_1_2 + 6.523986558712557e-04*G0_2_0 + 6.523986558713534e-04*G0_2_1 + 1.304797311742215e-03*G0_2_2;
    block[1948] = 1.304797311741890e-03*G0_0_1 + 6.523986558706173e-04*G0_0_2 + 1.304797311741687e-03*G0_1_0 - 2.283395295548101e-02*G0_1_1 - 1.076457782187026e-02*G0_1_2 + 6.523986558710044e-04*G0_2_0 - 1.076457782186903e-02*G0_2_1 + 1.304797311741658e-03*G0_2_2;
    block[1949] = 3.001033817005970e-02*G0_0_1 + 1.500516908503007e-02*G0_0_2 + 3.001033817006021e-02*G0_1_0 - 4.566790591096139e-02*G0_1_1 - 7.828783870451068e-03*G0_1_2 + 1.500516908503011e-02*G0_2_0 - 7.828783870450672e-03*G0_2_1 + 3.001033817005983e-02*G0_2_2;
    block[1950] = 3.783912204051029e-02*G0_0_1 + 5.284429112553999e-02*G0_0_2 + 3.783912204050983e-02*G0_1_0 + 1.278701365506903e-01*G0_1_1 + 9.003101451018009e-02*G0_1_2 + 5.284429112554002e-02*G0_2_0 + 9.003101451017990e-02*G0_2_1 + 5.219189246966949e-02*G0_2_2;
    block[1951] = 5.545388574902437e-03*G0_0_1 + 6.197787230774184e-03*G0_0_2 + 5.545388574902952e-03*G0_1_0 + 5.023469650205693e-02*G0_1_1 + 3.816532136844665e-02*G0_1_2 + 6.197787230773600e-03*G0_2_0 + 3.816532136844578e-02*G0_2_1 + 2.609594623483542e-02*G0_2_2;
    block[1952] = 3.783912204051062e-02*G0_0_1 + 5.284429112554087e-02*G0_0_2 + 3.783912204051063e-02*G0_1_0 + 3.001033817005994e-02*G0_1_1 + 1.500516908503022e-02*G0_1_2 + 5.284429112554087e-02*G0_2_0 + 1.500516908502984e-02*G0_2_1;
    block[1953] = -6.784946021057009e-02*G0_0_1 - 1.047099842672744e-01*G0_0_2 - 6.784946021056985e-02*G0_1_0 - 2.922745978301499e-01*G0_1_1 - 1.950671981053899e-01*G0_1_2 - 1.047099842672743e-01*G0_2_0 - 1.950671981053904e-01*G0_2_1 - 1.859336169231986e-01*G0_2_2;
    block[1954] = -6.784946021057081e-02*G0_0_1 - 1.047099842672752e-01*G0_0_2 - 6.784946021057175e-02*G0_1_0 - 9.655500106888883e-02*G0_1_1 - 3.686052405670407e-02*G0_1_2 - 1.047099842672758e-01*G0_2_0 - 3.686052405670415e-02*G0_2_1;
    block[1955] = 1.356989204211402e-01*G0_0_1 + 2.713978408422820e-01*G0_0_2 + 1.356989204211416e-01*G0_1_0 + 3.235897333119513e-01*G0_1_1 + 1.356989204211403e-01*G0_1_2 + 2.713978408422831e-01*G0_2_0 + 1.356989204211411e-01*G0_2_1;
    block[1956] = -7.502584542514931e-02*G0_0_1 - 2.609594623483489e-02*G0_0_2 - 7.502584542514969e-02*G0_1_0 + 1.435277042915937e-01*G0_1_1 - 4.240591263160692e-02*G0_1_2 - 2.609594623483390e-02*G0_2_0 - 4.240591263160567e-02*G0_2_1 - 5.219189246966890e-02*G0_2_2;
    block[1957] = -7.502584542515080e-02*G0_0_1 - 2.609594623483602e-02*G0_0_2 - 7.502584542514990e-02*G0_1_0 + 4.566790591096190e-02*G0_1_1 - 2.609594623483526e-02*G0_1_2 - 2.609594623483578e-02*G0_2_0 - 2.609594623483563e-02*G0_2_1 - 5.219189246967068e-02*G0_2_2;
    block[1958] = 3.164133480973728e-01*G0_0_1 + 1.859336169231980e-01*G0_0_2 + 3.164133480973724e-01*G0_1_0 - 1.500516908503026e-01*G0_1_1 + 1.859336169231972e-01*G0_1_2 + 1.859336169231979e-01*G0_2_0 + 1.859336169231980e-01*G0_2_1 + 3.718672338463976e-01*G0_2_2;
    block[1959] = -5.871587902837980e-02*G0_0_1 - 2.609594623483477e-02*G0_0_2 - 5.871587902837968e-02*G0_1_0 + 1.761476370851349e-01*G0_1_1 - 9.785979838063157e-03*G0_1_2 - 2.609594623483530e-02*G0_2_0 - 9.785979838064070e-03*G0_2_1 - 5.219189246967102e-02*G0_2_2;
    block[1960] = 9.464999699374595e-03*G0_0_0 + 9.464999699374581e-03*G0_0_1 + 9.464999699374581e-03*G0_0_2 + 1.174317580567568e-02*G0_1_0 + 1.174317580567565e-02*G0_1_1 + 1.174317580567566e-02*G0_1_2 + 1.174317580567574e-02*G0_2_0 + 1.174317580567572e-02*G0_2_1 + 1.174317580567571e-02*G0_2_2;
    block[1961] = -9.464999699374669e-03*G0_0_0;
    block[1962] = 4.724671065816710e-03*G0_0_1 - 2.984723850609251e-02*G0_1_1;
    block[1963] = 4.724671065816811e-03*G0_0_2 - 2.984723850609256e-02*G0_2_2;
    block[1964] = 2.926007971580859e-02*G0_0_0 + 3.294613212147709e-03*G0_0_1 + 3.294613212147960e-03*G0_1_0;
    block[1965] = -1.898480088584235e-02*G0_0_0 - 9.492400442920912e-03*G0_0_1 - 9.492400442921416e-03*G0_1_0 - 6.523986558708893e-04*G0_1_1;
    block[1966] = 3.522952741702501e-03*G0_0_0 + 6.491366625914666e-03*G0_0_1 + 6.491366625915459e-03*G0_1_0 + 8.807381854256937e-03*G0_1_1;
    block[1967] = 4.296045148909679e-02*G0_0_0 + 4.227543290043267e-02*G0_0_1 + 4.227543290043232e-02*G0_1_0 + 6.426126760328081e-02*G0_1_1;
    block[1968] = -4.296045148909679e-02*G0_0_0 - 6.850185886641791e-04*G0_0_1 - 4.296045148909675e-02*G0_0_2 - 4.227543290043236e-02*G0_1_0 + 4.397166940569679e-02*G0_1_1 - 4.227543290043228e-02*G0_1_2 - 4.227543290043231e-02*G0_2_1;
    block[1969] = -3.522952741702915e-03*G0_0_0 + 2.968413884212321e-03*G0_0_1 - 3.522952741703007e-03*G0_0_2 + 3.036915743078915e-02*G0_1_0 - 6.784946021056935e-03*G0_1_1 + 3.036915743078906e-02*G0_1_2 + 1.047099842672752e-01*G0_2_0 + 3.036915743078886e-02*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[1970] = 1.898480088584232e-02*G0_0_0 + 9.492400442921226e-03*G0_0_1 + 1.898480088584236e-02*G0_0_2 + 3.787174197330417e-02*G0_1_0 + 1.278701365506911e-02*G0_1_1 + 3.787174197330417e-02*G0_1_2 + 5.675868306076585e-02*G0_2_0 + 3.787174197330439e-02*G0_2_1 + 5.675868306076595e-02*G0_2_2;
    block[1971] = -2.926007971580864e-02*G0_0_0 - 2.596546650366069e-02*G0_0_1 - 2.926007971580863e-02*G0_0_2 - 3.770864230933673e-02*G0_1_0 - 3.186967433929216e-02*G0_1_1 - 3.770864230933672e-02*G0_1_2 - 4.354761027938057e-02*G0_2_0 - 3.770864230933652e-02*G0_2_1 - 4.354761027938061e-02*G0_2_2;
    block[1972] = -3.294613212147762e-03*G0_0_1 - 3.294613212147829e-03*G0_0_2 - 3.294613212147708e-03*G0_1_0 - 9.133581182192135e-03*G0_1_1 - 9.133581182192192e-03*G0_1_2 - 3.294613212147886e-03*G0_2_0 - 9.133581182191963e-03*G0_2_1 - 9.133581182191958e-03*G0_2_2;
    block[1973] = -2.576974690689962e-03*G0_0_1 - 2.576974690689920e-03*G0_0_2 - 2.576974690690353e-03*G0_1_0 - 1.565756774090100e-02*G0_1_1 - 1.565756774090100e-02*G0_1_2 - 2.576974690690108e-03*G0_2_0 - 1.565756774090101e-02*G0_2_1 - 1.565756774090097e-02*G0_2_2;
    block[1974] = -2.576974690689961e-03*G0_0_1 - 2.576974690689932e-03*G0_0_2 - 2.576974690689607e-03*G0_1_0 - 6.523986558709413e-04*G0_1_1 - 6.523986558709549e-04*G0_1_2 - 2.576974690689770e-03*G0_2_0 - 6.523986558708614e-04*G0_2_1 - 6.523986558708538e-04*G0_2_2;
    block[1975] = -3.294613212147707e-03*G0_0_1 - 3.294613212147728e-03*G0_0_2 - 3.294613212148041e-03*G0_1_0 - 3.294613212147954e-03*G0_2_0;
    block[1976] = -2.926007971580862e-02*G0_0_0 - 2.926007971580851e-02*G0_0_1 - 2.596546650366062e-02*G0_0_2 - 4.354761027938101e-02*G0_1_0 - 4.354761027938096e-02*G0_1_1 - 3.770864230933647e-02*G0_1_2 - 3.770864230933620e-02*G0_2_0 - 3.770864230933627e-02*G0_2_1 - 3.186967433929216e-02*G0_2_2;
    block[1977] = 1.898480088584232e-02*G0_0_0 + 1.898480088584232e-02*G0_0_1 + 9.492400442921049e-03*G0_0_2 + 5.675868306076609e-02*G0_1_0 + 5.675868306076607e-02*G0_1_1 + 3.787174197330433e-02*G0_1_2 + 3.787174197330359e-02*G0_2_0 + 3.787174197330366e-02*G0_2_1 + 1.278701365506906e-02*G0_2_2;
    block[1978] = -3.522952741703000e-03*G0_0_0 - 3.522952741703034e-03*G0_0_1 + 2.968413884212673e-03*G0_0_2 + 1.047099842672750e-01*G0_1_0 + 1.047099842672750e-01*G0_1_1 + 3.036915743078917e-02*G0_1_2 + 3.036915743078958e-02*G0_2_0 + 3.036915743078951e-02*G0_2_1 - 6.784946021056974e-03*G0_2_2;
    block[1979] = -4.296045148909670e-02*G0_0_0 - 4.296045148909667e-02*G0_0_1 - 6.850185886644240e-04*G0_0_2 - 4.227543290043264e-02*G0_1_2 - 4.227543290043274e-02*G0_2_0 - 4.227543290043276e-02*G0_2_1 + 4.397166940569695e-02*G0_2_2;
    block[1980] = 2.926007971580856e-02*G0_0_0 + 3.294613212147680e-03*G0_0_2 + 3.294613212147739e-03*G0_2_0;
    block[1981] = -1.898480088584240e-02*G0_0_0 - 9.492400442920915e-03*G0_0_2 - 9.492400442920965e-03*G0_2_0 - 6.523986558708627e-04*G0_2_2;
    block[1982] = 3.522952741702804e-03*G0_0_0 + 6.491366625914986e-03*G0_0_2 + 6.491366625914897e-03*G0_2_0 + 8.807381854256722e-03*G0_2_2;
    block[1983] = 4.296045148909673e-02*G0_0_0 + 4.227543290043251e-02*G0_0_2 + 4.227543290043277e-02*G0_2_0 + 6.426126760328116e-02*G0_2_2;
    block[1984] = 4.932133838383838e-02*G0_0_1 + 4.296045148909691e-02*G0_0_2 + 1.766369360770386e-01*G0_1_1 + 4.227543290043236e-02*G0_1_2 + 4.227543290043297e-02*G0_2_1;
    block[1985] = -1.677316944244018e-01*G0_0_1 - 7.770067991422071e-02*G0_0_2 - 3.346805104617579e-01*G0_1_1 - 8.386584721220072e-02*G0_1_2 - 8.386584721220072e-02*G0_2_1 + 1.047099842672757e-01*G0_2_2;
    block[1986] = -7.770067991422068e-02*G0_0_1 - 1.677316944244015e-01*G0_0_2 + 1.047099842672753e-01*G0_1_1 - 8.386584721220064e-02*G0_1_2 - 8.386584721220053e-02*G0_2_1 - 3.346805104617583e-01*G0_2_2;
    block[1987] = 4.296045148909673e-02*G0_0_1 + 4.932133838383779e-02*G0_0_2 + 4.227543290043251e-02*G0_1_2 + 4.227543290043279e-02*G0_2_1 + 1.766369360770394e-01*G0_2_2;
    block[1988] = -1.135173661215313e-01*G0_0_0 - 1.272177378948195e-02*G0_0_1 - 1.272177378948192e-02*G0_0_2 - 1.272177378948153e-02*G0_1_0 - 6.523986558707751e-04*G0_1_2 - 1.272177378948165e-02*G0_2_0 - 6.523986558708659e-04*G0_2_1;
    block[1989] = 1.497254915223657e-01*G0_0_0 + 2.837934153038310e-02*G0_0_1 + 7.486274576118343e-02*G0_0_2 + 2.837934153038255e-02*G0_1_0 + 1.418967076519142e-02*G0_1_2 + 7.486274576118246e-02*G0_2_0 + 1.418967076519118e-02*G0_2_1 + 1.957195967612631e-02*G0_2_2;
    block[1990] = 2.348635161135111e-02*G0_0_0 + 1.047099842672744e-01*G0_0_1 - 2.250775362754552e-02*G0_0_2 + 1.047099842672753e-01*G0_1_0 + 6.784946021057091e-02*G0_1_2 - 2.250775362754443e-02*G0_2_0 + 6.784946021057098e-02*G0_2_1 - 1.565756774090098e-01*G0_2_2;
    block[1991] = 1.497254915223651e-01*G0_0_0 + 7.486274576118329e-02*G0_0_1 + 2.837934153038271e-02*G0_0_2 + 7.486274576118272e-02*G0_1_0 + 1.957195967612637e-02*G0_1_1 + 1.418967076519172e-02*G0_1_2 + 2.837934153038201e-02*G0_2_0 + 1.418967076519141e-02*G0_2_1;
    block[1992] = -5.401860870610825e-01*G0_0_0 - 2.700930435305405e-01*G0_0_1 - 2.700930435305408e-01*G0_0_2 - 2.700930435305411e-01*G0_1_0 + 9.296680846160003e-02*G0_1_1 - 1.350465217652705e-01*G0_1_2 - 2.700930435305406e-01*G0_2_0 - 1.350465217652696e-01*G0_2_1 + 9.296680846160096e-02*G0_2_2;
    block[1993] = 2.348635161135177e-02*G0_0_0 - 2.250775362754577e-02*G0_0_1 + 1.047099842672746e-01*G0_0_2 - 2.250775362754586e-02*G0_1_0 - 1.565756774090103e-01*G0_1_1 + 6.784946021057012e-02*G0_1_2 + 1.047099842672762e-01*G0_2_0 + 6.784946021057085e-02*G0_2_1;
    block[1994] = -2.348635161135161e-02*G0_0_0 - 4.599410523889740e-02*G0_0_1 + 8.122363265592333e-02*G0_0_2 + 2.250775362754607e-02*G0_1_0 - 2.681358475629290e-01*G0_1_1 + 5.349668978141161e-02*G0_1_2 - 1.047099842672761e-01*G0_2_0 + 5.349668978141090e-02*G0_2_1 - 2.094199685345512e-01*G0_2_2;
    block[1995] = 5.401860870610826e-01*G0_0_0 + 2.700930435305411e-01*G0_0_1 + 2.700930435305407e-01*G0_0_2 + 2.700930435305411e-01*G0_1_0 + 7.261197039842825e-01*G0_1_1 + 2.700930435305412e-01*G0_1_2 + 2.700930435305407e-01*G0_2_0 + 2.700930435305411e-01*G0_2_1 + 7.261197039842825e-01*G0_2_2;
    block[1996] = -2.348635161135098e-02*G0_0_0 + 8.122363265592371e-02*G0_0_1 - 4.599410523889592e-02*G0_0_2 - 1.047099842672754e-01*G0_1_0 - 2.094199685345502e-01*G0_1_1 + 5.349668978141234e-02*G0_1_2 + 2.250775362754449e-02*G0_2_0 + 5.349668978141102e-02*G0_2_1 - 2.681358475629301e-01*G0_2_2;
    block[1997] = -1.497254915223645e-01*G0_0_0 - 7.486274576118183e-02*G0_0_1 - 1.213461499919813e-01*G0_0_2 - 1.776155340608457e-01*G0_1_0 - 3.718672338463966e-02*G0_1_1 - 2.240989382916447e-01*G0_1_2 - 3.268517265913071e-01*G0_2_0 - 2.240989382916445e-01*G0_2_1 - 4.481978765832897e-01*G0_2_2;
    block[1998] = -1.497254915223655e-01*G0_0_0 - 1.213461499919819e-01*G0_0_1 - 7.486274576118307e-02*G0_0_2 - 3.268517265913078e-01*G0_1_0 - 4.481978765832904e-01*G0_1_1 - 2.240989382916463e-01*G0_1_2 - 1.776155340608447e-01*G0_2_0 - 2.240989382916443e-01*G0_2_1 - 3.718672338463879e-02*G0_2_2;
    block[1999] = 1.135173661215316e-01*G0_0_0 + 1.007955923320493e-01*G0_0_1 + 1.007955923320496e-01*G0_0_2 + 1.986553907126810e-01*G0_1_0 + 1.722332451499106e-01*G0_1_1 + 1.660354579191378e-01*G0_1_2 + 1.986553907126803e-01*G0_2_0 + 1.660354579191367e-01*G0_2_1 + 1.722332451499098e-01*G0_2_2;
    block[2000] = -1.047099842672746e-01*G0_0_1 - 3.686052405670407e-02*G0_0_2 - 1.047099842672748e-01*G0_1_0 - 6.784946021057067e-02*G0_1_2 - 3.686052405670448e-02*G0_2_0 - 6.784946021057098e-02*G0_2_1 - 9.655500106888965e-02*G0_2_2;
    block[2001] = -2.837934153038324e-02*G0_0_1 - 1.418967076519149e-02*G0_0_2 - 2.837934153038399e-02*G0_1_0 - 1.418967076519171e-02*G0_1_2 - 1.418967076519118e-02*G0_2_0 - 1.418967076519138e-02*G0_2_1 - 3.327233144941457e-02*G0_2_2;
    block[2002] = 1.272177378948191e-02*G0_0_1 + 1.206937513361095e-02*G0_0_2 + 1.272177378948225e-02*G0_1_0 + 6.523986558706462e-04*G0_1_2 + 1.206937513361106e-02*G0_2_0 + 6.523986558710493e-04*G0_2_1 + 1.304797311741628e-03*G0_2_2;
    block[2003] = -2.837934153038294e-02*G0_0_1 - 1.418967076519146e-02*G0_0_2 - 2.837934153038249e-02*G0_1_0 + 9.296680846159985e-02*G0_1_1 + 3.229373346560811e-02*G0_1_2 - 1.418967076519147e-02*G0_2_0 + 3.229373346560796e-02*G0_2_1 - 8.807381854256146e-03*G0_2_2;
    block[2004] = 1.810406270041726e-02*G0_0_1 + 1.027527882996648e-02*G0_0_2 + 1.810406270041660e-02*G0_1_0 + 1.957195967612673e-02*G0_1_1 + 2.984723850609289e-02*G0_1_2 + 1.027527882996626e-02*G0_2_0 + 2.984723850609278e-02*G0_2_1 + 4.012251733605887e-02*G0_2_2;
    block[2005] = 1.272177378948186e-02*G0_0_1 + 1.206937513361090e-02*G0_0_2 + 1.272177378948234e-02*G0_1_0 + 3.914391935225222e-02*G0_1_1 + 4.468930792715481e-02*G0_1_2 + 1.206937513361117e-02*G0_2_0 + 4.468930792715468e-02*G0_2_1 + 5.023469650205643e-02*G0_2_2;
    block[2006] = 1.206937513361116e-02*G0_0_1 + 1.272177378948213e-02*G0_0_2 + 1.206937513361156e-02*G0_1_0 + 5.023469650205714e-02*G0_1_1 + 4.468930792715457e-02*G0_1_2 + 1.272177378948234e-02*G0_2_0 + 4.468930792715477e-02*G0_2_1 + 3.914391935225272e-02*G0_2_2;
    block[2007] = 1.027527882996608e-02*G0_0_1 + 1.810406270041684e-02*G0_0_2 + 1.027527882996589e-02*G0_1_0 + 4.012251733605890e-02*G0_1_1 + 2.984723850609278e-02*G0_1_2 + 1.810406270041646e-02*G0_2_0 + 2.984723850609255e-02*G0_2_1 + 1.957195967612662e-02*G0_2_2;
    block[2008] = 1.206937513361099e-02*G0_0_1 + 1.272177378948205e-02*G0_0_2 + 1.206937513361135e-02*G0_1_0 + 1.304797311741906e-03*G0_1_1 + 6.523986558707985e-04*G0_1_2 + 1.272177378948183e-02*G0_2_0 + 6.523986558706824e-04*G0_2_1;
    block[2009] = -1.418967076519154e-02*G0_0_1 - 2.837934153038313e-02*G0_0_2 - 1.418967076519139e-02*G0_1_0 - 8.807381854256766e-03*G0_1_1 + 3.229373346560799e-02*G0_1_2 - 2.837934153038327e-02*G0_2_0 + 3.229373346560827e-02*G0_2_1 + 9.296680846159958e-02*G0_2_2;
    block[2010] = -1.418967076519098e-02*G0_0_1 - 2.837934153038290e-02*G0_0_2 - 1.418967076519145e-02*G0_1_0 - 3.327233144941474e-02*G0_1_1 - 1.418967076519168e-02*G0_1_2 - 2.837934153038273e-02*G0_2_0 - 1.418967076519103e-02*G0_2_1;
    block[2011] = -3.686052405670441e-02*G0_0_1 - 1.047099842672745e-01*G0_0_2 - 3.686052405670463e-02*G0_1_0 - 9.655500106888899e-02*G0_1_1 - 6.784946021057017e-02*G0_1_2 - 1.047099842672751e-01*G0_2_0 - 6.784946021057126e-02*G0_2_1;
    block[2012] = -9.296680846159877e-02*G0_0_1 - 9.296680846159863e-02*G0_0_2 - 9.296680846159877e-02*G0_1_0 - 2.348635161135143e-01*G0_1_1 - 2.152915564373872e-01*G0_1_2 - 9.296680846159922e-02*G0_2_0 - 2.152915564373883e-01*G0_2_1 - 2.348635161135150e-01*G0_2_2;
    block[2013] = -9.296680846160042e-02*G0_0_1 - 9.296680846160060e-02*G0_0_2 - 9.296680846160062e-02*G0_1_0 - 3.914391935225330e-02*G0_1_1 - 4.403690927128454e-02*G0_1_2 - 9.296680846159934e-02*G0_2_0 - 4.403690927128458e-02*G0_2_1 - 3.914391935225305e-02*G0_2_2;
    block[2014] = 1.027527882996628e-01*G0_0_1 + 2.984723850609241e-01*G0_0_2 + 1.027527882996626e-01*G0_1_0 + 3.522952741702724e-01*G0_1_1 + 1.027527882996625e-01*G0_1_2 + 2.984723850609246e-01*G0_2_0 + 1.027527882996630e-01*G0_2_1 - 1.859336169232003e-01*G0_2_2;
    block[2015] = 2.984723850609237e-01*G0_0_1 + 1.027527882996619e-01*G0_0_2 + 2.984723850609253e-01*G0_1_0 - 1.859336169232000e-01*G0_1_1 + 1.027527882996617e-01*G0_1_2 + 1.027527882996621e-01*G0_2_0 + 1.027527882996617e-01*G0_2_1 + 3.522952741702722e-01*G0_2_2;
    block[2016] = 1.374212528726395e-02*G0_0_0 + 1.374212528726397e-02*G0_0_1 + 1.374212528726399e-02*G0_0_2 + 1.891956102025517e-02*G0_1_0 + 1.891956102025519e-02*G0_1_1 + 1.891956102025522e-02*G0_1_2 + 1.891956102025513e-02*G0_2_0 + 1.891956102025512e-02*G0_2_1 + 1.891956102025522e-02*G0_2_2;
    block[2017] = -1.374212528726411e-02*G0_0_0;
    block[2018] = 5.177435732991197e-03*G0_0_1 + 1.891956102025515e-02*G0_1_1;
    block[2019] = -1.439452394313500e-02*G0_0_2 + 3.359853077735014e-02*G0_2_2;
    block[2020] = 1.878908128908083e-02*G0_0_0 + 9.394540644540329e-03*G0_0_1 + 9.394540644540430e-03*G0_1_0;
    block[2021] = -1.487468935385583e-02*G0_0_0 - 1.493992921944287e-02*G0_0_1 - 1.493992921944308e-02*G0_1_0 - 1.500516908503006e-02*G0_1_1;
    block[2022] = -1.174317580567690e-03*G0_0_0 - 1.239557446155081e-03*G0_0_1 - 1.239557446154702e-03*G0_1_0 - 1.304797311742120e-03*G0_1_1;
    block[2023] = -1.187365553684976e-02*G0_0_0 - 2.126819618138999e-02*G0_0_1 - 2.126819618139052e-02*G0_1_0 - 3.066273682593067e-02*G0_1_1;
    block[2024] = 1.187365553684976e-02*G0_0_0 - 9.394540644540287e-03*G0_0_1 + 1.187365553684973e-02*G0_0_2 + 2.126819618139052e-02*G0_1_0 - 1.878908128908055e-02*G0_1_1 + 2.126819618139047e-02*G0_1_2 + 2.126819618139065e-02*G0_2_1;
    block[2025] = 1.174317580567385e-03*G0_0_0 - 6.523986558739892e-05*G0_0_1 + 1.174317580567420e-03*G0_0_2 - 1.376561163887557e-02*G0_1_0 - 1.304797311748540e-04*G0_1_1 - 1.376561163887557e-02*G0_1_2 - 5.284429112554070e-02*G0_2_0 - 1.376561163887560e-02*G0_2_1 - 5.284429112554071e-02*G0_2_2;
    block[2026] = 1.487468935385566e-02*G0_0_0 - 6.523986558698760e-05*G0_0_1 + 1.487468935385563e-02*G0_0_2 + 1.363513190770114e-02*G0_1_0 - 1.304797311740127e-04*G0_1_1 + 1.363513190770121e-02*G0_1_2 - 2.544354757896435e-02*G0_2_0 + 1.363513190770120e-02*G0_2_1 - 2.544354757896439e-02*G0_2_2;
    block[2027] = -1.878908128908108e-02*G0_0_0 - 9.394540644540662e-03*G0_0_1 - 1.878908128908109e-02*G0_0_2 - 4.005727747047139e-02*G0_1_0 - 1.878908128908107e-02*G0_1_1 - 4.005727747047141e-02*G0_1_2 - 6.132547365186235e-02*G0_2_0 - 4.005727747047152e-02*G0_2_1 - 6.132547365186236e-02*G0_2_2;
    block[2028] = -9.394540644540605e-03*G0_0_1 - 9.394540644540516e-03*G0_0_2 - 9.394540644540551e-03*G0_1_0 - 3.066273682593090e-02*G0_1_1 - 3.066273682593088e-02*G0_1_2 - 9.394540644540504e-03*G0_2_0 - 3.066273682593136e-02*G0_2_1 - 3.066273682593135e-02*G0_2_2;
    block[2029] = -6.523986558698423e-05*G0_0_1 - 6.523986558701715e-05*G0_0_2 - 6.523986558693027e-05*G0_1_0 - 1.304797311741616e-03*G0_1_1 - 1.304797311741599e-03*G0_1_2 - 6.523986558704992e-05*G0_2_0 - 1.304797311741695e-03*G0_2_1 - 1.304797311741745e-03*G0_2_2;
    block[2030] = -6.523986558718735e-05*G0_0_1 - 6.523986558721378e-05*G0_0_2 - 6.523986558726578e-05*G0_1_0 - 1.500516908502999e-02*G0_1_1 - 1.500516908502993e-02*G0_1_2 - 6.523986558699783e-05*G0_2_0 - 1.500516908503018e-02*G0_2_1 - 1.500516908503016e-02*G0_2_2;
    block[2031] = -9.394540644540436e-03*G0_0_1 - 9.394540644540390e-03*G0_0_2 - 9.394540644540586e-03*G0_1_0 - 9.394540644540816e-03*G0_2_0;
    block[2032] = -6.413078787210660e-02*G0_0_0 - 6.413078787210665e-02*G0_0_1 - 5.473624722756621e-02*G0_0_2 - 1.118863694818542e-01*G0_1_0 - 1.118863694818543e-01*G0_1_1 - 9.061817330046404e-02*G0_1_2 - 9.061817330046422e-02*G0_2_0 - 9.061817330046421e-02*G0_2_1 - 6.934997711907355e-02*G0_2_2;
    block[2033] = 1.270872581636457e-01*G0_0_0 + 1.270872581636456e-01*G0_0_1 + 8.931337598872249e-02*G0_0_2 + 2.094199685345497e-01*G0_1_0 + 2.094199685345496e-01*G0_1_1 + 1.734728025960648e-01*G0_1_2 + 1.734728025960655e-01*G0_2_0 + 1.734728025960653e-01*G0_2_1 + 8.468134553203879e-02*G0_2_2;
    block[2034] = -1.247386230025108e-01*G0_0_0 - 1.247386230025107e-01*G0_0_1 - 6.236931150125534e-02*G0_0_2 - 2.713978408422828e-01*G0_1_0 - 2.713978408422828e-01*G0_1_1 - 1.980682319223967e-01*G0_1_2 - 1.980682319223973e-01*G0_2_0 - 1.980682319223972e-01*G0_2_1 - 3.392473010527869e-03*G0_2_2;
    block[2035] = 1.247386230025112e-01*G0_0_0 + 1.247386230025112e-01*G0_0_1 + 2.844458139596994e-02*G0_0_2 + 9.629404160654070e-02*G0_1_2 + 9.629404160654147e-02*G0_2_0 + 9.629404160654152e-02*G0_2_1 - 6.445698720004291e-02*G0_2_2;
    block[2036] = 6.413078787210678e-02*G0_0_0 + 9.394540644540244e-03*G0_0_2 + 9.394540644540567e-03*G0_2_0;
    block[2037] = -1.270872581636461e-01*G0_0_0 - 3.777388217492324e-02*G0_0_2 - 3.777388217492373e-02*G0_2_0 - 1.500516908503033e-02*G0_2_2;
    block[2038] = 1.247386230025112e-01*G0_0_0 + 6.236931150125520e-02*G0_0_2 + 6.236931150125585e-02*G0_2_0 + 4.762510187857417e-02*G0_2_2;
    block[2039] = -1.247386230025112e-01*G0_0_0 - 9.629404160654090e-02*G0_0_2 - 9.629404160654148e-02*G0_2_0 - 1.285225352065629e-01*G0_2_2;
    block[2040] = -4.775558160974742e-02*G0_0_1 - 1.187365553684978e-02*G0_0_2 - 1.118863694818541e-01*G0_1_1 - 2.126819618139044e-02*G0_1_2 - 2.126819618138996e-02*G0_2_1;
    block[2041] = 8.233271037090366e-02*G0_0_1 - 1.826716236438262e-03*G0_0_2 + 2.094199685345497e-01*G0_1_1 + 3.594716593848534e-02*G0_1_2 + 3.594716593848399e-02*G0_2_1 - 5.284429112554127e-02*G0_2_2;
    block[2042] = -1.466592178397719e-01*G0_0_1 - 1.096029741863089e-02*G0_0_2 - 2.713978408422830e-01*G0_1_1 - 7.332960891988635e-02*G0_1_2 - 7.332960891988539e-02*G0_2_1 + 1.213461499919827e-01*G0_2_2;
    block[2043] = -1.247386230025112e-01*G0_0_1 - 1.925880832130820e-01*G0_0_2 - 9.629404160654054e-02*G0_1_2 - 9.629404160654149e-02*G0_2_1 - 2.570450704131249e-01*G0_2_2;
    block[2044] = -1.056885822510811e-01*G0_0_0 - 5.284429112554115e-02*G0_0_1 - 3.001033817006048e-02*G0_0_2 - 5.284429112554029e-02*G0_1_0 - 1.500516908503019e-02*G0_1_2 - 3.001033817006011e-02*G0_2_0 - 1.500516908503022e-02*G0_2_1;
    block[2045] = 2.094199685345513e-01*G0_0_0 + 1.047099842672762e-01*G0_0_1 + 7.372104811340968e-02*G0_0_2 + 1.047099842672753e-01*G0_1_0 + 3.686052405670542e-02*G0_1_2 + 7.372104811340906e-02*G0_2_0 + 3.686052405670504e-02*G0_2_1 - 2.283395295548092e-02*G0_2_2;
    block[2046] = -5.427956816845666e-01*G0_0_0 - 2.713978408422834e-01*G0_0_1 - 2.713978408422826e-01*G0_0_2 - 2.713978408422829e-01*G0_1_0 - 1.356989204211417e-01*G0_1_2 - 2.713978408422838e-01*G0_2_0 - 1.356989204211423e-01*G0_2_1 + 5.219189246967121e-02*G0_2_2;
    block[2047] = 1.370037177328834e-02*G0_0_0 + 1.989815900406219e-02*G0_0_1 - 1.272177378948214e-02*G0_0_2 + 1.989815900406145e-02*G0_1_0 + 2.609594623483521e-02*G0_1_1 - 1.206937513361142e-02*G0_1_2 - 1.272177378948157e-02*G0_2_0 - 1.206937513361083e-02*G0_2_1;
    block[2048] = 2.348635161135106e-02*G0_0_0 - 8.122363265592369e-02*G0_0_1 + 4.599410523889617e-02*G0_0_2 - 8.122363265592367e-02*G0_1_0 - 1.859336169231985e-01*G0_1_1 + 9.133581182192374e-03*G0_1_2 + 4.599410523889582e-02*G0_2_0 + 9.133581182191961e-03*G0_2_1 - 8.807381854256954e-02*G0_2_2;
    block[2049] = -5.349668978141069e-02*G0_0_0 - 6.523986558706947e-04*G0_0_1 - 5.284429112554005e-02*G0_0_2 - 6.523986558700070e-04*G0_1_0 + 5.219189246966992e-02*G0_1_1 - 3.783912204051016e-02*G0_1_2 - 5.284429112554065e-02*G0_2_0 - 3.783912204051072e-02*G0_2_1;
    block[2050] = 5.349668978141065e-02*G0_0_0 + 5.284429112554028e-02*G0_0_1 + 6.523986558709743e-04*G0_0_2 + 6.523986558700284e-04*G0_1_0 + 1.056885822510802e-01*G0_1_1 - 2.218155429961002e-02*G0_1_2 + 5.284429112554073e-02*G0_2_0 - 2.218155429961043e-02*G0_2_1 + 1.056885822510821e-01*G0_2_2;
    block[2051] = -2.348635161135098e-02*G0_0_0 - 1.047099842672754e-01*G0_0_1 + 2.250775362754449e-02*G0_0_2 + 8.122363265592369e-02*G0_1_0 - 2.094199685345502e-01*G0_1_1 + 5.349668978141103e-02*G0_1_2 - 4.599410523889594e-02*G0_2_0 + 5.349668978141234e-02*G0_2_1 - 2.681358475629301e-01*G0_2_2;
    block[2052] = 5.427956816845666e-01*G0_0_0 + 2.713978408422827e-01*G0_0_1 + 2.713978408422836e-01*G0_0_2 + 2.713978408422827e-01*G0_1_0 + 5.427956816845660e-01*G0_1_1 + 2.713978408422827e-01*G0_1_2 + 2.713978408422836e-01*G0_2_0 + 2.713978408422827e-01*G0_2_1 + 6.471794666239082e-01*G0_2_2;
    block[2053] = -1.370037177328809e-02*G0_0_0 + 6.197787230773606e-03*G0_0_1 - 2.642214556276971e-02*G0_0_2 + 6.197787230774418e-03*G0_1_0 + 1.239557446154796e-02*G0_1_1 + 6.197787230773954e-03*G0_1_2 + 7.143765281786080e-02*G0_2_0 + 6.197787230773861e-03*G0_2_1 + 1.722332451499108e-01*G0_2_2;
    block[2054] = -2.094199685345494e-01*G0_0_0 - 1.047099842672740e-01*G0_0_1 - 1.356989204211413e-01*G0_0_2 - 2.906436011904734e-01*G0_1_0 - 2.094199685345493e-01*G0_1_1 - 2.629166583159608e-01*G0_1_2 - 3.901343962107824e-01*G0_2_0 - 2.629166583159618e-01*G0_2_1 - 5.845491956603037e-01*G0_2_2;
    block[2055] = 1.056885822510806e-01*G0_0_0 + 5.284429112554039e-02*G0_0_1 + 7.567824408102106e-02*G0_0_2 + 1.050361835952096e-01*G0_1_0 + 1.056885822510805e-01*G0_1_1 + 1.278701365506903e-01*G0_1_2 + 1.800620290203609e-01*G0_2_0 + 1.278701365506909e-01*G0_2_1 + 2.557402731013835e-01*G0_2_2;
    block[2056] = 2.713978408422831e-01*G0_0_1 + 1.356989204211421e-01*G0_0_2 + 2.713978408422829e-01*G0_1_0 + 1.356989204211411e-01*G0_1_2 + 1.356989204211414e-01*G0_2_0 + 1.356989204211419e-01*G0_2_1 + 3.235897333119549e-01*G0_2_2;
    block[2057] = -1.047099842672761e-01*G0_0_1 - 6.784946021057109e-02*G0_0_2 - 1.047099842672750e-01*G0_1_0 - 3.686052405670400e-02*G0_1_2 - 6.784946021057099e-02*G0_2_0 - 3.686052405670499e-02*G0_2_1 - 9.655500106889010e-02*G0_2_2;
    block[2058] = 5.284429112554109e-02*G0_0_1 + 3.783912204051067e-02*G0_0_2 + 5.284429112554080e-02*G0_1_0 + 1.500516908502987e-02*G0_1_2 + 3.783912204051126e-02*G0_2_0 + 1.500516908503027e-02*G0_2_1 + 3.001033817006098e-02*G0_2_2;
    block[2059] = -1.047099842672750e-01*G0_0_1 - 6.784946021057127e-02*G0_0_2 - 1.047099842672750e-01*G0_1_0 - 1.859336169231992e-01*G0_1_1 - 1.950671981053906e-01*G0_1_2 - 6.784946021057052e-02*G0_2_0 - 1.950671981053911e-01*G0_2_1 - 2.922745978301529e-01*G0_2_2;
    block[2060] = 6.197787230773391e-03*G0_0_1 + 5.545388574902632e-03*G0_0_2 + 6.197787230773348e-03*G0_1_0 + 2.609594623483499e-02*G0_1_1 + 3.816532136844565e-02*G0_1_2 + 5.545388574901859e-03*G0_2_0 + 3.816532136844564e-02*G0_2_1 + 5.023469650205717e-02*G0_2_2;
    block[2061] = 5.284429112554023e-02*G0_0_1 + 3.783912204051056e-02*G0_0_2 + 5.284429112554035e-02*G0_1_0 + 5.219189246966965e-02*G0_1_1 + 9.003101451018009e-02*G0_1_2 + 3.783912204051069e-02*G0_2_0 + 9.003101451018061e-02*G0_2_1 + 1.278701365506925e-01*G0_2_2;
    block[2062] = 1.500516908502974e-02*G0_0_1 + 3.001033817005953e-02*G0_0_2 + 1.500516908502991e-02*G0_1_0 + 3.001033817006012e-02*G0_1_1 - 7.828783870450280e-03*G0_1_2 + 3.001033817006018e-02*G0_2_0 - 7.828783870450490e-03*G0_2_1 - 4.566790591096190e-02*G0_2_2;
    block[2063] = 6.523986558708115e-04*G0_0_1 + 1.304797311742046e-03*G0_0_2 + 6.523986558710231e-04*G0_1_0 + 1.304797311741185e-03*G0_1_1 - 1.076457782186925e-02*G0_1_2 + 1.304797311741517e-03*G0_2_0 - 1.076457782186982e-02*G0_2_1 - 2.283395295548093e-02*G0_2_2;
    block[2064] = 1.500516908503013e-02*G0_0_1 + 3.001033817006055e-02*G0_0_2 + 1.500516908502998e-02*G0_1_0 + 3.001033817006018e-02*G0_1_1 + 1.500516908503048e-02*G0_1_2 + 3.001033817006069e-02*G0_2_0 + 1.500516908503045e-02*G0_2_1;
    block[2065] = 6.523986558711603e-04*G0_0_1 + 1.272177378948176e-02*G0_0_2 + 6.523986558708008e-04*G0_1_0 + 1.304797311742180e-03*G0_1_1 + 6.523986558710420e-04*G0_1_2 + 1.272177378948255e-02*G0_2_0 + 6.523986558713704e-04*G0_2_1 - 8.807381854256779e-02*G0_2_2;
    block[2066] = 6.523986558711043e-04*G0_0_1 + 1.272177378948209e-02*G0_0_2 + 6.523986558710764e-04*G0_1_0 + 1.304797311742189e-03*G0_1_1 + 1.206937513361130e-02*G0_1_2 + 1.272177378948178e-02*G0_2_0 + 1.206937513361111e-02*G0_2_1;
    block[2067] = 1.500516908502978e-02*G0_0_1 + 5.284429112554009e-02*G0_0_2 + 1.500516908503029e-02*G0_1_0 + 3.001033817005942e-02*G0_1_1 + 3.783912204051025e-02*G0_1_2 + 5.284429112554051e-02*G0_2_0 + 3.783912204051027e-02*G0_2_1;
    block[2068] = -2.609594623483431e-02*G0_0_1 - 7.502584542514912e-02*G0_0_2 - 2.609594623483455e-02*G0_1_0 - 5.219189246966974e-02*G0_1_1 - 4.240591263160744e-02*G0_1_2 - 7.502584542514969e-02*G0_2_0 - 4.240591263160616e-02*G0_2_1 + 1.435277042915937e-01*G0_2_2;
    block[2069] = -2.609594623483524e-02*G0_0_1 - 7.502584542515177e-02*G0_0_2 - 2.609594623483496e-02*G0_1_0 - 5.219189246967006e-02*G0_1_1 - 2.609594623483639e-02*G0_1_2 - 7.502584542515123e-02*G0_2_0 - 2.609594623483458e-02*G0_2_1 + 4.566790591096143e-02*G0_2_2;
    block[2070] = -2.609594623483544e-02*G0_0_1 - 5.871587902837811e-02*G0_0_2 - 2.609594623483601e-02*G0_1_0 - 5.219189246966995e-02*G0_1_1 - 9.785979838063312e-03*G0_1_2 - 5.871587902837924e-02*G0_2_0 - 9.785979838064042e-03*G0_2_1 + 1.761476370851369e-01*G0_2_2;
    block[2071] = 1.859336169231987e-01*G0_0_1 + 3.164133480973721e-01*G0_0_2 + 1.859336169231981e-01*G0_1_0 + 3.718672338463977e-01*G0_1_1 + 1.859336169231994e-01*G0_1_2 + 3.164133480973733e-01*G0_2_0 + 1.859336169231992e-01*G0_2_1 - 1.500516908503025e-01*G0_2_2;
    block[2072] = -3.457190957190927e-02*G0_0_0 - 3.457190957190926e-02*G0_0_1 - 3.457190957190925e-02*G0_0_2 - 2.984723850609245e-02*G0_1_0 - 2.984723850609250e-02*G0_1_1 - 2.984723850609244e-02*G0_1_2 - 2.984723850609236e-02*G0_2_0 - 2.984723850609235e-02*G0_2_1 - 2.984723850609236e-02*G0_2_2;
    block[2073] = -9.464999699374659e-03*G0_0_0;
    block[2074] = 4.724671065816879e-03*G0_0_1 - 2.984723850609238e-02*G0_1_1;
    block[2075] = 2.278176106301091e-03*G0_0_2 + 1.174317580567578e-02*G0_2_2;
    block[2076] = 2.926007971580906e-02*G0_0_0 + 3.294613212148278e-03*G0_0_1 + 3.294613212147775e-03*G0_1_0;
    block[2077] = -1.898480088584302e-02*G0_0_0 - 9.492400442922010e-03*G0_0_1 - 9.492400442921245e-03*G0_1_0 - 6.523986558708084e-04*G0_1_1;
    block[2078] = 3.522952741703141e-03*G0_0_0 + 6.491366625916104e-03*G0_0_1 + 6.491366625914851e-03*G0_1_0 + 8.807381854256759e-03*G0_1_1;
    block[2079] = 4.296045148909631e-02*G0_0_0 + 4.227543290043158e-02*G0_0_1 + 4.227543290043252e-02*G0_1_0 + 6.426126760328038e-02*G0_1_1;
    block[2080] = -4.296045148909644e-02*G0_0_0 - 3.591454600569169e-02*G0_0_1 - 4.296045148909646e-02*G0_0_2 - 4.227543290043261e-02*G0_1_0 + 9.208607027617331e-02*G0_1_1 - 4.227543290043267e-02*G0_1_2 - 4.227543290043304e-02*G0_2_1;
    block[2081] = 1.824106641814954e-01*G0_0_0 + 9.854481696929535e-02*G0_0_1 + 1.824106641814955e-01*G0_0_2 + 1.885758314794757e-01*G0_1_0 - 6.223883177008094e-02*G0_1_1 + 1.885758314794757e-01*G0_1_2 + 1.047099842672751e-01*G0_2_0 + 1.885758314794760e-01*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[2082] = -1.669488160373556e-01*G0_0_0 - 1.607836487393763e-01*G0_0_1 - 1.669488160373557e-01*G0_0_2 - 2.508146632495564e-01*G0_1_0 - 6.223883177008117e-02*G0_1_1 - 2.508146632495565e-01*G0_1_2 - 3.346805104617574e-01*G0_2_0 - 2.508146632495569e-01*G0_2_1 - 3.346805104617576e-01*G0_2_2;
    block[2083] = 1.273155976932002e-01*G0_0_0 + 1.280006162818650e-01*G0_0_1 + 1.273155976932002e-01*G0_0_2 + 1.343615031766057e-01*G0_1_0 + 9.208607027617370e-02*G0_1_1 + 1.343615031766057e-01*G0_1_2 + 1.766369360770383e-01*G0_2_0 + 1.343615031766060e-01*G0_2_1 + 1.766369360770382e-01*G0_2_2;
    block[2084] = 2.267085329151274e-02*G0_0_0 + 2.198583470284802e-02*G0_0_1 + 2.198583470284798e-02*G0_0_2 + 2.198583470284839e-02*G0_1_0 + 6.426126760328058e-02*G0_1_1 + 6.426126760328062e-02*G0_1_2 + 2.198583470284823e-02*G0_2_0 + 6.426126760328056e-02*G0_2_1 + 6.426126760328058e-02*G0_2_2;
    block[2085] = -6.523986558708579e-04*G0_0_0 + 2.316015228341600e-03*G0_0_1 + 2.316015228341573e-03*G0_0_2 + 2.316015228341494e-03*G0_1_0 + 8.807381854256710e-03*G0_1_1 + 8.807381854256667e-03*G0_1_2 + 2.316015228341692e-03*G0_2_0 + 8.807381854256660e-03*G0_2_1 + 8.807381854256653e-03*G0_2_2;
    block[2086] = -6.523986558709484e-04*G0_0_0 + 8.840001787049995e-03*G0_0_1 + 8.840001787050035e-03*G0_0_2 + 8.840001787050567e-03*G0_1_0 - 6.523986558711633e-04*G0_1_1 - 6.523986558710877e-04*G0_1_2 + 8.840001787050357e-03*G0_2_0 - 6.523986558710201e-04*G0_2_1 - 6.523986558710210e-04*G0_2_2;
    block[2087] = 2.267085329151302e-02*G0_0_0 - 3.294613212148058e-03*G0_0_1 - 3.294613212148132e-03*G0_0_2 - 3.294613212147834e-03*G0_1_0 - 3.294613212147901e-03*G0_2_0;
    block[2088] = 4.397166940569652e-02*G0_0_0 + 4.397166940569654e-02*G0_0_1 + 4.465668799436131e-02*G0_0_2 + 1.285225352065617e-01*G0_1_0 + 1.285225352065618e-01*G0_1_1 + 8.624710230612974e-02*G0_1_2 + 8.624710230612928e-02*G0_2_0 + 8.624710230612936e-02*G0_2_1 + 4.397166940569705e-02*G0_2_2;
    block[2089] = -4.364547007776119e-02*G0_0_0 - 4.364547007776112e-02*G0_0_1 - 9.753359905269793e-03*G0_0_2 + 3.718672338464009e-02*G0_1_0 + 3.718672338463998e-02*G0_1_1 - 3.715410345184660e-02*G0_1_2 - 3.715410345184588e-02*G0_2_0 - 3.715410345184595e-02*G0_2_1 - 6.784946021057669e-03*G0_2_2;
    block[2090] = -1.559232787531447e-02*G0_0_0 - 1.559232787531445e-02*G0_0_1 + 3.294613212147911e-03*G0_0_2 - 6.197787230773999e-03*G0_1_0 - 6.197787230773967e-03*G0_1_1 - 2.508472831823497e-02*G0_1_2 - 2.508472831823549e-02*G0_2_0 - 2.508472831823543e-02*G0_2_1 + 1.278701365506954e-02*G0_2_2;
    block[2091] = 2.544354757896284e-03*G0_0_0 + 2.544354757896268e-03*G0_0_1 - 5.904207835631404e-03*G0_0_2 + 5.838967970044213e-03*G0_1_2 + 5.838967970044360e-03*G0_2_0 + 5.838967970044347e-03*G0_2_1 - 3.186967433929242e-02*G0_2_2;
    block[2092] = 6.589226424296183e-03*G0_0_0 + 3.294613212148190e-03*G0_0_2 + 3.294613212147942e-03*G0_2_0;
    block[2093] = 4.501550725509169e-03*G0_0_0 + 1.924576034819216e-03*G0_0_2 + 1.924576034818991e-03*G0_2_0 - 6.523986558709767e-04*G0_2_2;
    block[2094] = -1.050361835952097e-02*G0_0_0 - 1.308059305021092e-02*G0_0_2 - 1.308059305021102e-02*G0_2_0 - 1.565756774090096e-02*G0_2_2;
    block[2095] = -2.544354757896299e-03*G0_0_0 - 5.838967970044229e-03*G0_0_2 - 5.838967970044357e-03*G0_2_0 - 9.133581182192353e-03*G0_2_2;
    block[2096] = 8.455086580086432e-02*G0_0_1 + 4.296045148909629e-02*G0_0_2 + 1.285225352065615e-01*G0_1_1 + 4.227543290043244e-02*G0_1_2 + 4.227543290043237e-02*G0_2_1;
    block[2097] = 8.083219346240166e-02*G0_0_1 + 1.082329370089783e-01*G0_0_2 + 3.718672338464019e-02*G0_1_1 + 7.434082683648605e-02*G0_1_2 + 7.434082683648587e-02*G0_2_1 + 1.047099842672746e-01*G0_2_2;
    block[2098] = 9.394540644539923e-03*G0_0_1 + 3.777388217492279e-02*G0_0_2 - 6.197787230773967e-03*G0_1_1 + 1.888694108746131e-02*G0_1_2 + 1.888694108746139e-02*G0_2_1 + 5.675868306076585e-02*G0_2_2;
    block[2099] = -2.544354757896278e-03*G0_0_1 - 1.428753056357190e-02*G0_0_2 - 5.838967970044313e-03*G0_1_2 - 5.838967970044372e-03*G0_2_1 - 4.354761027938096e-02*G0_2_2;
    block[2100] = -2.544354757896396e-02*G0_0_0 - 1.304797311740782e-03*G0_0_1 - 1.272177378948191e-02*G0_0_2 - 1.304797311741645e-03*G0_1_0 - 6.523986558714286e-04*G0_1_2 - 1.272177378948231e-02*G0_2_0 - 6.523986558709088e-04*G0_2_1;
    block[2101] = -1.663616572470708e-02*G0_0_0 - 1.810406270041622e-02*G0_0_1 + 1.467896975710067e-03*G0_0_2 - 1.810406270041693e-02*G0_1_0 - 1.027527882996580e-02*G0_1_2 + 1.467896975709480e-03*G0_2_0 - 1.027527882996627e-02*G0_2_1 + 1.957195967612651e-02*G0_2_2;
    block[2102] = 1.370037177328812e-02*G0_0_0 - 6.197787230772914e-03*G0_0_1 + 2.642214556276991e-02*G0_0_2 - 6.197787230773666e-03*G0_1_0 - 5.545388574902924e-03*G0_1_2 + 2.642214556276969e-02*G0_2_0 - 5.545388574902732e-03*G0_2_1 + 3.914391935225167e-02*G0_2_2;
    block[2103] = 5.675868306076642e-02*G0_0_0 + 2.837934153038249e-02*G0_0_1 + 2.837934153038317e-02*G0_0_2 + 2.837934153038332e-02*G0_1_0 - 4.892989919031312e-03*G0_1_1 + 1.418967076519181e-02*G0_1_2 + 2.837934153038343e-02*G0_2_0 + 1.418967076519154e-02*G0_2_1;
    block[2104] = 1.497254915223644e-01*G0_0_0 + 7.486274576118120e-02*G0_0_1 + 1.213461499919819e-01*G0_0_2 + 7.486274576118175e-02*G0_1_0 + 1.957195967612506e-02*G0_1_1 + 6.067307499599097e-02*G0_1_2 + 1.213461499919812e-01*G0_2_0 + 6.067307499599020e-02*G0_2_1 + 9.296680846159870e-02*G0_2_2;
    block[2105] = 2.094199685345493e-01*G0_0_0 + 1.356989204211418e-01*G0_0_1 + 1.047099842672743e-01*G0_0_2 + 1.356989204211409e-01*G0_1_0 + 3.914391935225183e-02*G0_1_1 + 6.784946021056965e-02*G0_1_2 + 1.047099842672746e-01*G0_2_0 + 6.784946021057045e-02*G0_2_1;
    block[2106] = -2.094199685345496e-01*G0_0_0 - 3.901343962107807e-01*G0_0_1 - 2.906436011904736e-01*G0_0_2 - 1.356989204211410e-01*G0_1_0 - 5.845491956603021e-01*G0_1_1 - 2.629166583159616e-01*G0_1_2 - 1.047099842672748e-01*G0_2_0 - 2.629166583159613e-01*G0_2_1 - 2.094199685345494e-01*G0_2_2;
    block[2107] = -1.497254915223644e-01*G0_0_0 - 1.776155340608457e-01*G0_0_1 - 3.268517265913071e-01*G0_0_2 - 7.486274576118183e-02*G0_1_0 - 3.718672338463966e-02*G0_1_1 - 2.240989382916445e-01*G0_1_2 - 1.213461499919813e-01*G0_2_0 - 2.240989382916447e-01*G0_2_1 - 4.481978765832897e-01*G0_2_2;
    block[2108] = -1.370037177328809e-02*G0_0_0 + 6.197787230774415e-03*G0_0_1 + 7.143765281786080e-02*G0_0_2 + 6.197787230773602e-03*G0_1_0 + 1.239557446154795e-02*G0_1_1 + 6.197787230773862e-03*G0_1_2 - 2.642214556276971e-02*G0_2_0 + 6.197787230773954e-03*G0_2_1 + 1.722332451499108e-01*G0_2_2;
    block[2109] = 7.261197039842806e-01*G0_0_0 + 4.560266604537396e-01*G0_0_1 + 4.560266604537397e-01*G0_0_2 + 4.560266604537396e-01*G0_1_0 + 9.120533209074806e-01*G0_1_1 + 4.560266604537397e-01*G0_1_2 + 4.560266604537397e-01*G0_2_0 + 4.560266604537397e-01*G0_2_1 + 7.261197039842814e-01*G0_2_2;
    block[2110] = 6.556606491502232e-02*G0_0_0 + 1.404288106762053e-01*G0_0_1 + 3.767602237654264e-02*G0_0_2 + 3.767602237654173e-02*G0_1_0 - 3.718672338464047e-02*G0_1_1 + 1.869122149070045e-01*G0_1_2 + 1.404288106762049e-01*G0_2_0 + 1.869122149070048e-01*G0_2_1 - 3.718672338464020e-02*G0_2_2;
    block[2111] = -2.681358475629282e-01*G0_0_0 - 1.944147994495196e-01*G0_0_1 - 2.221417423240315e-01*G0_0_2 - 4.488502752391599e-01*G0_1_0 - 5.845491956603018e-01*G0_1_1 - 3.216325373443398e-01*G0_1_2 - 2.906436011904730e-01*G0_2_0 - 3.216325373443399e-01*G0_2_1 - 2.681358475629279e-01*G0_2_2;
    block[2112] = 2.609594623483538e-02*G0_0_0 + 6.197787230772805e-03*G0_0_1 + 3.816532136844639e-02*G0_0_2 + 6.197787230773967e-03*G0_1_0 + 5.545388574902854e-03*G0_1_2 + 3.816532136844643e-02*G0_2_0 + 5.545388574902691e-03*G0_2_1 + 5.023469650205767e-02*G0_2_2;
    block[2113] = 1.957195967612596e-02*G0_0_0 + 1.810406270041639e-02*G0_0_1 + 2.984723850609242e-02*G0_0_2 + 1.810406270041554e-02*G0_1_0 + 1.027527882996575e-02*G0_1_2 + 2.984723850609221e-02*G0_2_0 + 1.027527882996634e-02*G0_2_1 + 4.012251733605872e-02*G0_2_2;
    block[2114] = -2.283395295548060e-02*G0_0_0 + 1.304797311740545e-03*G0_0_1 - 1.076457782186934e-02*G0_0_2 + 1.304797311742112e-03*G0_1_0 + 6.523986558701660e-04*G0_1_2 - 1.076457782186920e-02*G0_2_0 + 6.523986558707921e-04*G0_2_1 + 1.304797311741830e-03*G0_2_2;
    block[2115] = 1.957195967612606e-02*G0_0_0 - 5.529078608505688e-02*G0_0_1 + 5.382288910934134e-03*G0_0_2 - 5.529078608505604e-02*G0_1_0 + 1.957195967612622e-02*G0_1_1 - 4.110111531986596e-02*G0_1_2 + 5.382288910934691e-03*G0_2_0 - 4.110111531986495e-02*G0_2_1 - 8.807381854257676e-03*G0_2_2;
    block[2116] = -4.892989919031597e-03*G0_0_0 - 3.327233144941491e-02*G0_0_1 - 1.908266068422313e-02*G0_0_2 - 3.327233144941453e-02*G0_1_0 - 4.892989919030828e-03*G0_1_1 - 1.908266068422195e-02*G0_1_2 - 1.908266068422309e-02*G0_2_0 - 1.908266068422324e-02*G0_2_1 - 3.327233144941424e-02*G0_2_2;
    block[2117] = -2.283395295548056e-02*G0_0_0 - 9.655500106888927e-02*G0_0_1 - 5.969447701218433e-02*G0_0_2 - 9.655500106888910e-02*G0_1_0 + 3.914391935225255e-02*G0_1_1 - 2.870554085831787e-02*G0_1_2 - 5.969447701218498e-02*G0_2_0 - 2.870554085831804e-02*G0_2_1 - 9.655500106888826e-02*G0_2_2;
    block[2118] = -8.807381854256732e-02*G0_0_0 - 9.720739972475935e-02*G0_0_1 - 1.340679237814643e-01*G0_0_2 - 9.720739972475891e-02*G0_1_0 - 2.922745978301500e-01*G0_1_1 - 2.244251376195795e-01*G0_1_2 - 1.340679237814636e-01*G0_2_0 - 2.244251376195791e-01*G0_2_1 - 1.565756774090088e-01*G0_2_2;
    block[2119] = 1.957195967612605e-02*G0_0_0 - 4.110111531986509e-02*G0_0_1 - 5.529078608505743e-02*G0_0_2 - 4.110111531986592e-02*G0_1_0 - 8.807381854256743e-03*G0_1_1 + 5.382288910934040e-03*G0_1_2 - 5.529078608505697e-02*G0_2_0 + 5.382288910934880e-03*G0_2_1 + 1.957195967612558e-02*G0_2_2;
    block[2120] = -8.807381854256807e-02*G0_0_0 + 6.523986558716558e-04*G0_0_1 + 1.272177378948160e-02*G0_0_2 + 6.523986558712781e-04*G0_1_0 + 1.304797311741554e-03*G0_1_1 + 6.523986558711032e-04*G0_1_2 + 1.272177378948225e-02*G0_2_0 + 6.523986558709539e-04*G0_2_1;
    block[2121] = 9.296680846159837e-02*G0_0_0 + 2.280133302268690e-01*G0_0_1 + 3.630598519921395e-01*G0_0_2 + 2.280133302268686e-01*G0_1_0 + 4.560266604537386e-01*G0_1_1 + 2.280133302268691e-01*G0_1_2 + 3.630598519921397e-01*G0_2_0 + 2.280133302268687e-01*G0_2_1 + 9.296680846159869e-02*G0_2_2;
    block[2122] = 9.296680846160028e-02*G0_0_0 + 3.229373346560768e-02*G0_0_1 - 2.837934153038290e-02*G0_0_2 + 3.229373346560907e-02*G0_1_0 - 8.807381854256632e-03*G0_1_1 - 1.418967076519158e-02*G0_1_2 - 2.837934153038269e-02*G0_2_0 - 1.418967076519160e-02*G0_2_1;
    block[2123] = -1.859336169231985e-01*G0_0_0 - 1.950671981053894e-01*G0_0_1 - 1.047099842672745e-01*G0_0_2 - 1.950671981053905e-01*G0_1_0 - 2.922745978301499e-01*G0_1_1 - 6.784946021056973e-02*G0_1_2 - 1.047099842672744e-01*G0_2_0 - 6.784946021056967e-02*G0_2_1;
    block[2124] = 1.467896975709446e-01*G0_0_0 + 4.452620826318689e-01*G0_0_1 + 2.495424858706080e-01*G0_0_2 + 4.452620826318707e-01*G0_1_0 - 3.914391935225355e-02*G0_1_1 + 2.495424858706087e-01*G0_1_2 + 2.495424858706082e-01*G0_2_0 + 2.495424858706083e-01*G0_2_1 + 3.522952741702710e-01*G0_2_2;
    block[2125] = 1.467896975709476e-01*G0_0_0 + 4.892989919032808e-03*G0_0_1 + 5.382288910934784e-02*G0_0_2 + 4.892989919030814e-03*G0_1_0 + 9.785979838062191e-03*G0_1_1 + 4.892989919031985e-03*G0_1_2 + 5.382288910934707e-02*G0_2_0 + 4.892989919031908e-03*G0_2_1 - 3.914391935225173e-02*G0_2_2;
    block[2126] = -7.828783870450464e-01*G0_0_0 - 4.844060019841220e-01*G0_0_1 - 4.844060019841209e-01*G0_0_2 - 4.844060019841228e-01*G0_1_0 - 3.914391935225099e-02*G0_1_1 - 2.886864052228599e-01*G0_1_2 - 4.844060019841229e-01*G0_2_0 - 2.886864052228609e-01*G0_2_1 - 1.859336169231973e-01*G0_2_2;
    block[2127] = -4.892989919031487e-02*G0_0_0 - 1.957195967612414e-02*G0_0_1 - 1.418967076519136e-01*G0_0_2 - 1.957195967612465e-02*G0_1_0 - 3.914391935225128e-02*G0_1_1 - 1.957195967612612e-02*G0_1_2 - 1.418967076519143e-01*G0_2_0 - 1.957195967612510e-02*G0_2_1 - 2.348635161135139e-01*G0_2_2;
    block[2128] = -3.457190957190911e-02*G0_0_0 - 3.457190957190912e-02*G0_0_1 - 3.457190957190914e-02*G0_0_2 - 2.984723850609225e-02*G0_1_0 - 2.984723850609220e-02*G0_1_1 - 2.984723850609225e-02*G0_1_2 - 2.984723850609226e-02*G0_2_0 - 2.984723850609221e-02*G0_2_1 - 2.984723850609232e-02*G0_2_2;
    block[2129] = -9.464999699374683e-03*G0_0_0;
    block[2130] = 2.278176106301188e-03*G0_0_1 + 1.174317580567582e-02*G0_1_1;
    block[2131] = 4.724671065816845e-03*G0_0_2 - 2.984723850609261e-02*G0_2_2;
    block[2132] = 6.589226424296011e-03*G0_0_0 + 3.294613212148093e-03*G0_0_1 + 3.294613212148090e-03*G0_1_0;
    block[2133] = 4.501550725509279e-03*G0_0_0 + 1.924576034819204e-03*G0_0_1 + 1.924576034819182e-03*G0_1_0 - 6.523986558709093e-04*G0_1_1;
    block[2134] = -1.050361835952131e-02*G0_0_0 - 1.308059305021102e-02*G0_0_1 - 1.308059305021119e-02*G0_1_0 - 1.565756774090093e-02*G0_1_1;
    block[2135] = -2.544354757896319e-03*G0_0_0 - 5.838967970044561e-03*G0_0_1 - 5.838967970044170e-03*G0_1_0 - 9.133581182192336e-03*G0_1_1;
    block[2136] = 2.544354757896408e-03*G0_0_0 - 5.904207835631722e-03*G0_0_1 + 2.544354757896353e-03*G0_0_2 + 5.838967970044207e-03*G0_1_0 - 3.186967433929246e-02*G0_1_1 + 5.838967970044209e-03*G0_1_2 + 5.838967970044233e-03*G0_2_1;
    block[2137] = -1.559232787531395e-02*G0_0_0 + 3.294613212148275e-03*G0_0_1 - 1.559232787531381e-02*G0_0_2 - 2.508472831823511e-02*G0_1_0 + 1.278701365506942e-02*G0_1_1 - 2.508472831823509e-02*G0_1_2 - 6.197787230773565e-03*G0_2_0 - 2.508472831823501e-02*G0_2_1 - 6.197787230773705e-03*G0_2_2;
    block[2138] = -4.364547007776117e-02*G0_0_0 - 9.753359905269680e-03*G0_0_1 - 4.364547007776128e-02*G0_0_2 - 3.715410345184610e-02*G0_1_0 - 6.784946021057167e-03*G0_1_1 - 3.715410345184609e-02*G0_1_2 + 3.718672338464037e-02*G0_2_0 - 3.715410345184610e-02*G0_2_1 + 3.718672338464039e-02*G0_2_2;
    block[2139] = 4.397166940569690e-02*G0_0_0 + 4.465668799436120e-02*G0_0_1 + 4.397166940569698e-02*G0_0_2 + 8.624710230612938e-02*G0_1_0 + 4.397166940569672e-02*G0_1_1 + 8.624710230612936e-02*G0_1_2 + 1.285225352065622e-01*G0_2_0 + 8.624710230612925e-02*G0_2_1 + 1.285225352065622e-01*G0_2_2;
    block[2140] = 2.267085329151270e-02*G0_0_0 + 2.198583470284844e-02*G0_0_1 + 2.198583470284846e-02*G0_0_2 + 2.198583470284802e-02*G0_1_0 + 6.426126760328060e-02*G0_1_1 + 6.426126760328060e-02*G0_1_2 + 2.198583470284826e-02*G0_2_0 + 6.426126760328119e-02*G0_2_1 + 6.426126760328117e-02*G0_2_2;
    block[2141] = -6.523986558707921e-04*G0_0_0 + 2.316015228341562e-03*G0_0_1 + 2.316015228341556e-03*G0_0_2 + 2.316015228342070e-03*G0_1_0 + 8.807381854256825e-03*G0_1_1 + 8.807381854256823e-03*G0_1_2 + 2.316015228341760e-03*G0_2_0 + 8.807381854256854e-03*G0_2_1 + 8.807381854256887e-03*G0_2_2;
    block[2142] = -6.523986558709702e-04*G0_0_0 + 8.840001787050546e-03*G0_0_1 + 8.840001787050546e-03*G0_0_2 + 8.840001787049977e-03*G0_1_0 - 6.523986558710429e-04*G0_1_1 - 6.523986558710694e-04*G0_1_2 + 8.840001787050052e-03*G0_2_0 - 6.523986558708077e-04*G0_2_1 - 6.523986558708552e-04*G0_2_2;
    block[2143] = 2.267085329151294e-02*G0_0_0 - 3.294613212148055e-03*G0_0_1 - 3.294613212148056e-03*G0_0_2 - 3.294613212147646e-03*G0_1_0 - 3.294613212147594e-03*G0_2_0;
    block[2144] = 1.273155976932005e-01*G0_0_0 + 1.273155976932006e-01*G0_0_1 + 1.280006162818649e-01*G0_0_2 + 1.766369360770385e-01*G0_1_0 + 1.766369360770384e-01*G0_1_1 + 1.343615031766060e-01*G0_1_2 + 1.343615031766059e-01*G0_2_0 + 1.343615031766060e-01*G0_2_1 + 9.208607027617319e-02*G0_2_2;
    block[2145] = -1.669488160373559e-01*G0_0_0 - 1.669488160373560e-01*G0_0_1 - 1.607836487393763e-01*G0_0_2 - 3.346805104617575e-01*G0_1_0 - 3.346805104617573e-01*G0_1_1 - 2.508146632495568e-01*G0_1_2 - 2.508146632495572e-01*G0_2_0 - 2.508146632495569e-01*G0_2_1 - 6.223883177008018e-02*G0_2_2;
    block[2146] = 1.824106641814960e-01*G0_0_0 + 1.824106641814960e-01*G0_0_1 + 9.854481696929489e-02*G0_0_2 + 1.047099842672746e-01*G0_1_0 + 1.047099842672746e-01*G0_1_1 + 1.885758314794755e-01*G0_1_2 + 1.885758314794758e-01*G0_2_0 + 1.885758314794758e-01*G0_2_1 - 6.223883177008267e-02*G0_2_2;
    block[2147] = -4.296045148909691e-02*G0_0_0 - 4.296045148909694e-02*G0_0_1 - 3.591454600569133e-02*G0_0_2 - 4.227543290043241e-02*G0_1_2 - 4.227543290043306e-02*G0_2_0 - 4.227543290043308e-02*G0_2_1 + 9.208607027617442e-02*G0_2_2;
    block[2148] = 2.926007971580893e-02*G0_0_0 + 3.294613212148153e-03*G0_0_2 + 3.294613212147997e-03*G0_2_0;
    block[2149] = -1.898480088584312e-02*G0_0_0 - 9.492400442921774e-03*G0_0_2 - 9.492400442921193e-03*G0_2_0 - 6.523986558708180e-04*G0_2_2;
    block[2150] = 3.522952741703059e-03*G0_0_0 + 6.491366625915521e-03*G0_0_2 + 6.491366625914931e-03*G0_2_0 + 8.807381854256620e-03*G0_2_2;
    block[2151] = 4.296045148909688e-02*G0_0_0 + 4.227543290043244e-02*G0_0_2 + 4.227543290043305e-02*G0_2_0 + 6.426126760328157e-02*G0_2_2;
    block[2152] = -1.428753056357248e-02*G0_0_1 - 2.544354757896352e-03*G0_0_2 - 4.354761027938097e-02*G0_1_1 - 5.838967970044233e-03*G0_1_2 - 5.838967970045100e-03*G0_2_1;
    block[2153] = 3.777388217492419e-02*G0_0_1 + 9.394540644540568e-03*G0_0_2 + 5.675868306076634e-02*G0_1_1 + 1.888694108746184e-02*G0_1_2 + 1.888694108746318e-02*G0_2_1 - 6.197787230772659e-03*G0_2_2;
    block[2154] = 1.082329370089774e-01*G0_0_1 + 8.083219346240135e-02*G0_0_2 + 1.047099842672747e-01*G0_1_1 + 7.434082683648581e-02*G0_1_2 + 7.434082683648494e-02*G0_2_1 + 3.718672338463941e-02*G0_2_2;
    block[2155] = 4.296045148909689e-02*G0_0_1 + 8.455086580086490e-02*G0_0_2 + 4.227543290043228e-02*G0_1_2 + 4.227543290043307e-02*G0_2_1 + 1.285225352065625e-01*G0_2_2;
    block[2156] = -2.544354757896459e-02*G0_0_0 - 1.272177378948238e-02*G0_0_1 - 1.304797311741528e-03*G0_0_2 - 1.272177378948278e-02*G0_1_0 - 6.523986558708660e-04*G0_1_2 - 1.304797311741861e-03*G0_2_0 - 6.523986558709949e-04*G0_2_1;
    block[2157] = 5.675868306076558e-02*G0_0_0 + 2.837934153038213e-02*G0_0_1 + 2.837934153038186e-02*G0_0_2 + 2.837934153038394e-02*G0_1_0 + 1.418967076519139e-02*G0_1_2 + 2.837934153038296e-02*G0_2_0 + 1.418967076519115e-02*G0_2_1 - 4.892989919031440e-03*G0_2_2;
    block[2158] = 2.094199685345496e-01*G0_0_0 + 1.047099842672751e-01*G0_0_1 + 1.356989204211410e-01*G0_0_2 + 1.047099842672742e-01*G0_1_0 + 6.784946021057037e-02*G0_1_2 + 1.356989204211415e-01*G0_2_0 + 6.784946021057130e-02*G0_2_1 + 3.914391935225130e-02*G0_2_2;
    block[2159] = -1.663616572470735e-02*G0_0_0 + 1.467896975709204e-03*G0_0_1 - 1.810406270041672e-02*G0_0_2 + 1.467896975709818e-03*G0_1_0 + 1.957195967612655e-02*G0_1_1 - 1.027527882996627e-02*G0_1_2 - 1.810406270041685e-02*G0_2_0 - 1.027527882996621e-02*G0_2_1;
    block[2160] = 1.497254915223656e-01*G0_0_0 + 1.213461499919818e-01*G0_0_1 + 7.486274576118297e-02*G0_0_2 + 1.213461499919819e-01*G0_1_0 + 9.296680846159883e-02*G0_1_1 + 6.067307499599113e-02*G0_1_2 + 7.486274576118314e-02*G0_2_0 + 6.067307499599077e-02*G0_2_1 + 1.957195967612719e-02*G0_2_2;
    block[2161] = 1.370037177328804e-02*G0_0_0 + 2.642214556277063e-02*G0_0_1 - 6.197787230773720e-03*G0_0_2 + 2.642214556277052e-02*G0_1_0 + 3.914391935225266e-02*G0_1_1 - 5.545388574902259e-03*G0_1_2 - 6.197787230773658e-03*G0_2_0 - 5.545388574902299e-03*G0_2_1;
    block[2162] = -1.370037177328829e-02*G0_0_0 + 7.143765281786159e-02*G0_0_1 + 6.197787230773333e-03*G0_0_2 - 2.642214556277070e-02*G0_1_0 + 1.722332451499113e-01*G0_1_1 + 6.197787230773417e-03*G0_1_2 + 6.197787230773500e-03*G0_2_0 + 6.197787230774570e-03*G0_2_1 + 1.239557446154631e-02*G0_2_2;
    block[2163] = -1.497254915223655e-01*G0_0_0 - 3.268517265913078e-01*G0_0_1 - 1.776155340608447e-01*G0_0_2 - 1.213461499919819e-01*G0_1_0 - 4.481978765832904e-01*G0_1_1 - 2.240989382916443e-01*G0_1_2 - 7.486274576118306e-02*G0_2_0 - 2.240989382916463e-01*G0_2_1 - 3.718672338463882e-02*G0_2_2;
    block[2164] = -2.094199685345494e-01*G0_0_0 - 2.906436011904734e-01*G0_0_1 - 3.901343962107824e-01*G0_0_2 - 1.047099842672740e-01*G0_1_0 - 2.094199685345493e-01*G0_1_1 - 2.629166583159618e-01*G0_1_2 - 1.356989204211412e-01*G0_2_0 - 2.629166583159608e-01*G0_2_1 - 5.845491956603037e-01*G0_2_2;
    block[2165] = 6.556606491502232e-02*G0_0_0 + 3.767602237654174e-02*G0_0_1 + 1.404288106762049e-01*G0_0_2 + 1.404288106762053e-01*G0_1_0 - 3.718672338464050e-02*G0_1_1 + 1.869122149070048e-01*G0_1_2 + 3.767602237654263e-02*G0_2_0 + 1.869122149070045e-01*G0_2_1 - 3.718672338464017e-02*G0_2_2;
    block[2166] = 7.261197039842820e-01*G0_0_0 + 4.560266604537397e-01*G0_0_1 + 4.560266604537402e-01*G0_0_2 + 4.560266604537397e-01*G0_1_0 + 7.261197039842813e-01*G0_1_1 + 4.560266604537401e-01*G0_1_2 + 4.560266604537401e-01*G0_2_0 + 4.560266604537401e-01*G0_2_1 + 9.120533209074819e-01*G0_2_2;
    block[2167] = -2.681358475629277e-01*G0_0_0 - 2.221417423240315e-01*G0_0_1 - 1.944147994495200e-01*G0_0_2 - 2.906436011904734e-01*G0_1_0 - 2.681358475629281e-01*G0_1_1 - 3.216325373443401e-01*G0_1_2 - 4.488502752391605e-01*G0_2_0 - 3.216325373443399e-01*G0_2_1 - 5.845491956603036e-01*G0_2_2;
    block[2168] = -1.859336169231989e-01*G0_0_0 - 1.047099842672746e-01*G0_0_1 - 1.950671981053912e-01*G0_0_2 - 1.047099842672748e-01*G0_1_0 - 6.784946021056987e-02*G0_1_2 - 1.950671981053906e-01*G0_2_0 - 6.784946021057099e-02*G0_2_1 - 2.922745978301523e-01*G0_2_2;
    block[2169] = 9.296680846160023e-02*G0_0_0 - 2.837934153038199e-02*G0_0_1 + 3.229373346560865e-02*G0_0_2 - 2.837934153038193e-02*G0_1_0 - 1.418967076519141e-02*G0_1_2 + 3.229373346560849e-02*G0_2_0 - 1.418967076519090e-02*G0_2_1 - 8.807381854255909e-03*G0_2_2;
    block[2170] = -8.807381854256857e-02*G0_0_0 + 1.272177378948226e-02*G0_0_1 + 6.523986558709252e-04*G0_0_2 + 1.272177378948190e-02*G0_1_0 + 6.523986558715525e-04*G0_1_2 + 6.523986558703734e-04*G0_2_0 + 6.523986558707462e-04*G0_2_1 + 1.304797311741125e-03*G0_2_2;
    block[2171] = 9.296680846159867e-02*G0_0_0 + 3.630598519921406e-01*G0_0_1 + 2.280133302268703e-01*G0_0_2 + 3.630598519921399e-01*G0_1_0 + 9.296680846159848e-02*G0_1_1 + 2.280133302268693e-01*G0_1_2 + 2.280133302268696e-01*G0_2_0 + 2.280133302268699e-01*G0_2_1 + 4.560266604537421e-01*G0_2_2;
    block[2172] = 1.957195967612659e-02*G0_0_0 - 5.529078608505673e-02*G0_0_1 - 4.110111531986527e-02*G0_0_2 - 5.529078608505664e-02*G0_1_0 + 1.957195967612526e-02*G0_1_1 + 5.382288910934367e-03*G0_1_2 - 4.110111531986455e-02*G0_2_0 + 5.382288910934846e-03*G0_2_1 - 8.807381854256927e-03*G0_2_2;
    block[2173] = -8.807381854256773e-02*G0_0_0 - 1.340679237814639e-01*G0_0_1 - 9.720739972476002e-02*G0_0_2 - 1.340679237814642e-01*G0_1_0 - 1.565756774090091e-01*G0_1_1 - 2.244251376195795e-01*G0_1_2 - 9.720739972475996e-02*G0_2_0 - 2.244251376195808e-01*G0_2_1 - 2.922745978301520e-01*G0_2_2;
    block[2174] = -2.283395295548059e-02*G0_0_0 - 5.969447701218474e-02*G0_0_1 - 9.655500106888842e-02*G0_0_2 - 5.969447701218505e-02*G0_1_0 - 9.655500106888884e-02*G0_1_1 - 2.870554085831836e-02*G0_1_2 - 9.655500106888953e-02*G0_2_0 - 2.870554085831849e-02*G0_2_1 + 3.914391935225279e-02*G0_2_2;
    block[2175] = -4.892989919031351e-03*G0_0_0 - 1.908266068422285e-02*G0_0_1 - 3.327233144941463e-02*G0_0_2 - 1.908266068422282e-02*G0_1_0 - 3.327233144941440e-02*G0_1_1 - 1.908266068422372e-02*G0_1_2 - 3.327233144941403e-02*G0_2_0 - 1.908266068422274e-02*G0_2_1 - 4.892989919031289e-03*G0_2_2;
    block[2176] = -2.283395295548096e-02*G0_0_0 - 1.076457782186989e-02*G0_0_1 + 1.304797311741300e-03*G0_0_2 - 1.076457782186961e-02*G0_1_0 + 1.304797311741764e-03*G0_1_1 + 6.523986558706446e-04*G0_1_2 + 1.304797311741239e-03*G0_2_0 + 6.523986558704782e-04*G0_2_1;
    block[2177] = 1.957195967612580e-02*G0_0_0 + 5.382288910933884e-03*G0_0_1 - 5.529078608505696e-02*G0_0_2 + 5.382288910934612e-03*G0_1_0 - 8.807381854257191e-03*G0_1_1 - 4.110111531986498e-02*G0_1_2 - 5.529078608505707e-02*G0_2_0 - 4.110111531986547e-02*G0_2_1 + 1.957195967612610e-02*G0_2_2;
    block[2178] = 1.957195967612619e-02*G0_0_0 + 2.984723850609259e-02*G0_0_1 + 1.810406270041670e-02*G0_0_2 + 2.984723850609239e-02*G0_1_0 + 4.012251733605866e-02*G0_1_1 + 1.027527882996629e-02*G0_1_2 + 1.810406270041668e-02*G0_2_0 + 1.027527882996613e-02*G0_2_1;
    block[2179] = 2.609594623483522e-02*G0_0_0 + 3.816532136844679e-02*G0_0_1 + 6.197787230773695e-03*G0_0_2 + 3.816532136844631e-02*G0_1_0 + 5.023469650205764e-02*G0_1_1 + 5.545388574902289e-03*G0_1_2 + 6.197787230773648e-03*G0_2_0 + 5.545388574903071e-03*G0_2_1;
    block[2180] = 1.467896975709447e-01*G0_0_0 + 2.495424858706086e-01*G0_0_1 + 4.452620826318697e-01*G0_0_2 + 2.495424858706072e-01*G0_1_0 + 3.522952741702705e-01*G0_1_1 + 2.495424858706077e-01*G0_1_2 + 4.452620826318701e-01*G0_2_0 + 2.495424858706089e-01*G0_2_1 - 3.914391935225382e-02*G0_2_2;
    block[2181] = 1.467896975709474e-01*G0_0_0 + 5.382288910934750e-02*G0_0_1 + 4.892989919033179e-03*G0_0_2 + 5.382288910934889e-02*G0_1_0 - 3.914391935225149e-02*G0_1_1 + 4.892989919032715e-03*G0_1_2 + 4.892989919032286e-03*G0_2_0 + 4.892989919031489e-03*G0_2_1 + 9.785979838063279e-03*G0_2_2;
    block[2182] = -4.892989919031451e-02*G0_0_0 - 1.418967076519152e-01*G0_0_1 - 1.957195967612592e-02*G0_0_2 - 1.418967076519148e-01*G0_1_0 - 2.348635161135144e-01*G0_1_1 - 1.957195967612622e-02*G0_1_2 - 1.957195967612553e-02*G0_2_0 - 1.957195967612578e-02*G0_2_1 - 3.914391935225300e-02*G0_2_2;
    block[2183] = -7.828783870450476e-01*G0_0_0 - 4.844060019841224e-01*G0_0_1 - 4.844060019841224e-01*G0_0_2 - 4.844060019841240e-01*G0_1_0 - 1.859336169231972e-01*G0_1_1 - 2.886864052228598e-01*G0_1_2 - 4.844060019841233e-01*G0_2_0 - 2.886864052228609e-01*G0_2_1 - 3.914391935225042e-02*G0_2_2;
    block[2184] = 4.799305472048473e-02*G0_0_0 + 4.799305472048474e-02*G0_0_1 + 4.799305472048472e-02*G0_0_2 + 3.359853077734992e-02*G0_1_0 + 3.359853077734997e-02*G0_1_1 + 3.359853077734994e-02*G0_1_2 + 3.359853077734983e-02*G0_2_0 + 3.359853077734978e-02*G0_2_1 + 3.359853077734988e-02*G0_2_2;
    block[2185] = -1.374212528726389e-02*G0_0_0;
    block[2186] = 5.177435732991295e-03*G0_0_1 + 1.891956102025522e-02*G0_1_1;
    block[2187] = 5.177435732991322e-03*G0_0_2 + 1.891956102025542e-02*G0_2_2;
    block[2188] = 1.878908128908095e-02*G0_0_0 + 9.394540644540639e-03*G0_0_1 + 9.394540644540881e-03*G0_1_0;
    block[2189] = -1.487468935385577e-02*G0_0_0 - 1.493992921944314e-02*G0_0_1 - 1.493992921944331e-02*G0_1_0 - 1.500516908503045e-02*G0_1_1;
    block[2190] = -1.174317580567697e-03*G0_0_0 - 1.239557446154784e-03*G0_0_1 - 1.239557446154091e-03*G0_1_0 - 1.304797311741384e-03*G0_1_1;
    block[2191] = -1.187365553684940e-02*G0_0_0 - 2.126819618138974e-02*G0_0_1 - 2.126819618139072e-02*G0_1_0 - 3.066273682593079e-02*G0_1_1;
    block[2192] = 1.187365553684942e-02*G0_0_0 - 1.461372989150761e-02*G0_0_1 + 1.187365553684940e-02*G0_0_2 + 2.126819618139072e-02*G0_1_0 - 6.934997711907336e-02*G0_1_1 + 2.126819618139077e-02*G0_1_2 + 2.126819618139066e-02*G0_2_1;
    block[2193] = -5.101757488910176e-02*G0_0_0 - 4.632030456682932e-03*G0_0_1 - 5.101757488910171e-02*G0_0_2 - 8.879145706402583e-02*G0_1_0 + 8.468134553203874e-02*G0_1_1 - 8.879145706402586e-02*G0_1_2 - 5.284429112554039e-02*G0_2_0 - 8.879145706402580e-02*G0_2_1 - 5.284429112554030e-02*G0_2_2;
    block[2194] = 1.323064474106120e-01*G0_0_0 + 5.897683849072641e-02*G0_0_1 + 1.323064474106120e-01*G0_0_2 + 1.946757589118680e-01*G0_1_0 - 3.392473010528330e-03*G0_1_1 + 1.946757589118681e-01*G0_1_2 + 1.213461499919815e-01*G0_2_0 + 1.946757589118682e-01*G0_2_1 + 1.213461499919814e-01*G0_2_2;
    block[2195] = -6.445698720004184e-02*G0_0_0 - 9.290156859601194e-02*G0_0_1 - 6.445698720004191e-02*G0_0_2 - 1.607510288065827e-01*G0_1_0 - 6.445698720004232e-02*G0_1_1 - 1.607510288065827e-01*G0_1_2 - 2.570450704131236e-01*G0_2_0 - 1.607510288065829e-01*G0_2_1 - 2.570450704131236e-01*G0_2_2;
    block[2196] = -6.067307499599085e-02*G0_0_0 - 3.222849360002089e-02*G0_0_1 - 3.222849360002089e-02*G0_0_2 - 3.222849360002098e-02*G0_1_0 - 1.285225352065615e-01*G0_1_1 - 1.285225352065615e-01*G0_1_2 - 3.222849360002089e-02*G0_2_0 - 1.285225352065618e-01*G0_2_1 - 1.285225352065618e-01*G0_2_2;
    block[2197] = 4.762510187857342e-02*G0_0_0 - 1.474420962268168e-02*G0_0_1 - 1.474420962268165e-02*G0_0_2 - 1.474420962268182e-02*G0_1_0 + 4.762510187857370e-02*G0_1_1 + 4.762510187857369e-02*G0_1_2 - 1.474420962268194e-02*G0_2_0 + 4.762510187857374e-02*G0_2_1 + 4.762510187857365e-02*G0_2_2;
    block[2198] = -6.654466289882889e-02*G0_0_0 + 2.276871308989356e-02*G0_0_1 + 2.276871308989353e-02*G0_0_2 + 2.276871308989332e-02*G0_1_0 - 1.500516908502999e-02*G0_1_1 - 1.500516908503000e-02*G0_1_2 + 2.276871308989368e-02*G0_2_0 - 1.500516908503005e-02*G0_2_1 - 1.500516908502999e-02*G0_2_2;
    block[2199] = 4.534170658302541e-02*G0_0_0 - 9.394540644540718e-03*G0_0_1 - 9.394540644540669e-03*G0_0_2 - 9.394540644540619e-03*G0_1_0 - 9.394540644540794e-03*G0_2_0;
    block[2200] = -6.445698720004192e-02*G0_0_0 - 6.445698720004195e-02*G0_0_1 - 9.290156859601204e-02*G0_0_2 - 2.570450704131237e-01*G0_1_0 - 2.570450704131236e-01*G0_1_1 - 1.607510288065833e-01*G0_1_2 - 1.607510288065828e-01*G0_2_0 - 1.607510288065827e-01*G0_2_1 - 6.445698720004213e-02*G0_2_2;
    block[2201] = 1.323064474106129e-01*G0_0_0 + 1.323064474106128e-01*G0_0_1 + 5.897683849072659e-02*G0_0_2 + 1.213461499919820e-01*G0_1_0 + 1.213461499919822e-01*G0_1_1 + 1.946757589118688e-01*G0_1_2 + 1.946757589118685e-01*G0_2_0 + 1.946757589118682e-01*G0_2_1 - 3.392473010529000e-03*G0_2_2;
    block[2202] = -5.101757488910196e-02*G0_0_0 - 5.101757488910190e-02*G0_0_1 - 4.632030456682684e-03*G0_0_2 - 5.284429112554018e-02*G0_1_0 - 5.284429112554023e-02*G0_1_1 - 8.879145706402587e-02*G0_1_2 - 8.879145706402564e-02*G0_2_0 - 8.879145706402562e-02*G0_2_1 + 8.468134553204017e-02*G0_2_2;
    block[2203] = 1.187365553684983e-02*G0_0_0 + 1.187365553684983e-02*G0_0_1 - 1.461372989150778e-02*G0_0_2 + 2.126819618139053e-02*G0_1_2 + 2.126819618139074e-02*G0_2_0 + 2.126819618139075e-02*G0_2_1 - 6.934997711907423e-02*G0_2_2;
    block[2204] = 1.878908128908093e-02*G0_0_0 + 9.394540644540629e-03*G0_0_2 + 9.394540644540535e-03*G0_2_0;
    block[2205] = -1.487468935385563e-02*G0_0_0 - 1.493992921944304e-02*G0_0_2 - 1.493992921944312e-02*G0_2_0 - 1.500516908503007e-02*G0_2_2;
    block[2206] = -1.174317580568048e-03*G0_0_0 - 1.239557446155051e-03*G0_0_2 - 1.239557446154416e-03*G0_2_0 - 1.304797311741658e-03*G0_2_2;
    block[2207] = -1.187365553684985e-02*G0_0_0 - 2.126819618139048e-02*G0_0_2 - 2.126819618139076e-02*G0_2_0 - 3.066273682593136e-02*G0_2_2;
    block[2208] = -4.253639236278015e-02*G0_0_1 - 1.187365553684935e-02*G0_0_2 - 6.132547365186182e-02*G0_1_1 - 2.126819618139060e-02*G0_1_2 - 2.126819618138990e-02*G0_2_1;
    block[2209] = -4.031823693282061e-02*G0_0_1 - 5.401860870610863e-02*G0_0_2 - 2.544354757896450e-02*G0_1_1 - 3.907867948666532e-02*G0_1_2 - 3.907867948666602e-02*G0_2_1 - 5.284429112554068e-02*G0_2_2;
    block[2210] = -5.401860870610762e-02*G0_0_1 - 4.031823693281954e-02*G0_0_2 - 5.284429112554020e-02*G0_1_1 - 3.907867948666505e-02*G0_1_2 - 3.907867948666460e-02*G0_2_1 - 2.544354757896391e-02*G0_2_2;
    block[2211] = -1.187365553684985e-02*G0_0_1 - 4.253639236278083e-02*G0_0_2 - 2.126819618139041e-02*G0_1_2 - 2.126819618139074e-02*G0_2_1 - 6.132547365186236e-02*G0_2_2;
    block[2212] = -6.002067634011993e-02*G0_0_0 - 3.001033817006007e-02*G0_0_1 - 3.001033817006014e-02*G0_0_2 - 3.001033817005984e-02*G0_1_0 - 1.500516908502932e-02*G0_1_2 - 3.001033817005982e-02*G0_2_0 - 1.500516908502996e-02*G0_2_1;
    block[2213] = -2.544354757896437e-02*G0_0_0 - 1.272177378948239e-02*G0_0_1 - 2.413875026722203e-02*G0_0_2 - 1.272177378948179e-02*G0_1_0 - 1.206937513361101e-02*G0_1_2 - 2.413875026722237e-02*G0_2_0 - 1.206937513361113e-02*G0_2_1 - 2.283395295548076e-02*G0_2_2;
    block[2214] = -1.056885822510808e-01*G0_0_0 - 5.284429112554093e-02*G0_0_1 - 7.567824408102103e-02*G0_0_2 - 5.284429112554032e-02*G0_1_0 - 3.783912204051021e-02*G0_1_2 - 7.567824408102108e-02*G0_2_0 - 3.783912204051083e-02*G0_2_1 - 4.566790591096023e-02*G0_2_2;
    block[2215] = -2.544354757896429e-02*G0_0_0 - 2.413875026722222e-02*G0_0_1 - 1.272177378948247e-02*G0_0_2 - 2.413875026722218e-02*G0_1_0 - 2.283395295548061e-02*G0_1_1 - 1.206937513361129e-02*G0_1_2 - 1.272177378948182e-02*G0_2_0 - 1.206937513361088e-02*G0_2_1;
    block[2216] = -1.135173661215316e-01*G0_0_0 - 1.007955923320488e-01*G0_0_1 - 1.007955923320497e-01*G0_0_2 - 1.007955923320493e-01*G0_1_0 - 8.807381854256696e-02*G0_1_1 - 8.872621719843853e-02*G0_1_2 - 1.007955923320496e-01*G0_2_0 - 8.872621719843816e-02*G0_2_1 - 8.807381854256791e-02*G0_2_2;
    block[2217] = -1.056885822510804e-01*G0_0_0 - 7.567824408102121e-02*G0_0_1 - 5.284429112553964e-02*G0_0_2 - 7.567824408102117e-02*G0_1_0 - 4.566790591096090e-02*G0_1_1 - 3.783912204050996e-02*G0_1_2 - 5.284429112554021e-02*G0_2_0 - 3.783912204051040e-02*G0_2_1;
    block[2218] = 1.056885822510806e-01*G0_0_0 + 1.800620290203598e-01*G0_0_1 + 1.050361835952102e-01*G0_0_2 + 7.567824408102132e-02*G0_1_0 + 2.557402731013819e-01*G0_1_1 + 1.278701365506909e-01*G0_1_2 + 5.284429112554035e-02*G0_2_0 + 1.278701365506901e-01*G0_2_1 + 1.056885822510809e-01*G0_2_2;
    block[2219] = 1.135173661215316e-01*G0_0_0 + 1.986553907126810e-01*G0_0_1 + 1.986553907126804e-01*G0_0_2 + 1.007955923320493e-01*G0_1_0 + 1.722332451499106e-01*G0_1_1 + 1.660354579191367e-01*G0_1_2 + 1.007955923320496e-01*G0_2_0 + 1.660354579191378e-01*G0_2_1 + 1.722332451499098e-01*G0_2_2;
    block[2220] = 1.056885822510807e-01*G0_0_0 + 1.050361835952096e-01*G0_0_1 + 1.800620290203609e-01*G0_0_2 + 5.284429112554040e-02*G0_1_0 + 1.056885822510805e-01*G0_1_1 + 1.278701365506909e-01*G0_1_2 + 7.567824408102106e-02*G0_2_0 + 1.278701365506903e-01*G0_2_1 + 2.557402731013834e-01*G0_2_2;
    block[2221] = -2.681358475629282e-01*G0_0_0 - 4.488502752391599e-01*G0_0_1 - 2.906436011904730e-01*G0_0_2 - 1.944147994495196e-01*G0_1_0 - 5.845491956603017e-01*G0_1_1 - 3.216325373443399e-01*G0_1_2 - 2.221417423240315e-01*G0_2_0 - 3.216325373443399e-01*G0_2_1 - 2.681358475629279e-01*G0_2_2;
    block[2222] = -2.681358475629277e-01*G0_0_0 - 2.906436011904734e-01*G0_0_1 - 4.488502752391605e-01*G0_0_2 - 2.221417423240315e-01*G0_1_0 - 2.681358475629281e-01*G0_1_1 - 3.216325373443399e-01*G0_1_2 - 1.944147994495200e-01*G0_2_0 - 3.216325373443401e-01*G0_2_1 - 5.845491956603036e-01*G0_2_2;
    block[2223] = 6.471794666239054e-01*G0_0_0 + 3.757816257816222e-01*G0_0_1 + 3.757816257816231e-01*G0_0_2 + 3.757816257816222e-01*G0_1_0 + 6.471794666239056e-01*G0_1_1 + 3.757816257816223e-01*G0_1_2 + 3.757816257816231e-01*G0_2_0 + 3.757816257816223e-01*G0_2_1 + 6.471794666239067e-01*G0_2_2;
    block[2224] = 5.219189246967013e-02*G0_0_0 + 5.284429112554102e-02*G0_0_1 + 9.003101451018033e-02*G0_0_2 + 5.284429112554011e-02*G0_1_0 + 3.783912204051024e-02*G0_1_2 + 9.003101451018009e-02*G0_2_0 + 3.783912204051072e-02*G0_2_1 + 1.278701365506918e-01*G0_2_2;
    block[2225] = 3.914391935225225e-02*G0_0_0 + 1.272177378948207e-02*G0_0_1 + 4.468930792715523e-02*G0_0_2 + 1.272177378948246e-02*G0_1_0 + 1.206937513361113e-02*G0_1_2 + 4.468930792715479e-02*G0_2_0 + 1.206937513361088e-02*G0_2_1 + 5.023469650205658e-02*G0_2_2;
    block[2226] = -4.566790591096104e-02*G0_0_0 + 3.001033817006024e-02*G0_0_1 - 7.828783870450336e-03*G0_0_2 + 3.001033817005999e-02*G0_1_0 + 1.500516908503076e-02*G0_1_2 - 7.828783870450164e-03*G0_2_0 + 1.500516908503023e-02*G0_2_1 + 3.001033817006057e-02*G0_2_2;
    block[2227] = -1.565756774090095e-01*G0_0_0 - 1.340679237814641e-01*G0_0_1 - 2.244251376195804e-01*G0_0_2 - 1.340679237814644e-01*G0_1_0 - 8.807381854256773e-02*G0_1_1 - 9.720739972475935e-02*G0_1_2 - 2.244251376195802e-01*G0_2_0 - 9.720739972476002e-02*G0_2_1 - 2.922745978301519e-01*G0_2_2;
    block[2228] = 3.914391935225237e-02*G0_0_0 - 9.655500106888922e-02*G0_0_1 - 2.870554085831875e-02*G0_0_2 - 9.655500106888933e-02*G0_1_0 - 2.283395295548077e-02*G0_1_1 - 5.969447701218549e-02*G0_1_2 - 2.870554085831901e-02*G0_2_0 - 5.969447701218464e-02*G0_2_1 - 9.655500106888913e-02*G0_2_2;
    block[2229] = 5.219189246966960e-02*G0_0_0 + 3.235897333119531e-01*G0_0_1 + 1.878908128908113e-01*G0_0_2 + 3.235897333119528e-01*G0_1_0 + 5.219189246966952e-02*G0_1_1 + 1.878908128908109e-01*G0_1_2 + 1.878908128908117e-01*G0_2_0 + 1.878908128908118e-01*G0_2_1 + 3.235897333119535e-01*G0_2_2;
    block[2230] = 5.219189246966904e-02*G0_0_0 + 1.878908128908102e-01*G0_0_1 + 3.235897333119517e-01*G0_0_2 + 1.878908128908107e-01*G0_1_0 + 3.235897333119520e-01*G0_1_1 + 1.878908128908107e-01*G0_1_2 + 3.235897333119529e-01*G0_2_0 + 1.878908128908107e-01*G0_2_1 + 5.219189246966935e-02*G0_2_2;
    block[2231] = 3.914391935225299e-02*G0_0_0 - 2.870554085831833e-02*G0_0_1 - 9.655500106888858e-02*G0_0_2 - 2.870554085831796e-02*G0_1_0 - 9.655500106888922e-02*G0_1_1 - 5.969447701218435e-02*G0_1_2 - 9.655500106888958e-02*G0_2_0 - 5.969447701218500e-02*G0_2_1 - 2.283395295548021e-02*G0_2_2;
    block[2232] = -4.566790591096113e-02*G0_0_0 - 7.828783870450256e-03*G0_0_1 + 3.001033817006030e-02*G0_0_2 - 7.828783870450755e-03*G0_1_0 + 3.001033817006082e-02*G0_1_1 + 1.500516908502970e-02*G0_1_2 + 3.001033817006052e-02*G0_2_0 + 1.500516908503018e-02*G0_2_1;
    block[2233] = -1.565756774090082e-01*G0_0_0 - 2.244251376195787e-01*G0_0_1 - 1.340679237814639e-01*G0_0_2 - 2.244251376195792e-01*G0_1_0 - 2.922745978301500e-01*G0_1_1 - 9.720739972475925e-02*G0_1_2 - 1.340679237814634e-01*G0_2_0 - 9.720739972475918e-02*G0_2_1 - 8.807381854256741e-02*G0_2_2;
    block[2234] = 3.914391935225205e-02*G0_0_0 + 4.468930792715474e-02*G0_0_1 + 1.272177378948233e-02*G0_0_2 + 4.468930792715447e-02*G0_1_0 + 5.023469650205670e-02*G0_1_1 + 1.206937513361106e-02*G0_1_2 + 1.272177378948173e-02*G0_2_0 + 1.206937513361114e-02*G0_2_1;
    block[2235] = 5.219189246966920e-02*G0_0_0 + 9.003101451017910e-02*G0_0_1 + 5.284429112553973e-02*G0_0_2 + 9.003101451017989e-02*G0_1_0 + 1.278701365506903e-01*G0_1_1 + 3.783912204050999e-02*G0_1_2 + 5.284429112554009e-02*G0_2_0 + 3.783912204050987e-02*G0_2_1;
    block[2236] = -7.828783870450465e-01*G0_0_0 - 4.664650389476735e-01*G0_0_1 - 4.664650389476721e-01*G0_0_2 - 4.664650389476739e-01*G0_1_0 - 1.500516908503001e-01*G0_1_1 - 3.359853077734992e-01*G0_1_2 - 4.664650389476734e-01*G0_2_0 - 3.359853077734989e-01*G0_2_1 - 1.500516908502992e-01*G0_2_2;
    block[2237] = 1.957195967612617e-01*G0_0_0 + 1.206937513361113e-01*G0_0_1 + 1.206937513361103e-01*G0_0_2 + 1.206937513361115e-01*G0_1_0 + 4.566790591096127e-02*G0_1_1 + 7.176385214579509e-02*G0_1_2 + 1.206937513361105e-01*G0_2_0 + 7.176385214579530e-02*G0_2_1 + 4.566790591096036e-02*G0_2_2;
    block[2238] = 2.935793951418923e-01*G0_0_0 + 2.185535497167421e-01*G0_0_1 + 2.348635161135135e-01*G0_0_2 + 2.185535497167415e-01*G0_1_0 + 1.435277042915916e-01*G0_1_1 + 1.859336169231979e-01*G0_1_2 + 2.348635161135132e-01*G0_2_0 + 1.859336169231977e-01*G0_2_1 + 1.761476370851351e-01*G0_2_2;
    block[2239] = 2.935793951418920e-01*G0_0_0 + 2.348635161135129e-01*G0_0_1 + 2.185535497167416e-01*G0_0_2 + 2.348635161135133e-01*G0_1_0 + 1.761476370851346e-01*G0_1_1 + 1.859336169231985e-01*G0_1_2 + 2.185535497167423e-01*G0_2_0 + 1.859336169231982e-01*G0_2_1 + 1.435277042915904e-01*G0_2_2;
    block[2240] = 1.891956102025532e-02*G0_0_0 + 1.891956102025531e-02*G0_0_1 + 1.891956102025537e-02*G0_0_2 + 1.374212528726407e-02*G0_1_0 + 1.374212528726406e-02*G0_1_1 + 1.374212528726411e-02*G0_1_2 + 1.891956102025523e-02*G0_2_0 + 1.891956102025523e-02*G0_2_1 + 1.891956102025532e-02*G0_2_2;
    block[2241] = 1.891956102025535e-02*G0_0_0 + 5.177435732991269e-03*G0_1_0;
    block[2242] = -1.374212528726406e-02*G0_1_1;
    block[2243] = -1.439452394313488e-02*G0_1_2 + 3.359853077735002e-02*G0_2_2;
    block[2244] = -3.066273682593073e-02*G0_0_0 - 2.126819618139020e-02*G0_0_1 - 2.126819618139027e-02*G0_1_0 - 1.187365553684969e-02*G0_1_1;
    block[2245] = -1.304797311741887e-03*G0_0_0 - 1.239557446154896e-03*G0_0_1 - 1.239557446154841e-03*G0_1_0 - 1.174317580567885e-03*G0_1_1;
    block[2246] = -1.500516908503004e-02*G0_0_0 - 1.493992921944277e-02*G0_0_1 - 1.493992921944286e-02*G0_1_0 - 1.487468935385549e-02*G0_1_1;
    block[2247] = 9.394540644540490e-03*G0_0_1 + 9.394540644540482e-03*G0_1_0 + 1.878908128908104e-02*G0_1_1;
    block[2248] = -9.394540644540240e-03*G0_0_1 - 9.394540644540504e-03*G0_1_0 - 9.394540644540469e-03*G0_1_2 - 9.394540644540136e-03*G0_2_1;
    block[2249] = -1.500516908503020e-02*G0_0_0 - 6.523986558752408e-05*G0_0_1 - 1.500516908503021e-02*G0_0_2 - 6.523986558720913e-05*G0_1_0 - 6.523986558718901e-05*G0_1_2 - 1.500516908503024e-02*G0_2_0 - 6.523986558765350e-05*G0_2_1 - 1.500516908503020e-02*G0_2_2;
    block[2250] = -1.304797311741740e-03*G0_0_0 - 6.523986558690108e-05*G0_0_1 - 1.304797311741673e-03*G0_0_2 - 6.523986558719185e-05*G0_1_0 - 6.523986558723496e-05*G0_1_2 - 1.304797311741829e-03*G0_2_0 - 6.523986558671473e-05*G0_2_1 - 1.304797311741848e-03*G0_2_2;
    block[2251] = -3.066273682593085e-02*G0_0_0 - 9.394540644540605e-03*G0_0_1 - 3.066273682593082e-02*G0_0_2 - 9.394540644540561e-03*G0_1_0 - 9.394540644540482e-03*G0_1_2 - 3.066273682593132e-02*G0_2_0 - 9.394540644540712e-03*G0_2_1 - 3.066273682593131e-02*G0_2_2;
    block[2252] = -1.878908128908136e-02*G0_0_0 - 4.005727747047155e-02*G0_0_1 - 4.005727747047155e-02*G0_0_2 - 9.394540644540858e-03*G0_1_0 - 1.878908128908122e-02*G0_1_1 - 1.878908128908115e-02*G0_1_2 - 4.005727747047163e-02*G0_2_0 - 6.132547365186225e-02*G0_2_1 - 6.132547365186223e-02*G0_2_2;
    block[2253] = -1.304797311739139e-04*G0_0_0 + 1.363513190770127e-02*G0_0_1 + 1.363513190770127e-02*G0_0_2 - 6.523986558686014e-05*G0_1_0 + 1.487468935385588e-02*G0_1_1 + 1.487468935385583e-02*G0_1_2 + 1.363513190770125e-02*G0_2_0 - 2.544354757896385e-02*G0_2_1 - 2.544354757896388e-02*G0_2_2;
    block[2254] = -1.304797311744036e-04*G0_0_0 - 1.376561163887536e-02*G0_0_1 - 1.376561163887527e-02*G0_0_2 - 6.523986558712493e-05*G0_1_0 + 1.174317580567478e-03*G0_1_1 + 1.174317580567496e-03*G0_1_2 - 1.376561163887528e-02*G0_2_0 - 5.284429112554088e-02*G0_2_1 - 5.284429112554091e-02*G0_2_2;
    block[2255] = -1.878908128908107e-02*G0_0_0 + 2.126819618139032e-02*G0_0_1 + 2.126819618139017e-02*G0_0_2 - 9.394540644540572e-03*G0_1_0 + 1.187365553684978e-02*G0_1_1 + 1.187365553684966e-02*G0_1_2 + 2.126819618139028e-02*G0_2_0;
    block[2256] = -1.118863694818544e-01*G0_0_0 - 1.118863694818542e-01*G0_0_1 - 9.061817330046415e-02*G0_0_2 - 6.413078787210665e-02*G0_1_0 - 6.413078787210655e-02*G0_1_1 - 5.473624722756629e-02*G0_1_2 - 9.061817330046419e-02*G0_2_0 - 9.061817330046407e-02*G0_2_1 - 6.934997711907367e-02*G0_2_2;
    block[2257] = 2.094199685345501e-01*G0_0_0 + 2.094199685345499e-01*G0_0_1 + 1.734728025960648e-01*G0_0_2 + 1.270872581636459e-01*G0_1_0 + 1.270872581636457e-01*G0_1_1 + 8.931337598872241e-02*G0_1_2 + 1.734728025960652e-01*G0_2_0 + 1.734728025960649e-01*G0_2_1 + 8.468134553203885e-02*G0_2_2;
    block[2258] = -2.713978408422829e-01*G0_0_0 - 2.713978408422829e-01*G0_0_1 - 1.980682319223965e-01*G0_0_2 - 1.247386230025107e-01*G0_1_0 - 1.247386230025106e-01*G0_1_1 - 6.236931150125517e-02*G0_1_2 - 1.980682319223974e-01*G0_2_0 - 1.980682319223974e-01*G0_2_1 - 3.392473010527829e-03*G0_2_2;
    block[2259] = 9.629404160654063e-02*G0_0_2 + 1.247386230025110e-01*G0_1_0 + 1.247386230025110e-01*G0_1_1 + 2.844458139596978e-02*G0_1_2 + 9.629404160654165e-02*G0_2_0 + 9.629404160654165e-02*G0_2_1 - 6.445698720004260e-02*G0_2_2;
    block[2260] = -1.118863694818545e-01*G0_0_0 - 2.126819618139026e-02*G0_0_2 - 4.775558160974775e-02*G0_1_0 - 1.187365553684977e-02*G0_1_2 - 2.126819618139046e-02*G0_2_0;
    block[2261] = 2.094199685345501e-01*G0_0_0 + 3.594716593848485e-02*G0_0_2 + 8.233271037090378e-02*G0_1_0 - 1.826716236438623e-03*G0_1_2 + 3.594716593848481e-02*G0_2_0 - 5.284429112554113e-02*G0_2_2;
    block[2262] = -2.713978408422832e-01*G0_0_0 - 7.332960891988599e-02*G0_0_2 - 1.466592178397719e-01*G0_1_0 - 1.096029741863046e-02*G0_1_2 - 7.332960891988556e-02*G0_2_0 + 1.213461499919831e-01*G0_2_2;
    block[2263] = -9.629404160654072e-02*G0_0_2 - 1.247386230025110e-01*G0_1_0 - 1.925880832130817e-01*G0_1_2 - 9.629404160654162e-02*G0_2_0 - 2.570450704131250e-01*G0_2_2;
    block[2264] = 6.413078787210676e-02*G0_1_1 + 9.394540644540388e-03*G0_1_2 + 9.394540644541170e-03*G0_2_1;
    block[2265] = -1.270872581636462e-01*G0_1_1 - 3.777388217492339e-02*G0_1_2 - 3.777388217492451e-02*G0_2_1 - 1.500516908502968e-02*G0_2_2;
    block[2266] = 1.247386230025109e-01*G0_1_1 + 6.236931150125516e-02*G0_1_2 + 6.236931150125637e-02*G0_2_1 + 4.762510187857333e-02*G0_2_2;
    block[2267] = -1.247386230025110e-01*G0_1_1 - 9.629404160654106e-02*G0_1_2 - 9.629404160654170e-02*G0_2_1 - 1.285225352065626e-01*G0_2_2;
    block[2268] = 5.219189246966929e-02*G0_0_0 - 6.523986558707625e-04*G0_0_1 - 3.783912204051031e-02*G0_0_2 - 6.523986558716936e-04*G0_1_0 - 5.349668978141193e-02*G0_1_1 - 5.284429112554068e-02*G0_1_2 - 3.783912204051101e-02*G0_2_0 - 5.284429112554112e-02*G0_2_1;
    block[2269] = -1.859336169231983e-01*G0_0_0 - 8.122363265592340e-02*G0_0_1 + 9.133581182192157e-03*G0_0_2 - 8.122363265592264e-02*G0_1_0 + 2.348635161135204e-02*G0_1_1 + 4.599410523889625e-02*G0_1_2 + 9.133581182192950e-03*G0_2_0 + 4.599410523889744e-02*G0_2_1 - 8.807381854256878e-02*G0_2_2;
    block[2270] = -2.713978408422829e-01*G0_0_1 - 1.356989204211412e-01*G0_0_2 - 2.713978408422834e-01*G0_1_0 - 5.427956816845657e-01*G0_1_1 - 2.713978408422821e-01*G0_1_2 - 1.356989204211423e-01*G0_2_0 - 2.713978408422841e-01*G0_2_1 + 5.219189246967117e-02*G0_2_2;
    block[2271] = 2.609594623483541e-02*G0_0_0 + 1.989815900406178e-02*G0_0_1 - 1.206937513361097e-02*G0_0_2 + 1.989815900406251e-02*G0_1_0 + 1.370037177328848e-02*G0_1_1 - 1.272177378948163e-02*G0_1_2 - 1.206937513361092e-02*G0_2_0 - 1.272177378948201e-02*G0_2_1;
    block[2272] = 1.047099842672752e-01*G0_0_1 + 3.686052405670428e-02*G0_0_2 + 1.047099842672746e-01*G0_1_0 + 2.094199685345499e-01*G0_1_1 + 7.372104811340817e-02*G0_1_2 + 3.686052405670399e-02*G0_2_0 + 7.372104811340870e-02*G0_2_1 - 2.283395295548101e-02*G0_2_2;
    block[2273] = -5.284429112554076e-02*G0_0_1 - 1.500516908503005e-02*G0_0_2 - 5.284429112554104e-02*G0_1_0 - 1.056885822510813e-01*G0_1_1 - 3.001033817006001e-02*G0_1_2 - 1.500516908502961e-02*G0_2_0 - 3.001033817005999e-02*G0_2_1;
    block[2274] = 5.284429112554005e-02*G0_0_1 + 1.500516908502993e-02*G0_0_2 + 5.284429112554096e-02*G0_1_0 + 3.783912204051086e-02*G0_1_2 + 1.500516908502964e-02*G0_2_0 + 3.783912204051008e-02*G0_2_1 + 3.001033817005994e-02*G0_2_2;
    block[2275] = -1.047099842672748e-01*G0_0_1 - 3.686052405670449e-02*G0_0_2 - 1.047099842672746e-01*G0_1_0 - 6.784946021057098e-02*G0_1_2 - 3.686052405670407e-02*G0_2_0 - 6.784946021057067e-02*G0_2_1 - 9.655500106888965e-02*G0_2_2;
    block[2276] = 2.713978408422829e-01*G0_0_1 + 1.356989204211414e-01*G0_0_2 + 2.713978408422831e-01*G0_1_0 + 1.356989204211419e-01*G0_1_2 + 1.356989204211422e-01*G0_2_0 + 1.356989204211411e-01*G0_2_1 + 3.235897333119549e-01*G0_2_2;
    block[2277] = 2.609594623483537e-02*G0_0_0 + 6.197787230773973e-03*G0_0_1 + 3.816532136844643e-02*G0_0_2 + 6.197787230772806e-03*G0_1_0 + 5.545388574902691e-03*G0_1_2 + 3.816532136844638e-02*G0_2_0 + 5.545388574902848e-03*G0_2_1 + 5.023469650205767e-02*G0_2_2;
    block[2278] = -1.859336169231989e-01*G0_0_0 - 1.047099842672748e-01*G0_0_1 - 1.950671981053906e-01*G0_0_2 - 1.047099842672746e-01*G0_1_0 - 6.784946021057101e-02*G0_1_2 - 1.950671981053912e-01*G0_2_0 - 6.784946021056985e-02*G0_2_1 - 2.922745978301523e-01*G0_2_2;
    block[2279] = 5.219189246967013e-02*G0_0_0 + 5.284429112554011e-02*G0_0_1 + 9.003101451018009e-02*G0_0_2 + 5.284429112554102e-02*G0_1_0 + 3.783912204051073e-02*G0_1_2 + 9.003101451018033e-02*G0_2_0 + 3.783912204051024e-02*G0_2_1 + 1.278701365506918e-01*G0_2_2;
    block[2280] = 5.427956816845658e-01*G0_0_0 + 2.713978408422824e-01*G0_0_1 + 2.713978408422828e-01*G0_0_2 + 2.713978408422824e-01*G0_1_0 + 5.427956816845657e-01*G0_1_1 + 2.713978408422835e-01*G0_1_2 + 2.713978408422828e-01*G0_2_0 + 2.713978408422835e-01*G0_2_1 + 6.471794666239074e-01*G0_2_2;
    block[2281] = -2.094199685345497e-01*G0_0_0 + 8.122363265592326e-02*G0_0_1 + 5.349668978141141e-02*G0_0_2 - 1.047099842672750e-01*G0_1_0 - 2.348635161135194e-02*G0_1_1 + 2.250775362754443e-02*G0_1_2 + 5.349668978141138e-02*G0_2_0 - 4.599410523889729e-02*G0_2_1 - 2.681358475629302e-01*G0_2_2;
    block[2282] = 1.056885822510813e-01*G0_0_0 + 6.523986558709373e-04*G0_0_1 - 2.218155429960912e-02*G0_0_2 + 5.284429112554103e-02*G0_1_0 + 5.349668978141194e-02*G0_1_1 + 6.523986558715772e-04*G0_1_2 - 2.218155429960914e-02*G0_2_0 + 5.284429112554117e-02*G0_2_1 + 1.056885822510825e-01*G0_2_2;
    block[2283] = -2.094199685345502e-01*G0_0_0 - 2.906436011904740e-01*G0_0_1 - 2.629166583159618e-01*G0_0_2 - 1.047099842672746e-01*G0_1_0 - 2.094199685345495e-01*G0_1_1 - 1.356989204211421e-01*G0_1_2 - 2.629166583159615e-01*G0_2_0 - 3.901343962107824e-01*G0_2_1 - 5.845491956603038e-01*G0_2_2;
    block[2284] = 1.239557446154616e-02*G0_0_0 + 6.197787230772757e-03*G0_0_1 + 6.197787230772594e-03*G0_0_2 + 6.197787230772442e-03*G0_1_0 - 1.370037177328894e-02*G0_1_1 - 2.642214556277049e-02*G0_1_2 + 6.197787230772478e-03*G0_2_0 + 7.143765281786027e-02*G0_2_1 + 1.722332451499103e-01*G0_2_2;
    block[2285] = 1.056885822510814e-01*G0_0_0 + 1.050361835952113e-01*G0_0_1 + 1.278701365506913e-01*G0_0_2 + 5.284429112554097e-02*G0_1_0 + 1.056885822510818e-01*G0_1_1 + 7.567824408102172e-02*G0_1_2 + 1.278701365506913e-01*G0_2_0 + 1.800620290203614e-01*G0_2_1 + 2.557402731013831e-01*G0_2_2;
    block[2286] = 3.001033817006013e-02*G0_0_0 + 1.500516908503032e-02*G0_0_1 - 7.828783870449718e-03*G0_0_2 + 1.500516908502992e-02*G0_1_0 + 3.001033817006011e-02*G0_1_2 - 7.828783870450185e-03*G0_2_0 + 3.001033817006009e-02*G0_2_1 - 4.566790591096130e-02*G0_2_2;
    block[2287] = 1.304797311741609e-03*G0_0_0 + 6.523986558702998e-04*G0_0_1 + 6.523986558703714e-04*G0_0_2 + 6.523986558707218e-04*G0_1_0 + 1.272177378948161e-02*G0_1_2 + 6.523986558704222e-04*G0_2_0 + 1.272177378948131e-02*G0_2_1 - 8.807381854256824e-02*G0_2_2;
    block[2288] = 3.001033817005979e-02*G0_0_0 + 1.500516908503018e-02*G0_0_1 + 3.783912204051058e-02*G0_0_2 + 1.500516908503014e-02*G0_1_0 + 5.284429112554075e-02*G0_1_2 + 3.783912204051099e-02*G0_2_0 + 5.284429112554099e-02*G0_2_1;
    block[2289] = 1.304797311741668e-03*G0_0_0 + 6.523986558707569e-04*G0_0_1 - 1.076457782186947e-02*G0_0_2 + 6.523986558711037e-04*G0_1_0 + 1.304797311741326e-03*G0_1_2 - 1.076457782186922e-02*G0_2_0 + 1.304797311742213e-03*G0_2_1 - 2.283395295548067e-02*G0_2_2;
    block[2290] = 1.304797311741963e-03*G0_0_0 + 6.523986558709425e-04*G0_0_1 + 1.206937513361093e-02*G0_0_2 + 6.523986558709393e-04*G0_1_0 + 1.272177378948168e-02*G0_1_2 + 1.206937513361105e-02*G0_2_0 + 1.272177378948224e-02*G0_2_1;
    block[2291] = 3.001033817006027e-02*G0_0_0 + 1.500516908503006e-02*G0_0_1 + 1.500516908503015e-02*G0_0_2 + 1.500516908503003e-02*G0_1_0 + 3.001033817006006e-02*G0_1_2 + 1.500516908503016e-02*G0_2_0 + 3.001033817006007e-02*G0_2_1;
    block[2292] = -5.219189246967097e-02*G0_0_0 - 2.609594623483629e-02*G0_0_1 - 4.240591263160844e-02*G0_0_2 - 2.609594623483569e-02*G0_1_0 - 7.502584542515005e-02*G0_1_2 - 4.240591263160613e-02*G0_2_0 - 7.502584542515014e-02*G0_2_1 + 1.435277042915929e-01*G0_2_2;
    block[2293] = -5.219189246966835e-02*G0_0_0 - 2.609594623483453e-02*G0_0_1 - 9.785979838062859e-03*G0_0_2 - 2.609594623483371e-02*G0_1_0 - 5.871587902837803e-02*G0_1_2 - 9.785979838063164e-03*G0_2_0 - 5.871587902837803e-02*G0_2_1 + 1.761476370851365e-01*G0_2_2;
    block[2294] = -5.219189246967105e-02*G0_0_0 - 2.609594623483433e-02*G0_0_1 - 2.609594623483496e-02*G0_0_2 - 2.609594623483539e-02*G0_1_0 - 7.502584542514988e-02*G0_1_2 - 2.609594623483549e-02*G0_2_0 - 7.502584542515159e-02*G0_2_1 + 4.566790591096132e-02*G0_2_2;
    block[2295] = 3.718672338463973e-01*G0_0_0 + 1.859336169231990e-01*G0_0_1 + 1.859336169231992e-01*G0_0_2 + 1.859336169231974e-01*G0_1_0 + 3.164133480973718e-01*G0_1_2 + 1.859336169231985e-01*G0_2_0 + 3.164133480973738e-01*G0_2_1 - 1.500516908503023e-01*G0_2_2;
    block[2296] = 1.174317580567566e-02*G0_0_0 + 1.174317580567568e-02*G0_0_1 + 1.174317580567563e-02*G0_0_2 + 9.464999699374605e-03*G0_1_0 + 9.464999699374645e-03*G0_1_1 + 9.464999699374596e-03*G0_1_2 + 1.174317580567575e-02*G0_2_0 + 1.174317580567574e-02*G0_2_1 + 1.174317580567572e-02*G0_2_2;
    block[2297] = -2.984723850609245e-02*G0_0_0 + 4.724671065816859e-03*G0_1_0;
    block[2298] = -9.464999699374678e-03*G0_1_1;
    block[2299] = 4.724671065816892e-03*G0_1_2 - 2.984723850609248e-02*G0_2_2;
    block[2300] = 6.426126760328056e-02*G0_0_0 + 4.227543290043201e-02*G0_0_1 + 4.227543290043249e-02*G0_1_0 + 4.296045148909691e-02*G0_1_1;
    block[2301] = 8.807381854256707e-03*G0_0_0 + 6.491366625915415e-03*G0_0_1 + 6.491366625915237e-03*G0_1_0 + 3.522952741702903e-03*G0_1_1;
    block[2302] = -6.523986558708584e-04*G0_0_0 - 9.492400442921380e-03*G0_0_1 - 9.492400442921219e-03*G0_1_0 - 1.898480088584261e-02*G0_1_1;
    block[2303] = 3.294613212147545e-03*G0_0_1 + 3.294613212147851e-03*G0_1_0 + 2.926007971580866e-02*G0_1_1;
    block[2304] = -3.294613212148296e-03*G0_0_1 - 3.294613212147900e-03*G0_1_0 - 3.294613212147860e-03*G0_1_2 - 3.294613212148334e-03*G0_2_1;
    block[2305] = -6.523986558709240e-04*G0_0_0 - 2.576974690689665e-03*G0_0_1 - 6.523986558708467e-04*G0_0_2 - 2.576974690689876e-03*G0_1_0 - 2.576974690689896e-03*G0_1_2 - 6.523986558707864e-04*G0_2_0 - 2.576974690689548e-03*G0_2_1 - 6.523986558707663e-04*G0_2_2;
    block[2306] = -1.565756774090083e-02*G0_0_0 - 2.576974690689778e-03*G0_0_1 - 1.565756774090089e-02*G0_0_2 - 2.576974690690102e-03*G0_1_0 - 2.576974690690087e-03*G0_1_2 - 1.565756774090107e-02*G0_2_0 - 2.576974690690113e-03*G0_2_1 - 1.565756774090105e-02*G0_2_2;
    block[2307] = -9.133581182192334e-03*G0_0_0 - 3.294613212148046e-03*G0_0_1 - 9.133581182192308e-03*G0_0_2 - 3.294613212147747e-03*G0_1_0 - 3.294613212147755e-03*G0_1_2 - 9.133581182191926e-03*G0_2_0 - 3.294613212147837e-03*G0_2_1 - 9.133581182191840e-03*G0_2_2;
    block[2308] = -3.186967433929185e-02*G0_0_0 - 3.770864230933623e-02*G0_0_1 - 3.770864230933622e-02*G0_0_2 - 2.596546650366068e-02*G0_1_0 - 2.926007971580847e-02*G0_1_1 - 2.926007971580846e-02*G0_1_2 - 3.770864230933643e-02*G0_2_0 - 4.354761027938047e-02*G0_2_1 - 4.354761027938046e-02*G0_2_2;
    block[2309] = 1.278701365506870e-02*G0_0_0 + 3.787174197330402e-02*G0_0_1 + 3.787174197330407e-02*G0_0_2 + 9.492400442921104e-03*G0_1_0 + 1.898480088584228e-02*G0_1_1 + 1.898480088584235e-02*G0_1_2 + 3.787174197330417e-02*G0_2_0 + 5.675868306076565e-02*G0_2_1 + 5.675868306076568e-02*G0_2_2;
    block[2310] = -6.784946021056823e-03*G0_0_0 + 3.036915743078877e-02*G0_0_1 + 3.036915743078870e-02*G0_0_2 + 2.968413884212583e-03*G0_1_0 - 3.522952741702579e-03*G0_1_1 - 3.522952741702585e-03*G0_1_2 + 3.036915743078908e-02*G0_2_0 + 1.047099842672751e-01*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[2311] = 4.397166940569681e-02*G0_0_0 - 4.227543290043204e-02*G0_0_1 - 4.227543290043199e-02*G0_0_2 - 6.850185886644478e-04*G0_1_0 - 4.296045148909677e-02*G0_1_1 - 4.296045148909682e-02*G0_1_2 - 4.227543290043255e-02*G0_2_0;
    block[2312] = -4.354761027938053e-02*G0_0_0 - 4.354761027938059e-02*G0_0_1 - 3.770864230933613e-02*G0_0_2 - 2.926007971580832e-02*G0_1_0 - 2.926007971580838e-02*G0_1_1 - 2.596546650366055e-02*G0_1_2 - 3.770864230933607e-02*G0_2_0 - 3.770864230933605e-02*G0_2_1 - 3.186967433929192e-02*G0_2_2;
    block[2313] = 5.675868306076545e-02*G0_0_0 + 5.675868306076532e-02*G0_0_1 + 3.787174197330381e-02*G0_0_2 + 1.898480088584201e-02*G0_1_0 + 1.898480088584201e-02*G0_1_1 + 9.492400442920870e-03*G0_1_2 + 3.787174197330377e-02*G0_2_0 + 3.787174197330372e-02*G0_2_1 + 1.278701365506877e-02*G0_2_2;
    block[2314] = 1.047099842672751e-01*G0_0_0 + 1.047099842672752e-01*G0_0_1 + 3.036915743078945e-02*G0_0_2 - 3.522952741702130e-03*G0_1_0 - 3.522952741702198e-03*G0_1_1 + 2.968413884212863e-03*G0_1_2 + 3.036915743078957e-02*G0_2_0 + 3.036915743078951e-02*G0_2_1 - 6.784946021056852e-03*G0_2_2;
    block[2315] = -4.227543290043269e-02*G0_0_2 - 4.296045148909733e-02*G0_1_0 - 4.296045148909731e-02*G0_1_1 - 6.850185886645680e-04*G0_1_2 - 4.227543290043306e-02*G0_2_0 - 4.227543290043308e-02*G0_2_1 + 4.397166940569693e-02*G0_2_2;
    block[2316] = 1.766369360770383e-01*G0_0_0 + 4.227543290043199e-02*G0_0_2 + 4.932133838383770e-02*G0_1_0 + 4.296045148909684e-02*G0_1_2 + 4.227543290043246e-02*G0_2_0;
    block[2317] = -3.346805104617571e-01*G0_0_0 - 8.386584721219999e-02*G0_0_2 - 1.677316944244013e-01*G0_1_0 - 7.770067991422110e-02*G0_1_2 - 8.386584721220033e-02*G0_2_0 + 1.047099842672756e-01*G0_2_2;
    block[2318] = 1.047099842672747e-01*G0_0_0 - 8.386584721220103e-02*G0_0_2 - 7.770067991422110e-02*G0_1_0 - 1.677316944244015e-01*G0_1_2 - 8.386584721220090e-02*G0_2_0 - 3.346805104617584e-01*G0_2_2;
    block[2319] = 4.227543290043270e-02*G0_0_2 + 4.296045148909725e-02*G0_1_0 + 4.932133838383826e-02*G0_1_2 + 4.227543290043305e-02*G0_2_0 + 1.766369360770396e-01*G0_2_2;
    block[2320] = 2.926007971580864e-02*G0_1_1 + 3.294613212147895e-03*G0_1_2 + 3.294613212147266e-03*G0_2_1;
    block[2321] = -1.898480088584245e-02*G0_1_1 - 9.492400442921232e-03*G0_1_2 - 9.492400442920481e-03*G0_2_1 - 6.523986558710812e-04*G0_2_2;
    block[2322] = 3.522952741702856e-03*G0_1_1 + 6.491366625915236e-03*G0_1_2 + 6.491366625914523e-03*G0_2_1 + 8.807381854256920e-03*G0_2_2;
    block[2323] = 4.296045148909736e-02*G0_1_1 + 4.227543290043295e-02*G0_1_2 + 4.227543290043312e-02*G0_2_1 + 6.426126760328142e-02*G0_2_2;
    block[2324] = -1.565756774090090e-01*G0_0_0 - 2.250775362754533e-02*G0_0_1 + 6.784946021057001e-02*G0_0_2 - 2.250775362754522e-02*G0_1_0 + 2.348635161135067e-02*G0_1_1 + 1.047099842672747e-01*G0_1_2 + 6.784946021057102e-02*G0_2_0 + 1.047099842672757e-01*G0_2_1;
    block[2325] = 9.296680846159822e-02*G0_0_0 - 2.700930435305416e-01*G0_0_1 - 1.350465217652707e-01*G0_0_2 - 2.700930435305418e-01*G0_1_0 - 5.401860870610827e-01*G0_1_1 - 2.700930435305412e-01*G0_1_2 - 1.350465217652715e-01*G0_2_0 - 2.700930435305415e-01*G0_2_1 + 9.296680846160030e-02*G0_2_2;
    block[2326] = 1.047099842672750e-01*G0_0_1 + 6.784946021057013e-02*G0_0_2 + 1.047099842672760e-01*G0_1_0 + 2.348635161135209e-02*G0_1_1 - 2.250775362754505e-02*G0_1_2 + 6.784946021057106e-02*G0_2_0 - 2.250775362754430e-02*G0_2_1 - 1.565756774090107e-01*G0_2_2;
    block[2327] = 1.957195967612614e-02*G0_0_0 + 7.486274576118238e-02*G0_0_1 + 1.418967076519138e-02*G0_0_2 + 7.486274576118329e-02*G0_1_0 + 1.497254915223662e-01*G0_1_1 + 2.837934153038343e-02*G0_1_2 + 1.418967076519170e-02*G0_2_0 + 2.837934153038250e-02*G0_2_1;
    block[2328] = 2.837934153038281e-02*G0_0_1 + 1.418967076519230e-02*G0_0_2 + 2.837934153038312e-02*G0_1_0 + 1.497254915223658e-01*G0_1_1 + 7.486274576118321e-02*G0_1_2 + 1.418967076519146e-02*G0_2_0 + 7.486274576118179e-02*G0_2_1 + 1.957195967612618e-02*G0_2_2;
    block[2329] = -1.272177378948182e-02*G0_0_1 - 6.523986558717409e-04*G0_0_2 - 1.272177378948229e-02*G0_1_0 - 1.135173661215323e-01*G0_1_1 - 1.272177378948245e-02*G0_1_2 - 6.523986558713855e-04*G0_2_0 - 1.272177378948153e-02*G0_2_1;
    block[2330] = 1.272177378948323e-02*G0_0_1 + 6.523986558705809e-04*G0_0_2 + 1.272177378948238e-02*G0_1_0 + 1.206937513361112e-02*G0_1_2 + 6.523986558714196e-04*G0_2_0 + 1.206937513361176e-02*G0_2_1 + 1.304797311741937e-03*G0_2_2;
    block[2331] = -2.837934153038400e-02*G0_0_1 - 1.418967076519118e-02*G0_0_2 - 2.837934153038324e-02*G0_1_0 - 1.418967076519138e-02*G0_1_2 - 1.418967076519149e-02*G0_2_0 - 1.418967076519171e-02*G0_2_1 - 3.327233144941458e-02*G0_2_2;
    block[2332] = -1.047099842672750e-01*G0_0_1 - 6.784946021057099e-02*G0_0_2 - 1.047099842672761e-01*G0_1_0 - 3.686052405670499e-02*G0_1_2 - 6.784946021057109e-02*G0_2_0 - 3.686052405670400e-02*G0_2_1 - 9.655500106889010e-02*G0_2_2;
    block[2333] = 1.957195967612596e-02*G0_0_0 + 1.810406270041555e-02*G0_0_1 + 2.984723850609221e-02*G0_0_2 + 1.810406270041640e-02*G0_1_0 + 1.027527882996634e-02*G0_1_2 + 2.984723850609242e-02*G0_2_0 + 1.027527882996575e-02*G0_2_1 + 4.012251733605873e-02*G0_2_2;
    block[2334] = 9.296680846160023e-02*G0_0_0 - 2.837934153038192e-02*G0_0_1 + 3.229373346560850e-02*G0_0_2 - 2.837934153038199e-02*G0_1_0 - 1.418967076519089e-02*G0_1_2 + 3.229373346560865e-02*G0_2_0 - 1.418967076519141e-02*G0_2_1 - 8.807381854255916e-03*G0_2_2;
    block[2335] = 3.914391935225226e-02*G0_0_0 + 1.272177378948246e-02*G0_0_1 + 4.468930792715481e-02*G0_0_2 + 1.272177378948207e-02*G0_1_0 + 1.206937513361088e-02*G0_1_2 + 4.468930792715523e-02*G0_2_0 + 1.206937513361113e-02*G0_2_1 + 5.023469650205657e-02*G0_2_2;
    block[2336] = -2.094199685345497e-01*G0_0_0 - 1.047099842672750e-01*G0_0_1 + 5.349668978141138e-02*G0_0_2 + 8.122363265592328e-02*G0_1_0 - 2.348635161135196e-02*G0_1_1 - 4.599410523889728e-02*G0_1_2 + 5.349668978141142e-02*G0_2_0 + 2.250775362754445e-02*G0_2_1 - 2.681358475629302e-01*G0_2_2;
    block[2337] = 7.261197039842794e-01*G0_0_0 + 2.700930435305415e-01*G0_0_1 + 2.700930435305404e-01*G0_0_2 + 2.700930435305415e-01*G0_1_0 + 5.401860870610827e-01*G0_1_1 + 2.700930435305410e-01*G0_1_2 + 2.700930435305404e-01*G0_2_0 + 2.700930435305410e-01*G0_2_1 + 7.261197039842822e-01*G0_2_2;
    block[2338] = -2.681358475629281e-01*G0_0_0 + 2.250775362754489e-02*G0_0_1 + 5.349668978141099e-02*G0_0_2 - 4.599410523889674e-02*G0_1_0 - 2.348635161135108e-02*G0_1_1 + 8.122363265592353e-02*G0_1_2 + 5.349668978141182e-02*G0_2_0 - 1.047099842672757e-01*G0_2_1 - 2.094199685345510e-01*G0_2_2;
    block[2339] = -4.481978765832885e-01*G0_0_0 - 3.268517265913059e-01*G0_0_1 - 2.240989382916444e-01*G0_0_2 - 1.213461499919821e-01*G0_1_0 - 1.497254915223643e-01*G0_1_1 - 7.486274576118221e-02*G0_1_2 - 2.240989382916441e-01*G0_2_0 - 1.776155340608439e-01*G0_2_1 - 3.718672338463839e-02*G0_2_2;
    block[2340] = -3.718672338463941e-02*G0_0_0 - 1.776155340608435e-01*G0_0_1 - 2.240989382916431e-01*G0_0_2 - 7.486274576118242e-02*G0_1_0 - 1.497254915223643e-01*G0_1_1 - 1.213461499919819e-01*G0_1_2 - 2.240989382916449e-01*G0_2_0 - 3.268517265913069e-01*G0_2_1 - 4.481978765832897e-01*G0_2_2;
    block[2341] = 1.722332451499100e-01*G0_0_0 + 1.986553907126797e-01*G0_0_1 + 1.660354579191363e-01*G0_0_2 + 1.007955923320497e-01*G0_1_0 + 1.135173661215318e-01*G0_1_1 + 1.007955923320495e-01*G0_1_2 + 1.660354579191366e-01*G0_2_0 + 1.986553907126807e-01*G0_2_1 + 1.722332451499097e-01*G0_2_2;
    block[2342] = 5.023469650205734e-02*G0_0_0 + 1.206937513361091e-02*G0_0_1 + 4.468930792715441e-02*G0_0_2 + 1.206937513361123e-02*G0_1_0 + 1.272177378948207e-02*G0_1_2 + 4.468930792715459e-02*G0_2_0 + 1.272177378948194e-02*G0_2_1 + 3.914391935225280e-02*G0_2_2;
    block[2343] = -8.807381854257005e-03*G0_0_0 - 1.418967076519089e-02*G0_0_1 + 3.229373346560867e-02*G0_0_2 - 1.418967076519143e-02*G0_1_0 - 2.837934153038215e-02*G0_1_2 + 3.229373346560812e-02*G0_2_0 - 2.837934153038233e-02*G0_2_1 + 9.296680846159941e-02*G0_2_2;
    block[2344] = -9.655500106888851e-02*G0_0_0 - 3.686052405670415e-02*G0_0_1 - 6.784946021057037e-02*G0_0_2 - 3.686052405670449e-02*G0_1_0 - 1.047099842672748e-01*G0_1_2 - 6.784946021057076e-02*G0_2_0 - 1.047099842672751e-01*G0_2_1;
    block[2345] = 4.012251733605864e-02*G0_0_0 + 1.027527882996592e-02*G0_0_1 + 2.984723850609230e-02*G0_0_2 + 1.027527882996615e-02*G0_1_0 + 1.810406270041619e-02*G0_1_2 + 2.984723850609267e-02*G0_2_0 + 1.810406270041627e-02*G0_2_1 + 1.957195967612626e-02*G0_2_2;
    block[2346] = -3.327233144941451e-02*G0_0_0 - 1.418967076519172e-02*G0_0_1 - 1.418967076519146e-02*G0_0_2 - 1.418967076519129e-02*G0_1_0 - 2.837934153038340e-02*G0_1_2 - 1.418967076519140e-02*G0_2_0 - 2.837934153038351e-02*G0_2_1;
    block[2347] = 1.304797311741724e-03*G0_0_0 + 1.206937513361187e-02*G0_0_1 + 6.523986558716622e-04*G0_0_2 + 1.206937513361112e-02*G0_1_0 + 1.272177378948232e-02*G0_1_2 + 6.523986558706789e-04*G0_2_0 + 1.272177378948248e-02*G0_2_1;
    block[2348] = -2.348635161135120e-01*G0_0_0 - 9.296680846159720e-02*G0_0_1 - 2.152915564373847e-01*G0_0_2 - 9.296680846159867e-02*G0_1_0 - 9.296680846159863e-02*G0_1_2 - 2.152915564373879e-01*G0_2_0 - 9.296680846159916e-02*G0_2_1 - 2.348635161135140e-01*G0_2_2;
    block[2349] = 3.522952741702689e-01*G0_0_0 + 1.027527882996617e-01*G0_0_1 + 1.027527882996624e-01*G0_0_2 + 1.027527882996620e-01*G0_1_0 + 2.984723850609237e-01*G0_1_2 + 1.027527882996619e-01*G0_2_0 + 2.984723850609246e-01*G0_2_1 - 1.859336169231994e-01*G0_2_2;
    block[2350] = -3.914391935225198e-02*G0_0_0 - 9.296680846160076e-02*G0_0_1 - 4.403690927128436e-02*G0_0_2 - 9.296680846159983e-02*G0_1_0 - 9.296680846159930e-02*G0_1_2 - 4.403690927128419e-02*G0_2_0 - 9.296680846159958e-02*G0_2_1 - 3.914391935225225e-02*G0_2_2;
    block[2351] = -1.859336169231987e-01*G0_0_0 + 2.984723850609227e-01*G0_0_1 + 1.027527882996600e-01*G0_0_2 + 2.984723850609238e-01*G0_1_0 + 1.027527882996614e-01*G0_1_2 + 1.027527882996628e-01*G0_2_0 + 1.027527882996620e-01*G0_2_1 + 3.522952741702715e-01*G0_2_2;
    block[2352] = 1.891956102025538e-02*G0_0_0 + 1.891956102025538e-02*G0_0_1 + 1.891956102025542e-02*G0_0_2 + 1.374212528726415e-02*G0_1_0 + 1.374212528726418e-02*G0_1_1 + 1.374212528726419e-02*G0_1_2 + 1.891956102025526e-02*G0_2_0 + 1.891956102025527e-02*G0_2_1 + 1.891956102025527e-02*G0_2_2;
    block[2353] = 3.359853077735001e-02*G0_0_0 - 1.439452394313490e-02*G0_1_0;
    block[2354] = -1.374212528726410e-02*G0_1_1;
    block[2355] = 5.177435732991130e-03*G0_1_2 + 1.891956102025534e-02*G0_2_2;
    block[2356] = -1.285225352065617e-01*G0_0_0 - 9.629404160654047e-02*G0_0_1 - 9.629404160654045e-02*G0_1_0 - 1.247386230025105e-01*G0_1_1;
    block[2357] = 4.762510187857377e-02*G0_0_0 + 6.236931150125542e-02*G0_0_1 + 6.236931150125544e-02*G0_1_0 + 1.247386230025108e-01*G0_1_1;
    block[2358] = -1.500516908502996e-02*G0_0_0 - 3.777388217492342e-02*G0_0_1 - 3.777388217492370e-02*G0_1_0 - 1.270872581636461e-01*G0_1_1;
    block[2359] = 9.394540644540461e-03*G0_0_1 + 9.394540644540459e-03*G0_1_0 + 6.413078787210655e-02*G0_1_1;
    block[2360] = -9.394540644540308e-03*G0_0_1 - 9.394540644540459e-03*G0_1_0 - 9.394540644540430e-03*G0_1_2 - 9.394540644540391e-03*G0_2_1;
    block[2361] = -1.500516908503016e-02*G0_0_0 - 6.523986558738544e-05*G0_0_1 - 1.500516908503019e-02*G0_0_2 - 6.523986558727676e-05*G0_1_0 - 6.523986558711209e-05*G0_1_2 - 1.500516908503034e-02*G0_2_0 - 6.523986558723023e-05*G0_2_1 - 1.500516908503032e-02*G0_2_2;
    block[2362] = -1.304797311741860e-03*G0_0_0 - 6.523986558687707e-05*G0_0_1 - 1.304797311741831e-03*G0_0_2 - 6.523986558710871e-05*G0_1_0 - 6.523986558722236e-05*G0_1_2 - 1.304797311741543e-03*G0_2_0 - 6.523986558686242e-05*G0_2_1 - 1.304797311741572e-03*G0_2_2;
    block[2363] = -3.066273682593112e-02*G0_0_0 - 9.394540644540728e-03*G0_0_1 - 3.066273682593105e-02*G0_0_2 - 9.394540644540619e-03*G0_1_0 - 9.394540644540546e-03*G0_1_2 - 3.066273682593122e-02*G0_2_0 - 9.394540644540757e-03*G0_2_1 - 3.066273682593120e-02*G0_2_2;
    block[2364] = -6.934997711907390e-02*G0_0_0 - 9.061817330046429e-02*G0_0_1 - 9.061817330046432e-02*G0_0_2 - 5.473624722756624e-02*G0_1_0 - 6.413078787210660e-02*G0_1_1 - 6.413078787210662e-02*G0_1_2 - 9.061817330046390e-02*G0_2_0 - 1.118863694818546e-01*G0_2_1 - 1.118863694818545e-01*G0_2_2;
    block[2365] = 8.468134553203938e-02*G0_0_0 + 1.734728025960652e-01*G0_0_1 + 1.734728025960652e-01*G0_0_2 + 8.931337598872247e-02*G0_1_0 + 1.270872581636459e-01*G0_1_1 + 1.270872581636459e-01*G0_1_2 + 1.734728025960646e-01*G0_2_0 + 2.094199685345501e-01*G0_2_1 + 2.094199685345500e-01*G0_2_2;
    block[2366] = -3.392473010528558e-03*G0_0_0 - 1.980682319223969e-01*G0_0_1 - 1.980682319223969e-01*G0_0_2 - 6.236931150125571e-02*G0_1_0 - 1.247386230025110e-01*G0_1_1 - 1.247386230025109e-01*G0_1_2 - 1.980682319223965e-01*G0_2_0 - 2.713978408422830e-01*G0_2_1 - 2.713978408422830e-01*G0_2_2;
    block[2367] = -6.445698720004246e-02*G0_0_0 + 9.629404160654056e-02*G0_0_1 + 9.629404160654047e-02*G0_0_2 + 2.844458139597025e-02*G0_1_0 + 1.247386230025107e-01*G0_1_1 + 1.247386230025105e-01*G0_1_2 + 9.629404160654055e-02*G0_2_0;
    block[2368] = -6.132547365186218e-02*G0_0_0 - 6.132547365186217e-02*G0_0_1 - 4.005727747047180e-02*G0_0_2 - 1.878908128908096e-02*G0_1_0 - 1.878908128908100e-02*G0_1_1 - 9.394540644540757e-03*G0_1_2 - 4.005727747047173e-02*G0_2_0 - 4.005727747047176e-02*G0_2_1 - 1.878908128908116e-02*G0_2_2;
    block[2369] = -2.544354757896400e-02*G0_0_0 - 2.544354757896392e-02*G0_0_1 + 1.363513190770137e-02*G0_0_2 + 1.487468935385611e-02*G0_1_0 + 1.487468935385608e-02*G0_1_1 - 6.523986558682555e-05*G0_1_2 + 1.363513190770108e-02*G0_2_0 + 1.363513190770107e-02*G0_2_1 - 1.304797311741354e-04*G0_2_2;
    block[2370] = -5.284429112554080e-02*G0_0_0 - 5.284429112554082e-02*G0_0_1 - 1.376561163887534e-02*G0_0_2 + 1.174317580567109e-03*G0_1_0 + 1.174317580567133e-03*G0_1_1 - 6.523986558744663e-05*G0_1_2 - 1.376561163887561e-02*G0_2_0 - 1.376561163887556e-02*G0_2_1 - 1.304797311739905e-04*G0_2_2;
    block[2371] = 2.126819618139045e-02*G0_0_2 + 1.187365553685040e-02*G0_1_0 + 1.187365553685037e-02*G0_1_1 - 9.394540644540239e-03*G0_1_2 + 2.126819618139059e-02*G0_2_0 + 2.126819618139059e-02*G0_2_1 - 1.878908128908135e-02*G0_2_2;
    block[2372] = -2.570450704131235e-01*G0_0_0 - 9.629404160654037e-02*G0_0_2 - 1.925880832130812e-01*G0_1_0 - 1.247386230025105e-01*G0_1_2 - 9.629404160654108e-02*G0_2_0;
    block[2373] = 1.213461499919818e-01*G0_0_0 - 7.332960891988642e-02*G0_0_2 - 1.096029741863125e-02*G0_1_0 - 1.466592178397726e-01*G0_1_2 - 7.332960891988591e-02*G0_2_0 - 2.713978408422828e-01*G0_2_2;
    block[2374] = -5.284429112554033e-02*G0_0_0 + 3.594716593848538e-02*G0_0_2 - 1.826716236437857e-03*G0_1_0 + 8.233271037090456e-02*G0_1_2 + 3.594716593848496e-02*G0_2_0 + 2.094199685345501e-01*G0_2_2;
    block[2375] = -2.126819618139077e-02*G0_0_2 - 1.187365553685058e-02*G0_1_0 - 4.775558160974833e-02*G0_1_2 - 2.126819618139072e-02*G0_2_0 - 1.118863694818550e-01*G0_2_2;
    block[2376] = 1.878908128908107e-02*G0_1_1 + 9.394540644540416e-03*G0_1_2 + 9.394540644540790e-03*G0_2_1;
    block[2377] = -1.487468935385612e-02*G0_1_1 - 1.493992921944290e-02*G0_1_2 - 1.493992921944329e-02*G0_2_1 - 1.500516908502969e-02*G0_2_2;
    block[2378] = -1.174317580567134e-03*G0_1_1 - 1.239557446154764e-03*G0_1_2 - 1.239557446154258e-03*G0_2_1 - 1.304797311742006e-03*G0_2_2;
    block[2379] = -1.187365553685049e-02*G0_1_1 - 2.126819618139063e-02*G0_1_2 - 2.126819618139066e-02*G0_2_1 - 3.066273682593113e-02*G0_2_2;
    block[2380] = 5.219189246967076e-02*G0_0_0 - 2.713978408422821e-01*G0_0_1 - 1.356989204211404e-01*G0_0_2 - 2.713978408422824e-01*G0_1_0 - 5.427956816845653e-01*G0_1_1 - 2.713978408422818e-01*G0_1_2 - 1.356989204211408e-01*G0_2_0 - 2.713978408422834e-01*G0_2_1;
    block[2381] = -8.807381854256745e-02*G0_0_0 + 4.599410523889649e-02*G0_0_1 + 9.133581182192435e-03*G0_0_2 + 4.599410523889631e-02*G0_1_0 + 2.348635161135085e-02*G0_1_1 - 8.122363265592404e-02*G0_1_2 + 9.133581182192299e-03*G0_2_0 - 8.122363265592350e-02*G0_2_1 - 1.859336169231985e-01*G0_2_2;
    block[2382] = -5.284429112554087e-02*G0_0_1 - 3.783912204051064e-02*G0_0_2 - 5.284429112554111e-02*G0_1_0 - 5.349668978141185e-02*G0_1_1 - 6.523986558711247e-04*G0_1_2 - 3.783912204051068e-02*G0_2_0 - 6.523986558714861e-04*G0_2_1 + 5.219189246967011e-02*G0_2_2;
    block[2383] = -2.283395295548053e-02*G0_0_0 + 7.372104811340925e-02*G0_0_1 + 3.686052405670459e-02*G0_0_2 + 7.372104811340904e-02*G0_1_0 + 2.094199685345507e-01*G0_1_1 + 1.047099842672751e-01*G0_1_2 + 3.686052405670448e-02*G0_2_0 + 1.047099842672763e-01*G0_2_1;
    block[2384] = -1.272177378948208e-02*G0_0_1 - 1.206937513361138e-02*G0_0_2 - 1.272177378948183e-02*G0_1_0 + 1.370037177328856e-02*G0_1_1 + 1.989815900406211e-02*G0_1_2 - 1.206937513361089e-02*G0_2_0 + 1.989815900406238e-02*G0_2_1 + 2.609594623483543e-02*G0_2_2;
    block[2385] = -3.001033817006019e-02*G0_0_1 - 1.500516908502997e-02*G0_0_2 - 3.001033817006038e-02*G0_1_0 - 1.056885822510816e-01*G0_1_1 - 5.284429112554115e-02*G0_1_2 - 1.500516908503005e-02*G0_2_0 - 5.284429112554132e-02*G0_2_1;
    block[2386] = 3.001033817006001e-02*G0_0_1 + 1.500516908503001e-02*G0_0_2 + 3.001033817006048e-02*G0_1_0 + 1.500516908503019e-02*G0_1_2 + 1.500516908503010e-02*G0_2_0 + 1.500516908503034e-02*G0_2_1 + 3.001033817005993e-02*G0_2_2;
    block[2387] = 1.272177378948225e-02*G0_0_1 + 1.206937513361107e-02*G0_0_2 + 1.272177378948191e-02*G0_1_0 + 6.523986558710484e-04*G0_1_2 + 1.206937513361095e-02*G0_2_0 + 6.523986558706462e-04*G0_2_1 + 1.304797311741627e-03*G0_2_2;
    block[2388] = 5.284429112554080e-02*G0_0_1 + 3.783912204051126e-02*G0_0_2 + 5.284429112554108e-02*G0_1_0 + 1.500516908503028e-02*G0_1_2 + 3.783912204051067e-02*G0_2_0 + 1.500516908502987e-02*G0_2_1 + 3.001033817006098e-02*G0_2_2;
    block[2389] = -2.283395295548061e-02*G0_0_0 + 1.304797311742115e-03*G0_0_1 - 1.076457782186919e-02*G0_0_2 + 1.304797311740542e-03*G0_1_0 + 6.523986558707900e-04*G0_1_2 - 1.076457782186934e-02*G0_2_0 + 6.523986558701638e-04*G0_2_1 + 1.304797311741828e-03*G0_2_2;
    block[2390] = -8.807381854256857e-02*G0_0_0 + 1.272177378948191e-02*G0_0_1 + 6.523986558703785e-04*G0_0_2 + 1.272177378948227e-02*G0_1_0 + 6.523986558707405e-04*G0_1_2 + 6.523986558709273e-04*G0_2_0 + 6.523986558715516e-04*G0_2_1 + 1.304797311741126e-03*G0_2_2;
    block[2391] = -4.566790591096104e-02*G0_0_0 + 3.001033817006001e-02*G0_0_1 - 7.828783870450169e-03*G0_0_2 + 3.001033817006025e-02*G0_1_0 + 1.500516908503024e-02*G0_1_2 - 7.828783870450336e-03*G0_2_0 + 1.500516908503076e-02*G0_2_1 + 3.001033817006057e-02*G0_2_2;
    block[2392] = 1.056885822510813e-01*G0_0_0 + 5.284429112554103e-02*G0_0_1 - 2.218155429960913e-02*G0_0_2 + 6.523986558709450e-04*G0_1_0 + 5.349668978141193e-02*G0_1_1 + 5.284429112554116e-02*G0_1_2 - 2.218155429960912e-02*G0_2_0 + 6.523986558715775e-04*G0_2_1 + 1.056885822510825e-01*G0_2_2;
    block[2393] = -2.681358475629281e-01*G0_0_0 - 4.599410523889674e-02*G0_0_1 + 5.349668978141184e-02*G0_0_2 + 2.250775362754489e-02*G0_1_0 - 2.348635161135108e-02*G0_1_1 - 1.047099842672757e-01*G0_1_2 + 5.349668978141098e-02*G0_2_0 + 8.122363265592350e-02*G0_2_1 - 2.094199685345510e-01*G0_2_2;
    block[2394] = 6.471794666239067e-01*G0_0_0 + 2.713978408422827e-01*G0_0_1 + 2.713978408422834e-01*G0_0_2 + 2.713978408422827e-01*G0_1_0 + 5.427956816845657e-01*G0_1_1 + 2.713978408422834e-01*G0_1_2 + 2.713978408422834e-01*G0_2_0 + 2.713978408422834e-01*G0_2_1 + 5.427956816845659e-01*G0_2_2;
    block[2395] = 1.722332451499099e-01*G0_0_0 + 7.143765281785966e-02*G0_0_1 + 6.197787230772377e-03*G0_0_2 - 2.642214556276999e-02*G0_1_0 - 1.370037177328797e-02*G0_1_1 + 6.197787230772896e-03*G0_1_2 + 6.197787230773510e-03*G0_2_0 + 6.197787230772921e-03*G0_2_1 + 1.239557446154548e-02*G0_2_2;
    block[2396] = -5.845491956603037e-01*G0_0_0 - 3.901343962107825e-01*G0_0_1 - 2.629166583159628e-01*G0_0_2 - 1.356989204211417e-01*G0_1_0 - 2.094199685345496e-01*G0_1_1 - 1.047099842672749e-01*G0_1_2 - 2.629166583159622e-01*G0_2_0 - 2.906436011904726e-01*G0_2_1 - 2.094199685345492e-01*G0_2_2;
    block[2397] = 2.557402731013833e-01*G0_0_0 + 1.800620290203621e-01*G0_0_1 + 1.278701365506919e-01*G0_0_2 + 7.567824408102124e-02*G0_1_0 + 1.056885822510820e-01*G0_1_1 + 5.284429112554079e-02*G0_1_2 + 1.278701365506917e-01*G0_2_0 + 1.050361835952104e-01*G0_2_1 + 1.056885822510814e-01*G0_2_2;
    block[2398] = 1.278701365506919e-01*G0_0_0 + 3.783912204051101e-02*G0_0_1 + 9.003101451018113e-02*G0_0_2 + 3.783912204051068e-02*G0_1_0 + 5.284429112554091e-02*G0_1_2 + 9.003101451018104e-02*G0_2_0 + 5.284429112554116e-02*G0_2_1 + 5.219189246967010e-02*G0_2_2;
    block[2399] = -2.922745978301523e-01*G0_0_0 - 6.784946021057141e-02*G0_0_1 - 1.950671981053912e-01*G0_0_2 - 6.784946021057084e-02*G0_1_0 - 1.047099842672752e-01*G0_1_2 - 1.950671981053914e-01*G0_2_0 - 1.047099842672754e-01*G0_2_1 - 1.859336169231981e-01*G0_2_2;
    block[2400] = 3.235897333119532e-01*G0_0_0 + 1.356989204211417e-01*G0_0_1 + 1.356989204211411e-01*G0_0_2 + 1.356989204211411e-01*G0_1_0 + 2.713978408422825e-01*G0_1_2 + 1.356989204211420e-01*G0_2_0 + 2.713978408422827e-01*G0_2_1;
    block[2401] = 5.023469650205722e-02*G0_0_0 + 5.545388574902110e-03*G0_0_1 + 3.816532136844587e-02*G0_0_2 + 5.545388574901969e-03*G0_1_0 + 6.197787230771895e-03*G0_1_2 + 3.816532136844566e-02*G0_2_0 + 6.197787230772493e-03*G0_2_1 + 2.609594623483442e-02*G0_2_2;
    block[2402] = -9.655500106888942e-02*G0_0_0 - 6.784946021057095e-02*G0_0_1 - 3.686052405670462e-02*G0_0_2 - 6.784946021057030e-02*G0_1_0 - 1.047099842672753e-01*G0_1_2 - 3.686052405670442e-02*G0_2_0 - 1.047099842672747e-01*G0_2_1;
    block[2403] = 3.001033817006022e-02*G0_0_0 + 3.783912204051084e-02*G0_0_1 + 1.500516908502996e-02*G0_0_2 + 3.783912204051092e-02*G0_1_0 + 5.284429112554116e-02*G0_1_2 + 1.500516908503051e-02*G0_2_0 + 5.284429112554115e-02*G0_2_1;
    block[2404] = 1.435277042915926e-01*G0_0_0 - 7.502584542515139e-02*G0_0_1 - 4.240591263160802e-02*G0_0_2 - 7.502584542514963e-02*G0_1_0 - 2.609594623483431e-02*G0_1_2 - 4.240591263160544e-02*G0_2_0 - 2.609594623483411e-02*G0_2_1 - 5.219189246966884e-02*G0_2_2;
    block[2405] = -1.500516908503023e-01*G0_0_0 + 3.164133480973728e-01*G0_0_1 + 1.859336169231977e-01*G0_0_2 + 3.164133480973719e-01*G0_1_0 + 1.859336169231984e-01*G0_1_2 + 1.859336169231967e-01*G0_2_0 + 1.859336169231967e-01*G0_2_1 + 3.718672338463962e-01*G0_2_2;
    block[2406] = 4.566790591096103e-02*G0_0_0 - 7.502584542515038e-02*G0_0_1 - 2.609594623483456e-02*G0_0_2 - 7.502584542514952e-02*G0_1_0 - 2.609594623483392e-02*G0_1_2 - 2.609594623483519e-02*G0_2_0 - 2.609594623483553e-02*G0_2_1 - 5.219189246966976e-02*G0_2_2;
    block[2407] = 1.761476370851358e-01*G0_0_0 - 5.871587902837790e-02*G0_0_1 - 9.785979838062465e-03*G0_0_2 - 5.871587902837874e-02*G0_1_0 - 2.609594623483556e-02*G0_1_2 - 9.785979838063326e-03*G0_2_0 - 2.609594623483562e-02*G0_2_1 - 5.219189246967140e-02*G0_2_2;
    block[2408] = -2.984723850609237e-02*G0_0_0 - 2.984723850609233e-02*G0_0_1 - 2.984723850609238e-02*G0_0_2 - 3.457190957190924e-02*G0_1_0 - 3.457190957190926e-02*G0_1_1 - 3.457190957190925e-02*G0_1_2 - 2.984723850609236e-02*G0_2_0 - 2.984723850609235e-02*G0_2_1 - 2.984723850609247e-02*G0_2_2;
    block[2409] = 1.174317580567569e-02*G0_0_0 + 2.278176106301050e-03*G0_1_0;
    block[2410] = -9.464999699374628e-03*G0_1_1;
    block[2411] = 4.724671065816815e-03*G0_1_2 - 2.984723850609258e-02*G0_2_2;
    block[2412] = -9.133581182192025e-03*G0_0_0 - 5.838967970043961e-03*G0_0_1 - 5.838967970044304e-03*G0_1_0 - 2.544354757896255e-03*G0_1_1;
    block[2413] = -1.565756774090090e-02*G0_0_0 - 1.308059305021114e-02*G0_0_1 - 1.308059305021053e-02*G0_1_0 - 1.050361835952079e-02*G0_1_1;
    block[2414] = -6.523986558709247e-04*G0_0_0 + 1.924576034819010e-03*G0_0_1 + 1.924576034818810e-03*G0_1_0 + 4.501550725508709e-03*G0_1_1;
    block[2415] = 3.294613212148260e-03*G0_0_1 + 3.294613212148299e-03*G0_1_0 + 6.589226424296238e-03*G0_1_1;
    block[2416] = -3.294613212147822e-03*G0_0_1 - 3.294613212148252e-03*G0_1_0 + 2.267085329151283e-02*G0_1_1 - 3.294613212148261e-03*G0_1_2 - 3.294613212148304e-03*G0_2_1;
    block[2417] = -6.523986558707774e-04*G0_0_0 + 8.840001787050421e-03*G0_0_1 - 6.523986558708691e-04*G0_0_2 + 8.840001787050362e-03*G0_1_0 - 6.523986558706903e-04*G0_1_1 + 8.840001787050399e-03*G0_1_2 - 6.523986558708639e-04*G0_2_0 + 8.840001787050831e-03*G0_2_1 - 6.523986558709471e-04*G0_2_2;
    block[2418] = 8.807381854256708e-03*G0_0_0 + 2.316015228341358e-03*G0_0_1 + 8.807381854256740e-03*G0_0_2 + 2.316015228341518e-03*G0_1_0 - 6.523986558711723e-04*G0_1_1 + 2.316015228341449e-03*G0_1_2 + 8.807381854257159e-03*G0_2_0 + 2.316015228341317e-03*G0_2_1 + 8.807381854257159e-03*G0_2_2;
    block[2419] = 6.426126760328107e-02*G0_0_0 + 2.198583470284850e-02*G0_0_1 + 6.426126760328099e-02*G0_0_2 + 2.198583470284852e-02*G0_1_0 + 2.267085329151298e-02*G0_1_1 + 2.198583470284851e-02*G0_1_2 + 6.426126760328127e-02*G0_2_0 + 2.198583470284847e-02*G0_2_1 + 6.426126760328128e-02*G0_2_2;
    block[2420] = 4.397166940569663e-02*G0_0_0 + 8.624710230612917e-02*G0_0_1 + 8.624710230612920e-02*G0_0_2 + 4.465668799436129e-02*G0_1_0 + 4.397166940569690e-02*G0_1_1 + 4.397166940569689e-02*G0_1_2 + 8.624710230612942e-02*G0_2_0 + 1.285225352065621e-01*G0_2_1 + 1.285225352065622e-01*G0_2_2;
    block[2421] = -6.784946021056766e-03*G0_0_0 - 3.715410345184619e-02*G0_0_1 - 3.715410345184623e-02*G0_0_2 - 9.753359905269605e-03*G0_1_0 - 4.364547007776133e-02*G0_1_1 - 4.364547007776132e-02*G0_1_2 - 3.715410345184609e-02*G0_2_0 + 3.718672338463971e-02*G0_2_1 + 3.718672338463971e-02*G0_2_2;
    block[2422] = 1.278701365506890e-02*G0_0_0 - 2.508472831823480e-02*G0_0_1 - 2.508472831823482e-02*G0_0_2 + 3.294613212147968e-03*G0_1_0 - 1.559232787531335e-02*G0_1_1 - 1.559232787531335e-02*G0_1_2 - 2.508472831823539e-02*G0_2_0 - 6.197787230773032e-03*G0_2_1 - 6.197787230773077e-03*G0_2_2;
    block[2423] = -3.186967433929206e-02*G0_0_0 + 5.838967970043969e-03*G0_0_1 + 5.838967970044024e-03*G0_0_2 - 5.904207835631442e-03*G0_1_0 + 2.544354757896224e-03*G0_1_1 + 2.544354757896289e-03*G0_1_2 + 5.838967970044615e-03*G0_2_0;
    block[2424] = 1.766369360770386e-01*G0_0_0 + 1.766369360770385e-01*G0_0_1 + 1.343615031766060e-01*G0_0_2 + 1.273155976932005e-01*G0_1_0 + 1.273155976932004e-01*G0_1_1 + 1.280006162818649e-01*G0_1_2 + 1.343615031766061e-01*G0_2_0 + 1.343615031766059e-01*G0_2_1 + 9.208607027617341e-02*G0_2_2;
    block[2425] = -3.346805104617576e-01*G0_0_0 - 3.346805104617573e-01*G0_0_1 - 2.508146632495569e-01*G0_0_2 - 1.669488160373559e-01*G0_1_0 - 1.669488160373558e-01*G0_1_1 - 1.607836487393760e-01*G0_1_2 - 2.508146632495570e-01*G0_2_0 - 2.508146632495568e-01*G0_2_1 - 6.223883177008024e-02*G0_2_2;
    block[2426] = 1.047099842672750e-01*G0_0_0 + 1.047099842672749e-01*G0_0_1 + 1.885758314794755e-01*G0_0_2 + 1.824106641814961e-01*G0_1_0 + 1.824106641814961e-01*G0_1_1 + 9.854481696929458e-02*G0_1_2 + 1.885758314794762e-01*G0_2_0 + 1.885758314794762e-01*G0_2_1 - 6.223883177008275e-02*G0_2_2;
    block[2427] = -4.227543290043244e-02*G0_0_2 - 4.296045148909686e-02*G0_1_0 - 4.296045148909684e-02*G0_1_1 - 3.591454600569124e-02*G0_1_2 - 4.227543290043326e-02*G0_2_0 - 4.227543290043324e-02*G0_2_1 + 9.208607027617442e-02*G0_2_2;
    block[2428] = -4.354761027938038e-02*G0_0_0 - 5.838967970043949e-03*G0_0_2 - 1.428753056357179e-02*G0_1_0 - 2.544354757896216e-03*G0_1_2 - 5.838967970044116e-03*G0_2_0;
    block[2429] = 5.675868306076525e-02*G0_0_0 + 1.888694108746114e-02*G0_0_2 + 3.777388217492282e-02*G0_1_0 + 9.394540644540244e-03*G0_1_2 + 1.888694108746192e-02*G0_2_0 - 6.197787230772859e-03*G0_2_2;
    block[2430] = 1.047099842672754e-01*G0_0_0 + 7.434082683648624e-02*G0_0_2 + 1.082329370089780e-01*G0_1_0 + 8.083219346240099e-02*G0_1_2 + 7.434082683648557e-02*G0_2_0 + 3.718672338463911e-02*G0_2_2;
    block[2431] = 4.227543290043240e-02*G0_0_2 + 4.296045148909688e-02*G0_1_0 + 8.455086580086521e-02*G0_1_2 + 4.227543290043324e-02*G0_2_0 + 1.285225352065629e-01*G0_2_2;
    block[2432] = 2.926007971580886e-02*G0_1_1 + 3.294613212148322e-03*G0_1_2 + 3.294613212147174e-03*G0_2_1;
    block[2433] = -1.898480088584252e-02*G0_1_1 - 9.492400442921795e-03*G0_1_2 - 9.492400442920277e-03*G0_2_1 - 6.523986558712478e-04*G0_2_2;
    block[2434] = 3.522952741702895e-03*G0_1_1 + 6.491366625915951e-03*G0_1_2 + 6.491366625914319e-03*G0_2_1 + 8.807381854257054e-03*G0_2_2;
    block[2435] = 4.296045148909685e-02*G0_1_1 + 4.227543290043224e-02*G0_1_2 + 4.227543290043327e-02*G0_2_1 + 6.426126760328153e-02*G0_2_2;
    block[2436] = 3.914391935225197e-02*G0_0_0 + 2.642214556276993e-02*G0_0_1 - 5.545388574902278e-03*G0_0_2 + 2.642214556277049e-02*G0_1_0 + 1.370037177328811e-02*G0_1_1 - 6.197787230772973e-03*G0_1_2 - 5.545388574902391e-03*G0_2_0 - 6.197787230773127e-03*G0_2_1;
    block[2437] = 9.296680846160034e-02*G0_0_0 + 1.213461499919824e-01*G0_0_1 + 6.067307499599154e-02*G0_0_2 + 1.213461499919823e-01*G0_1_0 + 1.497254915223644e-01*G0_1_1 + 7.486274576118238e-02*G0_1_2 + 6.067307499599113e-02*G0_2_0 + 7.486274576118231e-02*G0_2_1 + 1.957195967612689e-02*G0_2_2;
    block[2438] = 1.047099842672750e-01*G0_0_1 + 6.784946021057085e-02*G0_0_2 + 1.047099842672752e-01*G0_1_0 + 2.094199685345502e-01*G0_1_1 + 1.356989204211416e-01*G0_1_2 + 6.784946021057141e-02*G0_2_0 + 1.356989204211426e-01*G0_2_1 + 3.914391935225178e-02*G0_2_2;
    block[2439] = 1.957195967612641e-02*G0_0_0 + 1.467896975710244e-03*G0_0_1 - 1.027527882996621e-02*G0_0_2 + 1.467896975709167e-03*G0_1_0 - 1.663616572470656e-02*G0_1_1 - 1.810406270041648e-02*G0_1_2 - 1.027527882996614e-02*G0_2_0 - 1.810406270041680e-02*G0_2_1;
    block[2440] = 2.837934153038318e-02*G0_0_1 + 1.418967076519107e-02*G0_0_2 + 2.837934153038314e-02*G0_1_0 + 5.675868306076633e-02*G0_1_1 + 2.837934153038265e-02*G0_1_2 + 1.418967076519157e-02*G0_2_0 + 2.837934153038276e-02*G0_2_1 - 4.892989919031569e-03*G0_2_2;
    block[2441] = -1.272177378948243e-02*G0_0_1 - 6.523986558703014e-04*G0_0_2 - 1.272177378948213e-02*G0_1_0 - 2.544354757896474e-02*G0_1_1 - 1.304797311741595e-03*G0_1_2 - 6.523986558714177e-04*G0_2_0 - 1.304797311741660e-03*G0_2_1;
    block[2442] = 1.272177378948161e-02*G0_0_1 + 6.523986558712534e-04*G0_0_2 + 1.272177378948198e-02*G0_1_0 - 8.807381854256806e-02*G0_1_1 + 6.523986558713471e-04*G0_1_2 + 6.523986558713128e-04*G0_2_0 + 6.523986558718772e-04*G0_2_1 + 1.304797311742215e-03*G0_2_2;
    block[2443] = -2.837934153038249e-02*G0_0_1 - 1.418967076519146e-02*G0_0_2 - 2.837934153038294e-02*G0_1_0 + 9.296680846159984e-02*G0_1_1 + 3.229373346560796e-02*G0_1_2 - 1.418967076519146e-02*G0_2_0 + 3.229373346560810e-02*G0_2_1 - 8.807381854256146e-03*G0_2_2;
    block[2444] = -1.047099842672750e-01*G0_0_1 - 6.784946021057051e-02*G0_0_2 - 1.047099842672750e-01*G0_1_0 - 1.859336169231992e-01*G0_1_1 - 1.950671981053911e-01*G0_1_2 - 6.784946021057127e-02*G0_2_0 - 1.950671981053906e-01*G0_2_1 - 2.922745978301529e-01*G0_2_2;
    block[2445] = 1.957195967612607e-02*G0_0_0 - 5.529078608505603e-02*G0_0_1 + 5.382288910934690e-03*G0_0_2 - 5.529078608505687e-02*G0_1_0 + 1.957195967612621e-02*G0_1_1 - 4.110111531986493e-02*G0_1_2 + 5.382288910934134e-03*G0_2_0 - 4.110111531986596e-02*G0_2_1 - 8.807381854257683e-03*G0_2_2;
    block[2446] = 9.296680846159867e-02*G0_0_0 + 3.630598519921399e-01*G0_0_1 + 2.280133302268696e-01*G0_0_2 + 3.630598519921406e-01*G0_1_0 + 9.296680846159848e-02*G0_1_1 + 2.280133302268699e-01*G0_1_2 + 2.280133302268703e-01*G0_2_0 + 2.280133302268693e-01*G0_2_1 + 4.560266604537420e-01*G0_2_2;
    block[2447] = -1.565756774090095e-01*G0_0_0 - 1.340679237814644e-01*G0_0_1 - 2.244251376195802e-01*G0_0_2 - 1.340679237814641e-01*G0_1_0 - 8.807381854256775e-02*G0_1_1 - 9.720739972476002e-02*G0_1_2 - 2.244251376195804e-01*G0_2_0 - 9.720739972475934e-02*G0_2_1 - 2.922745978301520e-01*G0_2_2;
    block[2448] = -2.094199685345502e-01*G0_0_0 - 1.047099842672746e-01*G0_0_1 - 2.629166583159615e-01*G0_0_2 - 2.906436011904740e-01*G0_1_0 - 2.094199685345495e-01*G0_1_1 - 3.901343962107825e-01*G0_1_2 - 2.629166583159618e-01*G0_2_0 - 1.356989204211421e-01*G0_2_1 - 5.845491956603038e-01*G0_2_2;
    block[2449] = -4.481978765832884e-01*G0_0_0 - 1.213461499919821e-01*G0_0_1 - 2.240989382916441e-01*G0_0_2 - 3.268517265913059e-01*G0_1_0 - 1.497254915223643e-01*G0_1_1 - 1.776155340608438e-01*G0_1_2 - 2.240989382916444e-01*G0_2_0 - 7.486274576118221e-02*G0_2_1 - 3.718672338463839e-02*G0_2_2;
    block[2450] = 1.722332451499099e-01*G0_0_0 - 2.642214556276999e-02*G0_0_1 + 6.197787230773509e-03*G0_0_2 + 7.143765281785969e-02*G0_1_0 - 1.370037177328797e-02*G0_1_1 + 6.197787230772925e-03*G0_1_2 + 6.197787230772382e-03*G0_2_0 + 6.197787230772900e-03*G0_2_1 + 1.239557446154549e-02*G0_2_2;
    block[2451] = 7.261197039842807e-01*G0_0_0 + 4.560266604537391e-01*G0_0_1 + 4.560266604537397e-01*G0_0_2 + 4.560266604537391e-01*G0_1_0 + 7.261197039842807e-01*G0_1_1 + 4.560266604537404e-01*G0_1_2 + 4.560266604537397e-01*G0_2_0 + 4.560266604537404e-01*G0_2_1 + 9.120533209074830e-01*G0_2_2;
    block[2452] = -3.718672338463954e-02*G0_0_0 + 1.404288106762046e-01*G0_0_1 + 1.869122149070044e-01*G0_0_2 + 3.767602237654352e-02*G0_1_0 + 6.556606491502251e-02*G0_1_1 + 1.404288106762046e-01*G0_1_2 + 1.869122149070064e-01*G0_2_0 + 3.767602237654308e-02*G0_2_1 - 3.718672338463977e-02*G0_2_2;
    block[2453] = -2.681358475629289e-01*G0_0_0 - 2.906436011904737e-01*G0_0_1 - 3.216325373443398e-01*G0_0_2 - 2.221417423240321e-01*G0_1_0 - 2.681358475629285e-01*G0_1_1 - 1.944147994495201e-01*G0_1_2 - 3.216325373443407e-01*G0_2_0 - 4.488502752391614e-01*G0_2_1 - 5.845491956603037e-01*G0_2_2;
    block[2454] = -9.655500106888951e-02*G0_0_0 - 5.969447701218482e-02*G0_0_1 - 2.870554085831862e-02*G0_0_2 - 5.969447701218488e-02*G0_1_0 - 2.283395295548074e-02*G0_1_1 - 9.655500106888899e-02*G0_1_2 - 2.870554085831904e-02*G0_2_0 - 9.655500106888926e-02*G0_2_1 + 3.914391935225234e-02*G0_2_2;
    block[2455] = -8.807381854256165e-03*G0_0_0 + 5.382288910934747e-03*G0_0_1 - 4.110111531986497e-02*G0_0_2 + 5.382288910935101e-03*G0_1_0 + 1.957195967612633e-02*G0_1_1 - 5.529078608505573e-02*G0_1_2 - 4.110111531986415e-02*G0_2_0 - 5.529078608505595e-02*G0_2_1 + 1.957195967612664e-02*G0_2_2;
    block[2456] = 5.023469650205663e-02*G0_0_0 + 3.816532136844593e-02*G0_0_1 + 5.545388574902285e-03*G0_0_2 + 3.816532136844556e-02*G0_1_0 + 2.609594623483418e-02*G0_1_1 + 6.197787230772967e-03*G0_1_2 + 5.545388574901899e-03*G0_2_0 + 6.197787230772918e-03*G0_2_1;
    block[2457] = -3.327233144941449e-02*G0_0_0 - 1.908266068422286e-02*G0_0_1 - 1.908266068422305e-02*G0_0_2 - 1.908266068422312e-02*G0_1_0 - 4.892989919031658e-03*G0_1_1 - 3.327233144941488e-02*G0_1_2 - 1.908266068422338e-02*G0_2_0 - 3.327233144941499e-02*G0_2_1 - 4.892989919031364e-03*G0_2_2;
    block[2458] = 4.012251733605875e-02*G0_0_0 + 2.984723850609258e-02*G0_0_1 + 1.027527882996630e-02*G0_0_2 + 2.984723850609218e-02*G0_1_0 + 1.957195967612653e-02*G0_1_1 + 1.810406270041654e-02*G0_1_2 + 1.027527882996619e-02*G0_2_0 + 1.810406270041647e-02*G0_2_1;
    block[2459] = 1.304797311741776e-03*G0_0_0 - 1.076457782186984e-02*G0_0_1 + 6.523986558702801e-04*G0_0_2 - 1.076457782186916e-02*G0_1_0 - 2.283395295548083e-02*G0_1_1 + 1.304797311741516e-03*G0_1_2 + 6.523986558708621e-04*G0_2_0 + 1.304797311741985e-03*G0_2_1;
    block[2460] = 3.522952741702697e-01*G0_0_0 + 2.495424858706076e-01*G0_0_1 + 2.495424858706070e-01*G0_0_2 + 2.495424858706080e-01*G0_1_0 + 1.467896975709458e-01*G0_1_1 + 4.452620826318696e-01*G0_1_2 + 2.495424858706079e-01*G0_2_0 + 4.452620826318707e-01*G0_2_1 - 3.914391935225371e-02*G0_2_2;
    block[2461] = -2.348635161135127e-01*G0_0_0 - 1.418967076519148e-01*G0_0_1 - 1.957195967612648e-02*G0_0_2 - 1.418967076519145e-01*G0_1_0 - 4.892989919031633e-02*G0_1_1 - 1.957195967612660e-02*G0_1_2 - 1.957195967612543e-02*G0_2_0 - 1.957195967612632e-02*G0_2_1 - 3.914391935225299e-02*G0_2_2;
    block[2462] = -3.914391935225245e-02*G0_0_0 + 5.382288910934811e-02*G0_0_1 + 4.892989919031828e-03*G0_0_2 + 5.382288910934790e-02*G0_1_0 + 1.467896975709472e-01*G0_1_1 + 4.892989919032325e-03*G0_1_2 + 4.892989919032130e-03*G0_2_0 + 4.892989919032467e-03*G0_2_1 + 9.785979838063126e-03*G0_2_2;
    block[2463] = -1.859336169231988e-01*G0_0_0 - 4.844060019841219e-01*G0_0_1 - 2.886864052228589e-01*G0_0_2 - 4.844060019841229e-01*G0_1_0 - 7.828783870450468e-01*G0_1_1 - 4.844060019841219e-01*G0_1_2 - 2.886864052228616e-01*G0_2_0 - 4.844060019841234e-01*G0_2_1 - 3.914391935225060e-02*G0_2_2;
    block[2464] = -2.984723850609250e-02*G0_0_0 - 2.984723850609251e-02*G0_0_1 - 2.984723850609253e-02*G0_0_2 - 3.457190957190925e-02*G0_1_0 - 3.457190957190924e-02*G0_1_1 - 3.457190957190924e-02*G0_1_2 - 2.984723850609234e-02*G0_2_0 - 2.984723850609232e-02*G0_2_1 - 2.984723850609234e-02*G0_2_2;
    block[2465] = -2.984723850609246e-02*G0_0_0 + 4.724671065816947e-03*G0_1_0;
    block[2466] = -9.464999699374621e-03*G0_1_1;
    block[2467] = 2.278176106301155e-03*G0_1_2 + 1.174317580567573e-02*G0_2_2;
    block[2468] = 6.426126760328121e-02*G0_0_0 + 4.227543290043280e-02*G0_0_1 + 4.227543290043296e-02*G0_1_0 + 4.296045148909754e-02*G0_1_1;
    block[2469] = 8.807381854256524e-03*G0_0_0 + 6.491366625914692e-03*G0_0_1 + 6.491366625914812e-03*G0_1_0 + 3.522952741702074e-03*G0_1_1;
    block[2470] = -6.523986558708865e-04*G0_0_0 - 9.492400442920998e-03*G0_0_1 - 9.492400442921172e-03*G0_1_0 - 1.898480088584206e-02*G0_1_1;
    block[2471] = 3.294613212147831e-03*G0_0_1 + 3.294613212148091e-03*G0_1_0 + 2.926007971580864e-02*G0_1_1;
    block[2472] = -3.294613212147881e-03*G0_0_1 - 3.294613212148064e-03*G0_1_0 + 2.267085329151285e-02*G0_1_1 - 3.294613212148071e-03*G0_1_2 - 3.294613212147478e-03*G0_2_1;
    block[2473] = -6.523986558710655e-04*G0_0_0 + 8.840001787050340e-03*G0_0_1 - 6.523986558710122e-04*G0_0_2 + 8.840001787050389e-03*G0_1_0 - 6.523986558708959e-04*G0_1_1 + 8.840001787050305e-03*G0_1_2 - 6.523986558708890e-04*G0_2_0 + 8.840001787049903e-03*G0_2_1 - 6.523986558709253e-04*G0_2_2;
    block[2474] = 8.807381854257090e-03*G0_0_0 + 2.316015228341447e-03*G0_0_1 + 8.807381854257073e-03*G0_0_2 + 2.316015228341693e-03*G0_1_0 - 6.523986558709023e-04*G0_1_1 + 2.316015228341663e-03*G0_1_2 + 8.807381854256710e-03*G0_2_0 + 2.316015228341736e-03*G0_2_1 + 8.807381854256733e-03*G0_2_2;
    block[2475] = 6.426126760328120e-02*G0_0_0 + 2.198583470284859e-02*G0_0_1 + 6.426126760328109e-02*G0_0_2 + 2.198583470284820e-02*G0_1_0 + 2.267085329151282e-02*G0_1_1 + 2.198583470284812e-02*G0_1_2 + 6.426126760328094e-02*G0_2_0 + 2.198583470284830e-02*G0_2_1 + 6.426126760328085e-02*G0_2_2;
    block[2476] = 9.208607027617376e-02*G0_0_0 + 1.343615031766063e-01*G0_0_1 + 1.343615031766064e-01*G0_0_2 + 1.280006162818650e-01*G0_1_0 + 1.273155976932005e-01*G0_1_1 + 1.273155976932005e-01*G0_1_2 + 1.343615031766058e-01*G0_2_0 + 1.766369360770386e-01*G0_2_1 + 1.766369360770385e-01*G0_2_2;
    block[2477] = -6.223883177008118e-02*G0_0_0 - 2.508146632495571e-01*G0_0_1 - 2.508146632495570e-01*G0_0_2 - 1.607836487393765e-01*G0_1_0 - 1.669488160373562e-01*G0_1_1 - 1.669488160373562e-01*G0_1_2 - 2.508146632495565e-01*G0_2_0 - 3.346805104617576e-01*G0_2_1 - 3.346805104617574e-01*G0_2_2;
    block[2478] = -6.223883177008161e-02*G0_0_0 + 1.885758314794763e-01*G0_0_1 + 1.885758314794762e-01*G0_0_2 + 9.854481696929535e-02*G0_1_0 + 1.824106641814959e-01*G0_1_1 + 1.824106641814959e-01*G0_1_2 + 1.885758314794753e-01*G0_2_0 + 1.047099842672752e-01*G0_2_1 + 1.047099842672752e-01*G0_2_2;
    block[2479] = 9.208607027617390e-02*G0_0_0 - 4.227543290043288e-02*G0_0_1 - 4.227543290043283e-02*G0_0_2 - 3.591454600569162e-02*G0_1_0 - 4.296045148909765e-02*G0_1_1 - 4.296045148909763e-02*G0_1_2 - 4.227543290043239e-02*G0_2_0;
    block[2480] = 1.285225352065623e-01*G0_0_0 + 1.285225352065621e-01*G0_0_1 + 8.624710230612957e-02*G0_0_2 + 4.397166940569654e-02*G0_1_0 + 4.397166940569655e-02*G0_1_1 + 4.465668799436102e-02*G0_1_2 + 8.624710230612934e-02*G0_2_0 + 8.624710230612936e-02*G0_2_1 + 4.397166940569661e-02*G0_2_2;
    block[2481] = 3.718672338463994e-02*G0_0_0 + 3.718672338463981e-02*G0_0_1 - 3.715410345184619e-02*G0_0_2 - 4.364547007776101e-02*G0_1_0 - 4.364547007776091e-02*G0_1_1 - 9.753359905269278e-03*G0_1_2 - 3.715410345184597e-02*G0_2_0 - 3.715410345184596e-02*G0_2_1 - 6.784946021056944e-03*G0_2_2;
    block[2482] = -6.197787230773372e-03*G0_0_0 - 6.197787230773305e-03*G0_0_1 - 2.508472831823551e-02*G0_0_2 - 1.559232787531380e-02*G0_1_0 - 1.559232787531384e-02*G0_1_1 + 3.294613212147540e-03*G0_1_2 - 2.508472831823503e-02*G0_2_0 - 2.508472831823501e-02*G0_2_1 + 1.278701365506894e-02*G0_2_2;
    block[2483] = 5.838967970044553e-03*G0_0_2 + 2.544354757896354e-03*G0_1_0 + 2.544354757896373e-03*G0_1_1 - 5.904207835631320e-03*G0_1_2 + 5.838967970044554e-03*G0_2_0 + 5.838967970044566e-03*G0_2_1 - 3.186967433929214e-02*G0_2_2;
    block[2484] = 1.285225352065622e-01*G0_0_0 + 4.227543290043277e-02*G0_0_2 + 8.455086580086538e-02*G0_1_0 + 4.296045148909750e-02*G0_1_2 + 4.227543290043304e-02*G0_2_0;
    block[2485] = 3.718672338463982e-02*G0_0_0 + 7.434082683648595e-02*G0_0_2 + 8.083219346240042e-02*G0_1_0 + 1.082329370089766e-01*G0_1_2 + 7.434082683648525e-02*G0_2_0 + 1.047099842672740e-01*G0_2_2;
    block[2486] = -6.197787230773357e-03*G0_0_0 + 1.888694108746176e-02*G0_0_2 + 9.394540644540633e-03*G0_1_0 + 3.777388217492410e-02*G0_1_2 + 1.888694108746209e-02*G0_2_0 + 5.675868306076669e-02*G0_2_2;
    block[2487] = -5.838967970043946e-03*G0_0_2 - 2.544354757896168e-03*G0_1_0 - 1.428753056357219e-02*G0_1_2 - 5.838967970044418e-03*G0_2_0 - 4.354761027938112e-02*G0_2_2;
    block[2488] = 6.589226424295893e-03*G0_1_1 + 3.294613212148013e-03*G0_1_2 + 3.294613212148319e-03*G0_2_1;
    block[2489] = 4.501550725508788e-03*G0_1_1 + 1.924576034818715e-03*G0_1_2 + 1.924576034818657e-03*G0_2_1 - 6.523986558708971e-04*G0_2_2;
    block[2490] = -1.050361835952131e-02*G0_1_1 - 1.308059305021110e-02*G0_1_2 - 1.308059305021081e-02*G0_2_1 - 1.565756774090101e-02*G0_2_2;
    block[2491] = -2.544354757896306e-03*G0_1_1 - 5.838967970044324e-03*G0_1_2 - 5.838967970044521e-03*G0_2_1 - 9.133581182192416e-03*G0_2_2;
    block[2492] = 3.914391935225119e-02*G0_0_0 + 1.356989204211413e-01*G0_0_1 + 6.784946021057030e-02*G0_0_2 + 1.356989204211398e-01*G0_1_0 + 2.094199685345494e-01*G0_1_1 + 1.047099842672750e-01*G0_1_2 + 6.784946021056983e-02*G0_2_0 + 1.047099842672748e-01*G0_2_1;
    block[2493] = 1.957195967612629e-02*G0_0_0 + 7.486274576118271e-02*G0_0_1 + 6.067307499599067e-02*G0_0_2 + 7.486274576118346e-02*G0_1_0 + 1.497254915223648e-01*G0_1_1 + 1.213461499919815e-01*G0_1_2 + 6.067307499599199e-02*G0_2_0 + 1.213461499919823e-01*G0_2_1 + 9.296680846159854e-02*G0_2_2;
    block[2494] = -6.197787230772821e-03*G0_0_1 - 5.545388574902171e-03*G0_0_2 - 6.197787230773378e-03*G0_1_0 + 1.370037177328856e-02*G0_1_1 + 2.642214556277057e-02*G0_1_2 - 5.545388574902677e-03*G0_2_0 + 2.642214556277025e-02*G0_2_1 + 3.914391935225298e-02*G0_2_2;
    block[2495] = -4.892989919031572e-03*G0_0_0 + 2.837934153038189e-02*G0_0_1 + 1.418967076519102e-02*G0_0_2 + 2.837934153038324e-02*G0_1_0 + 5.675868306076537e-02*G0_1_1 + 2.837934153038232e-02*G0_1_2 + 1.418967076519159e-02*G0_2_0 + 2.837934153038289e-02*G0_2_1;
    block[2496] = -1.810406270041700e-02*G0_0_1 - 1.027527882996618e-02*G0_0_2 - 1.810406270041733e-02*G0_1_0 - 1.663616572470698e-02*G0_1_1 + 1.467896975709402e-03*G0_1_2 - 1.027527882996648e-02*G0_2_0 + 1.467896975709761e-03*G0_2_1 + 1.957195967612617e-02*G0_2_2;
    block[2497] = -1.304797311741503e-03*G0_0_1 - 6.523986558710296e-04*G0_0_2 - 1.304797311741999e-03*G0_1_0 - 2.544354757896440e-02*G0_1_1 - 1.272177378948182e-02*G0_1_2 - 6.523986558706937e-04*G0_2_0 - 1.272177378948228e-02*G0_2_1;
    block[2498] = 1.304797311741680e-03*G0_0_1 + 6.523986558710027e-04*G0_0_2 + 1.304797311741890e-03*G0_1_0 - 2.283395295548100e-02*G0_1_1 - 1.076457782186903e-02*G0_1_2 + 6.523986558706173e-04*G0_2_0 - 1.076457782187025e-02*G0_2_1 + 1.304797311741658e-03*G0_2_2;
    block[2499] = 1.810406270041661e-02*G0_0_1 + 1.027527882996627e-02*G0_0_2 + 1.810406270041726e-02*G0_1_0 + 1.957195967612673e-02*G0_1_1 + 2.984723850609278e-02*G0_1_2 + 1.027527882996648e-02*G0_2_0 + 2.984723850609289e-02*G0_2_1 + 4.012251733605886e-02*G0_2_2;
    block[2500] = 6.197787230773342e-03*G0_0_1 + 5.545388574901860e-03*G0_0_2 + 6.197787230773391e-03*G0_1_0 + 2.609594623483499e-02*G0_1_1 + 3.816532136844564e-02*G0_1_2 + 5.545388574902632e-03*G0_2_0 + 3.816532136844564e-02*G0_2_1 + 5.023469650205717e-02*G0_2_2;
    block[2501] = -4.892989919031594e-03*G0_0_0 - 3.327233144941453e-02*G0_0_1 - 1.908266068422308e-02*G0_0_2 - 3.327233144941490e-02*G0_1_0 - 4.892989919030834e-03*G0_1_1 - 1.908266068422324e-02*G0_1_2 - 1.908266068422314e-02*G0_2_0 - 1.908266068422195e-02*G0_2_1 - 3.327233144941424e-02*G0_2_2;
    block[2502] = 1.957195967612659e-02*G0_0_0 - 5.529078608505665e-02*G0_0_1 - 4.110111531986456e-02*G0_0_2 - 5.529078608505673e-02*G0_1_0 + 1.957195967612527e-02*G0_1_1 + 5.382288910934836e-03*G0_1_2 - 4.110111531986527e-02*G0_2_0 + 5.382288910934360e-03*G0_2_1 - 8.807381854256930e-03*G0_2_2;
    block[2503] = 3.914391935225237e-02*G0_0_0 - 9.655500106888930e-02*G0_0_1 - 2.870554085831901e-02*G0_0_2 - 9.655500106888922e-02*G0_1_0 - 2.283395295548076e-02*G0_1_1 - 5.969447701218464e-02*G0_1_2 - 2.870554085831876e-02*G0_2_0 - 5.969447701218549e-02*G0_2_1 - 9.655500106888915e-02*G0_2_2;
    block[2504] = 1.239557446154615e-02*G0_0_0 + 6.197787230772442e-03*G0_0_1 + 6.197787230772485e-03*G0_0_2 + 6.197787230772763e-03*G0_1_0 - 1.370037177328894e-02*G0_1_1 + 7.143765281786027e-02*G0_1_2 + 6.197787230772594e-03*G0_2_0 - 2.642214556277048e-02*G0_2_1 + 1.722332451499103e-01*G0_2_2;
    block[2505] = -3.718672338463941e-02*G0_0_0 - 7.486274576118244e-02*G0_0_1 - 2.240989382916449e-01*G0_0_2 - 1.776155340608435e-01*G0_1_0 - 1.497254915223643e-01*G0_1_1 - 3.268517265913069e-01*G0_1_2 - 2.240989382916431e-01*G0_2_0 - 1.213461499919819e-01*G0_2_1 - 4.481978765832897e-01*G0_2_2;
    block[2506] = -5.845491956603038e-01*G0_0_0 - 1.356989204211417e-01*G0_0_1 - 2.629166583159622e-01*G0_0_2 - 3.901343962107825e-01*G0_1_0 - 2.094199685345496e-01*G0_1_1 - 2.906436011904725e-01*G0_1_2 - 2.629166583159628e-01*G0_2_0 - 1.047099842672749e-01*G0_2_1 - 2.094199685345492e-01*G0_2_2;
    block[2507] = -3.718672338463951e-02*G0_0_0 + 3.767602237654354e-02*G0_0_1 + 1.869122149070064e-01*G0_0_2 + 1.404288106762046e-01*G0_1_0 + 6.556606491502251e-02*G0_1_1 + 3.767602237654310e-02*G0_1_2 + 1.869122149070044e-01*G0_2_0 + 1.404288106762046e-01*G0_2_1 - 3.718672338463980e-02*G0_2_2;
    block[2508] = 9.120533209074830e-01*G0_0_0 + 4.560266604537402e-01*G0_0_1 + 4.560266604537407e-01*G0_0_2 + 4.560266604537402e-01*G0_1_0 + 7.261197039842796e-01*G0_1_1 + 4.560266604537392e-01*G0_1_2 + 4.560266604537407e-01*G0_2_0 + 4.560266604537391e-01*G0_2_1 + 7.261197039842806e-01*G0_2_2;
    block[2509] = -5.845491956603038e-01*G0_0_0 - 4.488502752391614e-01*G0_0_1 - 3.216325373443414e-01*G0_0_2 - 1.944147994495199e-01*G0_1_0 - 2.681358475629284e-01*G0_1_1 - 2.221417423240317e-01*G0_1_2 - 3.216325373443403e-01*G0_2_0 - 2.906436011904734e-01*G0_2_1 - 2.681358475629282e-01*G0_2_2;
    block[2510] = -2.922745978301523e-01*G0_0_0 - 9.720739972476027e-02*G0_0_1 - 2.244251376195805e-01*G0_0_2 - 9.720739972475986e-02*G0_1_0 - 8.807381854256781e-02*G0_1_1 - 1.340679237814644e-01*G0_1_2 - 2.244251376195803e-01*G0_2_0 - 1.340679237814644e-01*G0_2_1 - 1.565756774090096e-01*G0_2_2;
    block[2511] = 4.560266604537417e-01*G0_0_0 + 2.280133302268700e-01*G0_0_1 + 2.280133302268698e-01*G0_0_2 + 2.280133302268702e-01*G0_1_0 + 9.296680846159946e-02*G0_1_1 + 3.630598519921400e-01*G0_1_2 + 2.280133302268704e-01*G0_2_0 + 3.630598519921397e-01*G0_2_1 + 9.296680846159915e-02*G0_2_2;
    block[2512] = -2.922745978301521e-01*G0_0_0 - 1.950671981053912e-01*G0_0_1 - 6.784946021057076e-02*G0_0_2 - 1.950671981053915e-01*G0_1_0 - 1.859336169231982e-01*G0_1_1 - 1.047099842672754e-01*G0_1_2 - 6.784946021057145e-02*G0_2_0 - 1.047099842672747e-01*G0_2_1;
    block[2513] = -8.807381854257067e-03*G0_0_0 - 4.110111531986490e-02*G0_0_1 + 5.382288910934349e-03*G0_0_2 - 4.110111531986511e-02*G0_1_0 + 1.957195967612649e-02*G0_1_1 - 5.529078608505642e-02*G0_1_2 + 5.382288910934852e-03*G0_2_0 - 5.529078608505581e-02*G0_2_1 + 1.957195967612607e-02*G0_2_2;
    block[2514] = -8.807381854256120e-03*G0_0_0 + 3.229373346560884e-02*G0_0_1 - 1.418967076519096e-02*G0_0_2 + 3.229373346560865e-02*G0_1_0 + 9.296680846159917e-02*G0_1_1 - 2.837934153038226e-02*G0_1_2 - 1.418967076519122e-02*G0_2_0 - 2.837934153038258e-02*G0_2_1;
    block[2515] = 1.304797311741803e-03*G0_0_0 + 6.523986558707313e-04*G0_0_1 + 6.523986558710217e-04*G0_0_2 + 6.523986558708535e-04*G0_1_0 - 8.807381854256797e-02*G0_1_1 + 1.272177378948183e-02*G0_1_2 + 6.523986558707469e-04*G0_2_0 + 1.272177378948137e-02*G0_2_1;
    block[2516] = -3.914391935225392e-02*G0_0_0 + 4.452620826318709e-01*G0_0_1 + 2.495424858706087e-01*G0_0_2 + 4.452620826318687e-01*G0_1_0 + 1.467896975709448e-01*G0_1_1 + 2.495424858706072e-01*G0_1_2 + 2.495424858706076e-01*G0_2_0 + 2.495424858706073e-01*G0_2_1 + 3.522952741702696e-01*G0_2_2;
    block[2517] = -3.914391935224980e-02*G0_0_0 - 4.844060019841220e-01*G0_0_1 - 2.886864052228600e-01*G0_0_2 - 4.844060019841194e-01*G0_1_0 - 7.828783870450452e-01*G0_1_1 - 4.844060019841213e-01*G0_1_2 - 2.886864052228590e-01*G0_2_0 - 4.844060019841220e-01*G0_2_1 - 1.859336169231976e-01*G0_2_2;
    block[2518] = 9.785979838063218e-03*G0_0_0 + 4.892989919032145e-03*G0_0_1 + 4.892989919031802e-03*G0_0_2 + 4.892989919031737e-03*G0_1_0 + 1.467896975709480e-01*G0_1_1 + 5.382288910934693e-02*G0_1_2 + 4.892989919031594e-03*G0_2_0 + 5.382288910934804e-02*G0_2_1 - 3.914391935225246e-02*G0_2_2;
    block[2519] = -3.914391935225272e-02*G0_0_0 - 1.957195967612613e-02*G0_0_1 - 1.957195967612596e-02*G0_0_2 - 1.957195967612646e-02*G0_1_0 - 4.892989919031487e-02*G0_1_1 - 1.418967076519131e-01*G0_1_2 - 1.957195967612660e-02*G0_2_0 - 1.418967076519140e-01*G0_2_1 - 2.348635161135126e-01*G0_2_2;
    block[2520] = 3.359853077735001e-02*G0_0_0 + 3.359853077735003e-02*G0_0_1 + 3.359853077735004e-02*G0_0_2 + 4.799305472048486e-02*G0_1_0 + 4.799305472048485e-02*G0_1_1 + 4.799305472048487e-02*G0_1_2 + 3.359853077734978e-02*G0_2_0 + 3.359853077734978e-02*G0_2_1 + 3.359853077734989e-02*G0_2_2;
    block[2521] = 1.891956102025535e-02*G0_0_0 + 5.177435732991257e-03*G0_1_0;
    block[2522] = -1.374212528726398e-02*G0_1_1;
    block[2523] = 5.177435732991361e-03*G0_1_2 + 1.891956102025542e-02*G0_2_2;
    block[2524] = -3.066273682593108e-02*G0_0_0 - 2.126819618139055e-02*G0_0_1 - 2.126819618139096e-02*G0_1_0 - 1.187365553685053e-02*G0_1_1;
    block[2525] = -1.304797311741755e-03*G0_0_0 - 1.239557446154521e-03*G0_0_1 - 1.239557446154156e-03*G0_1_0 - 1.174317580566897e-03*G0_1_1;
    block[2526] = -1.500516908502996e-02*G0_0_0 - 1.493992921944291e-02*G0_0_1 - 1.493992921944352e-02*G0_1_0 - 1.487468935385650e-02*G0_1_1;
    block[2527] = 9.394540644540582e-03*G0_0_1 + 9.394540644540997e-03*G0_1_0 + 1.878908128908150e-02*G0_1_1;
    block[2528] = -9.394540644540542e-03*G0_0_1 - 9.394540644541005e-03*G0_1_0 + 4.534170658302529e-02*G0_1_1 - 9.394540644541031e-03*G0_1_2 - 9.394540644540197e-03*G0_2_1;
    block[2529] = -1.500516908502986e-02*G0_0_0 + 2.276871308989326e-02*G0_0_1 - 1.500516908502989e-02*G0_0_2 + 2.276871308989382e-02*G0_1_0 - 6.654466289882861e-02*G0_1_1 + 2.276871308989390e-02*G0_1_2 - 1.500516908503012e-02*G0_2_0 + 2.276871308989303e-02*G0_2_1 - 1.500516908503006e-02*G0_2_2;
    block[2530] = 4.762510187857348e-02*G0_0_0 - 1.474420962268142e-02*G0_0_1 + 4.762510187857343e-02*G0_0_2 - 1.474420962268240e-02*G0_1_0 + 4.762510187857341e-02*G0_1_1 - 1.474420962268237e-02*G0_1_2 + 4.762510187857340e-02*G0_2_0 - 1.474420962268167e-02*G0_2_1 + 4.762510187857331e-02*G0_2_2;
    block[2531] = -1.285225352065621e-01*G0_0_0 - 3.222849360002134e-02*G0_0_1 - 1.285225352065620e-01*G0_0_2 - 3.222849360002102e-02*G0_1_0 - 6.067307499599102e-02*G0_1_1 - 3.222849360002104e-02*G0_1_2 - 1.285225352065621e-01*G0_2_0 - 3.222849360002095e-02*G0_2_1 - 1.285225352065619e-01*G0_2_2;
    block[2532] = -6.445698720004227e-02*G0_0_0 - 1.607510288065830e-01*G0_0_1 - 1.607510288065830e-01*G0_0_2 - 9.290156859601223e-02*G0_1_0 - 6.445698720004227e-02*G0_1_1 - 6.445698720004227e-02*G0_1_2 - 1.607510288065825e-01*G0_2_0 - 2.570450704131235e-01*G0_2_1 - 2.570450704131235e-01*G0_2_2;
    block[2533] = -3.392473010528699e-03*G0_0_0 + 1.946757589118684e-01*G0_0_1 + 1.946757589118684e-01*G0_0_2 + 5.897683849072676e-02*G0_1_0 + 1.323064474106129e-01*G0_1_1 + 1.323064474106130e-01*G0_1_2 + 1.946757589118678e-01*G0_2_0 + 1.213461499919822e-01*G0_2_1 + 1.213461499919821e-01*G0_2_2;
    block[2534] = 8.468134553203953e-02*G0_0_0 - 8.879145706402619e-02*G0_0_1 - 8.879145706402611e-02*G0_0_2 - 4.632030456682950e-03*G0_1_0 - 5.101757488910265e-02*G0_1_1 - 5.101757488910259e-02*G0_1_2 - 8.879145706402509e-02*G0_2_0 - 5.284429112554073e-02*G0_2_1 - 5.284429112554070e-02*G0_2_2;
    block[2535] = -6.934997711907388e-02*G0_0_0 + 2.126819618139053e-02*G0_0_1 + 2.126819618139050e-02*G0_0_2 - 1.461372989150765e-02*G0_1_0 + 1.187365553685063e-02*G0_1_1 + 1.187365553685055e-02*G0_1_2 + 2.126819618139005e-02*G0_2_0;
    block[2536] = -2.570450704131240e-01*G0_0_0 - 2.570450704131239e-01*G0_0_1 - 1.607510288065833e-01*G0_0_2 - 6.445698720004202e-02*G0_1_0 - 6.445698720004189e-02*G0_1_1 - 9.290156859601197e-02*G0_1_2 - 1.607510288065827e-01*G0_2_0 - 1.607510288065827e-01*G0_2_1 - 6.445698720004191e-02*G0_2_2;
    block[2537] = 1.213461499919822e-01*G0_0_0 + 1.213461499919822e-01*G0_0_1 + 1.946757589118687e-01*G0_0_2 + 1.323064474106129e-01*G0_1_0 + 1.323064474106126e-01*G0_1_1 + 5.897683849072630e-02*G0_1_2 + 1.946757589118682e-01*G0_2_0 + 1.946757589118681e-01*G0_2_1 - 3.392473010529172e-03*G0_2_2;
    block[2538] = -5.284429112554041e-02*G0_0_0 - 5.284429112554048e-02*G0_0_1 - 8.879145706402553e-02*G0_0_2 - 5.101757488910213e-02*G0_1_0 - 5.101757488910209e-02*G0_1_1 - 4.632030456682260e-03*G0_1_2 - 8.879145706402586e-02*G0_2_0 - 8.879145706402583e-02*G0_2_1 + 8.468134553204024e-02*G0_2_2;
    block[2539] = 2.126819618139032e-02*G0_0_2 + 1.187365553684972e-02*G0_1_0 + 1.187365553684971e-02*G0_1_1 - 1.461372989150802e-02*G0_1_2 + 2.126819618139070e-02*G0_2_0 + 2.126819618139069e-02*G0_2_1 - 6.934997711907433e-02*G0_2_2;
    block[2540] = -6.132547365186215e-02*G0_0_0 - 2.126819618139051e-02*G0_0_2 - 4.253639236278164e-02*G0_1_0 - 1.187365553685056e-02*G0_1_2 - 2.126819618139076e-02*G0_2_0;
    block[2541] = -2.544354757896406e-02*G0_0_0 - 3.907867948666532e-02*G0_0_2 - 4.031823693281939e-02*G0_1_0 - 5.401860870610779e-02*G0_1_2 - 3.907867948666501e-02*G0_2_0 - 5.284429112554035e-02*G0_2_2;
    block[2542] = -5.284429112554074e-02*G0_0_0 - 3.907867948666518e-02*G0_0_2 - 5.401860870610886e-02*G0_1_0 - 4.031823693282054e-02*G0_1_2 - 3.907867948666530e-02*G0_2_0 - 2.544354757896427e-02*G0_2_2;
    block[2543] = -2.126819618139072e-02*G0_0_2 - 1.187365553684981e-02*G0_1_0 - 4.253639236278092e-02*G0_1_2 - 2.126819618139077e-02*G0_2_0 - 6.132547365186234e-02*G0_2_2;
    block[2544] = 1.878908128908150e-02*G0_1_1 + 9.394540644540952e-03*G0_1_2 + 9.394540644540971e-03*G0_2_1;
    block[2545] = -1.487468935385613e-02*G0_1_1 - 1.493992921944310e-02*G0_1_2 - 1.493992921944351e-02*G0_2_1 - 1.500516908502987e-02*G0_2_2;
    block[2546] = -1.174317580567264e-03*G0_1_1 - 1.239557446154559e-03*G0_1_2 - 1.239557446154044e-03*G0_2_1 - 1.304797311741728e-03*G0_2_2;
    block[2547] = -1.187365553684980e-02*G0_1_1 - 2.126819618139037e-02*G0_1_2 - 2.126819618139072e-02*G0_2_1 - 3.066273682593127e-02*G0_2_2;
    block[2548] = -4.566790591096057e-02*G0_0_0 - 7.567824408102096e-02*G0_0_1 - 3.783912204051020e-02*G0_0_2 - 7.567824408102060e-02*G0_1_0 - 1.056885822510818e-01*G0_1_1 - 5.284429112554098e-02*G0_1_2 - 3.783912204050999e-02*G0_2_0 - 5.284429112554051e-02*G0_2_1;
    block[2549] = -8.807381854256789e-02*G0_0_0 - 1.007955923320500e-01*G0_0_1 - 8.872621719843839e-02*G0_0_2 - 1.007955923320505e-01*G0_1_0 - 1.135173661215322e-01*G0_1_1 - 1.007955923320496e-01*G0_1_2 - 8.872621719843918e-02*G0_2_0 - 1.007955923320498e-01*G0_2_1 - 8.807381854256768e-02*G0_2_2;
    block[2550] = -5.284429112554094e-02*G0_0_1 - 3.783912204051065e-02*G0_0_2 - 5.284429112554032e-02*G0_1_0 - 1.056885822510816e-01*G0_1_1 - 7.567824408102153e-02*G0_1_2 - 3.783912204051059e-02*G0_2_0 - 7.567824408102176e-02*G0_2_1 - 4.566790591096090e-02*G0_2_2;
    block[2551] = -2.283395295548003e-02*G0_0_0 - 2.413875026722164e-02*G0_0_1 - 1.206937513361084e-02*G0_0_2 - 2.413875026722243e-02*G0_1_0 - 2.544354757896332e-02*G0_1_1 - 1.272177378948203e-02*G0_1_2 - 1.206937513361106e-02*G0_2_0 - 1.272177378948153e-02*G0_2_1;
    block[2552] = -1.272177378948149e-02*G0_0_1 - 1.206937513361107e-02*G0_0_2 - 1.272177378948188e-02*G0_1_0 - 2.544354757896358e-02*G0_1_1 - 2.413875026722198e-02*G0_1_2 - 1.206937513361095e-02*G0_2_0 - 2.413875026722197e-02*G0_2_1 - 2.283395295548044e-02*G0_2_2;
    block[2553] = -3.001033817006045e-02*G0_0_1 - 1.500516908502997e-02*G0_0_2 - 3.001033817005954e-02*G0_1_0 - 6.002067634012054e-02*G0_1_1 - 3.001033817005998e-02*G0_1_2 - 1.500516908502996e-02*G0_2_0 - 3.001033817006035e-02*G0_2_1;
    block[2554] = 3.001033817006020e-02*G0_0_1 + 1.500516908503011e-02*G0_0_2 + 3.001033817005970e-02*G0_1_0 - 4.566790591096140e-02*G0_1_1 - 7.828783870450670e-03*G0_1_2 + 1.500516908503007e-02*G0_2_0 - 7.828783870451068e-03*G0_2_1 + 3.001033817005984e-02*G0_2_2;
    block[2555] = 1.272177378948234e-02*G0_0_1 + 1.206937513361117e-02*G0_0_2 + 1.272177378948186e-02*G0_1_0 + 3.914391935225222e-02*G0_1_1 + 4.468930792715469e-02*G0_1_2 + 1.206937513361091e-02*G0_2_0 + 4.468930792715481e-02*G0_2_1 + 5.023469650205643e-02*G0_2_2;
    block[2556] = 5.284429112554035e-02*G0_0_1 + 3.783912204051069e-02*G0_0_2 + 5.284429112554022e-02*G0_1_0 + 5.219189246966964e-02*G0_1_1 + 9.003101451018063e-02*G0_1_2 + 3.783912204051056e-02*G0_2_0 + 9.003101451018009e-02*G0_2_1 + 1.278701365506925e-01*G0_2_2;
    block[2557] = -2.283395295548056e-02*G0_0_0 - 9.655500106888916e-02*G0_0_1 - 5.969447701218498e-02*G0_0_2 - 9.655500106888927e-02*G0_1_0 + 3.914391935225255e-02*G0_1_1 - 2.870554085831804e-02*G0_1_2 - 5.969447701218432e-02*G0_2_0 - 2.870554085831787e-02*G0_2_1 - 9.655500106888824e-02*G0_2_2;
    block[2558] = -8.807381854256773e-02*G0_0_0 - 1.340679237814642e-01*G0_0_1 - 9.720739972475997e-02*G0_0_2 - 1.340679237814639e-01*G0_1_0 - 1.565756774090091e-01*G0_1_1 - 2.244251376195808e-01*G0_1_2 - 9.720739972476002e-02*G0_2_0 - 2.244251376195795e-01*G0_2_1 - 2.922745978301521e-01*G0_2_2;
    block[2559] = 5.219189246966963e-02*G0_0_0 + 3.235897333119528e-01*G0_0_1 + 1.878908128908117e-01*G0_0_2 + 3.235897333119531e-01*G0_1_0 + 5.219189246966948e-02*G0_1_1 + 1.878908128908118e-01*G0_1_2 + 1.878908128908113e-01*G0_2_0 + 1.878908128908109e-01*G0_2_1 + 3.235897333119535e-01*G0_2_2;
    block[2560] = 1.056885822510814e-01*G0_0_0 + 5.284429112554097e-02*G0_0_1 + 1.278701365506913e-01*G0_0_2 + 1.050361835952113e-01*G0_1_0 + 1.056885822510818e-01*G0_1_1 + 1.800620290203614e-01*G0_1_2 + 1.278701365506913e-01*G0_2_0 + 7.567824408102172e-02*G0_2_1 + 2.557402731013831e-01*G0_2_2;
    block[2561] = 1.722332451499100e-01*G0_0_0 + 1.007955923320497e-01*G0_0_1 + 1.660354579191366e-01*G0_0_2 + 1.986553907126797e-01*G0_1_0 + 1.135173661215318e-01*G0_1_1 + 1.986553907126807e-01*G0_1_2 + 1.660354579191363e-01*G0_2_0 + 1.007955923320495e-01*G0_2_1 + 1.722332451499097e-01*G0_2_2;
    block[2562] = 2.557402731013833e-01*G0_0_0 + 7.567824408102122e-02*G0_0_1 + 1.278701365506917e-01*G0_0_2 + 1.800620290203621e-01*G0_1_0 + 1.056885822510820e-01*G0_1_1 + 1.050361835952105e-01*G0_1_2 + 1.278701365506919e-01*G0_2_0 + 5.284429112554080e-02*G0_2_1 + 1.056885822510814e-01*G0_2_2;
    block[2563] = -2.681358475629289e-01*G0_0_0 - 2.221417423240321e-01*G0_0_1 - 3.216325373443407e-01*G0_0_2 - 2.906436011904737e-01*G0_1_0 - 2.681358475629285e-01*G0_1_1 - 4.488502752391614e-01*G0_1_2 - 3.216325373443398e-01*G0_2_0 - 1.944147994495201e-01*G0_2_1 - 5.845491956603038e-01*G0_2_2;
    block[2564] = -5.845491956603037e-01*G0_0_0 - 1.944147994495199e-01*G0_0_1 - 3.216325373443403e-01*G0_0_2 - 4.488502752391614e-01*G0_1_0 - 2.681358475629284e-01*G0_1_1 - 2.906436011904734e-01*G0_1_2 - 3.216325373443414e-01*G0_2_0 - 2.221417423240317e-01*G0_2_1 - 2.681358475629282e-01*G0_2_2;
    block[2565] = 6.471794666239071e-01*G0_0_0 + 3.757816257816233e-01*G0_0_1 + 3.757816257816232e-01*G0_0_2 + 3.757816257816233e-01*G0_1_0 + 6.471794666239066e-01*G0_1_1 + 3.757816257816237e-01*G0_1_2 + 3.757816257816232e-01*G0_2_0 + 3.757816257816237e-01*G0_2_1 + 6.471794666239067e-01*G0_2_2;
    block[2566] = 3.235897333119535e-01*G0_0_0 + 1.878908128908111e-01*G0_0_1 + 1.878908128908114e-01*G0_0_2 + 1.878908128908117e-01*G0_1_0 + 5.219189246966954e-02*G0_1_1 + 3.235897333119526e-01*G0_1_2 + 1.878908128908115e-01*G0_2_0 + 3.235897333119525e-01*G0_2_1 + 5.219189246966976e-02*G0_2_2;
    block[2567] = -2.922745978301521e-01*G0_0_0 - 2.244251376195801e-01*G0_0_1 - 9.720739972475977e-02*G0_0_2 - 2.244251376195810e-01*G0_1_0 - 1.565756774090090e-01*G0_1_1 - 1.340679237814640e-01*G0_1_2 - 9.720739972476053e-02*G0_2_0 - 1.340679237814643e-01*G0_2_1 - 8.807381854256750e-02*G0_2_2;
    block[2568] = 1.278701365506918e-01*G0_0_0 + 9.003101451018088e-02*G0_0_1 + 3.783912204051062e-02*G0_0_2 + 9.003101451018118e-02*G0_1_0 + 5.219189246966950e-02*G0_1_1 + 5.284429112554111e-02*G0_1_2 + 3.783912204051110e-02*G0_2_0 + 5.284429112554073e-02*G0_2_1;
    block[2569] = -9.655500106888883e-02*G0_0_0 - 2.870554085831814e-02*G0_0_1 - 5.969447701218438e-02*G0_0_2 - 2.870554085831781e-02*G0_1_0 + 3.914391935225250e-02*G0_1_1 - 9.655500106888915e-02*G0_1_2 - 5.969447701218449e-02*G0_2_0 - 9.655500106888874e-02*G0_2_1 - 2.283395295548058e-02*G0_2_2;
    block[2570] = 5.023469650205685e-02*G0_0_0 + 4.468930792715401e-02*G0_0_1 + 1.206937513361070e-02*G0_0_2 + 4.468930792715429e-02*G0_1_0 + 3.914391935225219e-02*G0_1_1 + 1.272177378948195e-02*G0_1_2 + 1.206937513361100e-02*G0_2_0 + 1.272177378948196e-02*G0_2_1;
    block[2571] = 3.001033817005993e-02*G0_0_0 - 7.828783870450462e-03*G0_0_1 + 1.500516908503001e-02*G0_0_2 - 7.828783870450447e-03*G0_1_0 - 4.566790591096111e-02*G0_1_1 + 3.001033817006009e-02*G0_1_2 + 1.500516908502999e-02*G0_2_0 + 3.001033817005991e-02*G0_2_1;
    block[2572] = -1.500516908502992e-01*G0_0_0 - 4.664650389476739e-01*G0_0_1 - 3.359853077734988e-01*G0_0_2 - 4.664650389476730e-01*G0_1_0 - 7.828783870450472e-01*G0_1_1 - 4.664650389476721e-01*G0_1_2 - 3.359853077734981e-01*G0_2_0 - 4.664650389476735e-01*G0_2_1 - 1.500516908502990e-01*G0_2_2;
    block[2573] = 1.435277042915903e-01*G0_0_0 + 2.185535497167415e-01*G0_0_1 + 1.859336169231978e-01*G0_0_2 + 2.185535497167407e-01*G0_1_0 + 2.935793951418916e-01*G0_1_1 + 2.348635161135133e-01*G0_1_2 + 1.859336169231968e-01*G0_2_0 + 2.348635161135131e-01*G0_2_1 + 1.761476370851345e-01*G0_2_2;
    block[2574] = 4.566790591096054e-02*G0_0_0 + 1.206937513361113e-01*G0_0_1 + 7.176385214579552e-02*G0_0_2 + 1.206937513361116e-01*G0_1_0 + 1.957195967612615e-01*G0_1_1 + 1.206937513361110e-01*G0_1_2 + 7.176385214579524e-02*G0_2_0 + 1.206937513361105e-01*G0_2_1 + 4.566790591096098e-02*G0_2_2;
    block[2575] = 1.761476370851354e-01*G0_0_0 + 2.348635161135133e-01*G0_0_1 + 1.859336169231979e-01*G0_0_2 + 2.348635161135142e-01*G0_1_0 + 2.935793951418919e-01*G0_1_1 + 2.185535497167411e-01*G0_1_2 + 1.859336169231992e-01*G0_2_0 + 2.185535497167421e-01*G0_2_1 + 1.435277042915904e-01*G0_2_2;
    block[2576] = 3.359853077734984e-02*G0_0_0 + 3.359853077734982e-02*G0_0_1 + 3.359853077734988e-02*G0_0_2 + 3.359853077734973e-02*G0_1_0 + 3.359853077734978e-02*G0_1_1 + 3.359853077734978e-02*G0_1_2 + 4.799305472048476e-02*G0_2_0 + 4.799305472048480e-02*G0_2_1 + 4.799305472048473e-02*G0_2_2;
    block[2577] = 1.891956102025540e-02*G0_0_0 + 5.177435732991254e-03*G0_2_0;
    block[2578] = 1.891956102025523e-02*G0_1_1 + 5.177435732991353e-03*G0_2_1;
    block[2579] = -1.374212528726408e-02*G0_2_2;
    block[2580] = -6.132547365186218e-02*G0_0_0 - 2.126819618139056e-02*G0_0_1 - 2.126819618139048e-02*G0_1_0 - 4.253639236278113e-02*G0_2_0 - 1.187365553685016e-02*G0_2_1;
    block[2581] = -2.544354757896355e-02*G0_0_0 - 3.907867948666496e-02*G0_0_1 - 3.907867948666509e-02*G0_1_0 - 5.284429112554057e-02*G0_1_1 - 4.031823693281941e-02*G0_2_0 - 5.401860870610786e-02*G0_2_1;
    block[2582] = -5.284429112554051e-02*G0_0_0 - 3.907867948666499e-02*G0_0_1 - 3.907867948666482e-02*G0_1_0 - 2.544354757896378e-02*G0_1_1 - 5.401860870610820e-02*G0_2_0 - 4.031823693281993e-02*G0_2_1;
    block[2583] = -2.126819618139012e-02*G0_0_1 - 2.126819618139058e-02*G0_1_0 - 6.132547365186160e-02*G0_1_1 - 1.187365553684940e-02*G0_2_0 - 4.253639236278027e-02*G0_2_1;
    block[2584] = 2.126819618139040e-02*G0_0_1 + 2.126819618139057e-02*G0_1_0 - 6.934997711907331e-02*G0_1_1 + 2.126819618139063e-02*G0_1_2 + 1.187365553684939e-02*G0_2_0 - 1.461372989150780e-02*G0_2_1 + 1.187365553684946e-02*G0_2_2;
    block[2585] = -5.284429112553979e-02*G0_0_0 - 8.879145706402537e-02*G0_0_1 - 5.284429112553986e-02*G0_0_2 - 8.879145706402548e-02*G0_1_0 + 8.468134553203921e-02*G0_1_1 - 8.879145706402558e-02*G0_1_2 - 5.101757488910157e-02*G0_2_0 - 4.632030456682620e-03*G0_2_1 - 5.101757488910164e-02*G0_2_2;
    block[2586] = 1.213461499919810e-01*G0_0_0 + 1.946757589118679e-01*G0_0_1 + 1.213461499919809e-01*G0_0_2 + 1.946757589118675e-01*G0_1_0 - 3.392473010528964e-03*G0_1_1 + 1.946757589118675e-01*G0_1_2 + 1.323064474106116e-01*G0_2_0 + 5.897683849072607e-02*G0_2_1 + 1.323064474106117e-01*G0_2_2;
    block[2587] = -2.570450704131232e-01*G0_0_0 - 1.607510288065828e-01*G0_0_1 - 2.570450704131231e-01*G0_0_2 - 1.607510288065824e-01*G0_1_0 - 6.445698720004168e-02*G0_1_1 - 1.607510288065823e-01*G0_1_2 - 6.445698720004149e-02*G0_2_0 - 9.290156859601173e-02*G0_2_1 - 6.445698720004153e-02*G0_2_2;
    block[2588] = -6.445698720004191e-02*G0_0_0 - 1.607510288065826e-01*G0_0_1 - 1.607510288065826e-01*G0_0_2 - 1.607510288065824e-01*G0_1_0 - 2.570450704131232e-01*G0_1_1 - 2.570450704131232e-01*G0_1_2 - 9.290156859601201e-02*G0_2_0 - 6.445698720004185e-02*G0_2_1 - 6.445698720004188e-02*G0_2_2;
    block[2589] = -3.392473010528979e-03*G0_0_0 + 1.946757589118683e-01*G0_0_1 + 1.946757589118683e-01*G0_0_2 + 1.946757589118678e-01*G0_1_0 + 1.213461499919821e-01*G0_1_1 + 1.213461499919821e-01*G0_1_2 + 5.897683849072684e-02*G0_2_0 + 1.323064474106128e-01*G0_2_1 + 1.323064474106128e-01*G0_2_2;
    block[2590] = 8.468134553203957e-02*G0_0_0 - 8.879145706402611e-02*G0_0_1 - 8.879145706402600e-02*G0_0_2 - 8.879145706402562e-02*G0_1_0 - 5.284429112554091e-02*G0_1_1 - 5.284429112554096e-02*G0_1_2 - 4.632030456683366e-03*G0_2_0 - 5.101757488910261e-02*G0_2_1 - 5.101757488910263e-02*G0_2_2;
    block[2591] = -6.934997711907394e-02*G0_0_0 + 2.126819618139054e-02*G0_0_1 + 2.126819618139049e-02*G0_0_2 + 2.126819618139037e-02*G0_1_0 - 1.461372989150741e-02*G0_2_0 + 1.187365553685019e-02*G0_2_1 + 1.187365553685021e-02*G0_2_2;
    block[2592] = -1.285225352065619e-01*G0_0_0 - 1.285225352065620e-01*G0_0_1 - 3.222849360002116e-02*G0_0_2 - 1.285225352065616e-01*G0_1_0 - 1.285225352065617e-01*G0_1_1 - 3.222849360002100e-02*G0_1_2 - 3.222849360002102e-02*G0_2_0 - 3.222849360002102e-02*G0_2_1 - 6.067307499599108e-02*G0_2_2;
    block[2593] = 4.762510187857372e-02*G0_0_0 + 4.762510187857371e-02*G0_0_1 - 1.474420962268166e-02*G0_0_2 + 4.762510187857355e-02*G0_1_0 + 4.762510187857363e-02*G0_1_1 - 1.474420962268175e-02*G0_1_2 - 1.474420962268167e-02*G0_2_0 - 1.474420962268160e-02*G0_2_1 + 4.762510187857389e-02*G0_2_2;
    block[2594] = -1.500516908502991e-02*G0_0_0 - 1.500516908502994e-02*G0_0_1 + 2.276871308989376e-02*G0_0_2 - 1.500516908503000e-02*G0_1_0 - 1.500516908503004e-02*G0_1_1 + 2.276871308989366e-02*G0_1_2 + 2.276871308989343e-02*G0_2_0 + 2.276871308989341e-02*G0_2_1 - 6.654466289882907e-02*G0_2_2;
    block[2595] = -9.394540644540726e-03*G0_0_2 - 9.394540644540541e-03*G0_1_2 - 9.394540644540761e-03*G0_2_0 - 9.394540644540768e-03*G0_2_1 + 4.534170658302580e-02*G0_2_2;
    block[2596] = -3.066273682593115e-02*G0_0_0 - 2.126819618139057e-02*G0_0_2 - 2.126819618139082e-02*G0_2_0 - 1.187365553685013e-02*G0_2_2;
    block[2597] = -1.304797311741893e-03*G0_0_0 - 1.239557446154718e-03*G0_0_2 - 1.239557446154411e-03*G0_2_0 - 1.174317580567524e-03*G0_2_2;
    block[2598] = -1.500516908503002e-02*G0_0_0 - 1.493992921944292e-02*G0_0_2 - 1.493992921944338e-02*G0_2_0 - 1.487468935385624e-02*G0_2_2;
    block[2599] = 9.394540644540476e-03*G0_0_2 + 9.394540644540678e-03*G0_2_0 + 1.878908128908129e-02*G0_2_2;
    block[2600] = -3.066273682593070e-02*G0_1_1 - 2.126819618139042e-02*G0_1_2 - 2.126819618139011e-02*G0_2_1 - 1.187365553684937e-02*G0_2_2;
    block[2601] = -1.304797311741901e-03*G0_1_1 - 1.239557446154598e-03*G0_1_2 - 1.239557446154759e-03*G0_2_1 - 1.174317580567933e-03*G0_2_2;
    block[2602] = -1.500516908502999e-02*G0_1_1 - 1.493992921944299e-02*G0_1_2 - 1.493992921944291e-02*G0_2_1 - 1.487468935385562e-02*G0_2_2;
    block[2603] = 9.394540644540688e-03*G0_1_2 + 9.394540644540709e-03*G0_2_1 + 1.878908128908136e-02*G0_2_2;
    block[2604] = -4.566790591096041e-02*G0_0_0 - 3.783912204051046e-02*G0_0_1 - 7.567824408102070e-02*G0_0_2 - 3.783912204050987e-02*G0_1_0 - 5.284429112554011e-02*G0_1_2 - 7.567824408102060e-02*G0_2_0 - 5.284429112554081e-02*G0_2_1 - 1.056885822510813e-01*G0_2_2;
    block[2605] = -2.283395295548056e-02*G0_0_0 - 1.206937513361141e-02*G0_0_1 - 2.413875026722219e-02*G0_0_2 - 1.206937513361128e-02*G0_1_0 - 1.272177378948157e-02*G0_1_2 - 2.413875026722236e-02*G0_2_0 - 1.272177378948232e-02*G0_2_1 - 2.544354757896335e-02*G0_2_2;
    block[2606] = -1.500516908502984e-02*G0_0_1 - 3.001033817005983e-02*G0_0_2 - 1.500516908502966e-02*G0_1_0 - 3.001033817006016e-02*G0_1_2 - 3.001033817005953e-02*G0_2_0 - 3.001033817005986e-02*G0_2_1 - 6.002067634012047e-02*G0_2_2;
    block[2607] = -8.807381854256720e-02*G0_0_0 - 8.872621719843772e-02*G0_0_1 - 1.007955923320489e-01*G0_0_2 - 8.872621719843850e-02*G0_1_0 - 8.807381854256727e-02*G0_1_1 - 1.007955923320493e-01*G0_1_2 - 1.007955923320496e-01*G0_2_0 - 1.007955923320489e-01*G0_2_1 - 1.135173661215314e-01*G0_2_2;
    block[2608] = -1.206937513361099e-02*G0_0_1 - 1.272177378948224e-02*G0_0_2 - 1.206937513361120e-02*G0_1_0 - 2.283395295548038e-02*G0_1_1 - 2.413875026722235e-02*G0_1_2 - 1.272177378948217e-02*G0_2_0 - 2.413875026722192e-02*G0_2_1 - 2.544354757896425e-02*G0_2_2;
    block[2609] = -3.783912204051038e-02*G0_0_1 - 5.284429112553970e-02*G0_0_2 - 3.783912204051020e-02*G0_1_0 - 4.566790591096089e-02*G0_1_1 - 7.567824408102047e-02*G0_1_2 - 5.284429112553988e-02*G0_2_0 - 7.567824408102110e-02*G0_2_1 - 1.056885822510801e-01*G0_2_2;
    block[2610] = 3.783912204050983e-02*G0_0_1 + 5.284429112554002e-02*G0_0_2 + 3.783912204051029e-02*G0_1_0 + 1.278701365506903e-01*G0_1_1 + 9.003101451017990e-02*G0_1_2 + 5.284429112554000e-02*G0_2_0 + 9.003101451018009e-02*G0_2_1 + 5.219189246966950e-02*G0_2_2;
    block[2611] = 1.206937513361156e-02*G0_0_1 + 1.272177378948234e-02*G0_0_2 + 1.206937513361116e-02*G0_1_0 + 5.023469650205714e-02*G0_1_1 + 4.468930792715477e-02*G0_1_2 + 1.272177378948214e-02*G0_2_0 + 4.468930792715457e-02*G0_2_1 + 3.914391935225272e-02*G0_2_2;
    block[2612] = 1.500516908502991e-02*G0_0_1 + 3.001033817006017e-02*G0_0_2 + 1.500516908502974e-02*G0_1_0 + 3.001033817006013e-02*G0_1_1 - 7.828783870450497e-03*G0_1_2 + 3.001033817005953e-02*G0_2_0 - 7.828783870450282e-03*G0_2_1 - 4.566790591096190e-02*G0_2_2;
    block[2613] = -8.807381854256732e-02*G0_0_0 - 9.720739972475891e-02*G0_0_1 - 1.340679237814635e-01*G0_0_2 - 9.720739972475935e-02*G0_1_0 - 2.922745978301500e-01*G0_1_1 - 2.244251376195792e-01*G0_1_2 - 1.340679237814643e-01*G0_2_0 - 2.244251376195795e-01*G0_2_1 - 1.565756774090088e-01*G0_2_2;
    block[2614] = -2.283395295548058e-02*G0_0_0 - 5.969447701218506e-02*G0_0_1 - 9.655500106888958e-02*G0_0_2 - 5.969447701218474e-02*G0_1_0 - 9.655500106888884e-02*G0_1_1 - 2.870554085831849e-02*G0_1_2 - 9.655500106888842e-02*G0_2_0 - 2.870554085831836e-02*G0_2_1 + 3.914391935225282e-02*G0_2_2;
    block[2615] = 5.219189246966906e-02*G0_0_0 + 1.878908128908107e-01*G0_0_1 + 3.235897333119529e-01*G0_0_2 + 1.878908128908102e-01*G0_1_0 + 3.235897333119520e-01*G0_1_1 + 1.878908128908107e-01*G0_1_2 + 3.235897333119517e-01*G0_2_0 + 1.878908128908107e-01*G0_2_1 + 5.219189246966934e-02*G0_2_2;
    block[2616] = 3.001033817006014e-02*G0_0_0 + 1.500516908502992e-02*G0_0_1 - 7.828783870450188e-03*G0_0_2 + 1.500516908503033e-02*G0_1_0 + 3.001033817006010e-02*G0_1_2 - 7.828783870449718e-03*G0_2_0 + 3.001033817006011e-02*G0_2_1 - 4.566790591096130e-02*G0_2_2;
    block[2617] = 5.023469650205735e-02*G0_0_0 + 1.206937513361124e-02*G0_0_1 + 4.468930792715459e-02*G0_0_2 + 1.206937513361091e-02*G0_1_0 + 1.272177378948194e-02*G0_1_2 + 4.468930792715441e-02*G0_2_0 + 1.272177378948207e-02*G0_2_1 + 3.914391935225280e-02*G0_2_2;
    block[2618] = 1.278701365506919e-01*G0_0_0 + 3.783912204051069e-02*G0_0_1 + 9.003101451018103e-02*G0_0_2 + 3.783912204051100e-02*G0_1_0 + 5.284429112554116e-02*G0_1_2 + 9.003101451018111e-02*G0_2_0 + 5.284429112554091e-02*G0_2_1 + 5.219189246967008e-02*G0_2_2;
    block[2619] = -9.655500106888948e-02*G0_0_0 - 5.969447701218488e-02*G0_0_1 - 2.870554085831903e-02*G0_0_2 - 5.969447701218482e-02*G0_1_0 - 2.283395295548074e-02*G0_1_1 - 9.655500106888926e-02*G0_1_2 - 2.870554085831862e-02*G0_2_0 - 9.655500106888899e-02*G0_2_1 + 3.914391935225234e-02*G0_2_2;
    block[2620] = -2.922745978301523e-01*G0_0_0 - 9.720739972475988e-02*G0_0_1 - 2.244251376195804e-01*G0_0_2 - 9.720739972476029e-02*G0_1_0 - 8.807381854256781e-02*G0_1_1 - 1.340679237814644e-01*G0_1_2 - 2.244251376195805e-01*G0_2_0 - 1.340679237814644e-01*G0_2_1 - 1.565756774090096e-01*G0_2_2;
    block[2621] = 3.235897333119535e-01*G0_0_0 + 1.878908128908117e-01*G0_0_1 + 1.878908128908116e-01*G0_0_2 + 1.878908128908111e-01*G0_1_0 + 5.219189246966956e-02*G0_1_1 + 3.235897333119525e-01*G0_1_2 + 1.878908128908114e-01*G0_2_0 + 3.235897333119526e-01*G0_2_1 + 5.219189246966974e-02*G0_2_2;
    block[2622] = 6.471794666239054e-01*G0_0_0 + 3.757816257816211e-01*G0_0_1 + 3.757816257816211e-01*G0_0_2 + 3.757816257816211e-01*G0_1_0 + 6.471794666239035e-01*G0_1_1 + 3.757816257816208e-01*G0_1_2 + 3.757816257816211e-01*G0_2_0 + 3.757816257816208e-01*G0_2_1 + 6.471794666239034e-01*G0_2_2;
    block[2623] = -5.845491956603022e-01*G0_0_0 - 3.216325373443393e-01*G0_0_1 - 1.944147994495191e-01*G0_0_2 - 3.216325373443392e-01*G0_1_0 - 2.681358475629277e-01*G0_1_1 - 2.221417423240311e-01*G0_1_2 - 4.488502752391592e-01*G0_2_0 - 2.906436011904726e-01*G0_2_1 - 2.681358475629275e-01*G0_2_2;
    block[2624] = 2.557402731013830e-01*G0_0_0 + 1.278701365506912e-01*G0_0_1 + 7.567824408102115e-02*G0_0_2 + 1.278701365506910e-01*G0_1_0 + 1.056885822510819e-01*G0_1_1 + 5.284429112554059e-02*G0_1_2 + 1.800620290203608e-01*G0_2_0 + 1.050361835952106e-01*G0_2_1 + 1.056885822510815e-01*G0_2_2;
    block[2625] = -2.681358475629267e-01*G0_0_0 - 3.216325373443383e-01*G0_0_1 - 2.221417423240304e-01*G0_0_2 - 3.216325373443382e-01*G0_1_0 - 5.845491956602994e-01*G0_1_1 - 1.944147994495185e-01*G0_1_2 - 2.906436011904718e-01*G0_2_0 - 4.488502752391583e-01*G0_2_1 - 2.681358475629274e-01*G0_2_2;
    block[2626] = 1.722332451499088e-01*G0_0_0 + 1.660354579191357e-01*G0_0_1 + 1.007955923320486e-01*G0_0_2 + 1.660354579191356e-01*G0_1_0 + 1.722332451499090e-01*G0_1_1 + 1.007955923320490e-01*G0_1_2 + 1.986553907126792e-01*G0_2_0 + 1.986553907126793e-01*G0_2_1 + 1.135173661215312e-01*G0_2_2;
    block[2627] = 1.056885822510805e-01*G0_0_0 + 1.278701365506900e-01*G0_0_1 + 5.284429112553987e-02*G0_0_2 + 1.278701365506903e-01*G0_1_0 + 2.557402731013810e-01*G0_1_1 + 7.567824408102046e-02*G0_1_2 + 1.050361835952097e-01*G0_2_0 + 1.800620290203596e-01*G0_2_1 + 1.056885822510802e-01*G0_2_2;
    block[2628] = -1.500516908502989e-01*G0_0_0 - 3.359853077734992e-01*G0_0_1 - 4.664650389476725e-01*G0_0_2 - 3.359853077734979e-01*G0_1_0 - 1.500516908503000e-01*G0_1_1 - 4.664650389476724e-01*G0_1_2 - 4.664650389476723e-01*G0_2_0 - 4.664650389476736e-01*G0_2_1 - 7.828783870450452e-01*G0_2_2;
    block[2629] = 1.435277042915901e-01*G0_0_0 + 1.859336169231975e-01*G0_0_1 + 2.185535497167409e-01*G0_0_2 + 1.859336169231975e-01*G0_1_0 + 1.761476370851350e-01*G0_1_1 + 2.348635161135123e-01*G0_1_2 + 2.185535497167414e-01*G0_2_0 + 2.348635161135133e-01*G0_2_1 + 2.935793951418908e-01*G0_2_2;
    block[2630] = 1.761476370851346e-01*G0_0_0 + 1.859336169231981e-01*G0_0_1 + 2.348635161135126e-01*G0_0_2 + 1.859336169231979e-01*G0_1_0 + 1.435277042915915e-01*G0_1_1 + 2.185535497167410e-01*G0_1_2 + 2.348635161135139e-01*G0_2_0 + 2.185535497167425e-01*G0_2_1 + 2.935793951418915e-01*G0_2_2;
    block[2631] = 4.566790591096095e-02*G0_0_0 + 7.176385214579571e-02*G0_0_1 + 1.206937513361111e-01*G0_0_2 + 7.176385214579577e-02*G0_1_0 + 4.566790591096093e-02*G0_1_1 + 1.206937513361118e-01*G0_1_2 + 1.206937513361105e-01*G0_2_0 + 1.206937513361107e-01*G0_2_1 + 1.957195967612619e-01*G0_2_2;
    block[2632] = -2.984723850609239e-02*G0_0_0 - 2.984723850609239e-02*G0_0_1 - 2.984723850609240e-02*G0_0_2 - 2.984723850609237e-02*G0_1_0 - 2.984723850609238e-02*G0_1_1 - 2.984723850609237e-02*G0_1_2 - 3.457190957190925e-02*G0_2_0 - 3.457190957190927e-02*G0_2_1 - 3.457190957190925e-02*G0_2_2;
    block[2633] = -2.984723850609246e-02*G0_0_0 + 4.724671065816995e-03*G0_2_0;
    block[2634] = 1.174317580567567e-02*G0_1_1 + 2.278176106301151e-03*G0_2_1;
    block[2635] = -9.464999699374640e-03*G0_2_2;
    block[2636] = 1.285225352065624e-01*G0_0_0 + 4.227543290043274e-02*G0_0_1 + 4.227543290043281e-02*G0_1_0 + 8.455086580086557e-02*G0_2_0 + 4.296045148909752e-02*G0_2_1;
    block[2637] = 3.718672338463890e-02*G0_0_0 + 7.434082683648544e-02*G0_0_1 + 7.434082683648550e-02*G0_1_0 + 1.047099842672748e-01*G0_1_1 + 8.083219346240031e-02*G0_2_0 + 1.082329370089772e-01*G0_2_1;
    block[2638] = -6.197787230773353e-03*G0_0_0 + 1.888694108746152e-02*G0_0_1 + 1.888694108746175e-02*G0_1_0 + 5.675868306076558e-02*G0_1_1 + 9.394540644540740e-03*G0_2_0 + 3.777388217492369e-02*G0_2_1;
    block[2639] = -5.838967970044562e-03*G0_0_1 - 5.838967970044271e-03*G0_1_0 - 4.354761027938057e-02*G0_1_1 - 2.544354757896486e-03*G0_2_0 - 1.428753056357239e-02*G0_2_1;
    block[2640] = 5.838967970044271e-03*G0_0_1 + 5.838967970044309e-03*G0_1_0 - 3.186967433929210e-02*G0_1_1 + 5.838967970044321e-03*G0_1_2 + 2.544354757896544e-03*G0_2_0 - 5.904207835631657e-03*G0_2_1 + 2.544354757896538e-03*G0_2_2;
    block[2641] = -6.197787230773847e-03*G0_0_0 - 2.508472831823514e-02*G0_0_1 - 6.197787230773757e-03*G0_0_2 - 2.508472831823490e-02*G0_1_0 + 1.278701365506912e-02*G0_1_1 - 2.508472831823493e-02*G0_1_2 - 1.559232787531398e-02*G0_2_0 + 3.294613212148192e-03*G0_2_1 - 1.559232787531405e-02*G0_2_2;
    block[2642] = 3.718672338464082e-02*G0_0_0 - 3.715410345184608e-02*G0_0_1 + 3.718672338464076e-02*G0_0_2 - 3.715410345184619e-02*G0_1_0 - 6.784946021056950e-03*G0_1_1 - 3.715410345184616e-02*G0_1_2 - 4.364547007776097e-02*G0_2_0 - 9.753359905269401e-03*G0_2_1 - 4.364547007776101e-02*G0_2_2;
    block[2643] = 1.285225352065618e-01*G0_0_0 + 8.624710230612932e-02*G0_0_1 + 1.285225352065618e-01*G0_0_2 + 8.624710230612931e-02*G0_1_0 + 4.397166940569661e-02*G0_1_1 + 8.624710230612927e-02*G0_1_2 + 4.397166940569639e-02*G0_2_0 + 4.465668799436102e-02*G0_2_1 + 4.397166940569638e-02*G0_2_2;
    block[2644] = 9.208607027617349e-02*G0_0_0 + 1.343615031766059e-01*G0_0_1 + 1.343615031766059e-01*G0_0_2 + 1.343615031766059e-01*G0_1_0 + 1.766369360770385e-01*G0_1_1 + 1.766369360770385e-01*G0_1_2 + 1.280006162818651e-01*G0_2_0 + 1.273155976932004e-01*G0_2_1 + 1.273155976932004e-01*G0_2_2;
    block[2645] = -6.223883177008097e-02*G0_0_0 - 2.508146632495570e-01*G0_0_1 - 2.508146632495569e-01*G0_0_2 - 2.508146632495566e-01*G0_1_0 - 3.346805104617573e-01*G0_1_1 - 3.346805104617573e-01*G0_1_2 - 1.607836487393768e-01*G0_2_0 - 1.669488160373563e-01*G0_2_1 - 1.669488160373563e-01*G0_2_2;
    block[2646] = -6.223883177008149e-02*G0_0_0 + 1.885758314794763e-01*G0_0_1 + 1.885758314794762e-01*G0_0_2 + 1.885758314794759e-01*G0_1_0 + 1.047099842672757e-01*G0_1_1 + 1.047099842672756e-01*G0_1_2 + 9.854481696929572e-02*G0_2_0 + 1.824106641814962e-01*G0_2_1 + 1.824106641814962e-01*G0_2_2;
    block[2647] = 9.208607027617383e-02*G0_0_0 - 4.227543290043281e-02*G0_0_1 - 4.227543290043275e-02*G0_0_2 - 4.227543290043279e-02*G0_1_0 - 3.591454600569187e-02*G0_2_0 - 4.296045148909762e-02*G0_2_1 - 4.296045148909765e-02*G0_2_2;
    block[2648] = 6.426126760328113e-02*G0_0_0 + 6.426126760328106e-02*G0_0_1 + 2.198583470284848e-02*G0_0_2 + 6.426126760328109e-02*G0_1_0 + 6.426126760328106e-02*G0_1_1 + 2.198583470284842e-02*G0_1_2 + 2.198583470284815e-02*G0_2_0 + 2.198583470284816e-02*G0_2_1 + 2.267085329151278e-02*G0_2_2;
    block[2649] = 8.807381854256767e-03*G0_0_0 + 8.807381854256724e-03*G0_0_1 + 2.316015228341570e-03*G0_0_2 + 8.807381854256599e-03*G0_1_0 + 8.807381854256512e-03*G0_1_1 + 2.316015228341492e-03*G0_1_2 + 2.316015228341854e-03*G0_2_0 + 2.316015228341860e-03*G0_2_1 - 6.523986558707784e-04*G0_2_2;
    block[2650] = -6.523986558710384e-04*G0_0_0 - 6.523986558710077e-04*G0_0_1 + 8.840001787049955e-03*G0_0_2 - 6.523986558705354e-04*G0_1_0 - 6.523986558704991e-04*G0_1_1 + 8.840001787050347e-03*G0_1_2 + 8.840001787050368e-03*G0_2_0 + 8.840001787050356e-03*G0_2_1 - 6.523986558711115e-04*G0_2_2;
    block[2651] = -3.294613212147619e-03*G0_0_2 - 3.294613212147887e-03*G0_1_2 - 3.294613212147897e-03*G0_2_0 - 3.294613212147905e-03*G0_2_1 + 2.267085329151294e-02*G0_2_2;
    block[2652] = 6.426126760328124e-02*G0_0_0 + 4.227543290043274e-02*G0_0_2 + 4.227543290043283e-02*G0_2_0 + 4.296045148909753e-02*G0_2_2;
    block[2653] = 8.807381854256861e-03*G0_0_0 + 6.491366625915232e-03*G0_0_2 + 6.491366625914692e-03*G0_2_0 + 3.522952741701915e-03*G0_2_2;
    block[2654] = -6.523986558708504e-04*G0_0_0 - 9.492400442921298e-03*G0_0_2 - 9.492400442921043e-03*G0_2_0 - 1.898480088584203e-02*G0_2_2;
    block[2655] = 3.294613212148108e-03*G0_0_2 + 3.294613212148025e-03*G0_2_0 + 2.926007971580866e-02*G0_2_2;
    block[2656] = -9.133581182192076e-03*G0_1_1 - 5.838967970044262e-03*G0_1_2 - 5.838967970044693e-03*G0_2_1 - 2.544354757896584e-03*G0_2_2;
    block[2657] = -1.565756774090099e-02*G0_1_1 - 1.308059305021092e-02*G0_1_2 - 1.308059305021097e-02*G0_2_1 - 1.050361835952130e-02*G0_2_2;
    block[2658] = -6.523986558708135e-04*G0_1_1 + 1.924576034818941e-03*G0_1_2 + 1.924576034818745e-03*G0_2_1 + 4.501550725508799e-03*G0_2_2;
    block[2659] = 3.294613212148066e-03*G0_1_2 + 3.294613212147956e-03*G0_2_1 + 6.589226424295927e-03*G0_2_2;
    block[2660] = 3.914391935225108e-02*G0_0_0 + 6.784946021057062e-02*G0_0_1 + 1.356989204211408e-01*G0_0_2 + 6.784946021057031e-02*G0_1_0 + 1.047099842672751e-01*G0_1_2 + 1.356989204211402e-01*G0_2_0 + 1.047099842672749e-01*G0_2_1 + 2.094199685345500e-01*G0_2_2;
    block[2661] = -4.892989919031437e-03*G0_0_0 + 1.418967076519155e-02*G0_0_1 + 2.837934153038276e-02*G0_0_2 + 1.418967076519147e-02*G0_1_0 + 2.837934153038261e-02*G0_1_2 + 2.837934153038322e-02*G0_2_0 + 2.837934153038234e-02*G0_2_1 + 5.675868306076529e-02*G0_2_2;
    block[2662] = -6.523986558709205e-04*G0_0_1 - 1.304797311742040e-03*G0_0_2 - 6.523986558709233e-04*G0_1_0 - 1.272177378948215e-02*G0_1_2 - 1.304797311742116e-03*G0_2_0 - 1.272177378948191e-02*G0_2_1 - 2.544354757896454e-02*G0_2_2;
    block[2663] = 1.957195967612593e-02*G0_0_0 + 6.067307499598987e-02*G0_0_1 + 7.486274576118129e-02*G0_0_2 + 6.067307499599098e-02*G0_1_0 + 9.296680846159888e-02*G0_1_1 + 1.213461499919816e-01*G0_1_2 + 7.486274576118278e-02*G0_2_0 + 1.213461499919811e-01*G0_2_1 + 1.497254915223641e-01*G0_2_2;
    block[2664] = -1.027527882996619e-02*G0_0_1 - 1.810406270041620e-02*G0_0_2 - 1.027527882996606e-02*G0_1_0 + 1.957195967612643e-02*G0_1_1 + 1.467896975709950e-03*G0_1_2 - 1.810406270041687e-02*G0_2_0 + 1.467896975709623e-03*G0_2_1 - 1.663616572470680e-02*G0_2_2;
    block[2665] = -5.545388574902492e-03*G0_0_1 - 6.197787230774099e-03*G0_0_2 - 5.545388574902487e-03*G0_1_0 + 3.914391935225234e-02*G0_1_1 + 2.642214556277002e-02*G0_1_2 - 6.197787230774262e-03*G0_2_0 + 2.642214556277009e-02*G0_2_1 + 1.370037177328776e-02*G0_2_2;
    block[2666] = 5.545388574902961e-03*G0_0_1 + 6.197787230773597e-03*G0_0_2 + 5.545388574902437e-03*G0_1_0 + 5.023469650205693e-02*G0_1_1 + 3.816532136844578e-02*G0_1_2 + 6.197787230774182e-03*G0_2_0 + 3.816532136844665e-02*G0_2_1 + 2.609594623483542e-02*G0_2_2;
    block[2667] = 1.027527882996589e-02*G0_0_1 + 1.810406270041648e-02*G0_0_2 + 1.027527882996608e-02*G0_1_0 + 4.012251733605891e-02*G0_1_1 + 2.984723850609255e-02*G0_1_2 + 1.810406270041684e-02*G0_2_0 + 2.984723850609278e-02*G0_2_1 + 1.957195967612661e-02*G0_2_2;
    block[2668] = 6.523986558710214e-04*G0_0_1 + 1.304797311741522e-03*G0_0_2 + 6.523986558708090e-04*G0_1_0 + 1.304797311741179e-03*G0_1_1 - 1.076457782186982e-02*G0_1_2 + 1.304797311742047e-03*G0_2_0 - 1.076457782186925e-02*G0_2_1 - 2.283395295548092e-02*G0_2_2;
    block[2669] = 1.957195967612605e-02*G0_0_0 - 4.110111531986591e-02*G0_0_1 - 5.529078608505697e-02*G0_0_2 - 4.110111531986507e-02*G0_1_0 - 8.807381854256734e-03*G0_1_1 + 5.382288910934880e-03*G0_1_2 - 5.529078608505743e-02*G0_2_0 + 5.382288910934040e-03*G0_2_1 + 1.957195967612558e-02*G0_2_2;
    block[2670] = -4.892989919031353e-03*G0_0_0 - 1.908266068422281e-02*G0_0_1 - 3.327233144941404e-02*G0_0_2 - 1.908266068422284e-02*G0_1_0 - 3.327233144941440e-02*G0_1_1 - 1.908266068422273e-02*G0_1_2 - 3.327233144941463e-02*G0_2_0 - 1.908266068422372e-02*G0_2_1 - 4.892989919031287e-03*G0_2_2;
    block[2671] = 3.914391935225299e-02*G0_0_0 - 2.870554085831795e-02*G0_0_1 - 9.655500106888959e-02*G0_0_2 - 2.870554085831835e-02*G0_1_0 - 9.655500106888920e-02*G0_1_1 - 5.969447701218501e-02*G0_1_2 - 9.655500106888856e-02*G0_2_0 - 5.969447701218435e-02*G0_2_1 - 2.283395295548021e-02*G0_2_2;
    block[2672] = 1.304797311741609e-03*G0_0_0 + 6.523986558707209e-04*G0_0_1 + 6.523986558704135e-04*G0_0_2 + 6.523986558702970e-04*G0_1_0 + 1.272177378948131e-02*G0_1_2 + 6.523986558703747e-04*G0_2_0 + 1.272177378948160e-02*G0_2_1 - 8.807381854256825e-02*G0_2_2;
    block[2673] = -8.807381854257005e-03*G0_0_0 - 1.418967076519143e-02*G0_0_1 + 3.229373346560813e-02*G0_0_2 - 1.418967076519088e-02*G0_1_0 - 2.837934153038233e-02*G0_1_2 + 3.229373346560867e-02*G0_2_0 - 2.837934153038215e-02*G0_2_1 + 9.296680846159941e-02*G0_2_2;
    block[2674] = -2.922745978301522e-01*G0_0_0 - 6.784946021057085e-02*G0_0_1 - 1.950671981053914e-01*G0_0_2 - 6.784946021057141e-02*G0_1_0 - 1.047099842672754e-01*G0_1_2 - 1.950671981053912e-01*G0_2_0 - 1.047099842672752e-01*G0_2_1 - 1.859336169231981e-01*G0_2_2;
    block[2675] = -8.807381854256164e-03*G0_0_0 + 5.382288910935102e-03*G0_0_1 - 4.110111531986415e-02*G0_0_2 + 5.382288910934748e-03*G0_1_0 + 1.957195967612633e-02*G0_1_1 - 5.529078608505592e-02*G0_1_2 - 4.110111531986497e-02*G0_2_0 - 5.529078608505573e-02*G0_2_1 + 1.957195967612664e-02*G0_2_2;
    block[2676] = 4.560266604537418e-01*G0_0_0 + 2.280133302268702e-01*G0_0_1 + 2.280133302268704e-01*G0_0_2 + 2.280133302268700e-01*G0_1_0 + 9.296680846159951e-02*G0_1_1 + 3.630598519921398e-01*G0_1_2 + 2.280133302268698e-01*G0_2_0 + 3.630598519921400e-01*G0_2_1 + 9.296680846159915e-02*G0_2_2;
    block[2677] = -2.922745978301521e-01*G0_0_0 - 2.244251376195810e-01*G0_0_1 - 9.720739972476052e-02*G0_0_2 - 2.244251376195802e-01*G0_1_0 - 1.565756774090090e-01*G0_1_1 - 1.340679237814643e-01*G0_1_2 - 9.720739972475978e-02*G0_2_0 - 1.340679237814640e-01*G0_2_1 - 8.807381854256750e-02*G0_2_2;
    block[2678] = -5.845491956603022e-01*G0_0_0 - 3.216325373443392e-01*G0_0_1 - 4.488502752391592e-01*G0_0_2 - 3.216325373443393e-01*G0_1_0 - 2.681358475629277e-01*G0_1_1 - 2.906436011904726e-01*G0_1_2 - 1.944147994495191e-01*G0_2_0 - 2.221417423240311e-01*G0_2_1 - 2.681358475629275e-01*G0_2_2;
    block[2679] = 9.120533209074814e-01*G0_0_0 + 4.560266604537394e-01*G0_0_1 + 4.560266604537393e-01*G0_0_2 + 4.560266604537394e-01*G0_1_0 + 7.261197039842803e-01*G0_1_1 + 4.560266604537399e-01*G0_1_2 + 4.560266604537394e-01*G0_2_0 + 4.560266604537399e-01*G0_2_1 + 7.261197039842808e-01*G0_2_2;
    block[2680] = -5.845491956603033e-01*G0_0_0 - 2.629166583159618e-01*G0_0_1 - 1.356989204211413e-01*G0_0_2 - 2.629166583159621e-01*G0_1_0 - 2.094199685345506e-01*G0_1_1 - 1.047099842672753e-01*G0_1_2 - 3.901343962107822e-01*G0_2_0 - 2.906436011904735e-01*G0_2_1 - 2.094199685345506e-01*G0_2_2;
    block[2681] = -3.718672338464141e-02*G0_0_0 + 1.869122149070035e-01*G0_0_1 + 3.767602237654157e-02*G0_0_2 + 1.869122149070046e-01*G0_1_0 - 3.718672338464051e-02*G0_1_1 + 1.404288106762047e-01*G0_1_2 + 1.404288106762048e-01*G0_2_0 + 3.767602237654147e-02*G0_2_1 + 6.556606491502205e-02*G0_2_2;
    block[2682] = -3.718672338463772e-02*G0_0_0 - 2.240989382916434e-01*G0_0_1 - 7.486274576118128e-02*G0_0_2 - 2.240989382916437e-01*G0_1_0 - 4.481978765832881e-01*G0_1_1 - 1.213461499919814e-01*G0_1_2 - 1.776155340608439e-01*G0_2_0 - 3.268517265913070e-01*G0_2_1 - 1.497254915223640e-01*G0_2_2;
    block[2683] = 1.239557446154696e-02*G0_0_0 + 6.197787230773927e-03*G0_0_1 + 6.197787230774028e-03*G0_0_2 + 6.197787230773064e-03*G0_1_0 + 1.722332451499101e-01*G0_1_1 - 2.642214556277028e-02*G0_1_2 + 6.197787230773215e-03*G0_2_0 + 7.143765281786126e-02*G0_2_1 - 1.370037177328794e-02*G0_2_2;
    block[2684] = -3.914391935225411e-02*G0_0_0 + 2.495424858706090e-01*G0_0_1 + 4.452620826318699e-01*G0_0_2 + 2.495424858706088e-01*G0_1_0 + 3.522952741702706e-01*G0_1_1 + 2.495424858706076e-01*G0_1_2 + 4.452620826318699e-01*G0_2_0 + 2.495424858706081e-01*G0_2_1 + 1.467896975709453e-01*G0_2_2;
    block[2685] = -3.914391935224987e-02*G0_0_0 - 2.886864052228601e-01*G0_0_1 - 4.844060019841215e-01*G0_0_2 - 2.886864052228607e-01*G0_1_0 - 1.859336169231985e-01*G0_1_1 - 4.844060019841225e-01*G0_1_2 - 4.844060019841213e-01*G0_2_0 - 4.844060019841214e-01*G0_2_1 - 7.828783870450456e-01*G0_2_2;
    block[2686] = -3.914391935225207e-02*G0_0_0 - 1.957195967612555e-02*G0_0_1 - 1.957195967612533e-02*G0_0_2 - 1.957195967612589e-02*G0_1_0 - 2.348635161135141e-01*G0_1_1 - 1.418967076519146e-01*G0_1_2 - 1.957195967612529e-02*G0_2_0 - 1.418967076519140e-01*G0_2_1 - 4.892989919031505e-02*G0_2_2;
    block[2687] = 9.785979838062947e-03*G0_0_0 + 4.892989919031340e-03*G0_0_1 + 4.892989919031571e-03*G0_0_2 + 4.892989919031563e-03*G0_1_0 - 3.914391935225250e-02*G0_1_1 + 5.382288910934734e-02*G0_1_2 + 4.892989919031601e-03*G0_2_0 + 5.382288910934656e-02*G0_2_1 + 1.467896975709466e-01*G0_2_2;
    block[2688] = 1.891956102025533e-02*G0_0_0 + 1.891956102025532e-02*G0_0_1 + 1.891956102025535e-02*G0_0_2 + 1.891956102025527e-02*G0_1_0 + 1.891956102025525e-02*G0_1_1 + 1.891956102025526e-02*G0_1_2 + 1.374212528726413e-02*G0_2_0 + 1.374212528726413e-02*G0_2_1 + 1.374212528726415e-02*G0_2_2;
    block[2689] = 3.359853077734996e-02*G0_0_0 - 1.439452394313497e-02*G0_2_0;
    block[2690] = 1.891956102025518e-02*G0_1_1 + 5.177435732991223e-03*G0_2_1;
    block[2691] = -1.374212528726419e-02*G0_2_2;
    block[2692] = -2.570450704131236e-01*G0_0_0 - 9.629404160654054e-02*G0_0_1 - 9.629404160654084e-02*G0_1_0 - 1.925880832130812e-01*G0_2_0 - 1.247386230025106e-01*G0_2_1;
    block[2693] = 1.213461499919823e-01*G0_0_0 - 7.332960891988605e-02*G0_0_1 - 7.332960891988607e-02*G0_1_0 - 2.713978408422830e-01*G0_1_1 - 1.096029741863068e-02*G0_2_0 - 1.466592178397724e-01*G0_2_1;
    block[2694] = -5.284429112554021e-02*G0_0_0 + 3.594716593848533e-02*G0_0_1 + 3.594716593848520e-02*G0_1_0 + 2.094199685345500e-01*G0_1_1 - 1.826716236438411e-03*G0_2_0 + 8.233271037090438e-02*G0_2_1;
    block[2695] = -2.126819618139053e-02*G0_0_1 - 2.126819618139085e-02*G0_1_0 - 1.118863694818547e-01*G0_1_1 - 1.187365553685005e-02*G0_2_0 - 4.775558160974815e-02*G0_2_1;
    block[2696] = 2.126819618139088e-02*G0_0_1 + 2.126819618139081e-02*G0_1_0 - 1.878908128908064e-02*G0_1_1 + 2.126819618139087e-02*G0_1_2 + 1.187365553685003e-02*G0_2_0 - 9.394540644540261e-03*G0_2_1 + 1.187365553685009e-02*G0_2_2;
    block[2697] = -5.284429112554102e-02*G0_0_0 - 1.376561163887588e-02*G0_0_1 - 5.284429112554099e-02*G0_0_2 - 1.376561163887581e-02*G0_1_0 - 1.304797311746114e-04*G0_1_1 - 1.376561163887588e-02*G0_1_2 + 1.174317580567132e-03*G0_2_0 - 6.523986558756113e-05*G0_2_1 + 1.174317580567218e-03*G0_2_2;
    block[2698] = -2.544354757896417e-02*G0_0_0 + 1.363513190770154e-02*G0_0_1 - 2.544354757896414e-02*G0_0_2 + 1.363513190770160e-02*G0_1_0 - 1.304797311739792e-04*G0_1_1 + 1.363513190770165e-02*G0_1_2 + 1.487468935385610e-02*G0_2_0 - 6.523986558677621e-05*G0_2_1 + 1.487468935385605e-02*G0_2_2;
    block[2699] = -6.132547365186223e-02*G0_0_0 - 4.005727747047173e-02*G0_0_1 - 6.132547365186213e-02*G0_0_2 - 4.005727747047170e-02*G0_1_0 - 1.878908128908118e-02*G0_1_1 - 4.005727747047166e-02*G0_1_2 - 1.878908128908124e-02*G0_2_0 - 9.394540644540672e-03*G0_2_1 - 1.878908128908113e-02*G0_2_2;
    block[2700] = -6.934997711907373e-02*G0_0_0 - 9.061817330046414e-02*G0_0_1 - 9.061817330046415e-02*G0_0_2 - 9.061817330046400e-02*G0_1_0 - 1.118863694818546e-01*G0_1_1 - 1.118863694818545e-01*G0_1_2 - 5.473624722756627e-02*G0_2_0 - 6.413078787210674e-02*G0_2_1 - 6.413078787210674e-02*G0_2_2;
    block[2701] = 8.468134553203924e-02*G0_0_0 + 1.734728025960650e-01*G0_0_1 + 1.734728025960650e-01*G0_0_2 + 1.734728025960647e-01*G0_1_0 + 2.094199685345499e-01*G0_1_1 + 2.094199685345497e-01*G0_1_2 + 8.931337598872263e-02*G0_2_0 + 1.270872581636459e-01*G0_2_1 + 1.270872581636458e-01*G0_2_2;
    block[2702] = -3.392473010528499e-03*G0_0_0 - 1.980682319223971e-01*G0_0_1 - 1.980682319223970e-01*G0_0_2 - 1.980682319223967e-01*G0_1_0 - 2.713978408422830e-01*G0_1_1 - 2.713978408422829e-01*G0_1_2 - 6.236931150125580e-02*G0_2_0 - 1.247386230025110e-01*G0_2_1 - 1.247386230025108e-01*G0_2_2;
    block[2703] = -6.445698720004227e-02*G0_0_0 + 9.629404160654063e-02*G0_0_1 + 9.629404160654055e-02*G0_0_2 + 9.629404160654062e-02*G0_1_0 + 2.844458139597034e-02*G0_2_0 + 1.247386230025107e-01*G0_2_1 + 1.247386230025106e-01*G0_2_2;
    block[2704] = -3.066273682593114e-02*G0_0_0 - 3.066273682593108e-02*G0_0_1 - 9.394540644540620e-03*G0_0_2 - 3.066273682593126e-02*G0_1_0 - 3.066273682593118e-02*G0_1_1 - 9.394540644540580e-03*G0_1_2 - 9.394540644540645e-03*G0_2_0 - 9.394540644540558e-03*G0_2_1;
    block[2705] = -1.304797311741573e-03*G0_0_0 - 1.304797311741590e-03*G0_0_1 - 6.523986558709055e-05*G0_0_2 - 1.304797311741945e-03*G0_1_0 - 1.304797311741948e-03*G0_1_1 - 6.523986558717361e-05*G0_1_2 - 6.523986558679410e-05*G0_2_0 - 6.523986558682862e-05*G0_2_1;
    block[2706] = -1.500516908503010e-02*G0_0_0 - 1.500516908503012e-02*G0_0_1 - 6.523986558691749e-05*G0_0_2 - 1.500516908502999e-02*G0_1_0 - 1.500516908503000e-02*G0_1_1 - 6.523986558680174e-05*G0_1_2 - 6.523986558750147e-05*G0_2_0 - 6.523986558753465e-05*G0_2_1;
    block[2707] = -9.394540644540690e-03*G0_0_2 - 9.394540644540785e-03*G0_1_2 - 9.394540644540207e-03*G0_2_0 - 9.394540644540232e-03*G0_2_1;
    block[2708] = -1.285225352065616e-01*G0_0_0 - 9.629404160654051e-02*G0_0_2 - 9.629404160654026e-02*G0_2_0 - 1.247386230025106e-01*G0_2_2;
    block[2709] = 4.762510187857321e-02*G0_0_0 + 6.236931150125512e-02*G0_0_2 + 6.236931150125481e-02*G0_2_0 + 1.247386230025107e-01*G0_2_2;
    block[2710] = -1.500516908502957e-02*G0_0_0 - 3.777388217492302e-02*G0_0_2 - 3.777388217492298e-02*G0_2_0 - 1.270872581636458e-01*G0_2_2;
    block[2711] = 9.394540644540169e-03*G0_0_2 + 9.394540644540081e-03*G0_2_0 + 6.413078787210663e-02*G0_2_2;
    block[2712] = -3.066273682593084e-02*G0_1_1 - 2.126819618139072e-02*G0_1_2 - 2.126819618139054e-02*G0_2_1 - 1.187365553685002e-02*G0_2_2;
    block[2713] = -1.304797311741827e-03*G0_1_1 - 1.239557446154311e-03*G0_1_2 - 1.239557446154639e-03*G0_2_1 - 1.174317580567537e-03*G0_2_2;
    block[2714] = -1.500516908503006e-02*G0_1_1 - 1.493992921944316e-02*G0_1_2 - 1.493992921944293e-02*G0_2_1 - 1.487468935385589e-02*G0_2_2;
    block[2715] = 9.394540644540574e-03*G0_1_2 + 9.394540644540143e-03*G0_2_1 + 1.878908128908102e-02*G0_2_2;
    block[2716] = 5.219189246967051e-02*G0_0_0 - 1.356989204211407e-01*G0_0_1 - 2.713978408422817e-01*G0_0_2 - 1.356989204211409e-01*G0_1_0 - 2.713978408422831e-01*G0_1_2 - 2.713978408422824e-01*G0_2_0 - 2.713978408422820e-01*G0_2_1 - 5.427956816845652e-01*G0_2_2;
    block[2717] = -2.283395295548045e-02*G0_0_0 + 3.686052405670435e-02*G0_0_1 + 7.372104811340853e-02*G0_0_2 + 3.686052405670459e-02*G0_1_0 + 1.047099842672759e-01*G0_1_2 + 7.372104811340845e-02*G0_2_0 + 1.047099842672745e-01*G0_2_1 + 2.094199685345503e-01*G0_2_2;
    block[2718] = -1.500516908503004e-02*G0_0_1 - 3.001033817005987e-02*G0_0_2 - 1.500516908503011e-02*G0_1_0 - 5.284429112554070e-02*G0_1_2 - 3.001033817006058e-02*G0_2_0 - 5.284429112554059e-02*G0_2_1 - 1.056885822510820e-01*G0_2_2;
    block[2719] = -8.807381854256774e-02*G0_0_0 + 9.133581182192686e-03*G0_0_1 + 4.599410523889700e-02*G0_0_2 + 9.133581182192287e-03*G0_1_0 - 1.859336169231979e-01*G0_1_1 - 8.122363265592329e-02*G0_1_2 + 4.599410523889690e-02*G0_2_0 - 8.122363265592335e-02*G0_2_1 + 2.348635161135158e-02*G0_2_2;
    block[2720] = -1.206937513361158e-02*G0_0_1 - 1.272177378948268e-02*G0_0_2 - 1.206937513361097e-02*G0_1_0 + 2.609594623483526e-02*G0_1_1 + 1.989815900406181e-02*G0_1_2 - 1.272177378948200e-02*G0_2_0 + 1.989815900406133e-02*G0_2_1 + 1.370037177328841e-02*G0_2_2;
    block[2721] = -3.783912204051049e-02*G0_0_1 - 5.284429112554024e-02*G0_0_2 - 3.783912204051053e-02*G0_1_0 + 5.219189246966949e-02*G0_1_1 - 6.523986558709989e-04*G0_1_2 - 5.284429112554074e-02*G0_2_0 - 6.523986558706964e-04*G0_2_1 - 5.349668978141141e-02*G0_2_2;
    block[2722] = 3.783912204051063e-02*G0_0_1 + 5.284429112554087e-02*G0_0_2 + 3.783912204051062e-02*G0_1_0 + 3.001033817005993e-02*G0_1_1 + 1.500516908502984e-02*G0_1_2 + 5.284429112554087e-02*G0_2_0 + 1.500516908503022e-02*G0_2_1;
    block[2723] = 1.206937513361135e-02*G0_0_1 + 1.272177378948184e-02*G0_0_2 + 1.206937513361099e-02*G0_1_0 + 1.304797311741905e-03*G0_1_1 + 6.523986558706805e-04*G0_1_2 + 1.272177378948205e-02*G0_2_0 + 6.523986558707944e-04*G0_2_1;
    block[2724] = 1.500516908502998e-02*G0_0_1 + 3.001033817006069e-02*G0_0_2 + 1.500516908503013e-02*G0_1_0 + 3.001033817006018e-02*G0_1_1 + 1.500516908503045e-02*G0_1_2 + 3.001033817006055e-02*G0_2_0 + 1.500516908503048e-02*G0_2_1;
    block[2725] = -8.807381854256810e-02*G0_0_0 + 6.523986558712775e-04*G0_0_1 + 1.272177378948226e-02*G0_0_2 + 6.523986558716597e-04*G0_1_0 + 1.304797311741551e-03*G0_1_1 + 6.523986558709541e-04*G0_1_2 + 1.272177378948160e-02*G0_2_0 + 6.523986558711019e-04*G0_2_1;
    block[2726] = -2.283395295548096e-02*G0_0_0 - 1.076457782186960e-02*G0_0_1 + 1.304797311741245e-03*G0_0_2 - 1.076457782186989e-02*G0_1_0 + 1.304797311741765e-03*G0_1_1 + 6.523986558704762e-04*G0_1_2 + 1.304797311741300e-03*G0_2_0 + 6.523986558706454e-04*G0_2_1;
    block[2727] = -4.566790591096113e-02*G0_0_0 - 7.828783870450771e-03*G0_0_1 + 3.001033817006052e-02*G0_0_2 - 7.828783870450251e-03*G0_1_0 + 3.001033817006082e-02*G0_1_1 + 1.500516908503017e-02*G0_1_2 + 3.001033817006030e-02*G0_2_0 + 1.500516908502971e-02*G0_2_1;
    block[2728] = 3.001033817005978e-02*G0_0_0 + 1.500516908503014e-02*G0_0_1 + 3.783912204051101e-02*G0_0_2 + 1.500516908503018e-02*G0_1_0 + 5.284429112554100e-02*G0_1_2 + 3.783912204051058e-02*G0_2_0 + 5.284429112554075e-02*G0_2_1;
    block[2729] = -9.655500106888849e-02*G0_0_0 - 3.686052405670449e-02*G0_0_1 - 6.784946021057076e-02*G0_0_2 - 3.686052405670416e-02*G0_1_0 - 1.047099842672751e-01*G0_1_2 - 6.784946021057037e-02*G0_2_0 - 1.047099842672748e-01*G0_2_1;
    block[2730] = 3.235897333119532e-01*G0_0_0 + 1.356989204211411e-01*G0_0_1 + 1.356989204211420e-01*G0_0_2 + 1.356989204211417e-01*G0_1_0 + 2.713978408422827e-01*G0_1_2 + 1.356989204211411e-01*G0_2_0 + 2.713978408422825e-01*G0_2_1;
    block[2731] = 5.023469650205661e-02*G0_0_0 + 3.816532136844556e-02*G0_0_1 + 5.545388574901900e-03*G0_0_2 + 3.816532136844592e-02*G0_1_0 + 2.609594623483417e-02*G0_1_1 + 6.197787230772911e-03*G0_1_2 + 5.545388574902287e-03*G0_2_0 + 6.197787230772969e-03*G0_2_1;
    block[2732] = -2.922745978301522e-01*G0_0_0 - 1.950671981053915e-01*G0_0_1 - 6.784946021057148e-02*G0_0_2 - 1.950671981053912e-01*G0_1_0 - 1.859336169231982e-01*G0_1_1 - 1.047099842672746e-01*G0_1_2 - 6.784946021057077e-02*G0_2_0 - 1.047099842672754e-01*G0_2_1;
    block[2733] = 1.278701365506918e-01*G0_0_0 + 9.003101451018118e-02*G0_0_1 + 3.783912204051110e-02*G0_0_2 + 9.003101451018088e-02*G0_1_0 + 5.219189246966950e-02*G0_1_1 + 5.284429112554072e-02*G0_1_2 + 3.783912204051062e-02*G0_2_0 + 5.284429112554111e-02*G0_2_1;
    block[2734] = 2.557402731013830e-01*G0_0_0 + 1.278701365506910e-01*G0_0_1 + 1.800620290203609e-01*G0_0_2 + 1.278701365506912e-01*G0_1_0 + 1.056885822510819e-01*G0_1_1 + 1.050361835952106e-01*G0_1_2 + 7.567824408102115e-02*G0_2_0 + 5.284429112554061e-02*G0_2_1 + 1.056885822510815e-01*G0_2_2;
    block[2735] = -5.845491956603032e-01*G0_0_0 - 2.629166583159621e-01*G0_0_1 - 3.901343962107822e-01*G0_0_2 - 2.629166583159618e-01*G0_1_0 - 2.094199685345506e-01*G0_1_1 - 2.906436011904735e-01*G0_1_2 - 1.356989204211413e-01*G0_2_0 - 1.047099842672753e-01*G0_2_1 - 2.094199685345506e-01*G0_2_2;
    block[2736] = 6.471794666239061e-01*G0_0_0 + 2.713978408422832e-01*G0_0_1 + 2.713978408422825e-01*G0_0_2 + 2.713978408422832e-01*G0_1_0 + 5.427956816845663e-01*G0_1_1 + 2.713978408422834e-01*G0_1_2 + 2.713978408422825e-01*G0_2_0 + 2.713978408422834e-01*G0_2_1 + 5.427956816845658e-01*G0_2_2;
    block[2737] = 1.722332451499106e-01*G0_0_0 + 6.197787230773391e-03*G0_0_1 + 7.143765281786051e-02*G0_0_2 + 6.197787230773105e-03*G0_1_0 + 1.239557446154632e-02*G0_1_1 + 6.197787230773536e-03*G0_1_2 - 2.642214556277067e-02*G0_2_0 + 6.197787230773150e-03*G0_2_1 - 1.370037177328903e-02*G0_2_2;
    block[2738] = -2.681358475629293e-01*G0_0_0 + 5.349668978141112e-02*G0_0_1 - 4.599410523889712e-02*G0_0_2 + 5.349668978141114e-02*G0_1_0 - 2.094199685345502e-01*G0_1_1 + 8.122363265592315e-02*G0_1_2 + 2.250775362754514e-02*G0_2_0 - 1.047099842672754e-01*G0_2_1 - 2.348635161135183e-02*G0_2_2;
    block[2739] = 1.056885822510814e-01*G0_0_0 - 2.218155429960950e-02*G0_0_1 + 5.284429112554037e-02*G0_0_2 - 2.218155429960934e-02*G0_1_0 + 1.056885822510813e-01*G0_1_1 + 6.523986558711452e-04*G0_1_2 + 6.523986558712482e-04*G0_2_0 + 5.284429112554109e-02*G0_2_1 + 5.349668978141162e-02*G0_2_2;
    block[2740] = 1.435277042915924e-01*G0_0_0 - 4.240591263160746e-02*G0_0_1 - 7.502584542515085e-02*G0_0_2 - 4.240591263160699e-02*G0_1_0 - 5.219189246966940e-02*G0_1_1 - 2.609594623483548e-02*G0_1_2 - 7.502584542515113e-02*G0_2_0 - 2.609594623483608e-02*G0_2_1;
    block[2741] = -1.500516908503022e-01*G0_0_0 + 1.859336169231983e-01*G0_0_1 + 3.164133480973726e-01*G0_0_2 + 1.859336169231980e-01*G0_1_0 + 3.718672338463965e-01*G0_1_1 + 1.859336169231975e-01*G0_1_2 + 3.164133480973733e-01*G0_2_0 + 1.859336169231979e-01*G0_2_1;
    block[2742] = 1.761476370851359e-01*G0_0_0 - 9.785979838063076e-03*G0_0_1 - 5.871587902837790e-02*G0_0_2 - 9.785979838063986e-03*G0_1_0 - 5.219189246967007e-02*G0_1_1 - 2.609594623483529e-02*G0_1_2 - 5.871587902837849e-02*G0_2_0 - 2.609594623483365e-02*G0_2_1;
    block[2743] = 4.566790591096122e-02*G0_0_0 - 2.609594623483414e-02*G0_0_1 - 7.502584542515003e-02*G0_0_2 - 2.609594623483487e-02*G0_1_0 - 5.219189246966979e-02*G0_1_1 - 2.609594623483464e-02*G0_1_2 - 7.502584542514995e-02*G0_2_0 - 2.609594623483444e-02*G0_2_1;
    block[2744] = -2.984723850609227e-02*G0_0_0 - 2.984723850609229e-02*G0_0_1 - 2.984723850609228e-02*G0_0_2 - 2.984723850609224e-02*G0_1_0 - 2.984723850609231e-02*G0_1_1 - 2.984723850609226e-02*G0_1_2 - 3.457190957190916e-02*G0_2_0 - 3.457190957190921e-02*G0_2_1 - 3.457190957190918e-02*G0_2_2;
    block[2745] = 1.174317580567564e-02*G0_0_0 + 2.278176106301039e-03*G0_2_0;
    block[2746] = -2.984723850609240e-02*G0_1_1 + 4.724671065816779e-03*G0_2_1;
    block[2747] = -9.464999699374706e-03*G0_2_2;
    block[2748] = -4.354761027938065e-02*G0_0_0 - 5.838967970044275e-03*G0_0_1 - 5.838967970044103e-03*G0_1_0 - 1.428753056357169e-02*G0_2_0 - 2.544354757896116e-03*G0_2_1;
    block[2749] = 5.675868306076557e-02*G0_0_0 + 1.888694108746174e-02*G0_0_1 + 1.888694108746127e-02*G0_1_0 - 6.197787230773563e-03*G0_1_1 + 3.777388217492279e-02*G0_2_0 + 9.394540644540152e-03*G0_2_1;
    block[2750] = 1.047099842672750e-01*G0_0_0 + 7.434082683648575e-02*G0_0_1 + 7.434082683648575e-02*G0_1_0 + 3.718672338463980e-02*G0_1_1 + 1.082329370089782e-01*G0_2_0 + 8.083219346240147e-02*G0_2_1;
    block[2751] = 4.227543290043204e-02*G0_0_1 + 4.227543290043210e-02*G0_1_0 + 1.285225352065609e-01*G0_1_1 + 4.296045148909617e-02*G0_2_0 + 8.455086580086420e-02*G0_2_1;
    block[2752] = -4.227543290043254e-02*G0_0_1 - 4.227543290043213e-02*G0_1_0 + 9.208607027617348e-02*G0_1_1 - 4.227543290043222e-02*G0_1_2 - 4.296045148909621e-02*G0_2_0 - 3.591454600569141e-02*G0_2_1 - 4.296045148909619e-02*G0_2_2;
    block[2753] = 1.047099842672742e-01*G0_0_0 + 1.885758314794754e-01*G0_0_1 + 1.047099842672743e-01*G0_0_2 + 1.885758314794750e-01*G0_1_0 - 6.223883177008131e-02*G0_1_1 + 1.885758314794752e-01*G0_1_2 + 1.824106641814951e-01*G0_2_0 + 9.854481696929487e-02*G0_2_1 + 1.824106641814951e-01*G0_2_2;
    block[2754] = -3.346805104617568e-01*G0_0_0 - 2.508146632495562e-01*G0_0_1 - 3.346805104617568e-01*G0_0_2 - 2.508146632495555e-01*G0_1_0 - 6.223883177008047e-02*G0_1_1 - 2.508146632495556e-01*G0_1_2 - 1.669488160373551e-01*G0_2_0 - 1.607836487393757e-01*G0_2_1 - 1.669488160373552e-01*G0_2_2;
    block[2755] = 1.766369360770380e-01*G0_0_0 + 1.343615031766055e-01*G0_0_1 + 1.766369360770380e-01*G0_0_2 + 1.343615031766053e-01*G0_1_0 + 9.208607027617308e-02*G0_1_1 + 1.343615031766053e-01*G0_1_2 + 1.273155976932000e-01*G0_2_0 + 1.280006162818646e-01*G0_2_1 + 1.273155976931999e-01*G0_2_2;
    block[2756] = 4.397166940569648e-02*G0_0_0 + 8.624710230612906e-02*G0_0_1 + 8.624710230612906e-02*G0_0_2 + 8.624710230612892e-02*G0_1_0 + 1.285225352065614e-01*G0_1_1 + 1.285225352065614e-01*G0_1_2 + 4.465668799436106e-02*G0_2_0 + 4.397166940569650e-02*G0_2_1 + 4.397166940569647e-02*G0_2_2;
    block[2757] = -6.784946021056984e-03*G0_0_0 - 3.715410345184623e-02*G0_0_1 - 3.715410345184621e-02*G0_0_2 - 3.715410345184601e-02*G0_1_0 + 3.718672338463966e-02*G0_1_1 + 3.718672338463959e-02*G0_1_2 - 9.753359905269649e-03*G0_2_0 - 4.364547007776132e-02*G0_2_1 - 4.364547007776132e-02*G0_2_2;
    block[2758] = 1.278701365506922e-02*G0_0_0 - 2.508472831823499e-02*G0_0_1 - 2.508472831823505e-02*G0_0_2 - 2.508472831823489e-02*G0_1_0 - 6.197787230773238e-03*G0_1_1 - 6.197787230773140e-03*G0_1_2 + 3.294613212148118e-03*G0_2_0 - 1.559232787531385e-02*G0_2_1 - 1.559232787531387e-02*G0_2_2;
    block[2759] = -3.186967433929222e-02*G0_0_0 + 5.838967970044346e-03*G0_0_1 + 5.838967970044284e-03*G0_0_2 + 5.838967970044380e-03*G0_1_0 - 5.904207835631426e-03*G0_2_0 + 2.544354757896237e-03*G0_2_1 + 2.544354757896231e-03*G0_2_2;
    block[2760] = 6.426126760328087e-02*G0_0_0 + 6.426126760328089e-02*G0_0_1 + 2.198583470284848e-02*G0_0_2 + 6.426126760328067e-02*G0_1_0 + 6.426126760328080e-02*G0_1_1 + 2.198583470284839e-02*G0_1_2 + 2.198583470284812e-02*G0_2_0 + 2.198583470284807e-02*G0_2_1 + 2.267085329151271e-02*G0_2_2;
    block[2761] = 8.807381854256788e-03*G0_0_0 + 8.807381854256674e-03*G0_0_1 + 2.316015228341214e-03*G0_0_2 + 8.807381854256823e-03*G0_1_0 + 8.807381854256738e-03*G0_1_1 + 2.316015228341409e-03*G0_1_2 + 2.316015228341507e-03*G0_2_0 + 2.316015228341514e-03*G0_2_1 - 6.523986558707952e-04*G0_2_2;
    block[2762] = -6.523986558708856e-04*G0_0_0 - 6.523986558708534e-04*G0_0_1 + 8.840001787050692e-03*G0_0_2 - 6.523986558710689e-04*G0_1_0 - 6.523986558710636e-04*G0_1_1 + 8.840001787050423e-03*G0_1_2 + 8.840001787050160e-03*G0_2_0 + 8.840001787050161e-03*G0_2_1 - 6.523986558710774e-04*G0_2_2;
    block[2763] = -3.294613212148199e-03*G0_0_2 - 3.294613212148071e-03*G0_1_2 - 3.294613212147928e-03*G0_2_0 - 3.294613212147936e-03*G0_2_1 + 2.267085329151295e-02*G0_2_2;
    block[2764] = -9.133581182192164e-03*G0_0_0 - 5.838967970044272e-03*G0_0_2 - 5.838967970043991e-03*G0_2_0 - 2.544354757896166e-03*G0_2_2;
    block[2765] = -1.565756774090081e-02*G0_0_0 - 1.308059305021083e-02*G0_0_2 - 1.308059305021069e-02*G0_2_0 - 1.050361835952068e-02*G0_2_2;
    block[2766] = -6.523986558709279e-04*G0_0_0 + 1.924576034818982e-03*G0_0_2 + 1.924576034819173e-03*G0_2_0 + 4.501550725509050e-03*G0_2_2;
    block[2767] = 3.294613212147892e-03*G0_0_2 + 3.294613212147945e-03*G0_2_0 + 6.589226424295979e-03*G0_2_2;
    block[2768] = 6.426126760328027e-02*G0_1_1 + 4.227543290043195e-02*G0_1_2 + 4.227543290043191e-02*G0_2_1 + 4.296045148909616e-02*G0_2_2;
    block[2769] = 8.807381854257158e-03*G0_1_1 + 6.491366625915700e-03*G0_1_2 + 6.491366625915562e-03*G0_2_1 + 3.522952741703474e-03*G0_2_2;
    block[2770] = -6.523986558711156e-04*G0_1_1 - 9.492400442921644e-03*G0_1_2 - 9.492400442921298e-03*G0_2_1 - 1.898480088584298e-02*G0_2_2;
    block[2771] = 3.294613212147903e-03*G0_1_2 + 3.294613212147959e-03*G0_2_1 + 2.926007971580899e-02*G0_2_2;
    block[2772] = 3.914391935225259e-02*G0_0_0 - 5.545388574902033e-03*G0_0_1 + 2.642214556277036e-02*G0_0_2 - 5.545388574902483e-03*G0_1_0 - 6.197787230773560e-03*G0_1_2 + 2.642214556277099e-02*G0_2_0 - 6.197787230772073e-03*G0_2_1 + 1.370037177328873e-02*G0_2_2;
    block[2773] = 1.957195967612580e-02*G0_0_0 - 1.027527882996613e-02*G0_0_1 + 1.467896975709673e-03*G0_0_2 - 1.027527882996613e-02*G0_1_0 - 1.810406270041660e-02*G0_1_2 + 1.467896975709373e-03*G0_2_0 - 1.810406270041606e-02*G0_2_1 - 1.663616572470681e-02*G0_2_2;
    block[2774] = -6.523986558711457e-04*G0_0_1 - 1.272177378948253e-02*G0_0_2 - 6.523986558711929e-04*G0_1_0 - 1.304797311741755e-03*G0_1_2 - 1.272177378948184e-02*G0_2_0 - 1.304797311741431e-03*G0_2_1 - 2.544354757896422e-02*G0_2_2;
    block[2775] = 9.296680846159909e-02*G0_0_0 + 6.067307499599068e-02*G0_0_1 + 1.213461499919819e-01*G0_0_2 + 6.067307499599107e-02*G0_1_0 + 1.957195967612554e-02*G0_1_1 + 7.486274576118229e-02*G0_1_2 + 1.213461499919821e-01*G0_2_0 + 7.486274576118181e-02*G0_2_1 + 1.497254915223650e-01*G0_2_2;
    block[2776] = 1.418967076519112e-02*G0_0_1 + 2.837934153038317e-02*G0_0_2 + 1.418967076519153e-02*G0_1_0 - 4.892989919032033e-03*G0_1_1 + 2.837934153038335e-02*G0_1_2 + 2.837934153038314e-02*G0_2_0 + 2.837934153038239e-02*G0_2_1 + 5.675868306076642e-02*G0_2_2;
    block[2777] = 6.784946021057078e-02*G0_0_1 + 1.047099842672741e-01*G0_0_2 + 6.784946021057005e-02*G0_1_0 + 3.914391935225234e-02*G0_1_1 + 1.356989204211400e-01*G0_1_2 + 1.047099842672743e-01*G0_2_0 + 1.356989204211418e-01*G0_2_1 + 2.094199685345488e-01*G0_2_2;
    block[2778] = -6.784946021056983e-02*G0_0_1 - 1.047099842672743e-01*G0_0_2 - 6.784946021057008e-02*G0_1_0 - 2.922745978301499e-01*G0_1_1 - 1.950671981053904e-01*G0_1_2 - 1.047099842672744e-01*G0_2_0 - 1.950671981053899e-01*G0_2_1 - 1.859336169231985e-01*G0_2_2;
    block[2779] = -1.418967076519139e-02*G0_0_1 - 2.837934153038326e-02*G0_0_2 - 1.418967076519154e-02*G0_1_0 - 8.807381854256764e-03*G0_1_1 + 3.229373346560827e-02*G0_1_2 - 2.837934153038313e-02*G0_2_0 + 3.229373346560798e-02*G0_2_1 + 9.296680846159958e-02*G0_2_2;
    block[2780] = 6.523986558707965e-04*G0_0_1 + 1.272177378948252e-02*G0_0_2 + 6.523986558711571e-04*G0_1_0 + 1.304797311742179e-03*G0_1_1 + 6.523986558713835e-04*G0_1_2 + 1.272177378948177e-02*G0_2_0 + 6.523986558710416e-04*G0_2_1 - 8.807381854256779e-02*G0_2_2;
    block[2781] = 9.296680846159838e-02*G0_0_0 + 2.280133302268686e-01*G0_0_1 + 3.630598519921397e-01*G0_0_2 + 2.280133302268690e-01*G0_1_0 + 4.560266604537386e-01*G0_1_1 + 2.280133302268687e-01*G0_1_2 + 3.630598519921395e-01*G0_2_0 + 2.280133302268691e-01*G0_2_1 + 9.296680846159869e-02*G0_2_2;
    block[2782] = 1.957195967612580e-02*G0_0_0 + 5.382288910934611e-03*G0_0_1 - 5.529078608505707e-02*G0_0_2 + 5.382288910933881e-03*G0_1_0 - 8.807381854257191e-03*G0_1_1 - 4.110111531986551e-02*G0_1_2 - 5.529078608505696e-02*G0_2_0 - 4.110111531986498e-02*G0_2_1 + 1.957195967612610e-02*G0_2_2;
    block[2783] = -1.565756774090082e-01*G0_0_0 - 2.244251376195793e-01*G0_0_1 - 1.340679237814634e-01*G0_0_2 - 2.244251376195786e-01*G0_1_0 - 2.922745978301500e-01*G0_1_1 - 9.720739972475916e-02*G0_1_2 - 1.340679237814639e-01*G0_2_0 - 9.720739972475925e-02*G0_2_1 - 8.807381854256741e-02*G0_2_2;
    block[2784] = 1.304797311741667e-03*G0_0_0 + 6.523986558711055e-04*G0_0_1 - 1.076457782186922e-02*G0_0_2 + 6.523986558707582e-04*G0_1_0 + 1.304797311742227e-03*G0_1_2 - 1.076457782186947e-02*G0_2_0 + 1.304797311741326e-03*G0_2_1 - 2.283395295548067e-02*G0_2_2;
    block[2785] = 4.012251733605864e-02*G0_0_0 + 1.027527882996615e-02*G0_0_1 + 2.984723850609267e-02*G0_0_2 + 1.027527882996592e-02*G0_1_0 + 1.810406270041625e-02*G0_1_2 + 2.984723850609230e-02*G0_2_0 + 1.810406270041619e-02*G0_2_1 + 1.957195967612626e-02*G0_2_2;
    block[2786] = 5.023469650205722e-02*G0_0_0 + 5.545388574901970e-03*G0_0_1 + 3.816532136844566e-02*G0_0_2 + 5.545388574902103e-03*G0_1_0 + 6.197787230772496e-03*G0_1_2 + 3.816532136844585e-02*G0_2_0 + 6.197787230771898e-03*G0_2_1 + 2.609594623483441e-02*G0_2_2;
    block[2787] = -3.327233144941451e-02*G0_0_0 - 1.908266068422312e-02*G0_0_1 - 1.908266068422337e-02*G0_0_2 - 1.908266068422286e-02*G0_1_0 - 4.892989919031657e-03*G0_1_1 - 3.327233144941500e-02*G0_1_2 - 1.908266068422305e-02*G0_2_0 - 3.327233144941488e-02*G0_2_1 - 4.892989919031365e-03*G0_2_2;
    block[2788] = -8.807381854257071e-03*G0_0_0 - 4.110111531986509e-02*G0_0_1 + 5.382288910934851e-03*G0_0_2 - 4.110111531986491e-02*G0_1_0 + 1.957195967612649e-02*G0_1_1 - 5.529078608505581e-02*G0_1_2 + 5.382288910934349e-03*G0_2_0 - 5.529078608505641e-02*G0_2_1 + 1.957195967612608e-02*G0_2_2;
    block[2789] = -9.655500106888884e-02*G0_0_0 - 2.870554085831781e-02*G0_0_1 - 5.969447701218449e-02*G0_0_2 - 2.870554085831815e-02*G0_1_0 + 3.914391935225250e-02*G0_1_1 - 9.655500106888872e-02*G0_1_2 - 5.969447701218437e-02*G0_2_0 - 9.655500106888913e-02*G0_2_1 - 2.283395295548059e-02*G0_2_2;
    block[2790] = -2.681358475629268e-01*G0_0_0 - 3.216325373443383e-01*G0_0_1 - 2.906436011904718e-01*G0_0_2 - 3.216325373443383e-01*G0_1_0 - 5.845491956602994e-01*G0_1_1 - 4.488502752391583e-01*G0_1_2 - 2.221417423240304e-01*G0_2_0 - 1.944147994495185e-01*G0_2_1 - 2.681358475629273e-01*G0_2_2;
    block[2791] = -3.718672338464141e-02*G0_0_0 + 1.869122149070046e-01*G0_0_1 + 1.404288106762048e-01*G0_0_2 + 1.869122149070035e-01*G0_1_0 - 3.718672338464054e-02*G0_1_1 + 3.767602237654147e-02*G0_1_2 + 3.767602237654157e-02*G0_2_0 + 1.404288106762047e-01*G0_2_1 + 6.556606491502205e-02*G0_2_2;
    block[2792] = 1.722332451499106e-01*G0_0_0 + 6.197787230773107e-03*G0_0_1 - 2.642214556277067e-02*G0_0_2 + 6.197787230773380e-03*G0_1_0 + 1.239557446154633e-02*G0_1_1 + 6.197787230773150e-03*G0_1_2 + 7.143765281786051e-02*G0_2_0 + 6.197787230773544e-03*G0_2_1 - 1.370037177328903e-02*G0_2_2;
    block[2793] = 7.261197039842798e-01*G0_0_0 + 4.560266604537371e-01*G0_0_1 + 4.560266604537381e-01*G0_0_2 + 4.560266604537371e-01*G0_1_0 + 9.120533209074771e-01*G0_1_1 + 4.560266604537377e-01*G0_1_2 + 4.560266604537381e-01*G0_2_0 + 4.560266604537377e-01*G0_2_1 + 7.261197039842792e-01*G0_2_2;
    block[2794] = -4.481978765832886e-01*G0_0_0 - 2.240989382916441e-01*G0_0_1 - 1.213461499919815e-01*G0_0_2 - 2.240989382916428e-01*G0_1_0 - 3.718672338463873e-02*G0_1_1 - 7.486274576118197e-02*G0_1_2 - 3.268517265913057e-01*G0_2_0 - 1.776155340608447e-01*G0_2_1 - 1.497254915223645e-01*G0_2_2;
    block[2795] = -2.094199685345492e-01*G0_0_0 - 2.629166583159599e-01*G0_0_1 - 1.047099842672744e-01*G0_0_2 - 2.629166583159607e-01*G0_1_0 - 5.845491956602998e-01*G0_1_1 - 1.356989204211401e-01*G0_1_2 - 2.906436011904731e-01*G0_2_0 - 3.901343962107802e-01*G0_2_1 - 2.094199685345493e-01*G0_2_2;
    block[2796] = 3.522952741702699e-01*G0_0_0 + 2.495424858706080e-01*G0_0_1 + 2.495424858706072e-01*G0_0_2 + 2.495424858706065e-01*G0_1_0 - 3.914391935225369e-02*G0_1_1 + 4.452620826318688e-01*G0_1_2 + 2.495424858706072e-01*G0_2_0 + 4.452620826318689e-01*G0_2_1 + 1.467896975709442e-01*G0_2_2;
    block[2797] = -2.348635161135146e-01*G0_0_0 - 1.957195967612554e-02*G0_0_1 - 1.418967076519144e-01*G0_0_2 - 1.957195967612537e-02*G0_1_0 - 3.914391935225209e-02*G0_1_1 - 1.957195967612468e-02*G0_1_2 - 1.418967076519144e-01*G0_2_0 - 1.957195967612514e-02*G0_2_1 - 4.892989919031513e-02*G0_2_2;
    block[2798] = -1.859336169231975e-01*G0_0_0 - 2.886864052228610e-01*G0_0_1 - 4.844060019841213e-01*G0_0_2 - 2.886864052228601e-01*G0_1_0 - 3.914391935225097e-02*G0_1_1 - 4.844060019841209e-01*G0_1_2 - 4.844060019841212e-01*G0_2_0 - 4.844060019841216e-01*G0_2_1 - 7.828783870450452e-01*G0_2_2;
    block[2799] = -3.914391935225147e-02*G0_0_0 + 4.892989919032096e-03*G0_0_1 + 5.382288910934718e-02*G0_0_2 + 4.892989919032351e-03*G0_1_0 + 9.785979838063764e-03*G0_1_1 + 4.892989919031359e-03*G0_1_2 + 5.382288910934788e-02*G0_2_0 + 4.892989919032560e-03*G0_2_1 + 1.467896975709475e-01*G0_2_2;
    block[2800] = 1.174317580567563e-02*G0_0_0 + 1.174317580567563e-02*G0_0_1 + 1.174317580567562e-02*G0_0_2 + 1.174317580567568e-02*G0_1_0 + 1.174317580567572e-02*G0_1_1 + 1.174317580567567e-02*G0_1_2 + 9.464999699374517e-03*G0_2_0 + 9.464999699374524e-03*G0_2_1 + 9.464999699374475e-03*G0_2_2;
    block[2801] = -2.984723850609240e-02*G0_0_0 + 4.724671065816768e-03*G0_2_0;
    block[2802] = -2.984723850609242e-02*G0_1_1 + 4.724671065816796e-03*G0_2_1;
    block[2803] = -9.464999699374706e-03*G0_2_2;
    block[2804] = 1.766369360770384e-01*G0_0_0 + 4.227543290043244e-02*G0_0_1 + 4.227543290043265e-02*G0_1_0 + 4.932133838383804e-02*G0_2_0 + 4.296045148909684e-02*G0_2_1;
    block[2805] = -3.346805104617568e-01*G0_0_0 - 8.386584721220050e-02*G0_0_1 - 8.386584721220029e-02*G0_1_0 + 1.047099842672752e-01*G0_1_1 - 1.677316944244011e-01*G0_2_0 - 7.770067991422058e-02*G0_2_1;
    block[2806] = 1.047099842672746e-01*G0_0_0 - 8.386584721220053e-02*G0_0_1 - 8.386584721220060e-02*G0_1_0 - 3.346805104617571e-01*G0_1_1 - 7.770067991422061e-02*G0_2_0 - 1.677316944244009e-01*G0_2_1;
    block[2807] = 4.227543290043285e-02*G0_0_1 + 4.227543290043256e-02*G0_1_0 + 1.766369360770386e-01*G0_1_1 + 4.296045148909667e-02*G0_2_0 + 4.932133838383778e-02*G0_2_1;
    block[2808] = -4.227543290043286e-02*G0_0_1 - 4.227543290043258e-02*G0_1_0 + 4.397166940569655e-02*G0_1_1 - 4.227543290043263e-02*G0_1_2 - 4.296045148909670e-02*G0_2_0 - 6.850185886643739e-04*G0_2_1 - 4.296045148909668e-02*G0_2_2;
    block[2809] = 1.047099842672761e-01*G0_0_0 + 3.036915743078950e-02*G0_0_1 + 1.047099842672759e-01*G0_0_2 + 3.036915743078919e-02*G0_1_0 - 6.784946021056859e-03*G0_1_1 + 3.036915743078929e-02*G0_1_2 - 3.522952741702713e-03*G0_2_0 + 2.968413884212557e-03*G0_2_1 - 3.522952741702709e-03*G0_2_2;
    block[2810] = 5.675868306076521e-02*G0_0_0 + 3.787174197330355e-02*G0_0_1 + 5.675868306076524e-02*G0_0_2 + 3.787174197330389e-02*G0_1_0 + 1.278701365506874e-02*G0_1_1 + 3.787174197330388e-02*G0_1_2 + 1.898480088584209e-02*G0_2_0 + 9.492400442920811e-03*G0_2_1 + 1.898480088584221e-02*G0_2_2;
    block[2811] = -4.354761027938010e-02*G0_0_0 - 3.770864230933595e-02*G0_0_1 - 4.354761027938016e-02*G0_0_2 - 3.770864230933609e-02*G0_1_0 - 3.186967433929185e-02*G0_1_1 - 3.770864230933613e-02*G0_1_2 - 2.926007971580811e-02*G0_2_0 - 2.596546650366036e-02*G0_2_1 - 2.926007971580816e-02*G0_2_2;
    block[2812] = -3.186967433929189e-02*G0_0_0 - 3.770864230933607e-02*G0_0_1 - 3.770864230933607e-02*G0_0_2 - 3.770864230933634e-02*G0_1_0 - 4.354761027938045e-02*G0_1_1 - 4.354761027938051e-02*G0_1_2 - 2.596546650366038e-02*G0_2_0 - 2.926007971580821e-02*G0_2_1 - 2.926007971580815e-02*G0_2_2;
    block[2813] = 1.278701365506892e-02*G0_0_0 + 3.787174197330385e-02*G0_0_1 + 3.787174197330380e-02*G0_0_2 + 3.787174197330423e-02*G0_1_0 + 5.675868306076556e-02*G0_1_1 + 5.675868306076559e-02*G0_1_2 + 9.492400442920945e-03*G0_2_0 + 1.898480088584203e-02*G0_2_1 + 1.898480088584206e-02*G0_2_2;
    block[2814] = -6.784946021057062e-03*G0_0_0 + 3.036915743078924e-02*G0_0_1 + 3.036915743078933e-02*G0_0_2 + 3.036915743078879e-02*G0_1_0 + 1.047099842672748e-01*G0_1_1 + 1.047099842672748e-01*G0_1_2 + 2.968413884212439e-03*G0_2_0 - 3.522952741702593e-03*G0_2_1 - 3.522952741702625e-03*G0_2_2;
    block[2815] = 4.397166940569690e-02*G0_0_0 - 4.227543290043236e-02*G0_0_1 - 4.227543290043234e-02*G0_0_2 - 4.227543290043217e-02*G0_1_0 - 6.850185886642602e-04*G0_2_0 - 4.296045148909675e-02*G0_2_1 - 4.296045148909673e-02*G0_2_2;
    block[2816] = -9.133581182192155e-03*G0_0_0 - 9.133581182192119e-03*G0_0_1 - 3.294613212147951e-03*G0_0_2 - 9.133581182191987e-03*G0_1_0 - 9.133581182192032e-03*G0_1_1 - 3.294613212147916e-03*G0_1_2 - 3.294613212147628e-03*G0_2_0 - 3.294613212147632e-03*G0_2_1;
    block[2817] = -1.565756774090102e-02*G0_0_0 - 1.565756774090095e-02*G0_0_1 - 2.576974690689892e-03*G0_0_2 - 1.565756774090074e-02*G0_1_0 - 1.565756774090069e-02*G0_1_1 - 2.576974690689929e-03*G0_1_2 - 2.576974690690138e-03*G0_2_0 - 2.576974690690128e-03*G0_2_1;
    block[2818] = -6.523986558708573e-04*G0_0_0 - 6.523986558708746e-04*G0_0_1 - 2.576974690689919e-03*G0_0_2 - 6.523986558711664e-04*G0_1_0 - 6.523986558711681e-04*G0_1_1 - 2.576974690690033e-03*G0_1_2 - 2.576974690689892e-03*G0_2_0 - 2.576974690689875e-03*G0_2_1;
    block[2819] = -3.294613212147882e-03*G0_0_2 - 3.294613212147789e-03*G0_1_2 - 3.294613212147884e-03*G0_2_0 - 3.294613212147873e-03*G0_2_1;
    block[2820] = 6.426126760328080e-02*G0_0_0 + 4.227543290043235e-02*G0_0_2 + 4.227543290043259e-02*G0_2_0 + 4.296045148909677e-02*G0_2_2;
    block[2821] = 8.807381854256753e-03*G0_0_0 + 6.491366625915199e-03*G0_0_2 + 6.491366625915162e-03*G0_2_0 + 3.522952741703030e-03*G0_2_2;
    block[2822] = -6.523986558710051e-04*G0_0_0 - 9.492400442921392e-03*G0_0_2 - 9.492400442920934e-03*G0_2_0 - 1.898480088584244e-02*G0_2_2;
    block[2823] = 3.294613212147985e-03*G0_0_2 + 3.294613212147849e-03*G0_2_0 + 2.926007971580876e-02*G0_2_2;
    block[2824] = 6.426126760328070e-02*G0_1_1 + 4.227543290043249e-02*G0_1_2 + 4.227543290043238e-02*G0_2_1 + 4.296045148909674e-02*G0_2_2;
    block[2825] = 8.807381854256854e-03*G0_1_1 + 6.491366625915168e-03*G0_1_2 + 6.491366625915420e-03*G0_2_1 + 3.522952741703198e-03*G0_2_2;
    block[2826] = -6.523986558710374e-04*G0_1_1 - 9.492400442921290e-03*G0_1_2 - 9.492400442921309e-03*G0_2_1 - 1.898480088584271e-02*G0_2_2;
    block[2827] = 3.294613212147764e-03*G0_1_2 + 3.294613212147886e-03*G0_2_1 + 2.926007971580876e-02*G0_2_2;
    block[2828] = -1.565756774090094e-01*G0_0_0 + 6.784946021057014e-02*G0_0_1 - 2.250775362754553e-02*G0_0_2 + 6.784946021057062e-02*G0_1_0 + 1.047099842672754e-01*G0_1_2 - 2.250775362754484e-02*G0_2_0 + 1.047099842672750e-01*G0_2_1 + 2.348635161135142e-02*G0_2_2;
    block[2829] = 1.957195967612633e-02*G0_0_0 + 1.418967076519133e-02*G0_0_1 + 7.486274576118253e-02*G0_0_2 + 1.418967076519182e-02*G0_1_0 + 2.837934153038263e-02*G0_1_2 + 7.486274576118282e-02*G0_2_0 + 2.837934153038342e-02*G0_2_1 + 1.497254915223654e-01*G0_2_2;
    block[2830] = -6.523986558708195e-04*G0_0_1 - 1.272177378948186e-02*G0_0_2 - 6.523986558709882e-04*G0_1_0 - 1.272177378948169e-02*G0_1_2 - 1.272177378948197e-02*G0_2_0 - 1.272177378948156e-02*G0_2_1 - 1.135173661215316e-01*G0_2_2;
    block[2831] = 9.296680846159980e-02*G0_0_0 - 1.350465217652699e-01*G0_0_1 - 2.700930435305404e-01*G0_0_2 - 1.350465217652700e-01*G0_1_0 + 9.296680846160003e-02*G0_1_1 - 2.700930435305403e-01*G0_1_2 - 2.700930435305407e-01*G0_2_0 - 2.700930435305406e-01*G0_2_1 - 5.401860870610806e-01*G0_2_2;
    block[2832] = 1.418967076519177e-02*G0_0_1 + 2.837934153038305e-02*G0_0_2 + 1.418967076519096e-02*G0_1_0 + 1.957195967612569e-02*G0_1_1 + 7.486274576118215e-02*G0_1_2 + 2.837934153038284e-02*G0_2_0 + 7.486274576118206e-02*G0_2_1 + 1.497254915223651e-01*G0_2_2;
    block[2833] = 6.784946021057094e-02*G0_0_1 + 1.047099842672757e-01*G0_0_2 + 6.784946021057071e-02*G0_1_0 - 1.565756774090094e-01*G0_1_1 - 2.250775362754499e-02*G0_1_2 + 1.047099842672752e-01*G0_2_0 - 2.250775362754457e-02*G0_2_1 + 2.348635161135137e-02*G0_2_2;
    block[2834] = -6.784946021057174e-02*G0_0_1 - 1.047099842672758e-01*G0_0_2 - 6.784946021057081e-02*G0_1_0 - 9.655500106888884e-02*G0_1_1 - 3.686052405670415e-02*G0_1_2 - 1.047099842672752e-01*G0_2_0 - 3.686052405670407e-02*G0_2_1;
    block[2835] = -1.418967076519144e-02*G0_0_1 - 2.837934153038270e-02*G0_0_2 - 1.418967076519098e-02*G0_1_0 - 3.327233144941474e-02*G0_1_1 - 1.418967076519103e-02*G0_1_2 - 2.837934153038290e-02*G0_2_0 - 1.418967076519168e-02*G0_2_1;
    block[2836] = 6.523986558710773e-04*G0_0_1 + 1.272177378948178e-02*G0_0_2 + 6.523986558711069e-04*G0_1_0 + 1.304797311742189e-03*G0_1_1 + 1.206937513361111e-02*G0_1_2 + 1.272177378948209e-02*G0_2_0 + 1.206937513361130e-02*G0_2_1;
    block[2837] = 9.296680846160031e-02*G0_0_0 + 3.229373346560907e-02*G0_0_1 - 2.837934153038270e-02*G0_0_2 + 3.229373346560766e-02*G0_1_0 - 8.807381854256639e-03*G0_1_1 - 1.418967076519160e-02*G0_1_2 - 2.837934153038290e-02*G0_2_0 - 1.418967076519157e-02*G0_2_1;
    block[2838] = 1.957195967612619e-02*G0_0_0 + 2.984723850609239e-02*G0_0_1 + 1.810406270041668e-02*G0_0_2 + 2.984723850609259e-02*G0_1_0 + 4.012251733605866e-02*G0_1_1 + 1.027527882996614e-02*G0_1_2 + 1.810406270041669e-02*G0_2_0 + 1.027527882996629e-02*G0_2_1;
    block[2839] = 3.914391935225205e-02*G0_0_0 + 4.468930792715447e-02*G0_0_1 + 1.272177378948173e-02*G0_0_2 + 4.468930792715473e-02*G0_1_0 + 5.023469650205670e-02*G0_1_1 + 1.206937513361114e-02*G0_1_2 + 1.272177378948233e-02*G0_2_0 + 1.206937513361105e-02*G0_2_1;
    block[2840] = 1.304797311741962e-03*G0_0_0 + 6.523986558709390e-04*G0_0_1 + 1.206937513361105e-02*G0_0_2 + 6.523986558709416e-04*G0_1_0 + 1.272177378948225e-02*G0_1_2 + 1.206937513361094e-02*G0_2_0 + 1.272177378948168e-02*G0_2_1;
    block[2841] = -3.327233144941450e-02*G0_0_0 - 1.418967076519128e-02*G0_0_1 - 1.418967076519140e-02*G0_0_2 - 1.418967076519171e-02*G0_1_0 - 2.837934153038351e-02*G0_1_2 - 1.418967076519146e-02*G0_2_0 - 2.837934153038340e-02*G0_2_1;
    block[2842] = -9.655500106888941e-02*G0_0_0 - 6.784946021057030e-02*G0_0_1 - 3.686052405670442e-02*G0_0_2 - 6.784946021057092e-02*G0_1_0 - 1.047099842672747e-01*G0_1_2 - 3.686052405670462e-02*G0_2_0 - 1.047099842672753e-01*G0_2_1;
    block[2843] = 4.012251733605875e-02*G0_0_0 + 2.984723850609218e-02*G0_0_1 + 1.027527882996619e-02*G0_0_2 + 2.984723850609258e-02*G0_1_0 + 1.957195967612653e-02*G0_1_1 + 1.810406270041647e-02*G0_1_2 + 1.027527882996630e-02*G0_2_0 + 1.810406270041654e-02*G0_2_1;
    block[2844] = -8.807381854256120e-03*G0_0_0 + 3.229373346560867e-02*G0_0_1 - 1.418967076519121e-02*G0_0_2 + 3.229373346560884e-02*G0_1_0 + 9.296680846159915e-02*G0_1_1 - 2.837934153038258e-02*G0_1_2 - 1.418967076519096e-02*G0_2_0 - 2.837934153038226e-02*G0_2_1;
    block[2845] = 5.023469650205685e-02*G0_0_0 + 4.468930792715429e-02*G0_0_1 + 1.206937513361099e-02*G0_0_2 + 4.468930792715400e-02*G0_1_0 + 3.914391935225219e-02*G0_1_1 + 1.272177378948196e-02*G0_1_2 + 1.206937513361070e-02*G0_2_0 + 1.272177378948195e-02*G0_2_1;
    block[2846] = 1.722332451499088e-01*G0_0_0 + 1.660354579191356e-01*G0_0_1 + 1.986553907126792e-01*G0_0_2 + 1.660354579191357e-01*G0_1_0 + 1.722332451499090e-01*G0_1_1 + 1.986553907126793e-01*G0_1_2 + 1.007955923320486e-01*G0_2_0 + 1.007955923320490e-01*G0_2_1 + 1.135173661215312e-01*G0_2_2;
    block[2847] = -3.718672338463772e-02*G0_0_0 - 2.240989382916437e-01*G0_0_1 - 1.776155340608439e-01*G0_0_2 - 2.240989382916434e-01*G0_1_0 - 4.481978765832881e-01*G0_1_1 - 3.268517265913071e-01*G0_1_2 - 7.486274576118129e-02*G0_2_0 - 1.213461499919813e-01*G0_2_1 - 1.497254915223640e-01*G0_2_2;
    block[2848] = -2.681358475629293e-01*G0_0_0 + 5.349668978141114e-02*G0_0_1 + 2.250775362754513e-02*G0_0_2 + 5.349668978141112e-02*G0_1_0 - 2.094199685345502e-01*G0_1_1 - 1.047099842672754e-01*G0_1_2 - 4.599410523889711e-02*G0_2_0 + 8.122363265592315e-02*G0_2_1 - 2.348635161135185e-02*G0_2_2;
    block[2849] = -4.481978765832886e-01*G0_0_0 - 2.240989382916428e-01*G0_0_1 - 3.268517265913057e-01*G0_0_2 - 2.240989382916441e-01*G0_1_0 - 3.718672338463870e-02*G0_1_1 - 1.776155340608447e-01*G0_1_2 - 1.213461499919815e-01*G0_2_0 - 7.486274576118196e-02*G0_2_1 - 1.497254915223645e-01*G0_2_2;
    block[2850] = 7.261197039842799e-01*G0_0_0 + 2.700930435305404e-01*G0_0_1 + 2.700930435305404e-01*G0_0_2 + 2.700930435305404e-01*G0_1_0 + 7.261197039842803e-01*G0_1_1 + 2.700930435305402e-01*G0_1_2 + 2.700930435305404e-01*G0_2_0 + 2.700930435305402e-01*G0_2_1 + 5.401860870610808e-01*G0_2_2;
    block[2851] = -2.094199685345505e-01*G0_0_0 + 5.349668978141037e-02*G0_0_1 - 1.047099842672756e-01*G0_0_2 + 5.349668978141141e-02*G0_1_0 - 2.681358475629283e-01*G0_1_1 + 2.250775362754504e-02*G0_1_2 + 8.122363265592322e-02*G0_2_0 - 4.599410523889650e-02*G0_2_1 - 2.348635161135148e-02*G0_2_2;
    block[2852] = -2.348635161135144e-01*G0_0_0 - 2.152915564373875e-01*G0_0_1 - 9.296680846159874e-02*G0_0_2 - 2.152915564373883e-01*G0_1_0 - 2.348635161135147e-01*G0_1_1 - 9.296680846159837e-02*G0_1_2 - 9.296680846159971e-02*G0_2_0 - 9.296680846159995e-02*G0_2_1;
    block[2853] = 3.522952741702721e-01*G0_0_0 + 1.027527882996617e-01*G0_0_1 + 1.027527882996621e-01*G0_0_2 + 1.027527882996629e-01*G0_1_0 - 1.859336169231992e-01*G0_1_1 + 2.984723850609245e-01*G0_1_2 + 1.027527882996622e-01*G0_2_0 + 2.984723850609234e-01*G0_2_1;
    block[2854] = -1.859336169232002e-01*G0_0_0 + 1.027527882996620e-01*G0_0_1 + 2.984723850609226e-01*G0_0_2 + 1.027527882996625e-01*G0_1_0 + 3.522952741702720e-01*G0_1_1 + 1.027527882996625e-01*G0_1_2 + 2.984723850609239e-01*G0_2_0 + 1.027527882996623e-01*G0_2_1;
    block[2855] = -3.914391935225249e-02*G0_0_0 - 4.403690927128405e-02*G0_0_1 - 9.296680846159901e-02*G0_0_2 - 4.403690927128449e-02*G0_1_0 - 3.914391935225205e-02*G0_1_1 - 9.296680846159942e-02*G0_1_2 - 9.296680846159977e-02*G0_2_0 - 9.296680846159881e-02*G0_2_1;
    block[2856] = 1.891956102025521e-02*G0_0_0 + 1.891956102025525e-02*G0_0_1 + 1.891956102025521e-02*G0_0_2 + 1.891956102025516e-02*G0_1_0 + 1.891956102025519e-02*G0_1_1 + 1.891956102025518e-02*G0_1_2 + 1.374212528726394e-02*G0_2_0 + 1.374212528726399e-02*G0_2_1 + 1.374212528726395e-02*G0_2_2;
    block[2857] = 1.891956102025532e-02*G0_0_0 + 5.177435732991287e-03*G0_2_0;
    block[2858] = 3.359853077734996e-02*G0_1_1 - 1.439452394313488e-02*G0_2_1;
    block[2859] = -1.374212528726414e-02*G0_2_2;
    block[2860] = -1.118863694818545e-01*G0_0_0 - 2.126819618139047e-02*G0_0_1 - 2.126819618139079e-02*G0_1_0 - 4.775558160974790e-02*G0_2_0 - 1.187365553684979e-02*G0_2_1;
    block[2861] = 2.094199685345497e-01*G0_0_0 + 3.594716593848513e-02*G0_0_1 + 3.594716593848558e-02*G0_1_0 - 5.284429112554030e-02*G0_1_1 + 8.233271037090441e-02*G0_2_0 - 1.826716236438377e-03*G0_2_1;
    block[2862] = -2.713978408422825e-01*G0_0_0 - 7.332960891988620e-02*G0_0_1 - 7.332960891988637e-02*G0_1_0 + 1.213461499919817e-01*G0_1_1 - 1.466592178397724e-01*G0_2_0 - 1.096029741863095e-02*G0_2_1;
    block[2863] = -9.629404160654055e-02*G0_0_1 - 9.629404160654007e-02*G0_1_0 - 2.570450704131226e-01*G0_1_1 - 1.247386230025102e-01*G0_2_0 - 1.925880832130808e-01*G0_2_1;
    block[2864] = 9.629404160654105e-02*G0_0_1 + 9.629404160654007e-02*G0_1_0 - 6.445698720004196e-02*G0_1_1 + 9.629404160654012e-02*G0_1_2 + 1.247386230025102e-01*G0_2_0 + 2.844458139597013e-02*G0_2_1 + 1.247386230025102e-01*G0_2_2;
    block[2865] = -2.713978408422831e-01*G0_0_0 - 1.980682319223969e-01*G0_0_1 - 2.713978408422831e-01*G0_0_2 - 1.980682319223961e-01*G0_1_0 - 3.392473010528434e-03*G0_1_1 - 1.980682319223962e-01*G0_1_2 - 1.247386230025104e-01*G0_2_0 - 6.236931150125520e-02*G0_2_1 - 1.247386230025102e-01*G0_2_2;
    block[2866] = 2.094199685345497e-01*G0_0_0 + 1.734728025960646e-01*G0_0_1 + 2.094199685345497e-01*G0_0_2 + 1.734728025960637e-01*G0_1_0 + 8.468134553203868e-02*G0_1_1 + 1.734728025960638e-01*G0_1_2 + 1.270872581636452e-01*G0_2_0 + 8.931337598872190e-02*G0_2_1 + 1.270872581636452e-01*G0_2_2;
    block[2867] = -1.118863694818543e-01*G0_0_0 - 9.061817330046384e-02*G0_0_1 - 1.118863694818542e-01*G0_0_2 - 9.061817330046351e-02*G0_1_0 - 6.934997711907326e-02*G0_1_1 - 9.061817330046350e-02*G0_1_2 - 6.413078787210635e-02*G0_2_0 - 5.473624722756582e-02*G0_2_1 - 6.413078787210633e-02*G0_2_2;
    block[2868] = -1.878908128908098e-02*G0_0_0 - 4.005727747047151e-02*G0_0_1 - 4.005727747047149e-02*G0_0_2 - 4.005727747047135e-02*G0_1_0 - 6.132547365186182e-02*G0_1_1 - 6.132547365186176e-02*G0_1_2 - 9.394540644540466e-03*G0_2_0 - 1.878908128908116e-02*G0_2_1 - 1.878908128908108e-02*G0_2_2;
    block[2869] = -1.304797311740404e-04*G0_0_0 + 1.363513190770139e-02*G0_0_1 + 1.363513190770144e-02*G0_0_2 + 1.363513190770125e-02*G0_1_0 - 2.544354757896372e-02*G0_1_1 - 2.544354757896372e-02*G0_1_2 - 6.523986558693094e-05*G0_2_0 + 1.487468935385602e-02*G0_2_1 + 1.487468935385605e-02*G0_2_2;
    block[2870] = -1.304797311744739e-04*G0_0_0 - 1.376561163887556e-02*G0_0_1 - 1.376561163887560e-02*G0_0_2 - 1.376561163887554e-02*G0_1_0 - 5.284429112554055e-02*G0_1_1 - 5.284429112554062e-02*G0_1_2 - 6.523986558745523e-05*G0_2_0 + 1.174317580567391e-03*G0_2_1 + 1.174317580567385e-03*G0_2_2;
    block[2871] = -1.878908128908100e-02*G0_0_0 + 2.126819618139039e-02*G0_0_1 + 2.126819618139036e-02*G0_0_2 + 2.126819618139028e-02*G0_1_0 - 9.394540644540480e-03*G0_2_0 + 1.187365553684968e-02*G0_2_1 + 1.187365553684973e-02*G0_2_2;
    block[2872] = -3.066273682593087e-02*G0_0_0 - 3.066273682593089e-02*G0_0_1 - 9.394540644540495e-03*G0_0_2 - 3.066273682593087e-02*G0_1_0 - 3.066273682593093e-02*G0_1_1 - 9.394540644540516e-03*G0_1_2 - 9.394540644540489e-03*G0_2_0 - 9.394540644540558e-03*G0_2_1;
    block[2873] = -1.304797311741643e-03*G0_0_0 - 1.304797311741628e-03*G0_0_1 - 6.523986558704642e-05*G0_0_2 - 1.304797311741758e-03*G0_1_0 - 1.304797311741709e-03*G0_1_1 - 6.523986558701027e-05*G0_1_2 - 6.523986558703432e-05*G0_2_0 - 6.523986558693784e-05*G0_2_1;
    block[2874] = -1.500516908503026e-02*G0_0_0 - 1.500516908503024e-02*G0_0_1 - 6.523986558722411e-05*G0_0_2 - 1.500516908502992e-02*G0_1_0 - 1.500516908502992e-02*G0_1_1 - 6.523986558712195e-05*G0_1_2 - 6.523986558702587e-05*G0_2_0 - 6.523986558705799e-05*G0_2_1;
    block[2875] = -9.394540644540405e-03*G0_0_2 - 9.394540644540478e-03*G0_1_2 - 9.394540644540509e-03*G0_2_0 - 9.394540644540532e-03*G0_2_1;
    block[2876] = -3.066273682593099e-02*G0_0_0 - 2.126819618139041e-02*G0_0_2 - 2.126819618139042e-02*G0_2_0 - 1.187365553684978e-02*G0_2_2;
    block[2877] = -1.304797311741925e-03*G0_0_0 - 1.239557446154867e-03*G0_0_2 - 1.239557446154845e-03*G0_2_0 - 1.174317580568089e-03*G0_2_2;
    block[2878] = -1.500516908502995e-02*G0_0_0 - 1.493992921944282e-02*G0_0_2 - 1.493992921944309e-02*G0_2_0 - 1.487468935385586e-02*G0_2_2;
    block[2879] = 9.394540644540473e-03*G0_0_2 + 9.394540644540495e-03*G0_2_0 + 1.878908128908111e-02*G0_2_2;
    block[2880] = -1.285225352065609e-01*G0_1_1 - 9.629404160653995e-02*G0_1_2 - 9.629404160654008e-02*G0_2_1 - 1.247386230025102e-01*G0_2_2;
    block[2881] = 4.762510187857304e-02*G0_1_1 + 6.236931150125484e-02*G0_1_2 + 6.236931150125474e-02*G0_2_1 + 1.247386230025103e-01*G0_2_2;
    block[2882] = -1.500516908502948e-02*G0_1_1 - 3.777388217492293e-02*G0_1_2 - 3.777388217492323e-02*G0_2_1 - 1.270872581636458e-01*G0_2_2;
    block[2883] = 9.394540644540436e-03*G0_1_2 + 9.394540644540489e-03*G0_2_1 + 6.413078787210691e-02*G0_2_2;
    block[2884] = 5.219189246966938e-02*G0_0_0 - 3.783912204051084e-02*G0_0_1 - 6.523986558707260e-04*G0_0_2 - 3.783912204051080e-02*G0_1_0 - 5.284429112554072e-02*G0_1_2 - 6.523986558711986e-04*G0_2_0 - 5.284429112554086e-02*G0_2_1 - 5.349668978141135e-02*G0_2_2;
    block[2885] = 2.609594623483523e-02*G0_0_0 - 1.206937513361119e-02*G0_0_1 + 1.989815900406177e-02*G0_0_2 - 1.206937513361133e-02*G0_1_0 - 1.272177378948219e-02*G0_1_2 + 1.989815900406174e-02*G0_2_0 - 1.272177378948252e-02*G0_2_1 + 1.370037177328857e-02*G0_2_2;
    block[2886] = -1.500516908503008e-02*G0_0_1 - 5.284429112554081e-02*G0_0_2 - 1.500516908502984e-02*G0_1_0 - 3.001033817005998e-02*G0_1_2 - 5.284429112554018e-02*G0_2_0 - 3.001033817005995e-02*G0_2_1 - 1.056885822510813e-01*G0_2_2;
    block[2887] = -1.859336169231980e-01*G0_0_0 + 9.133581182192745e-03*G0_0_1 - 8.122363265592364e-02*G0_0_2 + 9.133581182191835e-03*G0_1_0 - 8.807381854256773e-02*G0_1_1 + 4.599410523889614e-02*G0_1_2 - 8.122363265592336e-02*G0_2_0 + 4.599410523889696e-02*G0_2_1 + 2.348635161135111e-02*G0_2_2;
    block[2888] = 3.686052405670420e-02*G0_0_1 + 1.047099842672748e-01*G0_0_2 + 3.686052405670443e-02*G0_1_0 - 2.283395295547979e-02*G0_1_1 + 7.372104811340843e-02*G0_1_2 + 1.047099842672745e-01*G0_2_0 + 7.372104811340931e-02*G0_2_1 + 2.094199685345500e-01*G0_2_2;
    block[2889] = -1.356989204211417e-01*G0_0_1 - 2.713978408422826e-01*G0_0_2 - 1.356989204211402e-01*G0_1_0 + 5.219189246967008e-02*G0_1_1 - 2.713978408422812e-01*G0_1_2 - 2.713978408422820e-01*G0_2_0 - 2.713978408422830e-01*G0_2_1 - 5.427956816845647e-01*G0_2_2;
    block[2890] = 1.356989204211416e-01*G0_0_1 + 2.713978408422831e-01*G0_0_2 + 1.356989204211402e-01*G0_1_0 + 3.235897333119513e-01*G0_1_1 + 1.356989204211411e-01*G0_1_2 + 2.713978408422820e-01*G0_2_0 + 1.356989204211403e-01*G0_2_1;
    block[2891] = -3.686052405670463e-02*G0_0_1 - 1.047099842672751e-01*G0_0_2 - 3.686052405670441e-02*G0_1_0 - 9.655500106888899e-02*G0_1_1 - 6.784946021057126e-02*G0_1_2 - 1.047099842672745e-01*G0_2_0 - 6.784946021057017e-02*G0_2_1;
    block[2892] = 1.500516908503029e-02*G0_0_1 + 5.284429112554051e-02*G0_0_2 + 1.500516908502978e-02*G0_1_0 + 3.001033817005942e-02*G0_1_1 + 3.783912204051026e-02*G0_1_2 + 5.284429112554008e-02*G0_2_0 + 3.783912204051025e-02*G0_2_1;
    block[2893] = -1.859336169231985e-01*G0_0_0 - 1.950671981053905e-01*G0_0_1 - 1.047099842672744e-01*G0_0_2 - 1.950671981053894e-01*G0_1_0 - 2.922745978301499e-01*G0_1_1 - 6.784946021056967e-02*G0_1_2 - 1.047099842672745e-01*G0_2_0 - 6.784946021056971e-02*G0_2_1;
    block[2894] = 2.609594623483523e-02*G0_0_0 + 3.816532136844631e-02*G0_0_1 + 6.197787230773650e-03*G0_0_2 + 3.816532136844679e-02*G0_1_0 + 5.023469650205764e-02*G0_1_1 + 5.545388574903076e-03*G0_1_2 + 6.197787230773693e-03*G0_2_0 + 5.545388574902289e-03*G0_2_1;
    block[2895] = 5.219189246966920e-02*G0_0_0 + 9.003101451017988e-02*G0_0_1 + 5.284429112554009e-02*G0_0_2 + 9.003101451017910e-02*G0_1_0 + 1.278701365506903e-01*G0_1_1 + 3.783912204050986e-02*G0_1_2 + 5.284429112553973e-02*G0_2_0 + 3.783912204050999e-02*G0_2_1;
    block[2896] = 3.001033817006027e-02*G0_0_0 + 1.500516908503003e-02*G0_0_1 + 1.500516908503016e-02*G0_0_2 + 1.500516908503006e-02*G0_1_0 + 3.001033817006006e-02*G0_1_2 + 1.500516908503015e-02*G0_2_0 + 3.001033817006006e-02*G0_2_1;
    block[2897] = 1.304797311741723e-03*G0_0_0 + 1.206937513361113e-02*G0_0_1 + 6.523986558706820e-04*G0_0_2 + 1.206937513361187e-02*G0_1_0 + 1.272177378948248e-02*G0_1_2 + 6.523986558716613e-04*G0_2_0 + 1.272177378948232e-02*G0_2_1;
    block[2898] = 3.001033817006022e-02*G0_0_0 + 3.783912204051093e-02*G0_0_1 + 1.500516908503051e-02*G0_0_2 + 3.783912204051084e-02*G0_1_0 + 5.284429112554116e-02*G0_1_2 + 1.500516908502997e-02*G0_2_0 + 5.284429112554116e-02*G0_2_1;
    block[2899] = 1.304797311741774e-03*G0_0_0 - 1.076457782186916e-02*G0_0_1 + 6.523986558708614e-04*G0_0_2 - 1.076457782186984e-02*G0_1_0 - 2.283395295548083e-02*G0_1_1 + 1.304797311741982e-03*G0_1_2 + 6.523986558702779e-04*G0_2_0 + 1.304797311741515e-03*G0_2_1;
    block[2900] = 1.304797311741806e-03*G0_0_0 + 6.523986558708529e-04*G0_0_1 + 6.523986558707457e-04*G0_0_2 + 6.523986558707105e-04*G0_1_0 - 8.807381854256797e-02*G0_1_1 + 1.272177378948137e-02*G0_1_2 + 6.523986558710226e-04*G0_2_0 + 1.272177378948183e-02*G0_2_1;
    block[2901] = 3.001033817005994e-02*G0_0_0 - 7.828783870450436e-03*G0_0_1 + 1.500516908502999e-02*G0_0_2 - 7.828783870450438e-03*G0_1_0 - 4.566790591096111e-02*G0_1_1 + 3.001033817005992e-02*G0_1_2 + 1.500516908503001e-02*G0_2_0 + 3.001033817006010e-02*G0_2_1;
    block[2902] = 1.056885822510805e-01*G0_0_0 + 1.278701365506903e-01*G0_0_1 + 1.050361835952097e-01*G0_0_2 + 1.278701365506900e-01*G0_1_0 + 2.557402731013810e-01*G0_1_1 + 1.800620290203596e-01*G0_1_2 + 5.284429112553987e-02*G0_2_0 + 7.567824408102045e-02*G0_2_1 + 1.056885822510802e-01*G0_2_2;
    block[2903] = 1.239557446154695e-02*G0_0_0 + 6.197787230773061e-03*G0_0_1 + 6.197787230773222e-03*G0_0_2 + 6.197787230773933e-03*G0_1_0 + 1.722332451499101e-01*G0_1_1 + 7.143765281786126e-02*G0_1_2 + 6.197787230774026e-03*G0_2_0 - 2.642214556277029e-02*G0_2_1 - 1.370037177328794e-02*G0_2_2;
    block[2904] = 1.056885822510814e-01*G0_0_0 - 2.218155429960934e-02*G0_0_1 + 6.523986558712458e-04*G0_0_2 - 2.218155429960948e-02*G0_1_0 + 1.056885822510813e-01*G0_1_1 + 5.284429112554109e-02*G0_1_2 + 5.284429112554038e-02*G0_2_0 + 6.523986558711465e-04*G0_2_1 + 5.349668978141162e-02*G0_2_2;
    block[2905] = -2.094199685345492e-01*G0_0_0 - 2.629166583159607e-01*G0_0_1 - 2.906436011904731e-01*G0_0_2 - 2.629166583159599e-01*G0_1_0 - 5.845491956602998e-01*G0_1_1 - 3.901343962107802e-01*G0_1_2 - 1.047099842672743e-01*G0_2_0 - 1.356989204211400e-01*G0_2_1 - 2.094199685345493e-01*G0_2_2;
    block[2906] = -2.094199685345504e-01*G0_0_0 + 5.349668978141141e-02*G0_0_1 + 8.122363265592321e-02*G0_0_2 + 5.349668978141038e-02*G0_1_0 - 2.681358475629283e-01*G0_1_1 - 4.599410523889651e-02*G0_1_2 - 1.047099842672756e-01*G0_2_0 + 2.250775362754504e-02*G0_2_1 - 2.348635161135150e-02*G0_2_2;
    block[2907] = 5.427956816845659e-01*G0_0_0 + 2.713978408422825e-01*G0_0_1 + 2.713978408422828e-01*G0_0_2 + 2.713978408422825e-01*G0_1_0 + 6.471794666239034e-01*G0_1_1 + 2.713978408422815e-01*G0_1_2 + 2.713978408422828e-01*G0_2_0 + 2.713978408422814e-01*G0_2_1 + 5.427956816845649e-01*G0_2_2;
    block[2908] = -5.219189246966861e-02*G0_0_0 - 4.240591263160651e-02*G0_0_1 - 2.609594623483382e-02*G0_0_2 - 4.240591263160474e-02*G0_1_0 + 1.435277042915938e-01*G0_1_1 - 7.502584542514910e-02*G0_1_2 - 2.609594623483435e-02*G0_2_0 - 7.502584542515052e-02*G0_2_1;
    block[2909] = -5.219189246967012e-02*G0_0_0 - 9.785979838063704e-03*G0_0_1 - 2.609594623483536e-02*G0_0_2 - 9.785979838063492e-03*G0_1_0 + 1.761476370851357e-01*G0_1_1 - 5.871587902837919e-02*G0_1_2 - 2.609594623483413e-02*G0_2_0 - 5.871587902837905e-02*G0_2_1;
    block[2910] = 3.718672338463967e-01*G0_0_0 + 1.859336169231986e-01*G0_0_1 + 1.859336169231983e-01*G0_0_2 + 1.859336169231974e-01*G0_1_0 - 1.500516908503026e-01*G0_1_1 + 3.164133480973715e-01*G0_1_2 + 1.859336169231977e-01*G0_2_0 + 3.164133480973735e-01*G0_2_1;
    block[2911] = -5.219189246967072e-02*G0_0_0 - 2.609594623483500e-02*G0_0_1 - 2.609594623483533e-02*G0_0_2 - 2.609594623483560e-02*G0_1_0 + 4.566790591096047e-02*G0_1_1 - 7.502584542515066e-02*G0_1_2 - 2.609594623483575e-02*G0_2_0 - 7.502584542515064e-02*G0_2_1;
    block[2912] = -7.828783870450448e-02*G0_0_0 - 7.828783870450451e-02*G0_0_1 - 7.828783870450444e-02*G0_0_2 - 7.828783870450465e-02*G0_1_0 - 7.828783870450465e-02*G0_1_1 - 7.828783870450466e-02*G0_1_2 - 7.828783870450459e-02*G0_2_0 - 7.828783870450469e-02*G0_2_1 - 7.828783870450456e-02*G0_2_2;
    block[2913] = 4.403690927128379e-02*G0_0_0;
    block[2914] = 4.403690927128374e-02*G0_1_1;
    block[2915] = 4.403690927128397e-02*G0_2_2;
    block[2916] = -5.056089582999240e-02*G0_0_0 - 2.609594623483388e-03*G0_0_1 - 2.609594623482571e-03*G0_1_0;
    block[2917] = 3.914391935225253e-02*G0_0_0 + 3.196753413767333e-02*G0_0_1 + 3.196753413767210e-02*G0_1_0 + 2.609594623483428e-02*G0_1_1;
    block[2918] = 2.609594623483513e-02*G0_0_0 + 3.196753413767281e-02*G0_0_1 + 3.196753413767407e-02*G0_1_0 + 3.914391935225368e-02*G0_1_1;
    block[2919] = -2.609594623484057e-03*G0_0_1 - 2.609594623484587e-03*G0_1_0 - 5.056089582999348e-02*G0_1_1;
    block[2920] = 2.609594623483968e-03*G0_0_1 + 2.609594623484574e-03*G0_1_0 - 1.513564881620419e-01*G0_1_1 + 2.609594623484655e-03*G0_1_2 + 2.609594623483904e-03*G0_2_1;
    block[2921] = 2.609594623483392e-02*G0_0_0 + 1.043837849393334e-02*G0_0_1 + 2.609594623483365e-02*G0_0_2 + 1.043837849393263e-02*G0_1_0 + 1.807144276762311e-01*G0_1_1 + 1.043837849393251e-02*G0_1_2 + 2.609594623483415e-02*G0_2_0 + 1.043837849393340e-02*G0_2_1 + 2.609594623483434e-02*G0_2_2;
    block[2922] = -1.565756774090085e-01*G0_0_0 - 6.621846357089280e-02*G0_0_1 - 1.565756774090085e-01*G0_0_2 - 6.621846357089251e-02*G0_1_0 - 1.617948666559757e-01*G0_1_1 - 6.621846357089259e-02*G0_1_2 - 1.565756774090086e-01*G0_2_0 - 6.621846357089303e-02*G0_2_1 - 1.565756774090087e-01*G0_2_2;
    block[2923] = 9.622880174095279e-02*G0_0_0 + 1.314583291579803e-01*G0_0_1 + 9.622880174095283e-02*G0_0_2 + 1.314583291579801e-01*G0_1_0 + 1.666878565750075e-01*G0_1_1 + 1.314583291579802e-01*G0_1_2 + 9.622880174095294e-02*G0_2_0 + 1.314583291579805e-01*G0_2_1 + 9.622880174095298e-02*G0_2_2;
    block[2924] = 1.666878565750073e-01*G0_0_0 + 1.314583291579801e-01*G0_0_1 + 1.314583291579800e-01*G0_0_2 + 1.314583291579807e-01*G0_1_0 + 9.622880174095325e-02*G0_1_1 + 9.622880174095325e-02*G0_1_2 + 1.314583291579805e-01*G0_2_0 + 9.622880174095300e-02*G0_2_1 + 9.622880174095295e-02*G0_2_2;
    block[2925] = -1.617948666559759e-01*G0_0_0 - 6.621846357089320e-02*G0_0_1 - 6.621846357089314e-02*G0_0_2 - 6.621846357089335e-02*G0_1_0 - 1.565756774090093e-01*G0_1_1 - 1.565756774090091e-01*G0_1_2 - 6.621846357089330e-02*G0_2_0 - 1.565756774090090e-01*G0_2_1 - 1.565756774090091e-01*G0_2_2;
    block[2926] = 1.807144276762315e-01*G0_0_0 + 1.043837849393352e-02*G0_0_1 + 1.043837849393356e-02*G0_0_2 + 1.043837849393358e-02*G0_1_0 + 2.609594623483498e-02*G0_1_1 + 2.609594623483492e-02*G0_1_2 + 1.043837849393391e-02*G0_2_0 + 2.609594623483541e-02*G0_2_1 + 2.609594623483550e-02*G0_2_2;
    block[2927] = -1.513564881620423e-01*G0_0_0 + 2.609594623483450e-03*G0_0_1 + 2.609594623483347e-03*G0_0_2 + 2.609594623483679e-03*G0_1_0 + 2.609594623483411e-03*G0_2_0;
    block[2928] = 9.622880174095279e-02*G0_0_0 + 9.622880174095287e-02*G0_0_1 + 1.314583291579802e-01*G0_0_2 + 9.622880174095298e-02*G0_1_0 + 9.622880174095279e-02*G0_1_1 + 1.314583291579804e-01*G0_1_2 + 1.314583291579803e-01*G0_2_0 + 1.314583291579803e-01*G0_2_1 + 1.666878565750077e-01*G0_2_2;
    block[2929] = -1.565756774090086e-01*G0_0_0 - 1.565756774090084e-01*G0_0_1 - 6.621846357089282e-02*G0_0_2 - 1.565756774090085e-01*G0_1_0 - 1.565756774090083e-01*G0_1_1 - 6.621846357089295e-02*G0_1_2 - 6.621846357089248e-02*G0_2_0 - 6.621846357089264e-02*G0_2_1 - 1.617948666559767e-01*G0_2_2;
    block[2930] = 2.609594623483441e-02*G0_0_0 + 2.609594623483432e-02*G0_0_1 + 1.043837849393300e-02*G0_0_2 + 2.609594623483412e-02*G0_1_0 + 2.609594623483411e-02*G0_1_1 + 1.043837849393288e-02*G0_1_2 + 1.043837849393365e-02*G0_2_0 + 1.043837849393371e-02*G0_2_1 + 1.807144276762320e-01*G0_2_2;
    block[2931] = 2.609594623483828e-03*G0_0_2 + 2.609594623484079e-03*G0_1_2 + 2.609594623484603e-03*G0_2_0 + 2.609594623484588e-03*G0_2_1 - 1.513564881620426e-01*G0_2_2;
    block[2932] = -5.056089582999238e-02*G0_0_0 - 2.609594623483419e-03*G0_0_2 - 2.609594623482569e-03*G0_2_0;
    block[2933] = 3.914391935225098e-02*G0_0_0 + 3.196753413767176e-02*G0_0_2 + 3.196753413767075e-02*G0_2_0 + 2.609594623483341e-02*G0_2_2;
    block[2934] = 2.609594623483615e-02*G0_0_0 + 3.196753413767382e-02*G0_0_2 + 3.196753413767441e-02*G0_2_0 + 3.914391935225373e-02*G0_2_2;
    block[2935] = -2.609594623483894e-03*G0_0_2 - 2.609594623484477e-03*G0_2_0 - 5.056089582999368e-02*G0_2_2;
    block[2936] = -5.056089582999339e-02*G0_1_1 - 2.609594623484575e-03*G0_1_2 - 2.609594623483208e-03*G0_2_1;
    block[2937] = 3.914391935225235e-02*G0_1_1 + 3.196753413767309e-02*G0_1_2 + 3.196753413767200e-02*G0_2_1 + 2.609594623483467e-02*G0_2_2;
    block[2938] = 2.609594623483512e-02*G0_1_1 + 3.196753413767273e-02*G0_1_2 + 3.196753413767339e-02*G0_2_1 + 3.914391935225280e-02*G0_2_2;
    block[2939] = -2.609594623484083e-03*G0_1_2 - 2.609594623484559e-03*G0_2_1 - 5.056089582999399e-02*G0_2_2;
    block[2940] = 1.957195967612609e-01*G0_0_0 + 7.502584542514934e-02*G0_0_1 + 7.502584542515099e-02*G0_0_2 + 7.502584542514942e-02*G0_1_0 + 2.609594623483583e-02*G0_1_2 + 7.502584542514887e-02*G0_2_0 + 2.609594623483418e-02*G0_2_1;
    block[2941] = 1.467896975709470e-01*G0_0_0 + 9.296680846159933e-02*G0_0_1 + 1.418967076519129e-01*G0_0_2 + 9.296680846160006e-02*G0_1_0 + 9.296680846159779e-02*G0_1_2 + 1.418967076519152e-01*G0_2_0 + 9.296680846159910e-02*G0_2_1 + 1.467896975709436e-01*G0_2_2;
    block[2942] = 2.609594623483546e-02*G0_0_1 + 7.502584542515146e-02*G0_0_2 + 2.609594623483422e-02*G0_1_0 + 7.502584542515173e-02*G0_1_2 + 7.502584542514906e-02*G0_2_0 + 7.502584542515010e-02*G0_2_1 + 1.957195967612633e-01*G0_2_2;
    block[2943] = 1.467896975709460e-01*G0_0_0 + 1.418967076519145e-01*G0_0_1 + 9.296680846160001e-02*G0_0_2 + 1.418967076519150e-01*G0_1_0 + 1.467896975709449e-01*G0_1_1 + 9.296680846160020e-02*G0_1_2 + 9.296680846159910e-02*G0_2_0 + 9.296680846159873e-02*G0_2_1;
    block[2944] = 9.296680846159831e-02*G0_0_1 + 9.296680846159837e-02*G0_0_2 + 9.296680846159887e-02*G0_1_0 + 1.467896975709446e-01*G0_1_1 + 1.418967076519130e-01*G0_1_2 + 9.296680846159878e-02*G0_2_0 + 1.418967076519136e-01*G0_2_1 + 1.467896975709447e-01*G0_2_2;
    block[2945] = 7.502584542515005e-02*G0_0_1 + 2.609594623483415e-02*G0_0_2 + 7.502584542514897e-02*G0_1_0 + 1.957195967612626e-01*G0_1_1 + 7.502584542515017e-02*G0_1_2 + 2.609594623483452e-02*G0_2_0 + 7.502584542515035e-02*G0_2_1;
    block[2946] = -7.502584542514969e-02*G0_0_1 - 2.609594623483390e-02*G0_0_2 - 7.502584542514930e-02*G0_1_0 + 1.435277042915937e-01*G0_1_1 - 4.240591263160567e-02*G0_1_2 - 2.609594623483488e-02*G0_2_0 - 4.240591263160691e-02*G0_2_1 - 5.219189246966890e-02*G0_2_2;
    block[2947] = -9.296680846159874e-02*G0_0_1 - 9.296680846159922e-02*G0_0_2 - 9.296680846159877e-02*G0_1_0 - 2.348635161135143e-01*G0_1_1 - 2.152915564373883e-01*G0_1_2 - 9.296680846159862e-02*G0_2_0 - 2.152915564373871e-01*G0_2_1 - 2.348635161135150e-01*G0_2_2;
    block[2948] = -2.609594623483454e-02*G0_0_1 - 7.502584542514967e-02*G0_0_2 - 2.609594623483431e-02*G0_1_0 - 5.219189246966975e-02*G0_1_1 - 4.240591263160617e-02*G0_1_2 - 7.502584542514912e-02*G0_2_0 - 4.240591263160744e-02*G0_2_1 + 1.435277042915938e-01*G0_2_2;
    block[2949] = 1.467896975709446e-01*G0_0_0 + 4.452620826318708e-01*G0_0_1 + 2.495424858706083e-01*G0_0_2 + 4.452620826318689e-01*G0_1_0 - 3.914391935225356e-02*G0_1_1 + 2.495424858706083e-01*G0_1_2 + 2.495424858706079e-01*G0_2_0 + 2.495424858706087e-01*G0_2_1 + 3.522952741702710e-01*G0_2_2;
    block[2950] = 1.467896975709447e-01*G0_0_0 + 2.495424858706072e-01*G0_0_1 + 4.452620826318701e-01*G0_0_2 + 2.495424858706085e-01*G0_1_0 + 3.522952741702705e-01*G0_1_1 + 2.495424858706089e-01*G0_1_2 + 4.452620826318697e-01*G0_2_0 + 2.495424858706076e-01*G0_2_1 - 3.914391935225388e-02*G0_2_2;
    block[2951] = -7.828783870450465e-01*G0_0_0 - 4.664650389476739e-01*G0_0_1 - 4.664650389476734e-01*G0_0_2 - 4.664650389476735e-01*G0_1_0 - 1.500516908503000e-01*G0_1_1 - 3.359853077734989e-01*G0_1_2 - 4.664650389476721e-01*G0_2_0 - 3.359853077734992e-01*G0_2_1 - 1.500516908502991e-01*G0_2_2;
    block[2952] = -5.219189246967097e-02*G0_0_0 - 2.609594623483569e-02*G0_0_1 - 4.240591263160613e-02*G0_0_2 - 2.609594623483629e-02*G0_1_0 - 7.502584542515009e-02*G0_1_2 - 4.240591263160844e-02*G0_2_0 - 7.502584542515005e-02*G0_2_1 + 1.435277042915929e-01*G0_2_2;
    block[2953] = -2.348635161135120e-01*G0_0_0 - 9.296680846159867e-02*G0_0_1 - 2.152915564373878e-01*G0_0_2 - 9.296680846159720e-02*G0_1_0 - 9.296680846159919e-02*G0_1_2 - 2.152915564373847e-01*G0_2_0 - 9.296680846159862e-02*G0_2_1 - 2.348635161135140e-01*G0_2_2;
    block[2954] = 1.435277042915926e-01*G0_0_0 - 7.502584542514963e-02*G0_0_1 - 4.240591263160544e-02*G0_0_2 - 7.502584542515138e-02*G0_1_0 - 2.609594623483410e-02*G0_1_2 - 4.240591263160802e-02*G0_2_0 - 2.609594623483431e-02*G0_2_1 - 5.219189246966884e-02*G0_2_2;
    block[2955] = 3.522952741702697e-01*G0_0_0 + 2.495424858706080e-01*G0_0_1 + 2.495424858706079e-01*G0_0_2 + 2.495424858706076e-01*G0_1_0 + 1.467896975709458e-01*G0_1_1 + 4.452620826318707e-01*G0_1_2 + 2.495424858706069e-01*G0_2_0 + 4.452620826318696e-01*G0_2_1 - 3.914391935225377e-02*G0_2_2;
    block[2956] = -3.914391935225398e-02*G0_0_0 + 4.452620826318687e-01*G0_0_1 + 2.495424858706076e-01*G0_0_2 + 4.452620826318709e-01*G0_1_0 + 1.467896975709448e-01*G0_1_1 + 2.495424858706073e-01*G0_1_2 + 2.495424858706087e-01*G0_2_0 + 2.495424858706072e-01*G0_2_1 + 3.522952741702695e-01*G0_2_2;
    block[2957] = -1.500516908502992e-01*G0_0_0 - 4.664650389476729e-01*G0_0_1 - 3.359853077734981e-01*G0_0_2 - 4.664650389476739e-01*G0_1_0 - 7.828783870450472e-01*G0_1_1 - 4.664650389476734e-01*G0_1_2 - 3.359853077734988e-01*G0_2_0 - 4.664650389476721e-01*G0_2_1 - 1.500516908502990e-01*G0_2_2;
    block[2958] = -1.500516908502989e-01*G0_0_0 - 3.359853077734979e-01*G0_0_1 - 4.664650389476723e-01*G0_0_2 - 3.359853077734992e-01*G0_1_0 - 1.500516908503000e-01*G0_1_1 - 4.664650389476736e-01*G0_1_2 - 4.664650389476724e-01*G0_2_0 - 4.664650389476724e-01*G0_2_1 - 7.828783870450453e-01*G0_2_2;
    block[2959] = -3.914391935225411e-02*G0_0_0 + 2.495424858706088e-01*G0_0_1 + 4.452620826318699e-01*G0_0_2 + 2.495424858706090e-01*G0_1_0 + 3.522952741702706e-01*G0_1_1 + 2.495424858706081e-01*G0_1_2 + 4.452620826318699e-01*G0_2_0 + 2.495424858706076e-01*G0_2_1 + 1.467896975709453e-01*G0_2_2;
    block[2960] = 1.435277042915924e-01*G0_0_0 - 4.240591263160699e-02*G0_0_1 - 7.502584542515112e-02*G0_0_2 - 4.240591263160746e-02*G0_1_0 - 5.219189246966940e-02*G0_1_1 - 2.609594623483608e-02*G0_1_2 - 7.502584542515088e-02*G0_2_0 - 2.609594623483549e-02*G0_2_1;
    block[2961] = 3.522952741702700e-01*G0_0_0 + 2.495424858706065e-01*G0_0_1 + 2.495424858706073e-01*G0_0_2 + 2.495424858706080e-01*G0_1_0 - 3.914391935225368e-02*G0_1_1 + 4.452620826318689e-01*G0_1_2 + 2.495424858706072e-01*G0_2_0 + 4.452620826318688e-01*G0_2_1 + 1.467896975709441e-01*G0_2_2;
    block[2962] = -2.348635161135144e-01*G0_0_0 - 2.152915564373884e-01*G0_0_1 - 9.296680846159971e-02*G0_0_2 - 2.152915564373875e-01*G0_1_0 - 2.348635161135147e-01*G0_1_1 - 9.296680846159995e-02*G0_1_2 - 9.296680846159874e-02*G0_2_0 - 9.296680846159840e-02*G0_2_1;
    block[2963] = -5.219189246966861e-02*G0_0_0 - 4.240591263160474e-02*G0_0_1 - 2.609594623483435e-02*G0_0_2 - 4.240591263160650e-02*G0_1_0 + 1.435277042915938e-01*G0_1_1 - 7.502584542515052e-02*G0_1_2 - 2.609594623483382e-02*G0_2_0 - 7.502584542514909e-02*G0_2_1;
    block[2964] = 1.761476370851355e+00*G0_0_0 + 9.785979838063067e-01*G0_0_1 + 9.785979838063052e-01*G0_0_2 + 9.785979838063066e-01*G0_1_0 + 1.761476370851355e+00*G0_1_1 + 9.785979838063065e-01*G0_1_2 + 9.785979838063052e-01*G0_2_0 + 9.785979838063065e-01*G0_2_1 + 1.761476370851352e+00*G0_2_2;
    block[2965] = -1.174317580567569e+00*G0_0_0 - 5.871587902837829e-01*G0_0_1 - 5.871587902837826e-01*G0_0_2 - 5.871587902837828e-01*G0_1_0 - 2.935793951418892e-01*G0_1_1 - 3.425092943322055e-01*G0_1_2 - 5.871587902837823e-01*G0_2_0 - 3.425092943322057e-01*G0_2_1 - 2.935793951418887e-01*G0_2_2;
    block[2966] = -2.935793951418904e-01*G0_0_0 - 5.871587902837844e-01*G0_0_1 - 3.425092943322053e-01*G0_0_2 - 5.871587902837836e-01*G0_1_0 - 1.174317580567571e+00*G0_1_1 - 5.871587902837815e-01*G0_1_2 - 3.425092943322064e-01*G0_2_0 - 5.871587902837854e-01*G0_2_1 - 2.935793951418889e-01*G0_2_2;
    block[2967] = -2.935793951418915e-01*G0_0_0 - 3.425092943322058e-01*G0_0_1 - 5.871587902837844e-01*G0_0_2 - 3.425092943322082e-01*G0_1_0 - 2.935793951418901e-01*G0_1_1 - 5.871587902837846e-01*G0_1_2 - 5.871587902837848e-01*G0_2_0 - 5.871587902837824e-01*G0_2_1 - 1.174317580567570e+00*G0_2_2;
    block[2968] = 4.403690927128375e-02*G0_0_0 + 4.403690927128381e-02*G0_0_1 + 4.403690927128376e-02*G0_0_2 + 4.403690927128365e-02*G0_1_0 + 4.403690927128363e-02*G0_1_1 + 4.403690927128367e-02*G0_1_2 + 4.403690927128373e-02*G0_2_0 + 4.403690927128377e-02*G0_2_1 + 4.403690927128377e-02*G0_2_2;
    block[2969] = -7.828783870450483e-02*G0_0_0;
    block[2970] = 4.403690927128394e-02*G0_1_1;
    block[2971] = 4.403690927128399e-02*G0_2_2;
    block[2972] = 9.622880174095397e-02*G0_0_0 - 3.522952741702713e-02*G0_0_1 - 3.522952741702697e-02*G0_1_0;
    block[2973] = -1.565756774090097e-01*G0_0_0 - 9.035721383811597e-02*G0_0_1 - 9.035721383811586e-02*G0_1_0 - 1.859336169231985e-01*G0_1_1;
    block[2974] = 2.609594623483469e-02*G0_0_0 + 1.565756774090063e-02*G0_0_1 + 1.565756774090162e-02*G0_1_0 + 1.859336169231993e-01*G0_1_1;
    block[2975] = -2.609594623483653e-03*G0_0_1 - 2.609594623484040e-03*G0_1_0 - 1.565756774090098e-01*G0_1_1;
    block[2976] = 2.609594623483231e-03*G0_0_1 + 2.609594623483990e-03*G0_1_0 - 4.534170658302551e-02*G0_1_1 + 2.609594623483957e-03*G0_1_2 + 2.609594623483559e-03*G0_2_1;
    block[2977] = 2.609594623483525e-02*G0_0_0 - 5.871587902837760e-03*G0_0_1 + 2.609594623483547e-02*G0_0_2 - 5.871587902838027e-03*G0_1_0 + 1.304797311741655e-03*G0_1_1 - 5.871587902838024e-03*G0_1_2 + 2.609594623483548e-02*G0_2_0 - 5.871587902837927e-03*G0_2_1 + 2.609594623483554e-02*G0_2_2;
    block[2978] = 3.914391935225248e-02*G0_0_0 + 7.176385214579546e-03*G0_0_1 + 3.914391935225241e-02*G0_0_2 + 7.176385214579476e-03*G0_1_0 + 1.304797311741573e-03*G0_1_1 + 7.176385214579642e-03*G0_1_2 + 3.914391935225162e-02*G0_2_0 + 7.176385214579482e-03*G0_2_1 + 3.914391935225166e-02*G0_2_2;
    block[2979] = -5.056089582999203e-02*G0_0_0 - 4.795130120650896e-02*G0_0_1 - 5.056089582999198e-02*G0_0_2 - 4.795130120650853e-02*G0_1_0 - 4.534170658302524e-02*G0_1_1 - 4.795130120650851e-02*G0_1_2 - 5.056089582999188e-02*G0_2_0 - 4.795130120650892e-02*G0_2_1 - 5.056089582999196e-02*G0_2_2;
    block[2980] = -1.513564881620417e-01*G0_0_0 - 1.539660827855250e-01*G0_0_1 - 1.539660827855249e-01*G0_0_2 - 1.539660827855251e-01*G0_1_0 - 1.565756774090086e-01*G0_1_1 - 1.565756774090084e-01*G0_1_2 - 1.539660827855254e-01*G0_2_0 - 1.565756774090086e-01*G0_2_1 - 1.565756774090086e-01*G0_2_2;
    block[2981] = 1.807144276762310e-01*G0_0_0 + 1.702760491822970e-01*G0_0_1 + 1.702760491822969e-01*G0_0_2 + 1.702760491822970e-01*G0_1_0 + 1.859336169231977e-01*G0_1_1 + 1.859336169231976e-01*G0_1_2 + 1.702760491822973e-01*G0_2_0 + 1.859336169231981e-01*G0_2_1 + 1.859336169231980e-01*G0_2_2;
    block[2982] = -1.617948666559764e-01*G0_0_0 - 9.557640308508210e-02*G0_0_1 - 9.557640308508199e-02*G0_0_2 - 9.557640308508233e-02*G0_1_0 - 1.859336169231977e-01*G0_1_1 - 1.859336169231977e-01*G0_1_2 - 9.557640308508254e-02*G0_2_0 - 1.859336169231978e-01*G0_2_1 - 1.859336169231978e-01*G0_2_2;
    block[2983] = 1.666878565750081e-01*G0_0_0 + 3.522952741702724e-02*G0_0_1 + 3.522952741702728e-02*G0_0_2 + 3.522952741702674e-02*G0_1_0 + 3.522952741702701e-02*G0_2_0;
    block[2984] = -5.056089582999196e-02*G0_0_0 - 5.056089582999201e-02*G0_0_1 - 4.795130120650880e-02*G0_0_2 - 5.056089582999211e-02*G0_1_0 - 5.056089582999219e-02*G0_1_1 - 4.795130120650866e-02*G0_1_2 - 4.795130120650839e-02*G0_2_0 - 4.795130120650856e-02*G0_2_1 - 4.534170658302551e-02*G0_2_2;
    block[2985] = 3.914391935225155e-02*G0_0_0 + 3.914391935225149e-02*G0_0_1 + 7.176385214579324e-03*G0_0_2 + 3.914391935225196e-02*G0_1_0 + 3.914391935225192e-02*G0_1_1 + 7.176385214579319e-03*G0_1_2 + 7.176385214579191e-03*G0_2_0 + 7.176385214579279e-03*G0_2_1 + 1.304797311741920e-03*G0_2_2;
    block[2986] = 2.609594623483493e-02*G0_0_0 + 2.609594623483499e-02*G0_0_1 - 5.871587902837626e-03*G0_0_2 + 2.609594623483500e-02*G0_1_0 + 2.609594623483504e-02*G0_1_1 - 5.871587902837523e-03*G0_1_2 - 5.871587902837498e-03*G0_2_0 - 5.871587902837489e-03*G0_2_1 + 1.304797311741820e-03*G0_2_2;
    block[2987] = 2.609594623483558e-03*G0_0_2 + 2.609594623483421e-03*G0_1_2 + 2.609594623483559e-03*G0_2_0 + 2.609594623483589e-03*G0_2_1 - 4.534170658302585e-02*G0_2_2;
    block[2988] = 9.622880174095380e-02*G0_0_0 - 3.522952741702716e-02*G0_0_2 - 3.522952741702712e-02*G0_2_0;
    block[2989] = -1.565756774090082e-01*G0_0_0 - 9.035721383811465e-02*G0_0_2 - 9.035721383811549e-02*G0_2_0 - 1.859336169231985e-01*G0_2_2;
    block[2990] = 2.609594623483402e-02*G0_0_0 + 1.565756774090008e-02*G0_0_2 + 1.565756774090086e-02*G0_2_0 + 1.859336169231989e-01*G0_2_2;
    block[2991] = -2.609594623483307e-03*G0_0_2 - 2.609594623483841e-03*G0_2_0 - 1.565756774090100e-01*G0_2_2;
    block[2992] = -5.056089582999285e-02*G0_1_1 - 2.609594623483910e-03*G0_1_2 - 2.609594623482871e-03*G0_2_1;
    block[2993] = 3.914391935225273e-02*G0_1_1 + 3.196753413767353e-02*G0_1_2 + 3.196753413767234e-02*G0_2_1 + 2.609594623483526e-02*G0_2_2;
    block[2994] = 2.609594623483552e-02*G0_1_1 + 3.196753413767286e-02*G0_1_2 + 3.196753413767414e-02*G0_2_1 + 3.914391935225284e-02*G0_2_2;
    block[2995] = -2.609594623483436e-03*G0_1_2 - 2.609594623483682e-03*G0_2_1 - 5.056089582999262e-02*G0_2_2;
    block[2996] = -7.828783870450458e-01*G0_0_0 - 3.164133480973718e-01*G0_0_1 - 3.164133480973731e-01*G0_0_2 - 3.164133480973710e-01*G0_1_0 - 1.859336169231978e-01*G0_1_2 - 3.164133480973719e-01*G0_2_0 - 1.859336169231983e-01*G0_2_1;
    block[2997] = 1.467896975709450e-01*G0_0_0 - 1.027527882996626e-01*G0_0_1 - 2.984723850609228e-01*G0_0_2 - 1.027527882996635e-01*G0_1_0 - 2.984723850609239e-01*G0_1_2 - 2.984723850609251e-01*G0_2_0 - 2.984723850609239e-01*G0_2_1 - 7.828783870450481e-01*G0_2_2;
    block[2998] = 2.609594623483414e-02*G0_0_1 + 7.502584542514894e-02*G0_0_2 + 2.609594623483534e-02*G0_1_0 + 5.871587902837917e-02*G0_1_2 + 7.502584542515189e-02*G0_2_0 + 5.871587902837866e-02*G0_2_1 + 2.935793951418949e-01*G0_2_2;
    block[2999] = 1.467896975709473e-01*G0_0_0 - 2.984723850609234e-01*G0_0_1 - 1.027527882996625e-01*G0_0_2 - 2.984723850609245e-01*G0_1_0 - 7.828783870450476e-01*G0_1_1 - 2.984723850609233e-01*G0_1_2 - 1.027527882996628e-01*G0_2_0 - 2.984723850609239e-01*G0_2_1;
    block[3000] = 9.296680846160024e-02*G0_0_1 + 9.296680846160132e-02*G0_0_2 + 9.296680846160030e-02*G0_1_0 - 4.892989919031614e-02*G0_1_1 - 2.935793951418934e-02*G0_1_2 + 9.296680846160042e-02*G0_2_0 - 2.935793951418833e-02*G0_2_1 - 4.892989919031514e-02*G0_2_2;
    block[3001] = 7.502584542515063e-02*G0_0_1 + 2.609594623483433e-02*G0_0_2 + 7.502584542515101e-02*G0_1_0 + 2.935793951418948e-01*G0_1_1 + 5.871587902837917e-02*G0_1_2 + 2.609594623483623e-02*G0_2_0 + 5.871587902837940e-02*G0_2_1;
    block[3002] = -7.502584542514991e-02*G0_0_1 - 2.609594623483579e-02*G0_0_2 - 7.502584542515080e-02*G0_1_0 + 4.566790591096190e-02*G0_1_1 - 2.609594623483562e-02*G0_1_2 - 2.609594623483602e-02*G0_2_0 - 2.609594623483527e-02*G0_2_1 - 5.219189246967069e-02*G0_2_2;
    block[3003] = -9.296680846160066e-02*G0_0_1 - 9.296680846159935e-02*G0_0_2 - 9.296680846160042e-02*G0_1_0 - 3.914391935225328e-02*G0_1_1 - 4.403690927128458e-02*G0_1_2 - 9.296680846160060e-02*G0_2_0 - 4.403690927128454e-02*G0_2_1 - 3.914391935225304e-02*G0_2_2;
    block[3004] = -2.609594623483496e-02*G0_0_1 - 7.502584542515123e-02*G0_0_2 - 2.609594623483524e-02*G0_1_0 - 5.219189246967006e-02*G0_1_1 - 2.609594623483458e-02*G0_1_2 - 7.502584542515178e-02*G0_2_0 - 2.609594623483639e-02*G0_2_1 + 4.566790591096143e-02*G0_2_2;
    block[3005] = 1.467896975709476e-01*G0_0_0 + 4.892989919030863e-03*G0_0_1 + 5.382288910934710e-02*G0_0_2 + 4.892989919032801e-03*G0_1_0 + 9.785979838062194e-03*G0_1_1 + 4.892989919031927e-03*G0_1_2 + 5.382288910934784e-02*G0_2_0 + 4.892989919031989e-03*G0_2_1 - 3.914391935225175e-02*G0_2_2;
    block[3006] = 1.467896975709474e-01*G0_0_0 + 5.382288910934889e-02*G0_0_1 + 4.892989919032265e-03*G0_0_2 + 5.382288910934747e-02*G0_1_0 - 3.914391935225150e-02*G0_1_1 + 4.892989919031488e-03*G0_1_2 + 4.892989919033172e-03*G0_2_0 + 4.892989919032708e-03*G0_2_1 + 9.785979838063279e-03*G0_2_2;
    block[3007] = 1.957195967612617e-01*G0_0_0 + 1.206937513361115e-01*G0_0_1 + 1.206937513361105e-01*G0_0_2 + 1.206937513361113e-01*G0_1_0 + 4.566790591096127e-02*G0_1_1 + 7.176385214579530e-02*G0_1_2 + 1.206937513361103e-01*G0_2_0 + 7.176385214579507e-02*G0_2_1 + 4.566790591096038e-02*G0_2_2;
    block[3008] = -5.219189246966834e-02*G0_0_0 - 2.609594623483371e-02*G0_0_1 - 9.785979838063178e-03*G0_0_2 - 2.609594623483453e-02*G0_1_0 - 5.871587902837803e-02*G0_1_2 - 9.785979838062859e-03*G0_2_0 - 5.871587902837803e-02*G0_2_1 + 1.761476370851365e-01*G0_2_2;
    block[3009] = 3.522952741702689e-01*G0_0_0 + 1.027527882996621e-01*G0_0_1 + 1.027527882996619e-01*G0_0_2 + 1.027527882996617e-01*G0_1_0 + 2.984723850609245e-01*G0_1_2 + 1.027527882996624e-01*G0_2_0 + 2.984723850609237e-01*G0_2_1 - 1.859336169231994e-01*G0_2_2;
    block[3010] = -1.500516908503023e-01*G0_0_0 + 3.164133480973719e-01*G0_0_1 + 1.859336169231967e-01*G0_0_2 + 3.164133480973728e-01*G0_1_0 + 1.859336169231967e-01*G0_1_2 + 1.859336169231978e-01*G0_2_0 + 1.859336169231984e-01*G0_2_1 + 3.718672338463963e-01*G0_2_2;
    block[3011] = -2.348635161135127e-01*G0_0_0 - 1.418967076519145e-01*G0_0_1 - 1.957195967612545e-02*G0_0_2 - 1.418967076519148e-01*G0_1_0 - 4.892989919031634e-02*G0_1_1 - 1.957195967612633e-02*G0_1_2 - 1.957195967612648e-02*G0_2_0 - 1.957195967612660e-02*G0_2_1 - 3.914391935225302e-02*G0_2_2;
    block[3012] = -3.914391935224984e-02*G0_0_0 - 4.844060019841195e-01*G0_0_1 - 2.886864052228589e-01*G0_0_2 - 4.844060019841220e-01*G0_1_0 - 7.828783870450452e-01*G0_1_1 - 4.844060019841221e-01*G0_1_2 - 2.886864052228599e-01*G0_2_0 - 4.844060019841213e-01*G0_2_1 - 1.859336169231977e-01*G0_2_2;
    block[3013] = 1.435277042915903e-01*G0_0_0 + 2.185535497167407e-01*G0_0_1 + 1.859336169231968e-01*G0_0_2 + 2.185535497167415e-01*G0_1_0 + 2.935793951418916e-01*G0_1_1 + 2.348635161135131e-01*G0_1_2 + 1.859336169231978e-01*G0_2_0 + 2.348635161135133e-01*G0_2_1 + 1.761476370851345e-01*G0_2_2;
    block[3014] = 1.435277042915901e-01*G0_0_0 + 1.859336169231975e-01*G0_0_1 + 2.185535497167414e-01*G0_0_2 + 1.859336169231974e-01*G0_1_0 + 1.761476370851350e-01*G0_1_1 + 2.348635161135133e-01*G0_1_2 + 2.185535497167409e-01*G0_2_0 + 2.348635161135123e-01*G0_2_1 + 2.935793951418907e-01*G0_2_2;
    block[3015] = -3.914391935224992e-02*G0_0_0 - 2.886864052228607e-01*G0_0_1 - 4.844060019841213e-01*G0_0_2 - 2.886864052228601e-01*G0_1_0 - 1.859336169231985e-01*G0_1_1 - 4.844060019841214e-01*G0_1_2 - 4.844060019841216e-01*G0_2_0 - 4.844060019841225e-01*G0_2_1 - 7.828783870450456e-01*G0_2_2;
    block[3016] = -1.500516908503022e-01*G0_0_0 + 1.859336169231980e-01*G0_0_1 + 3.164133480973733e-01*G0_0_2 + 1.859336169231983e-01*G0_1_0 + 3.718672338463965e-01*G0_1_1 + 1.859336169231979e-01*G0_1_2 + 3.164133480973726e-01*G0_2_0 + 1.859336169231975e-01*G0_2_1;
    block[3017] = -2.348635161135146e-01*G0_0_0 - 1.957195967612536e-02*G0_0_1 - 1.418967076519144e-01*G0_0_2 - 1.957195967612554e-02*G0_1_0 - 3.914391935225209e-02*G0_1_1 - 1.957195967612514e-02*G0_1_2 - 1.418967076519144e-01*G0_2_0 - 1.957195967612469e-02*G0_2_1 - 4.892989919031514e-02*G0_2_2;
    block[3018] = 3.522952741702721e-01*G0_0_0 + 1.027527882996629e-01*G0_0_1 + 1.027527882996622e-01*G0_0_2 + 1.027527882996617e-01*G0_1_0 - 1.859336169231992e-01*G0_1_1 + 2.984723850609234e-01*G0_1_2 + 1.027527882996621e-01*G0_2_0 + 2.984723850609245e-01*G0_2_1;
    block[3019] = -5.219189246967011e-02*G0_0_0 - 9.785979838063508e-03*G0_0_1 - 2.609594623483412e-02*G0_0_2 - 9.785979838063704e-03*G0_1_0 + 1.761476370851357e-01*G0_1_1 - 5.871587902837903e-02*G0_1_2 - 2.609594623483537e-02*G0_2_0 - 5.871587902837921e-02*G0_2_1;
    block[3020] = -1.174317580567569e+00*G0_0_0 - 5.871587902837828e-01*G0_0_1 - 5.871587902837823e-01*G0_0_2 - 5.871587902837829e-01*G0_1_0 - 2.935793951418892e-01*G0_1_1 - 3.425092943322057e-01*G0_1_2 - 5.871587902837826e-01*G0_2_0 - 3.425092943322055e-01*G0_2_1 - 2.935793951418887e-01*G0_2_2;
    block[3021] = 1.761476370851354e+00*G0_0_0 + 7.828783870450430e-01*G0_0_1 + 7.828783870450443e-01*G0_0_2 + 7.828783870450430e-01*G0_1_0 + 1.565756774090093e+00*G0_1_1 + 7.828783870450450e-01*G0_1_2 + 7.828783870450443e-01*G0_2_0 + 7.828783870450450e-01*G0_2_1 + 1.565756774090094e+00*G0_2_2;
    block[3022] = -2.935793951418950e-01*G0_0_0 + 2.935793951418919e-01*G0_0_1 + 4.892989919031332e-02*G0_0_2 + 2.935793951418919e-01*G0_1_0 - 2.935793951418970e-01*G0_1_1 + 4.892989919031487e-02*G0_1_2 + 4.892989919031501e-02*G0_2_0 + 4.892989919031284e-02*G0_2_1 + 9.785979838063004e-02*G0_2_2;
    block[3023] = -2.935793951418932e-01*G0_0_0 + 4.892989919031336e-02*G0_0_1 + 2.935793951418917e-01*G0_0_2 + 4.892989919031537e-02*G0_1_0 + 9.785979838063093e-02*G0_1_1 + 4.892989919031295e-02*G0_1_2 + 2.935793951418915e-01*G0_2_0 + 4.892989919031406e-02*G0_2_1 - 2.935793951418966e-01*G0_2_2;
    block[3024] = 4.403690927128372e-02*G0_0_0 + 4.403690927128374e-02*G0_0_1 + 4.403690927128372e-02*G0_0_2 + 4.403690927128385e-02*G0_1_0 + 4.403690927128391e-02*G0_1_1 + 4.403690927128387e-02*G0_1_2 + 4.403690927128370e-02*G0_2_0 + 4.403690927128372e-02*G0_2_1 + 4.403690927128375e-02*G0_2_2;
    block[3025] = 4.403690927128399e-02*G0_0_0;
    block[3026] = -7.828783870450452e-02*G0_1_1;
    block[3027] = 4.403690927128411e-02*G0_2_2;
    block[3028] = -1.565756774090099e-01*G0_0_0 - 2.609594623483836e-03*G0_0_1 - 2.609594623484200e-03*G0_1_0;
    block[3029] = 1.859336169231996e-01*G0_0_0 + 1.565756774090185e-02*G0_0_1 + 1.565756774090173e-02*G0_1_0 + 2.609594623483533e-02*G0_1_1;
    block[3030] = -1.859336169231991e-01*G0_0_0 - 9.035721383811642e-02*G0_0_1 - 9.035721383811718e-02*G0_1_0 - 1.565756774090105e-01*G0_1_1;
    block[3031] = -3.522952741702644e-02*G0_0_1 - 3.522952741702594e-02*G0_1_0 + 9.622880174095456e-02*G0_1_1;
    block[3032] = 3.522952741702705e-02*G0_0_1 + 3.522952741702601e-02*G0_1_0 + 1.666878565750074e-01*G0_1_1 + 3.522952741702598e-02*G0_1_2 + 3.522952741702683e-02*G0_2_1;
    block[3033] = -1.859336169231981e-01*G0_0_0 - 9.557640308508256e-02*G0_0_1 - 1.859336169231979e-01*G0_0_2 - 9.557640308508161e-02*G0_1_0 - 1.617948666559758e-01*G0_1_1 - 9.557640308508150e-02*G0_1_2 - 1.859336169231979e-01*G0_2_0 - 9.557640308508222e-02*G0_2_1 - 1.859336169231981e-01*G0_2_2;
    block[3034] = 1.859336169231977e-01*G0_0_0 + 1.702760491822970e-01*G0_0_1 + 1.859336169231979e-01*G0_0_2 + 1.702760491822971e-01*G0_1_0 + 1.807144276762308e-01*G0_1_1 + 1.702760491822970e-01*G0_1_2 + 1.859336169231976e-01*G0_2_0 + 1.702760491822966e-01*G0_2_1 + 1.859336169231976e-01*G0_2_2;
    block[3035] = -1.565756774090084e-01*G0_0_0 - 1.539660827855253e-01*G0_0_1 - 1.565756774090085e-01*G0_0_2 - 1.539660827855251e-01*G0_1_0 - 1.513564881620419e-01*G0_1_1 - 1.539660827855251e-01*G0_1_2 - 1.565756774090086e-01*G0_2_0 - 1.539660827855250e-01*G0_2_1 - 1.565756774090086e-01*G0_2_2;
    block[3036] = -4.534170658302530e-02*G0_0_0 - 4.795130120650856e-02*G0_0_1 - 4.795130120650853e-02*G0_0_2 - 4.795130120650910e-02*G0_1_0 - 5.056089582999220e-02*G0_1_1 - 5.056089582999221e-02*G0_1_2 - 4.795130120650885e-02*G0_2_0 - 5.056089582999231e-02*G0_2_1 - 5.056089582999240e-02*G0_2_2;
    block[3037] = 1.304797311741653e-03*G0_0_0 + 7.176385214579395e-03*G0_0_1 + 7.176385214579448e-03*G0_0_2 + 7.176385214579703e-03*G0_1_0 + 3.914391935225253e-02*G0_1_1 + 3.914391935225253e-02*G0_1_2 + 7.176385214579636e-03*G0_2_0 + 3.914391935225238e-02*G0_2_1 + 3.914391935225236e-02*G0_2_2;
    block[3038] = 1.304797311741776e-03*G0_0_0 - 5.871587902837442e-03*G0_0_1 - 5.871587902837541e-03*G0_0_2 - 5.871587902838105e-03*G0_1_0 + 2.609594623483483e-02*G0_1_1 + 2.609594623483483e-02*G0_1_2 - 5.871587902837927e-03*G0_2_0 + 2.609594623483508e-02*G0_2_1 + 2.609594623483510e-02*G0_2_2;
    block[3039] = -4.534170658302580e-02*G0_0_0 + 2.609594623483603e-03*G0_0_1 + 2.609594623483702e-03*G0_0_2 + 2.609594623483718e-03*G0_1_0 + 2.609594623483376e-03*G0_2_0;
    block[3040] = -5.056089582999182e-02*G0_0_0 - 5.056089582999194e-02*G0_0_1 - 4.795130120650881e-02*G0_0_2 - 5.056089582999218e-02*G0_1_0 - 5.056089582999211e-02*G0_1_1 - 4.795130120650908e-02*G0_1_2 - 4.795130120650885e-02*G0_2_0 - 4.795130120650875e-02*G0_2_1 - 4.534170658302537e-02*G0_2_2;
    block[3041] = 3.914391935225208e-02*G0_0_0 + 3.914391935225203e-02*G0_0_1 + 7.176385214579509e-03*G0_0_2 + 3.914391935225148e-02*G0_1_0 + 3.914391935225151e-02*G0_1_1 + 7.176385214579625e-03*G0_1_2 + 7.176385214579808e-03*G0_2_0 + 7.176385214579730e-03*G0_2_1 + 1.304797311741839e-03*G0_2_2;
    block[3042] = 2.609594623483582e-02*G0_0_0 + 2.609594623483581e-02*G0_0_1 - 5.871587902837749e-03*G0_0_2 + 2.609594623483589e-02*G0_1_0 + 2.609594623483583e-02*G0_1_1 - 5.871587902837692e-03*G0_1_2 - 5.871587902837690e-03*G0_2_0 - 5.871587902837682e-03*G0_2_1 + 1.304797311741833e-03*G0_2_2;
    block[3043] = 2.609594623483545e-03*G0_0_2 + 2.609594623483366e-03*G0_1_2 + 2.609594623483599e-03*G0_2_0 + 2.609594623483613e-03*G0_2_1 - 4.534170658302589e-02*G0_2_2;
    block[3044] = -5.056089582999276e-02*G0_0_0 - 2.609594623483692e-03*G0_0_2 - 2.609594623483799e-03*G0_2_0;
    block[3045] = 3.914391935225210e-02*G0_0_0 + 3.196753413767275e-02*G0_0_2 + 3.196753413767257e-02*G0_2_0 + 2.609594623483506e-02*G0_2_2;
    block[3046] = 2.609594623483546e-02*G0_0_0 + 3.196753413767316e-02*G0_0_2 + 3.196753413767287e-02*G0_2_0 + 3.914391935225214e-02*G0_2_2;
    block[3047] = -2.609594623483481e-03*G0_0_2 - 2.609594623483617e-03*G0_2_0 - 5.056089582999275e-02*G0_2_2;
    block[3048] = 9.622880174095429e-02*G0_1_1 - 3.522952741702595e-02*G0_1_2 - 3.522952741702646e-02*G0_2_1;
    block[3049] = -1.565756774090095e-01*G0_1_1 - 9.035721383811665e-02*G0_1_2 - 9.035721383811617e-02*G0_2_1 - 1.859336169231998e-01*G0_2_2;
    block[3050] = 2.609594623483420e-02*G0_1_1 + 1.565756774090107e-02*G0_1_2 + 1.565756774090123e-02*G0_2_1 + 1.859336169232000e-01*G0_2_2;
    block[3051] = -2.609594623482972e-03*G0_1_2 - 2.609594623483647e-03*G0_2_1 - 1.565756774090103e-01*G0_2_2;
    block[3052] = 2.935793951418930e-01*G0_0_0 + 7.502584542514990e-02*G0_0_1 + 5.871587902837887e-02*G0_0_2 + 7.502584542515037e-02*G0_1_0 + 2.609594623483394e-02*G0_1_2 + 5.871587902837853e-02*G0_2_0 + 2.609594623483413e-02*G0_2_1;
    block[3053] = -4.892989919031543e-02*G0_0_0 + 9.296680846159956e-02*G0_0_1 - 2.935793951419025e-02*G0_0_2 + 9.296680846159967e-02*G0_1_0 + 9.296680846160083e-02*G0_1_2 - 2.935793951418899e-02*G0_2_0 + 9.296680846159915e-02*G0_2_1 - 4.892989919031570e-02*G0_2_2;
    block[3054] = 2.609594623483562e-02*G0_0_1 + 5.871587902837980e-02*G0_0_2 + 2.609594623483558e-02*G0_1_0 + 7.502584542514952e-02*G0_1_2 + 5.871587902837827e-02*G0_2_0 + 7.502584542514995e-02*G0_2_1 + 2.935793951418935e-01*G0_2_2;
    block[3055] = -7.828783870450484e-01*G0_0_0 - 2.984723850609243e-01*G0_0_1 - 2.984723850609242e-01*G0_0_2 - 2.984723850609238e-01*G0_1_0 + 1.467896975709484e-01*G0_1_1 - 1.027527882996627e-01*G0_1_2 - 2.984723850609250e-01*G0_2_0 - 1.027527882996622e-01*G0_2_1;
    block[3056] = -1.027527882996625e-01*G0_0_1 - 2.984723850609248e-01*G0_0_2 - 1.027527882996629e-01*G0_1_0 + 1.467896975709478e-01*G0_1_1 - 2.984723850609233e-01*G0_1_2 - 2.984723850609242e-01*G0_2_0 - 2.984723850609239e-01*G0_2_1 - 7.828783870450483e-01*G0_2_2;
    block[3057] = -3.164133480973725e-01*G0_0_1 - 1.859336169231975e-01*G0_0_2 - 3.164133480973725e-01*G0_1_0 - 7.828783870450486e-01*G0_1_1 - 3.164133480973733e-01*G0_1_2 - 1.859336169231978e-01*G0_2_0 - 3.164133480973734e-01*G0_2_1;
    block[3058] = 3.164133480973724e-01*G0_0_1 + 1.859336169231979e-01*G0_0_2 + 3.164133480973728e-01*G0_1_0 - 1.500516908503027e-01*G0_1_1 + 1.859336169231980e-01*G0_1_2 + 1.859336169231980e-01*G0_2_0 + 1.859336169231972e-01*G0_2_1 + 3.718672338463976e-01*G0_2_2;
    block[3059] = 1.027527882996626e-01*G0_0_1 + 2.984723850609247e-01*G0_0_2 + 1.027527882996628e-01*G0_1_0 + 3.522952741702724e-01*G0_1_1 + 1.027527882996630e-01*G0_1_2 + 2.984723850609241e-01*G0_2_0 + 1.027527882996625e-01*G0_2_1 - 1.859336169232003e-01*G0_2_2;
    block[3060] = -2.609594623483601e-02*G0_0_1 - 5.871587902837924e-02*G0_0_2 - 2.609594623483545e-02*G0_1_0 - 5.219189246966994e-02*G0_1_1 - 9.785979838064040e-03*G0_1_2 - 5.871587902837811e-02*G0_2_0 - 9.785979838063303e-03*G0_2_1 + 1.761476370851369e-01*G0_2_2;
    block[3061] = -7.828783870450464e-01*G0_0_0 - 4.844060019841228e-01*G0_0_1 - 4.844060019841229e-01*G0_0_2 - 4.844060019841220e-01*G0_1_0 - 3.914391935225094e-02*G0_1_1 - 2.886864052228609e-01*G0_1_2 - 4.844060019841209e-01*G0_2_0 - 2.886864052228599e-01*G0_2_1 - 1.859336169231973e-01*G0_2_2;
    block[3062] = -4.892989919031449e-02*G0_0_0 - 1.418967076519148e-01*G0_0_1 - 1.957195967612554e-02*G0_0_2 - 1.418967076519153e-01*G0_1_0 - 2.348635161135144e-01*G0_1_1 - 1.957195967612577e-02*G0_1_2 - 1.957195967612590e-02*G0_2_0 - 1.957195967612622e-02*G0_2_1 - 3.914391935225300e-02*G0_2_2;
    block[3063] = 2.935793951418924e-01*G0_0_0 + 2.185535497167415e-01*G0_0_1 + 2.348635161135132e-01*G0_0_2 + 2.185535497167421e-01*G0_1_0 + 1.435277042915916e-01*G0_1_1 + 1.859336169231977e-01*G0_1_2 + 2.348635161135135e-01*G0_2_0 + 1.859336169231978e-01*G0_2_1 + 1.761476370851351e-01*G0_2_2;
    block[3064] = -5.219189246967105e-02*G0_0_0 - 2.609594623483539e-02*G0_0_1 - 2.609594623483548e-02*G0_0_2 - 2.609594623483433e-02*G0_1_0 - 7.502584542515160e-02*G0_1_2 - 2.609594623483496e-02*G0_2_0 - 7.502584542514990e-02*G0_2_1 + 4.566790591096130e-02*G0_2_2;
    block[3065] = -3.914391935225198e-02*G0_0_0 - 9.296680846159983e-02*G0_0_1 - 4.403690927128420e-02*G0_0_2 - 9.296680846160076e-02*G0_1_0 - 9.296680846159956e-02*G0_1_2 - 4.403690927128435e-02*G0_2_0 - 9.296680846159930e-02*G0_2_1 - 3.914391935225226e-02*G0_2_2;
    block[3066] = 4.566790591096103e-02*G0_0_0 - 7.502584542514953e-02*G0_0_1 - 2.609594623483519e-02*G0_0_2 - 7.502584542515038e-02*G0_1_0 - 2.609594623483554e-02*G0_1_2 - 2.609594623483456e-02*G0_2_0 - 2.609594623483392e-02*G0_2_1 - 5.219189246966975e-02*G0_2_2;
    block[3067] = -3.914391935225246e-02*G0_0_0 + 5.382288910934790e-02*G0_0_1 + 4.892989919032137e-03*G0_0_2 + 5.382288910934814e-02*G0_1_0 + 1.467896975709472e-01*G0_1_1 + 4.892989919032458e-03*G0_1_2 + 4.892989919031826e-03*G0_2_0 + 4.892989919032318e-03*G0_2_1 + 9.785979838063131e-03*G0_2_2;
    block[3068] = 9.785979838063211e-03*G0_0_0 + 4.892989919031736e-03*G0_0_1 + 4.892989919031587e-03*G0_0_2 + 4.892989919032162e-03*G0_1_0 + 1.467896975709480e-01*G0_1_1 + 5.382288910934804e-02*G0_1_2 + 4.892989919031809e-03*G0_2_0 + 5.382288910934691e-02*G0_2_1 - 3.914391935225246e-02*G0_2_2;
    block[3069] = 4.566790591096054e-02*G0_0_0 + 1.206937513361116e-01*G0_0_1 + 7.176385214579523e-02*G0_0_2 + 1.206937513361113e-01*G0_1_0 + 1.957195967612615e-01*G0_1_1 + 1.206937513361105e-01*G0_1_2 + 7.176385214579552e-02*G0_2_0 + 1.206937513361110e-01*G0_2_1 + 4.566790591096098e-02*G0_2_2;
    block[3070] = 1.761476370851346e-01*G0_0_0 + 1.859336169231979e-01*G0_0_1 + 2.348635161135139e-01*G0_0_2 + 1.859336169231981e-01*G0_1_0 + 1.435277042915915e-01*G0_1_1 + 2.185535497167425e-01*G0_1_2 + 2.348635161135126e-01*G0_2_0 + 2.185535497167410e-01*G0_2_1 + 2.935793951418916e-01*G0_2_2;
    block[3071] = -3.914391935225206e-02*G0_0_0 - 1.957195967612587e-02*G0_0_1 - 1.957195967612532e-02*G0_0_2 - 1.957195967612554e-02*G0_1_0 - 2.348635161135140e-01*G0_1_1 - 1.418967076519140e-01*G0_1_2 - 1.957195967612534e-02*G0_2_0 - 1.418967076519146e-01*G0_2_1 - 4.892989919031505e-02*G0_2_2;
    block[3072] = 1.761476370851359e-01*G0_0_0 - 9.785979838063993e-03*G0_0_1 - 5.871587902837849e-02*G0_0_2 - 9.785979838063048e-03*G0_1_0 - 5.219189246967008e-02*G0_1_1 - 2.609594623483365e-02*G0_1_2 - 5.871587902837790e-02*G0_2_0 - 2.609594623483529e-02*G0_2_1;
    block[3073] = -1.859336169231975e-01*G0_0_0 - 2.886864052228601e-01*G0_0_1 - 4.844060019841212e-01*G0_0_2 - 2.886864052228610e-01*G0_1_0 - 3.914391935225097e-02*G0_1_1 - 4.844060019841216e-01*G0_1_2 - 4.844060019841213e-01*G0_2_0 - 4.844060019841209e-01*G0_2_1 - 7.828783870450452e-01*G0_2_2;
    block[3074] = -1.859336169232002e-01*G0_0_0 + 1.027527882996626e-01*G0_0_1 + 2.984723850609239e-01*G0_0_2 + 1.027527882996620e-01*G0_1_0 + 3.522952741702719e-01*G0_1_1 + 1.027527882996623e-01*G0_1_2 + 2.984723850609225e-01*G0_2_0 + 1.027527882996625e-01*G0_2_1;
    block[3075] = 3.718672338463968e-01*G0_0_0 + 1.859336169231974e-01*G0_0_1 + 1.859336169231977e-01*G0_0_2 + 1.859336169231986e-01*G0_1_0 - 1.500516908503027e-01*G0_1_1 + 3.164133480973735e-01*G0_1_2 + 1.859336169231982e-01*G0_2_0 + 3.164133480973715e-01*G0_2_1;
    block[3076] = -2.935793951418904e-01*G0_0_0 - 5.871587902837836e-01*G0_0_1 - 3.425092943322064e-01*G0_0_2 - 5.871587902837844e-01*G0_1_0 - 1.174317580567571e+00*G0_1_1 - 5.871587902837854e-01*G0_1_2 - 3.425092943322053e-01*G0_2_0 - 5.871587902837814e-01*G0_2_1 - 2.935793951418889e-01*G0_2_2;
    block[3077] = -2.935793951418950e-01*G0_0_0 + 2.935793951418919e-01*G0_0_1 + 4.892989919031501e-02*G0_0_2 + 2.935793951418920e-01*G0_1_0 - 2.935793951418969e-01*G0_1_1 + 4.892989919031285e-02*G0_1_2 + 4.892989919031333e-02*G0_2_0 + 4.892989919031485e-02*G0_2_1 + 9.785979838063007e-02*G0_2_2;
    block[3078] = 1.565756774090095e+00*G0_0_0 + 7.828783870450451e-01*G0_0_1 + 7.828783870450459e-01*G0_0_2 + 7.828783870450452e-01*G0_1_0 + 1.761476370851358e+00*G0_1_1 + 7.828783870450442e-01*G0_1_2 + 7.828783870450459e-01*G0_2_0 + 7.828783870450443e-01*G0_2_1 + 1.565756774090094e+00*G0_2_2;
    block[3079] = 9.785979838062896e-02*G0_0_0 + 4.892989919031408e-02*G0_0_1 + 4.892989919031293e-02*G0_0_2 + 4.892989919031495e-02*G0_1_0 - 2.935793951418948e-01*G0_1_1 + 2.935793951418936e-01*G0_1_2 + 4.892989919031398e-02*G0_2_0 + 2.935793951418912e-01*G0_2_1 - 2.935793951418960e-01*G0_2_2;
    block[3080] = 4.403690927128370e-02*G0_0_0 + 4.403690927128371e-02*G0_0_1 + 4.403690927128375e-02*G0_0_2 + 4.403690927128368e-02*G0_1_0 + 4.403690927128368e-02*G0_1_1 + 4.403690927128371e-02*G0_1_2 + 4.403690927128388e-02*G0_2_0 + 4.403690927128392e-02*G0_2_1 + 4.403690927128384e-02*G0_2_2;
    block[3081] = 4.403690927128399e-02*G0_0_0;
    block[3082] = 4.403690927128386e-02*G0_1_1;
    block[3083] = -7.828783870450486e-02*G0_2_2;
    block[3084] = -5.056089582999273e-02*G0_0_0 - 2.609594623483540e-03*G0_0_1 - 2.609594623483960e-03*G0_1_0;
    block[3085] = 3.914391935225220e-02*G0_0_0 + 3.196753413767267e-02*G0_0_1 + 3.196753413767273e-02*G0_1_0 + 2.609594623483516e-02*G0_1_1;
    block[3086] = 2.609594623483538e-02*G0_0_0 + 3.196753413767312e-02*G0_0_1 + 3.196753413767266e-02*G0_1_0 + 3.914391935225194e-02*G0_1_1;
    block[3087] = -2.609594623483315e-03*G0_0_1 - 2.609594623483696e-03*G0_1_0 - 5.056089582999258e-02*G0_1_1;
    block[3088] = 2.609594623483676e-03*G0_0_1 + 2.609594623483622e-03*G0_1_0 - 4.534170658302550e-02*G0_1_1 + 2.609594623483598e-03*G0_1_2 + 2.609594623483519e-03*G0_2_1;
    block[3089] = 2.609594623483539e-02*G0_0_0 - 5.871587902837930e-03*G0_0_1 + 2.609594623483518e-02*G0_0_2 - 5.871587902837752e-03*G0_1_0 + 1.304797311741539e-03*G0_1_1 - 5.871587902837859e-03*G0_1_2 + 2.609594623483502e-02*G0_2_0 - 5.871587902837944e-03*G0_2_1 + 2.609594623483494e-02*G0_2_2;
    block[3090] = 3.914391935225167e-02*G0_0_0 + 7.176385214579459e-03*G0_0_1 + 3.914391935225184e-02*G0_0_2 + 7.176385214579166e-03*G0_1_0 + 1.304797311741753e-03*G0_1_1 + 7.176385214579323e-03*G0_1_2 + 3.914391935225237e-02*G0_2_0 + 7.176385214579803e-03*G0_2_1 + 3.914391935225251e-02*G0_2_2;
    block[3091] = -5.056089582999239e-02*G0_0_0 - 4.795130120650889e-02*G0_0_1 - 5.056089582999252e-02*G0_0_2 - 4.795130120650894e-02*G0_1_0 - 4.534170658302542e-02*G0_1_1 - 4.795130120650901e-02*G0_1_2 - 5.056089582999217e-02*G0_2_0 - 4.795130120650931e-02*G0_2_1 - 5.056089582999212e-02*G0_2_2;
    block[3092] = -4.534170658302560e-02*G0_0_0 - 4.795130120650921e-02*G0_0_1 - 4.795130120650921e-02*G0_0_2 - 4.795130120650892e-02*G0_1_0 - 5.056089582999257e-02*G0_1_1 - 5.056089582999256e-02*G0_1_2 - 4.795130120650927e-02*G0_2_0 - 5.056089582999224e-02*G0_2_1 - 5.056089582999213e-02*G0_2_2;
    block[3093] = 1.304797311741769e-03*G0_0_0 + 7.176385214579410e-03*G0_0_1 + 7.176385214579414e-03*G0_0_2 + 7.176385214579484e-03*G0_1_0 + 3.914391935225209e-02*G0_1_1 + 3.914391935225214e-02*G0_1_2 + 7.176385214579699e-03*G0_2_0 + 3.914391935225199e-02*G0_2_1 + 3.914391935225200e-02*G0_2_2;
    block[3094] = 1.304797311741866e-03*G0_0_0 - 5.871587902837669e-03*G0_0_1 - 5.871587902837649e-03*G0_0_2 - 5.871587902837746e-03*G0_1_0 + 2.609594623483479e-02*G0_1_1 + 2.609594623483480e-02*G0_1_2 - 5.871587902837923e-03*G0_2_0 + 2.609594623483480e-02*G0_2_1 + 2.609594623483476e-02*G0_2_2;
    block[3095] = -4.534170658302587e-02*G0_0_0 + 2.609594623483561e-03*G0_0_1 + 2.609594623483479e-03*G0_0_2 + 2.609594623483388e-03*G0_1_0 + 2.609594623483615e-03*G0_2_0;
    block[3096] = -1.565756774090089e-01*G0_0_0 - 1.565756774090090e-01*G0_0_1 - 1.539660827855255e-01*G0_0_2 - 1.565756774090088e-01*G0_1_0 - 1.565756774090088e-01*G0_1_1 - 1.539660827855253e-01*G0_1_2 - 1.539660827855251e-01*G0_2_0 - 1.539660827855252e-01*G0_2_1 - 1.513564881620421e-01*G0_2_2;
    block[3097] = 1.859336169231986e-01*G0_0_0 + 1.859336169231986e-01*G0_0_1 + 1.702760491822974e-01*G0_0_2 + 1.859336169231982e-01*G0_1_0 + 1.859336169231982e-01*G0_1_1 + 1.702760491822970e-01*G0_1_2 + 1.702760491822962e-01*G0_2_0 + 1.702760491822962e-01*G0_2_1 + 1.807144276762313e-01*G0_2_2;
    block[3098] = -1.859336169231983e-01*G0_0_0 - 1.859336169231983e-01*G0_0_1 - 9.557640308508214e-02*G0_0_2 - 1.859336169231989e-01*G0_1_0 - 1.859336169231989e-01*G0_1_1 - 9.557640308508197e-02*G0_1_2 - 9.557640308508199e-02*G0_2_0 - 9.557640308508202e-02*G0_2_1 - 1.617948666559758e-01*G0_2_2;
    block[3099] = 3.522952741702672e-02*G0_0_2 + 3.522952741702682e-02*G0_1_2 + 3.522952741702579e-02*G0_2_0 + 3.522952741702578e-02*G0_2_1 + 1.666878565750080e-01*G0_2_2;
    block[3100] = -1.565756774090097e-01*G0_0_0 - 2.609594623483483e-03*G0_0_2 - 2.609594623484184e-03*G0_2_0;
    block[3101] = 1.859336169231995e-01*G0_0_0 + 1.565756774090123e-02*G0_0_2 + 1.565756774090279e-02*G0_2_0 + 2.609594623483667e-02*G0_2_2;
    block[3102] = -1.859336169231994e-01*G0_0_0 - 9.035721383811632e-02*G0_0_2 - 9.035721383811736e-02*G0_2_0 - 1.565756774090112e-01*G0_2_2;
    block[3103] = -3.522952741702673e-02*G0_0_2 - 3.522952741702575e-02*G0_2_0 + 9.622880174095530e-02*G0_2_2;
    block[3104] = -1.565756774090089e-01*G0_1_1 - 2.609594623483634e-03*G0_1_2 - 2.609594623484002e-03*G0_2_1;
    block[3105] = 1.859336169231987e-01*G0_1_1 + 1.565756774090181e-02*G0_1_2 + 1.565756774090213e-02*G0_2_1 + 2.609594623483602e-02*G0_2_2;
    block[3106] = -1.859336169231984e-01*G0_1_1 - 9.035721383811626e-02*G0_1_2 - 9.035721383811710e-02*G0_2_1 - 1.565756774090107e-01*G0_2_2;
    block[3107] = -3.522952741702696e-02*G0_1_2 - 3.522952741702577e-02*G0_2_1 + 9.622880174095526e-02*G0_2_2;
    block[3108] = 2.935793951418929e-01*G0_0_0 + 5.871587902837897e-02*G0_0_1 + 7.502584542515024e-02*G0_0_2 + 5.871587902837969e-02*G0_1_0 + 2.609594623483462e-02*G0_1_2 + 7.502584542515141e-02*G0_2_0 + 2.609594623483568e-02*G0_2_1;
    block[3109] = -7.828783870450478e-01*G0_0_0 - 2.984723850609243e-01*G0_0_1 - 2.984723850609238e-01*G0_0_2 - 2.984723850609244e-01*G0_1_0 - 1.027527882996610e-01*G0_1_2 - 2.984723850609243e-01*G0_2_0 - 1.027527882996618e-01*G0_2_1 + 1.467896975709500e-01*G0_2_2;
    block[3110] = -1.859336169231978e-01*G0_0_1 - 3.164133480973723e-01*G0_0_2 - 1.859336169231987e-01*G0_1_0 - 3.164133480973737e-01*G0_1_2 - 3.164133480973723e-01*G0_2_0 - 3.164133480973724e-01*G0_2_1 - 7.828783870450493e-01*G0_2_2;
    block[3111] = -4.892989919031474e-02*G0_0_0 - 2.935793951418907e-02*G0_0_1 + 9.296680846159994e-02*G0_0_2 - 2.935793951419013e-02*G0_1_0 - 4.892989919031614e-02*G0_1_1 + 9.296680846159863e-02*G0_1_2 + 9.296680846160014e-02*G0_2_0 + 9.296680846160020e-02*G0_2_1;
    block[3112] = -2.984723850609237e-01*G0_0_1 - 1.027527882996623e-01*G0_0_2 - 2.984723850609238e-01*G0_1_0 - 7.828783870450475e-01*G0_1_1 - 2.984723850609236e-01*G0_1_2 - 1.027527882996619e-01*G0_2_0 - 2.984723850609238e-01*G0_2_1 + 1.467896975709486e-01*G0_2_2;
    block[3113] = 5.871587902837926e-02*G0_0_1 + 2.609594623483572e-02*G0_0_2 + 5.871587902838008e-02*G0_1_0 + 2.935793951418940e-01*G0_1_1 + 7.502584542515081e-02*G0_1_2 + 2.609594623483493e-02*G0_2_0 + 7.502584542515042e-02*G0_2_1;
    block[3114] = -5.871587902837970e-02*G0_0_1 - 2.609594623483529e-02*G0_0_2 - 5.871587902837980e-02*G0_1_0 + 1.761476370851349e-01*G0_1_1 - 9.785979838064066e-03*G0_1_2 - 2.609594623483475e-02*G0_2_0 - 9.785979838063156e-03*G0_2_1 - 5.219189246967101e-02*G0_2_2;
    block[3115] = 2.984723850609253e-01*G0_0_1 + 1.027527882996621e-01*G0_0_2 + 2.984723850609237e-01*G0_1_0 - 1.859336169232000e-01*G0_1_1 + 1.027527882996617e-01*G0_1_2 + 1.027527882996619e-01*G0_2_0 + 1.027527882996617e-01*G0_2_1 + 3.522952741702721e-01*G0_2_2;
    block[3116] = 1.859336169231981e-01*G0_0_1 + 3.164133480973734e-01*G0_0_2 + 1.859336169231987e-01*G0_1_0 + 3.718672338463977e-01*G0_1_1 + 1.859336169231992e-01*G0_1_2 + 3.164133480973721e-01*G0_2_0 + 1.859336169231994e-01*G0_2_1 - 1.500516908503025e-01*G0_2_2;
    block[3117] = -4.892989919031484e-02*G0_0_0 - 1.957195967612466e-02*G0_0_1 - 1.418967076519143e-01*G0_0_2 - 1.957195967612414e-02*G0_1_0 - 3.914391935225128e-02*G0_1_1 - 1.957195967612509e-02*G0_1_2 - 1.418967076519136e-01*G0_2_0 - 1.957195967612611e-02*G0_2_1 - 2.348635161135139e-01*G0_2_2;
    block[3118] = -7.828783870450474e-01*G0_0_0 - 4.844060019841240e-01*G0_0_1 - 4.844060019841233e-01*G0_0_2 - 4.844060019841224e-01*G0_1_0 - 1.859336169231972e-01*G0_1_1 - 2.886864052228609e-01*G0_1_2 - 4.844060019841224e-01*G0_2_0 - 2.886864052228598e-01*G0_2_1 - 3.914391935225043e-02*G0_2_2;
    block[3119] = 2.935793951418920e-01*G0_0_0 + 2.348635161135133e-01*G0_0_1 + 2.185535497167423e-01*G0_0_2 + 2.348635161135129e-01*G0_1_0 + 1.761476370851346e-01*G0_1_1 + 1.859336169231982e-01*G0_1_2 + 2.185535497167416e-01*G0_2_0 + 1.859336169231985e-01*G0_2_1 + 1.435277042915903e-01*G0_2_2;
    block[3120] = 3.718672338463973e-01*G0_0_0 + 1.859336169231974e-01*G0_0_1 + 1.859336169231985e-01*G0_0_2 + 1.859336169231990e-01*G0_1_0 + 3.164133480973738e-01*G0_1_2 + 1.859336169231992e-01*G0_2_0 + 3.164133480973719e-01*G0_2_1 - 1.500516908503023e-01*G0_2_2;
    block[3121] = -1.859336169231987e-01*G0_0_0 + 2.984723850609239e-01*G0_0_1 + 1.027527882996628e-01*G0_0_2 + 2.984723850609228e-01*G0_1_0 + 1.027527882996620e-01*G0_1_2 + 1.027527882996600e-01*G0_2_0 + 1.027527882996614e-01*G0_2_1 + 3.522952741702715e-01*G0_2_2;
    block[3122] = 1.761476370851358e-01*G0_0_0 - 5.871587902837874e-02*G0_0_1 - 9.785979838063332e-03*G0_0_2 - 5.871587902837790e-02*G0_1_0 - 2.609594623483562e-02*G0_1_2 - 9.785979838062417e-03*G0_2_0 - 2.609594623483556e-02*G0_2_1 - 5.219189246967140e-02*G0_2_2;
    block[3123] = -1.859336169231988e-01*G0_0_0 - 4.844060019841230e-01*G0_0_1 - 2.886864052228615e-01*G0_0_2 - 4.844060019841219e-01*G0_1_0 - 7.828783870450468e-01*G0_1_1 - 4.844060019841234e-01*G0_1_2 - 2.886864052228589e-01*G0_2_0 - 4.844060019841219e-01*G0_2_1 - 3.914391935225060e-02*G0_2_2;
    block[3124] = -3.914391935225272e-02*G0_0_0 - 1.957195967612647e-02*G0_0_1 - 1.957195967612660e-02*G0_0_2 - 1.957195967612613e-02*G0_1_0 - 4.892989919031489e-02*G0_1_1 - 1.418967076519140e-01*G0_1_2 - 1.957195967612597e-02*G0_2_0 - 1.418967076519131e-01*G0_2_1 - 2.348635161135126e-01*G0_2_2;
    block[3125] = 1.761476370851354e-01*G0_0_0 + 2.348635161135142e-01*G0_0_1 + 1.859336169231992e-01*G0_0_2 + 2.348635161135133e-01*G0_1_0 + 2.935793951418920e-01*G0_1_1 + 2.185535497167421e-01*G0_1_2 + 1.859336169231979e-01*G0_2_0 + 2.185535497167411e-01*G0_2_1 + 1.435277042915904e-01*G0_2_2;
    block[3126] = 4.566790591096095e-02*G0_0_0 + 7.176385214579577e-02*G0_0_1 + 1.206937513361105e-01*G0_0_2 + 7.176385214579570e-02*G0_1_0 + 4.566790591096093e-02*G0_1_1 + 1.206937513361107e-01*G0_1_2 + 1.206937513361111e-01*G0_2_0 + 1.206937513361118e-01*G0_2_1 + 1.957195967612619e-01*G0_2_2;
    block[3127] = 9.785979838062940e-03*G0_0_0 + 4.892989919031560e-03*G0_0_1 + 4.892989919031594e-03*G0_0_2 + 4.892989919031340e-03*G0_1_0 - 3.914391935225250e-02*G0_1_1 + 5.382288910934657e-02*G0_1_2 + 4.892989919031573e-03*G0_2_0 + 5.382288910934733e-02*G0_2_1 + 1.467896975709466e-01*G0_2_2;
    block[3128] = 4.566790591096121e-02*G0_0_0 - 2.609594623483487e-02*G0_0_1 - 7.502584542514995e-02*G0_0_2 - 2.609594623483415e-02*G0_1_0 - 5.219189246966978e-02*G0_1_1 - 2.609594623483444e-02*G0_1_2 - 7.502584542515001e-02*G0_2_0 - 2.609594623483463e-02*G0_2_1;
    block[3129] = -3.914391935225147e-02*G0_0_0 + 4.892989919032358e-03*G0_0_1 + 5.382288910934788e-02*G0_0_2 + 4.892989919032092e-03*G0_1_0 + 9.785979838063771e-03*G0_1_1 + 4.892989919032563e-03*G0_1_2 + 5.382288910934720e-02*G0_2_0 + 4.892989919031359e-03*G0_2_1 + 1.467896975709475e-01*G0_2_2;
    block[3130] = -3.914391935225250e-02*G0_0_0 - 4.403690927128450e-02*G0_0_1 - 9.296680846159977e-02*G0_0_2 - 4.403690927128406e-02*G0_1_0 - 3.914391935225204e-02*G0_1_1 - 9.296680846159881e-02*G0_1_2 - 9.296680846159901e-02*G0_2_0 - 9.296680846159940e-02*G0_2_1;
    block[3131] = -5.219189246967071e-02*G0_0_0 - 2.609594623483559e-02*G0_0_1 - 2.609594623483576e-02*G0_0_2 - 2.609594623483500e-02*G0_1_0 + 4.566790591096045e-02*G0_1_1 - 7.502584542515064e-02*G0_1_2 - 2.609594623483533e-02*G0_2_0 - 7.502584542515063e-02*G0_2_1;
    block[3132] = -2.935793951418915e-01*G0_0_0 - 3.425092943322082e-01*G0_0_1 - 5.871587902837848e-01*G0_0_2 - 3.425092943322058e-01*G0_1_0 - 2.935793951418902e-01*G0_1_1 - 5.871587902837824e-01*G0_1_2 - 5.871587902837844e-01*G0_2_0 - 5.871587902837846e-01*G0_2_1 - 1.174317580567570e+00*G0_2_2;
    block[3133] = -2.935793951418932e-01*G0_0_0 + 4.892989919031538e-02*G0_0_1 + 2.935793951418916e-01*G0_0_2 + 4.892989919031338e-02*G0_1_0 + 9.785979838063096e-02*G0_1_1 + 4.892989919031403e-02*G0_1_2 + 2.935793951418917e-01*G0_2_0 + 4.892989919031294e-02*G0_2_1 - 2.935793951418966e-01*G0_2_2;
    block[3134] = 9.785979838062897e-02*G0_0_0 + 4.892989919031495e-02*G0_0_1 + 4.892989919031396e-02*G0_0_2 + 4.892989919031409e-02*G0_1_0 - 2.935793951418948e-01*G0_1_1 + 2.935793951418912e-01*G0_1_2 + 4.892989919031292e-02*G0_2_0 + 2.935793951418936e-01*G0_2_1 - 2.935793951418961e-01*G0_2_2;
    block[3135] = 1.565756774090095e+00*G0_0_0 + 7.828783870450461e-01*G0_0_1 + 7.828783870450469e-01*G0_0_2 + 7.828783870450461e-01*G0_1_0 + 1.565756774090094e+00*G0_1_1 + 7.828783870450452e-01*G0_1_2 + 7.828783870450469e-01*G0_2_0 + 7.828783870450453e-01*G0_2_1 + 1.761476370851357e+00*G0_2_2;
  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 56;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      static unsigned int face_reordering_0[6][6] = {{0, 1, 2, 3, 4, 5}, {0, 3, 5, 1, 4, 2}, {5, 3, 0, 4, 1, 2}, {2, 1, 0, 4, 3, 5}, {2, 4, 5, 1, 3, 0}, {5, 4, 2, 3, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][2];
      dofs[7] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][2];
      dofs[11] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][2];
      dofs[15] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(3);
      dofs[16] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][2];
      dofs[19] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(4);
      dofs[20] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[21] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[22] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][2];
      dofs[23] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(5);
      dofs[24] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[25] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[26] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][2];
      dofs[27] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][3];
      alignment = cell.faceAlignment(0);
      offset = offset + 4*mesh.noEdges();
      dofs[28] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[29] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[30] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][2];
      dofs[31] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][3];
      dofs[32] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][4];
      dofs[33] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(1);
      dofs[34] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[35] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[36] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][2];
      dofs[37] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][3];
      dofs[38] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][4];
      dofs[39] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(2);
      dofs[40] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[41] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[42] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][2];
      dofs[43] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][3];
      dofs[44] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][4];
      dofs[45] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(3);
      dofs[46] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[47] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[48] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][2];
      dofs[49] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][3];
      dofs[50] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][4];
      dofs[51] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][5];
      offset = offset + 6*mesh.noFaces();
      dofs[52] = offset + 4*cell.id() + 0;
      dofs[53] = offset + 4*cell.id() + 1;
      dofs[54] = offset + 4*cell.id() + 2;
      dofs[55] = offset + 4*cell.id() + 3;
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(8.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(6.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(4.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[7] = map(2.000000000000000e-01, 8.000000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 8.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 6.000000000000000e-01, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 4.000000000000000e-01, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(2.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(4.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[14] = map(6.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[15] = map(8.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[16] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.000000000000000e-01);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 4.000000000000000e-01);
      points[18] = map(0.000000000000000e+00, 0.000000000000000e+00, 6.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 0.000000000000000e+00, 8.000000000000000e-01);
      points[20] = map(8.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[21] = map(6.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[22] = map(4.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[23] = map(2.000000000000000e-01, 0.000000000000000e+00, 8.000000000000000e-01);
      points[24] = map(0.000000000000000e+00, 8.000000000000000e-01, 2.000000000000000e-01);
      points[25] = map(0.000000000000000e+00, 6.000000000000000e-01, 4.000000000000000e-01);
      points[26] = map(0.000000000000000e+00, 4.000000000000000e-01, 6.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.000000000000000e-01, 8.000000000000000e-01);
      points[28] = map(6.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[29] = map(4.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      points[30] = map(2.000000000000000e-01, 2.000000000000000e-01, 6.000000000000000e-01);
      points[31] = map(4.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[32] = map(2.000000000000000e-01, 4.000000000000000e-01, 4.000000000000000e-01);
      points[33] = map(2.000000000000000e-01, 6.000000000000000e-01, 2.000000000000000e-01);
      points[34] = map(0.000000000000000e+00, 6.000000000000000e-01, 2.000000000000000e-01);
      points[35] = map(0.000000000000000e+00, 4.000000000000000e-01, 4.000000000000000e-01);
      points[36] = map(0.000000000000000e+00, 2.000000000000000e-01, 6.000000000000000e-01);
      points[37] = map(0.000000000000000e+00, 4.000000000000000e-01, 2.000000000000000e-01);
      points[38] = map(0.000000000000000e+00, 2.000000000000000e-01, 4.000000000000000e-01);
      points[39] = map(0.000000000000000e+00, 2.000000000000000e-01, 2.000000000000000e-01);
      points[40] = map(2.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[41] = map(4.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[42] = map(6.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[43] = map(2.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[44] = map(4.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[45] = map(2.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[46] = map(2.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[47] = map(4.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[48] = map(6.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[49] = map(2.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[50] = map(4.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[51] = map(2.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[52] = map(2.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[53] = map(4.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[54] = map(2.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[55] = map(2.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
      components[35] = 0;
      components[36] = 0;
      components[37] = 0;
      components[38] = 0;
      components[39] = 0;
      components[40] = 0;
      components[41] = 0;
      components[42] = 0;
      components[43] = 0;
      components[44] = 0;
      components[45] = 0;
      components[46] = 0;
      components[47] = 0;
      components[48] = 0;
      components[49] = 0;
      components[50] = 0;
      components[51] = 0;
      components[52] = 0;
      components[53] = 0;
      components[54] = 0;
      components[55] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 56;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][4] = {{0, 1, 2, 3}, {3, 2, 1, 0}};
      static unsigned int face_reordering_0[6][6] = {{0, 1, 2, 3, 4, 5}, {0, 3, 5, 1, 4, 2}, {5, 3, 0, 4, 1, 2}, {2, 1, 0, 4, 3, 5}, {2, 4, 5, 1, 3, 0}, {5, 4, 2, 3, 1, 0}};
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.noVertices();
      dofs[4] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][0];
      dofs[5] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][1];
      dofs[6] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][2];
      dofs[7] = offset + 4*cell.edgeID(0) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(1);
      dofs[8] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][0];
      dofs[9] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][1];
      dofs[10] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][2];
      dofs[11] = offset + 4*cell.edgeID(1) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(2);
      dofs[12] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][0];
      dofs[13] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][1];
      dofs[14] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][2];
      dofs[15] = offset + 4*cell.edgeID(2) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(3);
      dofs[16] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][0];
      dofs[17] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][1];
      dofs[18] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][2];
      dofs[19] = offset + 4*cell.edgeID(3) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(4);
      dofs[20] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][0];
      dofs[21] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][1];
      dofs[22] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][2];
      dofs[23] = offset + 4*cell.edgeID(4) + edge_reordering_0[alignment][3];
      alignment = cell.edgeAlignment(5);
      dofs[24] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][0];
      dofs[25] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][1];
      dofs[26] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][2];
      dofs[27] = offset + 4*cell.edgeID(5) + edge_reordering_0[alignment][3];
      alignment = cell.faceAlignment(0);
      offset = offset + 4*mesh.noEdges();
      dofs[28] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][0];
      dofs[29] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][1];
      dofs[30] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][2];
      dofs[31] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][3];
      dofs[32] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][4];
      dofs[33] = offset + 6*cell.faceID(0) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(1);
      dofs[34] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][0];
      dofs[35] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][1];
      dofs[36] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][2];
      dofs[37] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][3];
      dofs[38] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][4];
      dofs[39] = offset + 6*cell.faceID(1) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(2);
      dofs[40] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][0];
      dofs[41] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][1];
      dofs[42] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][2];
      dofs[43] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][3];
      dofs[44] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][4];
      dofs[45] = offset + 6*cell.faceID(2) + face_reordering_0[alignment][5];
      alignment = cell.faceAlignment(3);
      dofs[46] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][0];
      dofs[47] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][1];
      dofs[48] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][2];
      dofs[49] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][3];
      dofs[50] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][4];
      dofs[51] = offset + 6*cell.faceID(3) + face_reordering_0[alignment][5];
      offset = offset + 6*mesh.noFaces();
      dofs[52] = offset + 4*cell.id() + 0;
      dofs[53] = offset + 4*cell.id() + 1;
      dofs[54] = offset + 4*cell.id() + 2;
      dofs[55] = offset + 4*cell.id() + 3;
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(8.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(6.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(4.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[7] = map(2.000000000000000e-01, 8.000000000000000e-01, 0.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 8.000000000000000e-01, 0.000000000000000e+00);
      points[9] = map(0.000000000000000e+00, 6.000000000000000e-01, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 4.000000000000000e-01, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 2.000000000000000e-01, 0.000000000000000e+00);
      points[12] = map(2.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(4.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[14] = map(6.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[15] = map(8.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[16] = map(0.000000000000000e+00, 0.000000000000000e+00, 2.000000000000000e-01);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 4.000000000000000e-01);
      points[18] = map(0.000000000000000e+00, 0.000000000000000e+00, 6.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 0.000000000000000e+00, 8.000000000000000e-01);
      points[20] = map(8.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[21] = map(6.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[22] = map(4.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[23] = map(2.000000000000000e-01, 0.000000000000000e+00, 8.000000000000000e-01);
      points[24] = map(0.000000000000000e+00, 8.000000000000000e-01, 2.000000000000000e-01);
      points[25] = map(0.000000000000000e+00, 6.000000000000000e-01, 4.000000000000000e-01);
      points[26] = map(0.000000000000000e+00, 4.000000000000000e-01, 6.000000000000000e-01);
      points[27] = map(0.000000000000000e+00, 2.000000000000000e-01, 8.000000000000000e-01);
      points[28] = map(6.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[29] = map(4.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      points[30] = map(2.000000000000000e-01, 2.000000000000000e-01, 6.000000000000000e-01);
      points[31] = map(4.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[32] = map(2.000000000000000e-01, 4.000000000000000e-01, 4.000000000000000e-01);
      points[33] = map(2.000000000000000e-01, 6.000000000000000e-01, 2.000000000000000e-01);
      points[34] = map(0.000000000000000e+00, 6.000000000000000e-01, 2.000000000000000e-01);
      points[35] = map(0.000000000000000e+00, 4.000000000000000e-01, 4.000000000000000e-01);
      points[36] = map(0.000000000000000e+00, 2.000000000000000e-01, 6.000000000000000e-01);
      points[37] = map(0.000000000000000e+00, 4.000000000000000e-01, 2.000000000000000e-01);
      points[38] = map(0.000000000000000e+00, 2.000000000000000e-01, 4.000000000000000e-01);
      points[39] = map(0.000000000000000e+00, 2.000000000000000e-01, 2.000000000000000e-01);
      points[40] = map(2.000000000000000e-01, 0.000000000000000e+00, 6.000000000000000e-01);
      points[41] = map(4.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[42] = map(6.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[43] = map(2.000000000000000e-01, 0.000000000000000e+00, 4.000000000000000e-01);
      points[44] = map(4.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[45] = map(2.000000000000000e-01, 0.000000000000000e+00, 2.000000000000000e-01);
      points[46] = map(2.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[47] = map(4.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[48] = map(6.000000000000000e-01, 2.000000000000000e-01, 0.000000000000000e+00);
      points[49] = map(2.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[50] = map(4.000000000000000e-01, 4.000000000000000e-01, 0.000000000000000e+00);
      points[51] = map(2.000000000000000e-01, 6.000000000000000e-01, 0.000000000000000e+00);
      points[52] = map(2.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[53] = map(4.000000000000000e-01, 2.000000000000000e-01, 2.000000000000000e-01);
      points[54] = map(2.000000000000000e-01, 4.000000000000000e-01, 2.000000000000000e-01);
      points[55] = map(2.000000000000000e-01, 2.000000000000000e-01, 4.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 0;
      components[11] = 0;
      components[12] = 0;
      components[13] = 0;
      components[14] = 0;
      components[15] = 0;
      components[16] = 0;
      components[17] = 0;
      components[18] = 0;
      components[19] = 0;
      components[20] = 0;
      components[21] = 0;
      components[22] = 0;
      components[23] = 0;
      components[24] = 0;
      components[25] = 0;
      components[26] = 0;
      components[27] = 0;
      components[28] = 0;
      components[29] = 0;
      components[30] = 0;
      components[31] = 0;
      components[32] = 0;
      components[33] = 0;
      components[34] = 0;
      components[35] = 0;
      components[36] = 0;
      components[37] = 0;
      components[38] = 0;
      components[39] = 0;
      components[40] = 0;
      components[41] = 0;
      components[42] = 0;
      components[43] = 0;
      components[44] = 0;
      components[45] = 0;
      components[46] = 0;
      components[47] = 0;
      components[48] = 0;
      components[49] = 0;
      components[50] = 0;
      components[51] = 0;
      components[52] = 0;
      components[53] = 0;
      components[54] = 0;
      components[55] = 0;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];
    const real c0_4 = c[0][4];
    const real c0_5 = c[0][5];
    const real c0_6 = c[0][6];
    const real c0_7 = c[0][7];
    const real c0_8 = c[0][8];
    const real c0_9 = c[0][9];
    const real c0_10 = c[0][10];
    const real c0_11 = c[0][11];
    const real c0_12 = c[0][12];
    const real c0_13 = c[0][13];
    const real c0_14 = c[0][14];
    const real c0_15 = c[0][15];
    const real c0_16 = c[0][16];
    const real c0_17 = c[0][17];
    const real c0_18 = c[0][18];
    const real c0_19 = c[0][19];
    const real c0_20 = c[0][20];
    const real c0_21 = c[0][21];
    const real c0_22 = c[0][22];
    const real c0_23 = c[0][23];
    const real c0_24 = c[0][24];
    const real c0_25 = c[0][25];
    const real c0_26 = c[0][26];
    const real c0_27 = c[0][27];
    const real c0_28 = c[0][28];
    const real c0_29 = c[0][29];
    const real c0_30 = c[0][30];
    const real c0_31 = c[0][31];
    const real c0_32 = c[0][32];
    const real c0_33 = c[0][33];
    const real c0_34 = c[0][34];
    const real c0_35 = c[0][35];
    const real c0_36 = c[0][36];
    const real c0_37 = c[0][37];
    const real c0_38 = c[0][38];
    const real c0_39 = c[0][39];
    const real c0_40 = c[0][40];
    const real c0_41 = c[0][41];
    const real c0_42 = c[0][42];
    const real c0_43 = c[0][43];
    const real c0_44 = c[0][44];
    const real c0_45 = c[0][45];
    const real c0_46 = c[0][46];
    const real c0_47 = c[0][47];
    const real c0_48 = c[0][48];
    const real c0_49 = c[0][49];
    const real c0_50 = c[0][50];
    const real c0_51 = c[0][51];
    const real c0_52 = c[0][52];
    const real c0_53 = c[0][53];
    const real c0_54 = c[0][54];
    const real c0_55 = c[0][55];

    // Compute geometry tensors
    const real G0_0 = map.det*c0_0;
    const real G0_1 = map.det*c0_1;
    const real G0_2 = map.det*c0_2;
    const real G0_3 = map.det*c0_3;
    const real G0_4 = map.det*c0_4;
    const real G0_5 = map.det*c0_5;
    const real G0_6 = map.det*c0_6;
    const real G0_7 = map.det*c0_7;
    const real G0_8 = map.det*c0_8;
    const real G0_9 = map.det*c0_9;
    const real G0_10 = map.det*c0_10;
    const real G0_11 = map.det*c0_11;
    const real G0_12 = map.det*c0_12;
    const real G0_13 = map.det*c0_13;
    const real G0_14 = map.det*c0_14;
    const real G0_15 = map.det*c0_15;
    const real G0_16 = map.det*c0_16;
    const real G0_17 = map.det*c0_17;
    const real G0_18 = map.det*c0_18;
    const real G0_19 = map.det*c0_19;
    const real G0_20 = map.det*c0_20;
    const real G0_21 = map.det*c0_21;
    const real G0_22 = map.det*c0_22;
    const real G0_23 = map.det*c0_23;
    const real G0_24 = map.det*c0_24;
    const real G0_25 = map.det*c0_25;
    const real G0_26 = map.det*c0_26;
    const real G0_27 = map.det*c0_27;
    const real G0_28 = map.det*c0_28;
    const real G0_29 = map.det*c0_29;
    const real G0_30 = map.det*c0_30;
    const real G0_31 = map.det*c0_31;
    const real G0_32 = map.det*c0_32;
    const real G0_33 = map.det*c0_33;
    const real G0_34 = map.det*c0_34;
    const real G0_35 = map.det*c0_35;
    const real G0_36 = map.det*c0_36;
    const real G0_37 = map.det*c0_37;
    const real G0_38 = map.det*c0_38;
    const real G0_39 = map.det*c0_39;
    const real G0_40 = map.det*c0_40;
    const real G0_41 = map.det*c0_41;
    const real G0_42 = map.det*c0_42;
    const real G0_43 = map.det*c0_43;
    const real G0_44 = map.det*c0_44;
    const real G0_45 = map.det*c0_45;
    const real G0_46 = map.det*c0_46;
    const real G0_47 = map.det*c0_47;
    const real G0_48 = map.det*c0_48;
    const real G0_49 = map.det*c0_49;
    const real G0_50 = map.det*c0_50;
    const real G0_51 = map.det*c0_51;
    const real G0_52 = map.det*c0_52;
    const real G0_53 = map.det*c0_53;
    const real G0_54 = map.det*c0_54;
    const real G0_55 = map.det*c0_55;

    // Compute element tensor
    block[0] = 8.349578662079096e-05*G0_0 + 9.278514052820081e-06*G0_1 + 9.278514052820123e-06*G0_2 + 9.278514052820135e-06*G0_3 + 4.074982373593870e-06*G0_4 + 1.529623925457323e-05*G0_5 + 1.529623925457358e-05*G0_6 + 4.074982373593504e-06*G0_7 + 1.818686714520132e-05*G0_8 - 4.438318240401786e-05*G0_9 + 6.040207863124805e-05*G0_10 - 6.040207863124819e-05*G0_11 - 6.040207863124851e-05*G0_12 + 6.040207863124882e-05*G0_13 - 4.438318240401814e-05*G0_14 + 1.818686714520143e-05*G0_15 - 6.040207863124796e-05*G0_16 + 6.040207863124785e-05*G0_17 - 4.438318240401757e-05*G0_18 + 1.818686714520118e-05*G0_19 + 4.074982373593963e-06*G0_20 + 1.529623925457305e-05*G0_21 + 1.529623925457398e-05*G0_22 + 4.074982373593485e-06*G0_23 + 4.074982373593735e-06*G0_24 + 1.529623925457313e-05*G0_25 + 1.529623925457351e-05*G0_26 + 4.074982373593535e-06*G0_27 + 1.734376734376831e-04*G0_28 - 1.771513273249494e-05*G0_29 + 1.734376734376822e-04*G0_30 - 1.771513273249466e-05*G0_31 - 1.771513273249511e-05*G0_32 + 1.734376734376828e-04*G0_33 + 9.595278692501431e-05*G0_34 + 3.984650252011542e-05*G0_35 + 9.595278692501389e-05*G0_36 - 1.214967035279600e-04*G0_37 - 1.214967035279590e-04*G0_38 + 1.496502147543894e-04*G0_39 + 9.595278692501406e-05*G0_40 + 3.984650252011556e-05*G0_41 + 9.595278692501474e-05*G0_42 - 1.214967035279601e-04*G0_43 - 1.214967035279605e-04*G0_44 + 1.496502147543898e-04*G0_45 + 1.496502147543896e-04*G0_46 - 1.214967035279606e-04*G0_47 + 9.595278692501474e-05*G0_48 - 1.214967035279601e-04*G0_49 + 3.984650252011575e-05*G0_50 + 9.595278692501429e-05*G0_51 - 2.800295769045909e-04*G0_52 + 2.042509637995861e-04*G0_53 + 2.042509637995856e-04*G0_54 + 2.042509637995844e-04*G0_55;
    block[1] = 9.278514052820083e-06*G0_0 + 8.349578662079107e-05*G0_1 + 9.278514052820056e-06*G0_2 + 9.278514052820088e-06*G0_3 - 6.040207863124880e-05*G0_4 + 6.040207863124899e-05*G0_5 - 4.438318240401869e-05*G0_6 + 1.818686714520159e-05*G0_7 + 4.074982373593773e-06*G0_8 + 1.529623925457329e-05*G0_9 + 1.529623925457350e-05*G0_10 + 4.074982373593585e-06*G0_11 + 1.818686714520153e-05*G0_12 - 4.438318240401821e-05*G0_13 + 6.040207863124864e-05*G0_14 - 6.040207863124864e-05*G0_15 + 4.074982373593689e-06*G0_16 + 1.529623925457340e-05*G0_17 + 1.529623925457337e-05*G0_18 + 4.074982373593800e-06*G0_19 - 6.040207863124855e-05*G0_20 + 6.040207863124859e-05*G0_21 - 4.438318240401823e-05*G0_22 + 1.818686714520159e-05*G0_23 + 4.074982373593819e-06*G0_24 + 1.529623925457327e-05*G0_25 + 1.529623925457346e-05*G0_26 + 4.074982373593742e-06*G0_27 + 1.496502147543885e-04*G0_28 - 1.214967035279594e-04*G0_29 + 9.595278692501378e-05*G0_30 - 1.214967035279596e-04*G0_31 + 3.984650252011565e-05*G0_32 + 9.595278692501462e-05*G0_33 + 1.734376734376830e-04*G0_34 - 1.771513273249492e-05*G0_35 + 1.734376734376824e-04*G0_36 - 1.771513273249520e-05*G0_37 - 1.771513273249474e-05*G0_38 + 1.734376734376826e-04*G0_39 + 9.595278692501412e-05*G0_40 - 1.214967035279596e-04*G0_41 + 1.496502147543884e-04*G0_42 + 3.984650252011544e-05*G0_43 - 1.214967035279597e-04*G0_44 + 9.595278692501435e-05*G0_45 + 9.595278692501408e-05*G0_46 - 1.214967035279598e-04*G0_47 + 1.496502147543884e-04*G0_48 + 3.984650252011514e-05*G0_49 - 1.214967035279595e-04*G0_50 + 9.595278692501440e-05*G0_51 + 2.042509637995856e-04*G0_52 - 2.800295769045921e-04*G0_53 + 2.042509637995867e-04*G0_54 + 2.042509637995854e-04*G0_55;
    block[2] = 9.278514052820123e-06*G0_0 + 9.278514052820052e-06*G0_1 + 8.349578662079080e-05*G0_2 + 9.278514052820093e-06*G0_3 + 1.818686714520150e-05*G0_4 - 4.438318240401832e-05*G0_5 + 6.040207863124877e-05*G0_6 - 6.040207863124867e-05*G0_7 - 6.040207863124864e-05*G0_8 + 6.040207863124861e-05*G0_9 - 4.438318240401823e-05*G0_10 + 1.818686714520142e-05*G0_11 + 4.074982373593577e-06*G0_12 + 1.529623925457360e-05*G0_13 + 1.529623925457332e-05*G0_14 + 4.074982373593822e-06*G0_15 + 4.074982373593659e-06*G0_16 + 1.529623925457335e-05*G0_17 + 1.529623925457343e-05*G0_18 + 4.074982373593685e-06*G0_19 + 4.074982373593764e-06*G0_20 + 1.529623925457332e-05*G0_21 + 1.529623925457351e-05*G0_22 + 4.074982373593701e-06*G0_23 - 6.040207863124851e-05*G0_24 + 6.040207863124847e-05*G0_25 - 4.438318240401814e-05*G0_26 + 1.818686714520145e-05*G0_27 + 9.595278692501421e-05*G0_28 + 3.984650252011552e-05*G0_29 + 9.595278692501439e-05*G0_30 - 1.214967035279598e-04*G0_31 - 1.214967035279598e-04*G0_32 + 1.496502147543890e-04*G0_33 + 1.496502147543888e-04*G0_34 - 1.214967035279595e-04*G0_35 + 9.595278692501413e-05*G0_36 - 1.214967035279601e-04*G0_37 + 3.984650252011559e-05*G0_38 + 9.595278692501436e-05*G0_39 + 1.734376734376825e-04*G0_40 - 1.771513273249508e-05*G0_41 + 1.734376734376828e-04*G0_42 - 1.771513273249505e-05*G0_43 - 1.771513273249503e-05*G0_44 + 1.734376734376827e-04*G0_45 + 9.595278692501413e-05*G0_46 + 3.984650252011533e-05*G0_47 + 9.595278692501432e-05*G0_48 - 1.214967035279602e-04*G0_49 - 1.214967035279599e-04*G0_50 + 1.496502147543889e-04*G0_51 + 2.042509637995853e-04*G0_52 + 2.042509637995858e-04*G0_53 - 2.800295769045914e-04*G0_54 + 2.042509637995860e-04*G0_55;
    block[3] = 9.278514052820135e-06*G0_0 + 9.278514052820086e-06*G0_1 + 9.278514052820093e-06*G0_2 + 8.349578662079110e-05*G0_3 + 4.074982373593703e-06*G0_4 + 1.529623925457349e-05*G0_5 + 1.529623925457330e-05*G0_6 + 4.074982373593757e-06*G0_7 + 4.074982373593699e-06*G0_8 + 1.529623925457346e-05*G0_9 + 1.529623925457333e-05*G0_10 + 4.074982373593725e-06*G0_11 + 4.074982373593731e-06*G0_12 + 1.529623925457349e-05*G0_13 + 1.529623925457348e-05*G0_14 + 4.074982373593703e-06*G0_15 + 1.818686714520149e-05*G0_16 - 4.438318240401822e-05*G0_17 + 6.040207863124858e-05*G0_18 - 6.040207863124855e-05*G0_19 + 1.818686714520152e-05*G0_20 - 4.438318240401835e-05*G0_21 + 6.040207863124880e-05*G0_22 - 6.040207863124859e-05*G0_23 + 1.818686714520153e-05*G0_24 - 4.438318240401828e-05*G0_25 + 6.040207863124858e-05*G0_26 - 6.040207863124860e-05*G0_27 + 9.595278692501399e-05*G0_28 - 1.214967035279602e-04*G0_29 + 1.496502147543892e-04*G0_30 + 3.984650252011593e-05*G0_31 - 1.214967035279601e-04*G0_32 + 9.595278692501428e-05*G0_33 + 9.595278692501435e-05*G0_34 - 1.214967035279600e-04*G0_35 + 1.496502147543892e-04*G0_36 + 3.984650252011550e-05*G0_37 - 1.214967035279598e-04*G0_38 + 9.595278692501427e-05*G0_39 + 1.496502147543891e-04*G0_40 - 1.214967035279601e-04*G0_41 + 9.595278692501418e-05*G0_42 - 1.214967035279601e-04*G0_43 + 3.984650252011581e-05*G0_44 + 9.595278692501448e-05*G0_45 + 1.734376734376827e-04*G0_46 - 1.771513273249512e-05*G0_47 + 1.734376734376827e-04*G0_48 - 1.771513273249503e-05*G0_49 - 1.771513273249490e-05*G0_50 + 1.734376734376828e-04*G0_51 + 2.042509637995860e-04*G0_52 + 2.042509637995855e-04*G0_53 + 2.042509637995857e-04*G0_54 - 2.800295769045924e-04*G0_55;
    block[4] = 4.074982373593864e-06*G0_0 - 6.040207863124879e-05*G0_1 + 1.818686714520150e-05*G0_2 + 4.074982373593704e-06*G0_3 + 8.862584817446378e-04*G0_4 - 8.586570001501005e-04*G0_5 + 6.594244875495227e-04*G0_6 - 2.993506140207685e-04*G0_7 - 1.440295494115011e-04*G0_8 + 9.049940328875984e-05*G0_9 - 1.784059401246993e-04*G0_10 + 5.503568148244356e-05*G0_11 - 1.440295494115019e-04*G0_12 + 3.573137253693006e-04*G0_13 - 4.569299816695899e-04*G0_14 + 4.431292408723203e-04*G0_15 + 2.751784074122160e-05*G0_16 - 2.249938954221464e-05*G0_17 - 2.249938954221489e-05*G0_18 + 2.751784074122172e-05*G0_19 + 4.431292408723194e-04*G0_20 - 4.569299816695891e-04*G0_21 + 3.573137253692997e-04*G0_22 - 1.440295494115013e-04*G0_23 - 1.440295494115012e-04*G0_24 + 9.049940328876006e-05*G0_25 - 1.784059401246995e-04*G0_26 + 5.503568148244354e-05*G0_27 + 1.104059263781541e-04*G0_28 - 5.520296318907805e-05*G0_29 - 4.014760959205519e-05*G0_30 + 3.086347487389314e-04*G0_31 - 9.284134718162868e-05*G0_32 - 3.412546815324780e-04*G0_33 - 5.553752660234451e-04*G0_34 - 8.782289598260958e-06*G0_35 - 2.668143220805398e-04*G0_36 - 8.782289598261453e-06*G0_37 + 1.354981823731890e-04*G0_38 - 2.668143220805403e-04*G0_39 - 2.007380479602794e-05*G0_40 - 2.760148159453974e-05*G0_41 + 5.520296318907862e-05*G0_42 + 2.885609439429029e-05*G0_43 - 2.760148159453881e-05*G0_44 - 2.007380479602851e-05*G0_45 - 4.014760959205580e-05*G0_46 - 5.520296318907844e-05*G0_47 + 1.104059263781565e-04*G0_48 - 9.284134718162844e-05*G0_49 + 3.086347487389311e-04*G0_50 - 3.412546815324778e-04*G0_51 - 3.011070719404215e-04*G0_52 + 7.276754238560182e-04*G0_53 - 7.778599358460899e-04*G0_54 - 3.011070719404191e-04*G0_55;
    block[5] = 1.529623925457323e-05*G0_0 + 6.040207863124898e-05*G0_1 - 4.438318240401833e-05*G0_2 + 1.529623925457349e-05*G0_3 - 8.586570001501005e-04*G0_4 + 1.684192222386756e-03*G0_5 - 1.301786241022422e-03*G0_6 + 6.594244875495222e-04*G0_7 + 3.573137253692991e-04*G0_8 - 2.619631525881664e-04*G0_9 + 3.477786680911862e-04*G0_10 - 1.784059401246993e-04*G0_11 + 9.049940328876069e-05*G0_12 - 2.619631525881678e-04*G0_13 + 3.285412718283279e-04*G0_14 - 4.569299816695902e-04*G0_15 - 2.249938954221458e-05*G0_16 + 1.120787434444889e-05*G0_17 + 1.120787434444899e-05*G0_18 - 2.249938954221471e-05*G0_19 - 4.569299816695895e-04*G0_20 + 3.285412718283268e-04*G0_21 - 2.619631525881665e-04*G0_22 + 9.049940328875991e-05*G0_23 + 3.573137253692996e-04*G0_24 - 2.619631525881665e-04*G0_25 + 3.477786680911864e-04*G0_26 - 1.784059401246994e-04*G0_27 - 1.104059263781536e-04*G0_28 - 1.204428287761683e-04*G0_29 + 1.279705055746785e-04*G0_30 - 4.516606079106255e-05*G0_31 - 7.025831678609970e-05*G0_32 + 4.918082175026893e-04*G0_33 + 8.732105086272226e-04*G0_34 - 1.480443103707084e-04*G0_35 + 1.706273407662389e-04*G0_36 - 1.480443103707080e-04*G0_37 - 1.229520543756712e-04*G0_38 + 1.706273407662395e-04*G0_39 - 1.095695178449865e-04*G0_40 + 2.534317855498554e-04*G0_41 - 6.239607657432074e-04*G0_42 - 2.258303039553117e-05*G0_43 + 2.534317855498551e-04*G0_44 - 1.095695178449863e-04*G0_45 + 1.279705055746790e-04*G0_46 - 1.204428287761678e-04*G0_47 - 1.104059263781565e-04*G0_48 - 7.025831678609977e-05*G0_49 - 4.516606079106266e-05*G0_50 + 4.918082175026890e-04*G0_51 + 6.273063998758898e-05*G0_52 - 9.033212158212647e-04*G0_53 + 1.104059263781545e-03*G0_54 + 6.273063998758694e-05*G0_55;
    block[6] = 1.529623925457358e-05*G0_0 - 4.438318240401867e-05*G0_1 + 6.040207863124879e-05*G0_2 + 1.529623925457330e-05*G0_3 + 6.594244875495227e-04*G0_4 - 1.301786241022421e-03*G0_5 + 1.684192222386757e-03*G0_6 - 8.586570001501006e-04*G0_7 - 4.569299816695886e-04*G0_8 + 3.285412718283257e-04*G0_9 - 2.619631525881662e-04*G0_10 + 9.049940328875974e-05*G0_11 - 1.784059401247004e-04*G0_12 + 3.477786680911884e-04*G0_13 - 2.619631525881682e-04*G0_14 + 3.573137253693010e-04*G0_15 - 2.249938954221502e-05*G0_16 + 1.120787434444905e-05*G0_17 + 1.120787434444893e-05*G0_18 - 2.249938954221482e-05*G0_19 + 3.573137253693007e-04*G0_20 - 2.619631525881675e-04*G0_21 + 3.477786680911871e-04*G0_22 - 1.784059401246998e-04*G0_23 - 4.569299816695887e-04*G0_24 + 3.285412718283259e-04*G0_25 - 2.619631525881665e-04*G0_26 + 9.049940328875969e-05*G0_27 + 4.918082175026873e-04*G0_28 - 7.025831678609907e-05*G0_29 + 1.279705055746794e-04*G0_30 - 4.516606079106169e-05*G0_31 - 1.204428287761681e-04*G0_32 - 1.104059263781557e-04*G0_33 - 6.239607657432087e-04*G0_34 + 2.534317855498557e-04*G0_35 - 1.095695178449875e-04*G0_36 + 2.534317855498547e-04*G0_37 - 2.258303039553129e-05*G0_38 - 1.095695178449880e-04*G0_39 + 1.706273407662379e-04*G0_40 - 1.480443103707081e-04*G0_41 + 8.732105086272228e-04*G0_42 - 1.229520543756725e-04*G0_43 - 1.480443103707079e-04*G0_44 + 1.706273407662384e-04*G0_45 + 1.279705055746784e-04*G0_46 - 7.025831678609921e-05*G0_47 + 4.918082175026892e-04*G0_48 - 1.204428287761675e-04*G0_49 - 4.516606079106282e-05*G0_50 - 1.104059263781559e-04*G0_51 + 6.273063998758504e-05*G0_52 + 1.104059263781547e-03*G0_53 - 9.033212158212667e-04*G0_54 + 6.273063998758732e-05*G0_55;
    block[7] = 4.074982373593502e-06*G0_0 + 1.818686714520159e-05*G0_1 - 6.040207863124867e-05*G0_2 + 4.074982373593756e-06*G0_3 - 2.993506140207685e-04*G0_4 + 6.594244875495222e-04*G0_5 - 8.586570001501006e-04*G0_6 + 8.862584817446383e-04*G0_7 + 4.431292408723187e-04*G0_8 - 4.569299816695882e-04*G0_9 + 3.573137253692984e-04*G0_10 - 1.440295494115005e-04*G0_11 + 5.503568148244442e-05*G0_12 - 1.784059401247003e-04*G0_13 + 9.049940328876080e-05*G0_14 - 1.440295494115019e-04*G0_15 + 2.751784074122222e-05*G0_16 - 2.249938954221502e-05*G0_17 - 2.249938954221479e-05*G0_18 + 2.751784074122183e-05*G0_19 - 1.440295494115015e-04*G0_20 + 9.049940328876014e-05*G0_21 - 1.784059401246997e-04*G0_22 + 5.503568148244366e-05*G0_23 + 4.431292408723193e-04*G0_24 - 4.569299816695891e-04*G0_25 + 3.573137253692995e-04*G0_26 - 1.440295494115012e-04*G0_27 - 3.412546815324775e-04*G0_28 - 9.284134718162896e-05*G0_29 - 4.014760959205716e-05*G0_30 + 3.086347487389313e-04*G0_31 - 5.520296318907836e-05*G0_32 + 1.104059263781547e-04*G0_33 + 5.520296318907776e-05*G0_34 - 2.760148159453971e-05*G0_35 - 2.007380479602862e-05*G0_36 - 2.760148159453895e-05*G0_37 + 2.885609439429070e-05*G0_38 - 2.007380479602822e-05*G0_39 - 2.668143220805399e-04*G0_40 - 8.782289598261094e-06*G0_41 - 5.553752660234444e-04*G0_42 + 1.354981823731901e-04*G0_43 - 8.782289598261563e-06*G0_44 - 2.668143220805399e-04*G0_45 - 4.014760959205609e-05*G0_46 - 9.284134718162896e-05*G0_47 - 3.412546815324783e-04*G0_48 - 5.520296318907748e-05*G0_49 + 3.086347487389315e-04*G0_50 + 1.104059263781544e-04*G0_51 - 3.011070719404205e-04*G0_52 - 7.778599358460880e-04*G0_53 + 7.276754238560166e-04*G0_54 - 3.011070719404232e-04*G0_55;
    block[8] = 1.818686714520131e-05*G0_0 + 4.074982373593771e-06*G0_1 - 6.040207863124865e-05*G0_2 + 4.074982373593699e-06*G0_3 - 1.440295494115011e-04*G0_4 + 3.573137253692991e-04*G0_5 - 4.569299816695886e-04*G0_6 + 4.431292408723187e-04*G0_7 + 8.862584817446379e-04*G0_8 - 8.586570001501003e-04*G0_9 + 6.594244875495217e-04*G0_10 - 2.993506140207686e-04*G0_11 - 1.440295494115012e-04*G0_12 + 9.049940328875978e-05*G0_13 - 1.784059401246994e-04*G0_14 + 5.503568148244337e-05*G0_15 - 1.440295494115014e-04*G0_16 + 9.049940328876034e-05*G0_17 - 1.784059401246997e-04*G0_18 + 5.503568148244374e-05*G0_19 + 2.751784074122185e-05*G0_20 - 2.249938954221483e-05*G0_21 - 2.249938954221482e-05*G0_22 + 2.751784074122178e-05*G0_23 + 4.431292408723196e-04*G0_24 - 4.569299816695887e-04*G0_25 + 3.573137253692999e-04*G0_26 - 1.440295494115013e-04*G0_27 - 2.007380479602798e-05*G0_28 + 2.885609439429080e-05*G0_29 - 2.007380479602889e-05*G0_30 - 2.760148159453910e-05*G0_31 - 2.760148159453906e-05*G0_32 + 5.520296318907819e-05*G0_33 + 1.104059263781556e-04*G0_34 - 5.520296318907819e-05*G0_35 - 4.014760959205643e-05*G0_36 + 3.086347487389310e-04*G0_37 - 9.284134718162861e-05*G0_38 - 3.412546815324772e-04*G0_39 - 2.668143220805402e-04*G0_40 + 1.354981823731902e-04*G0_41 - 2.668143220805396e-04*G0_42 - 8.782289598261465e-06*G0_43 - 8.782289598261983e-06*G0_44 - 5.553752660234435e-04*G0_45 - 3.412546815324770e-04*G0_46 - 9.284134718162956e-05*G0_47 - 4.014760959205597e-05*G0_48 + 3.086347487389318e-04*G0_49 - 5.520296318907818e-05*G0_50 + 1.104059263781550e-04*G0_51 - 7.778599358460880e-04*G0_52 - 3.011070719404203e-04*G0_53 + 7.276754238560167e-04*G0_54 - 3.011070719404225e-04*G0_55;
    block[9] = -4.438318240401785e-05*G0_0 + 1.529623925457325e-05*G0_1 + 6.040207863124861e-05*G0_2 + 1.529623925457347e-05*G0_3 + 9.049940328875984e-05*G0_4 - 2.619631525881664e-04*G0_5 + 3.285412718283257e-04*G0_6 - 4.569299816695881e-04*G0_7 - 8.586570001501003e-04*G0_8 + 1.684192222386754e-03*G0_9 - 1.301786241022419e-03*G0_10 + 6.594244875495211e-04*G0_11 + 3.573137253692992e-04*G0_12 - 2.619631525881662e-04*G0_13 + 3.477786680911860e-04*G0_14 - 1.784059401246990e-04*G0_15 + 3.573137253692996e-04*G0_16 - 2.619631525881671e-04*G0_17 + 3.477786680911869e-04*G0_18 - 1.784059401246996e-04*G0_19 - 2.249938954221472e-05*G0_20 + 1.120787434444900e-05*G0_21 + 1.120787434444884e-05*G0_22 - 2.249938954221471e-05*G0_23 - 4.569299816695887e-04*G0_24 + 3.285412718283259e-04*G0_25 - 2.619631525881664e-04*G0_26 + 9.049940328875965e-05*G0_27 - 1.095695178449870e-04*G0_28 - 2.258303039553189e-05*G0_29 - 1.095695178449858e-04*G0_30 + 2.534317855498554e-04*G0_31 + 2.534317855498549e-04*G0_32 - 6.239607657432077e-04*G0_33 - 1.104059263781565e-04*G0_34 - 1.204428287761675e-04*G0_35 + 1.279705055746790e-04*G0_36 - 4.516606079106158e-05*G0_37 - 7.025831678609987e-05*G0_38 + 4.918082175026868e-04*G0_39 + 1.706273407662388e-04*G0_40 - 1.229520543756725e-04*G0_41 + 1.706273407662385e-04*G0_42 - 1.480443103707077e-04*G0_43 - 1.480443103707070e-04*G0_44 + 8.732105086272224e-04*G0_45 + 4.918082175026876e-04*G0_46 - 7.025831678609867e-05*G0_47 + 1.279705055746782e-04*G0_48 - 4.516606079106377e-05*G0_49 - 1.204428287761671e-04*G0_50 - 1.104059263781554e-04*G0_51 + 1.104059263781546e-03*G0_52 + 6.273063998758660e-05*G0_53 - 9.033212158212638e-04*G0_54 + 6.273063998758893e-05*G0_55;
    block[10] = 6.040207863124807e-05*G0_0 + 1.529623925457349e-05*G0_1 - 4.438318240401821e-05*G0_2 + 1.529623925457332e-05*G0_3 - 1.784059401246993e-04*G0_4 + 3.477786680911863e-04*G0_5 - 2.619631525881662e-04*G0_6 + 3.573137253692984e-04*G0_7 + 6.594244875495217e-04*G0_8 - 1.301786241022419e-03*G0_9 + 1.684192222386754e-03*G0_10 - 8.586570001500988e-04*G0_11 - 4.569299816695884e-04*G0_12 + 3.285412718283256e-04*G0_13 - 2.619631525881663e-04*G0_14 + 9.049940328875951e-05*G0_15 - 4.569299816695887e-04*G0_16 + 3.285412718283261e-04*G0_17 - 2.619631525881667e-04*G0_18 + 9.049940328876015e-05*G0_19 - 2.249938954221474e-05*G0_20 + 1.120787434444888e-05*G0_21 + 1.120787434444941e-05*G0_22 - 2.249938954221488e-05*G0_23 + 3.573137253692995e-04*G0_24 - 2.619631525881663e-04*G0_25 + 3.477786680911864e-04*G0_26 - 1.784059401246991e-04*G0_27 + 1.706273407662388e-04*G0_28 - 1.229520543756716e-04*G0_29 + 1.706273407662373e-04*G0_30 - 1.480443103707077e-04*G0_31 - 1.480443103707079e-04*G0_32 + 8.732105086272224e-04*G0_33 + 4.918082175026886e-04*G0_34 - 7.025831678609908e-05*G0_35 + 1.279705055746786e-04*G0_36 - 4.516606079106406e-05*G0_37 - 1.204428287761659e-04*G0_38 - 1.104059263781557e-04*G0_39 - 1.095695178449867e-04*G0_40 - 2.258303039553105e-05*G0_41 - 1.095695178449866e-04*G0_42 + 2.534317855498552e-04*G0_43 + 2.534317855498550e-04*G0_44 - 6.239607657432080e-04*G0_45 - 1.104059263781560e-04*G0_46 - 1.204428287761678e-04*G0_47 + 1.279705055746790e-04*G0_48 - 4.516606079106330e-05*G0_49 - 7.025831678609930e-05*G0_50 + 4.918082175026880e-04*G0_51 - 9.033212158212630e-04*G0_52 + 6.273063998758837e-05*G0_53 + 1.104059263781543e-03*G0_54 + 6.273063998758644e-05*G0_55;
    block[11] = -6.040207863124819e-05*G0_0 + 4.074982373593585e-06*G0_1 + 1.818686714520143e-05*G0_2 + 4.074982373593730e-06*G0_3 + 5.503568148244357e-05*G0_4 - 1.784059401246993e-04*G0_5 + 9.049940328875977e-05*G0_6 - 1.440295494115005e-04*G0_7 - 2.993506140207686e-04*G0_8 + 6.594244875495211e-04*G0_9 - 8.586570001500988e-04*G0_10 + 8.862584817446380e-04*G0_11 + 4.431292408723192e-04*G0_12 - 4.569299816695890e-04*G0_13 + 3.573137253692990e-04*G0_14 - 1.440295494115008e-04*G0_15 + 4.431292408723195e-04*G0_16 - 4.569299816695890e-04*G0_17 + 3.573137253693002e-04*G0_18 - 1.440295494115017e-04*G0_19 + 2.751784074122168e-05*G0_20 - 2.249938954221455e-05*G0_21 - 2.249938954221539e-05*G0_22 + 2.751784074122191e-05*G0_23 - 1.440295494115014e-04*G0_24 + 9.049940328875996e-05*G0_25 - 1.784059401246995e-04*G0_26 + 5.503568148244355e-05*G0_27 - 2.668143220805402e-04*G0_28 + 1.354981823731894e-04*G0_29 - 2.668143220805389e-04*G0_30 - 8.782289598262029e-06*G0_31 - 8.782289598261367e-06*G0_32 - 5.553752660234437e-04*G0_33 - 3.412546815324779e-04*G0_34 - 9.284134718162897e-05*G0_35 - 4.014760959205602e-05*G0_36 + 3.086347487389314e-04*G0_37 - 5.520296318907914e-05*G0_38 + 1.104059263781550e-04*G0_39 - 2.007380479602800e-05*G0_40 + 2.885609439429041e-05*G0_41 - 2.007380479602831e-05*G0_42 - 2.760148159453915e-05*G0_43 - 2.760148159453858e-05*G0_44 + 5.520296318907791e-05*G0_45 + 1.104059263781538e-04*G0_46 - 5.520296318907683e-05*G0_47 - 4.014760959205727e-05*G0_48 + 3.086347487389305e-04*G0_49 - 9.284134718162899e-05*G0_50 - 3.412546815324777e-04*G0_51 + 7.276754238560164e-04*G0_52 - 3.011070719404218e-04*G0_53 - 7.778599358460859e-04*G0_54 - 3.011070719404193e-04*G0_55;
    block[12] = -6.040207863124850e-05*G0_0 + 1.818686714520154e-05*G0_1 + 4.074982373593576e-06*G0_2 + 4.074982373593735e-06*G0_3 - 1.440295494115019e-04*G0_4 + 9.049940328876066e-05*G0_5 - 1.784059401247004e-04*G0_6 + 5.503568148244443e-05*G0_7 - 1.440295494115012e-04*G0_8 + 3.573137253692992e-04*G0_9 - 4.569299816695885e-04*G0_10 + 4.431292408723192e-04*G0_11 + 8.862584817446401e-04*G0_12 - 8.586570001501021e-04*G0_13 + 6.594244875495237e-04*G0_14 - 2.993506140207685e-04*G0_15 + 4.431292408723195e-04*G0_16 - 4.569299816695897e-04*G0_17 + 3.573137253693001e-04*G0_18 - 1.440295494115015e-04*G0_19 - 1.440295494115021e-04*G0_20 + 9.049940328876056e-05*G0_21 - 1.784059401247005e-04*G0_22 + 5.503568148244384e-05*G0_23 + 2.751784074122197e-05*G0_24 - 2.249938954221482e-05*G0_25 - 2.249938954221473e-05*G0_26 + 2.751784074122182e-05*G0_27 - 5.553752660234450e-04*G0_28 - 8.782289598261407e-06*G0_29 - 2.668143220805396e-04*G0_30 - 8.782289598261528e-06*G0_31 + 1.354981823731901e-04*G0_32 - 2.668143220805407e-04*G0_33 - 2.007380479602830e-05*G0_34 + 2.885609439429072e-05*G0_35 - 2.007380479602830e-05*G0_36 - 2.760148159453904e-05*G0_37 - 2.760148159454032e-05*G0_38 + 5.520296318907798e-05*G0_39 - 4.014760959205649e-05*G0_40 - 9.284134718162904e-05*G0_41 - 3.412546815324792e-04*G0_42 - 5.520296318907768e-05*G0_43 + 3.086347487389324e-04*G0_44 + 1.104059263781547e-04*G0_45 + 1.104059263781538e-04*G0_46 + 3.086347487389330e-04*G0_47 - 3.412546815324795e-04*G0_48 - 5.520296318907793e-05*G0_49 - 9.284134718162851e-05*G0_50 - 4.014760959205680e-05*G0_51 + 7.276754238560165e-04*G0_52 - 7.778599358460888e-04*G0_53 - 3.011070719404193e-04*G0_54 - 3.011070719404198e-04*G0_55;
    block[13] = 6.040207863124881e-05*G0_0 - 4.438318240401821e-05*G0_1 + 1.529623925457361e-05*G0_2 + 1.529623925457349e-05*G0_3 + 3.573137253693006e-04*G0_4 - 2.619631525881678e-04*G0_5 + 3.477786680911884e-04*G0_6 - 1.784059401247003e-04*G0_7 + 9.049940328875984e-05*G0_8 - 2.619631525881662e-04*G0_9 + 3.285412718283256e-04*G0_10 - 4.569299816695890e-04*G0_11 - 8.586570001501021e-04*G0_12 + 1.684192222386758e-03*G0_13 - 1.301786241022423e-03*G0_14 + 6.594244875495235e-04*G0_15 - 4.569299816695893e-04*G0_16 + 3.285412718283268e-04*G0_17 - 2.619631525881667e-04*G0_18 + 9.049940328875991e-05*G0_19 + 3.573137253693010e-04*G0_20 - 2.619631525881677e-04*G0_21 + 3.477786680911880e-04*G0_22 - 1.784059401247001e-04*G0_23 - 2.249938954221501e-05*G0_24 + 1.120787434444909e-05*G0_25 + 1.120787434444900e-05*G0_26 - 2.249938954221503e-05*G0_27 + 8.732105086272248e-04*G0_28 - 1.480443103707088e-04*G0_29 + 1.706273407662397e-04*G0_30 - 1.480443103707086e-04*G0_31 - 1.229520543756720e-04*G0_32 + 1.706273407662398e-04*G0_33 - 1.095695178449863e-04*G0_34 - 2.258303039553134e-05*G0_35 - 1.095695178449859e-04*G0_36 + 2.534317855498548e-04*G0_37 + 2.534317855498556e-04*G0_38 - 6.239607657432055e-04*G0_39 + 1.279705055746799e-04*G0_40 - 7.025831678609984e-05*G0_41 + 4.918082175026917e-04*G0_42 - 1.204428287761687e-04*G0_43 - 4.516606079106550e-05*G0_44 - 1.104059263781531e-04*G0_45 - 1.104059263781526e-04*G0_46 - 4.516606079106627e-05*G0_47 + 4.918082175026920e-04*G0_48 - 1.204428287761674e-04*G0_49 - 7.025831678609977e-05*G0_50 + 1.279705055746797e-04*G0_51 - 9.033212158212639e-04*G0_52 + 1.104059263781548e-03*G0_53 + 6.273063998758615e-05*G0_54 + 6.273063998758791e-05*G0_55;
    block[14] = -4.438318240401814e-05*G0_0 + 6.040207863124864e-05*G0_1 + 1.529623925457332e-05*G0_2 + 1.529623925457348e-05*G0_3 - 4.569299816695899e-04*G0_4 + 3.285412718283279e-04*G0_5 - 2.619631525881682e-04*G0_6 + 9.049940328876083e-05*G0_7 - 1.784059401246994e-04*G0_8 + 3.477786680911860e-04*G0_9 - 2.619631525881662e-04*G0_10 + 3.573137253692990e-04*G0_11 + 6.594244875495237e-04*G0_12 - 1.301786241022423e-03*G0_13 + 1.684192222386757e-03*G0_14 - 8.586570001501018e-04*G0_15 + 3.573137253692996e-04*G0_16 - 2.619631525881668e-04*G0_17 + 3.477786680911864e-04*G0_18 - 1.784059401246992e-04*G0_19 - 4.569299816695904e-04*G0_20 + 3.285412718283276e-04*G0_21 - 2.619631525881673e-04*G0_22 + 9.049940328876022e-05*G0_23 - 2.249938954221463e-05*G0_24 + 1.120787434444888e-05*G0_25 + 1.120787434444918e-05*G0_26 - 2.249938954221485e-05*G0_27 - 6.239607657432083e-04*G0_28 + 2.534317855498554e-04*G0_29 - 1.095695178449865e-04*G0_30 + 2.534317855498559e-04*G0_31 - 2.258303039553172e-05*G0_32 - 1.095695178449865e-04*G0_33 + 1.706273407662391e-04*G0_34 - 1.229520543756720e-04*G0_35 + 1.706273407662391e-04*G0_36 - 1.480443103707078e-04*G0_37 - 1.480443103707078e-04*G0_38 + 8.732105086272216e-04*G0_39 + 1.279705055746789e-04*G0_40 - 1.204428287761679e-04*G0_41 - 1.104059263781572e-04*G0_42 - 7.025831678609848e-05*G0_43 - 4.516606079106133e-05*G0_44 + 4.918082175026880e-04*G0_45 + 4.918082175026866e-04*G0_46 - 4.516606079106117e-05*G0_47 - 1.104059263781578e-04*G0_48 - 7.025831678609966e-05*G0_49 - 1.204428287761668e-04*G0_50 + 1.279705055746789e-04*G0_51 + 1.104059263781546e-03*G0_52 - 9.033212158212642e-04*G0_53 + 6.273063998759154e-05*G0_54 + 6.273063998758878e-05*G0_55;
    block[15] = 1.818686714520143e-05*G0_0 - 6.040207863124866e-05*G0_1 + 4.074982373593828e-06*G0_2 + 4.074982373593703e-06*G0_3 + 4.431292408723203e-04*G0_4 - 4.569299816695902e-04*G0_5 + 3.573137253693010e-04*G0_6 - 1.440295494115019e-04*G0_7 + 5.503568148244337e-05*G0_8 - 1.784059401246990e-04*G0_9 + 9.049940328875951e-05*G0_10 - 1.440295494115008e-04*G0_11 - 2.993506140207685e-04*G0_12 + 6.594244875495235e-04*G0_13 - 8.586570001501018e-04*G0_14 + 8.862584817446395e-04*G0_15 - 1.440295494115013e-04*G0_16 + 9.049940328875995e-05*G0_17 - 1.784059401246993e-04*G0_18 + 5.503568148244335e-05*G0_19 + 4.431292408723204e-04*G0_20 - 4.569299816695903e-04*G0_21 + 3.573137253693008e-04*G0_22 - 1.440295494115018e-04*G0_23 + 2.751784074122144e-05*G0_24 - 2.249938954221449e-05*G0_25 - 2.249938954221521e-05*G0_26 + 2.751784074122189e-05*G0_27 + 5.520296318907769e-05*G0_28 - 2.760148159453900e-05*G0_29 - 2.007380479602801e-05*G0_30 - 2.760148159453943e-05*G0_31 + 2.885609439429041e-05*G0_32 - 2.007380479602867e-05*G0_33 - 2.668143220805411e-04*G0_34 + 1.354981823731896e-04*G0_35 - 2.668143220805400e-04*G0_36 - 8.782289598261773e-06*G0_37 - 8.782289598261702e-06*G0_38 - 5.553752660234433e-04*G0_39 - 4.014760959205599e-05*G0_40 - 5.520296318907765e-05*G0_41 + 1.104059263781563e-04*G0_42 - 9.284134718162973e-05*G0_43 + 3.086347487389310e-04*G0_44 - 3.412546815324769e-04*G0_45 - 3.412546815324765e-04*G0_46 + 3.086347487389309e-04*G0_47 + 1.104059263781559e-04*G0_48 - 9.284134718162854e-05*G0_49 - 5.520296318907803e-05*G0_50 - 4.014760959205721e-05*G0_51 - 7.778599358460870e-04*G0_52 + 7.276754238560180e-04*G0_53 - 3.011070719404258e-04*G0_54 - 3.011070719404211e-04*G0_55;
    block[16] = -6.040207863124795e-05*G0_0 + 4.074982373593688e-06*G0_1 + 4.074982373593656e-06*G0_2 + 1.818686714520149e-05*G0_3 + 2.751784074122161e-05*G0_4 - 2.249938954221458e-05*G0_5 - 2.249938954221501e-05*G0_6 + 2.751784074122221e-05*G0_7 - 1.440295494115014e-04*G0_8 + 3.573137253692996e-04*G0_9 - 4.569299816695887e-04*G0_10 + 4.431292408723195e-04*G0_11 + 4.431292408723195e-04*G0_12 - 4.569299816695893e-04*G0_13 + 3.573137253692996e-04*G0_14 - 1.440295494115013e-04*G0_15 + 8.862584817446385e-04*G0_16 - 8.586570001501002e-04*G0_17 + 6.594244875495217e-04*G0_18 - 2.993506140207687e-04*G0_19 + 5.503568148244321e-05*G0_20 - 1.784059401246990e-04*G0_21 + 9.049940328875904e-05*G0_22 - 1.440295494115012e-04*G0_23 + 5.503568148244344e-05*G0_24 - 1.784059401246992e-04*G0_25 + 9.049940328875961e-05*G0_26 - 1.440295494115014e-04*G0_27 - 2.668143220805402e-04*G0_28 - 8.782289598261897e-06*G0_29 - 5.553752660234420e-04*G0_30 + 1.354981823731892e-04*G0_31 - 8.782289598261314e-06*G0_32 - 2.668143220805403e-04*G0_33 - 4.014760959205640e-05*G0_34 - 9.284134718162892e-05*G0_35 - 3.412546815324768e-04*G0_36 - 5.520296318907759e-05*G0_37 + 3.086347487389294e-04*G0_38 + 1.104059263781555e-04*G0_39 - 3.412546815324764e-04*G0_40 - 9.284134718162984e-05*G0_41 - 4.014760959205651e-05*G0_42 + 3.086347487389308e-04*G0_43 - 5.520296318907715e-05*G0_44 + 1.104059263781551e-04*G0_45 + 5.520296318907701e-05*G0_46 - 2.760148159453804e-05*G0_47 - 2.007380479602872e-05*G0_48 - 2.760148159453874e-05*G0_49 + 2.885609439429043e-05*G0_50 - 2.007380479602838e-05*G0_51 + 7.276754238560147e-04*G0_52 - 3.011070719404218e-04*G0_53 - 3.011070719404196e-04*G0_54 - 7.778599358460840e-04*G0_55;
    block[17] = 6.040207863124784e-05*G0_0 + 1.529623925457340e-05*G0_1 + 1.529623925457335e-05*G0_2 - 4.438318240401822e-05*G0_3 - 2.249938954221464e-05*G0_4 + 1.120787434444889e-05*G0_5 + 1.120787434444906e-05*G0_6 - 2.249938954221501e-05*G0_7 + 9.049940328876034e-05*G0_8 - 2.619631525881671e-04*G0_9 + 3.285412718283261e-04*G0_10 - 4.569299816695890e-04*G0_11 - 4.569299816695897e-04*G0_12 + 3.285412718283268e-04*G0_13 - 2.619631525881669e-04*G0_14 + 9.049940328875995e-05*G0_15 - 8.586570001501001e-04*G0_16 + 1.684192222386756e-03*G0_17 - 1.301786241022421e-03*G0_18 + 6.594244875495229e-04*G0_19 - 1.784059401246993e-04*G0_20 + 3.477786680911859e-04*G0_21 - 2.619631525881657e-04*G0_22 + 3.573137253692997e-04*G0_23 - 1.784059401246990e-04*G0_24 + 3.477786680911859e-04*G0_25 - 2.619631525881660e-04*G0_26 + 3.573137253692999e-04*G0_27 + 1.706273407662391e-04*G0_28 - 1.480443103707071e-04*G0_29 + 8.732105086272200e-04*G0_30 - 1.229520543756713e-04*G0_31 - 1.480443103707078e-04*G0_32 + 1.706273407662392e-04*G0_33 + 1.279705055746787e-04*G0_34 - 7.025831678609856e-05*G0_35 + 4.918082175026873e-04*G0_36 - 1.204428287761674e-04*G0_37 - 4.516606079106113e-05*G0_38 - 1.104059263781552e-04*G0_39 + 4.918082175026865e-04*G0_40 - 7.025831678609813e-05*G0_41 + 1.279705055746790e-04*G0_42 - 4.516606079106308e-05*G0_43 - 1.204428287761684e-04*G0_44 - 1.104059263781564e-04*G0_45 - 6.239607657432056e-04*G0_46 + 2.534317855498545e-04*G0_47 - 1.095695178449859e-04*G0_48 + 2.534317855498551e-04*G0_49 - 2.258303039553142e-05*G0_50 - 1.095695178449866e-04*G0_51 - 9.033212158212634e-04*G0_52 + 6.273063998758897e-05*G0_53 + 6.273063998758850e-05*G0_54 + 1.104059263781540e-03*G0_55;
    block[18] = -4.438318240401755e-05*G0_0 + 1.529623925457337e-05*G0_1 + 1.529623925457341e-05*G0_2 + 6.040207863124861e-05*G0_3 - 2.249938954221489e-05*G0_4 + 1.120787434444899e-05*G0_5 + 1.120787434444893e-05*G0_6 - 2.249938954221477e-05*G0_7 - 1.784059401246997e-04*G0_8 + 3.477786680911869e-04*G0_9 - 2.619631525881667e-04*G0_10 + 3.573137253693001e-04*G0_11 + 3.573137253693001e-04*G0_12 - 2.619631525881667e-04*G0_13 + 3.477786680911865e-04*G0_14 - 1.784059401246993e-04*G0_15 + 6.594244875495217e-04*G0_16 - 1.301786241022421e-03*G0_17 + 1.684192222386755e-03*G0_18 - 8.586570001501013e-04*G0_19 + 9.049940328875974e-05*G0_20 - 2.619631525881660e-04*G0_21 + 3.285412718283255e-04*G0_22 - 4.569299816695891e-04*G0_23 + 9.049940328875946e-05*G0_24 - 2.619631525881656e-04*G0_25 + 3.285412718283253e-04*G0_26 - 4.569299816695889e-04*G0_27 - 1.095695178449864e-04*G0_28 + 2.534317855498544e-04*G0_29 - 6.239607657432053e-04*G0_30 - 2.258303039553208e-05*G0_31 + 2.534317855498547e-04*G0_32 - 1.095695178449869e-04*G0_33 + 1.279705055746789e-04*G0_34 - 1.204428287761677e-04*G0_35 - 1.104059263781540e-04*G0_36 - 7.025831678609905e-05*G0_37 - 4.516606079106478e-05*G0_38 + 4.918082175026889e-04*G0_39 - 1.104059263781531e-04*G0_40 - 1.204428287761691e-04*G0_41 + 1.279705055746796e-04*G0_42 - 4.516606079106448e-05*G0_43 - 7.025831678609855e-05*G0_44 + 4.918082175026892e-04*G0_45 + 8.732105086272207e-04*G0_46 - 1.480443103707073e-04*G0_47 + 1.706273407662386e-04*G0_48 - 1.480443103707081e-04*G0_49 - 1.229520543756721e-04*G0_50 + 1.706273407662385e-04*G0_51 + 1.104059263781544e-03*G0_52 + 6.273063998758756e-05*G0_53 + 6.273063998758774e-05*G0_54 - 9.033212158212609e-04*G0_55;
    block[19] = 1.818686714520118e-05*G0_0 + 4.074982373593798e-06*G0_1 + 4.074982373593687e-06*G0_2 - 6.040207863124856e-05*G0_3 + 2.751784074122171e-05*G0_4 - 2.249938954221470e-05*G0_5 - 2.249938954221482e-05*G0_6 + 2.751784074122182e-05*G0_7 + 5.503568148244374e-05*G0_8 - 1.784059401246995e-04*G0_9 + 9.049940328876011e-05*G0_10 - 1.440295494115016e-04*G0_11 - 1.440295494115015e-04*G0_12 + 9.049940328875988e-05*G0_13 - 1.784059401246992e-04*G0_14 + 5.503568148244340e-05*G0_15 - 2.993506140207687e-04*G0_16 + 6.594244875495229e-04*G0_17 - 8.586570001501013e-04*G0_18 + 8.862584817446390e-04*G0_19 - 1.440295494115015e-04*G0_20 + 3.573137253692998e-04*G0_21 - 4.569299816695897e-04*G0_22 + 4.431292408723201e-04*G0_23 - 1.440295494115011e-04*G0_24 + 3.573137253692991e-04*G0_25 - 4.569299816695884e-04*G0_26 + 4.431292408723200e-04*G0_27 - 2.007380479602766e-05*G0_28 - 2.760148159453858e-05*G0_29 + 5.520296318907743e-05*G0_30 + 2.885609439429027e-05*G0_31 - 2.760148159453845e-05*G0_32 - 2.007380479602780e-05*G0_33 - 4.014760959205599e-05*G0_34 - 5.520296318907702e-05*G0_35 + 1.104059263781542e-04*G0_36 - 9.284134718162964e-05*G0_37 + 3.086347487389316e-04*G0_38 - 3.412546815324769e-04*G0_39 + 1.104059263781545e-04*G0_40 - 5.520296318907696e-05*G0_41 - 4.014760959205601e-05*G0_42 + 3.086347487389320e-04*G0_43 - 9.284134718163011e-05*G0_44 - 3.412546815324772e-04*G0_45 - 5.553752660234433e-04*G0_46 - 8.782289598262166e-06*G0_47 - 2.668143220805395e-04*G0_48 - 8.782289598261844e-06*G0_49 + 1.354981823731895e-04*G0_50 - 2.668143220805397e-04*G0_51 - 7.778599358460878e-04*G0_52 - 3.011070719404212e-04*G0_53 - 3.011070719404205e-04*G0_54 + 7.276754238560176e-04*G0_55;
    block[20] = 4.074982373593966e-06*G0_0 - 6.040207863124855e-05*G0_1 + 4.074982373593764e-06*G0_2 + 1.818686714520152e-05*G0_3 + 4.431292408723194e-04*G0_4 - 4.569299816695895e-04*G0_5 + 3.573137253693008e-04*G0_6 - 1.440295494115015e-04*G0_7 + 2.751784074122185e-05*G0_8 - 2.249938954221472e-05*G0_9 - 2.249938954221474e-05*G0_10 + 2.751784074122167e-05*G0_11 - 1.440295494115021e-04*G0_12 + 3.573137253693010e-04*G0_13 - 4.569299816695904e-04*G0_14 + 4.431292408723205e-04*G0_15 + 5.503568148244321e-05*G0_16 - 1.784059401246993e-04*G0_17 + 9.049940328875972e-05*G0_18 - 1.440295494115015e-04*G0_19 + 8.862584817446392e-04*G0_20 - 8.586570001501008e-04*G0_21 + 6.594244875495219e-04*G0_22 - 2.993506140207687e-04*G0_23 + 5.503568148244340e-05*G0_24 - 1.784059401246991e-04*G0_25 + 9.049940328875965e-05*G0_26 - 1.440295494115016e-04*G0_27 + 1.104059263781543e-04*G0_28 + 3.086347487389303e-04*G0_29 - 3.412546815324756e-04*G0_30 - 5.520296318907750e-05*G0_31 - 9.284134718162939e-05*G0_32 - 4.014760959205633e-05*G0_33 - 2.668143220805404e-04*G0_34 - 8.782289598261604e-06*G0_35 - 5.553752660234426e-04*G0_36 + 1.354981823731894e-04*G0_37 - 8.782289598262239e-06*G0_38 - 2.668143220805398e-04*G0_39 - 3.412546815324765e-04*G0_40 + 3.086347487389300e-04*G0_41 + 1.104059263781574e-04*G0_42 - 9.284134718162999e-05*G0_43 - 5.520296318907814e-05*G0_44 - 4.014760959205548e-05*G0_45 - 2.007380479602776e-05*G0_46 - 2.760148159453916e-05*G0_47 + 5.520296318907882e-05*G0_48 + 2.885609439429070e-05*G0_49 - 2.760148159453881e-05*G0_50 - 2.007380479602832e-05*G0_51 - 3.011070719404219e-04*G0_52 + 7.276754238560185e-04*G0_53 - 3.011070719404223e-04*G0_54 - 7.778599358460863e-04*G0_55;
    block[21] = 1.529623925457305e-05*G0_0 + 6.040207863124860e-05*G0_1 + 1.529623925457332e-05*G0_2 - 4.438318240401834e-05*G0_3 - 4.569299816695891e-04*G0_4 + 3.285412718283268e-04*G0_5 - 2.619631525881675e-04*G0_6 + 9.049940328876011e-05*G0_7 - 2.249938954221482e-05*G0_8 + 1.120787434444899e-05*G0_9 + 1.120787434444889e-05*G0_10 - 2.249938954221454e-05*G0_11 + 9.049940328876056e-05*G0_12 - 2.619631525881677e-04*G0_13 + 3.285412718283276e-04*G0_14 - 4.569299816695903e-04*G0_15 - 1.784059401246990e-04*G0_16 + 3.477786680911859e-04*G0_17 - 2.619631525881660e-04*G0_18 + 3.573137253692997e-04*G0_19 - 8.586570001501008e-04*G0_20 + 1.684192222386757e-03*G0_21 - 1.301786241022422e-03*G0_22 + 6.594244875495230e-04*G0_23 - 1.784059401246989e-04*G0_24 + 3.477786680911856e-04*G0_25 - 2.619631525881661e-04*G0_26 + 3.573137253693001e-04*G0_27 - 1.104059263781550e-04*G0_28 - 4.516606079106161e-05*G0_29 + 4.918082175026855e-04*G0_30 - 1.204428287761685e-04*G0_31 - 7.025831678609778e-05*G0_32 + 1.279705055746789e-04*G0_33 + 1.706273407662391e-04*G0_34 - 1.480443103707077e-04*G0_35 + 8.732105086272197e-04*G0_36 - 1.229520543756719e-04*G0_37 - 1.480443103707064e-04*G0_38 + 1.706273407662386e-04*G0_39 + 4.918082175026866e-04*G0_40 - 4.516606079106125e-05*G0_41 - 1.104059263781561e-04*G0_42 - 7.025831678609741e-05*G0_43 - 1.204428287761689e-04*G0_44 + 1.279705055746789e-04*G0_45 - 1.095695178449873e-04*G0_46 + 2.534317855498559e-04*G0_47 - 6.239607657432084e-04*G0_48 - 2.258303039553168e-05*G0_49 + 2.534317855498547e-04*G0_50 - 1.095695178449866e-04*G0_51 + 6.273063998758870e-05*G0_52 - 9.033212158212642e-04*G0_53 + 6.273063998758877e-05*G0_54 + 1.104059263781542e-03*G0_55;
    block[22] = 1.529623925457396e-05*G0_0 - 4.438318240401823e-05*G0_1 + 1.529623925457350e-05*G0_2 + 6.040207863124879e-05*G0_3 + 3.573137253692997e-04*G0_4 - 2.619631525881665e-04*G0_5 + 3.477786680911871e-04*G0_6 - 1.784059401246998e-04*G0_7 - 2.249938954221483e-05*G0_8 + 1.120787434444885e-05*G0_9 + 1.120787434444941e-05*G0_10 - 2.249938954221539e-05*G0_11 - 1.784059401247005e-04*G0_12 + 3.477786680911880e-04*G0_13 - 2.619631525881672e-04*G0_14 + 3.573137253693008e-04*G0_15 + 9.049940328875901e-05*G0_16 - 2.619631525881656e-04*G0_17 + 3.285412718283255e-04*G0_18 - 4.569299816695898e-04*G0_19 + 6.594244875495221e-04*G0_20 - 1.301786241022422e-03*G0_21 + 1.684192222386757e-03*G0_22 - 8.586570001501008e-04*G0_23 + 9.049940328875938e-05*G0_24 - 2.619631525881656e-04*G0_25 + 3.285412718283260e-04*G0_26 - 4.569299816695893e-04*G0_27 + 4.918082175026892e-04*G0_28 - 4.516606079106555e-05*G0_29 - 1.104059263781509e-04*G0_30 - 7.025831678609762e-05*G0_31 - 1.204428287761690e-04*G0_32 + 1.279705055746803e-04*G0_33 - 1.095695178449856e-04*G0_34 + 2.534317855498553e-04*G0_35 - 6.239607657432041e-04*G0_36 - 2.258303039553212e-05*G0_37 + 2.534317855498534e-04*G0_38 - 1.095695178449852e-04*G0_39 - 1.104059263781525e-04*G0_40 - 4.516606079106440e-05*G0_41 + 4.918082175026896e-04*G0_42 - 1.204428287761706e-04*G0_43 - 7.025831678609902e-05*G0_44 + 1.279705055746806e-04*G0_45 + 1.706273407662403e-04*G0_46 - 1.480443103707096e-04*G0_47 + 8.732105086272241e-04*G0_48 - 1.229520543756723e-04*G0_49 - 1.480443103707071e-04*G0_50 + 1.706273407662394e-04*G0_51 + 6.273063998758717e-05*G0_52 + 1.104059263781545e-03*G0_53 + 6.273063998758923e-05*G0_54 - 9.033212158212607e-04*G0_55;
    block[23] = 4.074982373593485e-06*G0_0 + 1.818686714520159e-05*G0_1 + 4.074982373593698e-06*G0_2 - 6.040207863124859e-05*G0_3 - 1.440295494115013e-04*G0_4 + 9.049940328875991e-05*G0_5 - 1.784059401246998e-04*G0_6 + 5.503568148244366e-05*G0_7 + 2.751784074122177e-05*G0_8 - 2.249938954221471e-05*G0_9 - 2.249938954221487e-05*G0_10 + 2.751784074122193e-05*G0_11 + 5.503568148244384e-05*G0_12 - 1.784059401247002e-04*G0_13 + 9.049940328876020e-05*G0_14 - 1.440295494115018e-04*G0_15 - 1.440295494115012e-04*G0_16 + 3.573137253692997e-04*G0_17 - 4.569299816695891e-04*G0_18 + 4.431292408723201e-04*G0_19 - 2.993506140207687e-04*G0_20 + 6.594244875495230e-04*G0_21 - 8.586570001501008e-04*G0_22 + 8.862584817446399e-04*G0_23 - 1.440295494115012e-04*G0_24 + 3.573137253692995e-04*G0_25 - 4.569299816695887e-04*G0_26 + 4.431292408723203e-04*G0_27 - 3.412546815324769e-04*G0_28 + 3.086347487389324e-04*G0_29 + 1.104059263781536e-04*G0_30 - 9.284134718162952e-05*G0_31 - 5.520296318907737e-05*G0_32 - 4.014760959205620e-05*G0_33 - 2.007380479602787e-05*G0_34 - 2.760148159453942e-05*G0_35 + 5.520296318907679e-05*G0_36 + 2.885609439429033e-05*G0_37 - 2.760148159453830e-05*G0_38 - 2.007380479602818e-05*G0_39 + 1.104059263781545e-04*G0_40 + 3.086347487389323e-04*G0_41 - 3.412546815324779e-04*G0_42 - 5.520296318907648e-05*G0_43 - 9.284134718163002e-05*G0_44 - 4.014760959205615e-05*G0_45 - 2.668143220805399e-04*G0_46 - 8.782289598261287e-06*G0_47 - 5.553752660234443e-04*G0_48 + 1.354981823731892e-04*G0_49 - 8.782289598261675e-06*G0_50 - 2.668143220805401e-04*G0_51 - 3.011070719404203e-04*G0_52 - 7.778599358460868e-04*G0_53 - 3.011070719404206e-04*G0_54 + 7.276754238560171e-04*G0_55;
    block[24] = 4.074982373593740e-06*G0_0 + 4.074982373593815e-06*G0_1 - 6.040207863124853e-05*G0_2 + 1.818686714520153e-05*G0_3 - 1.440295494115012e-04*G0_4 + 3.573137253692996e-04*G0_5 - 4.569299816695887e-04*G0_6 + 4.431292408723193e-04*G0_7 + 4.431292408723196e-04*G0_8 - 4.569299816695888e-04*G0_9 + 3.573137253692995e-04*G0_10 - 1.440295494115014e-04*G0_11 + 2.751784074122197e-05*G0_12 - 2.249938954221501e-05*G0_13 - 2.249938954221462e-05*G0_14 + 2.751784074122143e-05*G0_15 + 5.503568148244344e-05*G0_16 - 1.784059401246990e-04*G0_17 + 9.049940328875946e-05*G0_18 - 1.440295494115011e-04*G0_19 + 5.503568148244340e-05*G0_20 - 1.784059401246989e-04*G0_21 + 9.049940328875940e-05*G0_22 - 1.440295494115012e-04*G0_23 + 8.862584817446377e-04*G0_24 - 8.586570001500995e-04*G0_25 + 6.594244875495210e-04*G0_26 - 2.993506140207681e-04*G0_27 - 4.014760959205614e-05*G0_28 - 9.284134718162926e-05*G0_29 - 3.412546815324774e-04*G0_30 - 5.520296318907774e-05*G0_31 + 3.086347487389304e-04*G0_32 + 1.104059263781555e-04*G0_33 + 1.104059263781558e-04*G0_34 + 3.086347487389298e-04*G0_35 - 3.412546815324766e-04*G0_36 - 5.520296318907776e-05*G0_37 - 9.284134718162929e-05*G0_38 - 4.014760959205592e-05*G0_39 - 5.553752660234428e-04*G0_40 - 8.782289598261272e-06*G0_41 - 2.668143220805403e-04*G0_42 - 8.782289598261633e-06*G0_43 + 1.354981823731894e-04*G0_44 - 2.668143220805398e-04*G0_45 - 2.007380479602789e-05*G0_46 + 2.885609439429043e-05*G0_47 - 2.007380479602818e-05*G0_48 - 2.760148159453870e-05*G0_49 - 2.760148159453895e-05*G0_50 + 5.520296318907811e-05*G0_51 - 3.011070719404204e-04*G0_52 - 3.011070719404213e-04*G0_53 + 7.276754238560168e-04*G0_54 - 7.778599358460869e-04*G0_55;
    block[25] = 1.529623925457313e-05*G0_0 + 1.529623925457326e-05*G0_1 + 6.040207863124849e-05*G0_2 - 4.438318240401828e-05*G0_3 + 9.049940328876006e-05*G0_4 - 2.619631525881665e-04*G0_5 + 3.285412718283259e-04*G0_6 - 4.569299816695890e-04*G0_7 - 4.569299816695887e-04*G0_8 + 3.285412718283259e-04*G0_9 - 2.619631525881663e-04*G0_10 + 9.049940328875996e-05*G0_11 - 2.249938954221481e-05*G0_12 + 1.120787434444909e-05*G0_13 + 1.120787434444887e-05*G0_14 - 2.249938954221449e-05*G0_15 - 1.784059401246992e-04*G0_16 + 3.477786680911860e-04*G0_17 - 2.619631525881657e-04*G0_18 + 3.573137253692991e-04*G0_19 - 1.784059401246990e-04*G0_20 + 3.477786680911856e-04*G0_21 - 2.619631525881656e-04*G0_22 + 3.573137253692995e-04*G0_23 - 8.586570001500995e-04*G0_24 + 1.684192222386753e-03*G0_25 - 1.301786241022420e-03*G0_26 + 6.594244875495217e-04*G0_27 + 1.279705055746783e-04*G0_28 - 7.025831678609764e-05*G0_29 + 4.918082175026862e-04*G0_30 - 1.204428287761683e-04*G0_31 - 4.516606079106190e-05*G0_32 - 1.104059263781554e-04*G0_33 - 1.104059263781556e-04*G0_34 - 4.516606079106200e-05*G0_35 + 4.918082175026863e-04*G0_36 - 1.204428287761678e-04*G0_37 - 7.025831678609718e-05*G0_38 + 1.279705055746777e-04*G0_39 + 8.732105086272204e-04*G0_40 - 1.480443103707075e-04*G0_41 + 1.706273407662388e-04*G0_42 - 1.480443103707071e-04*G0_43 - 1.229520543756719e-04*G0_44 + 1.706273407662379e-04*G0_45 - 1.095695178449874e-04*G0_46 - 2.258303039553081e-05*G0_47 - 1.095695178449871e-04*G0_48 + 2.534317855498547e-04*G0_49 + 2.534317855498545e-04*G0_50 - 6.239607657432071e-04*G0_51 + 6.273063998758729e-05*G0_52 + 6.273063998758729e-05*G0_53 - 9.033212158212629e-04*G0_54 + 1.104059263781543e-03*G0_55;
    block[26] = 1.529623925457351e-05*G0_0 + 1.529623925457347e-05*G0_1 - 4.438318240401815e-05*G0_2 + 6.040207863124859e-05*G0_3 - 1.784059401246996e-04*G0_4 + 3.477786680911864e-04*G0_5 - 2.619631525881665e-04*G0_6 + 3.573137253692995e-04*G0_7 + 3.573137253692999e-04*G0_8 - 2.619631525881664e-04*G0_9 + 3.477786680911864e-04*G0_10 - 1.784059401246995e-04*G0_11 - 2.249938954221473e-05*G0_12 + 1.120787434444900e-05*G0_13 + 1.120787434444919e-05*G0_14 - 2.249938954221520e-05*G0_15 + 9.049940328875962e-05*G0_16 - 2.619631525881660e-04*G0_17 + 3.285412718283254e-04*G0_18 - 4.569299816695885e-04*G0_19 + 9.049940328875966e-05*G0_20 - 2.619631525881660e-04*G0_21 + 3.285412718283261e-04*G0_22 - 4.569299816695887e-04*G0_23 + 6.594244875495210e-04*G0_24 - 1.301786241022420e-03*G0_25 + 1.684192222386754e-03*G0_26 - 8.586570001501003e-04*G0_27 + 1.279705055746789e-04*G0_28 - 1.204428287761684e-04*G0_29 - 1.104059263781540e-04*G0_30 - 7.025831678609801e-05*G0_31 - 4.516606079106450e-05*G0_32 + 4.918082175026881e-04*G0_33 + 4.918082175026884e-04*G0_34 - 4.516606079106409e-05*G0_35 - 1.104059263781534e-04*G0_36 - 7.025831678609842e-05*G0_37 - 1.204428287761683e-04*G0_38 + 1.279705055746789e-04*G0_39 - 6.239607657432053e-04*G0_40 + 2.534317855498547e-04*G0_41 - 1.095695178449870e-04*G0_42 + 2.534317855498537e-04*G0_43 - 2.258303039553131e-05*G0_44 - 1.095695178449862e-04*G0_45 + 1.706273407662385e-04*G0_46 - 1.229520543756726e-04*G0_47 + 1.706273407662387e-04*G0_48 - 1.480443103707073e-04*G0_49 - 1.480443103707079e-04*G0_50 + 8.732105086272215e-04*G0_51 + 6.273063998758813e-05*G0_52 + 6.273063998758793e-05*G0_53 + 1.104059263781544e-03*G0_54 - 9.033212158212627e-04*G0_55;
    block[27] = 4.074982373593537e-06*G0_0 + 4.074982373593739e-06*G0_1 + 1.818686714520145e-05*G0_2 - 6.040207863124858e-05*G0_3 + 5.503568148244355e-05*G0_4 - 1.784059401246994e-04*G0_5 + 9.049940328875969e-05*G0_6 - 1.440295494115012e-04*G0_7 - 1.440295494115013e-04*G0_8 + 9.049940328875965e-05*G0_9 - 1.784059401246991e-04*G0_10 + 5.503568148244355e-05*G0_11 + 2.751784074122183e-05*G0_12 - 2.249938954221503e-05*G0_13 - 2.249938954221484e-05*G0_14 + 2.751784074122190e-05*G0_15 - 1.440295494115014e-04*G0_16 + 3.573137253692999e-04*G0_17 - 4.569299816695889e-04*G0_18 + 4.431292408723200e-04*G0_19 - 1.440295494115016e-04*G0_20 + 3.573137253693001e-04*G0_21 - 4.569299816695893e-04*G0_22 + 4.431292408723203e-04*G0_23 - 2.993506140207681e-04*G0_24 + 6.594244875495217e-04*G0_25 - 8.586570001501003e-04*G0_26 + 8.862584817446387e-04*G0_27 - 4.014760959205646e-05*G0_28 - 5.520296318907685e-05*G0_29 + 1.104059263781542e-04*G0_30 - 9.284134718163007e-05*G0_31 + 3.086347487389326e-04*G0_32 - 3.412546815324774e-04*G0_33 - 3.412546815324772e-04*G0_34 + 3.086347487389315e-04*G0_35 + 1.104059263781542e-04*G0_36 - 9.284134718162966e-05*G0_37 - 5.520296318907730e-05*G0_38 - 4.014760959205619e-05*G0_39 + 5.520296318907719e-05*G0_40 - 2.760148159453862e-05*G0_41 - 2.007380479602827e-05*G0_42 - 2.760148159453825e-05*G0_43 + 2.885609439429016e-05*G0_44 - 2.007380479602874e-05*G0_45 - 2.668143220805399e-04*G0_46 + 1.354981823731902e-04*G0_47 - 2.668143220805401e-04*G0_48 - 8.782289598262019e-06*G0_49 - 8.782289598261899e-06*G0_50 - 5.553752660234434e-04*G0_51 - 3.011070719404219e-04*G0_52 - 3.011070719404224e-04*G0_53 - 7.778599358460868e-04*G0_54 + 7.276754238560182e-04*G0_55;
    block[28] = 1.734376734376831e-04*G0_0 + 1.496502147543884e-04*G0_1 + 9.595278692501421e-05*G0_2 + 9.595278692501399e-05*G0_3 + 1.104059263781539e-04*G0_4 - 1.104059263781535e-04*G0_5 + 4.918082175026872e-04*G0_6 - 3.412546815324775e-04*G0_7 - 2.007380479602798e-05*G0_8 - 1.095695178449870e-04*G0_9 + 1.706273407662388e-04*G0_10 - 2.668143220805402e-04*G0_11 - 5.553752660234449e-04*G0_12 + 8.732105086272248e-04*G0_13 - 6.239607657432083e-04*G0_14 + 5.520296318907768e-05*G0_15 - 2.668143220805402e-04*G0_16 + 1.706273407662391e-04*G0_17 - 1.095695178449864e-04*G0_18 - 2.007380479602765e-05*G0_19 + 1.104059263781543e-04*G0_20 - 1.104059263781549e-04*G0_21 + 4.918082175026892e-04*G0_22 - 3.412546815324769e-04*G0_23 - 4.014760959205614e-05*G0_24 + 1.279705055746783e-04*G0_25 + 1.279705055746789e-04*G0_26 - 4.014760959205643e-05*G0_27 + 4.550062420433027e-03*G0_28 - 1.806642431642524e-03*G0_29 + 1.037146581128115e-03*G0_30 - 1.806642431642523e-03*G0_31 + 5.143912478982161e-04*G0_32 + 1.037146581128118e-03*G0_33 + 6.942190825293049e-04*G0_34 + 5.771218878858060e-04*G0_35 + 6.942190825293037e-04*G0_36 - 2.132841759577990e-04*G0_37 - 2.132841759577945e-04*G0_38 + 6.189423145441977e-04*G0_39 + 5.185732905640589e-04*G0_40 - 9.033212158212639e-04*G0_41 + 2.275031210216517e-03*G0_42 + 6.273063998758621e-05*G0_43 - 1.254612799751758e-03*G0_44 + 6.942190825293063e-04*G0_45 + 6.942190825293063e-04*G0_46 - 1.254612799751760e-03*G0_47 + 2.275031210216518e-03*G0_48 + 6.273063998758734e-05*G0_49 - 9.033212158212644e-04*G0_50 + 5.185732905640603e-04*G0_51 - 3.512915839304905e-04*G0_52 + 1.405166335721972e-03*G0_53 + 7.778599358460853e-04*G0_54 + 7.778599358460837e-04*G0_55;
    block[29] = -1.771513273249494e-05*G0_0 - 1.214967035279594e-04*G0_1 + 3.984650252011552e-05*G0_2 - 1.214967035279602e-04*G0_3 - 5.520296318907808e-05*G0_4 - 1.204428287761683e-04*G0_5 - 7.025831678609907e-05*G0_6 - 9.284134718162895e-05*G0_7 + 2.885609439429079e-05*G0_8 - 2.258303039553189e-05*G0_9 - 1.229520543756716e-04*G0_10 + 1.354981823731895e-04*G0_11 - 8.782289598261396e-06*G0_12 - 1.480443103707088e-04*G0_13 + 2.534317855498554e-04*G0_14 - 2.760148159453900e-05*G0_15 - 8.782289598261917e-06*G0_16 - 1.480443103707071e-04*G0_17 + 2.534317855498544e-04*G0_18 - 2.760148159453858e-05*G0_19 + 3.086347487389303e-04*G0_20 - 4.516606079106162e-05*G0_21 - 4.516606079106549e-05*G0_22 + 3.086347487389324e-04*G0_23 - 9.284134718162926e-05*G0_24 - 7.025831678609764e-05*G0_25 - 1.204428287761684e-04*G0_26 - 5.520296318907689e-05*G0_27 - 1.806642431642525e-03*G0_28 + 5.269373758957367e-03*G0_29 - 1.806642431642526e-03*G0_30 - 9.409595998138175e-04*G0_31 - 9.409595998138143e-04*G0_32 + 5.143912478982191e-04*G0_33 + 6.273063998758764e-05*G0_34 - 6.398525278733939e-04*G0_35 - 1.254612799751753e-03*G0_36 + 4.140222239180789e-04*G0_37 + 2.258303039553148e-04*G0_38 - 2.132841759577980e-04*G0_39 - 9.033212158212619e-04*G0_40 + 2.634686879478684e-03*G0_41 - 9.033212158212641e-04*G0_42 - 6.398525278733944e-04*G0_43 - 6.398525278733941e-04*G0_44 + 5.771218878858063e-04*G0_45 - 2.132841759577994e-04*G0_46 + 2.258303039553181e-04*G0_47 - 1.254612799751757e-03*G0_48 + 4.140222239180782e-04*G0_49 - 6.398525278733945e-04*G0_50 + 6.273063998758706e-05*G0_51 - 6.398525278733956e-04*G0_52 + 6.774909118659404e-04*G0_53 - 1.204428287761682e-03*G0_54 + 6.774909118659509e-04*G0_55;
    block[30] = 1.734376734376822e-04*G0_0 + 9.595278692501379e-05*G0_1 + 9.595278692501439e-05*G0_2 + 1.496502147543892e-04*G0_3 - 4.014760959205524e-05*G0_4 + 1.279705055746785e-04*G0_5 + 1.279705055746794e-04*G0_6 - 4.014760959205716e-05*G0_7 - 2.007380479602889e-05*G0_8 - 1.095695178449859e-04*G0_9 + 1.706273407662373e-04*G0_10 - 2.668143220805389e-04*G0_11 - 2.668143220805396e-04*G0_12 + 1.706273407662396e-04*G0_13 - 1.095695178449865e-04*G0_14 - 2.007380479602799e-05*G0_15 - 5.553752660234420e-04*G0_16 + 8.732105086272200e-04*G0_17 - 6.239607657432054e-04*G0_18 + 5.520296318907742e-05*G0_19 - 3.412546815324756e-04*G0_20 + 4.918082175026856e-04*G0_21 - 1.104059263781509e-04*G0_22 + 1.104059263781536e-04*G0_23 - 3.412546815324774e-04*G0_24 + 4.918082175026862e-04*G0_25 - 1.104059263781541e-04*G0_26 + 1.104059263781543e-04*G0_27 + 1.037146581128115e-03*G0_28 - 1.806642431642525e-03*G0_29 + 4.550062420433021e-03*G0_30 + 5.143912478982196e-04*G0_31 - 1.806642431642527e-03*G0_32 + 1.037146581128117e-03*G0_33 + 5.185732905640573e-04*G0_34 - 9.033212158212652e-04*G0_35 + 2.275031210216511e-03*G0_36 + 6.273063998758757e-05*G0_37 - 1.254612799751749e-03*G0_38 + 6.942190825293018e-04*G0_39 + 2.275031210216512e-03*G0_40 - 9.033212158212617e-04*G0_41 + 5.185732905640589e-04*G0_42 - 1.254612799751752e-03*G0_43 + 6.273063998758752e-05*G0_44 + 6.942190825293044e-04*G0_45 + 6.189423145441982e-04*G0_46 - 2.132841759578000e-04*G0_47 + 6.942190825293039e-04*G0_48 - 2.132841759577985e-04*G0_49 + 5.771218878858060e-04*G0_50 + 6.942190825293036e-04*G0_51 - 3.512915839304864e-04*G0_52 + 7.778599358460920e-04*G0_53 + 7.778599358460785e-04*G0_54 + 1.405166335721957e-03*G0_55;
    block[31] = -1.771513273249464e-05*G0_0 - 1.214967035279596e-04*G0_1 - 1.214967035279598e-04*G0_2 + 3.984650252011592e-05*G0_3 + 3.086347487389315e-04*G0_4 - 4.516606079106251e-05*G0_5 - 4.516606079106175e-05*G0_6 + 3.086347487389313e-04*G0_7 - 2.760148159453910e-05*G0_8 + 2.534317855498554e-04*G0_9 - 1.480443103707076e-04*G0_10 - 8.782289598262039e-06*G0_11 - 8.782289598261524e-06*G0_12 - 1.480443103707085e-04*G0_13 + 2.534317855498559e-04*G0_14 - 2.760148159453941e-05*G0_15 + 1.354981823731892e-04*G0_16 - 1.229520543756713e-04*G0_17 - 2.258303039553208e-05*G0_18 + 2.885609439429028e-05*G0_19 - 5.520296318907753e-05*G0_20 - 1.204428287761685e-04*G0_21 - 7.025831678609763e-05*G0_22 - 9.284134718162952e-05*G0_23 - 5.520296318907776e-05*G0_24 - 1.204428287761683e-04*G0_25 - 7.025831678609797e-05*G0_26 - 9.284134718163004e-05*G0_27 - 1.806642431642523e-03*G0_28 - 9.409595998138178e-04*G0_29 + 5.143912478982197e-04*G0_30 + 5.269373758957370e-03*G0_31 - 9.409595998138124e-04*G0_32 - 1.806642431642529e-03*G0_33 - 1.254612799751757e-03*G0_34 - 6.398525278733918e-04*G0_35 + 6.273063998758821e-05*G0_36 + 2.258303039553187e-04*G0_37 + 4.140222239180784e-04*G0_38 - 2.132841759577984e-04*G0_39 + 6.273063998758623e-05*G0_40 - 6.398525278733943e-04*G0_41 - 1.254612799751757e-03*G0_42 + 4.140222239180802e-04*G0_43 + 2.258303039553179e-04*G0_44 - 2.132841759578005e-04*G0_45 + 5.771218878858058e-04*G0_46 - 6.398525278733941e-04*G0_47 - 9.033212158212633e-04*G0_48 - 6.398525278733922e-04*G0_49 + 2.634686879478685e-03*G0_50 - 9.033212158212653e-04*G0_51 - 6.398525278733951e-04*G0_52 + 6.774909118659470e-04*G0_53 + 6.774909118659441e-04*G0_54 - 1.204428287761679e-03*G0_55;
    block[32] = -1.771513273249511e-05*G0_0 + 3.984650252011565e-05*G0_1 - 1.214967035279597e-04*G0_2 - 1.214967035279601e-04*G0_3 - 9.284134718162869e-05*G0_4 - 7.025831678609972e-05*G0_5 - 1.204428287761681e-04*G0_6 - 5.520296318907836e-05*G0_7 - 2.760148159453906e-05*G0_8 + 2.534317855498549e-04*G0_9 - 1.480443103707079e-04*G0_10 - 8.782289598261384e-06*G0_11 + 1.354981823731901e-04*G0_12 - 1.229520543756720e-04*G0_13 - 2.258303039553173e-05*G0_14 + 2.885609439429041e-05*G0_15 - 8.782289598261297e-06*G0_16 - 1.480443103707078e-04*G0_17 + 2.534317855498547e-04*G0_18 - 2.760148159453846e-05*G0_19 - 9.284134718162939e-05*G0_20 - 7.025831678609783e-05*G0_21 - 1.204428287761690e-04*G0_22 - 5.520296318907737e-05*G0_23 + 3.086347487389302e-04*G0_24 - 4.516606079106190e-05*G0_25 - 4.516606079106457e-05*G0_26 + 3.086347487389326e-04*G0_27 + 5.143912478982163e-04*G0_28 - 9.409595998138139e-04*G0_29 - 1.806642431642527e-03*G0_30 - 9.409595998138126e-04*G0_31 + 5.269373758957364e-03*G0_32 - 1.806642431642528e-03*G0_33 - 9.033212158212640e-04*G0_34 + 2.634686879478680e-03*G0_35 - 9.033212158212641e-04*G0_36 - 6.398525278733931e-04*G0_37 - 6.398525278733926e-04*G0_38 + 5.771218878858050e-04*G0_39 - 1.254612799751753e-03*G0_40 - 6.398525278733941e-04*G0_41 + 6.273063998758756e-05*G0_42 + 2.258303039553172e-04*G0_43 + 4.140222239180785e-04*G0_44 - 2.132841759577994e-04*G0_45 - 2.132841759577986e-04*G0_46 + 4.140222239180794e-04*G0_47 + 6.273063998758724e-05*G0_48 + 2.258303039553175e-04*G0_49 - 6.398525278733934e-04*G0_50 - 1.254612799751755e-03*G0_51 - 6.398525278733919e-04*G0_52 - 1.204428287761684e-03*G0_53 + 6.774909118659434e-04*G0_54 + 6.774909118659431e-04*G0_55;
    block[33] = 1.734376734376828e-04*G0_0 + 9.595278692501463e-05*G0_1 + 1.496502147543890e-04*G0_2 + 9.595278692501427e-05*G0_3 - 3.412546815324781e-04*G0_4 + 4.918082175026893e-04*G0_5 - 1.104059263781557e-04*G0_6 + 1.104059263781547e-04*G0_7 + 5.520296318907817e-05*G0_8 - 6.239607657432077e-04*G0_9 + 8.732105086272224e-04*G0_10 - 5.553752660234437e-04*G0_11 - 2.668143220805407e-04*G0_12 + 1.706273407662398e-04*G0_13 - 1.095695178449865e-04*G0_14 - 2.007380479602868e-05*G0_15 - 2.668143220805403e-04*G0_16 + 1.706273407662392e-04*G0_17 - 1.095695178449869e-04*G0_18 - 2.007380479602778e-05*G0_19 - 4.014760959205640e-05*G0_20 + 1.279705055746789e-04*G0_21 + 1.279705055746803e-04*G0_22 - 4.014760959205618e-05*G0_23 + 1.104059263781555e-04*G0_24 - 1.104059263781554e-04*G0_25 + 4.918082175026880e-04*G0_26 - 3.412546815324774e-04*G0_27 + 1.037146581128118e-03*G0_28 + 5.143912478982190e-04*G0_29 + 1.037146581128117e-03*G0_30 - 1.806642431642529e-03*G0_31 - 1.806642431642528e-03*G0_32 + 4.550062420433034e-03*G0_33 + 2.275031210216518e-03*G0_34 - 9.033212158212645e-04*G0_35 + 5.185732905640604e-04*G0_36 - 1.254612799751756e-03*G0_37 + 6.273063998759004e-05*G0_38 + 6.942190825293053e-04*G0_39 + 6.942190825293053e-04*G0_40 + 5.771218878858066e-04*G0_41 + 6.942190825293057e-04*G0_42 - 2.132841759577996e-04*G0_43 - 2.132841759578000e-04*G0_44 + 6.189423145442003e-04*G0_45 + 6.942190825293042e-04*G0_46 + 6.273063998758438e-05*G0_47 + 5.185732905640606e-04*G0_48 - 1.254612799751756e-03*G0_49 - 9.033212158212647e-04*G0_50 + 2.275031210216517e-03*G0_51 - 3.512915839304907e-04*G0_52 + 7.778599358460880e-04*G0_53 + 1.405166335721969e-03*G0_54 + 7.778599358460878e-04*G0_55;
    block[34] = 9.595278692501431e-05*G0_0 + 1.734376734376830e-04*G0_1 + 1.496502147543888e-04*G0_2 + 9.595278692501435e-05*G0_3 - 5.553752660234451e-04*G0_4 + 8.732105086272227e-04*G0_5 - 6.239607657432085e-04*G0_6 + 5.520296318907775e-05*G0_7 + 1.104059263781556e-04*G0_8 - 1.104059263781564e-04*G0_9 + 4.918082175026888e-04*G0_10 - 3.412546815324779e-04*G0_11 - 2.007380479602831e-05*G0_12 - 1.095695178449863e-04*G0_13 + 1.706273407662390e-04*G0_14 - 2.668143220805411e-04*G0_15 - 4.014760959205639e-05*G0_16 + 1.279705055746787e-04*G0_17 + 1.279705055746789e-04*G0_18 - 4.014760959205595e-05*G0_19 - 2.668143220805404e-04*G0_20 + 1.706273407662391e-04*G0_21 - 1.095695178449856e-04*G0_22 - 2.007380479602788e-05*G0_23 + 1.104059263781558e-04*G0_24 - 1.104059263781555e-04*G0_25 + 4.918082175026884e-04*G0_26 - 3.412546815324772e-04*G0_27 + 6.942190825293049e-04*G0_28 + 6.273063998758761e-05*G0_29 + 5.185732905640573e-04*G0_30 - 1.254612799751757e-03*G0_31 - 9.033212158212640e-04*G0_32 + 2.275031210216518e-03*G0_33 + 4.550062420433027e-03*G0_34 - 1.806642431642525e-03*G0_35 + 1.037146581128119e-03*G0_36 - 1.806642431642528e-03*G0_37 + 5.143912478982193e-04*G0_38 + 1.037146581128117e-03*G0_39 + 6.942190825293050e-04*G0_40 - 2.132841759577983e-04*G0_41 + 6.189423145441987e-04*G0_42 + 5.771218878858052e-04*G0_43 - 2.132841759577992e-04*G0_44 + 6.942190825293058e-04*G0_45 + 5.185732905640582e-04*G0_46 + 6.273063998758462e-05*G0_47 + 6.942190825293048e-04*G0_48 - 9.033212158212646e-04*G0_49 - 1.254612799751756e-03*G0_50 + 2.275031210216515e-03*G0_51 + 7.778599358460891e-04*G0_52 - 3.512915839304920e-04*G0_53 + 1.405166335721969e-03*G0_54 + 7.778599358460889e-04*G0_55;
    block[35] = 3.984650252011544e-05*G0_0 - 1.771513273249493e-05*G0_1 - 1.214967035279595e-04*G0_2 - 1.214967035279600e-04*G0_3 - 8.782289598260955e-06*G0_4 - 1.480443103707083e-04*G0_5 + 2.534317855498556e-04*G0_6 - 2.760148159453970e-05*G0_7 - 5.520296318907818e-05*G0_8 - 1.204428287761675e-04*G0_9 - 7.025831678609909e-05*G0_10 - 9.284134718162903e-05*G0_11 + 2.885609439429073e-05*G0_12 - 2.258303039553134e-05*G0_13 - 1.229520543756720e-04*G0_14 + 1.354981823731896e-04*G0_15 - 9.284134718162892e-05*G0_16 - 7.025831678609854e-05*G0_17 - 1.204428287761677e-04*G0_18 - 5.520296318907705e-05*G0_19 - 8.782289598261616e-06*G0_20 - 1.480443103707077e-04*G0_21 + 2.534317855498553e-04*G0_22 - 2.760148159453941e-05*G0_23 + 3.086347487389298e-04*G0_24 - 4.516606079106201e-05*G0_25 - 4.516606079106408e-05*G0_26 + 3.086347487389315e-04*G0_27 + 5.771218878858060e-04*G0_28 - 6.398525278733941e-04*G0_29 - 9.033212158212652e-04*G0_30 - 6.398525278733918e-04*G0_31 + 2.634686879478680e-03*G0_32 - 9.033212158212644e-04*G0_33 - 1.806642431642525e-03*G0_34 + 5.269373758957362e-03*G0_35 - 1.806642431642528e-03*G0_36 - 9.409595998138149e-04*G0_37 - 9.409595998138108e-04*G0_38 + 5.143912478982169e-04*G0_39 - 1.254612799751753e-03*G0_40 + 2.258303039553157e-04*G0_41 - 2.132841759577974e-04*G0_42 - 6.398525278733922e-04*G0_43 + 4.140222239180787e-04*G0_44 + 6.273063998758687e-05*G0_45 + 6.273063998758782e-05*G0_46 + 4.140222239180794e-04*G0_47 - 2.132841759577978e-04*G0_48 - 6.398525278733947e-04*G0_49 + 2.258303039553179e-04*G0_50 - 1.254612799751754e-03*G0_51 - 1.204428287761680e-03*G0_52 - 6.398525278733921e-04*G0_53 + 6.774909118659422e-04*G0_54 + 6.774909118659403e-04*G0_55;
    block[36] = 9.595278692501389e-05*G0_0 + 1.734376734376824e-04*G0_1 + 9.595278692501416e-05*G0_2 + 1.496502147543892e-04*G0_3 - 2.668143220805398e-04*G0_4 + 1.706273407662389e-04*G0_5 - 1.095695178449875e-04*G0_6 - 2.007380479602863e-05*G0_7 - 4.014760959205640e-05*G0_8 + 1.279705055746791e-04*G0_9 + 1.279705055746786e-04*G0_10 - 4.014760959205599e-05*G0_11 - 2.007380479602830e-05*G0_12 - 1.095695178449859e-04*G0_13 + 1.706273407662391e-04*G0_14 - 2.668143220805400e-04*G0_15 - 3.412546815324767e-04*G0_16 + 4.918082175026873e-04*G0_17 - 1.104059263781539e-04*G0_18 + 1.104059263781541e-04*G0_19 - 5.553752660234426e-04*G0_20 + 8.732105086272197e-04*G0_21 - 6.239607657432041e-04*G0_22 + 5.520296318907680e-05*G0_23 - 3.412546815324765e-04*G0_24 + 4.918082175026863e-04*G0_25 - 1.104059263781534e-04*G0_26 + 1.104059263781541e-04*G0_27 + 6.942190825293037e-04*G0_28 - 1.254612799751753e-03*G0_29 + 2.275031210216511e-03*G0_30 + 6.273063998758821e-05*G0_31 - 9.033212158212641e-04*G0_32 + 5.185732905640605e-04*G0_33 + 1.037146581128119e-03*G0_34 - 1.806642431642528e-03*G0_35 + 4.550062420433028e-03*G0_36 + 5.143912478982187e-04*G0_37 - 1.806642431642521e-03*G0_38 + 1.037146581128117e-03*G0_39 + 2.275031210216512e-03*G0_40 - 1.254612799751752e-03*G0_41 + 6.942190825293047e-04*G0_42 - 9.033212158212629e-04*G0_43 + 6.273063998758641e-05*G0_44 + 5.185732905640599e-04*G0_45 + 6.942190825293041e-04*G0_46 - 2.132841759578001e-04*G0_47 + 6.189423145441988e-04*G0_48 + 5.771218878858060e-04*G0_49 - 2.132841759577994e-04*G0_50 + 6.942190825293057e-04*G0_51 + 7.778599358460896e-04*G0_52 - 3.512915839304866e-04*G0_53 + 7.778599358460877e-04*G0_54 + 1.405166335721958e-03*G0_55;
    block[37] = -1.214967035279600e-04*G0_0 - 1.771513273249520e-05*G0_1 - 1.214967035279601e-04*G0_2 + 3.984650252011550e-05*G0_3 - 8.782289598261507e-06*G0_4 - 1.480443103707080e-04*G0_5 + 2.534317855498547e-04*G0_6 - 2.760148159453894e-05*G0_7 + 3.086347487389309e-04*G0_8 - 4.516606079106177e-05*G0_9 - 4.516606079106397e-05*G0_10 + 3.086347487389314e-04*G0_11 - 2.760148159453904e-05*G0_12 + 2.534317855498548e-04*G0_13 - 1.480443103707077e-04*G0_14 - 8.782289598261834e-06*G0_15 - 5.520296318907765e-05*G0_16 - 1.204428287761674e-04*G0_17 - 7.025831678609897e-05*G0_18 - 9.284134718162964e-05*G0_19 + 1.354981823731893e-04*G0_20 - 1.229520543756719e-04*G0_21 - 2.258303039553214e-05*G0_22 + 2.885609439429034e-05*G0_23 - 5.520296318907776e-05*G0_24 - 1.204428287761678e-04*G0_25 - 7.025831678609839e-05*G0_26 - 9.284134718162966e-05*G0_27 - 2.132841759577991e-04*G0_28 + 4.140222239180789e-04*G0_29 + 6.273063998758752e-05*G0_30 + 2.258303039553186e-04*G0_31 - 6.398525278733931e-04*G0_32 - 1.254612799751757e-03*G0_33 - 1.806642431642528e-03*G0_34 - 9.409595998138149e-04*G0_35 + 5.143912478982184e-04*G0_36 + 5.269373758957368e-03*G0_37 - 9.409595998138147e-04*G0_38 - 1.806642431642526e-03*G0_39 + 6.273063998758638e-05*G0_40 + 4.140222239180800e-04*G0_41 - 2.132841759577991e-04*G0_42 - 6.398525278733943e-04*G0_43 + 2.258303039553160e-04*G0_44 - 1.254612799751754e-03*G0_45 - 9.033212158212631e-04*G0_46 - 6.398525278733936e-04*G0_47 + 5.771218878858055e-04*G0_48 + 2.634686879478685e-03*G0_49 - 6.398525278733936e-04*G0_50 - 9.033212158212643e-04*G0_51 + 6.774909118659428e-04*G0_52 - 6.398525278733961e-04*G0_53 + 6.774909118659494e-04*G0_54 - 1.204428287761684e-03*G0_55;
    block[38] = -1.214967035279589e-04*G0_0 - 1.771513273249473e-05*G0_1 + 3.984650252011558e-05*G0_2 - 1.214967035279598e-04*G0_3 + 1.354981823731890e-04*G0_4 - 1.229520543756712e-04*G0_5 - 2.258303039553129e-05*G0_6 + 2.885609439429070e-05*G0_7 - 9.284134718162866e-05*G0_8 - 7.025831678609981e-05*G0_9 - 1.204428287761659e-04*G0_10 - 5.520296318907919e-05*G0_11 - 2.760148159454029e-05*G0_12 + 2.534317855498556e-04*G0_13 - 1.480443103707078e-04*G0_14 - 8.782289598261675e-06*G0_15 + 3.086347487389294e-04*G0_16 - 4.516606079106112e-05*G0_17 - 4.516606079106494e-05*G0_18 + 3.086347487389315e-04*G0_19 - 8.782289598262209e-06*G0_20 - 1.480443103707064e-04*G0_21 + 2.534317855498533e-04*G0_22 - 2.760148159453832e-05*G0_23 - 9.284134718162935e-05*G0_24 - 7.025831678609709e-05*G0_25 - 1.204428287761682e-04*G0_26 - 5.520296318907730e-05*G0_27 - 2.132841759577945e-04*G0_28 + 2.258303039553148e-04*G0_29 - 1.254612799751749e-03*G0_30 + 4.140222239180784e-04*G0_31 - 6.398525278733926e-04*G0_32 + 6.273063998759001e-05*G0_33 + 5.143912478982191e-04*G0_34 - 9.409595998138108e-04*G0_35 - 1.806642431642521e-03*G0_36 - 9.409595998138149e-04*G0_37 + 5.269373758957355e-03*G0_38 - 1.806642431642522e-03*G0_39 - 9.033212158212593e-04*G0_40 - 6.398525278733938e-04*G0_41 + 5.771218878858081e-04*G0_42 + 2.634686879478683e-03*G0_43 - 6.398525278733953e-04*G0_44 - 9.033212158212623e-04*G0_45 - 1.254612799751751e-03*G0_46 + 2.258303039553146e-04*G0_47 - 2.132841759577961e-04*G0_48 - 6.398525278733947e-04*G0_49 + 4.140222239180790e-04*G0_50 + 6.273063998758921e-05*G0_51 + 6.774909118659384e-04*G0_52 - 6.398525278733889e-04*G0_53 - 1.204428287761674e-03*G0_54 + 6.774909118659551e-04*G0_55;
    block[39] = 1.496502147543894e-04*G0_0 + 1.734376734376826e-04*G0_1 + 9.595278692501433e-05*G0_2 + 9.595278692501427e-05*G0_3 - 2.668143220805403e-04*G0_4 + 1.706273407662395e-04*G0_5 - 1.095695178449880e-04*G0_6 - 2.007380479602821e-05*G0_7 - 3.412546815324772e-04*G0_8 + 4.918082175026868e-04*G0_9 - 1.104059263781557e-04*G0_10 + 1.104059263781550e-04*G0_11 + 5.520296318907801e-05*G0_12 - 6.239607657432055e-04*G0_13 + 8.732105086272216e-04*G0_14 - 5.553752660234433e-04*G0_15 + 1.104059263781552e-04*G0_16 - 1.104059263781552e-04*G0_17 + 4.918082175026889e-04*G0_18 - 3.412546815324768e-04*G0_19 - 2.668143220805398e-04*G0_20 + 1.706273407662386e-04*G0_21 - 1.095695178449851e-04*G0_22 - 2.007380479602820e-05*G0_23 - 4.014760959205590e-05*G0_24 + 1.279705055746777e-04*G0_25 + 1.279705055746789e-04*G0_26 - 4.014760959205621e-05*G0_27 + 6.189423145441976e-04*G0_28 - 2.132841759577980e-04*G0_29 + 6.942190825293017e-04*G0_30 - 2.132841759577984e-04*G0_31 + 5.771218878858050e-04*G0_32 + 6.942190825293053e-04*G0_33 + 1.037146581128117e-03*G0_34 + 5.143912478982170e-04*G0_35 + 1.037146581128117e-03*G0_36 - 1.806642431642526e-03*G0_37 - 1.806642431642522e-03*G0_38 + 4.550062420433023e-03*G0_39 + 5.185732905640587e-04*G0_40 + 6.273063998758652e-05*G0_41 + 6.942190825293045e-04*G0_42 - 9.033212158212639e-04*G0_43 - 1.254612799751753e-03*G0_44 + 2.275031210216514e-03*G0_45 + 2.275031210216511e-03*G0_46 - 1.254612799751756e-03*G0_47 + 6.942190825293043e-04*G0_48 - 9.033212158212646e-04*G0_49 + 6.273063998758676e-05*G0_50 + 5.185732905640591e-04*G0_51 + 1.405166335721971e-03*G0_52 - 3.512915839304925e-04*G0_53 + 7.778599358460866e-04*G0_54 + 7.778599358460844e-04*G0_55;
    block[40] = 9.595278692501408e-05*G0_0 + 9.595278692501410e-05*G0_1 + 1.734376734376825e-04*G0_2 + 1.496502147543891e-04*G0_3 - 2.007380479602794e-05*G0_4 - 1.095695178449865e-04*G0_5 + 1.706273407662379e-04*G0_6 - 2.668143220805399e-04*G0_7 - 2.668143220805402e-04*G0_8 + 1.706273407662388e-04*G0_9 - 1.095695178449867e-04*G0_10 - 2.007380479602798e-05*G0_11 - 4.014760959205645e-05*G0_12 + 1.279705055746799e-04*G0_13 + 1.279705055746789e-04*G0_14 - 4.014760959205594e-05*G0_15 - 3.412546815324763e-04*G0_16 + 4.918082175026865e-04*G0_17 - 1.104059263781530e-04*G0_18 + 1.104059263781545e-04*G0_19 - 3.412546815324765e-04*G0_20 + 4.918082175026866e-04*G0_21 - 1.104059263781524e-04*G0_22 + 1.104059263781544e-04*G0_23 - 5.553752660234430e-04*G0_24 + 8.732105086272204e-04*G0_25 - 6.239607657432055e-04*G0_26 + 5.520296318907717e-05*G0_27 + 5.185732905640589e-04*G0_28 - 9.033212158212619e-04*G0_29 + 2.275031210216512e-03*G0_30 + 6.273063998758626e-05*G0_31 - 1.254612799751753e-03*G0_32 + 6.942190825293052e-04*G0_33 + 6.942190825293052e-04*G0_34 - 1.254612799751753e-03*G0_35 + 2.275031210216512e-03*G0_36 + 6.273063998758644e-05*G0_37 - 9.033212158212594e-04*G0_38 + 5.185732905640587e-04*G0_39 + 4.550062420433027e-03*G0_40 - 1.806642431642525e-03*G0_41 + 1.037146581128119e-03*G0_42 - 1.806642431642524e-03*G0_43 + 5.143912478982160e-04*G0_44 + 1.037146581128117e-03*G0_45 + 6.942190825293027e-04*G0_46 + 5.771218878858040e-04*G0_47 + 6.942190825293047e-04*G0_48 - 2.132841759577982e-04*G0_49 - 2.132841759577990e-04*G0_50 + 6.189423145441981e-04*G0_51 + 7.778599358460870e-04*G0_52 + 7.778599358460890e-04*G0_53 - 3.512915839304901e-04*G0_54 + 1.405166335721963e-03*G0_55;
    block[41] = 3.984650252011556e-05*G0_0 - 1.214967035279596e-04*G0_1 - 1.771513273249508e-05*G0_2 - 1.214967035279601e-04*G0_3 - 2.760148159453973e-05*G0_4 + 2.534317855498554e-04*G0_5 - 1.480443103707081e-04*G0_6 - 8.782289598261070e-06*G0_7 + 1.354981823731902e-04*G0_8 - 1.229520543756725e-04*G0_9 - 2.258303039553105e-05*G0_10 + 2.885609439429041e-05*G0_11 - 9.284134718162904e-05*G0_12 - 7.025831678609978e-05*G0_13 - 1.204428287761680e-04*G0_14 - 5.520296318907769e-05*G0_15 - 9.284134718162984e-05*G0_16 - 7.025831678609808e-05*G0_17 - 1.204428287761691e-04*G0_18 - 5.520296318907689e-05*G0_19 + 3.086347487389299e-04*G0_20 - 4.516606079106125e-05*G0_21 - 4.516606079106441e-05*G0_22 + 3.086347487389324e-04*G0_23 - 8.782289598261306e-06*G0_24 - 1.480443103707075e-04*G0_25 + 2.534317855498547e-04*G0_26 - 2.760148159453861e-05*G0_27 - 9.033212158212639e-04*G0_28 + 2.634686879478683e-03*G0_29 - 9.033212158212618e-04*G0_30 - 6.398525278733943e-04*G0_31 - 6.398525278733942e-04*G0_32 + 5.771218878858066e-04*G0_33 - 2.132841759577983e-04*G0_34 + 2.258303039553157e-04*G0_35 - 1.254612799751752e-03*G0_36 + 4.140222239180800e-04*G0_37 - 6.398525278733939e-04*G0_38 + 6.273063998758650e-05*G0_39 - 1.806642431642525e-03*G0_40 + 5.269373758957367e-03*G0_41 - 1.806642431642528e-03*G0_42 - 9.409595998138148e-04*G0_43 - 9.409595998138140e-04*G0_44 + 5.143912478982174e-04*G0_45 + 6.273063998758600e-05*G0_46 - 6.398525278733933e-04*G0_47 - 1.254612799751757e-03*G0_48 + 4.140222239180793e-04*G0_49 + 2.258303039553159e-04*G0_50 - 2.132841759577987e-04*G0_51 - 1.204428287761683e-03*G0_52 + 6.774909118659406e-04*G0_53 - 6.398525278733925e-04*G0_54 + 6.774909118659471e-04*G0_55;
    block[42] = 9.595278692501474e-05*G0_0 + 1.496502147543885e-04*G0_1 + 1.734376734376828e-04*G0_2 + 9.595278692501417e-05*G0_3 + 5.520296318907859e-05*G0_4 - 6.239607657432074e-04*G0_5 + 8.732105086272228e-04*G0_6 - 5.553752660234444e-04*G0_7 - 2.668143220805396e-04*G0_8 + 1.706273407662385e-04*G0_9 - 1.095695178449866e-04*G0_10 - 2.007380479602832e-05*G0_11 - 3.412546815324791e-04*G0_12 + 4.918082175026917e-04*G0_13 - 1.104059263781569e-04*G0_14 + 1.104059263781563e-04*G0_15 - 4.014760959205649e-05*G0_16 + 1.279705055746790e-04*G0_17 + 1.279705055746796e-04*G0_18 - 4.014760959205603e-05*G0_19 + 1.104059263781574e-04*G0_20 - 1.104059263781562e-04*G0_21 + 4.918082175026896e-04*G0_22 - 3.412546815324779e-04*G0_23 - 2.668143220805403e-04*G0_24 + 1.706273407662388e-04*G0_25 - 1.095695178449870e-04*G0_26 - 2.007380479602827e-05*G0_27 + 2.275031210216517e-03*G0_28 - 9.033212158212639e-04*G0_29 + 5.185732905640589e-04*G0_30 - 1.254612799751756e-03*G0_31 + 6.273063998758756e-05*G0_32 + 6.942190825293056e-04*G0_33 + 6.189423145441987e-04*G0_34 - 2.132841759577973e-04*G0_35 + 6.942190825293046e-04*G0_36 - 2.132841759577991e-04*G0_37 + 5.771218878858079e-04*G0_38 + 6.942190825293045e-04*G0_39 + 1.037146581128119e-03*G0_40 - 1.806642431642528e-03*G0_41 + 4.550062420433036e-03*G0_42 + 5.143912478982176e-04*G0_43 - 1.806642431642531e-03*G0_44 + 1.037146581128121e-03*G0_45 + 5.185732905640599e-04*G0_46 - 9.033212158212691e-04*G0_47 + 2.275031210216518e-03*G0_48 + 6.273063998758760e-05*G0_49 - 1.254612799751756e-03*G0_50 + 6.942190825293048e-04*G0_51 + 7.778599358460890e-04*G0_52 + 1.405166335721968e-03*G0_53 - 3.512915839304924e-04*G0_54 + 7.778599358460881e-04*G0_55;
    block[43] = -1.214967035279601e-04*G0_0 + 3.984650252011544e-05*G0_1 - 1.771513273249504e-05*G0_2 - 1.214967035279601e-04*G0_3 + 2.885609439429029e-05*G0_4 - 2.258303039553117e-05*G0_5 - 1.229520543756725e-04*G0_6 + 1.354981823731901e-04*G0_7 - 8.782289598261506e-06*G0_8 - 1.480443103707077e-04*G0_9 + 2.534317855498552e-04*G0_10 - 2.760148159453904e-05*G0_11 - 5.520296318907761e-05*G0_12 - 1.204428287761687e-04*G0_13 - 7.025831678609851e-05*G0_14 - 9.284134718162973e-05*G0_15 + 3.086347487389308e-04*G0_16 - 4.516606079106313e-05*G0_17 - 4.516606079106448e-05*G0_18 + 3.086347487389320e-04*G0_19 - 9.284134718163000e-05*G0_20 - 7.025831678609749e-05*G0_21 - 1.204428287761706e-04*G0_22 - 5.520296318907652e-05*G0_23 - 8.782289598261646e-06*G0_24 - 1.480443103707071e-04*G0_25 + 2.534317855498537e-04*G0_26 - 2.760148159453824e-05*G0_27 + 6.273063998758619e-05*G0_28 - 6.398525278733944e-04*G0_29 - 1.254612799751752e-03*G0_30 + 4.140222239180802e-04*G0_31 + 2.258303039553172e-04*G0_32 - 2.132841759577996e-04*G0_33 + 5.771218878858052e-04*G0_34 - 6.398525278733925e-04*G0_35 - 9.033212158212629e-04*G0_36 - 6.398525278733943e-04*G0_37 + 2.634686879478683e-03*G0_38 - 9.033212158212639e-04*G0_39 - 1.806642431642524e-03*G0_40 - 9.409595998138149e-04*G0_41 + 5.143912478982176e-04*G0_42 + 5.269373758957368e-03*G0_43 - 9.409595998138131e-04*G0_44 - 1.806642431642530e-03*G0_45 - 1.254612799751756e-03*G0_46 - 6.398525278733936e-04*G0_47 + 6.273063998758603e-05*G0_48 + 2.258303039553162e-04*G0_49 + 4.140222239180796e-04*G0_50 - 2.132841759577989e-04*G0_51 + 6.774909118659421e-04*G0_52 - 1.204428287761685e-03*G0_53 - 6.398525278733936e-04*G0_54 + 6.774909118659520e-04*G0_55;
    block[44] = -1.214967035279605e-04*G0_0 - 1.214967035279597e-04*G0_1 - 1.771513273249503e-05*G0_2 + 3.984650252011581e-05*G0_3 - 2.760148159453880e-05*G0_4 + 2.534317855498551e-04*G0_5 - 1.480443103707079e-04*G0_6 - 8.782289598261563e-06*G0_7 - 8.782289598261988e-06*G0_8 - 1.480443103707070e-04*G0_9 + 2.534317855498549e-04*G0_10 - 2.760148159453858e-05*G0_11 + 3.086347487389324e-04*G0_12 - 4.516606079106553e-05*G0_13 - 4.516606079106144e-05*G0_14 + 3.086347487389311e-04*G0_15 - 5.520296318907718e-05*G0_16 - 1.204428287761684e-04*G0_17 - 7.025831678609850e-05*G0_18 - 9.284134718163014e-05*G0_19 - 5.520296318907814e-05*G0_20 - 1.204428287761689e-04*G0_21 - 7.025831678609905e-05*G0_22 - 9.284134718162996e-05*G0_23 + 1.354981823731894e-04*G0_24 - 1.229520543756719e-04*G0_25 - 2.258303039553131e-05*G0_26 + 2.885609439429017e-05*G0_27 - 1.254612799751758e-03*G0_28 - 6.398525278733941e-04*G0_29 + 6.273063998758748e-05*G0_30 + 2.258303039553181e-04*G0_31 + 4.140222239180785e-04*G0_32 - 2.132841759578000e-04*G0_33 - 2.132841759577992e-04*G0_34 + 4.140222239180787e-04*G0_35 + 6.273063998758649e-05*G0_36 + 2.258303039553159e-04*G0_37 - 6.398525278733953e-04*G0_38 - 1.254612799751753e-03*G0_39 + 5.143912478982157e-04*G0_40 - 9.409595998138137e-04*G0_41 - 1.806642431642531e-03*G0_42 - 9.409595998138129e-04*G0_43 + 5.269373758957371e-03*G0_44 - 1.806642431642527e-03*G0_45 - 9.033212158212654e-04*G0_46 + 2.634686879478688e-03*G0_47 - 9.033212158212658e-04*G0_48 - 6.398525278733942e-04*G0_49 - 6.398525278733927e-04*G0_50 + 5.771218878858056e-04*G0_51 + 6.774909118659466e-04*G0_52 + 6.774909118659466e-04*G0_53 - 6.398525278733954e-04*G0_54 - 1.204428287761685e-03*G0_55;
    block[45] = 1.496502147543898e-04*G0_0 + 9.595278692501435e-05*G0_1 + 1.734376734376827e-04*G0_2 + 9.595278692501448e-05*G0_3 - 2.007380479602856e-05*G0_4 - 1.095695178449863e-04*G0_5 + 1.706273407662383e-04*G0_6 - 2.668143220805399e-04*G0_7 - 5.553752660234435e-04*G0_8 + 8.732105086272223e-04*G0_9 - 6.239607657432080e-04*G0_10 + 5.520296318907787e-05*G0_11 + 1.104059263781546e-04*G0_12 - 1.104059263781531e-04*G0_13 + 4.918082175026880e-04*G0_14 - 3.412546815324769e-04*G0_15 + 1.104059263781551e-04*G0_16 - 1.104059263781564e-04*G0_17 + 4.918082175026893e-04*G0_18 - 3.412546815324772e-04*G0_19 - 4.014760959205550e-05*G0_20 + 1.279705055746789e-04*G0_21 + 1.279705055746805e-04*G0_22 - 4.014760959205614e-05*G0_23 - 2.668143220805398e-04*G0_24 + 1.706273407662379e-04*G0_25 - 1.095695178449862e-04*G0_26 - 2.007380479602875e-05*G0_27 + 6.942190825293063e-04*G0_28 + 5.771218878858063e-04*G0_29 + 6.942190825293044e-04*G0_30 - 2.132841759578005e-04*G0_31 - 2.132841759577994e-04*G0_32 + 6.189423145442003e-04*G0_33 + 6.942190825293060e-04*G0_34 + 6.273063998758683e-05*G0_35 + 5.185732905640600e-04*G0_36 - 1.254612799751755e-03*G0_37 - 9.033212158212622e-04*G0_38 + 2.275031210216514e-03*G0_39 + 1.037146581128117e-03*G0_40 + 5.143912478982174e-04*G0_41 + 1.037146581128121e-03*G0_42 - 1.806642431642530e-03*G0_43 - 1.806642431642527e-03*G0_44 + 4.550062420433035e-03*G0_45 + 2.275031210216513e-03*G0_46 - 9.033212158212667e-04*G0_47 + 5.185732905640608e-04*G0_48 - 1.254612799751755e-03*G0_49 + 6.273063998758627e-05*G0_50 + 6.942190825293055e-04*G0_51 + 1.405166335721969e-03*G0_52 + 7.778599358460863e-04*G0_53 - 3.512915839304921e-04*G0_54 + 7.778599358460861e-04*G0_55;
    block[46] = 1.496502147543896e-04*G0_0 + 9.595278692501406e-05*G0_1 + 9.595278692501410e-05*G0_2 + 1.734376734376826e-04*G0_3 - 4.014760959205582e-05*G0_4 + 1.279705055746790e-04*G0_5 + 1.279705055746784e-04*G0_6 - 4.014760959205611e-05*G0_7 - 3.412546815324769e-04*G0_8 + 4.918082175026875e-04*G0_9 - 1.104059263781559e-04*G0_10 + 1.104059263781536e-04*G0_11 + 1.104059263781538e-04*G0_12 - 1.104059263781526e-04*G0_13 + 4.918082175026866e-04*G0_14 - 3.412546815324766e-04*G0_15 + 5.520296318907701e-05*G0_16 - 6.239607657432056e-04*G0_17 + 8.732105086272207e-04*G0_18 - 5.553752660234433e-04*G0_19 - 2.007380479602776e-05*G0_20 - 1.095695178449873e-04*G0_21 + 1.706273407662403e-04*G0_22 - 2.668143220805399e-04*G0_23 - 2.007380479602788e-05*G0_24 - 1.095695178449874e-04*G0_25 + 1.706273407662385e-04*G0_26 - 2.668143220805399e-04*G0_27 + 6.942190825293065e-04*G0_28 - 2.132841759577994e-04*G0_29 + 6.189423145441982e-04*G0_30 + 5.771218878858058e-04*G0_31 - 2.132841759577986e-04*G0_32 + 6.942190825293042e-04*G0_33 + 5.185732905640581e-04*G0_34 + 6.273063998758782e-05*G0_35 + 6.942190825293041e-04*G0_36 - 9.033212158212633e-04*G0_37 - 1.254612799751751e-03*G0_38 + 2.275031210216511e-03*G0_39 + 6.942190825293027e-04*G0_40 + 6.273063998758603e-05*G0_41 + 5.185732905640599e-04*G0_42 - 1.254612799751756e-03*G0_43 - 9.033212158212653e-04*G0_44 + 2.275031210216513e-03*G0_45 + 4.550062420433021e-03*G0_46 - 1.806642431642529e-03*G0_47 + 1.037146581128120e-03*G0_48 - 1.806642431642528e-03*G0_49 + 5.143912478982176e-04*G0_50 + 1.037146581128116e-03*G0_51 + 1.405166335721964e-03*G0_52 + 7.778599358460866e-04*G0_53 + 7.778599358460874e-04*G0_54 - 3.512915839304921e-04*G0_55;
    block[47] = -1.214967035279606e-04*G0_0 - 1.214967035279598e-04*G0_1 + 3.984650252011532e-05*G0_2 - 1.771513273249512e-05*G0_3 - 5.520296318907836e-05*G0_4 - 1.204428287761678e-04*G0_5 - 7.025831678609927e-05*G0_6 - 9.284134718162895e-05*G0_7 - 9.284134718162957e-05*G0_8 - 7.025831678609865e-05*G0_9 - 1.204428287761678e-04*G0_10 - 5.520296318907673e-05*G0_11 + 3.086347487389330e-04*G0_12 - 4.516606079106644e-05*G0_13 - 4.516606079106116e-05*G0_14 + 3.086347487389309e-04*G0_15 - 2.760148159453807e-05*G0_16 + 2.534317855498544e-04*G0_17 - 1.480443103707074e-04*G0_18 - 8.782289598262151e-06*G0_19 - 2.760148159453917e-05*G0_20 + 2.534317855498559e-04*G0_21 - 1.480443103707096e-04*G0_22 - 8.782289598261287e-06*G0_23 + 2.885609439429044e-05*G0_24 - 2.258303039553082e-05*G0_25 - 1.229520543756726e-04*G0_26 + 1.354981823731902e-04*G0_27 - 1.254612799751761e-03*G0_28 + 2.258303039553181e-04*G0_29 - 2.132841759578001e-04*G0_30 - 6.398525278733941e-04*G0_31 + 4.140222239180794e-04*G0_32 + 6.273063998758438e-05*G0_33 + 6.273063998758461e-05*G0_34 + 4.140222239180794e-04*G0_35 - 2.132841759578000e-04*G0_36 - 6.398525278733936e-04*G0_37 + 2.258303039553146e-04*G0_38 - 1.254612799751756e-03*G0_39 + 5.771218878858040e-04*G0_40 - 6.398525278733932e-04*G0_41 - 9.033212158212692e-04*G0_42 - 6.398525278733935e-04*G0_43 + 2.634686879478688e-03*G0_44 - 9.033212158212667e-04*G0_45 - 1.806642431642529e-03*G0_46 + 5.269373758957372e-03*G0_47 - 1.806642431642535e-03*G0_48 - 9.409595998138135e-04*G0_49 - 9.409595998138123e-04*G0_50 + 5.143912478982153e-04*G0_51 + 6.774909118659452e-04*G0_52 + 6.774909118659429e-04*G0_53 - 1.204428287761687e-03*G0_54 - 6.398525278733969e-04*G0_55;
    block[48] = 9.595278692501474e-05*G0_0 + 1.496502147543884e-04*G0_1 + 9.595278692501433e-05*G0_2 + 1.734376734376827e-04*G0_3 + 1.104059263781565e-04*G0_4 - 1.104059263781563e-04*G0_5 + 4.918082175026892e-04*G0_6 - 3.412546815324782e-04*G0_7 - 4.014760959205599e-05*G0_8 + 1.279705055746782e-04*G0_9 + 1.279705055746790e-04*G0_10 - 4.014760959205728e-05*G0_11 - 3.412546815324795e-04*G0_12 + 4.918082175026919e-04*G0_13 - 1.104059263781577e-04*G0_14 + 1.104059263781560e-04*G0_15 - 2.007380479602871e-05*G0_16 - 1.095695178449859e-04*G0_17 + 1.706273407662386e-04*G0_18 - 2.668143220805395e-04*G0_19 + 5.520296318907880e-05*G0_20 - 6.239607657432084e-04*G0_21 + 8.732105086272241e-04*G0_22 - 5.553752660234443e-04*G0_23 - 2.007380479602817e-05*G0_24 - 1.095695178449871e-04*G0_25 + 1.706273407662386e-04*G0_26 - 2.668143220805401e-04*G0_27 + 2.275031210216518e-03*G0_28 - 1.254612799751757e-03*G0_29 + 6.942190825293040e-04*G0_30 - 9.033212158212633e-04*G0_31 + 6.273063998758726e-05*G0_32 + 5.185732905640606e-04*G0_33 + 6.942190825293048e-04*G0_34 - 2.132841759577978e-04*G0_35 + 6.189423145441988e-04*G0_36 + 5.771218878858055e-04*G0_37 - 2.132841759577961e-04*G0_38 + 6.942190825293044e-04*G0_39 + 6.942190825293047e-04*G0_40 - 1.254612799751757e-03*G0_41 + 2.275031210216518e-03*G0_42 + 6.273063998758600e-05*G0_43 - 9.033212158212658e-04*G0_44 + 5.185732905640609e-04*G0_45 + 1.037146581128120e-03*G0_46 - 1.806642431642535e-03*G0_47 + 4.550062420433029e-03*G0_48 + 5.143912478982175e-04*G0_49 - 1.806642431642528e-03*G0_50 + 1.037146581128119e-03*G0_51 + 7.778599358460874e-04*G0_52 + 1.405166335721969e-03*G0_53 + 7.778599358460874e-04*G0_54 - 3.512915839304925e-04*G0_55;
    block[49] = -1.214967035279601e-04*G0_0 + 3.984650252011514e-05*G0_1 - 1.214967035279602e-04*G0_2 - 1.771513273249504e-05*G0_3 - 9.284134718162853e-05*G0_4 - 7.025831678609978e-05*G0_5 - 1.204428287761675e-04*G0_6 - 5.520296318907753e-05*G0_7 + 3.086347487389318e-04*G0_8 - 4.516606079106389e-05*G0_9 - 4.516606079106329e-05*G0_10 + 3.086347487389305e-04*G0_11 - 5.520296318907787e-05*G0_12 - 1.204428287761674e-04*G0_13 - 7.025831678609963e-05*G0_14 - 9.284134718162854e-05*G0_15 - 2.760148159453874e-05*G0_16 + 2.534317855498551e-04*G0_17 - 1.480443103707081e-04*G0_18 - 8.782289598261792e-06*G0_19 + 2.885609439429070e-05*G0_20 - 2.258303039553166e-05*G0_21 - 1.229520543756723e-04*G0_22 + 1.354981823731892e-04*G0_23 - 2.760148159453871e-05*G0_24 + 2.534317855498548e-04*G0_25 - 1.480443103707073e-04*G0_26 - 8.782289598262017e-06*G0_27 + 6.273063998758730e-05*G0_28 + 4.140222239180782e-04*G0_29 - 2.132841759577985e-04*G0_30 - 6.398525278733920e-04*G0_31 + 2.258303039553176e-04*G0_32 - 1.254612799751756e-03*G0_33 - 9.033212158212646e-04*G0_34 - 6.398525278733947e-04*G0_35 + 5.771218878858059e-04*G0_36 + 2.634686879478685e-03*G0_37 - 6.398525278733945e-04*G0_38 - 9.033212158212646e-04*G0_39 - 2.132841759577982e-04*G0_40 + 4.140222239180793e-04*G0_41 + 6.273063998758760e-05*G0_42 + 2.258303039553162e-04*G0_43 - 6.398525278733943e-04*G0_44 - 1.254612799751756e-03*G0_45 - 1.806642431642528e-03*G0_46 - 9.409595998138135e-04*G0_47 + 5.143912478982173e-04*G0_48 + 5.269373758957366e-03*G0_49 - 9.409595998138131e-04*G0_50 - 1.806642431642528e-03*G0_51 + 6.774909118659406e-04*G0_52 - 1.204428287761682e-03*G0_53 + 6.774909118659487e-04*G0_54 - 6.398525278733973e-04*G0_55;
    block[50] = 3.984650252011575e-05*G0_0 - 1.214967035279595e-04*G0_1 - 1.214967035279599e-04*G0_2 - 1.771513273249494e-05*G0_3 + 3.086347487389311e-04*G0_4 - 4.516606079106278e-05*G0_5 - 4.516606079106293e-05*G0_6 + 3.086347487389315e-04*G0_7 - 5.520296318907816e-05*G0_8 - 1.204428287761671e-04*G0_9 - 7.025831678609932e-05*G0_10 - 9.284134718162897e-05*G0_11 - 9.284134718162849e-05*G0_12 - 7.025831678609977e-05*G0_13 - 1.204428287761668e-04*G0_14 - 5.520296318907805e-05*G0_15 + 2.885609439429045e-05*G0_16 - 2.258303039553141e-05*G0_17 - 1.229520543756721e-04*G0_18 + 1.354981823731895e-04*G0_19 - 2.760148159453881e-05*G0_20 + 2.534317855498547e-04*G0_21 - 1.480443103707071e-04*G0_22 - 8.782289598261668e-06*G0_23 - 2.760148159453900e-05*G0_24 + 2.534317855498545e-04*G0_25 - 1.480443103707079e-04*G0_26 - 8.782289598261921e-06*G0_27 - 9.033212158212644e-04*G0_28 - 6.398525278733945e-04*G0_29 + 5.771218878858059e-04*G0_30 + 2.634686879478685e-03*G0_31 - 6.398525278733934e-04*G0_32 - 9.033212158212649e-04*G0_33 - 1.254612799751756e-03*G0_34 + 2.258303039553178e-04*G0_35 - 2.132841759577994e-04*G0_36 - 6.398525278733936e-04*G0_37 + 4.140222239180791e-04*G0_38 + 6.273063998758673e-05*G0_39 - 2.132841759577990e-04*G0_40 + 2.258303039553160e-04*G0_41 - 1.254612799751756e-03*G0_42 + 4.140222239180796e-04*G0_43 - 6.398525278733927e-04*G0_44 + 6.273063998758626e-05*G0_45 + 5.143912478982176e-04*G0_46 - 9.409595998138123e-04*G0_47 - 1.806642431642528e-03*G0_48 - 9.409595998138131e-04*G0_49 + 5.269373758957367e-03*G0_50 - 1.806642431642528e-03*G0_51 - 1.204428287761685e-03*G0_52 + 6.774909118659475e-04*G0_53 + 6.774909118659420e-04*G0_54 - 6.398525278733928e-04*G0_55;
    block[51] = 9.595278692501431e-05*G0_0 + 9.595278692501443e-05*G0_1 + 1.496502147543889e-04*G0_2 + 1.734376734376828e-04*G0_3 - 3.412546815324777e-04*G0_4 + 4.918082175026890e-04*G0_5 - 1.104059263781559e-04*G0_6 + 1.104059263781544e-04*G0_7 + 1.104059263781550e-04*G0_8 - 1.104059263781554e-04*G0_9 + 4.918082175026880e-04*G0_10 - 3.412546815324776e-04*G0_11 - 4.014760959205681e-05*G0_12 + 1.279705055746797e-04*G0_13 + 1.279705055746789e-04*G0_14 - 4.014760959205728e-05*G0_15 - 2.007380479602837e-05*G0_16 - 1.095695178449866e-04*G0_17 + 1.706273407662385e-04*G0_18 - 2.668143220805397e-04*G0_19 - 2.007380479602830e-05*G0_20 - 1.095695178449866e-04*G0_21 + 1.706273407662394e-04*G0_22 - 2.668143220805400e-04*G0_23 + 5.520296318907811e-05*G0_24 - 6.239607657432071e-04*G0_25 + 8.732105086272215e-04*G0_26 - 5.553752660234435e-04*G0_27 + 5.185732905640603e-04*G0_28 + 6.273063998758706e-05*G0_29 + 6.942190825293036e-04*G0_30 - 9.033212158212651e-04*G0_31 - 1.254612799751755e-03*G0_32 + 2.275031210216517e-03*G0_33 + 2.275031210216515e-03*G0_34 - 1.254612799751754e-03*G0_35 + 6.942190825293057e-04*G0_36 - 9.033212158212642e-04*G0_37 + 6.273063998758920e-05*G0_38 + 5.185732905640592e-04*G0_39 + 6.189423145441980e-04*G0_40 - 2.132841759577988e-04*G0_41 + 6.942190825293049e-04*G0_42 - 2.132841759577990e-04*G0_43 + 5.771218878858056e-04*G0_44 + 6.942190825293057e-04*G0_45 + 1.037146581128116e-03*G0_46 + 5.143912478982153e-04*G0_47 + 1.037146581128119e-03*G0_48 - 1.806642431642528e-03*G0_49 - 1.806642431642528e-03*G0_50 + 4.550062420433034e-03*G0_51 + 7.778599358460904e-04*G0_52 + 7.778599358460873e-04*G0_53 + 1.405166335721967e-03*G0_54 - 3.512915839304920e-04*G0_55;
    block[52] = -2.800295769045909e-04*G0_0 + 2.042509637995856e-04*G0_1 + 2.042509637995853e-04*G0_2 + 2.042509637995860e-04*G0_3 - 3.011070719404215e-04*G0_4 + 6.273063998758896e-05*G0_5 + 6.273063998758509e-05*G0_6 - 3.011070719404204e-04*G0_7 - 7.778599358460881e-04*G0_8 + 1.104059263781546e-03*G0_9 - 9.033212158212628e-04*G0_10 + 7.276754238560164e-04*G0_11 + 7.276754238560163e-04*G0_12 - 9.033212158212639e-04*G0_13 + 1.104059263781546e-03*G0_14 - 7.778599358460870e-04*G0_15 + 7.276754238560147e-04*G0_16 - 9.033212158212633e-04*G0_17 + 1.104059263781544e-03*G0_18 - 7.778599358460880e-04*G0_19 - 3.011070719404219e-04*G0_20 + 6.273063998758870e-05*G0_21 + 6.273063998758717e-05*G0_22 - 3.011070719404204e-04*G0_23 - 3.011070719404205e-04*G0_24 + 6.273063998758732e-05*G0_25 + 6.273063998758805e-05*G0_26 - 3.011070719404220e-04*G0_27 - 3.512915839304904e-04*G0_28 - 6.398525278733956e-04*G0_29 - 3.512915839304864e-04*G0_30 - 6.398525278733950e-04*G0_31 - 6.398525278733920e-04*G0_32 - 3.512915839304908e-04*G0_33 + 7.778599358460893e-04*G0_34 - 1.204428287761680e-03*G0_35 + 7.778599358460896e-04*G0_36 + 6.774909118659428e-04*G0_37 + 6.774909118659384e-04*G0_38 + 1.405166335721971e-03*G0_39 + 7.778599358460873e-04*G0_40 - 1.204428287761683e-03*G0_41 + 7.778599358460889e-04*G0_42 + 6.774909118659419e-04*G0_43 + 6.774909118659462e-04*G0_44 + 1.405166335721969e-03*G0_45 + 1.405166335721964e-03*G0_46 + 6.774909118659451e-04*G0_47 + 7.778599358460874e-04*G0_48 + 6.774909118659405e-04*G0_49 - 1.204428287761685e-03*G0_50 + 7.778599358460905e-04*G0_51 + 1.656088895672315e-02*G0_52 - 2.258303039553154e-03*G0_53 - 2.258303039553146e-03*G0_54 - 2.258303039553144e-03*G0_55;
    block[53] = 2.042509637995860e-04*G0_0 - 2.800295769045922e-04*G0_1 + 2.042509637995858e-04*G0_2 + 2.042509637995855e-04*G0_3 + 7.276754238560182e-04*G0_4 - 9.033212158212647e-04*G0_5 + 1.104059263781547e-03*G0_6 - 7.778599358460878e-04*G0_7 - 3.011070719404203e-04*G0_8 + 6.273063998758660e-05*G0_9 + 6.273063998758839e-05*G0_10 - 3.011070719404218e-04*G0_11 - 7.778599358460888e-04*G0_12 + 1.104059263781548e-03*G0_13 - 9.033212158212642e-04*G0_14 + 7.276754238560180e-04*G0_15 - 3.011070719404218e-04*G0_16 + 6.273063998758896e-05*G0_17 + 6.273063998758755e-05*G0_18 - 3.011070719404212e-04*G0_19 + 7.276754238560185e-04*G0_20 - 9.033212158212642e-04*G0_21 + 1.104059263781545e-03*G0_22 - 7.778599358460868e-04*G0_23 - 3.011070719404213e-04*G0_24 + 6.273063998758726e-05*G0_25 + 6.273063998758791e-05*G0_26 - 3.011070719404224e-04*G0_27 + 1.405166335721972e-03*G0_28 + 6.774909118659402e-04*G0_29 + 7.778599358460920e-04*G0_30 + 6.774909118659468e-04*G0_31 - 1.204428287761684e-03*G0_32 + 7.778599358460880e-04*G0_33 - 3.512915839304921e-04*G0_34 - 6.398525278733921e-04*G0_35 - 3.512915839304867e-04*G0_36 - 6.398525278733960e-04*G0_37 - 6.398525278733887e-04*G0_38 - 3.512915839304923e-04*G0_39 + 7.778599358460890e-04*G0_40 + 6.774909118659408e-04*G0_41 + 1.405166335721968e-03*G0_42 - 1.204428287761684e-03*G0_43 + 6.774909118659471e-04*G0_44 + 7.778599358460863e-04*G0_45 + 7.778599358460865e-04*G0_46 + 6.774909118659428e-04*G0_47 + 1.405166335721969e-03*G0_48 - 1.204428287761682e-03*G0_49 + 6.774909118659478e-04*G0_50 + 7.778599358460873e-04*G0_51 - 2.258303039553154e-03*G0_52 + 1.656088895672314e-02*G0_53 - 2.258303039553171e-03*G0_54 - 2.258303039553150e-03*G0_55;
    block[54] = 2.042509637995856e-04*G0_0 + 2.042509637995867e-04*G0_1 - 2.800295769045914e-04*G0_2 + 2.042509637995857e-04*G0_3 - 7.778599358460899e-04*G0_4 + 1.104059263781545e-03*G0_5 - 9.033212158212667e-04*G0_6 + 7.276754238560166e-04*G0_7 + 7.276754238560167e-04*G0_8 - 9.033212158212638e-04*G0_9 + 1.104059263781543e-03*G0_10 - 7.778599358460859e-04*G0_11 - 3.011070719404193e-04*G0_12 + 6.273063998758621e-05*G0_13 + 6.273063998759152e-05*G0_14 - 3.011070719404258e-04*G0_15 - 3.011070719404196e-04*G0_16 + 6.273063998758848e-05*G0_17 + 6.273063998758772e-05*G0_18 - 3.011070719404205e-04*G0_19 - 3.011070719404223e-04*G0_20 + 6.273063998758875e-05*G0_21 + 6.273063998758924e-05*G0_22 - 3.011070719404205e-04*G0_23 + 7.276754238560167e-04*G0_24 - 9.033212158212629e-04*G0_25 + 1.104059263781544e-03*G0_26 - 7.778599358460866e-04*G0_27 + 7.778599358460855e-04*G0_28 - 1.204428287761682e-03*G0_29 + 7.778599358460785e-04*G0_30 + 6.774909118659444e-04*G0_31 + 6.774909118659434e-04*G0_32 + 1.405166335721969e-03*G0_33 + 1.405166335721969e-03*G0_34 + 6.774909118659423e-04*G0_35 + 7.778599358460878e-04*G0_36 + 6.774909118659498e-04*G0_37 - 1.204428287761674e-03*G0_38 + 7.778599358460865e-04*G0_39 - 3.512915839304903e-04*G0_40 - 6.398525278733925e-04*G0_41 - 3.512915839304924e-04*G0_42 - 6.398525278733932e-04*G0_43 - 6.398525278733956e-04*G0_44 - 3.512915839304920e-04*G0_45 + 7.778599358460874e-04*G0_46 - 1.204428287761687e-03*G0_47 + 7.778599358460873e-04*G0_48 + 6.774909118659497e-04*G0_49 + 6.774909118659423e-04*G0_50 + 1.405166335721967e-03*G0_51 - 2.258303039553146e-03*G0_52 - 2.258303039553170e-03*G0_53 + 1.656088895672315e-02*G0_54 - 2.258303039553167e-03*G0_55;
    block[55] = 2.042509637995844e-04*G0_0 + 2.042509637995854e-04*G0_1 + 2.042509637995859e-04*G0_2 - 2.800295769045924e-04*G0_3 - 3.011070719404191e-04*G0_4 + 6.273063998758691e-05*G0_5 + 6.273063998758734e-05*G0_6 - 3.011070719404231e-04*G0_7 - 3.011070719404225e-04*G0_8 + 6.273063998758889e-05*G0_9 + 6.273063998758644e-05*G0_10 - 3.011070719404193e-04*G0_11 - 3.011070719404199e-04*G0_12 + 6.273063998758791e-05*G0_13 + 6.273063998758875e-05*G0_14 - 3.011070719404211e-04*G0_15 - 7.778599358460840e-04*G0_16 + 1.104059263781540e-03*G0_17 - 9.033212158212609e-04*G0_18 + 7.276754238560176e-04*G0_19 - 7.778599358460863e-04*G0_20 + 1.104059263781542e-03*G0_21 - 9.033212158212605e-04*G0_22 + 7.276754238560171e-04*G0_23 - 7.778599358460869e-04*G0_24 + 1.104059263781543e-03*G0_25 - 9.033212158212628e-04*G0_26 + 7.276754238560183e-04*G0_27 + 7.778599358460837e-04*G0_28 + 6.774909118659513e-04*G0_29 + 1.405166335721957e-03*G0_30 - 1.204428287761679e-03*G0_31 + 6.774909118659430e-04*G0_32 + 7.778599358460878e-04*G0_33 + 7.778599358460889e-04*G0_34 + 6.774909118659405e-04*G0_35 + 1.405166335721958e-03*G0_36 - 1.204428287761684e-03*G0_37 + 6.774909118659551e-04*G0_38 + 7.778599358460842e-04*G0_39 + 1.405166335721963e-03*G0_40 + 6.774909118659471e-04*G0_41 + 7.778599358460880e-04*G0_42 + 6.774909118659518e-04*G0_43 - 1.204428287761685e-03*G0_44 + 7.778599358460861e-04*G0_45 - 3.512915839304922e-04*G0_46 - 6.398525278733967e-04*G0_47 - 3.512915839304925e-04*G0_48 - 6.398525278733974e-04*G0_49 - 6.398525278733929e-04*G0_50 - 3.512915839304920e-04*G0_51 - 2.258303039553144e-03*G0_52 - 2.258303039553149e-03*G0_53 - 2.258303039553166e-03*G0_54 + 1.656088895672311e-02*G0_55;
  }

};

} }

#endif
