// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.5.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __STOKES3D_H
#define __STOKES3D_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Stokes3D {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 4;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 34;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.edgeID(0);
      dofs[5] = offset + cell.edgeID(1);
      dofs[6] = offset + cell.edgeID(2);
      dofs[7] = offset + cell.edgeID(3);
      dofs[8] = offset + cell.edgeID(4);
      dofs[9] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[10] = offset + cell.vertexID(0);
      dofs[11] = offset + cell.vertexID(1);
      dofs[12] = offset + cell.vertexID(2);
      dofs[13] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[14] = offset + cell.edgeID(0);
      dofs[15] = offset + cell.edgeID(1);
      dofs[16] = offset + cell.edgeID(2);
      dofs[17] = offset + cell.edgeID(3);
      dofs[18] = offset + cell.edgeID(4);
      dofs[19] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[20] = offset + cell.vertexID(0);
      dofs[21] = offset + cell.vertexID(1);
      dofs[22] = offset + cell.vertexID(2);
      dofs[23] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[24] = offset + cell.edgeID(0);
      dofs[25] = offset + cell.edgeID(1);
      dofs[26] = offset + cell.edgeID(2);
      dofs[27] = offset + cell.edgeID(3);
      dofs[28] = offset + cell.edgeID(4);
      dofs[29] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[30] = offset + cell.vertexID(0);
      dofs[31] = offset + cell.vertexID(1);
      dofs[32] = offset + cell.vertexID(2);
      dofs[33] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 1;
      components[11] = 1;
      components[12] = 1;
      components[13] = 1;
      components[14] = 1;
      components[15] = 1;
      components[16] = 1;
      components[17] = 1;
      components[18] = 1;
      components[19] = 1;
      components[20] = 2;
      components[21] = 2;
      components[22] = 2;
      components[23] = 2;
      components[24] = 2;
      components[25] = 2;
      components[26] = 2;
      components[27] = 2;
      components[28] = 2;
      components[29] = 2;
      points[30] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[31] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[32] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[33] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[30] = 3;
      components[31] = 3;
      components[32] = 3;
      components[33] = 3;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices() + mesh.noEdges();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[2] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[3] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        tensordims = new unsigned int [1];
        tensordims[0] = 3;
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 30;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_assert(i < 1);
        return tensordims[i];
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 1;
      }
    
      void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
      {
        dofs[0] = cell.vertexID(0);
        dofs[1] = cell.vertexID(1);
        dofs[2] = cell.vertexID(2);
        dofs[3] = cell.vertexID(3);
        int offset = mesh.noVertices();
        dofs[4] = offset + cell.edgeID(0);
        dofs[5] = offset + cell.edgeID(1);
        dofs[6] = offset + cell.edgeID(2);
        dofs[7] = offset + cell.edgeID(3);
        dofs[8] = offset + cell.edgeID(4);
        dofs[9] = offset + cell.edgeID(5);
        offset = offset + mesh.noEdges();
        dofs[10] = offset + cell.vertexID(0);
        dofs[11] = offset + cell.vertexID(1);
        dofs[12] = offset + cell.vertexID(2);
        dofs[13] = offset + cell.vertexID(3);
        offset = offset + mesh.noVertices();
        dofs[14] = offset + cell.edgeID(0);
        dofs[15] = offset + cell.edgeID(1);
        dofs[16] = offset + cell.edgeID(2);
        dofs[17] = offset + cell.edgeID(3);
        dofs[18] = offset + cell.edgeID(4);
        dofs[19] = offset + cell.edgeID(5);
        offset = offset + mesh.noEdges();
        dofs[20] = offset + cell.vertexID(0);
        dofs[21] = offset + cell.vertexID(1);
        dofs[22] = offset + cell.vertexID(2);
        dofs[23] = offset + cell.vertexID(3);
        offset = offset + mesh.noVertices();
        dofs[24] = offset + cell.edgeID(0);
        dofs[25] = offset + cell.edgeID(1);
        dofs[26] = offset + cell.edgeID(2);
        dofs[27] = offset + cell.edgeID(3);
        dofs[28] = offset + cell.edgeID(4);
        dofs[29] = offset + cell.edgeID(5);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
        components[4] = 0;
        components[5] = 0;
        components[6] = 0;
        components[7] = 0;
        components[8] = 0;
        components[9] = 0;
        components[10] = 1;
        components[11] = 1;
        components[12] = 1;
        components[13] = 1;
        components[14] = 1;
        components[15] = 1;
        components[16] = 1;
        components[17] = 1;
        components[18] = 1;
        components[19] = 1;
        components[20] = 2;
        components[21] = 2;
        components[22] = 2;
        components[23] = 2;
        components[24] = 2;
        components[25] = 2;
        components[26] = 2;
        components[27] = 2;
        components[28] = 2;
        components[29] = 2;
      }
    
      void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        values[0] = x[vertex];
        int offset = mesh.noVertices() + mesh.noEdges();
        values[1] = x[offset + vertex];
        offset = offset + mesh.noVertices() + mesh.noEdges();
        values[2] = x[offset + vertex];
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
      {
        dofs[0] = cell.vertexID(0);
        dofs[1] = cell.vertexID(1);
        dofs[2] = cell.vertexID(2);
        dofs[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        values[0] = x[vertex];
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 4;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 34;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.edgeID(0);
      dofs[5] = offset + cell.edgeID(1);
      dofs[6] = offset + cell.edgeID(2);
      dofs[7] = offset + cell.edgeID(3);
      dofs[8] = offset + cell.edgeID(4);
      dofs[9] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[10] = offset + cell.vertexID(0);
      dofs[11] = offset + cell.vertexID(1);
      dofs[12] = offset + cell.vertexID(2);
      dofs[13] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[14] = offset + cell.edgeID(0);
      dofs[15] = offset + cell.edgeID(1);
      dofs[16] = offset + cell.edgeID(2);
      dofs[17] = offset + cell.edgeID(3);
      dofs[18] = offset + cell.edgeID(4);
      dofs[19] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[20] = offset + cell.vertexID(0);
      dofs[21] = offset + cell.vertexID(1);
      dofs[22] = offset + cell.vertexID(2);
      dofs[23] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[24] = offset + cell.edgeID(0);
      dofs[25] = offset + cell.edgeID(1);
      dofs[26] = offset + cell.edgeID(2);
      dofs[27] = offset + cell.edgeID(3);
      dofs[28] = offset + cell.edgeID(4);
      dofs[29] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[30] = offset + cell.vertexID(0);
      dofs[31] = offset + cell.vertexID(1);
      dofs[32] = offset + cell.vertexID(2);
      dofs[33] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 1;
      components[11] = 1;
      components[12] = 1;
      components[13] = 1;
      components[14] = 1;
      components[15] = 1;
      components[16] = 1;
      components[17] = 1;
      components[18] = 1;
      components[19] = 1;
      components[20] = 2;
      components[21] = 2;
      components[22] = 2;
      components[23] = 2;
      components[24] = 2;
      components[25] = 2;
      components[26] = 2;
      components[27] = 2;
      components[28] = 2;
      components[29] = 2;
      points[30] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[31] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[32] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[33] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[30] = 3;
      components[31] = 3;
      components[32] = 3;
      components[33] = 3;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices() + mesh.noEdges();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[2] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[3] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        tensordims = new unsigned int [1];
        tensordims[0] = 3;
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 30;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_assert(i < 1);
        return tensordims[i];
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 1;
      }
    
      void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
      {
        dofs[0] = cell.vertexID(0);
        dofs[1] = cell.vertexID(1);
        dofs[2] = cell.vertexID(2);
        dofs[3] = cell.vertexID(3);
        int offset = mesh.noVertices();
        dofs[4] = offset + cell.edgeID(0);
        dofs[5] = offset + cell.edgeID(1);
        dofs[6] = offset + cell.edgeID(2);
        dofs[7] = offset + cell.edgeID(3);
        dofs[8] = offset + cell.edgeID(4);
        dofs[9] = offset + cell.edgeID(5);
        offset = offset + mesh.noEdges();
        dofs[10] = offset + cell.vertexID(0);
        dofs[11] = offset + cell.vertexID(1);
        dofs[12] = offset + cell.vertexID(2);
        dofs[13] = offset + cell.vertexID(3);
        offset = offset + mesh.noVertices();
        dofs[14] = offset + cell.edgeID(0);
        dofs[15] = offset + cell.edgeID(1);
        dofs[16] = offset + cell.edgeID(2);
        dofs[17] = offset + cell.edgeID(3);
        dofs[18] = offset + cell.edgeID(4);
        dofs[19] = offset + cell.edgeID(5);
        offset = offset + mesh.noEdges();
        dofs[20] = offset + cell.vertexID(0);
        dofs[21] = offset + cell.vertexID(1);
        dofs[22] = offset + cell.vertexID(2);
        dofs[23] = offset + cell.vertexID(3);
        offset = offset + mesh.noVertices();
        dofs[24] = offset + cell.edgeID(0);
        dofs[25] = offset + cell.edgeID(1);
        dofs[26] = offset + cell.edgeID(2);
        dofs[27] = offset + cell.edgeID(3);
        dofs[28] = offset + cell.edgeID(4);
        dofs[29] = offset + cell.edgeID(5);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
        components[4] = 0;
        components[5] = 0;
        components[6] = 0;
        components[7] = 0;
        components[8] = 0;
        components[9] = 0;
        components[10] = 1;
        components[11] = 1;
        components[12] = 1;
        components[13] = 1;
        components[14] = 1;
        components[15] = 1;
        components[16] = 1;
        components[17] = 1;
        components[18] = 1;
        components[19] = 1;
        components[20] = 2;
        components[21] = 2;
        components[22] = 2;
        components[23] = 2;
        components[24] = 2;
        components[25] = 2;
        components[26] = 2;
        components[27] = 2;
        components[28] = 2;
        components[29] = 2;
      }
    
      void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        values[0] = x[vertex];
        int offset = mesh.noVertices() + mesh.noEdges();
        values[1] = x[offset + vertex];
        offset = offset + mesh.noVertices() + mesh.noEdges();
        values[2] = x[offset + vertex];
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
      {
        dofs[0] = cell.vertexID(0);
        dofs[1] = cell.vertexID(1);
        dofs[2] = cell.vertexID(2);
        dofs[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        values[0] = x[vertex];
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_0_0 = map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02;
    const real G0_0_1 = map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12;
    const real G0_0_2 = map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22;
    const real G0_1_0 = map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02;
    const real G0_1_1 = map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12;
    const real G0_1_2 = map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22;
    const real G0_2_0 = map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02;
    const real G0_2_1 = map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12;
    const real G0_2_2 = map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22;
    const real G1_0_0 = map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02;
    const real G1_0_1 = map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12;
    const real G1_0_2 = map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22;
    const real G1_1_0 = map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02;
    const real G1_1_1 = map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12;
    const real G1_1_2 = map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22;
    const real G1_2_0 = map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02;
    const real G1_2_1 = map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12;
    const real G1_2_2 = map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22;
    const real G2_0_0 = map.det*map.g00*map.g00 + map.det*map.g01*map.g01 + map.det*map.g02*map.g02;
    const real G2_0_1 = map.det*map.g00*map.g10 + map.det*map.g01*map.g11 + map.det*map.g02*map.g12;
    const real G2_0_2 = map.det*map.g00*map.g20 + map.det*map.g01*map.g21 + map.det*map.g02*map.g22;
    const real G2_1_0 = map.det*map.g10*map.g00 + map.det*map.g11*map.g01 + map.det*map.g12*map.g02;
    const real G2_1_1 = map.det*map.g10*map.g10 + map.det*map.g11*map.g11 + map.det*map.g12*map.g12;
    const real G2_1_2 = map.det*map.g10*map.g20 + map.det*map.g11*map.g21 + map.det*map.g12*map.g22;
    const real G2_2_0 = map.det*map.g20*map.g00 + map.det*map.g21*map.g01 + map.det*map.g22*map.g02;
    const real G2_2_1 = map.det*map.g20*map.g10 + map.det*map.g21*map.g11 + map.det*map.g22*map.g12;
    const real G2_2_2 = map.det*map.g20*map.g20 + map.det*map.g21*map.g21 + map.det*map.g22*map.g22;
    const real G3_0 = map.det*map.g00;
    const real G3_1 = map.det*map.g10;
    const real G3_2 = map.det*map.g20;
    const real G4_0 = map.det*map.g01;
    const real G4_1 = map.det*map.g11;
    const real G4_2 = map.det*map.g21;
    const real G5_0 = map.det*map.g02;
    const real G5_1 = map.det*map.g12;
    const real G5_2 = map.det*map.g22;
    const real G6_0 = map.det*map.g00;
    const real G6_1 = map.det*map.g10;
    const real G6_2 = map.det*map.g20;
    const real G7_0 = map.det*map.g01;
    const real G7_1 = map.det*map.g11;
    const real G7_2 = map.det*map.g21;
    const real G8_0 = map.det*map.g02;
    const real G8_1 = map.det*map.g12;
    const real G8_2 = map.det*map.g22;

    // Compute element tensor
    block[0] = 9.999999999999978e-02*G0_0_0 + 9.999999999999977e-02*G0_0_1 + 9.999999999999977e-02*G0_0_2 + 9.999999999999977e-02*G0_1_0 + 9.999999999999976e-02*G0_1_1 + 9.999999999999976e-02*G0_1_2 + 9.999999999999977e-02*G0_2_0 + 9.999999999999976e-02*G0_2_1 + 9.999999999999976e-02*G0_2_2;
    block[1] = 3.333333333333328e-02*G0_0_0 + 3.333333333333328e-02*G0_0_1 + 3.333333333333327e-02*G0_0_2;
    block[2] = 3.333333333333326e-02*G0_1_0 + 3.333333333333325e-02*G0_1_1 + 3.333333333333324e-02*G0_1_2;
    block[3] = 3.333333333333321e-02*G0_2_0 + 3.333333333333322e-02*G0_2_1 + 3.333333333333322e-02*G0_2_2;
    block[4] = 3.333333333333330e-02*G0_0_0 + 3.333333333333327e-02*G0_0_1 + 3.333333333333326e-02*G0_0_2 + 3.333333333333331e-02*G0_1_0 + 3.333333333333328e-02*G0_1_1 + 3.333333333333327e-02*G0_1_2;
    block[5] = -3.333333333333331e-02*G0_0_0 - 3.333333333333329e-02*G0_0_1 - 3.333333333333326e-02*G0_0_2 - 1.333333333333330e-01*G0_1_0 - 1.333333333333330e-01*G0_1_1 - 1.333333333333330e-01*G0_1_2 - 3.333333333333331e-02*G0_2_0 - 3.333333333333328e-02*G0_2_1 - 3.333333333333326e-02*G0_2_2;
    block[6] = -1.333333333333331e-01*G0_0_0 - 1.333333333333330e-01*G0_0_1 - 1.333333333333330e-01*G0_0_2 - 3.333333333333333e-02*G0_1_0 - 3.333333333333330e-02*G0_1_1 - 3.333333333333328e-02*G0_1_2 - 3.333333333333335e-02*G0_2_0 - 3.333333333333331e-02*G0_2_1 - 3.333333333333329e-02*G0_2_2;
    block[7] = -3.333333333333327e-02*G0_0_0 - 3.333333333333326e-02*G0_0_1 - 3.333333333333324e-02*G0_0_2 - 3.333333333333328e-02*G0_1_0 - 3.333333333333325e-02*G0_1_1 - 3.333333333333324e-02*G0_1_2 - 1.333333333333330e-01*G0_2_0 - 1.333333333333330e-01*G0_2_1 - 1.333333333333330e-01*G0_2_2;
    block[8] = 3.333333333333327e-02*G0_0_0 + 3.333333333333326e-02*G0_0_1 + 3.333333333333324e-02*G0_0_2 + 3.333333333333335e-02*G0_2_0 + 3.333333333333331e-02*G0_2_1 + 3.333333333333330e-02*G0_2_2;
    block[9] = 3.333333333333328e-02*G0_1_0 + 3.333333333333326e-02*G0_1_1 + 3.333333333333325e-02*G0_1_2 + 3.333333333333331e-02*G0_2_0 + 3.333333333333328e-02*G0_2_1 + 3.333333333333326e-02*G0_2_2;
    block[10] = 0.000000000000000e+00;
    block[11] = 0.000000000000000e+00;
    block[12] = 0.000000000000000e+00;
    block[13] = 0.000000000000000e+00;
    block[14] = 0.000000000000000e+00;
    block[15] = 0.000000000000000e+00;
    block[16] = 0.000000000000000e+00;
    block[17] = 0.000000000000000e+00;
    block[18] = 0.000000000000000e+00;
    block[19] = 0.000000000000000e+00;
    block[20] = 0.000000000000000e+00;
    block[21] = 0.000000000000000e+00;
    block[22] = 0.000000000000000e+00;
    block[23] = 0.000000000000000e+00;
    block[24] = 0.000000000000000e+00;
    block[25] = 0.000000000000000e+00;
    block[26] = 0.000000000000000e+00;
    block[27] = 0.000000000000000e+00;
    block[28] = 0.000000000000000e+00;
    block[29] = 0.000000000000000e+00;
    block[30] = 2.499999999999993e-02*G3_0 + 2.499999999999993e-02*G3_1 + 2.499999999999993e-02*G3_2;
    block[31] = -8.333333333333331e-03*G3_0 - 8.333333333333323e-03*G3_1 - 8.333333333333318e-03*G3_2;
    block[32] = -8.333333333333326e-03*G3_0 - 8.333333333333321e-03*G3_1 - 8.333333333333316e-03*G3_2;
    block[33] = -8.333333333333318e-03*G3_0 - 8.333333333333314e-03*G3_1 - 8.333333333333311e-03*G3_2;
    block[34] = 3.333333333333328e-02*G0_0_0 + 3.333333333333328e-02*G0_1_0 + 3.333333333333327e-02*G0_2_0;
    block[35] = 9.999999999999977e-02*G0_0_0;
    block[36] = -3.333333333333323e-02*G0_1_0;
    block[37] = -3.333333333333324e-02*G0_2_0;
    block[38] = -3.333333333333325e-02*G0_0_0 + 9.999999999999970e-02*G0_1_0;
    block[39] = 3.333333333333326e-02*G0_0_0 + 3.333333333333326e-02*G0_2_0;
    block[40] = -1.333333333333331e-01*G0_0_0 - 9.999999999999969e-02*G0_1_0 - 9.999999999999971e-02*G0_2_0;
    block[41] = 3.333333333333329e-02*G0_0_0 + 3.333333333333328e-02*G0_1_0;
    block[42] = -3.333333333333329e-02*G0_0_0 + 9.999999999999971e-02*G0_2_0;
    block[43] = -3.333333333333330e-02*G0_1_0 - 3.333333333333328e-02*G0_2_0;
    block[44] = 0.000000000000000e+00;
    block[45] = 0.000000000000000e+00;
    block[46] = 0.000000000000000e+00;
    block[47] = 0.000000000000000e+00;
    block[48] = 0.000000000000000e+00;
    block[49] = 0.000000000000000e+00;
    block[50] = 0.000000000000000e+00;
    block[51] = 0.000000000000000e+00;
    block[52] = 0.000000000000000e+00;
    block[53] = 0.000000000000000e+00;
    block[54] = 0.000000000000000e+00;
    block[55] = 0.000000000000000e+00;
    block[56] = 0.000000000000000e+00;
    block[57] = 0.000000000000000e+00;
    block[58] = 0.000000000000000e+00;
    block[59] = 0.000000000000000e+00;
    block[60] = 0.000000000000000e+00;
    block[61] = 0.000000000000000e+00;
    block[62] = 0.000000000000000e+00;
    block[63] = 0.000000000000000e+00;
    block[64] = 8.333333333333319e-03*G3_0;
    block[65] = -2.499999999999992e-02*G3_0;
    block[66] = 8.333333333333316e-03*G3_0;
    block[67] = 8.333333333333319e-03*G3_0;
    block[68] = 3.333333333333326e-02*G0_0_1 + 3.333333333333325e-02*G0_1_1 + 3.333333333333324e-02*G0_2_1;
    block[69] = -3.333333333333323e-02*G0_0_1;
    block[70] = 9.999999999999973e-02*G0_1_1;
    block[71] = -3.333333333333326e-02*G0_2_1;
    block[72] = 9.999999999999970e-02*G0_0_1 - 3.333333333333322e-02*G0_1_1;
    block[73] = -9.999999999999973e-02*G0_0_1 - 1.333333333333329e-01*G0_1_1 - 9.999999999999973e-02*G0_2_1;
    block[74] = 3.333333333333322e-02*G0_1_1 + 3.333333333333322e-02*G0_2_1;
    block[75] = 3.333333333333324e-02*G0_0_1 + 3.333333333333322e-02*G0_1_1;
    block[76] = -3.333333333333324e-02*G0_0_1 - 3.333333333333321e-02*G0_2_1;
    block[77] = -3.333333333333324e-02*G0_1_1 + 9.999999999999973e-02*G0_2_1;
    block[78] = 0.000000000000000e+00;
    block[79] = 0.000000000000000e+00;
    block[80] = 0.000000000000000e+00;
    block[81] = 0.000000000000000e+00;
    block[82] = 0.000000000000000e+00;
    block[83] = 0.000000000000000e+00;
    block[84] = 0.000000000000000e+00;
    block[85] = 0.000000000000000e+00;
    block[86] = 0.000000000000000e+00;
    block[87] = 0.000000000000000e+00;
    block[88] = 0.000000000000000e+00;
    block[89] = 0.000000000000000e+00;
    block[90] = 0.000000000000000e+00;
    block[91] = 0.000000000000000e+00;
    block[92] = 0.000000000000000e+00;
    block[93] = 0.000000000000000e+00;
    block[94] = 0.000000000000000e+00;
    block[95] = 0.000000000000000e+00;
    block[96] = 0.000000000000000e+00;
    block[97] = 0.000000000000000e+00;
    block[98] = 8.333333333333312e-03*G3_1;
    block[99] = 8.333333333333305e-03*G3_1;
    block[100] = -2.499999999999993e-02*G3_1;
    block[101] = 8.333333333333307e-03*G3_1;
    block[102] = 3.333333333333321e-02*G0_0_2 + 3.333333333333321e-02*G0_1_2 + 3.333333333333322e-02*G0_2_2;
    block[103] = -3.333333333333324e-02*G0_0_2;
    block[104] = -3.333333333333326e-02*G0_1_2;
    block[105] = 9.999999999999973e-02*G0_2_2;
    block[106] = -3.333333333333328e-02*G0_0_2 - 3.333333333333327e-02*G0_1_2;
    block[107] = 3.333333333333330e-02*G0_0_2 + 3.333333333333328e-02*G0_2_2;
    block[108] = 3.333333333333326e-02*G0_1_2 + 3.333333333333325e-02*G0_2_2;
    block[109] = -9.999999999999969e-02*G0_0_2 - 9.999999999999967e-02*G0_1_2 - 1.333333333333329e-01*G0_2_2;
    block[110] = 9.999999999999969e-02*G0_0_2 - 3.333333333333327e-02*G0_2_2;
    block[111] = 9.999999999999970e-02*G0_1_2 - 3.333333333333329e-02*G0_2_2;
    block[112] = 0.000000000000000e+00;
    block[113] = 0.000000000000000e+00;
    block[114] = 0.000000000000000e+00;
    block[115] = 0.000000000000000e+00;
    block[116] = 0.000000000000000e+00;
    block[117] = 0.000000000000000e+00;
    block[118] = 0.000000000000000e+00;
    block[119] = 0.000000000000000e+00;
    block[120] = 0.000000000000000e+00;
    block[121] = 0.000000000000000e+00;
    block[122] = 0.000000000000000e+00;
    block[123] = 0.000000000000000e+00;
    block[124] = 0.000000000000000e+00;
    block[125] = 0.000000000000000e+00;
    block[126] = 0.000000000000000e+00;
    block[127] = 0.000000000000000e+00;
    block[128] = 0.000000000000000e+00;
    block[129] = 0.000000000000000e+00;
    block[130] = 0.000000000000000e+00;
    block[131] = 0.000000000000000e+00;
    block[132] = 8.333333333333311e-03*G3_2;
    block[133] = 8.333333333333312e-03*G3_2;
    block[134] = 8.333333333333321e-03*G3_2;
    block[135] = -2.499999999999992e-02*G3_2;
    block[136] = 3.333333333333330e-02*G0_0_0 + 3.333333333333331e-02*G0_0_1 + 3.333333333333327e-02*G0_1_0 + 3.333333333333328e-02*G0_1_1 + 3.333333333333326e-02*G0_2_0 + 3.333333333333326e-02*G0_2_1;
    block[137] = -3.333333333333326e-02*G0_0_0 + 9.999999999999970e-02*G0_0_1;
    block[138] = 9.999999999999969e-02*G0_1_0 - 3.333333333333322e-02*G0_1_1;
    block[139] = -3.333333333333329e-02*G0_2_0 - 3.333333333333328e-02*G0_2_1;
    block[140] = 2.666666666666659e-01*G0_0_0 + 1.333333333333329e-01*G0_0_1 + 1.333333333333329e-01*G0_1_0 + 2.666666666666658e-01*G0_1_1;
    block[141] = -2.666666666666660e-01*G0_0_0 - 1.333333333333330e-01*G0_0_1 - 1.333333333333330e-01*G0_1_0 - 2.666666666666659e-01*G0_2_0 - 1.333333333333329e-01*G0_2_1;
    block[142] = -1.333333333333330e-01*G0_0_1 - 1.333333333333329e-01*G0_1_0 - 2.666666666666658e-01*G0_1_1 - 1.333333333333329e-01*G0_2_0 - 2.666666666666658e-01*G0_2_1;
    block[143] = -1.333333333333330e-01*G0_0_0 - 1.333333333333330e-01*G0_0_1 - 1.333333333333330e-01*G0_1_0 - 1.333333333333329e-01*G0_1_1;
    block[144] = 1.333333333333330e-01*G0_0_0 + 1.333333333333330e-01*G0_0_1 + 1.333333333333330e-01*G0_2_0 + 2.666666666666659e-01*G0_2_1;
    block[145] = 1.333333333333331e-01*G0_1_0 + 1.333333333333330e-01*G0_1_1 + 2.666666666666659e-01*G0_2_0 + 1.333333333333329e-01*G0_2_1;
    block[146] = 0.000000000000000e+00;
    block[147] = 0.000000000000000e+00;
    block[148] = 0.000000000000000e+00;
    block[149] = 0.000000000000000e+00;
    block[150] = 0.000000000000000e+00;
    block[151] = 0.000000000000000e+00;
    block[152] = 0.000000000000000e+00;
    block[153] = 0.000000000000000e+00;
    block[154] = 0.000000000000000e+00;
    block[155] = 0.000000000000000e+00;
    block[156] = 0.000000000000000e+00;
    block[157] = 0.000000000000000e+00;
    block[158] = 0.000000000000000e+00;
    block[159] = 0.000000000000000e+00;
    block[160] = 0.000000000000000e+00;
    block[161] = 0.000000000000000e+00;
    block[162] = 0.000000000000000e+00;
    block[163] = 0.000000000000000e+00;
    block[164] = 0.000000000000000e+00;
    block[165] = 0.000000000000000e+00;
    block[166] = -3.333333333333323e-02*G3_0 - 3.333333333333323e-02*G3_1;
    block[167] = -3.333333333333324e-02*G3_0 - 6.666666666666646e-02*G3_1;
    block[168] = -6.666666666666647e-02*G3_0 - 3.333333333333324e-02*G3_1;
    block[169] = -3.333333333333325e-02*G3_0 - 3.333333333333324e-02*G3_1;
    block[170] = -3.333333333333331e-02*G0_0_0 - 1.333333333333330e-01*G0_0_1 - 3.333333333333331e-02*G0_0_2 - 3.333333333333328e-02*G0_1_0 - 1.333333333333330e-01*G0_1_1 - 3.333333333333328e-02*G0_1_2 - 3.333333333333327e-02*G0_2_0 - 1.333333333333329e-01*G0_2_1 - 3.333333333333327e-02*G0_2_2;
    block[171] = 3.333333333333326e-02*G0_0_0 + 3.333333333333326e-02*G0_0_2;
    block[172] = -9.999999999999971e-02*G0_1_0 - 1.333333333333329e-01*G0_1_1 - 9.999999999999973e-02*G0_1_2;
    block[173] = 3.333333333333330e-02*G0_2_0 + 3.333333333333328e-02*G0_2_2;
    block[174] = -2.666666666666660e-01*G0_0_0 - 1.333333333333330e-01*G0_0_1 - 2.666666666666659e-01*G0_0_2 - 1.333333333333330e-01*G0_1_0 - 1.333333333333329e-01*G0_1_2;
    block[175] = 2.666666666666661e-01*G0_0_0 + 1.333333333333330e-01*G0_0_1 + 2.666666666666660e-01*G0_0_2 + 1.333333333333330e-01*G0_1_0 + 2.666666666666658e-01*G0_1_1 + 1.333333333333330e-01*G0_1_2 + 2.666666666666660e-01*G0_2_0 + 1.333333333333330e-01*G0_2_1 + 2.666666666666659e-01*G0_2_2;
    block[176] = 1.333333333333330e-01*G0_0_1 + 1.333333333333330e-01*G0_1_0 + 1.333333333333330e-01*G0_1_2 + 1.333333333333330e-01*G0_2_0 + 1.333333333333329e-01*G0_2_2;
    block[177] = 1.333333333333331e-01*G0_0_0 + 1.333333333333331e-01*G0_0_2 + 1.333333333333330e-01*G0_1_0 + 1.333333333333330e-01*G0_1_2 + 1.333333333333329e-01*G0_2_1;
    block[178] = -1.333333333333331e-01*G0_0_0 - 1.333333333333331e-01*G0_0_2 - 1.333333333333331e-01*G0_2_0 - 1.333333333333331e-01*G0_2_2;
    block[179] = -1.333333333333331e-01*G0_1_0 - 1.333333333333331e-01*G0_1_2 - 2.666666666666660e-01*G0_2_0 - 1.333333333333330e-01*G0_2_1 - 2.666666666666659e-01*G0_2_2;
    block[180] = 0.000000000000000e+00;
    block[181] = 0.000000000000000e+00;
    block[182] = 0.000000000000000e+00;
    block[183] = 0.000000000000000e+00;
    block[184] = 0.000000000000000e+00;
    block[185] = 0.000000000000000e+00;
    block[186] = 0.000000000000000e+00;
    block[187] = 0.000000000000000e+00;
    block[188] = 0.000000000000000e+00;
    block[189] = 0.000000000000000e+00;
    block[190] = 0.000000000000000e+00;
    block[191] = 0.000000000000000e+00;
    block[192] = 0.000000000000000e+00;
    block[193] = 0.000000000000000e+00;
    block[194] = 0.000000000000000e+00;
    block[195] = 0.000000000000000e+00;
    block[196] = 0.000000000000000e+00;
    block[197] = 0.000000000000000e+00;
    block[198] = 0.000000000000000e+00;
    block[199] = 0.000000000000000e+00;
    block[200] = 3.333333333333324e-02*G3_0 - 3.333333333333322e-02*G3_1 + 3.333333333333324e-02*G3_2;
    block[201] = 3.333333333333326e-02*G3_0 + 3.333333333333325e-02*G3_2;
    block[202] = 6.666666666666649e-02*G3_0 + 3.333333333333324e-02*G3_1 + 6.666666666666649e-02*G3_2;
    block[203] = 3.333333333333326e-02*G3_0 + 3.333333333333326e-02*G3_2;
    block[204] = -1.333333333333331e-01*G0_0_0 - 3.333333333333333e-02*G0_0_1 - 3.333333333333335e-02*G0_0_2 - 1.333333333333330e-01*G0_1_0 - 3.333333333333329e-02*G0_1_1 - 3.333333333333331e-02*G0_1_2 - 1.333333333333330e-01*G0_2_0 - 3.333333333333328e-02*G0_2_1 - 3.333333333333329e-02*G0_2_2;
    block[205] = -1.333333333333331e-01*G0_0_0 - 9.999999999999969e-02*G0_0_1 - 9.999999999999971e-02*G0_0_2;
    block[206] = 3.333333333333322e-02*G0_1_1 + 3.333333333333322e-02*G0_1_2;
    block[207] = 3.333333333333326e-02*G0_2_1 + 3.333333333333325e-02*G0_2_2;
    block[208] = -1.333333333333329e-01*G0_0_1 - 1.333333333333329e-01*G0_0_2 - 1.333333333333330e-01*G0_1_0 - 2.666666666666658e-01*G0_1_1 - 2.666666666666658e-01*G0_1_2;
    block[209] = 1.333333333333330e-01*G0_0_1 + 1.333333333333330e-01*G0_0_2 + 1.333333333333330e-01*G0_1_0 + 1.333333333333329e-01*G0_2_1 + 1.333333333333329e-01*G0_2_2;
    block[210] = 2.666666666666662e-01*G0_0_0 + 1.333333333333330e-01*G0_0_1 + 1.333333333333330e-01*G0_0_2 + 1.333333333333330e-01*G0_1_0 + 2.666666666666658e-01*G0_1_1 + 2.666666666666658e-01*G0_1_2 + 1.333333333333331e-01*G0_2_0 + 2.666666666666658e-01*G0_2_1 + 2.666666666666658e-01*G0_2_2;
    block[211] = 1.333333333333330e-01*G0_0_1 + 1.333333333333330e-01*G0_0_2 + 1.333333333333330e-01*G0_1_1 + 1.333333333333329e-01*G0_1_2 + 1.333333333333330e-01*G0_2_0;
    block[212] = -1.333333333333330e-01*G0_0_1 - 1.333333333333330e-01*G0_0_2 - 1.333333333333331e-01*G0_2_0 - 2.666666666666659e-01*G0_2_1 - 2.666666666666659e-01*G0_2_2;
    block[213] = -1.333333333333331e-01*G0_1_1 - 1.333333333333330e-01*G0_1_2 - 1.333333333333329e-01*G0_2_1 - 1.333333333333329e-01*G0_2_2;
    block[214] = 0.000000000000000e+00;
    block[215] = 0.000000000000000e+00;
    block[216] = 0.000000000000000e+00;
    block[217] = 0.000000000000000e+00;
    block[218] = 0.000000000000000e+00;
    block[219] = 0.000000000000000e+00;
    block[220] = 0.000000000000000e+00;
    block[221] = 0.000000000000000e+00;
    block[222] = 0.000000000000000e+00;
    block[223] = 0.000000000000000e+00;
    block[224] = 0.000000000000000e+00;
    block[225] = 0.000000000000000e+00;
    block[226] = 0.000000000000000e+00;
    block[227] = 0.000000000000000e+00;
    block[228] = 0.000000000000000e+00;
    block[229] = 0.000000000000000e+00;
    block[230] = 0.000000000000000e+00;
    block[231] = 0.000000000000000e+00;
    block[232] = 0.000000000000000e+00;
    block[233] = 0.000000000000000e+00;
    block[234] = -3.333333333333324e-02*G3_0 + 3.333333333333323e-02*G3_1 + 3.333333333333321e-02*G3_2;
    block[235] = 3.333333333333326e-02*G3_0 + 6.666666666666646e-02*G3_1 + 6.666666666666646e-02*G3_2;
    block[236] = 3.333333333333324e-02*G3_1 + 3.333333333333323e-02*G3_2;
    block[237] = 3.333333333333324e-02*G3_1 + 3.333333333333324e-02*G3_2;
    block[238] = -3.333333333333327e-02*G0_0_0 - 3.333333333333328e-02*G0_0_1 - 1.333333333333330e-01*G0_0_2 - 3.333333333333326e-02*G0_1_0 - 3.333333333333325e-02*G0_1_1 - 1.333333333333330e-01*G0_1_2 - 3.333333333333325e-02*G0_2_0 - 3.333333333333324e-02*G0_2_1 - 1.333333333333330e-01*G0_2_2;
    block[239] = 3.333333333333328e-02*G0_0_0 + 3.333333333333328e-02*G0_0_1;
    block[240] = 3.333333333333324e-02*G0_1_0 + 3.333333333333322e-02*G0_1_1;
    block[241] = -9.999999999999969e-02*G0_2_0 - 9.999999999999967e-02*G0_2_1 - 1.333333333333329e-01*G0_2_2;
    block[242] = -1.333333333333331e-01*G0_0_0 - 1.333333333333330e-01*G0_0_1 - 1.333333333333330e-01*G0_1_0 - 1.333333333333329e-01*G0_1_1;
    block[243] = 1.333333333333331e-01*G0_0_0 + 1.333333333333331e-01*G0_0_1 + 1.333333333333329e-01*G0_1_2 + 1.333333333333330e-01*G0_2_0 + 1.333333333333330e-01*G0_2_1;
    block[244] = 1.333333333333330e-01*G0_0_2 + 1.333333333333330e-01*G0_1_0 + 1.333333333333330e-01*G0_1_1 + 1.333333333333330e-01*G0_2_0 + 1.333333333333329e-01*G0_2_1;
    block[245] = 2.666666666666661e-01*G0_0_0 + 2.666666666666660e-01*G0_0_1 + 1.333333333333330e-01*G0_0_2 + 2.666666666666660e-01*G0_1_0 + 2.666666666666659e-01*G0_1_1 + 1.333333333333330e-01*G0_1_2 + 1.333333333333330e-01*G0_2_0 + 1.333333333333330e-01*G0_2_1 + 2.666666666666659e-01*G0_2_2;
    block[246] = -2.666666666666661e-01*G0_0_0 - 2.666666666666660e-01*G0_0_1 - 1.333333333333330e-01*G0_0_2 - 1.333333333333331e-01*G0_2_0 - 1.333333333333330e-01*G0_2_1;
    block[247] = -2.666666666666662e-01*G0_1_0 - 2.666666666666660e-01*G0_1_1 - 1.333333333333330e-01*G0_1_2 - 1.333333333333330e-01*G0_2_0 - 1.333333333333330e-01*G0_2_1;
    block[248] = 0.000000000000000e+00;
    block[249] = 0.000000000000000e+00;
    block[250] = 0.000000000000000e+00;
    block[251] = 0.000000000000000e+00;
    block[252] = 0.000000000000000e+00;
    block[253] = 0.000000000000000e+00;
    block[254] = 0.000000000000000e+00;
    block[255] = 0.000000000000000e+00;
    block[256] = 0.000000000000000e+00;
    block[257] = 0.000000000000000e+00;
    block[258] = 0.000000000000000e+00;
    block[259] = 0.000000000000000e+00;
    block[260] = 0.000000000000000e+00;
    block[261] = 0.000000000000000e+00;
    block[262] = 0.000000000000000e+00;
    block[263] = 0.000000000000000e+00;
    block[264] = 0.000000000000000e+00;
    block[265] = 0.000000000000000e+00;
    block[266] = 0.000000000000000e+00;
    block[267] = 0.000000000000000e+00;
    block[268] = 3.333333333333326e-02*G3_0 + 3.333333333333325e-02*G3_1 - 3.333333333333323e-02*G3_2;
    block[269] = 3.333333333333326e-02*G3_0 + 3.333333333333325e-02*G3_1;
    block[270] = 3.333333333333326e-02*G3_0 + 3.333333333333325e-02*G3_1;
    block[271] = 6.666666666666650e-02*G3_0 + 6.666666666666649e-02*G3_1 + 3.333333333333324e-02*G3_2;
    block[272] = 3.333333333333327e-02*G0_0_0 + 3.333333333333335e-02*G0_0_2 + 3.333333333333326e-02*G0_1_0 + 3.333333333333331e-02*G0_1_2 + 3.333333333333325e-02*G0_2_0 + 3.333333333333330e-02*G0_2_2;
    block[273] = -3.333333333333328e-02*G0_0_0 + 9.999999999999971e-02*G0_0_2;
    block[274] = -3.333333333333324e-02*G0_1_0 - 3.333333333333321e-02*G0_1_2;
    block[275] = 9.999999999999969e-02*G0_2_0 - 3.333333333333328e-02*G0_2_2;
    block[276] = 1.333333333333331e-01*G0_0_0 + 1.333333333333330e-01*G0_0_2 + 1.333333333333330e-01*G0_1_0 + 2.666666666666659e-01*G0_1_2;
    block[277] = -1.333333333333331e-01*G0_0_0 - 1.333333333333331e-01*G0_0_2 - 1.333333333333330e-01*G0_2_0 - 1.333333333333331e-01*G0_2_2;
    block[278] = -1.333333333333331e-01*G0_0_2 - 1.333333333333330e-01*G0_1_0 - 2.666666666666659e-01*G0_1_2 - 1.333333333333330e-01*G0_2_0 - 2.666666666666659e-01*G0_2_2;
    block[279] = -2.666666666666661e-01*G0_0_0 - 1.333333333333331e-01*G0_0_2 - 2.666666666666660e-01*G0_1_0 - 1.333333333333330e-01*G0_1_2 - 1.333333333333330e-01*G0_2_0;
    block[280] = 2.666666666666661e-01*G0_0_0 + 1.333333333333331e-01*G0_0_2 + 1.333333333333331e-01*G0_2_0 + 2.666666666666661e-01*G0_2_2;
    block[281] = 2.666666666666662e-01*G0_1_0 + 1.333333333333331e-01*G0_1_2 + 1.333333333333330e-01*G0_2_0 + 1.333333333333330e-01*G0_2_2;
    block[282] = 0.000000000000000e+00;
    block[283] = 0.000000000000000e+00;
    block[284] = 0.000000000000000e+00;
    block[285] = 0.000000000000000e+00;
    block[286] = 0.000000000000000e+00;
    block[287] = 0.000000000000000e+00;
    block[288] = 0.000000000000000e+00;
    block[289] = 0.000000000000000e+00;
    block[290] = 0.000000000000000e+00;
    block[291] = 0.000000000000000e+00;
    block[292] = 0.000000000000000e+00;
    block[293] = 0.000000000000000e+00;
    block[294] = 0.000000000000000e+00;
    block[295] = 0.000000000000000e+00;
    block[296] = 0.000000000000000e+00;
    block[297] = 0.000000000000000e+00;
    block[298] = 0.000000000000000e+00;
    block[299] = 0.000000000000000e+00;
    block[300] = 0.000000000000000e+00;
    block[301] = 0.000000000000000e+00;
    block[302] = -3.333333333333326e-02*G3_0 - 3.333333333333324e-02*G3_2;
    block[303] = -3.333333333333326e-02*G3_0 - 6.666666666666649e-02*G3_2;
    block[304] = -3.333333333333326e-02*G3_0 - 3.333333333333326e-02*G3_2;
    block[305] = -6.666666666666650e-02*G3_0 - 3.333333333333326e-02*G3_2;
    block[306] = 3.333333333333328e-02*G0_0_1 + 3.333333333333331e-02*G0_0_2 + 3.333333333333327e-02*G0_1_1 + 3.333333333333328e-02*G0_1_2 + 3.333333333333326e-02*G0_2_1 + 3.333333333333327e-02*G0_2_2;
    block[307] = -3.333333333333328e-02*G0_0_1 - 3.333333333333327e-02*G0_0_2;
    block[308] = -3.333333333333324e-02*G0_1_1 + 9.999999999999971e-02*G0_1_2;
    block[309] = 9.999999999999970e-02*G0_2_1 - 3.333333333333328e-02*G0_2_2;
    block[310] = 1.333333333333331e-01*G0_0_1 + 2.666666666666659e-01*G0_0_2 + 1.333333333333330e-01*G0_1_1 + 1.333333333333329e-01*G0_1_2;
    block[311] = -1.333333333333331e-01*G0_0_1 - 2.666666666666660e-01*G0_0_2 - 1.333333333333330e-01*G0_1_2 - 1.333333333333331e-01*G0_2_1 - 2.666666666666659e-01*G0_2_2;
    block[312] = -1.333333333333330e-01*G0_1_1 - 1.333333333333329e-01*G0_1_2 - 1.333333333333330e-01*G0_2_1 - 1.333333333333329e-01*G0_2_2;
    block[313] = -2.666666666666662e-01*G0_0_1 - 1.333333333333330e-01*G0_0_2 - 2.666666666666661e-01*G0_1_1 - 1.333333333333330e-01*G0_1_2 - 1.333333333333330e-01*G0_2_1;
    block[314] = 2.666666666666662e-01*G0_0_1 + 1.333333333333330e-01*G0_0_2 + 1.333333333333331e-01*G0_2_1 + 1.333333333333330e-01*G0_2_2;
    block[315] = 2.666666666666662e-01*G0_1_1 + 1.333333333333331e-01*G0_1_2 + 1.333333333333331e-01*G0_2_1 + 2.666666666666659e-01*G0_2_2;
    block[316] = 0.000000000000000e+00;
    block[317] = 0.000000000000000e+00;
    block[318] = 0.000000000000000e+00;
    block[319] = 0.000000000000000e+00;
    block[320] = 0.000000000000000e+00;
    block[321] = 0.000000000000000e+00;
    block[322] = 0.000000000000000e+00;
    block[323] = 0.000000000000000e+00;
    block[324] = 0.000000000000000e+00;
    block[325] = 0.000000000000000e+00;
    block[326] = 0.000000000000000e+00;
    block[327] = 0.000000000000000e+00;
    block[328] = 0.000000000000000e+00;
    block[329] = 0.000000000000000e+00;
    block[330] = 0.000000000000000e+00;
    block[331] = 0.000000000000000e+00;
    block[332] = 0.000000000000000e+00;
    block[333] = 0.000000000000000e+00;
    block[334] = 0.000000000000000e+00;
    block[335] = 0.000000000000000e+00;
    block[336] = -3.333333333333326e-02*G3_1 - 3.333333333333323e-02*G3_2;
    block[337] = -3.333333333333326e-02*G3_1 - 3.333333333333324e-02*G3_2;
    block[338] = -3.333333333333327e-02*G3_1 - 6.666666666666649e-02*G3_2;
    block[339] = -6.666666666666651e-02*G3_1 - 3.333333333333325e-02*G3_2;
    block[340] = 0.000000000000000e+00;
    block[341] = 0.000000000000000e+00;
    block[342] = 0.000000000000000e+00;
    block[343] = 0.000000000000000e+00;
    block[344] = 0.000000000000000e+00;
    block[345] = 0.000000000000000e+00;
    block[346] = 0.000000000000000e+00;
    block[347] = 0.000000000000000e+00;
    block[348] = 0.000000000000000e+00;
    block[349] = 0.000000000000000e+00;
    block[350] = 9.999999999999978e-02*G1_0_0 + 9.999999999999976e-02*G1_0_1 + 9.999999999999977e-02*G1_0_2 + 9.999999999999976e-02*G1_1_0 + 9.999999999999974e-02*G1_1_1 + 9.999999999999974e-02*G1_1_2 + 9.999999999999977e-02*G1_2_0 + 9.999999999999973e-02*G1_2_1 + 9.999999999999974e-02*G1_2_2;
    block[351] = 3.333333333333328e-02*G1_0_0 + 3.333333333333327e-02*G1_0_1 + 3.333333333333328e-02*G1_0_2;
    block[352] = 3.333333333333325e-02*G1_1_0 + 3.333333333333324e-02*G1_1_1 + 3.333333333333322e-02*G1_1_2;
    block[353] = 3.333333333333321e-02*G1_2_0 + 3.333333333333320e-02*G1_2_1 + 3.333333333333321e-02*G1_2_2;
    block[354] = 3.333333333333328e-02*G1_0_0 + 3.333333333333326e-02*G1_0_1 + 3.333333333333323e-02*G1_0_2 + 3.333333333333329e-02*G1_1_0 + 3.333333333333327e-02*G1_1_1 + 3.333333333333326e-02*G1_1_2;
    block[355] = -3.333333333333330e-02*G1_0_0 - 3.333333333333328e-02*G1_0_1 - 3.333333333333325e-02*G1_0_2 - 1.333333333333330e-01*G1_1_0 - 1.333333333333330e-01*G1_1_1 - 1.333333333333330e-01*G1_1_2 - 3.333333333333328e-02*G1_2_0 - 3.333333333333327e-02*G1_2_1 - 3.333333333333324e-02*G1_2_2;
    block[356] = -1.333333333333330e-01*G1_0_0 - 1.333333333333330e-01*G1_0_1 - 1.333333333333330e-01*G1_0_2 - 3.333333333333331e-02*G1_1_0 - 3.333333333333328e-02*G1_1_1 - 3.333333333333326e-02*G1_1_2 - 3.333333333333331e-02*G1_2_0 - 3.333333333333329e-02*G1_2_1 - 3.333333333333328e-02*G1_2_2;
    block[357] = -3.333333333333326e-02*G1_0_0 - 3.333333333333323e-02*G1_0_1 - 3.333333333333322e-02*G1_0_2 - 3.333333333333324e-02*G1_1_0 - 3.333333333333323e-02*G1_1_1 - 3.333333333333323e-02*G1_1_2 - 1.333333333333330e-01*G1_2_0 - 1.333333333333329e-01*G1_2_1 - 1.333333333333329e-01*G1_2_2;
    block[358] = 3.333333333333326e-02*G1_0_0 + 3.333333333333324e-02*G1_0_1 + 3.333333333333323e-02*G1_0_2 + 3.333333333333334e-02*G1_2_0 + 3.333333333333331e-02*G1_2_1 + 3.333333333333329e-02*G1_2_2;
    block[359] = 3.333333333333326e-02*G1_1_0 + 3.333333333333324e-02*G1_1_1 + 3.333333333333323e-02*G1_1_2 + 3.333333333333328e-02*G1_2_0 + 3.333333333333327e-02*G1_2_1 + 3.333333333333324e-02*G1_2_2;
    block[360] = 0.000000000000000e+00;
    block[361] = 0.000000000000000e+00;
    block[362] = 0.000000000000000e+00;
    block[363] = 0.000000000000000e+00;
    block[364] = 0.000000000000000e+00;
    block[365] = 0.000000000000000e+00;
    block[366] = 0.000000000000000e+00;
    block[367] = 0.000000000000000e+00;
    block[368] = 0.000000000000000e+00;
    block[369] = 0.000000000000000e+00;
    block[370] = 2.499999999999993e-02*G4_0 + 2.499999999999993e-02*G4_1 + 2.499999999999993e-02*G4_2;
    block[371] = -8.333333333333325e-03*G4_0 - 8.333333333333321e-03*G4_1 - 8.333333333333316e-03*G4_2;
    block[372] = -8.333333333333321e-03*G4_0 - 8.333333333333316e-03*G4_1 - 8.333333333333311e-03*G4_2;
    block[373] = -8.333333333333314e-03*G4_0 - 8.333333333333311e-03*G4_1 - 8.333333333333307e-03*G4_2;
    block[374] = 0.000000000000000e+00;
    block[375] = 0.000000000000000e+00;
    block[376] = 0.000000000000000e+00;
    block[377] = 0.000000000000000e+00;
    block[378] = 0.000000000000000e+00;
    block[379] = 0.000000000000000e+00;
    block[380] = 0.000000000000000e+00;
    block[381] = 0.000000000000000e+00;
    block[382] = 0.000000000000000e+00;
    block[383] = 0.000000000000000e+00;
    block[384] = 3.333333333333328e-02*G1_0_0 + 3.333333333333327e-02*G1_1_0 + 3.333333333333328e-02*G1_2_0;
    block[385] = 9.999999999999973e-02*G1_0_0;
    block[386] = -3.333333333333322e-02*G1_1_0;
    block[387] = -3.333333333333324e-02*G1_2_0;
    block[388] = -3.333333333333326e-02*G1_0_0 + 9.999999999999969e-02*G1_1_0;
    block[389] = 3.333333333333327e-02*G1_0_0 + 3.333333333333326e-02*G1_2_0;
    block[390] = -1.333333333333331e-01*G1_0_0 - 9.999999999999970e-02*G1_1_0 - 9.999999999999970e-02*G1_2_0;
    block[391] = 3.333333333333328e-02*G1_0_0 + 3.333333333333328e-02*G1_1_0;
    block[392] = -3.333333333333328e-02*G1_0_0 + 9.999999999999971e-02*G1_2_0;
    block[393] = -3.333333333333329e-02*G1_1_0 - 3.333333333333327e-02*G1_2_0;
    block[394] = 0.000000000000000e+00;
    block[395] = 0.000000000000000e+00;
    block[396] = 0.000000000000000e+00;
    block[397] = 0.000000000000000e+00;
    block[398] = 0.000000000000000e+00;
    block[399] = 0.000000000000000e+00;
    block[400] = 0.000000000000000e+00;
    block[401] = 0.000000000000000e+00;
    block[402] = 0.000000000000000e+00;
    block[403] = 0.000000000000000e+00;
    block[404] = 8.333333333333323e-03*G4_0;
    block[405] = -2.499999999999991e-02*G4_0;
    block[406] = 8.333333333333316e-03*G4_0;
    block[407] = 8.333333333333321e-03*G4_0;
    block[408] = 0.000000000000000e+00;
    block[409] = 0.000000000000000e+00;
    block[410] = 0.000000000000000e+00;
    block[411] = 0.000000000000000e+00;
    block[412] = 0.000000000000000e+00;
    block[413] = 0.000000000000000e+00;
    block[414] = 0.000000000000000e+00;
    block[415] = 0.000000000000000e+00;
    block[416] = 0.000000000000000e+00;
    block[417] = 0.000000000000000e+00;
    block[418] = 3.333333333333325e-02*G1_0_1 + 3.333333333333324e-02*G1_1_1 + 3.333333333333324e-02*G1_2_1;
    block[419] = -3.333333333333322e-02*G1_0_1;
    block[420] = 9.999999999999967e-02*G1_1_1;
    block[421] = -3.333333333333326e-02*G1_2_1;
    block[422] = 9.999999999999969e-02*G1_0_1 - 3.333333333333322e-02*G1_1_1;
    block[423] = -9.999999999999973e-02*G1_0_1 - 1.333333333333329e-01*G1_1_1 - 9.999999999999969e-02*G1_2_1;
    block[424] = 3.333333333333321e-02*G1_1_1 + 3.333333333333323e-02*G1_2_1;
    block[425] = 3.333333333333322e-02*G1_0_1 + 3.333333333333322e-02*G1_1_1;
    block[426] = -3.333333333333323e-02*G1_0_1 - 3.333333333333321e-02*G1_2_1;
    block[427] = -3.333333333333323e-02*G1_1_1 + 9.999999999999969e-02*G1_2_1;
    block[428] = 0.000000000000000e+00;
    block[429] = 0.000000000000000e+00;
    block[430] = 0.000000000000000e+00;
    block[431] = 0.000000000000000e+00;
    block[432] = 0.000000000000000e+00;
    block[433] = 0.000000000000000e+00;
    block[434] = 0.000000000000000e+00;
    block[435] = 0.000000000000000e+00;
    block[436] = 0.000000000000000e+00;
    block[437] = 0.000000000000000e+00;
    block[438] = 8.333333333333311e-03*G4_1;
    block[439] = 8.333333333333302e-03*G4_1;
    block[440] = -2.499999999999992e-02*G4_1;
    block[441] = 8.333333333333304e-03*G4_1;
    block[442] = 0.000000000000000e+00;
    block[443] = 0.000000000000000e+00;
    block[444] = 0.000000000000000e+00;
    block[445] = 0.000000000000000e+00;
    block[446] = 0.000000000000000e+00;
    block[447] = 0.000000000000000e+00;
    block[448] = 0.000000000000000e+00;
    block[449] = 0.000000000000000e+00;
    block[450] = 0.000000000000000e+00;
    block[451] = 0.000000000000000e+00;
    block[452] = 3.333333333333321e-02*G1_0_2 + 3.333333333333320e-02*G1_1_2 + 3.333333333333321e-02*G1_2_2;
    block[453] = -3.333333333333324e-02*G1_0_2;
    block[454] = -3.333333333333326e-02*G1_1_2;
    block[455] = 9.999999999999973e-02*G1_2_2;
    block[456] = -3.333333333333328e-02*G1_0_2 - 3.333333333333327e-02*G1_1_2;
    block[457] = 3.333333333333330e-02*G1_0_2 + 3.333333333333328e-02*G1_2_2;
    block[458] = 3.333333333333327e-02*G1_1_2 + 3.333333333333326e-02*G1_2_2;
    block[459] = -9.999999999999970e-02*G1_0_2 - 9.999999999999967e-02*G1_1_2 - 1.333333333333329e-01*G1_2_2;
    block[460] = 9.999999999999969e-02*G1_0_2 - 3.333333333333327e-02*G1_2_2;
    block[461] = 9.999999999999969e-02*G1_1_2 - 3.333333333333328e-02*G1_2_2;
    block[462] = 0.000000000000000e+00;
    block[463] = 0.000000000000000e+00;
    block[464] = 0.000000000000000e+00;
    block[465] = 0.000000000000000e+00;
    block[466] = 0.000000000000000e+00;
    block[467] = 0.000000000000000e+00;
    block[468] = 0.000000000000000e+00;
    block[469] = 0.000000000000000e+00;
    block[470] = 0.000000000000000e+00;
    block[471] = 0.000000000000000e+00;
    block[472] = 8.333333333333311e-03*G4_2;
    block[473] = 8.333333333333312e-03*G4_2;
    block[474] = 8.333333333333321e-03*G4_2;
    block[475] = -2.499999999999992e-02*G4_2;
    block[476] = 0.000000000000000e+00;
    block[477] = 0.000000000000000e+00;
    block[478] = 0.000000000000000e+00;
    block[479] = 0.000000000000000e+00;
    block[480] = 0.000000000000000e+00;
    block[481] = 0.000000000000000e+00;
    block[482] = 0.000000000000000e+00;
    block[483] = 0.000000000000000e+00;
    block[484] = 0.000000000000000e+00;
    block[485] = 0.000000000000000e+00;
    block[486] = 3.333333333333328e-02*G1_0_0 + 3.333333333333328e-02*G1_0_1 + 3.333333333333326e-02*G1_1_0 + 3.333333333333326e-02*G1_1_1 + 3.333333333333323e-02*G1_2_0 + 3.333333333333326e-02*G1_2_1;
    block[487] = -3.333333333333326e-02*G1_0_0 + 9.999999999999969e-02*G1_0_1;
    block[488] = 9.999999999999969e-02*G1_1_0 - 3.333333333333321e-02*G1_1_1;
    block[489] = -3.333333333333328e-02*G1_2_0 - 3.333333333333328e-02*G1_2_1;
    block[490] = 2.666666666666658e-01*G1_0_0 + 1.333333333333329e-01*G1_0_1 + 1.333333333333329e-01*G1_1_0 + 2.666666666666658e-01*G1_1_1;
    block[491] = -2.666666666666660e-01*G1_0_0 - 1.333333333333330e-01*G1_0_1 - 1.333333333333330e-01*G1_1_0 - 2.666666666666659e-01*G1_2_0 - 1.333333333333329e-01*G1_2_1;
    block[492] = -1.333333333333330e-01*G1_0_1 - 1.333333333333329e-01*G1_1_0 - 2.666666666666658e-01*G1_1_1 - 1.333333333333329e-01*G1_2_0 - 2.666666666666658e-01*G1_2_1;
    block[493] = -1.333333333333329e-01*G1_0_0 - 1.333333333333329e-01*G1_0_1 - 1.333333333333329e-01*G1_1_0 - 1.333333333333329e-01*G1_1_1;
    block[494] = 1.333333333333330e-01*G1_0_0 + 1.333333333333330e-01*G1_0_1 + 1.333333333333330e-01*G1_2_0 + 2.666666666666659e-01*G1_2_1;
    block[495] = 1.333333333333330e-01*G1_1_0 + 1.333333333333330e-01*G1_1_1 + 2.666666666666659e-01*G1_2_0 + 1.333333333333329e-01*G1_2_1;
    block[496] = 0.000000000000000e+00;
    block[497] = 0.000000000000000e+00;
    block[498] = 0.000000000000000e+00;
    block[499] = 0.000000000000000e+00;
    block[500] = 0.000000000000000e+00;
    block[501] = 0.000000000000000e+00;
    block[502] = 0.000000000000000e+00;
    block[503] = 0.000000000000000e+00;
    block[504] = 0.000000000000000e+00;
    block[505] = 0.000000000000000e+00;
    block[506] = -3.333333333333322e-02*G4_0 - 3.333333333333323e-02*G4_1;
    block[507] = -3.333333333333324e-02*G4_0 - 6.666666666666646e-02*G4_1;
    block[508] = -6.666666666666647e-02*G4_0 - 3.333333333333324e-02*G4_1;
    block[509] = -3.333333333333324e-02*G4_0 - 3.333333333333324e-02*G4_1;
    block[510] = 0.000000000000000e+00;
    block[511] = 0.000000000000000e+00;
    block[512] = 0.000000000000000e+00;
    block[513] = 0.000000000000000e+00;
    block[514] = 0.000000000000000e+00;
    block[515] = 0.000000000000000e+00;
    block[516] = 0.000000000000000e+00;
    block[517] = 0.000000000000000e+00;
    block[518] = 0.000000000000000e+00;
    block[519] = 0.000000000000000e+00;
    block[520] = -3.333333333333330e-02*G1_0_0 - 1.333333333333330e-01*G1_0_1 - 3.333333333333328e-02*G1_0_2 - 3.333333333333328e-02*G1_1_0 - 1.333333333333330e-01*G1_1_1 - 3.333333333333326e-02*G1_1_2 - 3.333333333333324e-02*G1_2_0 - 1.333333333333330e-01*G1_2_1 - 3.333333333333324e-02*G1_2_2;
    block[521] = 3.333333333333327e-02*G1_0_0 + 3.333333333333327e-02*G1_0_2;
    block[522] = -9.999999999999973e-02*G1_1_0 - 1.333333333333329e-01*G1_1_1 - 9.999999999999969e-02*G1_1_2;
    block[523] = 3.333333333333330e-02*G1_2_0 + 3.333333333333328e-02*G1_2_2;
    block[524] = -2.666666666666659e-01*G1_0_0 - 1.333333333333330e-01*G1_0_1 - 2.666666666666659e-01*G1_0_2 - 1.333333333333330e-01*G1_1_0 - 1.333333333333329e-01*G1_1_2;
    block[525] = 2.666666666666661e-01*G1_0_0 + 1.333333333333331e-01*G1_0_1 + 2.666666666666661e-01*G1_0_2 + 1.333333333333331e-01*G1_1_0 + 2.666666666666659e-01*G1_1_1 + 1.333333333333331e-01*G1_1_2 + 2.666666666666660e-01*G1_2_0 + 1.333333333333331e-01*G1_2_1 + 2.666666666666659e-01*G1_2_2;
    block[526] = 1.333333333333331e-01*G1_0_1 + 1.333333333333330e-01*G1_1_0 + 1.333333333333329e-01*G1_1_2 + 1.333333333333330e-01*G1_2_0 + 1.333333333333329e-01*G1_2_2;
    block[527] = 1.333333333333331e-01*G1_0_0 + 1.333333333333330e-01*G1_0_2 + 1.333333333333331e-01*G1_1_0 + 1.333333333333330e-01*G1_1_2 + 1.333333333333329e-01*G1_2_1;
    block[528] = -1.333333333333331e-01*G1_0_0 - 1.333333333333330e-01*G1_0_2 - 1.333333333333331e-01*G1_2_0 - 1.333333333333330e-01*G1_2_2;
    block[529] = -1.333333333333331e-01*G1_1_0 - 1.333333333333330e-01*G1_1_2 - 2.666666666666661e-01*G1_2_0 - 1.333333333333331e-01*G1_2_1 - 2.666666666666659e-01*G1_2_2;
    block[530] = 0.000000000000000e+00;
    block[531] = 0.000000000000000e+00;
    block[532] = 0.000000000000000e+00;
    block[533] = 0.000000000000000e+00;
    block[534] = 0.000000000000000e+00;
    block[535] = 0.000000000000000e+00;
    block[536] = 0.000000000000000e+00;
    block[537] = 0.000000000000000e+00;
    block[538] = 0.000000000000000e+00;
    block[539] = 0.000000000000000e+00;
    block[540] = 3.333333333333325e-02*G4_0 - 3.333333333333322e-02*G4_1 + 3.333333333333323e-02*G4_2;
    block[541] = 3.333333333333326e-02*G4_0 + 3.333333333333324e-02*G4_2;
    block[542] = 6.666666666666650e-02*G4_0 + 3.333333333333326e-02*G4_1 + 6.666666666666649e-02*G4_2;
    block[543] = 3.333333333333327e-02*G4_0 + 3.333333333333325e-02*G4_2;
    block[544] = 0.000000000000000e+00;
    block[545] = 0.000000000000000e+00;
    block[546] = 0.000000000000000e+00;
    block[547] = 0.000000000000000e+00;
    block[548] = 0.000000000000000e+00;
    block[549] = 0.000000000000000e+00;
    block[550] = 0.000000000000000e+00;
    block[551] = 0.000000000000000e+00;
    block[552] = 0.000000000000000e+00;
    block[553] = 0.000000000000000e+00;
    block[554] = -1.333333333333331e-01*G1_0_0 - 3.333333333333330e-02*G1_0_1 - 3.333333333333331e-02*G1_0_2 - 1.333333333333330e-01*G1_1_0 - 3.333333333333328e-02*G1_1_1 - 3.333333333333328e-02*G1_1_2 - 1.333333333333330e-01*G1_2_0 - 3.333333333333326e-02*G1_2_1 - 3.333333333333328e-02*G1_2_2;
    block[555] = -1.333333333333331e-01*G1_0_0 - 9.999999999999970e-02*G1_0_1 - 9.999999999999970e-02*G1_0_2;
    block[556] = 3.333333333333322e-02*G1_1_1 + 3.333333333333323e-02*G1_1_2;
    block[557] = 3.333333333333327e-02*G1_2_1 + 3.333333333333326e-02*G1_2_2;
    block[558] = -1.333333333333329e-01*G1_0_1 - 1.333333333333329e-01*G1_0_2 - 1.333333333333330e-01*G1_1_0 - 2.666666666666658e-01*G1_1_1 - 2.666666666666658e-01*G1_1_2;
    block[559] = 1.333333333333330e-01*G1_0_1 + 1.333333333333330e-01*G1_0_2 + 1.333333333333331e-01*G1_1_0 + 1.333333333333329e-01*G1_2_1 + 1.333333333333329e-01*G1_2_2;
    block[560] = 2.666666666666662e-01*G1_0_0 + 1.333333333333330e-01*G1_0_1 + 1.333333333333330e-01*G1_0_2 + 1.333333333333330e-01*G1_1_0 + 2.666666666666658e-01*G1_1_1 + 2.666666666666658e-01*G1_1_2 + 1.333333333333331e-01*G1_2_0 + 2.666666666666658e-01*G1_2_1 + 2.666666666666658e-01*G1_2_2;
    block[561] = 1.333333333333329e-01*G1_0_1 + 1.333333333333329e-01*G1_0_2 + 1.333333333333329e-01*G1_1_1 + 1.333333333333329e-01*G1_1_2 + 1.333333333333330e-01*G1_2_0;
    block[562] = -1.333333333333329e-01*G1_0_1 - 1.333333333333329e-01*G1_0_2 - 1.333333333333331e-01*G1_2_0 - 2.666666666666659e-01*G1_2_1 - 2.666666666666659e-01*G1_2_2;
    block[563] = -1.333333333333329e-01*G1_1_1 - 1.333333333333329e-01*G1_1_2 - 1.333333333333329e-01*G1_2_1 - 1.333333333333329e-01*G1_2_2;
    block[564] = 0.000000000000000e+00;
    block[565] = 0.000000000000000e+00;
    block[566] = 0.000000000000000e+00;
    block[567] = 0.000000000000000e+00;
    block[568] = 0.000000000000000e+00;
    block[569] = 0.000000000000000e+00;
    block[570] = 0.000000000000000e+00;
    block[571] = 0.000000000000000e+00;
    block[572] = 0.000000000000000e+00;
    block[573] = 0.000000000000000e+00;
    block[574] = -3.333333333333324e-02*G4_0 + 3.333333333333322e-02*G4_1 + 3.333333333333322e-02*G4_2;
    block[575] = 3.333333333333326e-02*G4_0 + 6.666666666666646e-02*G4_1 + 6.666666666666646e-02*G4_2;
    block[576] = 3.333333333333323e-02*G4_1 + 3.333333333333322e-02*G4_2;
    block[577] = 3.333333333333323e-02*G4_1 + 3.333333333333323e-02*G4_2;
    block[578] = 0.000000000000000e+00;
    block[579] = 0.000000000000000e+00;
    block[580] = 0.000000000000000e+00;
    block[581] = 0.000000000000000e+00;
    block[582] = 0.000000000000000e+00;
    block[583] = 0.000000000000000e+00;
    block[584] = 0.000000000000000e+00;
    block[585] = 0.000000000000000e+00;
    block[586] = 0.000000000000000e+00;
    block[587] = 0.000000000000000e+00;
    block[588] = -3.333333333333326e-02*G1_0_0 - 3.333333333333324e-02*G1_0_1 - 1.333333333333330e-01*G1_0_2 - 3.333333333333324e-02*G1_1_0 - 3.333333333333323e-02*G1_1_1 - 1.333333333333329e-01*G1_1_2 - 3.333333333333323e-02*G1_2_0 - 3.333333333333321e-02*G1_2_1 - 1.333333333333329e-01*G1_2_2;
    block[589] = 3.333333333333328e-02*G1_0_0 + 3.333333333333328e-02*G1_0_1;
    block[590] = 3.333333333333322e-02*G1_1_0 + 3.333333333333323e-02*G1_1_1;
    block[591] = -9.999999999999970e-02*G1_2_0 - 9.999999999999967e-02*G1_2_1 - 1.333333333333329e-01*G1_2_2;
    block[592] = -1.333333333333329e-01*G1_0_0 - 1.333333333333329e-01*G1_0_1 - 1.333333333333329e-01*G1_1_0 - 1.333333333333329e-01*G1_1_1;
    block[593] = 1.333333333333331e-01*G1_0_0 + 1.333333333333331e-01*G1_0_1 + 1.333333333333329e-01*G1_1_2 + 1.333333333333330e-01*G1_2_0 + 1.333333333333330e-01*G1_2_1;
    block[594] = 1.333333333333330e-01*G1_0_2 + 1.333333333333329e-01*G1_1_0 + 1.333333333333329e-01*G1_1_1 + 1.333333333333329e-01*G1_2_0 + 1.333333333333329e-01*G1_2_1;
    block[595] = 2.666666666666659e-01*G1_0_0 + 2.666666666666658e-01*G1_0_1 + 1.333333333333330e-01*G1_0_2 + 2.666666666666658e-01*G1_1_0 + 2.666666666666658e-01*G1_1_1 + 1.333333333333329e-01*G1_1_2 + 1.333333333333330e-01*G1_2_0 + 1.333333333333329e-01*G1_2_1 + 2.666666666666658e-01*G1_2_2;
    block[596] = -2.666666666666660e-01*G1_0_0 - 2.666666666666659e-01*G1_0_1 - 1.333333333333330e-01*G1_0_2 - 1.333333333333330e-01*G1_2_0 - 1.333333333333330e-01*G1_2_1;
    block[597] = -2.666666666666659e-01*G1_1_0 - 2.666666666666659e-01*G1_1_1 - 1.333333333333330e-01*G1_1_2 - 1.333333333333330e-01*G1_2_0 - 1.333333333333330e-01*G1_2_1;
    block[598] = 0.000000000000000e+00;
    block[599] = 0.000000000000000e+00;
    block[600] = 0.000000000000000e+00;
    block[601] = 0.000000000000000e+00;
    block[602] = 0.000000000000000e+00;
    block[603] = 0.000000000000000e+00;
    block[604] = 0.000000000000000e+00;
    block[605] = 0.000000000000000e+00;
    block[606] = 0.000000000000000e+00;
    block[607] = 0.000000000000000e+00;
    block[608] = 3.333333333333324e-02*G4_0 + 3.333333333333325e-02*G4_1 - 3.333333333333323e-02*G4_2;
    block[609] = 3.333333333333325e-02*G4_0 + 3.333333333333324e-02*G4_1;
    block[610] = 3.333333333333324e-02*G4_0 + 3.333333333333324e-02*G4_1;
    block[611] = 6.666666666666647e-02*G4_0 + 6.666666666666646e-02*G4_1 + 3.333333333333324e-02*G4_2;
    block[612] = 0.000000000000000e+00;
    block[613] = 0.000000000000000e+00;
    block[614] = 0.000000000000000e+00;
    block[615] = 0.000000000000000e+00;
    block[616] = 0.000000000000000e+00;
    block[617] = 0.000000000000000e+00;
    block[618] = 0.000000000000000e+00;
    block[619] = 0.000000000000000e+00;
    block[620] = 0.000000000000000e+00;
    block[621] = 0.000000000000000e+00;
    block[622] = 3.333333333333326e-02*G1_0_0 + 3.333333333333334e-02*G1_0_2 + 3.333333333333324e-02*G1_1_0 + 3.333333333333331e-02*G1_1_2 + 3.333333333333323e-02*G1_2_0 + 3.333333333333329e-02*G1_2_2;
    block[623] = -3.333333333333328e-02*G1_0_0 + 9.999999999999971e-02*G1_0_2;
    block[624] = -3.333333333333323e-02*G1_1_0 - 3.333333333333321e-02*G1_1_2;
    block[625] = 9.999999999999969e-02*G1_2_0 - 3.333333333333328e-02*G1_2_2;
    block[626] = 1.333333333333330e-01*G1_0_0 + 1.333333333333330e-01*G1_0_2 + 1.333333333333330e-01*G1_1_0 + 2.666666666666659e-01*G1_1_2;
    block[627] = -1.333333333333331e-01*G1_0_0 - 1.333333333333331e-01*G1_0_2 - 1.333333333333330e-01*G1_2_0 - 1.333333333333330e-01*G1_2_2;
    block[628] = -1.333333333333331e-01*G1_0_2 - 1.333333333333329e-01*G1_1_0 - 2.666666666666659e-01*G1_1_2 - 1.333333333333329e-01*G1_2_0 - 2.666666666666659e-01*G1_2_2;
    block[629] = -2.666666666666660e-01*G1_0_0 - 1.333333333333330e-01*G1_0_2 - 2.666666666666659e-01*G1_1_0 - 1.333333333333330e-01*G1_1_2 - 1.333333333333330e-01*G1_2_0;
    block[630] = 2.666666666666661e-01*G1_0_0 + 1.333333333333331e-01*G1_0_2 + 1.333333333333331e-01*G1_2_0 + 2.666666666666661e-01*G1_2_2;
    block[631] = 2.666666666666661e-01*G1_1_0 + 1.333333333333330e-01*G1_1_2 + 1.333333333333331e-01*G1_2_0 + 1.333333333333330e-01*G1_2_2;
    block[632] = 0.000000000000000e+00;
    block[633] = 0.000000000000000e+00;
    block[634] = 0.000000000000000e+00;
    block[635] = 0.000000000000000e+00;
    block[636] = 0.000000000000000e+00;
    block[637] = 0.000000000000000e+00;
    block[638] = 0.000000000000000e+00;
    block[639] = 0.000000000000000e+00;
    block[640] = 0.000000000000000e+00;
    block[641] = 0.000000000000000e+00;
    block[642] = -3.333333333333326e-02*G4_0 - 3.333333333333324e-02*G4_2;
    block[643] = -3.333333333333326e-02*G4_0 - 6.666666666666649e-02*G4_2;
    block[644] = -3.333333333333326e-02*G4_0 - 3.333333333333326e-02*G4_2;
    block[645] = -6.666666666666650e-02*G4_0 - 3.333333333333326e-02*G4_2;
    block[646] = 0.000000000000000e+00;
    block[647] = 0.000000000000000e+00;
    block[648] = 0.000000000000000e+00;
    block[649] = 0.000000000000000e+00;
    block[650] = 0.000000000000000e+00;
    block[651] = 0.000000000000000e+00;
    block[652] = 0.000000000000000e+00;
    block[653] = 0.000000000000000e+00;
    block[654] = 0.000000000000000e+00;
    block[655] = 0.000000000000000e+00;
    block[656] = 3.333333333333327e-02*G1_0_1 + 3.333333333333328e-02*G1_0_2 + 3.333333333333324e-02*G1_1_1 + 3.333333333333326e-02*G1_1_2 + 3.333333333333323e-02*G1_2_1 + 3.333333333333324e-02*G1_2_2;
    block[657] = -3.333333333333329e-02*G1_0_1 - 3.333333333333327e-02*G1_0_2;
    block[658] = -3.333333333333323e-02*G1_1_1 + 9.999999999999969e-02*G1_1_2;
    block[659] = 9.999999999999970e-02*G1_2_1 - 3.333333333333327e-02*G1_2_2;
    block[660] = 1.333333333333330e-01*G1_0_1 + 2.666666666666659e-01*G1_0_2 + 1.333333333333330e-01*G1_1_1 + 1.333333333333329e-01*G1_1_2;
    block[661] = -1.333333333333331e-01*G1_0_1 - 2.666666666666661e-01*G1_0_2 - 1.333333333333331e-01*G1_1_2 - 1.333333333333330e-01*G1_2_1 - 2.666666666666659e-01*G1_2_2;
    block[662] = -1.333333333333329e-01*G1_1_1 - 1.333333333333329e-01*G1_1_2 - 1.333333333333329e-01*G1_2_1 - 1.333333333333329e-01*G1_2_2;
    block[663] = -2.666666666666659e-01*G1_0_1 - 1.333333333333330e-01*G1_0_2 - 2.666666666666659e-01*G1_1_1 - 1.333333333333330e-01*G1_1_2 - 1.333333333333330e-01*G1_2_1;
    block[664] = 2.666666666666661e-01*G1_0_1 + 1.333333333333331e-01*G1_0_2 + 1.333333333333330e-01*G1_2_1 + 1.333333333333330e-01*G1_2_2;
    block[665] = 2.666666666666660e-01*G1_1_1 + 1.333333333333331e-01*G1_1_2 + 1.333333333333331e-01*G1_2_1 + 2.666666666666659e-01*G1_2_2;
    block[666] = 0.000000000000000e+00;
    block[667] = 0.000000000000000e+00;
    block[668] = 0.000000000000000e+00;
    block[669] = 0.000000000000000e+00;
    block[670] = 0.000000000000000e+00;
    block[671] = 0.000000000000000e+00;
    block[672] = 0.000000000000000e+00;
    block[673] = 0.000000000000000e+00;
    block[674] = 0.000000000000000e+00;
    block[675] = 0.000000000000000e+00;
    block[676] = -3.333333333333326e-02*G4_1 - 3.333333333333324e-02*G4_2;
    block[677] = -3.333333333333325e-02*G4_1 - 3.333333333333325e-02*G4_2;
    block[678] = -3.333333333333326e-02*G4_1 - 6.666666666666649e-02*G4_2;
    block[679] = -6.666666666666650e-02*G4_1 - 3.333333333333326e-02*G4_2;
    block[680] = 0.000000000000000e+00;
    block[681] = 0.000000000000000e+00;
    block[682] = 0.000000000000000e+00;
    block[683] = 0.000000000000000e+00;
    block[684] = 0.000000000000000e+00;
    block[685] = 0.000000000000000e+00;
    block[686] = 0.000000000000000e+00;
    block[687] = 0.000000000000000e+00;
    block[688] = 0.000000000000000e+00;
    block[689] = 0.000000000000000e+00;
    block[690] = 0.000000000000000e+00;
    block[691] = 0.000000000000000e+00;
    block[692] = 0.000000000000000e+00;
    block[693] = 0.000000000000000e+00;
    block[694] = 0.000000000000000e+00;
    block[695] = 0.000000000000000e+00;
    block[696] = 0.000000000000000e+00;
    block[697] = 0.000000000000000e+00;
    block[698] = 0.000000000000000e+00;
    block[699] = 0.000000000000000e+00;
    block[700] = 9.999999999999977e-02*G2_0_0 + 9.999999999999976e-02*G2_0_1 + 9.999999999999977e-02*G2_0_2 + 9.999999999999976e-02*G2_1_0 + 9.999999999999974e-02*G2_1_1 + 9.999999999999976e-02*G2_1_2 + 9.999999999999977e-02*G2_2_0 + 9.999999999999974e-02*G2_2_1 + 9.999999999999976e-02*G2_2_2;
    block[701] = 3.333333333333328e-02*G2_0_0 + 3.333333333333326e-02*G2_0_1 + 3.333333333333327e-02*G2_0_2;
    block[702] = 3.333333333333325e-02*G2_1_0 + 3.333333333333325e-02*G2_1_1 + 3.333333333333325e-02*G2_1_2;
    block[703] = 3.333333333333323e-02*G2_2_0 + 3.333333333333322e-02*G2_2_1 + 3.333333333333323e-02*G2_2_2;
    block[704] = 3.333333333333329e-02*G2_0_0 + 3.333333333333327e-02*G2_0_1 + 3.333333333333326e-02*G2_0_2 + 3.333333333333333e-02*G2_1_0 + 3.333333333333329e-02*G2_1_1 + 3.333333333333329e-02*G2_1_2;
    block[705] = -3.333333333333330e-02*G2_0_0 - 3.333333333333328e-02*G2_0_1 - 3.333333333333327e-02*G2_0_2 - 1.333333333333330e-01*G2_1_0 - 1.333333333333330e-01*G2_1_1 - 1.333333333333330e-01*G2_1_2 - 3.333333333333329e-02*G2_2_0 - 3.333333333333327e-02*G2_2_1 - 3.333333333333326e-02*G2_2_2;
    block[706] = -1.333333333333330e-01*G2_0_0 - 1.333333333333330e-01*G2_0_1 - 1.333333333333330e-01*G2_0_2 - 3.333333333333331e-02*G2_1_0 - 3.333333333333328e-02*G2_1_1 - 3.333333333333328e-02*G2_1_2 - 3.333333333333333e-02*G2_2_0 - 3.333333333333329e-02*G2_2_1 - 3.333333333333329e-02*G2_2_2;
    block[707] = -3.333333333333327e-02*G2_0_0 - 3.333333333333324e-02*G2_0_1 - 3.333333333333324e-02*G2_0_2 - 3.333333333333327e-02*G2_1_0 - 3.333333333333324e-02*G2_1_1 - 3.333333333333324e-02*G2_1_2 - 1.333333333333330e-01*G2_2_0 - 1.333333333333329e-01*G2_2_1 - 1.333333333333329e-01*G2_2_2;
    block[708] = 3.333333333333327e-02*G2_0_0 + 3.333333333333324e-02*G2_0_1 + 3.333333333333324e-02*G2_0_2 + 3.333333333333333e-02*G2_2_0 + 3.333333333333329e-02*G2_2_1 + 3.333333333333330e-02*G2_2_2;
    block[709] = 3.333333333333327e-02*G2_1_0 + 3.333333333333326e-02*G2_1_1 + 3.333333333333324e-02*G2_1_2 + 3.333333333333328e-02*G2_2_0 + 3.333333333333327e-02*G2_2_1 + 3.333333333333326e-02*G2_2_2;
    block[710] = 2.499999999999993e-02*G5_0 + 2.499999999999993e-02*G5_1 + 2.499999999999993e-02*G5_2;
    block[711] = -8.333333333333326e-03*G5_0 - 8.333333333333319e-03*G5_1 - 8.333333333333319e-03*G5_2;
    block[712] = -8.333333333333323e-03*G5_0 - 8.333333333333318e-03*G5_1 - 8.333333333333316e-03*G5_2;
    block[713] = -8.333333333333318e-03*G5_0 - 8.333333333333311e-03*G5_1 - 8.333333333333311e-03*G5_2;
    block[714] = 0.000000000000000e+00;
    block[715] = 0.000000000000000e+00;
    block[716] = 0.000000000000000e+00;
    block[717] = 0.000000000000000e+00;
    block[718] = 0.000000000000000e+00;
    block[719] = 0.000000000000000e+00;
    block[720] = 0.000000000000000e+00;
    block[721] = 0.000000000000000e+00;
    block[722] = 0.000000000000000e+00;
    block[723] = 0.000000000000000e+00;
    block[724] = 0.000000000000000e+00;
    block[725] = 0.000000000000000e+00;
    block[726] = 0.000000000000000e+00;
    block[727] = 0.000000000000000e+00;
    block[728] = 0.000000000000000e+00;
    block[729] = 0.000000000000000e+00;
    block[730] = 0.000000000000000e+00;
    block[731] = 0.000000000000000e+00;
    block[732] = 0.000000000000000e+00;
    block[733] = 0.000000000000000e+00;
    block[734] = 3.333333333333328e-02*G2_0_0 + 3.333333333333326e-02*G2_1_0 + 3.333333333333328e-02*G2_2_0;
    block[735] = 9.999999999999974e-02*G2_0_0;
    block[736] = -3.333333333333322e-02*G2_1_0;
    block[737] = -3.333333333333324e-02*G2_2_0;
    block[738] = -3.333333333333325e-02*G2_0_0 + 9.999999999999974e-02*G2_1_0;
    block[739] = 3.333333333333324e-02*G2_0_0 + 3.333333333333324e-02*G2_2_0;
    block[740] = -1.333333333333331e-01*G2_0_0 - 9.999999999999974e-02*G2_1_0 - 9.999999999999974e-02*G2_2_0;
    block[741] = 3.333333333333327e-02*G2_0_0 + 3.333333333333327e-02*G2_1_0;
    block[742] = -3.333333333333328e-02*G2_0_0 + 9.999999999999974e-02*G2_2_0;
    block[743] = -3.333333333333327e-02*G2_1_0 - 3.333333333333323e-02*G2_2_0;
    block[744] = 8.333333333333319e-03*G5_0;
    block[745] = -2.499999999999993e-02*G5_0;
    block[746] = 8.333333333333311e-03*G5_0;
    block[747] = 8.333333333333314e-03*G5_0;
    block[748] = 0.000000000000000e+00;
    block[749] = 0.000000000000000e+00;
    block[750] = 0.000000000000000e+00;
    block[751] = 0.000000000000000e+00;
    block[752] = 0.000000000000000e+00;
    block[753] = 0.000000000000000e+00;
    block[754] = 0.000000000000000e+00;
    block[755] = 0.000000000000000e+00;
    block[756] = 0.000000000000000e+00;
    block[757] = 0.000000000000000e+00;
    block[758] = 0.000000000000000e+00;
    block[759] = 0.000000000000000e+00;
    block[760] = 0.000000000000000e+00;
    block[761] = 0.000000000000000e+00;
    block[762] = 0.000000000000000e+00;
    block[763] = 0.000000000000000e+00;
    block[764] = 0.000000000000000e+00;
    block[765] = 0.000000000000000e+00;
    block[766] = 0.000000000000000e+00;
    block[767] = 0.000000000000000e+00;
    block[768] = 3.333333333333325e-02*G2_0_1 + 3.333333333333325e-02*G2_1_1 + 3.333333333333325e-02*G2_2_1;
    block[769] = -3.333333333333322e-02*G2_0_1;
    block[770] = 9.999999999999971e-02*G2_1_1;
    block[771] = -3.333333333333323e-02*G2_2_1;
    block[772] = 9.999999999999973e-02*G2_0_1 - 3.333333333333323e-02*G2_1_1;
    block[773] = -9.999999999999976e-02*G2_0_1 - 1.333333333333329e-01*G2_1_1 - 9.999999999999973e-02*G2_2_1;
    block[774] = 3.333333333333322e-02*G2_1_1 + 3.333333333333324e-02*G2_2_1;
    block[775] = 3.333333333333321e-02*G2_0_1 + 3.333333333333323e-02*G2_1_1;
    block[776] = -3.333333333333322e-02*G2_0_1 - 3.333333333333323e-02*G2_2_1;
    block[777] = -3.333333333333323e-02*G2_1_1 + 9.999999999999970e-02*G2_2_1;
    block[778] = 8.333333333333312e-03*G5_1;
    block[779] = 8.333333333333304e-03*G5_1;
    block[780] = -2.499999999999993e-02*G5_1;
    block[781] = 8.333333333333307e-03*G5_1;
    block[782] = 0.000000000000000e+00;
    block[783] = 0.000000000000000e+00;
    block[784] = 0.000000000000000e+00;
    block[785] = 0.000000000000000e+00;
    block[786] = 0.000000000000000e+00;
    block[787] = 0.000000000000000e+00;
    block[788] = 0.000000000000000e+00;
    block[789] = 0.000000000000000e+00;
    block[790] = 0.000000000000000e+00;
    block[791] = 0.000000000000000e+00;
    block[792] = 0.000000000000000e+00;
    block[793] = 0.000000000000000e+00;
    block[794] = 0.000000000000000e+00;
    block[795] = 0.000000000000000e+00;
    block[796] = 0.000000000000000e+00;
    block[797] = 0.000000000000000e+00;
    block[798] = 0.000000000000000e+00;
    block[799] = 0.000000000000000e+00;
    block[800] = 0.000000000000000e+00;
    block[801] = 0.000000000000000e+00;
    block[802] = 3.333333333333323e-02*G2_0_2 + 3.333333333333322e-02*G2_1_2 + 3.333333333333323e-02*G2_2_2;
    block[803] = -3.333333333333324e-02*G2_0_2;
    block[804] = -3.333333333333323e-02*G2_1_2;
    block[805] = 9.999999999999969e-02*G2_2_2;
    block[806] = -3.333333333333320e-02*G2_0_2 - 3.333333333333321e-02*G2_1_2;
    block[807] = 3.333333333333321e-02*G2_0_2 + 3.333333333333319e-02*G2_2_2;
    block[808] = 3.333333333333321e-02*G2_1_2 + 3.333333333333319e-02*G2_2_2;
    block[809] = -9.999999999999973e-02*G2_0_2 - 9.999999999999973e-02*G2_1_2 - 1.333333333333329e-01*G2_2_2;
    block[810] = 9.999999999999973e-02*G2_0_2 - 3.333333333333321e-02*G2_2_2;
    block[811] = 9.999999999999973e-02*G2_1_2 - 3.333333333333319e-02*G2_2_2;
    block[812] = 8.333333333333297e-03*G5_2;
    block[813] = 8.333333333333299e-03*G5_2;
    block[814] = 8.333333333333300e-03*G5_2;
    block[815] = -2.499999999999993e-02*G5_2;
    block[816] = 0.000000000000000e+00;
    block[817] = 0.000000000000000e+00;
    block[818] = 0.000000000000000e+00;
    block[819] = 0.000000000000000e+00;
    block[820] = 0.000000000000000e+00;
    block[821] = 0.000000000000000e+00;
    block[822] = 0.000000000000000e+00;
    block[823] = 0.000000000000000e+00;
    block[824] = 0.000000000000000e+00;
    block[825] = 0.000000000000000e+00;
    block[826] = 0.000000000000000e+00;
    block[827] = 0.000000000000000e+00;
    block[828] = 0.000000000000000e+00;
    block[829] = 0.000000000000000e+00;
    block[830] = 0.000000000000000e+00;
    block[831] = 0.000000000000000e+00;
    block[832] = 0.000000000000000e+00;
    block[833] = 0.000000000000000e+00;
    block[834] = 0.000000000000000e+00;
    block[835] = 0.000000000000000e+00;
    block[836] = 3.333333333333328e-02*G2_0_0 + 3.333333333333333e-02*G2_0_1 + 3.333333333333327e-02*G2_1_0 + 3.333333333333328e-02*G2_1_1 + 3.333333333333326e-02*G2_2_0 + 3.333333333333330e-02*G2_2_1;
    block[837] = -3.333333333333325e-02*G2_0_0 + 9.999999999999974e-02*G2_0_1;
    block[838] = 9.999999999999973e-02*G2_1_0 - 3.333333333333323e-02*G2_1_1;
    block[839] = -3.333333333333320e-02*G2_2_0 - 3.333333333333321e-02*G2_2_1;
    block[840] = 2.666666666666661e-01*G2_0_0 + 1.333333333333331e-01*G2_0_1 + 1.333333333333331e-01*G2_1_0 + 2.666666666666661e-01*G2_1_1;
    block[841] = -2.666666666666661e-01*G2_0_0 - 1.333333333333330e-01*G2_0_1 - 1.333333333333331e-01*G2_1_0 - 2.666666666666660e-01*G2_2_0 - 1.333333333333330e-01*G2_2_1;
    block[842] = -1.333333333333331e-01*G2_0_1 - 1.333333333333329e-01*G2_1_0 - 2.666666666666659e-01*G2_1_1 - 1.333333333333329e-01*G2_2_0 - 2.666666666666659e-01*G2_2_1;
    block[843] = -1.333333333333331e-01*G2_0_0 - 1.333333333333330e-01*G2_0_1 - 1.333333333333331e-01*G2_1_0 - 1.333333333333330e-01*G2_1_1;
    block[844] = 1.333333333333331e-01*G2_0_0 + 1.333333333333331e-01*G2_0_1 + 1.333333333333331e-01*G2_2_0 + 2.666666666666661e-01*G2_2_1;
    block[845] = 1.333333333333331e-01*G2_1_0 + 1.333333333333330e-01*G2_1_1 + 2.666666666666659e-01*G2_2_0 + 1.333333333333330e-01*G2_2_1;
    block[846] = -3.333333333333324e-02*G5_0 - 3.333333333333324e-02*G5_1;
    block[847] = -3.333333333333325e-02*G5_0 - 6.666666666666649e-02*G5_1;
    block[848] = -6.666666666666650e-02*G5_0 - 3.333333333333325e-02*G5_1;
    block[849] = -3.333333333333326e-02*G5_0 - 3.333333333333325e-02*G5_1;
    block[850] = 0.000000000000000e+00;
    block[851] = 0.000000000000000e+00;
    block[852] = 0.000000000000000e+00;
    block[853] = 0.000000000000000e+00;
    block[854] = 0.000000000000000e+00;
    block[855] = 0.000000000000000e+00;
    block[856] = 0.000000000000000e+00;
    block[857] = 0.000000000000000e+00;
    block[858] = 0.000000000000000e+00;
    block[859] = 0.000000000000000e+00;
    block[860] = 0.000000000000000e+00;
    block[861] = 0.000000000000000e+00;
    block[862] = 0.000000000000000e+00;
    block[863] = 0.000000000000000e+00;
    block[864] = 0.000000000000000e+00;
    block[865] = 0.000000000000000e+00;
    block[866] = 0.000000000000000e+00;
    block[867] = 0.000000000000000e+00;
    block[868] = 0.000000000000000e+00;
    block[869] = 0.000000000000000e+00;
    block[870] = -3.333333333333328e-02*G2_0_0 - 1.333333333333330e-01*G2_0_1 - 3.333333333333329e-02*G2_0_2 - 3.333333333333327e-02*G2_1_0 - 1.333333333333330e-01*G2_1_1 - 3.333333333333327e-02*G2_1_2 - 3.333333333333326e-02*G2_2_0 - 1.333333333333330e-01*G2_2_1 - 3.333333333333327e-02*G2_2_2;
    block[871] = 3.333333333333324e-02*G2_0_0 + 3.333333333333324e-02*G2_0_2;
    block[872] = -9.999999999999973e-02*G2_1_0 - 1.333333333333329e-01*G2_1_1 - 9.999999999999973e-02*G2_1_2;
    block[873] = 3.333333333333320e-02*G2_2_0 + 3.333333333333319e-02*G2_2_2;
    block[874] = -2.666666666666661e-01*G2_0_0 - 1.333333333333330e-01*G2_0_1 - 2.666666666666660e-01*G2_0_2 - 1.333333333333330e-01*G2_1_0 - 1.333333333333330e-01*G2_1_2;
    block[875] = 2.666666666666660e-01*G2_0_0 + 1.333333333333331e-01*G2_0_1 + 2.666666666666660e-01*G2_0_2 + 1.333333333333331e-01*G2_1_0 + 2.666666666666659e-01*G2_1_1 + 1.333333333333330e-01*G2_1_2 + 2.666666666666659e-01*G2_2_0 + 1.333333333333330e-01*G2_2_1 + 2.666666666666659e-01*G2_2_2;
    block[876] = 1.333333333333330e-01*G2_0_1 + 1.333333333333329e-01*G2_1_0 + 1.333333333333329e-01*G2_1_2 + 1.333333333333329e-01*G2_2_0 + 1.333333333333329e-01*G2_2_2;
    block[877] = 1.333333333333331e-01*G2_0_0 + 1.333333333333331e-01*G2_0_2 + 1.333333333333330e-01*G2_1_0 + 1.333333333333330e-01*G2_1_2 + 1.333333333333329e-01*G2_2_1;
    block[878] = -1.333333333333331e-01*G2_0_0 - 1.333333333333331e-01*G2_0_2 - 1.333333333333330e-01*G2_2_0 - 1.333333333333330e-01*G2_2_2;
    block[879] = -1.333333333333330e-01*G2_1_0 - 1.333333333333330e-01*G2_1_2 - 2.666666666666659e-01*G2_2_0 - 1.333333333333330e-01*G2_2_1 - 2.666666666666659e-01*G2_2_2;
    block[880] = 3.333333333333324e-02*G5_0 - 3.333333333333322e-02*G5_1 + 3.333333333333323e-02*G5_2;
    block[881] = 3.333333333333325e-02*G5_0 + 3.333333333333324e-02*G5_2;
    block[882] = 6.666666666666649e-02*G5_0 + 3.333333333333326e-02*G5_1 + 6.666666666666649e-02*G5_2;
    block[883] = 3.333333333333325e-02*G5_0 + 3.333333333333325e-02*G5_2;
    block[884] = 0.000000000000000e+00;
    block[885] = 0.000000000000000e+00;
    block[886] = 0.000000000000000e+00;
    block[887] = 0.000000000000000e+00;
    block[888] = 0.000000000000000e+00;
    block[889] = 0.000000000000000e+00;
    block[890] = 0.000000000000000e+00;
    block[891] = 0.000000000000000e+00;
    block[892] = 0.000000000000000e+00;
    block[893] = 0.000000000000000e+00;
    block[894] = 0.000000000000000e+00;
    block[895] = 0.000000000000000e+00;
    block[896] = 0.000000000000000e+00;
    block[897] = 0.000000000000000e+00;
    block[898] = 0.000000000000000e+00;
    block[899] = 0.000000000000000e+00;
    block[900] = 0.000000000000000e+00;
    block[901] = 0.000000000000000e+00;
    block[902] = 0.000000000000000e+00;
    block[903] = 0.000000000000000e+00;
    block[904] = -1.333333333333331e-01*G2_0_0 - 3.333333333333331e-02*G2_0_1 - 3.333333333333333e-02*G2_0_2 - 1.333333333333330e-01*G2_1_0 - 3.333333333333327e-02*G2_1_1 - 3.333333333333328e-02*G2_1_2 - 1.333333333333330e-01*G2_2_0 - 3.333333333333328e-02*G2_2_1 - 3.333333333333329e-02*G2_2_2;
    block[905] = -1.333333333333331e-01*G2_0_0 - 9.999999999999974e-02*G2_0_1 - 9.999999999999974e-02*G2_0_2;
    block[906] = 3.333333333333322e-02*G2_1_1 + 3.333333333333322e-02*G2_1_2;
    block[907] = 3.333333333333321e-02*G2_2_1 + 3.333333333333319e-02*G2_2_2;
    block[908] = -1.333333333333330e-01*G2_0_1 - 1.333333333333329e-01*G2_0_2 - 1.333333333333331e-01*G2_1_0 - 2.666666666666659e-01*G2_1_1 - 2.666666666666659e-01*G2_1_2;
    block[909] = 1.333333333333329e-01*G2_0_1 + 1.333333333333329e-01*G2_0_2 + 1.333333333333330e-01*G2_1_0 + 1.333333333333329e-01*G2_2_1 + 1.333333333333329e-01*G2_2_2;
    block[910] = 2.666666666666662e-01*G2_0_0 + 1.333333333333330e-01*G2_0_1 + 1.333333333333330e-01*G2_0_2 + 1.333333333333330e-01*G2_1_0 + 2.666666666666658e-01*G2_1_1 + 2.666666666666658e-01*G2_1_2 + 1.333333333333331e-01*G2_2_0 + 2.666666666666658e-01*G2_2_1 + 2.666666666666658e-01*G2_2_2;
    block[911] = 1.333333333333329e-01*G2_0_1 + 1.333333333333330e-01*G2_0_2 + 1.333333333333329e-01*G2_1_1 + 1.333333333333329e-01*G2_1_2 + 1.333333333333330e-01*G2_2_0;
    block[912] = -1.333333333333330e-01*G2_0_1 - 1.333333333333330e-01*G2_0_2 - 1.333333333333331e-01*G2_2_0 - 2.666666666666659e-01*G2_2_1 - 2.666666666666659e-01*G2_2_2;
    block[913] = -1.333333333333329e-01*G2_1_1 - 1.333333333333329e-01*G2_1_2 - 1.333333333333329e-01*G2_2_1 - 1.333333333333329e-01*G2_2_2;
    block[914] = -3.333333333333324e-02*G5_0 + 3.333333333333322e-02*G5_1 + 3.333333333333322e-02*G5_2;
    block[915] = 3.333333333333326e-02*G5_0 + 6.666666666666646e-02*G5_1 + 6.666666666666646e-02*G5_2;
    block[916] = 3.333333333333323e-02*G5_1 + 3.333333333333322e-02*G5_2;
    block[917] = 3.333333333333323e-02*G5_1 + 3.333333333333323e-02*G5_2;
    block[918] = 0.000000000000000e+00;
    block[919] = 0.000000000000000e+00;
    block[920] = 0.000000000000000e+00;
    block[921] = 0.000000000000000e+00;
    block[922] = 0.000000000000000e+00;
    block[923] = 0.000000000000000e+00;
    block[924] = 0.000000000000000e+00;
    block[925] = 0.000000000000000e+00;
    block[926] = 0.000000000000000e+00;
    block[927] = 0.000000000000000e+00;
    block[928] = 0.000000000000000e+00;
    block[929] = 0.000000000000000e+00;
    block[930] = 0.000000000000000e+00;
    block[931] = 0.000000000000000e+00;
    block[932] = 0.000000000000000e+00;
    block[933] = 0.000000000000000e+00;
    block[934] = 0.000000000000000e+00;
    block[935] = 0.000000000000000e+00;
    block[936] = 0.000000000000000e+00;
    block[937] = 0.000000000000000e+00;
    block[938] = -3.333333333333327e-02*G2_0_0 - 3.333333333333327e-02*G2_0_1 - 1.333333333333330e-01*G2_0_2 - 3.333333333333324e-02*G2_1_0 - 3.333333333333324e-02*G2_1_1 - 1.333333333333329e-01*G2_1_2 - 3.333333333333324e-02*G2_2_0 - 3.333333333333325e-02*G2_2_1 - 1.333333333333330e-01*G2_2_2;
    block[939] = 3.333333333333327e-02*G2_0_0 + 3.333333333333326e-02*G2_0_1;
    block[940] = 3.333333333333321e-02*G2_1_0 + 3.333333333333323e-02*G2_1_1;
    block[941] = -9.999999999999973e-02*G2_2_0 - 9.999999999999973e-02*G2_2_1 - 1.333333333333329e-01*G2_2_2;
    block[942] = -1.333333333333331e-01*G2_0_0 - 1.333333333333331e-01*G2_0_1 - 1.333333333333330e-01*G2_1_0 - 1.333333333333331e-01*G2_1_1;
    block[943] = 1.333333333333331e-01*G2_0_0 + 1.333333333333331e-01*G2_0_1 + 1.333333333333329e-01*G2_1_2 + 1.333333333333331e-01*G2_2_0 + 1.333333333333330e-01*G2_2_1;
    block[944] = 1.333333333333330e-01*G2_0_2 + 1.333333333333329e-01*G2_1_0 + 1.333333333333329e-01*G2_1_1 + 1.333333333333330e-01*G2_2_0 + 1.333333333333329e-01*G2_2_1;
    block[945] = 2.666666666666661e-01*G2_0_0 + 2.666666666666661e-01*G2_0_1 + 1.333333333333330e-01*G2_0_2 + 2.666666666666661e-01*G2_1_0 + 2.666666666666661e-01*G2_1_1 + 1.333333333333330e-01*G2_1_2 + 1.333333333333330e-01*G2_2_0 + 1.333333333333330e-01*G2_2_1 + 2.666666666666659e-01*G2_2_2;
    block[946] = -2.666666666666662e-01*G2_0_0 - 2.666666666666662e-01*G2_0_1 - 1.333333333333330e-01*G2_0_2 - 1.333333333333330e-01*G2_2_0 - 1.333333333333331e-01*G2_2_1;
    block[947] = -2.666666666666661e-01*G2_1_0 - 2.666666666666661e-01*G2_1_1 - 1.333333333333330e-01*G2_1_2 - 1.333333333333330e-01*G2_2_0 - 1.333333333333330e-01*G2_2_1;
    block[948] = 3.333333333333326e-02*G5_0 + 3.333333333333326e-02*G5_1 - 3.333333333333321e-02*G5_2;
    block[949] = 3.333333333333325e-02*G5_0 + 3.333333333333326e-02*G5_1;
    block[950] = 3.333333333333326e-02*G5_0 + 3.333333333333326e-02*G5_1;
    block[951] = 6.666666666666650e-02*G5_0 + 6.666666666666650e-02*G5_1 + 3.333333333333325e-02*G5_2;
    block[952] = 0.000000000000000e+00;
    block[953] = 0.000000000000000e+00;
    block[954] = 0.000000000000000e+00;
    block[955] = 0.000000000000000e+00;
    block[956] = 0.000000000000000e+00;
    block[957] = 0.000000000000000e+00;
    block[958] = 0.000000000000000e+00;
    block[959] = 0.000000000000000e+00;
    block[960] = 0.000000000000000e+00;
    block[961] = 0.000000000000000e+00;
    block[962] = 0.000000000000000e+00;
    block[963] = 0.000000000000000e+00;
    block[964] = 0.000000000000000e+00;
    block[965] = 0.000000000000000e+00;
    block[966] = 0.000000000000000e+00;
    block[967] = 0.000000000000000e+00;
    block[968] = 0.000000000000000e+00;
    block[969] = 0.000000000000000e+00;
    block[970] = 0.000000000000000e+00;
    block[971] = 0.000000000000000e+00;
    block[972] = 3.333333333333328e-02*G2_0_0 + 3.333333333333333e-02*G2_0_2 + 3.333333333333326e-02*G2_1_0 + 3.333333333333328e-02*G2_1_2 + 3.333333333333326e-02*G2_2_0 + 3.333333333333330e-02*G2_2_2;
    block[973] = -3.333333333333328e-02*G2_0_0 + 9.999999999999974e-02*G2_0_2;
    block[974] = -3.333333333333322e-02*G2_1_0 - 3.333333333333324e-02*G2_1_2;
    block[975] = 9.999999999999974e-02*G2_2_0 - 3.333333333333321e-02*G2_2_2;
    block[976] = 1.333333333333331e-01*G2_0_0 + 1.333333333333331e-01*G2_0_2 + 1.333333333333331e-01*G2_1_0 + 2.666666666666661e-01*G2_1_2;
    block[977] = -1.333333333333331e-01*G2_0_0 - 1.333333333333330e-01*G2_0_2 - 1.333333333333331e-01*G2_2_0 - 1.333333333333330e-01*G2_2_2;
    block[978] = -1.333333333333331e-01*G2_0_2 - 1.333333333333330e-01*G2_1_0 - 2.666666666666659e-01*G2_1_2 - 1.333333333333330e-01*G2_2_0 - 2.666666666666659e-01*G2_2_2;
    block[979] = -2.666666666666662e-01*G2_0_0 - 1.333333333333330e-01*G2_0_2 - 2.666666666666662e-01*G2_1_0 - 1.333333333333331e-01*G2_1_2 - 1.333333333333331e-01*G2_2_0;
    block[980] = 2.666666666666662e-01*G2_0_0 + 1.333333333333331e-01*G2_0_2 + 1.333333333333331e-01*G2_2_0 + 2.666666666666661e-01*G2_2_2;
    block[981] = 2.666666666666662e-01*G2_1_0 + 1.333333333333330e-01*G2_1_2 + 1.333333333333330e-01*G2_2_0 + 1.333333333333330e-01*G2_2_2;
    block[982] = -3.333333333333326e-02*G5_0 - 3.333333333333324e-02*G5_2;
    block[983] = -3.333333333333326e-02*G5_0 - 6.666666666666649e-02*G5_2;
    block[984] = -3.333333333333327e-02*G5_0 - 3.333333333333324e-02*G5_2;
    block[985] = -6.666666666666651e-02*G5_0 - 3.333333333333326e-02*G5_2;
    block[986] = 0.000000000000000e+00;
    block[987] = 0.000000000000000e+00;
    block[988] = 0.000000000000000e+00;
    block[989] = 0.000000000000000e+00;
    block[990] = 0.000000000000000e+00;
    block[991] = 0.000000000000000e+00;
    block[992] = 0.000000000000000e+00;
    block[993] = 0.000000000000000e+00;
    block[994] = 0.000000000000000e+00;
    block[995] = 0.000000000000000e+00;
    block[996] = 0.000000000000000e+00;
    block[997] = 0.000000000000000e+00;
    block[998] = 0.000000000000000e+00;
    block[999] = 0.000000000000000e+00;
    block[1000] = 0.000000000000000e+00;
    block[1001] = 0.000000000000000e+00;
    block[1002] = 0.000000000000000e+00;
    block[1003] = 0.000000000000000e+00;
    block[1004] = 0.000000000000000e+00;
    block[1005] = 0.000000000000000e+00;
    block[1006] = 3.333333333333328e-02*G2_0_1 + 3.333333333333328e-02*G2_0_2 + 3.333333333333326e-02*G2_1_1 + 3.333333333333327e-02*G2_1_2 + 3.333333333333325e-02*G2_2_1 + 3.333333333333326e-02*G2_2_2;
    block[1007] = -3.333333333333327e-02*G2_0_1 - 3.333333333333323e-02*G2_0_2;
    block[1008] = -3.333333333333323e-02*G2_1_1 + 9.999999999999970e-02*G2_1_2;
    block[1009] = 9.999999999999973e-02*G2_2_1 - 3.333333333333318e-02*G2_2_2;
    block[1010] = 1.333333333333331e-01*G2_0_1 + 2.666666666666659e-01*G2_0_2 + 1.333333333333330e-01*G2_1_1 + 1.333333333333329e-01*G2_1_2;
    block[1011] = -1.333333333333331e-01*G2_0_1 - 2.666666666666659e-01*G2_0_2 - 1.333333333333330e-01*G2_1_2 - 1.333333333333330e-01*G2_2_1 - 2.666666666666659e-01*G2_2_2;
    block[1012] = -1.333333333333329e-01*G2_1_1 - 1.333333333333329e-01*G2_1_2 - 1.333333333333329e-01*G2_2_1 - 1.333333333333329e-01*G2_2_2;
    block[1013] = -2.666666666666661e-01*G2_0_1 - 1.333333333333330e-01*G2_0_2 - 2.666666666666660e-01*G2_1_1 - 1.333333333333330e-01*G2_1_2 - 1.333333333333330e-01*G2_2_1;
    block[1014] = 2.666666666666662e-01*G2_0_1 + 1.333333333333330e-01*G2_0_2 + 1.333333333333330e-01*G2_2_1 + 1.333333333333329e-01*G2_2_2;
    block[1015] = 2.666666666666661e-01*G2_1_1 + 1.333333333333330e-01*G2_1_2 + 1.333333333333330e-01*G2_2_1 + 2.666666666666658e-01*G2_2_2;
    block[1016] = -3.333333333333326e-02*G5_1 - 3.333333333333322e-02*G5_2;
    block[1017] = -3.333333333333326e-02*G5_1 - 3.333333333333324e-02*G5_2;
    block[1018] = -3.333333333333326e-02*G5_1 - 6.666666666666647e-02*G5_2;
    block[1019] = -6.666666666666650e-02*G5_1 - 3.333333333333324e-02*G5_2;
    block[1020] = -2.499999999999993e-02*G6_0 - 2.499999999999993e-02*G6_1 - 2.499999999999993e-02*G6_2;
    block[1021] = -8.333333333333319e-03*G6_0;
    block[1022] = -8.333333333333311e-03*G6_1;
    block[1023] = -8.333333333333311e-03*G6_2;
    block[1024] = 3.333333333333323e-02*G6_0 + 3.333333333333323e-02*G6_1;
    block[1025] = -3.333333333333324e-02*G6_0 + 3.333333333333322e-02*G6_1 - 3.333333333333323e-02*G6_2;
    block[1026] = 3.333333333333324e-02*G6_0 - 3.333333333333323e-02*G6_1 - 3.333333333333321e-02*G6_2;
    block[1027] = -3.333333333333326e-02*G6_0 - 3.333333333333325e-02*G6_1 + 3.333333333333323e-02*G6_2;
    block[1028] = 3.333333333333326e-02*G6_0 + 3.333333333333324e-02*G6_2;
    block[1029] = 3.333333333333326e-02*G6_1 + 3.333333333333323e-02*G6_2;
    block[1030] = -2.499999999999993e-02*G7_0 - 2.499999999999993e-02*G7_1 - 2.499999999999993e-02*G7_2;
    block[1031] = -8.333333333333323e-03*G7_0;
    block[1032] = -8.333333333333309e-03*G7_1;
    block[1033] = -8.333333333333311e-03*G7_2;
    block[1034] = 3.333333333333322e-02*G7_0 + 3.333333333333323e-02*G7_1;
    block[1035] = -3.333333333333325e-02*G7_0 + 3.333333333333322e-02*G7_1 - 3.333333333333323e-02*G7_2;
    block[1036] = 3.333333333333324e-02*G7_0 - 3.333333333333322e-02*G7_1 - 3.333333333333322e-02*G7_2;
    block[1037] = -3.333333333333324e-02*G7_0 - 3.333333333333324e-02*G7_1 + 3.333333333333324e-02*G7_2;
    block[1038] = 3.333333333333326e-02*G7_0 + 3.333333333333324e-02*G7_2;
    block[1039] = 3.333333333333326e-02*G7_1 + 3.333333333333324e-02*G7_2;
    block[1040] = -2.499999999999993e-02*G8_0 - 2.499999999999993e-02*G8_1 - 2.499999999999993e-02*G8_2;
    block[1041] = -8.333333333333319e-03*G8_0;
    block[1042] = -8.333333333333309e-03*G8_1;
    block[1043] = -8.333333333333297e-03*G8_2;
    block[1044] = 3.333333333333324e-02*G8_0 + 3.333333333333324e-02*G8_1;
    block[1045] = -3.333333333333324e-02*G8_0 + 3.333333333333322e-02*G8_1 - 3.333333333333323e-02*G8_2;
    block[1046] = 3.333333333333324e-02*G8_0 - 3.333333333333322e-02*G8_1 - 3.333333333333322e-02*G8_2;
    block[1047] = -3.333333333333326e-02*G8_0 - 3.333333333333326e-02*G8_1 + 3.333333333333321e-02*G8_2;
    block[1048] = 3.333333333333326e-02*G8_0 + 3.333333333333324e-02*G8_2;
    block[1049] = 3.333333333333326e-02*G8_1 + 3.333333333333322e-02*G8_2;
    block[1050] = 0.000000000000000e+00;
    block[1051] = 0.000000000000000e+00;
    block[1052] = 0.000000000000000e+00;
    block[1053] = 0.000000000000000e+00;
    block[1054] = 8.333333333333330e-03*G6_0 + 8.333333333333323e-03*G6_1 + 8.333333333333318e-03*G6_2;
    block[1055] = 2.499999999999992e-02*G6_0;
    block[1056] = -8.333333333333305e-03*G6_1;
    block[1057] = -8.333333333333312e-03*G6_2;
    block[1058] = 3.333333333333324e-02*G6_0 + 6.666666666666646e-02*G6_1;
    block[1059] = -3.333333333333326e-02*G6_0 - 3.333333333333325e-02*G6_2;
    block[1060] = -3.333333333333325e-02*G6_0 - 6.666666666666646e-02*G6_1 - 6.666666666666646e-02*G6_2;
    block[1061] = -3.333333333333326e-02*G6_0 - 3.333333333333325e-02*G6_1;
    block[1062] = 3.333333333333326e-02*G6_0 + 6.666666666666649e-02*G6_2;
    block[1063] = 3.333333333333326e-02*G6_1 + 3.333333333333324e-02*G6_2;
    block[1064] = 8.333333333333325e-03*G7_0 + 8.333333333333321e-03*G7_1 + 8.333333333333316e-03*G7_2;
    block[1065] = 2.499999999999991e-02*G7_0;
    block[1066] = -8.333333333333302e-03*G7_1;
    block[1067] = -8.333333333333312e-03*G7_2;
    block[1068] = 3.333333333333324e-02*G7_0 + 6.666666666666646e-02*G7_1;
    block[1069] = -3.333333333333326e-02*G7_0 - 3.333333333333324e-02*G7_2;
    block[1070] = -3.333333333333325e-02*G7_0 - 6.666666666666646e-02*G7_1 - 6.666666666666646e-02*G7_2;
    block[1071] = -3.333333333333324e-02*G7_0 - 3.333333333333324e-02*G7_1;
    block[1072] = 3.333333333333326e-02*G7_0 + 6.666666666666649e-02*G7_2;
    block[1073] = 3.333333333333325e-02*G7_1 + 3.333333333333325e-02*G7_2;
    block[1074] = 8.333333333333328e-03*G8_0 + 8.333333333333318e-03*G8_1 + 8.333333333333319e-03*G8_2;
    block[1075] = 2.499999999999993e-02*G8_0;
    block[1076] = -8.333333333333304e-03*G8_1;
    block[1077] = -8.333333333333297e-03*G8_2;
    block[1078] = 3.333333333333326e-02*G8_0 + 6.666666666666649e-02*G8_1;
    block[1079] = -3.333333333333325e-02*G8_0 - 3.333333333333324e-02*G8_2;
    block[1080] = -3.333333333333325e-02*G8_0 - 6.666666666666646e-02*G8_1 - 6.666666666666646e-02*G8_2;
    block[1081] = -3.333333333333325e-02*G8_0 - 3.333333333333326e-02*G8_1;
    block[1082] = 3.333333333333326e-02*G8_0 + 6.666666666666649e-02*G8_2;
    block[1083] = 3.333333333333326e-02*G8_1 + 3.333333333333324e-02*G8_2;
    block[1084] = 0.000000000000000e+00;
    block[1085] = 0.000000000000000e+00;
    block[1086] = 0.000000000000000e+00;
    block[1087] = 0.000000000000000e+00;
    block[1088] = 8.333333333333326e-03*G6_0 + 8.333333333333319e-03*G6_1 + 8.333333333333316e-03*G6_2;
    block[1089] = -8.333333333333316e-03*G6_0;
    block[1090] = 2.499999999999993e-02*G6_1;
    block[1091] = -8.333333333333321e-03*G6_2;
    block[1092] = 6.666666666666647e-02*G6_0 + 3.333333333333324e-02*G6_1;
    block[1093] = -6.666666666666650e-02*G6_0 - 3.333333333333325e-02*G6_1 - 6.666666666666649e-02*G6_2;
    block[1094] = -3.333333333333324e-02*G6_1 - 3.333333333333323e-02*G6_2;
    block[1095] = -3.333333333333326e-02*G6_0 - 3.333333333333325e-02*G6_1;
    block[1096] = 3.333333333333326e-02*G6_0 + 3.333333333333326e-02*G6_2;
    block[1097] = 3.333333333333326e-02*G6_1 + 6.666666666666649e-02*G6_2;
    block[1098] = 8.333333333333321e-03*G7_0 + 8.333333333333316e-03*G7_1 + 8.333333333333309e-03*G7_2;
    block[1099] = -8.333333333333316e-03*G7_0;
    block[1100] = 2.499999999999992e-02*G7_1;
    block[1101] = -8.333333333333321e-03*G7_2;
    block[1102] = 6.666666666666647e-02*G7_0 + 3.333333333333324e-02*G7_1;
    block[1103] = -6.666666666666651e-02*G7_0 - 3.333333333333326e-02*G7_1 - 6.666666666666649e-02*G7_2;
    block[1104] = -3.333333333333323e-02*G7_1 - 3.333333333333322e-02*G7_2;
    block[1105] = -3.333333333333324e-02*G7_0 - 3.333333333333324e-02*G7_1;
    block[1106] = 3.333333333333326e-02*G7_0 + 3.333333333333326e-02*G7_2;
    block[1107] = 3.333333333333326e-02*G7_1 + 6.666666666666649e-02*G7_2;
    block[1108] = 8.333333333333323e-03*G8_0 + 8.333333333333318e-03*G8_1 + 8.333333333333318e-03*G8_2;
    block[1109] = -8.333333333333311e-03*G8_0;
    block[1110] = 2.499999999999993e-02*G8_1;
    block[1111] = -8.333333333333300e-03*G8_2;
    block[1112] = 6.666666666666650e-02*G8_0 + 3.333333333333325e-02*G8_1;
    block[1113] = -6.666666666666650e-02*G8_0 - 3.333333333333326e-02*G8_1 - 6.666666666666649e-02*G8_2;
    block[1114] = -3.333333333333323e-02*G8_1 - 3.333333333333322e-02*G8_2;
    block[1115] = -3.333333333333326e-02*G8_0 - 3.333333333333326e-02*G8_1;
    block[1116] = 3.333333333333326e-02*G8_0 + 3.333333333333324e-02*G8_2;
    block[1117] = 3.333333333333326e-02*G8_1 + 6.666666666666647e-02*G8_2;
    block[1118] = 0.000000000000000e+00;
    block[1119] = 0.000000000000000e+00;
    block[1120] = 0.000000000000000e+00;
    block[1121] = 0.000000000000000e+00;
    block[1122] = 8.333333333333318e-03*G6_0 + 8.333333333333314e-03*G6_1 + 8.333333333333311e-03*G6_2;
    block[1123] = -8.333333333333319e-03*G6_0;
    block[1124] = -8.333333333333307e-03*G6_1;
    block[1125] = 2.499999999999992e-02*G6_2;
    block[1126] = 3.333333333333324e-02*G6_0 + 3.333333333333324e-02*G6_1;
    block[1127] = -3.333333333333326e-02*G6_0 - 3.333333333333326e-02*G6_2;
    block[1128] = -3.333333333333324e-02*G6_1 - 3.333333333333324e-02*G6_2;
    block[1129] = -6.666666666666650e-02*G6_0 - 6.666666666666649e-02*G6_1 - 3.333333333333324e-02*G6_2;
    block[1130] = 6.666666666666650e-02*G6_0 + 3.333333333333326e-02*G6_2;
    block[1131] = 6.666666666666650e-02*G6_1 + 3.333333333333324e-02*G6_2;
    block[1132] = 8.333333333333312e-03*G7_0 + 8.333333333333311e-03*G7_1 + 8.333333333333305e-03*G7_2;
    block[1133] = -8.333333333333321e-03*G7_0;
    block[1134] = -8.333333333333304e-03*G7_1;
    block[1135] = 2.499999999999992e-02*G7_2;
    block[1136] = 3.333333333333324e-02*G7_0 + 3.333333333333324e-02*G7_1;
    block[1137] = -3.333333333333328e-02*G7_0 - 3.333333333333325e-02*G7_2;
    block[1138] = -3.333333333333323e-02*G7_1 - 3.333333333333323e-02*G7_2;
    block[1139] = -6.666666666666647e-02*G7_0 - 6.666666666666646e-02*G7_1 - 3.333333333333324e-02*G7_2;
    block[1140] = 6.666666666666650e-02*G7_0 + 3.333333333333326e-02*G7_2;
    block[1141] = 6.666666666666650e-02*G7_1 + 3.333333333333326e-02*G7_2;
    block[1142] = 8.333333333333318e-03*G8_0 + 8.333333333333311e-03*G8_1 + 8.333333333333311e-03*G8_2;
    block[1143] = -8.333333333333314e-03*G8_0;
    block[1144] = -8.333333333333304e-03*G8_1;
    block[1145] = 2.499999999999993e-02*G8_2;
    block[1146] = 3.333333333333326e-02*G8_0 + 3.333333333333325e-02*G8_1;
    block[1147] = -3.333333333333325e-02*G8_0 - 3.333333333333325e-02*G8_2;
    block[1148] = -3.333333333333323e-02*G8_1 - 3.333333333333323e-02*G8_2;
    block[1149] = -6.666666666666650e-02*G8_0 - 6.666666666666650e-02*G8_1 - 3.333333333333325e-02*G8_2;
    block[1150] = 6.666666666666651e-02*G8_0 + 3.333333333333326e-02*G8_2;
    block[1151] = 6.666666666666650e-02*G8_1 + 3.333333333333324e-02*G8_2;
    block[1152] = 0.000000000000000e+00;
    block[1153] = 0.000000000000000e+00;
    block[1154] = 0.000000000000000e+00;
    block[1155] = 0.000000000000000e+00;
  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 4;
  
      subelements = new FiniteElement* [2];
      subelements[0] = new SubElement_0();
      subelements[1] = new SubElement_1();
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 34;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 2;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.edgeID(0);
      dofs[5] = offset + cell.edgeID(1);
      dofs[6] = offset + cell.edgeID(2);
      dofs[7] = offset + cell.edgeID(3);
      dofs[8] = offset + cell.edgeID(4);
      dofs[9] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[10] = offset + cell.vertexID(0);
      dofs[11] = offset + cell.vertexID(1);
      dofs[12] = offset + cell.vertexID(2);
      dofs[13] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[14] = offset + cell.edgeID(0);
      dofs[15] = offset + cell.edgeID(1);
      dofs[16] = offset + cell.edgeID(2);
      dofs[17] = offset + cell.edgeID(3);
      dofs[18] = offset + cell.edgeID(4);
      dofs[19] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[20] = offset + cell.vertexID(0);
      dofs[21] = offset + cell.vertexID(1);
      dofs[22] = offset + cell.vertexID(2);
      dofs[23] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[24] = offset + cell.edgeID(0);
      dofs[25] = offset + cell.edgeID(1);
      dofs[26] = offset + cell.edgeID(2);
      dofs[27] = offset + cell.edgeID(3);
      dofs[28] = offset + cell.edgeID(4);
      dofs[29] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[30] = offset + cell.vertexID(0);
      dofs[31] = offset + cell.vertexID(1);
      dofs[32] = offset + cell.vertexID(2);
      dofs[33] = offset + cell.vertexID(3);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 1;
      components[11] = 1;
      components[12] = 1;
      components[13] = 1;
      components[14] = 1;
      components[15] = 1;
      components[16] = 1;
      components[17] = 1;
      components[18] = 1;
      components[19] = 1;
      components[20] = 2;
      components[21] = 2;
      components[22] = 2;
      components[23] = 2;
      components[24] = 2;
      components[25] = 2;
      components[26] = 2;
      components[27] = 2;
      components[28] = 2;
      components[29] = 2;
      points[30] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[31] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[32] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[33] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[30] = 3;
      components[31] = 3;
      components[32] = 3;
      components[33] = 3;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices() + mesh.noEdges();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[2] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[3] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *subelements[i];
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *subelements[i];
    }
    
  private:
    
    class SubElement_0 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        tensordims = new unsigned int [1];
        tensordims[0] = 3;
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_0()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 30;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_assert(i < 1);
        return tensordims[i];
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 1;
      }
    
      void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
      {
        dofs[0] = cell.vertexID(0);
        dofs[1] = cell.vertexID(1);
        dofs[2] = cell.vertexID(2);
        dofs[3] = cell.vertexID(3);
        int offset = mesh.noVertices();
        dofs[4] = offset + cell.edgeID(0);
        dofs[5] = offset + cell.edgeID(1);
        dofs[6] = offset + cell.edgeID(2);
        dofs[7] = offset + cell.edgeID(3);
        dofs[8] = offset + cell.edgeID(4);
        dofs[9] = offset + cell.edgeID(5);
        offset = offset + mesh.noEdges();
        dofs[10] = offset + cell.vertexID(0);
        dofs[11] = offset + cell.vertexID(1);
        dofs[12] = offset + cell.vertexID(2);
        dofs[13] = offset + cell.vertexID(3);
        offset = offset + mesh.noVertices();
        dofs[14] = offset + cell.edgeID(0);
        dofs[15] = offset + cell.edgeID(1);
        dofs[16] = offset + cell.edgeID(2);
        dofs[17] = offset + cell.edgeID(3);
        dofs[18] = offset + cell.edgeID(4);
        dofs[19] = offset + cell.edgeID(5);
        offset = offset + mesh.noEdges();
        dofs[20] = offset + cell.vertexID(0);
        dofs[21] = offset + cell.vertexID(1);
        dofs[22] = offset + cell.vertexID(2);
        dofs[23] = offset + cell.vertexID(3);
        offset = offset + mesh.noVertices();
        dofs[24] = offset + cell.edgeID(0);
        dofs[25] = offset + cell.edgeID(1);
        dofs[26] = offset + cell.edgeID(2);
        dofs[27] = offset + cell.edgeID(3);
        dofs[28] = offset + cell.edgeID(4);
        dofs[29] = offset + cell.edgeID(5);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
        points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
        points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
        points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
        points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
        points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
        components[4] = 0;
        components[5] = 0;
        components[6] = 0;
        components[7] = 0;
        components[8] = 0;
        components[9] = 0;
        components[10] = 1;
        components[11] = 1;
        components[12] = 1;
        components[13] = 1;
        components[14] = 1;
        components[15] = 1;
        components[16] = 1;
        components[17] = 1;
        components[18] = 1;
        components[19] = 1;
        components[20] = 2;
        components[21] = 2;
        components[22] = 2;
        components[23] = 2;
        components[24] = 2;
        components[25] = 2;
        components[26] = 2;
        components[27] = 2;
        components[28] = 2;
        components[29] = 2;
      }
    
      void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        values[0] = x[vertex];
        int offset = mesh.noVertices() + mesh.noEdges();
        values[1] = x[offset + vertex];
        offset = offset + mesh.noVertices() + mesh.noEdges();
        values[2] = x[offset + vertex];
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
      
    class SubElement_1 : public dolfin::FiniteElement
    {
    public:
    
      SubElement_1() : dolfin::FiniteElement(), tensordims(0), subelements(0)
      {
        // Element is scalar, don't need to initialize tensordims
    
        // Element is simple, don't need to initialize subelements
      }
    
      ~SubElement_1()
      {
        if ( tensordims ) delete [] tensordims;
        if ( subelements )
        {
          for (unsigned int i = 0; i < elementdim(); i++)
            delete subelements[i];
          delete [] subelements;
        }
      }
    
      inline unsigned int spacedim() const
      {
        return 4;
      }
    
      inline unsigned int shapedim() const
      {
        return 3;
      }
    
      inline unsigned int tensordim(unsigned int i) const
      {
        dolfin_error("Element is scalar.");
        return 0;
      }
    
      inline unsigned int elementdim() const
      {
        return 1;
      }
    
      inline unsigned int rank() const
      {
        return 0;
      }
    
      void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
      {
        dofs[0] = cell.vertexID(0);
        dofs[1] = cell.vertexID(1);
        dofs[2] = cell.vertexID(2);
        dofs[3] = cell.vertexID(3);
      }
    
      void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
      {
        points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
        points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
        points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
        components[0] = 0;
        components[1] = 0;
        components[2] = 0;
        components[3] = 0;
      }
    
      void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
      {
        // FIXME: Temporary fix for Lagrange elements
        values[0] = x[vertex];
      }
    
      const FiniteElement& operator[] (unsigned int i) const
      {
        return *this;
      }
    
      FiniteElement& operator[] (unsigned int i)
      {
        return *this;
      }
      
    private:
    
      unsigned int* tensordims;
      FiniteElement** subelements;
    
    };
    
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 30;
    }
  
    inline unsigned int shapedim() const
    {
      return 3;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 1;
    }
  
    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.vertexID(0);
      dofs[1] = cell.vertexID(1);
      dofs[2] = cell.vertexID(2);
      dofs[3] = cell.vertexID(3);
      int offset = mesh.noVertices();
      dofs[4] = offset + cell.edgeID(0);
      dofs[5] = offset + cell.edgeID(1);
      dofs[6] = offset + cell.edgeID(2);
      dofs[7] = offset + cell.edgeID(3);
      dofs[8] = offset + cell.edgeID(4);
      dofs[9] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[10] = offset + cell.vertexID(0);
      dofs[11] = offset + cell.vertexID(1);
      dofs[12] = offset + cell.vertexID(2);
      dofs[13] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[14] = offset + cell.edgeID(0);
      dofs[15] = offset + cell.edgeID(1);
      dofs[16] = offset + cell.edgeID(2);
      dofs[17] = offset + cell.edgeID(3);
      dofs[18] = offset + cell.edgeID(4);
      dofs[19] = offset + cell.edgeID(5);
      offset = offset + mesh.noEdges();
      dofs[20] = offset + cell.vertexID(0);
      dofs[21] = offset + cell.vertexID(1);
      dofs[22] = offset + cell.vertexID(2);
      dofs[23] = offset + cell.vertexID(3);
      offset = offset + mesh.noVertices();
      dofs[24] = offset + cell.edgeID(0);
      dofs[25] = offset + cell.edgeID(1);
      dofs[26] = offset + cell.edgeID(2);
      dofs[27] = offset + cell.edgeID(3);
      dofs[28] = offset + cell.edgeID(4);
      dofs[29] = offset + cell.edgeID(5);
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[5] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[6] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[8] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[9] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[10] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[12] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[13] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[14] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[15] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[16] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[17] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[18] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[19] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      points[20] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[21] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[22] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[23] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[24] = map(5.000000000000000e-01, 5.000000000000000e-01, 0.000000000000000e+00);
      points[25] = map(0.000000000000000e+00, 5.000000000000000e-01, 0.000000000000000e+00);
      points[26] = map(5.000000000000000e-01, 0.000000000000000e+00, 0.000000000000000e+00);
      points[27] = map(0.000000000000000e+00, 0.000000000000000e+00, 5.000000000000000e-01);
      points[28] = map(5.000000000000000e-01, 0.000000000000000e+00, 5.000000000000000e-01);
      points[29] = map(0.000000000000000e+00, 5.000000000000000e-01, 5.000000000000000e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
      components[10] = 1;
      components[11] = 1;
      components[12] = 1;
      components[13] = 1;
      components[14] = 1;
      components[15] = 1;
      components[16] = 1;
      components[17] = 1;
      components[18] = 1;
      components[19] = 1;
      components[20] = 2;
      components[21] = 2;
      components[22] = 2;
      components[23] = 2;
      components[24] = 2;
      components[25] = 2;
      components[26] = 2;
      components[27] = 2;
      components[28] = 2;
      components[29] = 2;
    }
  
    void vertexeval(real values[], unsigned int vertex, const real x[], const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x[vertex];
      int offset = mesh.noVertices() + mesh.noEdges();
      values[1] = x[offset + vertex];
      offset = offset + mesh.noVertices() + mesh.noEdges();
      values[2] = x[offset + vertex];
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];
    const real c0_4 = c[0][4];
    const real c0_5 = c[0][5];
    const real c0_6 = c[0][6];
    const real c0_7 = c[0][7];
    const real c0_8 = c[0][8];
    const real c0_9 = c[0][9];
    const real c0_10 = c[0][10];
    const real c0_11 = c[0][11];
    const real c0_12 = c[0][12];
    const real c0_13 = c[0][13];
    const real c0_14 = c[0][14];
    const real c0_15 = c[0][15];
    const real c0_16 = c[0][16];
    const real c0_17 = c[0][17];
    const real c0_18 = c[0][18];
    const real c0_19 = c[0][19];
    const real c0_20 = c[0][20];
    const real c0_21 = c[0][21];
    const real c0_22 = c[0][22];
    const real c0_23 = c[0][23];
    const real c0_24 = c[0][24];
    const real c0_25 = c[0][25];
    const real c0_26 = c[0][26];
    const real c0_27 = c[0][27];
    const real c0_28 = c[0][28];
    const real c0_29 = c[0][29];

    // Compute geometry tensors
    const real G0_0 = map.det*c0_0;
    const real G0_1 = map.det*c0_1;
    const real G0_2 = map.det*c0_2;
    const real G0_3 = map.det*c0_3;
    const real G0_4 = map.det*c0_4;
    const real G0_5 = map.det*c0_5;
    const real G0_6 = map.det*c0_6;
    const real G0_7 = map.det*c0_7;
    const real G0_8 = map.det*c0_8;
    const real G0_9 = map.det*c0_9;
    const real G1_10 = map.det*c0_10;
    const real G1_11 = map.det*c0_11;
    const real G1_12 = map.det*c0_12;
    const real G1_13 = map.det*c0_13;
    const real G1_14 = map.det*c0_14;
    const real G1_15 = map.det*c0_15;
    const real G1_16 = map.det*c0_16;
    const real G1_17 = map.det*c0_17;
    const real G1_18 = map.det*c0_18;
    const real G1_19 = map.det*c0_19;
    const real G2_20 = map.det*c0_20;
    const real G2_21 = map.det*c0_21;
    const real G2_22 = map.det*c0_22;
    const real G2_23 = map.det*c0_23;
    const real G2_24 = map.det*c0_24;
    const real G2_25 = map.det*c0_25;
    const real G2_26 = map.det*c0_26;
    const real G2_27 = map.det*c0_27;
    const real G2_28 = map.det*c0_28;
    const real G2_29 = map.det*c0_29;

    // Compute element tensor
    block[0] = 2.380952380952376e-03*G0_0 + 3.968253968253970e-04*G0_1 + 3.968253968253966e-04*G0_2 + 3.968253968253977e-04*G0_3 - 2.380952380952377e-03*G0_4 - 1.587301587301585e-03*G0_5 - 1.587301587301587e-03*G0_6 - 1.587301587301587e-03*G0_7 - 2.380952380952378e-03*G0_8 - 2.380952380952379e-03*G0_9;
    block[1] = 3.968253968253970e-04*G0_0 + 2.380952380952379e-03*G0_1 + 3.968253968253966e-04*G0_2 + 3.968253968253975e-04*G0_3 - 1.587301587301584e-03*G0_4 - 2.380952380952378e-03*G0_5 - 1.587301587301587e-03*G0_6 - 2.380952380952379e-03*G0_7 - 1.587301587301586e-03*G0_8 - 2.380952380952381e-03*G0_9;
    block[2] = 3.968253968253967e-04*G0_0 + 3.968253968253963e-04*G0_1 + 2.380952380952378e-03*G0_2 + 3.968253968253976e-04*G0_3 - 1.587301587301586e-03*G0_4 - 1.587301587301586e-03*G0_5 - 2.380952380952379e-03*G0_6 - 2.380952380952379e-03*G0_7 - 2.380952380952380e-03*G0_8 - 1.587301587301586e-03*G0_9;
    block[3] = 3.968253968253977e-04*G0_0 + 3.968253968253974e-04*G0_1 + 3.968253968253976e-04*G0_2 + 2.380952380952380e-03*G0_3 - 2.380952380952382e-03*G0_4 - 2.380952380952380e-03*G0_5 - 2.380952380952380e-03*G0_6 - 1.587301587301589e-03*G0_7 - 1.587301587301589e-03*G0_8 - 1.587301587301592e-03*G0_9;
    block[4] = -2.380952380952377e-03*G0_0 - 1.587301587301584e-03*G0_1 - 1.587301587301586e-03*G0_2 - 2.380952380952382e-03*G0_3 + 1.269841269841269e-02*G0_4 + 6.349206349206338e-03*G0_5 + 6.349206349206346e-03*G0_6 + 3.174603174603172e-03*G0_7 + 6.349206349206346e-03*G0_8 + 6.349206349206347e-03*G0_9;
    block[5] = -1.587301587301585e-03*G0_0 - 2.380952380952378e-03*G0_1 - 1.587301587301586e-03*G0_2 - 2.380952380952380e-03*G0_3 + 6.349206349206337e-03*G0_4 + 1.269841269841268e-02*G0_5 + 6.349206349206347e-03*G0_6 + 6.349206349206341e-03*G0_7 + 3.174603174603172e-03*G0_8 + 6.349206349206341e-03*G0_9;
    block[6] = -1.587301587301587e-03*G0_0 - 1.587301587301588e-03*G0_1 - 2.380952380952379e-03*G0_2 - 2.380952380952380e-03*G0_3 + 6.349206349206344e-03*G0_4 + 6.349206349206347e-03*G0_5 + 1.269841269841268e-02*G0_6 + 6.349206349206345e-03*G0_7 + 6.349206349206343e-03*G0_8 + 3.174603174603177e-03*G0_9;
    block[7] = -1.587301587301587e-03*G0_0 - 2.380952380952379e-03*G0_1 - 2.380952380952379e-03*G0_2 - 1.587301587301589e-03*G0_3 + 3.174603174603172e-03*G0_4 + 6.349206349206342e-03*G0_5 + 6.349206349206345e-03*G0_6 + 1.269841269841268e-02*G0_7 + 6.349206349206343e-03*G0_8 + 6.349206349206345e-03*G0_9;
    block[8] = -2.380952380952379e-03*G0_0 - 1.587301587301586e-03*G0_1 - 2.380952380952380e-03*G0_2 - 1.587301587301590e-03*G0_3 + 6.349206349206346e-03*G0_4 + 3.174603174603172e-03*G0_5 + 6.349206349206343e-03*G0_6 + 6.349206349206343e-03*G0_7 + 1.269841269841269e-02*G0_8 + 6.349206349206348e-03*G0_9;
    block[9] = -2.380952380952379e-03*G0_0 - 2.380952380952381e-03*G0_1 - 1.587301587301587e-03*G0_2 - 1.587301587301592e-03*G0_3 + 6.349206349206347e-03*G0_4 + 6.349206349206341e-03*G0_5 + 3.174603174603177e-03*G0_6 + 6.349206349206345e-03*G0_7 + 6.349206349206348e-03*G0_8 + 1.269841269841269e-02*G0_9;
    block[10] = 2.380952380952376e-03*G1_10 + 3.968253968253962e-04*G1_11 + 3.968253968253961e-04*G1_12 + 3.968253968253973e-04*G1_13 - 2.380952380952376e-03*G1_14 - 1.587301587301583e-03*G1_15 - 1.587301587301585e-03*G1_16 - 1.587301587301586e-03*G1_17 - 2.380952380952377e-03*G1_18 - 2.380952380952378e-03*G1_19;
    block[11] = 3.968253968253962e-04*G1_10 + 2.380952380952379e-03*G1_11 + 3.968253968253961e-04*G1_12 + 3.968253968253974e-04*G1_13 - 1.587301587301584e-03*G1_14 - 2.380952380952377e-03*G1_15 - 1.587301587301586e-03*G1_16 - 2.380952380952378e-03*G1_17 - 1.587301587301585e-03*G1_18 - 2.380952380952379e-03*G1_19;
    block[12] = 3.968253968253960e-04*G1_10 + 3.968253968253961e-04*G1_11 + 2.380952380952378e-03*G1_12 + 3.968253968253977e-04*G1_13 - 1.587301587301585e-03*G1_14 - 1.587301587301586e-03*G1_15 - 2.380952380952379e-03*G1_16 - 2.380952380952380e-03*G1_17 - 2.380952380952380e-03*G1_18 - 1.587301587301587e-03*G1_19;
    block[13] = 3.968253968253973e-04*G1_10 + 3.968253968253972e-04*G1_11 + 3.968253968253977e-04*G1_12 + 2.380952380952380e-03*G1_13 - 2.380952380952382e-03*G1_14 - 2.380952380952380e-03*G1_15 - 2.380952380952379e-03*G1_16 - 1.587301587301589e-03*G1_17 - 1.587301587301589e-03*G1_18 - 1.587301587301592e-03*G1_19;
    block[14] = -2.380952380952376e-03*G1_10 - 1.587301587301583e-03*G1_11 - 1.587301587301585e-03*G1_12 - 2.380952380952382e-03*G1_13 + 1.269841269841268e-02*G1_14 + 6.349206349206335e-03*G1_15 + 6.349206349206341e-03*G1_16 + 3.174603174603172e-03*G1_17 + 6.349206349206344e-03*G1_18 + 6.349206349206343e-03*G1_19;
    block[15] = -1.587301587301583e-03*G1_10 - 2.380952380952377e-03*G1_11 - 1.587301587301585e-03*G1_12 - 2.380952380952380e-03*G1_13 + 6.349206349206335e-03*G1_14 + 1.269841269841268e-02*G1_15 + 6.349206349206342e-03*G1_16 + 6.349206349206344e-03*G1_17 + 3.174603174603171e-03*G1_18 + 6.349206349206340e-03*G1_19;
    block[16] = -1.587301587301585e-03*G1_10 - 1.587301587301586e-03*G1_11 - 2.380952380952379e-03*G1_12 - 2.380952380952379e-03*G1_13 + 6.349206349206341e-03*G1_14 + 6.349206349206342e-03*G1_15 + 1.269841269841268e-02*G1_16 + 6.349206349206343e-03*G1_17 + 6.349206349206341e-03*G1_18 + 3.174603174603174e-03*G1_19;
    block[17] = -1.587301587301586e-03*G1_10 - 2.380952380952378e-03*G1_11 - 2.380952380952380e-03*G1_12 - 1.587301587301589e-03*G1_13 + 3.174603174603172e-03*G1_14 + 6.349206349206344e-03*G1_15 + 6.349206349206342e-03*G1_16 + 1.269841269841268e-02*G1_17 + 6.349206349206343e-03*G1_18 + 6.349206349206347e-03*G1_19;
    block[18] = -2.380952380952377e-03*G1_10 - 1.587301587301585e-03*G1_11 - 2.380952380952380e-03*G1_12 - 1.587301587301590e-03*G1_13 + 6.349206349206344e-03*G1_14 + 3.174603174603171e-03*G1_15 + 6.349206349206341e-03*G1_16 + 6.349206349206344e-03*G1_17 + 1.269841269841269e-02*G1_18 + 6.349206349206348e-03*G1_19;
    block[19] = -2.380952380952377e-03*G1_10 - 2.380952380952379e-03*G1_11 - 1.587301587301587e-03*G1_12 - 1.587301587301592e-03*G1_13 + 6.349206349206344e-03*G1_14 + 6.349206349206341e-03*G1_15 + 3.174603174603173e-03*G1_16 + 6.349206349206347e-03*G1_17 + 6.349206349206348e-03*G1_18 + 1.269841269841269e-02*G1_19;
    block[20] = 2.380952380952376e-03*G2_20 + 3.968253968253962e-04*G2_21 + 3.968253968253963e-04*G2_22 + 3.968253968253963e-04*G2_23 - 2.380952380952377e-03*G2_24 - 1.587301587301584e-03*G2_25 - 1.587301587301586e-03*G2_26 - 1.587301587301585e-03*G2_27 - 2.380952380952379e-03*G2_28 - 2.380952380952377e-03*G2_29;
    block[21] = 3.968253968253963e-04*G2_20 + 2.380952380952378e-03*G2_21 + 3.968253968253961e-04*G2_22 + 3.968253968253960e-04*G2_23 - 1.587301587301583e-03*G2_24 - 2.380952380952376e-03*G2_25 - 1.587301587301585e-03*G2_26 - 2.380952380952377e-03*G2_27 - 1.587301587301585e-03*G2_28 - 2.380952380952378e-03*G2_29;
    block[22] = 3.968253968253963e-04*G2_20 + 3.968253968253961e-04*G2_21 + 2.380952380952378e-03*G2_22 + 3.968253968253965e-04*G2_23 - 1.587301587301585e-03*G2_24 - 1.587301587301586e-03*G2_25 - 2.380952380952378e-03*G2_26 - 2.380952380952379e-03*G2_27 - 2.380952380952381e-03*G2_28 - 1.587301587301585e-03*G2_29;
    block[23] = 3.968253968253964e-04*G2_20 + 3.968253968253960e-04*G2_21 + 3.968253968253965e-04*G2_22 + 2.380952380952378e-03*G2_23 - 2.380952380952379e-03*G2_24 - 2.380952380952378e-03*G2_25 - 2.380952380952377e-03*G2_26 - 1.587301587301584e-03*G2_27 - 1.587301587301586e-03*G2_28 - 1.587301587301587e-03*G2_29;
    block[24] = -2.380952380952377e-03*G2_20 - 1.587301587301583e-03*G2_21 - 1.587301587301585e-03*G2_22 - 2.380952380952379e-03*G2_23 + 1.269841269841269e-02*G2_24 + 6.349206349206340e-03*G2_25 + 6.349206349206343e-03*G2_26 + 3.174603174603171e-03*G2_27 + 6.349206349206350e-03*G2_28 + 6.349206349206347e-03*G2_29;
    block[25] = -1.587301587301585e-03*G2_20 - 2.380952380952376e-03*G2_21 - 1.587301587301585e-03*G2_22 - 2.380952380952377e-03*G2_23 + 6.349206349206340e-03*G2_24 + 1.269841269841268e-02*G2_25 + 6.349206349206343e-03*G2_26 + 6.349206349206342e-03*G2_27 + 3.174603174603172e-03*G2_28 + 6.349206349206340e-03*G2_29;
    block[26] = -1.587301587301586e-03*G2_20 - 1.587301587301585e-03*G2_21 - 2.380952380952378e-03*G2_22 - 2.380952380952377e-03*G2_23 + 6.349206349206343e-03*G2_24 + 6.349206349206343e-03*G2_25 + 1.269841269841268e-02*G2_26 + 6.349206349206339e-03*G2_27 + 6.349206349206344e-03*G2_28 + 3.174603174603172e-03*G2_29;
    block[27] = -1.587301587301586e-03*G2_20 - 2.380952380952377e-03*G2_21 - 2.380952380952379e-03*G2_22 - 1.587301587301584e-03*G2_23 + 3.174603174603171e-03*G2_24 + 6.349206349206342e-03*G2_25 + 6.349206349206339e-03*G2_26 + 1.269841269841268e-02*G2_27 + 6.349206349206343e-03*G2_28 + 6.349206349206341e-03*G2_29;
    block[28] = -2.380952380952379e-03*G2_20 - 1.587301587301585e-03*G2_21 - 2.380952380952381e-03*G2_22 - 1.587301587301586e-03*G2_23 + 6.349206349206350e-03*G2_24 + 3.174603174603172e-03*G2_25 + 6.349206349206344e-03*G2_26 + 6.349206349206343e-03*G2_27 + 1.269841269841270e-02*G2_28 + 6.349206349206348e-03*G2_29;
    block[29] = -2.380952380952378e-03*G2_20 - 2.380952380952377e-03*G2_21 - 1.587301587301585e-03*G2_22 - 1.587301587301586e-03*G2_23 + 6.349206349206347e-03*G2_24 + 6.349206349206340e-03*G2_25 + 3.174603174603172e-03*G2_26 + 6.349206349206341e-03*G2_27 + 6.349206349206348e-03*G2_28 + 1.269841269841269e-02*G2_29;
    block[30] = 0.000000000000000e+00;
    block[31] = 0.000000000000000e+00;
    block[32] = 0.000000000000000e+00;
    block[33] = 0.000000000000000e+00;
  }

};

} }

#endif
